/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],se=function(X){for(var e=[],D=0,R=X.length;D<R;D++)e[D]=ne[X[D]];return e};define(ne[72],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const k=new Map,N=new Map,A=new Map,E=new Map;function u(w,$){w.has($.detail)||w.set($.detail,-$.timestamp)}function a(w,$){const I=w.get($.detail);I&&(I>=0||w.set($.detail,I+$.timestamp))}let f=[];typeof X=="function"&&typeof X.getStats=="function"&&(f=X.getStats().slice(0).sort((w,$)=>w.timestamp-$.timestamp));for(const w of f)switch(w.type){case 10:u(k,w);break;case 11:case 12:a(k,w);break;case 21:u(N,w);break;case 22:a(N,w);break;case 33:u(A,w);break;case 34:a(A,w);break;case 31:u(E,w);break;case 32:a(E,w);break}let b=0;A.forEach(w=>b+=w);function y(w){const $=[];return w.forEach((I,g)=>$.push([g,I])),$}return{amdLoad:y(k),amdInvoke:y(N),nodeRequire:y(A),nodeEval:y(E),nodeRequireTotal:b}}static toMarkdownTable(k,N){let A="";const E=[];return k.forEach((u,a)=>{E[a]=u.length}),N.forEach(u=>{u.forEach((a,f)=>{typeof a>"u"&&(a=u[f]="-");const b=a.toString().length;E[f]=Math.max(b,E[f])})}),k.forEach((u,a)=>{A+=`| ${u+" ".repeat(E[a]-u.toString().length)} `}),A+=`|
`,k.forEach((u,a)=>{A+=`| ${"-".repeat(E[a])} `}),A+=`|
`,N.forEach(u=>{u.forEach((a,f)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(E[f]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(ne[54],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=R,e.$4h=k,e.$5h=N;function D(A){return(E,u,a)=>{let f=null,b=null;if(typeof a.value=="function"?(f="value",b=a.value):typeof a.get=="function"&&(f="get",b=a.get),!b)throw new Error("not supported");a[f]=A(b,u)}}function R(A,E,u){let a=null,f=null;if(typeof u.value=="function"?(a="value",f=u.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",f=u.get),!f)throw new Error("not supported");const b=`$memoize$${E}`;u[a]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,y)}),this[b]}}function k(A,E,u){return D((a,f)=>{const b=`$debounce$${f}`,y=`$debounce$result$${f}`;return function(...w){this[y]||(this[y]=u?u():void 0),clearTimeout(this[b]),E&&(this[y]=E(this[y],...w),w=[this[y]]),this[b]=setTimeout(()=>{a.apply(this,w),this[y]=u?u():void 0},A)}})}function N(A,E,u){return D((a,f)=>{const b=`$throttle$timer$${f}`,y=`$throttle$result$${f}`,w=`$throttle$lastRun$${f}`,$=`$throttle$pending$${f}`;return function(...I){if(this[y]||(this[y]=u?u():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...I)),this[$])return;const g=this[w]+A;g<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0):(this[$]=!0,this[b]=setTimeout(()=>{this[$]=!1,this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0},g-Date.now()))}})}}),define(ne[73],se([0,1,9]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=R,e.$ed=k,e.$fd=N,e.$gd=A,e.$hd=E,e.$id=u;function R(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function k(a,f="Unreachable"){throw new Error(f)}function N(a){if(!a)throw new D.$cb("Assertion Failed")}function A(a){a||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function E(a){if(!a()){debugger;a(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function u(a,f){let b=0;for(;b<a.length-1;){const y=a[b],w=a[b+1];if(!f(y,w))return!1;b++}return!0}}),define(ne[38],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=A,e.$Kn=b,e.$Ln=y,e.$Mn=w,e.$Nn=$,e.$On=I,e.$Pn=g,e.$Qn=l,e.$Rn=c,e.$Sn=v,e.$Tn=p,e.$Un=m;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(n,r=!1){let t=0;const i=n.length;let s="",o=0,h=16,S=0;function j(ie){let he=0,le=0;for(;he<ie;){const ce=n.charCodeAt(t);if(ce>=48&&ce<=57)le=le*16+ce-48;else if(ce>=65&&ce<=70)le=le*16+ce-65+10;else if(ce>=97&&ce<=102)le=le*16+ce-97+10;else break;t++,he++}return he<ie&&(le=-1),le}function O(ie){t=ie,s="",o=0,h=16,S=0}function z(){const ie=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&a(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&a(n.charCodeAt(t)))for(t++;t<n.length&&a(n.charCodeAt(t));)t++;else return S=3,n.substring(ie,t);let he=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&a(n.charCodeAt(t))){for(t++;t<n.length&&a(n.charCodeAt(t));)t++;he=t}else S=3;return n.substring(ie,he)}function C(){let ie="",he=t;for(;;){if(t>=i){ie+=n.substring(he,t),S=2;break}const le=n.charCodeAt(t);if(le===34){ie+=n.substring(he,t),t++;break}if(le===92){if(ie+=n.substring(he,t),t++,t>=i){S=2;break}switch(n.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const B=j(4);B>=0?ie+=String.fromCharCode(B):S=4;break}default:S=5}he=t;continue}if(le>=0&&le<=31)if(u(le)){ie+=n.substring(he,t),S=2;break}else S=6;t++}return ie}function T(){if(s="",S=0,o=t,t>=i)return o=i,h=17;let ie=n.charCodeAt(t);if(E(ie)){do t++,s+=String.fromCharCode(ie),ie=n.charCodeAt(t);while(E(ie));return h=15}if(u(ie))return t++,s+=String.fromCharCode(ie),ie===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),h=14;switch(ie){case 123:return t++,h=1;case 125:return t++,h=2;case 91:return t++,h=3;case 93:return t++,h=4;case 58:return t++,h=6;case 44:return t++,h=5;case 34:return t++,s=C(),h=10;case 47:{const he=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(n.charCodeAt(t));)t++;return s=n.substring(he,t),h=12}if(n.charCodeAt(t+1)===42){t+=2;const le=i-1;let ce=!1;for(;t<le;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,S=1),s=n.substring(he,t),h=13}return s+=String.fromCharCode(ie),t++,h=16}case 45:if(s+=String.fromCharCode(ie),t++,t===i||!a(n.charCodeAt(t)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=z(),h=11;default:for(;t<i&&J(ie);)t++,ie=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(ie),t++,h=16}}function J(ie){if(E(ie)||u(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ie;do ie=T();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>t,scan:r?re:T,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>S}}function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function u(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var f;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(f||(f={}));function b(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function S(j,O,z,C){o.value=j,o.offset=O,o.length=z,o.type=C,o.colonOffset=void 0,s=o}try{v(n,{onObjectBegin:(j,O)=>{if(r<=j)throw i;s=void 0,h=r>j,t.push("")},onObjectProperty:(j,O,z)=>{if(r<O||(S(j,O,z,"property"),t[t.length-1]=j,r<=O+z))throw i},onObjectEnd:(j,O)=>{if(r<=j)throw i;s=void 0,t.pop()},onArrayBegin:(j,O)=>{if(r<=j)throw i;s=void 0,t.push(0)},onArrayEnd:(j,O)=>{if(r<=j)throw i;s=void 0,t.pop()},onLiteralValue:(j,O,z)=>{if(r<O||(S(j,O,z,m(j)),r<=O+z))throw i},onSeparator:(j,O,z)=>{if(r<=O)throw i;if(j===":"&&s&&s.type==="property")s.colonOffset=O,h=!1,s=void 0;else if(j===","){const C=t[t.length-1];typeof C=="number"?t[t.length-1]=C+1:(h=!0,t[t.length-1]=""),s=void 0}}})}catch(j){if(j!==i)throw j}return{path:t,previousNode:s,isAtPropertyKey:h,matches:j=>{let O=0;for(let z=0;O<j.length&&z<t.length;z++)if(j[O]===t[z]||j[O]==="*")O++;else if(j[O]!=="**")return!1;return O===j.length}}}function y(n,r=[],t=N.DEFAULT){let i=null,s=[];const o=[];function h(j){Array.isArray(s)?s.push(j):i!==null&&(s[i]=j)}return v(n,{onObjectBegin:()=>{const j={};h(j),o.push(s),s=j,i=null},onObjectProperty:j=>{i=j},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const j=[];h(j),o.push(s),s=j,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:h,onError:(j,O,z)=>{r.push({error:j,offset:O,length:z})}},t),s[0]}function w(n,r=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(j){i.type==="property"&&(i.length=j-i.offset,i=i.parent)}function o(j){return i.children.push(j),j}v(n,{onObjectBegin:j=>{i=o({type:"object",offset:j,length:-1,parent:i,children:[]})},onObjectProperty:(j,O,z)=>{i=o({type:"property",offset:O,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:j,offset:O,length:z,parent:i})},onObjectEnd:(j,O)=>{i.length=j+O-i.offset,i=i.parent,s(j+O)},onArrayBegin:(j,O)=>{i=o({type:"array",offset:j,length:-1,parent:i,children:[]})},onArrayEnd:(j,O)=>{i.length=j+O-i.offset,i=i.parent,s(j+O)},onLiteralValue:(j,O,z)=>{o({type:m(j),offset:O,length:z,parent:i,value:j}),s(O+z)},onSeparator:(j,O,z)=>{i.type==="property"&&(j===":"?i.colonOffset=O:j===","&&s(O))},onError:(j,O,z)=>{r.push({error:j,offset:O,length:z})}},t);const S=i.children[0];return S&&delete S.parent,S}function $(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function I(n){if(!n.parent||!n.parent.children)return[];const r=I(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}function g(n){switch(n.type){case"array":return n.children.map(g);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=g(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function l(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}function c(n,r,t=!1){if(l(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=c(i[s],r,t);if(o)return o}return n}}function v(n,r,t=N.DEFAULT){const i=A(n,!1);function s(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Q){return Q?_=>Q(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=s(r.onObjectBegin),S=o(r.onObjectProperty),j=s(r.onObjectEnd),O=s(r.onArrayBegin),z=s(r.onArrayEnd),C=o(r.onLiteralValue),T=o(r.onSeparator),J=s(r.onComment),re=o(r.onError),ie=t&&t.disallowComments,he=t&&t.allowTrailingComma;function le(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Q){case 12:case 13:ie?ce(10):J();break;case 16:ce(1);break;case 15:case 14:break;default:return Q}}}function ce(Q,_=[],U=[]){if(re(Q),_.length+U.length>0){let F=i.getToken();for(;F!==17;){if(_.indexOf(F)!==-1){le();break}else if(U.indexOf(F)!==-1)break;F=le()}}}function B(Q){const _=i.getTokenValue();return Q?C(_):S(_),le(),!0}function Y(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(ce(2),Q=0)}catch{ce(2)}C(Q);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return le(),!0}function V(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(T(":"),le(),Z()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){h(),le();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ce(4,[],[]),T(","),le(),i.getToken()===2&&he)break}else Q&&ce(6,[],[]);V()||ce(4,[],[2,5]),Q=!0}return j(),i.getToken()!==2?ce(7,[2],[]):le(),!0}function H(){O(),le();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ce(4,[],[]),T(","),le(),i.getToken()===4&&he)break}else Q&&ce(6,[],[]);Z()||ce(4,[],[4,5]),Q=!0}return z(),i.getToken()!==4?ce(8,[4],[]):le(),!0}function Z(){switch(i.getToken()){case 3:return H();case 1:return q();case 10:return B(!0);default:return Y()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):Z()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function p(n,r){const t=A(n),i=[];let s,o=0,h;do switch(h=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==h&&i.push(n.substring(o,h)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}function m(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[74],se([0,1,38]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=R,e.$Wn=k,e.$Xn=E,e.$Yn=u;function R(a,f,b){let y,w,$,I,g;if(f){for(I=f.offset,g=I+f.length,$=I;$>0&&!u(a,$-1);)$--;let h=g;for(;h<a.length&&!u(a,h);)h++;w=a.substring($,h),y=A(w,b)}else w=a,y=0,$=0,I=0,g=a.length;const l=E(b,a);let c=!1,v=0,p;b.insertSpaces?p=N(" ",b.tabSize||4):p="	";const m=(0,D.$Jn)(w,!1);let n=!1;function r(){return l+N(p,y+v)}function t(){let h=m.scan();for(c=!1;h===15||h===14;)c=c||h===14,h=m.scan();return n=h===16||m.getTokenError()!==0,h}const i=[];function s(h,S,j){!n&&S<g&&j>I&&a.substring(S,j)!==h&&i.push({offset:S,length:j-S,content:h})}let o=t();if(o!==17){const h=m.getTokenOffset()+$,S=N(p,y);s(S,$,h)}for(;o!==17;){let h=m.getTokenOffset()+m.getTokenLength()+$,S=t(),j="";for(;!c&&(S===12||S===13);){const z=m.getTokenOffset()+$;s(" ",h,z),h=m.getTokenOffset()+m.getTokenLength()+$,j=S===12?r():"",S=t()}if(S===2)o!==1&&(v--,j=r());else if(S===4)o!==3&&(v--,j=r());else{switch(o){case 3:case 1:v++,j=r();break;case 5:case 12:j=r();break;case 13:c?j=r():j=" ";break;case 6:j=" ";break;case 10:if(S===6){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?j=" ":S!==5&&S!==17&&(n=!0);break;case 16:n=!0;break}c&&(S===12||S===13)&&(j=r())}const O=m.getTokenOffset()+$;s(j,h,O),o=S}return i}function k(a,f){const b=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?b.replace(/\r\n|\r|\n/g,f.eol):b}function N(a,f){let b="";for(let y=0;y<f;y++)b+=a;return b}function A(a,f){let b=0,y=0;const w=f.tabSize||4;for(;b<a.length;){const $=a.charAt(b);if($===" ")y++;else if($==="	")y+=w;else break;b++}return Math.floor(y/w)}function E(a,f){for(let b=0;b<f.length;b++){const y=f.charAt(b);if(y==="\r")return b+1<f.length&&f.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}function u(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(ne[75],se([0,1,38,74]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=k,e.$1n=N,e.$2n=A,e.$3n=E,e.$4n=u;function k(a,f,b){return N(a,f,void 0,b)}function N(a,f,b,y,w){const $=f.slice(),I=[],g=(0,D.$Mn)(a,I);let l,c;for(;$.length>0&&(c=$.pop(),l=(0,D.$Nn)(g,$),l===void 0&&b!==void 0);)typeof c=="string"?b={[c]:b}:b=[b];if(l)if(l.type==="object"&&typeof c=="string"&&Array.isArray(l.children)){const v=(0,D.$Nn)(l,[c]);if(v!==void 0)if(b===void 0){if(!v.parent)throw new Error("Malformed AST");const p=l.children.indexOf(v.parent);let m,n=v.parent.offset+v.parent.length;if(p>0){const r=l.children[p-1];m=r.offset+r.length}else m=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return A(a,{offset:m,length:n-m,content:""},y)}else return A(a,{offset:v.offset,length:v.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const p=`${JSON.stringify(c)}: ${JSON.stringify(b)}`,m=w?w(l.children.map(r=>r.children[0].value)):l.children.length;let n;if(m>0){const r=l.children[m-1];n={offset:r.offset+r.length,length:0,content:","+p}}else l.children.length===0?n={offset:l.offset+1,length:0,content:p}:n={offset:l.offset+1,length:0,content:p+","};return A(a,n,y)}}else if(l.type==="array"&&typeof c=="number"&&Array.isArray(l.children))if(b!==void 0){const v=`${JSON.stringify(b)}`;let p;if(l.children.length===0||c===0)p={offset:l.offset+1,length:0,content:l.children.length===0?v:v+","};else{const m=c===-1||c>l.children.length?l.children.length:c,n=l.children[m-1];p={offset:n.offset+n.length,length:0,content:","+v}}return A(a,p,y)}else{const v=c,p=l.children[v];let m;if(l.children.length===1)m={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===v){const n=l.children[v-1],r=n.offset+n.length,t=l.offset+l.length;m={offset:r,length:t-2-r,content:""}}else m={offset:p.offset,length:l.children[v+1].offset-p.offset,content:""};return A(a,m,y)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${l.type}`);else return b===void 0?[]:A(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(b)},y)}function A(a,f,b){let y=E(a,f),w=f.offset,$=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;w>0&&!(0,R.$Yn)(y,w-1);)w--;for(;$<y.length&&!(0,R.$Yn)(y,$);)$++}const I=(0,R.$Vn)(y,{offset:w,length:$-w},b);for(let l=I.length-1;l>=0;l--){const c=I[l];y=E(y,c),w=Math.min(w,c.offset),$=Math.max($,c.offset+c.length),$+=c.content.length-c.length}const g=a.length-(y.length-$)-w;return[{offset:w,length:g,content:y.substring(w,$)}]}function E(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function u(a,f){const b=f.slice(0).sort((w,$)=>{const I=w.offset-$.offset;return I===0?w.length-$.length:I});let y=a.length;for(let w=b.length-1;w>=0;w--){const $=b[w];if($.offset+$.length<=y)a=E(a,$);else throw new Error("Overlapping edit");y=$.offset}return a}}),define(ne[76],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=D,e.rot=R;function D(E,u,a){return Math.min(Math.max(E,u),a)}function R(E,u){return(u+E%u)%u}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=k;class N{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=N;class A{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=A}),function(){function X(k){const N=[];typeof k=="number"&&N.push("code/timeOrigin",k);function A(u){N.push(u,Date.now())}function E(){const u=[];for(let a=0;a<N.length;a+=2)u.push({name:N[a],startTime:N[a+1]});return u}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(k+A.startTime)});return N}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=D(R))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var R in D)(typeof exports=="object"?exports:X)[R]=D[R]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function D(R){if(e[R])return e[R].exports;var k=e[R]={i:R,l:!1,exports:{}};return X[R].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=X,D.c=e,D.d=function(R,k,N){D.o(R,k)||Object.defineProperty(R,k,{enumerable:!0,get:N})},D.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},D.t=function(R,k){if(1&k&&(R=D(R)),8&k||4&k&&typeof R=="object"&&R&&R.__esModule)return R;var N=Object.create(null);if(D.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:R}),2&k&&typeof R!="string")for(var A in R)D.d(N,A,function(E){return R[E]}.bind(null,A));return N},D.n=function(R){var k=R&&R.__esModule?function(){return R.default}:function(){return R};return D.d(k,"a",k),k},D.o=function(R,k){return Object.prototype.hasOwnProperty.call(R,k)},D.p="",D(D.s=0)}([function(X,e,D){(function(R){var k;e=X.exports=U,k=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],a=0,f=a++;u[f]="0|[1-9]\\d*";var b=a++;u[b]="[0-9]+";var y=a++;u[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;u[w]="("+u[f]+")\\.("+u[f]+")\\.("+u[f]+")";var $=a++;u[$]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var I=a++;u[I]="(?:"+u[f]+"|"+u[y]+")";var g=a++;u[g]="(?:"+u[b]+"|"+u[y]+")";var l=a++;u[l]="(?:-("+u[I]+"(?:\\."+u[I]+")*))";var c=a++;u[c]="(?:-?("+u[g]+"(?:\\."+u[g]+")*))";var v=a++;u[v]="[0-9A-Za-z-]+";var p=a++;u[p]="(?:\\+("+u[v]+"(?:\\."+u[v]+")*))";var m=a++,n="v?"+u[w]+u[l]+"?"+u[p]+"?";u[m]="^"+n+"$";var r="[v=\\s]*"+u[$]+u[c]+"?"+u[p]+"?",t=a++;u[t]="^"+r+"$";var i=a++;u[i]="((?:<|>)?=?)";var s=a++;u[s]=u[b]+"|x|X|\\*";var o=a++;u[o]=u[f]+"|x|X|\\*";var h=a++;u[h]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[l]+")?"+u[p]+"?)?)?";var S=a++;u[S]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[c]+")?"+u[p]+"?)?)?";var j=a++;u[j]="^"+u[i]+"\\s*"+u[h]+"$";var O=a++;u[O]="^"+u[i]+"\\s*"+u[S]+"$";var z=a++;u[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=a++;u[C]="(?:~>?)";var T=a++;u[T]="(\\s*)"+u[C]+"\\s+",E[T]=new RegExp(u[T],"g");var J=a++;u[J]="^"+u[C]+u[h]+"$";var re=a++;u[re]="^"+u[C]+u[S]+"$";var ie=a++;u[ie]="(?:\\^)";var he=a++;u[he]="(\\s*)"+u[ie]+"\\s+",E[he]=new RegExp(u[he],"g");var le=a++;u[le]="^"+u[ie]+u[h]+"$";var ce=a++;u[ce]="^"+u[ie]+u[S]+"$";var B=a++;u[B]="^"+u[i]+"\\s*("+r+")$|^$";var Y=a++;u[Y]="^"+u[i]+"\\s*("+n+")$|^$";var V=a++;u[V]="(\\s*)"+u[i]+"\\s*("+r+"|"+u[h]+")",E[V]=new RegExp(u[V],"g");var q=a++;u[q]="^\\s*("+u[h]+")\\s+-\\s+("+u[h]+")\\s*$";var H=a++;u[H]="^\\s*("+u[S]+")\\s+-\\s+("+u[S]+")\\s*$";var Z=a++;u[Z]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)k(Q,u[Q]),E[Q]||(E[Q]=new RegExp(u[Q]));function _(x,K){if(x instanceof U)return x;if(typeof x!="string"||x.length>N||!(K?E[t]:E[m]).test(x))return null;try{return new U(x,K)}catch{return null}}function U(x,K){if(x instanceof U){if(x.loose===K)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof U))return new U(x,K);k("SemVer",x,K),this.loose=K;var ee=x.trim().match(K?E[t]:E[m]);if(!ee)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<A)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,K){var ee=_(x,K);return ee?ee.version:null},e.clean=function(x,K){var ee=_(x.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof U||(x=new U(x,this.loose)),this.compareMain(x)||this.comparePre(x)},U.prototype.compareMain=function(x){return x instanceof U||(x=new U(x,this.loose)),d(this.major,x.major)||d(this.minor,x.minor)||d(this.patch,x.patch)},U.prototype.comparePre=function(x){if(x instanceof U||(x=new U(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=x.prerelease[K];if(k("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return d(ee,ge)}while(++K)},U.prototype.inc=function(x,K){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new U(x,ee).inc(K,ge).version}catch{return null}},e.diff=function(x,K){if(G(x,K))return null;var ee=_(x),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=d;var F=/^[0-9]+$/;function d(x,K){var ee=F.test(x),ge=F.test(K);return ee&&ge&&(x=+x,K=+K),ee&&!ge?-1:ge&&!ee?1:x<K?-1:x>K?1:0}function P(x,K,ee){return new U(x,ee).compare(new U(K,ee))}function L(x,K,ee){return P(x,K,ee)>0}function M(x,K,ee){return P(x,K,ee)<0}function G(x,K,ee){return P(x,K,ee)===0}function W(x,K,ee){return P(x,K,ee)!==0}function te(x,K,ee){return P(x,K,ee)>=0}function ae(x,K,ee){return P(x,K,ee)<=0}function ue(x,K,ee,ge){var ve;switch(K){case"===":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x===ee;break;case"!==":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x!==ee;break;case"":case"=":case"==":ve=G(x,ee,ge);break;case"!=":ve=W(x,ee,ge);break;case">":ve=L(x,ee,ge);break;case">=":ve=te(x,ee,ge);break;case"<":ve=M(x,ee,ge);break;case"<=":ve=ae(x,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function pe(x,K){if(x instanceof pe){if(x.loose===K)return x;x=x.value}if(!(this instanceof pe))return new pe(x,K);k("comparator",x,K),this.loose=K,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,K){return d(K,x)},e.major=function(x,K){return new U(x,K).major},e.minor=function(x,K){return new U(x,K).minor},e.patch=function(x,K){return new U(x,K).patch},e.compare=P,e.compareLoose=function(x,K){return P(x,K,!0)},e.rcompare=function(x,K,ee){return P(K,x,ee)},e.sort=function(x,K){return x.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(x,K){return x.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=L,e.lt=M,e.eq=G,e.neq=W,e.gte=te,e.lte=ae,e.cmp=ue,e.Comparator=pe;var ye={};function fe(x,K){if(x instanceof fe)return x.loose===K?x:new fe(x.raw,K);if(x instanceof pe)return new fe(x.value,K);if(!(this instanceof fe))return new fe(x,K);if(this.loose=K,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,K,ee,ge,ve,De,Se,Le,je,Ae,Ce,Oe,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(je)?"":me(Ae)?"<"+(+je+1)+".0.0":me(Ce)?"<"+je+"."+(+Ae+1)+".0":Oe?"<="+je+"."+Ae+"."+Ce+"-"+Oe:"<="+Le)).trim()}function we(x,K){for(var ee=0;ee<x.length;ee++)if(!x[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<x.length;ee++)if(k(x[ee].semver),x[ee].semver!==ye&&x[ee].semver.prerelease.length>0){var ge=x[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(x,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(x)}function ke(x,K,ee,ge){var ve,De,Se,Le,je;switch(x=new U(x,ge),K=new fe(K,ge),ee){case">":ve=L,De=ae,Se=M,Le=">",je=">=";break;case"<":ve=M,De=te,Se=L,Le="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var Ce=K.set[Ae],Oe=null,Ne=null;if(Ce.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),Oe=Oe||ze,Ne=Ne||ze,ve(ze.semver,Oe.semver,ge)?Oe=ze:Se(ze.semver,Ne.semver,ge)&&(Ne=ze)}),Oe.operator===Le||Oe.operator===je||(!Ne.operator||Ne.operator===Le)&&De(x,Ne.semver)||Ne.operator===je&&Se(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var K=this.loose?E[B]:E[Y],ee=x.match(K);if(!ee)throw new TypeError("Invalid comparator: "+x);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new U(x,this.loose)),ue(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,K){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(x.value,K),Ee(this.value,ee,K);if(x.operator==="")return ee=new fe(this.value,K),Ee(x.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=ue(this.semver,"<",x.semver,K)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),je=ue(this.semver,">",x.semver,K)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||ve||De&&Se||Le||je},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var K=this.loose;x=x.trim(),k("range",x,K);var ee=K?E[H]:E[q];x=x.replace(ee,de),k("hyphen replace",x),x=x.replace(E[V],"$1$2$3"),k("comparator trim",x,E[V]),x=(x=(x=x.replace(E[T],"$1~")).replace(E[he],"$1^")).split(/\s+/).join(" ");var ge=K?E[B]:E[Y],ve=x.split(" ").map(function(De){return function(Se,Le){return k("comp",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(Ce){return function(Oe,Ne){k("caret",Oe,Ne);var ze=Ne?E[ce]:E[le];return Oe.replace(ze,function(Fe,be,Pe,Ie,Re){var Ue;return k("caret",Oe,Fe,be,Pe,Ie,Re),me(be)?Ue="":me(Pe)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+Re+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+Re+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+Re+" <"+(+be+1)+".0.0"):(k("no pr"),Ue=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+" <"+(+be+1)+".0.0"),k("caret return",Ue),Ue})}(Ce,Ae)}).join(" ")}(Se,Le),k("caret",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(Ce){return function(Oe,Ne){var ze=Ne?E[re]:E[J];return Oe.replace(ze,function(Fe,be,Pe,Ie,Re){var Ue;return k("tilde",Oe,Fe,be,Pe,Ie,Re),me(be)?Ue="":me(Pe)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=">="+be+"."+Pe+"."+Ie+Re+" <"+be+"."+(+Pe+1)+".0"):Ue=">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0",k("tilde return",Ue),Ue})}(Ce,Ae)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(je,Ae){return k("replaceXRanges",je,Ae),je.split(/\s+/).map(function(Ce){return function(Oe,Ne){Oe=Oe.trim();var ze=Ne?E[O]:E[j];return Oe.replace(ze,function(Fe,be,Pe,Ie,Re,Ue){k("xRange",Oe,Fe,be,Pe,Ie,Re,Ue);var Te=me(Pe),Me=Te||me(Ie),qe=Me||me(Re);return be==="="&&qe&&(be=""),Te?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&qe?(Me&&(Ie=0),qe&&(Re=0),be===">"?(be=">=",Me?(Pe=+Pe+1,Ie=0,Re=0):qe&&(Ie=+Ie+1,Re=0)):be==="<="&&(be="<",Me?Pe=+Pe+1:Ie=+Ie+1),Fe=be+Pe+"."+Ie+"."+Re):Me?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":qe&&(Fe=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0"),k("xRange return",Fe),Fe})}(Ce,Ae)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(je,Ae){return k("replaceStars",je,Ae),je.trim().replace(E[Z],"")}(Se,Le),k("stars",Se),Se}(De,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ge)})),ve=ve.map(function(De){return new pe(De,K)})},fe.prototype.intersects=function(x,K){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return x.set.some(function(ve){return ve.every(function(De){return ge.intersects(De,K)})})})})},e.toComparators=function(x,K){return new fe(x,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new U(x,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,K,ee){var ge=null,ve=null;try{var De=new fe(K,ee)}catch{return null}return x.forEach(function(Se){De.test(Se)&&(ge&&ve.compare(Se)!==-1||(ve=new U(ge=Se,ee)))}),ge},e.minSatisfying=function(x,K,ee){var ge=null,ve=null;try{var De=new fe(K,ee)}catch{return null}return x.forEach(function(Se){De.test(Se)&&(ge&&ve.compare(Se)!==1||(ve=new U(ge=Se,ee)))}),ge},e.validRange=function(x,K){try{return new fe(x,K).range||"*"}catch{return null}},e.ltr=function(x,K,ee){return ke(x,K,"<",ee)},e.gtr=function(x,K,ee){return ke(x,K,">",ee)},e.outside=ke,e.prerelease=function(x,K){var ee=_(x,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(x,K,ee){return x=new fe(x,ee),K=new fe(K,ee),x.intersects(K)},e.coerce=function(x){if(x instanceof U)return x;if(typeof x!="string")return null;var K=x.match(E[z]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,D(1))},function(X,e){var D,R,k=X.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(g){if(D===setTimeout)return setTimeout(g,0);if((D===N||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch{try{return D.call(null,g,0)}catch{return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:N}catch{D=N}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var u,a=[],f=!1,b=-1;function y(){f&&u&&(f=!1,u.length?a=u.concat(a):b=-1,a.length&&w())}function w(){if(!f){var g=E(y);f=!0;for(var l=a.length;l;){for(u=a,a=[];++b<l;)u&&u[b].run();b=-1,l=a.length}u=null,f=!1,function(c){if(R===clearTimeout)return clearTimeout(c);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(c);try{R(c)}catch{try{return R.call(null,c)}catch{return R.call(this,c)}}}(g)}}function $(g,l){this.fun=g,this.array=l}function I(){}k.nextTick=function(g){var l=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)l[c-1]=arguments[c];a.push(new $(g,l)),a.length!==1||f||E(w)},$.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=I,k.addListener=I,k.once=I,k.off=I,k.removeListener=I,k.removeAllListeners=I,k.emit=I,k.prependListener=I,k.prependOnceListener=I,k.listeners=function(g){return[]},k.binding=function(g){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(g){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[77],se([0,1]),function(X,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=void 0;class R{constructor(E,u,a){this.level=E,this.key=u,this.value=a,this.forward=[]}}const k=void 0;class N{constructor(E,u=2**16){this.comparator=E,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new R(this.c,k,k)}get size(){return this.f}clear(){this.e=new R(this.c,k,k),this.f=0}has(E){return!!N.g(this,E,this.comparator)}get(E){return N.g(this,E,this.comparator)?.value}set(E,u){return N.h(this,E,u,this.comparator)&&(this.f+=1),this}delete(E){const u=N.k(this,E,this.comparator);return u&&(this.f-=1),u}forEach(E,u){let a=this.e.forward[0];for(;a;)E.call(u,a.value,a.key,this),a=a.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this.e.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static g(E,u,a){let f=E.e;for(let b=E.d-1;b>=0;b--)for(;f.forward[b]&&a(f.forward[b].key,u)<0;)f=f.forward[b];if(f=f.forward[0],f&&a(f.key,u)===0)return f}static h(E,u,a,f){const b=[];let y=E.e;for(let w=E.d-1;w>=0;w--){for(;y.forward[w]&&f(y.forward[w].key,u)<0;)y=y.forward[w];b[w]=y}if(y=y.forward[0],y&&f(y.key,u)===0)return y.value=a,!1;{const w=N.j(E);if(w>E.d){for(let $=E.d;$<w;$++)b[$]=E.e;E.d=w}y=new R(w,u,a);for(let $=0;$<w;$++)y.forward[$]=b[$].forward[$],b[$].forward[$]=y;return!0}}static j(E,u=.5){let a=1;for(;Math.random()<u&&a<E.c;)a+=1;return a}static k(E,u,a){const f=[];let b=E.e;for(let y=E.d-1;y>=0;y--){for(;b.forward[y]&&a(b.forward[y].key,u)<0;)b=b.forward[y];f[y]=b}if(b=b.forward[0],!b||a(b.key,u)!==0)return!1;for(let y=0;y<E.d&&f[y].forward[y]===b;y++)f[y].forward[y]=b.forward[y];for(;E.d>0&&E.e.forward[E.d-1]===k;)E.d-=1;return!0}}e.$Cs=N}),define(ne[46],se([0,1,9,2]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=k,e.$te=N,e.$ue=A,e.$ve=E,e.$we=a,e.$xe=f,e.$ye=b,e.$ze=y,e.$Ae=w,e.$Be=$,e.$Ce=I,e.$De=g,e.$Ee=l,e.$Fe=c,e.$Ge=v;function k(p){const m=p;return m?typeof m.read=="function":!1}function N(p){const m=p;return m?[m.on,m.pause,m.resume,m.destroy].every(n=>typeof n=="function"):!1}function A(p){const m=p;return m?N(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}function E(p,m){return new u(p,m)}class u{constructor(m,n){this.e=m,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(n=>n(m))}h(m){this.c.error.length===0?(0,D.$1)(m):this.c.error.slice(0).forEach(n=>n(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,n){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(m,n){if(this.a.destroyed)return;let r;switch(m){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(p,m){const n=[];let r;for(;(r=p.read())!==null;)n.push(r);return m(n)}function f(p,m,n){const r=[];let t;for(;(t=p.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}function b(p,m){return new Promise((n,r)=>{const t=[];y(p,{onData:i=>{m&&t.push(i)},onError:i=>{m?r(i):n(void 0)},onEnd:()=>{n(m?m(t):void 0)}})})}function y(p,m,n){p.on("error",r=>{n?.isCancellationRequested||m.onError(r)}),p.on("end",()=>{n?.isCancellationRequested||m.onEnd()}),p.on("data",r=>{n?.isCancellationRequested||m.onData(r)})}function w(p,m){return new Promise((n,r)=>{const t=new R.$Tc,i=[],s=S=>{if(i.push(S),i.length>m)return t.dispose(),p.pause(),n({stream:p,buffer:i,ended:!1})},o=S=>(t.dispose(),r(S)),h=()=>(t.dispose(),n({stream:p,buffer:i,ended:!0}));t.add((0,R.$Sc)(()=>p.removeListener("error",o))),p.on("error",o),t.add((0,R.$Sc)(()=>p.removeListener("end",h))),p.on("end",h),t.add((0,R.$Sc)(()=>p.removeListener("data",s))),p.on("data",s)})}function $(p,m){const n=E(m);return n.end(p),n}function I(){const p=E(()=>{throw new Error("not supported")});return p.end(),p}function g(p){let m=!1;return{read:()=>m?null:(m=!0,p)}}function l(p,m,n){const r=E(n);return y(p,{onData:t=>r.write(m.data(t)),onError:t=>r.error(m.error?m.error(t):t),onEnd:()=>r.end()}),r}function c(p,m,n){let r=!1;return{read:()=>{const t=m.read();return r?t:(r=!0,t!==null?n([p,t]):p)}}}function v(p,m,n){let r=!1;const t=E(n);return y(m,{onData:i=>r?t.write(i):(r=!0,t.write(n([p,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(p)),t.end()}}),t}}),define(ne[14],se([0,1,169,46]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=a,e.$Je=f,e.$Ke=b,e.$Le=y,e.$Me=w,e.$Ne=$,e.$Oe=I,e.$Pe=g,e.$Qe=l,e.$Re=c,e.$Se=v,e.$Te=p,e.$Ue=m,e.$Ve=n,e.$We=r,e.$Xe=t,e.$Ye=i,e.$Ze=s,e.$1e=o,e.$2e=j;const k=typeof Buffer<"u",N=new D.$V(()=>new Uint8Array(256));let A,E;class u{static alloc(z){return k?new u(Buffer.allocUnsafe(z)):new u(new Uint8Array(z))}static wrap(z){return k&&!Buffer.isBuffer(z)&&(z=Buffer.from(z.buffer,z.byteOffset,z.byteLength)),new u(z)}static fromString(z,C){return!(C?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(z)):(A||(A=new TextEncoder),new u(A.encode(z)))}static fromByteArray(z){const C=u.alloc(z.length);for(let T=0,J=z.length;T<J;T++)C.buffer[T]=z[T];return C}static concat(z,C){if(typeof C>"u"){C=0;for(let re=0,ie=z.length;re<ie;re++)C+=z[re].byteLength}const T=u.alloc(C);let J=0;for(let re=0,ie=z.length;re<ie;re++){const he=z[re];T.set(he,J),J+=he.byteLength}return T}constructor(z){this.buffer=z,this.byteLength=this.buffer.byteLength}clone(){const z=u.alloc(this.byteLength);return z.set(this),z}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(z,C){return new u(this.buffer.subarray(z,C))}set(z,C){if(z instanceof u)this.buffer.set(z.buffer,C);else if(z instanceof Uint8Array)this.buffer.set(z,C);else if(z instanceof ArrayBuffer)this.buffer.set(new Uint8Array(z),C);else if(ArrayBuffer.isView(z))this.buffer.set(new Uint8Array(z.buffer,z.byteOffset,z.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(z){return y(this.buffer,z)}writeUInt32BE(z,C){w(this.buffer,z,C)}readUInt32LE(z){return $(this.buffer,z)}writeUInt32LE(z,C){I(this.buffer,z,C)}readUInt8(z){return g(this.buffer,z)}writeUInt8(z,C){l(this.buffer,z,C)}indexOf(z,C=0){return a(this.buffer,z instanceof u?z.buffer:z,C)}}e.$He=u;function a(O,z,C=0){const T=z.byteLength,J=O.byteLength;if(T===0)return 0;if(T===1)return O.indexOf(z[0]);if(T>J-C)return-1;const re=N.value;re.fill(z.length);for(let ce=0;ce<z.length;ce++)re[z[ce]]=z.length-ce-1;let ie=C+z.length-1,he=ie,le=-1;for(;ie<J;)if(O[ie]===z[he]){if(he===0){le=ie;break}ie--,he--}else ie+=Math.max(z.length-he,re[O[ie]]),he=z.length-1;return le}function f(O,z){return O[z+0]<<0>>>0|O[z+1]<<8>>>0}function b(O,z,C){O[C+0]=z&255,z=z>>>8,O[C+1]=z&255}function y(O,z){return O[z]*2**24+O[z+1]*2**16+O[z+2]*2**8+O[z+3]}function w(O,z,C){O[C+3]=z,z=z>>>8,O[C+2]=z,z=z>>>8,O[C+1]=z,z=z>>>8,O[C]=z}function $(O,z){return O[z+0]<<0>>>0|O[z+1]<<8>>>0|O[z+2]<<16>>>0|O[z+3]<<24>>>0}function I(O,z,C){O[C+0]=z&255,z=z>>>8,O[C+1]=z&255,z=z>>>8,O[C+2]=z&255,z=z>>>8,O[C+3]=z&255}function g(O,z){return O[z]}function l(O,z,C){O[C]=z}function c(O){return R.$we(O,z=>u.concat(z))}function v(O){return R.$De(O)}function p(O){return R.$ye(O,z=>u.concat(z))}async function m(O){return O.ended?u.concat(O.buffer):u.concat([...O.buffer,await p(O.stream)])}function n(O){return R.$Be(O,z=>u.concat(z))}function r(O){return R.$Ee(O,{data:z=>typeof z=="string"?u.fromString(z):u.wrap(z)},z=>u.concat(z))}function t(O){return R.$ve(z=>u.concat(z),O)}function i(O,z){return R.$Fe(O,z,C=>u.concat(C))}function s(O,z){return R.$Ge(O,z,C=>u.concat(C))}function o(O){let z=0,C=0,T=0;const J=new Uint8Array(Math.floor(O.length/4*3)),re=he=>{switch(C){case 3:J[T++]=z|he,C=0;break;case 2:J[T++]=z|he>>>2,z=he<<6,C=3;break;case 1:J[T++]=z|he>>>4,z=he<<4,C=2;break;default:z=he<<2,C=1}};for(let he=0;he<O.length;he++){const le=O.charCodeAt(he);if(le>=65&&le<=90)re(le-65);else if(le>=97&&le<=122)re(le-97+26);else if(le>=48&&le<=57)re(le-48+52);else if(le===43||le===45)re(62);else if(le===47||le===95)re(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${O[he]}`)}}const ie=T;for(;C>0;)re(0);return u.wrap(J).slice(0,ie)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:O},z=!0,C=!1){const T=C?S:h;let J="";const re=O.byteLength%3;let ie=0;for(;ie<O.byteLength-re;ie+=3){const he=O[ie+0],le=O[ie+1],ce=O[ie+2];J+=T[he>>>2],J+=T[(he<<4|le>>>4)&63],J+=T[(le<<2|ce>>>6)&63],J+=T[ce&63]}if(re===1){const he=O[ie+0];J+=T[he>>>2],J+=T[he<<4&63],z&&(J+="==")}else if(re===2){const he=O[ie+0],le=O[ie+1];J+=T[he>>>2],J+=T[(he<<4|le>>>4)&63],J+=T[le<<2&63],z&&(J+="=")}return J}}),define(ne[43],se([0,1,31]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=R,e.$nj=k,e.$oj=N,e.$pj=E,e.$rj=I;function R(l){return k(l,0)}function k(l,c){switch(typeof l){case"object":return l===null?N(349,c):Array.isArray(l)?u(l,c):a(l,c);case"string":return E(l,c);case"boolean":return A(l,c);case"number":return N(l,c);case"undefined":return N(937,c);default:return N(617,c)}}function N(l,c){return(c<<5)-c+l|0}function A(l,c){return N(l?433:863,c)}function E(l,c){c=N(149417,c);for(let v=0,p=l.length;v<p;v++)c=N(l.charCodeAt(v),c);return c}function u(l,c){return c=N(104579,c),l.reduce((v,p)=>k(p,v),c)}function a(l,c){return c=N(181387,c),Object.keys(l).sort().reduce((v,p)=>(v=E(p,v),k(l[p],v)),c)}class f{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=k(c,this.g),this.g}}e.$qj=f;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y(l,c,v=32){const p=v-c,m=~((1<<p)-1);return(l<<c|(m&l)>>>p)>>>0}function w(l,c=0,v=l.byteLength,p=0){for(let m=0;m<v;m++)l[c+m]=p}function $(l,c,v="0"){for(;l.length<c;)l=v+l;return l}function I(l,c=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(v=>v.toString(16).padStart(2,"0")).join(""):$((l>>>0).toString(16),c/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const v=c.length;if(v===0)return;const p=this.p;let m=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=c.charCodeAt(0),t=0);;){let i=r;if(D.$Df(r))if(t+1<v){const s=c.charCodeAt(t+1);D.$Ef(s)?(t++,i=D.$Ff(r,s)):i=65533}else{n=r;break}else D.$Ef(r)&&(i=65533);if(m=this.w(p,m,i),t++,t<v)r=c.charCodeAt(t);else break}this.r=m,this.u=n}w(c,v,p){return p<128?c[v++]=p:p<2048?(c[v++]=192|(p&1984)>>>6,c[v++]=128|(p&63)>>>0):p<65536?(c[v++]=224|(p&61440)>>>12,c[v++]=128|(p&4032)>>>6,c[v++]=128|(p&63)>>>0):(c[v++]=240|(p&1835008)>>>18,c[v++]=128|(p&258048)>>>12,c[v++]=128|(p&4032)>>>6,c[v++]=128|(p&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,c[0]=c[64],c[1]=c[65],c[2]=c[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),I(this.h)+I(this.l)+I(this.m)+I(this.n)+I(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=g.g,v=this.q;for(let h=0;h<64;h+=4)c.setUint32(h,v.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)c.setUint32(h,y(c.getUint32(h-12,!1)^c.getUint32(h-32,!1)^c.getUint32(h-56,!1)^c.getUint32(h-64,!1),1),!1);let p=this.h,m=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let h=0;h<80;h++)h<20?(i=m&n|~m&r,s=1518500249):h<40?(i=m^n^r,s=1859775393):h<60?(i=m&n|m&r|n&r,s=2400959708):(i=m^n^r,s=3395469782),o=y(p,5)+i+t+s+c.getUint32(h*4,!1)&4294967295,t=r,r=n,n=y(m,30),m=p,p=o;this.h=this.h+p&4294967295,this.l=this.l+m&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$sj=g}),define(ne[55],se([0,1,31]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const N="error",A="warning",E="warn",u="info",a="ignore";function f(y){return y?D.$zf(N,y)?k.Error:D.$zf(A,y)||D.$zf(E,y)?k.Warning:D.$zf(u,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=f;function b(y){switch(y){case k.Error:return N;case k.Warning:return A;case k.Info:return u;default:return a}}k.toString=b}(R||(R={})),e.default=R}),define(ne[27],se([0,1,3]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=R,e.$6n=k,e.$7n=A,e.$8n=u,e.$9n=a,e.$0n=f,e.$$n=b,e.$_n=y,e.$ao=w,e.$bo=$,e.$co=I,e.$do=g,e.$eo=l;function R(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const v=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([p,m])=>{v[p]=m&&typeof m=="object"?R(m):m}),v}function k(c){if(!c||typeof c!="object")return c;const v=[c];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const m in p)if(N.call(p,m)){const n=p[m];typeof n=="object"&&!Object.isFrozen(n)&&!(0,D.$bg)(n)&&v.push(n)}}return c}const N=Object.prototype.hasOwnProperty;function A(c,v){return E(c,v,new Set)}function E(c,v,p){if((0,D.$hg)(c))return c;const m=v(c);if(typeof m<"u")return m;if(Array.isArray(c)){const n=[];for(const r of c)n.push(E(r,v,p));return n}if((0,D.$ag)(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const n={};for(const r in c)N.call(c,r)&&(n[r]=E(c[r],v,p));return p.delete(c),n}return c}function u(c,v,p=!0){return(0,D.$ag)(c)?((0,D.$ag)(v)&&Object.keys(v).forEach(m=>{m in c?p&&((0,D.$ag)(c[m])&&(0,D.$ag)(v[m])?u(c[m],v[m],p):c[m]=v[m]):c[m]=v[m]}),c):v}function a(c,v){if(c===v)return!0;if(c==null||v===null||v===void 0||typeof c!=typeof v||typeof c!="object"||Array.isArray(c)!==Array.isArray(v))return!1;let p,m;if(Array.isArray(c)){if(c.length!==v.length)return!1;for(p=0;p<c.length;p++)if(!a(c[p],v[p]))return!1}else{const n=[];for(m in c)n.push(m);n.sort();const r=[];for(m in v)r.push(m);if(r.sort(),!a(n,r))return!1;for(p=0;p<n.length;p++)if(!a(c[n[p]],v[n[p]]))return!1}return!0}function f(c){const v=new Set;return JSON.stringify(c,(p,m)=>{if((0,D.$ag)(m)||Array.isArray(m)){if(v.has(m))return"[Circular]";v.add(m)}return typeof m=="bigint"?`[BigInt ${m.toString()}]`:m})}function b(c,v){const p=Object.create(null);return!c||!v||Object.keys(v).forEach(n=>{const r=c[n],t=v[n];a(r,t)||(p[n]=t)}),p}function y(c,v){const p=v.toLowerCase(),m=Object.keys(c).find(n=>n.toLowerCase()===p);return m?c[m]:c[v]}function w(c,v){const p=Object.create(null);for(const[m,n]of Object.entries(c))v(m,n)&&(p[m]=n);return p}function $(c){let v=[];for(;Object.prototype!==c;)v=v.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return v}function I(c){const v=[];for(const p of $(c))typeof c[p]=="function"&&v.push(p);return v}function g(c,v){const p=n=>function(){const r=Array.prototype.slice.call(arguments,0);return v(n,r)},m={};for(const n of c)m[n]=p(n);return m}function l(c,v){const p={};for(const[m,n]of Object.entries(c))p[m]=v(n,m);return p}}),define(ne[28],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=R;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(k){return D.test(k)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const N=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){k(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let u=0,a="";return a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a}}()}),define(ne[78],se([0,1,33]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=N;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const E=A.replace(/\-/g,":").toLowerCase();return!R.has(E)}function N(){const A=(0,D.networkInterfaces)();for(const E in A){const u=A[E];if(u){for(const{mac:a}of u)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[79],se([7,4]),function(X,e){return X.create("vs/base/common/date",e)}),define(ne[80],se([0,1,79]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=a,e.$5m=f,e.$6m=b;const R=60,k=R*60,N=k*24,A=N*7,E=N*30,u=N*365;function a(y,w,$,I){typeof y!="number"&&(y=y.getTime());const g=Math.round((new Date().getTime()-y)/1e3);if(g<-30)return(0,D.localize)(0,null,a(new Date().getTime()+g*1e3,!1));if(!I&&g<30)return(0,D.localize)(1,null);let l;return g<R?(l=g,w?l===1?$?(0,D.localize)(2,null,l):(0,D.localize)(3,null,l):$?(0,D.localize)(4,null,l):(0,D.localize)(5,null,l):l===1?$?(0,D.localize)(6,null,l):(0,D.localize)(7,null,l):$?(0,D.localize)(8,null,l):(0,D.localize)(9,null,l)):g<k?(l=Math.floor(g/R),w?l===1?$?(0,D.localize)(10,null,l):(0,D.localize)(11,null,l):$?(0,D.localize)(12,null,l):(0,D.localize)(13,null,l):l===1?$?(0,D.localize)(14,null,l):(0,D.localize)(15,null,l):$?(0,D.localize)(16,null,l):(0,D.localize)(17,null,l)):g<N?(l=Math.floor(g/k),w?l===1?$?(0,D.localize)(18,null,l):(0,D.localize)(19,null,l):$?(0,D.localize)(20,null,l):(0,D.localize)(21,null,l):l===1?$?(0,D.localize)(22,null,l):(0,D.localize)(23,null,l):$?(0,D.localize)(24,null,l):(0,D.localize)(25,null,l)):g<A?(l=Math.floor(g/N),w?l===1?(0,D.localize)(26,null,l):(0,D.localize)(27,null,l):l===1?(0,D.localize)(28,null,l):(0,D.localize)(29,null,l)):g<E?(l=Math.floor(g/A),w?l===1?$?(0,D.localize)(30,null,l):(0,D.localize)(31,null,l):$?(0,D.localize)(32,null,l):(0,D.localize)(33,null,l):l===1?$?(0,D.localize)(34,null,l):(0,D.localize)(35,null,l):$?(0,D.localize)(36,null,l):(0,D.localize)(37,null,l)):g<u?(l=Math.floor(g/E),w?l===1?$?(0,D.localize)(38,null,l):(0,D.localize)(39,null,l):$?(0,D.localize)(40,null,l):(0,D.localize)(41,null,l):l===1?$?(0,D.localize)(42,null,l):(0,D.localize)(43,null,l):$?(0,D.localize)(44,null,l):(0,D.localize)(45,null,l)):(l=Math.floor(g/u),w?l===1?$?(0,D.localize)(46,null,l):(0,D.localize)(47,null,l):$?(0,D.localize)(48,null,l):(0,D.localize)(49,null,l):l===1?$?(0,D.localize)(50,null,l):(0,D.localize)(51,null,l):$?(0,D.localize)(52,null,l):(0,D.localize)(53,null,l))}function f(y,w){const $=Math.abs(y/1e3);return $<1?w?(0,D.localize)(54,null,y):(0,D.localize)(55,null,y):$<R?w?(0,D.localize)(56,null,Math.round(y)/1e3):(0,D.localize)(57,null,Math.round(y)/1e3):$<k?w?(0,D.localize)(58,null,Math.round(y/(1e3*R))):(0,D.localize)(59,null,Math.round(y/(1e3*R))):$<N?w?(0,D.localize)(60,null,Math.round(y/(1e3*k))):(0,D.localize)(61,null,Math.round(y/(1e3*k))):(0,D.localize)(62,null,Math.round(y/(1e3*N)))}function b(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[81],se([7,4]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ne[34],se([0,1,19,3,81]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=u,e.$kj=a,e.$lj=f;function N(b,y){return y&&(b.stack||b.stacktrace)?k.localize(0,null,E(b),A(b.stack)||A(b.stacktrace)):E(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function E(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?k.localize(1,null,b.message):b.message||k.localize(2,null)}function u(b=null,y=!1){if(!b)return k.localize(3,null);if(Array.isArray(b)){const w=D.$Hb(b),$=u(w[0],y);return w.length>1?k.localize(4,null,$,w.length):$}if(R.$$f(b))return b;if(b.detail){const w=b.detail;if(w.error)return N(w.error,y);if(w.exception)return N(w.exception,y)}return b.stack?N(b,y):b.message?b.message:k.localize(5,null)}function a(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}function f(b,y){let w;return typeof b=="string"?w=new Error(b):w=b,w.actions=y,w}}),define(ne[82],se([7,4]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ne[83],se([0,1,82]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=R;function R(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(ne[56],se([0,1,12]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=N,e.$pm=A;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R||(e.Source=R={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function N(E,...u){const a=u.reduce((y,w)=>(y[w]=!0,y),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(y=>!a[y]).forEach(y=>{for(let w=0;w<f.length;w++)if(y.search(f[w])!==-1){delete E[y];break}})}function A(E){E&&(delete E.DEBUG,D.$j&&delete E.DYLD_LIBRARY_PATH,D.$k&&delete E.LD_PRELOAD)}}),define(ne[84],se([0,1,11]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=R,e.$Zq=k,e.$1q=N,e.log=E;function R(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function k(a){const f=[];let b;try{const y=JSON.parse(a.arguments),w=y[y.length-1];w&&w.__$stack&&(y.pop(),b=w.__$stack),f.push(...y)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:b}}function N(a){if(typeof a!="string")return N(k(a).stack);const f=a;if(f){const b=A(f),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:D.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function A(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function E(a,f){const{args:b,stack:y}=k(a),w=typeof b[0]=="string"&&b.length===1;let $=A(y);$&&($=`(${$.trim()})`);let I=[];if(typeof b[0]=="string"?$&&w?I=[`%c[${f}] %c${b[0]} %c${$}`,u("blue"),u(""),u("grey")]:I=[`%c[${f}] %c${b[0]}`,u("blue"),u(""),...b.slice(1)]:I=[`%c[${f}]%`,u("blue"),...b],$&&!w&&I.push($),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,I)}function u(a){return`color: ${a}`}}),define(ne[47],se([0,1,14,11]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=k,e.$7h=N,e.$8h=E;function k(u){return JSON.stringify(u,A)}function N(u){let a=JSON.parse(u);return a=E(a),a}function A(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function E(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return R.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof D.$He||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let f=0;f<u.length;++f)u[f]=E(u[f],a+1);else for(const f in u)Object.hasOwnProperty.call(u,f)&&(u[f]=E(u[f],a+1))}return u}}),define(ne[85],se([0,1,72,15,12,11]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=f;class A{constructor(y,w,$){this.id=y,this.dependencies=w,this.callback=$}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(y,w,$)=>{typeof y!="string"&&($=w,w=y,y=null),(typeof w!="object"||!Array.isArray(w))&&($=w,w=null),this.c.push(new A(y,w,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this.g();const w=await(this.a?this.i(y):this.b?this.h(y):this.j(y));if(!w)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(y){return new Promise((w,$)=>{const I=document.createElement("script");I.setAttribute("async","async"),I.setAttribute("type","text/javascript");const g=()=>{I.removeEventListener("load",l),I.removeEventListener("error",c)},l=v=>{g(),w(this.c.pop())},c=v=>{g(),$(v)};I.addEventListener("load",l),I.addEventListener("error",c),this.f&&(y=this.f.createScriptURL(y)),I.setAttribute("src",y),window.document.getElementsByTagName("head")[0].appendChild(I)})}i(y){return new Promise((w,$)=>{try{this.f&&(y=this.f.createScriptURL(y)),importScripts(y),w(this.c.pop())}catch(I){$(I)}})}async j(y){try{const w=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,I=globalThis._VSCODE_NODE_MODULES.module,g=N.URI.parse(y).fsPath,l=w.readFileSync(g).toString(),c=I.wrap(l.replace(/^#!.*/,""));return new $.Script(c).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function f(b,y,w){if(D.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[b]&&(b=a[b]);const $=`${b}/${y}`;if(u.has($))return u.get($);let I;if(/^\w[\w\d+.-]*:\/\//.test($))I=$;else{const v=`${w&&!k.$o?R.$Pg:R.$Og}/${$}`;I=R.$Sg.asBrowserUri(v).toString(!0)}const g=E.INSTANCE.load(I);return u.set($,g),g}else return await new Promise(($,I)=>{X([b],$,I)})}}),define(ne[86],se([0,1,33,48,28,78,12]),function(X,e,D,R,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Hn=u,e.$In=b,e.$Gn=new class{c(y){return this.a||(this.a=R.$Ei.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,w=0;const $=(0,D.networkInterfaces)();for(const I in $){const g=$[I];if(g)for(const{mac:l,internal:c}of g)c||(w+=1,this.c(l.toUpperCase())&&(y+=1))}this.b=w>0?y/w:0}return this.b}};let E;async function u(y){return E||(E=(async()=>await a(y)||k.$Ug())()),E}async function a(y){try{const w=await new Promise((I,g)=>{X(["crypto"],I,g)}),$=(0,N.$Fn)();return w.createHash("sha256").update($,"utf8").digest("hex")}catch(w){y(w);return}}const f="Software\\Microsoft\\SQMClient";async function b(y){if(A.$i){const w=await new Promise(($,I)=>{X(["@vscode/windows-registry"],$,I)});try{return w.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch($){return y($),""}}return""}}),define(ne[87],se([0,1,33,16,25]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=c,e.$nm=v;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=1:f=0;class b{constructor(m,n,r){this.exePath=m,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:p=!1}={}){return p?a===0?process.env["ProgramFiles(x86)"]||null:f===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:p=!1,findPreview:m=!1}={}){const n=y({useAlternateBitness:p});if(!n)return null;const r=R.$jc(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const h of await k.Promises.readdir(r)){let S=-1;if(m){const O=h.indexOf("-");if(O<0)continue;const z=h.substring(0,O);if(!N.test(z)||h.substring(O+1)!=="preview")continue;S=parseInt(z,10)}else{if(!N.test(h))continue;S=parseInt(h,10)}if(S<=t)continue;const j=R.$jc(r,h,"pwsh.exe");await k.SymlinkSupport.existsFile(j)&&(i=j,t=S)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=m?" Preview":"";return new b(i,`PowerShell${o}${s}`,!0)}async function $({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const m=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=p?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(m))if(n.test(t)){const i=R.$jc(m,t,"pwsh.exe");return new b(i,r)}return null}function I(){const p=R.$jc(D.homedir(),".dotnet","tools","pwsh.exe");return new b(p,".NET Core PowerShell Global Tool")}function g(){const p=R.$jc(process.env.windir,a===1&&f!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(p,"Windows PowerShell",!0)}async function*l(){let p=await w();p&&(yield p),p=await w({useAlternateBitness:!0}),p&&(yield p),p=await $(),p&&(yield p),p=I(),p&&(yield p),p=await w({findPreview:!0}),p&&(yield p),p=await $({findPreview:!0}),p&&(yield p),p=await w({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=g(),p&&(yield p)}async function*c(){for await(const p of l())await p.exists()&&(yield p)}async function v(){for await(const p of c())return p;return null}}),define(ne[57],se([0,1,16,12,35,56,3,25]),function(X,e,D,R,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=u,e.$rm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function u(b=k.env){return b.comspec||"cmd.exe"}function a(b){let y=[],w=!1;const $=function(I){if(w){y.push(I);return}(!b.send(I,l=>{if(l&&console.error(l),w=!1,y.length>0){const c=y.slice(0);y=[],c.forEach(v=>$(v))}})||R.$i)&&(w=!0)};return{send:$}}var f;(function(b){async function y(w,$,I){if(D.$ic(w))return w;if($===void 0&&($=k.cwd()),D.$mc(w)!=="."||(I===void 0&&A.$$f(k.env.PATH)&&(I=k.env.PATH.split(D.$tc)),I===void 0||I.length===0))return D.$jc($,w);async function l(c){if(await E.Promises.exists(c)){let v;try{v=await E.Promises.stat(c)}catch(p){p.message.startsWith("EACCES")&&(v=await E.Promises.lstat(c))}return v?!v.isDirectory():!1}return!1}for(const c of I){let v;if(D.$ic(c)?v=D.$jc(c,w):v=D.$jc($,c,w),await l(v))return v;let p=v+".com";if(await l(p)||(p=v+".exe",await l(p)))return p}return D.$jc($,w)}b.findExecutable=y})(f||(e.win32=f={}))}),define(ne[88],se([0,1,33,12,87,57]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=A;async function A(b,y){return b===1?R.$i?f():N.$qm(y):u(b,y)}let E=null;function u(b,y){if(R.$k&&b===2||R.$j&&b===3)return"/bin/bash";if(!E){let w;if(R.$i)w="/bin/bash";else{if(w=y.SHELL,!w)try{w=(0,D.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}E=w}return E}let a=null;async function f(){return a||(a=(await(0,k.$nm)()).exePath),a}});var $e=this&&this.__decorate||function(X,e,D,R){var k=arguments.length,N=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,D):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(X,e,D,R);else for(var E=X.length-1;E>=0;E--)(A=X[E])&&(N=(k<3?A(N):k>3?A(e,D,N):A(e,D))||N);return k>3&&N&&Object.defineProperty(e,D,N),N};define(ne[58],se([0,1,19,8,14,20,54,9,5,2,47,31,3]),function(X,e,D,R,k,N,A,E,u,a,f,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=o,e.$_h=h,e.$ei=T,e.$fi=J;var w;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(w||(w={}));function $(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(I||(I={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(l||(l={}));function c(V){let q=0;for(let H=0;;H+=7){const Z=V.read(1);if(q|=(Z.buffer[0]&127)<<H,!(Z.buffer[0]&128))return q}}const v=t(0);function p(V,q){if(q===0){V.write(v);return}let H=0;for(let Q=q;Q!==0;Q=Q>>>7)H++;const Z=k.$He.alloc(H);for(let Q=0;q!==0;Q++)Z.buffer[Q]=q&127,q=q>>>7,q>0&&(Z.buffer[Q]|=128);V.write(Z)}class m{constructor(q){this.b=q,this.a=0}read(q){const H=this.b.slice(this.a,this.a+q);return this.a+=H.byteLength,H}}e.$9h=m;class n{constructor(){this.a=[]}get buffer(){return k.$He.concat(this.a)}write(q){this.a.push(q)}}e.$0h=n;var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(r||(r={}));function t(V){const q=k.$He.alloc(1);return q.writeUInt8(V,0),q}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(V,q){if(typeof q>"u")V.write(i.Undefined);else if(typeof q=="string"){const H=k.$He.fromString(q);V.write(i.String),p(V,H.byteLength),V.write(H)}else if(s&&Buffer.isBuffer(q)){const H=k.$He.wrap(q);V.write(i.Buffer),p(V,H.byteLength),V.write(H)}else if(q instanceof k.$He)V.write(i.VSBuffer),p(V,q.byteLength),V.write(q);else if(Array.isArray(q)){V.write(i.Array),p(V,q.length);for(const H of q)o(V,H)}else if(typeof q=="number"&&(q|0)===q)V.write(i.Uint),p(V,q);else{const H=k.$He.fromString(JSON.stringify(q));V.write(i.Object),p(V,H.byteLength),V.write(H)}}function h(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(c(V)).toString();case r.Buffer:return V.read(c(V)).buffer;case r.VSBuffer:return V.read(c(V));case r.Array:{const H=c(V),Z=[];for(let Q=0;Q<H;Q++)Z.push(h(V));return Z}case r.Object:return JSON.parse(V.read(c(V)).toString());case r.Int:return c(V)}}class S{constructor(q,H,Z=null,Q=1e3){this.h=q,this.j=H,this.k=Z,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(q,H){this.b.set(q,H),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const H=this.o([q.type]);this.k?.logOutgoing(H,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const H=this.o([q.type,q.id],q.data);this.k?.logOutgoing(H,q.id,1,g(q.type),q.data);return}}}o(q,H=void 0){const Z=new n;return o(Z,q),o(Z,H),this.p(Z.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const H=new m(q),Z=h(H),Q=h(H),_=Z[0];switch(_){case 100:return this.k?.logIncoming(q.byteLength,Z[1],1,`${$(_)}: ${Z[2]}.${Z[3]}`,Q),this.s({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:Q});case 102:return this.k?.logIncoming(q.byteLength,Z[1],1,`${$(_)}: ${Z[2]}.${Z[3]}`,Q),this.t({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:Q});case 101:return this.k?.logIncoming(q.byteLength,Z[1],1,`${$(_)}`),this.u({type:_,id:Z[1]});case 103:return this.k?.logIncoming(q.byteLength,Z[1],1,`${$(_)}`),this.u({type:_,id:Z[1]})}}s(q){const H=this.b.get(q.channelName);if(!H){this.v(q);return}const Z=new N.$qe;let Q;try{Q=H.call(this.j,q.name,q.arg,Z.token)}catch(F){Q=Promise.reject(F)}const _=q.id;Q.then(F=>{this.m({id:_,data:F,type:201})},F=>{F instanceof Error?this.m({id:_,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:_,data:F,type:203})}).finally(()=>{U.dispose(),this.d.delete(q.id)});const U=(0,a.$Sc)(()=>Z.cancel());this.d.set(q.id,U)}t(q){const H=this.b.get(q.channelName);if(!H){this.v(q);return}const Z=q.id,_=H.listen(this.j,q.name,q.arg)(U=>this.m({id:Z,data:U,type:204}));this.d.set(q.id,_)}u(q){const H=this.d.get(q.id);H&&(H.dispose(),this.d.delete(q.id))}v(q){let H=this.g.get(q.channelName);H||(H=[],this.g.set(q.channelName,H));const Z=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:q,timeoutTimer:Z})}w(q){const H=this.g.get(q);if(H){for(const Z of H)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$ai=S;var j;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(j||(e.RequestInitiator=j={}));class O{constructor(q,H=null){this.l=q,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=H}getChannel(q){const H=this;return{call(Z,Q,_){return H.a?Promise.reject(new E.$5):H.m(q,Z,Q,_)},listen(Z,Q){return H.a?u.Event.None:H.o(q,Z,Q)}}}m(q,H,Z,Q=N.CancellationToken.None){const _=this.g++,F={id:_,type:100,channelName:q,name:H,arg:Z};if(Q.isCancellationRequested)return Promise.reject(new E.$5);let d;return new Promise((L,M)=>{if(Q.isCancellationRequested)return M(new E.$5);const G=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(_),L(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,M(ye);break}case 203:this.f.delete(_),M(pe.data);break}};this.f.set(_,ue),this.p(F)};let W=null;this.b===l.Idle?G():(W=(0,R.$lh)(ue=>this.u()),W.then(()=>{W=null,G()}));const te=()=>{W?(W.cancel(),W=null):this.p({id:_,type:101}),M(new E.$5)},ae=Q.onCancellationRequested(te);d=(0,a.$Rc)((0,a.$Sc)(te),ae),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(q,H,Z){const Q=this.g++,U={id:Q,type:102,channelName:q,name:H,arg:Z};let F=null;const d=new u.$fe({onWillAddFirstListener:()=>{F=(0,R.$lh)(L=>this.u()),F.then(()=>{F=null,this.d.add(d),this.p(U)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(d),this.p({id:Q,type:103}))}}),P=L=>d.fire(L.data);return this.f.set(Q,P),d.event}p(q){switch(q.type){case 100:case 102:{const H=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(H,q.id,0,`${$(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const H=this.q([q.type,q.id]);this.j?.logOutgoing(H,q.id,0,$(q.type));return}}}q(q,H=void 0){const Z=new n;return o(Z,q),o(Z,H),this.r(Z.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const H=new m(q),Z=h(H),Q=h(H),_=Z[0];switch(_){case 200:return this.j?.logIncoming(q.byteLength,0,0,g(_)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,Z[1],0,g(_),Q),this.t({type:Z[0],id:Z[1],data:Q})}}t(q){if(q.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$bi=O,$e([A.$3h],O.prototype,"onDidInitializePromise",null);class z{get connections(){const q=[];return this.f.forEach(H=>q.push(H)),q}constructor(q,H,Z){this.a=new Map,this.f=new Set,this.g=new u.$fe,this.onDidAddConnection=this.g.event,this.h=new u.$fe,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(q(({protocol:Q,onDidClientDisconnect:_})=>{const U=u.Event.once(Q.onMessage);this.j.add(U(F=>{const d=new m(F),P=h(d),L=new S(Q,P,H,Z),M=new O(Q,H);this.a.forEach((W,te)=>L.registerChannel(te,W));const G={channelServer:L,channelClient:M,ctx:P};this.f.add(G),this.g.fire(G),this.j.add(_(()=>{L.dispose(),M.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(q,H){const Z=this;return{call(Q,_,U){let F;if((0,y.$mg)(H)){const P=(0,D.$3b)(Z.connections.filter(H));F=P?Promise.resolve(P):u.Event.toPromise(u.Event.filter(Z.onDidAddConnection,H))}else F=H.routeCall(Z,Q,_);const d=F.then(P=>P.channelClient.getChannel(q));return T(d).call(Q,_,U)},listen(Q,_){if((0,y.$mg)(H))return Z.k(q,H,Q,_);const U=H.routeEvent(Z,Q,_).then(F=>F.channelClient.getChannel(q));return T(U).listen(Q,_)}}}k(q,H,Z,Q){const _=this;let U;const F=new u.$fe({onWillAddFirstListener:()=>{U=new a.$Tc;const d=new u.$le,P=new Map,L=G=>{const te=G.channelClient.getChannel(q).listen(Z,Q),ae=d.add(te);P.set(G,ae)},M=G=>{const W=P.get(G);W&&(W.dispose(),P.delete(G))};_.connections.filter(H).forEach(L),u.Event.filter(_.onDidAddConnection,H)(L,void 0,U),_.onDidRemoveConnection(M,void 0,U),d.event(F.fire,F,U),U.add(d)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return F.event}registerChannel(q,H){this.a.set(q,H);for(const Z of this.f)Z.channelServer.registerChannel(q,H)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=z;class C{constructor(q,H,Z=null){const Q=new n;o(Q,H),q.send(Q.buffer),this.a=new O(q,Z),this.d=new S(q,H,Z)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,H){this.d.registerChannel(q,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=C;function T(V){return{call(q,H,Z){return V.then(Q=>Q.call(q,H,Z))},listen(q,H){const Z=new u.$oe;return V.then(Q=>Z.input=Q.listen(q,H)),Z.event}}}function J(V){let q=!1;return{call(H,Z,Q){return q?V.call(H,Z,Q):(0,R.$zh)(0).then(()=>q=!0).then(()=>V.call(H,Z,Q))},listen(H,Z){if(q)return V.listen(H,Z);const Q=new u.$oe;return(0,R.$zh)(0).then(()=>q=!0).then(()=>Q.input=V.listen(H,Z)),Q.event}}}class re{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const H of q.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$gi=re;var ie;(function(V){function q(_,U,F){const d=_,P=F&&F.disableMarshalling,L=new Map;for(const M in d)Z(M)&&L.set(M,u.Event.buffer(d[M],!0,void 0,U));return new class{listen(M,G,W){const te=L.get(G);if(te)return te;const ae=d[G];if(typeof ae=="function"){if(Q(G))return ae.call(d,W);if(Z(G))return L.set(G,u.Event.buffer(d[G],!0,void 0,U)),L.get(G)}throw new E.$bb(`Event not found: ${G}`)}call(M,G,W){const te=d[G];if(typeof te=="function"){if(!P&&Array.isArray(W))for(let ue=0;ue<W.length;ue++)W[ue]=(0,f.$8h)(W[ue]);let ae=te.apply(d,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${G}`)}}}V.fromService=q;function H(_,U){const F=U&&U.disableMarshalling;return new Proxy({},{get(d,P){if(typeof P=="string")return U?.properties?.has(P)?U.properties.get(P):Q(P)?function(L){return _.listen(P,L)}:Z(P)?_.listen(P):async function(...L){let M;U&&!(0,y.$hg)(U.context)?M=[U.context,...L]:M=L;const G=await _.call(P,M);return F?G:(0,f.$8h)(G)};throw new E.$bb(`Property not found: ${String(P)}`)}})}V.toService=H;function Z(_){return _[0]==="o"&&_[1]==="n"&&b.$yf(_.charCodeAt(2))}function Q(_){return/^onDynamic/.test(_)&&b.$yf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const q=V.toString();if(q!=="[object Object]")return q}return V}function ce(V){return Array.isArray(V)?V.map(le):le(V)}function B(V,q,H,Z,Q,_,U){U=ce(U);const F=he[Q],d=F[Z%F.length];let P=[`%c[${V}]%c[${String(q).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(_)?(P=P.concat(U),P.push(")")):P.push(U),console.log.apply(console,P)}class Y{constructor(q,H){this.d=q,this.f=H,this.a=0,this.b=0}logOutgoing(q,H,Z,Q,_){this.b+=q,B(this.d,this.b,q,H,Z,Q,_)}logIncoming(q,H,Z,Q,_){this.a+=q,B(this.f,this.a,q,H,Z,Q,_)}}e.$hi=Y}),define(ne[89],se([0,1,59,8,14,20,84,9,5,2,27,57,56,58]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;class $ extends w.$ai{constructor(l){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",c=>k.$He.wrap(Buffer.from(c,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$3q=$;class I{constructor(l,c){this.i=l,this.j=c,this.c=new Set,this.g=new Map,this.h=new u.$fe,this.onDidProcessExit=this.h.event;const v=c&&c.timeout?c.timeout:6e4;this.b=new R.$vh(v),this.d=null,this.f=null}getChannel(l){const c=this;return{call(v,p,m){return c.k(l,v,p,m)},listen(v,p){return c.l(l,v,p)}}}k(l,c,v,p=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const m=this.n(l),n=(0,R.$lh)(i=>m.call(c,v,i)),r=p.onCancellationRequested(()=>n.cancel()),t=(0,a.$Sc)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,c,v){if(!this.b)return u.Event.None;this.b.cancel();let p;const m=new u.$fe({onWillAddFirstListener:()=>{p=this.n(l).listen(c,v)(m.fire,m),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,f.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,y.$pm)(c.env),this.d=(0,D.fork)(this.i,l,c);const v=new u.$fe,m=u.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$Yq)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(k.$He.wrap(Buffer.from(o,"base64")))}),n=this.j.useQueue?(0,b.$rm)(this.d):this.d,r=o=>this.d&&this.d.connected&&n.send(o.buffer.toString("base64")),t=v.event,i={send:r,onMessage:t};this.f=new w.$bi(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",s),m.dispose(),this.c.forEach(S=>(0,a.$Pc)(S)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(l){let c=this.g.get(l);return c||(c=this.m.getChannel(l),this.g.set(l,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4q=I}),define(ne[90],se([0,1,8,5,2,47,3]),function(X,e,D,R,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.StorageState=e.StorageHint=void 0,e.$Yp=u;var E;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(y){const w=y;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends k.$Uc{static{this.a=100}constructor(w,$=Object.create(null)){super(),this.r=w,this.s=$,this.b=this.B(new R.$ie),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new D.$wh(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach(($,I)=>this.w(I,$)),w.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(w,$){if(this.c===a.Closed)return;let I=!1;(0,A.$hg)($)?I=this.f.delete(w):this.f.get(w)!==$&&(this.f.set(w,$),I=!0),I&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,$){const I=this.f.get(w);return(0,A.$hg)(I)?$:I}getBoolean(w,$){const I=this.get(w);return(0,A.$hg)(I)?$:I==="true"}getNumber(w,$){const I=this.get(w);return(0,A.$hg)(I)?$:parseInt(I,10)}getObject(w,$){const I=this.get(w);return(0,A.$hg)(I)?$:(0,N.$7h)(I)}async set(w,$,I=!1){if(this.c===a.Closed)return;if((0,A.$hg)($))return this.delete(w,I);const g=(0,A.$ag)($)||Array.isArray($)?(0,N.$6h)($):String($);if(this.f.get(w)!==g)return this.f.set(w,g),this.j.set(w,g),this.h.delete(w),this.b.fire({key:w,external:I}),this.D()}async delete(w,$=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:$}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Zp=f;class b{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach(($,I)=>this.a.set(I,$)),w.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$1p=b}),define(ne[91],se([7,4]),function(X,e){return X.create("vs/base/node/zip",e)}),define(ne[49],se([0,1,60,8,16,3,25,91]),function(X,e,D,R,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0,e.zip=g,e.$mq=l,e.$nq=v,e.$jq="end of central directory record signature not found";const u=new RegExp(e.$jq);class a extends Error{constructor(m,n){let r=n.message;switch(m){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=m,this.cause=n}}e.$kq=a;function f(p){const m=p.externalFileAttributes>>16||33188;return[448,56,7].map(n=>m&n).reduce((n,r)=>n+r,m&61440)}function b(p){if(p instanceof a)return p;let m;return u.test(p.message)&&(m="CorruptZip"),new a(m,p)}function y(p,m,n,r,t,i){const s=k.$mc(m),o=k.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(E.localize(0,null,m)));const h=k.$jc(r,m);let S;return i.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((j,O)=>{if(!i.isCancellationRequested)try{S=(0,D.createWriteStream)(h,{mode:n}),S.once("close",()=>j()),S.once("error",O),p.once("error",O),p.pipe(S)}catch(z){O(z)}}))}function w(p,m,n,r){let t=(0,R.$lh)(()=>Promise.resolve()),i=0;const s=r.onCancellationRequested(()=>{t.cancel(),p.close()});return new Promise((o,h)=>{const S=new R.$th,j=O=>{O.isCancellationRequested||(i++,p.readEntry())};p.once("error",h),p.once("close",()=>t.then(()=>{r.isCancellationRequested||p.entryCount===i?o():h(new a("Incomplete",new Error(E.localize(1,null,i,p.entryCount))))},h)),p.readEntry(),p.on("entry",O=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(O.fileName)){j(r);return}const z=O.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(z)){const J=k.$jc(m,z);t=(0,R.$lh)(re=>A.Promises.mkdir(J,{recursive:!0}).then(()=>j(re)).then(void 0,h));return}const C=I(p,O),T=f(O);t=(0,R.$lh)(J=>S.queue(()=>C.then(re=>y(re,z,T,m,n,J).then(()=>j(J)))).then(null,h))})}).finally(()=>s.dispose())}async function $(p,m=!1){const{open:n}=await new Promise((r,t)=>{X(["yauzl"],r,t)});return new Promise((r,t)=>{n(p,m?{lazyEntries:!0}:void 0,(i,s)=>{i?t(b(i)):r((0,N.$jg)(s))})})}function I(p,m){return new Promise((n,r)=>{p.openReadStream(m,(t,i)=>{t?r(b(t)):n((0,N.$jg)(i))})})}async function g(p,m){const{ZipFile:n}=await new Promise((r,t)=>{X(["yazl"],r,t)});return new Promise((r,t)=>{const i=new n;m.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,D.createWriteStream)(p);i.outputStream.pipe(s),i.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(p))})}function l(p,m,n={},r){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=$(p,!0);return n.overwrite&&(i=i.then(s=>A.Promises.rm(m).then(()=>s))),i.then(s=>w(s,m,{sourcePathRegex:t},r))}function c(p,m){return $(p).then(n=>new Promise((r,t)=>{n.on("entry",i=>{i.fileName===m&&I(n,i).then(s=>r(s),s=>t(s))}),n.once("close",()=>t(new Error(E.localize(2,null,m))))}))}function v(p,m){return c(p,m).then(n=>new Promise((r,t)=>{const i=[];n.once("error",t),n.on("data",s=>i.push(s)),n.on("end",()=>r(Buffer.concat(i)))}))}}),define(ne[92],se([7,4]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[93],se([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[94],se([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(ne[95],se([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[96],se([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[97],se([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[98],se([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[99],se([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[100],se([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[101],se([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[102],se([7,4]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[103],se([7,4]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ne[104],se([7,4]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ne[105],se([7,4]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[106],se([7,4]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[107],se([7,4]),function(X,e){return X.create("vs/platform/log/common/log",e)}),define(ne[108],se([7,4]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ne[109],se([7,4]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ne[110],se([7,4]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[111],se([7,4]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[112],se([7,4]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ne[113],se([0,1,9,94]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function N(...a){switch(a.length){case 1:return(0,R.localize)(0,null,a[0]);case 2:return(0,R.localize)(1,null,a[0],a[1]);case 3:return(0,R.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,R.localize)(3,null),E=(0,R.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return f.isTripleEq?"===":"==";case 4:return f.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return f.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return f.lexeme;case 18:return f.lexeme;case 19:return f.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(f){return this.c=f,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(f){return this.r()||this.c.charCodeAt(this.e)!==f?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(f){this.f.push({type:f,offset:this.d})}l(f){const b=this.d,y=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:f}),this.f.push(w)}n(){this.m.lastIndex=this.d;const f=this.m.exec(this.c);if(f){this.e=this.d+f[0].length;const b=this.c.substring(this.d,this.e),y=u.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let f=this.e,b=!1,y=!1;for(;;){if(f>=this.c.length){this.e=f,this.l(E);return}const $=this.c.charCodeAt(f);if(b)b=!1;else if($===47&&!y){f++;break}else $===91?y=!0:$===92?b=!0:$===93&&(y=!1);f++}for(;f<this.c.length&&u.a.has(this.c.charCodeAt(f));)f++;this.e=f;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=u}),define(ne[114],se([0,1,80,54,15,16,35,17,11]),function(X,e,D,R,k,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=f,e.$0m=b,e.$7m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(k.$Sg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,D.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",w)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$_g)(u.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?u.URI.file((0,N.$jc)(w,"argv.json")):(0,E.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,N.$kc)(w):(0,N.$hc)((0,N.$jc)(k.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?u.URI.file((0,N.$kc)(w)):u.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,N.$kc)(w);const $=A.env.VSCODE_EXTENSIONS;if($)return $;const I=A.env.VSCODE_PORTABLE;return I?(0,N.$jc)(I,"extensions"):(0,E.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map($=>/^[^:/?#]+?:\/\//.test($)?u.URI.parse($):u.URI.file((0,N.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,N.$hc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$7m.test(w))}get extensionLogLevel(){const w=[];for(const $ of this.args.log||[]){const I=e.$7m.exec($);I&&I[1]&&I[2]&&w.push([I[1],I[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,E.$_g)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?u.URI.file((0,N.$jc)(w,"policy.json")):(0,E.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,$,I){this.a=w,this.b=$,this.c=I,this.editSessionId=this.args.editSessionId}}e.$8m=a,$e([R.$3h],a.prototype,"appRoot",null),$e([R.$3h],a.prototype,"userHome",null),$e([R.$3h],a.prototype,"userDataPath",null),$e([R.$3h],a.prototype,"appSettingsHome",null),$e([R.$3h],a.prototype,"tmpDir",null),$e([R.$3h],a.prototype,"cacheHome",null),$e([R.$3h],a.prototype,"stateResource",null),$e([R.$3h],a.prototype,"userRoamingDataHome",null),$e([R.$3h],a.prototype,"userDataSyncHome",null),$e([R.$3h],a.prototype,"sync",null),$e([R.$3h],a.prototype,"machineSettingsResource",null),$e([R.$3h],a.prototype,"workspaceStorageHome",null),$e([R.$3h],a.prototype,"localHistoryHome",null),$e([R.$3h],a.prototype,"keyboardLayoutResource",null),$e([R.$3h],a.prototype,"argvResource",null),$e([R.$3h],a.prototype,"isExtensionDevelopment",null),$e([R.$3h],a.prototype,"untitledWorkspacesHome",null),$e([R.$3h],a.prototype,"builtinExtensionsPath",null),$e([R.$3h],a.prototype,"extensionsPath",null),$e([R.$3h],a.prototype,"extensionDevelopmentLocationURI",null),$e([R.$3h],a.prototype,"extensionDevelopmentKind",null),$e([R.$3h],a.prototype,"extensionTestsLocationURI",null),$e([R.$3h],a.prototype,"debugExtensionHost",null),$e([R.$3h],a.prototype,"logLevel",null),$e([R.$3h],a.prototype,"extensionLogLevel",null),$e([R.$3h],a.prototype,"serviceMachineIdResource",null),$e([R.$3h],a.prototype,"disableTelemetry",null),$e([R.$3h],a.prototype,"disableWorkspaceTrust",null),$e([R.$3h],a.prototype,"useInMemorySecretStorage",null),$e([R.$3h],a.prototype,"policyFile",null);function f(y,w){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,w,y.debugId,y.extensionEnvironment)}function b(y,w,$,I,g,l){const v=Number(w||y)||(I?null:$),p=v?!!w:!1;let m;if(l)try{m=JSON.parse(l)}catch{}return{port:v,break:p,debugId:g,env:m}}}),function(){"use strict";function X(e,D,R){function k(A,E){const u=N(A,E),a=[u];return e.isAbsolute(u)||a.unshift(R),e.resolve(...a)}function N(A,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,E);const f=A["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(D.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,E)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[115],se([170,33,35]),function(e,D,R){return X(e,D,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=X(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[116],se([0,1,33,114,115]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=A,e.$an=E;class N extends R.$8m{constructor(a,f){super(a,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,f.nameShort)},f)}}e.$$m=N;function A(u,a){return(0,R.$0m)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function E(u,a){return(0,R.$0m)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(ne[117],se([0,1,3,98]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=k;function k(A,E,u,a){try{N(A,E,u,a)}catch(f){A.error(f?.message??f)}return E}function N(A,E,u,a){const f=(b,y,w)=>{const $=b[y];if((0,D.$$f)($)){const I=$,g=I.length;if(g>1&&I[0]==="%"&&I[g-1]==="%"){const l=I.substr(1,g-2);let c=u[l];c===void 0&&a&&(c=a[l]);const v=typeof c=="string"?c:c?.message,p=a?.[l],m=typeof p=="string"?p:p?.message;if(!v){m||A.warn(`[${E.name}]: ${(0,R.localize)(0,null,l)}`);return}if(w&&(y==="title"||y==="category")&&m&&m!==v){const n={value:v,original:m};b[y]=n}else b[y]=v}}else if((0,D.$ag)($))for(const I in $)$.hasOwnProperty(I)&&(I==="commands"?f($,I,!0):f($,I,w));else if(Array.isArray($))for(let I=0;I<$.length;I++)f($,I,w)};for(const b in E)E.hasOwnProperty(b)&&f(E,b)}}),define(ne[118],se([0,1,49,101]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=k;function k(N){return(0,D.$nq)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}}),define(ne[50],se([0,1,17,55,102,44]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=u,e.$Kp=a,e.$Lp=f,e.$Mp=b,e.$Np=y,e.$Op=w,e.$Pp=$;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(l){return l=l.trim(),l==="*"||A.test(l)}function a(l){if(!u(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=l.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function f(l){if(!l)return null;const c=l.majorBase,v=l.majorMustEqual,p=l.minorBase;let m=l.minorMustEqual;const n=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(c===0||(m=!1),r=!1);let t=0;if(l.preRelease){const i=E.exec(l.preRelease);if(i){const[,s,o,h]=i;t=Date.UTC(Number(s),Number(o)-1,Number(h))}}return{majorBase:c,majorMustEqual:v,minorBase:p,minorMustEqual:m,patchBase:n,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}function b(l,c,v){let p;typeof l=="string"?p=f(a(l)):p=l;let m;c instanceof Date?m=c.getTime():typeof c=="string"&&(m=new Date(c).getTime());let n;if(typeof v=="string"?n=f(a(v)):n=v,!p||!n)return!1;const r=p.majorBase,t=p.minorBase,i=p.patchBase;let s=n.majorBase,o=n.minorBase,h=n.patchBase;const S=n.notBefore;let j=n.majorMustEqual,O=n.minorMustEqual,z=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||m&&m<S?!1:i>=h:(r===1&&s===0&&(!j||!O||!z)&&(s=1,o=0,h=0,j=!0,O=!1,z=!1),r<s?!1:r>s?!j:t<o?!1:t>o?!O:i<h?!1:i>h?!z:!(m&&m<S))}function y(l,c,v,p,m){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([R.default.Error,k.localize(0,null)]),n;if(typeof p.name!="string")return n.push([R.default.Error,k.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([R.default.Error,k.localize(2,null,"version")]),n;if(!p.engines)return n.push([R.default.Error,k.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([R.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!g(p.extensionDependencies))return n.push([R.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!g(p.activationEvents))return n.push([R.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([R.default.Error,k.localize(7,null,"activationEvents","main","browser")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([R.default.Warning,k.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([R.default.Error,k.localize(9,null,"main")]),n;{const i=(0,D.$_g)(v,p.main);(0,D.$6g)(i,v)||n.push([R.default.Warning,k.localize(10,null,i.path,v.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([R.default.Error,k.localize(11,null,"browser")]),n;{const i=(0,D.$_g)(v,p.browser);(0,D.$6g)(i,v)||n.push([R.default.Warning,k.localize(12,null,i.path,v.path)])}}if(!N.valid(p.version))return n.push([R.default.Error,k.localize(13,null)]),n;const r=[];if(!w(l,c,p,m,r))for(const i of r)n.push([R.default.Error,i]);return n}function w(l,c,v,p,m){return p||typeof v.main>"u"&&typeof v.browser>"u"?!0:I(l,c,v.engines.vscode,m)}function $(l,c,v){return l==="*"||I(c,v,l)}function I(l,c,v,p=[]){const m=f(a(v));if(!m)return p.push(k.localize(14,null,v)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return p.push(k.localize(15,null,v)),!1}else if(!m.majorMustEqual)return p.push(k.localize(16,null,v)),!1;return b(l,c,m)?!0:(p.push(k.localize(17,null,l,v)),!1)}function g(l){if(!Array.isArray(l))return!1;for(let c=0,v=l.length;c<v;c++)if(typeof l[c]!="string")return!1;return!0}}),define(ne[119],se([0,1,14,28]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=k;async function k(N,A,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const f=(await A.readFile(N.serviceMachineIdResource)).value.toString();u=(0,R.$Tg)(f)?f:null}catch{u=null}if(!u){u=(0,R.$Ug)();try{await A.writeFile(N.serviceMachineIdResource,D.$He.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}}),define(ne[51],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class D{constructor(k,N=[],A=!1){this.ctor=k,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$vi=D}),define(ne[120],se([0,1,51]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$As=N,e.$Bs=A;const R=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function N(E,u,a){u instanceof D.$vi||(u=new D.$vi(u,[],!!a)),R.push([E,u])}function A(){return R}}),define(ne[121],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;class D{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$dr=D;class R{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const E=this.lookupOrInsertNode(N),u=this.lookupOrInsertNode(A);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const E of this.a.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let E=this.a.get(A);return E||(E=new D(A,N),this.a.set(A,E)),E}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,E]of this.a)N.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const E=new Set([N]),u=this.c(A,E);if(u)return u}}c(N,A){for(const[E,u]of N.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const a=this.c(u,A);if(a)return a;A.delete(E)}}}e.$er=R}),define(ne[29],se([0,1,3,11,10]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=N,e.$7i=A,e.$8i=u,e.$9i=a,e.$0i=f,e.$$i=b,e.$_i=y,e.$aj=$,e.$bj=I,e.$cj=g,e.$5i=(0,k.$yi)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof R.URI)}function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof R.URI)}var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function f(l,c){const v=Object.create(null);for(const p in l)b(v,p,l[p],c);return v}function b(l,c,v,p){const m=c.split("."),n=m.pop();let r=l;for(let t=0;t<m.length;t++){const i=m[t];let s=r[i];switch(typeof s){case"undefined":s=r[i]=Object.create(null);break;case"object":if(s===null){p(`Ignoring ${c} as ${m.slice(0,t+1).join(".")} is null`);return}break;default:p(`Ignoring ${c} as ${m.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=v}catch{p(`Ignoring ${c} as ${m.join(".")} is ${JSON.stringify(r)}`)}else p(`Ignoring ${c} as ${m.join(".")} is ${JSON.stringify(r)}`)}function y(l,c){const v=c.split(".");w(l,v)}function w(l,c){const v=c.shift();if(c.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const p=l[v];typeof p=="object"&&!Array.isArray(p)&&(w(p,c),Object.keys(p).length===0&&delete l[v])}}function $(l,c,v){function p(r,t){let i=r;for(const s of t){if(typeof i!="object"||i===null)return;i=i[s]}return i}const m=c.split("."),n=p(l,m);return typeof n>"u"?v:n}function I(l,c,v){Object.keys(c).forEach(p=>{p!=="__proto__"&&(p in l?D.$ag(l[p])&&D.$ag(c[p])?I(l[p],c[p],v):v&&(l[p]=c[p]):l[p]=c[p])})}function g(l){return l.replace(/[\[\]]/g,"")}}),define(ne[122],se([0,1,12,31,113,10,93,9]),function(X,e,D,R,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=a,e.$xj=r,e.$yj=t,e.$Rj=Q;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",D.$j),u.set("isLinux",D.$k),u.set("isWindows",D.$i),u.set("isWeb",D.$o),u.set("isMacNative",D.$j&&!D.$o),u.set("isEdge",D.$H),u.set("isFirefox",D.$F),u.set("isChrome",D.$E),u.set("isSafari",D.$G);function a(F,d){if(u.get(F)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(F,d)}const f=Object.prototype.hasOwnProperty;var b;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),$=(0,A.localize)(1,null),I=(0,A.localize)(2,null),g=(0,A.localize)(3,null),l=(0,A.localize)(4,null),c=(0,A.localize)(5,null),v=(0,A.localize)(6,null),p=(0,A.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=y){this.k=d,this.d=new k.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const L=this.D(),M=L.type===17?c:void 0;throw this.h.push({message:l,offset:L.offset,lexeme:k.$tj.getLexeme(L),additionalInfo:M}),m.c}return P}catch(P){if(P!==m.c)throw P;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const P=this.o();d.push(P)}return d.length===1?d[0]:n.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const P=this.s();d.push(P)}return d.length===1?d[0]:n.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,g),P?.negate()}case 17:return this.z(),C.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const P=this.l();return this.A(1,g),P}case 17:{const P=d.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const G=M.lexeme,W=G.lastIndexOf("/"),te=W===G.length-1?void 0:this.w(G.substring(W+1));let ae;try{ae=new RegExp(G.substring(1,W),te)}catch{throw this.B("REGEX",M)}return le.create(P,ae)}switch(M.type){case 10:case 19:{const G=[M.lexeme];this.z();let W=this.D(),te=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;G.push(k.$tj.getLexeme(W)),this.z(),W=this.D()}const ae=G.join(""),ue=ae.lastIndexOf("/"),pe=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let ye;try{ye=new RegExp(ae.substring(1,ue),pe)}catch{throw this.B("REGEX",M)}return n.regex(P,ye)}case 18:{const G=M.lexeme;this.z();let W=null;if(!(0,R.$9e)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const ue=G.slice(te+1,ae),pe=G[ae+1]==="i"?"i":"";try{W=new RegExp(ue,pe)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return le.create(P,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,I);const M=this.u();return n.notIn(P,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return n.equals(P,M);switch(M){case"true":return n.has(P);case"false":return n.not(P);default:return n.equals(P,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return n.notEquals(P,M);switch(M){case"true":return n.not(P);case"false":return n.has(P);default:return n.notEquals(P,M)}}case 5:return this.z(),ie.create(P,this.u());case 6:return this.z(),he.create(P,this.u());case 7:return this.z(),J.create(P,this.u());case 8:return this.z(),re.create(P,this.u());case 13:return this.z(),n.in(P,this.u());default:return n.has(P)}}case 20:throw this.h.push({message:v,offset:d.offset,lexeme:"",additionalInfo:p}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,P){if(this.C(d))return this.z();throw this.B(P,this.D())}B(d,P,L){const M=(0,A.localize)(8,null,d,k.$tj.getLexeme(P)),G=P.offset,W=k.$tj.getLexeme(P);return this.h.push({message:M,offset:G,lexeme:W,additionalInfo:L}),m.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=m;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(d){return h.create(d)}static equals(d,P){return S.create(d,P)}static notEquals(d,P){return z.create(d,P)}static regex(d,P){return le.create(d,P)}static in(d,P){return j.create(d,P)}static notIn(d,P){return O.create(d,P)}static not(d){return C.create(d)}static and(...d){return Y.create(d,null,!0)}static or(...d){return V.create(d,null,!0)}static greater(d,P){return J.create(d,P)}static greaterEquals(d,P){return re.create(d,P)}static smaller(d,P){return ie.create(d,P)}static smallerEquals(d,P){return he.create(d,P)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$wj=n;function r(F){const d=new m({regexParsingWithErrorRecovery:!1});return F.map(P=>(d.parse(P),d.lexingErrors.length>0?d.lexingErrors.map(L=>({errorMessage:L.additionalInfo?(0,A.localize)(9,null,L.additionalInfo):(0,A.localize)(10,null),offset:L.offset,length:L.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(L=>({errorMessage:L.additionalInfo?`${L.message}. ${L.additionalInfo}`:L.message,offset:L.offset,length:L.lexeme.length})):[]))}function t(F,d){const P=F?F.substituteConstants():void 0,L=d?d.substituteConstants():void 0;return!P&&!L?!0:!P||!L?!1:P.equals(L)}function i(F,d){return F.cmp(d)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return o.INSTANCE}}e.$zj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return s.INSTANCE}}e.$Aj=o;class h{static create(d,P=null){const L=u.get(d);return typeof L=="boolean"?L?o.INSTANCE:s.INSTANCE:new h(d,P)}constructor(d,P){this.key=d,this.c=P,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:H(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=u.get(this.key);return typeof d=="boolean"?d?o.INSTANCE:s.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Bj=h;class S{static create(d,P,L=null){if(typeof P=="boolean")return P?h.create(d,L):C.create(d,L);const M=u.get(d);return typeof M=="boolean"?P===(M?"true":"false")?o.INSTANCE:s.INSTANCE:new S(d,P,L)}constructor(d,P,L){this.c=d,this.d=P,this.f=L,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=u.get(this.c);if(typeof d=="boolean"){const P=d?"true":"false";return this.d===P?o.INSTANCE:s.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Cj=S;class j{static create(d,P){return new j(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const P=d.getValue(this.f),L=d.getValue(this.d);return Array.isArray(P)?P.includes(L):typeof L=="string"&&typeof P=="object"&&P!==null?f.call(P,L):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.$Dj=j;class O{static create(d,P){return new O(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=11,this.c=j.create(d,P)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=O;class z{static create(d,P,L=null){if(typeof P=="boolean")return P?C.create(d,L):h.create(d,L);const M=u.get(d);return typeof M=="boolean"?P===(M?"true":"false")?s.INSTANCE:o.INSTANCE:new z(d,P,L)}constructor(d,P,L){this.c=d,this.d=P,this.f=L,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=u.get(this.c);if(typeof d=="boolean"){const P=d?"true":"false";return this.d===P?s.INSTANCE:o.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Fj=z;class C{static create(d,P=null){const L=u.get(d);return typeof L=="boolean"?L?s.INSTANCE:o.INSTANCE:new C(d,P)}constructor(d,P){this.c=d,this.d=P,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:H(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=u.get(this.c);return typeof d=="boolean"?d?s.INSTANCE:o.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$Gj=C;function T(F,d){if(typeof F=="string"){const P=parseFloat(F);isNaN(P)||(F=P)}return typeof F=="string"||typeof F=="number"?d(F):s.INSTANCE}class J{static create(d,P,L=null){return T(P,M=>new J(d,M,L))}constructor(d,P,L){this.c=d,this.d=P,this.f=L,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$Hj=J;class re{static create(d,P,L=null){return T(P,M=>new re(d,M,L))}constructor(d,P,L){this.c=d,this.d=P,this.f=L,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Ij=re;class ie{static create(d,P,L=null){return T(P,M=>new ie(d,M,L))}constructor(d,P,L){this.c=d,this.d=P,this.f=L,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Jj=ie;class he{static create(d,P,L=null){return T(P,M=>new he(d,M,L))}constructor(d,P,L){this.c=d,this.d=P,this.f=L,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Kj=he;class le{static create(d,P){return new le(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const P=this.f?this.f.source:"",L=d.f?d.f.source:"";return P<L?-1:P>L?1:0}equals(d){if(d.type===this.type){const P=this.f?this.f.source:"",L=d.f?d.f.source:"";return this.d===d.d&&P===L}return!1}substituteConstants(){return this}evaluate(d){const P=d.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Lj=le;class ce{static create(d){return new ce(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new ce(this.c.map(d))}negate(){return this.c}}e.$Mj=ce;function B(F){let d=null;for(let P=0,L=F.length;P<L;P++){const M=F[P].substituteConstants();if(F[P]!==M&&d===null){d=[];for(let G=0;G<P;G++)d[G]=F[G]}d!==null&&(d[P]=M)}return d===null?F:d}class Y{static create(d,P,L){return Y.d(d,P,L)}constructor(d,P){this.expr=d,this.c=P,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let P=0,L=this.expr.length;P<L;P++){const M=i(this.expr[P],d.expr[P]);if(M!==0)return M}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let P=0,L=this.expr.length;P<L;P++)if(!this.expr[P].equals(d.expr[P]))return!1;return!0}return!1}substituteConstants(){const d=B(this.expr);return d===this.expr?this:Y.create(d,this.c,!1)}evaluate(d){for(let P=0,L=this.expr.length;P<L;P++)if(!this.expr[P].evaluate(d))return!1;return!0}static d(d,P,L){const M=[];let G=!1;for(const W of d)if(W){if(W.type===1){G=!0;continue}if(W.type===0)return s.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&G)return o.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const te=M.pop(),ae=M.length===0,ue=V.create(W.expr.map(pe=>Y.create([pe,te],null,L)),null,ae);ue&&(M.push(ue),M.sort(i))}if(M.length===1)return M[0];if(L){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return s.INSTANCE;if(M.length===1)return M[0]}return new Y(M,P)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const P of this.expr)d.push(...P.keys());return d}map(d){return new Y(this.expr.map(P=>P.map(d)),null)}negate(){if(!this.c){const d=[];for(const P of this.expr)d.push(P.negate());this.c=V.create(d,this,!0)}return this.c}}e.$Nj=Y;class V{static create(d,P,L){return V.d(d,P,L)}constructor(d,P){this.expr=d,this.c=P,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let P=0,L=this.expr.length;P<L;P++){const M=i(this.expr[P],d.expr[P]);if(M!==0)return M}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let P=0,L=this.expr.length;P<L;P++)if(!this.expr[P].equals(d.expr[P]))return!1;return!0}return!1}substituteConstants(){const d=B(this.expr);return d===this.expr?this:V.create(d,this.c,!1)}evaluate(d){for(let P=0,L=this.expr.length;P<L;P++)if(this.expr[P].evaluate(d))return!0;return!1}static d(d,P,L){let M=[],G=!1;if(d){for(let W=0,te=d.length;W<te;W++){const ae=d[W];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){M=M.concat(ae.expr);continue}M.push(ae)}}if(M.length===0&&G)return s.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(L){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return o.INSTANCE;if(M.length===1)return M[0]}return new V(M,P)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const P of this.expr)d.push(...P.keys());return d}map(d){return new V(this.expr.map(P=>P.map(d)),null)}negate(){if(!this.c){const d=[];for(const P of this.expr)d.push(P.negate());for(;d.length>1;){const P=d.shift(),L=d.shift(),M=[];for(const G of U(P))for(const W of U(L))M.push(Y.create([G,W],null,!1));d.unshift(V.create(M,null,!1))}this.c=V.create(d,this,!0)}return this.c}}e.$Oj=V;class q extends h{static{this.d=[]}static all(){return q.d.values()}constructor(d,P,L){super(d,null),this.f=P,typeof L=="object"?q.d.push({...L,key:d}):L!==!0&&q.d.push({key:d,description:L,type:P!=null?typeof P:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return S.create(this.key,d)}notEqualsTo(d){return z.create(this.key,d)}}e.$Pj=q,e.$Qj=(0,N.$yi)("contextKeyService");function H(F,d){return F<d?-1:F>d?1:0}function Z(F,d,P,L){return F<P?-1:F>P?1:d<L?-1:d>L?1:0}function Q(F,d){if(F.type===0||d.type===1)return!0;if(F.type===9)return d.type===9?_(F.expr,d.expr):!1;if(d.type===9){for(const P of d.expr)if(Q(F,P))return!0;return!1}if(F.type===6){if(d.type===6)return _(d.expr,F.expr);for(const P of F.expr)if(Q(P,d))return!0;return!1}return F.equals(d)}function _(F,d){let P=0,L=0;for(;P<F.length&&L<d.length;){const M=F[P].cmp(d[L]);if(M<0)return!1;M===0&&P++,L++}return P===F.length}function U(F){return F.type===9?F.expr:[F]}}),define(ne[61],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0,e.$No=(0,D.$yi)("downloadService")}),define(ne[18],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,D.$yi)("environmentService"),e.$Gi=(0,D.$zi)(e.$Fi)}),define(ne[21],se([0,1,96,10]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.ExtensionManagementErrorCode=e.$9o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$3o=k,e.$4o=N,e.$5o=A,e.$6o=E,e.$7o=u,e.$8o=a,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall";function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(c,v){switch(c){case 3:return v==="x64"?"win32-x64":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(c,v){return v==="web"&&!c.includes("web")}function u(c,v,p){return E(v,p)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===p}function a(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var f;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var b;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function(c){c.Install="install",c.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var w;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$9o=(0,R.$yi)("extensionGalleryService");var $;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));class I extends Error{constructor(v,p){super(v),this.code=p,this.name=p}}e.$0o=I;var g;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class l extends Error{constructor(v,p){super(v),this.code=p,this.name=p}}e.$$o=l,e.$_o=(0,R.$yi)("extensionManagementService"),e.$ap="extensionsIdentifiers/disabled",e.$bp="extensionsIdentifiers/enabled",e.$cp=(0,R.$yi)("IGlobalExtensionEnablementService"),e.$dp=(0,R.$yi)("IExtensionTipsService"),e.$ep=(0,D.localize2)(0,"Extensions"),e.$fp=(0,D.localize2)(1,"Preferences")}),define(ne[62],se([0,1,14,9,104,13]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=A;async function A(f,b,y,w,$,I){let g;try{await E(f,b,y,w,$,I)}catch(l){g=l}finally{g&&$.errorTransformer&&(g=$.errorTransformer(g)),typeof g<"u"&&y.error(g),y.end()}}async function E(f,b,y,w,$,I){u(I);const g=await f.open(b,{create:!1});try{u(I);let l=0,c=0,v=$&&typeof $.length=="number"?$.length:void 0,p=D.$He.alloc(Math.min($.bufferSize,typeof v=="number"?v:$.bufferSize)),m=$&&typeof $.position=="number"?$.position:0,n=0;do c=await f.read(g,m,p.buffer,n,p.byteLength-n),m+=c,n+=c,l+=c,typeof v=="number"&&(v-=c),n===p.byteLength&&(await y.write(w(p)),p=D.$He.alloc(Math.min($.bufferSize,typeof v=="number"?v:$.bufferSize)),n=0);while(c>0&&(typeof v!="number"||v>0)&&u(I)&&a(l,$));if(n>0){let r=n;typeof v=="number"&&(r=Math.min(n,v)),y.write(w(p.slice(0,r)))}}catch(l){throw(0,N.$gl)(l)}finally{await f.close(g)}}function u(f){if(f.isCancellationRequested)throw(0,R.$6)();return!0}function a(f,b){if(typeof b?.limits?.size=="number"&&f>b.limits.size)throw(0,N.$fl)((0,k.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[123],se([0,1,60,2,52,5,11,8]),function(X,e,D,R,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class u extends R.$Uc{constructor(){super(),this.a=this.B(new N.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new N.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new R.$4c),this.m=new Set,this.n=5007,this.r=new E.$Vh,this.P=!1,this.B(this.f(f=>this.s(f)))}s(f){this.t(f)&&this.w(f)}t(f){return(0,k.$Mq)(f)}async watch(f){this.r.isSettled||this.r.complete(),this.r=new E.$Vh;try{this.h.clear(),this.g.clear();for(const b of f)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))])}isSuspended(f){return typeof f.correlationId!="number"?!1:this.m.has(f.correlationId)?"polling":this.j.has(f.correlationId)}async w(f){if(this.j.has(f.correlationId))return;const b=new R.$Tc;this.j.set(f.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(f,b),this.u())}y(f){this.j.deleteAndDispose(f.correlationId),this.m.delete(f.correlationId),this.u()}z(f,b){this.C(f,b)?(this.N(`reusing an existing recursive watcher to monitor ${f.path}`),this.m.delete(f.correlationId)):(this.D(f,b),this.m.add(f.correlationId))}C(f,b){const y=this.M?.subscribe(f.path,(w,$)=>{b.isDisposed||(w?this.z(f,b):$?.type===1&&this.F(f))});return y?(b.add(y),!0):!1}D(f,b){let y=!1;const w=($,I)=>{if(b.isDisposed)return;const g=this.G($),l=this.G(I),c=y;y=g,!g&&(l||c)&&this.F(f)};this.N(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,D.watchFile)(f.path,{persistent:!1,interval:this.n},w)}catch($){this.O(`fs.watchFile() failed with error ${$} on path ${f.path} (correlationId: ${f.correlationId})`)}b.add((0,R.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,D.unwatchFile)(f.path,w)}catch($){this.O(`fs.unwatchFile() failed with error ${$} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}F(f){this.N(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const b={resource:A.URI.file(f.path),type:1,cId:f.correlationId};this.a.fire([b]),this.H(b,f),this.y(f)}G(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(f,b){if(this.P){const y=` >> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.I(y,b)}}I(f,b){this.P&&this.N(`${f}${typeof b.correlationId=="number"?` <${b.correlationId}> `:""}`)}J(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,k.$Wq)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.P=f}}e.$6q=u}),define(ne[124],se([0,1,5,171,123,12,172,63]),function(X,e,D,R,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class u extends k.$6q{constructor(f){super(),this.M=f,this.onDidError=D.Event.None,this.watchers=new Set}async L(f){f=this.X(f);const b=[],y=new Set(Array.from(this.watchers));for(const w of f){const $=this.S(w);$&&(0,R.$wk)($.request.excludes,w.excludes)&&(0,R.$wk)($.request.includes,w.includes)?y.delete($):b.push(w)}b.length&&this.N(`Request to start watching: ${b.map(w=>this.J(w)).join(",")}`),y.size&&this.N(`Request to stop watching: ${Array.from(y).map(w=>this.J(w.request)).join(",")}`);for(const w of y)this.W(w);for(const w of b)this.U(w)}S(f){for(const b of this.watchers)if(typeof f.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===f.correlationId)return b}else if((0,E.$wg)(b.request.path,f.path,!N.$k))return b}U(f){const b=new A.$$q(f,this.M,w=>this.a.fire(w),()=>this.c.fire(f),w=>this.b.fire(w),this.P),y={request:f,instance:b};this.watchers.add(y)}async stop(){await super.stop();for(const f of this.watchers)this.W(f)}W(f){this.N("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}X(f){const b=new Map;for(const y of f){const w=N.$k?y.path:y.path.toLowerCase();let $=b.get(y.correlationId);$||($=new Map,b.set(y.correlationId,$)),$.has(w)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(y)}`),$.set(w,y)}return Array.from(b.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const b of this.watchers)b.instance.setVerboseLogging(f)}N(f,b){this.P&&this.b.fire({type:"trace",message:this.$(f,b)})}O(f){this.b.fire({type:"warn",message:this.$(f)})}$(f,b){return b?`[File Watcher (node.js)] ${f} (${this.J(b.request)})`:`[File Watcher (node.js)] ${f}`}}e.$ar=u}),define(ne[125],se([0,1,52,124]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class k extends D.$Pq{constructor(A,E,u){super(A,E,u),this.s()}r(A){return A.add(new R.$ar(void 0))}}e.$br=k}),define(ne[126],se([0,1,15,58,89,52]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class A extends N.$Qq{constructor(u,a,f){super(u,a,f),this.s()}r(u){const a=u.add(new k.$4q(D.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:f,signal:b})=>this.t(`terminated by itself with code ${f}, signal: ${b} (ETERM)`))),R.ProxyChannel.toService((0,R.$fi)(a.getChannel("watcher")))}}e.$5q=A}),define(ne[64],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class D{constructor(...k){this.a=new Map;for(const[N,A]of k)this.set(N,A)}set(k,N){const A=this.a.get(k);return this.a.set(k,N),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$wi=D}),define(ne[127],se([0,1,8,9,2,51,121,10,64,173]),function(X,e,D,R,k,N,A,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;const f=!1;class b extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class y{constructor(g=new u.$wi,l=!1,c,v=f){this.i=g,this.j=l,this.k=c,this.l=v,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$xi,this),this._globalGraph=v?c?._globalGraph??new A.$er(p=>p):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Pc)(this.h),this.h.clear();for(const g of this.g)(0,k.$Oc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const l=new class extends y{dispose(){this.h.delete(l),super.dispose()}}(g,this.j,this,this.l);return this.h.add(l),l}invokeFunction(g,...l){this.m();const c=$.traceInvocation(this.l,g);let v=!1;try{return g({get:m=>{if(v)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const n=this.s(m,c);if(!n)throw new Error(`[invokeFunction] unknown service '${m}'`);return n}},...l)}finally{v=!0,c.stop()}}createInstance(g,...l){this.m();let c,v;return g instanceof N.$vi?(c=$.traceCreation(this.l,g.ctor),v=this.o(g.ctor,g.staticArguments.concat(l),c)):(c=$.traceCreation(this.l,g),v=this.o(g,l,c)),c.stop(),v}o(g,l=[],c){const v=E._util.getServiceDependencies(g).sort((n,r)=>n.index-r.index),p=[];for(const n of v){const r=this.s(n.id,c);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${n.id}.`,!1),p.push(r)}const m=v.length>0?v[0].index:l.length;if(l.length!==m){console.trace(`[createInstance] First service dependency of ${g.name} at position ${m+1} conflicts with ${l.length} static arguments`);const n=m-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,m)}return Reflect.construct(g,l.concat(p))}q(g,l){if(this.i.get(g)instanceof N.$vi)this.i.set(g,l);else if(this.k)this.k.q(g,l);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const l=this.i.get(g);return!l&&this.k?this.k.r(g):l}s(g,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const c=this.r(g);return c instanceof N.$vi?this.u(g,c,l.branch(g,!0)):(l.branch(g,!1),c)}u(g,l,c){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,l,c)}finally{this.t.delete(g)}}v(g,l,c){const v=new A.$er(n=>n.id.toString());let p=0;const m=[{id:g,desc:l,_trace:c}];for(;m.length;){const n=m.pop();if(v.lookupOrInsertNode(n),p++>1e3)throw new b(v);for(const r of E._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof N.$vi){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};v.insertEdge(n,i),m.push(i)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new b(v);break}for(const{data:r}of n){if(this.r(r.id)instanceof N.$vi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}v.removeNode(r)}}return this.r(g)}w(g,l,c=[],v,p){if(this.i.get(g)instanceof N.$vi)return this.x(g,l,c,v,p,this.g);if(this.k)return this.k.w(g,l,c,v,p);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}x(g,l,c=[],v,p,m){if(v){const n=new y(void 0,this.j,this,this.l);n.c=String(g);const r=new Map,t=new D.$Rh(()=>{const i=n.o(l,c,p);for(const[s,o]of r){const h=i[s];if(typeof h=="function")for(const S of o)S.disposable=h.apply(i,S.listener)}return r.clear(),m.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=r.get(s);return S||(S=new a.$5c,r.set(s,S)),(O,z,C)=>{if(t.isInitialized)return t.value[s](O,z,C);{const T={listener:[O,z,C],disposable:void 0},J=S.push(T);return(0,k.$Sc)(()=>{J(),T.disposable?.dispose()})}}}if(s in i)return i[s];const o=t.value;let h=o[s];return typeof h!="function"||(h=h.bind(o),i[s]=h),h},set(i,s,o){return t.value[s]=o,!0},getPrototypeOf(i){return l.prototype}})}else{const n=this.o(l,c,p);return m.add(n),n}}y(g,l){if(l&&console.warn(g),this.j)throw new Error(g)}}e.$fr=y;var w;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(w||(w={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,l){return g?new $(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(g,l){return g?new $(1,l.name):$.c}static{this.f=0}constructor(g,l){this.type=g,this.name=l,this.g=Date.now(),this.h=[]}branch(g,l){const c=new $(3,g.toString());return this.h.push([g,l,c]),c}stop(){const g=Date.now()-this.g;$.f+=g;let l=!1;function c(p,m){const n=[],r=new Array(p+1).join("	");for(const[t,i,s]of m.h)if(i&&s){l=!0,n.push(`${r}CREATES -> ${t}`);const o=c(p+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(g>2||l)&&$.all.add(v.join(`
`))}}e.$gr=$});var oe=this&&this.__param||function(X,e){return function(D,R){e(D,R,X)}};define(ne[65],se([0,1,20,2,12,106,21,10]),function(X,e,D,R,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=void 0,e.$Tr=u;function u(f){return f.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Ur=(0,E.$yi)("languagePackService");let a=class extends R.$Uc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new D.$qe;setTimeout(()=>b.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const $=y.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(g=>g.startsWith("lp-"))).map(I=>{const g=I.properties.localizedLanguages?.[0],l=u(I);return{...this.f(l,g,I),extensionId:I.identifier.id,galleryExtension:I}});return $.push(this.f("en","English")),$}f(b,y,w){const $=y??b;let I;if($!==b&&(I=`(${b})`),b.toLowerCase()===k.$w.toLowerCase()&&(I??="",I+=(0,N.localize)(0,null)),w?.installCount){I??="";const g=w.installCount;let l;g>1e6?l=`${Math.floor(g/1e5)/10}M`:g>1e3?l=`${Math.floor(g/1e3)}K`:l=String(g),I+=` $(cloud-download) ${l}`}return{id:b,label:$,description:I}}};e.$Vr=a,e.$Vr=a=$e([oe(0,A.$9o)],a)}),define(ne[6],se([0,1,107,34,5,43,2,30,12,17,3,11,122,10]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=I,e.log=l,e.$gk=h,e.$hk=S,e.$ik=j,e.$jk=O,e.$5j=(0,w.$yi)("logService"),e.$6j=(0,w.$yi)("loggerService");function $(){return new Date().toISOString()}function I(z){return(0,f.$cg)(z)}var g;(function(z){z[z.Off=0]="Off",z[z.Trace=1]="Trace",z[z.Debug=2]="Debug",z[z.Info=3]="Info",z[z.Warning=4]="Warning",z[z.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$8j=g.Info;function l(z,C,T){switch(C){case g.Trace:z.trace(T);break;case g.Debug:z.debug(T);break;case g.Info:z.info(T);break;case g.Warning:z.warn(T);break;case g.Error:z.error(T);break;case g.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function c(z,C=!1){let T="";for(let J=0;J<z.length;J++){let re=z[J];if(re instanceof Error&&(re=(0,R.$jj)(re,C)),typeof re=="object")try{re=JSON.stringify(re)}catch{}T+=(J>0?" ":"")+re}return T}class v extends A.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new k.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==g.Off&&this.b<=C}}e.$0j=v;class p extends v{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...T){this.f(g.Trace)&&this.g(g.Trace,c([C,...T],!0))}debug(C,...T){this.f(g.Debug)&&this.g(g.Debug,c([C,...T]))}info(C,...T){this.f(g.Info)&&this.g(g.Info,c([C,...T]))}warn(C,...T){this.f(g.Warning)&&this.g(g.Warning,c([C,...T]))}error(C,...T){if(this.f(g.Error))if(C instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=C.stack,this.g(g.Error,c(J))}else this.g(g.Error,c([C,...T]))}flush(){}}e.$$j=p;class m extends v{constructor(C=e.$8j){super(),this.setLevel(C),this.g=!u.$i}trace(C,...T){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,C,...T):console.log(`[main ${$()}]`,C,...T))}debug(C,...T){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,C,...T):console.log(`[main ${$()}]`,C,...T))}info(C,...T){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,C,...T):console.log(`[main ${$()}]`,C,...T))}warn(C,...T){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,C,...T):console.warn(`[main ${$()}]`,C,...T))}error(C,...T){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,C,...T):console.error(`[main ${$()}]`,C,...T))}flush(){}}e.$_j=m;class n extends v{constructor(C=e.$8j,T=!0){super(),this.g=T,this.setLevel(C)}trace(C,...T){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...T):console.log(C,...T))}debug(C,...T){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...T):console.log(C,...T))}info(C,...T){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...T):console.log(C,...T))}warn(C,...T){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...T):console.log(C,...T))}error(C,...T){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...T):console.error(C,...T))}flush(){}}e.$ak=n;class r extends v{constructor(C,T=e.$8j){super(),this.g=C,this.setLevel(T)}trace(C,...T){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(C),...T])}debug(C,...T){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(C),...T])}info(C,...T){this.f(g.Info)&&this.g.log(g.Info,[this.h(C),...T])}warn(C,...T){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(C),...T])}error(C,...T){this.f(g.Error)&&this.g.log(g.Error,[this.h(C),...T])}h(C){return typeof C=="string"?C:(0,R.$jj)(C,this.f(g.Trace))}flush(){}}e.$bk=r;class t extends v{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const T of this.g)T.setLevel(C);super.setLevel(C)}trace(C,...T){for(const J of this.g)J.trace(C,...T)}debug(C,...T){for(const J of this.g)J.debug(C,...T)}info(C,...T){for(const J of this.g)J.info(C,...T)}warn(C,...T){for(const J of this.g)J.warn(C,...T)}error(C,...T){for(const J of this.g)J.error(C,...T)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ck=t;class i extends A.$Uc{constructor(C,T,J){if(super(),this.h=C,this.j=T,this.b=new E.$Ac,this.c=this.B(new k.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$fe),this.onDidChangeVisibility=this.g.event,J)for(const re of J)this.b.set(re.resource,{logger:void 0,info:re})}m(C){return(0,f.$$f)(C)?[...this.b.values()].find(T=>T.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,T){const J=this.n(C),re=(0,f.$$f)(C)?C:T?.id??(0,N.$mj)(J.toString()).toString(16);let ie=this.b.get(J)?.logger;const he=T?.logLevel==="always"?g.Trace:T?.logLevel;ie||(ie=this.s(J,he??this.getLogLevel(J)??this.h,{...T,id:re}));const le={logger:ie,info:{resource:J,id:re,logLevel:he,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(le.info),this.b.set(J,le),ie}n(C){return(0,f.$$f)(C)?(0,a.$_g)(this.j,`${C}.log`):C}setLogLevel(C,T){if(b.URI.isUri(C)){const J=C,re=T,ie=this.b.get(J);ie&&re!==ie.info.logLevel&&(ie.info.logLevel=re===this.h?void 0:re,ie.logger?.setLevel(re),this.b.set(ie.info.resource,ie),this.f.fire([J,re]))}else{this.h=C;for(const[J,re]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&re.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,T){const J=this.m(C);J&&T!==!J.info.hidden&&(J.info.hidden=!T,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,T]))}getLogLevel(C){let T;return C&&(T=this.b.get(C)?.info.logLevel),T??this.h}registerLogger(C){const T=this.b.get(C.resource);T?T.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const T=this.b.get(C);T&&(T.logger&&T.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=i;class s{constructor(){this.onDidChangeLogLevel=new k.$fe().event}setLevel(C){}getLevel(){return g.Info}trace(C,...T){}debug(C,...T){}info(C,...T){}warn(C,...T){}error(C,...T){}critical(C,...T){}dispose(){}flush(){}}e.$ek=s;class o extends s{}e.$fk=o;function h(z){if(z.verbose)return g.Trace;if(typeof z.logLevel=="string"){const C=O(z.logLevel.toLowerCase());if(C!==void 0)return C}return e.$8j}function S(z){switch(z){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function j(z){switch(z){case g.Trace:return{original:"Trace",value:D.localize(0,null)};case g.Debug:return{original:"Debug",value:D.localize(1,null)};case g.Info:return{original:"Info",value:D.localize(2,null)};case g.Warning:return{original:"Warning",value:D.localize(3,null)};case g.Error:return{original:"Error",value:D.localize(4,null)};case g.Off:return{original:"Off",value:D.localize(5,null)}}}function O(z){switch(z){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$kk=new y.$Pj("logLevel",S(g.Info))}),define(ne[128],se([0,1,19,8,9,5,63,2,16,52,6]),function(X,e,D,R,k,N,A,E,u,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class b extends E.$Uc{constructor(w,$){super(),this.a=w,this.b=$,this.c=this.B(new N.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$wh(0)),this.w=[],this.y=this.B(new R.$wh(0))}watch(w,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(w,$):this.z(w,$)}n(w,$){const I={path:this.J(w),excludes:$.excludes,includes:$.includes,recursive:$.recursive,filter:$.filter,correlationId:$.correlationId},g=(0,D.$Tb)(this.j,I);return this.r(),(0,E.$Sc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,k.$1)(w))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,a.$Rq)($)),$=>this.G($),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const $ of this.j)(0,a.$Nq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const $ of this.j)(0,a.$Nq)($)&&w.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,$){const I={path:this.J(w),excludes:$.excludes,includes:$.includes,recursive:!1,filter:$.filter,correlationId:$.correlationId},g=(0,D.$Tb)(this.w,I);return this.C(),(0,E.$Sc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,k.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$Rq)(w)),w=>this.G(w),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,u.$hc)(w.fsPath)}J(w){const $=this.I(w);return(0,A.$Ag)($)}}e.$Xq=b}),define(ne[129],se([0,1,19,8,14,20,5,43,66,2,48,15,130,17,46,103,13,62,6,9]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;let m=class extends a.$Uc{static{p=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$fe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$fe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$fe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$fe),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$fe),this.Y=this.B(new A.$fe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$fe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$Hh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${r}`);const i=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),i.add(t.onDidChangeFile(s=>{const o=new g.$ll(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(i){t.push(i)}}),!this.h.has(r)&&await R.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,w.$dh)(r))throw new g.$nl((0,I.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const i=new v.$bb;throw i.message=(0,I.localize)(1,null,r.toString()),i}return t}async m(r){const t=await this.j(r);if((0,g.$$k)(t)||(0,g.$8k)(t)||(0,g.$_k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,g.$$k)(t)||(0,g.$8k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(i){throw(0,g.$il)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.$nl((0,I.localize)(2,null,this.sb(r)),1):(0,g.$gl)(i)}}async s(r,t){const i=await this.j(r),s=this.S(i),o=t?.resolveTo,h=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,j=await i.stat(r);let O;return this.t(i,r,j,void 0,!!S,(z,C)=>(O||(O=f.$Ei.forUris(()=>!s),O.set(r,!0),o&&O.fill(!0,o)),O.get(z.resource)||O.findSuperstr(z.resource.with({query:null,fragment:null}))?!0:z.isDirectory&&h?C===1:!1))}async t(r,t,i,s,o,h){const{providerExtUri:S}=this.R(r),j={resource:t,name:S.basename(t),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.$yl)({mtime:i.mtime,size:i.size}),children:void 0};if(j.isDirectory&&h(j,s)){try{const O=await r.readdir(t),z=await R.Promises.settled(O.map(async([C,T])=>{try{const J=S.joinPath(t,C),re=o?await r.stat(J):{type:T};return await this.t(r,J,re,O.length,o,h)}catch(J){return this.b.trace(J),null}}));j.children=(0,D.$Hb)(z)}catch(O){this.b.trace(O),j.children=[]}return j}return j}async resolveAll(r){return R.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),i=await t.stat(r);return this.t(t,r,i,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(i){return i}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new g.$nl((0,I.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$He.fromString(""),i){await this.u(r,i);const s=await this.writeFile(r,t);return this.r.fire(new g.$kl(r,0,s)),s}async writeFile(r,t,i){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let h=i;if((0,g.$bl)(s)&&!h?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(h={...i,atomic:S})}try{await this.w(s,r,h)||await this.U(s,o.dirname(r));let j;if((0,g.$8k)(s)&&!(t instanceof k.$He))if((0,$.$te)(t)){const O=await(0,$.$Ae)(t,3);O.ended?j=k.$He.concat(O.buffer):j=O}else j=(0,$.$xe)(t,O=>k.$He.concat(O),3);else j=t;!(0,g.$$k)(s)||(0,g.$8k)(s)&&j instanceof k.$He||(0,g.$8k)(s)&&(0,g.$bl)(s)&&h?.atomic?await this.hb(s,r,h,j):await this.db(s,r,h,j instanceof k.$He?(0,k.$Se)(j):j),this.r.fire(new g.$kl(r,4))}catch(S){throw new g.$nl((0,I.localize)(4,null,this.sb(r),(0,g.$gl)(S).toString()),(0,g.$jl)(S),h)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,i){const s=!!i?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,I.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,I.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,I.localize)(7,null,this.sb(t)));if(s)throw new Error((0,I.localize)(8,null,this.sb(t)))}let h;try{h=await r.stat(t)}catch{return}if(h.type&g.FileType.Directory)throw new g.$nl((0,I.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,h),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.$xl&&typeof h.mtime=="number"&&typeof h.size=="number"&&i.mtime<h.mtime&&i.etag!==(0,g.$yl)({mtime:i.mtime,size:h.size}))throw new g.$nl((0,I.localize)(10,null),3,i);return h}async readFile(r,t,i){const s=await this.m(r);return t?.atomic?this.z(s,r,t,i):this.C(s,r,t,i)}async z(r,t,i,s){return new Promise((o,h)=>{this.cb.queueFor(t,async()=>{try{const S=await this.C(r,t,i,s);o(S)}catch(S){h(S)}},this.R(r).providerExtUri)})}async C(r,t,i,s){const o=await this.D(r,t,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Te)(o.value)}}async readFileStream(r,t,i){const s=await this.m(r);return this.D(s,r,t,i)}async D(r,t,i,s){const o=new N.$qe(s);let h=i;(0,g.$al)(r)&&r.enforceAtomicReadFile?.(t)&&(h={...i,atomic:!0});const S=this.J(t,h).then(O=>O,O=>{throw o.dispose(!0),O});let j;try{return typeof h?.etag=="string"&&h.etag!==g.$xl&&await S,h?.atomic&&(0,g.$al)(r)||!((0,g.$$k)(r)||(0,g.$_k)(r))||(0,g.$8k)(r)&&h?.preferUnbuffered?j=this.I(r,t,h):(0,g.$_k)(r)?j=this.G(r,t,o.token,h):j=this.H(r,t,o.token,h),j.on("end",()=>o.dispose()),j.on("error",()=>o.dispose()),{...await S,value:j}}catch(O){throw j&&await(0,$.$ye)(j),this.F(O,t,h)}}F(r,t,i){const s=(0,I.localize)(11,null,this.sb(t),(0,g.$gl)(r).toString());return r instanceof g.$pl?new g.$pl(s,r.stat,i):r instanceof g.$ol?new g.$ol(s,r.fileOperationResult,r.size,r.options):new g.$nl(s,(0,g.$jl)(r),i)}G(r,t,i,s=Object.create(null)){const o=r.readFileStream(t,s,i);return(0,$.$Ee)(o,{data:h=>h instanceof k.$He?h:k.$He.wrap(h),error:h=>this.F(h,t,s)},h=>k.$He.concat(h))}H(r,t,i,s=Object.create(null)){const o=(0,k.$Xe)();return(0,l.$Kq)(r,t,o,h=>h,{...s,bufferSize:this.a,errorTransformer:h=>this.F(h,t,s)},i),o}I(r,t,i){const s=(0,$.$ve)(o=>k.$He.concat(o));return(async()=>{try{let o;i?.atomic&&(0,g.$al)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(t,o.byteLength,i),s.end(k.$He.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new g.$nl((0,I.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==g.$xl&&t.etag===i.etag)throw new g.$pl((0,I.localize)(13,null),i,t);return this.L(r,i.size,t),i}L(r,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new g.$ol((0,I.localize)(14,null,this.sb(r)),7,t,i)}async canMove(r,t,i){return this.M(r,t,"move",i)}async canCopy(r,t,i){return this.M(r,t,"copy",i)}async M(r,t,i,s){if(r.toString()!==t.toString())try{const o=i==="move"?this.qb(await this.n(r),r):await this.m(r),h=this.qb(await this.n(t),t);await this.Q(o,r,h,t,i,s)}catch(o){return o}return!0}async move(r,t,i){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"move",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$kl(r,h==="move"?2:3,S)),S}async copy(r,t,i){const s=await this.m(r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"copy",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$kl(r,h==="copy"?3:2,S)),S}async N(r,t,i,s,o,h){if(t.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:j}=await this.Q(r,t,i,s,o,h);if(S&&!j&&h&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(r===i&&(0,g.$9k)(r))await r.copy(t,s,{overwrite:h});else{const O=await this.resolve(t);O.isDirectory?await this.P(r,O,i,s):await this.O(r,t,i,s)}return o}else return r===i?(await r.rename(t,s,{overwrite:h}),o):(await this.N(r,t,i,s,"copy",h),await this.del(t,{recursive:!0}),"copy")}async O(r,t,i,s){if((0,g.$$k)(r)&&(0,g.$$k)(i))return this.jb(r,t,i,s);if((0,g.$$k)(r)&&(0,g.$8k)(i))return this.pb(r,t,i,s);if((0,g.$8k)(r)&&(0,g.$$k)(i))return this.nb(r,t,i,s);if((0,g.$8k)(r)&&(0,g.$8k)(i))return this.lb(r,t,i,s)}async P(r,t,i,s){await i.mkdir(s),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async o=>{const h=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),i,h):this.O(r,o.resource,i,h)}))}async Q(r,t,i,s,o,h){let S=!1;if(r===i){const{providerExtUri:O,isPathCaseSensitive:z}=this.R(r);if(z||(S=O.isEqual(t,s)),S&&o==="copy")throw new Error((0,I.localize)(15,null,this.sb(t),this.sb(s)));if(!S&&O.isEqualOrParent(s,t))throw new Error((0,I.localize)(16,null,this.sb(t),this.sb(s)))}const j=await this.exists(s);if(j&&!S){if(!h)throw new g.$nl((0,I.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===i){const{providerExtUri:O}=this.R(r);if(O.isEqualOrParent(t,s))throw new Error((0,I.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:j,isSameResourceWithDifferentPathCase:S}}R(r){const t=this.S(r);return{providerExtUri:t?w.$2g:w.$4g,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$kl(r,0,i)),i}async U(r,t){const i=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&g.FileType.Directory))throw new Error((0,I.localize)(19,null,this.sb(t)));break}catch(o){if((0,g.$il)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(t)),t=s.dirname(t)}for(let o=i.length-1;o>=0;o--){t=s.joinPath(t,i[o]);try{await r.mkdir(t)}catch(h){if((0,g.$il)(h)!==g.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(r,t){try{await this.W(r,t)}catch(i){return i}return!0}async W(r,t){const i=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,I.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,I.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,I.localize)(22,null,this.sb(r)));let h;try{h=await i.stat(r)}catch{}if(h)this.rb(r,h);else throw new g.$nl((0,I.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const j=await this.resolve(r);if(j.isDirectory&&Array.isArray(j.children)&&j.children.length>0)throw new Error((0,I.localize)(24,null,this.sb(r)))}return i}async del(r,t){const i=await this.W(r,t);let s=t;if((0,g.$cl)(i)&&!s?.atomic){const j=i.enforceAtomicDelete?.(r);j&&(s={...t,atomic:j})}const o=!!s?.useTrash,h=!!s?.recursive,S=s?.atomic??!1;await i.delete(r,{recursive:h,useTrash:o,atomic:S}),this.r.fire(new g.$kl(r,1))}async cloneFile(r,t){const i=await this.j(r),s=this.qb(await this.n(t),t);if(!(i===s&&this.R(i).providerExtUri.isEqual(r,t)))return i===s&&(0,g.$0k)(i)?i.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),i===s&&(0,g.$9k)(i)?this.cb.queueFor(r,()=>i.copy(r,t,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,s,t),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:p.ab++})}watch(r,t={recursive:!1,excludes:[]}){const i=new a.$Tc;let s=!1,o=()=>{s=!0};i.add((0,a.$Sc)(()=>o())),(async()=>{try{const S=await this.bb(r,t);s?(0,a.$Pc)(S):o=()=>(0,a.$Pc)(S)}catch(S){this.b.error(S)}})();const h=t.correlationId;if(typeof h=="number"){const S=i.add(new A.$fe);return i.add(this.X.event(O=>{O.correlates(h)&&S.fire(O)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(r,t){const i=await this.j(r),s=(0,E.$mj)([this.R(i).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,i,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,$.$te)(s)||(0,$.$ue)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(h){throw(0,g.$gl)(h)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,i){let s=0,o;if((0,$.$ue)(i)){if(i.buffer.length>0){const h=k.$He.concat(i.buffer);await this.gb(r,t,h,h.byteLength,s,0),s+=h.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((h,S)=>{(0,$.$ze)(o,{onData:async j=>{o.pause();try{await this.gb(r,t,j,j.byteLength,s,0)}catch(O){return S(O)}s+=j.byteLength,setTimeout(()=>o.resume())},onError:j=>S(j),onEnd:()=>h()})})}async fb(r,t,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,i,s,o,h){let S=0;for(;S<s;){const j=await r.write(t,o+S,i.buffer,h+S,s-S);S+=j}}async hb(r,t,i,s){return this.cb.queueFor(t,()=>this.ib(r,t,i,s),this.R(r).providerExtUri)}async ib(r,t,i,s){let o;s instanceof k.$He?o=s:(0,$.$te)(s)?o=await(0,k.$Te)(s):(0,$.$ue)(s)?o=await(0,k.$Ue)(s):o=(0,k.$Re)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,t,i,s){return this.cb.queueFor(s,()=>this.kb(r,t,i,s),this.R(i).providerExtUri)}async kb(r,t,i,s){let o,h;try{o=await r.open(t,{create:!1}),h=await i.open(s,{create:!0,unlock:!1});const S=k.$He.alloc(this.a);let j=0,O=0,z=0;do z=await r.read(o,j,S.buffer,O,S.byteLength-O),await this.gb(i,h,S,z,j,O),j+=z,O+=z,O===S.byteLength&&(O=0);while(z>0)}catch(S){throw(0,g.$gl)(S)}finally{await R.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof h=="number"?i.close(h):Promise.resolve()])}}async lb(r,t,i,s){return this.cb.queueFor(s,()=>this.mb(r,t,i,s),this.R(i).providerExtUri)}async mb(r,t,i,s){return i.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,i,s){return this.cb.queueFor(s,()=>this.ob(r,t,i,s),this.R(i).providerExtUri)}async ob(r,t,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const h=await r.readFile(t);await this.gb(i,o,k.$He.wrap(h),h.byteLength,0,0)}catch(h){throw(0,g.$gl)(h)}finally{await i.close(o)}}async pb(r,t,i,s){const o=await(0,k.$Te)(this.H(r,t,N.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new g.$nl((0,I.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&g.FilePermission.Readonly)throw new g.$nl((0,I.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$Lq=m,e.$Lq=m=p=$e([oe(0,c.$5j)],m)}),define(ne[131],se([0,1,60,174,8,30,14,5,63,2,16,12,17,46,25,105,13,62,128,34,126,125]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c,v,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0,(()=>{try{(0,R.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,v.$jj)(r)}`)}})();class n extends c.$Xq{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=E.Event.None,this.P=new N.$Ac(s=>y.$3g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,b.$k&&(this.M|=1024)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await $.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await $.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,y.$_g)(t,o.name))).type:h=this.O(o),s.push([o.name,h])}catch(h){this.a.trace(h)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=g.FileType.Unknown:t.isFile()?s=g.FileType.File:t.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,i&&(s|=g.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new k.$xh;return this.P.set(t,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const o=this.I(t);return await $.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,w.$ve)(h=>A.$He.concat(h.map(S=>A.$He.wrap(S))).buffer);return(0,l.$Kq)(this,t,o,h=>h.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,y.$_g)((0,y.$$g)(t),`${(0,y.$9g)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await $.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,o){const h=new a.$Tc;try{h.add(await this.Q(t)),h.add(await this.Q(i)),await this.W(i,s,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{h.dispose()}}async W(t,i,s,o){let h;try{const S=this.I(t);if(!s.create||!s.overwrite){if(await $.Promises.exists(S)){if(!s.overwrite)throw(0,g.$fl)((0,I.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$fl)((0,I.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(h,0,i,0,i.byteLength)}catch(S){throw await this.ib(t,S)}finally{typeof h=="number"&&await this.close(h)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const o=this.I(t);let h;(0,g.$6k)(i)&&!s&&(h=await this.Q(t));let S;try{if((0,g.$6k)(i)&&i.unlock)try{const{stat:O}=await $.SymlinkSupport.stat(o);O.mode&128||await $.Promises.chmod(o,O.mode|128)}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}let j;if((0,g.$6k)(i)){if(b.$i)try{await $.Promises.truncate(o,0),j="r+"}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}j||(j="w")}else j="r";S=await $.Promises.open(o,j)}catch(j){throw h?.dispose(),(0,g.$6k)(i)?await this.ib(t,j):this.hb(j)}if(this.X.set(S,0),(0,g.$6k)(i)&&this.Z.set(S,t),h){const j=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.Y.set(S,h),j&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),j.dispose())}return S}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await $.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await $.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,h){const S=this.ab(t,i);let j=null;try{j=(await $.Promises.read(t,s,o,h,S)).bytesRead}catch(O){throw this.hb(O)}finally{this.bb(t,S,j)}return j}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const o=this.X.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,o+s):this.X.delete(t)))}async write(t,i,s,o,h){return(0,k.$Sh)(()=>this.cb(t,i,s,o,h),100,3)}async cb(t,i,s,o,h){const S=this.ab(t,i);let j=null;try{j=(await $.Promises.write(t,s,o,h,S)).bytesWritten}catch(O){throw await this.ib(this.Z.get(t),O)}finally{this.bb(t,S,j)}return j}async mkdir(t){try{await $.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,f.$jc)((0,f.$mc)(s),`${(0,f.$nc)(s)}${i.atomic.postfix}`)),await $.Promises.rm(s,$.RimRafMode.MOVE,o)}else try{await $.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let h=!1;try{const{stat:S,symbolicLink:j}=await $.SymlinkSupport.stat(s);h=S.isDirectory()&&!j}catch{}if(h)await $.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.hb(s)}}async rename(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"move",s.overwrite),await $.Promises.rename(o,h)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,I.localize)(2,null,(0,f.$nc)(o),(0,f.$nc)((0,f.$mc)(h)),S.toString()))),this.hb(S)}}async copy(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"copy",s.overwrite),await $.Promises.copy(o,h,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,I.localize)(3,null,(0,f.$nc)(o),(0,f.$nc)((0,f.$mc)(h)),S.toString()))),this.hb(S)}}async db(t,i,s,o){const h=this.I(t),S=this.I(i);let j=!1;if(!!(this.capabilities&1024)||(j=(0,u.$wg)(h,S,!0)),j){if(s==="copy")throw(0,g.$fl)((0,I.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const z=await this.N(t);if(!z)throw(0,g.$fl)((0,I.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(i);if(C){if(!o)throw(0,g.$fl)((0,I.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);z.type&g.FileType.File&&C.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const o=this.I(t),h=this.I(i),S=!!(this.capabilities&1024);if((0,u.$wg)(o,h,!S))return;const j=new a.$Tc;try{j.add(await this.Q(t)),j.add(await this.Q(i)),s&&await $.Promises.mkdir((0,f.$mc)(h),{recursive:!0}),await $.Promises.copyFile(o,h)}catch(O){if(O.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(O)}finally{j.dispose()}}t(t,i,s){return new p.$5q(o=>t(o),o=>i(o),s)}F(t,i,s){return new m.$br(o=>t(o),o=>i(o),s)}hb(t){if(t instanceof g.$el)return t;let i=t,s;switch(t.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$fl)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await $.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,g.$fl)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$cr=n}),define(ne[132],se([0,1,2,6]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=void 0;class k extends D.$Uc{constructor(A,E=[]){super(),this.a=new R.$ck([A,...E]),this.B(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...E){this.a.trace(A,...E)}debug(A,...E){this.a.debug(A,...E)}info(A,...E){this.a.info(A,...E)}warn(A,...E){this.a.warn(A,...E)}error(A,...E){this.a.error(A,...E)}flush(){this.a.flush()}}e.$0P=k}),define(ne[133],se([0,1,13,6]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function N(a,f,b,y,w){try{const $=await new Promise((g,l)=>{X(["@vscode/spdlog"],g,l)});$.setFlushOn(k.Trace);const I=await $.createAsyncRotatingLogger(a,f,b,y);return w?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch($){console.error($)}return null}function A(a,f,b){switch(f){case R.LogLevel.Trace:a.trace(b);break;case R.LogLevel.Debug:a.debug(b);break;case R.LogLevel.Info:a.info(b);break;case R.LogLevel.Warning:a.warn(b);break;case R.LogLevel.Error:a.error(b);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function E(a,f){switch(f){case R.LogLevel.Trace:a.setLevel(k.Trace);break;case R.LogLevel.Debug:a.setLevel(k.Debug);break;case R.LogLevel.Info:a.setLevel(k.Info);break;case R.LogLevel.Warning:a.setLevel(k.Warning);break;case R.LogLevel.Error:a.setLevel(k.Error);break;case R.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class u extends R.$$j{constructor(f,b,y,w,$){super(),this.m=[],this.setLevel($),this.n=this.s(f,b,y,w),this.B(this.onDidChangeLogLevel(I=>{this.r&&E(this.r,I)}))}async s(f,b,y,w){const $=y?6:1,I=30/$*D.$Al.MB,g=await N(f,b,I,$,w);if(g){this.r=g,E(this.r,this.getLevel());for(const{level:l,message:c}of this.m)A(this.r,l,c);this.m=[]}}g(f,b){this.r?A(this.r,f,b):this.getLevel()<=f&&this.m.push({level:f,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$YP=u}),define(ne[134],se([0,1,28,6,133]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=void 0;class N extends R.$dk{s(E,u,a){return new k.$YP((0,D.$Ug)(),E.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$ZP=N}),define(ne[39],se([0,1,5,66,2,10]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=void 0,e.$ho=(0,N.$yi)("policy");class A extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$fe),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),R.Iterable.reduce(this.g.entries(),(b,[y,w])=>({...b,[y]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(a,[f,b])=>({...a,[f]:{definition:b,value:this.g.get(f)}}),{})}}e.$io=A;class E{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$jo=E}),define(ne[135],se([0,1,8,5,66,3,13,6,39]),function(X,e,D,R,k,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;function a(b,y){const w=[];for(const $ of new Set(k.Iterable.concat(b.keys(),y.keys())))b.get($)!==y.get($)&&w.push($);return w}let f=class extends u.$io{constructor(y,w,$){super(),this.m=y,this.n=w,this.s=$,this.c=this.B(new D.$wh(500));const I=R.Event.filter(w.onDidFilesChange,g=>g.affects(y));this.B(w.watch(y)),this.B(I(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const w=await this.n.readFile(this.m),$=JSON.parse(w.value.toString());if(!(0,N.$ag)($))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys($))this.f[I]&&y.set(I,$[I])}catch(w){w.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",w)}return y}async w(){const y=await this.u(),w=a(this.g,y);this.g=y,w.length>0&&this.h.fire(w)}};e.$jec=f,e.$jec=f=$e([oe(1,A.$5k),oe(2,E.$5j)],f)}),define(ne[136],se([0,1,39,8,2,6]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let A=class extends D.$io{constructor(u,a){super(),this.m=u,this.n=a,this.a=new R.$sh,this.b=this.B(new k.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((f,b)=>{X(["@vscode/policy-watcher"],f,b)});await this.a.queue(()=>new Promise((f,b)=>{try{this.b.value=a(this.n,u,y=>{this.t(y),f()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const f=u[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(u))}};e.$iec=A,e.$iec=A=$e([oe(0,N.$5j)],A)}),define(ne[32],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,D.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,73,3]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class k{constructor(){this.a=new Map}add(A,E){D.ok(R.$$f(A)),D.ok(R.$ag(E)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,E)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$fo=new k}),define(ne[137],se([0,1,5,36]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class N{constructor(){this.b=new D.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[k(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;R.$fo.add(e.$go.JSONContribution,A)}),define(ne[40],se([0,1,19,5,3,92,29,137,36]),function(X,e,D,R,k,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=I,e.$wo=g,e.$xo=l,e.$yo=v,e.$zo=p;var a;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$ko={Configuration:"base.contributions.configuration"};var f;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const b=u.$fo.as(E.$go.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.$fe,this.onDidSchemaChange=this.i.event,this.j=new R.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.$uo.test(o)){const h=this.a.get(o),S=h?.valuesSources??new Map;if(s)for(const C of Object.keys(i[o]))S.set(C,s);const j={...h?.value||{},...i[o]};this.a.set(o,{source:s,value:j,valuesSources:S});const O=(0,A.$cj)(o),z={type:"object",default:j,description:N.localize(1,null,O),$ref:e.$ro,defaultDefaultValue:j,source:k.$$f(s)?void 0:s,defaultValueSource:s};t.push(...I(o)),this.d[o]=z,this.b.properties[o]=z}else{this.a.set(o,{value:i[o],source:s});const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),h=k.$$f(i)?i:i?.id,S=k.$$f(o?.source)?o?.source:o?.source?.id;if(h===S)if(r.add(s),this.a.delete(s),e.$uo.test(s))delete this.d[s],delete this.b.properties[s];else{const j=this.d[s];j&&(this.w(s,j),this.r(s,j))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=k.$hg(n.scope)?s:n.scope;const h=n.properties;if(h)for(const j in h){const O=h[j];if(r&&v(j,O)){delete h[j];continue}if(O.source=t,O.defaultDefaultValue=h[j].default,this.w(j,O),e.$uo.test(j)?O.scope=void 0:(O.scope=k.$hg(O.scope)?s:O.scope,O.restricted=k.$hg(O.restricted)?!!i?.includes(j):O.restricted),h[j].hasOwnProperty("included")&&!h[j].included){this.f[j]=h[j],delete h[j];continue}else this.d[j]=h[j],h[j].policy?.name&&this.e.set(h[j].policy.name,j);!h[j].deprecationMessage&&h[j].markdownDeprecationMessage&&(h[j].deprecationMessage=h[j].markdownDeprecationMessage),o.add(j)}const S=n.allOf;if(S)for(const j of S)this.p(j,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$lo.properties[n]=r,r.scope){case 1:e.$mo.properties[n]=r;break;case 2:e.$no.properties[n]=r;break;case 6:e.$oo.properties[n]=r;break;case 3:e.$po.properties[n]=r;break;case 4:e.$qo.properties[n]=r;break;case 5:e.$qo.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$lo.properties[n],r.scope){case 1:delete e.$mo.properties[n];break;case 2:delete e.$no.properties[n];break;case 6:delete e.$oo.properties[n];break;case 3:delete e.$po.properties[n];break;case 4:case 5:delete e.$qo.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ro};this.w(r,t),e.$lo.properties[r]=t,e.$mo.properties[r]=t,e.$no.properties[r]=t,e.$oo.properties[r]=t,e.$po.properties[r]=t,e.$qo.properties[r]=t}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=n,e.$mo.patternProperties[e.$to]=n,e.$no.patternProperties[e.$to]=n,e.$oo.patternProperties[e.$to]=n,e.$po.patternProperties[e.$to]=n,e.$qo.patternProperties[e.$to]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;k.$fg(i)&&(i=r.defaultDefaultValue,s=void 0),k.$fg(i)&&(i=l(r.type)),r.default=i,r.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",$=new RegExp(w,"g");e.$to=`^(${w})+$`,e.$uo=new RegExp(e.$to);function I(m){const n=[];if(e.$uo.test(m)){let r=$.exec(m);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=$.exec(m)}}return(0,D.$Mb)(n)}function g(m){return m.reduce((n,r)=>`${n}[${r}]`,"")}function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new y;u.$fo.add(e.$ko.Configuration,c);function v(m,n){return m.trim()?e.$uo.test(m)?N.localize(7,null,m):c.getConfigurationProperties()[m]!==void 0?N.localize(8,null,m):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,m,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}function p(){const m=[],n=c.getConfigurationProperties();for(const r of Object.keys(n))m.push([r,n[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}}),define(ne[67],se([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(X,e,D,R,k,N,A,E,u,a,f,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=v;function w(r){return Object.isFrozen(r)?r:E.$6n(r)}class ${static createEmptyModel(t){return new $({},[],[],void 0,t)}constructor(t,i,s,o,h){this.b=t,this.c=i,this.d=s,this.raw=o,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof $)return i;const s=new I("",this.f);return s.parseRaw(i),s.configurationModel});this.g=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,f.$aj)(this.contents,t):this.contents}inspect(t,i){const s=this;return{get value(){return w(s.rawConfiguration.getValue(t))},get override(){return i?w(s.rawConfiguration.getOverrideValue(t,i)):void 0},get merged(){return w(i?s.rawConfiguration.override(i).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:h,identifiers:S,keys:j}of s.rawConfiguration.overrides){const O=new $(h,j,[],void 0,s.f).getValue(t);O!==void 0&&o.push({identifiers:S,value:O})}return o.length?w(o):void 0}}}getOverrideValue(t,i){const s=this.j(i);return s?t?(0,f.$aj)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return D.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return D.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.h(t),this.a.set(t,i)),i}merge(...t){const i=E.$5n(this.contents),s=E.$5n(this.overrides),o=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const S of t)if(h.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(i,S.contents);for(const j of S.overrides){const[O]=s.filter(z=>D.$ub(z.identifiers,j.identifiers));O?(this.i(O.contents,j.contents),O.keys.push(...j.keys),O.keys=D.$Mb(O.keys)):s.push(E.$5n(j))}for(const j of S.keys)o.indexOf(j)===-1&&o.push(j)}return new $(i,o,s,h.every(S=>S instanceof $)?void 0:h,this.f)}h(t){const i=this.j(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[o];const S=i[o];S&&(typeof h=="object"&&typeof S=="object"?(h=E.$5n(h),this.i(h,S)):h=S),s[o]=h}return new $(s,this.keys,this.overrides,void 0,this.f)}i(t,i){for(const s of Object.keys(i)){if(s in t&&u.$ag(t[s])&&u.$ag(i[s])){this.i(t[s],i[s]);continue}t[s]=E.$5n(i[s])}}j(t){let i=null,s=null;const o=h=>{h&&(s?this.i(s,h):s=E.$5n(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?i=h.contents:h.identifiers.includes(t)&&o(h.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.k(t,i,!0)}setValue(t,i){this.k(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,f.$_i)(this.contents,t),b.$uo.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>D.$ub(s.identifiers,(0,b.$vo)(t))),1))}k(t,i,s){(0,f.$$i)(this.contents,t,i,o=>this.f.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),b.$uo.test(t)&&this.overrides.push({identifiers:(0,b.$vo)(t),keys:Object.keys(this.contents[t]),contents:(0,f.$0i)(this.contents[t],o=>this.f.error(o))})}}e.$Ao=$;class I{constructor(t,i){this.f=t,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||$.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$hg(t)){const s=this.h(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:h,restricted:S,hasExcludedProperties:j}=this.i(t,i);this.b=new $(s,o,h,j?[t]:void 0,this.g),this.c=S||[]}h(t){let i={},s=null,o=[];const h=[],S=[];function j(z){Array.isArray(o)?o.push(z):s!==null&&(o[s]=z)}const O={onObjectBegin:()=>{const z={};j(z),h.push(o),o=z,s=null},onObjectProperty:z=>{s=z},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const z=[];j(z),h.push(o),o=z,s=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:j,onError:(z,C,T)=>{S.push({error:z,offset:C,length:T})}};if(t)try{k.$Sn(t,O),i=o[0]||{}}catch(z){this.g.error(`Error while parsing settings file ${this.f}: ${z}`),this.d=[z]}return i}i(t,i){const s=y.$fo.as(b.$ko.Configuration).getConfigurationProperties(),o=this.j(t,s,!0,i);t=o.raw;const h=(0,f.$0i)(t,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`)),S=Object.keys(t),j=this.l(t,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:h,keys:S,overrides:j,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,i,s,o){let h=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const S={},j=[];for(const O in t)if(b.$uo.test(O)&&s){const z=this.j(t[O],i,!1,o);S[O]=z.raw,h=h||z.hasExcludedProperties,j.push(...z.restricted)}else{const z=i[O],C=z?typeof z.scope<"u"?z.scope:3:void 0;z?.restricted&&j.push(O),!o.exclude?.includes(O)&&(o.include?.includes(O)||(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&!(o.skipRestricted&&z?.restricted))?S[O]=t[O]:h=!0}return{raw:S,restricted:j,hasExcludedProperties:h}}l(t,i){const s=[];for(const o of Object.keys(t))if(b.$uo.test(o)){const h={};for(const S in t[o])h[S]=t[o][S];s.push({identifiers:(0,b.$vo)(o),keys:Object.keys(h),contents:(0,f.$0i)(h,i)})}return s}}e.$Bo=I;class g extends N.$Uc{constructor(t,i,s,o,h){super(),this.c=t,this.f=i,this.g=o,this.h=h,this.b=this.B(new R.$fe),this.onDidChange=this.b.event,this.a=new I(this.c.toString(),h),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return $.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=g;class l{constructor(t,i,s,o,h,S,j,O,z,C,T,J,re){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=h,this.f=S,this.g=j,this.h=O,this.i=z,this.j=C,this.k=T,this.l=J,this.m=re}get value(){return w(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class c{constructor(t,i,s,o,h,S,j,O,z,C){this.j=t,this.l=i,this.m=s,this.n=o,this.p=h,this.q=S,this.r=j,this.s=O,this.t=z,this.u=C,this.h=null,this.i=new A.$Ac,this.v=null}getValue(t,i,s){return this.w(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.t.get(s.resource),o||(o=$.createEmptyModel(this.u),this.t.set(s.resource,o))):o=this.s,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.h=null)}inspect(t,i,s){const o=this.w(t,i,s),h=this.A(i.resource,s),S=i.resource?this.t.get(i.resource)||this.s:this.s,j=new Set;for(const O of o.overrides)for(const z of O.identifiers)o.getOverrideValue(t,z)!==void 0&&j.add(z);return new l(t,i,o.getValue(t),j.size?[...j]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,h||void 0,S)}keys(t){const i=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,i){this.r.set(t,i),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:h,removed:S}=m(this.j,t);i=[...o,...h,...S]}for(const o of i)for(const h of(0,b.$vo)(o)){const S=this.j.getKeysForOverrideIdentifier(h),j=t.getKeysForOverrideIdentifier(h),O=[...j.filter(z=>S.indexOf(z)===-1),...S.filter(z=>j.indexOf(z)===-1),...S.filter(z=>!E.$9n(this.j.override(h).getValue(z),t.override(h).getValue(z)))];s.push([h,O])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=m(this.l,t),h=[...i,...s,...o];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=m(this.applicationConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=m(this.localUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=m(this.remoteUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=m(this.workspaceConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:h}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:h,removed:S,overrides:j}=m(s,i),O=[...o,...h,...S];return(O.length||!s)&&this.updateFolderConfiguration(t,i),{keys:O,overrides:j}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:h,overrides:S}=m(i,void 0);return{keys:[...s,...o,...h],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,i,s){let o=this.x(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},i){let s=this.y();if(i&&t){const o=i.getFolder(t);o&&(s=this.z(o.uri)||s);const h=this.t.get(t);h&&(s=s.merge(h))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let i=this.i.get(t);if(!i){const s=this.y(),o=this.r.get(t);o?(i=s.merge(o),this.i.set(t,i)):i=s}return i}A(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:h}=this.r.get(i);return t.push([i,{contents:s,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.q.keys.forEach(i=>t.add(i)),this.r.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}D(t){const i=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.q.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t,i){const s=this.E(t.defaults,i),o=this.E(t.policy,i),h=this.E(t.application,i),S=this.E(t.user,i),j=this.E(t.workspace,i),O=t.folders.reduce((z,C)=>(z.set(a.URI.revive(C[0]),this.E(C[1],i)),z),new A.$Ac);return new c(s,o,h,S,$.createEmptyModel(i),j,O,$.createEmptyModel(i),new A.$Ac,i)}static E(t,i){return new $(t.contents,t.keys,t.overrides,void 0,i)}}e.$Do=c;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,S])=>{const j=(0,A.$xc)(i,h,new Set);S.forEach(O=>j.add(O))});const s=[];return i.forEach((o,h)=>s.push([h,[...o.values()]])),{keys:[...t.values()],overrides:s}}class p{constructor(t,i,s,o,h){this.change=t,this.f=i,this.g=s,this.h=o,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of t.keys)this.affectedKeys.add(S);for(const[,S]of t.overrides)for(const j of S)this.affectedKeys.add(j);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=c.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const h=o+s.length;if(h>=this.d.length)return!1;const S=this.d.charCodeAt(h);if(S!==this.b&&S!==this.c)return!1;if(i){const j=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,O=this.g.getValue(t,i,this.h);return!E.$9n(j,O)}return!0}}e.$Fo=p;function m(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),h=[],S=r?.getAllOverrideIdentifiers()||[],j=t?.getAllOverrideIdentifiers()||[];if(t){const O=j.filter(z=>!S.includes(z));for(const z of O)h.push([z,t.getKeysForOverrideIdentifier(z)])}if(r){const O=S.filter(z=>!j.includes(z));for(const z of O)h.push([z,r.getKeysForOverrideIdentifier(z)])}if(t&&r){for(const O of S)if(j.includes(O)){const z=n({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:t.getOverrideValue(void 0,O)||{},keys:t.getKeysForOverrideIdentifier(O)});h.push([O,[...z.added,...z.removed,...z.updated]])}}return{added:i,removed:s,updated:o,overrides:h}}function n(r,t){const i=r?t?r.keys.filter(h=>t.keys.indexOf(h)===-1):[...r.keys]:[],s=t?r?t.keys.filter(h=>r.keys.indexOf(h)===-1):[...t.keys]:[],o=[];if(r&&t){for(const h of t.keys)if(r.keys.indexOf(h)!==-1){const S=(0,f.$aj)(t.contents,h),j=(0,f.$aj)(r.contents,h);E.$9n(S,j)||o.push(h)}}return{added:i,removed:s,updated:o}}}),define(ne[138],se([0,1,19,5,2,27,3,67,40,6,39,36]),function(X,e,D,R,k,N,A,E,u,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=void 0;class y extends k.$Uc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new R.$fe),this.onDidChangeConfiguration=this.a.event,this.b=E.$Ao.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$fo.as(u.$ko.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:l})=>this.f(Array.from(g),l))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,l){this.j(g,b.$fo.as(u.$ko.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=E.$Ao.createEmptyModel(this.c);const g=b.$fo.as(u.$ko.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,l){const c=this.g();for(const v of g){const p=c[v],m=l[v];p!==void 0?this.b.addValue(v,p):m?this.b.addValue(v,m.default):this.b.removeValue(v)}}}e.$Go=y;class w{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=E.$Ao.createEmptyModel(new a.$fk)}async initialize(){return this.configurationModel}}e.$Ho=w;let $=class extends k.$Uc{get configurationModel(){return this.b}constructor(g,l,c){super(),this.c=g,this.f=l,this.g=c,this.a=this.B(new R.$fe),this.onDidChangeConfiguration=this.a.event,this.b=E.$Ao.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const l={},c=[],v=b.$fo.as(u.$ko.Configuration).getConfigurationProperties();for(const p of g){const m=v[p];if(!m){c.push(p);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}c.push(p),l[m.policy.name]={type:m.type}}}return(0,A.$lg)(l)||await this.f.updatePolicyDefinitions(l),c}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const l=b.$fo.as(u.$ko.Configuration).getPolicyConfigurations(),c=(0,D.$Hb)(g.map(v=>l.get(v)));this.m(c,!0)}m(g,l){this.g.trace("PolicyConfiguration#update",g);const c=b.$fo.as(u.$ko.Configuration).getConfigurationProperties(),v=[],p=this.b.isEmpty();for(const m of g){const n=c[m]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(p?r!==void 0:!(0,N.$9n)(this.b.getValue(m),r))&&v.push([m,r])}else this.b.getValue(m)!==void 0&&v.push([m,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const m=this.b;this.b=E.$Ao.createEmptyModel(this.g);for(const n of m.keys)this.b.setValue(n,m.getValue(n));for(const[n,r]of v)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);l&&this.a.fire(this.b)}}};e.$Io=$,e.$Io=$=$e([oe(1,f.$ho),oe(2,a.$5j)],$)}),define(ne[139],se([0,1,19,8,14,5,38,75,2,30,27,12,17,29,67,40,138,39]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0;class c extends u.$Uc{constructor(m,n,r,t){super(),this.m=m,this.n=t,this.h=this.B(new N.$fe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Go(t)),this.c=r instanceof l.$jo?new g.$Ho:this.B(new g.$Io(this.b,r,t)),this.f=this.B(new $.$Co(this.m,{},y.$3g,n,t)),this.a=new $.$Do(this.b.configurationModel,this.c.configurationModel,$.$Ao.createEmptyModel(t),$.$Ao.createEmptyModel(t),$.$Ao.createEmptyModel(t),$.$Ao.createEmptyModel(t),new a.$Ac,$.$Ao.createEmptyModel(t),new a.$Ac,t),this.j=new v(m,n,this),this.g=this.B(new R.$Kh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:s})=>this.s(i,s))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$Do(m,n,$.$Ao.createEmptyModel(this.n),r,$.$Ao.createEmptyModel(this.n),$.$Ao.createEmptyModel(this.n),new a.$Ac,$.$Ao.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(m,n){const r=typeof m=="string"?m:void 0,t=(0,w.$6i)(m)?m:(0,w.$6i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(m,n,r,t,i){const s=(0,w.$7i)(r)?r:(0,w.$6i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=s?t:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${m} to target ${o}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,D.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const h=this.inspect(m,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${m} because it is configured in system policy.`);if((0,f.$9n)(n,h.defaultValue)&&(n=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const j=s.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(z=>(0,D.$ub)([...z.identifiers].sort(),j));O&&(s.overrideIdentifiers=O.identifiers)}const S=s?.overrideIdentifiers?.length?[(0,I.$wo)(s.overrideIdentifiers),m]:[m];await this.j.write(S,n),await this.reloadConfiguration()}inspect(m,n={}){return this.a.inspect(m,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.r(m)}r(m){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(m);this.u(r,n,2)}s(m,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(m,n);this.u(t,r,7)}t(m){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(m);this.u(r,n,7)}u(m,n,r){const t=new $.$Fo(m,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Jo=c;class v{constructor(m,n,r){this.b=m,this.c=n,this.d=r,this.a=new R.$Fh}write(m,n){return this.a.queue(()=>this.e(m,n))}async e(m,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)r="{}";else throw s}const t=[];if((0,A.$Ln)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,m,n);r=(0,E.$4n)(r,i),await this.c.writeFile(this.b,k.$He.fromString(r))}f(m,n,r){const{tabSize:t,insertSpaces:i,eol:s}=this.h;if(!n.length){const o=JSON.stringify(r,null,i?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,E.$1n)(m,n,r,{tabSize:t,insertSpaces:i,eol:s})}get h(){if(!this.g){let m=b.OS===3||b.OS===2?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(m=n),this.g={eol:m,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ne[68],se([0,1,15]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=R,e.$Km=k,e.$Lm=N,e.$Mm=A;function R(u){return u.scheme===D.Schemas.vscodeRemote?u.authority:void 0}function k(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function N(u){const{host:a,port:f}=E(u);if(typeof f>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function A(u,a){let{host:f,port:b}=E(u);return typeof b>"u"&&(b=a),{host:f,port:b}}function E(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=u.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const b=u.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:u,port:void 0}}}),define(ne[37],se([0,1,31,10,68]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=N,e.$Wm=b,e.$Xm=y,e.$Ym=w,e.$Zm=$,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function N(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(I){I.WIN32_X64="win32-x64",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,l){if(typeof g>"u"||g===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof g=="string"||typeof l=="string"){const c=typeof g=="string"?g:g.value,v=typeof l=="string"?l:l.value;return D.$zf(c,v)}return g._lower===l._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Tm=u;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const l of g)this.add(l)}add(g){this.c.add(u.toKey(g))}delete(g){return this.c.delete(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}}e.$Um=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(u.toKey(g))}get(g){return this.c.get(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}set(g,l){this.c.set(u.toKey(g),l)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=f;function b(I){return y(I)}function y(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}function w(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}function $(I,g){if(g){const l=`onResolveRemoteAuthority:${(0,k.$Km)(g)}`;return!!I.activationEvents?.includes(l)}return!1}e.$1m=(0,R.$yi)("IBuiltinExtensionsScannerService")}),define(ne[140],se([0,1,2,37,13]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class N extends D.$Uc{constructor(E,u,a,f,b){super(),this.a=E,this.b=u,this.c=a,this.f=b,this.B(f.onDidInstallExtensions(y=>this.g(y))),this.B(f.onDidUninstallExtension(y=>this.h(y)))}g(E){for(const u of E)u.local&&this.invalidate(u.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,E)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,R.$Nm))}catch(u){(0,k.$jl)(u)!==1&&this.f.error(u)}}}e.$Eq=N}),define(ne[45],se([0,1,14,9,2,108,40,10,6,36]),function(X,e,D,R,k,N,A,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Sp=y,e.$Tp=w,e.$Up=$,e.$Vp=I,e.$Wp=g,e.$Xp=l,e.$Qp=(0,E.$yi)("requestService");class f{constructor(m){this.b=m}toJSON(){if(!this.a){const m=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?m[n]="*****":m[n]=this.b[n];this.a=m}return this.a}}class b extends k.$Uc{constructor(m){super(),this.b=0,this.a=m.createLogger("network",{name:(0,N.localize)(0,null),when:u.$kk.isEqualTo((0,u.$hk)(u.LogLevel.Trace)).serialize()})}async c(m,n,r){const t=`${m} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new f(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,R.$0)(i)),i}}}e.$Rp=b;function y(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function w(p){return p.res.statusCode===204}async function $(p){return w(p)?null:(await(0,D.$Te)(p.stream)).toString()}async function I(p){if(!y(p))throw new Error("Server returned "+p.res.statusCode);return $(p)}async function g(p){if(!y(p))throw new Error("Server returned "+p.res.statusCode);if(w(p))return null;const n=(await(0,D.$Te)(p.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function l(p){v(p)}let c;function v(p){const m=a.$fo.as(A.$ko.Configuration),n=c;c={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},m.updateConfigurations({add:[c],remove:n?[n]:[]})}v(1)}),define(ne[141],se([0,1,20,15,13,45]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=void 0;let A=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,f=D.CancellationToken.None){if(u.scheme===R.Schemas.file||u.scheme===R.Schemas.vscodeRemote){await this.b.copy(u,a);return}const b={type:"GET",url:u.toString(!0)},y=await this.a.request(b,f);if(y.res.statusCode===200)await this.b.writeFile(a,y.stream);else{const w=await(0,N.$Vp)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${w}`)}}};e.$mQ=A,e.$mQ=A=$e([oe(0,N.$Qp),oe(1,k.$5k)],A)}),define(ne[142],se([0,1,143,3]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=N;function k(A,E){return A.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:A.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function N(A,E,u={}){const a=(0,D.parse)(A),f=u.proxyUrl||k(a,E);if(!f)return null;const b=(0,D.parse)(f);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,R.$eg)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,$)=>{X(["http-proxy-agent"],w,$)})).HttpProxyAgent(f,y):new(await new Promise((w,$)=>{X(["https-proxy-agent"],w,$)})).HttpsProxyAgent(f,y)}}),define(ne[144],se([0,1,59,16,109,20,34,9,12,28,88,175,8,76]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=I;let $;async function I(l,c,v,p){return v["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Cm)(p)&&!v["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Cm)(p)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),$||($=y.Promises.withAsyncBody(async(m,n)=>{const r=new N.$qe;let t=1e4;const i=l.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,w.$Dm)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,k.localize)(0,null)))},t);try{m(await g(c,r.token))}catch(o){!(0,E.$4)(o)&&!r.token.isCancellationRequested?n(new Error((0,k.localize)(1,null,(0,A.$jj)(o)))):m({})}finally{clearTimeout(s),r.dispose()}})),$)}async function g(l,c){const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",p);const m=(0,a.$Ug)().replace(/-/g,"").substr(0,12),n=new RegExp(m+"({.*})"+m),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,f.$sm)(u.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(c.isCancellationRequested)return s(new E.$5);const o=(0,R.$nc)(t);let h,S;const j="";/^pwsh(-preview)?$/.test(o)?(h=`& '${process.execPath}' ${j} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,S=["-Login","-Command"]):o==="nu"?(h=`^'${process.execPath}' ${j} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,S=["-i","-l","-c"]):o==="xonsh"?(h=`import os, json; print("${m}", json.dumps(dict(os.environ)), "${m}")`,S=["-i","-l","-c"]):(h=`'${process.execPath}' ${j} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),h);const O=(0,D.spawn)(t,[...S,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});c.onCancellationRequested(()=>(O.kill(),s(new E.$5))),O.on("error",T=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.$jj)(T)),s(T)});const z=[];O.stdout.on("data",T=>z.push(T));const C=[];O.stderr.on("data",T=>C.push(T)),O.on("close",(T,J)=>{const re=Buffer.concat(z).toString("utf8");l.trace("getUnixShellEnvironment#raw",re);const ie=Buffer.concat(C).toString("utf8");if(ie.trim()&&l.trace("getUnixShellEnvironment#stderr",ie),T||J)return s(new Error((0,k.localize)(2,null,T,J)));const he=n.exec(re),le=he?he[1]:"{}";try{const ce=JSON.parse(le);v?ce.ELECTRON_RUN_AS_NODE=v:delete ce.ELECTRON_RUN_AS_NODE,p?ce.ELECTRON_NO_ATTACH_CONSOLE=p:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){l.error("getUnixShellEnvironment#errorCaught",(0,A.$jj)(ce)),s(ce)}})})}}),define(ne[145],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,D.$yi)("stateReadService"),e.$2P=(0,D.$yi)("stateService")}),define(ne[69],se([0,1,8,14,2,3,18,13,6]),function(X,e,D,R,k,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=e.$3P=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends k.$Uc{constructor($,I,g,l){super(),this.h=$,this.j=I,this.m=g,this.n=l,this.a=Object.create(null),this.b="",this.c=this.B(new D.$wh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch($){$.fileOperationResult!==1&&this.m.error($)}}getItem($,I){const g=this.a[$];return(0,N.$hg)(g)?I:g}setItem($,I){this.setItems([{key:$,data:I}])}setItems($){let I=!1;for(const{key:g,data:l}of $)this.a[g]!==l&&((0,N.$hg)(l)?(0,N.$fg)(this.a[g])||(this.a[g]=void 0,I=!0):(this.a[g]=l,I=!0));I&&this.s()}removeItem($){(0,N.$fg)(this.a[$])||(this.a[$]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const $=JSON.stringify(this.a,null,4);if($!==this.b)try{await this.n.writeFile(this.h,R.$He.fromString($),{atomic:{postfix:".vsctmp"}}),this.b=$}catch(I){this.m.error(I)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$3P=f;let b=class extends k.$Uc{constructor($,I,g,l){super(),this.a=this.B(new f(I.stateResource,$,g,l))}async init(){await this.a.init()}getItem($,I){return this.a.getItem($,I)}};e.$4P=b,e.$4P=b=$e([oe(1,A.$Fi),oe(2,u.$5j),oe(3,E.$5k)],b);class y extends b{setItem($,I){this.a.setItem($,I)}setItems($){this.a.setItems($)}removeItem($){this.a.removeItem($)}close(){return this.a.close()}}e.$5P=y}),define(ne[70],se([0,1,12,35,28]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=A,e.$hp=E;function N(u){if(D.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,a,f,b,y,w,$,I,g){const l=Object.create(null);l["common.machineId"]=w,l["common.sqmId"]=$,l.sessionID=(0,k.$Ug)()+Date.now(),l.commitHash=b,l.version=y,l["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$u),l["common.nodePlatform"]=R.$dc,l["common.nodeArch"]=f,l["common.product"]=g||"desktop",I&&(l["common.msftInternal"]=I);let c=0;const v=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const p=N(a);return p&&(l["common.platformDetail"]=p),l}function E(u){const a=R.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return u.some(b=>f===b)}}),define(ne[22],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,D.$yi)("telemetryService"),e.$5l=(0,D.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var R;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var k;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[71],se([0,1,9,10,6,22]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.ExtensionSignatureVerificationCode=e.$cq=void 0,e.$cq=(0,R.$yi)("IExtensionSignatureVerificationService");var A;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class E extends Error{constructor(f){super(f),this.code=f}}e.$dq=E;let u=class{constructor(f,b){this.b=f,this.c=b}d(){return this.a||(this.a=new Promise((f,b)=>X(["@vscode/vsce-sign"],async y=>f(y),b))),this.a}async verify(f,b,y){let w;try{w=await this.d()}catch(l){return this.b.error("Could not load vsce-sign module",(0,D.$0)(l)),this.b.info(`Extension signature verification is not done: ${f}`),!1}const $=new Date().getTime();let I;try{I=await w.verify(b,y,this.b.getLevel()===k.LogLevel.Trace)}catch(l){I={code:"UnknownError",didExecute:!1,output:(0,D.$0)(l)}}const g=new Date().getTime()-$;if(this.b.info(`Extension signature verification result for ${f}: ${I.code}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${f}:
${I.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:f,code:I.code,duration:g,didExecute:I.didExecute}),I.code==="Success")return!0;throw new E(I.code)}};e.$eq=u,e.$eq=u=$e([oe(0,k.$5j),oe(1,N.$4l)],u)}),define(ne[41],se([0,1,27,3,68,70,22]),function(X,e,D,R,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=void 0,e.$pp=f,e.$qp=b,e.$rp=y,e.$sp=w,e.$tp=I,e.$up=l,e.$vp=c,e.$wp=m;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$ip=E;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$jp=u,e.$kp=new u;class a{async publicLog(r,t,i){}async publicLogError(r,t,i){}}e.$lp=a,e.$mp="telemetry",e.$np="extensionTelemetryLog",e.$op={log:()=>null,flush:()=>Promise.resolve(null)};function f(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function b(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function y(n){const r=n.getValue(A.$_l),t=n.getValue(A.$am);if(n.getValue(A.$bm)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(n){const r={},t={},i={};g(n,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(n){if(!n)return"none";const r=(0,k.$Km)(n);return $.has(r)?r:"other"}function g(n,r,t=0,i){if(n)for(const s of Object.getOwnPropertyNames(n)){const o=n[s],h=i?i+s:s;Array.isArray(o)?r[h]=(0,D.$0n)(o):o instanceof Date?r[h]=o.toISOString():(0,R.$ag)(o)?t<2?g(o,r,t+1,h+"."):r[h]=(0,D.$0n)(o):r[h]=o}}function l(n,r){const t=n.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,N.$hp)(t)||i}function c(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function v(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let t=n;const i=[];for(const S of r)for(;;){const j=S.exec(n);if(!j)break;i.push([j.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(t="";;){const S=o.exec(n);if(!S)break;const j=i.some(([O,z])=>S.index<z&&O<o.lastIndex);!s.test(S[0])&&!j&&(t+=n.substring(h,S.index)+"<REDACTED: user-file-path>",h=o.lastIndex)}return h<n.length&&(t+=n.substr(h)),t}function p(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(n))return`<REDACTED: ${t.label}>`;return n}function m(n,r){return(0,D.$7n)(n,t=>{if(t instanceof E||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let i=t.replaceAll("%20"," ");i=v(i,r);for(const s of r)i=i.replace(s,"");return i=p(i),i}})}}),define(ne[26],se([0,1,31,21,37,12,11,9,35,41]),function(X,e,D,R,k,N,A,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$yp=void 0,e.$xp=f,e.$zp=$,e.$Ap=I,e.$Bp=g,e.$Cp=l,e.$Dp=c,e.$Ep=v,e.$Fp=p,e.$Hp=m,e.$Ip=r;function f(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,D.$uf)(t.id,i.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,s,o)}static parse(i){const s=b.exec(i);return s&&s[1]&&s[2]?new y({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?f(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$yp=y;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(t){const i=w.exec(t);return i&&i[1]?[g(i[1]),i[2]]:[g(t),void 0]}function I(t,i){return`${t}.${i}`}function g(t){return t.toLowerCase()}function l(t,i){return g(I(t??k.$Pm,i))}function c(t,i){const s=[],o=h=>{for(const S of s)if(S.some(j=>f(i(j),i(h))))return S;return null};for(const h of t){const S=o(h);S?S.push(h):s.push([h])}return s}function v(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function p(t){return{id:new a.$ip(t.identifier.id),name:new a.$ip(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Gp=new k.$Tm("pprice.better-merge");function m(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const h=o.shift();if(h&&s.every(S=>!f(S.identifier,{id:h}))){const S=t.filter(j=>f(j.identifier,{id:h}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function n(t,i){if(!N.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,E.$0)(h))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,R.$5o)(s?"alpine":N.$u,u.$ec);return i.debug("ComputeTargetPlatform:",o),o}}),define(ne[146],se([0,1,20,9,15,17,44,11,97,21,26,37]),function(X,e,D,R,k,N,A,E,u,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;const y=I=>(0,u.localize)(0,null,I),w=(0,u.localize)(1,null,"ms-dotnettools.csharp");let $=class{constructor(g,l,c){this.a=g,this.b=l,this.d=c}get f(){}async listExtensions(g,l,c){let v=await this.b.getInstalled(1,c);const p=b.$Sm.map(n=>n.toLowerCase());if(l&&l!==""){if(p.indexOf(l.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(n=>n.manifest.categories?n.manifest.categories.map(t=>t.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.a.info("Possible Categories: "),p.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),v=v.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let m;for(const n of v)m!==n.identifier.id&&(m=n.identifier.id,this.a.info(g?`${m}@${n.manifest.version}`:m))}async installExtensions(g,l,c,v){const p=[];try{g.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const m=[],n=[],r=(i,s,o)=>{n.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...c,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||c.installPreReleaseVersion}})};for(const i of g)if(i instanceof E.URI)m.push({vsix:i,installOptions:c});else{const[s,o]=(0,f.$zp)(i);r(s,o,!1)}for(const i of l)if(i instanceof E.URI)m.push({vsix:i,installOptions:{...c,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,f.$zp)(i);r(s,o,!0)}const t=await this.b.getInstalled(void 0,c.profileLocation);if(m.length&&await Promise.all(m.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,v,t)}catch(o){this.a.error(o),p.push(i.toString())}})),n.length){const i=await this.g(n,t,v);p.push(...i)}}catch(m){throw this.a.error((0,u.localize)(5,null,(0,R.$0)(m))),m}if(p.length)throw new Error((0,u.localize)(6,null,p.join(", ")))}async updateExtensions(g){const l=await this.b.getInstalled(1,g),c=[];for(const n of l)n.identifier.uuid&&c.push({...n.identifier,preRelease:n.preRelease});this.a.trace((0,u.localize)(7,null,c.length));const v=await this.d.getExtensions(c,{compatible:!0},D.CancellationToken.None),p=[];for(const n of v)for(const r of l)(0,f.$xp)(r.identifier,n.identifier)&&(0,A.gt)(n.version,r.manifest.version)&&p.push({extension:n,options:{operation:3,installPreReleaseVersion:r.preRelease,profileLocation:g}});if(!p.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,p.map(n=>n.extension.identifier.id).join(", ")));const m=await this.b.installGalleryExtensions(p);for(const n of m)n.error?this.a.error((0,u.localize)(10,null,n.identifier.id,(0,R.$0)(n.error))):this.a.info((0,u.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async g(g,l,c){if(g=g.filter(({id:n,version:r})=>{const t=l.find(i=>(0,f.$xp)(i.identifier,{id:n}));if(t){if(!c&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,n,t.manifest.version,n)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${n}@${r}`)),!1}return!0}),!g.length)return[];const v=[],p=[],m=await this.j(g);if(await Promise.all(g.map(async({id:n,version:r,installOptions:t})=>{const i=m.get(n.toLowerCase());if(!i){this.a.error(`${y(r?`${n}@${r}`:n)}
${w}`),v.push(n);return}try{const o=await this.d.getManifest(i,D.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),v.push(n);return}const s=l.find(o=>(0,f.$xp)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${n}@${r}`:n));return}this.a.info((0,u.localize)(15,null,n,i.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,n,r):(0,u.localize)(17,null,n)):this.a.info(r?(0,u.localize)(18,null,n,r):(0,u.localize)(19,null,n)),p.push({extension:i,options:{...t,installGivenVersion:!!r}})})),p.length){const n=await this.b.installGalleryExtensions(p);for(const r of n)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,R.$0)(r.error))),v.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return v}async h(g,l,c,v){const p=await this.b.getManifest(g);if(!p)throw new Error("Invalid vsix");if(await this.l(p,c,l.profileLocation,v))try{await this.b.install(g,l),this.a.info((0,u.localize)(22,null,(0,N.$9g)(g)))}catch(n){if((0,R.$4)(n))this.a.info((0,u.localize)(23,null,(0,N.$9g)(g)));else throw n}}async j(g){const l=new Map,c=g.some(m=>m.installOptions.installPreReleaseVersion),v=await this.b.getTargetPlatform(),p=[];for(const m of g)a.$Xo.test(m.id)&&p.push({...m,preRelease:c});if(p.length){const m=await this.d.getExtensions(p,{targetPlatform:v},D.CancellationToken.None);for(const n of m)l.set(n.identifier.id.toLowerCase(),n)}return l}k(g){return!0}async l(g,l,c,v){if(!l){const p={id:(0,f.$Cp)(g.publisher,g.name)},m=v.find(n=>(0,f.$xp)(p,n.identifier)&&(0,A.gt)(n.manifest.version,g.version));if(m)return this.a.info((0,u.localize)(24,null,m.identifier.id,m.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,l,c){const v=async m=>{if(m instanceof E.URI){const n=await this.b.getManifest(m);return(0,f.$Ap)(n.publisher,n.name)}return m},p=[];for(const m of g){const n=await v(m),t=(await this.b.getInstalled(void 0,c)).filter(i=>(0,f.$xp)(i.identifier,{id:n}));if(!t.length)throw new Error(`${this.m(n)}
${w}`);if(t.some(i=>i.type===0)){this.a.info((0,u.localize)(25,null,n));return}if(!l&&t.some(i=>i.isBuiltin)){this.a.info((0,u.localize)(26,null,n));return}this.a.info((0,u.localize)(27,null,n));for(const i of t)await this.b.uninstall(i,{profileLocation:c}),p.push(i);this.f?this.a.info((0,u.localize)(28,null,n,this.f)):this.a.info((0,u.localize)(29,null,n))}}async locateExtension(g){const l=await this.b.getInstalled();g.forEach(c=>{l.forEach(v=>{if(v.identifier.id===c&&v.location.scheme===k.Schemas.file){this.a.info(v.location.fsPath);return}})})}m(g){return this.f?(0,u.localize)(30,null,g,this.f):(0,u.localize)(31,null,g)}};e.$fq=$,e.$fq=$=$e([oe(1,a.$_o),oe(2,a.$9o)],$)}),define(ne[147],se([0,1,8,9,2,15,17,44,3,28,25,49,29,18,21,26,71,13,6]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;let p=class extends k.$Uc{static{v=this}static{this.c=".sigzip"}constructor(n,r,t,i,s,o){super(),this.h=r,this.j=t,this.m=i,this.n=s,this.r=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,r,t){await this.g;const i=(0,A.$_g)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,i,o=>this.j.download(n,o,r))}catch(o){throw new $.$0o(o.message,$.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(n)){const o=await this.u(n);try{s=await this.n.verify(n.identifier.id,i.fsPath,o.fsPath)}catch(h){if(s=h.code,s==="PackageIsInvalidZip"||s==="SignatureArchiveIsInvalidZip"){try{await this.delete(i)}catch(j){this.r.error(j)}throw new $.$0o(b.$jq,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(h){this.r.error(h)}}}return{location:i,verificationStatus:s}}t(n){if(!n.isSigned)return this.r.info(`Extension is not signed: ${n.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$eg)(r)?r:!0}async u(n){await this.g;const r=(0,A.$_g)(this.extensionsDownloadDir,`${this.z(n)}${v.c}`);try{await this.w(n,r,t=>this.j.downloadSignatureArchive(n,t))}catch(t){throw new $.$0o(t.message,$.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(n,r,t){if(await this.h.exists(r))return;if(r.scheme!==N.Schemas.file){await t(r);return}const i=(0,A.$_g)(this.extensionsDownloadDir,`.${(0,a.$Ug)()}`);await this.h.exists(i)||await t(i);try{await f.Promises.rename(i.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const h of n.children)if(h.name.endsWith(v.c))i.push(h.resource);else{const S=I.$yp.parse(h.name);S&&t.push([S,h])}const s=(0,I.$Dp)(t,([h])=>h),o=[];for(const h of s)h.sort((S,j)=>E.rcompare(S[0].version,j[0].version)),r.push(...h.slice(1).map(S=>S[1].resource)),o.push(h[0][1]);o.sort((h,S)=>h.mtime-S.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(h=>h.resource)),r.push(...i),await D.Promises.settled(r.map(h=>(this.r.trace("Deleting from cache",h.path),this.h.del(h))))}}catch(n){this.r.error(n)}}z(n){return this.f?I.$yp.create(n).toString().toLowerCase():(0,a.$Ug)()}};e.$Bq=p,e.$Bq=p=v=$e([oe(0,w.$Gi),oe(1,l.$5k),oe(2,$.$9o),oe(3,y.$5i),oe(4,g.$cq),oe(5,c.$5j)],p)}),define(ne[148],se([0,1,5,2,30,26,37]),function(X,e,D,R,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class E extends R.$Uc{constructor(a,f,b,y,w,$,I){super(),this.f=a,this.g=f,this.h=b,this.j=y,this.m=w,this.n=$,this.r=I,this.a=this.B(new D.$fe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$4c),this.s().then(null,g=>I.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(f=>(this.c.set(f.id,(0,R.$Rc)(this.n.watch(this.m.extUri.dirname(f.extensionsResource)),this.n.watch(f.extensionsResource))),this.G(f.extensionsResource))))}catch(f){throw this.r.error(f),f}}async w(a){for(const f of a.extensions)this.I(this.L(f.identifier,f.version),a.profileLocation)}async y(a){for(const f of a.extensions){const b=this.L(f.identifier,f.version);a.error?this.J(b,a.profileLocation):this.I(b,a.profileLocation)}}async z(a){for(const f of a.extensions)this.J(this.L(f.identifier,f.version),a.profileLocation)}async C(a){const f=[],b=[];for(const y of a.extensions){const w=this.L(y.identifier,y.version);a.error?this.I(w,a.profileLocation):(this.J(w,a.profileLocation),this.b.has(w)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),b.push(this.f.scanInstalledExtensionAtLocation(y.location).then($=>{$?f.push($):this.r.info("Extension not found at the location",y.location.toString())},$=>this.r.error($)))))}try{await Promise.all(b),f.length&&await this.H(f)}catch(y){this.r.error(y)}}D(a){for(const f of this.h.profiles)a.contains(f.extensionsResource,0,1)&&this.F(f.extensionsResource)}async F(a){const f=[],b=[],y=await this.j.scanProfileExtensions(a),w=new Set,$=new Set;for(const[I,g]of this.b)g.has(a)&&$.add(I);for(const I of y){const g=this.L(I.identifier,I.version);w.add(g),$.has(g)||(f.push(I.identifier),this.I(g,a))}for(const I of $)if(!w.has(I)){const g=this.M(I);g&&(b.push(g.identifier),this.J(I,a))}(f.length||b.length)&&this.a.fire({added:f.length?{extensions:f,profileLocation:a}:void 0,removed:b.length?{extensions:b,profileLocation:a}:void 0})}async G(a){const f=await this.j.scanProfileExtensions(a);for(const b of f)this.I(this.L(b.identifier,b.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,f){let b=this.b.get(a);b||this.b.set(a,b=new k.$Bc(y=>this.m.extUri.getComparisonKey(y))),b.add(f)}J(a,f){const b=this.b.get(a);b&&b.delete(f),b?.size||this.b.delete(a)}L(a,f){return`${A.$Tm.toKey(a.id)}@${f}`}M(a){const[f,b]=(0,N.$zp)(a);return b?{identifier:{id:f},version:b}:void 0}}e.$Fq=E}),define(ne[149],se([0,1,119,41]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=k;async function k(N,A,E,u,a,f,b){const y={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,R.$pp)(A,E)&&(0,R.$rp)(u)===3){const w=await(0,D.$0p)(E,a,f);y["X-Market-User-Id"]=w,y["VSCode-SessionId"]=b.machineId||w}return y}}),define(ne[150],se([0,1,176,19,8,2,15,16,25,18,21,26,6,65,11]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0;let I=class extends w.$Vr{constructor(v,p,m,n){super(m),this.h=v,this.j=n,this.g=this.B(new g(p,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(v,p){const n=(await this.g.getLanguagePacks())[p];if(!n){this.j.warn(`No language pack found for ${p}`);return}const r=n.translations[v];return r?$.URI.file(r):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),p=Object.keys(v).map(m=>{const n=v[m];return{...this.f(m,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((m,n)=>m.label.localeCompare(n.label)),p}async m(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",v.identifier.id),await this.update())}async n(v){const p=await this.g.getLanguagePacks();Object.keys(p).some(m=>p[m]&&p[m].extensions.some(n=>(0,b.$xp)(n.extensionIdentifier,v.identifier)))&&(this.j.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),m=await this.g.update(p);return!(0,R.$ub)(Object.keys(v),Object.keys(m))}};e.$Wr=I,e.$Wr=I=$e([oe(0,f.$_o),oe(1,a.$Gi),oe(2,f.$9o),oe(3,y.$5j)],I);let g=class extends N.$Uc{constructor(v,p){super(),this.j=p,this.c={},this.f=(0,E.$jc)(v.userDataPath,"languagepacks.json"),this.g=new k.$Fh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.s(p=>{Object.keys(p).forEach(m=>delete p[m]),this.m(p,...v)}).then(()=>this.c)}m(v,...p){for(const m of p)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.n(v,m);Object.keys(v).forEach(m=>this.r(v[m]))}n(v,p){const m=p.identifier,n=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const r of n)if(p.location.scheme===A.Schemas.file&&l(r)){let t=v[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},v[r.languageId]=t);const i=t.extensions.filter(s=>(0,b.$xp)(s.extensionIdentifier,m))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:m,version:p.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,E.$jc)(p.location.fsPath,s.path)}}r(v){if(v){const p=(0,D.createHash)("md5");for(const m of v.extensions)p.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);v.hash=p.digest("hex")}}s(v=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(p=v(m),m)).then(m=>{for(const r of Object.keys(m))m[r]||delete m[r];this.c=m,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),u.Promises.writeFile(this.f,n)}).then(()=>p,m=>this.j.error(m))})}};g=$e([oe(0,a.$Gi),oe(1,y.$5j)],g);function l(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const v of c.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(ne[151],se([0,1,85,9,27,41]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function u(f,b,y){const w=await(0,D.$$D)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,D.$$D)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new w.AppInsightsCore,g=new $.PostChannel,l={instrumentationKey:f,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(y){l.extensionConfig={};const c={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:y};l.extensionConfig[g.identifier]=c}return I.initialize(l,[]),I.addTelemetryInitializer(c=>{c.ext=c.ext??{},c.ext.web=c.ext.web??{},c.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),I}class a{constructor(b,y,w,$,I){this.e=b,this.f=y,this.g=w,this.h=I,this.c=A,this.d=E,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(y=>{b(y)},y=>{(0,R.$1)(y),console.error(y)})}}log(b,y){if(!this.a)return;y=(0,k.$8n)(y,this.g),y=(0,N.$sp)(y);const w=this.f+"/"+b;try{this.i($=>{$.pluginVersionString=y?.properties.version??"Unknown",$.track({name:w,baseData:{name:w,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$WP=a}),define(ne[152],se([0,1,2,27,12,31,110,29,40,153,32,36,22,41]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,c,v){this.k=c,this.l=v,this.d={},this.i=new D.$Tc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,N.$bf)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$bf)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(y.$_l)||p.affectsConfiguration(y.$bm)||p.affectsConfiguration(y.$am))&&this.m()}))}setExperimentProperty(l,c){this.d[l]=c}m(){let l=(0,w.$rp)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const v=c.usage?3:c.error?2:0;l=Math.min(l,v)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,c,v){this.g<c||(v=(0,R.$8n)(v,this.d),v=(0,w.$wp)(v,this.j),v=(0,R.$8n)(v,this.c),this.b.forEach(p=>p.log(l,v)))}publicLog(l,c){this.n(l,3,c)}publicLog2(l,c){this.publicLog(l,c)}publicLogError(l,c){this.h&&this.n(l,2,c)}publicLogError2(l,c){this.publicLogError(l,c)}};e.$3r=$,e.$3r=$=$e([oe(1,E.$5i),oe(2,f.$lk)],$);function I(){const g=(0,A.localize)(0,null,a.default.nameLong),l=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=k.$o?"":(0,A.localize)(3,null),v=(0,A.localize)(4,null),p=(0,A.localize)(5,null),m=(0,A.localize)(6,null),n=(0,A.localize)(7,null),r=`
|       | ${v} | ${p} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${g} ${l} ${c}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}b.$fo.as(u.$ko.Configuration).registerConfiguration({id:y.$$l,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[y.$_l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:I(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$fo.as(u.$ko.Configuration).registerConfiguration({id:y.$$l,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.$bm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.$_l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[154],se([0,1,14,20,177,151]),function(X,e,D,R,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=void 0;async function A(f,b){const y=await b.request(f,R.CancellationToken.None),w=(await(0,D.$Te)(y.stream)).toString(),$=y.res.statusCode??200;return{headers:y.res.headers,statusCode:$,responseData:w}}async function E(f){const b={method:f.type,headers:f.headers};return new Promise((w,$)=>{const I=k.request(f.url??"",b,g=>{g.on("data",function(l){w({headers:g.headers,statusCode:g.statusCode??200,responseData:l.toString()})}),g.on("error",function(l){$(l)})});I.write(f.data,g=>{g&&$(g)}),I.end()})}async function u(f,b,y){const w=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),$={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:w};try{const I=f?await A($,f):await E($);y(I.statusCode,I.headers,I.responseData)}catch{y(0,{})}}class a extends N.$WP{constructor(b,y,w,$,I){const g={sendPOST:(l,c)=>{u(b,l,c)}};super(y,w,$,I,g)}}e.$XP=a}),define(ne[155],se([0,1,16,25]),function(X,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=k;async function k(N,A){const E=Object.create(null),u=(f,b)=>{const y=JSON.parse(f);E[b]=y};if(A){const f=[],b=await R.Promises.readdir(A);for(const w of b)try{(await R.Promises.stat((0,D.$jc)(A,w))).isDirectory()&&f.push(w)}catch{}const y=[];for(const w of f)(await R.Promises.readdir((0,D.$jc)(A,w))).filter(I=>I==="telemetry.json").length===1&&y.push(w);for(const w of y){const $=(await R.Promises.readFile((0,D.$jc)(A,w,"telemetry.json"))).toString();u($,w)}}let a=(await R.Promises.readFile((0,D.$jc)(N,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await R.Promises.readFile((0,D.$jc)(N,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(E,null,4)}}),define(ne[156],se([0,1,12,86,22]),function(X,e,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=N,e.$Zdc=A;async function N(E,u){let a=E.getItem(k.$9l);return(typeof a!="string"||D.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,R.$Hn)(u.error.bind(u))),a}async function A(E,u){let a=E.getItem(k.$0l);return typeof a!="string"&&(a=await(0,R.$In)(u.error.bind(u))),a}}),define(ne[23],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,D.$yi)("IUriIdentityService")}),define(ne[157],se([0,1,23,120,13,17,77,5,2]),function(X,e,D,R,k,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(y){this.g=y,this.c=new u.$Tc,this.f=2**16;const w=new Map,$=I=>{let g=w.get(I.scheme);return g===void 0&&(g=y.hasProvider(I)&&!this.g.hasCapability(I,1024),w.set(I.scheme,g)),g};this.c.add(E.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(I=>{w.delete(I.scheme)})),this.extUri=new N.$1g($),this.d=new A.$Cs((I,g)=>this.extUri.compare(I,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,N.$ah)(y));const w=this.d.get(y);return w?w.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort(($,I)=>$[1].time<I[1].time?1:$[1].time>I[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let $=0;$<w;$++)this.d.set(y[$][0],y[$][1].touch())}};e.$Ds=f,e.$Ds=f=$e([oe(0,k.$5k)],f),(0,R.$As)(D.$Cl,f,1)}),define(ne[158],se([0,1,5,2,13,48,30]),function(X,e,D,R,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class E extends R.$Uc{constructor(a,f,b,y,w,$){super(),this.f=a,this.g=f,this.h=b,this.j=y,this.m=w,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$fe),this.onDidChangeFile=this.a.event,this.b=N.$Ei.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(I=>this.m.extUri.getComparisonKey(this.t(I))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(I=>this.s(I)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,b,y,w){return this.g.read(a,f,b,y,w)}write(a,f,b,y,w){return this.g.write(a,f,b,y,w)}watch(a,f){this.b.set(a,a);const b=this.g.watch(this.t(a),f);return(0,R.$Sc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,b){return this.g.rename(this.t(a),this.t(f),b)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,b){return this.g.readFileStream(this.t(a),f,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,b){return this.g.writeFile(this.t(a),f,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,b){if((0,k.$9k)(this.g))return this.g.copy(this.t(a),this.t(f),b);throw new Error("copy not supported")}cloneFile(a,f){if((0,k.$0k)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&f.push({resource:y,type:b.type,cId:b.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$kec=E}),define(ne[159],se([0,1,112,16,48,17,11,10,15]),function(X,e,D,R,k,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=a,e.$Ji=f,e.$Mi=b,e.$Ni=y,e.$Oi=w,e.$Pi=I,e.$Qi=g,e.$Ti=v,e.$Yi=p,e.$Zi=m,e.$2i=n,e.$3i=r,e.$4i=t,e.$Hi=(0,E.$yi)("contextService");function a(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function f(i){return typeof i?.id=="string"&&!a(i)&&!y(i)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function b(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:s?e.$Ki:e.$Li;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function y(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function w(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function I(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class l{constructor(s,o,h,S,j){this.h=s,this.j=h,this.k=S,this.l=j,this.c=k.$Ei.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$Ei.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=l;class c{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.$_g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=c;function v(i){return new c({uri:i,index:0,name:(0,N.$8g)(i)},{uri:i.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,D.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function p(i,s){return N.$3g.isEqualOrParent(i,s.untitledWorkspacesHome)}function m(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===u.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.$1i}function r(i,s){return!p(i,s)&&!m(i)}function t(i){return(typeof i=="string"?(0,R.$oc)(i):(0,N.$0g)(i))===e.$Vi}}),define(ne[24],se([0,1,43,5,2,17,11,111,18,13,10,6,159,30,23,8,28,31,3]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=p,e.$Fl=m,e.$Gl=n;var v;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function p(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$El=(0,f.$yi)("IUserDataProfilesService");function m(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function n(i,s,o,h,S,j){return{id:i,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:j&&S?.useDefaultFlags?.globalState?j.globalStorageHome:(0,N.$_g)(o,"globalStorage"),settingsResource:j&&S?.useDefaultFlags?.settings?j.settingsResource:(0,N.$_g)(o,"settings.json"),keybindingsResource:j&&S?.useDefaultFlags?.keybindings?j.keybindingsResource:(0,N.$_g)(o,"keybindings.json"),tasksResource:j&&S?.useDefaultFlags?.tasks?j.tasksResource:(0,N.$_g)(o,"tasks.json"),snippetsHome:j&&S?.useDefaultFlags?.snippets?j.snippetsHome:(0,N.$_g)(o,"snippets"),extensionsResource:j&&S?.useDefaultFlags?.extensions?j.extensionsResource:(0,N.$_g)(o,"extensions.json"),cacheHome:(0,N.$_g)(h,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,h,S){super(),this.t=s,this.u=o,this.w=h,this.y=S,this.f=!0,this.h=this.B(new R.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const j of this.O()){if(!j.name||!(0,c.$$f)(j.name)||!j.location){this.y.warn("Skipping the invalid stored profile",j.location||j.name);continue}o.push(n((0,N.$9g)(j.location),j.name,j.location,this.g,{shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags},s))}}catch(j){this.y.error(j)}const h=new w.$Ac,S=new Map;if(o.length)try{const j=this.Q();if(j.workspaces)for(const[O,z]of Object.entries(j.workspaces)){const C=A.URI.parse(O),T=o.find(J=>J.id===z);T&&h.set(C,T)}if(j.emptyWindows)for(const[O,z]of Object.entries(j.emptyWindows)){const C=o.find(T=>T.id===z);C&&S.set(O,C)}}catch(j){this.y.error(j)}this.z={profiles:o,workspaces:h,emptyWindows:S}}return this.z}D(){const s=n("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",h=new RegExp(`${(0,l.$bf)(o)}\\s(\\d+)`);let S=0;for(const O of this.profiles){const z=h.exec(O.name),C=z?parseInt(z[1]):0;S=C>S?C:S}const j=`${o} ${S+1}`;return this.createProfile((0,D.$mj)((0,g.$Ug)()).toString(16),j,{transient:!0},s)}async createNamedProfile(s,o,h){return this.createProfile((0,D.$mj)((0,g.$Ug)()).toString(16),s,o,h)}async createProfile(s,o,h,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const j=await this.F(s,o,h);return S&&await this.setProfileForWorkspace(S,j),j}async F(s,o,h){if(!(0,c.$$f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{if(this.profiles.find(C=>C.name===o||C.id===s))throw new Error(`Profile with ${o} name already exists`);const O=n(s,o,(0,N.$_g)(this.profilesHome,s),this.g,h,this.defaultProfile);await this.u.createFolder(O.location);const z=[];return this.j.fire({profile:O,join(C){z.push(C)}}),await I.Promises.settled(z),this.I([O],[],[]),O}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(S=>S.id===s.id);if(!h)throw new Error(`Profile '${s.name}' does not exist`);return h=n(h.id,o.name??h.name,h.location,this.g,{shortName:o.shortName??h.shortName,icon:o.icon===null?void 0:o.icon??h.icon,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const h=[];this.m.fire({profile:o,join(S){h.push(S)}});try{await Promise.allSettled(h)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.$jl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(S=>S.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,h)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,y.$Ii)(s)?s.uri:(0,y.$Ni)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,h){const S=[...this.profiles,...s],j=[];this.s.profiles=[];for(let O of S)O.isDefault||o.some(z=>O.id===z.id)||(O=h.find(z=>O.id===z.id)??O,O.isTransient?this.s.profiles.push(O):j.push({location:O.location,name:O.name,shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags}));this.P(j),this.z=void 0,this.J(s,o,h)}J(s,o,h){this.h.fire({added:s,removed:o,updated:h,all:this.profiles})}L(s,o,h){h=o?.isTransient?!0:h,h||this.L(s,void 0,!0);const S=this.G(s),j=h?this.s:this.C;A.URI.isUri(S)?(j.workspaces.delete(S),o&&j.workspaces.set(S,o)):(j.emptyWindows.delete(S),o&&j.emptyWindows.set(S,o)),h||this.M()}M(){const s={};for(const[h,S]of this.C.workspaces.entries())s[h.toString()]=S.id;const o={};for(const[h,S]of this.C.emptyWindows.entries())o[h.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},h=this.D();if(s.workspaces)for(const[j,O]of Object.entries(s.workspaces)){const z=A.URI.parse(O);o[j]=this.w.extUri.isEqual(z,h.location)?h.id:this.w.extUri.basename(z)}const S={};if(s.emptyWindows)for(const[j,O]of Object.entries(s.emptyWindows)){const z=A.URI.parse(O);S[j]=this.w.extUri.isEqual(z,h.location)?h.id:this.w.extUri.basename(z)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Hl=r,e.$Hl=r=$e([oe(0,u.$Fi),oe(1,a.$5k),oe(2,$.$Cl),oe(3,b.$5j)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Il=t}),define(ne[160],se([0,1,19,8,20,9,5,2,12,3,11,95,21,26,37,6,32,22,23,24]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$oq=void 0,e.$pq=m;let p=class extends E.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,s,o,h,S,j){super(),this.z=i,this.C=s,this.D=o,this.F=h,this.G=S,this.H=j,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$fe),this.s=this.B(new A.$fe),this.t=this.B(new A.$fe),this.u=this.B(new A.$fe),this.w=this.B(new A.$fe),this.y=[],this.B((0,E.$Sc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,y.$7o)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const h=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:S})=>(0,w.$xp)(S,i.identifier));if(h?.local)return h?.local;throw h?.error?h.error:new y.$0o(`Unknown error while installing extension ${i.identifier.id}`,y.ExtensionManagementErrorCode.Unknown)}catch(o){throw m(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new y.$0o(b.localize(0,null),y.ExtensionManagementErrorCode.NotAllowed);const s=[],o=[];return await Promise.allSettled(i.map(async({extension:h,options:S})=>{try{const j=await this.N(h,!!S?.installGivenVersion,!!S?.installPreReleaseVersion,S.productVersion??{version:this.G.version,date:this.G.date});o.push({...j,options:S})}catch(j){s.push({identifier:h.identifier,operation:2,source:h,error:j})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(i,s={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,s)}async toggleAppliationScope(i,s){if((0,$.$Wm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,s));for(const h of this.H.profiles){const S=(await this.getInstalled(1,h.extensionsResource)).find(j=>(0,w.$xp)(j.identifier,i.identifier));S?this.w.fire(S):this.u.fire({identifier:i.identifier,profileLocation:h.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const s=new Map,o=new Map,h=[],S=(O,z)=>`${w.$yp.create(O).toString()}-${z.toString()}`,j=(O,z,C,T)=>{const J=this.Y(O,z,C),re=`${(0,w.$Cp)(O.publisher,O.name)}-${C.profileLocation.toString()}`;o.set(re,{task:J,root:T}),this.n.fire({identifier:J.identifier,source:z,profileLocation:C.profileLocation}),this.F.info("Installing extension:",J.identifier.id),f.URI.isUri(z)||this.j.set(S(z,C.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:O,extension:z,options:C}of i){const T=C.isApplicationScoped||C.isBuiltin||(0,$.$Wm)(O),J={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!f.URI.isUri(z),isApplicationScoped:T,profileLocation:T?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},re=f.URI.isUri(z)?void 0:this.j.get(S(z,J.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id),h.push(re.task.waitUntilTaskIsFinished())):j(O,z,J,void 0)}return await Promise.all([...o.values()].map(async({task:O})=>{if(O.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const z=await this.M(O.identifier,O.manifest,!!O.options.installOnlyNewlyAddedFromExtensionPack,!!O.options.installPreReleaseVersion,O.options.profileLocation,O.options.productVersion),C=await this.getInstalled(void 0,O.options.profileLocation,O.options.productVersion),T={...O.options,context:{...O.options.context,[y.$2o]:!0}};for(const{gallery:J,manifest:re}of(0,D.$Mb)(z,({gallery:ie})=>ie.identifier.id)){if(o.has(`${J.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`))continue;const ie=this.j.get(S(J,T.profileLocation));if(ie){if(this.J(O,ie.task)){const he=ie.task.identifier;this.F.info("Waiting for already requested installing extension",he.id,O.identifier.id),ie.waitingTasks.push(O),h.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,le=>le.some(ce=>(0,w.$xp)(ce.identifier,he)))).then(le=>{if(this.F.info("Finished waiting for already requested installing extension",he.id,O.identifier.id),!le.find(B=>(0,w.$xp)(B.identifier,he))?.local)throw new Error(`Extension ${he.id} is not installed`)}))}}else C.some(({identifier:he})=>(0,w.$xp)(he,J.identifier))||j(re,J,T,O)}}catch(z){if(f.URI.isUri(O.source))(0,D.$Lb)(O.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",O.identifier.id,z.message),(0,D.$Lb)(O.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",O.identifier.id,z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),z}})),await this.L([...o.entries()].map(async([O,{task:z}])=>{const C=new Date().getTime();try{const T=await z.run();if(await this.L(this.y.map(J=>J.postInstall(T,z.source,z.options,k.CancellationToken.None))),!f.URI.isUri(z.source)){const J=z.operation===3,re=J?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(n(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Fp)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:re}),u.$o&&z.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}s.set(O,{local:T,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){const J=m(T);throw f.URI.isUri(z.source)||n(this.C,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Fp)(z.source),error:J}),s.set(O,{error:J,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:z.options.isApplicationScoped}),this.F.error("Error while installing the extension",z.identifier.id,(0,N.$0)(J)),J}})),h.length&&await this.L(h),[...s.values()]}catch(O){const z=(J,re,ie)=>{const he=[];J.manifest.extensionDependencies?.length&&he.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&he.push(...J.manifest.extensionPack);for(const le of he){if(ie.includes(le.toLowerCase()))continue;ie.push(le.toLowerCase());const ce=s.get(`${le.toLowerCase()}-${re.toString()}`);ce?.local&&(ie=z(ce.local,re,ie))}return ie},C=J=>({identifier:J.identifier,operation:2,source:J.source,context:J.options.context,profileLocation:J.profileLocation,error:O}),T=[];for(const[J,{task:re,root:ie}]of o){const he=s.get(J);he?he.local&&ie&&!s.get(`${ie.identifier.id.toLowerCase()}-${re.profileLocation.toString()}`)?.local&&(T.push(this.Z(he.local,{versionOnly:!0,profileLocation:re.profileLocation})),s.set(J,C(re))):(re.cancel(),s.set(J,C(re)))}for(const[J,{task:re}]of o){const ie=s.get(J);if(!ie?.local||re.options.donotIncludePackAndDependencies)continue;z(ie.local,re.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(le=>o.has(`${le.toLowerCase()}-${re.profileLocation.toString()}`)&&!s.get(`${le.toLowerCase()}-${re.profileLocation.toString()}`)?.local)&&(T.push(this.Z(ie.local,{versionOnly:!0,profileLocation:re.profileLocation})),s.set(J,C(re)))}throw T.length&&await Promise.allSettled(T.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(re){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,N.$0)(re))}})),O}finally{for(const{task:O}of o.values())O.source&&!f.URI.isUri(O.source)&&this.j.delete(S(O.source,O.profileLocation));if(s.size){const O=[...s.values()];for(const z of O)z.local&&this.F.info("Extension installed successfully:",z.identifier.id);this.s.fire(O)}}}J(i,s){for(const[,{task:o,waitingTasks:h}]of this.j.entries())if(o===i&&(h.includes(s)||h.some(S=>this.J(S,s)))||o===s&&h[0]&&!this.J(i,h[0]))return!1;return!0}async L(i){const s=[],o=[],h=await Promise.allSettled(i);for(const S of h)S.status==="fulfilled"?s.push(S.value):o.push(S.reason);if(o.length){if(o.length===1)throw o[0];let S=new y.$0o("",y.ExtensionManagementErrorCode.Unknown);for(const j of o){const O=j instanceof y.$0o?j.code:y.ExtensionManagementErrorCode.Unknown;S=new y.$0o(j.message?`${j.message}, ${S.message}`:S.message,O!==y.ExtensionManagementErrorCode.Unknown&&O!==y.ExtensionManagementErrorCode.Internal?O:S.code)}throw S}return s}async M(i,s,o,h,S,j){if(!this.z.isEnabled())return[];const O=await this.getInstalled(void 0,S,j),z=[],C=[],T=async(J,re)=>{z.push(J);const ie=re.extensionDependencies||[],he=[...ie];if(re.extensionPack){const le=o?O.find(ce=>(0,w.$xp)(ce.identifier,J)):void 0;for(const ce of re.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(B=>(0,w.$xp)({id:B},{id:ce}))||he.every(B=>!(0,w.$xp)({id:B},{id:ce}))&&he.push(ce)}if(he.length){const le=he.filter(ce=>z.every(B=>!(0,w.$xp)(B,{id:ce})));if(le.length){const ce=await this.z.getExtensions(le.map(B=>({id:B,preRelease:h})),k.CancellationToken.None);for(const B of ce){if(z.find(q=>(0,w.$xp)(q,B.identifier)))continue;const Y=ie.some(q=>(0,w.$xp)({id:q},B.identifier));let V;try{V=await this.N(B,!1,h,j)}catch(q){if(Y)throw q;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,N.$0)(q));continue}C.push({gallery:V.extension,manifest:V.manifest}),await T(V.extension.identifier,V.manifest)}}}};return await T(i,s),C}async N(i,s,o,h){let S;const j=await this.getExtensionsControlManifest();if(j.malicious.some(C=>(0,w.$xp)(i.identifier,C)))throw new y.$0o(b.localize(1,null,i.identifier.id),y.ExtensionManagementErrorCode.Malicious);const O=j.deprecated[i.identifier.id.toLowerCase()];if(O?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${O.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:O.extension.id,preRelease:O.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:h},k.CancellationToken.None))[0],!S)throw new y.$0o(b.localize(2,null,i.identifier.id,O.extension.id),y.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const C=await this.getTargetPlatform();throw new y.$0o(b.localize(3,null,i.identifier.id,this.G.nameLong,(0,y.$3o)(C)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.O(i,s,o,h),!S)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],k.CancellationToken.None))[0]?new y.$0o(b.localize(4,null,i.displayName??i.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.$0o(b.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),y.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",S.identifier.id);const z=await this.z.getManifest(S,k.CancellationToken.None);if(z===null)throw new y.$0o(`Missing manifest for extension ${S.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(z.version!==S.version)throw new y.$0o(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:z}}async O(i,s,o,h){const S=await this.getTargetPlatform();let j=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(j=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:S,compatible:!0,productVersion:h},k.CancellationToken.None))[0]||null),!j&&await this.z.isExtensionCompatible(i,o,S,h)&&(j=i),j||(s?j=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:S,compatible:!0,productVersion:h},k.CancellationToken.None))[0]||null:j=await this.z.getCompatibleExtension(i,o,S,h)),j}async P(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},h=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,S=this.m.get(h(i.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),S.waitUntilTaskIsFinished();const j=T=>{const J=this.Z(T,o);return this.m.set(h(J.extension.identifier),J),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),J},O=(T,J)=>{J?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,J.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Ep)(T),error:J}),this.u.fire({identifier:T.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},z=[],C=[];try{z.push(j(i));const T=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const J=this.S(i,T);for(const re of J)this.m.has(h(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):z.push(j(re))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(z.map(J=>J.extension),T,i),await this.L(z.map(async J=>{try{if(await J.run(),await this.L(this.y.map(re=>re.postUninstall(J.extension,o,k.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}O(J.extension)}catch(re){const ie=m(re);throw O(J.extension,ie),ie}finally{C.push(J)}}))}catch(T){const J=m(T);for(const re of z){try{re.cancel()}catch{}C.includes(re)||O(re.extension,J)}throw J}finally{for(const T of z)this.m.delete(h(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(i,s,o){for(const h of i){const S=this.U(h,s);if(S.length){const j=S.filter(O=>!i.some(z=>(0,w.$xp)(z.identifier,O.identifier)));if(j.length)throw new Error(this.R(h,j,o))}}}R(i,s,o){return o===i?s.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const h=i.manifest.extensionPack?i.manifest.extensionPack:[];if(h.length){const S=s.filter(O=>!O.isBuiltin&&h.some(z=>(0,w.$xp)({id:z},O.identifier))),j=[];for(const O of S)j.push(...this.S(O,s,o));return[...S,...j]}return[]}U(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(h=>(0,w.$xp)({id:h},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,N.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$oq=p,e.$oq=p=$e([oe(0,y.$9o),oe(1,l.$4l),oe(2,c.$Cl),oe(3,I.$5j),oe(4,g.$lk),oe(5,v.$El)],p);function m(t){if(t instanceof y.$0o)return t;if(t instanceof y.$$o){const s=new y.$0o(t.message,y.ExtensionManagementErrorCode.Gallery);return s.stack=t.stack,s}const i=new y.$0o(t.message,(0,N.$4)(t)?y.ExtensionManagementErrorCode.Cancelled:y.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:o,duration:h,error:S,durationSinceUpdate:j}){let O,z;(0,a.$gg)(o)&&(o===!0?o="Verified":(o===!1||(O=y.ExtensionManagementErrorCode.Signature,z=o),o="Unverified")),S&&(O=S.code,S.code===y.ExtensionManagementErrorCode.Signature&&(z=S.message)),t.publicLog(i,{...s,verificationStatus:o,success:!S,duration:h,errorcode:O,errorcodeDetail:z,durationSinceUpdate:j})}class r{constructor(){this.d=new R.$xh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,R.$lh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$lh)(i=>new Promise((s,o)=>{const h=i.onCancellationRequested(()=>{h.dispose(),o(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$qq=r}),define(ne[42],se([0,1,8,14,2,5,30,11,21,26,13,10,6,24,23,3,9,22]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class v extends Error{constructor(t,i){super(t),this.code=i}}e.$rq=v,e.$sq=(0,b.$yi)("IExtensionsProfileScannerService");let p=class extends k.$Uc{constructor(t,i,s,o,h,S){super(),this.j=t,this.m=i,this.n=s,this.r=o,this.s=h,this.t=S,this.b=this.B(new N.$fe),this.onAddExtensions=this.b.event,this.c=this.B(new N.$fe),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$fe),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$fe),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i,s){const o=[],h=[];try{return await this.u(i,S=>{const j=[];if(s)j.push(...S);else for(const O of S)t.some(([z])=>(0,a.$xp)(z.identifier,O.identifier)&&z.manifest.version!==O.version)?o.push(O):j.push(O);for(const[O,z]of t){const C=j.findIndex(J=>(0,a.$xp)(J.identifier,O.identifier)&&J.version===O.manifest.version),T={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:z};C===-1?(h.push(T),j.push(T)):j.splice(C,1,T)}return h.length&&this.b.fire({extensions:h,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),j}),h.length&&this.c.fire({extensions:h,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),h}catch(S){throw h.length&&this.c.fire({extensions:h,error:S,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:i}),S}}async updateMetadata(t,i){const s=[];return await this.u(i,o=>{const h=[];for(const S of o){const j=t.find(([O])=>(0,a.$xp)(O.identifier,S.identifier)&&O.manifest.version===S.version);j&&(S.metadata={...S.metadata,...j[1]},s.push(S)),h.push(S)}return h}),s}async removeExtensionFromProfile(t,i){const s=[];try{await this.u(i,o=>{const h=[];for(const S of o)(0,a.$xp)(S.identifier,t.identifier)?s.push(S):h.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:i}),h}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(t,i,s){return this.F(t).queue(async()=>{let o=[],h;try{const S=await this.m.readFile(t);h=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,f.$jl)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&s?.bailOutWhenFileNotFound)throw new v((0,g.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.w(t);let S=!1;for(const j of h){m(j)||this.w(t);let O;if((0,I.$$f)(j.relativeLocation)&&j.relativeLocation)O=this.z(j.relativeLocation);else if((0,I.$$f)(j.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${j.location}`);continue}else{O=E.URI.revive(j.location);const z=this.y(O);z&&(S=!0,j.relativeLocation=z)}(0,I.$fg)(j.metadata?.hasPreReleaseVersion)&&j.metadata?.preRelease&&(S=!0,j.metadata.hasPreReleaseVersion=!0),o.push({identifier:j.identifier,location:O,version:j.version,metadata:j.metadata})}S&&await this.m.writeFile(t,R.$He.fromString(JSON.stringify(h)))}if(i){o=i(o);const S=o.map(j=>({identifier:j.identifier,version:j.version,location:j.location.toJSON(),relativeLocation:this.y(j.location),metadata:j.metadata}));await this.m.writeFile(t,R.$He.fromString(JSON.stringify(S)))}return o})}w(t){const i=new v(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(h){if((0,f.$jl)(h)===1)return;throw h}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const h=JSON.parse(s);Array.isArray(h)&&h.every(S=>m(S))?o=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$He.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,f.$jl)(h)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(t)}catch(h){(0,f.$jl)(h)!==1&&this.t.error(h)}try{await this.m.del(i)}catch(h){(0,f.$jl)(h)!==1&&this.t.error(h)}return o})()),this.C}F(t){let i=this.h.get(t);return i||(i=new D.$Fh,this.h.set(t,i)),i}};e.$tq=p,e.$tq=p=$e([oe(1,f.$5k),oe(2,w.$El),oe(3,$.$Cl),oe(4,l.$4l),oe(5,y.$5j)],p);function m(r){return(0,I.$ag)(r)&&(0,u.$8o)(r.identifier)&&(n(r.location)||(0,I.$$f)(r.location)&&r.location)&&((0,I.$fg)(r.relativeLocation)||(0,I.$$f)(r.relativeLocation))&&r.version&&(0,I.$$f)(r.version)}function n(r){return r?(0,I.$$f)(r.path)&&(0,I.$$f)(r.scheme):!1}}),define(ne[53],se([0,1,19,8,27,14,9,38,83,2,15,16,12,17,44,55,3,11,99,18,26,37,50,13,10,6,32,5,47,42,24,23,117]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c,v,p,m,n,r,t,i,s,o,h,S,j,O,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$yq=e.$xq=e.$wq=e.Translations=void 0,e.$zq=he;var C;(function(ce){function B(Y,V){if(Y===V)return!0;const q=Object.keys(Y),H=new Set;for(const Z of Object.keys(V))H.add(Z);if(q.length!==H.size)return!1;for(const Z of q){if(Y[Z]!==V[Z])return!1;H.delete(Z)}return H.size===0}ce.equals=B})(C||(e.Translations=C={})),e.$wq=(0,t.$yi)("IExtensionsScannerService");let T=class extends a.$Uc{constructor(B,Y,V,q,H,Z,Q,_,U,F,d,P){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Y,this.r=V,this.s=q,this.t=H,this.u=Z,this.w=Q,this.y=_,this.z=U,this.C=F,this.D=d,this.F=P,this.g=this.B(new o.$fe),this.onDidChangeCache=this.g.event,this.h=(0,w.$_g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Ip)(this.w,this.y)),this.G}async scanAllExtensions(B,Y,V){const[q,H]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Y)]),Z=V?await this.scanExtensionsUnderDevelopment(B,[...q,...H]):[];return this.L(q,H,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Y=[];Y.push(this.M(!!B.useCache,B.language)),Y.push(this.N(B.language,!!B.checkControlFile));const[V,q]=await Promise.all(Y);return this.J([...V,...q],0,B,!1)}async scanUserExtensions(B){const Y=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const V=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(Y,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,V,B.productVersion??this.R()),H=B.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let Z;try{Z=await H.scanExtensions(q)}catch(Q){if(Q instanceof S.$rq&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Z=await H.scanExtensions(q);else throw Q}return Z=await this.J(Z,1,B,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(B,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===f.Schemas.file).map(async q=>{const H=await this.P(q,!1,1,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(Q=>(Q.type=Y.find(_=>(0,p.$xp)(_.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,H)))}))).flat();return this.J(V,"development",B,!0)}return[]}async scanExistingExtension(B,Y,V){const q=await this.P(B,!1,Y,!0,V.language,!0,void 0,V.productVersion??this.R()),H=await this.n.scanExtension(q);return!H||!V.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(B,Y,V){const q=await this.P(B,!1,Y,!0,V.language,!0,void 0,V.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(q);return this.J(H,Y,V,!0)}async scanMultipleExtensions(B,Y,V){const q=[];return await Promise.all(B.map(async H=>{const Z=await this.scanOneOrMultipleExtensions(H,Y,V);q.push(...Z)})),this.J(q,Y,V,!0)}async scanMetadata(B){const Y=(0,w.$_g)(B,"package.json"),V=(await this.w.readFile(Y)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(B,Y){const V=(0,w.$_g)(B,"package.json"),q=(await this.w.readFile(V)).value.toString(),H=JSON.parse(q);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,H.__metadata={...H.__metadata,...Y},await this.w.writeFile((0,w.$_g)(B,"package.json"),N.$He.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof S.$rq&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$He.fromString(JSON.stringify([])))}catch(Y){(0,r.$jl)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,Y,V,q){return V.includeAllVersions||(B=this.L(Y===0?B:void 0,Y===1?B:void 0,Y==="development"?B:void 0,await this.getTargetPlatform(),q)),V.includeInvalid||(B=B.filter(H=>H.isValid)),B.sort((H,Z)=>{const Q=b.$nc(H.location.fsPath),_=b.$nc(Z.location.fsPath);return Q<_?-1:Q>_?1:0})}L(B,Y,V,q,H){const Z=(_,U,F)=>{if(_.isValid&&!U.isValid)return!1;if(_.isValid===U.isValid){if(H&&$.gt(_.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if($.eq(_.manifest.version,U.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===q)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${_.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${U.location.path}.`),!0},Q=new m.$Vm;return B?.forEach(_=>{const U=Q.get(_.identifier.id);(!U||Z(U,_,!1))&&Q.set(_.identifier.id,_)}),Y?.forEach(_=>{const U=Q.get(_.identifier.id);if(!U&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!U||Z(U,_,!1))&&Q.set(_.identifier.id,_)}),V?.forEach(_=>{const U=Q.get(_.identifier.id);(!U||Z(U,_,!0))&&Q.set(_.identifier.id,_),Q.set(_.identifier.id,_)}),[...Q.values()]}async M(B,Y){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0,this.R()),H=await(B&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",H.length),H}async N(B,Y){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const q=Y?await this.O():{},H=[],Z=l.URI.file(b.$hc(b.$jc(f.$Sg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of V){const U=q[_.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":H.push((0,w.$_g)(Z,_.name));break;default:H.push(l.URI.file(U));break}}const Q=await Promise.all(H.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,D.$Hb)(Q)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,Y,V,q,H,Z,Q,_){const U=await this.f(H??y.$w),F=await this.Q(B),d=Y&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=d?await this.Q(d):void 0;return new J(B,F,d,P,Y,Q,V,q,Z,_.version,_.date,this.C.commit,!this.z.isBuilt,H,U)}async Q(B){try{const Y=await this.w.stat(B);if(typeof Y.mtime=="number")return Y.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$xq=T,e.$xq=T=$e([oe(4,j.$El),oe(5,S.$sq),oe(6,r.$5k),oe(7,i.$5j),oe(8,v.$Fi),oe(9,s.$lk),oe(10,O.$Cl),oe(11,t.$xi)],T);class J{constructor(B,Y,V,q,H,Z,Q,_,U,F,d,P,L,M,G){this.location=B,this.mtime=Y,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=q,this.profile=H,this.profileScanOptions=Z,this.type=Q,this.excludeObsolete=_,this.validate=U,this.productVersion=F,this.productDate=d,this.productCommit=P,this.devMode=L,this.language=M,this.translations=G}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Y){return(0,w.$5g)(B.location,Y.location)&&B.mtime===Y.mtime&&(0,w.$5g)(B.applicationExtensionslocation,Y.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&B.profile===Y.profile&&k.$9n(B.profileScanOptions,Y.profileScanOptions)&&B.type===Y.type&&B.excludeObsolete===Y.excludeObsolete&&B.validate===Y.validate&&B.productVersion===Y.productVersion&&B.productDate===Y.productDate&&B.productCommit===Y.productCommit&&B.devMode===Y.devMode&&B.language===Y.language&&C.equals(B.translations,Y.translations)}}e.$yq=J;let re=class extends a.$Uc{constructor(B,Y,V,q,H){super(),this.f=B,this.g=Y,this.h=V,this.j=q,this.m=H}async scanExtensions(B){const Y=B.profile?await this.r(B):await this.n(B);let V={};if(B.excludeObsolete&&B.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(q)}catch{}return(0,g.$lg)(V)?Y:Y.filter(q=>!V[p.$yp.create(q).toString()])}async n(B){const Y=await this.j.resolve(B.location);if(!Y.children?.length)return[];const V=await Promise.all(Y.children.map(async q=>{if(!q.isDirectory||B.type===1&&(0,w.$9g)(q.resource).indexOf(".")===0)return null;const H=new J(q.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(H)}));return(0,D.$Hb)(V).sort((q,H)=>q.location.path<H.location.path?-1:1)}async r(B){let Y=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){Y=Y.filter(q=>!q.metadata?.isApplicationScoped);const V=await this.s(B.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,B);Y.push(...V)}return Y}async s(B,Y,V){const q=await this.g.scanProfileExtensions(B,V.profileScanOptions);if(!q.length)return[];const H=await Promise.all(q.map(async Z=>{if(Y(Z)){const Q=new J(Z.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(Q,Z.metadata)}return null}));return(0,D.$Hb)(H)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,w.$_g)(B.location,"package.json"))){const Y=await this.scanExtension(B);return Y?[Y]:[]}else return await this.scanExtensions(B)}catch(Y){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,A.$0)(Y)),[]}}async scanExtension(B,Y){try{let V=await this.scanExtensionManifest(B.location);if(V){V.publisher||(V.publisher=m.$Pm),Y=Y??V.__metadata,delete V.__metadata;const q=(0,p.$Cp)(V.publisher,V.name),H=Y?.id?{id:q,uuid:Y.id}:{id:q},Z=Y?.isSystem?0:B.type,Q=Z===0||!!Y?.isBuiltin;V=await this.t(B.location,V,J.createNlsConfiguration(B));const _={type:Z,identifier:H,manifest:V,location:B.location,isBuiltin:Q,targetPlatform:Y?.targetPlatform??"undefined",publisherDisplayName:Y?.publisherDisplayName,metadata:Y,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(V){B.type!==0&&this.m.error(V)}return null}validate(B,Y){let V=!0;const q=(0,n.$Np)(Y.productVersion,Y.productDate,Y.location,B.manifest,B.isBuiltin);for(const[H,Z]of q)H===I.default.Error&&(V=!1,this.m.error(this.z(Y.location,Z)));return B.isValid=V,B.validations=q,B}async scanExtensionManifest(B){const Y=(0,w.$_g)(B,"package.json");let V;try{V=(await this.j.readFile(Y)).value.toString()}catch(H){return(0,r.$jl)(H)!==1&&this.m.error(this.z(B,(0,c.localize)(0,null,Y.path,H.message))),null}let q;try{q=JSON.parse(V)}catch{const Z=[];(0,E.$Ln)(V,Z);for(const Q of Z)this.m.error(this.z(B,(0,c.localize)(1,null,Y.path,Q.offset,Q.length,(0,u.$uq)(Q.error))));return null}return(0,E.$Un)(q)!=="object"?(this.m.error(this.z(B,(0,c.localize)(2,null,Y.path))),null):q}async t(B,Y,V){const q=await this.u(B,Y,V);if(q)try{const H=[],Z=await this.w(q.default,H);if(H.length>0)return H.forEach(_=>{this.m.error(this.z(B,(0,c.localize)(3,null,q.default?.path,(0,u.$uq)(_.error))))}),Y;if((0,E.$Un)(q)!=="object")return this.m.error(this.z(B,(0,c.localize)(4,null,q.default?.path))),Y;const Q=q.values||Object.create(null);return(0,z.$vq)(this.m,Y,Q,Z)}catch{}return Y}async u(B,Y,V){const q=(0,w.$_g)(B,"package.nls.json"),H=(U,F)=>{F.forEach(d=>{this.m.error(this.z(B,(0,c.localize)(5,null,U?.path,(0,u.$uq)(d.error))))})},Z=U=>{this.m.error(this.z(B,(0,c.localize)(6,null,U?.path)))},Q=`${Y.publisher}.${Y.name}`,_=V.translations[Q];if(_)try{const U=l.URI.file(_),F=(await this.j.readFile(U)).value.toString(),d=[],P=(0,E.$Ln)(F,d);return d.length>0?(H(U,d),{values:void 0,default:q}):(0,E.$Un)(P)!=="object"?(Z(U),{values:void 0,default:q}):{values:P.contents?P.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let F;try{F=await this.y(B,V)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const d=(await this.j.readFile(F.localized)).value.toString(),P=[],L=(0,E.$Ln)(d,P);return P.length>0?(H(F.localized,P),{values:void 0,default:F.original}):(0,E.$Un)(L)!=="object"?(Z(F.localized),{values:void 0,default:F.original}):{values:L,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,Y){if(B)try{const V=(await this.j.readFile(B)).value.toString();return(0,E.$Ln)(V,Y)}catch{}}y(B,Y){return new Promise((V,q)=>{const H=Z=>{const Q=(0,w.$_g)(B,`package.nls.${Z}.json`);this.j.exists(Q).then(_=>{_&&V({localized:Q,original:(0,w.$_g)(B,"package.nls.json")});const U=Z.lastIndexOf("-");U===-1?V({localized:(0,w.$_g)(B,"package.nls.json"),original:null}):(Z=Z.substring(0,U),H(Z))})};if(Y.devMode||Y.pseudo||!Y.language)return V({localized:(0,w.$_g)(B,"package.nls.json"),original:null});H(Y.language)})}z(B,Y){return`[${B.path}]: ${Y}`}};re=$e([oe(1,S.$sq),oe(2,O.$Cl),oe(3,r.$5k),oe(4,i.$5j)],re);let ie=class extends re{constructor(B,Y,V,q,H,Z,Q){super(Y,q,H,Z,Q),this.G=B,this.H=V,this.D=this.B(new R.$wh(3e3)),this.F=this.B(new o.$fe),this.onDidChangeCache=this.F.event}async scanExtensions(B){const Y=this.M(B),V=await this.I(Y);if(this.C=B,V&&V.input&&J.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),V.result.map(H=>(H.location=l.URI.revive(H.location),H));const q=await super.scanExtensions(B);return await this.J(Y,{input:B,result:q}),q}async I(B){try{const Y=await this.j.readFile(B),V=JSON.parse(Y.value.toString());return{result:V.result,input:(0,h.$8h)(V.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",B.path,(0,A.$0)(Y))}return null}async J(B,Y){try{await this.j.writeFile(B,N.$He.fromString(JSON.stringify(Y)))}catch(V){this.m.debug("Error while writing the extension cache file:",B.path,(0,A.$0)(V))}}async L(){if(!this.C)return;const B=this.M(this.C),Y=await this.I(B);if(!Y)return;const V=Y.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$9n(q,V))try{this.m.info("Invalidating Cache",V,q),await this.j.del(B),this.F.fire()}catch(H){this.m.error(H)}}M(B){const Y=this.N(B);return this.h.extUri.joinPath(Y.cacheHome,B.type===0?m.$Om:m.$Nm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(B.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,j.$El),oe(3,S.$sq),oe(4,O.$Cl),oe(5,r.$5k),oe(6,i.$5j)],ie);function he(ce,B){const Y=(0,p.$Ap)(ce.manifest.publisher,ce.manifest.name);return{id:Y,identifier:new m.$Tm(Y),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:B,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class le extends T{constructor(B,Y,V,q,H,Z,Q,_,U,F,d,P){super(B,Y,(0,w.$_g)(V,".vscode-oss-dev","extensions","control.json"),q,H,Z,Q,_,U,F,d,P),this.S=(async()=>{if(y.$z)try{const L=await this.w.readFile(l.URI.file(y.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$Aq=le}),define(ne[161],se([0,1,59,8,34,5,2,15,16,25,6,24]),function(X,e,D,R,k,N,A,E,u,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let y=class extends A.$Uc{constructor($,I){super(),this.b=$,this.f=I,this.a=new R.$Eh(5)}async postUninstall($){const I=this.g($,"uninstall");I&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(I.script,"uninstall",I.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(g)}}));try{await a.Promises.rm(this.m($))}catch(g){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(g)}}g($,I){const g=`vscode:${I}`;if($.location.scheme===E.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[g]=="string"){const l=$.manifest.scripts[g].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn($.identifier.id,$.manifest.version,`${g} should be a node script`),null):{script:(0,u.$jc)($.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h($,I,g,l,c){return new Promise((v,p)=>{const m=this.j($,I,g,c);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?p(t):v(void 0)};m.on("error",t=>{r((0,k.$jj)(t)||"Unknown")}),m.on("exit",(t,i)=>{r(t?`post-${I} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,m.kill(),p("timed out")},5e3))})}j($,I,g,l){const c={silent:!0,execArgv:void 0},v=(0,D.fork)($,[`--type=extension-post-${I}`,...g],c);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const p=N.Event.fromNodeEventEmitter(v.stdout,"data"),m=N.Event.fromNodeEventEmitter(v.stderr,"data");this.B(p(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${I}`,t))),this.B(m(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${I}`,t)));const n=N.Event.any(N.Event.map(p,t=>({data:`%c${t}`,format:[""]}),this.q),N.Event.map(m,t=>({data:`%c${t}`,format:["color: red"]}),this.q));return N.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}m($){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Cq=y,e.$Cq=y=$e([oe(0,b.$El),oe(1,f.$5j)],y)}),define(ne[162],se([0,1,8,14,20,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,100,61,18,160,21,26,42,53,147,161,118,140,148,50,13,10,6,32,22,23,24]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c,v,p,m,n,r,t,i,s,o,h,S,j,O,z,C,T,J,re,ie,he,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=e.$Gq=void 0,e.$Gq=(0,J.$zi)(t.$_o);const B=".vsctmp";let Y=class extends r.$oq{constructor(U,F,d,P,L,M,G,W,te,ae,ue,pe){super(U,F,ue,d,ae,pe),this.eb=L,this.fb=M,this.gb=G,this.hb=te,this.db=new Map,this.qb=new f.$Bc;const ye=this.B(W.createInstance(S.$Cq));this.ab=this.B(W.createInstance(V,me=>ye.postUninstall(me))),this.bb=this.B(new O.$Eq(pe,te,ue,this,this.F)),this.cb=this.B(W.createInstance(h.$Bq));const fe=this.B(new z.$Fq(this,this.eb,pe,M,ue,te,d));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,i.$Ip)(this.hb,this.F)),this.ib}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const F=await this.ob(U),d=await(0,v.zip)((0,w.$_g)(this.cb.extensionsDownloadDir,(0,l.$Ug)()).fsPath,F);return g.URI.file(d)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:F,cleanup:d}=await this.kb(U),P=y.$kc(F.fsPath);try{return await(0,j.$Dq)(P)}finally{await d()}}getInstalled(U,F=this.H.defaultProfile.extensionsResource,d={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(U??null,F,d)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.ab.scanUserExtensionAtLocation(U)}async install(U,F={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:d,cleanup:P}=await this.kb(U);try{const L=await(0,j.$Dq)(y.$kc(d.fsPath)),M=(0,i.$Cp)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,C.$Pp)(L.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:L,extension:d,options:F}])).find(({identifier:te})=>(0,i.$xp)(te,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,r.$pq)(new Error(`Unknown error while installing extension ${M}`))}finally{await P()}}async installFromLocation(U,F){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const d=await this.ab.scanUserExtensionAtLocation(U);if(!d||!d.manifest.name||!d.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.tb([[d,{source:"resource"}]],F),this.F.info("Successfully installed extension",d.identifier.id,F.toString()),d}async installExtensionsFromProfile(U,F,d){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,F.toString(),d.toString());const P=(await this.getInstalled(1,F)).filter(L=>U.some(M=>(0,i.$xp)(M,L.identifier)));if(P.length){const L=await Promise.all(P.map(M=>this.ab.scanMetadata(M,F)));await this.tb(P.map((M,G)=>[M,L[G]]),d),this.F.info("Successfully installed extensions",P.map(M=>M.identifier.id),d.toString())}return P}async updateMetadata(U,F,d=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),U=await this.ab.updateMetadata(U,F,d),this.bb.invalidate(d),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const F=await this.getTargetPlatform(),[d]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!d)throw new Error(p.localize(2,null));await this.ab.setUninstalled(U);try{await this.ab.removeUninstalledExtension(U)}catch(P){throw new Error(p.localize(3,null,(0,N.$jj)(P)))}return this.installFromGallery(d)}$(U,F,d,P){return this.ab.copyExtension(U,F,d,P)}copyExtensions(U,F){return this.ab.copyExtensions(U,F,{version:this.G.version,date:this.G.date})}markAsUninstalled(...U){return this.ab.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(U){this.F.error(U)}}async download(U,F,d){const{location:P}=await this.cb.download(U,F,!d);return P}async kb(U){if(U.scheme===b.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const F=(0,w.$_g)(this.cb.extensionsDownloadDir,(0,l.$Ug)());return await this.gb.download(U,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(P){this.F.error(P)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(U,F,d){if(g.URI.isUri(F))return new Z(U,F,d,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const P=i.$yp.create(F).toString();let L=this.db.get(P);return L||(this.db.set(P,L=new H(U,F,d,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),L.waitUntilTaskIsFinished().finally(()=>this.db.delete(P))),L}Z(U,F){return new Q(U,F.profileLocation,this.fb)}async ob(U){const F=async P=>{let L=await c.Promises.readdir(P);L=L.map(W=>y.$jc(P,W));const M=await Promise.all(L.map(W=>c.Promises.stat(W)));let G=Promise.resolve([]);return M.forEach((W,te)=>{const ae=L[te];W.isFile()&&(G=G.then(ue=>[...ue,ae])),W.isDirectory()&&(G=G.then(ue=>F(ae).then(pe=>[...ue,...pe])))}),G};return(await F(U.location.fsPath)).map(P=>({path:`extension/${y.$lc(U.location.fsPath,P)}`,localPath:P}))}async pb({added:U,removed:F}){if(F){const d=U&&this.D.extUri.isEqual(F.profileLocation,U.profileLocation)?F.extensions.filter(P=>U.extensions.every(L=>!(0,i.$xp)(L,P))):F.extensions;for(const P of d)this.F.info("Extensions removed from another source",P.id,F.profileLocation.toString()),this.u.fire({identifier:P,profileLocation:F.profileLocation})}if(U){const P=(await this.getInstalled(1,U.profileLocation)).filter(L=>U.extensions.some(M=>(0,i.$xp)(M,L.identifier)));this.s.fire(P.map(L=>(this.F.info("Extensions added from another source",L.identifier.id,U.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:U.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const U=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of U.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(U){if(!U.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const d of U.rawAdded){if(this.qb.has(d)||!this.D.extUri.isEqual(this.D.extUri.dirname(d),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(d,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(d).startsWith(".")||!(await this.hb.stat(d)).isDirectory)continue;const P=await this.ab.scanUserExtensionAtLocation(d);P&&P.installedTimestamp===void 0&&(this.qb.add(d),F.push(P))}F.length&&(await this.tb(F.map(d=>[d,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(d=>d.identifier.id)))}async tb(U,F){const d=U.map(P=>P[0]);await this.ub(d),await this.fb.addExtensionsToProfile(U,F),this.s.fire(d.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:F})))}async ub(U){const F=await this.ab.getUninstalledExtensions();for(const d of U){const P=i.$yp.create(d);F[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.ab.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$Hq=Y,e.$Hq=Y=$e([oe(0,t.$9o),oe(1,he.$4l),oe(2,re.$5j),oe(3,n.$Gi),oe(4,o.$wq),oe(5,s.$sq),oe(6,m.$No),oe(7,J.$xi),oe(8,T.$5k),oe(9,ie.$lk),oe(10,le.$Cl),oe(11,ce.$El)],Y);let V=class extends a.$Uc{constructor(U,F,d,P,L,M){super(),this.j=U,this.m=F,this.n=d,this.s=P,this.t=L,this.u=M,this.h=this.B(new E.$fe),this.onExtract=this.h.event,this.c=(0,w.$_g)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Fh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,F,d){const P={includeInvalid:!0,profileLocation:F,productVersion:d};let L=[];return U===null||U===0?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):U===1&&L.push(...await this.n.scanUserExtensions(P)),L=U!==null?L.filter(M=>M.type===U):L,Promise.all(L.map(M=>this.F(M)))}async scanAllUserExtensions(U){const F=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(F.map(d=>this.F(d)))}async scanUserExtensionAtLocation(U){try{const F=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(U,F,d,P,L){const M=U.toString(),G=g.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Ug)()}`)),W=g.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,M));let te=await this.m.exists(W);if(te&&P){try{await this.y(U.id,W,"removeExisting")}catch{throw new t.$0o(p.localize(4,null,W.fsPath,U.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(W,d);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${W.fsPath}`),await(0,v.$mq)(F,G.fsPath,{sourcePath:"extension",overwrite:!0},L),this.u.info(`Extracted extension to ${W}:`,U.id)}catch(ae){let ue=t.ExtensionManagementErrorCode.Extract;throw ae instanceof v.$kq&&(ae.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$0o(ae.message,ue)}await this.n.updateMetadata(G,d);try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${W.fsPath}`),await this.C(G.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ae)}. Deleted from extracted location`,G),ae}this.h.fire(W)}catch(ae){try{await this.m.del(G,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(U,F){return F?(await this.w(U,F))?.metadata:this.n.scanMetadata(U.location)}async w(U,F){return(await this.s.scanProfileExtensions(F)).find(P=>(0,i.$xp)(P.identifier,U.identifier))}async updateMetadata(U,F,d){return d?await this.s.updateMetadata([[U,F]],d):await this.n.updateMetadata(U.location,F),this.D(U.location,U.type,d)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const F=U.map(d=>i.$yp.create(d));await this.z(d=>F.forEach(P=>{d[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(U){await this.z(F=>delete F[U.toString()])}async removeExtension(U,F){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,F)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(F=>delete F[i.$yp.create(U).toString()])}async copyExtension(U,F,d,P){const L=await this.w(U,F),M=await this.w(U,d);if(P={...L?.metadata,...P},M)if(this.t.extUri.isEqual(M.location,U.location))await this.s.updateMetadata([[U,{...M.metadata,...P}]],d);else{const G=await this.D(M.location,U.type,d);await this.s.removeExtensionFromProfile(G,d),await this.s.addExtensionsToProfile([[U,{...M.metadata,...P}]],d)}else await this.s.addExtensionsToProfile([[U,P]],d);return this.D(U.location,U.type,d)}async copyExtensions(U,F,d){const P=await this.scanExtensions(1,U,d),L=await Promise.all(P.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,U)]));await this.s.addExtensionsToProfile(L,F)}async y(U,F,d){this.u.trace(`Deleting ${d} extension from disk`,U,F.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,u.$mj)((0,l.$Ug)()).toString(16)}${B}`);await this.C(F.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${d} extension from disk`,U,F.fsPath)}async z(U){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,T.$jl)(P)!==1)throw P}let d={};if(F)try{d=JSON.parse(F)}catch{}return U&&(U(d),Object.keys(d).length?await this.m.writeFile(this.c,R.$He.fromString(JSON.stringify(d))):await this.m.del(this.c)),d})}async C(U,F){try{await c.Promises.rename(U,F,2*60*1e3)}catch(d){throw new t.$0o(d.message||p.localize(5,null,U,F),d.code||t.ExtensionManagementErrorCode.Rename)}}async D(U,F,d){if(d){const L=(await this.n.scanUserExtensions({profileLocation:d})).find(M=>this.t.extUri.isEqual(M.location,U));if(L)return this.F(L)}else{const P=await this.n.scanExistingExtension(U,F,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(p.localize(6,null,U.path))}async F(U){const F=await this.m.resolve(U.location);let d,P;return F.children&&(d=F.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,P=F.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:d,changelogUrl:P,publisherDisplayName:U.metadata?.publisherDisplayName,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned,isWorkspaceScoped:!1,source:U.metadata?.source??(U.identifier.uuid?"gallery":"vsix")}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const L of F)U[i.$yp.create(L).toString()]||d.add(L.identifier.id.toLowerCase());try{const L=(0,i.$Dp)(F,M=>M.identifier);await D.Promises.settled(L.map(async M=>{const G=M.sort((W,te)=>$.rcompare(W.manifest.version,te.manifest.version))[0];d.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(L){this.u.error(L)}const P=F.filter(L=>L.metadata&&U[i.$yp.create(L).toString()]);await Promise.allSettled(P.map(L=>this.removeUninstalledExtension(L)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,T.$jl)(F)!==1&&this.u.error(F);return}if(U?.children)try{await Promise.allSettled(U.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(d){(0,T.$jl)(d)!==1&&this.u.error(d)}}}))}catch{}}};e.$Iq=V,e.$Iq=V=$e([oe(1,T.$5k),oe(2,o.$wq),oe(3,s.$sq),oe(4,le.$Cl),oe(5,re.$5j)],V);class q extends r.$qq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,I.$fg)(this.options.operation)?this.l:this.options.operation}constructor(U,F,d,P,L,M,G,W,te,ae){super(),this.manifest=U,this.identifier=F,this.source=d,this.options=P,this.m=L,this.n=M,this.o=G,this.p=W,this.q=te,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[F,d]=await this.x(U);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,d]],this.j,!F.isValid),F}async u({zipPath:U,key:F,metadata:d},P,L){let M=await this.v(F);return M?M=await this.m.updateMetadata(M,d):(this.s.trace("Extracting extension...",F.id),M=await this.m.extractUserExtension(F,U,d,P,L),this.s.info("Extracting extension completed.",F.id)),M}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(P=>i.$yp.create(P).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class H extends q{constructor(U,F,d,P,L,M,G,W,te,ae,ue){super(U,F.identifier,F,d,L,M,G,W,te,ae),this.y=F,this.z=P,this.A=ue}async x(U){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(L){throw new t.$0o(L,t.ExtensionManagementErrorCode.Scanning)}const d=F.find(L=>(0,i.$xp)(L.identifier,this.y.identifier));d&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:d?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:(0,I.$eg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||d?.preRelease,source:"gallery"};if(d&&d.type!==0&&d.manifest.version===this.y.version)try{return[await this.m.updateMetadata(d,P),P]}catch(L){throw new t.$0o((0,A.$0)(L),t.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(P,U)}catch(L){if(L instanceof t.$0o&&(L.code===t.ExtensionManagementErrorCode.CorruptZip||L.code===t.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const M=await this.C(P,U);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),M}catch(M){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),M}}else throw L}}async C(U,F){const{location:d,verificationStatus:P}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=P,this.D(d.fsPath),[await this.u({zipPath:d.fsPath,key:i.$yp.create(this.y),metadata:U},!1,F),U]}catch(L){try{await this.z.delete(d)}catch(M){this.s.warn("Error while deleting the downloaded file",d.toString(),(0,A.$0)(M))}throw L}}async D(U){try{await(0,j.$Dq)(U)}catch(F){throw new t.$0o(F.message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Jq=H;class Z extends q{constructor(U,F,d,P,L,M,G,W,te,ae){super(U,{id:(0,i.$Cp)(U.publisher,U.name)},F,d,L,M,G,W,te,ae),this.y=F,this.z=P}async h(U){const F=await super.h(U);return this.C(F,U),F}async x(U){const F=new i.$yp(this.identifier,this.manifest.version),P=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.$xp)(this.identifier,G.identifier)),L={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned,source:"vsix"};if(P)if(this.l=3,F.equals(new i.$yp(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&$.gt(P.manifest.version,this.manifest.version)&&await this.m.setUninstalled(P);else{const G=await this.v(F);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:y.$kc(this.y.fsPath),key:F,metadata:L},!0,U),L]}async C(U,F){try{let[d]=await this.z.getExtensions([{id:U.identifier.id,version:U.manifest.version}],F);if(d||([d]=await this.z.getExtensions([{id:U.identifier.id}],F)),d){const P={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,P,this.options.profileLocation)}}catch{}}}class Q extends r.$qq{constructor(U,F,d){super(),this.extension=U,this.j=F,this.k=d}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],se([0,1,6,24,23,22,42,13,18,11]),function(X,e,D,R,k,N,A,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=void 0;let f=class extends A.$tq{constructor(y,w,$,I,g,l){super(a.URI.file(y.extensionsPath),w,$,I,g,l)}};e.$9P=f,e.$9P=f=$e([oe(0,u.$Gi),oe(1,E.$5k),oe(2,R.$El),oe(3,k.$Cl),oe(4,N.$4l),oe(5,D.$5j)],f)}),define(ne[164],se([0,1,11,18,42,53,13,10,6,32,23,24]),function(X,e,D,R,k,N,A,E,u,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;let y=class extends N.$Aq{constructor($,I,g,l,c,v,p,m){super(D.URI.file(c.builtinExtensionsPath),D.URI.file(c.extensionsPath),c.userHome,$.defaultProfile,$,I,g,l,c,v,p,m)}};e.$Vdc=y,e.$Vdc=y=$e([oe(0,b.$El),oe(1,k.$sq),oe(2,A.$5k),oe(3,u.$5j),oe(4,R.$Gi),oe(5,a.$lk),oe(6,f.$Cl),oe(7,E.$xi)],y)}),define(ne[165],se([0,1,8,5,2,130,3,90,10,24]),function(X,e,D,R,k,N,A,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$6p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4p=e.$3p=e.$2p=void 0,e.$5p=w,e.$7p=I,e.$9p=l,e.$2p="__$__isNewStorageMarker",e.$3p="__$__targetStorageMarker",e.$4p=(0,u.$yi)("storageService");var f;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var b;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function w(c){const v=c.get(e.$3p);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class $ extends k.$Uc{static{this.a=60*1e3}constructor(v={flushInterval:$.a}){super(),this.m=v,this.b=this.B(new R.$ie),this.c=this.B(new R.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(v,p,m){return R.Event.filter(this.b.event,n=>n.scope===v&&(p===void 0||n.key===p),m)}n(){this.j.value=(0,D.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(v,p){const{key:m,external:n}=p;if(m===e.$3p){switch(v){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:m,target:this.J(v)[m],external:n})}w(v){this.f.fire({reason:v})}get(v,p,m){return this.P(p)?.get(v,m)}getBoolean(v,p,m){return this.P(p)?.getBoolean(v,m)}getNumber(v,p,m){return this.P(p)?.getNumber(v,m)}getObject(v,p,m){return this.P(p)?.getObject(v,m)}storeAll(v,p){this.y(()=>{for(const m of v)this.store(m.key,m.value,m.scope,m.target,p)})}store(v,p,m,n,r=!1){if((0,A.$hg)(p)){this.remove(v,m,r);return}this.y(()=>{this.z(v,m,n),this.P(m)?.set(v,p,r)})}remove(v,p,m=!1){this.y(()=>{this.z(v,p,void 0),this.P(p)?.delete(v,m)})}y(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,p){const m=[],n=this.J(v);for(const r of Object.keys(n))n[r]===p&&m.push(r);return m}z(v,p,m,n=!1){const r=this.J(p);typeof m=="number"?r[v]!==m&&(r[v]=m,this.P(p)?.set(e.$3p,JSON.stringify(r),n)):typeof r[v]=="number"&&(delete r[v],this.P(p)?.set(e.$3p,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(v){switch(v){case-1:return this.I;case 0:return this.G;default:return this.D}}L(v){const p=this.P(v);return p?w(p):Object.create(null)}isNew(v){return this.getBoolean(e.$2p,v)===!0}async flush(v=f.NONE){this.f.fire({reason:v});const p=this.P(-1),m=this.P(0),n=this.P(1);switch(v){case f.NONE:await D.Promises.settled([p?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await D.Promises.settled([p?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,m=this.P(1)?.items??new Map;return l(v,p,m,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(v){return await this.flush(),this.P(v)?.optimize()}async switch(v,p){return this.w(f.NONE),(0,a.$Dl)(v)?this.R(v,p):this.S(v,p)}M(v,p){return!(v.id===p.id||I(p)&&I(v))}N(v,p,m){this.y(()=>{const n=new Set;for(const[r,t]of v)n.add(r),p.get(r)!==t&&this.u(m,{key:r,external:!0});for(const[r]of p.items)n.has(r)||this.u(m,{key:r,external:!0})})}}e.$6p=$;function I(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class g extends ${constructor(){super(),this.U=this.B(new E.$Zp(new E.$1p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Zp(new E.$1p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Zp(new E.$1p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(v=>this.u(1,v))),this.B(this.W.onDidChangeStorage(v=>this.u(0,v))),this.B(this.U.onDidChangeStorage(v=>this.u(-1,v)))}P(v){switch(v){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(v){return!1}}e.$8p=g;async function l(c,v,p,m,n,r){const t=C=>{try{return JSON.parse(C)}catch{return C}},i=new Map,s=new Map;c.forEach((C,T)=>{i.set(T,C),s.set(T,t(C))});const o=new Map,h=new Map;v.forEach((C,T)=>{o.set(T,C),h.set(T,t(C))});const S=new Map,j=new Map;p.forEach((C,T)=>{S.set(T,C),j.set(T,t(C))}),console.group(m!==n?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const O=[];if(i.forEach((C,T)=>{O.push({key:T,value:C})}),console.table(O),console.groupEnd(),console.log(s),m!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const C=[];o.forEach((T,J)=>{C.push({key:J,value:T})}),console.table(C),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${r})`);const z=[];S.forEach((C,T)=>{z.push({key:T,value:C})}),console.table(z),console.groupEnd(),console.log(j)}}),define(ne[166],se([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c,v,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0,e.$_p=Z;const n=N.$o?"web":(0,b.$5o)(N.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...P){return String(P.reduce((L,M)=>L|M,0))}var s;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},j={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class O{constructor(L=j){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,M=this.d.pageSize){return new O({...this.d,pageNumber:L,pageSize:M})}withFilter(L,...M){const G=[...this.d.criteria,...M.length?M.map(W=>({filterType:L,value:W})):[{filterType:L}]];return new O({...this.d,criteria:G})}withSortBy(L){return new O({...this.d,sortBy:L})}withSortOrder(L){return new O({...this.d,sortOrder:L})}withFlags(...L){return new O({...this.d,flags:L.reduce((M,G)=>M|G,0)})}withAssetTypes(...L){return new O({...this.d,assetTypes:L})}withSource(L){return new O({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:L,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te}],assetTypes:ue,flags:ae}}get searchText(){const L=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function z(P,L){const M=(P||[]).filter(G=>G.statisticName===L)[0];return M?M.value:0}function C(P){const L="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(G=>G.assetType.indexOf(L)===0).reduce((G,W)=>{const te=re(P,W.assetType);return te&&G.push([W.assetType.substring(L.length),te]),G},[])}function T(P){if(P.properties){const L=P.properties.filter(W=>W.key===o.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=L.filter(W=>M.test(W.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return re(P,o.Repository)}function J(P){return{uri:`${P.fallbackAssetUri}/${o.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${o.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function re(P,L){return P.files.filter(G=>G.assetType===L)[0]?{uri:`${P.assetUri}/${L}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${L}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function ie(P,L){const M=P.properties?P.properties.filter(W=>W.key===L):[],G=M.length>0&&M[0].value;return G?G.split(",").map(W=>(0,y.$Bp)(W)):[]}function he(P){const L=P.properties?P.properties.filter(M=>M.key===h.Engine):[];return L.length>0&&L[0].value||""}function le(P){const L=P.properties?P.properties.filter(M=>M.key===h.PreRelease):[];return L.length>0&&L[0].value==="true"}function ce(P){const L=P.properties?P.properties.filter(G=>G.key===h.LocalizedLanguages):[],M=L.length>0&&L[0].value||"";return M?M.split(","):[]}function B(P){return P.properties?.find(L=>L.key===h.SponsorLink)?.value}function Y(P){return P.properties?.find(L=>L.key===h.SupportLink)?.value}function V(P){return P.indexOf("preview")!==-1}function q(P){return P.targetPlatform?(0,b.$4o)(P.targetPlatform):"undefined"}function H(P){const L=(0,D.$Mb)(P.versions.map(q)),M=!!P.tags?.includes(b.$Yo),G=L.indexOf("web");return M?G===-1&&L.push("web"):G!==-1&&L.splice(G,1),L}function Z(P,L){for(let M=0;M<P.length;M++){const G=P[M];if(G.version===P[M-1]?.version){let W=M;if(q(G)===L)for(;W>0&&P[W-1].version===G.version;)W--;W!==M&&(P.splice(M,1),P.splice(W,0,G))}}return P}function Q(P,L,M){P.telemetryData={index:L,querySource:M,queryActivityId:P.queryContext?.[r]}}function _(P,L,M,G){const W=P.versions[0],te={manifest:re(L,o.Manifest),readme:re(L,o.Details),changelog:re(L,o.Changelog),license:re(L,o.License),repository:T(L),download:J(L),icon:re(L,o.Icon),signature:re(L,o.Signature),coreTranslations:C(L)};return{type:"gallery",identifier:{id:(0,y.$Cp)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:L.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(W),description:P.shortDescription??"",installCount:z(P.statistics,"install"),rating:z(P.statistics,"averagerating"),ratingCount:z(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:M,assets:te,properties:{dependencies:ie(L,h.Dependency),extensionPack:ie(L,h.ExtensionPack),engine:he(L),localizedLanguages:ce(L),targetPlatform:q(L),isPreReleaseVersion:le(L)},hasPreReleaseVersion:le(W),hasReleaseVersion:!0,preview:V(P.flags),isSigned:!!te.signature,queryContext:G,supportLink:Y(W)}}let U=class{constructor(L,M,G,W,te,ae,ue,pe){this.k=M,this.l=G,this.n=W,this.o=te,this.q=ae,this.u=ue,this.w=pe;const ye=ue.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,c.$$p)(ue.version,ue,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,M,G){const W=R.CancellationToken.isCancellationToken(M)?{}:M,te=R.CancellationToken.isCancellationToken(M)?M:G,ae=[],ue=[],pe=[],ye=[];let fe=!0;for(const we of L){we.uuid?ue.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!ue.length&&!ae.length)return[];let me=new O().withPage(1,L.length);ue.length&&(me=me.withFilter(s.ExtensionId,...ue)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(W.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),W.source&&(me=me.withSource(W.source));const{extensions:de}=await this.z(me,{targetPlatform:W.targetPlatform??n,includePreRelease:pe,versions:ye,compatible:!!W.compatible,productVersion:W.productVersion??{version:this.u.version,date:this.u.date}},te);return W.source&&de.forEach((we,Ee)=>Q(we,Ee,W.source)),de}async getCompatibleExtension(L,M,G,W={version:this.u.version,date:this.u.date}){if((0,b.$6o)(L.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(L,M,G))return L;const te=new O().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,L.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:G,compatible:!0,includePreRelease:M,productVersion:W},R.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(L,M,G,W={version:this.u.version,date:this.u.date}){if(!(0,b.$7o)(L.properties.targetPlatform,L.allTargetPlatforms,G)||!M&&L.properties.isPreReleaseVersion)return!1;let te=L.properties.engine;if(!te){const ae=await this.getManifest(L,R.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,w.$Pp)(te,W.version,W.date)}async y(L,M,G,W,te,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,b.$7o)(q(M),te,ae)||G!=="any"&&le(M)!==(G==="prerelease"))return!1;if(W)try{const pe=await this.E(L,M);if(!(0,w.$Pp)(pe,ue.version,ue.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,k.$0)(pe)),!1}return!0}async query(L,M){let G=L.text||"";const W=L.pageSize??50;let te=new O().withPage(1,W);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(s.SearchText,G)),te=te.withSortBy(0)):L.ids?te=te.withFilter(s.ExtensionId,...L.ids):L.names?te=te.withFilter(s.ExtensionName,...L.names):te=te.withSortBy(4),typeof L.sortBy=="number"&&(te=te.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(te=te.withSortOrder(L.sortOrder)),L.source&&(te=te.withSource(L.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!L.includePreRelease,productVersion:L.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>Q(Ee,(fe.pageNumber-1)*fe.pageSize+ke,L.source)),{extensions:de,total:we}},{extensions:ue,total:pe}=await ae(te,M),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:ue,total:pe,pageSize:te.pageSize,getPage:ye}}async z(L,M,G){const W=L.flags;L.flags&t.IncludeLatestVersionOnly&&L.flags&t.IncludeVersions&&(L=L.withFlags(L.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(L.flags&t.IncludeLatestVersionOnly)&&!(L.flags&t.IncludeVersions)&&(L=L.withFlags(L.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(L=L.withFlags(L.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),L=L.withFlags(L.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:ue}=await this.B(L,G);if(!(L.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,M,ue);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,y.$Cp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,E.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(x=>(0,y.$xp)(x,we))?.includePreRelease;if(M.compatible&&(0,b.$6o)(H(de),M.targetPlatform))continue;const ke=await this.A(de,M,ue);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,ke])}if(fe.size){const me=new m.$be,de=new O().withFlags(W&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,M,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const ke=fe.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(L,M,G){const W={id:(0,y.$Cp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},te=M.versions?.find(ye=>(0,y.$xp)(ye,W))?.version,ae=(0,E.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ye=>(0,y.$xp)(ye,W))?.includePreRelease,ue=H(L),pe=Z(L.versions,M.targetPlatform);if(M.compatible&&(0,b.$6o)(ue,M.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,y.$Cp)(L.publisher.publisherName,L.extensionName),fe,ae?"any":"release",M.compatible,ue,M.targetPlatform,M.productVersion))return _(L,fe,ue,G);if(te&&fe.version===te)return null}}return te||M.compatible?null:_(L,L.versions[0],ue)}async B(L,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(t.Unpublished));const G=await this.j,W=JSON.stringify(L.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},ae=new m.$be;let ue,pe,ye=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&L.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:W,headers:te},M),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,l.$Wp)(ue);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,k.$4)(fe)?b.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(fe).startsWith("XHR timeout")?b.ExtensionGalleryErrorCode.Timeout:b.ExtensionGalleryErrorCode.Failed;throw pe=new b.$$o((0,k.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(W.length),duration:ae.elapsed(),success:!!ue&&(0,l.$Sp)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(L,M,G,W){if(!this.isEnabled())return;const te=N.$o?this.x(`/itemName/${L}.${M}/version/${G}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${M}/${G}/stats?statType=${W}`),ae=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},R.CancellationToken.None)}catch{}}async download(L,M,G){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const W=(0,y.$Fp)(L),te=new Date().getTime(),ae=me=>this.o.publicLog("galleryService:downloadVSIX",{...W,duration:me}),ue=G===2?"install":G===3?"update":"",pe=ue?{uri:`${L.assets.download.uri}${u.URI.parse(L.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${L.assets.download.fallbackUri}${u.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:L.assets.download,ye=L.queryContext?.[r]?{[r]:L.queryContext[r]}:void 0,fe=await this.D(L.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(M,fe.stream),ae(new Date().getTime()-te)}async downloadSignatureArchive(L,M){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const G=await this.D(L.identifier.id,L.assets.signature,o.Signature);await this.q.writeFile(M,G.stream)}async getReadme(L,M){if(L.assets.readme){const G=await this.D(L.identifier.id,L.assets.readme,o.Details,{},M);return await(0,l.$Vp)(G)||""}return""}async getManifest(L,M){if(L.assets.manifest){const G=await this.D(L.identifier.id,L.assets.manifest,o.Manifest,{},M),W=await(0,l.$Vp)(G);return W?JSON.parse(W):null}return null}async C(L,M,G){const W=re(M,o.Manifest);if(!W)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(L,W,o.Manifest,{headers:te});return await(0,l.$Wp)(ae)}async getCoreTranslation(L,M){const G=L.assets.coreTranslations.filter(W=>W[0]===M.toUpperCase())[0];if(G){const W=await this.D(L.identifier.id,G[1],G[0]),te=await(0,l.$Vp)(W);return te?JSON.parse(te):null}return null}async getChangelog(L,M){if(L.assets.changelog){const G=await this.D(L.identifier.id,L.assets.changelog,o.Changelog,{},M);return await(0,l.$Vp)(G)||""}return""}async getAllCompatibleVersions(L,M,G){let W=new O().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?W=W.withFilter(s.ExtensionId,L.identifier.uuid):W=W.withFilter(s.ExtensionName,L.identifier.id);const{galleryExtensions:te}=await this.B(W,R.CancellationToken.None);if(!te.length)return[];const ae=H(te[0]);if((0,b.$6o)(ae,G))return[];const ue=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(L.identifier.id,fe,M?"any":"release",!0,ae,G)&&ue.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Z(ue,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:le(fe)}));return pe}async D(L,M,G,W={},te=R.CancellationToken.None){const ae=await this.j,ue={type:"GET"},pe={...ae,...W.headers||{}};W={...W,...ue,headers:pe};const ye=M.uri,fe=M.fallbackUri,me={...W,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,l.$Vp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,k.$4)(de))throw de;const we=(0,k.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:L,assetType:G,message:we});const Ee={...W,url:fe};return this.k.request(Ee,te)}}async E(L,M){let G=he(M);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:L,version:M.version});const W=await this.C(L,M,R.CancellationToken.None);if(!W)throw new Error("Manifest was not found");G=W.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,l.$Wp)(L),G=[],W={},te=[];if(M){for(const ae of M.malicious)G.push({id:ae});if(M.migrateToPreRelease)for(const[ae,ue]of Object.entries(M.migrateToPreRelease))(!ue.engine||(0,w.$Pp)(ue.engine,this.u.version,this.u.date))&&(W[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ae,ue]of Object.entries(M.deprecated))ue&&(W[ae.toLowerCase()]=(0,E.$eg)(ue)?{}:ue);if(M.search)for(const ae of M.search)te.push(ae)}return{malicious:G,deprecated:W,search:te}}};U=$e([oe(1,l.$Qp),oe(2,I.$5j),oe(3,f.$Fi),oe(4,p.$4l),oe(5,$.$5k),oe(6,g.$lk),oe(7,a.$5i)],U);let F=class extends U{constructor(L,M,G,W,te,ae,ue,pe){super(L,M,G,W,te,ae,ue,pe)}};e.$aq=F,e.$aq=F=$e([oe(0,v.$4p),oe(1,l.$Qp),oe(2,I.$5j),oe(3,f.$Fi),oe(4,p.$4l),oe(5,$.$5k),oe(6,g.$lk),oe(7,a.$5i)],F);let d=class extends U{constructor(L,M,G,W,te,ae,ue){super(void 0,L,M,G,W,te,ae,ue)}};e.$bq=d,e.$bq=d=$e([oe(0,l.$Qp),oe(1,I.$5j),oe(2,f.$Fi),oe(3,p.$4l),oe(4,$.$5k),oe(5,g.$lk),oe(6,a.$5i)],d)}),define(ne[167],se([0,1,11,18,13,6,145,23,24,3,69]),function(X,e,D,R,k,N,A,E,u,a,f){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=e.$6P=void 0;let w=class extends u.$Hl{static{b=this}static{this.a="profileAssociationsMigration"}constructor(l,c,v,p,m){super(v,p,c,m),this.U=l,this.W=v}O(){return this.U.getItem(b.b,[]).map(c=>({...c,location:(0,a.$$f)(c.location)?this.w.extUri.joinPath(this.profilesHome,c.location):D.URI.revive(c.location)}))}Q(){const l=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?l:this.N(l)}S(){return this.w.extUri.joinPath(D.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$6P=w,e.$6P=w=b=$e([oe(0,A.$1P),oe(1,E.$Cl),oe(2,R.$Gi),oe(3,k.$5k),oe(4,N.$5j)],w);let $=y=class extends w{constructor(l,c,v,p,m){super(l,c,v,p,m),this.$=l}P(l){l.length?this.$.setItem(y.b,l.map(c=>({...c,location:this.w.extUri.basename(c.location)}))):this.$.removeItem(y.b)}O(){const l=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(l),this.$.setItem("userDataProfilesMigration",!0)),l}R(l){l.emptyWindows||l.workspaces?this.$.setItem(y.c,l):this.$.removeItem(y.c)}Q(){const l="workspaceAndProfileInfo",c=this.$.getItem(l,void 0);if(c){this.$.removeItem(l);const p=c.reduce((m,{workspace:n,profile:r})=>(m[D.URI.revive(n).toString()]=D.URI.revive(r).toString(),m),{});this.$.setItem(y.c,{workspaces:p})}const v=super.Q();return this.$.getItem(y.a,!1)||(this.R(v),this.$.setItem(y.a,!0)),v}};e.$7P=$,e.$7P=$=y=$e([oe(0,A.$2P),oe(1,E.$Cl),oe(2,R.$Gi),oe(3,k.$5k),oe(4,N.$5j)],$);let I=class extends ${constructor(l,c,v,p){super(new f.$5P(0,c,p,v),l,c,v,p)}async init(){return await this.$.init(),super.init()}};e.$8P=I,e.$8P=I=$e([oe(0,E.$Cl),oe(1,R.$Gi),oe(2,k.$5k),oe(3,N.$5j)],I)}),define(ne[168],se([0,1,143,8,14,9,3,29,18,144,6,45,142,179]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0,e.$2r=g;let $=class extends b.$Rp{constructor(c,v,p,m){super(m),this.m=c,this.n=v,this.r=p,this.s(),this.B(c.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const c=this.m.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,v){const{f:p,g:m}=this;let n;try{n=await(0,a.$Im)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const r={...process.env,...n},t=c.agent?c.agent:await(0,y.$Zr)(c.url||"",r,{proxyUrl:p,strictSSL:m});return c.agent=t,c.strictSSL=m,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>g(c,v))}async resolveProxy(c){}async loadCertificates(){return(await new Promise((v,p)=>{X(["@vscode/proxy-agent"],v,p)})).loadSystemCertificates({log:this.r})}};e.$1r=$,e.$1r=$=$e([oe(0,E.$5i),oe(1,u.$Gi),oe(2,f.$5j),oe(3,f.$6j)],$);async function I(l){return((0,D.parse)(l.url).protocol==="https:"?await new Promise((p,m)=>{X(["https"],p,m)}):await new Promise((p,m)=>{X(["http"],p,m)})).request}async function g(l,c){return R.Promises.withAsyncBody(async(v,p)=>{const m=(0,D.parse)(l.url),n=l.getRawRequest?l.getRawRequest(l):await I(l),r={hostname:m.hostname,port:m.port?parseInt(m.port):m.protocol==="https:"?443:80,protocol:m.protocol,path:m.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,A.$eg)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(r.auth=l.user+":"+l.password);const t=n(r,i=>{const s=(0,A.$cg)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)g({...l,url:i.headers.location,followRedirects:s-1},c).then(v,p);else{let o=i;!l.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,w.createGunzip)())),v({res:i,stream:(0,k.$We)(o)})}});t.on("error",p),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),c.onCancellationRequested(()=>{t.abort(),p(new N.$5)})})}}),define(ne[180],se([0,1,33,8,34,9,2,15,16,12,35,11,25,29,139,61,141,18,116,166,21,71,146,42,53,162,164,13,129,131,51,127,64,65,150,6,135,39,136,153,32,45,168,69,70,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(X,e,D,R,k,N,A,E,u,a,f,b,y,w,$,I,g,l,c,v,p,m,n,r,t,i,s,o,h,S,j,O,z,C,T,J,re,ie,he,le,ce,B,Y,V,q,H,Z,Q,_,U,F,d,P,L,M,G,W,te,ae,ue,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends A.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(J.$5j),x=Ee.get(o.$5k),K=Ee.get(l.$Gi),ee=Ee.get(P.$El);ke.info("CLI main",this.b),this.h(ke),await this.j(K,x,ee,de),await Promise.all(we.map(ge=>{(0,R.$ph)(ge.flush(),1e3)}))})}async f(){const de=new z.$wi,we={_serviceBrand:void 0,...le.default};de.set(ce.$lk,we);const Ee=new c.$$m(this.b,we);de.set(l.$Gi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:E.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?y.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new te.$ZP((0,J.$gk)(Ee),Ee.logsHome);de.set(J.$6j,ke);const x=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];ke.getLogLevel()===J.LogLevel.Trace&&K.push(new J.$ak(ke.getLogLevel()));const ee=this.B(new W.$0P(x,K));de.set(J.$5j,ee);const ge=this.B(new h.$Lq(ee));de.set(o.$5k,ge);const ve=this.B(new S.$cr(ee));ge.registerProvider(E.Schemas.file,ve);const De=new d.$Ds(ge);de.set(F.$Cl,De);const Se=new V.$4P(1,Ee,ee,ge),Le=new L.$6P(Se,De,Ee,ge,ee);de.set(P.$El,Le),ge.registerProvider(E.Schemas.vscodeUserData,new ue.$kec(E.Schemas.file,ve,E.Schemas.vscodeUserData,Le,De,ee));const je=a.$i&&we.win32RegValueName?this.B(new he.$iec(ee,we.win32RegValueName)):Ee.policyFile?this.B(new re.$jec(Ee.policyFile,ge,ee)):new ie.$jo;de.set(ie.$ho,je);const Ae=this.B(new $.$Jo(Le.defaultProfile.settingsResource,ge,je,ee));de.set(w.$5i,Ae),await Promise.all([Se.init(),Ae.initialize()]);let Ce;try{Ce=await(0,M.$Ydc)(Se,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const Oe=await(0,M.$Zdc)(Se,ee);Le.init(),de.set(F.$Cl,new d.$Ds(ge));const Ne=new Y.$1r(Ae,Ee,ee,ke);de.set(B.$Qp,Ne),de.set(I.$No,new j.$vi(g.$mQ,void 0,!0)),de.set(r.$sq,new j.$vi(G.$9P,void 0,!0)),de.set(t.$wq,new j.$vi(s.$Vdc,void 0,!0)),de.set(m.$cq,new j.$vi(m.$eq,void 0,!0)),de.set(i.$Gq,new j.$vi(i.$Hq,void 0,!0)),de.set(p.$9o,new j.$vi(v.$bq,void 0,!0)),de.set(C.$Ur,new j.$vi(T.$Wr,void 0,!1));const ze=[],Fe=(0,Q.$up)(we,Ae);if((0,Q.$pp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$XP(Ne,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,q.$gp)((0,D.release)(),(0,D.hostname)(),process.arch,we.commit,we.version,Ce,Oe,Fe),piiPaths:(0,Q.$vp)(Ee)};de.set(H.$4l,new j.$vi(Z.$3r,[be],!1))}else de.set(H.$4l,Q.$kp);return[new O.$fr(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,N.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$jj)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,N.$Z)(we)||(0,N.$1)(we)}),process.on("unhandledRejection",we=>(0,N.$1)(we))}async j(de,we,Ee,ke){let x;if(de.args.profile&&(x=Ee.profiles.find(ee=>ee.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(n.$fq,new J.$ak(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return ke.createInstance(n.$fq,new J.$ak(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(n.$fq,new J.$ak(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return ke.createInstance(n.$fq,new J.$ak(J.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return ke.createInstance(n.$fq,new J.$ak(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$Iec)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?b.URI.file((0,u.$ic)(we)?we:(0,u.$jc)((0,f.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60468916e48fe8293e7641f0fc4ada80d79117b3/core/vs/code/node/cliProcessMain.js.map
