/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(he){for(var e=[],l=0,L=he.length;l<L;l++)e[l]=ke[he[l]];return e};define(ke[163],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class l{static get(){const O=new Map,M=new Map,R=new Map,b=new Map;function $(S,v){S.has(v.detail)||S.set(v.detail,-v.timestamp)}function E(S,v){const h=S.get(v.detail);h&&(h>=0||S.set(v.detail,h+v.timestamp))}let A=[];typeof he=="function"&&typeof he.getStats=="function"&&(A=he.getStats().slice(0).sort((S,v)=>S.timestamp-v.timestamp));for(const S of A)switch(S.type){case 10:$(O,S);break;case 11:case 12:E(O,S);break;case 21:$(M,S);break;case 22:E(M,S);break;case 33:$(R,S);break;case 34:E(R,S);break;case 31:$(b,S);break;case 32:E(b,S);break}let I=0;R.forEach(S=>I+=S);function p(S){const v=[];return S.forEach((h,d)=>v.push([d,h])),v}return{amdLoad:p(O),amdInvoke:p(M),nodeRequire:p(R),nodeEval:p(b),nodeRequireTotal:I}}static toMarkdownTable(O,M){let R="";const b=[];return O.forEach(($,E)=>{b[E]=$.length}),M.forEach($=>{$.forEach((E,A)=>{typeof E>"u"&&(E=$[A]="-");const I=E.toString().length;b[A]=Math.max(I,b[A])})}),O.forEach(($,E)=>{R+=`| ${$+" ".repeat(b[E]-$.toString().length)} `}),R+=`|
`,O.forEach(($,E)=>{R+=`| ${"-".repeat(b[E])} `}),R+=`|
`,M.forEach($=>{$.forEach((E,A)=>{typeof E<"u"&&(R+=`| ${E+" ".repeat(b[A]-E.toString().length)} `)}),R+=`|
`}),R}}e.$U=l}),define(ke[164],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=l,e.$gb=L,e.$hb=O,e.$ib=M,e.$jb=R,e.$kb=b,e.$lb=$,e.$nb=A,e.$ob=I,e.$pb=p,e.$qb=S,e.$rb=v;function l(h,d){const c=L(h,d);if(c!==-1)return h[c]}function L(h,d,c=h.length-1){for(let n=c;n>=0;n--){const i=h[n];if(d(i))return n}return-1}function O(h,d){const c=M(h,d);return c===-1?void 0:h[c]}function M(h,d,c=0,n=h.length){let i=c,a=n;for(;i<a;){const s=Math.floor((i+a)/2);d(h[s])?i=s+1:a=s}return i-1}function R(h,d){const c=b(h,d);return c===h.length?void 0:h[c]}function b(h,d,c=0,n=h.length){let i=c,a=n;for(;i<a;){const s=Math.floor((i+a)/2);d(h[s])?a=s:i=s+1}return i}function $(h,d,c=0,n=h.length){const i=b(h,d,c,n);return i===h.length?-1:i}class E{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!d(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const c=M(this.e,d,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=E;function A(h,d){if(h.length===0)return;let c=h[0];for(let n=1;n<h.length;n++){const i=h[n];d(i,c)>0&&(c=i)}return c}function I(h,d){if(h.length===0)return;let c=h[0];for(let n=1;n<h.length;n++){const i=h[n];d(i,c)>=0&&(c=i)}return c}function p(h,d){return A(h,(c,n)=>-d(c,n))}function S(h,d){if(h.length===0)return-1;let c=0;for(let n=1;n<h.length;n++){const i=h[n];d(i,h[c])>0&&(c=n)}return c}function v(h,d){for(const c of h){const n=d(c);if(n!==void 0)return n}}}),define(ke[74],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=l,e.$L=L,e.$M=O,e.$N=M;function l(R,b){const $=Object.create(null);for(const E of R){const A=b(E);let I=$[A];I||(I=$[A]=[]),I.push(E)}return $}function L(R,b){const $=[],E=[];for(const A of R)b.has(A)||$.push(A);for(const A of b)R.has(A)||E.push(A);return{removed:$,added:E}}function O(R,b){const $=[],E=[];for(const[A,I]of R)b.has(A)||$.push(I);for(const[A,I]of b)R.has(A)||E.push(I);return{removed:$,added:E}}function M(R,b){const $=new Set;for(const E of b)R.has(E)&&$.add(E);return $}}),define(ke[56],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=L,e.$4h=O,e.$5h=M;function l(R){return(b,$,E)=>{let A=null,I=null;if(typeof E.value=="function"?(A="value",I=E.value):typeof E.get=="function"&&(A="get",I=E.get),!I)throw new Error("not supported");E[A]=R(I,$)}}function L(R,b,$){let E=null,A=null;if(typeof $.value=="function"?(E="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(E="get",A=$.get),!A)throw new Error("not supported");const I=`$memoize$${b}`;$[E]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,p)}),this[I]}}function O(R,b,$){return l((E,A)=>{const I=`$debounce$${A}`,p=`$debounce$result$${A}`;return function(...S){this[p]||(this[p]=$?$():void 0),clearTimeout(this[I]),b&&(this[p]=b(this[p],...S),S=[this[p]]),this[I]=setTimeout(()=>{E.apply(this,S),this[p]=$?$():void 0},R)}})}function M(R,b,$){return l((E,A)=>{const I=`$throttle$timer$${A}`,p=`$throttle$result$${A}`,S=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...h){if(this[p]||(this[p]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...h)),this[v])return;const d=this[S]+R;d<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0):(this[v]=!0,this[I]=setTimeout(()=>{this[v]=!1,this[S]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0},d-Date.now()))}})}}),define(ke[13],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=O,e.$1=M,e.$2=R,e.$3=b,e.$4=E,e.$6=I,e.$7=p,e.$8=S,e.$0=h;class l{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=l,e.$X=new l;function L(s){e.$X.setUnexpectedErrorHandler(s)}function O(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(s){E(s)||e.$X.onUnexpectedError(s)}function R(s){E(s)||e.$X.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:u}=s,r=s.stacktrace||s.stack;return{$isError:!0,name:t,message:u,stack:r,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const $="Canceled";function E(s){return s instanceof A?!0:s instanceof Error&&s.name===$&&s.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function I(){const s=new Error($);return s.name=s.message,s}function p(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function S(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function h(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=d;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const u=new i;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class a extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}e.$cb=a}),define(ke[19],De([1,0,13,164]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=O,e.$tb=M,e.$ub=R,e.$vb=b,e.$wb=$,e.$xb=E,e.$yb=A,e.$zb=I,e.$Ab=p,e.$Bb=S,e.$Cb=v,e.$Db=h,e.$Eb=d,e.top=c,e.$Gb=n,e.$Hb=a,e.$Ib=s,e.$Jb=t,e.$Kb=u,e.$Lb=r,e.$Mb=o,e.$Nb=f,e.$Ob=g,e.$Pb=w,e.$Qb=k,e.$Rb=m,e.$Sb=y,e.$Tb=D,e.$Ub=C,e.$Vb=P,e.$Wb=j,e.$Xb=T,e.$Yb=z,e.$Zb=N,e.$1b=F,e.$2b=U,e.$3b=Y,e.$4b=ie,e.$5b=H,e.$6b=ne,e.$7b=be,e.$0b=ee;function O(ue,ce=0){return ue[ue.length-(1+ce)]}function M(ue){if(ue.length===0)throw new Error("Invalid tail call");return[ue.slice(0,ue.length-1),ue[ue.length-1]]}function R(ue,ce,oe=(le,K)=>le===K){if(ue===ce)return!0;if(!ue||!ce||ue.length!==ce.length)return!1;for(let le=0,K=ue.length;le<K;le++)if(!oe(ue[le],ce[le]))return!1;return!0}function b(ue,ce){const oe=ue.length-1;ce<oe&&(ue[ce]=ue[oe]),ue.pop()}function $(ue,ce,oe){return E(ue.length,le=>oe(ue[le],ce))}function E(ue,ce){let oe=0,le=ue-1;for(;oe<=le;){const K=(oe+le)/2|0,se=ce(K);if(se<0)oe=K+1;else if(se>0)le=K-1;else return K}return-(oe+1)}function A(ue,ce,oe){if(ue=ue|0,ue>=ce.length)throw new TypeError("invalid index");const le=ce[Math.floor(ce.length*Math.random())],K=[],se=[],$e=[];for(const ve of ce){const Me=oe(ve,le);Me<0?K.push(ve):Me>0?se.push(ve):$e.push(ve)}return ue<K.length?A(ue,K,oe):ue<K.length+$e.length?$e[0]:A(ue-(K.length+$e.length),se,oe)}function I(ue,ce){const oe=[];let le;for(const K of ue.slice(0).sort(ce))!le||ce(le[0],K)!==0?(le=[K],oe.push(le)):le.push(K);return oe}function*p(ue,ce){let oe,le;for(const K of ue)le!==void 0&&ce(le,K)?oe.push(K):(oe&&(yield oe),oe=[K]),le=K;oe&&(yield oe)}function S(ue,ce){for(let oe=0;oe<=ue.length;oe++)ce(oe===0?void 0:ue[oe-1],oe===ue.length?void 0:ue[oe])}function v(ue,ce){for(let oe=0;oe<ue.length;oe++)ce(oe===0?void 0:ue[oe-1],ue[oe],oe+1===ue.length?void 0:ue[oe+1])}function h(ue,ce,oe){const le=[];function K(ve,Me,ge){if(Me===0&&ge.length===0)return;const Pe=le[le.length-1];Pe&&Pe.start+Pe.deleteCount===ve?(Pe.deleteCount+=Me,Pe.toInsert.push(...ge)):le.push({start:ve,deleteCount:Me,toInsert:ge})}let se=0,$e=0;for(;;){if(se===ue.length){K(se,0,ce.slice($e));break}if($e===ce.length){K(se,ue.length-se,[]);break}const ve=ue[se],Me=ce[$e],ge=oe(ve,Me);ge===0?(se+=1,$e+=1):ge<0?(K(se,1,[]),se+=1):ge>0&&(K(se,0,[Me]),$e+=1)}return le}function d(ue,ce,oe){const le=h(ue,ce,oe),K=[],se=[];for(const $e of le)K.push(...ue.slice($e.start,$e.start+$e.deleteCount)),se.push(...$e.toInsert);return{removed:K,added:se}}function c(ue,ce,oe){if(oe===0)return[];const le=ue.slice(0,oe).sort(ce);return i(ue,ce,le,oe,ue.length),le}function n(ue,ce,oe,le,K){return oe===0?Promise.resolve([]):new Promise((se,$e)=>{(async()=>{const ve=ue.length,Me=ue.slice(0,oe).sort(ce);for(let ge=oe,Pe=Math.min(oe+le,ve);ge<ve;ge=Pe,Pe=Math.min(Pe+le,ve)){if(ge>oe&&await new Promise(Ae=>setTimeout(Ae)),K&&K.isCancellationRequested)throw new l.$5;i(ue,ce,Me,ge,Pe)}return Me})().then(se,$e)})}function i(ue,ce,oe,le,K){for(const se=oe.length;le<K;le++){const $e=ue[le];if(ce($e,oe[se-1])<0){oe.pop();const ve=(0,L.$kb)(oe,Me=>ce($e,Me)<0);oe.splice(ve,0,$e)}}}function a(ue){return ue.filter(ce=>!!ce)}function s(ue){let ce=0;for(let oe=0;oe<ue.length;oe++)ue[oe]&&(ue[ce]=ue[oe],ce+=1);ue.length=ce}function t(ue,ce,oe){ue.splice(oe,0,ue.splice(ce,1)[0])}function u(ue){return!Array.isArray(ue)||ue.length===0}function r(ue){return Array.isArray(ue)&&ue.length>0}function o(ue,ce=oe=>oe){const oe=new Set;return ue.filter(le=>{const K=ce(le);return oe.has(K)?!1:(oe.add(K),!0)})}function f(ue){const ce=new Set;return oe=>{const le=ue(oe);return ce.has(le)?!1:(ce.add(le),!0)}}function g(ue,ce){return ue.length>0?ue[0]:ce}function w(ue,ce){return ue.length>0?ue[ue.length-1]:ce}function k(ue,ce,oe=(le,K)=>le===K){let le=0;for(let K=0,se=Math.min(ue.length,ce.length);K<se&&oe(ue[K],ce[K]);K++)le++;return le}function m(ue,ce){let oe=typeof ce=="number"?ue:0;typeof ce=="number"?oe=ue:(oe=0,ce=ue);const le=[];if(oe<=ce)for(let K=oe;K<ce;K++)le.push(K);else for(let K=oe;K>ce;K--)le.push(K);return le}function y(ue,ce,oe){return ue.reduce((le,K)=>(le[ce(K)]=oe?oe(K):K,le),Object.create(null))}function D(ue,ce){return ue.push(ce),()=>C(ue,ce)}function C(ue,ce){const oe=ue.indexOf(ce);if(oe>-1)return ue.splice(oe,1),ce}function P(ue,ce,oe){const le=ue.slice(0,ce),K=ue.slice(ce);return le.concat(oe,K)}function j(ue,ce){let oe;if(typeof ce=="number"){let le=ce;oe=()=>{const K=Math.sin(le++)*179426549;return K-Math.floor(K)}}else oe=Math.random;for(let le=ue.length-1;le>0;le-=1){const K=Math.floor(oe()*(le+1)),se=ue[le];ue[le]=ue[K],ue[K]=se}}function T(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.unshift(ce))}function z(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.push(ce))}function N(ue,ce){for(const oe of ce)ue.push(oe)}function F(ue,ce){return Array.isArray(ue)?ue.map(ce):ce(ue)}function U(ue){return Array.isArray(ue)?ue:[ue]}function Y(ue){return ue[Math.floor(Math.random()*ue.length)]}function ie(ue,ce,oe){const le=J(ue,ce),K=ue.length,se=oe.length;ue.length=K+se;for(let $e=K-1;$e>=le;$e--)ue[$e+se]=ue[$e];for(let $e=0;$e<se;$e++)ue[$e+le]=oe[$e]}function H(ue,ce,oe,le){const K=J(ue,ce);let se=ue.splice(K,oe);return se===void 0&&(se=[]),ie(ue,K,le),se}function J(ue,ce){return ce<0?Math.max(ce+ue.length,0):Math.min(ce,ue.length)}var x;(function(ue){function ce(se){return se<0}ue.isLessThan=ce;function oe(se){return se<=0}ue.isLessThanOrEqual=oe;function le(se){return se>0}ue.isGreaterThan=le;function K(se){return se===0}ue.isNeitherLessOrGreaterThan=K,ue.greaterThan=1,ue.lessThan=-1,ue.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function ne(ue,ce){return(oe,le)=>ce(ue(oe),ue(le))}function be(...ue){return(ce,oe)=>{for(const le of ue){const K=le(ce,oe);if(!x.isNeitherLessOrGreaterThan(K))return K}return x.neitherLessOrGreaterThan}}const ae=(ue,ce)=>ue-ce;e.$8b=ae;const Ie=(ue,ce)=>(0,e.$8b)(ue?1:0,ce?1:0);e.$9b=Ie;function ee(ue){return(ce,oe)=>-ue(ce,oe)}class B{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let oe=this.c;for(;oe<this.g.length&&ce(this.g[oe]);)oe++;const le=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,le}takeFromEndWhile(ce){let oe=this.d;for(;oe>=0&&ce(this.g[oe]);)oe--;const le=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const oe=this.g.slice(this.c,this.c+ce);return this.c+=ce,oe}}e.$$b=B;class _{static{this.empty=new _(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(oe=>(ce(oe),!0))}toArray(){const ce=[];return this.iterate(oe=>(ce.push(oe),!0)),ce}filter(ce){return new _(oe=>this.iterate(le=>ce(le)?oe(le):!0))}map(ce){return new _(oe=>this.iterate(le=>oe(ce(le))))}some(ce){let oe=!1;return this.iterate(le=>(oe=ce(le),!oe)),oe}findFirst(ce){let oe;return this.iterate(le=>ce(le)?(oe=le,!1):!0),oe}findLast(ce){let oe;return this.iterate(le=>(ce(le)&&(oe=le),!0)),oe}findLastMaxBy(ce){let oe,le=!0;return this.iterate(K=>((le||x.isGreaterThan(ce(K,oe)))&&(le=!1,oe=K),!0)),oe}}e.$_b=_;class pe{constructor(ce){this.c=ce}static createSortPermutation(ce,oe){const le=Array.from(ce.keys()).sort((K,se)=>oe(ce[K],ce[se]));return new pe(le)}apply(ce){return ce.map((oe,le)=>ce[this.c[le]])}inverse(){const ce=this.c.slice();for(let oe=0;oe<this.c.length;oe++)ce[this.c[oe]]=oe;return new pe(ce)}}e.$ac=pe}),define(ke[62],De([1,0,13]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$ed=O,e.$fd=M,e.$gd=R,e.$hd=b,e.$id=$;function L(E,A){if(!E)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function O(E,A="Unreachable"){throw new Error(A)}function M(E){if(!E)throw new l.$cb("Assertion Failed")}function R(E){E||(0,l.$1)(new l.$cb("Soft Assertion Failed"))}function b(E){if(!E()){debugger;E(),(0,l.$1)(new l.$cb("Assertion Failed"))}}function $(E,A){let I=0;for(;I<E.length-1;){const p=E[I],S=E[I+1];if(!A(p,S))return!1;I++}return!0}}),define(ke[165],De([1,0,19]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=O,e.$8c=M,e.$9c=R,e.$0c=b,e.$$c=$,e.$_c=E;const L=(S,v)=>S===v;e.$6c=L;function O(S=e.$6c){return(v,h)=>l.$ub(v,h,S)}function M(){return(S,v)=>JSON.stringify(S)===JSON.stringify(v)}function R(){return(S,v)=>S.equals(v)}function b(S,v,h){return!S||!v?S===v:h(S,v)}function $(S,v){if(S===v)return!0;if(Array.isArray(S)&&Array.isArray(v)){if(S.length!==v.length)return!1;for(let h=0;h<S.length;h++)if(!$(S[h],v[h]))return!1;return!0}if(S&&typeof S=="object"&&v&&typeof v=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(v)===Object.prototype){const h=S,d=v,c=Object.keys(h),n=Object.keys(d),i=new Set(n);if(c.length!==n.length)return!1;for(const a of c)if(!i.has(a)||!$(h[a],d[a]))return!1;return!0}return!1}function E(S){return JSON.stringify(p(S))}let A=0;const I=new WeakMap;function p(S){if(Array.isArray(S))return S.map(p);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const v=S,h=Object.create(null);for(const d of Object.keys(v).sort())h[d]=p(v[d]);return h}else{let v=I.get(S);return v===void 0&&(v=A++,I.set(S,v)),v+"----2b76a038c20c4bcc"}return S}}),define(ke[75],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=l;function l(L,O){const M=this;let R=!1,b;return function(){if(R)return b;if(R=!0,O)try{b=L.apply(M,arguments)}finally{O()}else b=L.apply(M,arguments);return b}}}),define(ke[125],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0;class l{constructor(O){this.a=O,this.b=0}nextId(){return this.a+ ++this.b}}e.$OO=l,e.$PO=new l("id#")}),define(ke[39],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(L){function O(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=O;const M=Object.freeze([]);function R(){return M}L.empty=R;function*b(t){yield t}L.single=b;function $(t){return O(t)?t:b(t)}L.wrap=$;function E(t){return t||M}L.from=E;function*A(t){for(let u=t.length-1;u>=0;u--)yield t[u]}L.reverse=A;function I(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=I;function p(t){return t[Symbol.iterator]().next().value}L.first=p;function S(t,u){for(const r of t)if(u(r))return!0;return!1}L.some=S;function v(t,u){for(const r of t)if(u(r))return r}L.find=v;function*h(t,u){for(const r of t)u(r)&&(yield r)}L.filter=h;function*d(t,u){let r=0;for(const o of t)yield u(o,r++)}L.map=d;function*c(...t){for(const u of t)yield*u}L.concat=c;function n(t,u,r){let o=r;for(const f of t)o=u(o,f);return o}L.reduce=n;function*i(t,u,r=t.length){for(u<0&&(u+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);u<r;u++)yield t[u]}L.slice=i;function a(t,u=Number.POSITIVE_INFINITY){const r=[];if(u===0)return[r,t];const o=t[Symbol.iterator]();for(let f=0;f<u;f++){const g=o.next();if(g.done)return[r,L.empty()];r.push(g.value)}return[r,{[Symbol.iterator](){return o}}]}L.consume=a;async function s(t){const u=[];for await(const r of t)u.push(r);return Promise.resolve(u)}L.asyncToArray=s})(l||(e.Iterable=l={}))}),define(ke[166],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=R,e.$Kn=I,e.$Ln=p,e.$Mn=S,e.$Nn=v,e.$On=h,e.$Pn=d,e.$Qn=c,e.$Rn=n,e.$Sn=i,e.$Tn=a,e.$Un=s;var l;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(l||(e.ScanError=l={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(t,u=!1){let r=0;const o=t.length;let f="",g=0,w=16,k=0;function m(z){let N=0,F=0;for(;N<z;){const U=t.charCodeAt(r);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;r++,N++}return N<z&&(F=-1),F}function y(z){r=z,f="",g=0,w=16,k=0}function D(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&E(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&E(t.charCodeAt(r)))for(r++;r<t.length&&E(t.charCodeAt(r));)r++;else return k=3,t.substring(z,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&E(t.charCodeAt(r))){for(r++;r<t.length&&E(t.charCodeAt(r));)r++;N=r}else k=3;return t.substring(z,N)}function C(){let z="",N=r;for(;;){if(r>=o){z+=t.substring(N,r),k=2;break}const F=t.charCodeAt(r);if(F===34){z+=t.substring(N,r),r++;break}if(F===92){if(z+=t.substring(N,r),r++,r>=o){k=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Y=m(4);Y>=0?z+=String.fromCharCode(Y):k=4;break}default:k=5}N=r;continue}if(F>=0&&F<=31)if($(F)){z+=t.substring(N,r),k=2;break}else k=6;r++}return z}function P(){if(f="",k=0,g=r,r>=o)return g=o,w=17;let z=t.charCodeAt(r);if(b(z)){do r++,f+=String.fromCharCode(z),z=t.charCodeAt(r);while(b(z));return w=15}if($(z))return r++,f+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,f+=`
`),w=14;switch(z){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,f=C(),w=10;case 47:{const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<o&&!$(t.charCodeAt(r));)r++;return f=t.substring(N,r),w=12}if(t.charCodeAt(r+1)===42){r+=2;const F=o-1;let U=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,k=1),f=t.substring(N,r),w=13}return f+=String.fromCharCode(z),r++,w=16}case 45:if(f+=String.fromCharCode(z),r++,r===o||!E(t.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=D(),w=11;default:for(;r<o&&j(z);)r++,z=t.charCodeAt(r);if(g!==r){switch(f=t.substring(g,r),f){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return f+=String.fromCharCode(z),r++,w=16}}function j(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=P();while(z>=12&&z<=15);return z}return{setPosition:y,getPosition:()=>r,scan:u?T:P,getToken:()=>w,getTokenValue:()=>f,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>k}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,u){const r=[],o=new Object;let f;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(m,y,D,C){g.value=m,g.offset=y,g.length=D,g.type=C,g.colonOffset=void 0,f=g}try{i(t,{onObjectBegin:(m,y)=>{if(u<=m)throw o;f=void 0,w=u>m,r.push("")},onObjectProperty:(m,y,D)=>{if(u<y||(k(m,y,D,"property"),r[r.length-1]=m,u<=y+D))throw o},onObjectEnd:(m,y)=>{if(u<=m)throw o;f=void 0,r.pop()},onArrayBegin:(m,y)=>{if(u<=m)throw o;f=void 0,r.push(0)},onArrayEnd:(m,y)=>{if(u<=m)throw o;f=void 0,r.pop()},onLiteralValue:(m,y,D)=>{if(u<y||(k(m,y,D,s(m)),u<=y+D))throw o},onSeparator:(m,y,D)=>{if(u<=y)throw o;if(m===":"&&f&&f.type==="property")f.colonOffset=y,w=!1,f=void 0;else if(m===","){const C=r[r.length-1];typeof C=="number"?r[r.length-1]=C+1:(w=!0,r[r.length-1]=""),f=void 0}}})}catch(m){if(m!==o)throw m}return{path:r,previousNode:f,isAtPropertyKey:w,matches:m=>{let y=0;for(let D=0;y<m.length&&D<r.length;D++)if(m[y]===r[D]||m[y]==="*")y++;else if(m[y]!=="**")return!1;return y===m.length}}}function p(t,u=[],r=M.DEFAULT){let o=null,f=[];const g=[];function w(m){Array.isArray(f)?f.push(m):o!==null&&(f[o]=m)}return i(t,{onObjectBegin:()=>{const m={};w(m),g.push(f),f=m,o=null},onObjectProperty:m=>{o=m},onObjectEnd:()=>{f=g.pop()},onArrayBegin:()=>{const m=[];w(m),g.push(f),f=m,o=null},onArrayEnd:()=>{f=g.pop()},onLiteralValue:w,onError:(m,y,D)=>{u.push({error:m,offset:y,length:D})}},r),f[0]}function S(t,u=[],r=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(m){o.type==="property"&&(o.length=m-o.offset,o=o.parent)}function g(m){return o.children.push(m),m}i(t,{onObjectBegin:m=>{o=g({type:"object",offset:m,length:-1,parent:o,children:[]})},onObjectProperty:(m,y,D)=>{o=g({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:m,offset:y,length:D,parent:o})},onObjectEnd:(m,y)=>{o.length=m+y-o.offset,o=o.parent,f(m+y)},onArrayBegin:(m,y)=>{o=g({type:"array",offset:m,length:-1,parent:o,children:[]})},onArrayEnd:(m,y)=>{o.length=m+y-o.offset,o=o.parent,f(m+y)},onLiteralValue:(m,y,D)=>{g({type:s(m),offset:y,length:D,parent:o,value:m}),f(y+D)},onSeparator:(m,y,D)=>{o.type==="property"&&(m===":"?o.colonOffset=y:m===","&&f(y))},onError:(m,y,D)=>{u.push({error:m,offset:y,length:D})}},r);const k=o.children[0];return k&&delete k.parent,k}function v(t,u){if(!t)return;let r=t;for(const o of u)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let f=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===o){r=g.children[1],f=!0;break}if(!f)return}else{const f=o;if(r.type!=="array"||f<0||!Array.isArray(r.children)||f>=r.children.length)return;r=r.children[f]}return r}function h(t){if(!t.parent||!t.parent.children)return[];const u=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const u=Object.create(null);for(const r of t.children){const o=r.children[1];o&&(u[r.children[0].value]=d(o))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}function n(t,u,r=!1){if(c(t,u,r)){const o=t.children;if(Array.isArray(o))for(let f=0;f<o.length&&o[f].offset<=u;f++){const g=n(o[f],u,r);if(g)return g}return t}}function i(t,u,r=M.DEFAULT){const o=R(t,!1);function f(be){return be?()=>be(o.getTokenOffset(),o.getTokenLength()):()=>!0}function g(be){return be?ae=>be(ae,o.getTokenOffset(),o.getTokenLength()):()=>!0}const w=f(u.onObjectBegin),k=g(u.onObjectProperty),m=f(u.onObjectEnd),y=f(u.onArrayBegin),D=f(u.onArrayEnd),C=g(u.onLiteralValue),P=g(u.onSeparator),j=f(u.onComment),T=g(u.onError),z=r&&r.disallowComments,N=r&&r.allowTrailingComma;function F(){for(;;){const be=o.scan();switch(o.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:z||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(be){case 12:case 13:z?U(10):j();break;case 16:U(1);break;case 15:case 14:break;default:return be}}}function U(be,ae=[],Ie=[]){if(T(be),ae.length+Ie.length>0){let ee=o.getToken();for(;ee!==17;){if(ae.indexOf(ee)!==-1){F();break}else if(Ie.indexOf(ee)!==-1)break;ee=F()}}}function Y(be){const ae=o.getTokenValue();return be?C(ae):k(ae),F(),!0}function ie(){switch(o.getToken()){case 11:{let be=0;try{be=JSON.parse(o.getTokenValue()),typeof be!="number"&&(U(2),be=0)}catch{U(2)}C(be);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return F(),!0}function H(){return o.getToken()!==10?(U(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(P(":"),F(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function J(){w(),F();let be=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(be||U(4,[],[]),P(","),F(),o.getToken()===2&&N)break}else be&&U(6,[],[]);H()||U(4,[],[2,5]),be=!0}return m(),o.getToken()!==2?U(7,[2],[]):F(),!0}function x(){y(),F();let be=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(be||U(4,[],[]),P(","),F(),o.getToken()===4&&N)break}else be&&U(6,[],[]);ne()||U(4,[],[4,5]),be=!0}return D(),o.getToken()!==4?U(8,[4],[]):F(),!0}function ne(){switch(o.getToken()){case 3:return x();case 1:return J();case 10:return Y(!0);default:return ie()}}return F(),o.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(o.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}function a(t,u){const r=R(t),o=[];let f,g=0,w;do switch(w=r.getPosition(),f=r.scan(),f){case 12:case 13:case 17:g!==w&&o.push(t.substring(g,w)),u!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,u)),g=r.getPosition();break}while(f!==17);return o.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class l{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=l}),define(ke[76],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class l{static{this.Undefined=new l(void 0)}constructor(M){this.element=M,this.next=l.Undefined,this.prev=l.Undefined}}class L{constructor(){this.a=l.Undefined,this.b=l.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===l.Undefined}clear(){let M=this.a;for(;M!==l.Undefined;){const R=M.next;M.prev=l.Undefined,M.next=l.Undefined,M=R}this.a=l.Undefined,this.b=l.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,R){const b=new l(M);if(this.a===l.Undefined)this.a=b,this.b=b;else if(R){const E=this.b;this.b=b,b.prev=E,E.next=b}else{const E=this.a;this.a=b,b.next=E,E.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==l.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==l.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==l.Undefined&&M.next!==l.Undefined){const R=M.prev;R.next=M.next,M.next.prev=R}else M.prev===l.Undefined&&M.next===l.Undefined?(this.a=l.Undefined,this.b=l.Undefined):M.next===l.Undefined?(this.b=this.b.prev,this.b.next=l.Undefined):M.prev===l.Undefined&&(this.a=this.a.next,this.a.prev=l.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==l.Undefined;)yield M.element,M=M.next}}e.$5c=L}),define(ke[27],De([1,0]),function(he,e){"use strict";var l,L,O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=M,e.$yc=R,e.$zc=b,e.$Ic=a;function M(s,t,u){let r=s.get(t);return r===void 0&&(r=u,s.set(t,r)),r}function R(s){const t=[];return s.forEach((u,r)=>{t.push(`${r} => ${u}`)}),`Map(${s.size}) {${t.join(", ")}}`}function b(s){const t=[];return s.forEach(u=>{t.push(u)}),`Set(${s.size}) {${t.join(", ")}}`}class ${constructor(t,u){this.uri=t,this.value=u}}function E(s){return Array.isArray(s)}class A{static{this.c=t=>t.toString()}constructor(t,u){if(this[l]="ResourceMap",t instanceof A)this.d=new Map(t.d),this.e=u??A.c;else if(E(t)){this.d=new Map,this.e=u??A.c;for(const[r,o]of t)this.set(r,o)}else this.d=new Map,this.e=t??A.c}set(t,u){return this.d.set(this.e(t),new $(t,u)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,u){typeof u<"u"&&(t=t.bind(u));for(const[r,o]of this.d)t(o.value,o.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(l=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=A;class I{constructor(t,u){this[L]="ResourceSet",!t||typeof t=="function"?this.c=new A(t):(this.c=new A(u),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,u){this.c.forEach((r,o)=>t.call(u,o,o,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var p;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class S{constructor(){this[O]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,u=0){const r=this.c.get(t);if(r)return u!==0&&this.m(r,u),r.value}set(t,u,r=0){let o=this.c.get(t);if(o)o.value=u,r!==0&&this.m(o,r);else{switch(o={key:t,value:u,next:void 0,previous:void 0},r){case 0:this.k(o);break;case 1:this.j(o);break;case 2:this.k(o);break;default:this.k(o);break}this.c.set(t,o),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this.c.get(t);if(u)return this.c.delete(t),this.l(u),this.f--,u.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,u){const r=this.g;let o=this.d;for(;o;){if(u?t.bind(u)(o.value,o.key,this):t(o.value,o.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,u=this.g;let r=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.key,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return o}values(){const t=this,u=this.g;let r=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.value,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return o}entries(){const t=this,u=this.g;let r=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:[r.key,r.value],done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return o}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this.d,r=this.size;for(;u&&r>t;)this.c.delete(u.key),u=u.next,r--;this.d=u,this.f=r,u&&(u.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this.e,r=this.size;for(;u&&r>t;)this.c.delete(u.key),u=u.previous,r--;this.e=u,this.f=r,u&&(u.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const u=t.next,r=t.previous;if(!u||!r)throw new Error("Invalid list");u.previous=r,r.next=u}t.next=void 0,t.previous=void 0,this.g++}m(t,u){if(!this.d||!this.e)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this.d)return;const r=t.next,o=t.previous;t===this.e?(o.next=void 0,this.e=o):(r.previous=o,o.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(u===2){if(t===this.e)return;const r=t.next,o=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=o,o.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((u,r)=>{t.push([r,u])}),t}fromJSON(t){this.clear();for(const[u,r]of t)this.set(u,r)}}e.$Cc=S;class v extends S{constructor(t,u=1){super(),this.n=t,this.o=Math.min(Math.max(0,u),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends v{constructor(t,u=1){super(t,u)}q(t){this.h(t)}set(t,u){return super.set(t,u),this.p(),this}}e.$Dc=h;class d extends v{constructor(t,u=1){super(t,u)}q(t){this.i(t)}set(t,u){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,u),this}}e.$Ec=d;class c{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let u=this.c.get(t)||0;return u===0?!1:(u--,u===0?this.c.delete(t):this.c.set(t,u),!0)}has(t){return this.c.has(t)}}e.$Fc=c;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[u,r]of t)this.set(u,r)}clear(){this.c.clear(),this.d.clear()}set(t,u){this.c.set(t,u),this.d.set(u,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const u=this.c.get(t);return u===void 0?!1:(this.c.delete(t),this.d.delete(u),!0)}forEach(t,u){this.c.forEach((r,o)=>{t.call(u,r,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class i{constructor(){this.c=new Map}add(t,u){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(u)}delete(t,u){const r=this.c.get(t);r&&(r.delete(u),r.size===0&&this.c.delete(t))}forEach(t,u){const r=this.c.get(t);r&&r.forEach(u)}get(t){const u=this.c.get(t);return u||new Set}}e.$Hc=i;function a(s,t){if(s===t)return!0;if(s.size!==t.size)return!1;for(const[u,r]of s)if(!t.has(u)||t.get(u)!==r)return!1;for(const[u]of t)if(!s.has(u))return!1;return!0}}),define(ke[3],De([1,0,19,74,27,75,39]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=I,e.$Mc=p,e.$Nc=h,e.$Oc=d,e.$Pc=c,e.$Qc=n,e.$Rc=i,e.$Sc=a,e.$3c=m;const b=!1;let $=null;class E{constructor(){this.b=new Map}static{this.a=0}c(C){let P=this.b.get(C);return P||(P={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,P)),P}trackDisposable(C){const P=this.c(C);P.source||(P.source=new Error().stack)}setParent(C,P){const j=this.c(C);j.parent=P}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,P){const j=P.get(C);if(j)return j;const T=C.parent?this.f(this.c(C.parent),P):C;return P.set(C,T),T}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,C).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(C=10,P){let j;if(P)j=P;else{const U=new Map,Y=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,U).isSingleton);if(Y.length===0)return;const ie=new Set(Y.map(H=>H.value));if(j=Y.filter(H=>!(H.parent&&ie.has(H.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function T(U){function Y(H,J){for(;H.length>0&&J.some(x=>typeof x=="string"?x===H[0]:H[0].match(x));)H.shift()}const ie=U.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return Y(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const z=new O.$Hc;for(const U of j){const Y=T(U);for(let ie=0;ie<=Y.length;ie++)z.add(Y.slice(0,ie).join(`
`),U)}j.sort((0,l.$6b)(U=>U.idx,l.$8b));let N="",F=0;for(const U of j.slice(0,C)){F++;const Y=T(U),ie=[];for(let H=0;H<Y.length;H++){let J=Y[H];J=`(shared with ${z.get(Y.slice(0,H+1).join(`
`)).size}/${j.length} leaks) at ${J}`;const ne=z.get(Y.slice(0,H).join(`
`)),be=(0,L.$K)([...ne].map(ae=>T(ae)[H]),ae=>ae);delete be[Y[H]];for(const[ae,Ie]of Object.entries(be))ie.unshift(`    - stacktraces of ${Ie.length} other leaks continue with ${ae}`);ie.unshift(J)}N+=`


==================== Leaking disposable ${F}/${j.length}: ${U.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return j.length>C&&(N+=`


... and ${j.length-C} more leaking disposables

`),{leaks:j,details:N}}}e.$Jc=E;function A(D){$=D}if(b){const D="__is_disposable_tracked__";A(new class{trackDisposable(C){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[D]||console.log(P)},3e3)}setParent(C,P){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsSingleton(C){}})}function I(D){return $?.trackDisposable(D),D}function p(D){$?.markAsDisposed(D)}function S(D,C){$?.setParent(D,C)}function v(D,C){if($)for(const P of D)$.setParent(P,C)}function h(D){return $?.markAsSingleton(D),D}function d(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function c(D){if(R.Iterable.is(D)){const C=[];for(const P of D)if(P)try{P.dispose()}catch(j){C.push(j)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function n(D){for(const C of D)d(C)&&C.dispose();return[]}function i(...D){const C=a(()=>c(D));return v(D,C),C}function a(D){const C=I({dispose:(0,M.$db)(()=>{p(C),D()})});return C}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return S(C,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),S(C,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,I(this),S(this.q,this)}dispose(){p(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class u{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&S(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&S(C,null),C}}e.$Vc=u;class r{constructor(C){this.a=new u,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class o{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=o;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(C){let P=C;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,p(this))},this}}e.$Yc=f;class g{constructor(){this.a=new Map}acquire(C,...P){let j=this.a.get(C);j||(j={counter:0,object:this.b(C,...P)},this.a.set(C,j));const{object:T}=j,z=(0,M.$db)(()=>{--j.counter===0&&(this.c(C,j.object),this.a.delete(C))});return j.counter++,{object:T,dispose:z}}}e.$Zc=g;class w{constructor(C){this.a=C}async acquire(C,...P){const j=this.a.acquire(C,...P);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(T){throw j.dispose(),T}}}e.$1c=w;class k{constructor(C){this.object=C}dispose(){}}e.$2c=k;function m(D){const C=new s;try{D(C)}finally{C.dispose()}}class y{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,P,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(C)?.dispose(),this.a.set(C,P)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=y}),function(he,e){typeof define=="function"&&define.amd?define(ke[167],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ce,oe){for(var le=0;le<oe.length;le++){var K=oe[le];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ce,K.key,K)}}function l(ce,oe,le){return oe&&e(ce.prototype,oe),le&&e(ce,le),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function L(ce,oe){if(ce){if(typeof ce=="string")return O(ce,oe);var le=Object.prototype.toString.call(ce).slice(8,-1);if(le==="Object"&&ce.constructor&&(le=ce.constructor.name),le==="Map"||le==="Set")return Array.from(ce);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return O(ce,oe)}}function O(ce,oe){(oe==null||oe>ce.length)&&(oe=ce.length);for(var le=0,K=new Array(oe);le<oe;le++)K[le]=ce[le];return K}function M(ce,oe){var le=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(le)return(le=le.call(ce)).next.bind(le);if(Array.isArray(ce)||(le=L(ce))||oe&&ce&&typeof ce.length=="number"){le&&(ce=le);var K=0;return function(){return K>=ce.length?{done:!0}:{done:!1,value:ce[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=R();function b(ce){he.defaults=ce}var $=/[&<>"']/,E=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(oe){return p[oe]};function v(ce,oe){if(oe){if($.test(ce))return ce.replace(E,S)}else if(A.test(ce))return ce.replace(I,S);return ce}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ce){return ce.replace(h,function(oe,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var c=/(^|[^\[])\^/g;function n(ce,oe){ce=typeof ce=="string"?ce:ce.source,oe=oe||"";var le={replace:function(se,$e){return $e=$e.source||$e,$e=$e.replace(c,"$1"),ce=ce.replace(se,$e),le},getRegex:function(){return new RegExp(ce,oe)}};return le}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ce,oe,le){if(ce){var K;try{K=decodeURIComponent(d(le)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}oe&&!a.test(le)&&(le=f(oe,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(ce,oe){t[" "+ce]||(u.test(ce)?t[" "+ce]=ce+"/":t[" "+ce]=m(ce,"/",!0)),ce=t[" "+ce];var le=ce.indexOf(":")===-1;return oe.substring(0,2)==="//"?le?oe:ce.replace(r,"$1")+oe:oe.charAt(0)==="/"?le?oe:ce.replace(o,"$1")+oe:ce+oe}var g={exec:function(){}};function w(ce){for(var oe=1,le,K;oe<arguments.length;oe++){le=arguments[oe];for(K in le)Object.prototype.hasOwnProperty.call(le,K)&&(ce[K]=le[K])}return ce}function k(ce,oe){var le=ce.replace(/\|/g,function($e,ve,Me){for(var ge=!1,Pe=ve;--Pe>=0&&Me[Pe]==="\\";)ge=!ge;return ge?"|":" |"}),K=le.split(/ \|/),se=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>oe)K.splice(oe);else for(;K.length<oe;)K.push("");for(;se<K.length;se++)K[se]=K[se].trim().replace(/\\\|/g,"|");return K}function m(ce,oe,le){var K=ce.length;if(K===0)return"";for(var se=0;se<K;){var $e=ce.charAt(K-se-1);if($e===oe&&!le)se++;else if($e!==oe&&le)se++;else break}return ce.slice(0,K-se)}function y(ce,oe){if(ce.indexOf(oe[1])===-1)return-1;for(var le=ce.length,K=0,se=0;se<le;se++)if(ce[se]==="\\")se++;else if(ce[se]===oe[0])K++;else if(ce[se]===oe[1]&&(K--,K<0))return se;return-1}function D(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ce,oe){if(oe<1)return"";for(var le="";oe>1;)oe&1&&(le+=ce),oe>>=1,ce+=ce;return le+ce}function P(ce,oe,le,K){var se=oe.href,$e=oe.title?v(oe.title):null,ve=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){K.state.inLink=!0;var Me={type:"link",raw:le,href:se,title:$e,text:ve,tokens:K.inlineTokens(ve)};return K.state.inLink=!1,Me}return{type:"image",raw:le,href:se,title:$e,text:v(ve)}}function j(ce,oe){var le=ce.match(/^(\s+)(?:```)/);if(le===null)return oe;var K=le[1];return oe.split(`
`).map(function(se){var $e=se.match(/^\s+/);if($e===null)return se;var ve=$e[0];return ve.length>=K.length?se.slice(K.length):se}).join(`
`)}var T=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.space=function(K){var se=this.rules.block.newline.exec(K);if(se&&se[0].length>0)return{type:"space",raw:se[0]}},oe.code=function(K){var se=this.rules.block.code.exec(K);if(se){var $e=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:m($e,`
`)}}},oe.fences=function(K){var se=this.rules.block.fences.exec(K);if(se){var $e=se[0],ve=j($e,se[3]||"");return{type:"code",raw:$e,lang:se[2]?se[2].trim():se[2],text:ve}}},oe.heading=function(K){var se=this.rules.block.heading.exec(K);if(se){var $e=se[2].trim();if(/#$/.test($e)){var ve=m($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:se[0],depth:se[1].length,text:$e,tokens:this.lexer.inline($e)}}},oe.hr=function(K){var se=this.rules.block.hr.exec(K);if(se)return{type:"hr",raw:se[0]}},oe.blockquote=function(K){var se=this.rules.block.blockquote.exec(K);if(se){var $e=se[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},oe.list=function(K){var se=this.rules.block.list.exec(K);if(se){var $e,ve,Me,ge,Pe,Ae,ze,q,W,X,Q,de,we=se[1].trim(),je=we.length>1,qe={type:"list",raw:"",ordered:je,start:je?+we.slice(0,-1):"",loose:!1,items:[]};we=je?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=je?we:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(de=!1,!(!(se=Ke.exec(K))||this.rules.block.hr.test(K)));){if($e=se[0],K=K.substring($e.length),q=se[2].split(`
`,1)[0],W=K.split(`
`,1)[0],this.options.pedantic?(ge=2,Q=q.trimLeft()):(ge=se[2].search(/[^ ]/),ge=ge>4?1:ge,Q=q.slice(ge),ge+=se[1].length),Ae=!1,!q&&/^ *$/.test(W)&&($e+=W+`
`,K=K.substring(W.length+1),de=!0),!de)for(var tt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");K&&(X=K.split(`
`,1)[0],q=X,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(q)||it.test(q)||tt.test(q)||_e.test(K)));){if(q.search(/[^ ]/)>=ge||!q.trim())Q+=`
`+q.slice(ge);else if(!Ae)Q+=`
`+q;else break;!Ae&&!q.trim()&&(Ae=!0),$e+=X+`
`,K=K.substring(X.length+1)}qe.loose||(ze?qe.loose=!0:/\n *\n *$/.test($e)&&(ze=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(Q),ve&&(Me=ve[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:$e,task:!!ve,checked:Me,loose:!1,text:Q}),qe.raw+=$e}qe.items[qe.items.length-1].raw=$e.trimRight(),qe.items[qe.items.length-1].text=Q.trimRight(),qe.raw=qe.raw.trimRight();var rt=qe.items.length;for(Pe=0;Pe<rt;Pe++){this.lexer.state.top=!1,qe.items[Pe].tokens=this.lexer.blockTokens(qe.items[Pe].text,[]);var ct=qe.items[Pe].tokens.filter(function(Se){return Se.type==="space"}),Re=ct.every(function(Se){for(var Ve=Se.raw.split(""),te=0,re=M(Ve),Ce;!(Ce=re()).done;){var Ge=Ce.value;if(Ge===`
`&&(te+=1),te>1)return!0}return!1});!qe.loose&&ct.length&&Re&&(qe.loose=!0,qe.items[Pe].loose=!0)}return qe}},oe.html=function(K){var se=this.rules.block.html.exec(K);if(se){var $e={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},oe.def=function(K){var se=this.rules.block.def.exec(K);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var $e=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:se[0],href:se[2],title:se[3]}}},oe.table=function(K){var se=this.rules.block.table.exec(K);if(se){var $e={type:"table",header:k(se[1]).map(function(ze){return{text:ze}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]&&se[3].trim()?se[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=se[0];var ve=$e.align.length,Me,ge,Pe,Ae;for(Me=0;Me<ve;Me++)/^ *-+: *$/.test($e.align[Me])?$e.align[Me]="right":/^ *:-+: *$/.test($e.align[Me])?$e.align[Me]="center":/^ *:-+ *$/.test($e.align[Me])?$e.align[Me]="left":$e.align[Me]=null;for(ve=$e.rows.length,Me=0;Me<ve;Me++)$e.rows[Me]=k($e.rows[Me],$e.header.length).map(function(ze){return{text:ze}});for(ve=$e.header.length,ge=0;ge<ve;ge++)$e.header[ge].tokens=this.lexer.inline($e.header[ge].text);for(ve=$e.rows.length,ge=0;ge<ve;ge++)for(Ae=$e.rows[ge],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=this.lexer.inline(Ae[Pe].text);return $e}}},oe.lheading=function(K){var se=this.rules.block.lheading.exec(K);if(se)return{type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:this.lexer.inline(se[1])}},oe.paragraph=function(K){var se=this.rules.block.paragraph.exec(K);if(se){var $e=se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1];return{type:"paragraph",raw:se[0],text:$e,tokens:this.lexer.inline($e)}}},oe.text=function(K){var se=this.rules.block.text.exec(K);if(se)return{type:"text",raw:se[0],text:se[0],tokens:this.lexer.inline(se[0])}},oe.escape=function(K){var se=this.rules.inline.escape.exec(K);if(se)return{type:"escape",raw:se[0],text:v(se[1])}},oe.tag=function(K){var se=this.rules.inline.tag.exec(K);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]):se[0]}},oe.link=function(K){var se=this.rules.inline.link.exec(K);if(se){var $e=se[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=m($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Me=y(se[2],"()");if(Me>-1){var ge=se[0].indexOf("!")===0?5:4,Pe=ge+se[1].length+Me;se[2]=se[2].substring(0,Me),se[0]=se[0].substring(0,Pe).trim(),se[3]=""}}var Ae=se[2],ze="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);q&&(Ae=q[1],ze=q[3])}else ze=se[3]?se[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test($e)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),P(se,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},oe.reflink=function(K,se){var $e;if(($e=this.rules.inline.reflink.exec(K))||($e=this.rules.inline.nolink.exec(K))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=se[ve.toLowerCase()],!ve||!ve.href){var Me=$e[0].charAt(0);return{type:"text",raw:Me,text:Me}}return P($e,ve,$e[0],this.lexer)}},oe.emStrong=function(K,se,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(K);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=ve[1]||ve[2]||"";if(!Me||Me&&($e===""||this.rules.inline.punctuation.exec($e))){var ge=ve[0].length-1,Pe,Ae,ze=ge,q=0,W=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,se=se.slice(-1*K.length+ge);(ve=W.exec(se))!=null;)if(Pe=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Pe){if(Ae=Pe.length,ve[3]||ve[4]){ze+=Ae;continue}else if((ve[5]||ve[6])&&ge%3&&!((ge+Ae)%3)){q+=Ae;continue}if(ze-=Ae,!(ze>0)){if(Ae=Math.min(Ae,Ae+ze+q),Math.min(ge,Ae)%2){var X=K.slice(1,ge+ve.index+Ae);return{type:"em",raw:K.slice(0,ge+ve.index+Ae+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Q=K.slice(2,ge+ve.index+Ae-1);return{type:"strong",raw:K.slice(0,ge+ve.index+Ae+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},oe.codespan=function(K){var se=this.rules.inline.code.exec(K);if(se){var $e=se[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Me=/^ /.test($e)&&/ $/.test($e);return ve&&Me&&($e=$e.substring(1,$e.length-1)),$e=v($e,!0),{type:"codespan",raw:se[0],text:$e}}},oe.br=function(K){var se=this.rules.inline.br.exec(K);if(se)return{type:"br",raw:se[0]}},oe.del=function(K){var se=this.rules.inline.del.exec(K);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2])}},oe.autolink=function(K,se){var $e=this.rules.inline.autolink.exec(K);if($e){var ve,Me;return $e[2]==="@"?(ve=v(this.options.mangle?se($e[1]):$e[1]),Me="mailto:"+ve):(ve=v($e[1]),Me=ve),{type:"link",raw:$e[0],text:ve,href:Me,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.url=function(K,se){var $e;if($e=this.rules.inline.url.exec(K)){var ve,Me;if($e[2]==="@")ve=v(this.options.mangle?se($e[0]):$e[0]),Me="mailto:"+ve;else{var ge;do ge=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(ge!==$e[0]);ve=v($e[0]),$e[1]==="www."?Me="http://"+ve:Me=ve}return{type:"link",raw:$e[0],text:ve,href:Me,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.inlineText=function(K,se){var $e=this.rules.inline.text.exec(K);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):v($e[0]):$e[0]:ve=v(this.options.smartypants?se($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=w({},z),z.gfm=w({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=w({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=n(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=n(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=n(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=n(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=n(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=n(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=n(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=n(N.reflink).replace("label",N._label).replace("ref",z._label).getRegex(),N.nolink=n(N.nolink).replace("ref",z._label).getRegex(),N.reflinkSearch=n(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=w({},N),N.pedantic=w({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=w({},N.normal,{escape:n(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=n(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=w({},N.gfm,{br:n(N.br).replace("{2,}","*").getRegex(),text:n(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ce){var oe="",le,K,se=ce.length;for(le=0;le<se;le++)K=ce.charCodeAt(le),Math.random()>.5&&(K="x"+K.toString(16)),oe+="&#"+K+";";return oe}var Y=function(){function ce(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||he.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:N.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=N.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=N.breaks:K.inline=N.gfm),this.tokenizer.rules=K}ce.lex=function(K,se){var $e=new ce(se);return $e.lex(K)},ce.lexInline=function(K,se){var $e=new ce(se);return $e.inlineTokens(K)};var oe=ce.prototype;return oe.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},oe.blockTokens=function(K,se){var $e=this;se===void 0&&(se=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(ze,q,W){return q+"    ".repeat(W.length)});for(var ve,Me,ge,Pe;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(ve=ze.call({lexer:$e},K,se))?(K=K.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.space(K)){K=K.substring(ve.raw.length),ve.raw.length===1&&se.length>0?se[se.length-1].raw+=`
`:se.push(ve);continue}if(ve=this.tokenizer.code(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):se.push(ve);continue}if(ve=this.tokenizer.fences(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.heading(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.hr(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.blockquote(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.list(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.html(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.def(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.lheading(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ge=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,q=K.slice(1),W=void 0;$e.options.extensions.startBlock.forEach(function(X){W=X.call({lexer:this},q),typeof W=="number"&&W>=0&&(ze=Math.min(ze,W))}),ze<1/0&&ze>=0&&(ge=K.substring(0,ze+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(ge))){Me=se[se.length-1],Pe&&Me.type==="paragraph"?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):se.push(ve),Pe=ge.length!==K.length,K=K.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):se.push(ve);continue}if(K){var Ae="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,se},oe.inline=function(K,se){return se===void 0&&(se=[]),this.inlineQueue.push({src:K,tokens:se}),se},oe.inlineTokens=function(K,se){var $e=this;se===void 0&&(se=[]);var ve,Me,ge,Pe=K,Ae,ze,q;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)W.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(ze||(q=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(ve=Q.call({lexer:$e},K,se))?(K=K.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.tag(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&ve.type==="text"&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.link(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&ve.type==="text"&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.emStrong(K,Pe,q)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.codespan(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.br(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.del(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.autolink(K,U)){K=K.substring(ve.raw.length),se.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(K,U))){K=K.substring(ve.raw.length),se.push(ve);continue}if(ge=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,de=K.slice(1),we=void 0;$e.options.extensions.startInline.forEach(function(je){we=je.call({lexer:this},de),typeof we=="number"&&we>=0&&(Q=Math.min(Q,we))}),Q<1/0&&Q>=0&&(ge=K.substring(0,Q+1))}(),ve=this.tokenizer.inlineText(ge,F)){K=K.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(q=ve.raw.slice(-1)),ze=!0,Me=se[se.length-1],Me&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):se.push(ve);continue}if(K){var X="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return se},l(ce,null,[{key:"rules",get:function(){return{block:z,inline:N}}}]),ce}(),ie=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.code=function(K,se,$e){var ve=(se||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(K,ve);Me!=null&&Me!==K&&($e=!0,K=Me)}return K=K.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+v(ve,!0)+'">'+($e?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+($e?K:v(K,!0))+`</code></pre>
`},oe.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},oe.html=function(K){return K},oe.heading=function(K,se,$e,ve){if(this.options.headerIds){var Me=this.options.headerPrefix+ve.slug($e);return"<h"+se+' id="'+Me+'">'+K+"</h"+se+`>
`}return"<h"+se+">"+K+"</h"+se+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(K,se,$e){var ve=se?"ol":"ul",Me=se&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Me+`>
`+K+"</"+ve+`>
`},oe.listitem=function(K){return"<li>"+K+`</li>
`},oe.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(K){return"<p>"+K+`</p>
`},oe.table=function(K,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+se+`</table>
`},oe.tablerow=function(K){return`<tr>
`+K+`</tr>
`},oe.tablecell=function(K,se){var $e=se.header?"th":"td",ve=se.align?"<"+$e+' align="'+se.align+'">':"<"+$e+">";return ve+K+("</"+$e+`>
`)},oe.strong=function(K){return"<strong>"+K+"</strong>"},oe.em=function(K){return"<em>"+K+"</em>"},oe.codespan=function(K){return"<code>"+K+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(K){return"<del>"+K+"</del>"},oe.link=function(K,se,$e){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var ve='<a href="'+v(K)+'"';return se&&(ve+=' title="'+se+'"'),ve+=">"+$e+"</a>",ve},oe.image=function(K,se,$e){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var ve='<img src="'+K+'" alt="'+$e+'"';return se&&(ve+=' title="'+se+'"'),ve+=this.options.xhtml?"/>":">",ve},oe.text=function(K){return K},ce}(),H=function(){function ce(){}var oe=ce.prototype;return oe.strong=function(K){return K},oe.em=function(K){return K},oe.codespan=function(K){return K},oe.del=function(K){return K},oe.html=function(K){return K},oe.text=function(K){return K},oe.link=function(K,se,$e){return""+$e},oe.image=function(K,se,$e){return""+$e},oe.br=function(){return""},ce}(),J=function(){function ce(){this.seen={}}var oe=ce.prototype;return oe.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(K,se){var $e=K,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[K];do ve++,$e=K+"-"+ve;while(this.seen.hasOwnProperty($e))}return se||(this.seen[K]=ve,this.seen[$e]=0),$e},oe.slug=function(K,se){se===void 0&&(se={});var $e=this.serialize(K);return this.getNextSafeSlug($e,se.dryrun)},ce}(),x=function(){function ce(le){this.options=le||he.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new J}ce.parse=function(K,se){var $e=new ce(se);return $e.parse(K)},ce.parseInline=function(K,se){var $e=new ce(se);return $e.parseInline(K)};var oe=ce.prototype;return oe.parse=function(K,se){se===void 0&&(se=!0);var $e="",ve,Me,ge,Pe,Ae,ze,q,W,X,Q,de,we,je,qe,Ke,tt,_e,nt,it,rt=K.length;for(ve=0;ve<rt;ve++){if(Q=K[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(it=this.options.extensions.renderers[Q.type].call({parser:this},Q),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){$e+=it||"";continue}switch(Q.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,d(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(W="",q="",Pe=Q.header.length,Me=0;Me<Pe;Me++)q+=this.renderer.tablecell(this.parseInline(Q.header[Me].tokens),{header:!0,align:Q.align[Me]});for(W+=this.renderer.tablerow(q),X="",Pe=Q.rows.length,Me=0;Me<Pe;Me++){for(ze=Q.rows[Me],q="",Ae=ze.length,ge=0;ge<Ae;ge++)q+=this.renderer.tablecell(this.parseInline(ze[ge].tokens),{header:!1,align:Q.align[ge]});X+=this.renderer.tablerow(q)}$e+=this.renderer.table(W,X);continue}case"blockquote":{X=this.parse(Q.tokens),$e+=this.renderer.blockquote(X);continue}case"list":{for(de=Q.ordered,we=Q.start,je=Q.loose,Pe=Q.items.length,X="",Me=0;Me<Pe;Me++)Ke=Q.items[Me],tt=Ke.checked,_e=Ke.task,qe="",Ke.task&&(nt=this.renderer.checkbox(tt),je?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):qe+=nt),qe+=this.parse(Ke.tokens,je),X+=this.renderer.listitem(qe,_e,tt);$e+=this.renderer.list(X,de,we);continue}case"html":{$e+=this.renderer.html(Q.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(X=Q.tokens?this.parseInline(Q.tokens):Q.text;ve+1<rt&&K[ve+1].type==="text";)Q=K[++ve],X+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);$e+=se?this.renderer.paragraph(X):X;continue}default:{var ct='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return $e},oe.parseInline=function(K,se){se=se||this.renderer;var $e="",ve,Me,ge,Pe=K.length;for(ve=0;ve<Pe;ve++){if(Me=K[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(ge=this.options.extensions.renderers[Me.type].call({parser:this},Me),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){$e+=ge||"";continue}switch(Me.type){case"escape":{$e+=se.text(Me.text);break}case"html":{$e+=se.html(Me.text);break}case"link":{$e+=se.link(Me.href,Me.title,this.parseInline(Me.tokens,se));break}case"image":{$e+=se.image(Me.href,Me.title,Me.text);break}case"strong":{$e+=se.strong(this.parseInline(Me.tokens,se));break}case"em":{$e+=se.em(this.parseInline(Me.tokens,se));break}case"codespan":{$e+=se.codespan(Me.text);break}case"br":{$e+=se.br();break}case"del":{$e+=se.del(this.parseInline(Me.tokens,se));break}case"text":{$e+=se.text(Me.text);break}default:{var Ae='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return $e},ce}();function ne(ce,oe,le){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof oe=="function"&&(le=oe,oe=null),oe=w({},ne.defaults,oe||{}),D(oe),le){var K=oe.highlight,se;try{se=Y.lex(ce,oe)}catch(Pe){return le(Pe)}var $e=function(Ae){var ze;if(!Ae)try{oe.walkTokens&&ne.walkTokens(se,oe.walkTokens),ze=x.parse(se,oe)}catch(q){Ae=q}return oe.highlight=K,Ae?le(Ae):le(null,ze)};if(!K||K.length<3||(delete oe.highlight,!se.length))return $e();var ve=0;ne.walkTokens(se,function(Pe){Pe.type==="code"&&(ve++,setTimeout(function(){K(Pe.text,Pe.lang,function(Ae,ze){if(Ae)return $e(Ae);ze!=null&&ze!==Pe.text&&(Pe.text=ze,Pe.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Me(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(Pe.message+"",!0)+"</pre>";throw Pe}try{var ge=Y.lex(ce,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ne.walkTokens(ge,oe.walkTokens)).then(function(){return x.parse(ge,oe)}).catch(Me);ne.walkTokens(ge,oe.walkTokens)}return x.parse(ge,oe)}catch(Pe){Me(Pe)}}ne.options=ne.setOptions=function(ce){return w(ne.defaults,ce),b(ne.defaults),ne},ne.getDefaults=R,ne.defaults=he.defaults,ne.use=function(){for(var ce=arguments.length,oe=new Array(ce),le=0;le<ce;le++)oe[le]=arguments[le];var K=w.apply(void 0,[{}].concat(oe)),se=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;oe.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Pe=se.renderers?se.renderers[ge.name]:null;Pe?se.renderers[ge.name]=function(){for(var Ae=arguments.length,ze=new Array(Ae),q=0;q<Ae;q++)ze[q]=arguments[q];var W=ge.renderer.apply(this,ze);return W===!1&&(W=Pe.apply(this,ze)),W}:se.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[ge.level]?se[ge.level].unshift(ge.tokenizer):se[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?se.startBlock?se.startBlock.push(ge.start):se.startBlock=[ge.start]:ge.level==="inline"&&(se.startInline?se.startInline.push(ge.start):se.startInline=[ge.start]))}ge.childTokens&&(se.childTokens[ge.name]=ge.childTokens)})),ve.renderer&&function(){var ge=ne.defaults.renderer||new ie,Pe=function(q){var W=ge[q];ge[q]=function(){for(var X=arguments.length,Q=new Array(X),de=0;de<X;de++)Q[de]=arguments[de];var we=ve.renderer[q].apply(ge,Q);return we===!1&&(we=W.apply(ge,Q)),we}};for(var Ae in ve.renderer)Pe(Ae);K.renderer=ge}(),ve.tokenizer&&function(){var ge=ne.defaults.tokenizer||new T,Pe=function(q){var W=ge[q];ge[q]=function(){for(var X=arguments.length,Q=new Array(X),de=0;de<X;de++)Q[de]=arguments[de];var we=ve.tokenizer[q].apply(ge,Q);return we===!1&&(we=W.apply(ge,Q)),we}};for(var Ae in ve.tokenizer)Pe(Ae);K.tokenizer=ge}(),ve.walkTokens){var Me=ne.defaults.walkTokens;K.walkTokens=function(ge){var Pe=[];return Pe.push(ve.walkTokens.call(this,ge)),Me&&(Pe=Pe.concat(Me.call(this,ge))),Pe}}$e&&(K.extensions=se),ne.setOptions(K)})},ne.walkTokens=function(ce,oe){for(var le=[],K=function(){var Me=$e.value;switch(le=le.concat(oe.call(ne,Me)),Me.type){case"table":{for(var ge=M(Me.header),Pe;!(Pe=ge()).done;){var Ae=Pe.value;le=le.concat(ne.walkTokens(Ae.tokens,oe))}for(var ze=M(Me.rows),q;!(q=ze()).done;)for(var W=q.value,X=M(W),Q;!(Q=X()).done;){var de=Q.value;le=le.concat(ne.walkTokens(de.tokens,oe))}break}case"list":{le=le.concat(ne.walkTokens(Me.items,oe));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Me.type]?ne.defaults.extensions.childTokens[Me.type].forEach(function(we){le=le.concat(ne.walkTokens(Me[we],oe))}):Me.tokens&&(le=le.concat(ne.walkTokens(Me.tokens,oe)))}},se=M(ce),$e;!($e=se()).done;)K();return le},ne.parseInline=function(ce,oe){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");oe=w({},ne.defaults,oe||{}),D(oe);try{var le=Y.lexInline(ce,oe);return oe.walkTokens&&ne.walkTokens(le,oe.walkTokens),x.parseInline(le,oe)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},ne.Parser=x,ne.parser=x.parse,ne.Renderer=ie,ne.TextRenderer=H,ne.Lexer=Y,ne.lexer=Y.lex,ne.Tokenizer=T,ne.Slugger=J,ne.parse=ne;var be=ne.options,ae=ne.setOptions,Ie=ne.use,ee=ne.walkTokens,B=ne.parseInline,_=ne,pe=x.parse,ue=Y.lex;he.Lexer=Y,he.Parser=x,he.Renderer=ie,he.Slugger=J,he.TextRenderer=H,he.Tokenizer=T,he.getDefaults=R,he.lexer=ue,he.marked=ne,he.options=be,he.parse=_,he.parseInline=B,he.parser=pe,he.setOptions=ae,he.use=Ie,he.walkTokens=ee,Object.defineProperty(he,"__esModule",{value:!0})}),define(ke[168],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=l;function l(h){const d=M(h);if(d&&d.length>0)return new Uint32Array(d)}let L=0;const O=new Uint32Array(10);function M(h){if(L=0,R(h,I,4352),L>0||(R(h,p,4449),L>0)||(R(h,S,4520),L>0)||(R(h,v,12593),L))return O.subarray(0,L);if(h>=44032&&h<=55203){const d=h-44032,c=d%588,n=Math.floor(d/588),i=Math.floor(c/28),a=c%28-1;if(n<I.length?R(n,I,0):4352+n-12593<v.length&&R(4352+n,v,12593),i<p.length?R(i,p,0):4449+i-12593<v.length&&R(4449+i-12593,v,12593),a>=0&&(a<S.length?R(a,S,0):4520+a-12593<v.length&&R(4520+a-12593,v,12593)),L>0)return O.subarray(0,L)}}function R(h,d,c){h>=c&&h<c+d.length&&b(d[h-c])}function b(h){h!==0&&(O[L++]=h&255,h>>8&&(O[L++]=h>>8&255),h>>16&&(O[L++]=h>>16&255))}var $;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var E;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(E||(E={}));var A;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(A||(A={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[77],De([1,0,27]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=void 0,e.$dm=O,e.$em=R;const L=new l.$Dc(1e4);function O(E){return $(E,"NFC",L)}const M=new l.$Dc(1e4);function R(E){return $(E,"NFD",M)}const b=/[^\u0000-\u0080]/;function $(E,A,I){if(!E)return E;const p=I.get(E);if(p)return p;let S;return b.test(E)?S=E.normalize(A):S=E,I.set(E,S),S}e.$fm=function(){const E=/[\u0300-\u036f]/g;return function(A){return R(A).replace(E,"")}}()}),define(ke[126],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=l,e.rot=L;function l(b,$,E){return Math.min(Math.max(b,$),E)}function L(b,$){return($+b%$)%$}class O{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=O;class M{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=M;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const E=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=R}),define(ke[169],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=M,e.$cd=p;class l{constructor(v,h,d){this.owner=v,this.debugNameSource=h,this.referenceFn=d}getDebugName(v){return M(v,this)}}e.$ad=l;const L=new Map,O=new WeakMap;function M(S,v){const h=O.get(S);if(h)return h;const d=R(S,v);if(d){let c=L.get(d)??0;c++,L.set(d,c);const n=c===1?d:`${d}#${c}`;return O.set(S,n),n}}function R(S,v){const h=O.get(S);if(h)return h;const d=v.owner?A(v.owner)+".":"";let c;const n=v.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(c=n(),c!==void 0)return d+c}else return d+n;const i=v.referenceFn;if(i!==void 0&&(c=p(i),c!==void 0))return d+c;if(v.owner!==void 0){const a=b(v.owner,S);if(a!==void 0)return d+a}}function b(S,v){for(const h in S)if(S[h]===v)return h}const $=new Map,E=new WeakMap;function A(S){const v=E.get(S);if(v)return v;const h=I(S);let d=$.get(h)??0;d++,$.set(h,d);const c=d===1?h:`${h}#${d}`;return E.set(S,c),c}function I(S){const v=S.constructor;return v?v.name:"Object"}function p(S){const v=S.toString(),d=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(v);return(d?d[1]:void 0)?.trim()}}),define(ke[170],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=L,e.$Id=O;let l;function L(h){l=h}function O(){return l}class M{constructor(){this.a=0,this.d=new WeakMap}b(d){return R([b(S("|  ",this.a)),d])}c(d){return d.hadValue?d.didChange?[b(" "),E(A(d.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),E(A(d.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),E(A(d.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(d,c){console.log(...this.b([$("observable value changed"),E(d.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(d){if(d.size!==0)return E(" (changed deps: "+[...d].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(d){const c=d.handleChange;this.d.set(d,new Set),d.handleChange=(n,i)=>(this.d.get(d).add(n),c.apply(d,[n,i]))}handleDerivedRecomputed(d,c){const n=this.d.get(d);console.log(...this.b([$("derived recomputed"),E(d.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(n),{data:[{fn:d._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(d,c){console.log(...this.b([$("observable from event triggered"),E(d.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:d._getValue}]}]))}handleAutorunCreated(d){const c=d.handleChange;this.d.set(d,new Set),d.handleChange=(n,i)=>(this.d.get(d).add(n),c.apply(d,[n,i]))}handleAutorunTriggered(d){const c=this.d.get(d);console.log(...this.b([$("autorun"),E(d.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:d._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(d){this.a--}handleBeginTransaction(d){let c=d.getDebugName();c===void 0&&(c=""),console.log(...this.b([$("transaction"),E(c,{color:"BlueViolet"}),{data:[{fn:d._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=M;function R(h){const d=new Array,c=[];let n="";function i(s){if("length"in s)for(const t of s)t&&i(t);else"text"in s?(n+=`%c${s.text}`,d.push(s.style),s.data&&c.push(...s.data)):"data"in s&&c.push(...s.data)}i(h);const a=[n,...d];return a.push(...c),a}function b(h){return E(h,{color:"black"})}function $(h){return E(v(`${h}: `,10),{color:"black",bold:!0})}function E(h,d={color:"black"}){function c(i){return Object.entries(i).reduce((a,[s,t])=>`${a}${s}:${t};`,"")}const n={color:d.color};return d.strikeThrough&&(n["text-decoration"]="line-through"),d.bold&&(n["font-weight"]="bold"),{text:h,style:c(n)}}function A(h,d){switch(typeof h){case"number":return""+h;case"string":return h.length+2<=d?`"${h}"`:`"${h.substr(0,d-7)}"+...`;case"boolean":return h?"true":"false";case"undefined":return"undefined";case"object":return h===null?"null":Array.isArray(h)?I(h,d):p(h,d);case"symbol":return h.toString();case"function":return`[[Function${h.name?" "+h.name:""}]]`;default:return""+h}}function I(h,d){let c="[ ",n=!0;for(const i of h){if(n||(c+=", "),c.length-5>d){c+="...";break}n=!1,c+=`${A(i,d-c.length)}`}return c+=" ]",c}function p(h,d){let c="{ ",n=!0;for(const[i,a]of Object.entries(h)){if(n||(c+=", "),c.length-5>d){c+="...";break}n=!1,c+=`${i}: ${A(a,d-c.length)}`}return c+=" }",c}function S(h,d){let c="";for(let n=1;n<=d;n++)c+=h;return c}function v(h,d){for(;h.length<d;)h+=" ";return h}}),define(ke[171],De([1,0,165,169,170]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=R,e.$Td=$,e.$Ud=A,e.$Xd=S,e.$Yd=h,e.$Zd=d,e.$1d=c,e.$3d=i,e.$4d=a,e.$6d=t;let M;function R(r){M=r}let b;function $(r){b=r}let E;function A(r){E=r}class I{get TChange(){return null}reportChanges(){this.get()}read(o){return o?o.readObservable(this):this.get()}map(o,f){const g=f===void 0?void 0:o,w=f===void 0?o:f;return E({owner:g,debugName:()=>{const k=(0,L.$cd)(w);if(k!==void 0)return k;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(w.toString());if(y)return`${this.debugName}.${y[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:w},k=>w(this.read(k),k))}recomputeInitiallyAndOnChange(o,f){return o.add(M(this,f)),this}keepObserved(o){return o.add(b(this)),this}get a(){return this.get()}}e.$Vd=I;class p extends I{constructor(){super(...arguments),this.b=new Set}addObserver(o){const f=this.b.size;this.b.add(o),f===0&&this.c()}removeObserver(o){this.b.delete(o)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=p;function S(r,o){const f=new n(r,o);try{r(f)}finally{f.finish()}}let v;function h(r){if(v)r(v);else{const o=new n(r,void 0);v=o;try{r(o)}finally{o.finish(),v=void 0}}}async function d(r,o){const f=new n(r,o);try{await r(f)}finally{f.finish()}}function c(r,o,f){r?o(r):S(o,f)}class n{constructor(o,f){this._fn=o,this.b=f,this.a=[],(0,O.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,L.$cd)(this._fn)}updateObserver(o,f){this.a.push({observer:o,observable:f}),o.beginUpdate(f)}finish(){const o=this.a;for(let f=0;f<o.length;f++){const{observer:g,observable:w}=o[f];g.endUpdate(w)}this.a=null,(0,O.$Id)()?.handleEndTransaction()}}e.$2d=n;function i(r,o){let f;return typeof r=="string"?f=new L.$ad(void 0,r,void 0):f=new L.$ad(r,void 0,void 0),new s(f,o,l.$6c)}function a(r,o){return new s(new L.$ad(r.owner,r.debugName,void 0),o,r.equalsFn??l.$6c)}class s extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(o,f,g){super(),this.e=o,this.g=g,this.d=f}get(){return this.d}set(o,f,g){if(g===void 0&&this.g(this.d,o))return;let w;f||(f=w=new n(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(o),(0,O.$Id)()?.handleObservableChanged(this,{oldValue:k,newValue:o,change:g,didChange:!0,hadValue:!0});for(const m of this.b)f.updateObserver(m,this),m.handleChange(this,g)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(o){this.d=o}}e.$5d=s;function t(r,o){let f;return typeof r=="string"?f=new L.$ad(void 0,r,void 0):f=new L.$ad(r,void 0,void 0),new u(f,o,l.$6c)}class u extends s{h(o){this.d!==o&&(this.d&&this.d.dispose(),this.d=o)}dispose(){this.d?.dispose()}}e.$7d=u}),function(){function he(O){const M=[];typeof O=="number"&&M.push("code/timeOrigin",O);function R($){M.push($,Date.now())}function b(){const $=[];for(let E=0;E<M.length;E+=2)$.push({name:M[E],startTime:M[E+1]});return $}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(O+R.startTime)});return M}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function l(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=l(L))}(),define(ke[172],De([1,0,39]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;const L=Symbol("unset");class O{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||l.Iterable.empty()}insert($,E,A){this.d($,I=>I._value=E,A)}mutate($,E){this.d($,A=>A._value=E(A._value===L?void 0:A._value))}delete($){const E=this.c($);if(!E)return;let A=E.length-1;const I=E[A].node._value;if(I!==L){for(this.b--,E[A].node._value=L;A>0;A--){const{node:p,part:S}=E[A];if(p.children?.size||p._value!==L)break;E[A-1].node.children.delete(S)}return I}}*deleteRecursive($){const E=this.c($);if(!E)return;const A=E[E.length-1].node;for(let I=E.length-1;I>0;I--){const p=E[I-1];if(p.node.children.delete(E[I].part),p.node.children.size>0||p.node._value!==L)break}for(const I of M(A))I._value!==L&&(this.b--,yield I._value)}find($){let E=this.a;for(const A of $){const I=E.children?.get(A);if(!I)return;E=I}return E._value===L?void 0:E._value}hasKeyOrParent($){let E=this.a;for(const A of $){const I=E.children?.get(A);if(!I)return!1;if(I._value!==L)return!0;E=I}return!1}hasKeyOrChildren($){let E=this.a;for(const A of $){const I=E.children?.get(A);if(!I)return!1;E=I}return!0}hasKey($){let E=this.a;for(const A of $){const I=E.children?.get(A);if(!I)return!1;E=I}return E._value!==L}c($){const E=[{part:"",node:this.a}];let A=0;for(const I of $){const p=E[A].node.children?.get(I);if(!p)return;E.push({part:I,node:p}),A++}return E}d($,E,A){let I=this.a;for(const v of $){if(I.children)if(I.children.has(v))I=I.children.get(v);else{const h=new R;I.children.set(v,h),I=h}else{const h=new R;I.children=new Map([[v,h]]),I=h}A?.(I)}const p=I._value===L?0:1;E(I);const S=I._value===L?0:1;this.b+=S-p}*values(){for(const{_value:$}of M(this.a))$!==L&&(yield $)}}e.$yO=O;function*M(b){const $=[b];for(;$.length>0;){const E=$.pop();if(yield E,E.children)for(const A of E.children.values())$.push(A)}}class R{constructor(){this._value=L}get value(){return this._value===L?void 0:this._value}set value($){this._value=$===void 0?L:$}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var L in l)(typeof exports=="object"?exports:he)[L]=l[L]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function l(L){if(e[L])return e[L].exports;var O=e[L]={i:L,l:!1,exports:{}};return he[L].call(O.exports,O,O.exports,l),O.l=!0,O.exports}return l.m=he,l.c=e,l.d=function(L,O,M){l.o(L,O)||Object.defineProperty(L,O,{enumerable:!0,get:M})},l.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},l.t=function(L,O){if(1&O&&(L=l(L)),8&O||4&O&&typeof L=="object"&&L&&L.__esModule)return L;var M=Object.create(null);if(l.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:L}),2&O&&typeof L!="string")for(var R in L)l.d(M,R,function(b){return L[b]}.bind(null,R));return M},l.n=function(L){var O=L&&L.__esModule?function(){return L.default}:function(){return L};return l.d(O,"a",O),O},l.o=function(L,O){return Object.prototype.hasOwnProperty.call(L,O)},l.p="",l(l.s=0)}([function(he,e,l){(function(L){var O;e=he.exports=Ie,O=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],E=0,A=E++;$[A]="0|[1-9]\\d*";var I=E++;$[I]="[0-9]+";var p=E++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;$[S]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var v=E++;$[v]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var h=E++;$[h]="(?:"+$[A]+"|"+$[p]+")";var d=E++;$[d]="(?:"+$[I]+"|"+$[p]+")";var c=E++;$[c]="(?:-("+$[h]+"(?:\\."+$[h]+")*))";var n=E++;$[n]="(?:-?("+$[d]+"(?:\\."+$[d]+")*))";var i=E++;$[i]="[0-9A-Za-z-]+";var a=E++;$[a]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var s=E++,t="v?"+$[S]+$[c]+"?"+$[a]+"?";$[s]="^"+t+"$";var u="[v=\\s]*"+$[v]+$[n]+"?"+$[a]+"?",r=E++;$[r]="^"+u+"$";var o=E++;$[o]="((?:<|>)?=?)";var f=E++;$[f]=$[I]+"|x|X|\\*";var g=E++;$[g]=$[A]+"|x|X|\\*";var w=E++;$[w]="[v=\\s]*("+$[g]+")(?:\\.("+$[g]+")(?:\\.("+$[g]+")(?:"+$[c]+")?"+$[a]+"?)?)?";var k=E++;$[k]="[v=\\s]*("+$[f]+")(?:\\.("+$[f]+")(?:\\.("+$[f]+")(?:"+$[n]+")?"+$[a]+"?)?)?";var m=E++;$[m]="^"+$[o]+"\\s*"+$[w]+"$";var y=E++;$[y]="^"+$[o]+"\\s*"+$[k]+"$";var D=E++;$[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;$[C]="(?:~>?)";var P=E++;$[P]="(\\s*)"+$[C]+"\\s+",b[P]=new RegExp($[P],"g");var j=E++;$[j]="^"+$[C]+$[w]+"$";var T=E++;$[T]="^"+$[C]+$[k]+"$";var z=E++;$[z]="(?:\\^)";var N=E++;$[N]="(\\s*)"+$[z]+"\\s+",b[N]=new RegExp($[N],"g");var F=E++;$[F]="^"+$[z]+$[w]+"$";var U=E++;$[U]="^"+$[z]+$[k]+"$";var Y=E++;$[Y]="^"+$[o]+"\\s*("+u+")$|^$";var ie=E++;$[ie]="^"+$[o]+"\\s*("+t+")$|^$";var H=E++;$[H]="(\\s*)"+$[o]+"\\s*("+u+"|"+$[w]+")",b[H]=new RegExp($[H],"g");var J=E++;$[J]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var x=E++;$[x]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var ne=E++;$[ne]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)O(be,$[be]),b[be]||(b[be]=new RegExp($[be]));function ae(W,X){if(W instanceof Ie)return W;if(typeof W!="string"||W.length>M||!(X?b[r]:b[s]).test(W))return null;try{return new Ie(W,X)}catch{return null}}function Ie(W,X){if(W instanceof Ie){if(W.loose===X)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Ie))return new Ie(W,X);O("SemVer",W,X),this.loose=X;var Q=W.trim().match(X?b[r]:b[s]);if(!Q)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var we=+de;if(we>=0&&we<R)return we}return de}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=ae,e.valid=function(W,X){var Q=ae(W,X);return Q?Q.version:null},e.clean=function(W,X){var Q=ae(W.trim().replace(/^[=v]+/,""),X);return Q?Q.version:null},e.SemVer=Ie,Ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ie.prototype.toString=function(){return this.version},Ie.prototype.compare=function(W){return O("SemVer.compare",this.version,this.loose,W),W instanceof Ie||(W=new Ie(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Ie.prototype.compareMain=function(W){return W instanceof Ie||(W=new Ie(W,this.loose)),B(this.major,W.major)||B(this.minor,W.minor)||B(this.patch,W.patch)},Ie.prototype.comparePre=function(W){if(W instanceof Ie||(W=new Ie(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var X=0;do{var Q=this.prerelease[X],de=W.prerelease[X];if(O("prerelease compare",X,Q,de),Q===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Q===void 0)return-1;if(Q!==de)return B(Q,de)}while(++X)},Ie.prototype.inc=function(W,X){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,X,Q,de){typeof Q=="string"&&(de=Q,Q=void 0);try{return new Ie(W,Q).inc(X,de).version}catch{return null}},e.diff=function(W,X){if(ce(W,X))return null;var Q=ae(W),de=ae(X);if(Q.prerelease.length||de.prerelease.length){for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==de[we])return"pre"+we;return"prerelease"}for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==de[we])return we},e.compareIdentifiers=B;var ee=/^[0-9]+$/;function B(W,X){var Q=ee.test(W),de=ee.test(X);return Q&&de&&(W=+W,X=+X),Q&&!de?-1:de&&!Q?1:W<X?-1:W>X?1:0}function _(W,X,Q){return new Ie(W,Q).compare(new Ie(X,Q))}function pe(W,X,Q){return _(W,X,Q)>0}function ue(W,X,Q){return _(W,X,Q)<0}function ce(W,X,Q){return _(W,X,Q)===0}function oe(W,X,Q){return _(W,X,Q)!==0}function le(W,X,Q){return _(W,X,Q)>=0}function K(W,X,Q){return _(W,X,Q)<=0}function se(W,X,Q,de){var we;switch(X){case"===":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),we=W===Q;break;case"!==":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),we=W!==Q;break;case"":case"=":case"==":we=ce(W,Q,de);break;case"!=":we=oe(W,Q,de);break;case">":we=pe(W,Q,de);break;case">=":we=le(W,Q,de);break;case"<":we=ue(W,Q,de);break;case"<=":we=K(W,Q,de);break;default:throw new TypeError("Invalid operator: "+X)}return we}function $e(W,X){if(W instanceof $e){if(W.loose===X)return W;W=W.value}if(!(this instanceof $e))return new $e(W,X);O("comparator",W,X),this.loose=X,this.parse(W),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(W,X){return B(X,W)},e.major=function(W,X){return new Ie(W,X).major},e.minor=function(W,X){return new Ie(W,X).minor},e.patch=function(W,X){return new Ie(W,X).patch},e.compare=_,e.compareLoose=function(W,X){return _(W,X,!0)},e.rcompare=function(W,X,Q){return _(X,W,Q)},e.sort=function(W,X){return W.sort(function(Q,de){return e.compare(Q,de,X)})},e.rsort=function(W,X){return W.sort(function(Q,de){return e.rcompare(Q,de,X)})},e.gt=pe,e.lt=ue,e.eq=ce,e.neq=oe,e.gte=le,e.lte=K,e.cmp=se,e.Comparator=$e;var ve={};function Me(W,X){if(W instanceof Me)return W.loose===X?W:new Me(W.raw,X);if(W instanceof $e)return new Me(W.value,X);if(!(this instanceof Me))return new Me(W,X);if(this.loose=X,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function Pe(W,X,Q,de,we,je,qe,Ke,tt,_e,nt,it,rt){return((X=ge(Q)?"":ge(de)?">="+Q+".0.0":ge(we)?">="+Q+"."+de+".0":">="+X)+" "+(Ke=ge(tt)?"":ge(_e)?"<"+(+tt+1)+".0.0":ge(nt)?"<"+tt+"."+(+_e+1)+".0":it?"<="+tt+"."+_e+"."+nt+"-"+it:"<="+Ke)).trim()}function Ae(W,X){for(var Q=0;Q<W.length;Q++)if(!W[Q].test(X))return!1;if(X.prerelease.length){for(Q=0;Q<W.length;Q++)if(O(W[Q].semver),W[Q].semver!==ve&&W[Q].semver.prerelease.length>0){var de=W[Q].semver;if(de.major===X.major&&de.minor===X.minor&&de.patch===X.patch)return!0}return!1}return!0}function ze(W,X,Q){try{X=new Me(X,Q)}catch{return!1}return X.test(W)}function q(W,X,Q,de){var we,je,qe,Ke,tt;switch(W=new Ie(W,de),X=new Me(X,de),Q){case">":we=pe,je=K,qe=ue,Ke=">",tt=">=";break;case"<":we=ue,je=le,qe=pe,Ke="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(W,X,de))return!1;for(var _e=0;_e<X.set.length;++_e){var nt=X.set[_e],it=null,rt=null;if(nt.forEach(function(ct){ct.semver===ve&&(ct=new $e(">=0.0.0")),it=it||ct,rt=rt||ct,we(ct.semver,it.semver,de)?it=ct:qe(ct.semver,rt.semver,de)&&(rt=ct)}),it.operator===Ke||it.operator===tt||(!rt.operator||rt.operator===Ke)&&je(W,rt.semver)||rt.operator===tt&&qe(W,rt.semver))return!1}return!0}$e.prototype.parse=function(W){var X=this.loose?b[Y]:b[ie],Q=W.match(X);if(!Q)throw new TypeError("Invalid comparator: "+W);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new Ie(Q[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(W){return O("Comparator.test",W,this.loose),this.semver===ve||(typeof W=="string"&&(W=new Ie(W,this.loose)),se(W,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(W,X){if(!(W instanceof $e))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Me(W.value,X),ze(this.value,Q,X);if(W.operator==="")return Q=new Me(this.value,X),ze(W.semver,Q,X);var de=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),je=this.semver.version===W.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ke=se(this.semver,"<",W.semver,X)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=se(this.semver,">",W.semver,X)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return de||we||je&&qe||Ke||tt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(W){var X=this.loose;W=W.trim(),O("range",W,X);var Q=X?b[x]:b[J];W=W.replace(Q,Pe),O("hyphen replace",W),W=W.replace(b[H],"$1$2$3"),O("comparator trim",W,b[H]),W=(W=(W=W.replace(b[P],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var de=X?b[Y]:b[ie],we=W.split(" ").map(function(je){return function(qe,Ke){return O("comp",qe),qe=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){O("caret",it,rt);var ct=rt?b[U]:b[F];return it.replace(ct,function(Re,Se,Ve,te,re){var Ce;return O("caret",it,Re,Se,Ve,te,re),ge(Se)?Ce="":ge(Ve)?Ce=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(te)?Ce=Se==="0"?">="+Se+"."+Ve+".0 <"+Se+"."+(+Ve+1)+".0":">="+Se+"."+Ve+".0 <"+(+Se+1)+".0.0":re?(O("replaceCaret pr",re),re.charAt(0)!=="-"&&(re="-"+re),Ce=Se==="0"?Ve==="0"?">="+Se+"."+Ve+"."+te+re+" <"+Se+"."+Ve+"."+(+te+1):">="+Se+"."+Ve+"."+te+re+" <"+Se+"."+(+Ve+1)+".0":">="+Se+"."+Ve+"."+te+re+" <"+(+Se+1)+".0.0"):(O("no pr"),Ce=Se==="0"?Ve==="0"?">="+Se+"."+Ve+"."+te+" <"+Se+"."+Ve+"."+(+te+1):">="+Se+"."+Ve+"."+te+" <"+Se+"."+(+Ve+1)+".0":">="+Se+"."+Ve+"."+te+" <"+(+Se+1)+".0.0"),O("caret return",Ce),Ce})}(nt,_e)}).join(" ")}(qe,Ke),O("caret",qe),qe=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){var ct=rt?b[T]:b[j];return it.replace(ct,function(Re,Se,Ve,te,re){var Ce;return O("tilde",it,Re,Se,Ve,te,re),ge(Se)?Ce="":ge(Ve)?Ce=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(te)?Ce=">="+Se+"."+Ve+".0 <"+Se+"."+(+Ve+1)+".0":re?(O("replaceTilde pr",re),re.charAt(0)!=="-"&&(re="-"+re),Ce=">="+Se+"."+Ve+"."+te+re+" <"+Se+"."+(+Ve+1)+".0"):Ce=">="+Se+"."+Ve+"."+te+" <"+Se+"."+(+Ve+1)+".0",O("tilde return",Ce),Ce})}(nt,_e)}).join(" ")}(qe,Ke),O("tildes",qe),qe=function(tt,_e){return O("replaceXRanges",tt,_e),tt.split(/\s+/).map(function(nt){return function(it,rt){it=it.trim();var ct=rt?b[y]:b[m];return it.replace(ct,function(Re,Se,Ve,te,re,Ce){O("xRange",it,Re,Se,Ve,te,re,Ce);var Ge=ge(Ve),Oe=Ge||ge(te),st=Oe||ge(re);return Se==="="&&st&&(Se=""),Ge?Re=Se===">"||Se==="<"?"<0.0.0":"*":Se&&st?(Oe&&(te=0),st&&(re=0),Se===">"?(Se=">=",Oe?(Ve=+Ve+1,te=0,re=0):st&&(te=+te+1,re=0)):Se==="<="&&(Se="<",Oe?Ve=+Ve+1:te=+te+1),Re=Se+Ve+"."+te+"."+re):Oe?Re=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":st&&(Re=">="+Ve+"."+te+".0 <"+Ve+"."+(+te+1)+".0"),O("xRange return",Re),Re})}(nt,_e)}).join(" ")}(qe,Ke),O("xrange",qe),qe=function(tt,_e){return O("replaceStars",tt,_e),tt.trim().replace(b[ne],"")}(qe,Ke),O("stars",qe),qe}(je,X)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(je){return!!je.match(de)})),we=we.map(function(je){return new $e(je,X)})},Me.prototype.intersects=function(W,X){if(!(W instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(de){return W.set.some(function(we){return we.every(function(je){return de.intersects(je,X)})})})})},e.toComparators=function(W,X){return new Me(W,X).set.map(function(Q){return Q.map(function(de){return de.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Ie(W,this.loose));for(var X=0;X<this.set.length;X++)if(Ae(this.set[X],W))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(W,X,Q){var de=null,we=null;try{var je=new Me(X,Q)}catch{return null}return W.forEach(function(qe){je.test(qe)&&(de&&we.compare(qe)!==-1||(we=new Ie(de=qe,Q)))}),de},e.minSatisfying=function(W,X,Q){var de=null,we=null;try{var je=new Me(X,Q)}catch{return null}return W.forEach(function(qe){je.test(qe)&&(de&&we.compare(qe)!==1||(we=new Ie(de=qe,Q)))}),de},e.validRange=function(W,X){try{return new Me(W,X).range||"*"}catch{return null}},e.ltr=function(W,X,Q){return q(W,X,"<",Q)},e.gtr=function(W,X,Q){return q(W,X,">",Q)},e.outside=q,e.prerelease=function(W,X){var Q=ae(W,X);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(W,X,Q){return W=new Me(W,Q),X=new Me(X,Q),W.intersects(X)},e.coerce=function(W){if(W instanceof Ie)return W;if(typeof W!="string")return null;var X=W.match(b[D]);return X==null?null:ae((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,l(1))},function(he,e){var l,L,O=he.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(d){if(l===setTimeout)return setTimeout(d,0);if((l===M||!l)&&setTimeout)return l=setTimeout,setTimeout(d,0);try{return l(d,0)}catch{try{return l.call(null,d,0)}catch{return l.call(this,d,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:M}catch{l=M}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var $,E=[],A=!1,I=-1;function p(){A&&$&&(A=!1,$.length?E=$.concat(E):I=-1,E.length&&S())}function S(){if(!A){var d=b(p);A=!0;for(var c=E.length;c;){for($=E,E=[];++I<c;)$&&$[I].run();I=-1,c=E.length}$=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(d)}}function v(d,c){this.fun=d,this.array=c}function h(){}O.nextTick=function(d){var c=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)c[n-1]=arguments[n];E.push(new v(d,c)),E.length!==1||A||b(S)},v.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=h,O.addListener=h,O.once=h,O.off=h,O.removeListener=h,O.removeAllListeners=h,O.emit=h,O.prependListener=h,O.prependOnceListener=h,O.listeners=function(d){return[]},O.binding=function(d){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(d){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ke[40],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const l=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(M){return new L(M)}constructor(M){this.c=l&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=L}),define(ke[4],De([1,0,13,75,3,76,40]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=S;const b=!1,$=!1,E=!1;var A;(function(P){P.None=()=>O.$Uc.None;function j(Me){if(E){const{onDidAddListener:ge}=Me,Pe=h.create();let Ae=0;Me.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),ge?.()}}}function T(Me,ge){return ne(Me,()=>{},0,void 0,!0,void 0,ge)}P.defer=T;function z(Me){return(ge,Pe=null,Ae)=>{let ze=!1,q;return q=Me(W=>{if(!ze)return q?q.dispose():ze=!0,ge.call(Pe,W)},null,Ae),ze&&q.dispose(),q}}P.once=z;function N(Me,ge,Pe){return J((Ae,ze=null,q)=>Me(W=>Ae.call(ze,ge(W)),null,q),Pe)}P.map=N;function F(Me,ge,Pe){return J((Ae,ze=null,q)=>Me(W=>{ge(W),Ae.call(ze,W)},null,q),Pe)}P.forEach=F;function U(Me,ge,Pe){return J((Ae,ze=null,q)=>Me(W=>ge(W)&&Ae.call(ze,W),null,q),Pe)}P.filter=U;function Y(Me){return Me}P.signal=Y;function ie(...Me){return(ge,Pe=null,Ae)=>{const ze=(0,O.$Rc)(...Me.map(q=>q(W=>ge.call(Pe,W))));return x(ze,Ae)}}P.any=ie;function H(Me,ge,Pe,Ae){let ze=Pe;return N(Me,q=>(ze=ge(ze,q),ze),Ae)}P.reduce=H;function J(Me,ge){let Pe;const Ae={onWillAddFirstListener(){Pe=Me(ze.fire,ze)},onDidRemoveLastListener(){Pe?.dispose()}};ge||j(Ae);const ze=new s(Ae);return ge?.add(ze),ze.event}function x(Me,ge){return ge instanceof Array?ge.push(Me):ge&&ge.add(Me),Me}function ne(Me,ge,Pe=100,Ae=!1,ze=!1,q,W){let X,Q,de,we=0,je;const qe={leakWarningThreshold:q,onWillAddFirstListener(){X=Me(tt=>{we++,Q=ge(Q,tt),Ae&&!de&&(Ke.fire(Q),Q=void 0),je=()=>{const _e=Q;Q=void 0,de=void 0,(!Ae||we>1)&&Ke.fire(_e),we=0},typeof Pe=="number"?(clearTimeout(de),de=setTimeout(je,Pe)):de===void 0&&(de=0,queueMicrotask(je))})},onWillRemoveListener(){ze&&we>0&&je?.()},onDidRemoveLastListener(){je=void 0,X.dispose()}};W||j(qe);const Ke=new s(qe);return W?.add(Ke),Ke.event}P.debounce=ne;function be(Me,ge=0,Pe){return P.debounce(Me,(Ae,ze)=>Ae?(Ae.push(ze),Ae):[ze],ge,void 0,!0,void 0,Pe)}P.accumulate=be;function ae(Me,ge=(Ae,ze)=>Ae===ze,Pe){let Ae=!0,ze;return U(Me,q=>{const W=Ae||!ge(q,ze);return Ae=!1,ze=q,W},Pe)}P.latch=ae;function Ie(Me,ge,Pe){return[P.filter(Me,ge,Pe),P.filter(Me,Ae=>!ge(Ae),Pe)]}P.split=Ie;function ee(Me,ge=!1,Pe=[],Ae){let ze=Pe.slice(),q=Me(Q=>{ze?ze.push(Q):X.fire(Q)});Ae&&Ae.add(q);const W=()=>{ze?.forEach(Q=>X.fire(Q)),ze=null},X=new s({onWillAddFirstListener(){q||(q=Me(Q=>X.fire(Q)),Ae&&Ae.add(q))},onDidAddFirstListener(){ze&&(ge?setTimeout(W):W())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return Ae&&Ae.add(X),X.event}P.buffer=ee;function B(Me,ge){return(Ae,ze,q)=>{const W=ge(new pe);return Me(function(X){const Q=W.evaluate(X);Q!==_&&Ae.call(ze,Q)},void 0,q)}}P.chain=B;const _=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(Pe=>(ge(Pe),Pe)),this}filter(ge){return this.f.push(Pe=>ge(Pe)?Pe:_),this}reduce(ge,Pe){let Ae=Pe;return this.f.push(ze=>(Ae=ge(Ae,ze),Ae)),this}latch(ge=(Pe,Ae)=>Pe===Ae){let Pe=!0,Ae;return this.f.push(ze=>{const q=Pe||!ge(ze,Ae);return Pe=!1,Ae=ze,q?ze:_}),this}evaluate(ge){for(const Pe of this.f)if(ge=Pe(ge),ge===_)break;return ge}}function ue(Me,ge,Pe=Ae=>Ae){const Ae=(...X)=>W.fire(Pe(...X)),ze=()=>Me.on(ge,Ae),q=()=>Me.removeListener(ge,Ae),W=new s({onWillAddFirstListener:ze,onDidRemoveLastListener:q});return W.event}P.fromNodeEventEmitter=ue;function ce(Me,ge,Pe=Ae=>Ae){const Ae=(...X)=>W.fire(Pe(...X)),ze=()=>Me.addEventListener(ge,Ae),q=()=>Me.removeEventListener(ge,Ae),W=new s({onWillAddFirstListener:ze,onDidRemoveLastListener:q});return W.event}P.fromDOMEventEmitter=ce;function oe(Me){return new Promise(ge=>z(Me)(ge))}P.toPromise=oe;function le(Me){const ge=new s;return Me.then(Pe=>{ge.fire(Pe)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}P.fromPromise=le;function K(Me,ge,Pe){return ge(Pe),Me(Ae=>ge(Ae))}P.runAndSubscribe=K;class se{constructor(ge,Pe){this._observable=ge,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};Pe||j(Ae),this.emitter=new s(Ae),Pe&&Pe.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,Pe){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(Me,ge){return new se(Me,ge).emitter.event}P.fromObservable=$e;function ve(Me){return(ge,Pe,Ae)=>{let ze=0,q=!1;const W={beginUpdate(){ze++},endUpdate(){ze--,ze===0&&(Me.reportChanges(),q&&(q=!1,ge.call(Pe)))},handlePossibleChange(){},handleChange(){q=!0}};Me.addObserver(W),Me.reportChanges();const X={dispose(){Me.removeObserver(W)}};return Ae instanceof O.$Tc?Ae.add(X):Array.isArray(Ae)&&Ae.push(X),X}}P.fromObservableLight=ve})(A||(e.Event=A={}));class I{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${I.f++}`,I.all.add(this)}start(j){this.g=new R.$be,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$de=I;let p=-1;function S(P){const j=p;return p=P,{dispose(){p=j}}}class v{constructor(j,T=Math.random().toString(18).slice(2,5)){this.threshold=j,this.name=T,this.g=0}dispose(){this.f?.clear()}check(j,T){const z=this.threshold;if(z<=0||T<z)return;this.f||(this.f=new Map);const N=this.f.get(j.value)||0;if(this.f.set(j.value,N+1),this.g-=1,this.g<=0){this.g=z*.5;let F,U=0;for(const[Y,ie]of this.f)(!F||U<ie)&&(F=Y,U=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${U}):`),console.warn(F)}return()=>{const F=this.f.get(j.value)||0;this.f.set(j.value,F-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let d=0;class c{constructor(j){this.value=j,this.id=d++}}const n=2,i=(P,j)=>{if(P instanceof c)j(P);else for(let T=0;T<P.length;T++){const z=P[T];z&&j(z)}},a=b?new FinalizationRegistry(P=>{typeof P=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(P))}):void 0;class s{constructor(j){this.w=0,this.f=j,this.g=p>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new I(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const j=this.t;queueMicrotask(()=>{i(j,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,T,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$Uc.None;if(this.m)return O.$Uc.None;T&&(j=j.bind(T));const N=new c(j);let F,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=h.create(),F=this.g.check(N.stack,this.w+1)),$&&(N.stack=U??h.create()),this.t?this.t instanceof c?(this.u??=new u,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const Y=(0,O.$Sc)(()=>{a?.unregister(Y),F?.(),this.x(N)});if(z instanceof O.$Tc?z.add(Y):Array.isArray(z)&&z.push(Y),a){const ie=new Error().stack.split(`
`).slice(2).join(`
`).trim();a.register(Y,ie,Y)}return Y},this.q}x(j){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,z=T.indexOf(j);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[z]=void 0;const N=this.u.current===this;if(this.w*n<=T.length){let F=0;for(let U=0;U<T.length;U++)T[U]?T[F++]=T[U]:N&&(this.u.end--,F<this.u.i&&this.u.i--);T.length=F}}y(j,T){if(!j)return;const z=this.f?.onListenerError||l.$1;if(!z){j.value(T);return}try{j.value(T)}catch(N){z(N)}}z(j){const T=j.current.t;for(;j.i<j.end;)this.y(T[j.i++],j.value);j.reset()}fire(j){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,j);else{const T=this.u;T.enqueue(this,j,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$fe=s;const t=()=>new u;e.$ge=t;class u{constructor(){this.i=-1,this.end=0}enqueue(j,T,z){this.i=0,this.end=z,this.current=j,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends s{async fireAsync(j,T,z){if(this.t)for(this.h||(this.h=new M.$5c),i(this.t,N=>this.h.push([N.value,j]));this.h.size>0&&!T.isCancellationRequested;){const[N,F]=this.h.shift(),U=[],Y={...F,token:T,waitUntil:ie=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");z&&(ie=z(ie,N)),U.push(ie)}};try{N(Y)}catch(ie){(0,l.$1)(ie);continue}Object.freeze(U),await Promise.allSettled(U).then(ie=>{for(const H of ie)H.status==="rejected"&&(0,l.$1)(H.reason)})}}}e.$he=r;class o extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new M.$5c,this.A=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.A(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.w&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$ie=o;class f extends o{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$je=f;class g extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ke=g;class w{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const T={event:j,listener:null};this.h.push(T),this.g&&this.m(T);const z=()=>{this.g&&this.o(T);const N=this.h.indexOf(T);this.h.splice(N,1)};return(0,O.$Sc)((0,L.$db)(z))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(T=>this.f.fire(T))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$le=w;class k{constructor(j,T,z,N){this.f=new O.$Tc;const F=this.f.add(new w),U=this.f.add(new O.$4c);function Y(ie){U.set(ie,F.add(N(ie)))}for(const ie of j)Y(ie);this.f.add(T(ie=>{Y(ie)})),this.f.add(z(ie=>{U.deleteAndDispose(ie)})),this.event=F.event}dispose(){this.f.dispose()}}e.$me=k;class m{constructor(){this.f=[]}wrapEvent(j,T,z){return(N,F,U)=>j(Y=>{const ie=this.f[this.f.length-1];if(!T){ie?ie.buffers.push(()=>N.call(F,Y)):N.call(F,Y);return}const H=ie;if(!H){N.call(F,T(z,Y));return}H.items??=[],H.items.push(Y),H.buffers.length===0&&ie.buffers.push(()=>{H.reducedResult??=z?H.items.reduce(T,z):H.items.reduce(T),N.call(F,H.reducedResult)})},void 0,U)}bufferEvents(j){const T={buffers:new Array};this.f.push(T);const z=j();return this.f.pop(),T.buffers.forEach(N=>N()),z}}e.$ne=m;class y{constructor(){this.f=!1,this.g=A.None,this.h=O.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$oe=y;class D{static const(j){return new C(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$pe=D;class C{constructor(j){this.value=j,this.onDidChange=A.None}}}),define(ke[22],De([1,0,4]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=e.CancellationToken=void 0,e.$re=b;const L=Object.freeze(function($,E){const A=setTimeout($.bind(E),0);return{dispose(){clearTimeout(A)}}});var O;(function($){function E(A){return A===$.None||A===$.Cancelled||A instanceof M?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}$.isCancellationToken=E,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(O||(e.CancellationToken=O={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new l.$fe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=O.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=O.None}}e.$qe=R;function b($){const E=new R;return $.add({dispose(){E.cancel()}}),E.token}}),define(ke[173],De([1,0,22]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=e.$3e=void 0,e.$4e=O;class L{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new l.$qe,E=this.b($.token);return this.a={promise:E,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$3e=L;function O(b){return b}class M{constructor($,E){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=O):(this.c=E,this.d=$.getCacheKey)}get($){const E=this.d($);return this.b!==E&&(this.b=E,this.a=this.c($)),this.a}}e.$5e=M;class R{get cachedValues(){return this.a}constructor($,E){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=O):(this.c=E,this.d=$.getCacheKey)}get($){const E=this.d($);if(this.b.has(E))return this.b.get(E);const A=this.c($);return this.a.set($,A),this.b.set(E,A),A}}e.$6e=R}),define(ke[98],De([1,0,13,3]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=O,e.$te=M,e.$ue=R,e.$ve=b,e.$we=E,e.$xe=A,e.$ye=I,e.$ze=p,e.$Ae=S,e.$Be=v,e.$Ce=h,e.$De=d,e.$Ee=c,e.$Fe=n,e.$Ge=i;function O(a){const s=a;return s?typeof s.read=="function":!1}function M(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function R(a){const s=a;return s?M(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(a,s){return new $(a,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,l.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let u;switch(s){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const r=u.indexOf(t);r>=0&&u.splice(r,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(a,s){const t=[];let u;for(;(u=a.read())!==null;)t.push(u);return s(t)}function A(a,s,t){const u=[];let r;for(;(r=a.read())!==null&&u.length<t;)u.push(r);return r===null&&u.length>0?s(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const o=r;return r=void 0,o}return a.read()}}}function I(a,s){return new Promise((t,u)=>{const r=[];p(a,{onData:o=>{s&&r.push(o)},onError:o=>{s?u(o):t(void 0)},onEnd:()=>{t(s?s(r):void 0)}})})}function p(a,s,t){a.on("error",u=>{t?.isCancellationRequested||s.onError(u)}),a.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),a.on("data",u=>{t?.isCancellationRequested||s.onData(u)})}function S(a,s){return new Promise((t,u)=>{const r=new L.$Tc,o=[],f=k=>{if(o.push(k),o.length>s)return r.dispose(),a.pause(),t({stream:a,buffer:o,ended:!1})},g=k=>(r.dispose(),u(k)),w=()=>(r.dispose(),t({stream:a,buffer:o,ended:!0}));r.add((0,L.$Sc)(()=>a.removeListener("error",g))),a.on("error",g),r.add((0,L.$Sc)(()=>a.removeListener("end",w))),a.on("end",w),r.add((0,L.$Sc)(()=>a.removeListener("data",f))),a.on("data",f)})}function v(a,s){const t=b(s);return t.end(a),t}function h(){const a=b(()=>{throw new Error("not supported")});return a.end(),a}function d(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}function c(a,s,t){const u=b(t);return p(a,{onData:r=>u.write(s.data(r)),onError:r=>u.error(s.error?s.error(r):r),onEnd:()=>u.end()}),u}function n(a,s,t){let u=!1;return{read:()=>{const r=s.read();return u?r:(u=!0,r!==null?t([a,r]):a)}}}function i(a,s,t){let u=!1;const r=b(t);return p(s,{onData:o=>u?r.write(o):(u=!0,r.write(t([a,o]))),onError:o=>r.error(o),onEnd:()=>{u||(u=!0,r.write(a)),r.end()}}),r}}),define(ke[21],De([1,0,46,98]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=E,e.$Je=A,e.$Ke=I,e.$Le=p,e.$Me=S,e.$Ne=v,e.$Oe=h,e.$Pe=d,e.$Qe=c,e.$Re=n,e.$Se=i,e.$Te=a,e.$Ue=s,e.$Ve=t,e.$We=u,e.$Xe=r,e.$Ye=o,e.$Ze=f,e.$1e=g,e.$2e=m;const O=typeof Buffer<"u",M=new l.$V(()=>new Uint8Array(256));let R,b;class ${static alloc(D){return O?new $(Buffer.allocUnsafe(D)):new $(new Uint8Array(D))}static wrap(D){return O&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new $(D)}static fromString(D,C){return!(C?.dontUseNodeBuffer||!1)&&O?new $(Buffer.from(D)):(R||(R=new TextEncoder),new $(R.encode(D)))}static fromByteArray(D){const C=$.alloc(D.length);for(let P=0,j=D.length;P<j;P++)C.buffer[P]=D[P];return C}static concat(D,C){if(typeof C>"u"){C=0;for(let T=0,z=D.length;T<z;T++)C+=D[T].byteLength}const P=$.alloc(C);let j=0;for(let T=0,z=D.length;T<z;T++){const N=D[T];P.set(N,j),j+=N.byteLength}return P}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=$.alloc(this.byteLength);return D.set(this),D}toString(){return O?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(D,C){return new $(this.buffer.subarray(D,C))}set(D,C){if(D instanceof $)this.buffer.set(D.buffer,C);else if(D instanceof Uint8Array)this.buffer.set(D,C);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),C);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return p(this.buffer,D)}writeUInt32BE(D,C){S(this.buffer,D,C)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,C){h(this.buffer,D,C)}readUInt8(D){return d(this.buffer,D)}writeUInt8(D,C){c(this.buffer,D,C)}indexOf(D,C=0){return E(this.buffer,D instanceof $?D.buffer:D,C)}}e.$He=$;function E(y,D,C=0){const P=D.byteLength,j=y.byteLength;if(P===0)return 0;if(P===1)return y.indexOf(D[0]);if(P>j-C)return-1;const T=M.value;T.fill(D.length);for(let U=0;U<D.length;U++)T[D[U]]=D.length-U-1;let z=C+D.length-1,N=z,F=-1;for(;z<j;)if(y[z]===D[N]){if(N===0){F=z;break}z--,N--}else z+=Math.max(D.length-N,T[y[z]]),N=D.length-1;return F}function A(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}function I(y,D,C){y[C+0]=D&255,D=D>>>8,y[C+1]=D&255}function p(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}function S(y,D,C){y[C+3]=D,D=D>>>8,y[C+2]=D,D=D>>>8,y[C+1]=D,D=D>>>8,y[C]=D}function v(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}function h(y,D,C){y[C+0]=D&255,D=D>>>8,y[C+1]=D&255,D=D>>>8,y[C+2]=D&255,D=D>>>8,y[C+3]=D&255}function d(y,D){return y[D]}function c(y,D,C){y[C]=D}function n(y){return L.$we(y,D=>$.concat(D))}function i(y){return L.$De(y)}function a(y){return L.$ye(y,D=>$.concat(D))}async function s(y){return y.ended?$.concat(y.buffer):$.concat([...y.buffer,await a(y.stream)])}function t(y){return L.$Be(y,D=>$.concat(D))}function u(y){return L.$Ee(y,{data:D=>typeof D=="string"?$.fromString(D):$.wrap(D)},D=>$.concat(D))}function r(y){return L.$ve(D=>$.concat(D),y)}function o(y,D){return L.$Fe(y,D,C=>$.concat(C))}function f(y,D){return L.$Ge(y,D,C=>$.concat(C))}function g(y){let D=0,C=0,P=0;const j=new Uint8Array(Math.floor(y.length/4*3)),T=N=>{switch(C){case 3:j[P++]=D|N,C=0;break;case 2:j[P++]=D|N>>>2,D=N<<6,C=3;break;case 1:j[P++]=D|N>>>4,D=N<<4,C=2;break;default:D=N<<2,C=1}};for(let N=0;N<y.length;N++){const F=y.charCodeAt(N);if(F>=65&&F<=90)T(F-65);else if(F>=97&&F<=122)T(F-97+26);else if(F>=48&&F<=57)T(F-48+52);else if(F===43||F===45)T(62);else if(F===47||F===95)T(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${y[N]}`)}}const z=P;for(;C>0;)T(0);return $.wrap(j).slice(0,z)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:y},D=!0,C=!1){const P=C?k:w;let j="";const T=y.byteLength%3;let z=0;for(;z<y.byteLength-T;z+=3){const N=y[z+0],F=y[z+1],U=y[z+2];j+=P[N>>>2],j+=P[(N<<4|F>>>4)&63],j+=P[(F<<2|U>>>6)&63],j+=P[U&63]}if(T===1){const N=y[z+0];j+=P[N>>>2],j+=P[N<<4&63],D&&(j+="==")}else if(T===2){const N=y[z+0],F=y[z+1];j+=P[N>>>2],j+=P[(N<<4|F>>>4)&63],j+=P[F<<2&63],D&&(j+="=")}return j}}),define(ke[14],De([1,0,173,46]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.GraphemeBreakType=e.$Xf=e.$Pf=e.$If=e.$Hf=void 0,e.$9e=O,e.$0e=R,e.$$e=$,e.$_e=E,e.$af=A,e.$bf=I,e.$cf=p,e.$df=S,e.$ef=v,e.$ff=h,e.$gf=d,e.$hf=c,e.$if=n,e.$jf=i,e.$kf=a,e.$lf=s,e.$mf=t,e.$nf=u,e.$of=r,e.$pf=o,e.$qf=f,e.$rf=g,e.$sf=w,e.$tf=k,e.$uf=m,e.$vf=y,e.$wf=D,e.$xf=C,e.$yf=P,e.$zf=j,e.$Af=T,e.$Bf=z,e.$Cf=N,e.$Df=F,e.$Ef=U,e.$Ff=Y,e.$Gf=ie,e.$Jf=ne,e.$Kf=be,e.$Lf=ae,e.$Mf=Ie,e.$Nf=_,e.$Of=ue,e.$Qf=ce,e.$Rf=oe,e.$Sf=le,e.$Tf=K,e.$Uf=$e,e.$Vf=ve,e.$Wf=ge,e.$Yf=Pe,e.$Zf=Ae,e.$1f=ze,e.$2f=q,e.$3f=W,e.$4f=X,e.$5f=Q,e.$6f=de,e.$7f=tt;function O(Re){return!Re||typeof Re!="string"?!0:Re.trim().length===0}const M=/{(\d+)}/g;function R(Re,...Se){return Se.length===0?Re:Re.replace(M,function(Ve,te){const re=parseInt(te,10);return isNaN(re)||re<0||re>=Se.length?Ve:Se[re]})}const b=/{([^}]+)}/g;function $(Re,Se){return Object.keys(Se).length===0?Re:Re.replace(b,(Ve,te)=>Se[te]??Ve)}function E(Re){return Re.replace(/[<>"'&]/g,Se=>{switch(Se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Se})}function A(Re){return Re.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}function I(Re){return Re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Re,Se){let Ve=0,te=Re.indexOf(Se);for(;te!==-1;)Ve++,te=Re.indexOf(Se,te+Se.length);return Ve}function S(Re,Se,Ve="\u2026"){return Re.length<=Se?Re:`${Re.substr(0,Se)}${Ve}`}function v(Re,Se,Ve="\u2026"){if(Re.length<=Se)return Re;const te=Math.ceil(Se/2)-Ve.length/2,re=Math.floor(Se/2)-Ve.length/2;return`${Re.substr(0,te)}${Ve}${Re.substr(Re.length-re)}`}function h(Re,Se=" "){const Ve=d(Re,Se);return c(Ve,Se)}function d(Re,Se){if(!Re||!Se)return Re;const Ve=Se.length;if(Ve===0||Re.length===0)return Re;let te=0;for(;Re.indexOf(Se,te)===te;)te=te+Ve;return Re.substring(te)}function c(Re,Se){if(!Re||!Se)return Re;const Ve=Se.length,te=Re.length;if(Ve===0||te===0)return Re;let re=te,Ce=-1;for(;Ce=Re.lastIndexOf(Se,re-1),!(Ce===-1||Ce+Ve!==re);){if(Ce===0)return"";re=Ce}return Re.substring(0,re)}function n(Re){return Re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Re){return Re.replace(/\*/g,"")}function a(Re,Se,Ve={}){if(!Re)throw new Error("Cannot create regex from empty string");Se||(Re=I(Re)),Ve.wholeWord&&(/\B/.test(Re.charAt(0))||(Re="\\b"+Re),/\B/.test(Re.charAt(Re.length-1))||(Re=Re+"\\b"));let te="";return Ve.global&&(te+="g"),Ve.matchCase||(te+="i"),Ve.multiline&&(te+="m"),Ve.unicode&&(te+="u"),new RegExp(Re,te)}function s(Re){return Re.source==="^"||Re.source==="^$"||Re.source==="$"||Re.source==="^\\s*$"?!1:!!(Re.exec("")&&Re.lastIndex===0)}function t(Re){return Re.split(/\r\n|\r|\n/)}function u(Re){const Se=[],Ve=Re.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(Ve.length/2);te++)Se.push(Ve[2*te]+(Ve[2*te+1]??""));return Se}function r(Re){for(let Se=0,Ve=Re.length;Se<Ve;Se++){const te=Re.charCodeAt(Se);if(te!==32&&te!==9)return Se}return-1}function o(Re,Se=0,Ve=Re.length){for(let te=Se;te<Ve;te++){const re=Re.charCodeAt(te);if(re!==32&&re!==9)return Re.substring(Se,te)}return Re.substring(Se,Ve)}function f(Re,Se=Re.length-1){for(let Ve=Se;Ve>=0;Ve--){const te=Re.charCodeAt(Ve);if(te!==32&&te!==9)return Ve}return-1}function g(Re,Se,Ve){const te=[];let re=0;for(const Ce of Re.matchAll(Se)){if(te.push(Re.slice(re,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");re=Ce.index+Ce[0].length,te.push(Ve(Ce[0],...Ce.slice(1),Ce.index,Re,Ce.groups))}return te.push(Re.slice(re)),Promise.all(te).then(Ce=>Ce.join(""))}function w(Re,Se){return Re<Se?-1:Re>Se?1:0}function k(Re,Se,Ve=0,te=Re.length,re=0,Ce=Se.length){for(;Ve<te&&re<Ce;Ve++,re++){const st=Re.charCodeAt(Ve),lt=Se.charCodeAt(re);if(st<lt)return-1;if(st>lt)return 1}const Ge=te-Ve,Oe=Ce-re;return Ge<Oe?-1:Ge>Oe?1:0}function m(Re,Se){return y(Re,Se,0,Re.length,0,Se.length)}function y(Re,Se,Ve=0,te=Re.length,re=0,Ce=Se.length){for(;Ve<te&&re<Ce;Ve++,re++){let st=Re.charCodeAt(Ve),lt=Se.charCodeAt(re);if(st===lt)continue;if(st>=128||lt>=128)return k(Re.toLowerCase(),Se.toLowerCase(),Ve,te,re,Ce);C(st)&&(st-=32),C(lt)&&(lt-=32);const mt=st-lt;if(mt!==0)return mt}const Ge=te-Ve,Oe=Ce-re;return Ge<Oe?-1:Ge>Oe?1:0}function D(Re){return Re>=48&&Re<=57}function C(Re){return Re>=97&&Re<=122}function P(Re){return Re>=65&&Re<=90}function j(Re,Se){return Re.length===Se.length&&y(Re,Se)===0}function T(Re,Se){const Ve=Se.length;return Se.length>Re.length?!1:y(Re,Se,0,Ve)===0}function z(Re,Se){const Ve=Math.min(Re.length,Se.length);let te;for(te=0;te<Ve;te++)if(Re.charCodeAt(te)!==Se.charCodeAt(te))return te;return Ve}function N(Re,Se){const Ve=Math.min(Re.length,Se.length);let te;const re=Re.length-1,Ce=Se.length-1;for(te=0;te<Ve;te++)if(Re.charCodeAt(re-te)!==Se.charCodeAt(Ce-te))return te;return Ve}function F(Re){return 55296<=Re&&Re<=56319}function U(Re){return 56320<=Re&&Re<=57343}function Y(Re,Se){return(Re-55296<<10)+(Se-56320)+65536}function ie(Re,Se,Ve){const te=Re.charCodeAt(Ve);if(F(te)&&Ve+1<Se){const re=Re.charCodeAt(Ve+1);if(U(re))return Y(te,re)}return te}function H(Re,Se){const Ve=Re.charCodeAt(Se-1);if(U(Ve)&&Se>1){const te=Re.charCodeAt(Se-2);if(F(te))return Y(te,Ve)}return Ve}class J{get offset(){return this.e}constructor(Se,Ve=0){this.c=Se,this.d=Se.length,this.e=Ve}setOffset(Se){this.e=Se}prevCodePoint(){const Se=H(this.c,this.e);return this.e-=Se>=65536?2:1,Se}nextCodePoint(){const Se=ie(this.c,this.d,this.e);return this.e+=Se>=65536?2:1,Se}eol(){return this.e>=this.d}}e.$Hf=J;class x{get offset(){return this.c.offset}constructor(Se,Ve=0){this.c=new J(Se,Ve)}nextGraphemeLength(){const Se=qe.getInstance(),Ve=this.c,te=Ve.offset;let re=Se.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const Ce=Ve.offset,Ge=Se.getGraphemeBreakType(Ve.nextCodePoint());if(we(re,Ge)){Ve.setOffset(Ce);break}re=Ge}return Ve.offset-te}prevGraphemeLength(){const Se=qe.getInstance(),Ve=this.c,te=Ve.offset;let re=Se.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const Ce=Ve.offset,Ge=Se.getGraphemeBreakType(Ve.prevCodePoint());if(we(Ge,re)){Ve.setOffset(Ce);break}re=Ge}return te-Ve.offset}eol(){return this.c.eol()}}e.$If=x;function ne(Re,Se){return new x(Re,Se).nextGraphemeLength()}function be(Re,Se){return new x(Re,Se).prevGraphemeLength()}function ae(Re,Se){Se>0&&U(Re.charCodeAt(Se))&&Se--;const Ve=Se+ne(Re,Se);return[Ve-be(Re,Ve),Ve]}function Ie(Re){const Se=new x(Re);let Ve=0;for(;!Se.eol();)Ve++,Se.nextGraphemeLength();return Ve}let ee;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Re){return ee||(ee=B()),ee.test(Re)}const pe=/^[\t\n\r\x20-\x7E]*$/;function ue(Re){return pe.test(Re)}e.$Pf=/[\u2028\u2029]/;function ce(Re){return e.$Pf.test(Re)}function oe(Re){return Re>=11904&&Re<=55215||Re>=63744&&Re<=64255||Re>=65281&&Re<=65374}function le(Re){return Re>=127462&&Re<=127487||Re===8986||Re===8987||Re===9200||Re===9203||Re>=9728&&Re<=10175||Re===11088||Re===11093||Re>=127744&&Re<=128591||Re>=128640&&Re<=128764||Re>=128992&&Re<=129008||Re>=129280&&Re<=129535||Re>=129648&&Re<=129782}function K(Re,Se,Ve=""){const te=Re.trimStart();if(te.length<Se)return te;const re=/\b/g;let Ce=0;for(;re.test(te)&&!(te.length-re.lastIndex<Se);)Ce=re.lastIndex,re.lastIndex+=1;return Ce===0?te:Ve+te.substring(Ce).trimStart()}const se=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(Re){let Se=0;for(const Ve of Re.matchAll(se))Se!==Ve.index&&(yield{isCode:!1,str:Re.substring(Se,Ve.index)}),yield{isCode:!0,str:Ve[0]},Se=Ve.index+Ve[0].length;Se!==Re.length&&(yield{isCode:!1,str:Re.substring(Se)})}function ve(Re){return Re&&(Re=Re.replace(se,"")),Re}const Me=/\\\[.*?\\\]/g;function ge(Re){return ve(Re).replace(Me,"")}e.$Xf="\uFEFF";function Pe(Re){return!!(Re&&Re.length>0&&Re.charCodeAt(0)===65279)}function Ae(Re){return Pe(Re)?Re.substr(1):Re}function ze(Re,Se){if(!Re||!Se||Re.length<Se.length)return!1;const Ve=Se.length,te=Re.toLowerCase();let re=0,Ce=-1;for(;re<Ve;){const Ge=te.indexOf(Se[re],Ce+1);if(Ge<0)return!1;Ce=Ge,re++}return!0}function q(Re,Se=!1){return Re?(Se&&(Re=Re.replace(/\\./g,"")),Re.toLowerCase()!==Re):!1}function W(Re){return Re.charAt(0).toUpperCase()+Re.slice(1)}function X(Re,Se=1){if(Se===0)return"";let Ve=-1;do Ve=Re.indexOf(`
`,Ve+1),Se--;while(Se>0&&Ve>=0);return Ve===-1?Re:(Re[Ve-1]==="\r"&&Ve--,Re.substr(0,Ve))}function Q(Re){return Re=Re%(2*26),Re<26?String.fromCharCode(97+Re):String.fromCharCode(65+Re-26)}function de(Re){return qe.getInstance().getGraphemeBreakType(Re)}function we(Re,Se){return Re===0?Se!==5&&Se!==7:Re===2&&Se===3?!1:Re===4||Re===2||Re===3||Se===4||Se===2||Se===3?!0:!(Re===8&&(Se===8||Se===9||Se===11||Se===12)||(Re===11||Re===9)&&(Se===9||Se===10)||(Re===12||Re===10)&&Se===10||Se===5||Se===13||Se===7||Re===1||Re===13&&Se===14||Re===6&&Se===6)}var je;(function(Re){Re[Re.Other=0]="Other",Re[Re.Prepend=1]="Prepend",Re[Re.CR=2]="CR",Re[Re.LF=3]="LF",Re[Re.Control=4]="Control",Re[Re.Extend=5]="Extend",Re[Re.Regional_Indicator=6]="Regional_Indicator",Re[Re.SpacingMark=7]="SpacingMark",Re[Re.L=8]="L",Re[Re.V=9]="V",Re[Re.T=10]="T",Re[Re.LV=11]="LV",Re[Re.LVT=12]="LVT",Re[Re.ZWJ=13]="ZWJ",Re[Re.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class qe{static{this.c=null}static getInstance(){return qe.c||(qe.c=new qe),qe.c}constructor(){this.d=Ke()}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const Ve=this.d,te=Ve.length/3;let re=1;for(;re<=te;)if(Se<Ve[3*re])re=2*re;else if(Se>Ve[3*re+1])re=2*re+1;else return Ve[3*re+2];return 0}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Re,Se){if(Re===0)return 0;const Ve=_e(Re,Se);if(Ve!==void 0)return Ve;const te=new J(Se,Re);return te.prevCodePoint(),te.offset}function _e(Re,Se){const Ve=new J(Se,Re);let te=Ve.prevCodePoint();for(;nt(te)||te===65039||te===8419;){if(Ve.offset===0)return;te=Ve.prevCodePoint()}if(!le(te))return;let re=Ve.offset;return re>0&&Ve.prevCodePoint()===8205&&(re=Ve.offset),re}function nt(Re){return 127995<=Re&&Re<=127999}var it;(function(Re){Re[Re.zwj=8205]="zwj",Re[Re.emojiVariantSelector=65039]="emojiVariantSelector",Re[Re.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.$8f="\xA0";class rt{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new l.$5e({getCacheKey:JSON.stringify},Se=>{function Ve(mt){const Dt=new Map;for(let It=0;It<mt.length;It+=2)Dt.set(mt[It],mt[It+1]);return Dt}function te(mt,Dt){const It=new Map(mt);for(const[zt,Bt]of Dt)It.set(zt,Bt);return It}function re(mt,Dt){if(!mt)return Dt;const It=new Map;for(const[zt,Bt]of mt)Dt.has(zt)&&It.set(zt,Bt);return It}const Ce=this.c.value;let Ge=Se.filter(mt=>!mt.startsWith("_")&&mt in Ce);Ge.length===0&&(Ge=["_default"]);let Oe;for(const mt of Ge){const Dt=Ve(Ce[mt]);Oe=re(Oe,Dt)}const st=Ve(Ce._common),lt=te(st,Oe);return new rt(lt)})}static getInstance(Se){return rt.d.get(Array.from(Se))}static{this.e=new L.$V(()=>Object.keys(rt.c.value).filter(Se=>!Se.startsWith("_")))}static getLocales(){return rt.e.value}constructor(Se){this.f=Se}isAmbiguous(Se){return this.f.has(Se)}getPrimaryConfusable(Se){return this.f.get(Se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$9f=rt;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(Se){return ct.e().has(Se)}static get codePoints(){return ct.e()}}e.$0f=ct}),define(ke[127],De([1,0,27,168,14]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.FuzzyScore=e.$Ak=e.$zk=void 0,e.or=M,e.$Bk=b,e.$Ck=$,e.$Dk=I,e.$Ek=g,e.$Fk=w,e.$Gk=P,e.$Hk=j,e.$Ik=T,e.$Jk=z,e.$Kk=_,e.$Mk=oe,e.$Nk=se,e.$Ok=$e;function M(...ge){return function(Pe,Ae){for(let ze=0,q=ge.length;ze<q;ze++){const W=ge[ze](Pe,Ae);if(W)return W}return null}}e.$zk=R.bind(void 0,!1),e.$Ak=R.bind(void 0,!0);function R(ge,Pe,Ae){if(!Ae||Ae.length<Pe.length)return null;let ze;return ge?ze=O.$Af(Ae,Pe):ze=Ae.indexOf(Pe)===0,ze?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function b(ge,Pe){const Ae=Pe.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}function $(ge,Pe){return E(ge.toLowerCase(),Pe.toLowerCase(),0,0)}function E(ge,Pe,Ae,ze){if(Ae===ge.length)return[];if(ze===Pe.length)return null;if(ge[Ae]===Pe[ze]){let q=null;return(q=E(ge,Pe,Ae+1,ze+1))?a({start:ze,end:ze+1},q):null}return E(ge,Pe,Ae,ze+1)}function A(ge){return 97<=ge&&ge<=122}function I(ge){return 65<=ge&&ge<=90}function p(ge){return 48<=ge&&ge<=57}function S(ge){return ge===32||ge===9||ge===10||ge===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>v.add(ge.charCodeAt(0)));function h(ge){return S(ge)||v.has(ge)}function d(ge,Pe){return ge===Pe||h(ge)&&h(Pe)}const c=new Map;function n(ge){if(c.has(ge))return c.get(ge);let Pe;const Ae=(0,L.$xk)(ge);return Ae&&(Pe=Ae),c.set(ge,Pe),Pe}function i(ge){return A(ge)||I(ge)||p(ge)}function a(ge,Pe){return Pe.length===0?Pe=[ge]:ge.end===Pe[0].start?Pe[0].start=ge.start:Pe.unshift(ge),Pe}function s(ge,Pe){for(let Ae=Pe;Ae<ge.length;Ae++){const ze=ge.charCodeAt(Ae);if(I(ze)||p(ze)||Ae>0&&!i(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function t(ge,Pe,Ae,ze){if(Ae===ge.length)return[];if(ze===Pe.length)return null;if(ge[Ae]!==Pe[ze].toLowerCase())return null;{let q=null,W=ze+1;for(q=t(ge,Pe,Ae+1,ze+1);!q&&(W=s(Pe,W))<Pe.length;)q=t(ge,Pe,Ae+1,W),W++;return q===null?null:a({start:ze,end:ze+1},q)}}function u(ge){let Pe=0,Ae=0,ze=0,q=0,W=0;for(let je=0;je<ge.length;je++)W=ge.charCodeAt(je),I(W)&&Pe++,A(W)&&Ae++,i(W)&&ze++,p(W)&&q++;const X=Pe/ge.length,Q=Ae/ge.length,de=ze/ge.length,we=q/ge.length;return{upperPercent:X,lowerPercent:Q,alphaPercent:de,numericPercent:we}}function r(ge){const{upperPercent:Pe,lowerPercent:Ae}=ge;return Ae===0&&Pe>.6}function o(ge){const{upperPercent:Pe,lowerPercent:Ae,alphaPercent:ze,numericPercent:q}=ge;return Ae>.2&&Pe<.8&&ze>.6&&q<.2}function f(ge){let Pe=0,Ae=0,ze=0,q=0;for(let W=0;W<ge.length;W++)ze=ge.charCodeAt(W),I(ze)&&Pe++,A(ze)&&Ae++,S(ze)&&q++;return(Pe===0||Ae===0)&&q===0?ge.length<=30:Pe<=5}function g(ge,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!f(ge))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Ae=u(Pe);if(!o(Ae)){if(!r(Ae))return null;Pe=Pe.toLowerCase()}let ze=null,q=0;for(ge=ge.toLowerCase();q<Pe.length&&(ze=t(ge,Pe,0,q))===null;)q=s(Pe,q+1);return ze}function w(ge,Pe,Ae=!1){if(!Pe||Pe.length===0)return null;let ze=null,q=0;for(ge=ge.toLowerCase(),Pe=Pe.toLowerCase();q<Pe.length&&(ze=k(ge,Pe,0,q,Ae),ze===null);)q=m(Pe,q+1);return ze}function k(ge,Pe,Ae,ze,q){let W=0;if(Ae===ge.length)return[];if(ze===Pe.length)return null;if(!d(ge.charCodeAt(Ae),Pe.charCodeAt(ze))){const de=n(ge.charCodeAt(Ae));if(!de)return null;for(let we=0;we<de.length;we++)if(!d(de[we],Pe.charCodeAt(ze+we)))return null;W+=de.length-1}let X=null,Q=ze+W+1;if(X=k(ge,Pe,Ae+1,Q,q),!q)for(;!X&&(Q=m(Pe,Q))<Pe.length;)X=k(ge,Pe,Ae+1,Q,q),Q++;if(!X)return null;if(ge.charCodeAt(Ae)!==Pe.charCodeAt(ze)){const de=n(ge.charCodeAt(Ae));if(!de)return X;for(let we=0;we<de.length;we++)if(de[we]!==Pe.charCodeAt(ze+we))return X}return a({start:ze,end:ze+W+1},X)}function m(ge,Pe){for(let Ae=Pe;Ae<ge.length;Ae++)if(h(ge.charCodeAt(Ae))||Ae>0&&h(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const y=M(e.$Ak,g,b),D=M(e.$Ak,g,$),C=new l.$Dc(1e4);function P(ge,Pe,Ae=!1){if(typeof ge!="string"||typeof Pe!="string")return null;let ze=C.get(ge);ze||(ze=new RegExp(O.$if(ge),"i"),C.set(ge,ze));const q=ze.exec(Pe);return q?[{start:q.index,end:q.index+q[0].length}]:Ae?D(ge,Pe):y(ge,Pe)}function j(ge,Pe){const Ae=oe(ge,ge.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?z(Ae):null}function T(ge,Pe,Ae,ze,q,W){const X=Math.min(13,ge.length);for(;Ae<X;Ae++){const Q=oe(ge,Pe,Ae,ze,q,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,W]}function z(ge){if(typeof ge>"u")return[];const Pe=[],Ae=ge[1];for(let ze=ge.length-1;ze>1;ze--){const q=ge[ze]+Ae,W=Pe[Pe.length-1];W&&W.end===q?W.end=q+1:Pe.push({start:q,end:q+1})}return Pe}const N=128;function F(){const ge=[],Pe=[];for(let Ae=0;Ae<=N;Ae++)Pe[Ae]=0;for(let Ae=0;Ae<=N;Ae++)ge.push(Pe.slice(0));return ge}function U(ge){const Pe=[];for(let Ae=0;Ae<=ge;Ae++)Pe[Ae]=0;return Pe}const Y=U(2*N),ie=U(2*N),H=F(),J=F(),x=F(),ne=!1;function be(ge,Pe,Ae,ze,q){function W(Q,de,we=" "){for(;Q.length<de;)Q=we+Q;return Q}let X=` |   |${ze.split("").map(Q=>W(Q,3)).join("|")}
`;for(let Q=0;Q<=Ae;Q++)Q===0?X+=" |":X+=`${Pe[Q-1]}|`,X+=ge[Q].slice(0,q+1).map(de=>W(de.toString(),3)).join("|")+`
`;return X}function ae(ge,Pe,Ae,ze){ge=ge.substr(Pe),Ae=Ae.substr(ze),console.log(be(J,ge,ge.length,Ae,Ae.length)),console.log(be(x,ge,ge.length,Ae,Ae.length)),console.log(be(H,ge,ge.length,Ae,Ae.length))}function Ie(ge,Pe){if(Pe<0||Pe>=ge.length)return!1;const Ae=ge.codePointAt(Pe);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$Sf(Ae)}}function ee(ge,Pe){if(Pe<0||Pe>=ge.length)return!1;switch(ge.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function B(ge,Pe,Ae){return Pe[ge]!==Ae[ge]}function _(ge,Pe,Ae,ze,q,W,X=!1){for(;Pe<Ae&&q<W;)ge[Pe]===ze[q]&&(X&&(Y[Pe]=q),Pe+=1),q+=1;return Pe===Ae}var pe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var ue;(function(ge){ge.Default=[-100,0];function Pe(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Pe})(ue||(e.FuzzyScore=ue={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Ae){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Ae}}e.$Lk=ce;function oe(ge,Pe,Ae,ze,q,W,X=ce.default){const Q=ge.length>N?N:ge.length,de=ze.length>N?N:ze.length;if(Ae>=Q||W>=de||Q-Ae>de-W||!_(Pe,Ae,Q,q,W,de,!0))return;le(Q,de,Ae,W,Pe,q);let we=1,je=1,qe=Ae,Ke=W;const tt=[!1];for(we=1,qe=Ae;qe<Q;we++,qe++){const ct=Y[qe],Re=ie[qe],Se=qe+1<Q?ie[qe+1]:de;for(je=ct-W+1,Ke=ct;Ke<Se;je++,Ke++){let Ve=Number.MIN_SAFE_INTEGER,te=!1;Ke<=Re&&(Ve=K(ge,Pe,qe,Ae,ze,q,Ke,de,W,H[we-1][je-1]===0,tt));let re=0;Ve!==Number.MAX_SAFE_INTEGER&&(te=!0,re=Ve+J[we-1][je-1]);const Ce=Ke>ct,Ge=Ce?J[we][je-1]+(H[we][je-1]>0?-5:0):0,Oe=Ke>ct+1&&H[we][je-1]>0,st=Oe?J[we][je-2]+(H[we][je-2]>0?-5:0):0;if(Oe&&(!Ce||st>=Ge)&&(!te||st>=re))J[we][je]=st,x[we][je]=3,H[we][je]=0;else if(Ce&&(!te||Ge>=re))J[we][je]=Ge,x[we][je]=2,H[we][je]=0;else if(te)J[we][je]=re,x[we][je]=1,H[we][je]=H[we-1][je-1]+1;else throw new Error("not possible")}}if(ne&&ae(ge,Ae,ze,W),!tt[0]&&!X.firstMatchCanBeWeak)return;we--,je--;const _e=[J[we][je],W];let nt=0,it=0;for(;we>=1;){let ct=je;do{const Re=x[we][ct];if(Re===3)ct=ct-2;else if(Re===2)ct=ct-1;else break}while(ct>=1);nt>1&&Pe[Ae+we-1]===q[W+je-1]&&!B(ct+W-1,ze,q)&&nt+1>H[we][ct]&&(ct=je),ct===je?nt++:nt=1,it||(it=ct),we--,je=ct-1,_e.push(je)}de-W===Q&&X.boostFullMatch&&(_e[0]+=2);const rt=it-Q;return _e[0]-=rt,_e}function le(ge,Pe,Ae,ze,q,W){let X=ge-1,Q=Pe-1;for(;X>=Ae&&Q>=ze;)q[X]===W[Q]&&(ie[X]=Q,X--),Q--}function K(ge,Pe,Ae,ze,q,W,X,Q,de,we,je){if(Pe[Ae]!==W[X])return Number.MIN_SAFE_INTEGER;let qe=1,Ke=!1;return X===Ae-ze?qe=ge[Ae]===q[X]?7:5:B(X,q,W)&&(X===0||!B(X-1,q,W))?(qe=ge[Ae]===q[X]?7:5,Ke=!0):Ie(W,X)&&(X===0||!Ie(W,X-1))?qe=5:(Ie(W,X-1)||ee(W,X-1))&&(qe=5,Ke=!0),qe>1&&Ae===ze&&(je[0]=!0),Ke||(Ke=B(X,q,W)||Ie(W,X-1)||ee(W,X-1)),Ae===ze?X>de&&(qe-=Ke?3:5):we?qe+=Ke?2:0:qe+=Ke?0:1,X+1===Q&&(qe-=Ke?3:5),qe}function se(ge,Pe,Ae,ze,q,W,X){return ve(ge,Pe,Ae,ze,q,W,!0,X)}function $e(ge,Pe,Ae,ze,q,W,X){return ve(ge,Pe,Ae,ze,q,W,!1,X)}function ve(ge,Pe,Ae,ze,q,W,X,Q){let de=oe(ge,Pe,Ae,ze,q,W,Q);if(de&&!X)return de;if(ge.length>=3){const we=Math.min(7,ge.length-1);for(let je=Ae+1;je<we;je++){const qe=Me(ge,je);if(qe){const Ke=oe(qe,qe.toLowerCase(),Ae,ze,q,W,Q);Ke&&(Ke[0]-=3,(!de||Ke[0]>de[0])&&(de=Ke))}}}return de}function Me(ge,Pe){if(Pe+1>=ge.length)return;const Ae=ge[Pe],ze=ge[Pe+1];if(Ae!==ze)return ge.slice(0,Pe)+ze+Ae+ge.slice(Pe+2)}}),define(ke[57],De([1,0,14]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=L,e.$nj=O,e.$oj=M,e.$pj=b,e.$rj=h;function L(c){return O(c,0)}function O(c,n){switch(typeof c){case"object":return c===null?M(349,n):Array.isArray(c)?$(c,n):E(c,n);case"string":return b(c,n);case"boolean":return R(c,n);case"number":return M(c,n);case"undefined":return M(937,n);default:return M(617,n)}}function M(c,n){return(n<<5)-n+c|0}function R(c,n){return M(c?433:863,n)}function b(c,n){n=M(149417,n);for(let i=0,a=c.length;i<a;i++)n=M(c.charCodeAt(i),n);return n}function $(c,n){return n=M(104579,n),c.reduce((i,a)=>O(a,i),n)}function E(c,n){return n=M(181387,n),Object.keys(c).sort().reduce((i,a)=>(i=b(a,i),O(c[a],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=O(n,this.g),this.g}}e.$qj=A;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(c,n,i=32){const a=i-n,s=~((1<<a)-1);return(c<<n|(s&c)>>>a)>>>0}function S(c,n=0,i=c.byteLength,a=0){for(let s=0;s<i;s++)c[n+s]=a}function v(c,n,i="0"){for(;c.length<n;)c=i+c;return c}function h(c,n=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((c>>>0).toString(16),n/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const a=this.p;let s=this.r,t=this.u,u,r;for(t!==0?(u=t,r=-1,t=0):(u=n.charCodeAt(0),r=0);;){let o=u;if(l.$Df(u))if(r+1<i){const f=n.charCodeAt(r+1);l.$Ef(f)?(r++,o=l.$Ff(u,f)):o=65533}else{t=u;break}else l.$Ef(u)&&(o=65533);if(s=this.w(a,s,o),r++,r<i)u=n.charCodeAt(r);else break}this.r=s,this.u=t}w(n,i,a){return a<128?n[i++]=a:a<2048?(n[i++]=192|(a&1984)>>>6,n[i++]=128|(a&63)>>>0):a<65536?(n[i++]=224|(a&61440)>>>12,n[i++]=128|(a&4032)>>>6,n[i++]=128|(a&63)>>>0):(n[i++]=240|(a&1835008)>>>18,n[i++]=128|(a&258048)>>>12,n[i++]=128|(a&4032)>>>6,n[i++]=128|(a&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=d.g,i=this.q;for(let w=0;w<64;w+=4)n.setUint32(w,i.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)n.setUint32(w,p(n.getUint32(w-12,!1)^n.getUint32(w-32,!1)^n.getUint32(w-56,!1)^n.getUint32(w-64,!1),1),!1);let a=this.h,s=this.l,t=this.m,u=this.n,r=this.o,o,f,g;for(let w=0;w<80;w++)w<20?(o=s&t|~s&u,f=1518500249):w<40?(o=s^t^u,f=1859775393):w<60?(o=s&t|s&u|t&u,f=2400959708):(o=s^t^u,f=3395469782),g=p(a,5)+o+r+f+n.getUint32(w*4,!1)&4294967295,r=u,u=t,t=p(s,30),s=a,a=g;this.h=this.h+a&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+r&4294967295}}e.$sj=d}),define(ke[41],De([1,0,14]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(L||(L={})),function(O){const M="error",R="warning",b="warn",$="info",E="ignore";function A(p){return p?l.$zf(M,p)?O.Error:l.$zf(R,p)||l.$zf(b,p)?O.Warning:l.$zf($,p)?O.Info:O.Ignore:O.Ignore}O.fromValue=A;function I(p){switch(p){case O.Error:return M;case O.Warning:return R;case O.Info:return $;default:return E}}O.toString=I}(L||(L={})),e.default=L}),define(ke[174],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ke[78],De([1,0,19,14]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class O{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const v=S.charCodeAt(0),h=this.b.charCodeAt(this.c);return v-h}value(){return this.b[this.c]}}e.$Ai=O;class M{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,L.$tf)(S,this.b,0,S.length,this.c,this.d):(0,L.$vf)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=M;class R{constructor(S=!0,v=!0){this.f=S,this.g=v}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let v=S.length-1;v>=0;v--,this.c--){const h=this.b.charCodeAt(v);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,L.$tf)(S,this.b,0,S.length,this.d,this.e):(0,L.$vf)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=R;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(S,v){this.f=S,this.g=v,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,L.$uf)(S,this.c.scheme);if(this.d[this.e]===2)return(0,L.$uf)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,L.$sf)(S,this.c.query);if(this.d[this.e]===5)return(0,L.$sf)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=$;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(A||(A={}));class I{static forUris(S=()=>!1,v=()=>!1){return new I(new $(S,v))}static forPaths(S=!1){return new I(new R(void 0,!S))}static forStrings(){return new I(new O)}static forConfigKeys(){return new I(new M)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,v){if(v){const h=v.slice(0);(0,l.$Wb)(h);for(const d of h)this.set(d,S)}else{const h=S.slice(0);(0,l.$Wb)(h);for(const d of h)this.set(d[0],d[1])}}set(S,v){const h=this.b.reset(S);let d;this.c||(this.c=new E,this.c.segment=h.value());const c=[];for(d=this.c;;){const i=h.cmp(d.segment);if(i>0)d.left||(d.left=new E,d.left.segment=h.value()),c.push([-1,d]),d=d.left;else if(i<0)d.right||(d.right=new E,d.right.segment=h.value()),c.push([1,d]),d=d.right;else if(h.hasNext())h.next(),d.mid||(d.mid=new E,d.mid.segment=h.value()),c.push([0,d]),d=d.mid;else break}const n=d.value;d.value=v,d.key=S;for(let i=c.length-1;i>=0;i--){const a=c[i][1];a.updateHeight();const s=a.balanceFactor();if(s<-1||s>1){const t=c[i][0],u=c[i+1][0];if(t===1&&u===1)c[i][1]=a.rotateLeft();else if(t===-1&&u===-1)c[i][1]=a.rotateRight();else if(t===1&&u===-1)a.right=c[i+1][1]=c[i+1][1].rotateRight(),c[i][1]=a.rotateLeft();else if(t===-1&&u===1)a.left=c[i+1][1]=c[i+1][1].rotateLeft(),c[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}return n}get(S){return this.d(S)?.value}d(S){const v=this.b.reset(S);let h=this.c;for(;h;){const d=v.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(v.hasNext())v.next(),h=h.mid;else break}return h}has(S){const v=this.d(S);return!(v?.value===void 0&&v?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,v){const h=this.b.reset(S),d=[];let c=this.c;for(;c;){const n=h.cmp(c.segment);if(n>0)d.push([-1,c]),c=c.left;else if(n<0)d.push([1,c]),c=c.right;else if(h.hasNext())h.next(),d.push([0,c]),c=c.mid;else break}if(c){if(v?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const n=this.f(c.right);if(n.key){const{key:i,value:a,segment:s}=n;this.e(n.key,!1),c.key=i,c.value=a,c.segment=s}}else{const n=c.left??c.right;if(d.length>0){const[i,a]=d[d.length-1];switch(i){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=d.length-1;n>=0;n--){const i=d[n][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),d[n][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),d[n][1]=i.rotateRight()),n>0)switch(d[n-1][0]){case-1:d[n-1][1].left=d[n][1];break;case 1:d[n-1][1].right=d[n][1];break;case 0:d[n-1][1].mid=d[n][1];break}else this.c=d[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const v=this.b.reset(S);let h=this.c,d;for(;h;){const c=v.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(v.hasNext())v.next(),d=h.value||d,h=h.mid;else break}return h&&h.value||d}findSuperstr(S){return this.g(S,!1)}g(S,v){const h=this.b.reset(S);let d=this.c;for(;d;){const c=h.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(h.hasNext())h.next(),d=d.mid;else return d.mid?this.h(d.mid):v?d.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[v,h]of this)S(h,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const v=[];return this.j(S,v),v[Symbol.iterator]()}j(S,v){S&&(S.left&&this.j(S.left,v),S.value&&v.push([S.key,S.value]),S.mid&&this.j(S.mid,v),S.right&&this.j(S.right,v))}_isBalanced(){const S=v=>{if(!v)return!0;const h=v.balanceFactor();return h<-1||h>1?!1:S(v.left)&&S(v.right)};return S(this.c)}}e.$Ei=I}),define(ke[18],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=l,e.$_f=L,e.$ag=O,e.$bg=M,e.$cg=R,e.$dg=b,e.$eg=$,e.$fg=E,e.$gg=A,e.$hg=I,e.$ig=p,e.$jg=S,e.$kg=v,e.$lg=d,e.$mg=c,e.$ng=n,e.$og=i,e.$pg=a;function l(s){return typeof s=="string"}function L(s){return Array.isArray(s)&&s.every(t=>l(t))}function O(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function M(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function R(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function E(s){return typeof s>"u"}function A(s){return!I(s)}function I(s){return E(s)||s===null}function p(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function S(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let u=0;u<s.length;u++){const r=s[u];if(I(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(r)}return t}const h=Object.prototype.hasOwnProperty;function d(s){if(!O(s))return!1;for(const t in s)if(h.call(s,t))return!1;return!0}function c(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(c)}function i(s,t){const u=Math.min(s.length,t.length);for(let r=0;r<u;r++)a(s[r],t[r])}function a(s,t){if(l(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(s instanceof t)return}catch{}if(!I(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],De([1,0,18]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=O,e.$Tj=M;const L=Object.create(null);function O(R,b){if((0,l.$$f)(b)){const $=L[b];if($===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=$}return L[R]=b,{id:R}}function M(){return L}}),define(ke[175],De([1,0,99]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=void 0,e.$Uj={add:(0,l.$Sj)("add",6e4),plus:(0,l.$Sj)("plus",6e4),gistNew:(0,l.$Sj)("gist-new",6e4),repoCreate:(0,l.$Sj)("repo-create",6e4),lightbulb:(0,l.$Sj)("lightbulb",60001),lightBulb:(0,l.$Sj)("light-bulb",60001),repo:(0,l.$Sj)("repo",60002),repoDelete:(0,l.$Sj)("repo-delete",60002),gistFork:(0,l.$Sj)("gist-fork",60003),repoForked:(0,l.$Sj)("repo-forked",60003),gitPullRequest:(0,l.$Sj)("git-pull-request",60004),gitPullRequestAbandoned:(0,l.$Sj)("git-pull-request-abandoned",60004),recordKeys:(0,l.$Sj)("record-keys",60005),keyboard:(0,l.$Sj)("keyboard",60005),tag:(0,l.$Sj)("tag",60006),gitPullRequestLabel:(0,l.$Sj)("git-pull-request-label",60006),tagAdd:(0,l.$Sj)("tag-add",60006),tagRemove:(0,l.$Sj)("tag-remove",60006),person:(0,l.$Sj)("person",60007),personFollow:(0,l.$Sj)("person-follow",60007),personOutline:(0,l.$Sj)("person-outline",60007),personFilled:(0,l.$Sj)("person-filled",60007),gitBranch:(0,l.$Sj)("git-branch",60008),gitBranchCreate:(0,l.$Sj)("git-branch-create",60008),gitBranchDelete:(0,l.$Sj)("git-branch-delete",60008),sourceControl:(0,l.$Sj)("source-control",60008),mirror:(0,l.$Sj)("mirror",60009),mirrorPublic:(0,l.$Sj)("mirror-public",60009),star:(0,l.$Sj)("star",60010),starAdd:(0,l.$Sj)("star-add",60010),starDelete:(0,l.$Sj)("star-delete",60010),starEmpty:(0,l.$Sj)("star-empty",60010),comment:(0,l.$Sj)("comment",60011),commentAdd:(0,l.$Sj)("comment-add",60011),alert:(0,l.$Sj)("alert",60012),warning:(0,l.$Sj)("warning",60012),search:(0,l.$Sj)("search",60013),searchSave:(0,l.$Sj)("search-save",60013),logOut:(0,l.$Sj)("log-out",60014),signOut:(0,l.$Sj)("sign-out",60014),logIn:(0,l.$Sj)("log-in",60015),signIn:(0,l.$Sj)("sign-in",60015),eye:(0,l.$Sj)("eye",60016),eyeUnwatch:(0,l.$Sj)("eye-unwatch",60016),eyeWatch:(0,l.$Sj)("eye-watch",60016),circleFilled:(0,l.$Sj)("circle-filled",60017),primitiveDot:(0,l.$Sj)("primitive-dot",60017),closeDirty:(0,l.$Sj)("close-dirty",60017),debugBreakpoint:(0,l.$Sj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,l.$Sj)("debug-breakpoint-disabled",60017),debugHint:(0,l.$Sj)("debug-hint",60017),terminalDecorationSuccess:(0,l.$Sj)("terminal-decoration-success",60017),primitiveSquare:(0,l.$Sj)("primitive-square",60018),edit:(0,l.$Sj)("edit",60019),pencil:(0,l.$Sj)("pencil",60019),info:(0,l.$Sj)("info",60020),issueOpened:(0,l.$Sj)("issue-opened",60020),gistPrivate:(0,l.$Sj)("gist-private",60021),gitForkPrivate:(0,l.$Sj)("git-fork-private",60021),lock:(0,l.$Sj)("lock",60021),mirrorPrivate:(0,l.$Sj)("mirror-private",60021),close:(0,l.$Sj)("close",60022),removeClose:(0,l.$Sj)("remove-close",60022),x:(0,l.$Sj)("x",60022),repoSync:(0,l.$Sj)("repo-sync",60023),sync:(0,l.$Sj)("sync",60023),clone:(0,l.$Sj)("clone",60024),desktopDownload:(0,l.$Sj)("desktop-download",60024),beaker:(0,l.$Sj)("beaker",60025),microscope:(0,l.$Sj)("microscope",60025),vm:(0,l.$Sj)("vm",60026),deviceDesktop:(0,l.$Sj)("device-desktop",60026),file:(0,l.$Sj)("file",60027),fileText:(0,l.$Sj)("file-text",60027),more:(0,l.$Sj)("more",60028),ellipsis:(0,l.$Sj)("ellipsis",60028),kebabHorizontal:(0,l.$Sj)("kebab-horizontal",60028),mailReply:(0,l.$Sj)("mail-reply",60029),reply:(0,l.$Sj)("reply",60029),organization:(0,l.$Sj)("organization",60030),organizationFilled:(0,l.$Sj)("organization-filled",60030),organizationOutline:(0,l.$Sj)("organization-outline",60030),newFile:(0,l.$Sj)("new-file",60031),fileAdd:(0,l.$Sj)("file-add",60031),newFolder:(0,l.$Sj)("new-folder",60032),fileDirectoryCreate:(0,l.$Sj)("file-directory-create",60032),trash:(0,l.$Sj)("trash",60033),trashcan:(0,l.$Sj)("trashcan",60033),history:(0,l.$Sj)("history",60034),clock:(0,l.$Sj)("clock",60034),folder:(0,l.$Sj)("folder",60035),fileDirectory:(0,l.$Sj)("file-directory",60035),symbolFolder:(0,l.$Sj)("symbol-folder",60035),logoGithub:(0,l.$Sj)("logo-github",60036),markGithub:(0,l.$Sj)("mark-github",60036),github:(0,l.$Sj)("github",60036),terminal:(0,l.$Sj)("terminal",60037),console:(0,l.$Sj)("console",60037),repl:(0,l.$Sj)("repl",60037),zap:(0,l.$Sj)("zap",60038),symbolEvent:(0,l.$Sj)("symbol-event",60038),error:(0,l.$Sj)("error",60039),stop:(0,l.$Sj)("stop",60039),variable:(0,l.$Sj)("variable",60040),symbolVariable:(0,l.$Sj)("symbol-variable",60040),array:(0,l.$Sj)("array",60042),symbolArray:(0,l.$Sj)("symbol-array",60042),symbolModule:(0,l.$Sj)("symbol-module",60043),symbolPackage:(0,l.$Sj)("symbol-package",60043),symbolNamespace:(0,l.$Sj)("symbol-namespace",60043),symbolObject:(0,l.$Sj)("symbol-object",60043),symbolMethod:(0,l.$Sj)("symbol-method",60044),symbolFunction:(0,l.$Sj)("symbol-function",60044),symbolConstructor:(0,l.$Sj)("symbol-constructor",60044),symbolBoolean:(0,l.$Sj)("symbol-boolean",60047),symbolNull:(0,l.$Sj)("symbol-null",60047),symbolNumeric:(0,l.$Sj)("symbol-numeric",60048),symbolNumber:(0,l.$Sj)("symbol-number",60048),symbolStructure:(0,l.$Sj)("symbol-structure",60049),symbolStruct:(0,l.$Sj)("symbol-struct",60049),symbolParameter:(0,l.$Sj)("symbol-parameter",60050),symbolTypeParameter:(0,l.$Sj)("symbol-type-parameter",60050),symbolKey:(0,l.$Sj)("symbol-key",60051),symbolText:(0,l.$Sj)("symbol-text",60051),symbolReference:(0,l.$Sj)("symbol-reference",60052),goToFile:(0,l.$Sj)("go-to-file",60052),symbolEnum:(0,l.$Sj)("symbol-enum",60053),symbolValue:(0,l.$Sj)("symbol-value",60053),symbolRuler:(0,l.$Sj)("symbol-ruler",60054),symbolUnit:(0,l.$Sj)("symbol-unit",60054),activateBreakpoints:(0,l.$Sj)("activate-breakpoints",60055),archive:(0,l.$Sj)("archive",60056),arrowBoth:(0,l.$Sj)("arrow-both",60057),arrowDown:(0,l.$Sj)("arrow-down",60058),arrowLeft:(0,l.$Sj)("arrow-left",60059),arrowRight:(0,l.$Sj)("arrow-right",60060),arrowSmallDown:(0,l.$Sj)("arrow-small-down",60061),arrowSmallLeft:(0,l.$Sj)("arrow-small-left",60062),arrowSmallRight:(0,l.$Sj)("arrow-small-right",60063),arrowSmallUp:(0,l.$Sj)("arrow-small-up",60064),arrowUp:(0,l.$Sj)("arrow-up",60065),bell:(0,l.$Sj)("bell",60066),bold:(0,l.$Sj)("bold",60067),book:(0,l.$Sj)("book",60068),bookmark:(0,l.$Sj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,l.$Sj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,l.$Sj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,l.$Sj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,l.$Sj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,l.$Sj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,l.$Sj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,l.$Sj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,l.$Sj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,l.$Sj)("debug-breakpoint-log-disabled",60075),briefcase:(0,l.$Sj)("briefcase",60076),broadcast:(0,l.$Sj)("broadcast",60077),browser:(0,l.$Sj)("browser",60078),bug:(0,l.$Sj)("bug",60079),calendar:(0,l.$Sj)("calendar",60080),caseSensitive:(0,l.$Sj)("case-sensitive",60081),check:(0,l.$Sj)("check",60082),checklist:(0,l.$Sj)("checklist",60083),chevronDown:(0,l.$Sj)("chevron-down",60084),chevronLeft:(0,l.$Sj)("chevron-left",60085),chevronRight:(0,l.$Sj)("chevron-right",60086),chevronUp:(0,l.$Sj)("chevron-up",60087),chromeClose:(0,l.$Sj)("chrome-close",60088),chromeMaximize:(0,l.$Sj)("chrome-maximize",60089),chromeMinimize:(0,l.$Sj)("chrome-minimize",60090),chromeRestore:(0,l.$Sj)("chrome-restore",60091),circleOutline:(0,l.$Sj)("circle-outline",60092),circle:(0,l.$Sj)("circle",60092),debugBreakpointUnverified:(0,l.$Sj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,l.$Sj)("terminal-decoration-incomplete",60092),circleSlash:(0,l.$Sj)("circle-slash",60093),circuitBoard:(0,l.$Sj)("circuit-board",60094),clearAll:(0,l.$Sj)("clear-all",60095),clippy:(0,l.$Sj)("clippy",60096),closeAll:(0,l.$Sj)("close-all",60097),cloudDownload:(0,l.$Sj)("cloud-download",60098),cloudUpload:(0,l.$Sj)("cloud-upload",60099),code:(0,l.$Sj)("code",60100),collapseAll:(0,l.$Sj)("collapse-all",60101),colorMode:(0,l.$Sj)("color-mode",60102),commentDiscussion:(0,l.$Sj)("comment-discussion",60103),creditCard:(0,l.$Sj)("credit-card",60105),dash:(0,l.$Sj)("dash",60108),dashboard:(0,l.$Sj)("dashboard",60109),database:(0,l.$Sj)("database",60110),debugContinue:(0,l.$Sj)("debug-continue",60111),debugDisconnect:(0,l.$Sj)("debug-disconnect",60112),debugPause:(0,l.$Sj)("debug-pause",60113),debugRestart:(0,l.$Sj)("debug-restart",60114),debugStart:(0,l.$Sj)("debug-start",60115),debugStepInto:(0,l.$Sj)("debug-step-into",60116),debugStepOut:(0,l.$Sj)("debug-step-out",60117),debugStepOver:(0,l.$Sj)("debug-step-over",60118),debugStop:(0,l.$Sj)("debug-stop",60119),debug:(0,l.$Sj)("debug",60120),deviceCameraVideo:(0,l.$Sj)("device-camera-video",60121),deviceCamera:(0,l.$Sj)("device-camera",60122),deviceMobile:(0,l.$Sj)("device-mobile",60123),diffAdded:(0,l.$Sj)("diff-added",60124),diffIgnored:(0,l.$Sj)("diff-ignored",60125),diffModified:(0,l.$Sj)("diff-modified",60126),diffRemoved:(0,l.$Sj)("diff-removed",60127),diffRenamed:(0,l.$Sj)("diff-renamed",60128),diff:(0,l.$Sj)("diff",60129),diffSidebyside:(0,l.$Sj)("diff-sidebyside",60129),discard:(0,l.$Sj)("discard",60130),editorLayout:(0,l.$Sj)("editor-layout",60131),emptyWindow:(0,l.$Sj)("empty-window",60132),exclude:(0,l.$Sj)("exclude",60133),extensions:(0,l.$Sj)("extensions",60134),eyeClosed:(0,l.$Sj)("eye-closed",60135),fileBinary:(0,l.$Sj)("file-binary",60136),fileCode:(0,l.$Sj)("file-code",60137),fileMedia:(0,l.$Sj)("file-media",60138),filePdf:(0,l.$Sj)("file-pdf",60139),fileSubmodule:(0,l.$Sj)("file-submodule",60140),fileSymlinkDirectory:(0,l.$Sj)("file-symlink-directory",60141),fileSymlinkFile:(0,l.$Sj)("file-symlink-file",60142),fileZip:(0,l.$Sj)("file-zip",60143),files:(0,l.$Sj)("files",60144),filter:(0,l.$Sj)("filter",60145),flame:(0,l.$Sj)("flame",60146),foldDown:(0,l.$Sj)("fold-down",60147),foldUp:(0,l.$Sj)("fold-up",60148),fold:(0,l.$Sj)("fold",60149),folderActive:(0,l.$Sj)("folder-active",60150),folderOpened:(0,l.$Sj)("folder-opened",60151),gear:(0,l.$Sj)("gear",60152),gift:(0,l.$Sj)("gift",60153),gistSecret:(0,l.$Sj)("gist-secret",60154),gist:(0,l.$Sj)("gist",60155),gitCommit:(0,l.$Sj)("git-commit",60156),gitCompare:(0,l.$Sj)("git-compare",60157),compareChanges:(0,l.$Sj)("compare-changes",60157),gitMerge:(0,l.$Sj)("git-merge",60158),githubAction:(0,l.$Sj)("github-action",60159),githubAlt:(0,l.$Sj)("github-alt",60160),globe:(0,l.$Sj)("globe",60161),grabber:(0,l.$Sj)("grabber",60162),graph:(0,l.$Sj)("graph",60163),gripper:(0,l.$Sj)("gripper",60164),heart:(0,l.$Sj)("heart",60165),home:(0,l.$Sj)("home",60166),horizontalRule:(0,l.$Sj)("horizontal-rule",60167),hubot:(0,l.$Sj)("hubot",60168),inbox:(0,l.$Sj)("inbox",60169),issueReopened:(0,l.$Sj)("issue-reopened",60171),issues:(0,l.$Sj)("issues",60172),italic:(0,l.$Sj)("italic",60173),jersey:(0,l.$Sj)("jersey",60174),json:(0,l.$Sj)("json",60175),kebabVertical:(0,l.$Sj)("kebab-vertical",60176),key:(0,l.$Sj)("key",60177),law:(0,l.$Sj)("law",60178),lightbulbAutofix:(0,l.$Sj)("lightbulb-autofix",60179),linkExternal:(0,l.$Sj)("link-external",60180),link:(0,l.$Sj)("link",60181),listOrdered:(0,l.$Sj)("list-ordered",60182),listUnordered:(0,l.$Sj)("list-unordered",60183),liveShare:(0,l.$Sj)("live-share",60184),loading:(0,l.$Sj)("loading",60185),location:(0,l.$Sj)("location",60186),mailRead:(0,l.$Sj)("mail-read",60187),mail:(0,l.$Sj)("mail",60188),markdown:(0,l.$Sj)("markdown",60189),megaphone:(0,l.$Sj)("megaphone",60190),mention:(0,l.$Sj)("mention",60191),milestone:(0,l.$Sj)("milestone",60192),gitPullRequestMilestone:(0,l.$Sj)("git-pull-request-milestone",60192),mortarBoard:(0,l.$Sj)("mortar-board",60193),move:(0,l.$Sj)("move",60194),multipleWindows:(0,l.$Sj)("multiple-windows",60195),mute:(0,l.$Sj)("mute",60196),noNewline:(0,l.$Sj)("no-newline",60197),note:(0,l.$Sj)("note",60198),octoface:(0,l.$Sj)("octoface",60199),openPreview:(0,l.$Sj)("open-preview",60200),package:(0,l.$Sj)("package",60201),paintcan:(0,l.$Sj)("paintcan",60202),pin:(0,l.$Sj)("pin",60203),play:(0,l.$Sj)("play",60204),run:(0,l.$Sj)("run",60204),plug:(0,l.$Sj)("plug",60205),preserveCase:(0,l.$Sj)("preserve-case",60206),preview:(0,l.$Sj)("preview",60207),project:(0,l.$Sj)("project",60208),pulse:(0,l.$Sj)("pulse",60209),question:(0,l.$Sj)("question",60210),quote:(0,l.$Sj)("quote",60211),radioTower:(0,l.$Sj)("radio-tower",60212),reactions:(0,l.$Sj)("reactions",60213),references:(0,l.$Sj)("references",60214),refresh:(0,l.$Sj)("refresh",60215),regex:(0,l.$Sj)("regex",60216),remoteExplorer:(0,l.$Sj)("remote-explorer",60217),remote:(0,l.$Sj)("remote",60218),remove:(0,l.$Sj)("remove",60219),replaceAll:(0,l.$Sj)("replace-all",60220),replace:(0,l.$Sj)("replace",60221),repoClone:(0,l.$Sj)("repo-clone",60222),repoForcePush:(0,l.$Sj)("repo-force-push",60223),repoPull:(0,l.$Sj)("repo-pull",60224),repoPush:(0,l.$Sj)("repo-push",60225),report:(0,l.$Sj)("report",60226),requestChanges:(0,l.$Sj)("request-changes",60227),rocket:(0,l.$Sj)("rocket",60228),rootFolderOpened:(0,l.$Sj)("root-folder-opened",60229),rootFolder:(0,l.$Sj)("root-folder",60230),rss:(0,l.$Sj)("rss",60231),ruby:(0,l.$Sj)("ruby",60232),saveAll:(0,l.$Sj)("save-all",60233),saveAs:(0,l.$Sj)("save-as",60234),save:(0,l.$Sj)("save",60235),screenFull:(0,l.$Sj)("screen-full",60236),screenNormal:(0,l.$Sj)("screen-normal",60237),searchStop:(0,l.$Sj)("search-stop",60238),server:(0,l.$Sj)("server",60240),settingsGear:(0,l.$Sj)("settings-gear",60241),settings:(0,l.$Sj)("settings",60242),shield:(0,l.$Sj)("shield",60243),smiley:(0,l.$Sj)("smiley",60244),sortPrecedence:(0,l.$Sj)("sort-precedence",60245),splitHorizontal:(0,l.$Sj)("split-horizontal",60246),splitVertical:(0,l.$Sj)("split-vertical",60247),squirrel:(0,l.$Sj)("squirrel",60248),starFull:(0,l.$Sj)("star-full",60249),starHalf:(0,l.$Sj)("star-half",60250),symbolClass:(0,l.$Sj)("symbol-class",60251),symbolColor:(0,l.$Sj)("symbol-color",60252),symbolConstant:(0,l.$Sj)("symbol-constant",60253),symbolEnumMember:(0,l.$Sj)("symbol-enum-member",60254),symbolField:(0,l.$Sj)("symbol-field",60255),symbolFile:(0,l.$Sj)("symbol-file",60256),symbolInterface:(0,l.$Sj)("symbol-interface",60257),symbolKeyword:(0,l.$Sj)("symbol-keyword",60258),symbolMisc:(0,l.$Sj)("symbol-misc",60259),symbolOperator:(0,l.$Sj)("symbol-operator",60260),symbolProperty:(0,l.$Sj)("symbol-property",60261),wrench:(0,l.$Sj)("wrench",60261),wrenchSubaction:(0,l.$Sj)("wrench-subaction",60261),symbolSnippet:(0,l.$Sj)("symbol-snippet",60262),tasklist:(0,l.$Sj)("tasklist",60263),telescope:(0,l.$Sj)("telescope",60264),textSize:(0,l.$Sj)("text-size",60265),threeBars:(0,l.$Sj)("three-bars",60266),thumbsdown:(0,l.$Sj)("thumbsdown",60267),thumbsup:(0,l.$Sj)("thumbsup",60268),tools:(0,l.$Sj)("tools",60269),triangleDown:(0,l.$Sj)("triangle-down",60270),triangleLeft:(0,l.$Sj)("triangle-left",60271),triangleRight:(0,l.$Sj)("triangle-right",60272),triangleUp:(0,l.$Sj)("triangle-up",60273),twitter:(0,l.$Sj)("twitter",60274),unfold:(0,l.$Sj)("unfold",60275),unlock:(0,l.$Sj)("unlock",60276),unmute:(0,l.$Sj)("unmute",60277),unverified:(0,l.$Sj)("unverified",60278),verified:(0,l.$Sj)("verified",60279),versions:(0,l.$Sj)("versions",60280),vmActive:(0,l.$Sj)("vm-active",60281),vmOutline:(0,l.$Sj)("vm-outline",60282),vmRunning:(0,l.$Sj)("vm-running",60283),watch:(0,l.$Sj)("watch",60284),whitespace:(0,l.$Sj)("whitespace",60285),wholeWord:(0,l.$Sj)("whole-word",60286),window:(0,l.$Sj)("window",60287),wordWrap:(0,l.$Sj)("word-wrap",60288),zoomIn:(0,l.$Sj)("zoom-in",60289),zoomOut:(0,l.$Sj)("zoom-out",60290),listFilter:(0,l.$Sj)("list-filter",60291),listFlat:(0,l.$Sj)("list-flat",60292),listSelection:(0,l.$Sj)("list-selection",60293),selection:(0,l.$Sj)("selection",60293),listTree:(0,l.$Sj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,l.$Sj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,l.$Sj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,l.$Sj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,l.$Sj)("debug-stackframe-active",60297),circleSmallFilled:(0,l.$Sj)("circle-small-filled",60298),debugStackframeDot:(0,l.$Sj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,l.$Sj)("terminal-decoration-mark",60298),debugStackframe:(0,l.$Sj)("debug-stackframe",60299),debugStackframeFocused:(0,l.$Sj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,l.$Sj)("debug-breakpoint-unsupported",60300),symbolString:(0,l.$Sj)("symbol-string",60301),debugReverseContinue:(0,l.$Sj)("debug-reverse-continue",60302),debugStepBack:(0,l.$Sj)("debug-step-back",60303),debugRestartFrame:(0,l.$Sj)("debug-restart-frame",60304),debugAlt:(0,l.$Sj)("debug-alt",60305),callIncoming:(0,l.$Sj)("call-incoming",60306),callOutgoing:(0,l.$Sj)("call-outgoing",60307),menu:(0,l.$Sj)("menu",60308),expandAll:(0,l.$Sj)("expand-all",60309),feedback:(0,l.$Sj)("feedback",60310),gitPullRequestReviewer:(0,l.$Sj)("git-pull-request-reviewer",60310),groupByRefType:(0,l.$Sj)("group-by-ref-type",60311),ungroupByRefType:(0,l.$Sj)("ungroup-by-ref-type",60312),account:(0,l.$Sj)("account",60313),gitPullRequestAssignee:(0,l.$Sj)("git-pull-request-assignee",60313),bellDot:(0,l.$Sj)("bell-dot",60314),debugConsole:(0,l.$Sj)("debug-console",60315),library:(0,l.$Sj)("library",60316),output:(0,l.$Sj)("output",60317),runAll:(0,l.$Sj)("run-all",60318),syncIgnored:(0,l.$Sj)("sync-ignored",60319),pinned:(0,l.$Sj)("pinned",60320),githubInverted:(0,l.$Sj)("github-inverted",60321),serverProcess:(0,l.$Sj)("server-process",60322),serverEnvironment:(0,l.$Sj)("server-environment",60323),pass:(0,l.$Sj)("pass",60324),issueClosed:(0,l.$Sj)("issue-closed",60324),stopCircle:(0,l.$Sj)("stop-circle",60325),playCircle:(0,l.$Sj)("play-circle",60326),record:(0,l.$Sj)("record",60327),debugAltSmall:(0,l.$Sj)("debug-alt-small",60328),vmConnect:(0,l.$Sj)("vm-connect",60329),cloud:(0,l.$Sj)("cloud",60330),merge:(0,l.$Sj)("merge",60331),export:(0,l.$Sj)("export",60332),graphLeft:(0,l.$Sj)("graph-left",60333),magnet:(0,l.$Sj)("magnet",60334),notebook:(0,l.$Sj)("notebook",60335),redo:(0,l.$Sj)("redo",60336),checkAll:(0,l.$Sj)("check-all",60337),pinnedDirty:(0,l.$Sj)("pinned-dirty",60338),passFilled:(0,l.$Sj)("pass-filled",60339),circleLargeFilled:(0,l.$Sj)("circle-large-filled",60340),circleLarge:(0,l.$Sj)("circle-large",60341),circleLargeOutline:(0,l.$Sj)("circle-large-outline",60341),combine:(0,l.$Sj)("combine",60342),gather:(0,l.$Sj)("gather",60342),table:(0,l.$Sj)("table",60343),variableGroup:(0,l.$Sj)("variable-group",60344),typeHierarchy:(0,l.$Sj)("type-hierarchy",60345),typeHierarchySub:(0,l.$Sj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,l.$Sj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,l.$Sj)("git-pull-request-create",60348),runAbove:(0,l.$Sj)("run-above",60349),runBelow:(0,l.$Sj)("run-below",60350),notebookTemplate:(0,l.$Sj)("notebook-template",60351),debugRerun:(0,l.$Sj)("debug-rerun",60352),workspaceTrusted:(0,l.$Sj)("workspace-trusted",60353),workspaceUntrusted:(0,l.$Sj)("workspace-untrusted",60354),workspaceUnknown:(0,l.$Sj)("workspace-unknown",60355),terminalCmd:(0,l.$Sj)("terminal-cmd",60356),terminalDebian:(0,l.$Sj)("terminal-debian",60357),terminalLinux:(0,l.$Sj)("terminal-linux",60358),terminalPowershell:(0,l.$Sj)("terminal-powershell",60359),terminalTmux:(0,l.$Sj)("terminal-tmux",60360),terminalUbuntu:(0,l.$Sj)("terminal-ubuntu",60361),terminalBash:(0,l.$Sj)("terminal-bash",60362),arrowSwap:(0,l.$Sj)("arrow-swap",60363),copy:(0,l.$Sj)("copy",60364),personAdd:(0,l.$Sj)("person-add",60365),filterFilled:(0,l.$Sj)("filter-filled",60366),wand:(0,l.$Sj)("wand",60367),debugLineByLine:(0,l.$Sj)("debug-line-by-line",60368),inspect:(0,l.$Sj)("inspect",60369),layers:(0,l.$Sj)("layers",60370),layersDot:(0,l.$Sj)("layers-dot",60371),layersActive:(0,l.$Sj)("layers-active",60372),compass:(0,l.$Sj)("compass",60373),compassDot:(0,l.$Sj)("compass-dot",60374),compassActive:(0,l.$Sj)("compass-active",60375),azure:(0,l.$Sj)("azure",60376),issueDraft:(0,l.$Sj)("issue-draft",60377),gitPullRequestClosed:(0,l.$Sj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,l.$Sj)("git-pull-request-draft",60379),debugAll:(0,l.$Sj)("debug-all",60380),debugCoverage:(0,l.$Sj)("debug-coverage",60381),runErrors:(0,l.$Sj)("run-errors",60382),folderLibrary:(0,l.$Sj)("folder-library",60383),debugContinueSmall:(0,l.$Sj)("debug-continue-small",60384),beakerStop:(0,l.$Sj)("beaker-stop",60385),graphLine:(0,l.$Sj)("graph-line",60386),graphScatter:(0,l.$Sj)("graph-scatter",60387),pieChart:(0,l.$Sj)("pie-chart",60388),bracket:(0,l.$Sj)("bracket",60175),bracketDot:(0,l.$Sj)("bracket-dot",60389),bracketError:(0,l.$Sj)("bracket-error",60390),lockSmall:(0,l.$Sj)("lock-small",60391),azureDevops:(0,l.$Sj)("azure-devops",60392),verifiedFilled:(0,l.$Sj)("verified-filled",60393),newline:(0,l.$Sj)("newline",60394),layout:(0,l.$Sj)("layout",60395),layoutActivitybarLeft:(0,l.$Sj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,l.$Sj)("layout-activitybar-right",60397),layoutPanelLeft:(0,l.$Sj)("layout-panel-left",60398),layoutPanelCenter:(0,l.$Sj)("layout-panel-center",60399),layoutPanelJustify:(0,l.$Sj)("layout-panel-justify",60400),layoutPanelRight:(0,l.$Sj)("layout-panel-right",60401),layoutPanel:(0,l.$Sj)("layout-panel",60402),layoutSidebarLeft:(0,l.$Sj)("layout-sidebar-left",60403),layoutSidebarRight:(0,l.$Sj)("layout-sidebar-right",60404),layoutStatusbar:(0,l.$Sj)("layout-statusbar",60405),layoutMenubar:(0,l.$Sj)("layout-menubar",60406),layoutCentered:(0,l.$Sj)("layout-centered",60407),target:(0,l.$Sj)("target",60408),indent:(0,l.$Sj)("indent",60409),recordSmall:(0,l.$Sj)("record-small",60410),errorSmall:(0,l.$Sj)("error-small",60411),terminalDecorationError:(0,l.$Sj)("terminal-decoration-error",60411),arrowCircleDown:(0,l.$Sj)("arrow-circle-down",60412),arrowCircleLeft:(0,l.$Sj)("arrow-circle-left",60413),arrowCircleRight:(0,l.$Sj)("arrow-circle-right",60414),arrowCircleUp:(0,l.$Sj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,l.$Sj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,l.$Sj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,l.$Sj)("layout-sidebar-left-off",60418),blank:(0,l.$Sj)("blank",60419),heartFilled:(0,l.$Sj)("heart-filled",60420),map:(0,l.$Sj)("map",60421),mapHorizontal:(0,l.$Sj)("map-horizontal",60421),foldHorizontal:(0,l.$Sj)("fold-horizontal",60421),mapFilled:(0,l.$Sj)("map-filled",60422),mapHorizontalFilled:(0,l.$Sj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,l.$Sj)("fold-horizontal-filled",60422),circleSmall:(0,l.$Sj)("circle-small",60423),bellSlash:(0,l.$Sj)("bell-slash",60424),bellSlashDot:(0,l.$Sj)("bell-slash-dot",60425),commentUnresolved:(0,l.$Sj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,l.$Sj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,l.$Sj)("git-pull-request-new-changes",60428),searchFuzzy:(0,l.$Sj)("search-fuzzy",60429),commentDraft:(0,l.$Sj)("comment-draft",60430),send:(0,l.$Sj)("send",60431),sparkle:(0,l.$Sj)("sparkle",60432),insert:(0,l.$Sj)("insert",60433),mic:(0,l.$Sj)("mic",60434),thumbsdownFilled:(0,l.$Sj)("thumbsdown-filled",60435),thumbsupFilled:(0,l.$Sj)("thumbsup-filled",60436),coffee:(0,l.$Sj)("coffee",60437),snake:(0,l.$Sj)("snake",60438),game:(0,l.$Sj)("game",60439),vr:(0,l.$Sj)("vr",60440),chip:(0,l.$Sj)("chip",60441),piano:(0,l.$Sj)("piano",60442),music:(0,l.$Sj)("music",60443),micFilled:(0,l.$Sj)("mic-filled",60444),repoFetch:(0,l.$Sj)("repo-fetch",60445),copilot:(0,l.$Sj)("copilot",60446),lightbulbSparkle:(0,l.$Sj)("lightbulb-sparkle",60447),robot:(0,l.$Sj)("robot",60448),sparkleFilled:(0,l.$Sj)("sparkle-filled",60449),diffSingle:(0,l.$Sj)("diff-single",60450),diffMultiple:(0,l.$Sj)("diff-multiple",60451),surroundWith:(0,l.$Sj)("surround-with",60452),share:(0,l.$Sj)("share",60453),gitStash:(0,l.$Sj)("git-stash",60454),gitStashApply:(0,l.$Sj)("git-stash-apply",60455),gitStashPop:(0,l.$Sj)("git-stash-pop",60456),vscode:(0,l.$Sj)("vscode",60457),vscodeInsiders:(0,l.$Sj)("vscode-insiders",60458),codeOss:(0,l.$Sj)("code-oss",60459),runCoverage:(0,l.$Sj)("run-coverage",60460),runAllCoverage:(0,l.$Sj)("run-all-coverage",60461),coverage:(0,l.$Sj)("coverage",60462),githubProject:(0,l.$Sj)("github-project",60463),mapVertical:(0,l.$Sj)("map-vertical",60464),foldVertical:(0,l.$Sj)("fold-vertical",60464),mapVerticalFilled:(0,l.$Sj)("map-vertical-filled",60465),foldVerticalFilled:(0,l.$Sj)("fold-vertical-filled",60465),goToSearch:(0,l.$Sj)("go-to-search",60466),percentage:(0,l.$Sj)("percentage",60467),sortPercentage:(0,l.$Sj)("sort-percentage",60467)}}),define(ke[79],De([1,0,99,175]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=void 0,e.$Vj=O;function O(){return Object.values(e.$Xj)}e.$Wj={dialogError:(0,l.$Sj)("dialog-error","error"),dialogWarning:(0,l.$Sj)("dialog-warning","warning"),dialogInfo:(0,l.$Sj)("dialog-info","info"),dialogClose:(0,l.$Sj)("dialog-close","close"),treeItemExpanded:(0,l.$Sj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,l.$Sj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,l.$Sj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,l.$Sj)("tree-filter-clear","close"),treeItemLoading:(0,l.$Sj)("tree-item-loading","loading"),menuSelection:(0,l.$Sj)("menu-selection","check"),menuSubmenu:(0,l.$Sj)("menu-submenu","chevron-right"),menuBarMore:(0,l.$Sj)("menubar-more","more"),scrollbarButtonLeft:(0,l.$Sj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,l.$Sj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,l.$Sj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,l.$Sj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,l.$Sj)("toolbar-more","more"),quickInputBack:(0,l.$Sj)("quick-input-back","arrow-left"),dropDownButton:(0,l.$Sj)("drop-down-button",60084),symbolCustomColor:(0,l.$Sj)("symbol-customcolor",60252),exportIcon:(0,l.$Sj)("export",60332),workspaceUnspecified:(0,l.$Sj)("workspace-unspecified",60355),newLine:(0,l.$Sj)("newline",60394),thumbsDownFilled:(0,l.$Sj)("thumbsdown-filled",60435),thumbsUpFilled:(0,l.$Sj)("thumbsup-filled",60436),gitFetch:(0,l.$Sj)("git-fetch",60445),lightbulbSparkleAutofix:(0,l.$Sj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,l.$Sj)("debug-breakpoint-pending",60377)},e.$Xj={...L.$Uj,...e.$Wj}}),define(ke[24],De([1,0,18]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=L,e.$6n=O,e.$7n=R,e.$8n=$,e.$9n=E,e.$0n=A,e.$$n=I,e.$_n=p,e.$ao=S,e.$bo=v,e.$co=h,e.$do=d,e.$eo=c;function L(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const i=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([a,s])=>{i[a]=s&&typeof s=="object"?L(s):s}),i}function O(n){if(!n||typeof n!="object")return n;const i=[n];for(;i.length>0;){const a=i.shift();Object.freeze(a);for(const s in a)if(M.call(a,s)){const t=a[s];typeof t=="object"&&!Object.isFrozen(t)&&!(0,l.$bg)(t)&&i.push(t)}}return n}const M=Object.prototype.hasOwnProperty;function R(n,i){return b(n,i,new Set)}function b(n,i,a){if((0,l.$hg)(n))return n;const s=i(n);if(typeof s<"u")return s;if(Array.isArray(n)){const t=[];for(const u of n)t.push(b(u,i,a));return t}if((0,l.$ag)(n)){if(a.has(n))throw new Error("Cannot clone recursive data-structure");a.add(n);const t={};for(const u in n)M.call(n,u)&&(t[u]=b(n[u],i,a));return a.delete(n),t}return n}function $(n,i,a=!0){return(0,l.$ag)(n)?((0,l.$ag)(i)&&Object.keys(i).forEach(s=>{s in n?a&&((0,l.$ag)(n[s])&&(0,l.$ag)(i[s])?$(n[s],i[s],a):n[s]=i[s]):n[s]=i[s]}),n):i}function E(n,i){if(n===i)return!0;if(n==null||i===null||i===void 0||typeof n!=typeof i||typeof n!="object"||Array.isArray(n)!==Array.isArray(i))return!1;let a,s;if(Array.isArray(n)){if(n.length!==i.length)return!1;for(a=0;a<n.length;a++)if(!E(n[a],i[a]))return!1}else{const t=[];for(s in n)t.push(s);t.sort();const u=[];for(s in i)u.push(s);if(u.sort(),!E(t,u))return!1;for(a=0;a<t.length;a++)if(!E(n[t[a]],i[t[a]]))return!1}return!0}function A(n){const i=new Set;return JSON.stringify(n,(a,s)=>{if((0,l.$ag)(s)||Array.isArray(s)){if(i.has(s))return"[Circular]";i.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function I(n,i){const a=Object.create(null);return!n||!i||Object.keys(i).forEach(t=>{const u=n[t],r=i[t];E(u,r)||(a[t]=r)}),a}function p(n,i){const a=i.toLowerCase(),s=Object.keys(n).find(t=>t.toLowerCase()===a);return s?n[s]:n[i]}function S(n,i){const a=Object.create(null);for(const[s,t]of Object.entries(n))i(s,t)&&(a[s]=t);return a}function v(n){let i=[];for(;Object.prototype!==n;)i=i.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return i}function h(n){const i=[];for(const a of v(n))typeof n[a]=="function"&&i.push(a);return i}function d(n,i){const a=t=>function(){const u=Array.prototype.slice.call(arguments,0);return i(t,u)},s={};for(const t of n)s[t]=a(t);return s}function c(n,i){const a={};for(const[s,t]of Object.entries(n))a[s]=i(t,s);return a}}),define(ke[50],De([1,0,79]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=O;var L;(function(R){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=b})(L||(e.ThemeColor=L={}));function O(R){return{id:R}}var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(l.$Xj.error);const[,a,s]=i,t=["codicon","codicon-"+a];return s&&t.push("codicon-modifier-"+s.substring(1)),t}R.asClassNameArray=$;function E(n){return $(n).join(" ")}R.asClassName=E;function A(n){return"."+$(n).join(".")}R.asCSSSelector=A;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}R.isThemeIcon=I;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function S(n){const i=p.exec(n);if(!i)return;const[,a]=i;return{id:a}}R.fromString=S;function v(n){return{id:n}}R.fromId=v;function h(n,i){let a=n.id;const s=a.lastIndexOf("~");return s!==-1&&(a=a.substring(0,s)),i&&(a=`${a}~${i}`),{id:a}}R.modify=h;function d(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=d;function c(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=c})(M||(e.ThemeIcon=M={}))}),define(ke[176],De([1,0,127,14,50]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=$,e.$Qk=A,e.$Rk=p,e.$Sk=S,e.$Tk=h,e.$Uk=d;const M="$(",R=new RegExp(`\\$\\(${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function $(c){return c.replace(b,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${R.source}`,"g");function A(c){return c.replace(E,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function p(c){return c.indexOf(M)===-1?c:c.replace(I,(n,i,a,s)=>a?n:i||s||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${O.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(c){v.lastIndex=0;let n="";const i=[];let a=0;for(;;){const s=v.lastIndex,t=v.exec(c),u=c.substring(s,t?.index);if(u.length>0){n+=u;for(let r=0;r<u.length;r++)i.push(a)}if(!t)break;a+=t[0].length}return{text:n,iconOffsets:i}}function d(c,n,i=!1){const{text:a,iconOffsets:s}=n;if(!s||s.length===0)return(0,l.$Gk)(c,a,i);const t=(0,L.$gf)(a," "),u=a.length-t.length,r=(0,l.$Gk)(c,t,i);if(r)for(const o of r){const f=s[o.start+u]+u;o.start+=f,o.end+=f}return r}}),define(ke[128],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$7e=L,e.$8e=O;var l;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l||(e.Constants=l={}));function L(M){return M<0?0:M>255?255:M|0}function O(M){return M<0?0:M>4294967295?4294967295:M|0}}),define(ke[30],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=L;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(O){return l.test(O)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const M=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){O(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let $=0,E="";return E+=R[M[$++]],E+=R[M[$++]],E+=R[M[$++]],E+=R[M[$++]],E+="-",E+=R[M[$++]],E+=R[M[$++]],E+="-",E+=R[M[$++]],E+=R[M[$++]],E+="-",E+=R[M[$++]],E+=R[M[$++]],E+="-",E+=R[M[$++]],E+=R[M[$++]],E+=R[M[$++]],E+=R[M[$++]],E+=R[M[$++]],E+=R[M[$++]],E}}()}),define(ke[177],De([1,0,19,39,30]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=e.$Vt=void 0,e.$Tt=M,e.$Ut=R,e.$Wt=E;function M(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function R(I,p,S){const v={id:(0,O.$Ug)(),name:I,uri:p,data:S};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let p=0;for(const S of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const S=[...this.a.keys()];return L.Iterable.some(this,([v,h])=>h.asFile())&&S.push("files"),A($(p),S)}get(p){return this.a.get(this.b(p))?.[0]}append(p,S){const v=this.a.get(p);v?v.push(S):this.a.set(this.b(p),[S])}replace(p,S){this.a.set(this.b(p),[S])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,S]of this.a)for(const v of S)yield[p,v]}b(p){return $(p)}}e.$Vt=b;function $(I){return I.toLowerCase()}function E(I,p){return A($(I),p.map($))}function A(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[v,h,d]=S;return d==="*"?p.some(c=>c.startsWith(h+"/")):!1}e.$Xt=Object.freeze({create:I=>(0,l.$Mb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Xt.split(I).filter(p=>!p.startsWith("#"))})}),define(ke[178],De([1,0,63]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=void 0,e.$Wg=L,e.$Yg=M;function L(b,$,E,A=1){let I=!1;return new Promise(p=>{const S=setTimeout(()=>{if(!I)return I=!0,p(0)},E);O(b,$,A,v=>{if(!I)return I=!0,clearTimeout(S),p(v)})})}function O(b,$,E,A){if($===0)return A(0);const I=new l.Socket;I.once("connect",()=>(R(I),O(b+E,$-1,E,A))),I.once("data",()=>{}),I.once("error",p=>(R(I),p.code!=="ECONNREFUSED"?O(b+E,$-1,E,A):A(b))),I.connect(b,"127.0.0.1")}e.$Xg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(b,$,E,A="127.0.0.1"){let I=!1,p,S=1;const v=l.createServer({pauseOnConnect:!0});function h(d,c){I||(I=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),c(d))}return new Promise(d=>{p=setTimeout(()=>{h(0,d)},E),v.on("listening",()=>{h(b,d)}),v.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&S<$?(b++,S++,v.listen(b,A)):h(0,d)}),v.on("close",()=>{h(0,d)}),v.listen(b,A)})}function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[129],De([1,0,128]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.$Lt=void 0;class L{constructor(b){const $=(0,l.$7e)(b);this.c=$,this.a=L.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const E=(0,l.$7e)($);b>=0&&b<256?this.a[b]=E:this.b.set(b,E)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Lt=L;var O;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(O||(O={}));class M{constructor(){this.a=new L(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Mt=M}),define(ke[179],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$4t=L;var l;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(l||(e.StringEOL=l={}));function L(O){let M=0,R=0,b=0,$=0;for(let E=0,A=O.length;E<A;E++){const I=O.charCodeAt(E);I===13?(M===0&&(R=E),M++,E+1<A&&O.charCodeAt(E+1)===10?($|=2,E++):$|=3,b=E+1):I===10&&($|=1,M===0&&(R=E),M++,b=E+1)}return M===0&&(R=O.length),[M,R,O.length-b,$]}}),define(ke[51],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0;class l{constructor(O,M){this.lineNumber=O,this.column=M}with(O=this.lineNumber,M=this.column){return O===this.lineNumber&&M===this.column?this:new l(O,M)}delta(O=0,M=0){return this.with(this.lineNumber+O,this.column+M)}equals(O){return l.equals(this,O)}static equals(O,M){return!O&&!M?!0:!!O&&!!M&&O.lineNumber===M.lineNumber&&O.column===M.column}isBefore(O){return l.isBefore(this,O)}static isBefore(O,M){return O.lineNumber<M.lineNumber?!0:M.lineNumber<O.lineNumber?!1:O.column<M.column}isBeforeOrEqual(O){return l.isBeforeOrEqual(this,O)}static isBeforeOrEqual(O,M){return O.lineNumber<M.lineNumber?!0:M.lineNumber<O.lineNumber?!1:O.column<=M.column}static compare(O,M){const R=O.lineNumber|0,b=M.lineNumber|0;if(R===b){const $=O.column|0,E=M.column|0;return $-E}return R-b}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(O){return new l(O.lineNumber,O.column)}static isIPosition(O){return O&&typeof O.lineNumber=="number"&&typeof O.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$wt=l}),define(ke[29],De([1,0,51]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0;class L{constructor(M,R,b,$){M>b||M===b&&R>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=M,this.endColumn=R):(this.startLineNumber=M,this.startColumn=R,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return L.isEmpty(this)}static isEmpty(M){return M.startLineNumber===M.endLineNumber&&M.startColumn===M.endColumn}containsPosition(M){return L.containsPosition(this,M)}static containsPosition(M,R){return!(R.lineNumber<M.startLineNumber||R.lineNumber>M.endLineNumber||R.lineNumber===M.startLineNumber&&R.column<M.startColumn||R.lineNumber===M.endLineNumber&&R.column>M.endColumn)}static strictContainsPosition(M,R){return!(R.lineNumber<M.startLineNumber||R.lineNumber>M.endLineNumber||R.lineNumber===M.startLineNumber&&R.column<=M.startColumn||R.lineNumber===M.endLineNumber&&R.column>=M.endColumn)}containsRange(M){return L.containsRange(this,M)}static containsRange(M,R){return!(R.startLineNumber<M.startLineNumber||R.endLineNumber<M.startLineNumber||R.startLineNumber>M.endLineNumber||R.endLineNumber>M.endLineNumber||R.startLineNumber===M.startLineNumber&&R.startColumn<M.startColumn||R.endLineNumber===M.endLineNumber&&R.endColumn>M.endColumn)}strictContainsRange(M){return L.strictContainsRange(this,M)}static strictContainsRange(M,R){return!(R.startLineNumber<M.startLineNumber||R.endLineNumber<M.startLineNumber||R.startLineNumber>M.endLineNumber||R.endLineNumber>M.endLineNumber||R.startLineNumber===M.startLineNumber&&R.startColumn<=M.startColumn||R.endLineNumber===M.endLineNumber&&R.endColumn>=M.endColumn)}plusRange(M){return L.plusRange(this,M)}static plusRange(M,R){let b,$,E,A;return R.startLineNumber<M.startLineNumber?(b=R.startLineNumber,$=R.startColumn):R.startLineNumber===M.startLineNumber?(b=R.startLineNumber,$=Math.min(R.startColumn,M.startColumn)):(b=M.startLineNumber,$=M.startColumn),R.endLineNumber>M.endLineNumber?(E=R.endLineNumber,A=R.endColumn):R.endLineNumber===M.endLineNumber?(E=R.endLineNumber,A=Math.max(R.endColumn,M.endColumn)):(E=M.endLineNumber,A=M.endColumn),new L(b,$,E,A)}intersectRanges(M){return L.intersectRanges(this,M)}static intersectRanges(M,R){let b=M.startLineNumber,$=M.startColumn,E=M.endLineNumber,A=M.endColumn;const I=R.startLineNumber,p=R.startColumn,S=R.endLineNumber,v=R.endColumn;return b<I?(b=I,$=p):b===I&&($=Math.max($,p)),E>S?(E=S,A=v):E===S&&(A=Math.min(A,v)),b>E||b===E&&$>A?null:new L(b,$,E,A)}equalsRange(M){return L.equalsRange(this,M)}static equalsRange(M,R){return!M&&!R?!0:!!M&&!!R&&M.startLineNumber===R.startLineNumber&&M.startColumn===R.startColumn&&M.endLineNumber===R.endLineNumber&&M.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(M){return new l.$wt(M.endLineNumber,M.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(M){return new l.$wt(M.startLineNumber,M.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(M,R){return new L(this.startLineNumber,this.startColumn,M,R)}setStartPosition(M,R){return new L(M,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(M){return new L(M.startLineNumber,M.startColumn,M.startLineNumber,M.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(M){return new L(M.endLineNumber,M.endColumn,M.endLineNumber,M.endColumn)}delta(M){return new L(this.startLineNumber+M,this.startColumn,this.endLineNumber+M,this.endColumn)}static fromPositions(M,R=M){return new L(M.lineNumber,M.column,R.lineNumber,R.column)}static lift(M){return M?new L(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn):null}static isIRange(M){return M&&typeof M.startLineNumber=="number"&&typeof M.startColumn=="number"&&typeof M.endLineNumber=="number"&&typeof M.endColumn=="number"}static areIntersectingOrTouching(M,R){return!(M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn||R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn)}static areIntersecting(M,R){return!(M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn||R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn)}static compareRangesUsingStarts(M,R){if(M&&R){const E=M.startLineNumber|0,A=R.startLineNumber|0;if(E===A){const I=M.startColumn|0,p=R.startColumn|0;if(I===p){const S=M.endLineNumber|0,v=R.endLineNumber|0;if(S===v){const h=M.endColumn|0,d=R.endColumn|0;return h-d}return S-v}return I-p}return E-A}return(M?1:0)-(R?1:0)}static compareRangesUsingEnds(M,R){return M.endLineNumber===R.endLineNumber?M.endColumn===R.endColumn?M.startLineNumber===R.startLineNumber?M.startColumn-R.startColumn:M.startLineNumber-R.startLineNumber:M.endColumn-R.endColumn:M.endLineNumber-R.endLineNumber}static spansMultipleLines(M){return M.endLineNumber>M.startLineNumber}toJSON(){return this}}e.$xt=L}),define(ke[180],De([1,0,29]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0;class L{static insert(M,R){return{range:new l.$xt(M.lineNumber,M.column,M.lineNumber,M.column),text:R,forceMoveMarkers:!0}}static delete(M){return{range:M,text:null}}static replace(M,R){return{range:M,text:R}}static replaceMove(M,R){return{range:M,text:R,forceMoveMarkers:!0}}}e.$yt=L}),define(ke[181],De([1,0,51,29]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.SelectionDirection=void 0;var O;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(O||(e.SelectionDirection=O={}));class M extends L.$xt{constructor(b,$,E,A){super(b,$,E,A),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=E,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return M.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new M(this.startLineNumber,this.startColumn,b,$):new M(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new l.$wt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.$wt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new M(b,$,this.endLineNumber,this.endColumn):new M(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new M(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new M(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new M(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new M(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let E=0,A=b.length;E<A;E++)if(!this.selectionsEqual(b[E],$[E]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,E,A,I){return I===0?new M(b,$,E,A):new M(E,A,b,$)}}e.$zt=M}),define(ke[182],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$7s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[183],De([1,0,27,129]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.WordCharacterClass=void 0,e.$Ot=b;var O;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class M extends L.$Lt{constructor(E,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let I=0,p=E.length;I<p;I++)this.set(E.charCodeAt(I),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(E,A){let I=null;for(const p of this.h(E)){if(p.index>A)break;I=p}return I}findNextIntlWordAtOrAfterOffset(E,A){for(const I of this.h(E))if(!(I.index<A))return I;return null}h(E){return this.e?this.f===E?this.g:(this.f=E,this.g=this.j(this.e.segment(E)),this.g):[]}j(E){const A=[];for(const I of E)this.k(I)&&A.push(I);return A}k(E){return!!E.isWordLike}}e.$Nt=M;const R=new l.$Dc(10);function b($,E){const A=`${$}/${E.join(",")}`;let I=R.get(A);return I||(I=new M($,E),R.set(A,I)),I}}),define(ke[130],De([1,0,39,3,76]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=void 0,e.$0s=R,e.$$s=$,e.$_s=E,e.$8s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$8s)I.indexOf(S)>=0||(p+="\\"+S);return p+="\\s]+)",new RegExp(p,"g")}e.$9s=M();function R(I){let p=e.$9s;if(I&&I instanceof RegExp)if(I.global)p=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),p=new RegExp(I.source,S)}return p.lastIndex=0,p}const b=new O.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(I){const p=b.unshift(I);return(0,L.$Sc)(p)}function E(I,p,S,v,h){if(p=R(p),h||(h=l.Iterable.first(b)),S.length>h.maxLen){let a=I-h.maxLen/2;return a<0?a=0:v+=a,S=S.substring(a,I+h.maxLen/2),E(I,p,S,v,h)}const d=Date.now(),c=I-1-v;let n=-1,i=null;for(let a=1;!(Date.now()-d>=h.timeBudget);a++){const s=c-h.windowSize*a;p.lastIndex=Math.max(0,s);const t=A(p,S,c,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const a={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return p.lastIndex=0,a}return null}function A(I,p,S,v){let h;for(;h=I.exec(p);){const d=h.index||0;if(d<=S&&I.lastIndex>=S)return h;if(v>0&&d>v)return null}return null}}),define(ke[184],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$nu=e.IndentAction=void 0;var l;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(l||(e.IndentAction=l={}));class L{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,E=b.notIn.length;$<E;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset($-2),A=b.getStandardTokenType(E);return this.isOK(A)}g(b,$){for(let E=b;E<=$;E++){const A=String.fromCharCode(E);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$nu=L;class O{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)M(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),M(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),M(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),M(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&M(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$ou=O;function M(R,b,$){R.has(b)?R.get(b).push($):R.set(b,[$])}}),define(ke[185],De([1,0,129]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H2=e.$G2=e.State=void 0,e.$I2=p;var L;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class O{constructor(v,h,d){const c=new Uint8Array(v*h);for(let n=0,i=v*h;n<i;n++)c[n]=d;this.a=c,this.rows=v,this.cols=h}get(v,h){return this.a[v*this.cols+h]}set(v,h,d){this.a[v*this.cols+h]=d}}class M{constructor(v){let h=0,d=0;for(let n=0,i=v.length;n<i;n++){const[a,s,t]=v[n];s>h&&(h=s),a>d&&(d=a),t>d&&(d=t)}h++,d++;const c=new O(d,h,0);for(let n=0,i=v.length;n<i;n++){const[a,s,t]=v[n];c.set(a,s,t)}this.a=c,this.b=h}nextState(v,h){return h<0||h>=this.b?0:this.a.get(v,h)}}e.$G2=M;let R=null;function b(){return R===null&&(R=new M([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})($||($={}));let E=null;function A(){if(E===null){E=new l.$Lt(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<S.length;h++)E.set(S.charCodeAt(h),1);const v=".,;:";for(let h=0;h<v.length;h++)E.set(v.charCodeAt(h),2)}return E}class I{static a(v,h,d,c,n){let i=n-1;do{const a=h.charCodeAt(i);if(v.get(a)!==2)break;i--}while(i>c);if(c>0){const a=h.charCodeAt(c-1),s=h.charCodeAt(i);(a===40&&s===41||a===91&&s===93||a===123&&s===125)&&i--}return{range:{startLineNumber:d,startColumn:c+1,endLineNumber:d,endColumn:i+2},url:h.substring(c,i+1)}}static computeLinks(v,h=b()){const d=A(),c=[];for(let n=1,i=v.getLineCount();n<=i;n++){const a=v.getLineContent(n),s=a.length;let t=0,u=0,r=0,o=1,f=!1,g=!1,w=!1,k=!1;for(;t<s;){let m=!1;const y=a.charCodeAt(t);if(o===13){let D;switch(y){case 40:f=!0,D=0;break;case 41:D=f?0:1;break;case 91:w=!0,g=!0,D=0;break;case 93:w=!1,D=g?0:1;break;case 123:k=!0,D=0;break;case 125:D=k?0:1;break;case 39:case 34:case 96:r===y?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=w?0:1;break;default:D=d.get(y)}D===1&&(c.push(I.a(d,a,n,u,t)),m=!0)}else if(o===12){let D;y===91?(g=!0,D=0):D=d.get(y),D===1?m=!0:o=13}else o=h.nextState(o,y),o===0&&(m=!0);m&&(o=1,f=!1,g=!1,k=!1,u=t+1,r=y),t++}o===13&&c.push(I.a(d,a,n,u,s))}return c}}e.$H2=I;function p(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}}),define(ke[80],De([1,0,24]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Iv=e.$Hv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Jv=v,e.$Nv=a;var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var O;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(O||(e.GlyphMarginLane=O={}));var M;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(M||(e.MinimapPosition=M={}));var R;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var E;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,l.$9n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Hv=I;class p{constructor(t,u){this._findMatchBrand=void 0,this.range=t,this.matches=u}}e.$Iv=p;var S;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(S||(e.TrackedRangeStickiness=S={}));function v(s){return s&&typeof s.read=="function"}var h;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(h||(e.PositionAffinity=h={}));var d;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d||(e.ModelConstants=d={}));class c{constructor(t,u,r,o,f,g){this.identifier=t,this.range=u,this.text=r,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=f,this._isTracked=g}}e.$Kv=c;class n{constructor(t,u,r){this.regex=t,this.wordSeparators=u,this.simpleSearch=r}}e.$Lv=n;class i{constructor(t,u,r){this.reverseEdits=t,this.changes=u,this.trimAutoWhitespaceLineNumbers=r}}e.$Mv=i;function a(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[186],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.NodeColor=e.$IC=void 0,e.$KC=O,e.$LC=M,e.$MC=E,e.$NC=A,e.$OC=I,e.$PC=p,e.$QC=S,e.$RC=v;class l{constructor(d,c){this.piece=d,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$JC)return O(this.right);let d=this;for(;d.parent!==e.$JC&&d.parent.left!==d;)d=d.parent;return d.parent===e.$JC?e.$JC:d.parent}prev(){if(this.left!==e.$JC)return M(this.left);let d=this;for(;d.parent!==e.$JC&&d.parent.right!==d;)d=d.parent;return d.parent===e.$JC?e.$JC:d.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$IC=l;var L;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$JC=new l(null,0),e.$JC.parent=e.$JC,e.$JC.left=e.$JC,e.$JC.right=e.$JC,e.$JC.color=0;function O(h){for(;h.left!==e.$JC;)h=h.left;return h}function M(h){for(;h.right!==e.$JC;)h=h.right;return h}function R(h){return h===e.$JC?0:h.size_left+h.piece.length+R(h.right)}function b(h){return h===e.$JC?0:h.lf_left+h.piece.lineFeedCnt+b(h.right)}function $(){e.$JC.parent=e.$JC}function E(h,d){const c=d.right;c.size_left+=d.size_left+(d.piece?d.piece.length:0),c.lf_left+=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),d.right=c.left,c.left!==e.$JC&&(c.left.parent=d),c.parent=d.parent,d.parent===e.$JC?h.root=c:d.parent.left===d?d.parent.left=c:d.parent.right=c,c.left=d,d.parent=c}function A(h,d){const c=d.left;d.left=c.right,c.right!==e.$JC&&(c.right.parent=d),c.parent=d.parent,d.size_left-=c.size_left+(c.piece?c.piece.length:0),d.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),d.parent===e.$JC?h.root=c:d===d.parent.right?d.parent.right=c:d.parent.left=c,c.right=d,d.parent=c}function I(h,d){let c,n;if(d.left===e.$JC?(n=d,c=n.right):d.right===e.$JC?(n=d,c=n.left):(n=O(d.right),c=n.right),n===h.root){h.root=c,c.color=0,d.detach(),$(),h.root.parent=e.$JC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=c:n.parent.right=c,n===d?(c.parent=n.parent,v(h,c)):(n.parent===d?c.parent=n:c.parent=n.parent,v(h,c),n.left=d.left,n.right=d.right,n.parent=d.parent,n.color=d.color,d===h.root?h.root=n:d===d.parent.left?d.parent.left=n:d.parent.right=n,n.left!==e.$JC&&(n.left.parent=n),n.right!==e.$JC&&(n.right.parent=n),n.size_left=d.size_left,n.lf_left=d.lf_left,v(h,n)),d.detach(),c.parent.left===c){const s=R(c),t=b(c);if(s!==c.parent.size_left||t!==c.parent.lf_left){const u=s-c.parent.size_left,r=t-c.parent.lf_left;c.parent.size_left=s,c.parent.lf_left=t,S(h,c.parent,u,r)}}if(v(h,c.parent),i){$();return}let a;for(;c!==h.root&&c.color===0;)c===c.parent.left?(a=c.parent.right,a.color===1&&(a.color=0,c.parent.color=1,E(h,c.parent),a=c.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,c=c.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(h,a),a=c.parent.right),a.color=c.parent.color,c.parent.color=0,a.right.color=0,E(h,c.parent),c=h.root)):(a=c.parent.left,a.color===1&&(a.color=0,c.parent.color=1,A(h,c.parent),a=c.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,c=c.parent):(a.left.color===0&&(a.right.color=0,a.color=1,E(h,a),a=c.parent.left),a.color=c.parent.color,c.parent.color=0,a.left.color=0,A(h,c.parent),c=h.root));c.color=0,$()}function p(h,d){for(v(h,d);d!==h.root&&d.parent.color===1;)if(d.parent===d.parent.parent.left){const c=d.parent.parent.right;c.color===1?(d.parent.color=0,c.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.right&&(d=d.parent,E(h,d)),d.parent.color=0,d.parent.parent.color=1,A(h,d.parent.parent))}else{const c=d.parent.parent.left;c.color===1?(d.parent.color=0,c.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.left&&(d=d.parent,A(h,d)),d.parent.color=0,d.parent.parent.color=1,E(h,d.parent.parent))}h.root.color=0}function S(h,d,c,n){for(;d!==h.root&&d!==e.$JC;)d.parent.left===d&&(d.parent.size_left+=c,d.parent.lf_left+=n),d=d.parent}function v(h,d){let c=0,n=0;if(d!==h.root){for(;d!==h.root&&d===d.parent.right;)d=d.parent;if(d!==h.root)for(d=d.parent,c=R(d.left)-d.size_left,n=b(d.left)-d.lf_left,d.size_left+=c,d.lf_left+=n;d!==h.root&&(c!==0||n!==0);)d.parent.left===d&&(d.parent.size_left+=c,d.parent.lf_left+=n),d=d.parent}}}),define(ke[187],De([1,0,19,128]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$6v=void 0;class O{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,E){$=(0,L.$8e)($);const A=this.a,I=this.b,p=E.length;return p===0?!1:(this.a=new Uint32Array(A.length+p),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+p),this.a.set(E,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue($,E){return $=(0,L.$8e)($),E=(0,L.$8e)(E),this.a[$]===E?!1:(this.a[$]=E,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,E){$=(0,L.$8e)($),E=(0,L.$8e)(E);const A=this.a,I=this.b;if($>=A.length)return!1;const p=A.length-$;return E>=p&&(E=p),E===0?!1:(this.a=new Uint32Array(A.length-E),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+E),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,L.$8e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),$>=this.a.length&&($=this.a.length-1);for(let A=E;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let E=0,A=this.a.length-1,I=0,p=0,S=0;for(;E<=A;)if(I=E+(A-E)/2|0,p=this.b[I],S=p-this.a[I],$<S)A=I-1;else if($>=p)E=I+1;else break;return new R(I,$-S)}}e.$6v=O;class M{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const E=this.e[$],A=E>0?this.d[E-1]:0;return new R(E,$-A)}removeValues($,E){this.a.splice($,E),this.f($)}insertValues($,E){this.a=(0,l.$Vb)(this.a,$,E),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,E=this.a.length;$<E;$++){const A=this.a[$],I=$>0?this.d[$-1]:0;this.d[$]=I+A;for(let p=0;p<A;p++)this.e[I+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,E){this.a[$]!==E&&(this.a[$]=E,this.f($))}}e.$7v=M;class R{constructor($,E){this.index=$,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=E}}e.$8v=R}),define(ke[188],De([1,0,14,51,187]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=void 0;class M{constructor(b,$,E,A){this.d=b,this.f=$,this.g=E,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const E of $)this.o(E.range),this.p(new L.$wt(E.range.startLineNumber,E.range.startColumn),E.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,E=new Uint32Array($);for(let A=0;A<$;A++)E[A]=this.f[A].length+b;this.j=new O.$6v(E)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const E=(0,l.$mf)($);if(E.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]+this.f[b.lineNumber-1].substring(b.column-1));return}E[E.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]);const A=new Uint32Array(E.length-1);for(let I=1;I<E.length;I++)this.f.splice(b.lineNumber+I-1,0,E[I]),A[I-1]=E[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$9v=M}),define(ke[100],De([1,0,14,183,51,29,80]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$VC=e.$SC=void 0,e.$TC=E,e.$UC=A,e.$WC=h;const b=999;class ${constructor(n,i,a,s){this.searchString=n,this.isRegex=i,this.matchCase=a,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=l.$kf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let a=!this.isRegex&&!n;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new R.$Lv(i,this.wordSeparators?(0,L.$Ot)(this.wordSeparators,[]):null,a?this.searchString:null)}}e.$SC=$;function E(c){if(!c||c.length===0)return!1;for(let n=0,i=c.length;n<i;n++){const a=c.charCodeAt(n);if(a===10)return!0;if(a===92){if(n++,n>=i)break;const s=c.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(c,n,i){if(!i)return new R.$Iv(c,null);const a=[];for(let s=0,t=n.length;s<t;s++)a[s]=n[s];return new R.$Iv(c,a)}class I{constructor(n){const i=[];let a=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[a++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let a=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;a<s;){const t=a+((s-a)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(a=t,s=t):a=t+1}return a+1}}class p{static findMatches(n,i,a,s,t){const u=i.parseSearchRequest();return u?u.regex.multiline?this.b(n,a,new d(u.wordSeparators,u.regex),s,t):this.c(n,a,u,s,t):[]}static a(n,i,a,s,t,u){let r,o=0;s?(o=s.findLineFeedCountBeforeOffset(t),r=i+t+o):r=i+t;let f;if(s){const m=s.findLineFeedCountBeforeOffset(t+u.length)-o;f=r+u.length+m}else f=r+u.length;const g=n.getPositionAt(r),w=n.getPositionAt(f);return new M.$xt(g.lineNumber,g.column,w.lineNumber,w.column)}static b(n,i,a,s,t){const u=n.getOffsetAt(i.getStartPosition()),r=n.getValueInRange(i,1),o=n.getEOL()===`\r
`?new I(r):null,f=[];let g=0,w;for(a.reset(0);w=a.next(r);)if(f[g++]=A(this.a(n,u,r,o,w.index,w[0]),w,s),g>=t)return f;return f}static c(n,i,a,s,t){const u=[];let r=0;if(i.startLineNumber===i.endLineNumber){const f=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return r=this.d(a,f,i.startLineNumber,i.startColumn-1,r,u,s,t),u}const o=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);r=this.d(a,o,i.startLineNumber,i.startColumn-1,r,u,s,t);for(let f=i.startLineNumber+1;f<i.endLineNumber&&r<t;f++)r=this.d(a,n.getLineContent(f),f,0,r,u,s,t);if(r<t){const f=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);r=this.d(a,f,i.endLineNumber,0,r,u,s,t)}return u}static d(n,i,a,s,t,u,r,o){const f=n.wordSeparators;if(!r&&n.simpleSearch){const k=n.simpleSearch,m=k.length,y=i.length;let D=-m;for(;(D=i.indexOf(k,D+m))!==-1;)if((!f||h(f,i,y,D,m))&&(u[t++]=new R.$Iv(new M.$xt(a,D+1+s,a,D+1+m+s),null),t>=o))return t;return t}const g=new d(n.wordSeparators,n.regex);let w;g.reset(0);do if(w=g.next(i),w&&(u[t++]=A(new M.$xt(a,w.index+1+s,a,w.index+1+w[0].length+s),w,r),t>=o))return t;while(w);return t}static findNextMatch(n,i,a,s){const t=i.parseSearchRequest();if(!t)return null;const u=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,a,u,s):this.f(n,a,u,s)}static e(n,i,a,s){const t=new O.$wt(i.lineNumber,1),u=n.getOffsetAt(t),r=n.getLineCount(),o=n.getValueInRange(new M.$xt(t.lineNumber,t.column,r,n.getLineMaxColumn(r)),1),f=n.getEOL()===`\r
`?new I(o):null;a.reset(i.column-1);const g=a.next(o);return g?A(this.a(n,u,o,f,g.index,g[0]),g,s):i.lineNumber!==1||i.column!==1?this.e(n,new O.$wt(1,1),a,s):null}static f(n,i,a,s){const t=n.getLineCount(),u=i.lineNumber,r=n.getLineContent(u),o=this.g(a,r,u,i.column,s);if(o)return o;for(let f=1;f<=t;f++){const g=(u+f-1)%t,w=n.getLineContent(g+1),k=this.g(a,w,g+1,1,s);if(k)return k}return null}static g(n,i,a,s,t){n.reset(s-1);const u=n.next(i);return u?A(new M.$xt(a,u.index+1,a,u.index+1+u[0].length),u,t):null}static findPreviousMatch(n,i,a,s){const t=i.parseSearchRequest();if(!t)return null;const u=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,a,u,s):this.j(n,a,u,s)}static h(n,i,a,s){const t=this.b(n,new M.$xt(1,1,i.lineNumber,i.column),a,s,10*b);if(t.length>0)return t[t.length-1];const u=n.getLineCount();return i.lineNumber!==u||i.column!==n.getLineMaxColumn(u)?this.h(n,new O.$wt(u,n.getLineMaxColumn(u)),a,s):null}static j(n,i,a,s){const t=n.getLineCount(),u=i.lineNumber,r=n.getLineContent(u).substring(0,i.column-1),o=this.k(a,r,u,s);if(o)return o;for(let f=1;f<=t;f++){const g=(t+u-f-1)%t,w=n.getLineContent(g+1),k=this.k(a,w,g+1,s);if(k)return k}return null}static k(n,i,a,s){let t=null,u;for(n.reset(0);u=n.next(i);)t=A(new M.$xt(a,u.index+1,a,u.index+1+u[0].length),u,s);return t}}e.$VC=p;function S(c,n,i,a,s){if(a===0)return!0;const t=n.charCodeAt(a-1);if(c.get(t)!==0||t===13||t===10)return!0;if(s>0){const u=n.charCodeAt(a);if(c.get(u)!==0)return!0}return!1}function v(c,n,i,a,s){if(a+s===i)return!0;const t=n.charCodeAt(a+s);if(c.get(t)!==0||t===13||t===10)return!0;if(s>0){const u=n.charCodeAt(a+s-1);if(c.get(u)!==0)return!0}return!1}function h(c,n,i,a,s){return S(c,n,i,a,s)&&v(c,n,i,a,s)}class d{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let a;do{if(this.b+this.c===i||(a=this.a.exec(n),!a))return null;const s=a.index,t=a[0].length;if(s===this.b&&t===this.c){if(t===0){l.$Gf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||h(this._wordSeparators,n,i,s,t))return a}while(a);return null}}e.$XC=d}),define(ke[131],De([1,0,51,29,80,186,100]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=void 0,e.$YC=A,e.$ZC=I;const b=65535;function $(c){let n;return c[c.length-1]<65536?n=new Uint16Array(c.length):n=new Uint32Array(c.length),n.set(c,0),n}class E{constructor(n,i,a,s,t){this.lineStarts=n,this.cr=i,this.lf=a,this.crlf=s,this.isBasicASCII=t}}function A(c,n=!0){const i=[0];let a=1;for(let s=0,t=c.length;s<t;s++){const u=c.charCodeAt(s);u===13?s+1<t&&c.charCodeAt(s+1)===10?(i[a++]=s+2,s++):i[a++]=s+1:u===10&&(i[a++]=s+1)}return n?$(i):i}function I(c,n){c.length=0,c[0]=0;let i=1,a=0,s=0,t=0,u=!0;for(let o=0,f=n.length;o<f;o++){const g=n.charCodeAt(o);g===13?o+1<f&&n.charCodeAt(o+1)===10?(t++,c[i++]=o+2,o++):(a++,c[i++]=o+1):g===10?(s++,c[i++]=o+1):u&&g!==9&&(g<32||g>126)&&(u=!1)}const r=new E($(c),a,s,t,u);return c.length=0,r}class p{constructor(n,i,a,s,t){this.bufferIndex=n,this.start=i,this.end=a,this.lineFeedCnt=s,this.length=t}}e.$1C=p;class S{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$2C=S;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==M.$JC&&n.iterate(n.root,a=>(a!==M.$JC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const a=this.b;for(let s=0;s<a.length;s++){const t=a[s];if(t.node.parent===null||t.nodeStartOffset>=n){a[s]=null,i=!0;continue}}if(i){const s=[];for(const t of a)t!==null&&s.push(t);this.b=s}}}class d{constructor(n,i,a){this.create(n,i,a)}create(n,i,a){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=M.$JC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let s=null;for(let t=0,u=n.length;t<u;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const r=new p(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,r)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,a=i-Math.floor(i/3),s=a*2;let t="",u=0;const r=[];if(this.iterate(this.root,o=>{const f=this.R(o),g=f.length;if(u<=a||u+g<s)return t+=f,u+=g,!0;const w=t.replace(/\r\n|\r|\n/g,n);return r.push(new S(w,A(w))),t=f,u=g,!0}),u>0){const o=t.replace(/\r\n|\r|\n/g,n);r.push(new S(o,A(o)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===M.$JC)return!0;const t=this.R(s),u=t.length,r=n.G(i),o=n.G(i+u),f=n.getValueInRange2(r,o);return i+=u,t===f})}getOffsetAt(n,i){let a=0,s=this.root;for(;s!==M.$JC;)if(s.left!==M.$JC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){a+=s.size_left;const t=this.B(s,n-s.lf_left-2);return a+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,a+=s.size_left+s.piece.length,s=s.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,a=0;const s=n;for(;i!==M.$JC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const u=this.getOffsetAt(a+1,1),r=s-u;return new l.$wt(a+1,r+1)}return new l.$wt(a+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===M.$JC){const t=this.getOffsetAt(a+1,1),u=s-n-t;return new l.$wt(a+1,u+1)}else i=i.right;return new l.$wt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(a,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const r=n.node,o=this.a[r.piece.bufferIndex].buffer,f=this.u(r.piece.bufferIndex,r.piece.start);return o.substring(f+n.remainder,f+i.remainder)}let a=n.node;const s=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let u=s.substring(t+n.remainder,t+a.piece.length);for(a=a.next();a!==M.$JC;){const r=this.a[a.piece.bufferIndex].buffer,o=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){u+=r.substring(o,o+i.remainder);break}else u+=r.substr(o,a.piece.length);a=a.next()}return u}getLinesContent(){const n=[];let i=0,a="",s=!1;return this.iterate(this.root,t=>{if(t===M.$JC)return!0;const u=t.piece;let r=u.length;if(r===0)return!0;const o=this.a[u.bufferIndex].buffer,f=this.a[u.bufferIndex].lineStarts,g=u.start.line,w=u.end.line;let k=f[g]+u.start.column;if(s&&(o.charCodeAt(k)===10&&(k++,r--),n[i++]=a,a="",s=!1,r===0))return!0;if(g===w)return!this.f&&o.charCodeAt(k+r-1)===13?(s=!0,a+=o.substr(k,r-1)):a+=o.substr(k,r),!0;a+=this.f?o.substring(k,Math.max(k,f[g+1]-this.e)):o.substring(k,f[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;for(let m=g+1;m<w;m++)a=this.f?o.substring(f[m],f[m+1]-this.e):o.substring(f[m],f[m+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;return!this.f&&o.charCodeAt(f[w]+u.end.column-1)===13?(s=!0,u.end.column===0?i--:a=o.substr(f[w],u.end.column-1)):a=o.substr(f[w],u.end.column),!0}),s&&(n[i++]=a,a=""),n[i++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const a=this.H(n,i+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,a,s,t,u,r,o,f,g,w){const k=this.a[n.piece.bufferIndex],m=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,t),D=this.u(n.piece.bufferIndex,u);let C;const P={line:0,column:0};let j,T;i._wordSeparators?(j=k.buffer.substring(y,D),T=z=>z+y,i.reset(0)):(j=k.buffer,T=z=>z,i.reset(y));do if(C=i.next(j),C){if(T(C.index)>=D)return g;this.s(n,T(C.index)-m,P);const z=this.t(n.piece.bufferIndex,t,P),N=P.line===t.line?P.column-t.column+s:P.column+1,F=N+C[0].length;if(w[g++]=(0,R.$UC)(new L.$xt(a+z,N,a+z,F),C,o),T(C.index)+C[0].length>=D||g>=f)return g}while(C);return g}findMatchesLineByLine(n,i,a,s){const t=[];let u=0;const r=new R.$XC(i.wordSeparators,i.regex);let o=this.H(n.startLineNumber,n.startColumn);if(o===null)return[];const f=this.H(n.endLineNumber,n.endColumn);if(f===null)return[];let g=this.s(o.node,o.remainder);const w=this.s(f.node,f.remainder);if(o.node===f.node)return this.findMatchesInNode(o.node,r,n.startLineNumber,n.startColumn,g,w,i,a,s,u,t),t;let k=n.startLineNumber,m=o.node;for(;m!==f.node;){const D=this.t(m.piece.bufferIndex,g,m.piece.end);if(D>=1){const P=this.a[m.piece.bufferIndex].lineStarts,j=this.u(m.piece.bufferIndex,m.piece.start),T=P[g.line+D],z=k===n.startLineNumber?n.startColumn:1;if(u=this.findMatchesInNode(m,r,k,z,g,this.s(m,T-j),i,a,s,u,t),u>=s)return t;k+=D}const C=k===n.startLineNumber?n.startColumn-1:0;if(k===n.endLineNumber){const P=this.getLineContent(k).substring(C,n.endColumn-1);return u=this.n(i,r,P,n.endLineNumber,C,u,t,a,s),t}if(u=this.n(i,r,this.getLineContent(k).substr(C),k,C,u,t,a,s),u>=s)return t;k++,o=this.H(k,1),m=o.node,g=this.s(o.node,o.remainder)}if(k===n.endLineNumber){const D=k===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(k).substring(D,n.endColumn-1);return u=this.n(i,r,C,n.endLineNumber,D,u,t,a,s),t}const y=k===n.startLineNumber?n.startColumn:1;return u=this.findMatchesInNode(f.node,r,k,y,g,w,i,a,s,u,t),t}n(n,i,a,s,t,u,r,o,f){const g=n.wordSeparators;if(!o&&n.simpleSearch){const k=n.simpleSearch,m=k.length,y=a.length;let D=-m;for(;(D=a.indexOf(k,D+m))!==-1;)if((!g||(0,R.$WC)(g,a,y,D,m))&&(r[u++]=new O.$Iv(new L.$xt(s,D+1+t,s,D+1+m+t),null),u>=f))return u;return u}let w;i.reset(0);do if(w=i.next(a),w&&(r[u++]=(0,R.$UC)(new L.$xt(s,w.index+1+t,s,w.index+1+w[0].length+t),w,o),u>=f))return u;while(w);return u}insert(n,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==M.$JC){const{node:s,remainder:t,nodeStartOffset:u}=this.G(n),r=s.piece,o=r.bufferIndex,f=this.s(s,t);if(s.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&u+r.length===n&&i.length<b){this.F(s,i),this.y();return}if(u===n)this.o(i,s),this.h.validate(n);else if(u+s.piece.length>n){const g=[];let w=new p(r.bufferIndex,f,r.end,this.t(r.bufferIndex,f,r.end),this.u(o,r.end)-this.u(o,f));if(this.K()&&this.M(i)&&this.I(s,t)===10){const D={line:w.start.line+1,column:0};w=new p(w.bufferIndex,D,w.end,this.t(w.bufferIndex,D,w.end),w.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const D=this.s(s,t-1);this.C(s,D),i="\r"+i,s.piece.length===0&&g.push(s)}else this.C(s,f);else this.C(s,f);const k=this.w(i);w.length>0&&this.S(s,w);let m=s;for(let y=0;y<k.length;y++)m=this.S(m,k[y]);this.v(g)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let u=1;u<s.length;u++)t=this.S(t,s[u])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===M.$JC)return;const a=this.G(n),s=this.G(n+i),t=a.node,u=s.node;if(t===u){const k=this.s(t,a.remainder),m=this.s(t,s.remainder);if(a.nodeStartOffset===n){if(i===t.piece.length){const y=t.next();(0,M.$OC)(this,t),this.N(y),this.y();return}this.D(t,m),this.h.validate(n),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===n+i){this.C(t,k),this.O(t),this.y();return}this.E(t,k,m),this.y();return}const r=[],o=this.s(t,a.remainder);this.C(t,o),this.h.validate(n),t.piece.length===0&&r.push(t);const f=this.s(u,s.remainder);this.D(u,f),u.piece.length===0&&r.push(u);const g=t.next();for(let k=g;k!==M.$JC&&k!==u;k=k.next())r.push(k);const w=t.piece.length===0?t.prev():t;this.v(r),this.O(w),this.y()}o(n,i){const a=[];if(this.K()&&this.M(n)&&this.L(i)){const u=i.piece,r={line:u.start.line+1,column:0},o=new p(u.bufferIndex,r,u.end,this.t(u.bufferIndex,r,u.end),u.length-1);i.piece=o,n+=`
`,(0,M.$QC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let u=s.length-2;u>=0;u--)t=this.T(t,s[u]);this.N(t),this.v(a)}q(n,i){this.Q(n,i)&&(n+=`
`);const a=this.w(n),s=this.S(i,a[0]);let t=s;for(let u=1;u<a.length;u++)t=this.S(t,a[u]);this.N(s)}s(n,i,a){const s=n.piece,t=n.piece.bufferIndex,u=this.a[t].lineStarts,o=u[s.start.line]+s.start.column+i;let f=s.start.line,g=s.end.line,w=0,k=0,m=0;for(;f<=g&&(w=f+(g-f)/2|0,m=u[w],w!==g);)if(k=u[w+1],o<m)g=w-1;else if(o>=k)f=w+1;else break;return a?(a.line=w,a.column=o-m,null):{line:w,column:o-m}}t(n,i,a){if(a.column===0)return a.line-i.line;const s=this.a[n].lineStarts;if(a.line===s.length-1)return a.line-i.line;const t=s[a.line+1],u=s[a.line]+a.column;if(t>u+1)return a.line-i.line;const r=u-1;return this.a[n].buffer.charCodeAt(r)===13?a.line-i.line+1:a.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,M.$OC)(this,n[i])}w(n){if(n.length>b){const g=[];for(;n.length>b;){const k=n.charCodeAt(b-1);let m;k===13||k>=55296&&k<=56319?(m=n.substring(0,b-1),n=n.substring(b-1)):(m=n.substring(0,b),n=n.substring(b));const y=A(m);g.push(new p(this.a.length,{line:0,column:0},{line:y.length-1,column:m.length-y[y.length-1]},y.length-1,m.length)),this.a.push(new S(m,y))}const w=A(n);return g.push(new p(this.a.length,{line:0,column:0},{line:w.length-1,column:n.length-w[w.length-1]},w.length-1,n.length)),this.a.push(new S(n,w)),g}let i=this.a[0].buffer.length;const a=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let g=0;g<a.length;g++)a[g]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let g=0;g<a.length;g++)a[g]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[u],o={line:u,column:r},f=new p(0,s,o,this.t(0,s,o),t-i);return this.g=o,[f]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let a=this.root,s="";const t=this.h.get2(n);if(t){a=t.node;const u=this.B(a,n-t.nodeStartLineNumber-1),r=this.a[a.piece.bufferIndex].buffer,o=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===n)s=r.substring(o+u,o+a.piece.length);else{const f=this.B(a,n-t.nodeStartLineNumber);return r.substring(o+u,o+f-i)}}else{let u=0;const r=n;for(;a!==M.$JC;)if(a.left!==M.$JC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const o=this.B(a,n-a.lf_left-2),f=this.B(a,n-a.lf_left-1),g=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);return u+=a.size_left,this.h.set({node:a,nodeStartOffset:u,nodeStartLineNumber:r-(n-1-a.lf_left)}),g.substring(w+o,w+f-i)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const o=this.B(a,n-a.lf_left-2),f=this.a[a.piece.bufferIndex].buffer,g=this.u(a.piece.bufferIndex,a.piece.start);s=f.substring(g+o,g+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,u+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==M.$JC;){const u=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const r=this.B(a,0),o=this.u(a.piece.bufferIndex,a.piece.start);return s+=u.substring(o,o+r-i),s}else{const r=this.u(a.piece.bufferIndex,a.piece.start);s+=u.substr(r,a.piece.length)}a=a.next()}return s}y(){let n=this.root,i=1,a=0;for(;n!==M.$JC;)i+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=a,this.h.validate(this.c)}A(n,i){const a=n.piece,s=this.s(n,i),t=s.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const u=this.t(n.piece.bufferIndex,a.start,s);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const a=n.piece,s=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?s[a.end.line]+a.end.column-s[a.start.line]-a.start.column:s[t]-s[a.start.line]-a.start.column}C(n,i){const a=n.piece,s=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),u=i,r=this.u(a.bufferIndex,u),o=this.t(a.bufferIndex,a.start,u),f=o-s,g=r-t,w=a.length+g;n.piece=new p(a.bufferIndex,a.start,u,o,w),(0,M.$QC)(this,n,g,f)}D(n,i){const a=n.piece,s=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),u=i,r=this.t(a.bufferIndex,u,a.end),o=this.u(a.bufferIndex,u),f=r-s,g=t-o,w=a.length+g;n.piece=new p(a.bufferIndex,u,a.end,r,w),(0,M.$QC)(this,n,g,f)}E(n,i,a){const s=n.piece,t=s.start,u=s.end,r=s.length,o=s.lineFeedCnt,f=i,g=this.t(s.bufferIndex,s.start,f),w=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new p(s.bufferIndex,s.start,f,g,w),(0,M.$QC)(this,n,w-r,g-o);const k=new p(s.bufferIndex,a,u,this.t(s.bufferIndex,a,u),this.u(s.bufferIndex,u)-this.u(s.bufferIndex,a)),m=this.S(n,k);this.N(m)}F(n,i){this.Q(i,n)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let m=0;m<t.length;m++)t[m]+=s;if(a){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[u],o={line:u,column:r},f=n.piece.length+i.length,g=n.piece.lineFeedCnt,w=this.t(0,n.piece.start,o),k=w-g;n.piece=new p(n.piece.bufferIndex,n.piece.start,o,w,f),this.g=o,(0,M.$QC)(this,n,i.length,k)}G(n){let i=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let s=0;for(;i!==M.$JC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let a=this.root,s=0;for(;a!==M.$JC;)if(a.left!==M.$JC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const t=this.B(a,n-a.lf_left-2),u=this.B(a,n-a.lf_left-1);return s+=a.size_left,{node:a,remainder:Math.min(t+i-1,u),nodeStartOffset:s}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const t=this.B(a,n-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:s};i-=a.piece.length-t;break}else n-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==M.$JC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),u=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:u}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return a.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$JC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,a=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=a[s]+i.start.column;return s===a.length-1||a[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$JC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const a=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const u=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new p(n.piece.bufferIndex,n.piece.start,t,r,u),(0,M.$QC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const o={line:i.piece.start.line+1,column:0},f=i.piece.length-1,g=this.t(i.piece.bufferIndex,o,i.piece.end);i.piece=new p(i.piece.bufferIndex,o,i.piece.end,g,f),(0,M.$QC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const w=this.w(`\r
`);this.S(n,w[0]);for(let k=0;k<a.length;k++)(0,M.$OC)(this,a[k])}Q(n,i){if(this.K()&&this.M(n)){const a=i.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,M.$OC)(this,a);else{const s=a.piece,t={line:s.start.line+1,column:0},u=s.length-1,r=this.t(s.bufferIndex,t,s.end);a.piece=new p(s.bufferIndex,t,s.end,r,u),(0,M.$QC)(this,a,-1,-1)}return!0}}return!1}iterate(n,i){if(n===M.$JC)return i(M.$JC);const a=this.iterate(n.left,i);return a&&i(n)&&this.iterate(n.right,i)}R(n){if(n===M.$JC)return"";const i=this.a[n.piece.bufferIndex],a=n.piece,s=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(a,s)}S(n,i){const a=new M.$IC(i,1);if(a.left=M.$JC,a.right=M.$JC,a.parent=M.$JC,a.size_left=0,a.lf_left=0,this.root===M.$JC)this.root=a,a.color=0;else if(n.right===M.$JC)n.right=a,a.parent=n;else{const t=(0,M.$KC)(n.right);t.left=a,a.parent=t}return(0,M.$PC)(this,a),a}T(n,i){const a=new M.$IC(i,1);if(a.left=M.$JC,a.right=M.$JC,a.parent=M.$JC,a.size_left=0,a.lf_left=0,this.root===M.$JC)this.root=a,a.color=0;else if(n.left===M.$JC)n.left=a,a.parent=n;else{const s=(0,M.$LC)(n.left);s.right=a,a.parent=s}return(0,M.$PC)(this,a),a}U(n){let i="";return this.iterate(n,a=>(i+=this.R(a),!0)),i}}e.$3C=d}),define(ke[189],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0=e.$G0=void 0;class l{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$G0=l;class L{constructor(M){this.identifier=M}}e.$H0=L}),define(ke[190],De([1,0,4,3]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3t=void 0;class O{constructor(){this.a=new Map,this.b=new Map,this.c=new l.$fe,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,L.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const E=new M(this,b,$);return this.b.set(b,E),(0,L.$Sc)(()=>{const A=this.b.get(b);!A||A!==E||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const E=this.b.get(b);return!E||E.isResolved?null:(await E.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const E=this.b.get(b);return!!(!E||E.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$3t=O;class M extends L.$Uc{get isResolved(){return this.c}constructor(b,$,E){super(),this.f=b,this.g=$,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[191],De([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ke[192],De([1,0,4,3,191]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=void 0,e.$ij=A;class M extends L.$Uc{constructor(p,S="",v="",h=!0,d){super(),this.h=this.B(new l.$fe),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=S,this.u=v,this.w=h,this.C=d}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,S){this.C&&await this.C(p)}}e.$dj=M;class R extends L.$Uc{constructor(){super(...arguments),this.f=this.B(new l.$fe),this.onWillRun=this.f.event,this.m=this.B(new l.$fe),this.onDidRun=this.m.event}async run(p,S){if(!p.enabled)return;this.f.fire({action:p});let v;try{await this.u(p,S)}catch(h){v=h}this.m.fire({action:p,error:v})}async u(p,S){await p.run(S)}}e.$ej=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let S=[];for(const v of p)v.length&&(S.length?S=[...S,new b,...v]:S=v);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$fj=b;class ${get actions(){return this.a}constructor(p,S,v,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=S,this.class=h,this.a=v}async run(){}}e.$gj=$;class E extends M{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,O.localize(0,null),void 0,!1)}}e.$hj=E;function A(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...p)=>I.run(...p),tooltip:I.label}}}),define(ke[193],De([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(ke[194],De([1,0,193]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=E,e.$5m=A,e.$6m=I;const L=60,O=L*60,M=O*24,R=M*7,b=M*30,$=M*365;function E(p,S,v,h){typeof p!="number"&&(p=p.getTime());const d=Math.round((new Date().getTime()-p)/1e3);if(d<-30)return(0,l.localize)(0,null,E(new Date().getTime()+d*1e3,!1));if(!h&&d<30)return(0,l.localize)(1,null);let c;return d<L?(c=d,S?c===1?v?(0,l.localize)(2,null,c):(0,l.localize)(3,null,c):v?(0,l.localize)(4,null,c):(0,l.localize)(5,null,c):c===1?v?(0,l.localize)(6,null,c):(0,l.localize)(7,null,c):v?(0,l.localize)(8,null,c):(0,l.localize)(9,null,c)):d<O?(c=Math.floor(d/L),S?c===1?v?(0,l.localize)(10,null,c):(0,l.localize)(11,null,c):v?(0,l.localize)(12,null,c):(0,l.localize)(13,null,c):c===1?v?(0,l.localize)(14,null,c):(0,l.localize)(15,null,c):v?(0,l.localize)(16,null,c):(0,l.localize)(17,null,c)):d<M?(c=Math.floor(d/O),S?c===1?v?(0,l.localize)(18,null,c):(0,l.localize)(19,null,c):v?(0,l.localize)(20,null,c):(0,l.localize)(21,null,c):c===1?v?(0,l.localize)(22,null,c):(0,l.localize)(23,null,c):v?(0,l.localize)(24,null,c):(0,l.localize)(25,null,c)):d<R?(c=Math.floor(d/M),S?c===1?(0,l.localize)(26,null,c):(0,l.localize)(27,null,c):c===1?(0,l.localize)(28,null,c):(0,l.localize)(29,null,c)):d<b?(c=Math.floor(d/R),S?c===1?v?(0,l.localize)(30,null,c):(0,l.localize)(31,null,c):v?(0,l.localize)(32,null,c):(0,l.localize)(33,null,c):c===1?v?(0,l.localize)(34,null,c):(0,l.localize)(35,null,c):v?(0,l.localize)(36,null,c):(0,l.localize)(37,null,c)):d<$?(c=Math.floor(d/b),S?c===1?v?(0,l.localize)(38,null,c):(0,l.localize)(39,null,c):v?(0,l.localize)(40,null,c):(0,l.localize)(41,null,c):c===1?v?(0,l.localize)(42,null,c):(0,l.localize)(43,null,c):v?(0,l.localize)(44,null,c):(0,l.localize)(45,null,c)):(c=Math.floor(d/$),S?c===1?v?(0,l.localize)(46,null,c):(0,l.localize)(47,null,c):v?(0,l.localize)(48,null,c):(0,l.localize)(49,null,c):c===1?v?(0,l.localize)(50,null,c):(0,l.localize)(51,null,c):v?(0,l.localize)(52,null,c):(0,l.localize)(53,null,c))}function A(p,S){const v=Math.abs(p/1e3);return v<1?S?(0,l.localize)(54,null,p):(0,l.localize)(55,null,p):v<L?S?(0,l.localize)(56,null,Math.round(p)/1e3):(0,l.localize)(57,null,Math.round(p)/1e3):v<O?S?(0,l.localize)(58,null,Math.round(p/(1e3*L))):(0,l.localize)(59,null,Math.round(p/(1e3*L))):v<M?S?(0,l.localize)(60,null,Math.round(p/(1e3*O))):(0,l.localize)(61,null,Math.round(p/(1e3*O))):(0,l.localize)(62,null,Math.round(p/(1e3*M)))}function I(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[195],De([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ke[47],De([1,0,19,18,195]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=$,e.$kj=E,e.$lj=A;function M(I,p){return p&&(I.stack||I.stacktrace)?O.localize(0,null,b(I),R(I.stack)||R(I.stacktrace)):b(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?O.localize(1,null,I.message):I.message||O.localize(2,null)}function $(I=null,p=!1){if(!I)return O.localize(3,null);if(Array.isArray(I)){const S=l.$Hb(I),v=$(S[0],p);return S.length>1?O.localize(4,null,v,S.length):v}if(L.$$f(I))return I;if(I.detail){const S=I.detail;if(S.error)return M(S.error,p);if(S.exception)return M(S.exception,p)}return I.stack?M(I,p):I.message?I.message:O.localize(5,null)}function E(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}function A(I,p){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=p,S}}),define(ke[196],De([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(ke[12],De([1,0,196]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=u,e.$D=k,e.$J=m,e.$g="en";let L=!1,O=!1,M=!1,R=!1,b=!1,$=!1,E=!1,A=!1,I=!1,p=!1,S,v=e.$g,h=e.$g,d,c;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const a=typeof i?.versions?.electron=="string",s=a&&i?.type==="renderer";if(typeof i=="object"){L=i.platform==="win32",O=i.platform==="darwin",M=i.platform==="linux",R=M&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,E=a,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,v=e.$g;const y=i.env.VSCODE_NLS_CONFIG;if(y)try{const D=JSON.parse(y),C=D.availableLanguages["*"];S=D.locale,h=D.osLocale,v=C||e.$g,d=D._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(c=navigator.userAgent,L=c.indexOf("Windows")>=0,O=c.indexOf("Macintosh")>=0,A=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=c.indexOf("Linux")>=0,p=c?.indexOf("Mobi")>=0,$=!0,S=l.getConfiguredDefaultLocale(l.localize(0,null))||e.$g,v=S,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;O?r=1:L?r=3:M&&(r=2),e.$i=L,e.$j=O,e.$k=M,e.$l=R,e.$m=b,e.$n=E,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=p,e.$t=I,e.$u=r,e.$v=c,e.$w=v;var o;(function(y){function D(){return e.$w}y.value=D;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}y.isDefaultVariant=C;function P(){return e.$w==="en"}y.isDefault=P})(o||(e.Language=o={})),e.$x=S,e.$y=h,e.$z=d,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const y=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let P=0,j=y.length;P<j;P++){const T=y[P];if(T.id===C.data.vscodeScheduleAsyncWork){y.splice(P,1),T.callback();return}}});let D=0;return C=>{const P=++D;y.push({id:P,callback:C}),n.postMessage({vscodeScheduleAsyncWork:P},"*")}}return y=>setTimeout(y)})();var f;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(f||(e.OperatingSystem=f={})),e.OS=O||A?2:L?1:3;let g=!0,w=!1;function k(){if(!w){w=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,g=new Uint16Array(y.buffer)[0]===513}return g}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function m(y){return parseFloat(y)>=20}}),define(ke[52],De([1,0,12]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.process<"u"){const M=O.process;L={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return l.$i?"win32":l.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(ke[16],De([1,0,52]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,O=97,M=90,R=122,b=46,$=47,E=92,A=58,I=63;class p extends Error{constructor(u,r,o){let f;typeof r=="string"&&r.indexOf("not ")===0?(f="must not be",r=r.replace(/^not /,"")):f="must be";const g=u.indexOf(".")!==-1?"property":"argument";let w=`The "${u}" ${g} ${f} of type ${r}`;w+=`. Received type ${typeof o}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,u){if(t===null||typeof t!="object")throw new p(u,"Object",t)}function v(t,u){if(typeof t!="string")throw new p(u,"string",t)}const h=l.$dc==="win32";function d(t){return t===$||t===E}function c(t){return t===$}function n(t){return t>=L&&t<=M||t>=O&&t<=R}function i(t,u,r,o){let f="",g=0,w=-1,k=0,m=0;for(let y=0;y<=t.length;++y){if(y<t.length)m=t.charCodeAt(y);else{if(o(m))break;m=$}if(o(m)){if(!(w===y-1||k===1))if(k===2){if(f.length<2||g!==2||f.charCodeAt(f.length-1)!==b||f.charCodeAt(f.length-2)!==b){if(f.length>2){const D=f.lastIndexOf(r);D===-1?(f="",g=0):(f=f.slice(0,D),g=f.length-1-f.lastIndexOf(r)),w=y,k=0;continue}else if(f.length!==0){f="",g=0,w=y,k=0;continue}}u&&(f+=f.length>0?`${r}..`:"..",g=2)}else f.length>0?f+=`${r}${t.slice(w+1,y)}`:f=t.slice(w+1,y),g=y-w-1;w=y,k=0}else m===b&&k!==-1?++k:k=-1}return f}function a(t,u){S(u,"pathObject");const r=u.dir||u.root,o=u.base||`${u.name||""}${u.ext||""}`;return r?r===u.root?`${r}${o}`:`${r}${t}${o}`:o}e.$fc={resolve(...t){let u="",r="",o=!1;for(let f=t.length-1;f>=-1;f--){let g;if(f>=0){if(g=t[f],v(g,"path"),g.length===0)continue}else u.length===0?g=l.cwd():(g=l.env[`=${u}`]||l.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==u.toLowerCase()&&g.charCodeAt(2)===E)&&(g=`${u}\\`));const w=g.length;let k=0,m="",y=!1;const D=g.charCodeAt(0);if(w===1)d(D)&&(k=1,y=!0);else if(d(D))if(y=!0,d(g.charCodeAt(1))){let C=2,P=C;for(;C<w&&!d(g.charCodeAt(C));)C++;if(C<w&&C!==P){const j=g.slice(P,C);for(P=C;C<w&&d(g.charCodeAt(C));)C++;if(C<w&&C!==P){for(P=C;C<w&&!d(g.charCodeAt(C));)C++;(C===w||C!==P)&&(m=`\\\\${j}\\${g.slice(P,C)}`,k=C)}}}else k=1;else n(D)&&g.charCodeAt(1)===A&&(m=g.slice(0,2),k=2,w>2&&d(g.charCodeAt(2))&&(y=!0,k=3));if(m.length>0)if(u.length>0){if(m.toLowerCase()!==u.toLowerCase())continue}else u=m;if(o){if(u.length>0)break}else if(r=`${g.slice(k)}\\${r}`,o=y,y&&u.length>0)break}return r=i(r,!o,"\\",d),o?`${u}\\${r}`:`${u}${r}`||"."},normalize(t){v(t,"path");const u=t.length;if(u===0)return".";let r=0,o,f=!1;const g=t.charCodeAt(0);if(u===1)return c(g)?"\\":t;if(d(g))if(f=!0,d(t.charCodeAt(1))){let k=2,m=k;for(;k<u&&!d(t.charCodeAt(k));)k++;if(k<u&&k!==m){const y=t.slice(m,k);for(m=k;k<u&&d(t.charCodeAt(k));)k++;if(k<u&&k!==m){for(m=k;k<u&&!d(t.charCodeAt(k));)k++;if(k===u)return`\\\\${y}\\${t.slice(m)}\\`;k!==m&&(o=`\\\\${y}\\${t.slice(m,k)}`,r=k)}}}else r=1;else n(g)&&t.charCodeAt(1)===A&&(o=t.slice(0,2),r=2,u>2&&d(t.charCodeAt(2))&&(f=!0,r=3));let w=r<u?i(t.slice(r),!f,"\\",d):"";return w.length===0&&!f&&(w="."),w.length>0&&d(t.charCodeAt(u-1))&&(w+="\\"),o===void 0?f?`\\${w}`:w:f?`${o}\\${w}`:`${o}${w}`},isAbsolute(t){v(t,"path");const u=t.length;if(u===0)return!1;const r=t.charCodeAt(0);return d(r)||u>2&&n(r)&&t.charCodeAt(1)===A&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,r;for(let g=0;g<t.length;++g){const w=t[g];v(w,"path"),w.length>0&&(u===void 0?u=r=w:u+=`\\${w}`)}if(u===void 0)return".";let o=!0,f=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++f;const g=r.length;g>1&&d(r.charCodeAt(1))&&(++f,g>2&&(d(r.charCodeAt(2))?++f:o=!1))}if(o){for(;f<u.length&&d(u.charCodeAt(f));)f++;f>=2&&(u=`\\${u.slice(f)}`)}return e.$fc.normalize(u)},relative(t,u){if(v(t,"from"),v(u,"to"),t===u)return"";const r=e.$fc.resolve(t),o=e.$fc.resolve(u);if(r===o||(t=r.toLowerCase(),u=o.toLowerCase(),t===u))return"";let f=0;for(;f<t.length&&t.charCodeAt(f)===E;)f++;let g=t.length;for(;g-1>f&&t.charCodeAt(g-1)===E;)g--;const w=g-f;let k=0;for(;k<u.length&&u.charCodeAt(k)===E;)k++;let m=u.length;for(;m-1>k&&u.charCodeAt(m-1)===E;)m--;const y=m-k,D=w<y?w:y;let C=-1,P=0;for(;P<D;P++){const T=t.charCodeAt(f+P);if(T!==u.charCodeAt(k+P))break;T===E&&(C=P)}if(P!==D){if(C===-1)return o}else{if(y>D){if(u.charCodeAt(k+P)===E)return o.slice(k+P+1);if(P===2)return o.slice(k+P)}w>D&&(t.charCodeAt(f+P)===E?C=P:P===2&&(C=3)),C===-1&&(C=0)}let j="";for(P=f+C+1;P<=g;++P)(P===g||t.charCodeAt(P)===E)&&(j+=j.length===0?"..":"\\..");return k+=C,j.length>0?`${j}${o.slice(k,m)}`:(o.charCodeAt(k)===E&&++k,o.slice(k,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$fc.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===E){if(u.charCodeAt(1)===E){const r=u.charCodeAt(2);if(r!==I&&r!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(n(u.charCodeAt(0))&&u.charCodeAt(1)===A&&u.charCodeAt(2)===E)return`\\\\?\\${u}`;return t},dirname(t){v(t,"path");const u=t.length;if(u===0)return".";let r=-1,o=0;const f=t.charCodeAt(0);if(u===1)return d(f)?t:".";if(d(f)){if(r=o=1,d(t.charCodeAt(1))){let k=2,m=k;for(;k<u&&!d(t.charCodeAt(k));)k++;if(k<u&&k!==m){for(m=k;k<u&&d(t.charCodeAt(k));)k++;if(k<u&&k!==m){for(m=k;k<u&&!d(t.charCodeAt(k));)k++;if(k===u)return t;k!==m&&(r=o=k+1)}}}}else n(f)&&t.charCodeAt(1)===A&&(r=u>2&&d(t.charCodeAt(2))?3:2,o=r);let g=-1,w=!0;for(let k=u-1;k>=o;--k)if(d(t.charCodeAt(k))){if(!w){g=k;break}}else w=!1;if(g===-1){if(r===-1)return".";g=r}return t.slice(0,g)},basename(t,u){u!==void 0&&v(u,"ext"),v(t,"path");let r=0,o=-1,f=!0,g;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(r=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let w=u.length-1,k=-1;for(g=t.length-1;g>=r;--g){const m=t.charCodeAt(g);if(d(m)){if(!f){r=g+1;break}}else k===-1&&(f=!1,k=g+1),w>=0&&(m===u.charCodeAt(w)?--w===-1&&(o=g):(w=-1,o=k))}return r===o?o=k:o===-1&&(o=t.length),t.slice(r,o)}for(g=t.length-1;g>=r;--g)if(d(t.charCodeAt(g))){if(!f){r=g+1;break}}else o===-1&&(f=!1,o=g+1);return o===-1?"":t.slice(r,o)},extname(t){v(t,"path");let u=0,r=-1,o=0,f=-1,g=!0,w=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(u=o=2);for(let k=t.length-1;k>=u;--k){const m=t.charCodeAt(k);if(d(m)){if(!g){o=k+1;break}continue}f===-1&&(g=!1,f=k+1),m===b?r===-1?r=k:w!==1&&(w=1):r!==-1&&(w=-1)}return r===-1||f===-1||w===0||w===1&&r===f-1&&r===o+1?"":t.slice(r,f)},format:a.bind(null,"\\"),parse(t){v(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.length;let o=0,f=t.charCodeAt(0);if(r===1)return d(f)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(d(f)){if(o=1,d(t.charCodeAt(1))){let C=2,P=C;for(;C<r&&!d(t.charCodeAt(C));)C++;if(C<r&&C!==P){for(P=C;C<r&&d(t.charCodeAt(C));)C++;if(C<r&&C!==P){for(P=C;C<r&&!d(t.charCodeAt(C));)C++;C===r?o=C:C!==P&&(o=C+1)}}}}else if(n(f)&&t.charCodeAt(1)===A){if(r<=2)return u.root=u.dir=t,u;if(o=2,d(t.charCodeAt(2))){if(r===3)return u.root=u.dir=t,u;o=3}}o>0&&(u.root=t.slice(0,o));let g=-1,w=o,k=-1,m=!0,y=t.length-1,D=0;for(;y>=o;--y){if(f=t.charCodeAt(y),d(f)){if(!m){w=y+1;break}continue}k===-1&&(m=!1,k=y+1),f===b?g===-1?g=y:D!==1&&(D=1):g!==-1&&(D=-1)}return k!==-1&&(g===-1||D===0||D===1&&g===k-1&&g===w+1?u.base=u.name=t.slice(w,k):(u.name=t.slice(w,g),u.base=t.slice(w,k),u.ext=t.slice(g,k))),w>0&&w!==o?u.dir=t.slice(0,w-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(h){const t=/\\/g;return()=>{const u=l.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>l.cwd()})();e.$gc={resolve(...t){let u="",r=!1;for(let o=t.length-1;o>=-1&&!r;o--){const f=o>=0?t[o]:s();v(f,"path"),f.length!==0&&(u=`${f}/${u}`,r=f.charCodeAt(0)===$)}return u=i(u,!r,"/",c),r?`/${u}`:u.length>0?u:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$,r=t.charCodeAt(t.length-1)===$;return t=i(t,!u,"/",c),t.length===0?u?"/":r?"./":".":(r&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let u;for(let r=0;r<t.length;++r){const o=t[r];v(o,"path"),o.length>0&&(u===void 0?u=o:u+=`/${o}`)}return u===void 0?".":e.$gc.normalize(u)},relative(t,u){if(v(t,"from"),v(u,"to"),t===u||(t=e.$gc.resolve(t),u=e.$gc.resolve(u),t===u))return"";const r=1,o=t.length,f=o-r,g=1,w=u.length-g,k=f<w?f:w;let m=-1,y=0;for(;y<k;y++){const C=t.charCodeAt(r+y);if(C!==u.charCodeAt(g+y))break;C===$&&(m=y)}if(y===k)if(w>k){if(u.charCodeAt(g+y)===$)return u.slice(g+y+1);if(y===0)return u.slice(g+y)}else f>k&&(t.charCodeAt(r+y)===$?m=y:y===0&&(m=0));let D="";for(y=r+m+1;y<=o;++y)(y===o||t.charCodeAt(y)===$)&&(D+=D.length===0?"..":"/..");return`${D}${u.slice(g+m)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$;let r=-1,o=!0;for(let f=t.length-1;f>=1;--f)if(t.charCodeAt(f)===$){if(!o){r=f;break}}else o=!1;return r===-1?u?"/":".":u&&r===1?"//":t.slice(0,r)},basename(t,u){u!==void 0&&v(u,"ext"),v(t,"path");let r=0,o=-1,f=!0,g;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let w=u.length-1,k=-1;for(g=t.length-1;g>=0;--g){const m=t.charCodeAt(g);if(m===$){if(!f){r=g+1;break}}else k===-1&&(f=!1,k=g+1),w>=0&&(m===u.charCodeAt(w)?--w===-1&&(o=g):(w=-1,o=k))}return r===o?o=k:o===-1&&(o=t.length),t.slice(r,o)}for(g=t.length-1;g>=0;--g)if(t.charCodeAt(g)===$){if(!f){r=g+1;break}}else o===-1&&(f=!1,o=g+1);return o===-1?"":t.slice(r,o)},extname(t){v(t,"path");let u=-1,r=0,o=-1,f=!0,g=0;for(let w=t.length-1;w>=0;--w){const k=t.charCodeAt(w);if(k===$){if(!f){r=w+1;break}continue}o===-1&&(f=!1,o=w+1),k===b?u===-1?u=w:g!==1&&(g=1):u!==-1&&(g=-1)}return u===-1||o===-1||g===0||g===1&&u===o-1&&u===r+1?"":t.slice(u,o)},format:a.bind(null,"/"),parse(t){v(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.charCodeAt(0)===$;let o;r?(u.root="/",o=1):o=0;let f=-1,g=0,w=-1,k=!0,m=t.length-1,y=0;for(;m>=o;--m){const D=t.charCodeAt(m);if(D===$){if(!k){g=m+1;break}continue}w===-1&&(k=!1,w=m+1),D===b?f===-1?f=m:y!==1&&(y=1):f!==-1&&(y=-1)}if(w!==-1){const D=g===0&&r?1:g;f===-1||y===0||y===1&&f===w-1&&f===g+1?u.base=u.name=t.slice(D,w):(u.name=t.slice(D,f),u.base=t.slice(D,w),u.ext=t.slice(f,w))}return g>0?u.dir=t.slice(0,g-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(ke[132],De([1,0,46,16]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=b,e.$kr=$,e.$lr=E,e.$mr=A,e.$nr=I,e.$or=p,e.$pr=S,e.$qr=v,e.$rr=h,e.$sr=d,e.$tr=f,e.$ur=g,e.$vr=w;const O=new l.$V(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(k,m,y=!1){const D=k||"",C=m||"",P=O.value.collator.compare(D,C);return O.value.collatorIsNumeric&&P===0&&D!==C?D<C?-1:1:P}function $(k,m){const y=M.value.collator;return k=k||"",m=m||"",a(y,k,m)}function E(k,m){const y=M.value.collator;return k=k||"",m=m||"",r(k,m)||a(y,k,m)}function A(k,m){const y=M.value.collator;return k=k||"",m=m||"",u(k,m)||a(y,k,m)}function I(k,m){return k=k||"",m=m||"",k===m?0:k<m?-1:1}function p(k,m){const[y,D]=n(k),[C,P]=n(m);let j=O.value.collator.compare(D,P);if(j===0){if(O.value.collatorIsNumeric&&D!==P)return D<P?-1:1;if(j=O.value.collator.compare(y,C),O.value.collatorIsNumeric&&j===0&&y!==C)return y<C?-1:1}return j}function S(k,m){k=k||"",m=m||"";const y=i(k),D=i(m),C=M.value.collator,P=R.value.collator;return a(P,y,D)||a(C,k,m)}function v(k,m){k=k||"",m=m||"";const y=i(k),D=i(m),C=M.value.collator,P=R.value.collator;return a(P,y,D)||r(k,m)||a(C,k,m)}function h(k,m){k=k||"",m=m||"";const y=i(k),D=i(m),C=M.value.collator,P=R.value.collator;return a(P,y,D)||u(k,m)||a(C,k,m)}function d(k,m){k=k||"",m=m||"";const y=i(k).toLowerCase(),D=i(m).toLowerCase();return y!==D?y<D?-1:1:k!==m?k<m?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function n(k,m=!1){const y=k?c.exec(k):[];let D=[y&&y[1]||"",y&&y[3]||""];return m&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function i(k){const m=k?c.exec(k):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function a(k,m,y){const D=k.compare(m,y);return D!==0?D:m.length!==y.length?m.length<y.length?-1:1:0}function s(k){const m=k.charAt(0);return m.toLocaleUpperCase()!==m}function t(k){const m=k.charAt(0);return m.toLocaleLowerCase()!==m}function u(k,m){return s(k)&&t(m)?-1:t(k)&&s(m)?1:0}function r(k,m){return t(k)&&s(m)?-1:s(k)&&t(m)?1:0}function o(k,m,y=!1){return y||(k=k&&k.toLowerCase(),m=m&&m.toLowerCase()),k===m?0:k<m?-1:1}function f(k,m,y=!1){const D=k.split(L.sep),C=m.split(L.sep),P=D.length-1,j=C.length-1;let T,z;for(let N=0;;N++){if(T=P===N,z=j===N,T&&z)return b(D[N],C[N],y);if(T)return-1;if(z)return 1;const F=o(D[N],C[N],y);if(F!==0)return F}}function g(k,m,y){const D=k.toLowerCase(),C=m.toLowerCase(),P=w(k,m,y);if(P)return P;const j=D.endsWith(y),T=C.endsWith(y);if(j!==T)return j?-1:1;const z=b(D,C);return z!==0?z:D.localeCompare(C)}function w(k,m,y){const D=k.toLowerCase(),C=m.toLowerCase(),P=D.startsWith(y),j=C.startsWith(y);if(P!==j)return P?-1:1;if(P&&j){if(D.length<C.length)return-1;if(D.length>C.length)return 1}return 0}}),define(ke[31],De([1,0,16,12,14,18]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=R,e.$rg=b,e.$sg=$,e.$tg=E,e.$ug=A,e.$vg=v,e.$wg=h,e.$xg=d,e.$yg=c,e.$zg=n,e.$Ag=i,e.$Bg=a,e.$Cg=s,e.$Dg=t,e.$Eg=u,e.$Fg=r,e.$Gg=g;function R(w){return w===47||w===92}function b(w){return w.replace(/[\\/]/g,l.$gc.sep)}function $(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function E(w,k=l.$gc.sep){if(!w)return"";const m=w.length,y=w.charCodeAt(0);if(R(y)){if(R(w.charCodeAt(1))&&!R(w.charCodeAt(2))){let C=3;const P=C;for(;C<m&&!R(w.charCodeAt(C));C++);if(P!==C&&!R(w.charCodeAt(C+1))){for(C+=1;C<m;C++)if(R(w.charCodeAt(C)))return w.slice(0,C+1).replace(/[\\/]/g,k)}}return k}else if(c(y)&&w.charCodeAt(1)===58)return R(w.charCodeAt(2))?w.slice(0,2)+k:w.slice(0,2);let D=w.indexOf("://");if(D!==-1){for(D+=3;D<m;D++)if(R(w.charCodeAt(D)))return w.slice(0,D+1)}return""}function A(w){if(!L.$i||!w||w.length<5)return!1;let k=w.charCodeAt(0);if(k!==92||(k=w.charCodeAt(1),k!==92))return!1;let m=2;const y=m;for(;m<w.length&&(k=w.charCodeAt(m),k!==92);m++);return!(y===m||(k=w.charCodeAt(m+1),isNaN(k)||k===92))}const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(w,k=L.$i){const m=k?I:p;return!(!w||w.length===0||/^\s+$/.test(w)||(m.lastIndex=0,m.test(w))||k&&S.test(w)||w==="."||w===".."||k&&w[w.length-1]==="."||k&&w.length!==w.trim().length||w.length>255)}function h(w,k,m){const y=w===k;return!m||y?y:!w||!k?!1:(0,O.$zf)(w,k)}function d(w,k,m,y=l.sep){if(w===k)return!0;if(!w||!k||k.length>w.length)return!1;if(m){if(!(0,O.$Af)(w,k))return!1;if(k.length===w.length)return!0;let C=k.length;return k.charAt(k.length-1)===y&&C--,w.charAt(C)===y}return k.charAt(k.length-1)!==y&&(k+=y),w.indexOf(k)===0}function c(w){return w>=65&&w<=90||w>=97&&w<=122}function n(w,k){return L.$i&&w.endsWith(":")&&(w+=l.sep),(0,l.$ic)(w)||(w=(0,l.$jc)(k,w)),w=(0,l.$hc)(w),i(w)}function i(w){return L.$i?(w=(0,O.$hf)(w,l.sep),w.endsWith(":")&&(w+=l.sep)):(w=(0,O.$hf)(w,l.sep),w||(w=l.sep)),w}function a(w){const k=(0,l.$hc)(w);return L.$i?w.length>3?!1:s(k)&&(w.length===2||k.charCodeAt(2)===92):k===l.$gc.sep}function s(w,k=L.$i){return k?c(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function t(w,k=L.$i){return s(w,k)?w[0]:void 0}function u(w,k,m){return k.length>w.length?-1:w===k?0:(m&&(w=w.toLowerCase(),k=k.toLowerCase()),w.indexOf(k))}function r(w){const k=w.split(":");let m,y,D;for(const C of k){const P=Number(C);(0,M.$cg)(P)?y===void 0?y=P:D===void 0&&(D=P):m=m?[m,C].join(":"):C}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:y!==void 0?y:void 0,column:D!==void 0?D:y!==void 0?1:void 0}}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(w,k,m=8){let y="";for(let C=0;C<m;C++){let P;C===0&&L.$i&&!k&&(m===3||m===4)?P=f:P=o,y+=P.charAt(Math.floor(Math.random()*P.length))}let D;return k?D=`${k}-${y}`:D=y,w?(0,l.$jc)(w,D):D}}),define(ke[133],De([1,0,132,127,57,16,12,14]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=A,e.$xr=d,e.$yr=r,e.$zr=y,e.$Ar=z,e.$Br=F;const $=0,E=[$,[]];function A(U,Y,ie,H){if(!U||!Y)return E;const J=U.length,x=Y.length;if(J<x)return E;const ne=U.toLowerCase();return I(Y,ie,x,U,ne,J,H)}function I(U,Y,ie,H,J,x,ne){const be=[],ae=[];for(let _=0;_<ie;_++){const pe=_*x,ue=pe-x,ce=_>0,oe=U[_],le=Y[_];for(let K=0;K<x;K++){const se=K>0,$e=pe+K,ve=$e-1,Me=ue+K-1,ge=se?be[ve]:0,Pe=ce&&se?be[Me]:0,Ae=ce&&se?ae[Me]:0;let ze;!Pe&&ce?ze=0:ze=p(oe,le,H,J,K,Ae),ze&&Pe+ze>=ge&&(ne||ce||J.startsWith(Y,K))?(ae[$e]=Ae+1,be[$e]=Pe+ze):(ae[$e]=$,be[$e]=ge)}}const Ie=[];let ee=ie-1,B=x-1;for(;ee>=0&&B>=0;){const _=ee*x+B;ae[_]===$||(Ie.push(B),ee--),B--}return[be[ie*x-1],Ie.reverse()]}function p(U,Y,ie,H,J,x){let ne=0;if(!S(Y,H[J]))return ne;if(ne+=1,x>0&&(ne+=x*5),U===ie[J]&&(ne+=1),J===0)ne+=8;else{const be=v(ie.charCodeAt(J-1));be?ne+=be:(0,L.$Dk)(ie.charCodeAt(J))&&x===0&&(ne+=2)}return ne}function S(U,Y){return U===Y?!0:U==="/"||U==="\\"?Y==="/"||Y==="\\":!1}function v(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function d(U,Y,ie=0,H=0){const J=Y;return J.values&&J.values.length>1?c(U,J.values,ie,H):n(U,Y,ie,H)}function c(U,Y,ie,H){let J=0;const x=[];for(const ne of Y){const[be,ae]=n(U,ne,ie,H);if(typeof be!="number")return h;J+=be,x.push(...ae)}return[J,k(x)]}function n(U,Y,ie,H){const J=(0,L.$Mk)(Y.original,Y.originalLowercase,ie,U,U.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,L.$Jk)(J)]:h}const i=Object.freeze({score:0}),a=1<<18,s=1<<17,t=65536;function u(U,Y,ie,H){const J=H.values?H.values:[H];return(0,O.$mj)({[H.normalized]:{values:J.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:Y,allowNonContiguousMatches:ie}})}function r(U,Y,ie,H,J){if(!U||!Y.normalized)return i;const x=H.getItemLabel(U);if(!x)return i;const ne=H.getItemDescription(U),be=u(x,ne,ie,Y),ae=J[be];if(ae)return ae;const Ie=o(x,ne,H.getItemPath(U),Y,ie);return J[be]=Ie,Ie}function o(U,Y,ie,H,J){const x=!ie||!H.containsPathSeparator;return ie&&(R.$k?H.pathNormalized===ie:(0,b.$zf)(H.pathNormalized,ie))?{score:a,labelMatch:[{start:0,end:U.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:H.values&&H.values.length>1?f(U,Y,ie,H.values,x,J):g(U,Y,ie,H,x,J)}function f(U,Y,ie,H,J,x){let ne=0;const be=[],ae=[];for(const Ie of H){const{score:ee,labelMatch:B,descriptionMatch:_}=g(U,Y,ie,Ie,J,x);if(ee===$)return i;ne+=ee,B&&be.push(...B),_&&ae.push(..._)}return{score:ne,labelMatch:k(be),descriptionMatch:k(ae)}}function g(U,Y,ie,H,J,x){if(J||!Y){const[ne,be]=A(U,H.normalized,H.normalizedLowercase,x&&!H.expectContiguousMatch);if(ne){const ae=(0,L.$Ak)(H.normalized,U);let Ie;if(ae){Ie=s;const ee=Math.round(H.normalized.length/U.length*100);Ie+=ee}else Ie=t;return{score:Ie+ne,labelMatch:ae||w(be)}}}if(Y){let ne=Y;ie&&(ne=`${Y}${M.sep}`);const be=ne.length,ae=`${ne}${U}`,[Ie,ee]=A(ae,H.normalized,H.normalizedLowercase,x&&!H.expectContiguousMatch);if(Ie){const B=w(ee),_=[],pe=[];return B.forEach(ue=>{ue.start<be&&ue.end>be?(_.push({start:0,end:ue.end-be}),pe.push({start:ue.start,end:be})):ue.start>=be?_.push({start:ue.start-be,end:ue.end-be}):pe.push(ue)}),{score:Ie,labelMatch:_,descriptionMatch:pe}}}return i}function w(U){const Y=[];if(!U)return Y;let ie;for(const H of U)ie&&ie.end===H?ie.end+=1:(ie={start:H,end:H+1},Y.push(ie));return Y}function k(U){const Y=U.sort((J,x)=>J.start-x.start),ie=[];let H;for(const J of Y)!H||!m(H,J)?(H=J,ie.push(J)):(H.start=Math.min(H.start,J.start),H.end=Math.max(H.end,J.end));return ie}function m(U,Y){return!(U.end<Y.start||Y.end<U.start)}function y(U,Y,ie,H,J,x){const ne=r(U,ie,H,J,x),be=r(Y,ie,H,J,x),ae=ne.score,Ie=be.score;if((ae===a||Ie===a)&&ae!==Ie)return ae===a?-1:1;if(ae>t||Ie>t){if(ae!==Ie)return ae>Ie?-1:1;if(ae<s&&Ie<s){const oe=C(ne.labelMatch,be.labelMatch);if(oe!==0)return oe}const ue=J.getItemLabel(U)||"",ce=J.getItemLabel(Y)||"";if(ue.length!==ce.length)return ue.length-ce.length}if(ae!==Ie)return ae>Ie?-1:1;const ee=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,B=Array.isArray(be.labelMatch)&&be.labelMatch.length>0;if(ee&&!B)return-1;if(B&&!ee)return 1;const _=D(U,ne,J),pe=D(Y,be,J);return _&&pe&&_!==pe?pe>_?-1:1:P(U,Y,ie,J)}function D(U,Y,ie){let H=-1,J=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?H=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(H=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(J=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const x=ie.getItemDescription(U);x&&(J+=x.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(J=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return J-H}function C(U,Y){if(!U&&!Y||(!U||!U.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!U||!U.length)return 1;const ie=U[0].start,J=U[U.length-1].end-ie,x=Y[0].start,be=Y[Y.length-1].end-x;return J===be?0:be<J?1:-1}function P(U,Y,ie,H){const J=H.getItemLabel(U)||"",x=H.getItemLabel(Y)||"",ne=H.getItemDescription(U),be=H.getItemDescription(Y),ae=J.length+(ne?ne.length:0),Ie=x.length+(be?be.length:0);if(ae!==Ie)return ae-Ie;const ee=H.getItemPath(U),B=H.getItemPath(Y);return ee&&B&&ee.length!==B.length?ee.length-B.length:J!==x?(0,l.$ur)(J,x,ie.normalized):ne&&be&&ne!==be?(0,l.$ur)(ne,be,ie.normalized):ee&&B&&ee!==B?(0,l.$ur)(ee,B,ie.normalized):0}function j(U){return U.startsWith('"')&&U.endsWith('"')}const T=" ";function z(U){typeof U!="string"&&(U="");const Y=U.toLowerCase(),{pathNormalized:ie,normalized:H,normalizedLowercase:J}=N(U),x=ie.indexOf(M.sep)>=0,ne=j(U);let be;const ae=U.split(T);if(ae.length>1)for(const Ie of ae){const ee=j(Ie),{pathNormalized:B,normalized:_,normalizedLowercase:pe}=N(Ie);_&&(be||(be=[]),be.push({original:Ie,originalLowercase:Ie.toLowerCase(),pathNormalized:B,normalized:_,normalizedLowercase:pe,expectContiguousMatch:ee}))}return{original:U,originalLowercase:Y,pathNormalized:ie,normalized:H,normalizedLowercase:J,values:be,containsPathSeparator:x,expectContiguousMatch:ne}}function N(U){let Y;R.$i?Y=U.replace(/\//g,M.sep):Y=U.replace(/\\/g,M.sep);const ie=(0,b.$jf)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:ie,normalizedLowercase:ie.toLowerCase()}}function F(U){return Array.isArray(U)?z(U.map(Y=>Y.original).join(T)):z(U.original)}}),define(ke[101],De([1,0,16]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0,e.$Us=M,e.$Vs=R,e.$Ws=b,e.$Xs=E,e.$Ts=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const I=(0,l.$oc)(A),p=L[I.toLowerCase()];return p!==void 0?p:R(A)}function R(A){const I=(0,l.$oc)(A);return O[I.toLowerCase()]}function b(A){for(const I in O)if(O[I]===A)return I}const $=/^(.+)\/(.+?)(;.+)?$/;function E(A,I){const p=$.exec(A);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:A}}),define(ke[102],De([1,0,12]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=M,e.$pm=R;var L;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(L||(e.Source=L={}));var O;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function M(b,...$){const E=$.reduce((p,S)=>(p[S]=!0,p),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!E[p]).forEach(p=>{for(let S=0;S<A.length;S++)if(p.search(A[S])!==-1){delete b[p];break}})}function R(b){b&&(delete b.DEBUG,l.$j&&delete b.DYLD_LIBRARY_PATH,l.$k&&delete b.LD_PRELOAD)}}),define(ke[2],De([1,0,16,12]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=v,e.$wc=a;const O=/^\w[\w\d+.-]*$/,M=/^\//,R=/^\/\//;function b(o,f){if(!o.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!O.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!M.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(o,f){return!o&&!f?"file":o}function E(o,f){switch(o){case"https":case"http":case"file":f?f[0]!==I&&(f=I+f):f=I;break}return f}const A="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(f){return f instanceof S?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,g,w,k,m,y=!1){typeof f=="object"?(this.scheme=f.scheme||A,this.authority=f.authority||A,this.path=f.path||A,this.query=f.query||A,this.fragment=f.fragment||A):(this.scheme=$(f,y),this.authority=g||A,this.path=E(this.scheme,w||A),this.query=k||A,this.fragment=m||A,b(this,y))}get fsPath(){return a(this,!1)}with(f){if(!f)return this;let{scheme:g,authority:w,path:k,query:m,fragment:y}=f;return g===void 0?g=this.scheme:g===null&&(g=A),w===void 0?w=this.authority:w===null&&(w=A),k===void 0?k=this.path:k===null&&(k=A),m===void 0?m=this.query:m===null&&(m=A),y===void 0?y=this.fragment:y===null&&(y=A),g===this.scheme&&w===this.authority&&k===this.path&&m===this.query&&y===this.fragment?this:new d(g,w,k,m,y)}static parse(f,g=!1){const w=p.exec(f);return w?new d(w[2]||A,r(w[4]||A),r(w[5]||A),r(w[7]||A),r(w[9]||A),g):new d(A,A,A,A,A)}static file(f){let g=A;if(L.$i&&(f=f.replace(/\\/g,I)),f[0]===I&&f[1]===I){const w=f.indexOf(I,2);w===-1?(g=f.substring(2),f=I):(g=f.substring(2,w),f=f.substring(w)||I)}return new d("file",g,f,A,A)}static from(f,g){return new d(f.scheme,f.authority,f.path,f.query,f.fragment,g)}static joinPath(f,...g){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return L.$i&&f.scheme==="file"?w=S.file(l.$fc.join(a(f,!0),...g)).path:w=l.$gc.join(f.path,...g),f.with({path:w})}toString(f=!1){return s(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof S)return f;{const g=new d(f);return g._formatted=f.external??null,g._fsPath=f._sep===h?f.fsPath??null:null,g}}else return f}}e.URI=S;function v(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const h=L.$i?1:void 0;class d extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(f=!1){return f?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=h),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(o,f,g){let w,k=-1;for(let m=0;m<o.length;m++){const y=o.charCodeAt(m);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||f&&y===47||g&&y===91||g&&y===93||g&&y===58)k!==-1&&(w+=encodeURIComponent(o.substring(k,m)),k=-1),w!==void 0&&(w+=o.charAt(m));else{w===void 0&&(w=o.substr(0,m));const D=c[y];D!==void 0?(k!==-1&&(w+=encodeURIComponent(o.substring(k,m)),k=-1),w+=D):k===-1&&(k=m)}}return k!==-1&&(w+=encodeURIComponent(o.substring(k))),w!==void 0?w:o}function i(o){let f;for(let g=0;g<o.length;g++){const w=o.charCodeAt(g);w===35||w===63?(f===void 0&&(f=o.substr(0,g)),f+=c[w]):f!==void 0&&(f+=o[g])}return f!==void 0?f:o}function a(o,f){let g;return o.authority&&o.path.length>1&&o.scheme==="file"?g=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?f?g=o.path.substr(1):g=o.path[1].toLowerCase()+o.path.substr(2):g=o.path,L.$i&&(g=g.replace(/\//g,"\\")),g}function s(o,f){const g=f?i:n;let w="",{scheme:k,authority:m,path:y,query:D,fragment:C}=o;if(k&&(w+=k,w+=":"),(m||k==="file")&&(w+=I,w+=I),m){let P=m.indexOf("@");if(P!==-1){const j=m.substr(0,P);m=m.substr(P+1),P=j.lastIndexOf(":"),P===-1?w+=g(j,!1,!1):(w+=g(j.substr(0,P),!1,!1),w+=":",w+=g(j.substr(P+1),!1,!0)),w+="@"}m=m.toLowerCase(),P=m.lastIndexOf(":"),P===-1?w+=g(m,!1,!0):(w+=g(m.substr(0,P),!1,!0),w+=m.substr(P))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const P=y.charCodeAt(1);P>=65&&P<=90&&(y=`/${String.fromCharCode(P+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const P=y.charCodeAt(0);P>=65&&P<=90&&(y=`${String.fromCharCode(P+32)}:${y.substr(2)}`)}w+=g(y,!0,!1)}return D&&(w+="?",w+=g(D,!1,!1)),C&&(w+="#",w+=f?C:n(C,!1,!1)),w}function t(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+t(o.substr(3)):o}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(u)?o.replace(u,f=>t(f)):o}}),define(ke[197],De([1,0,2]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=L,e.$Zq=O,e.$1q=M,e.log=b;function L(E){const A=E;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function O(E){const A=[];let I;try{const p=JSON.parse(E.arguments),S=p[p.length-1];S&&S.__$stack&&(p.pop(),I=S.__$stack),A.push(...p)}catch{A.push("Unable to log remote console arguments",E.arguments)}return{args:A,stack:I}}function M(E){if(typeof E!="string")return M(O(E).stack);const A=E;if(A){const I=R(A),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:l.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function R(E){if(!E)return E;const A=E.indexOf(`
`);return A===-1?E:E.substring(0,A)}function b(E,A){const{args:I,stack:p}=O(E),S=typeof I[0]=="string"&&I.length===1;let v=R(p);v&&(v=`(${v.trim()})`);let h=[];if(typeof I[0]=="string"?v&&S?h=[`%c[${A}] %c${I[0]} %c${v}`,$("blue"),$(""),$("grey")]:h=[`%c[${A}] %c${I[0]}`,$("blue"),$(""),...I.slice(1)]:h=[`%c[${A}]%`,$("blue"),...I],v&&!S&&h.push(v),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}function $(E){return`color: ${E}`}}),define(ke[58],De([1,0,21,2]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=O,e.$7h=M,e.$8h=b;function O($){return JSON.stringify($,R)}function M($){let E=JSON.parse($);return E=b(E),E}function R($,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b($,E=0){if(!$||E>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return L.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof l.$He||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=b($[A],E+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=b($[A],E+1))}return $}}),define(ke[15],De([1,0,13,12,14,2,16]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=$,e.$Ig=E,e.$Mg=I;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(v,h){return M.URI.isUri(v)?(0,O.$zf)(v.scheme,h):(0,O.$Af)(v,h+":")}function E(v,...h){return h.some(d=>$(v,d))}e.$Jg="vscode-tkn",e.$Kg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,d){this.f=I(h,d)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,b.vscodeRemoteResource)}set(h,d,c){this.a[h]=d,this.b[h]=c}setConnectionToken(h,d){this.c[h]=d}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(s){return l.$1(s),h}const d=h.authority;let c=this.a[d];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const n=this.b[d],i=this.c[d];let a=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(a+=`&${e.$Kg}=${encodeURIComponent(i)}`),M.URI.from({scheme:L.$o?this.d:b.vscodeRemoteResource,authority:`${c}:${n}`,path:this.g,query:a})}}e.$Lg=new A;function I(v,h){return R.$gc.join(h??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class p{static{this.a=e.$Rg}asBrowserUri(h){const d=this.b(h,he);return this.uriToBrowserUri(d)}uriToBrowserUri(h){return h.scheme===b.vscodeRemote?e.$Lg.rewrite(h):h.scheme===b.file&&(L.$m||L.$q===`${b.vscodeFileResource}://${p.a}`)?h.with({scheme:b.vscodeFileResource,authority:h.authority||p.a,query:null,fragment:null}):h}asFileUri(h){const d=this.b(h,he);return this.uriToFileUri(d)}uriToFileUri(h){return h.scheme===b.vscodeFileResource?h.with({scheme:b.file,authority:h.authority!==p.a?h.authority:null,query:null,fragment:null}):h}b(h,d){return M.URI.isUri(h)?h:M.URI.parse(d.toUrl(h))}}e.$Sg=new p;var S;(function(v){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(h.get("3"));const d="vscode-coi";function c(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:M.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const s=a?.get(d);if(s)return h.get(s)}v.getHeadersFromQuery=c;function n(i,a,s){if(!globalThis.crossOriginIsolated)return;const t=a&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(d,t):i[d]=t}v.addSearchParam=n})(S||(e.COI=S={}))}),define(ke[198],De([1,0,163,15,12,2]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=A;class R{constructor(p,S,v){this.id=p,this.dependencies=S,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,S,v)=>{typeof p!="string"&&(v=S,S=p,p=null),(typeof S!="object"||!Array.isArray(S))&&(v=S,S=null),this.c.push(new R(p,S,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const S=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!S)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(p){return new Promise((S,v)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const d=()=>{h.removeEventListener("load",c),h.removeEventListener("error",n)},c=i=>{d(),S(this.c.pop())},n=i=>{d(),v(i)};h.addEventListener("load",c),h.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),h.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(p){return new Promise((S,v)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),S(this.c.pop())}catch(h){v(h)}})}async j(p){try{const S=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,d=M.URI.parse(p).fsPath,c=S.readFileSync(d).toString(),n=h.wrap(c.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const $=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function A(I,p,S){if(l.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[I]&&(I=E[I]);const v=`${I}/${p}`;if($.has(v))return $.get(v);let h;if(/^\w[\w\d+.-]*:\/\//.test(v))h=v;else{const i=`${S&&!O.$o?L.$Pg:L.$Og}/${v}`;h=L.$Sg.asBrowserUri(i).toString(!0)}const d=b.INSTANCE.load(h);return $.set(v,d),d}else return await new Promise((v,h)=>{he([I],v,h)})}}),define(ke[23],De([1,0,31,15,16,12,14,2]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=$,e.$ih=A,e.$jh=p;function $(S){return(0,b.$wc)(S,!0)}class E{constructor(v){this.a=v}compare(v,h,d=!1){return v===h?0:(0,R.$sf)(this.getComparisonKey(v,d),this.getComparisonKey(h,d))}isEqual(v,h,d=!1){return v===h?!0:!v||!h?!1:this.getComparisonKey(v,d)===this.getComparisonKey(h,d)}getComparisonKey(v,h=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,h,d=!1){if(v.scheme===h.scheme){if(v.scheme===L.Schemas.file)return l.$xg($(v),$(h),this.a(v))&&v.query===h.query&&(d||v.fragment===h.fragment);if((0,e.$eh)(v.authority,h.authority))return l.$xg(v.path,h.path,this.a(v),"/")&&v.query===h.query&&(d||v.fragment===h.fragment)}return!1}joinPath(v,...h){return b.URI.joinPath(v,...h)}basenameOrAuthority(v){return(0,e.$9g)(v)||v.authority}basename(v){return O.$gc.basename(v.path)}extname(v){return O.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let h;return v.scheme===L.Schemas.file?h=b.URI.file(O.$mc($(v))).path:(h=O.$gc.dirname(v.path),v.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),h="/")),v.with({path:h})}normalizePath(v){if(!v.path.length)return v;let h;return v.scheme===L.Schemas.file?h=b.URI.file(O.$hc($(v))).path:h=O.$gc.normalize(v.path),v.with({path:h})}relativePath(v,h){if(v.scheme!==h.scheme||!(0,e.$eh)(v.authority,h.authority))return;if(v.scheme===L.Schemas.file){const n=O.$lc($(v),$(h));return M.$i?l.$rg(n):n}let d=v.path||"/";const c=h.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(d.length,c.length);n<i&&!(d.charCodeAt(n)!==c.charCodeAt(n)&&d.charAt(n).toLowerCase()!==c.charAt(n).toLowerCase());n++);d=c.substr(0,n)+d.substr(n)}return O.$gc.relative(d,c)}resolvePath(v,h){if(v.scheme===L.Schemas.file){const d=b.URI.file(O.$kc($(v),h));return v.with({authority:d.authority,path:d.path})}return h=l.$sg(h),v.with({path:O.$gc.resolve(v.path,h)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,h){return v===h||v!==void 0&&h!==void 0&&(0,R.$zf)(v,h)}hasTrailingPathSeparator(v,h=O.sep){if(v.scheme===L.Schemas.file){const d=$(v);return d.length>l.$tg(d).length&&d[d.length-1]===h}else{const d=v.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,h=O.sep){return(0,e.$fh)(v,h)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,h=O.sep){let d=!1;if(v.scheme===L.Schemas.file){const c=$(v);d=c!==void 0&&c.length===l.$tg(c).length&&c[c.length-1]===h}else{h="/";const c=v.path;d=c.length===1&&c.charCodeAt(c.length-1)===47}return!d&&!(0,e.$fh)(v,h)?v.with({path:v.path+"/"}):v}}e.$1g=E,e.$2g=new E(()=>!1),e.$3g=new E(S=>S.scheme===L.Schemas.file?!M.$k:!0),e.$4g=new E(S=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function A(S,v){const h=[];for(let d=0;d<S.length;d++){const c=v(S[d]);S.some((n,i)=>i===d?!1:(0,e.$6g)(c,v(n)))||h.push(S[d])}return h}var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function v(h){const d=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,s]=i.split(":");a&&s&&d.set(a,s)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&d.set(S.META_DATA_MIME,n),d}S.parseMetaData=v})(I||(e.DataUri=I={}));function p(S,v,h){if(v){let d=S.path;return d&&d[0]!==O.$gc.sep&&(d=O.$gc.sep+d),S.with({scheme:h,authority:v,path:d})}return S.with({scheme:h})}}),define(ke[7],De([1,0,22,13,4,3,23,12,174,46]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=A,e.$lh=I,e.$mh=p,e.$nh=S,e.$oh=v,e.$ph=h,e.$qh=d,e.$rh=c,e.$zh=g,e.$Ah=w,e.$Bh=k,e.$Ch=m,e.$Dh=y,e.$Sh=J,e.$1h=ce;function A(le){return!!le&&typeof le.then=="function"}function I(le){const K=new l.$qe,se=le(K.token),$e=new Promise((ve,Me)=>{const ge=K.token.onCancellationRequested(()=>{ge.dispose(),Me(new L.$5)});Promise.resolve(se).then(Pe=>{ge.dispose(),K.dispose(),ve(Pe)},Pe=>{ge.dispose(),K.dispose(),Me(Pe)})});return new class{cancel(){K.cancel(),K.dispose()}then(ve,Me){return $e.then(ve,Me)}catch(ve){return this.then(void 0,ve)}finally(ve){return $e.finally(ve)}}}function p(le,K,se){return new Promise(($e,ve)=>{const Me=K.onCancellationRequested(()=>{Me.dispose(),$e(se)});le.then($e,ve).finally(()=>Me.dispose())})}function S(le,K){return new Promise((se,$e)=>{const ve=K.onCancellationRequested(()=>{ve.dispose(),$e(new L.$5)});le.then(se,$e).finally(()=>ve.dispose())})}async function v(le){let K=-1;const se=le.map(($e,ve)=>$e.then(Me=>(K=ve,Me)));try{return await Promise.race(se)}finally{le.forEach(($e,ve)=>{ve!==K&&$e.cancel()})}}function h(le,K,se){let $e;const ve=setTimeout(()=>{$e?.(void 0),se?.()},K);return Promise.race([le.finally(()=>clearTimeout(ve)),new Promise(Me=>$e=Me)])}function d(le){return new Promise((K,se)=>{const $e=le();A($e)?$e.then(K,se):K($e)})}function c(){let le,K;return{promise:new Promise(($e,ve)=>{le=$e,K=ve}),resolve:le,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const se=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(se,se).then($e)})}return new Promise((se,$e)=>{this.b.then(se,$e)})}return this.a=K(),new Promise((se,$e)=>{this.a.then(ve=>{this.a=null,se(ve)},ve=>{this.a=null,$e(ve)})})}dispose(){this.f=!0}}e.$sh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$th=i;class a{constructor(){this.a=new Map}queue(K,se){const ve=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(K)===ve&&this.a.delete(K)});return this.a.set(K,ve),ve}}e.$uh=a;const s=(le,K)=>{let se=!0;const $e=setTimeout(()=>{se=!1,K()},le);return{isTriggered:()=>se,dispose:()=>{clearTimeout($e),se=!1}}},t=le=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,le())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class u{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,se=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((ve,Me)=>{this.d=ve,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=se===$.$ce?t($e):s(se,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=u;class r{constructor(K){this.a=new u(K),this.b=new n}trigger(K,se){return this.a.trigger(()=>this.b.queue(K),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=r;class o{constructor(){this.a=!1,this.b=new Promise((K,se)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=o;class f extends o{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$yh=f;function g(le,K){return K?new Promise((se,$e)=>{const ve=setTimeout(()=>{Me.dispose(),se()},le),Me=K.onCancellationRequested(()=>{clearTimeout(ve),Me.dispose(),$e(new L.$5)})}):I(se=>g(le,se))}function w(le,K=0,se){const $e=setTimeout(()=>{le(),se&&ve.dispose()},K),ve=(0,M.$Sc)(()=>{clearTimeout($e),se?.deleteAndLeak(ve)});return se?.add(ve),ve}function k(le){const K=[];let se=0;const $e=le.length;function ve(){return se<$e?le[se++]():null}function Me(ge){ge!=null&&K.push(ge);const Pe=ve();return Pe?Pe.then(Me):Promise.resolve(K)}return Promise.resolve(null).then(Me)}function m(le,K=$e=>!!$e,se=null){let $e=0;const ve=le.length,Me=()=>{if($e>=ve)return Promise.resolve(se);const ge=le[$e++];return Promise.resolve(ge()).then(Ae=>K(Ae)?Promise.resolve(Ae):Me())};return Me()}function y(le,K=$e=>!!$e,se=null){if(le.length===0)return Promise.resolve(se);let $e=le.length;const ve=()=>{$e=-1;for(const Me of le)Me.cancel?.()};return new Promise((Me,ge)=>{for(const Pe of le)Pe.then(Ae=>{--$e>=0&&K(Ae)?(ve(),Me(Ae)):$e===0&&Me(se)}).catch(Ae=>{--$e>=0&&(ve(),ge(Ae))})})}class D{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new O.$fe}whenIdle(){return this.size>0?O.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,$e)=>{this.g.push({factory:K,c:se,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const se=K.factory();se.then(K.c,K.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=D;class C extends D{constructor(){super(1)}}e.$Fh=C;class P{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Gh=P;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ae;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,se=R.$2g){const $e=se.getComparisonKey(K);return this.a.get($e)?.size??0}queueFor(K,se,$e=R.$2g){const ve=$e.getComparisonKey(K);let Me=this.a.get(ve);if(!Me){Me=new C;const ge=this.f++,Pe=O.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(ve),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(ge,Pe),this.a.set(ve,Me)}return Me.queue(se)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=j;class T{constructor(K,se){this.a=-1,typeof K=="function"&&typeof se=="number"&&this.setIfNotSet(K,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},se)}setIfNotSet(K,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},se))}}e.$Ih=T;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,se,$e=globalThis){this.cancel();const ve=$e.setInterval(()=>{K()},se);this.d=(0,M.$Sc)(()=>{$e.clearInterval(ve),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=z;class N{constructor(K,se){this.b=-1,this.a=K,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=N;class F{constructor(K,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=K,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=F;class U extends N{constructor(K,se){super(K,se),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Mh=U;class Y extends M.$Uc{constructor(K,se){super(),this.g=K,this.h=se,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of K)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(le,K)=>{(0,b.$B)(()=>{if(se)return;const $e=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Ph=(le,K,se)=>{const $e=le.requestIdleCallback(K,typeof se=="number"?{timeout:se}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,le.cancelIdleCallback($e))}}},e.$Oh=le=>(0,e.$Ph)(globalThis,le)}();class ie{constructor(K,se){this.g=!1,this.d=()=>{try{this.j=se()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Ph)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=ie;class H extends ie{constructor(K){super(globalThis,K)}}e.$Rh=H;async function J(le,K,se){let $e;for(let ve=0;ve<se;ve++)try{return await le()}catch(Me){$e=Me,await g(K)}throw $e}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,se,$e){return this.a={taskId:K,cancel:()=>$e?.(),promise:se},se.then(()=>this.d(K),()=>this.d(K)),se}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:se,resolve:$e,reject:ve}=c();this.b={run:K,promise:se,promiseResolve:$e,promiseReject:ve}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=x;class ne{constructor(K,se=()=>Date.now()){this.d=K,this.f=se,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Uh=ne;var be;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(be||(be={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,se)=>{this.a=K,this.b=se})}complete(K){return new Promise(se=>{this.a(K),this.d={outcome:0,value:K},se()})}error(K){return new Promise(se=>{this.b(K),this.d={outcome:1,value:K},se()})}cancel(){return this.error(new L.$5)}}e.$Vh=ae;var Ie;(function(le){async function K($e){let ve;const Me=await Promise.all($e.map(ge=>ge.then(Pe=>Pe,Pe=>{ve||(ve=Pe)})));if(typeof ve<"u")throw ve;return Me}le.settled=K;function se($e){return new Promise(async(ve,Me)=>{try{await $e(ve,Me)}catch(ge){Me(ge)}})}le.withAsyncBody=se})(Ie||(e.Promises=Ie={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=ee;class B{constructor(K){this.b=K,this.a=new E.$V(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=B;var _;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(_||(_={}));class pe{static fromArray(K){return new pe(se=>{se.emitMany(K)})}static fromPromise(K){return new pe(async se=>{se.emitMany(await K)})}static fromPromises(K){return new pe(async se=>{await Promise.all(K.map(async $e=>se.emitOne(await $e)))})}static merge(K){return new pe(async se=>{await Promise.all(K.map(async $e=>{for await(const ve of $e)se.emitOne(ve)}))})}static{this.EMPTY=pe.fromArray([])}constructor(K,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new O.$fe,queueMicrotask(async()=>{const $e={emitOne:ve=>this.h(ve),emitMany:ve=>this.j(ve),reject:ve=>this.l(ve)};try{await Promise.resolve(K($e)),this.k()}catch(ve){this.l(ve)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,se){return new pe(async $e=>{for await(const ve of K)$e.emitOne(se(ve))})}map(K){return pe.map(this,K)}static filter(K,se){return new pe(async $e=>{for await(const ve of K)se(ve)&&$e.emitOne(ve)})}filter(K){return pe.filter(this,K)}static coalesce(K){return pe.filter(K,se=>!!se)}coalesce(){return pe.coalesce(this)}static async toPromise(K){const se=[];for await(const $e of K)se.push($e);return se}toPromise(){return pe.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Yh=pe;class ue extends pe{constructor(K,se){super(se),this.m=K}cancel(){this.m.cancel()}}e.$Zh=ue;function ce(le){const K=new l.$qe,se=le(K.token);return new ue(K,async $e=>{const ve=K.token.onCancellationRequested(()=>{ve.dispose(),K.dispose(),$e.reject(new L.$5)});try{for await(const Me of se){if(K.token.isCancellationRequested)return;$e.emitOne(Me)}ve.dispose(),K.dispose()}catch(Me){ve.dispose(),K.dispose(),$e.reject(Me)}})}class oe{constructor(K){this.a=new ae,this.b=new pe(ve=>{if(se){ve.reject(se);return}return $e&&ve.emitMany($e),this.d=Me=>ve.reject(Me),this.f=Me=>ve.emitOne(Me),this.a.p},K);let se,$e;this.f=ve=>{$e||($e=[]),$e.push(ve)},this.d=ve=>{se||(se=ve)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$2h=oe}),define(ke[35],De([1,0,19,7,31,27,16,12,14]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=E,e.$qk=v,e.$rk=C,e.$sk=P,e.$tk=j,e.$uk=T,e.$vk=z,e.$wk=Y;function E(){return Object.create(null)}e.$ok="**",e.$pk="/";const A="[/\\\\]",I="[^/\\\\]",p=/\//g;function S(ie,H){switch(ie){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${H?`|${A}${I}+`:""})*?`}}function v(ie,H){if(!ie)return[];const J=[];let x=!1,ne=!1,be="";for(const ae of ie){switch(ae){case H:if(!x&&!ne){J.push(be),be="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}be+=ae}return be&&J.push(be),J}function h(ie){if(!ie)return"";let H="";const J=v(ie,e.$pk);if(J.every(x=>x===e.$ok))H=".*";else{let x=!1;J.forEach((ne,be)=>{if(ne===e.$ok){if(x)return;H+=S(2,be===J.length-1)}else{let ae=!1,Ie="",ee=!1,B="";for(const _ of ne){if(_!=="}"&&ae){Ie+=_;continue}if(ee&&(_!=="]"||!B)){let pe;_==="-"?pe=_:(_==="^"||_==="!")&&!B?pe="^":_===e.$pk?pe="":pe=(0,$.$bf)(_),B+=pe;continue}switch(_){case"{":ae=!0;continue;case"[":ee=!0;continue;case"}":{const ue=`(?:${v(Ie,",").map(ce=>h(ce)).join("|")})`;H+=ue,ae=!1,Ie="";break}case"]":{H+="["+B+"]",ee=!1,B="";break}case"?":H+=I;continue;case"*":H+=S(1);continue;default:H+=(0,$.$bf)(_)}}be<J.length-1&&(J[be+1]!==e.$ok||be+2<J.length)&&(H+=A)}x=ne===e.$ok})}return H}const d=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),u=function(){return!1},r=function(){return null};function o(ie,H){if(!ie)return r;let J;typeof ie!="string"?J=ie.pattern:J=ie,J=J.trim();const x=`${J}_${!!H.trimForExclusions}`;let ne=t.get(x);if(ne)return f(ne,ie);let be;return d.test(J)?ne=w(J.substr(4),J):(be=c.exec(g(J,H)))?ne=k(be[1],J):(H.trimForExclusions?i:n).test(J)?ne=m(J,H):(be=a.exec(g(J,H)))?ne=y(be[1].substr(1),J,!0):(be=s.exec(g(J,H)))?ne=y(be[1],J,!1):ne=D(J),t.set(x,ne),f(ne,ie)}function f(ie,H){if(typeof H=="string")return ie;const J=function(x,ne){return(0,O.$xg)(x,H.base,!b.$k)?ie((0,$.$gf)(x.substr(H.base.length),R.sep),ne):null};return J.allBasenames=ie.allBasenames,J.allPaths=ie.allPaths,J.basenames=ie.basenames,J.patterns=ie.patterns,J}function g(ie,H){return H.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function w(ie,H){return function(J,x){return typeof J=="string"&&J.endsWith(ie)?H:null}}function k(ie,H){const J=`/${ie}`,x=`\\${ie}`,ne=function(ae,Ie){return typeof ae!="string"?null:Ie?Ie===ie?H:null:ae===ie||ae.endsWith(J)||ae.endsWith(x)?H:null},be=[ie];return ne.basenames=be,ne.patterns=[H],ne.allBasenames=be,ne}function m(ie,H){const J=U(ie.slice(1,-1).split(",").map(Ie=>o(Ie,H)).filter(Ie=>Ie!==r),ie),x=J.length;if(!x)return r;if(x===1)return J[0];const ne=function(Ie,ee){for(let B=0,_=J.length;B<_;B++)if(J[B](Ie,ee))return ie;return null},be=J.find(Ie=>!!Ie.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=J.reduce((Ie,ee)=>ee.allPaths?Ie.concat(ee.allPaths):Ie,[]);return ae.length&&(ne.allPaths=ae),ne}function y(ie,H,J){const x=R.sep===R.$gc.sep,ne=x?ie:ie.replace(p,R.sep),be=R.sep+ne,ae=R.$gc.sep+ie;let Ie;return J?Ie=function(ee,B){return typeof ee=="string"&&(ee===ne||ee.endsWith(be)||!x&&(ee===ie||ee.endsWith(ae)))?H:null}:Ie=function(ee,B){return typeof ee=="string"&&(ee===ne||!x&&ee===ie)?H:null},Ie.allPaths=[(J?"*/":"./")+ie],Ie}function D(ie){try{const H=new RegExp(`^${h(ie)}$`);return function(J){return H.lastIndex=0,typeof J=="string"&&H.test(J)?ie:null}}catch{return r}}function C(ie,H,J){return!ie||typeof H!="string"?!1:P(ie)(H,void 0,J)}function P(ie,H={}){if(!ie)return u;if(typeof ie=="string"||j(ie)){const J=o(ie,H);if(J===r)return u;const x=function(ne,be){return!!J(ne,be)};return J.allBasenames&&(x.allBasenames=J.allBasenames),J.allPaths&&(x.allPaths=J.allPaths),x}return N(ie,H)}function j(ie){const H=ie;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function T(ie){return ie.allBasenames||[]}function z(ie){return ie.allPaths||[]}function N(ie,H){const J=U(Object.getOwnPropertyNames(ie).map(Ie=>F(Ie,ie[Ie],H)).filter(Ie=>Ie!==r)),x=J.length;if(!x)return r;if(!J.some(Ie=>!!Ie.requiresSiblings)){if(x===1)return J[0];const Ie=function(_,pe){let ue;for(let ce=0,oe=J.length;ce<oe;ce++){const le=J[ce](_,pe);if(typeof le=="string")return le;(0,L.$kh)(le)&&(ue||(ue=[]),ue.push(le))}return ue?(async()=>{for(const ce of ue){const oe=await ce;if(typeof oe=="string")return oe}return null})():null},ee=J.find(_=>!!_.allBasenames);ee&&(Ie.allBasenames=ee.allBasenames);const B=J.reduce((_,pe)=>pe.allPaths?_.concat(pe.allPaths):_,[]);return B.length&&(Ie.allPaths=B),Ie}const ne=function(Ie,ee,B){let _,pe;for(let ue=0,ce=J.length;ue<ce;ue++){const oe=J[ue];oe.requiresSiblings&&B&&(ee||(ee=(0,R.$nc)(Ie)),_||(_=ee.substr(0,ee.length-(0,R.$oc)(Ie).length)));const le=oe(Ie,ee,_,B);if(typeof le=="string")return le;(0,L.$kh)(le)&&(pe||(pe=[]),pe.push(le))}return pe?(async()=>{for(const ue of pe){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},be=J.find(Ie=>!!Ie.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=J.reduce((Ie,ee)=>ee.allPaths?Ie.concat(ee.allPaths):Ie,[]);return ae.length&&(ne.allPaths=ae),ne}function F(ie,H,J){if(H===!1)return r;const x=o(ie,J);if(x===r)return r;if(typeof H=="boolean")return x;if(H){const ne=H.when;if(typeof ne=="string"){const be=(ae,Ie,ee,B)=>{if(!B||!x(ae,Ie))return null;const _=ne.replace("$(basename)",()=>ee),pe=B(_);return(0,L.$kh)(pe)?pe.then(ue=>ue?ie:null):pe?ie:null};return be.requiresSiblings=!0,be}}return x}function U(ie,H){const J=ie.filter(Ie=>!!Ie.basenames);if(J.length<2)return ie;const x=J.reduce((Ie,ee)=>{const B=ee.basenames;return B?Ie.concat(B):Ie},[]);let ne;if(H){ne=[];for(let Ie=0,ee=x.length;Ie<ee;Ie++)ne.push(H)}else ne=J.reduce((Ie,ee)=>{const B=ee.patterns;return B?Ie.concat(B):Ie},[]);const be=function(Ie,ee){if(typeof Ie!="string")return null;if(!ee){let _;for(_=Ie.length;_>0;_--){const pe=Ie.charCodeAt(_-1);if(pe===47||pe===92)break}ee=Ie.substr(_)}const B=x.indexOf(ee);return B!==-1?ne[B]:null};be.basenames=x,be.patterns=ne,be.allBasenames=x;const ae=ie.filter(Ie=>!Ie.basenames);return ae.push(be),ae}function Y(ie,H){return(0,l.$ub)(ie,H,(J,x)=>typeof J=="string"&&typeof x=="string"?J===x:typeof J!="string"&&typeof x!="string"?J.base===x.base&&J.pattern===x.pattern:!1)}}),define(ke[81],De([1,0,13,176,23,14,2]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.MarkdownStringTextNewlineStyle=void 0,e.$Wk=E,e.$Xk=A,e.$Yk=I,e.$Zk=p,e.$1k=S,e.$2k=v,e.$3k=h,e.$4k=d;var b;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,l.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=p(this.supportThemeIcons?(0,L.$Pk)(n):n).replace(/([ \t]+)/g,(a,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${S(i,n)}
`,this}appendLink(n,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(n,i){const a=new RegExp((0,M.$bf)(i),"g");return n.replace(a,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Vk=$;function E(c){return A(c)?!c.value:Array.isArray(c)?c.every(E):!0}function A(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function I(c,n){return c===n?!0:!c||!n?!1:c.value===n.value&&c.isTrusted===n.isTrusted&&c.supportThemeIcons===n.supportThemeIcons&&c.supportHtml===n.supportHtml&&(c.baseUri===n.baseUri||!!c.baseUri&&!!n.baseUri&&(0,O.$5g)(R.URI.from(c.baseUri),R.URI.from(n.baseUri)))}function p(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,n){const i=c.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${n}`,c,`${"`".repeat(a)}`].join(`
`)}function v(c){return c.replace(/"/g,"&quot;")}function h(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function d(c){const n=[],i=c.split("|").map(s=>s.trim());c=i[0];const a=i[1];if(a){const s=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),u=s?s[1]:"",r=t?t[1]:"",o=isFinite(parseInt(r)),f=isFinite(parseInt(u));o&&n.push(`width="${r}"`),f&&n.push(`height="${u}"`)}return{href:c,dimensions:n}}}),define(ke[103],De([1,0,19,31,16,12,23,14]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=$,e.$Hw=A,e.$Iw=p,e.$Jw=S,e.$Kw=c,e.$Lw=i,e.$Mw=a,e.$Nw=s,e.$Ow=t,e.$Pw=u;function $(o,f){const{os:g,tildify:w,relative:k}=f;if(k){const D=E(o,k,g);if(typeof D=="string")return D}let m=o.fsPath;if(g===1&&!M.$i?m=m.replace(/\//g,"\\"):g!==1&&M.$i&&(m=m.replace(/\\/g,"/")),g!==1&&w?.userHome){const D=w.userHome.fsPath;let C;o.scheme!==w.userHome.scheme&&o.path[0]===O.$gc.sep&&o.path[1]!==O.$gc.sep?C=w.userHome.with({path:o.path}).fsPath:C=m,m=p(C,D,g)}return(g===1?O.$fc:O.$gc).normalize(A(m,g===1))}function E(o,f,g){const w=g===1?O.$fc:O.$gc,k=g===3?R.$2g:R.$4g,m=f.getWorkspace(),y=(0,l.$Ob)(m.folders);if(!y)return;o.scheme!==y.uri.scheme&&o.path[0]===O.$gc.sep&&o.path[1]!==O.$gc.sep&&(o=y.uri.with({path:o.path}));const D=f.getWorkspaceFolder(o);if(!D)return;let C;if(k.isEqual(D.uri,o)?C="":C=k.relativePath(D.uri,o)??"",C&&(C=w.normalize(C)),m.folders.length>1&&!f.noPrefix){const P=D.name?D.name:k.basenameOrAuthority(D.uri);C=C?`${P} \u2022 ${C}`:P}return C}function A(o,f=M.$i){return(0,L.$Cg)(o,f)?o.charAt(0).toUpperCase()+o.slice(1):o}let I=Object.create(null);function p(o,f,g=M.OS){if(g===1||!o||!f)return o;let w=I.original===f?I.normalized:void 0;w||(w=f,M.$i&&(w=(0,L.$rg)(w)),w=`${(0,b.$hf)(w,O.$gc.sep)}${O.$gc.sep}`,I={original:f,normalized:w});let k=o;return M.$i&&(k=(0,L.$rg)(k)),(g===3?k.startsWith(w):(0,b.$Af)(k,w))?`~/${k.substr(w.length)}`:o}function S(o,f){return o.replace(/^~($|\/|\\)/,`${f}$1`)}const v="\u2026",h="\\\\",d="~";function c(o,f=O.sep){const g=new Array(o.length);let w=!1;for(let k=0;k<o.length;k++){const m=o[k];if(m===""){g[k]=`.${f}`;continue}if(!m){g[k]=m;continue}w=!0;let y="",D=m;D.indexOf(h)===0?(y=D.substr(0,D.indexOf(h)+h.length),D=D.substr(D.indexOf(h)+h.length)):D.indexOf(f)===0?(y=D.substr(0,D.indexOf(f)+f.length),D=D.substr(D.indexOf(f)+f.length)):D.indexOf(d)===0&&(y=D.substr(0,D.indexOf(d)+d.length),D=D.substr(D.indexOf(d)+d.length));const C=D.split(f);for(let P=1;w&&P<=C.length;P++)for(let j=C.length-P;w&&j>=0;j--){w=!1;let T=C.slice(j,j+P).join(f);for(let z=0;!w&&z<o.length;z++)if(z!==k&&o[z]&&o[z].indexOf(T)>-1){const N=j+P===C.length,F=j>0&&o[z].indexOf(f)>-1?f+T:T,U=o[z].endsWith(F);w=!N||U}if(!w){let z="";(C[0].endsWith(":")||y!=="")&&(j===1&&(j=0,P++,T=C[0]+f+T),j>0&&(z=C[0]+f),z=y+z),j>0&&(z=z+v+f),z=z+T,j+P<C.length&&(z=z+f+v),g[k]=z}}w&&(g[k]=m)}return g}var n;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(o,f=Object.create(null)){const g=[];let w=!1,k="";for(const m of o)if(m==="$"||w&&m==="{")k&&g.push({value:k,type:n.TEXT}),k="",w=!0;else if(m==="}"&&w){const y=f[k];if(typeof y=="string")y.length&&g.push({value:y,type:n.VARIABLE});else if(y){const D=g[g.length-1];(!D||D.type!==n.SEPARATOR)&&g.push({value:y.label,type:n.SEPARATOR})}k="",w=!1}else k+=m;return k&&!w&&g.push({value:k,type:n.TEXT}),g.filter((m,y)=>{if(m.type===n.SEPARATOR){const D=g[y-1],C=g[y+1];return[D,C].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(m=>m.value).join("")}function a(o,f){return M.$j||f?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):o.replace(/&&|&/g,g=>g==="&"?"&&":"&")}function s(o,f){return M.$j||f?o.replace(/\(&&\w\)|&&/g,""):M.$i?o.replace(/&&|&/g,g=>g==="&"?"&&":"&"):o.replace(/&&/g,"_")}function t(o){return o.replace(/&/g,"&&")}function u(o){if(o.endsWith("]")){const f=o.lastIndexOf(" [",o.length-2);if(f!==-1){const g=r(o.substring(0,f)),w=o.substring(f);return{name:g.name+w,parentPath:g.parentPath}}}return r(o)}function r(o){const f=o.indexOf("/")!==-1?O.$gc:O.$fc,g=f.basename(o),w=f.dirname(o);return g.length?{name:g,parentPath:w}:{name:w,parentPath:""}}}),define(ke[134],De([1,0,21,2]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=b,e.$Dn=E,e.$En=A;function O(I){return I.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const S=this.a.transformIncoming(p);return S===p?p:O(L.URI.from(S))}transformOutgoing(p){const S=this.a.transformOutgoing(p);return S===p?p:O(L.URI.from(S))}transformOutgoingURI(p){const S=this.a.transformOutgoing(p);return S===p?p:L.URI.from(S)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$An=M,e.$Bn=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,p,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof L.URI)return p.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const h=R(I[v],p,S+1);h!==null&&(I[v]=h)}}return null}function b(I,p){const S=R(I,p,0);return S===null?I:S}function $(I,p,S,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?L.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof l.$He)return null;for(const h in I)if(Object.hasOwnProperty.call(I,h)){const d=$(I[h],p,S,v+1);d!==null&&(I[h]=d)}}return null}function E(I,p){const S=$(I,p,!1,0);return S===null?I:S}function A(I,p){const S=$(I,p,!0,0);return S===null?I:S}}),define(ke[32],De([1,0,53,64,400,7,31,77,16,12,23,2]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=g,e.writeFileSync=k;var p;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function S(F,U=p.UNLINK,Y){if((0,R.$Bg)(F))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?h(F):v(F,Y)}async function v(F,U=(0,R.$Gg)((0,L.tmpdir)())){try{try{await l.promises.rename(F,U)}catch(Y){return Y.code==="ENOENT"?void 0:h(F)}h(U).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function h(F){return(0,O.promisify)(l.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function d(F){if((0,R.$Bg)(F))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function c(F,U){return a(await(U?n(F):(0,O.promisify)(l.readdir)(F)))}async function n(F){try{return await(0,O.promisify)(l.readdir)(F,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const U=[],Y=await c(F);for(const ie of Y){let H=!1,J=!1,x=!1;try{const ne=await e.Promises.lstat((0,$.$jc)(F,ie));H=ne.isFile(),J=ne.isDirectory(),x=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}U.push({name:ie,isFile:()=>H,isDirectory:()=>J,isSymbolicLink:()=>x})}return U}function i(F){return a(l.readdirSync(F))}function a(F){return F.map(U=>typeof U=="string"?E.$j?(0,b.$dm)(U):U:(U.name=E.$j?(0,b.$dm)(U.name):U.name,U))}async function s(F){const U=await c(F),Y=[];for(const ie of U)await u.existsDirectory((0,$.$jc)(F,ie))&&Y.push(ie);return Y}function t(F,U=1e3){return new Promise(Y=>{let ie=!1;const H=setInterval(()=>{ie||(ie=!0,l.access(F,J=>{ie=!1,J&&(clearInterval(H),Y(void 0))}))},U)})}var u;(function(F){async function U(H){let J;try{if(J=await e.Promises.lstat(H),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(E.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ne}throw x}}F.stat=U;async function Y(H){try{const{stat:J,symbolicLink:x}=await F.stat(H);return J.isFile()&&x?.dangling!==!0}catch{}return!1}F.existsFile=Y;async function ie(H){try{const{stat:J,symbolicLink:x}=await F.stat(H);return J.isDirectory()&&x?.dangling!==!0}catch{}return!1}F.existsDirectory=ie})(u||(e.SymlinkSupport=u={}));const r=new M.$Hh;function o(F,U,Y){return r.queueFor(I.URI.file(F),()=>{const ie=m(Y);return new Promise((H,J)=>w(F,U,ie,x=>x?J(x):H()))},A.$3g)}let f=!0;function g(F){f=F}function w(F,U,Y,ie){if(!f)return l.writeFile(F,U,{mode:Y.mode,flag:Y.flag},ie);l.open(F,Y.flag,Y.mode,(H,J)=>{if(H)return ie(H);l.writeFile(J,U,x=>{if(x)return l.close(J,()=>ie(x));l.fdatasync(J,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),g(!1)),l.close(J,be=>ie(be))))})})}function k(F,U,Y){const ie=m(Y);if(!f)return l.writeFileSync(F,U,{mode:ie.mode,flag:ie.flag});const H=l.openSync(F,ie.flag,ie.mode);try{l.writeFileSync(H,U);try{l.fdatasyncSync(H)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),g(!1)}}finally{l.closeSync(H)}}function m(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function y(F,U,Y=6e4){if(F!==U)try{E.$i&&typeof Y=="number"?await D(F,U,Date.now(),Y):await(0,O.promisify)(l.rename)(F,U)}catch(ie){if(F.toLowerCase()!==U.toLowerCase()&&ie.code==="EXDEV"||F.endsWith("."))await C(F,U,{preserveSymlinks:!1}),await S(F,p.MOVE);else throw ie}}async function D(F,U,Y,ie,H=0){try{return await(0,O.promisify)(l.rename)(F,U)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-Y>=ie)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${J}`),J;if(H===0){let x=!1;try{const{stat:ne}=await u.stat(U);ne.isFile()||(x=!0)}catch{}if(x)throw J}return await(0,M.$zh)(Math.min(100,H*10)),D(F,U,Y,ie,H+1)}}async function C(F,U,Y){return j(F,U,{root:{source:F,target:U},options:Y,handledSourcePaths:new Set})}const P=511;async function j(F,U,Y){if(Y.handledSourcePaths.has(F))return;Y.handledSourcePaths.add(F);const{stat:ie,symbolicLink:H}=await u.stat(F);if(H){if(Y.options.preserveSymlinks)try{return await N(F,U,Y)}catch{}if(H.dangling)return}return ie.isDirectory()?T(F,U,ie.mode&P,Y):z(F,U,ie.mode&P)}async function T(F,U,Y,ie){await e.Promises.mkdir(U,{recursive:!0,mode:Y});const H=await c(F);for(const J of H)await j((0,$.$jc)(F,J),(0,$.$jc)(U,J),ie)}async function z(F,U,Y){await e.Promises.copyFile(F,U),await e.Promises.chmod(U,Y)}async function N(F,U,Y){let ie=await e.Promises.readlink(F);(0,R.$xg)(ie,Y.root.source,!E.$k)&&(ie=(0,$.$jc)(Y.root.target,ie.substr(Y.root.source.length+1))),await e.Promises.symlink(ie,U)}e.Promises=new class{get access(){return(0,O.promisify)(l.access)}get stat(){return(0,O.promisify)(l.stat)}get lstat(){return(0,O.promisify)(l.lstat)}get utimes(){return(0,O.promisify)(l.utimes)}get read(){return(F,U,Y,ie,H)=>new Promise((J,x)=>{l.read(F,U,Y,ie,H,(ne,be,ae)=>ne?x(ne):J({bytesRead:be,buffer:ae}))})}get readFile(){return(0,O.promisify)(l.readFile)}get write(){return(F,U,Y,ie,H)=>new Promise((J,x)=>{l.write(F,U,Y,ie,H,(ne,be,ae)=>ne?x(ne):J({bytesWritten:be,buffer:ae}))})}get appendFile(){return(0,O.promisify)(l.appendFile)}get fdatasync(){return(0,O.promisify)(l.fdatasync)}get truncate(){return(0,O.promisify)(l.truncate)}get copyFile(){return(0,O.promisify)(l.copyFile)}get open(){return(0,O.promisify)(l.open)}get close(){return(0,O.promisify)(l.close)}get symlink(){return(0,O.promisify)(l.symlink)}get readlink(){return(0,O.promisify)(l.readlink)}get chmod(){return(0,O.promisify)(l.chmod)}get mkdir(){return(0,O.promisify)(l.mkdir)}get unlink(){return(0,O.promisify)(l.unlink)}get rmdir(){return(0,O.promisify)(l.rmdir)}get realpath(){return(0,O.promisify)(l.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return s}get writeFile(){return o}get rm(){return S}get rename(){return y}get copy(){return C}}}),define(ke[104],De([1,0,53,16,12,14,32]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=b,e.$8q=$,e.$9q=E,e.$0q=A;function b(p){if(O.$k)return p;const S=(0,L.$mc)(p);if(p===S)return p;const v=((0,L.$nc)(p)||p).toLowerCase();try{const d=(0,R.readdirSync)(S).filter(c=>c.toLowerCase()===v);if(d.length===1){const c=b(S);if(c)return(0,L.$jc)(c,d[0])}else if(d.length>1){const c=d.indexOf(v);if(c>=0){const n=b(S);if(n)return(0,L.$jc)(n,d[c])}}}catch{}return null}async function $(p,S){if(O.$k)return p;const v=(0,L.$mc)(p);if(p===v)return p;const h=((0,L.$nc)(p)||p).toLowerCase();try{if(S?.isCancellationRequested)return null;const c=(await R.Promises.readdir(v)).filter(n=>n.toLowerCase()===h);if(c.length===1){const n=await $(v,S);if(n)return(0,L.$jc)(n,c[0])}else if(c.length>1){const n=c.indexOf(h);if(n>=0){const i=await $(v,S);if(i)return(0,L.$jc)(i,c[n])}}}catch{}return null}async function E(p){try{return await R.Promises.realpath(p)}catch{const v=I(p);return await R.Promises.access(v,l.constants.R_OK),v}}function A(p){try{return l.realpathSync(p)}catch{const v=I(p);return l.accessSync(v,l.constants.R_OK),v}}function I(p){return(0,M.$hf)((0,L.$hc)(p),L.sep)}}),define(ke[105],De([1,0,16,12,52,102,18,32]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=$,e.$rm=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function $(I=O.env){return I.comspec||"cmd.exe"}function E(I){let p=[],S=!1;const v=function(h){if(S){p.push(h);return}(!I.send(h,c=>{if(c&&console.error(c),S=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(i=>v(i))}})||L.$i)&&(S=!0)};return{send:v}}var A;(function(I){async function p(S,v,h){if(l.$ic(S))return S;if(v===void 0&&(v=O.cwd()),l.$mc(S)!=="."||(h===void 0&&R.$$f(O.env.PATH)&&(h=O.env.PATH.split(l.$tc)),h===void 0||h.length===0))return l.$jc(v,S);async function c(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(a){a.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(l.$ic(n)?i=l.$jc(n,S):i=l.$jc(v,n,S),await c(i))return i;let a=i+".com";if(await c(a)||(a=i+".exe",await c(a)))return a}return l.$jc(v,S)}I.findExecutable=p})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(he,e,l,L){var O=arguments.length,M=O<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,l):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(he,e,l,L);else for(var b=he.length-1;b>=0;b--)(R=he[b])&&(M=(O<3?R(M):O>3?R(e,l,M):R(e,l))||M);return O>3&&M&&Object.defineProperty(e,l,M),M};define(ke[82],De([1,0,19,7,21,22,56,13,4,3,58,14,18]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=g,e.$_h=w,e.$ei=P,e.$fi=j;var S;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(S||(S={}));function v(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(h||(h={}));function d(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(c||(c={}));function n(H){let J=0;for(let x=0;;x+=7){const ne=H.read(1);if(J|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return J}}const i=r(0);function a(H,J){if(J===0){H.write(i);return}let x=0;for(let be=J;be!==0;be=be>>>7)x++;const ne=O.$He.alloc(x);for(let be=0;J!==0;be++)ne.buffer[be]=J&127,J=J>>>7,J>0&&(ne.buffer[be]|=128);H.write(ne)}class s{constructor(J){this.b=J,this.a=0}read(J){const x=this.b.slice(this.a,this.a+J);return this.a+=x.byteLength,x}}e.$9h=s;class t{constructor(){this.a=[]}get buffer(){return O.$He.concat(this.a)}write(J){this.a.push(J)}}e.$0h=t;var u;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(u||(u={}));function r(H){const J=O.$He.alloc(1);return J.writeUInt8(H,0),J}const o={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object),Uint:r(u.Int)},f=typeof Buffer<"u";function g(H,J){if(typeof J>"u")H.write(o.Undefined);else if(typeof J=="string"){const x=O.$He.fromString(J);H.write(o.String),a(H,x.byteLength),H.write(x)}else if(f&&Buffer.isBuffer(J)){const x=O.$He.wrap(J);H.write(o.Buffer),a(H,x.byteLength),H.write(x)}else if(J instanceof O.$He)H.write(o.VSBuffer),a(H,J.byteLength),H.write(J);else if(Array.isArray(J)){H.write(o.Array),a(H,J.length);for(const x of J)g(H,x)}else if(typeof J=="number"&&(J|0)===J)H.write(o.Uint),a(H,J);else{const x=O.$He.fromString(JSON.stringify(J));H.write(o.Object),a(H,x.byteLength),H.write(x)}}function w(H){switch(H.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return H.read(n(H)).toString();case u.Buffer:return H.read(n(H)).buffer;case u.VSBuffer:return H.read(n(H));case u.Array:{const x=n(H),ne=[];for(let be=0;be<x;be++)ne.push(w(H));return ne}case u.Object:return JSON.parse(H.read(n(H)).toString());case u.Int:return n(H)}}class k{constructor(J,x,ne=null,be=1e3){this.h=J,this.j=x,this.k=ne,this.l=be,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(J,x){this.b.set(J,x),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const x=this.o([J.type]);this.k?.logOutgoing(x,0,1,d(J.type));return}case 201:case 202:case 204:case 203:{const x=this.o([J.type,J.id],J.data);this.k?.logOutgoing(x,J.id,1,d(J.type),J.data);return}}}o(J,x=void 0){const ne=new t;return g(ne,J),g(ne,x),this.p(ne.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const x=new s(J),ne=w(x),be=w(x),ae=ne[0];switch(ae){case 100:return this.k?.logIncoming(J.byteLength,ne[1],1,`${v(ae)}: ${ne[2]}.${ne[3]}`,be),this.s({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 102:return this.k?.logIncoming(J.byteLength,ne[1],1,`${v(ae)}: ${ne[2]}.${ne[3]}`,be),this.t({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 101:return this.k?.logIncoming(J.byteLength,ne[1],1,`${v(ae)}`),this.u({type:ae,id:ne[1]});case 103:return this.k?.logIncoming(J.byteLength,ne[1],1,`${v(ae)}`),this.u({type:ae,id:ne[1]})}}s(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ne=new M.$qe;let be;try{be=x.call(this.j,J.name,J.arg,ne.token)}catch(ee){be=Promise.reject(ee)}const ae=J.id;be.then(ee=>{this.m({id:ae,data:ee,type:201})},ee=>{ee instanceof Error?this.m({id:ae,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:ae,data:ee,type:203})}).finally(()=>{Ie.dispose(),this.d.delete(J.id)});const Ie=(0,E.$Sc)(()=>ne.cancel());this.d.set(J.id,Ie)}t(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ne=J.id,ae=x.listen(this.j,J.name,J.arg)(Ie=>this.m({id:ne,data:Ie,type:204}));this.d.set(J.id,ae)}u(J){const x=this.d.get(J.id);x&&(x.dispose(),this.d.delete(J.id))}v(J){let x=this.g.get(J.channelName);x||(x=[],this.g.set(J.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:J,timeoutTimer:ne})}w(J){const x=this.g.get(J);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$ai=k;var m;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class y{constructor(J,x=null){this.l=J,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(J){const x=this;return{call(ne,be,ae){return x.a?Promise.reject(new b.$5):x.m(J,ne,be,ae)},listen(ne,be){return x.a?$.Event.None:x.o(J,ne,be)}}}m(J,x,ne,be=M.CancellationToken.None){const ae=this.g++,ee={id:ae,type:100,channelName:J,name:x,arg:ne};if(be.isCancellationRequested)return Promise.reject(new b.$5);let B;return new Promise((pe,ue)=>{if(be.isCancellationRequested)return ue(new b.$5);const ce=()=>{const se=$e=>{switch($e.type){case 201:this.f.delete(ae),pe($e.data);break;case 202:{this.f.delete(ae);const ve=new Error($e.data.message);ve.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,ve.name=$e.data.name,ue(ve);break}case 203:this.f.delete(ae),ue($e.data);break}};this.f.set(ae,se),this.p(ee)};let oe=null;this.b===c.Idle?ce():(oe=(0,L.$lh)(se=>this.u()),oe.then(()=>{oe=null,ce()}));const le=()=>{oe?(oe.cancel(),oe=null):this.p({id:ae,type:101}),ue(new b.$5)},K=be.onCancellationRequested(le);B=(0,E.$Rc)((0,E.$Sc)(le),K),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(J,x,ne){const be=this.g++,Ie={id:be,type:102,channelName:J,name:x,arg:ne};let ee=null;const B=new $.$fe({onWillAddFirstListener:()=>{ee=(0,L.$lh)(pe=>this.u()),ee.then(()=>{ee=null,this.d.add(B),this.p(Ie)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(B),this.p({id:be,type:103}))}}),_=pe=>B.fire(pe.data);return this.f.set(be,_),B.event}p(J){switch(J.type){case 100:case 102:{const x=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(x,J.id,0,`${v(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const x=this.q([J.type,J.id]);this.j?.logOutgoing(x,J.id,0,v(J.type));return}}}q(J,x=void 0){const ne=new t;return g(ne,J),g(ne,x),this.r(ne.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const x=new s(J),ne=w(x),be=w(x),ae=ne[0];switch(ae){case 200:return this.j?.logIncoming(J.byteLength,0,0,d(ae)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,ne[1],0,d(ae),be),this.t({type:ne[0],id:ne[1],data:be})}}t(J){if(J.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$bi=y,Je([R.$3h],y.prototype,"onDidInitializePromise",null);class D{get connections(){const J=[];return this.f.forEach(x=>J.push(x)),J}constructor(J,x,ne){this.a=new Map,this.f=new Set,this.g=new $.$fe,this.onDidAddConnection=this.g.event,this.h=new $.$fe,this.onDidRemoveConnection=this.h.event,this.j=new E.$Tc,this.j.add(J(({protocol:be,onDidClientDisconnect:ae})=>{const Ie=$.Event.once(be.onMessage);this.j.add(Ie(ee=>{const B=new s(ee),_=w(B),pe=new k(be,_,x,ne),ue=new y(be,x);this.a.forEach((oe,le)=>pe.registerChannel(le,oe));const ce={channelServer:pe,channelClient:ue,ctx:_};this.f.add(ce),this.g.fire(ce),this.j.add(ae(()=>{pe.dispose(),ue.dispose(),this.f.delete(ce),this.h.fire(ce)}))}))}))}getChannel(J,x){const ne=this;return{call(be,ae,Ie){let ee;if((0,p.$mg)(x)){const _=(0,l.$3b)(ne.connections.filter(x));ee=_?Promise.resolve(_):$.Event.toPromise($.Event.filter(ne.onDidAddConnection,x))}else ee=x.routeCall(ne,be,ae);const B=ee.then(_=>_.channelClient.getChannel(J));return P(B).call(be,ae,Ie)},listen(be,ae){if((0,p.$mg)(x))return ne.k(J,x,be,ae);const Ie=x.routeEvent(ne,be,ae).then(ee=>ee.channelClient.getChannel(J));return P(Ie).listen(be,ae)}}}k(J,x,ne,be){const ae=this;let Ie;const ee=new $.$fe({onWillAddFirstListener:()=>{Ie=new E.$Tc;const B=new $.$le,_=new Map,pe=ce=>{const le=ce.channelClient.getChannel(J).listen(ne,be),K=B.add(le);_.set(ce,K)},ue=ce=>{const oe=_.get(ce);oe&&(oe.dispose(),_.delete(ce))};ae.connections.filter(x).forEach(pe),$.Event.filter(ae.onDidAddConnection,x)(pe,void 0,Ie),ae.onDidRemoveConnection(ue,void 0,Ie),B.event(ee.fire,ee,Ie),Ie.add(B)},onDidRemoveLastListener:()=>{Ie?.dispose(),Ie=void 0}});return ee.event}registerChannel(J,x){this.a.set(J,x);for(const ne of this.f)ne.channelServer.registerChannel(J,x)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=D;class C{constructor(J,x,ne=null){const be=new t;g(be,x),J.send(be.buffer),this.a=new y(J,ne),this.d=new k(J,x,ne)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,x){this.d.registerChannel(J,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=C;function P(H){return{call(J,x,ne){return H.then(be=>be.call(J,x,ne))},listen(J,x){const ne=new $.$oe;return H.then(be=>ne.input=be.listen(J,x)),ne.event}}}function j(H){let J=!1;return{call(x,ne,be){return J?H.call(x,ne,be):(0,L.$zh)(0).then(()=>J=!0).then(()=>H.call(x,ne,be))},listen(x,ne){if(J)return H.listen(x,ne);const be=new $.$oe;return(0,L.$zh)(0).then(()=>J=!0).then(()=>be.input=H.listen(x,ne)),be.event}}}class T{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const x of J.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$gi=T;var z;(function(H){function J(ae,Ie,ee){const B=ae,_=ee&&ee.disableMarshalling,pe=new Map;for(const ue in B)ne(ue)&&pe.set(ue,$.Event.buffer(B[ue],!0,void 0,Ie));return new class{listen(ue,ce,oe){const le=pe.get(ce);if(le)return le;const K=B[ce];if(typeof K=="function"){if(be(ce))return K.call(B,oe);if(ne(ce))return pe.set(ce,$.Event.buffer(B[ce],!0,void 0,Ie)),pe.get(ce)}throw new b.$bb(`Event not found: ${ce}`)}call(ue,ce,oe){const le=B[ce];if(typeof le=="function"){if(!_&&Array.isArray(oe))for(let se=0;se<oe.length;se++)oe[se]=(0,A.$8h)(oe[se]);let K=le.apply(B,oe);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${ce}`)}}}H.fromService=J;function x(ae,Ie){const ee=Ie&&Ie.disableMarshalling;return new Proxy({},{get(B,_){if(typeof _=="string")return Ie?.properties?.has(_)?Ie.properties.get(_):be(_)?function(pe){return ae.listen(_,pe)}:ne(_)?ae.listen(_):async function(...pe){let ue;Ie&&!(0,p.$hg)(Ie.context)?ue=[Ie.context,...pe]:ue=pe;const ce=await ae.call(_,ue);return ee?ce:(0,A.$8h)(ce)};throw new b.$bb(`Property not found: ${String(_)}`)}})}H.toService=x;function ne(ae){return ae[0]==="o"&&ae[1]==="n"&&I.$yf(ae.charCodeAt(2))}function be(ae){return/^onDynamic/.test(ae)&&I.$yf(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const J=H.toString();if(J!=="[object Object]")return J}return H}function U(H){return Array.isArray(H)?H.map(F):F(H)}function Y(H,J,x,ne,be,ae,Ie){Ie=U(Ie);const ee=N[be],B=ee[ne%ee.length];let _=[`%c[${H}]%c[${String(J).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ae)?(_=_.concat(Ie),_.push(")")):_.push(Ie),console.log.apply(console,_)}class ie{constructor(J,x){this.d=J,this.f=x,this.a=0,this.b=0}logOutgoing(J,x,ne,be,ae){this.b+=J,Y(this.d,this.b,J,x,ne,be,ae)}logIncoming(J,x,ne,be,ae){this.a+=J,Y(this.f,this.a,J,x,ne,be,ae)}}e.$hi=ie}),define(ke[83],De([1,0,21,4,3,82]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.ProtocolConstants=e.$ii=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(o){o.enableDiagnostics=!1,o.records=[];const f=new WeakMap;let g=0;function w(m,y){if(!f.has(m)){const D=String(++g);f.set(m,D)}return f.get(m)}function k(m,y,D,C){if(!o.enableDiagnostics)return;const P=w(m,y);if(C instanceof l.$He||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const j=l.$He.alloc(C.byteLength);j.set(C),o.records.push({timestamp:Date.now(),id:P,label:y,type:D,buff:j})}else o.records.push({timestamp:Date.now(),id:P,label:y,type:D,data:C})}o.traceSocketEvent=k})(b||(e.SocketDiagnostics=b={}));var $;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let E=null;function A(){return E||(E=l.$He.alloc(0)),E}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(f){this.a.push(f),this.b+=f.byteLength}read(f){return this.c(f,!0)}peek(f){return this.c(f,!1)}c(f,g){if(f===0)return A();if(f>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===f){const y=this.a[0];return g&&(this.a.shift(),this.b-=f),y}if(this.a[0].byteLength>f){const y=this.a[0].slice(0,f);return g&&(this.a[0]=this.a[0].slice(f),this.b-=f),y}const w=l.$He.alloc(f);let k=0,m=0;for(;f>0;){const y=this.a[m];if(y.byteLength>f){const D=y.slice(0,f);w.set(D,k),k+=f,g&&(this.a[m]=y.slice(f),this.b-=f),f-=f}else w.set(y,k),k+=y.byteLength,g?(this.a.shift(),this.b-=y.byteLength):m++,f-=y.byteLength}return w}}e.$ii=I;var p;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(p||(p={}));function S(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",o[o.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class h{constructor(f,g,w,k){this.type=f,this.id=g,this.ack=w,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends O.$Uc{constructor(f){super(),this.f=this.B(new L.$fe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=f,this.b=!1,this.c=new I,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(f){if(!(!f||f.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(f);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,k=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new h(w,k,m,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(f){this.k=null,this.a=!1,this.b=!1,this.c=f,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(f){if(this.a)return;f.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=l.$He.alloc(13);g.writeUInt8(f.type,0),g.writeUInt32BE(f.id,1),g.writeUInt32BE(f.ack,5),g.writeUInt32BE(f.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(f.type),id:f.id,ack:f.ack,messageSize:f.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",f.data),this.j(g,f.data)}g(f,g){const w=this.f===0;return this.d.push(f,g),this.f+=f.byteLength+g.byteLength,w}h(){const f=l.$He.concat(this.d,this.f);return this.d.length=0,this.f=0,f}j(f,g){this.g(f,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const f=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:f.byteLength}),this.c.write(f)}}class n extends O.$Uc{constructor(f){super(),this.f=new L.$fe,this.onMessage=this.f.event,this.g=new L.$fe,this.onDidDispose=this.g.event,this.a=f,this.b=this.B(new c(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(f){this.b.write(new h(1,0,0,f))}}e.$ji=n;class i extends M.$di{static fromSocket(f,g){return new i(new n(f),g)}get onDidDispose(){return this.b.onDidDispose}constructor(f,g,w=null){super(f,g,w),this.b=f}dispose(){super.dispose();const f=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),f.end()}}e.$ki=i;class a{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$fe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(f){this.b?this.d.length>0?this.d.push(f):this.a.fire(f):this.d.push(f)}flushBuffer(){this.d=[]}}e.$li=a;class s{constructor(f){this.data=f,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let f=0,g=this.a;for(;g;)g=g.next,f++;return f}peek(){return this.a?this.a.data:null}toArray(){const f=[];let g=0,w=this.a;for(;w;)f[g++]=w.data,w=w.next;return f}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(f){const g=new s(f);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const f=Date.now();for(let g=0;g<u.a;g++)this.c[g]=f-1e3*g;setInterval(()=>{for(let g=u.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const f=Date.now(),g=(1+u.a)*1e3;let w=0;for(let k=0;k<u.a;k++)f-this.c[k]<=g&&w++;return 1-w/u.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(f){this.u=new a,this.onControlMessage=this.u.event,this.v=new a,this.onMessage=this.v.event,this.w=new a,this.onDidDispose=this.w.event,this.x=new a,this.onSocketClose=this.x.event,this.y=new a,this.onSocketTimeout=this.y.event,this.s=f.loadEstimator??u.getInstance(),this.t=f.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new O.$Tc,this.o=f.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),f.initialChunk&&this.q.acceptChunk(f.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const f=new h(5,0,0,A());this.p.write(f),this.p.flush()}sendPause(){const f=new h(7,0,0,A());this.p.write(f)}sendResume(){const f=new h(8,0,0,A());this.p.write(f)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(f,g){this.a=!0,this.r.dispose(),this.r=new O.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=f,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const f=new h(3,0,this.h,A());this.p.write(f);const g=this.b.toArray();for(let w=0,k=g.length;w<k;w++)this.p.write(g[w]);this.B()}acceptDisconnect(){this.w.fire()}z(f){if(f.ack>this.d){this.d=f.ack;do{const g=this.b.peek();if(g&&g.id<=f.ack)this.b.pop();else break}while(!0)}switch(f.type){case 0:break;case 1:{if(f.id>this.g)if(f.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new h(6,0,0,A())))}else this.g=f.id,this.j=Date.now(),this.A(),this.v.fire(f.data);break}case 2:{this.u.fire(f.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let w=0,k=g.length;w<k;w++)this.p.write(g[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(f){const g=++this.c;this.h=this.g;const w=new h(1,g,this.h,f);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(f){const g=new h(2,0,0,f);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const f=Date.now()-this.j;if(f>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-f+5)}B(){if(this.c<=this.d||this.f||this.a)return;const f=this.b.peek(),g=Date.now()-f.writtenTime,w=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(g>=2e4&&w>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:w});return}const m=Math.max(2e4-g,2e4-w,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const f=new h(3,0,this.h,A());this.p.write(f)}D(){this.h=this.g;const f=new h(9,0,this.h,A());this.p.write(f)}}e.$mi=r}),define(ke[199],De([1,0,54,7,21,22,197,13,4,3,24,105,102,82]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;class v extends S.$ai{constructor(c){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>O.$He.wrap(Buffer.from(n,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$3q=v;class h{constructor(c,n){this.i=c,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$fe,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new L.$vh(i),this.d=null,this.f=null}getChannel(c){const n=this;return{call(i,a,s){return n.k(c,i,a,s)},listen(i,a){return n.l(c,i,a)}}}k(c,n,i,a=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const s=this.n(c),t=(0,L.$lh)(o=>s.call(n,i,o)),u=a.onCancellationRequested(()=>t.cancel()),r=(0,E.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{u.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,n,i){if(!this.b)return $.Event.None;this.b.cancel();let a;const s=new $.$fe({onWillAddFirstListener:()=>{a=this.n(c).listen(n,i)(s.fire,s),this.c.add(a)},onDidRemoveLastListener:()=>{this.c.delete(a),a.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(g=>!/^--inspect(-brk)?=/.test(g)).filter(g=>!g.startsWith("--vscode-"))),(0,p.$pm)(n.env),this.d=(0,l.fork)(this.i,c,n);const i=new $.$fe,s=$.Event.fromNodeEventEmitter(this.d,"message",g=>g)(g=>{if((0,R.$Yq)(g)){(0,R.log)(g,`IPC Library: ${this.j.serverName}`);return}i.fire(O.$He.wrap(Buffer.from(g,"base64")))}),t=this.j.useQueue?(0,I.$rm)(this.d):this.d,u=g=>this.d&&this.d.connected&&t.send(g.buffer.toString("base64")),r=i.event,o={send:u,onMessage:r};this.f=new S.$bi(o);const f=()=>this.o();process.once("exit",f),this.d.on("error",g=>console.warn('IPC "'+this.j.serverName+'" errored with '+g)),this.d.on("exit",(g,w)=>{process.removeListener("exit",f),s.dispose(),this.c.forEach(k=>(0,E.$Pc)(k)),this.c.clear(),g!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+g+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:g,signal:w})})}return this.f}n(c){let n=this.g.get(c);return n||(n=this.m.getChannel(c),this.g.set(c,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4q=h}),define(ke[200],De([1,0,7,4,3,58,18]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.StorageState=e.StorageHint=void 0,e.$Yp=$;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(p){const S=p;return S?.changed instanceof Map||S?.deleted instanceof Set}var E;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(E||(e.StorageState=E={}));class A extends O.$Uc{static{this.a=100}constructor(S,v=Object.create(null)){super(),this.r=S,this.s=v,this.b=this.B(new L.$ie),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new l.$wh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((v,h)=>this.w(h,v)),S.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(S,v){if(this.c===E.Closed)return;let h=!1;(0,R.$hg)(v)?h=this.f.delete(S):this.f.get(S)!==v&&(this.f.set(S,v),h=!0),h&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,v){const h=this.f.get(S);return(0,R.$hg)(h)?v:h}getBoolean(S,v){const h=this.get(S);return(0,R.$hg)(h)?v:h==="true"}getNumber(S,v){const h=this.get(S);return(0,R.$hg)(h)?v:parseInt(h,10)}getObject(S,v){const h=this.get(S);return(0,R.$hg)(h)?v:(0,M.$7h)(h)}async set(S,v,h=!1){if(this.c===E.Closed)return;if((0,R.$hg)(v))return this.delete(S,h);const d=(0,R.$ag)(v)||Array.isArray(v)?(0,M.$6h)(v):String(v);if(this.f.get(S)!==d)return this.f.set(S,d),this.j.set(S,d),this.h.delete(S),this.b.fire({key:S,external:h}),this.D()}async delete(S,v=!1){if(!(this.c===E.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:v}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===E.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Zp=A;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((v,h)=>this.a.set(h,v)),S.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$1p=I}),define(ke[201],De([1,0,14,12,21]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0,e.$Gt=A,e.$Ht=I;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function A(){return E||(E=L.$D()?R():$()),E}function I(v,h,d){const c=new Uint16Array(v.buffer,h,d);return d>0&&(c[0]===65279||c[0]===65534)?p(v,h,d):R().decode(c)}function p(v,h,d){const c=[];let n=0;for(let i=0;i<d;i++){const a=O.$Je(v,h);h+=2,c[n++]=String.fromCharCode(a)}return c.join("")}class S{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return A().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const d=this.a-this.d;d<=1&&(d===0||l.$Df(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const d=h.length;if(this.d+d>=this.a){this.f(),this.c[this.c.length]=h;return}for(let c=0;c<d;c++)this.b[this.d++]=h.charCodeAt(c)}}e.$It=S}),define(ke[202],De([1,0,21,201]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0,e.$Kt=R;function O($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,A,I,p){this.oldPosition=E,this.oldText=A,this.newPosition=I,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${O(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${O(this.oldText)}")`:`(replace@${this.oldPosition} "${O(this.oldText)}" with "${O(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,A,I){const p=A.length;l.$Me(E,p,I),I+=4;for(let S=0;S<p;S++)l.$Ke(E,A.charCodeAt(S),I),I+=2;return I}static d(E,A){const I=l.$Le(E,A);return A+=4,(0,L.$Ht)(E,A,I)}writeSize(){return 8+M.a(this.oldText)+M.a(this.newText)}write(E,A){return l.$Me(E,this.oldPosition,A),A+=4,l.$Me(E,this.newPosition,A),A+=4,A=M.c(E,this.oldText,A),A=M.c(E,this.newText,A),A}static read(E,A,I){const p=l.$Le(E,A);A+=4;const S=l.$Le(E,A);A+=4;const v=M.d(E,A);A+=M.a(v);const h=M.d(E,A);return A+=M.a(h),I.push(new M(p,v,S,h)),A}}e.$Jt=M;function R($,E){return $===null||$.length===0?E:new b($,E).compress()}class b{constructor(E,A){this.a=E,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,A=0,I=this.n(E),p=this.l(A);for(;E<this.f||A<this.h;){if(I===null){this.k(p),p=this.l(++A);continue}if(p===null){this.m(I),I=this.n(++E);continue}if(p.oldEnd<=I.newPosition){this.k(p),p=this.l(++A);continue}if(I.newEnd<=p.oldPosition){this.m(I),I=this.n(++E);continue}if(p.oldPosition<I.newPosition){const[c,n]=b.r(p,I.newPosition-p.oldPosition);this.k(c),p=n;continue}if(I.newPosition<p.oldPosition){const[c,n]=b.q(I,p.oldPosition-I.newPosition);this.m(c),I=n;continue}let h,d;if(p.oldEnd===I.newEnd)h=I,d=p,I=this.n(++E),p=this.l(++A);else if(p.oldEnd<I.newEnd){const[c,n]=b.q(I,p.oldLength);h=c,d=p,I=n,p=this.l(++A)}else{const[c,n]=b.r(p,I.newLength);h=I,d=c,I=this.n(++E),p=n}this.d[this.e++]=new M(h.oldPosition,h.oldText,d.newPosition,d.newText),this.g+=h.newLength-h.oldLength,this.j+=d.newLength-d.oldLength}const S=b.s(this.d);return b.t(S)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,A){return new M(A.oldPosition-E,A.oldText,A.newPosition,A.newText)}static p(E,A){return new M(A.oldPosition,A.oldText,A.newPosition+E,A.newText)}static q(E,A){const I=E.newText.substr(0,A),p=E.newText.substr(A);return[new M(E.oldPosition,E.oldText,E.newPosition,I),new M(E.oldEnd,"",E.newPosition+A,p)]}static r(E,A){const I=E.oldText.substr(0,A),p=E.oldText.substr(A);return[new M(E.oldPosition,I,E.newPosition,E.newText),new M(E.oldPosition+A,p,E.newEnd,"")]}static s(E){if(E.length===0)return E;const A=[];let I=0,p=E[0];for(let S=1;S<E.length;S++){const v=E[S];p.oldEnd===v.oldPosition?p=new M(p.oldPosition,p.oldText+v.oldText,p.newPosition,p.newText+v.newText):(A[I++]=p,p=v)}return A[I++]=p,A}static t(E){if(E.length===0)return E;const A=[];let I=0;for(let p=0;p<E.length;p++){const S=E[p];S.oldText!==S.newText&&(A[I++]=S)}return A}}}),define(ke[203],De([1,0,35,16]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=O,e.$2t=M;function O(R,b,$,E,A,I){if(Array.isArray(R)){let p=0;for(const S of R){const v=O(S,b,$,E,A,I);if(v===10)return v;v>p&&(p=v)}return p}else{if(typeof R=="string")return E?R==="*"?5:R===$?10:0:0;if(R){const{language:p,pattern:S,scheme:v,hasAccessToAllModels:h,notebookType:d}=R;if(!E&&!h)return 0;d&&A&&(b=A);let c=0;if(v)if(v===b.scheme)c=10;else if(v==="*")c=5;else return 0;if(p)if(p===$)c=10;else if(p==="*")c=Math.max(c,5);else return 0;if(d)if(d===I)c=10;else if(d==="*"&&I!==void 0)c=Math.max(c,5);else return 0;if(S){let n;if(typeof S=="string"?n=S:n={...S,base:(0,L.$hc)(S.base)},n===b.fsPath||(0,l.$rk)(n,b.fsPath))c=10;else return 0}return c}else return 0}}function M(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(M):!!R.notebookType}}),define(ke[204],De([1,0,4,14,29,80,131,179,202,3]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=void 0;class A extends E.$Uc{constructor(p,S,v,h,d,c,n){super(),this.m=this.B(new l.$fe),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=h,this.h=d,this.c=new R.$3C(p,v,n)}equals(p){return!(p instanceof A)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,S){return this.c.getOffsetAt(p,S)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,S){const v=p+S,h=this.getPositionAt(p),d=this.getPositionAt(v);return new O.$xt(h.lineNumber,h.column,d.lineNumber,d.column)}getValueInRange(p,S=0){if(p.isEmpty())return"";const v=this.n(S);return this.c.getValueInRange(p,v)}getValueLengthInRange(p,S=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const v=this.getOffsetAt(p.startLineNumber,p.startColumn),h=this.getOffsetAt(p.endLineNumber,p.endColumn);let d=0;const c=this.n(S),n=this.getEOL();if(c.length!==n.length){const i=c.length-n.length,a=p.endLineNumber-p.startLineNumber;d=i*a}return h-v+d}getCharacterCountInRange(p,S=0){if(this.j){let v=0;const h=p.startLineNumber,d=p.endLineNumber;for(let c=h;c<=d;c++){const n=this.getLineContent(c),i=c===h?p.startColumn-1:0,a=c===d?p.endColumn-1:n.length;for(let s=i;s<a;s++)L.$Df(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(S).length*(d-h),v}return this.getValueLengthInRange(p,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,S){return this.c.getLineCharCode(p,S)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const S=L.$of(this.getLineContent(p));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(p){const S=L.$qf(this.getLineContent(p));return S===-1?0:S+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,S,v){let h=this.g,d=this.h,c=this.j,n=!0,i=[];for(let f=0;f<p.length;f++){const g=p[f];n&&g._isTracked&&(n=!1);const w=g.range;if(g.text){let C=!0;c||(C=!L.$Of(g.text),c=C),!h&&C&&(h=L.$Nf(g.text)),!d&&C&&(d=L.$Qf(g.text))}let k="",m=0,y=0,D=0;if(g.text){let C;[m,y,D,C]=(0,b.$4t)(g.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?k=g.text:k=g.text.replace(/\r\n|\r|\n/g,P)}i[f]={sortIndex:f,identifier:g.identifier||null,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w),text:k,eolCount:m,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}i.sort(A.u);let a=!1;for(let f=0,g=i.length-1;f<g;f++){const w=i[f].range.getEndPosition(),k=i[f+1].range.getStartPosition();if(k.isBeforeOrEqual(w)){if(k.isBefore(w))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(i=this.s(i));const s=v||S?A._getInverseEditRanges(i):[],t=[];if(S)for(let f=0;f<i.length;f++){const g=i[f],w=s[f];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let k=w.startLineNumber;k<=w.endLineNumber;k++){let m="";k===w.startLineNumber&&(m=this.getLineContent(g.range.startLineNumber),L.$of(m)!==-1)||t.push({lineNumber:k,oldContent:m})}}let u=null;if(v){let f=0;u=[];for(let g=0;g<i.length;g++){const w=i[g],k=s[g],m=this.getValueInRange(w.range),y=w.rangeOffset+f;f+=w.text.length-m.length,u[g]={sortIndex:w.sortIndex,identifier:w.identifier,range:k,text:m,textChange:new $.$Jt(w.rangeOffset,m,y,w.text)}}a||u.sort((g,w)=>g.sortIndex-w.sortIndex)}this.g=h,this.h=d,this.j=c;const r=this.t(i);let o=null;if(S&&t.length>0){t.sort((f,g)=>g.lineNumber-f.lineNumber),o=[];for(let f=0,g=t.length;f<g;f++){const w=t[f].lineNumber;if(f>0&&t[f-1].lineNumber===w)continue;const k=t[f].oldContent,m=this.getLineContent(w);m.length===0||m===k||L.$of(m)!==-1||o.push(w)}}return this.m.fire(),new M.$Mv(u,r,o)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let S=!1;const v=p[0].range,h=p[p.length-1].range,d=new O.$xt(v.startLineNumber,v.startColumn,h.endLineNumber,h.endColumn);let c=v.startLineNumber,n=v.startColumn;const i=[];for(let r=0,o=p.length;r<o;r++){const f=p[r],g=f.range;S=S||f.forceMoveMarkers,i.push(this.getValueInRange(new O.$xt(c,n,g.startLineNumber,g.startColumn))),f.text.length>0&&i.push(f.text),c=g.endLineNumber,n=g.endColumn}const a=i.join(""),[s,t,u]=(0,b.$4t)(a);return{sortIndex:0,identifier:p[0].identifier,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d,0),text:a,eolCount:s,firstLineLength:t,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(p){p.sort(A.w);const S=[];for(let v=0;v<p.length;v++){const h=p[v],d=h.range.startLineNumber,c=h.range.startColumn,n=h.range.endLineNumber,i=h.range.endColumn;if(d===n&&c===i&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const a=new O.$xt(d,c,n,i);S.push({range:a,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return S}findMatchesLineByLine(p,S,v,h){return this.c.findMatchesLineByLine(p,S,v,h)}getPieceTree(){return this.c}static _getInverseEditRange(p,S){const v=p.startLineNumber,h=p.startColumn,[d,c,n]=(0,b.$4t)(S);let i;if(S.length>0){const a=d+1;a===1?i=new O.$xt(v,h,v,h+c):i=new O.$xt(v,h,v+a-1,n+1)}else i=new O.$xt(v,h,v,h);return i}static _getInverseEditRanges(p){const S=[];let v=0,h=0,d=null;for(let c=0,n=p.length;c<n;c++){const i=p[c];let a,s;d?d.range.endLineNumber===i.range.startLineNumber?(a=v,s=h+(i.range.startColumn-d.range.endColumn)):(a=v+(i.range.startLineNumber-d.range.endLineNumber),s=i.range.startColumn):(a=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const u=i.eolCount+1;u===1?t=new O.$xt(a,s,a,s+i.firstLineLength):t=new O.$xt(a,s,a+u-1,i.lastLineLength+1)}else t=new O.$xt(a,s,a,s);v=t.endLineNumber,h=t.endColumn,S.push(t),d=i}return S}static u(p,S){const v=O.$xt.compareRangesUsingEnds(p.range,S.range);return v===0?p.sortIndex-S.sortIndex:v}static w(p,S){const v=O.$xt.compareRangesUsingEnds(p.range,S.range);return v===0?S.sortIndex-p.sortIndex:-v}}e.$4C=A}),define(ke[205],De([1,0,14,131,204]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=void 0;class M{constructor($,E,A,I,p,S,v,h,d){this.a=$,this.b=E,this.c=A,this.d=I,this.e=p,this.f=S,this.g=v,this.h=h,this.j=d}k($){const E=this.c+this.d+this.e,A=this.c+this.e;return E===0?$===1?`
`:`\r
`:A>E/2?`\r
`:`
`}create($){const E=this.k($),A=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,S=A.length;p<S;p++){const v=A[p].buffer.replace(/\r\n|\r|\n/g,E),h=(0,L.$YC)(v);A[p]=new L.$2C(v,h)}const I=new O.$4C(A,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&l.$Yf($)&&(this.b=l.$Xf,$=$.substr(1));const E=$.charCodeAt($.length-1);E===13||E>=55296&&E<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=E):(this.m($,!1),this.c=!1,this.d=E)}m($,E){!E&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const E=(0,L.$ZC)(this.e,$);this.a.push(new L.$2C($,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=l.$Nf($)),this.k||(this.k=l.$Qf($)))}finish($=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const E=(0,L.$YC)($.buffer);$.lineStarts=E,this.d===13&&this.f++}}}e.$5C=R}),define(ke[135],De([1,0,21,12]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbb=$,e.$ybb=A;var O;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(O||(O={}));function M(I){for(let p=0,S=I.length;p<S;p+=4){const v=I[p+0],h=I[p+1],d=I[p+2],c=I[p+3];I[p+0]=c,I[p+1]=d,I[p+2]=h,I[p+3]=v}}function R(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.$D()||M(p),l.$He.wrap(p)}function b(I){const p=I.buffer;if(L.$D()||M(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const S=new Uint8Array(p.byteLength);return S.set(p),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(I){const p=new Uint32Array(E(I));let S=0;if(p[S++]=I.id,I.type==="full")p[S++]=1,p[S++]=I.data.length,p.set(I.data,S),S+=I.data.length;else{p[S++]=2,p[S++]=I.deltas.length;for(const v of I.deltas)p[S++]=v.start,p[S++]=v.deleteCount,v.data?(p[S++]=v.data.length,p.set(v.data,S),S+=v.data.length):p[S++]=0}return R(p)}function E(I){let p=0;if(p+=2,I.type==="full")p+=1+I.data.length;else{p+=1,p+=3*I.deltas.length;for(const S of I.deltas)S.data&&(p+=S.data.length)}return p}function A(I){const p=b(I);let S=0;const v=p[S++];if(p[S++]===1){const n=p[S++],i=p.subarray(S,S+n);return S+=n,{id:v,type:"full",data:i}}const d=p[S++],c=[];for(let n=0;n<d;n++){const i=p[S++],a=p[S++],s=p[S++];let t;s>0&&(t=p.subarray(S,S+s),S+=s),c[n]={start:i,deleteCount:a,data:t}}return{id:v,type:"delta",deltas:c}}}),define(ke[206],De([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(ke[136],De([1,0,19,24,12,182,130,206]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=d,e.clampedInt=n,e.clampedFloat=a,e.stringSet=u,e.cursorStyleToString=D,e.filterValidationDecorations=ve;var $;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(re){this.c=re}hasChanged(re){return this.c[re]}}e.ConfigurationChangedEvent=E;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(re,Ce,Ge,Oe){this.id=re,this.name=Ce,this.defaultValue=Ge,this.schema=Oe}applyUpdate(re,Ce){return S(re,Ce)}compute(re,Ce,Ge){return Ge}}class p{constructor(re,Ce){this.newValue=re,this.didChange=Ce}}e.ApplyUpdateResult=p;function S(te,re){if(typeof te!="object"||typeof re!="object"||!te||!re)return new p(re,te!==re);if(Array.isArray(te)||Array.isArray(re)){const Ge=Array.isArray(te)&&Array.isArray(re)&&l.$ub(te,re);return new p(re,!Ge)}let Ce=!1;for(const Ge in re)if(re.hasOwnProperty(Ge)){const Oe=S(te[Ge],re[Ge]);Oe.didChange&&(te[Ge]=Oe.newValue,Ce=!0)}return new p(te,Ce)}class v{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Ce){return S(re,Ce)}validate(re){return this.defaultValue}}class h{constructor(re,Ce,Ge,Oe){this.id=re,this.name=Ce,this.defaultValue=Ge,this.schema=Oe}applyUpdate(re,Ce){return S(re,Ce)}validate(re){return typeof re>"u"?this.defaultValue:re}compute(re,Ce,Ge){return Ge}}function d(te,re){return typeof te>"u"?re:te==="false"?!1:!!te}class c extends h{constructor(re,Ce,Ge,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Ge),super(re,Ce,Ge,Oe)}validate(re){return d(re,this.defaultValue)}}function n(te,re,Ce,Ge){if(typeof te>"u")return re;let Oe=parseInt(te,10);return isNaN(Oe)?re:(Oe=Math.max(Ce,Oe),Oe=Math.min(Ge,Oe),Oe|0)}class i extends h{static clampedInt(re,Ce,Ge,Oe){return n(re,Ce,Ge,Oe)}constructor(re,Ce,Ge,Oe,st,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Ge,lt.minimum=Oe,lt.maximum=st),super(re,Ce,Ge,lt),this.minimum=Oe,this.maximum=st}validate(re){return i.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}function a(te,re,Ce,Ge){if(typeof te>"u")return re;const Oe=s.float(te,re);return s.clamp(Oe,Ce,Ge)}class s extends h{static clamp(re,Ce,Ge){return re<Ce?Ce:re>Ge?Ge:re}static float(re,Ce){if(typeof re=="number")return re;if(typeof re>"u")return Ce;const Ge=parseFloat(re);return isNaN(Ge)?Ce:Ge}constructor(re,Ce,Ge,Oe,st){typeof st<"u"&&(st.type="number",st.default=Ge),super(re,Ce,Ge,st),this.validationFn=Oe}validate(re){return this.validationFn(s.float(re,this.defaultValue))}}class t extends h{static string(re,Ce){return typeof re!="string"?Ce:re}constructor(re,Ce,Ge,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Ge),super(re,Ce,Ge,Oe)}validate(re){return t.string(re,this.defaultValue)}}function u(te,re,Ce,Ge){return typeof te!="string"?re:Ge&&te in Ge?Ge[te]:Ce.indexOf(te)===-1?re:te}class r extends h{constructor(re,Ce,Ge,Oe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Oe,st.default=Ge),super(re,Ce,Ge,st),this.c=Oe}validate(re){return u(re,this.defaultValue,this.c)}}class o extends I{constructor(re,Ce,Ge,Oe,st,lt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=Oe),super(re,Ce,Ge,mt),this.c=st,this.d=lt}validate(re){return typeof re!="string"?this.defaultValue:this.c.indexOf(re)===-1?this.defaultValue:this.d(re)}}function f(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Ce,Ge){return Ge===0?re.accessibilitySupport:Ge}}class w extends I{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:b.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertSpace:d(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function m(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(te){switch(te){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}function C(te){switch(te){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class P extends v{constructor(){super(142)}compute(re,Ce,Ge){const Oe=["monaco-editor"];return Ce.get(39)&&Oe.push(Ce.get(39)),re.extraEditorClassName&&Oe.push(re.extraEditorClassName),Ce.get(74)==="default"?Oe.push("mouse-default"):Ce.get(74)==="copy"&&Oe.push("mouse-copy"),Ce.get(111)&&Oe.push("showUnused"),Ce.get(140)&&Oe.push("showDeprecated"),Oe.join(" ")}}class j extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(re,Ce,Ge){return Ge&&re.emptySelectionClipboard}}class T extends I{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:b.localize(16,null),included:O.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:b.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{cursorMoveOnType:d(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":u(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":u(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(Ce.loop,this.defaultValue.loop)}}}class z extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"||re.length===0?z.OFF:re==="true"?z.ON:re:re?z.ON:z.OFF}}e.EditorFontLigatures=z;class N extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"?N.OFF:re==="true"?N.TRANSLATE:re:re?N.TRANSLATE:N.OFF}compute(re,Ce,Ge){return re.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class F extends v{constructor(){super(50)}compute(re,Ce,Ge){return re.fontInfo}}class U extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(re){const Ce=s.float(re,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Ce,6,100)}compute(re,Ce,Ge){return re.fontInfo.fontSize}}class Y extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(re){return re==="normal"||re==="bold"?re:String(i.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ie extends I{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:Ge,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:Ge,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:Ge,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:Ge,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:Ge,description:b.localize(41,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{multiple:u(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??u(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??u(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??u(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??u(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??u(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends I{constructor(){const re={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:re.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:re.above,description:b.localize(46,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:d(Ce.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(Ce.above,this.defaultValue.above)}}}var J;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class x extends v{constructor(){super(145)}compute(re,Ce,Ge){return x.computeLayout(Ce,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio,glyphMarginDecorationLaneCount:re.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(re){const Ce=re.height/re.lineHeight,Ge=Math.floor(re.paddingTop/re.lineHeight);let Oe=Math.floor(re.paddingBottom/re.lineHeight);re.scrollBeyondLastLine&&(Oe=Math.max(Oe,Ce-1));const st=(Ge+re.viewLineCount+Oe)/(re.pixelRatio*re.height),lt=Math.floor(re.viewLineCount/st);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Oe,desiredRatio:st,minimapLineCount:lt}}static c(re,Ce){const Ge=re.outerWidth,Oe=re.outerHeight,st=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const lt=Ce.stableMinimapLayoutInput,mt=lt&&re.outerHeight===lt.outerHeight&&re.lineHeight===lt.lineHeight&&re.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&re.pixelRatio===lt.pixelRatio&&re.scrollBeyondLastLine===lt.scrollBeyondLastLine&&re.paddingTop===lt.paddingTop&&re.paddingBottom===lt.paddingBottom&&re.minimap.enabled===lt.minimap.enabled&&re.minimap.side===lt.minimap.side&&re.minimap.size===lt.minimap.size&&re.minimap.showSlider===lt.minimap.showSlider&&re.minimap.renderCharacters===lt.minimap.renderCharacters&&re.minimap.maxColumn===lt.minimap.maxColumn&&re.minimap.scale===lt.minimap.scale&&re.verticalScrollbarWidth===lt.verticalScrollbarWidth&&re.isViewportWrapping===lt.isViewportWrapping,Dt=re.lineHeight,It=re.typicalHalfwidthCharacterWidth,zt=re.scrollBeyondLastLine,Bt=re.minimap.renderCharacters;let kt=st>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const Zt=re.minimap.maxColumn,xt=re.minimap.size,xe=re.minimap.side,on=re.verticalScrollbarWidth,Xt=re.viewLineCount,ft=re.remainingWidth,$t=re.isViewportWrapping,_t=Bt?2:3;let Qt=Math.floor(st*Oe);const Ft=Qt/st;let gt=!1,Vt=!1,en=_t*kt,Ut=kt/st,Ye=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Tt,extraLinesBeforeFirstLine:tn,extraLinesBeyondLastLine:Gt,desiredRatio:an,minimapLineCount:Rt}=x.computeContainedMinimapLineCount({viewLineCount:Xt,scrollBeyondLastLine:zt,paddingTop:re.paddingTop,paddingBottom:re.paddingBottom,height:Oe,lineHeight:Dt,pixelRatio:st});if(Xt/Rt>1)gt=!0,Vt=!0,kt=1,en=1,Ut=kt/st;else{let Nt=!1,At=kt+1;if(xt==="fit"){const wt=Math.ceil((tn+Xt+Gt)*en);$t&&mt&&ft<=Ce.stableFitRemainingWidth?(Nt=!0,At=Ce.stableFitMaxMinimapScale):Nt=wt>Qt}if(xt==="fill"||Nt){gt=!0;const wt=kt;en=Math.min(Dt*st,Math.max(1,Math.floor(1/an))),$t&&mt&&ft<=Ce.stableFitRemainingWidth&&(At=Ce.stableFitMaxMinimapScale),kt=Math.min(At,Math.max(1,Math.floor(en/_t))),kt>wt&&(Ye=Math.min(2,kt/wt)),Ut=kt/st/Ye,Qt=Math.ceil(Math.max(Tt,tn+Xt+Gt)*en),$t?(Ce.stableMinimapLayoutInput=re,Ce.stableFitRemainingWidth=ft,Ce.stableFitMaxMinimapScale=kt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const un=Math.floor(Zt*Ut),Yt=Math.min(un,Math.max(0,Math.floor((ft-on-2)*Ut/(It+Ut)))+e.MINIMAP_GUTTER_WIDTH);let Wt=Math.floor(st*Yt);const bt=Wt/st;Wt=Math.floor(Wt*Ye);const qt=Bt?1:2,Lt=xe==="left"?0:Ge-Yt-on;return{renderMinimap:qt,minimapLeft:Lt,minimapWidth:Yt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Vt,minimapScale:kt,minimapLineHeight:en,minimapCanvasInnerWidth:Wt,minimapCanvasInnerHeight:Qt,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:Ft}}static computeLayout(re,Ce){const Ge=Ce.outerWidth|0,Oe=Ce.outerHeight|0,st=Ce.lineHeight|0,lt=Ce.lineNumbersDigitCount|0,mt=Ce.typicalHalfwidthCharacterWidth,Dt=Ce.maxDigitWidth,It=Ce.pixelRatio,zt=Ce.viewLineCount,Bt=re.get(137),kt=Bt==="inherit"?re.get(136):Bt,Zt=kt==="inherit"?re.get(132):kt,xt=re.get(135),xe=Ce.isDominatedByLongLines,on=re.get(57),Xt=re.get(68).renderType!==0,ft=re.get(69),$t=re.get(105),_t=re.get(84),Qt=re.get(73),Ft=re.get(103),gt=Ft.verticalScrollbarSize,Vt=Ft.verticalHasArrows,en=Ft.arrowSize,Ut=Ft.horizontalScrollbarSize,Ye=re.get(43),un=re.get(110)!=="never";let Yt=re.get(66);Ye&&un&&(Yt+=16);let Wt=0;if(Xt){const rn=Math.max(lt,ft);Wt=Math.round(rn*Dt)}let bt=0;on&&(bt=st*Ce.glyphMarginDecorationLaneCount);let qt=0,Lt=qt+bt,Tt=Lt+Wt,tn=Tt+Yt;const Gt=Ge-bt-Wt-Yt;let an=!1,Rt=!1,jt=-1;kt==="inherit"&&xe?(an=!0,Rt=!0):Zt==="on"||Zt==="bounded"?Rt=!0:Zt==="wordWrapColumn"&&(jt=xt);const Nt=x.c({outerWidth:Ge,outerHeight:Oe,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:It,scrollBeyondLastLine:$t,paddingTop:_t.top,paddingBottom:_t.bottom,minimap:Qt,verticalScrollbarWidth:gt,viewLineCount:zt,remainingWidth:Gt,isViewportWrapping:Rt},Ce.memory||new A);Nt.renderMinimap!==0&&Nt.minimapLeft===0&&(qt+=Nt.minimapWidth,Lt+=Nt.minimapWidth,Tt+=Nt.minimapWidth,tn+=Nt.minimapWidth);const At=Gt-Nt.minimapWidth,wt=Math.max(1,Math.floor((At-gt-2)/mt)),Et=Vt?en:0;return Rt&&(jt=Math.max(1,wt),Zt==="bounded"&&(jt=Math.min(jt,xt))),{width:Ge,height:Oe,glyphMarginLeft:qt,glyphMarginWidth:bt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Lt,lineNumbersWidth:Wt,decorationsLeft:Tt,decorationsWidth:Yt,contentLeft:tn,contentWidth:At,minimap:Nt,viewportColumn:wt,isWordWrapMinified:an,isViewportWrapping:Rt,wrappingColumn:jt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Ut,overviewRuler:{top:Et,width:gt,height:Oe-2*Et,right:0}}}}e.EditorLayoutInfoComputer=x;class ne extends I{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(re){return u(re,"simple",["simple","advanced"])}compute(re,Ce,Ge){return Ce.get(2)===2?"advanced":Ge}}var be;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(be||(e.ShowLightbulbIconMode=be={}));class ae extends I{constructor(){const re={enabled:be.On};super(65,"lightbulb",re,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[be.Off,be.OnCode,be.On],default:re.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:u(re.enabled,this.defaultValue.enabled,[be.Off,be.OnCode,be.On])}}}class Ie extends I{constructor(){const re={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",re,{"editor.stickyScroll.enabled":{type:"boolean",default:re.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:re.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:re.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:re.scrollWithEditor,description:b.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:u(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends I{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:b.localize(65,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:u(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:d(Ce.padding,this.defaultValue.padding)}}}class B extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(re){return typeof re=="string"&&/^\d+(\.\d+)?ch$/.test(re)?-parseFloat(re.substring(0,re.length-2)):i.clampedInt(re,this.defaultValue,0,1e3)}compute(re,Ce,Ge){return Ge<0?i.clampedInt(-Ge*re.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class _ extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>s.clamp(re,0,150),{markdownDescription:b.localize(66,null)})}compute(re,Ce,Ge){return re.fontInfo.lineHeight}}class pe extends I{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:re.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:re.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:re.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:re.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:re.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),autohide:d(Ce.autohide,this.defaultValue.autohide),size:u(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(Ce.side,this.defaultValue.side,["right","left"]),showSlider:u(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ce.scale,1,1,3),maxColumn:i.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:d(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:d(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function ue(te){return te==="ctrlCmd"?O.$j?"metaKey":"ctrlKey":"altKey"}class ce extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{top:i.clampedInt(Ce.top,0,0,1e3),bottom:i.clampedInt(Ce.bottom,0,0,1e3)}}}class oe extends I{constructor(){const re={enabled:!0,cycle:!0};super(86,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:b.localize(84,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),cycle:d(Ce.cycle,this.defaultValue.cycle)}}}class le extends v{constructor(){super(143)}compute(re,Ce,Ge){return re.pixelRatio}}class K extends I{constructor(){const re={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:re.strings,description:b.localize(88,null)},comments:{anyOf:Ce,default:re.comments,description:b.localize(89,null)},other:{anyOf:Ce,default:re.other,description:b.localize(90,null)}},default:re,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=re}validate(re){if(typeof re=="boolean"){const It=re?"on":"off";return{comments:It,strings:It,other:It}}if(!re||typeof re!="object")return this.defaultValue;const{other:Ce,comments:Ge,strings:Oe}=re,st=["on","inline","off"];let lt,mt,Dt;return typeof Ce=="boolean"?lt=Ce?"on":"off":lt=u(Ce,this.defaultValue.other,st),typeof Ge=="boolean"?mt=Ge?"on":"off":mt=u(Ge,this.defaultValue.comments,st),typeof Oe=="boolean"?Dt=Oe?"on":"off":Dt=u(Oe,this.defaultValue.strings,st),{other:lt,comments:mt,strings:Dt}}}var se;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class $e extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(re){let Ce=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof re<"u"&&(typeof re=="function"?(Ce=4,Ge=re):re==="interval"?Ce=3:re==="relative"?Ce=2:re==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ge}}}function ve(te){const re=te.get(98);return re==="editable"?te.get(91):re!=="on"}class Me extends I{constructor(){const re=[],Ce={type:"number",description:b.localize(97,null)};super(102,"rulers",re,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:re,description:b.localize(99,null)})}validate(re){if(Array.isArray(re)){const Ce=[];for(const Ge of re)if(typeof Ge=="number")Ce.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Oe=Ge;Ce.push({column:i.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return Ce.sort((Ge,Oe)=>Ge.column-Oe.column),Ce}return this.defaultValue}}class ge extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(re){return!re||typeof re!="object"?this.defaultValue:re}}function Pe(te,re){if(typeof te!="string")return re;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends I{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:re.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re,Ge=i.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=i.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ce.vertical,this.defaultValue.vertical),horizontal:Pe(Ce.horizontal,this.defaultValue.horizontal),useShadows:d(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Ce.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:i.clampedInt(Ce.verticalSliderSize,Oe,0,1e3),scrollByPage:d(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends I{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:b.localize(118,null)}})}applyUpdate(re,Ce){let Ge=!1;Ce.allowedCharacters&&re&&(L.$9n(re.allowedCharacters,Ce.allowedCharacters)||(re={...re,allowedCharacters:Ce.allowedCharacters},Ge=!0)),Ce.allowedLocales&&re&&(L.$9n(re.allowedLocales,Ce.allowedLocales)||(re={...re,allowedLocales:Ce.allowedLocales},Ge=!0));const Oe=super.applyUpdate(re,Ce);return Ge?new p(Oe.newValue,!0):Oe}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{nonBasicASCII:de(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(re.allowedLocales,this.defaultValue.allowedLocales)}}c(re,Ce){if(typeof re!="object"||!re)return Ce;const Ge={};for(const[Oe,st]of Object.entries(re))st===!0&&(Ge[Oe]=!0);return Ge}}class q extends I{constructor(){const re={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:re.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:re.fontFamily,description:b.localize(125,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),mode:u(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class W extends I{constructor(){const re={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",re,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:re.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:re.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:re.backgroundColoring,description:b.localize(132,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showToolbar:u(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:d(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:d(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class X extends I{constructor(){const re={enabled:M.$7s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$7s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends I{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:re.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:re.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:re.highlightActiveIndentation,description:b.localize(148,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{bracketPairs:de(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(te,re,Ce){const Ge=Ce.indexOf(te);return Ge===-1?re:Ce[Ge]}class we extends I{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:re.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:re.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertMode:u(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:d(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:d(Ce.preview,this.defaultValue.preview),previewMode:u(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(Ce.showMethods,this.defaultValue.showMethods),showFunctions:d(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:d(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(Ce.showFields,this.defaultValue.showFields),showVariables:d(Ce.showVariables,this.defaultValue.showVariables),showClasses:d(Ce.showClasses,this.defaultValue.showClasses),showStructs:d(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:d(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:d(Ce.showModules,this.defaultValue.showModules),showProperties:d(Ce.showProperties,this.defaultValue.showProperties),showEvents:d(Ce.showEvents,this.defaultValue.showEvents),showOperators:d(Ce.showOperators,this.defaultValue.showOperators),showUnits:d(Ce.showUnits,this.defaultValue.showUnits),showValues:d(Ce.showValues,this.defaultValue.showValues),showConstants:d(Ce.showConstants,this.defaultValue.showConstants),showEnums:d(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:d(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(Ce.showKeywords,this.defaultValue.showKeywords),showWords:d(Ce.showWords,this.defaultValue.showWords),showColors:d(Ce.showColors,this.defaultValue.showColors),showFiles:d(Ce.showFiles,this.defaultValue.showFiles),showReferences:d(Ce.showReferences,this.defaultValue.showReferences),showFolders:d(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:d(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:d(Ce.showUsers,this.defaultValue.showUsers),showIssues:d(Ce.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(re.selectSubwords,this.defaultValue.selectSubwords)}}}class qe extends I{constructor(){const re=[];super(130,"wordSegmenterLocales",re,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(re){if(typeof re=="string"&&(re=[re]),Array.isArray(re)){const Ce=[];for(const Ge of re)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Ce.push(Ge)}catch{}return Ce}return this.defaultValue}}var Ke;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(Ke||(e.WrappingIndent=Ke={}));class tt extends I{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(re,Ce,Ge){return Ce.get(2)===2?0:Ge}}class _e extends v{constructor(){super(146)}compute(re,Ce,Ge){const Oe=Ce.get(145);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class nt extends I{constructor(){const re={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",re,{"editor.dropIntoEditor.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showDropSelector:u(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends I{constructor(){const re={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",re,{"editor.pasteAs.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showPasteSelector:u(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",Re="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:O.$j?ct:O.$k?Re:rt,fontWeight:"normal",fontSize:O.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Se(te){return e.editorOptionsRegistry[te.id]=te,te}var Ve;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",te[te.quickSuggestions=89]="quickSuggestions",te[te.quickSuggestionsDelay=90]="quickSuggestionsDelay",te[te.readOnly=91]="readOnly",te[te.readOnlyMessage=92]="readOnlyMessage",te[te.renameOnType=93]="renameOnType",te[te.renderControlCharacters=94]="renderControlCharacters",te[te.renderFinalNewline=95]="renderFinalNewline",te[te.renderLineHighlight=96]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=98]="renderValidationDecorations",te[te.renderWhitespace=99]="renderWhitespace",te[te.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",te[te.roundedSelection=101]="roundedSelection",te[te.rulers=102]="rulers",te[te.scrollbar=103]="scrollbar",te[te.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=105]="scrollBeyondLastLine",te[te.scrollPredominantAxis=106]="scrollPredominantAxis",te[te.selectionClipboard=107]="selectionClipboard",te[te.selectionHighlight=108]="selectionHighlight",te[te.selectOnLineNumbers=109]="selectOnLineNumbers",te[te.showFoldingControls=110]="showFoldingControls",te[te.showUnused=111]="showUnused",te[te.snippetSuggestions=112]="snippetSuggestions",te[te.smartSelect=113]="smartSelect",te[te.smoothScrolling=114]="smoothScrolling",te[te.stickyScroll=115]="stickyScroll",te[te.stickyTabStops=116]="stickyTabStops",te[te.stopRenderingLineAfter=117]="stopRenderingLineAfter",te[te.suggest=118]="suggest",te[te.suggestFontSize=119]="suggestFontSize",te[te.suggestLineHeight=120]="suggestLineHeight",te[te.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",te[te.suggestSelection=122]="suggestSelection",te[te.tabCompletion=123]="tabCompletion",te[te.tabIndex=124]="tabIndex",te[te.unicodeHighlighting=125]="unicodeHighlighting",te[te.unusualLineTerminators=126]="unusualLineTerminators",te[te.useShadowDOM=127]="useShadowDOM",te[te.useTabStops=128]="useTabStops",te[te.wordBreak=129]="wordBreak",te[te.wordSegmenterLocales=130]="wordSegmenterLocales",te[te.wordSeparators=131]="wordSeparators",te[te.wordWrap=132]="wordWrap",te[te.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=135]="wordWrapColumn",te[te.wordWrapOverride1=136]="wordWrapOverride1",te[te.wordWrapOverride2=137]="wordWrapOverride2",te[te.wrappingIndent=138]="wrappingIndent",te[te.wrappingStrategy=139]="wrappingStrategy",te[te.showDeprecated=140]="showDeprecated",te[te.inlayHints=141]="inlayHints",te[te.editorClassName=142]="editorClassName",te[te.pixelRatio=143]="pixelRatio",te[te.tabFocusMode=144]="tabFocusMode",te[te.layoutInfo=145]="layoutInfo",te[te.wrappingInfo=146]="wrappingInfo",te[te.defaultColorDecorators=147]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ve||(e.EditorOption=Ve={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Se(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Se(new g),accessibilityPageSize:Se(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Se(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Se(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Se(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Se(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Se(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Se(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Se(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Se(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Se(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Se(new c(13,"automaticLayout",!1)),autoSurround:Se(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Se(new X),bracketPairGuides:Se(new Q),stickyTabStops:Se(new c(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Se(new c(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Se(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Se(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Se(new c(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Se(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Se(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Se(new c(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Se(new w),contextmenu:Se(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new c(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Se(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Se(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Se(new o(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:Se(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Se(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Se(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Se(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new c(34,"domReadOnly",!1)),dragAndDrop:Se(new c(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Se(new j),dropIntoEditor:Se(new nt),stickyScroll:Se(new Ie),experimentalWhitespaceRendering:Se(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Se(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Se(new s(40,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:b.localize(271,null)})),find:Se(new T),fixedOverflowWidgets:Se(new c(42,"fixedOverflowWidgets",!1)),folding:Se(new c(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Se(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Se(new c(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Se(new c(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Se(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Se(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Se(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Se(new F),fontLigatures2:Se(new z),fontSize:Se(new U),fontWeight:Se(new Y),fontVariations:Se(new N),formatOnPaste:Se(new c(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Se(new c(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Se(new c(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Se(new ie),hideCursorInOverviewRuler:Se(new c(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Se(new H),inDiffEditor:Se(new c(61,"inDiffEditor",!1)),letterSpacing:Se(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>s.clamp(te,-5,20),{description:b.localize(285,null)})),lightbulb:Se(new ae),lineDecorationsWidth:Se(new B),lineHeight:Se(new _),lineNumbers:Se(new $e),lineNumbersMinChars:Se(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new c(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Se(new c(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Se(new r(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Se(new pe),mouseStyle:Se(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new s(75,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Se(new c(76,"mouseWheelZoom",!1,{markdownDescription:O.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Se(new c(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Se(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Se(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Se(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Se(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Se(new c(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Se(new i(83,"overviewRulerLanes",3,0,3)),padding:Se(new ce),pasteAs:Se(new it),parameterHints:Se(new oe),peekWidgetDefaultFocus:Se(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Se(new c(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Se(new K),quickSuggestionsDelay:Se(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Se(new c(91,"readOnly",!1)),readOnlyMessage:Se(new ge),renameOnType:Se(new c(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Se(new c(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Se(new r(95,"renderFinalNewline",O.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Se(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Se(new c(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Se(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Se(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Se(new c(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Se(new Me),scrollbar:Se(new Ae),scrollBeyondLastColumn:Se(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Se(new c(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Se(new c(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Se(new c(107,"selectionClipboard",!0,{description:b.localize(325,null),included:O.$k})),selectionHighlight:Se(new c(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Se(new c(109,"selectOnLineNumbers",!0)),showFoldingControls:Se(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Se(new c(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Se(new c(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Se(new ee),snippetSuggestions:Se(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Se(new je),smoothScrolling:Se(new c(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Se(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new we),inlineSuggest:Se(new q),inlineEdit:Se(new W),inlineCompletionsAccessibilityVerbose:Se(new c(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Se(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Se(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Se(new c(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Se(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Se(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Se(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Se(new ze),unusualLineTerminators:Se(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Se(new c(127,"useShadowDOM",!0)),useTabStops:Se(new c(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Se(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Se(new qe),wordSeparators:Se(new t(131,"wordSeparators",R.$8s,{description:b.localize(359,null)})),wordWrap:Se(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Se(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Se(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Se(new P),defaultColorDecorators:Se(new c(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Se(new le),tabFocusMode:Se(new c(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Se(new x),wrappingInfo:Se(new _e),wrappingIndent:Se(new tt),wrappingStrategy:Se(new ne)}}),define(ke[207],De([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(ke[84],De([1,0,79,2,180,29,190,207]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$iu=e.$hu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$gu=e.$fu=e.SymbolKinds=e.SymbolTag=e.$du=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$bu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$au=e.$_t=e.$$t=void 0,e.$cu=r,e.$eu=f;class ${constructor(J,x,ne){this.offset=J,this.type=x,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$$t=$;class E{constructor(J,x){this.tokens=J,this.endState=x,this._tokenizationResultBrand=void 0}}e.$_t=E;class A{constructor(J,x){this.tokens=J,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$au=A;var I;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(I||(e.HoverVerbosityAction=I={}));var p;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var S;(function(H){const J=new Map;J.set(0,l.$Xj.symbolMethod),J.set(1,l.$Xj.symbolFunction),J.set(2,l.$Xj.symbolConstructor),J.set(3,l.$Xj.symbolField),J.set(4,l.$Xj.symbolVariable),J.set(5,l.$Xj.symbolClass),J.set(6,l.$Xj.symbolStruct),J.set(7,l.$Xj.symbolInterface),J.set(8,l.$Xj.symbolModule),J.set(9,l.$Xj.symbolProperty),J.set(10,l.$Xj.symbolEvent),J.set(11,l.$Xj.symbolOperator),J.set(12,l.$Xj.symbolUnit),J.set(13,l.$Xj.symbolValue),J.set(15,l.$Xj.symbolEnum),J.set(14,l.$Xj.symbolConstant),J.set(15,l.$Xj.symbolEnum),J.set(16,l.$Xj.symbolEnumMember),J.set(17,l.$Xj.symbolKeyword),J.set(27,l.$Xj.symbolSnippet),J.set(18,l.$Xj.symbolText),J.set(19,l.$Xj.symbolColor),J.set(20,l.$Xj.symbolFile),J.set(21,l.$Xj.symbolReference),J.set(22,l.$Xj.symbolCustomColor),J.set(23,l.$Xj.symbolFolder),J.set(24,l.$Xj.symbolTypeParameter),J.set(25,l.$Xj.account),J.set(26,l.$Xj.issues);function x(ae){let Ie=J.get(ae);return Ie||(console.info("No codicon found for CompletionItemKind "+ae),Ie=l.$Xj.symbolProperty),Ie}H.toIcon=x;const ne=new Map;ne.set("method",0),ne.set("function",1),ne.set("constructor",2),ne.set("field",3),ne.set("variable",4),ne.set("class",5),ne.set("struct",6),ne.set("interface",7),ne.set("module",8),ne.set("property",9),ne.set("event",10),ne.set("operator",11),ne.set("unit",12),ne.set("value",13),ne.set("constant",14),ne.set("enum",15),ne.set("enum-member",16),ne.set("enumMember",16),ne.set("keyword",17),ne.set("snippet",27),ne.set("text",18),ne.set("color",19),ne.set("file",20),ne.set("reference",21),ne.set("customcolor",22),ne.set("folder",23),ne.set("type-parameter",24),ne.set("typeParameter",24),ne.set("account",25),ne.set("issue",26);function be(ae,Ie){let ee=ne.get(ae);return typeof ee>"u"&&!Ie&&(ee=9),ee}H.fromString=be})(S||(e.CompletionItemKinds=S={}));var v;(function(H){H[H.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var h;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(h||(e.CompletionItemInsertTextRule=h={}));var d;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(d||(e.PartialAcceptTriggerKind=d={}));var c;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var n;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(J,x,ne,be){this.range=J,this.text=x,this.completionKind=ne,this.isSnippetText=be}equals(J){return M.$xt.lift(this.range).equalsRange(J.range)&&this.text===J.text&&this.completionKind===J.completionKind&&this.isSnippetText===J.isSnippetText}}e.$bu=i;var a;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var s;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(s||(e.DocumentPasteTriggerKind=s={}));var t;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var u;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function r(H){return H&&L.URI.isUri(H.uri)&&M.$xt.isIRange(H.range)&&(M.$xt.isIRange(H.originSelectionRange)||M.$xt.isIRange(H.targetSelectionRange))}var o;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(o||(e.SymbolKind=o={})),e.$du={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function f(H,J){return(0,b.localize)(26,null,H,e.$du[J])}var g;(function(H){H[H.Deprecated=1]="Deprecated"})(g||(e.SymbolTag=g={}));var w;(function(H){const J=new Map;J.set(0,l.$Xj.symbolFile),J.set(1,l.$Xj.symbolModule),J.set(2,l.$Xj.symbolNamespace),J.set(3,l.$Xj.symbolPackage),J.set(4,l.$Xj.symbolClass),J.set(5,l.$Xj.symbolMethod),J.set(6,l.$Xj.symbolProperty),J.set(7,l.$Xj.symbolField),J.set(8,l.$Xj.symbolConstructor),J.set(9,l.$Xj.symbolEnum),J.set(10,l.$Xj.symbolInterface),J.set(11,l.$Xj.symbolFunction),J.set(12,l.$Xj.symbolVariable),J.set(13,l.$Xj.symbolConstant),J.set(14,l.$Xj.symbolString),J.set(15,l.$Xj.symbolNumber),J.set(16,l.$Xj.symbolBoolean),J.set(17,l.$Xj.symbolArray),J.set(18,l.$Xj.symbolObject),J.set(19,l.$Xj.symbolKey),J.set(20,l.$Xj.symbolNull),J.set(21,l.$Xj.symbolEnumMember),J.set(22,l.$Xj.symbolStruct),J.set(23,l.$Xj.symbolEvent),J.set(24,l.$Xj.symbolOperator),J.set(25,l.$Xj.symbolTypeParameter);function x(ne){let be=J.get(ne);return be||(console.info("No codicon found for SymbolKind "+ne),be=l.$Xj.symbolProperty),be}H.toIcon=x})(w||(e.SymbolKinds=w={}));class k{static asEditOperation(J){return O.$yt.replace(M.$xt.lift(J.range),J.text)}}e.$fu=k;class m{static{this.Comment=new m("comment")}static{this.Imports=new m("imports")}static{this.Region=new m("region")}static fromValue(J){switch(J){case"comment":return m.Comment;case"imports":return m.Imports;case"region":return m.Region}return new m(J)}constructor(J){this.value=J}}e.$gu=m;var y;(function(H){H[H.AIGenerated=1]="AIGenerated"})(y||(e.NewSymbolNameTag=y={}));var D;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(D||(e.NewSymbolNameTriggerKind=D={}));var C;(function(H){function J(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}H.is=J})(C||(e.Command=C={}));var P;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(P||(e.CommentThreadCollapsibleState=P={}));var j;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(j||(e.CommentThreadState=j={}));var T;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(T||(e.CommentThreadApplicability=T={}));var z;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var N;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(N||(e.CommentState=N={}));var F;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class U{constructor(J){this.b=J,this.a=null}dispose(){this.a&&this.a.then(J=>{J&&J.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$hu=U,e.$iu=new R.$3t;var Y;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Y||(e.ExternalUriOpenerPriority=Y={}));var ie;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(ie||(e.InlineEditTriggerKind=ie={}))}),define(ke[208],De([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[209],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[210],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ke[211],De([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[212],De([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[213],De([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[214],De([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[215],De([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ke[216],De([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(ke[217],De([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[218],De([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ke[219],De([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ke[220],De([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(ke[221],De([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[222],De([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[223],De([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ke[224],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[225],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[226],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[227],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[228],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[229],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[230],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[231],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[232],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[233],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[234],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[235],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[236],De([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[237],De([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(ke[238],De([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ke[239],De([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(ke[240],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[241],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[242],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[243],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[244],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[245],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[246],De([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[247],De([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[248],De([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[249],De([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[250],De([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[251],De([1,0,13,210]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var O;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(O||(e.TokenType=O={}));function M(...E){switch(E.length){case 1:return(0,L.localize)(0,null,E[0]);case 2:return(0,L.localize)(1,null,E[0],E[1]);case 3:return(0,L.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,L.localize)(3,null),b=(0,L.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,l.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,p=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:A}),this.f.push(S)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),p=$.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,p=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const v=this.c.charCodeAt(A);if(I)I=!1;else if(v===47&&!p){A++;break}else v===91?p=!0:v===92?I=!0:v===93&&(p=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=$}),define(ke[252],De([1,0,23,41,213,401]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=$,e.$Kp=E,e.$Lp=A,e.$Mp=I,e.$Np=p,e.$Op=S,e.$Pp=v;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(c){return c=c.trim(),c==="*"||R.test(c)}function E(c){if(!$(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=c.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(c){if(!c)return null;const n=c.majorBase,i=c.majorMustEqual,a=c.minorBase;let s=c.minorMustEqual;const t=c.patchBase;let u=c.patchMustEqual;c.hasCaret&&(n===0||(s=!1),u=!1);let r=0;if(c.preRelease){const o=b.exec(c.preRelease);if(o){const[,f,g,w]=o;r=Date.UTC(Number(f),Number(g)-1,Number(w))}}return{majorBase:n,majorMustEqual:i,minorBase:a,minorMustEqual:s,patchBase:t,patchMustEqual:u,isMinimum:c.hasGreaterEquals,notBefore:r}}function I(c,n,i){let a;typeof c=="string"?a=A(E(c)):a=c;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(E(i)):t=i,!a||!t)return!1;const u=a.majorBase,r=a.minorBase,o=a.patchBase;let f=t.majorBase,g=t.minorBase,w=t.patchBase;const k=t.notBefore;let m=t.majorMustEqual,y=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?u>f?!0:u<f?!1:r>g?!0:r<g||s&&s<k?!1:o>=w:(u===1&&f===0&&(!m||!y||!D)&&(f=1,g=0,w=0,m=!0,y=!1,D=!1),u<f?!1:u>f?!m:r<g?!1:r>g?!y:o<w?!1:o>w?!D:!(s&&s<k))}function p(c,n,i,a,s){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([L.default.Error,O.localize(0,null)]),t;if(typeof a.name!="string")return t.push([L.default.Error,O.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([L.default.Error,O.localize(2,null,"version")]),t;if(!a.engines)return t.push([L.default.Error,O.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([L.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!d(a.extensionDependencies))return t.push([L.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!d(a.activationEvents))return t.push([L.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([L.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([L.default.Warning,O.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([L.default.Error,O.localize(9,null,"main")]),t;{const o=(0,l.$_g)(i,a.main);(0,l.$6g)(o,i)||t.push([L.default.Warning,O.localize(10,null,o.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([L.default.Error,O.localize(11,null,"browser")]),t;{const o=(0,l.$_g)(i,a.browser);(0,l.$6g)(o,i)||t.push([L.default.Warning,O.localize(12,null,o.path,i.path)])}}if(!M.valid(a.version))return t.push([L.default.Error,O.localize(13,null)]),t;const u=[];if(!S(c,n,a,s,u))for(const o of u)t.push([L.default.Error,o]);return t}function S(c,n,i,a,s){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:h(c,n,i.engines.vscode,s)}function v(c,n,i){return c==="*"||h(n,i,c)}function h(c,n,i,a=[]){const s=A(E(i));if(!s)return a.push(O.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return a.push(O.localize(15,null,i)),!1}else if(!s.majorMustEqual)return a.push(O.localize(16,null,i)),!1;return I(c,n,s)?!0:(a.push(O.localize(17,null,c,i)),!1)}function d(c){if(!Array.isArray(c))return!1;for(let n=0,i=c.length;n<i;n++)if(typeof c[n]!="string")return!1;return!0}}),define(ke[106],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class l{constructor(O,M=[],R=!1){this.ctor=O,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$vi=l}),define(ke[85],De([1,0,106]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$As=M,e.$Bs=R;const L=[];var O;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function M(b,$,E){$ instanceof l.$vi||($=new l.$vi($,[],!!E)),L.push([b,$])}function R(){return L}}),define(ke[253],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;class l{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$dr=l;class L{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const b=this.lookupOrInsertNode(M),$=this.lookupOrInsertNode(R);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let b=this.a.get(R);return b||(b=new l(R,M),this.a.set(R,b)),b}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,b]of this.a)M.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const b=new Set([M]),$=this.c(R,b);if($)return $}}c(M,R){for(const[b,$]of M.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const E=this.c($,R);if(E)return E;R.delete(b)}}}e.$er=L}),define(ke[5],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=O,e.$zi=M;var l;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(l||(e._util=l={})),e.$xi=O("instantiationService");function L(R,b,$){b[l.DI_TARGET]===b?b[l.DI_DEPENDENCIES].push({id:R,index:$}):(b[l.DI_DEPENDENCIES]=[{id:R,index:$}],b[l.DI_TARGET]=b)}function O(R){if(l.serviceIds.has(R))return l.serviceIds.get(R);const b=function($,E,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(b,$,A)};return b.toString=()=>R,l.serviceIds.set(R,b),b}function M(R){return R}}),define(ke[55],De([1,0,18,2,5]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=M,e.$7i=R,e.$8i=$,e.$9i=E,e.$0i=A,e.$$i=I,e.$_i=p,e.$aj=v,e.$bj=h,e.$cj=d,e.$5i=(0,O.$yi)("configurationService");function M(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof L.URI)}function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof L.URI)}var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function A(c,n){const i=Object.create(null);for(const a in c)I(i,a,c[a],n);return i}function I(c,n,i,a){const s=n.split("."),t=s.pop();let u=c;for(let r=0;r<s.length;r++){const o=s[r];let f=u[o];switch(typeof f){case"undefined":f=u[o]=Object.create(null);break;case"object":if(f===null){a(`Ignoring ${n} as ${s.slice(0,r+1).join(".")} is null`);return}break;default:a(`Ignoring ${n} as ${s.slice(0,r+1).join(".")} is ${JSON.stringify(f)}`);return}u=f}if(typeof u=="object"&&u!==null)try{u[t]=i}catch{a(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(u)}`)}else a(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(u)}`)}function p(c,n){const i=n.split(".");S(c,i)}function S(c,n){const i=n.shift();if(n.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const a=c[i];typeof a=="object"&&!Array.isArray(a)&&(S(a,n),Object.keys(a).length===0&&delete c[i])}}function v(c,n,i){function a(u,r){let o=u;for(const f of r){if(typeof o!="object"||o===null)return;o=o[f]}return o}const s=n.split("."),t=a(c,s);return typeof t>"u"?i:t}function h(c,n,i){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in c?l.$ag(c[a])&&l.$ag(n[a])?h(c[a],n[a],i):i&&(c[a]=n[a]):c[a]=n[a])})}function d(c){return c.replace(/[\[\]]/g,"")}}),define(ke[38],De([1,0,12,14,251,5,209,13]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=E,e.$xj=u,e.$yj=r,e.$Rj=be;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",l.$j),$.set("isLinux",l.$k),$.set("isWindows",l.$i),$.set("isWeb",l.$o),$.set("isMacNative",l.$j&&!l.$o),$.set("isEdge",l.$H),$.set("isFirefox",l.$F),$.set("isChrome",l.$E),$.set("isSafari",l.$G);function E(ee,B){if($.get(ee)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(ee,B)}const A=Object.prototype.hasOwnProperty;var I;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},S=(0,R.localize)(0,null),v=(0,R.localize)(1,null),h=(0,R.localize)(2,null),d=(0,R.localize)(3,null),c=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=p){this.k=B,this.d=new O.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const pe=this.D(),ue=pe.type===17?n:void 0;throw this.h.push({message:c,offset:pe.offset,lexeme:O.$tj.getLexeme(pe),additionalInfo:ue}),s.c}return _}catch(_){if(_!==s.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const _=this.o();B.push(_)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const _=this.s();B.push(_)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),f.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,d),_?.negate()}case 17:return this.z(),C.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,d),_}case 17:{const _=B.lexeme;if(this.z(),this.y(9)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==10)throw this.B("REGEX",ue);const ce=ue.lexeme,oe=ce.lastIndexOf("/"),le=oe===ce.length-1?void 0:this.w(ce.substring(oe+1));let K;try{K=new RegExp(ce.substring(1,oe),le)}catch{throw this.B("REGEX",ue)}return F.create(_,K)}switch(ue.type){case 10:case 19:{const ce=[ue.lexeme];this.z();let oe=this.D(),le=0;for(let Me=0;Me<ue.lexeme.length;Me++)ue.lexeme.charCodeAt(Me)===40?le++:ue.lexeme.charCodeAt(Me)===41&&le--;for(;!this.E()&&oe.type!==15&&oe.type!==16;){switch(oe.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let Me=0;Me<oe.lexeme.length;Me++)oe.lexeme.charCodeAt(Me)===40?le++:ue.lexeme.charCodeAt(Me)===41&&le--}if(le<0)break;ce.push(O.$tj.getLexeme(oe)),this.z(),oe=this.D()}const K=ce.join(""),se=K.lastIndexOf("/"),$e=se===K.length-1?void 0:this.w(K.substring(se+1));let ve;try{ve=new RegExp(K.substring(1,se),$e)}catch{throw this.B("REGEX",ue)}return t.regex(_,ve)}case 18:{const ce=ue.lexeme;this.z();let oe=null;if(!(0,L.$9e)(ce)){const le=ce.indexOf("/"),K=ce.lastIndexOf("/");if(le!==K&&le>=0){const se=ce.slice(le+1,K),$e=ce[K+1]==="i"?"i":"";try{oe=new RegExp(se,$e)}catch{throw this.B("REGEX",ue)}}}if(oe===null)throw this.B("REGEX",ue);return F.create(_,oe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const ue=this.u();return t.notIn(_,ue)}switch(this.D().type){case 3:{this.z();const ue=this.u();if(this.x().type===18)return t.equals(_,ue);switch(ue){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,ue)}}case 4:{this.z();const ue=this.u();if(this.x().type===18)return t.notEquals(_,ue);switch(ue){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,ue)}}case 5:return this.z(),z.create(_,this.u());case 6:return this.z(),N.create(_,this.u());case 7:return this.z(),j.create(_,this.u());case 8:return this.z(),T.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:i,offset:B.offset,lexeme:"",additionalInfo:a}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,pe){const ue=(0,R.localize)(8,null,B,O.$tj.getLexeme(_)),ce=_.offset,oe=O.$tj.getLexeme(_);return this.h.push({message:ue,offset:ce,lexeme:oe,additionalInfo:pe}),s.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=s;class t{static false(){return f.INSTANCE}static true(){return g.INSTANCE}static has(B){return w.create(B)}static equals(B,_){return k.create(B,_)}static notEquals(B,_){return D.create(B,_)}static regex(B,_){return F.create(B,_)}static in(B,_){return m.create(B,_)}static notIn(B,_){return y.create(B,_)}static not(B){return C.create(B)}static and(...B){return ie.create(B,null,!0)}static or(...B){return H.create(B,null,!0)}static greater(B,_){return j.create(B,_)}static greaterEquals(B,_){return T.create(B,_)}static smaller(B,_){return z.create(B,_)}static smallerEquals(B,_){return N.create(B,_)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$wj=t;function u(ee){const B=new s({regexParsingWithErrorRecovery:!1});return ee.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,R.localize)(9,null,pe.additionalInfo):(0,R.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function r(ee,B){const _=ee?ee.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!_&&!pe?!0:!_||!pe?!1:_.equals(pe)}function o(ee,B){return ee.cmp(B)}class f{static{this.INSTANCE=new f}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return g.INSTANCE}}e.$zj=f;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return f.INSTANCE}}e.$Aj=g;class w{static create(B,_=null){const pe=$.get(B);return typeof pe=="boolean"?pe?g.INSTANCE:f.INSTANCE:new w(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:x(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=$.get(this.key);return typeof B=="boolean"?B?g.INSTANCE:f.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Bj=w;class k{static create(B,_,pe=null){if(typeof _=="boolean")return _?w.create(B,pe):C.create(B,pe);const ue=$.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?g.INSTANCE:f.INSTANCE:new k(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?g.INSTANCE:f.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Cj=k;class m{static create(B,_){return new m(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(_)?_.includes(pe):typeof pe=="string"&&typeof _=="object"&&_!==null?A.call(_,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$Dj=m;class y{static create(B,_){return new y(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=11,this.c=m.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=y;class D{static create(B,_,pe=null){if(typeof _=="boolean")return _?C.create(B,pe):w.create(B,pe);const ue=$.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?f.INSTANCE:g.INSTANCE:new D(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?f.INSTANCE:g.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Fj=D;class C{static create(B,_=null){const pe=$.get(B);return typeof pe=="boolean"?pe?f.INSTANCE:g.INSTANCE:new C(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:x(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=$.get(this.c);return typeof B=="boolean"?B?f.INSTANCE:g.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Gj=C;function P(ee,B){if(typeof ee=="string"){const _=parseFloat(ee);isNaN(_)||(ee=_)}return typeof ee=="string"||typeof ee=="number"?B(ee):f.INSTANCE}class j{static create(B,_,pe=null){return P(_,ue=>new j(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Hj=j;class T{static create(B,_,pe=null){return P(_,ue=>new T(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Ij=T;class z{static create(B,_,pe=null){return P(_,ue=>new z(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Jj=z;class N{static create(B,_,pe=null){return P(_,ue=>new N(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Kj=N;class F{static create(B,_){return new F(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return _<pe?-1:_>pe?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&_===pe}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Lj=F;class U{static create(B){return new U(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new U(this.c.map(B))}negate(){return this.c}}e.$Mj=U;function Y(ee){let B=null;for(let _=0,pe=ee.length;_<pe;_++){const ue=ee[_].substituteConstants();if(ee[_]!==ue&&B===null){B=[];for(let ce=0;ce<_;ce++)B[ce]=ee[ce]}B!==null&&(B[_]=ue)}return B===null?ee:B}class ie{static create(B,_,pe){return ie.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=o(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=Y(this.expr);return B===this.expr?this:ie.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,pe){const ue=[];let ce=!1;for(const oe of B)if(oe){if(oe.type===1){ce=!0;continue}if(oe.type===0)return f.INSTANCE;if(oe.type===6){ue.push(...oe.expr);continue}ue.push(oe)}if(ue.length===0&&ce)return g.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort(o);for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];for(;ue.length>1;){const oe=ue[ue.length-1];if(oe.type!==9)break;ue.pop();const le=ue.pop(),K=ue.length===0,se=H.create(oe.expr.map($e=>ie.create([$e,le],null,pe)),null,K);se&&(ue.push(se),ue.sort(o))}if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return f.INSTANCE;if(ue.length===1)return ue[0]}return new ie(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new ie(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=H.create(B,this,!0)}return this.c}}e.$Nj=ie;class H{static create(B,_,pe){return H.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=o(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=Y(this.expr);return B===this.expr?this:H.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,pe){let ue=[],ce=!1;if(B){for(let oe=0,le=B.length;oe<le;oe++){const K=B[oe];if(K){if(K.type===0){ce=!0;continue}if(K.type===1)return g.INSTANCE;if(K.type===9){ue=ue.concat(K.expr);continue}ue.push(K)}}if(ue.length===0&&ce)return f.INSTANCE;ue.sort(o)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return g.INSTANCE;if(ue.length===1)return ue[0]}return new H(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new H(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),pe=B.shift(),ue=[];for(const ce of Ie(_))for(const oe of Ie(pe))ue.push(ie.create([ce,oe],null,!1));B.unshift(H.create(ue,null,!1))}this.c=H.create(B,this,!0)}return this.c}}e.$Oj=H;class J extends w{static{this.d=[]}static all(){return J.d.values()}constructor(B,_,pe){super(B,null),this.f=_,typeof pe=="object"?J.d.push({...pe,key:B}):pe!==!0&&J.d.push({key:B,description:pe,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return k.create(this.key,B)}notEqualsTo(B){return D.create(this.key,B)}}e.$Pj=J,e.$Qj=(0,M.$yi)("contextKeyService");function x(ee,B){return ee<B?-1:ee>B?1:0}function ne(ee,B,_,pe){return ee<_?-1:ee>_?1:B<pe?-1:B>pe?1:0}function be(ee,B){if(ee.type===0||B.type===1)return!0;if(ee.type===9)return B.type===9?ae(ee.expr,B.expr):!1;if(B.type===9){for(const _ of B.expr)if(be(ee,_))return!0;return!1}if(ee.type===6){if(B.type===6)return ae(B.expr,ee.expr);for(const _ of ee.expr)if(be(_,B))return!0;return!1}return ee.equals(B)}function ae(ee,B){let _=0,pe=0;for(;_<ee.length&&pe<B.length;){const ue=ee[_].cmp(B[pe]);if(ue<0)return!1;ue===0&&_++,pe++}return _===ee.length}function Ie(ee){return ee.type===9?ee.expr:[ee]}}),define(ke[254],De([1,0,23,41,211,5,103,12,24]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Sw=e.$Rw=e.$Qw=void 0,e.$Tw=S,e.$Uw=v,e.$Qw=(0,M.$yi)("dialogService");var E;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(E||(E={}));class A{a(d){return this.d(d,E.Confirmation)}b(d){return this.d(d,E.Prompt)}c(d){return this.d(d,E.Input)}d(d,c){const n=[];switch(c){case E.Confirmation:{const i=d;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(1,null));break}case E.Prompt:{const i=d;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(a=>a.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,O.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,O.localize)(3,null))),n.length===0&&n.push((0,O.localize)(4,null));break}case E.Input:{const i=d;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(6,null));break}}return n}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===L.default.Info?"info":d===L.default.Error?"error":d===L.default.Warning?"warning":"none"}f(d,c,n){const i=[...d.buttons??[]];d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&i.push(d.cancelButton);let a=i[c]?.run({checkboxChecked:n});return a instanceof Promise||(a=Promise.resolve(a)),{result:a,checkboxChecked:n}}}e.$Rw=A,e.$Sw=(0,M.$yi)("fileDialogService");var I;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function S(h){const d=[];return d.push(...h.slice(0,p).map(c=>typeof c=="string"?c:(0,l.$9g)(c))),h.length>p&&(h.length-p===1?d.push((0,O.localize)(7,null)):d.push((0,O.localize)(8,null,h.length-p))),d.push(""),d.join(`
`)}function v(h,d){const c=(0,$.$5n)(h);let n=(c.buttons??[]).map(t=>(0,R.$Nw)(t)),i=(h.buttons||[]).map((t,u)=>u),a=0,s=c.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const u=i[s];i.splice(s,1),i.splice(1,0,u),s=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),a=n.length-1,typeof t=="string"&&(s=a-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const u=i[s];i.splice(s,1),i.push(u),s=n.length-1}}return c.buttons=n,c.defaultId=a,c.cancelId=s,c.noLink=!0,c.title=c.title||d.nameLong,{options:c,buttonIndeces:i}}}),define(ke[137],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,l.$yi)("environmentService"),e.$Gi=(0,l.$zi)(e.$Fi)}),define(ke[138],De([1,0,212,5]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.ExtensionManagementErrorCode=e.$9o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$3o=O,e.$4o=M,e.$5o=R,e.$6o=b,e.$7o=$,e.$8o=E,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall";function O(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(n,i){return i==="web"&&!n.includes("web")}function $(n,i,a){return b(i,a)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===a}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var I;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var p;(function(n){n.Install="install",n.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var S;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$9o=(0,L.$yi)("extensionGalleryService");var v;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class h extends Error{constructor(i,a){super(i),this.code=a,this.name=a}}e.$0o=h;var d;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(d||(e.ExtensionGalleryErrorCode=d={}));class c extends Error{constructor(i,a){super(i),this.code=a,this.name=a}}e.$$o=c,e.$_o=(0,L.$yi)("extensionManagementService"),e.$ap="extensionsIdentifiers/disabled",e.$bp="extensionsIdentifiers/enabled",e.$cp=(0,L.$yi)("IGlobalExtensionEnablementService"),e.$dp=(0,L.$yi)("IExtensionTipsService"),e.$ep=(0,l.localize2)(0,"Extensions"),e.$fp=(0,l.localize2)(1,"Preferences")}),define(ke[255],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=e.$C7b=void 0,e.$C7b=(0,l.$yi)("externalTerminal"),e.$D7b="Terminal.app"}),define(ke[256],De([1,0,54,56,15,16,12,102,32,105,214,255]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=e.$5cc=void 0;const p=A.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends S{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(l,s,E.$qm(),t)}spawnTerminal(s,t,u,r){const o=t.windowsExec||v.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const f=M.$nc(o,".exe").toLowerCase();if(f==="cmder")return s.spawn(o,r?[r]:void 0),Promise.resolve(void 0);const g=["/c","start","/wait"];return o.indexOf(" ")>=0&&g.push('""'),g.push(o),f==="wt"&&g.push("-d ."),new Promise((w,k)=>{const m=c(process),y=s.spawn(u,g,{cwd:r,env:m,detached:!0});y.on("error",k),y.on("exit",()=>w())})}async runInTerminal(s,t,u,r,o){const f="windowsExec"in o&&o.windowsExec?o.windowsExec:v.getDefaultTerminalWindows(),g=await v.f();return new Promise((w,k)=>{const m=`"${t} - ${p}"`,y=`"${u.join('" "')}" & pause`,D=Object.assign({},c(process),r);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const C={cwd:t,env:D,windowsVerbatimArguments:!0};let P,j;M.$nc(f,".exe")==="wt"?(P=f,j=["-d",".",v.b,"/c",y]):g?(P=g,j=["-d",".",f,"/c",y]):(P=v.b,j=["/c","start",m,"/wait",f,"/c",`"${y}"`]),l.spawn(P,j,C).on("error",z=>{k(n(z))}),w(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await E.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$5cc=v,Je([L.$3h],v,"f",null);class h extends S{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(l,s,t)}runInTerminal(s,t,u,r,o){const f=o.osxExec||I.$D7b;return new Promise((g,w)=>{if(f===I.$D7b||f==="iTerm.app"){const k=f===I.$D7b?"TerminalHelper":"iTermHelper",y=[O.$Sg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",s||p,"-w",t];for(const P of u)y.push("-a"),y.push(P);if(r){const P=Object.assign({},c(process),r);for(const j in P){const T=P[j];T===null?(y.push("-u"),y.push(j)):(y.push("-e"),y.push(`${j}=${T}`))}}let D="";const C=l.spawn(h.b,y);C.on("error",P=>{w(n(P))}),C.stderr.on("data",P=>{D+=P.toString()}),C.on("exit",P=>{if(P===0)g(void 0);else if(D){const j=D.split(`
`,1);w(new Error(j[0]))}else w(new Error(A.localize(1,null,k,P)))})}else w(new Error(A.localize(2,null,f)))})}spawnTerminal(s,t,u){const r=t.osxExec||I.$D7b;return new Promise((o,f)=>{const g=["-a",r];u&&g.push(u);const w=c(process),k=s.spawn("/usr/bin/open",g,{cwd:u,env:w});k.on("error",f),k.on("exit",()=>o())})}}e.$6cc=h;class d extends S{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(l,s,t)}runInTerminal(s,t,u,r,o){const f=o.linuxExec?Promise.resolve(o.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((g,w)=>{const k=[];f.then(m=>{m.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const y=`${i(u)}; echo; read -p "${d.b}" -n1;`;k.push(`''${y}''`);const D=Object.assign({},c(process),r);Object.keys(D).filter(T=>D[T]===null).forEach(T=>delete D[T]);const C={cwd:t,env:D};let P="";const j=l.spawn(m,k,C);j.on("error",T=>{w(n(T))}),j.stderr.on("data",T=>{P+=T.toString()}),j.on("exit",T=>{if(T===0)g(void 0);else if(P){const z=P.split(`
`,1);w(new Error(z[0]))}else w(new Error(A.localize(4,null,m,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!R.$k)d.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");d.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return d.d}spawnTerminal(s,t,u){const r=t.linuxExec?Promise.resolve(t.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((o,f)=>{r.then(g=>{const w=c(process),k=s.spawn(g,[],{cwd:u,env:w});k.on("error",f),k.on("exit",()=>o())})})}}e.$7cc=d;function c(a){const s={...a.env};return(0,b.$om)(s),s}function n(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(A.localize(5,null,a.path)):a}function i(a){let s="";for(const t of a)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[33],De([1,0,78,16,14,18,2,215,5,12,15,46]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=p,e.$7k=d,e.$8k=n,e.$9k=i,e.$0k=a,e.$$k=s,e.$_k=t,e.$al=u,e.$bl=r,e.$cl=o,e.$dl=f,e.$fl=k,e.$gl=m,e.$hl=y,e.$il=D,e.$jl=C,e.$ml=N,e.$yl=J,e.$zl=x,e.$Bl=be,e.$5k=(0,$.$yi)("fileService");function p(ae){return ae.create===!0}var S;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var v;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var h;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function d(ae){const Ie=ae;return!!Ie&&typeof Ie.onDidChange=="function"}var c;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function n(ae){return!!(ae.capabilities&2)}function i(ae){return!!(ae.capabilities&8)}function a(ae){return!!(ae.capabilities&131072)}function s(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function u(ae){return n(ae)?!!(ae.capabilities&16384):!1}function r(ae){return n(ae)?!!(ae.capabilities&32768):!1}function o(ae){return!!(ae.capabilities&65536)}function f(ae){return!!(ae.capabilities&2048)}var g;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class w extends Error{static create(Ie,ee){const B=new w(Ie.toString(),ee);return y(B,ee),B}constructor(Ie,ee){super(Ie),this.code=ee}}e.$el=w;function k(ae,Ie){return w.create(ae,Ie)}function m(ae){return ae||k((0,b.localize)(0,null),g.Unknown)}function y(ae,Ie){return ae.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",ae}function D(ae){if(!ae)return g.Unknown;if(ae instanceof w)return ae.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ie)return g.Unknown;switch(Ie[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}function C(ae){if(ae instanceof F)return ae.fileOperationResult;switch(D(ae)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}var P;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class j{constructor(Ie,ee,B){this.resource=Ie,this.operation=ee,this.target=B}isOperation(Ie){return this.operation===Ie}}e.$kl=j;var T;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class z{static{this.a=null}constructor(Ie,ee){this.c=ee,this.b=void 0,this.d=new I.$V(()=>{const B=l.$Ei.forUris(()=>this.c);return B.fill(this.rawAdded.map(_=>[_,!0])),B}),this.f=new I.$V(()=>{const B=l.$Ei.forUris(()=>this.c);return B.fill(this.rawUpdated.map(_=>[_,!0])),B}),this.g=new I.$V(()=>{const B=l.$Ei.forUris(()=>this.c);return B.fill(this.rawDeleted.map(_=>[_,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of Ie){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==z.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(Ie,...ee){return this.h(Ie,{includeChildren:!1},...ee)}affects(Ie,...ee){return this.h(Ie,{includeChildren:!0},...ee)}h(Ie,ee,...B){if(!Ie)return!1;const _=B.length>0;return!!((!_||B.includes(1))&&(this.d.value.get(Ie)||ee.includeChildren&&this.d.value.findSuperstr(Ie))||(!_||B.includes(0))&&(this.f.value.get(Ie)||ee.includeChildren&&this.f.value.findSuperstr(Ie))||(!_||B.includes(2))&&(this.g.value.findSubstr(Ie)||ee.includeChildren&&this.g.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.b===Ie}hasCorrelation(){return typeof this.b=="number"}}e.$ll=z;function N(ae,Ie,ee){return!ae||!Ie||ae===Ie||Ie.length>ae.length?!1:(Ie.charAt(Ie.length-1)!==L.sep&&(Ie+=L.sep),ee?(0,O.$Af)(ae,Ie):ae.indexOf(Ie)===0)}class F extends Error{constructor(Ie,ee,B){super(Ie),this.fileOperationResult=ee,this.options=B}}e.$nl=F;class U extends F{constructor(Ie,ee,B,_){super(Ie,ee,_),this.fileOperationResult=ee,this.size=B}}e.$ol=U;class Y extends F{constructor(Ie,ee,B){super(Ie,2,B),this.stat=ee}}e.$pl=Y;var ie;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var H;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$xl="";function J(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function x(ae,Ie){if(!Ie.hasProvider(R.URI.from({scheme:ae.scheme})))return new Promise(ee=>{const B=Ie.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===ae.scheme&&_.added&&(B.dispose(),ee())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Ie){return(0,M.$cg)(Ie)||(Ie=0),Ie<ne.KB?(0,b.localize)(1,null,Ie.toFixed(0)):Ie<ne.MB?(0,b.localize)(2,null,(Ie/ne.KB).toFixed(2)):Ie<ne.GB?(0,b.localize)(3,null,(Ie/ne.MB).toFixed(2)):Ie<ne.TB?(0,b.localize)(4,null,(Ie/ne.GB).toFixed(2)):(0,b.localize)(5,null,(Ie/ne.TB).toFixed(2))}}e.$Al=ne;function be(ae){const Ie=typeof ae=="string"||ae?.scheme===A.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===A.Schemas.file?1024*ne.MB:Ie?10*ne.MB:E.$o?50*ne.MB:1024*ne.MB}}),define(ke[257],De([1,0,21,13,216,33]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=R;async function R(A,I,p,S,v,h){let d;try{await b(A,I,p,S,v,h)}catch(c){d=c}finally{d&&v.errorTransformer&&(d=v.errorTransformer(d)),typeof d<"u"&&p.error(d),p.end()}}async function b(A,I,p,S,v,h){$(h);const d=await A.open(I,{create:!1});try{$(h);let c=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,a=l.$He.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(d,s,a.buffer,t,a.byteLength-t),s+=n,t+=n,c+=n,typeof i=="number"&&(i-=n),t===a.byteLength&&(await p.write(S(a)),a=l.$He.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(h)&&E(c,v));if(t>0){let u=t;typeof i=="number"&&(u=Math.min(t,i)),p.write(S(a.slice(0,u)))}}catch(c){throw(0,M.$gl)(c)}finally{await A.close(d)}}function $(A){if(A.isCancellationRequested)throw(0,L.$6)();return!0}function E(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,M.$fl)((0,O.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],De([1,0,35,3,16,12,2,33]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=void 0,e.$Mq=$,e.$Nq=E,e.$Rq=S,e.$Sq=v,e.$Tq=h,e.$Uq=d,e.$Vq=n,e.$Wq=i;function $(a){return typeof a.correlationId=="number"}function E(a){return a.recursive===!0}class A extends L.$Uc{static{this.a=5}constructor(s,t,u,r){super(),this.h=s,this.j=t,this.m=u,this.n=r,this.c=this.B(new L.$Vc),this.f=void 0,this.g=0}s(){const s=new L.$Tc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(t=>this.h(t))),s.add(this.b.onDidLogMessage(t=>this.j(t))),s.add(this.b.onDidError(t=>this.t(t)))}t(s){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${s}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${s}`):this.w(s)}u(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}w(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}y(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Oq=A;class I extends A{constructor(s,t,u){super(s,t,u,{type:"node.js",restartOnError:!1})}}e.$Pq=I;class p extends A{constructor(s,t,u){super(s,t,u,{type:"universal",restartOnError:!0})}}e.$Qq=p;function S(a){return a.map(s=>({type:s.type,resource:R.URI.revive(s.resource),cId:s.cId}))}function v(a){const s=new c;for(const t of a)s.processEvent(t);return s.coalesce()}function h(a,s){return typeof s=="string"&&!s.startsWith(l.$ok)&&!(0,O.$ic)(s)?{base:a,pattern:s}:s}function d(a,s){const t=[];for(const u of s)t.push((0,l.$sk)(h(a,u)));return t}class c{constructor(){this.a=new Set,this.b=new Map}c(s){return M.$k?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const t=this.b.get(this.c(s));let u=!1;if(t){const r=t.type,o=s.type;t.resource.fsPath!==s.resource.fsPath&&(s.type===2||s.type===1)?u=!0:r===1&&o===2?(this.b.delete(this.c(s)),this.a.delete(t)):r===2&&o===1?t.type=0:r===1&&o===0||(t.type=o)}else u=!0;u&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],t=[];return Array.from(this.a).filter(u=>u.type!==2?(s.push(u),!1):!0).sort((u,r)=>u.resource.fsPath.length-r.resource.fsPath.length).filter(u=>t.some(r=>(0,b.$ml)(u.resource.fsPath,r,!M.$k))?!1:(t.push(u.resource.fsPath),!0)).concat(s)}}function n(a,s){if(typeof s=="number")switch(a.type){case 1:return(s&4)===0;case 2:return(s&8)===0;case 0:return(s&2)===0}return!1}function i(a){if(typeof a=="number"){const s=[];return a&4&&s.push("Added"),a&8&&s.push("Deleted"),a&2&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(ke[258],De([1,0,53,3,65,4,2,7]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class $ extends L.$Uc{constructor(){super(),this.a=this.B(new M.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new L.$4c),this.m=new Set,this.n=5007,this.r=new b.$Vh,this.P=!1,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,O.$Mq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Vh;try{this.h.clear(),this.g.clear();for(const I of A)this.t(I)?this.h.set(I.correlationId,I):this.g.add(I);for(const[I]of this.j)this.h.has(I)||(this.j.deleteAndDispose(I),this.m.delete(I));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const I=new L.$Tc;this.j.set(A.correlationId,I),await this.r.p,!I.isDisposed&&(this.z(A,I),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,I){this.C(A,I)?(this.N(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,I),this.m.add(A.correlationId))}C(A,I){const p=this.M?.subscribe(A.path,(S,v)=>{I.isDisposed||(S?this.z(A,I):v?.type===1&&this.F(A))});return p?(I.add(p),!0):!1}D(A,I){let p=!1;const S=(v,h)=>{if(I.isDisposed)return;const d=this.G(v),c=this.G(h),n=p;p=d,!d&&(c||n)&&this.F(A)};this.N(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,l.watchFile)(A.path,{persistent:!1,interval:this.n},S)}catch(v){this.O(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}I.add((0,L.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,l.unwatchFile)(A.path,S)}catch(v){this.O(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.N(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const I={resource:R.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([I]),this.H(I,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,I){if(this.P){const p=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.I(p,I)}}I(A,I){this.P&&this.N(`${A}${typeof I.correlationId=="number"?` <${I.correlationId}> `:""}`)}J(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, filter: ${(0,O.$Wq)(A.filter)}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}async setVerboseLogging(A){this.P=A}}e.$6q=$}),define(ke[259],De([1,0,53,7,22,31,3,77,16,12,23,2,104,32,65]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0,e.$_q=d;class h extends R.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,a,s,t,u){super(),this.s=n,this.t=i,this.u=a,this.w=s,this.y=t,this.z=u,this.c=this.B(new L.$Nh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new L.$Mh(r=>this.M(r),h.b)),this.g=(0,v.$Uq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,v.$Uq)(this.s.path,this.s.includes):void 0,this.j=(0,v.$Mq)(this.s)?this.s.filter:void 0,this.m=new O.$qe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await S.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await S.Promises.realpath(n.path),n.path===i&&(i=await(0,p.$8q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const a=new R.$Tc;return this.H(n,i,a)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,a)),a}H(n,i,a){if(i)return!1;const s=I.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(u,r)=>{if(!a.isDisposed)if(u){const o=await this.G(n,i);a.isDisposed?o.dispose():a.add(o)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:s,type:r.type,cId:this.s.correlationId},!0)});return t?(a.add(t),!0):!1}async I(n,i,a){if(E.$j&&(0,M.$xg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new O.$qe(this.m.token);a.add((0,R.$Sc)(()=>s.dispose(!0)));const t=new R.$Tc;a.add(t);try{const u=I.URI.file(this.s.path),r=(0,$.$nc)(n),o=(0,l.watch)(n);t.add((0,R.$Sc)(()=>{o.removeAllListeners(),o.close()})),this.Q(`Started watching: '${n}'`);const f=new Set;if(i)try{for(const w of await S.Promises.readdir(n))f.add(w)}catch(w){this.O(w)}if(s.token.isCancellationRequested)return;const g=new Map;t.add((0,R.$Sc)(()=>{for(const[,w]of g)w.dispose();g.clear()})),o.on("error",(w,k)=>{s.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${w}, ${k})`),this.D())}),o.on("change",(w,k)=>{if(s.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${w}"] ${k}`);let m="";if(k&&(m=k.toString(),E.$j&&(m=(0,b.$dm)(m))),!(!m||w!=="change"&&w!=="rename"))if(i)if(w==="rename"){g.get(m)?.dispose();const y=setTimeout(async()=>{if(g.delete(m),m===r&&!await S.Promises.exists(n)){this.J(u);return}if(s.token.isCancellationRequested)return;const D=await this.N((0,$.$jc)(n,m));if(s.token.isCancellationRequested)return;let C;D?f.has(m)?C=0:(C=1,f.add(m)):(f.delete(m),C=2),this.L({resource:(0,A.$_g)(u,m),type:C,cId:this.s.correlationId})},h.a);g.set(m,(0,R.$Sc)(()=>clearTimeout(y)))}else{let y;f.has(m)?y=0:(y=1,f.add(m)),this.L({resource:(0,A.$_g)(u,m),type:y,cId:this.s.correlationId})}else if(w==="rename"||m!==r){const y=setTimeout(async()=>{const D=await S.Promises.exists(n);s.token.isCancellationRequested||(D?(this.L({resource:u,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(u))},h.a);t.clear(),t.add((0,R.$Sc)(()=>clearTimeout(y)))}else this.L({resource:u,type:0,cId:this.s.correlationId},!0)})}catch(u){s.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${u.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(a=>a(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(a=>a(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,v.$Sq)(n),a=[];for(const t of i){if((0,v.$Vq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}a.push(t)}if(a.length===0)return;if(this.z)for(const t of a)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(a)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(E.$k)return S.Promises.exists(n);try{const i=(0,$.$nc)(n);return(await S.Promises.readdir((0,$.$mc)(n))).some(s=>s===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$$q=h;async function d(c,n,i,a,s=512){const t=await S.Promises.open(c,"r"),u=Buffer.allocUnsafe(s),r=new O.$qe(a);let o,f=!1;const g={path:c,excludes:[],recursive:!1},w=new h(g,void 0,k=>{(async()=>{for(const{type:m}of k)if(m===0){if(f)return;f=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:y}=await S.Promises.read(t,u,0,s,null);if(!y||r.token.isCancellationRequested)break;n(u.slice(0,y))}}catch(y){o=new Error(y),r.dispose(!0)}finally{f=!1}}})()});return await w.ready,i(),new Promise((k,m)=>{r.token.onCancellationRequested(async()=>{w.dispose();try{await S.Promises.close(t)}catch(y){o=new Error(y)}o?m(o):k()})})}}),define(ke[260],De([1,0,4,35,258,12,259,31]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class $ extends O.$6q{constructor(A){super(),this.M=A,this.onDidError=l.Event.None,this.watchers=new Set}async L(A){A=this.X(A);const I=[],p=new Set(Array.from(this.watchers));for(const S of A){const v=this.S(S);v&&(0,L.$wk)(v.request.excludes,S.excludes)&&(0,L.$wk)(v.request.includes,S.includes)?p.delete(v):I.push(S)}I.length&&this.N(`Request to start watching: ${I.map(S=>this.J(S)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(S=>this.J(S.request)).join(",")}`);for(const S of p)this.W(S);for(const S of I)this.U(S)}S(A){for(const I of this.watchers)if(typeof A.correlationId=="number"||typeof I.request.correlationId=="number"){if(I.request.correlationId===A.correlationId)return I}else if((0,b.$wg)(I.request.path,A.path,!M.$k))return I}U(A){const I=new R.$$q(A,this.M,S=>this.a.fire(S),()=>this.c.fire(A),S=>this.b.fire(S),this.P),p={request:A,instance:I};this.watchers.add(p)}async stop(){await super.stop();for(const A of this.watchers)this.W(A)}W(A){this.N("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}X(A){const I=new Map;for(const p of A){const S=M.$k?p.path:p.path.toLowerCase();let v=I.get(p.correlationId);v||(v=new Map,I.set(p.correlationId,v)),v.has(S)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),v.set(S,p)}return Array.from(I.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(A){super.setVerboseLogging(A);for(const I of this.watchers)I.instance.setVerboseLogging(A)}N(A,I){this.P&&this.b.fire({type:"trace",message:this.$(A,I)})}O(A){this.b.fire({type:"warn",message:this.$(A)})}$(A,I){return I?`[File Watcher (node.js)] ${A} (${this.J(I.request)})`:`[File Watcher (node.js)] ${A}`}}e.$ar=$}),define(ke[261],De([1,0,65,260]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class O extends l.$Pq{constructor(R,b,$){super(R,b,$),this.s()}r(R){return R.add(new L.$ar(void 0))}}e.$br=O}),define(ke[262],De([1,0,15,82,199,65]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class R extends M.$Qq{constructor($,E,A){super($,E,A),this.s()}r($){const E=$.add(new O.$4q(l.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(E.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I} (ETERM)`))),L.ProxyChannel.toService((0,L.$fi)(E.getChannel("watcher")))}}e.$5q=R}),define(ke[107],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class l{constructor(...O){this.a=new Map;for(const[M,R]of O)this.set(M,R)}set(O,M){const R=this.a.get(O);return this.a.set(O,M),R}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$wi=l}),define(ke[263],De([1,0,7,13,3,106,253,5,107,76]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;const A=!1;class I extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class p{constructor(d=new $.$wi,c=!1,n,i=A){this.i=d,this.j=c,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$xi,this),this._globalGraph=i?n?._globalGraph??new R.$er(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,O.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,O.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d){this.m();const c=new class extends p{dispose(){this.h.delete(c),super.dispose()}}(d,this.j,this,this.l);return this.h.add(c),c}invokeFunction(d,...c){this.m();const n=v.traceInvocation(this.l,d);let i=!1;try{return d({get:s=>{if(i)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...c)}finally{i=!0,n.stop()}}createInstance(d,...c){this.m();let n,i;return d instanceof M.$vi?(n=v.traceCreation(this.l,d.ctor),i=this.o(d.ctor,d.staticArguments.concat(c),n)):(n=v.traceCreation(this.l,d),i=this.o(d,c,n)),n.stop(),i}o(d,c=[],n){const i=b._util.getServiceDependencies(d).sort((t,u)=>t.index-u.index),a=[];for(const t of i){const u=this.s(t.id,n);u||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(u)}const s=i.length>0?i[0].index:c.length;if(c.length!==s){console.trace(`[createInstance] First service dependency of ${d.name} at position ${s+1} conflicts with ${c.length} static arguments`);const t=s-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,s)}return Reflect.construct(d,c.concat(a))}q(d,c){if(this.i.get(d)instanceof M.$vi)this.i.set(d,c);else if(this.k)this.k.q(d,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const c=this.i.get(d);return!c&&this.k?this.k.r(d):c}s(d,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const n=this.r(d);return n instanceof M.$vi?this.u(d,n,c.branch(d,!0)):(c.branch(d,!1),n)}u(d,c,n){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,c,n)}finally{this.t.delete(d)}}v(d,c,n){const i=new R.$er(t=>t.id.toString());let a=0;const s=[{id:d,desc:c,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new I(i);for(const u of b._util.getServiceDependencies(t.desc.ctor)){const r=this.r(u.id);if(r||this.y(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),r instanceof M.$vi){const o={id:u.id,desc:r,_trace:t._trace.branch(u.id,!0)};i.insertEdge(t,o),s.push(o)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:u}of t){if(this.r(u.id)instanceof M.$vi){const o=this.w(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.q(u.id,o)}i.removeNode(u)}}return this.r(d)}w(d,c,n=[],i,a){if(this.i.get(d)instanceof M.$vi)return this.x(d,c,n,i,a,this.g);if(this.k)return this.k.w(d,c,n,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(d,c,n=[],i,a,s){if(i){const t=new p(void 0,this.j,this,this.l);t.c=String(d);const u=new Map,r=new l.$Rh(()=>{const o=t.o(c,n,a);for(const[f,g]of u){const w=o[f];if(typeof w=="function")for(const k of g)k.disposable=w.apply(o,k.listener)}return u.clear(),s.add(o),o});return new Proxy(Object.create(null),{get(o,f){if(!r.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let k=u.get(f);return k||(k=new E.$5c,u.set(f,k)),(y,D,C)=>{if(r.isInitialized)return r.value[f](y,D,C);{const P={listener:[y,D,C],disposable:void 0},j=k.push(P);return(0,O.$Sc)(()=>{j(),P.disposable?.dispose()})}}}if(f in o)return o[f];const g=r.value;let w=g[f];return typeof w!="function"||(w=w.bind(g),o[f]=w),w},set(o,f,g){return r.value[f]=g,!0},getPrototypeOf(o){return c.prototype}})}else{const t=this.o(c,n,a);return s.add(t),t}}y(d,c){if(c&&console.warn(d),this.j)throw new Error(d)}}e.$fr=p;var S;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(S||(S={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,c){return d?new v(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(d,c){return d?new v(1,c.name):v.c}static{this.f=0}constructor(d,c){this.type=d,this.name=c,this.g=Date.now(),this.h=[]}branch(d,c){const n=new v(3,d.toString());return this.h.push([d,c,n]),n}stop(){const d=Date.now()-this.g;v.f+=d;let c=!1;function n(a,s){const t=[],u=new Array(a+1).join("	");for(const[r,o,f]of s.h)if(o&&f){c=!0,t.push(`${u}CREATES -> ${r}`);const g=n(a+1,f);g&&t.push(g)}else t.push(`${u}uses -> ${r}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(d>2||c)&&v.all.add(i.join(`
`))}}e.$gr=v}),define(ke[11],De([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=h,e.log=c,e.$gk=w,e.$hk=k,e.$ik=m,e.$jk=y,e.$5j=(0,S.$yi)("logService"),e.$6j=(0,S.$yi)("loggerService");function v(){return new Date().toISOString()}function h(D){return(0,A.$cg)(D)}var d;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$8j=d.Info;function c(D,C,P){switch(C){case d.Trace:D.trace(P);break;case d.Debug:D.debug(P);break;case d.Info:D.info(P);break;case d.Warning:D.warn(P);break;case d.Error:D.error(P);break;case d.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(D,C=!1){let P="";for(let j=0;j<D.length;j++){let T=D[j];if(T instanceof Error&&(T=(0,L.$jj)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}P+=(j>0?" ":"")+T}return P}class i extends R.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new O.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==d.Off&&this.b<=C}}e.$0j=i;class a extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(d.Trace)&&this.g(d.Trace,n([C,...P],!0))}debug(C,...P){this.f(d.Debug)&&this.g(d.Debug,n([C,...P]))}info(C,...P){this.f(d.Info)&&this.g(d.Info,n([C,...P]))}warn(C,...P){this.f(d.Warning)&&this.g(d.Warning,n([C,...P]))}error(C,...P){if(this.f(d.Error))if(C instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=C.stack,this.g(d.Error,n(j))}else this.g(d.Error,n([C,...P]))}flush(){}}e.$$j=a;class s extends i{constructor(C=e.$8j){super(),this.setLevel(C),this.g=!$.$i}trace(C,...P){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...P):console.log(`[main ${v()}]`,C,...P))}debug(C,...P){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...P):console.log(`[main ${v()}]`,C,...P))}info(C,...P){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...P):console.log(`[main ${v()}]`,C,...P))}warn(C,...P){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...P):console.warn(`[main ${v()}]`,C,...P))}error(C,...P){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...P):console.error(`[main ${v()}]`,C,...P))}flush(){}}e.$_j=s;class t extends i{constructor(C=e.$8j,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$ak=t;class u extends i{constructor(C,P=e.$8j){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(C),...P])}debug(C,...P){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(C),...P])}info(C,...P){this.f(d.Info)&&this.g.log(d.Info,[this.h(C),...P])}warn(C,...P){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(C),...P])}error(C,...P){this.f(d.Error)&&this.g.log(d.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,L.$jj)(C,this.f(d.Trace))}flush(){}}e.$bk=u;class r extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const j of this.g)j.trace(C,...P)}debug(C,...P){for(const j of this.g)j.debug(C,...P)}info(C,...P){for(const j of this.g)j.info(C,...P)}warn(C,...P){for(const j of this.g)j.warn(C,...P)}error(C,...P){for(const j of this.g)j.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ck=r;class o extends R.$Uc{constructor(C,P,j){if(super(),this.h=C,this.j=P,this.b=new b.$Ac,this.c=this.B(new O.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$fe),this.onDidChangeVisibility=this.g.event,j)for(const T of j)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,A.$$f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const j=this.n(C),T=(0,A.$$f)(C)?C:P?.id??(0,M.$mj)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const N=P?.logLevel==="always"?d.Trace:P?.logLevel;z||(z=this.s(j,N??this.getLogLevel(j)??this.h,{...P,id:T}));const F={logger:z,info:{resource:j,id:T,logLevel:N,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(F.info),this.b.set(j,F),z}n(C){return(0,A.$$f)(C)?(0,E.$_g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(I.URI.isUri(C)){const j=C,T=P,z=this.b.get(j);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([j,T]))}else{this.h=C;for(const[j,T]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const j=this.m(C);j&&P!==!j.info.hidden&&(j.info.hidden=!P,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=o;class f{constructor(){this.onDidChangeLogLevel=new O.$fe().event}setLevel(C){}getLevel(){return d.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$ek=f;class g extends f{}e.$fk=g;function w(D){if(D.verbose)return d.Trace;if(typeof D.logLevel=="string"){const C=y(D.logLevel.toLowerCase());if(C!==void 0)return C}return e.$8j}function k(D){switch(D){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function m(D){switch(D){case d.Trace:return{original:"Trace",value:l.localize(0,null)};case d.Debug:return{original:"Debug",value:l.localize(1,null)};case d.Info:return{original:"Info",value:l.localize(2,null)};case d.Warning:return{original:"Warning",value:l.localize(3,null)};case d.Error:return{original:"Error",value:l.localize(4,null)};case d.Off:return{original:"Off",value:l.localize(5,null)}}}function y(D){switch(D){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$kk=new p.$Pj("logLevel",k(d.Info))}),define(ke[264],De([1,0,19,7,13,4,31,3,16,65,11]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class I extends b.$Uc{constructor(S,v){super(),this.a=S,this.b=v,this.c=this.B(new M.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$wh(0)),this.w=[],this.y=this.B(new L.$wh(0))}watch(S,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(S,v):this.z(S,v)}n(S,v){const h={path:this.J(S),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},d=(0,l.$Tb)(this.j,h);return this.r(),(0,b.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(S=>(0,O.$1)(S))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,E.$Rq)(v)),v=>this.G(v),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)})));const S=this.b?.watcher?.recursive?.usePolling;if(S===!0)for(const v of this.j)(0,E.$Nq)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const v of this.j)(0,E.$Nq)(v)&&S.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(S,v){const h={path:this.J(S),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},d=(0,l.$Tb)(this.w,h);return this.C(),(0,b.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(S=>(0,O.$1)(S))}D(){return this.u||(this.u=this.B(this.F(S=>this.c.fire((0,E.$Rq)(S)),S=>this.G(S),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)}))),this.u.watch(this.w)}G(S){S.type==="error"&&this.g.fire(S.message),this.H(S)}H(S){this.a[S.type](S.message)}I(S){return(0,$.$hc)(S.fsPath)}J(S){const v=this.I(S);return(0,R.$Ag)(v)}}e.$Xq=I}),define(ke[265],De([1,0,53,402,7,27,21,4,31,3,16,12,23,98,32,217,33,257,264,47,262,261]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0,(()=>{try{(0,L.gracefulify)(l)}catch(u){console.error(`Error enabling graceful-fs: ${(0,i.$jj)(u)}`)}})();class t extends n.$Xq{static{this.L=!1}constructor(r,o){super(r,o),this.onDidChangeCapabilities=b.Event.None,this.P=new M.$Ac(f=>p.$3g.getComparisonKey(f)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,I.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:o,symbolicLink:f}=await v.SymlinkSupport.stat(this.I(r));return{type:this.O(o,f),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size,permissions:o.mode&128?void 0:d.FilePermission.Locked}}catch(o){throw this.hb(o)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const o=await v.Promises.readdir(this.I(r),{withFileTypes:!0}),f=[];return await Promise.all(o.map(async g=>{try{let w;g.isSymbolicLink()?w=(await this.stat((0,p.$_g)(r,g.name))).type:w=this.O(g),f.push([g.name,w])}catch(w){this.a.trace(w)}})),f}catch(o){throw this.hb(o)}}O(r,o){let f;return o?.dangling?f=d.FileType.Unknown:r.isFile()?f=d.FileType.File:r.isDirectory()?f=d.FileType.Directory:f=d.FileType.Unknown,o&&(f|=d.FileType.SymbolicLink),f}async Q(r){const o=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let f;for(;f=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await f.wait();const g=new O.$xh;return this.P.set(r,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,E.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.P.get(r)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),g.open()})}async readFile(r,o){let f;try{o?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),f=await this.Q(r));const g=this.I(r);return await v.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{f?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,o,f){const g=(0,S.$ve)(w=>R.$He.concat(w.map(k=>R.$He.wrap(k))).buffer);return(0,c.$Kq)(this,r,g,w=>w.buffer,{...o,bufferSize:256*1024},f),g}async writeFile(r,o,f){return f?.atomic!==!1&&f?.atomic?.postfix&&await this.S(r)?this.U(r,(0,p.$_g)((0,p.$$g)(r),`${(0,p.$9g)(r)}${f.atomic.postfix}`),o,f):this.W(r,o,f)}async S(r){try{const o=this.I(r),{symbolicLink:f}=await v.SymlinkSupport.stat(o);if(f)return!1}catch{}return!0}async U(r,o,f,g){const w=new E.$Tc;try{w.add(await this.Q(r)),w.add(await this.Q(o)),await this.W(o,f,g,!0);try{await this.rename(o,r,{overwrite:!0})}catch(k){try{await this.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{w.dispose()}}async W(r,o,f,g){let w;try{const k=this.I(r);if(!f.create||!f.overwrite){if(await v.Promises.exists(k)){if(!f.overwrite)throw(0,d.$fl)((0,h.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,d.$fl)((0,h.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:f.unlock},g),await this.write(w,0,o,0,o.byteLength)}catch(k){throw await this.ib(r,k)}finally{typeof w=="number"&&await this.close(w)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,o,f){const g=this.I(r);let w;(0,d.$6k)(o)&&!f&&(w=await this.Q(r));let k;try{if((0,d.$6k)(o)&&o.unlock)try{const{stat:y}=await v.SymlinkSupport.stat(g);y.mode&128||await v.Promises.chmod(g,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let m;if((0,d.$6k)(o)){if(I.$i)try{await v.Promises.truncate(g,0),m="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}m||(m="w")}else m="r";k=await v.Promises.open(g,m)}catch(m){throw w?.dispose(),(0,d.$6k)(o)?await this.ib(r,m):this.hb(m)}if(this.X.set(k,0),(0,d.$6k)(o)&&this.Z.set(k,r),w){const m=this.Y.get(k);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${g})`),this.Y.set(k,w),m&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${g})`),m.dispose())}return k}async close(r){const o=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await v.Promises.fdatasync(r)}catch(f){t.configureFlushOnWrite(!1),this.a.error(f)}return await v.Promises.close(r)}catch(f){throw this.hb(f)}finally{o&&(this.Y.get(r)===o&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),o.dispose())}}async read(r,o,f,g,w){const k=this.ab(r,o);let m=null;try{m=(await v.Promises.read(r,f,g,w,k)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(r,k,m)}return m}ab(r,o){return o===this.X.get(r)?null:o}bb(r,o,f){const g=this.X.get(r);typeof g=="number"&&(typeof o=="number"||(typeof f=="number"?this.X.set(r,g+f):this.X.delete(r)))}async write(r,o,f,g,w){return(0,O.$Sh)(()=>this.cb(r,o,f,g,w),100,3)}async cb(r,o,f,g,w){const k=this.ab(r,o);let m=null;try{m=(await v.Promises.write(r,f,g,w,k)).bytesWritten}catch(y){throw await this.ib(this.Z.get(r),y)}finally{this.bb(r,k,m)}return m}async mkdir(r){try{await v.Promises.mkdir(this.I(r))}catch(o){throw this.hb(o)}}async delete(r,o){try{const f=this.I(r);if(o.recursive){let g;o?.atomic!==!1&&o.atomic.postfix&&(g=(0,A.$jc)((0,A.$mc)(f),`${(0,A.$nc)(f)}${o.atomic.postfix}`)),await v.Promises.rm(f,v.RimRafMode.MOVE,g)}else try{await v.Promises.unlink(f)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let w=!1;try{const{stat:k,symbolicLink:m}=await v.SymlinkSupport.stat(f);w=k.isDirectory()&&!m}catch{}if(w)await v.Promises.rmdir(f);else throw g}else throw g}}catch(f){throw this.hb(f)}}async rename(r,o,f){const g=this.I(r),w=this.I(o);if(g!==w)try{await this.db(r,o,"move",f.overwrite),await v.Promises.rename(g,w)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,h.localize)(2,null,(0,A.$nc)(g),(0,A.$nc)((0,A.$mc)(w)),k.toString()))),this.hb(k)}}async copy(r,o,f){const g=this.I(r),w=this.I(o);if(g!==w)try{await this.db(r,o,"copy",f.overwrite),await v.Promises.copy(g,w,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,h.localize)(3,null,(0,A.$nc)(g),(0,A.$nc)((0,A.$mc)(w)),k.toString()))),this.hb(k)}}async db(r,o,f,g){const w=this.I(r),k=this.I(o);let m=!1;if(!!(this.capabilities&1024)||(m=(0,$.$wg)(w,k,!0)),m){if(f==="copy")throw(0,d.$fl)((0,h.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(f==="move")return}const D=await this.N(r);if(!D)throw(0,d.$fl)((0,h.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(o);if(C){if(!g)throw(0,d.$fl)((0,h.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);D.type&d.FileType.File&&C.type&d.FileType.File||await this.delete(o,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,o){return this.eb(r,o,!1)}async eb(r,o,f){const g=this.I(r),w=this.I(o),k=!!(this.capabilities&1024);if((0,$.$wg)(g,w,!k))return;const m=new E.$Tc;try{m.add(await this.Q(r)),m.add(await this.Q(o)),f&&await v.Promises.mkdir((0,A.$mc)(w),{recursive:!0}),await v.Promises.copyFile(g,w)}catch(y){if(y.code==="ENOENT"&&!f)return this.eb(r,o,!0);throw this.hb(y)}finally{m.dispose()}}t(r,o,f){return new a.$5q(g=>r(g),g=>o(g),f)}F(r,o,f){return new s.$br(g=>r(g),g=>o(g),f)}hb(r){if(r instanceof d.$el)return r;let o=r,f;switch(r.code){case"ENOENT":f=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":o=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,f=d.FileSystemProviderErrorCode.Unknown;break;default:f=d.FileSystemProviderErrorCode.Unknown}return(0,d.$fl)(o,f)}async ib(r,o){let f=this.hb(o);if(r&&f.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await v.SymlinkSupport.stat(this.I(r));g.mode&128||(f=(0,d.$fl)(o,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return f}}e.$cr=t}),define(ke[266],De([1,0,3,11]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=void 0;class O extends l.$Uc{constructor(R,b=[]){super(),this.a=new L.$ck([R,...b]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$0P=O}),define(ke[267],De([1,0,33,11]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;var O;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(O||(O={}));async function M(E,A,I,p,S){try{const v=await new Promise((d,c)=>{he(["@vscode/spdlog"],d,c)});v.setFlushOn(O.Trace);const h=await v.createAsyncRotatingLogger(E,A,I,p);return S?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(v){console.error(v)}return null}function R(E,A,I){switch(A){case L.LogLevel.Trace:E.trace(I);break;case L.LogLevel.Debug:E.debug(I);break;case L.LogLevel.Info:E.info(I);break;case L.LogLevel.Warning:E.warn(I);break;case L.LogLevel.Error:E.error(I);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(E,A){switch(A){case L.LogLevel.Trace:E.setLevel(O.Trace);break;case L.LogLevel.Debug:E.setLevel(O.Debug);break;case L.LogLevel.Info:E.setLevel(O.Info);break;case L.LogLevel.Warning:E.setLevel(O.Warning);break;case L.LogLevel.Error:E.setLevel(O.Error);break;case L.LogLevel.Off:E.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends L.$$j{constructor(A,I,p,S,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,I,p,S),this.B(this.onDidChangeLogLevel(h=>{this.r&&b(this.r,h)}))}async s(A,I,p,S){const v=p?6:1,h=30/v*l.$Al.MB,d=await M(A,I,h,v,S);if(d){this.r=d,b(this.r,this.getLevel());for(const{level:c,message:n}of this.m)R(this.r,c,n);this.m=[]}}g(A,I){this.r?R(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$YP=$}),define(ke[139],De([1,0,41,219,5]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function E(v,h){return h-v}$.compare=E;const A=Object.create(null);A[$.Error]=(0,L.localize)(0,null),A[$.Warning]=(0,L.localize)(1,null),A[$.Info]=(0,L.localize)(2,null);function I(v){return A[v]||""}$.toString=I;function p(v){switch(v){case l.default.Error:return $.Error;case l.default.Warning:return $.Warning;case l.default.Info:return $.Info;case l.default.Ignore:return $.Hint}}$.fromSeverity=p;function S(v){switch(v){case $.Error:return l.default.Error;case $.Warning:return l.default.Warning;case $.Info:return l.default.Info;case $.Hint:return l.default.Ignore}}$.toSeverity=S}(R||(e.MarkerSeverity=R={}));var b;(function($){const E="";function A(p){return I(p,!0)}$.makeKey=A;function I(p,S){const v=[E];return p.source?v.push(p.source.replace("\xA6","\\\xA6")):v.push(E),p.code?typeof p.code=="string"?v.push(p.code.replace("\xA6","\\\xA6")):v.push(p.code.value.replace("\xA6","\\\xA6")):v.push(E),p.severity!==void 0&&p.severity!==null?v.push(R.toString(p.severity)):v.push(E),p.message&&S?v.push(p.message.replace("\xA6","\\\xA6")):v.push(E),p.startLineNumber!==void 0&&p.startLineNumber!==null?v.push(p.startLineNumber.toString()):v.push(E),p.startColumn!==void 0&&p.startColumn!==null?v.push(p.startColumn.toString()):v.push(E),p.endLineNumber!==void 0&&p.endLineNumber!==null?v.push(p.endLineNumber.toString()):v.push(E),p.endColumn!==void 0&&p.endColumn!==null?v.push(p.endColumn.toString()):v.push(E),v.push(E),v.join("\xA6")}$.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$0t=(0,O.$yi)("markerService")}),define(ke[268],De([1,0,4,41,5]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$aw=e.Severity=void 0,e.$bw=b,e.Severity=L.default,e.$aw=(0,O.$yi)("notificationService");var M;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function b(I){if(I){const p=I;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var $;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new A,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$cw=E;class A{infinite(){}done(){}total(p){}worked(p){}}e.$dw=A}),define(ke[269],De([1,0,52]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.context<"u"){const M=O.context.configuration();if(M)L=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,l.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:M.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ke[108],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,l.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(he,e){return function(l,L){e(l,L,he)}};define(ke[109],De([1,0,7,22,3,5]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.ProgressLocation=e.$ew=void 0,e.$ew=(0,M.$yi)("progressService");var R;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$fw=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$gw=b;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const S=this.d;this.d=()=>{S?.(),p()}}):Promise.resolve()}}e.$hw=$;let E=class extends O.$Uc{constructor(p,S){super(),this.a=new l.$Vh,S.withProgress(p,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,O.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$iw=E,e.$iw=E=Je([We(1,e.$ew)],E);class A extends O.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new O.$Tc)}start(p){this.stop();const S=++this.a,v=new L.$qe;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,O.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,O.$Sc)(()=>v.cancel())),this.b.add((0,O.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:v.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$jw=A,e.$kw=(0,M.$yi)("editorProgressService")}),define(ke[36],De([1,0,62,18]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class O{constructor(){this.a=new Map}add(R,b){l.ok(L.$$f(R)),l.ok(L.$ag(b)),l.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$fo=new O}),define(ke[110],De([1,0,4,36]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function O(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class M{constructor(){this.b=new l.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,E){this.a[O($)]=E,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;L.$fo.add(e.$go.JSONContribution,R)}),define(ke[66],De([1,0,19,4,18,208,55,110,36]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=h,e.$wo=d,e.$xo=c,e.$yo=i,e.$zo=a;var E;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ko={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const I=$.$fo.as(b.$go.JSONContribution);class p{constructor(){this.h=new Set,this.i=new L.$fe,this.onDidSchemaChange=this.i.event,this.j=new L.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const r=new Set;this.n(t,u,r),I.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const u=new Set;this.o(t,u),I.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const r=new Set;this.o(u,r),this.n(t,!1,r),I.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const r=[];for(const{overrides:o,source:f}of t)for(const g in o)if(u.add(g),e.$uo.test(g)){const w=this.a.get(g),k=w?.valuesSources??new Map;if(f)for(const C of Object.keys(o[g]))k.set(C,f);const m={...w?.value||{},...o[g]};this.a.set(g,{source:f,value:m,valuesSources:k});const y=(0,R.$cj)(g),D={type:"object",default:m,description:M.localize(1,null,y),$ref:e.$ro,defaultDefaultValue:m,source:O.$$f(f)?void 0:f,defaultValueSource:f};r.push(...h(g)),this.d[g]=D,this.b.properties[g]=D}else{this.a.set(g,{value:o[g],source:f});const w=this.d[g];w&&(this.w(g,w),this.r(g,w))}this.m(r)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:r,source:o}of t)for(const f in r){const g=this.a.get(f),w=O.$$f(o)?o:o?.id,k=O.$$f(g?.source)?g?.source:g?.source?.id;if(w===k)if(u.add(f),this.a.delete(f),e.$uo.test(f))delete this.d[f],delete this.b.properties[f];else{const m=this.d[f];m&&(this.w(f,m),this.r(f,m))}}this.u()}deltaConfiguration(t){let u=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,r){t.forEach(o=>{this.p(o,u,o.extensionInfo,o.restrictedProperties,void 0,r),this.c.push(o),this.q(o)})}o(t,u){const r=o=>{if(o.properties)for(const f in o.properties){u.add(f);const g=this.d[f];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[f],this.s(f,o.properties[f])}o.allOf?.forEach(f=>r(f))};for(const o of t){r(o);const f=this.c.indexOf(o);f!==-1&&this.c.splice(f,1)}}p(t,u=!0,r,o,f=3,g){f=O.$hg(t.scope)?f:t.scope;const w=t.properties;if(w)for(const m in w){const y=w[m];if(u&&i(m,y)){delete w[m];continue}if(y.source=r,y.defaultDefaultValue=w[m].default,this.w(m,y),e.$uo.test(m)?y.scope=void 0:(y.scope=O.$hg(y.scope)?f:y.scope,y.restricted=O.$hg(y.restricted)?!!o?.includes(m):y.restricted),w[m].hasOwnProperty("included")&&!w[m].included){this.f[m]=w[m],delete w[m];continue}else this.d[m]=w[m],w[m].policy?.name&&this.e.set(w[m].policy.name,m);!w[m].deprecationMessage&&w[m].markdownDeprecationMessage&&(w[m].deprecationMessage=w[m].markdownDeprecationMessage),g.add(m)}const k=t.allOf;if(k)for(const m of k)this.p(m,u,r,o,f,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=r=>{const o=r.properties;if(o)for(const g in o)this.r(g,o[g]);r.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$lo.properties[t]=u,u.scope){case 1:e.$mo.properties[t]=u;break;case 2:e.$no.properties[t]=u;break;case 6:e.$oo.properties[t]=u;break;case 3:e.$po.properties[t]=u;break;case 4:e.$qo.properties[t]=u;break;case 5:e.$qo.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$lo.properties[t],u.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$ro};this.w(u,r),e.$lo.properties[u]=r,e.$mo.properties[u]=r,e.$no.properties[u]=r,e.$oo.properties[u]=r,e.$po.properties[u]=r,e.$qo.properties[u]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,u){const r=this.a.get(t);let o=r?.value,f=r?.source;O.$fg(o)&&(o=u.defaultDefaultValue,f=void 0),O.$fg(o)&&(o=c(u.type)),u.default=o,u.defaultValueSource=f}}const S="\\[([^\\]]+)\\]",v=new RegExp(S,"g");e.$to=`^(${S})+$`,e.$uo=new RegExp(e.$to);function h(s){const t=[];if(e.$uo.test(s)){let u=v.exec(s);for(;u?.length;){const r=u[1].trim();r&&t.push(r),u=v.exec(s)}}return(0,l.$Mb)(t)}function d(s){return s.reduce((t,u)=>`${t}[${u}]`,"")}function c(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new p;$.$fo.add(e.$ko.Configuration,n);function i(s,t){return s.trim()?e.$uo.test(s)?M.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?M.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function a(){const s=[],t=n.getConfigurationProperties();for(const u of Object.keys(t))s.push([u,t[u].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ke[270],De([1,0,19,4,166,3,27,24,18,2,55,66,36]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=i;function S(u){return Object.isFrozen(u)?u:b.$6n(u)}class v{static createEmptyModel(r){return new v({},[],[],void 0,r)}constructor(r,o,f,g,w){this.b=r,this.c=o,this.d=f,this.raw=g,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof v)return o;const f=new h("",this.f);return f.parseRaw(o),f.configurationModel});this.g=r.reduce((o,f)=>f===o?f:o.merge(f),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$aj)(this.contents,r):this.contents}inspect(r,o){const f=this;return{get value(){return S(f.rawConfiguration.getValue(r))},get override(){return o?S(f.rawConfiguration.getOverrideValue(r,o)):void 0},get merged(){return S(o?f.rawConfiguration.override(o).getValue(r):f.rawConfiguration.getValue(r))},get overrides(){const g=[];for(const{contents:w,identifiers:k,keys:m}of f.rawConfiguration.overrides){const y=new v(w,m,[],void 0,f.f).getValue(r);y!==void 0&&g.push({identifiers:k,value:y})}return g.length?S(g):void 0}}}getOverrideValue(r,o){const f=this.j(o);return f?r?(0,A.$aj)(f,r):f:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const f of this.overrides)f.identifiers.includes(r)&&o.push(...f.keys);return l.$Mb(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return l.$Mb(r)}override(r){let o=this.a.get(r);return o||(o=this.h(r),this.a.set(r,o)),o}merge(...r){const o=b.$5n(this.contents),f=b.$5n(this.overrides),g=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const k of r)if(w.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(o,k.contents);for(const m of k.overrides){const[y]=f.filter(D=>l.$ub(D.identifiers,m.identifiers));y?(this.i(y.contents,m.contents),y.keys.push(...m.keys),y.keys=l.$Mb(y.keys)):f.push(b.$5n(m))}for(const m of k.keys)g.indexOf(m)===-1&&g.push(m)}return new v(o,g,f,w.every(k=>k instanceof v)?void 0:w,this.f)}h(r){const o=this.j(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const f={};for(const g of l.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let w=this.contents[g];const k=o[g];k&&(typeof w=="object"&&typeof k=="object"?(w=b.$5n(w),this.i(w,k)):w=k),f[g]=w}return new v(f,this.keys,this.overrides,void 0,this.f)}i(r,o){for(const f of Object.keys(o)){if(f in r&&$.$ag(r[f])&&$.$ag(o[f])){this.i(r[f],o[f]);continue}r[f]=b.$5n(o[f])}}j(r){let o=null,f=null;const g=w=>{w&&(f?this.i(f,w):f=b.$5n(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?o=w.contents:w.identifiers.includes(r)&&g(w.contents);return g(o),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,o){this.k(r,o,!0)}setValue(r,o){this.k(r,o,!1)}removeValue(r){const o=this.keys.indexOf(r);o!==-1&&(this.keys.splice(o,1),(0,A.$_i)(this.contents,r),I.$uo.test(r)&&this.overrides.splice(this.overrides.findIndex(f=>l.$ub(f.identifiers,(0,I.$vo)(r))),1))}k(r,o,f){(0,A.$$i)(this.contents,r,o,g=>this.f.error(g)),f=f||this.keys.indexOf(r)===-1,f&&this.keys.push(r),I.$uo.test(r)&&this.overrides.push({identifiers:(0,I.$vo)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$0i)(this.contents[r],g=>this.f.error(g))})}}e.$Ao=v;class h{constructor(r,o){this.f=r,this.g=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,o){if(!$.$hg(r)){const f=this.h(r);this.parseRaw(f,o)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,o){this.a=r;const{contents:f,keys:g,overrides:w,restricted:k,hasExcludedProperties:m}=this.i(r,o);this.b=new v(f,g,w,m?[r]:void 0,this.g),this.c=k||[]}h(r){let o={},f=null,g=[];const w=[],k=[];function m(D){Array.isArray(g)?g.push(D):f!==null&&(g[f]=D)}const y={onObjectBegin:()=>{const D={};m(D),w.push(g),g=D,f=null},onObjectProperty:D=>{f=D},onObjectEnd:()=>{g=w.pop()},onArrayBegin:()=>{const D=[];m(D),w.push(g),g=D,f=null},onArrayEnd:()=>{g=w.pop()},onLiteralValue:m,onError:(D,C,P)=>{k.push({error:D,offset:C,length:P})}};if(r)try{O.$Sn(r,y),o=g[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return o}i(r,o){const f=p.$fo.as(I.$ko.Configuration).getConfigurationProperties(),g=this.j(r,f,!0,o);r=g.raw;const w=(0,A.$0i)(r,y=>this.g.error(`Conflict in settings file ${this.f}: ${y}`)),k=Object.keys(r),m=this.l(r,y=>this.g.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:w,keys:k,overrides:m,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}j(r,o,f,g){let w=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const k={},m=[];for(const y in r)if(I.$uo.test(y)&&f){const D=this.j(r[y],o,!1,g);k[y]=D.raw,w=w||D.hasExcludedProperties,m.push(...D.restricted)}else{const D=o[y],C=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&m.push(y),!g.exclude?.includes(y)&&(g.include?.includes(y)||(C===void 0||g.scopes===void 0||g.scopes.includes(C))&&!(g.skipRestricted&&D?.restricted))?k[y]=r[y]:w=!0}return{raw:k,restricted:m,hasExcludedProperties:w}}l(r,o){const f=[];for(const g of Object.keys(r))if(I.$uo.test(g)){const w={};for(const k in r[g])w[k]=r[g][k];f.push({identifiers:(0,I.$vo)(g),keys:Object.keys(w),contents:(0,A.$0i)(w,o)})}return f}}e.$Bo=h;class d extends M.$Uc{constructor(r,o,f,g,w){super(),this.c=r,this.f=o,this.g=g,this.h=w,this.b=this.B(new L.$fe),this.onDidChange=this.b.event,this.a=new h(this.c.toString(),w),this.B(this.g.watch(f.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&f.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=d;class c{constructor(r,o,f,g,w,k,m,y,D,C,P,j,T){this.a=r,this.b=o,this.c=f,this.overrideIdentifiers=g,this.d=w,this.f=k,this.g=m,this.h=y,this.i=D,this.j=C,this.k=P,this.l=j,this.m=T}get value(){return S(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(r,o,f,g,w,k,m,y,D,C){this.j=r,this.l=o,this.m=f,this.n=g,this.p=w,this.q=k,this.r=m,this.s=y,this.t=D,this.u=C,this.h=null,this.i=new R.$Ac,this.v=null}getValue(r,o,f){return this.w(r,o,f).getValue(r)}updateValue(r,o,f={}){let g;f.resource?(g=this.t.get(f.resource),g||(g=v.createEmptyModel(this.u),this.t.set(f.resource,g))):g=this.s,o===void 0?g.removeValue(r):g.setValue(r,o),f.resource||(this.h=null)}inspect(r,o,f){const g=this.w(r,o,f),w=this.A(o.resource,f),k=o.resource?this.t.get(o.resource)||this.s:this.s,m=new Set;for(const y of g.overrides)for(const D of y.identifiers)g.getOverrideValue(r,D)!==void 0&&m.add(D);return new c(r,o,g.getValue(r),m.size?[...m]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this.q:void 0,w||void 0,k)}keys(r){const o=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,o){this.r.set(r,o),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const f=[];if(!o){const{added:g,updated:w,removed:k}=s(this.j,r);o=[...g,...w,...k]}for(const g of o)for(const w of(0,I.$vo)(g)){const k=this.j.getKeysForOverrideIdentifier(w),m=r.getKeysForOverrideIdentifier(w),y=[...m.filter(D=>k.indexOf(D)===-1),...k.filter(D=>m.indexOf(D)===-1),...k.filter(D=>!b.$9n(this.j.override(w).getValue(D),r.override(w).getValue(D)))];f.push([w,y])}return this.updateDefaultConfiguration(r),{keys:o,overrides:f}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:f,removed:g}=s(this.l,r),w=[...o,...f,...g];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:f,removed:g,overrides:w}=s(this.applicationConfiguration,r),k=[...o,...f,...g];return k.length&&this.updateApplicationConfiguration(r),{keys:k,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:f,removed:g,overrides:w}=s(this.localUserConfiguration,r),k=[...o,...f,...g];return k.length&&this.updateLocalUserConfiguration(r),{keys:k,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:f,removed:g,overrides:w}=s(this.remoteUserConfiguration,r),k=[...o,...f,...g];return k.length&&this.updateRemoteUserConfiguration(r),{keys:k,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:f,removed:g,overrides:w}=s(this.workspaceConfiguration,r),k=[...o,...f,...g];return k.length&&this.updateWorkspaceConfiguration(r),{keys:k,overrides:w}}compareAndUpdateFolderConfiguration(r,o){const f=this.folderConfigurations.get(r),{added:g,updated:w,removed:k,overrides:m}=s(f,o),y=[...g,...w,...k];return(y.length||!f)&&this.updateFolderConfiguration(r,o),{keys:y,overrides:m}}compareAndDeleteFolderConfiguration(r){const o=this.folderConfigurations.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:f,updated:g,removed:w,overrides:k}=s(o,void 0);return{keys:[...f,...g,...w],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,o,f){let g=this.x(o,f);return o.overrideIdentifier&&(g=g.override(o.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(g=g.merge(this.l)),g}x({resource:r},o){let f=this.y();if(o&&r){const g=o.getFolder(r);g&&(f=this.z(g.uri)||f);const w=this.t.get(r);w&&(f=f.merge(w))}return f}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let o=this.i.get(r);if(!o){const f=this.y(),g=this.r.get(r);g?(o=f.merge(g),this.i.set(r,o)):o=f}return o}A(r,o){if(o&&r){const f=o.getFolder(r);if(f)return this.r.get(f.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,o)=>{const{contents:f,overrides:g,keys:w}=this.r.get(o);return r.push([o,{contents:f,overrides:g,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(o=>r.add(o)),this.userConfiguration.keys.forEach(o=>r.add(o)),this.q.keys.forEach(o=>r.add(o)),this.r.forEach(o=>o.keys.forEach(f=>r.add(f))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.q.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.r.forEach(o=>o.getAllOverrideIdentifiers().forEach(f=>r.add(f))),[...r.values()]}D(r){const o=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(f=>o.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(f=>o.add(f)),this.q.getKeysForOverrideIdentifier(r).forEach(f=>o.add(f)),this.r.forEach(f=>f.getKeysForOverrideIdentifier(r).forEach(g=>o.add(g))),[...o.values()]}static parse(r,o){const f=this.E(r.defaults,o),g=this.E(r.policy,o),w=this.E(r.application,o),k=this.E(r.user,o),m=this.E(r.workspace,o),y=r.folders.reduce((D,C)=>(D.set(E.URI.revive(C[0]),this.E(C[1],o)),D),new R.$Ac);return new n(f,g,w,k,v.createEmptyModel(o),m,y,v.createEmptyModel(o),new R.$Ac,o)}static E(r,o){return new v(r.contents,r.keys,r.overrides,void 0,o)}}e.$Do=n;function i(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,o=new Map;for(const g of u)g.keys.forEach(w=>r.add(w)),g.overrides.forEach(([w,k])=>{const m=(0,R.$xc)(o,w,new Set);k.forEach(y=>m.add(y))});const f=[];return o.forEach((g,w)=>f.push([w,[...g.values()]])),{keys:[...r.values()],overrides:f}}class a{constructor(r,o,f,g,w){this.change=r,this.f=o,this.g=f,this.h=g,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const m of k)this.affectedKeys.add(m);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,o){const f=this.a+r,g=this.d.indexOf(f);if(g<0)return!1;const w=g+f.length;if(w>=this.d.length)return!1;const k=this.d.charCodeAt(w);if(k!==this.b&&k!==this.c)return!1;if(o){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.f?.workspace):void 0,y=this.g.getValue(r,o,this.h);return!b.$9n(m,y)}return!0}}e.$Fo=a;function s(u,r){const{added:o,removed:f,updated:g}=t(r?.rawConfiguration,u?.rawConfiguration),w=[],k=u?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const y=m.filter(D=>!k.includes(D));for(const D of y)w.push([D,r.getKeysForOverrideIdentifier(D)])}if(u){const y=k.filter(D=>!m.includes(D));for(const D of y)w.push([D,u.getKeysForOverrideIdentifier(D)])}if(r&&u){for(const y of k)if(m.includes(y)){const D=t({contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)},{contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)});w.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:o,removed:f,updated:g,overrides:w}}function t(u,r){const o=u?r?u.keys.filter(w=>r.keys.indexOf(w)===-1):[...u.keys]:[],f=r?u?r.keys.filter(w=>u.keys.indexOf(w)===-1):[...r.keys]:[],g=[];if(u&&r){for(const w of r.keys)if(u.keys.indexOf(w)!==-1){const k=(0,A.$aj)(r.contents,w),m=(0,A.$aj)(u.contents,w);b.$9n(k,m)||g.push(w)}}return{added:o,removed:f,updated:g}}}),define(ke[271],De([1,0,21,4,3,83]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gvb=e.$Evb=e.$Dvb=void 0,e.$Fvb=b;const R=(E,A,I)=>{const p=new Uint8Array(16);for(let h=0;h<16;h++)p[h]=Math.round(Math.random()*256);const S=(0,l.$2e)(l.$He.wrap(p));return[`GET ws://localhost${E}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$Dvb=R,e.$Evb=l.$He.fromString(`\r
\r
`);async function b(E,A,I,p,S){E.write(l.$He.fromString((0,e.$Dvb)(A,I,p)));const v=new O.$Tc;try{return await new Promise((h,d)=>{let c;v.add(E.onData(n=>{c?c=l.$He.concat([c,n],c.byteLength+n.byteLength):c=n;const i=c.indexOf(e.$Evb);if(i===-1)return;h(E),E.pauseData();const a=c.slice(i+e.$Evb.byteLength);a.byteLength&&S.onData.fire(a)})),v.add(E.onClose(n=>d(n??new Error("socket closed")))),v.add(E.onEnd(()=>d(new Error("socket ended"))))})}catch(h){throw E.dispose(),h}finally{v.dispose()}}class $ extends O.$Uc{constructor(A,I){super(),this.g=A,this.a=this.B(new L.$ie),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new L.$fe),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){M.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Gvb=$}),define(ke[67],De([1,0,13,5]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=E,e.$Jl=(0,L.$yi)("remoteAuthorityResolverService");var O;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class M{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=M;class R{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=R;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends l.$bb{static isNotAvailable(I){return I instanceof $&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof $&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof $&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof $&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof $&&I.isHandled}constructor(I,p=b.Unknown,S){super(I),this._message=I,this._code=p,this._detail=S,this.isHandled=p===b.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ml=$;function E(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}}),define(ke[272],De([1,0,7,21,22,13,4,3,15,59,40,30,83,67]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Sl=k,e.$Tl=m,e.$Ul=D;const v=30*1e3;var h;(function(ee){ee[ee.Management=1]="Management",ee[ee.ExtensionHost=2]="ExtensionHost",ee[ee.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function d(ee){switch(ee){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(ee){const B=new O.$qe;return setTimeout(()=>B.cancel(),ee),B.token}function n(ee,B){if(ee.isCancellationRequested||B.isCancellationRequested)return O.CancellationToken.Cancelled;const _=new O.$qe;return ee.onCancellationRequested(()=>_.cancel()),B.onCancellationRequested(()=>_.cancel()),_.token}class i{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,l.$rh)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function a(ee,B){const _=new i(B);return _.registerDisposable(ee.onControlMessage(pe=>{const ue=JSON.parse(pe.toString()),ce=J(ue);ce?_.reject(ce):_.resolve(ue)})),_.promise}function s(ee,B,_,pe,ue,ce,oe,le){const K=new i(le),se=A.$be.create(!1);return ee.info(`Creating a socket (${oe})...`),E.mark(`code/willCreateSocket/${ce}`),B.connect(_,pe,ue,oe).then($e=>{K.didTimeout?(E.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(E.mark(`code/didCreateSocketOK/${ce}`),ee.info(`Creating a socket (${oe}) was successful after ${se.elapsed()} ms.`),K.resolve($e))},$e=>{E.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) returned an error after ${se.elapsed()} ms.`),ee.error($e),K.reject($e)}),K.promise}function t(ee,B){const _=new i(B);return ee.then(pe=>{_.didTimeout||_.resolve(pe)},pe=>{_.didTimeout||_.reject(pe)}),_.promise}async function u(ee,B,_,pe){const ue=ae(ee,B);ee.logService.trace(`${ue} 1/6. invoking socketFactory.connect().`);let ce;try{ce=await s(ee.logService,ee.remoteSocketFactoryService,ee.connectTo,$.$Lg.getServerRootPath(),`reconnectionToken=${ee.reconnectionToken}&reconnection=${ee.reconnectionProtocol?"true":"false"}`,d(B),`renderer-${d(B)}-${ee.reconnectionToken}`,pe)}catch($e){throw ee.logService.error(`${ue} socketFactory.connect() failed or timed out. Error:`),ee.logService.error($e),$e}ee.logService.trace(`${ue} 2/6. socketFactory.connect() was successful.`);let oe,le;ee.reconnectionProtocol?(ee.reconnectionProtocol.beginAcceptReconnection(ce,null),oe=ee.reconnectionProtocol,le=!1):(oe=new p.$mi({socket:ce}),le=!0),ee.logService.trace(`${ue} 3/6. sending AuthRequest control message.`);const K=await t(ee.signService.createNewMessage((0,I.$Ug)()),pe),se={type:"auth",auth:ee.connectionToken||"00000000000000000000",data:K.data};oe.sendControl(L.$He.fromString(JSON.stringify(se)));try{const $e=await a(oe,n(pe,c(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(ee.logService.trace(`${ue} 4/6. received SignRequest control message.`),!await t(ee.signService.validate(K,$e.signedData),pe)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Me=await t(ee.signService.sign($e.data),pe),ge={type:"connectionType",commit:ee.commit,signedData:Me,desiredConnectionType:B};return _&&(ge.args=_),ee.logService.trace(`${ue} 5/6. sending ConnectionTypeRequest control message.`),oe.sendControl(L.$He.fromString(JSON.stringify(ge))),{protocol:oe,ownsProtocol:le}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(ee.logService.error(`${ue} the handshake timed out. Error:`),ee.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(ee.logService.error(`${ue} received error control message when negotiating connection. Error:`),ee.logService.error($e)),le&&H(oe),$e}}async function r(ee,B,_,pe){const ue=Date.now(),ce=ae(ee,B),{protocol:oe,ownsProtocol:le}=await u(ee,B,_,pe),K=new i(pe);return K.registerDisposable(oe.onControlMessage(se=>{const $e=JSON.parse(se.toString()),ve=J($e);ve?(ee.logService.error(`${ce} received error control message when negotiating connection. Error:`),ee.logService.error(ve),le&&H(oe),K.reject(ve)):(ee.reconnectionProtocol?.endAcceptReconnection(),ee.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${Ie(ue)}!`),K.resolve({protocol:oe,firstMessage:$e}))})),K.promise}async function o(ee,B){const{protocol:_}=await r(ee,1,void 0,B);return{protocol:_}}async function f(ee,B,_){const{protocol:pe,firstMessage:ue}=await r(ee,2,B,_),ce=ue&&ue.debugPort;return{protocol:pe,debugPort:ce}}async function g(ee,B,_){const pe=Date.now(),ue=ae(ee,3),{protocol:ce}=await u(ee,3,B,_);return ee.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${Ie(pe)}!`),ce}async function w(ee,B,_){const{connectTo:pe,connectionToken:ue}=await ee.addressProvider.getAddress();return{commit:ee.commit,quality:ee.quality,connectTo:pe,connectionToken:ue,reconnectionToken:B,reconnectionProtocol:_,remoteSocketFactoryService:ee.remoteSocketFactoryService,signService:ee.signService,logService:ee.logService}}async function k(ee,B,_){return y(ee,async pe=>{const{protocol:ue}=await o(pe,O.CancellationToken.None);return new Y(ee,B,_,pe.reconnectionToken,ue)})}async function m(ee,B){return y(ee,async _=>{const{protocol:pe,debugPort:ue}=await f(_,B,O.CancellationToken.None);return new ie(ee,B,_.reconnectionToken,pe,ue)})}async function y(ee,B){for(let pe=1;;pe++)try{const ue=(0,I.$Ug)(),ce=await w(ee,ue,null);return await B(ce)}catch(ue){if(pe<5)ee.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),ee.logService.error(ue);else throw ee.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ee.logService.error(ue),U.triggerPermanentFailure(0,0,S.$Ml.isHandled(ue)),ue}}async function D(ee,B,_){const pe=await w(ee,(0,I.$Ug)(),null);return await g(pe,{host:B,port:_},O.CancellationToken.None)}function C(ee){return(0,l.$lh)(B=>new Promise((_,pe)=>{const ue=setTimeout(_,ee*1e3);B.onCancellationRequested(()=>{clearTimeout(ue),_()})}))}var P;(function(ee){ee[ee.ConnectionLost=0]="ConnectionLost",ee[ee.ReconnectionWait=1]="ReconnectionWait",ee[ee.ReconnectionRunning=2]="ReconnectionRunning",ee[ee.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ee[ee.ConnectionGain=4]="ConnectionGain"})(P||(e.PersistentConnectionEventType=P={}));class j{constructor(B,_){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.type=0}}e.$Vl=j;class T{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.durationSeconds=pe,this.c=ue,this.type=1}skipWait(){this.c.cancel()}}e.$Wl=T;class z{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=2}}e.$Xl=z;class N{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=4}}e.$Yl=N;class F{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.handled=ue,this.type=3}}e.$Zl=F;class U extends b.$Uc{static triggerPermanentFailure(B,_,pe){this._permanentFailure=!0,this.f=B,this.g=_,this.h=pe,this.j.forEach(ue=>ue.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(B,_,pe,ue,ce){super(),this.t=B,this.u=_,this.reconnectionToken=pe,this.protocol=ue,this.w=ce,this.m=this.B(new R.$fe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(ue.onSocketClose(oe=>{const le=be(this.t,this.reconnectionToken,!0);oe?oe.type===0?(this.u.logService.info(`${le} received socket close event (hadError: ${oe.hadError}).`),oe.error&&this.u.logService.error(oe.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${oe.wasClean}, code: ${oe.code}, reason: ${oe.reason}).`),oe.event&&this.u.logService.error(oe.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(ue.onSocketTimeout(oe=>{const le=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${oe.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${oe.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${oe.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,b.$Sc)(()=>{const oe=U.j.indexOf(this);oe>=0&&U.j.splice(oe,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const ue=pe<_.length?_[pe]:_[_.length-1];try{if(ue>0){const oe=C(ue);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ue,oe)),this.u.logService.info(`${B} waiting for ${ue} seconds before reconnecting...`);try{await oe}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${B} resolving connection...`);const ce=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ce.connectTo}...`),await this.G(ce,c(v)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(ce){if(ce.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(S.$Ml.isTemporarilyNotAvailable(ce)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((ce.code==="ETIMEDOUT"||ce.code==="ENETUNREACH"||ce.code==="ECONNREFUSED"||ce.code==="ECONNRESET")&&ce.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((0,M.$4)(ce)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if(ce instanceof S.$Ml){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,S.$Ml.isHandled(ce));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(B,_,pe){this.w?U.triggerPermanentFailure(B,_,pe):this.D(B,_,pe)}D(B,_,pe){this.m.fire(new F(this.reconnectionToken,B,_,pe)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$1l=U;class Y extends U{constructor(B,_,pe,ue,ce){super(1,B,ue,ce,!0),this.client=this.B(new p.$ki(ce,{remoteAuthority:_,clientId:pe},B.ipcLogger))}async G(B,_){await o(B,_)}}e.$2l=Y;class ie extends U{constructor(B,_,pe,ue,ce){super(2,B,pe,ue,!1),this.H=_,this.debugPort=ce}async G(B,_){await f(B,this.H,_)}}e.$3l=ie;function H(ee){try{ee.acceptDisconnect();const B=ee.getSocket();ee.dispose(),B.dispose()}catch(B){(0,M.$1)(B)}}function J(ee){if(ee&&ee.type==="error"){const B=new Error(`Connection error: ${ee.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function x(ee,B){for(;ee.length<B;)ee+=" ";return ee}function ne(ee,B){return`[remote-connection][${x(d(ee),13)}][${B.substr(0,5)}\u2026]`}function be(ee,B,_){return`${ne(ee,B)}[${_?"reconnect":"initial"}]`}function ae(ee,B){return`${be(B,ee.reconnectionToken,!!ee.reconnectionProtocol)}[${ee.connectTo}]`}function Ie(ee){return`${Date.now()-ee} ms`}}),define(ke[86],De([1,0,15]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=L,e.$Km=O,e.$Lm=M,e.$Mm=R;function L($){return $.scheme===l.Schemas.vscodeRemote?$.authority:void 0}function O($){if(!$)return;const E=$.indexOf("+");return E<0?$:$.substr(0,E)}function M($){const{host:E,port:A}=b($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:A}}function R($,E){let{host:A,port:I}=b($);return typeof I>"u"&&(I=E),{host:A,port:I}}function b($){const E=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const I=$.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:$,port:void 0}}}),define(ke[25],De([1,0,14,5,86]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=M,e.$Wm=I,e.$Xm=p,e.$Ym=S,e.$Zm=v,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function M(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,c){if(typeof d>"u"||d===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof d=="string"||typeof c=="string"){const n=typeof d=="string"?d:d.value,i=typeof c=="string"?c:c.value;return l.$zf(n,i)}return d._lower===c._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Tm=$;class E{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const c of d)this.add(c)}add(d){this.c.add($.toKey(d))}delete(d){return this.c.delete($.toKey(d))}has(d){return this.c.has($.toKey(d))}}e.$Um=E;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete($.toKey(d))}get(d){return this.c.get($.toKey(d))}has(d){return this.c.has($.toKey(d))}set(d,c){this.c.set($.toKey(d),c)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=A;function I(h){return p(h)}function p(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function S(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function v(h,d){if(d){const c=`onResolveRemoteAuthority:${(0,O.$Km)(d)}`;return!!h.activationEvents?.includes(c)}return!1}e.$1m=(0,L.$yi)("IBuiltinExtensionsScannerService")}),define(ke[140],De([1,0,13,25]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=e.$wG=void 0;class O{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const $ of R){const E=this.readActivationEvents($);E.length>0&&(b[L.$Tm.toKey($.identifier)]=E)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${L.$Tm.toKey(R.identifier)}`);if(!R.contributes)return b;for(const $ in R.contributes){const E=this.a.get($);if(!E)continue;const A=R.contributes[$],I=Array.isArray(A)?A:[A];try{E(I,b)}catch(p){(0,l.$1)(p)}}return b}}e.$wG=O,e.$xG=new O}),define(ke[273],De([1,0,3,5]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol=(0,L.$yi)("remoteSocketFactoryService");class O{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,l.$Sc)(()=>{const $=this.a[R]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,b,$,E){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,b,$,E)}}e.$Pl=O}),define(ke[274],De([1,0,21,13,3,220,66,5,11,36]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Sp=p,e.$Tp=S,e.$Up=v,e.$Vp=h,e.$Wp=d,e.$Xp=c,e.$Qp=(0,b.$yi)("requestService");class A{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?s[t]="*****":s[t]=this.b[t];this.a=s}return this.a}}class I extends O.$Uc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,M.localize)(0,null),when:$.$kk.isEqualTo((0,$.$hk)($.LogLevel.Trace)).serialize()})}async c(s,t,u){const r=`${s} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new A(t.headers??{}));try{const o=await u();return this.a.trace(`${r} - end`,t.type,o.res.statusCode,o.res.headers),o}catch(o){throw this.a.error(`${r} - error`,t.type,(0,L.$0)(o)),o}}}e.$Rp=I;function p(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}function S(a){return a.res.statusCode===204}async function v(a){return S(a)?null:(await(0,l.$Te)(a.stream)).toString()}async function h(a){if(!p(a))throw new Error("Server returned "+a.res.statusCode);return v(a)}async function d(a){if(!p(a))throw new Error("Server returned "+a.res.statusCode);if(S(a))return null;const t=(await(0,l.$Te)(a.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}function c(a){i(a)}let n;function i(a){const s=E.$fo.as(R.$ko.Configuration),t=n;n={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},s.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(ke[275],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=void 0;class l{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(O){try{const M=await this.c();if(M){const R=String(l.a++);return this.b.set(R,M),{id:R,data:M.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,M){if(!O.id)return!0;const R=this.b.get(O.id);if(!R)return!1;this.b.delete(O.id);try{return R.validate(M)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(O){try{return await this.d(O)}catch{}return O}}e.$l_b=l}),define(ke[111],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql="signService",e.$Rl=(0,l.$yi)(e.$Ql)}),define(ke[141],De([1,0,275]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class L extends l.$l_b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(R=>new R.signer().sign(M))}h(){return new Promise((M,R)=>he(["vsda"],M,R))}}e.$hec=L}),define(ke[276],De([1,0,12,52,30]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=R,e.$hp=b;function M($){if(l.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,E,A,I,p,S,v,h,d){const c=Object.create(null);c["common.machineId"]=S,c["common.sqmId"]=v,c.sessionID=(0,O.$Ug)()+Date.now(),c.commitHash=I,c.version=p,c["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,l.$h)(l.$u),c["common.nodePlatform"]=L.$dc,c["common.nodeArch"]=A,c["common.product"]=d||"desktop",h&&(c["common.msftInternal"]=h);let n=0;const i=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),l.$l&&(c["common.snap"]="true");const a=M(E);return a&&(c["common.platformDetail"]=a),c}function b($){const E=L.env.USERDNSDOMAIN;if(!E)return!1;const A=E.toLowerCase();return $.some(I=>A===I)}}),define(ke[277],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,l.$yi)("telemetryService"),e.$5l=(0,l.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var O;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(ke[87],De([1,0,24,18,86,276,277]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=void 0,e.$pp=A,e.$qp=I,e.$rp=p,e.$sp=S,e.$tp=h,e.$up=c,e.$vp=n,e.$wp=s;class b{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$ip=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$jp=$,e.$kp=new $;class E{async publicLog(u,r,o){}async publicLogError(u,r,o){}}e.$lp=E,e.$mp="telemetry",e.$np="extensionTelemetryLog",e.$op={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}function I(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const u=t.getValue(R.$_l),r=t.getValue(R.$am);if(t.getValue(R.$bm)===!1||r===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function S(t){const u={},r={},o={};d(t,o);for(let f in o){f=f.length>150?f.substr(f.length-149):f;const g=o[f];typeof g=="number"?r[f]=g:typeof g=="boolean"?r[f]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${g.length}`),u[f]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(u[f]=g)}return{properties:u,measurements:r}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const u=(0,O.$Km)(t);return v.has(u)?u:"other"}function d(t,u,r=0,o){if(t)for(const f of Object.getOwnPropertyNames(t)){const g=t[f],w=o?o+f:f;Array.isArray(g)?u[w]=(0,l.$0n)(g):g instanceof Date?u[w]=g.toISOString():(0,L.$ag)(g)?r<2?d(g,u,r+1,w+"."):u[w]=(0,l.$0n)(g):u[w]=g}}function c(t,u){const r=t.msftInternalDomains||[],o=u.getValue("telemetry.internalTesting");return(0,M.$hp)(r)||o}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const o=[];for(const k of u)for(;;){const m=k.exec(t);if(!m)break;o.push([m.index,k.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const k=g.exec(t);if(!k)break;const m=o.some(([y,D])=>k.index<D&&y<g.lastIndex);!f.test(k[0])&&!m&&(r+=t.substring(w,k.index)+"<REDACTED: user-file-path>",w=g.lastIndex)}return w<t.length&&(r+=t.substr(w)),r}function a(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of u)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function s(t,u){return(0,l.$7n)(t,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=i(o,u);for(const f of u)o=o.replace(f,"");return o=a(o),o}})}}),define(ke[278],De([1,0,14,138,25,12,2,13,52,87]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$yp=void 0,e.$xp=A,e.$zp=v,e.$Ap=h,e.$Bp=d,e.$Cp=c,e.$Dp=n,e.$Ep=i,e.$Fp=a,e.$Hp=s,e.$Ip=u;function A(r,o){return r.uuid&&o.uuid?r.uuid===o.uuid:r.id===o.id?!0:(0,l.$uf)(r.id,o.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(o){const f=o.manifest?o.manifest.version:o.version,g=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new p(o.identifier,f,g)}static parse(o){const f=I.exec(o);return f&&f[1]&&f[2]?new p({id:f[1]},f[2],f[4]||void 0):null}constructor(o,f,g="undefined"){this.version=f,this.targetPlatform=g,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof p?A(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$yp=p;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const o=S.exec(r);return o&&o[1]?[d(o[1]),o[2]]:[d(r),void 0]}function h(r,o){return`${r}.${o}`}function d(r){return r.toLowerCase()}function c(r,o){return d(h(r??O.$Pm,o))}function n(r,o){const f=[],g=w=>{for(const k of f)if(k.some(m=>A(o(m),o(w))))return k;return null};for(const w of r){const k=g(w);k?k.push(w):f.push([w])}return f}function i(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function a(r){return{id:new E.$ip(r.identifier.id),name:new E.$ip(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Gp=new O.$Tm("pprice.better-merge");function s(r,o){const f=[],g=o.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&f.every(k=>!A(k.identifier,{id:w}))){const k=r.filter(m=>A(m.identifier,{id:w}));k.length===1&&(f.push(k[0]),g.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}async function t(r,o){if(!M.$k)return!1;let f;try{f=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){o.debug("Error while getting the os-release file.",(0,b.$0)(w))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,o){const f=await t(r,o),g=(0,L.$5o)(f?"alpine":M.$u,$.$ec);return o.debug("ComputeTargetPlatform:",g),g}}),define(ke[279],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=l,e.$ps=L,e.$qs=O,e.$rs=M,e.$ss=R,e.$ts=b;function l($){return[...$.entries()]}function L($){return $?[...$.entries()]:[]}function O($){return new Map($)}function M($){return new Map($??[])}function R($){return Array.from($.entries()).map(E=>[E[0],l(E[1].map),L(E[1].descriptionMap)])}function b($){return new Map($.map(E=>[E[0],{map:O(E[1]),descriptionMap:M(E[2])}]))}}),define(ke[280],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yvb=void 0;class l{constructor(O){this.b=O,this.a=new Map}dispose(){for(const O of this.a.values())O.dispose()}startBuffering(O,M,R=5){const b=M($=>{const E=typeof $=="string"?$:$.data;let A=this.a.get(O);if(A){A.data.push(E);return}const I=setTimeout(()=>this.flushBuffer(O),R);A={data:[E],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(O),b.dispose()}},this.a.set(O,A)});return b}stopBuffering(O){this.a.get(O)?.dispose()}flushBuffer(O){const M=this.a.get(O);M&&(this.a.delete(O),this.b(O,M.data.join("")))}}e.$Yvb=l}),define(ke[281],De([1,0,7,79,99,50,4,18,2,221,110,36]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$px=e.$ox=e.$nx=e.$mx=e.$lx=e.$kx=e.IconFontDefinition=e.IconContribution=e.$hx=void 0,e.$ix=d,e.$jx=c,e.$hx={IconContribution:"base.contributions.icons"};var p;(function(s){function t(u,r){let o=u.defaults;for(;M.ThemeIcon.isThemeIcon(o);){const f=h.getIcon(o.id);if(!f)return;o=f.defaults}return o}s.getDefinition=t})(p||(e.IconContribution=p={}));var S;(function(s){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(o=>({format:o.format,location:o.location.toString()}))}}s.toJSONObject=t;function u(r){const o=f=>(0,b.$$f)(f)?f:void 0;if(r&&Array.isArray(r.src)&&r.src.every(f=>(0,b.$$f)(f.format)&&(0,b.$$f)(f.location)))return{weight:o(r.weight),style:o(r.style),src:r.src.map(f=>({format:f.format,location:$.URI.parse(f.location)}))}}s.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class v{constructor(){this.a=new R.$fe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${M.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,u,r,o){const f=this.b[t];if(f){if(r&&!f.description){f.description=r,this.d.properties[t].markdownDescription=`${r} $(${t})`;const k=this.e.enum.indexOf(t);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return f}const g={id:t,description:r,defaults:u,deprecationMessage:o};this.b[t]=g;const w={$ref:"#/definitions/icons"};return o&&(w.deprecationMessage=o),r&&(w.markdownDescription=`${r}: $(${t})`),this.d.properties[t]=w,this.e.enum.push(t),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const u=this.e.enum.indexOf(t);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,u){const r=this.f[t];return r||(this.f[t]=u,this.a.fire(),u)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(f,g)=>f.id.localeCompare(g.id),u=f=>{for(;M.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(f=>this.b[f]);for(const f of o.filter(g=>!!g.description).sort(t))r.push(`|<i class="${u(f)}"></i>|${f.id}|${M.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const f of o.filter(g=>!M.ThemeIcon.isThemeIcon(g.defaults)).sort(t))r.push(`|<i class="${u(f)}"></i>|${f.id}|`);return r.join(`
`)}}const h=new v;I.$fo.add(e.$hx.IconContribution,h);function d(s,t,u,r){return h.registerIcon(s,t,u,r)}function c(){return h}function n(){const s=(0,O.$Tj)();for(const t in s){const u="\\"+s[t].toString(16);h.registerIcon(t,{fontCharacter:u})}}n(),e.$kx="vscode://schemas/icons";const i=I.$fo.as(A.$go.JSONContribution);i.registerSchema(e.$kx,h.getIconSchema());const a=new l.$Kh(()=>i.notifySchemaChanged(e.$kx),200);h.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$lx=d("widget-close",L.$Xj.close,(0,E.localize)(2,null)),e.$mx=d("goto-previous-location",L.$Xj.arrowUp,(0,E.localize)(3,null)),e.$nx=d("goto-next-location",L.$Xj.arrowDown,(0,E.localize)(4,null)),e.$ox=M.ThemeIcon.modify(L.$Xj.sync,"spin"),e.$px=M.ThemeIcon.modify(L.$Xj.loading,"spin")}),define(ke[88],De([1,0,4,2,55,5,11]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.$sw=e.$qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$mw=e.$lw=void 0,e.$nw=E,e.$ow=I,e.$pw=p,e.$rw=S,e.$tw=v,e.$uw=h,e.$lw=(0,M.$yi)("tunnelService"),e.$mw=(0,M.$yi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const a of i){const s=a.split("=")[1];if(/^https?:/.exec(s)){const t=I(L.URI.parse(s));if(t)return t}}}e.$qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(n){return e.$qw.indexOf(n)>=0}e.$sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$sw.indexOf(n)>=0}function h(n,i,a,s){if(a===1)return!1;if(a===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class d{constructor(i,a,s){this.remoteAddress=i,this.localAddress=a,this.b=s,this.a=new l.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vw=d;let c=class{constructor(i,a){this.k=i,this.l=a,this.a=new l.$fe,this.onTunnelOpened=this.a.event,this.b=new l.$fe,this.onTunnelClosed=this.b.event,this.c=new l.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const s of a){const t=Array.from(s.values());for(const u of t){const r=await u.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,s,t,u){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:s,privacy:t,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(v(i)||S(i))&&(i=e.$qw[0]);const s=this.s(i,a);if(s)return++s.refcount,s.value}openTunnel(i,a,s,t,u,r=!1,o,f){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${s} on local port ${u}.`);const g=this.f??i;if(!g)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.t(g,a,s,t,u,r,o,f);return w?w.then(k=>{if(k){if(typeof k=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,s),k}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(k);return(k.tunnelRemoteHost!==a||k.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&k.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const s=a.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,a,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=s.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const s=this.e.get(i);if(s&&s.has(a)){const t=s.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:s})}async r(i,a){const s=this.e.get(i);if(s){const t=s.get(a),u=t?await t.value:void 0;(!u||typeof u=="string")&&s.delete(a),s.size===0&&this.e.delete(i)}}s(i,a){const s=[i];S(i)?(s.push(...e.$qw),s.push(...e.$sw)):v(i)&&s.push(...e.$sw);const t=s.map(u=>this.e.get(u));for(const u of t){const r=u?.get(a);if(r)return r}}canTunnel(i){return!!I(i)}u(i,a,s,t,u,r,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${s} on local port ${t}.`);const f=s;this.j.add(f);const g=t===void 0?s:t,w={elevationRequired:u?this.isPortPrivileged(g):!1},k={remoteAddress:{host:a,port:s},localAddressPort:t,privacy:r,public:r?r!==$.Private:void 0,protocol:o},m=i.forwardPort(k,w);return m?(this.q(a,s,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(f)})):this.j.delete(f),m}};e.$ww=c,e.$ww=c=Je([We(0,R.$5j),We(1,O.$5i)],c)}),define(ke[282],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,l.$yi)("IUriIdentityService")}),define(ke[283],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xw=void 0,e.$xw=(0,l.$yi)("editSessionIdentityService");var L;(function(O){O[O.Complete=100]="Complete",O[O.Partial=50]="Partial",O[O.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(ke[284],De([1,0,15]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=L,e.$QL=O,e.$RL=M,e.$SL=R,e.$TL=b;function L($){return $.scheme!==l.Schemas.file&&$.scheme!==l.Schemas.vscodeRemote}function O($){if($.folders.length)return $.folders.every(E=>L(E.uri))?$.folders[0].uri:void 0;if($.configuration&&L($.configuration))return $.configuration}function M($){return O($)?.scheme}function R($){return O($)?.authority}function b($){return O($)!==void 0}}),define(ke[42],De([1,0,223,16,78,23,2,5,15]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=E,e.$Ji=A,e.$Mi=I,e.$Ni=p,e.$Oi=S,e.$Pi=h,e.$Qi=d,e.$Ti=i,e.$Yi=a,e.$Zi=s,e.$2i=t,e.$3i=u,e.$4i=r,e.$Hi=(0,b.$yi)("contextService");function E(o){const f=o;return typeof f?.id=="string"&&R.URI.isUri(f.uri)}function A(o){return typeof o?.id=="string"&&!E(o)&&!p(o)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function I(o,f){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,L.$nc)(o)}:f?e.$Ki:e.$Li;const g=o;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}function p(o){const f=o;return typeof f?.id=="string"&&R.URI.isUri(f.configPath)}function S(o){const f=o;if(f?.uri)return{id:f.id,uri:R.URI.revive(f.uri)};const g=o;if(g?.configPath)return{id:g.id,configPath:R.URI.revive(g.configPath)};if(o?.id)return{id:o.id}}var v;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function h(o){const f=o;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}function d(o){const f=o;return!!(f&&typeof f=="object"&&R.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}class c{constructor(f,g,w,k,m){this.h=f,this.j=w,this.k=k,this.l=m,this.c=O.$Ei.forUris(this.l,()=>!0),this.folders=g}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=O.$Ei.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=c;class n{constructor(f,g){this.raw=g,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.$_g)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=n;function i(o){return new n({uri:o,index:0,name:(0,M.$8g)(o)},{uri:o.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,l.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function a(o,f){return M.$3g.isEqualOrParent(o,f.untitledWorkspacesHome)}function s(o){let f;return R.URI.isUri(o)?f=o:f=o.configuration,f?.scheme===$.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$1i}function u(o,f){return!a(o,f)&&!s(o)}function r(o){return(typeof o=="string"?(0,L.$oc)(o):(0,M.$0g)(o))===e.$Vi}}),define(ke[285],De([1,0,57,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=a,e.$Fl=s,e.$Gl=t;var i;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function a(o){const f=o;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&typeof f.isDefault=="boolean"&&typeof f.name=="string"&&R.URI.isUri(f.location)&&R.URI.isUri(f.globalStorageHome)&&R.URI.isUri(f.settingsResource)&&R.URI.isUri(f.keybindingsResource)&&R.URI.isUri(f.tasksResource)&&R.URI.isUri(f.snippetsHome)&&R.URI.isUri(f.extensionsResource))}e.$El=(0,A.$yi)("IUserDataProfilesService");function s(o,f){return{id:o.id,isDefault:o.isDefault,name:o.name,shortName:o.shortName,icon:o.icon,location:R.URI.revive(o.location).with({scheme:f}),globalStorageHome:R.URI.revive(o.globalStorageHome).with({scheme:f}),settingsResource:R.URI.revive(o.settingsResource).with({scheme:f}),keybindingsResource:R.URI.revive(o.keybindingsResource).with({scheme:f}),tasksResource:R.URI.revive(o.tasksResource).with({scheme:f}),snippetsHome:R.URI.revive(o.snippetsHome).with({scheme:f}),extensionsResource:R.URI.revive(o.extensionsResource).with({scheme:f}),cacheHome:R.URI.revive(o.cacheHome).with({scheme:f}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}function t(o,f,g,w,k,m){return{id:o,name:f,location:g,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:m&&k?.useDefaultFlags?.globalState?m.globalStorageHome:(0,M.$_g)(g,"globalStorage"),settingsResource:m&&k?.useDefaultFlags?.settings?m.settingsResource:(0,M.$_g)(g,"settings.json"),keybindingsResource:m&&k?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,M.$_g)(g,"keybindings.json"),tasksResource:m&&k?.useDefaultFlags?.tasks?m.tasksResource:(0,M.$_g)(g,"tasks.json"),snippetsHome:m&&k?.useDefaultFlags?.snippets?m.snippetsHome:(0,M.$_g)(g,"snippets"),extensionsResource:m&&k?.useDefaultFlags?.extensions?m.extensionsResource:(0,M.$_g)(g,"extensions.json"),cacheHome:(0,M.$_g)(w,o),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}let u=class extends O.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(f,g,w,k){super(),this.t=f,this.u=g,this.w=w,this.y=k,this.f=!0,this.h=this.B(new L.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(f){this.f!==f&&(this.z=void 0,this.f=f)}isEnabled(){return this.f}get C(){if(!this.z){const f=this.D(),g=[f];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,n.$$f)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}g.push(t((0,M.$9g)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},f))}}catch(m){this.y.error(m)}const w=new S.$Ac,k=new Map;if(g.length)try{const m=this.Q();if(m.workspaces)for(const[y,D]of Object.entries(m.workspaces)){const C=R.URI.parse(y),P=g.find(j=>j.id===D);P&&w.set(C,P)}if(m.emptyWindows)for(const[y,D]of Object.entries(m.emptyWindows)){const C=g.find(P=>P.id===D);C&&k.set(y,C)}}catch(m){this.y.error(m)}this.z={profiles:g,workspaces:w,emptyWindows:k}}return this.z}D(){const f=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...f,extensionsResource:this.S()??f.extensionsResource,isDefault:!0}}async createTransientProfile(f){const g="Temp",w=new RegExp(`${(0,c.$bf)(g)}\\s(\\d+)`);let k=0;for(const y of this.profiles){const D=w.exec(y.name),C=D?parseInt(D[1]):0;k=C>k?C:k}const m=`${g} ${k+1}`;return this.createProfile((0,l.$mj)((0,d.$Ug)()).toString(16),m,{transient:!0},f)}async createNamedProfile(f,g,w){return this.createProfile((0,l.$mj)((0,d.$Ug)()).toString(16),f,g,w)}async createProfile(f,g,w,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(f,g,w);return k&&await this.setProfileForWorkspace(k,m),m}async F(f,g,w){if(!(0,n.$$f)(g)||!g)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(g);return k||(k=(async()=>{try{if(this.profiles.find(C=>C.name===g||C.id===f))throw new Error(`Profile with ${g} name already exists`);const y=t(f,g,(0,M.$_g)(this.profilesHome,f),this.g,w,this.defaultProfile);await this.u.createFolder(y.location);const D=[];return this.j.fire({profile:y,join(C){D.push(C)}}),await h.Promises.settled(D),this.I([y],[],[]),y}finally{this.r.delete(g)}})(),this.r.set(g,k)),k}async updateProfile(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(k=>k.id===f.id);if(!w)throw new Error(`Profile '${f.name}' does not exist`);return w=t(w.id,g.name??w.name,w.location,this.g,{shortName:g.shortName??w.shortName,icon:g.icon===null?void 0:g.icon??w.icon,transient:g.transient??w.isTransient,useDefaultFlags:g.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(f.isDefault)throw new Error("Cannot remove default profile");const g=this.profiles.find(k=>k.id===f.id);if(!g)throw new Error(`Profile '${f.name}' does not exist`);const w=[];this.m.fire({profile:g,join(k){w.push(k)}});try{await Promise.allSettled(w)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])g.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])g.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[g],[]);try{await this.u.del(g.cacheHome,{recursive:!0})}catch(k){(0,E.$jl)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(k=>k.id===g.id);if(!w)throw new Error(`Profile '${g.name}' does not exist`);this.L(f,w)}unsetWorkspace(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(f,void 0,g)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const f=await this.u.resolve(this.profilesHome);await Promise.all((f.children||[]).filter(g=>g.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,g.resource))).map(g=>this.u.del(g.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const f=this.s.profiles.filter(g=>!this.H(g));await Promise.allSettled(f.map(g=>this.removeProfile(g)))}getProfileForWorkspace(f){const g=this.G(f);return R.URI.isUri(g)?this.s.workspaces.get(g)??this.C.workspaces.get(g):this.s.emptyWindows.get(g)??this.C.emptyWindows.get(g)}G(f){return(0,p.$Ii)(f)?f.uri:(0,p.$Ni)(f)?f.configPath:f.id}H(f){return!!([...this.s.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.s.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.C.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.C.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,f.location)))}I(f,g,w){const k=[...this.profiles,...f],m=[];this.s.profiles=[];for(let y of k)y.isDefault||g.some(D=>y.id===D.id)||(y=w.find(D=>y.id===D.id)??y,y.isTransient?this.s.profiles.push(y):m.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.P(m),this.z=void 0,this.J(f,g,w)}J(f,g,w){this.h.fire({added:f,removed:g,updated:w,all:this.profiles})}L(f,g,w){w=g?.isTransient?!0:w,w||this.L(f,void 0,!0);const k=this.G(f),m=w?this.s:this.C;R.URI.isUri(k)?(m.workspaces.delete(k),g&&m.workspaces.set(k,g)):(m.emptyWindows.delete(k),g&&m.emptyWindows.set(k,g)),w||this.M()}M(){const f={};for(const[w,k]of this.C.workspaces.entries())f[w.toString()]=k.id;const g={};for(const[w,k]of this.C.emptyWindows.entries())g[w.toString()]=k.id;this.R({workspaces:f,emptyWindows:g}),this.z=void 0}N(f){const g={},w=this.D();if(f.workspaces)for(const[m,y]of Object.entries(f.workspaces)){const D=R.URI.parse(y);g[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}const k={};if(f.emptyWindows)for(const[m,y]of Object.entries(f.emptyWindows)){const D=R.URI.parse(y);k[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}return{workspaces:g,emptyWindows:k}}O(){return[]}P(f){throw new Error("not implemented")}Q(){return{}}R(f){throw new Error("not implemented")}S(){}};e.$Hl=u,e.$Hl=u=Je([We(0,$.$Fi),We(1,E.$5k),We(2,v.$Cl),We(3,I.$5j)],u);class r extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(f){this.a=f}Q(){return this.X}R(f){this.X=f}}e.$Il=r}),define(ke[142],De([1,0,7,4,3,59,18,200,5,285]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$6p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4p=e.$3p=e.$2p=void 0,e.$5p=S,e.$7p=h,e.$9p=c,e.$2p="__$__isNewStorageMarker",e.$3p="__$__targetStorageMarker",e.$4p=(0,$.$yi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function S(n){const i=n.get(e.$3p);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends O.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new L.$ie),this.c=this.B(new L.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new l.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new O.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,a,s){return L.Event.filter(this.b.event,t=>t.scope===i&&(a===void 0||t.key===a),s)}n(){this.j.value=(0,l.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,O.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,a){const{key:s,external:t}=a;if(s===e.$3p){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,a,s){return this.P(a)?.get(i,s)}getBoolean(i,a,s){return this.P(a)?.getBoolean(i,s)}getNumber(i,a,s){return this.P(a)?.getNumber(i,s)}getObject(i,a,s){return this.P(a)?.getObject(i,s)}storeAll(i,a){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,a)})}store(i,a,s,t,u=!1){if((0,R.$hg)(a)){this.remove(i,s,u);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,a,u)})}remove(i,a,s=!1){this.y(()=>{this.z(i,a,void 0),this.P(a)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,a){const s=[],t=this.J(i);for(const u of Object.keys(t))t[u]===a&&s.push(u);return s}z(i,a,s,t=!1){const u=this.J(a);typeof s=="number"?u[i]!==s&&(u[i]=s,this.P(a)?.set(e.$3p,JSON.stringify(u),t)):typeof u[i]=="number"&&(delete u[i],this.P(a)?.set(e.$3p,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const a=this.P(i);return a?S(a):Object.create(null)}isNew(i){return this.getBoolean(e.$2p,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const a=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await l.Promises.settled([a?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await l.Promises.settled([a?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,a=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return c(i,a,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,a){return this.w(A.NONE),(0,E.$Dl)(i)?this.R(i,a):this.S(i,a)}M(i,a){return!(i.id===a.id||h(a)&&h(i))}N(i,a,s){this.y(()=>{const t=new Set;for(const[u,r]of i)t.add(u),a.get(u)!==r&&this.u(s,{key:u,external:!0});for(const[u]of a.items)t.has(u)||this.u(s,{key:u,external:!0})})}}e.$6p=v;function h(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class d extends v{constructor(){super(),this.U=this.B(new b.$Zp(new b.$1p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Zp(new b.$1p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Zp(new b.$1p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$8p=d;async function c(n,i,a,s,t,u){const r=C=>{try{return JSON.parse(C)}catch{return C}},o=new Map,f=new Map;n.forEach((C,P)=>{o.set(P,C),f.set(P,r(C))});const g=new Map,w=new Map;i.forEach((C,P)=>{g.set(P,C),w.set(P,r(C))});const k=new Map,m=new Map;a.forEach((C,P)=>{k.set(P,C),m.set(P,r(C))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const y=[];if(o.forEach((C,P)=>{y.push({key:P,value:C})}),console.table(y),console.groupEnd(),console.log(f),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];g.forEach((P,j)=>{C.push({key:j,value:P})}),console.table(C),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${u})`);const D=[];k.forEach((C,P)=>{D.push({key:P,value:C})}),console.table(D),console.groupEnd(),console.log(m)}}),define(ke[112],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class l{static{this.a=!1}constructor(O){this.d=O,this.b=new Map,this.c=1}add(O){const M=this.c++;return this.b.set(M,O),this.e(),M}get(O,M){return this.b.has(O)?this.b.get(O)[M]:void 0}delete(O){this.b.delete(O),this.e()}e(){l.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Mlc=l}),define(ke[60],De([1,0,15,23,5]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=void 0;class M{constructor(){this.a=new Set(Object.keys(l.Schemas)),this.b=new Map,this.extUri=new L.$1g(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Rlc=M,e.$Slc=(0,O.$yi)("IExtHostFileSystemInfo")}),define(ke[28],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=void 0,e.$ZO=(0,l.$yi)("IExtHostInitDataService")}),define(ke[286],De([1,0,228,11,266,28]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;let R=class extends O.$0P{constructor($,E,A){const I=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=A.remote.isRemote?(0,l.localize)(0,null):$?(0,l.localize)(1,null):(0,l.localize)(2,null);super(E.createLogger(I,{name:p}))}};e.$Ync=R,e.$Ync=R=Je([We(1,L.$6j),We(2,M.$ZO)],R)}),define(ke[287],De([1,0,7]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=e.$xmc=void 0;class L{constructor(R,b,$){this.h=new Map,this.a=R,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new l.$Kh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of E.values())A.complete()}catch(A){for(const I of E.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let $=this.f[R];return typeof $>"u"&&($=b),$}update(R,b){this.f[R]=b;const $=this.h.get(R);if($!==void 0)return $.p;const E=new l.$Vh;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$xmc=L;class O extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$ymc=O}),define(ke[288],De([1,0,4,2]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class O{constructor(R){this.c=R,this.a=new l.$fe,this.onDidSaveNotebookDocument=this.a.event,this.b=new l.$fe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,$,E){const I=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged(b.value,$,E);this.b.fire(I)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$mnc=O}),define(ke[20],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0,e.$JO=(0,l.$yi)("IExtHostRpcService");class L{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$KO=L}),define(ke[289],De([1,0,25,4]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class O{#e;constructor(R,b){this.b=new L.$fe,this.onDidChange=this.b.event,this.a=l.$Tm.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$Hmc=O}),define(ke[68],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0,e.$8lc=(0,l.$yi)("IURITransformerService");class L{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$9lc=L}),define(ke[290],De([1,0,21]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xrb=O,e.$Yrb=R;class L{constructor(){this.buffers=[]}add($){let E=this.buffers.indexOf($);return E<0&&(E=this.buffers.length,this.buffers.push($)),E}}function O(b,$){if($.serializeBuffersForPostMessage){const E=new L,I=JSON.stringify(b,(S,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v)};if(ArrayBuffer.isView(v)){const h=M(v);if(h)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v.buffer),view:{type:h,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),p=E.buffers.map(S=>{const v=new Uint8Array(S);return l.$He.wrap(v)});return{message:I,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function M(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,$){const E=$.map(p=>{const S=new ArrayBuffer(p.byteLength);return new Uint8Array(S).set(p.buffer),S}),A=$.length?(p,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const v=S,{index:h}=v,d=E[h];if(v.view)switch(v.view.type){case 1:return new Int8Array(d,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return S}:void 0;return{message:JSON.parse(b,A),arrayBuffers:E}}}),define(ke[291],De([1,0,292,403,404,63,2,11,405]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=A;const E=!1;function A(i,a,s,t,u,r){const o=r.environment.useHostProxy,f=typeof o=="boolean"?o:!r.remote.isRemote,g={resolveProxy:m=>i.resolveProxy(m),lookupProxyAuthorization:d.bind(void 0,t,u,a,{},r.remote.isRemote),getProxyURL:()=>a.getConfiguration("http").get("proxy"),getProxySupport:()=>a.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(a),addCertificatesV2:()=>S(a),log:t,getLogLevel:()=>{const m=t.getLevel();switch(m){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return y(m)}function y(D){return t.error("Unknown log level",D),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:f,loadAdditionalCertificates:async()=>{const m=[];if(r.remote.isRemote&&m.push((0,$.loadSystemCertificates)({log:t})),f){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const y=i.loadCertificates();y.then(D=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",D.length)),m.push(y)}return(await Promise.all(m)).flat()},env:process.env},w=(0,$.createProxyResolver)(g),k=I(g,w);return h(s,k)}function I(i,a){return{http:Object.assign(l,(0,$.createHttpPatch)(i,l,a)),https:Object.assign(L,(0,$.createHttpPatch)(i,L,a)),net:Object.assign(M,(0,$.createNetPatch)(i,M)),tls:Object.assign(O,(0,$.createTlsPatch)(i,O))}}function p(i){const a=i.getConfiguration("http");return!a.get("experimental.systemCertificatesV2",E)&&!!a.get("systemCertificates")}function S(i){const a=i.getConfiguration("http");return!!a.get("experimental.systemCertificatesV2",E)&&!!a.get("systemCertificates")}const v=new Map;function h(i,a){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,u=t._load;t._load=function(o,f,g){if(o==="net")return a.net;if(o==="tls")return a.tls;if(o!=="http"&&o!=="https")return u.apply(this,arguments);const w=s.findSubstr(R.URI.file(f.filename));let k=v.get(w);if(k||v.set(w,k={}),!k[o]){const m=a[o];k[o]={...m}}return k[o]}})}async function d(i,a,s,t,u,r,o,f){const g=t[r];o&&(t[r]=o),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${o}`,`proxyAuthenticateCache:${g}`);const w=o||g,k=Array.isArray(w)?w:typeof w=="string"?[w]:[];if(n(a,k,u),k.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!f.kerberosRequested)try{f.kerberosRequested=!0;const m=await new Promise((j,T)=>{he(["kerberos"],j,T)}),y=new URL(r),D=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${D}`),"Negotiate "+await(await m.initializeClient(D)).step("")}catch(m){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let c=!1;function n(i,a,s){c||!a.length||(c=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:a.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[293],De([1,0,134]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=O;function L(M){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:M,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function O(M){return new l.$An(L(M))}}),define(ke[143],De([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$UF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$LF=e.EditorInputCapabilities=e.$KF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$BF=h,e.$CF=d,e.$DF=c,e.$EF=n,e.$FF=i,e.$GF=a,e.$HF=s,e.$IF=t,e.$JF=u,e.$MF=k,e.$NF=y,e.$OF=D,e.$PF=C,e.$QF=P,e.$RF=j,e.$SF=T,e.$TF=ie,e.$VF=x,e.$WF=be,e.$XF=ae,e.$YF=Ie,e.$wF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$xF={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.$yF="workbench.editor.sidebysideEditor",e.$zF="workbench.editors.textDiffEditor",e.$AF="workbench.editors.binaryResourceDiffEditor";var S;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var v;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function h(ee){const B=ee;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function d(ee){const B=ee;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function c(ee,B,_){for(const pe of _.visibleEditorPanes)if(pe.group.id===B&&ee.matches(pe.input))return pe.getViewState()}function n(ee){if(k(ee))return!1;const B=ee;return O.URI.isUri(B?.resource)}function i(ee){if(k(ee))return!1;const B=ee;return B?.original!==void 0&&B.modified!==void 0}function a(ee){if(k(ee))return!1;const B=ee;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function s(ee){if(k(ee)||i(ee))return!1;const B=ee;return B?.primary!==void 0&&B.secondary!==void 0}function t(ee){if(k(ee))return!1;const B=ee;return B?B.resource===void 0||B.resource.scheme===E.Schemas.untitled||B.forceUntitled===!0:!1}function u(ee){if(k(ee))return!1;const B=ee;return O.URI.isUri(B?.base?.resource)&&O.URI.isUri(B?.input1?.resource)&&O.URI.isUri(B?.input2?.resource)&&O.URI.isUri(B?.result?.resource)}var r;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var o;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class f{constructor(){this.a=new Map}registerSource(B,_){let pe=this.a.get(B);return pe||(pe={source:B,label:_},this.a.set(B,pe)),pe.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$KF=new f;var g;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad"})(g||(e.EditorInputCapabilities=g={}));class w extends M.$Uc{}e.$LF=w;function k(ee){return ee instanceof w}function m(ee){const B=ee;return O.URI.isUri(B?.preferredResource)}function y(ee){const B=ee;return k(B?.primary)&&k(B?.secondary)}function D(ee){const B=ee;return k(B?.modified)&&k(B?.original)}function C(ee,B,_,pe,ue){return Ie(pe,[(0,I.$ij)({id:"workbench.action.openLargeFile",label:(0,l.localize)(2,null),run:()=>{const ce={..._,limits:{size:Number.MAX_VALUE}};ee.openEditor(B,ce)}}),(0,I.$ij)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,l.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function P(ee){return k(ee?.editor)}function j(ee){const B=ee;return P(ee)&&B?.group!==void 0}function T(ee){const B=ee;return typeof B?.groupId=="number"&&k(B.editor)}var z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var N;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ee[ee.EDITOR_STICKY=12]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=13]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var F;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class U{getOriginalUri(B,_){if(!B)return;if(u(B))return e.$UF.getOriginalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===F.ANY)return this.getOriginalUri(ue,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===F.PRIMARY?ue:ce}}if(i(B)||a(B)||s(B)||u(B))return;const pe=m(B)?B.preferredResource:B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}a(B){return y(B)||s(B)?{primary:B.primary,secondary:B.secondary}:D(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,_){if(!B)return;if(u(B))return e.$UF.getCanonicalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===F.ANY)return this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===F.PRIMARY?ue:ce}}if(i(B)||a(B)||s(B)||u(B))return;const pe=B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}b(B,_){if(Array.isArray(_)){if(_.some(pe=>B.scheme===pe))return B}else if(_===B.scheme)return B}}var Y;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(Y||(e.EditorCloseMethod=Y={}));function ie(ee,B,_,pe){if(!ee.isSticky(B))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return _===Y.MOUSE||_===Y.KEYBOARD;case"mouse":return _===Y.MOUSE;case"keyboard":return _===Y.KEYBOARD}return!1}e.$UF=new U;var H;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class J{constructor(){this.c=new Map,this.d=new Map}start(B){const _=this.a=B.get(R.$xi);for(const[pe,ue]of this.c)this.e(pe,ue,_);this.c.clear()}e(B,_,pe){const ue=pe.createInstance(_);this.d.set(B,ue)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,L.$jg)(this.b)}registerEditorSerializer(B,_){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,_,this.a):this.c.set(B,_),(0,M.$Sc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}b.$fo.add(e.$wF.EditorFactory,new J);async function x(ee,B,_){return!ee||!ee.length?[]:await Promise.all(ee.map(async pe=>{const ue=O.URI.revive(pe.fileUri);if(!ue){_.info("Cannot resolve the path because it is not valid.",pe);return}if(!await B.canHandleResource(ue)){_.info("Cannot resolve the path because it cannot be handled",pe);return}let oe=pe.exists,le=pe.type;if(typeof oe!="boolean"||typeof le!="number")try{le=(await B.stat(ue)).isDirectory?$.FileType.Directory:$.FileType.Unknown,oe=!0}catch(se){_.error(se),oe=!1}if(!oe&&pe.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",pe);return}if(le===$.FileType.Directory){_.info("Cannot resolve the path because it is a directory",pe);return}const K={...pe.options,pinned:!0};return oe?{resource:ue,options:K}:{resource:ue,options:K,forceUntitled:!0}}))}var ne;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function be(ee){const B=ee;if(!B)return!1;const _=B;if(_.modified)return be(_.modified);const pe=B;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ae(ee){return(0,A.$kj)(ee)}function Ie(ee,B,_){const pe=(0,A.$lj)(ee,B);return pe.forceMessage=_?.forceMessage,pe.forceSeverity=_?.forceSeverity,pe.allowDialog=_?.allowDialog,pe}}),define(ke[294],De([1,0,4,239,5,3,27,36,24,79,281]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=e.$6F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$5F=e.ViewContentGroups=e.$3F=e.ViewContainerLocation=e.Extensions=e.$2F=e.$1F=e.$ZF=void 0,e.$4F=S,e.$ZF="views",e.$1F=(0,L.localize)(0,null),e.$2F=(0,A.$ix)("default-view-icon",E.$Xj.window,(0,L.localize)(1,null));var I;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(I||(e.Extensions=I={}));var p;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$3F=[0,1,2];function S(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class v extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$fe),this.onDidRegister=this.c.event,this.f=this.B(new l.$fe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,r,o){const f=this.get(u.id);if(f)return f;const g=u;return g.openCommandActionDescriptor=o?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,R.$xc)(this.g,r,[]).push(g),o?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:r}),g}deregisterViewContainer(u){for(const r of this.g.keys()){const o=this.g.get(r),f=o?.indexOf(u);if(f!==-1){o?.splice(f,1),o.length===0&&this.g.delete(r),this.f.fire({viewContainer:u,viewContainerLocation:r});return}}}get(u){return this.all.filter(r=>r.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(o=>o?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(r=>this.getViewContainerLocation(r)===u)}}b.$fo.add(I.ViewContainersRegistry,new v);var h;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(h||(e.ViewContentGroups=h={}));function d(t,u){const r=t.group??h.More,o=u.group??h.More;return r!==o?r.localeCompare(o):(t.order??5)-(u.order??5)}class c extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$fe),this.onViewsRegistered=this.c.event,this.f=this.B(new l.$fe),this.onViewsDeregistered=this.f.event,this.g=this.B(new l.$fe),this.onDidChangeContainer=this.g.event,this.h=this.B(new l.$fe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(u,r){this.registerViews2([{views:u,viewContainer:r}])}registerViews2(u){u.forEach(({views:r,viewContainer:o})=>this.r(r,o)),this.c.fire(u)}deregisterViews(u,r){const o=this.s(u,r);o.length&&this.f.fire({views:o,viewContainer:r})}moveViews(u,r){for(const o of this.m.keys())if(o!==r){const f=this.s(u,o);f.length&&(this.r(f,r),this.g.fire({views:f,from:o,to:r}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const r of this.j){const o=(this.m.get(r)||[]).filter(f=>f.id===u)[0];if(o)return o}return null}getViewContainer(u){for(const r of this.j)if((this.m.get(r)||[]).filter(f=>f.id===u)[0])return r;return null}registerViewWelcomeContent(u,r){return this.n.add(u,r),this.h.fire(u),(0,M.$Sc)(()=>{this.n.delete(u,r),this.h.fire(u)})}registerViewWelcomeContent2(u,r){const o=new Map;for(const[f,g]of r)this.n.add(u,g),o.set(f,(0,M.$Sc)(()=>{this.n.delete(u,g),this.h.fire(u)}));return this.h.fire(u),o}getViewWelcomeContent(u){const r=[];return this.n.forEach(u,o=>r.push(o)),r.sort(d)}r(u,r){let o=this.m.get(r);o||(o=[],this.m.set(r,o),this.j.push(r));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,L.localize)(2,null,f.id));o.push(f)}}s(u,r){const o=this.m.get(r);if(!o)return[];const f=[],g=[];for(const w of o)u.includes(w)?f.push(w):g.push(w);return f.length&&(g.length?this.m.set(r,g):(this.m.delete(r),this.j.splice(this.j.indexOf(r),1))),f}}b.$fo.add(I.ViewsRegistry,new c),e.$5F=(0,O.$yi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class a{constructor(u,r){this.c=!1,this.d=!1,(0,$.$8n)(this,u),this.d=!!r,this.resolve=async o=>{if(r&&!this.c){const f=await r(o);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}o.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$6F=a;class s extends Error{constructor(u){super((0,L.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$7F=s}),define(ke[295],De([1,0,240,38]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=void 0,e.$$F=new L.$Pj("chatSessionResponseVote","",{type:"string",description:(0,l.localize)(0,null)}),e.$_F=new L.$Pj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,l.localize)(1,null)}),e.$aG=new L.$Pj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,l.localize)(2,null)}),e.$bG=new L.$Pj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,l.localize)(3,null)}),e.$cG=new L.$Pj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,l.localize)(4,null)}),e.$dG=new L.$Pj("chatResponse",!1,{type:"boolean",description:(0,l.localize)(5,null)}),e.$eG=new L.$Pj("chatRequest",!1,{type:"boolean",description:(0,l.localize)(6,null)}),e.$fG=new L.$Pj("chatEditApplied",!1,{type:"boolean",description:(0,l.localize)(7,null)}),e.$gG=new L.$Pj("chatInputHasText",!1,{type:"boolean",description:(0,l.localize)(8,null)}),e.$hG=new L.$Pj("chatInputHasFocus",!1,{type:"boolean",description:(0,l.localize)(9,null)}),e.$iG=new L.$Pj("inChatInput",!1,{type:"boolean",description:(0,l.localize)(10,null)}),e.$jG=new L.$Pj("inChat",!1,{type:"boolean",description:(0,l.localize)(11,null)}),e.$kG=new L.$Pj("chatIsEnabled",!1,{type:"boolean",description:(0,l.localize)(12,null)}),e.$lG=new L.$Pj("chatCursorAtTop",!1),e.$mG=new L.$Pj("chatInputHasAgent",!1),e.$nG=new L.$Pj("chatLocation",void 0)}),define(ke[296],De([1,0,7,22,4,39,3,171,14,38,5,11,108,274,142,295]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.ChatAgentLocation=void 0;var c;(function(s){s.Panel="panel",s.Terminal="terminal",s.Notebook="notebook",s.Editor="editor"})(c||(e.ChatAgentLocation=c={})),function(s){function t(u){switch(u){case"panel":return s.Panel;case"terminal":return s.Terminal;case"notebook":return s.Notebook;case"editor":return s.Editor}return s.Panel}s.fromRaw=t}(c||(e.ChatAgentLocation=c={})),e.$lH=(0,A.$yi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new O.$fe,this.onDidChangeAgents=this.d.event,this.e=h.$kG.bindTo(this.f)}registerAgent(t,u){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const o=this,f=u.slashCommands;u={...u,get slashCommands(){return f.filter(w=>!w.when||o.f.contextMatchesRules(E.$wj.deserialize(w.when)))}};const g={data:u};return this.b.push(g),(0,R.$Sc)(()=>{this.b=this.b.filter(w=>w!==g),this.d.fire(void 0)})}registerAgentImplementation(t,u){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=u,this.d.fire(new i(r.data,u)),(0,R.$Sc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,u){t.isDynamic=!0;const r={data:t,impl:u};return this.b.push(r),this.d.fire(new i(t,u)),(0,R.$Sc)(()=>{this.b=this.b.filter(o=>o!==r),this.d.fire(void 0)})}updateAgent(t,u){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...u},this.d.fire(new i(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(u=>!!u.isDefault&&u.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(u=>!!u.isDefault&&u.locations.includes(t))}getSecondaryAgent(){return M.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(u=>u.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(u=>u.name===t)}async invokeAgent(t,u,r,o,f){const g=this.g(t);if(!g?.impl)throw new Error(`No activated agent with id ${t}`);return await g.impl.invoke(u,r,o,f)}async getFollowups(t,u,r,o,f){const g=this.g(t);if(!g?.impl)throw new Error(`No activated agent with id ${t}`);return g.impl?.provideFollowups?g.impl.provideFollowups(u,r,o,f):[]}};e.$mH=n,e.$mH=n=Je([We(0,E.$Qj)],n);class i{constructor(t,u){this.b=t,this.d=u}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,u,r,o){return this.d.invoke(t,u,r,o)}async provideFollowups(t,u,r,o){return this.d.provideFollowups?this.d.provideFollowups(t,u,r,o):[]}provideWelcomeMessage(t,u){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,u)}provideSampleQuestions(t,u){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,u)}}e.$nH=i,e.$oH=(0,A.$yi)("chatAgentNameService");let a=class{static{d=this}static{this.b="chat.participantNameRegistry"}constructor(t,u,r,o){if(this.g=u,this.h=r,this.i=o,this.e=(0,b.$3d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const f=o.get(d.b,-1);try{this.e.set(JSON.parse(f??"{}"),void 0)}catch{o.remove(d.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,l.$zh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},L.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const u=await(0,S.$Wp)(t);if(!u||u.version!==1)throw new Error("Unexpected chat participant registry response.");const r=u.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(d.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(o=>(0,$.$zf)(o,o.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$pH=a,e.$pH=a=d=Je([We(0,p.$lk),We(1,S.$Qp),We(2,I.$5j),We(3,v.$4p)],a)}),define(ke[297],De([1,0,2,29,5]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vG=e.$uG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$sG=M,e.$tG=R;function M(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof l.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(L.$xt.isIRange)}function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(M)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$uG=(0,O.$yi)("IChatService"),e.$vG="accessibility.voice.keywordActivation"}),define(ke[144],De([1,0,4,7,241]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rb=void 0;class M{constructor(){this.f=new Map,this.m=[],this.n=new l.$fe,this.o=new l.$fe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,E,A){const I={command:b};if($&&Object.keys($).length>0&&(I.arguments=$),this.u("request",I),typeof A=="number"){const p=setTimeout(()=>{clearTimeout(p);const S=this.f.get(I.seq);if(S){this.f.delete(I.seq);const v={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,O.localize)(0,null,A,b)};S(v)}},A)}return E&&this.f.set(I.seq,E),I.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,L.$zh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,E=this.f.get($.request_seq);E&&(this.f.delete($.request_seq),E($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,E)=>b.set(E,$)),await(0,L.$zh)(500),b.forEach(($,E)=>{$({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$$rb=M}),define(ke[298],De([1,0,2,242,38,5]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$FJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$DJ=e.MemoryRangeType=e.State=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=void 0,e.$CJ=$,e.$EJ=A,e.$qI="workbench.view.debug",e.$rI="workbench.debug.variablesView",e.$sI="workbench.debug.watchExpressionsView",e.$tI="workbench.debug.callStackView",e.$uI="workbench.debug.loadedScriptsView",e.$vI="workbench.debug.breakPointsView",e.$wI="workbench.debug.disassemblyView",e.$xI="workbench.panel.repl",e.$yI="workbench.panel.repl.view",e.$zI=new O.$Pj("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.$AI=new O.$Pj("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.$BI=new O.$Pj("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.$CI="debugUx",e.$DI=new O.$Pj(e.$CI,"default",{type:"string",description:L.localize(3,null)}),e.$EI=new O.$Pj("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.$FI=new O.$Pj("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.$GI=new O.$Pj("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.$HI=new O.$Pj("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.$II=new O.$Pj("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.$JI=new O.$Pj("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.$KI=new O.$Pj("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.$LI=new O.$Pj("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.$MI=new O.$Pj("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.$NI=new O.$Pj("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.$OI=new O.$Pj("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.$PI=new O.$Pj("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.$QI=new O.$Pj("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.$RI=new O.$Pj("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.$SI=new O.$Pj("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.$TI=new O.$Pj("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.$UI=new O.$Pj("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.$VI=new O.$Pj("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.$WI=new O.$Pj("breakpointItemBytes",void 0,{type:"boolean",description:L.localize(22,null)}),e.$XI=new O.$Pj("breakpointHasModes",!1,{type:"boolean",description:L.localize(23,null)}),e.$YI=new O.$Pj("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(24,null)}),e.$ZI=new O.$Pj("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(25,null)}),e.$1I=new O.$Pj("loadedScriptsItemType",void 0,{type:"string",description:L.localize(26,null)}),e.$2I=new O.$Pj("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(27,null)}),e.$3I=new O.$Pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(28,null)}),e.$4I=new O.$Pj("stepBackSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.$5I=new O.$Pj("restartFrameSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.$6I=new O.$Pj("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(31,null)}),e.$7I=new O.$Pj("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.$8I=new O.$Pj("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(33,null)}),e.$9I=new O.$Pj("breakpointsExist",!1,{type:"boolean",description:L.localize(34,null)}),e.$0I=new O.$Pj("debuggersAvailable",!1,{type:"boolean",description:L.localize(35,null)}),e.$$I=new O.$Pj("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(36,null)}),e.$_I=new O.$Pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(37,null)}),e.$aJ=new O.$Pj("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.$bJ=new O.$Pj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.$cJ=new O.$Pj("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.$dJ=new O.$Pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.$eJ=new O.$Pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.$fJ=new O.$Pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.$gJ=new O.$Pj("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(44,null)}),e.$hJ=new O.$Pj("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(45,null)}),e.$iJ=new O.$Pj("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(46,null)}),e.$jJ=new O.$Pj("variableIsReadonly",!1,{type:"boolean",description:L.localize(47,null)}),e.$kJ=new O.$Pj("variableValue",!1,{type:"string",description:L.localize(48,null)}),e.$lJ=new O.$Pj("variableType",!1,{type:"string",description:L.localize(49,null)}),e.$mJ=new O.$Pj("variableInterfaces",!1,{type:"array",description:L.localize(50,null)}),e.$nJ=new O.$Pj("variableName",!1,{type:"string",description:L.localize(51,null)}),e.$oJ=new O.$Pj("variableLanguage",!1,{type:"string",description:L.localize(52,null)}),e.$pJ=new O.$Pj("variableExtensionId",!1,{type:"string",description:L.localize(53,null)}),e.$qJ=new O.$Pj("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(54,null)}),e.$rJ=new O.$Pj("multiSessionRepl",!1,{type:"boolean",description:L.localize(55,null)}),e.$sJ=new O.$Pj("multiSessionDebug",!1,{type:"boolean",description:L.localize(56,null)}),e.$tJ=new O.$Pj("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(57,null)}),e.$uJ=new O.$Pj("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(58,null)}),e.$vJ=new O.$Pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(59,null)}),e.$wJ=new O.$Pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(60,null)});const R=i=>L.localize(61,null,i);e.$xJ=R,e.$yJ="editor.contrib.debug",e.$zJ="editor.contrib.breakpoint",e.$AJ="debug",e.$BJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$DJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var I;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(I||(e.DataBreakpointSetType=I={}));var p;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$FJ=(0,M.$yi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var h;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(h||(e.DebugVisualizationType=h={}));var d;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(d||(e.DebugTreeItemCollapsibleState=d={}));var c;(function(i){i.deserialize=a=>a,i.serialize=a=>a})(c||(e.IDebugVisualizationTreeItem=c={}));var n;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:l.URI.revive(a.iconPath.light),dark:l.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(n||(e.IDebugVisualization=n={}))}),define(ke[299],De([1,0,14,2,16,24,15,29,22,19]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EH=void 0,e.$sH=I,e.$tH=p,e.$uH=S,e.$vH=v,e.$wH=h,e.$xH=d,e.$yH=c,e.$zH=i,e.$AH=t,e.$BH=u,e.$CH=o,e.$DH=g;const A=/{([^}]+)}/g;function I(k,m,y){return k.replace(A,function(D,C){return m&&C.length>0&&C[0]!=="_"?D:y&&y.hasOwnProperty(C)?y[C]:D})}function p(k){const m={};for(const y of Object.keys(k))y.startsWith("!")||(m[y]=k[y]);return m}function S(k){return k.configuration.request==="attach"&&!v(k)&&(!k.parentSession||S(k.parentSession))}function v(k){let m=k.configuration.type;if(m)return m==="vslsShare"&&(m=k.configuration.adapterProxy.configuration.type),(0,l.$zf)(m,"extensionhost")||(0,l.$zf)(m,"pwa-extensionhost")?k:k.parentSession?v(k.parentSession):void 0}function h(k){return k.type&&(k.label||k.program||k.runtime)}function d(k,m,y){let D,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=P.exec(k);){const T=j.index+1,z=T+j[0].length;if(T<=m&&z>=y){D=j[0],C=T;break}}if(D){const T=/\w+/g;let z=null;for(;(z=T.exec(D))&&!(z.index+1+C+z[0].length>=y););z&&(D=D.substring(0,T.lastIndex))}return D?{start:C,end:C+D.length-1}:{start:0,end:0}}async function c(k,m,y,D){if(k.evaluatableExpressionProvider.has(m)){const C=k.evaluatableExpressionProvider.ordered(m),P=(0,E.$Hb)(await Promise.all(C.map(async j=>{try{return await j.provideEvaluatableExpression(m,y,D??$.CancellationToken.None)}catch{return}})));if(P.length>0){let j=P[0].expression;const T=P[0].range;return j||(j=m.getLineContent(y.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:j}}}else{const C=m.getLineContent(y.lineNumber),{start:P,end:j}=d(C,y.column,y.column),T=C.substring(P-1,j);return{matchingExpression:T,range:new b.$xt(y.lineNumber,P,y.lineNumber,P+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(k){return!!(k&&k.match(n))}function a(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(i(k.path))return L.URI.parse(k.path);if((0,O.$ic)(k.path))return L.URI.file(k.path)}return k.path}function s(k){if(typeof k.path=="object"){const m=L.URI.revive(k.path);if(m)return m.scheme===R.Schemas.file?m.fsPath:m.toString()}return k.path}function t(k,m){const y=m?a:s,D=(0,M.$5n)(k);return r(D,(C,P)=>{C&&P&&(P.path=y(P))}),D}function u(k,m){const y=m?a:s,D=(0,M.$5n)(k);return r(D,(C,P)=>{!C&&P&&(P.path=y(P))}),D}function r(k,m){switch(k.type){case"event":{const y=k;switch(y.event){case"output":m(!1,y.body.source);break;case"loadedSource":m(!1,y.body.source);break;case"breakpoint":m(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=k;switch(y.command){case"setBreakpoints":m(!0,y.arguments.source);break;case"breakpointLocations":m(!0,y.arguments.source);break;case"source":m(!0,y.arguments.source);break;case"gotoTargets":m(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>m(!1,D));break;default:break}break}case"response":{const y=k;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>m(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>m(!1,D));break;case"scopes":y.body.scopes.forEach(D=>m(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>m(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>m(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(C=>m(!1,C.location));break;default:break}break}}}function o(k){return k.filter(m=>!m.presentation?.hidden).sort((m,y)=>m.presentation?y.presentation?m.presentation.group?y.presentation.group?m.presentation.group!==y.presentation.group?m.presentation.group.localeCompare(y.presentation.group):f(m.presentation.order,y.presentation.order):-1:y.presentation.group?1:f(m.presentation.order,y.presentation.order):-1:y.presentation?1:0)}function f(k,m){return typeof k!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:k-m}async function g(k,m){const y=k.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(y!=="none"&&(await m.saveAll(),y==="allEditorsInActiveGroup")){const D=m.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await m.save({editor:D.input,groupId:D.group.id})}await k.reloadConfiguration()}const w=(k,m)=>!k||!m?k===m:k.name===m.name&&k.path===m.path&&k.sourceReference===m.sourceReference;e.$EH=w}),define(ke[300],De([1,0,54,63,24,16,12,14,32,243,144]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=e.$8nc=e.$7nc=e.$6nc=e.$5nc=void 0;class I extends A.$$rb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(c,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,c.on("data",i=>this.v(i))}sendMessage(c){if(this.l){const n=JSON.stringify(c);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}v(c){for(this.p=Buffer.concat([this.p,c]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(I.a);if(n!==-1){const a=this.p.toString("utf8",0,n).split(I.b);for(const s of a){const t=s.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+I.a.length);continue}}break}}}e.$5nc=I;class p extends I{startSession(){return new Promise((c,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),c(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",a=>{i?this.n.fire(a):n(a)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$6nc=p;class S extends p{constructor(c){super(),this.z=c}y(c){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$7nc=S;class v extends p{constructor(c){super(),this.z=c}y(c){return L.createConnection(this.z.path,c)}}e.$8nc=v;class h extends I{constructor(c,n){super(),this.y=c,this.z=n}async startSession(){const c=this.y.command,n=this.y.args,i=this.y.options||{};try{if(c)if(M.$ic(c)){if(!await $.Promises.exists(c))throw new Error(E.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let a=process.env;if(i.env&&Object.keys(i.env).length>0&&(a=O.$8n(O.$5n(process.env),i.env)),c==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:a,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const u=l.fork(n[0],n.slice(1),t);if(!u.pid)throw new Error(E.localize(2,null,n[0]));this.x=u}else throw new Error(E.localize(3,null));else{const s={env:a};i.cwd&&(s.cwd=i.cwd),this.x=l.spawn(c,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(a){this.n.fire(a)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((c,n)=>{const i=l.exec(`taskkill /F /T /PID ${this.x.pid}`,function(a,s,t){if(a)return n(a)});i.on("exit",c),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,n){if(!c)return;const i=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?i.runtime=M.$jc(n,c.runtime):i.runtime=c.runtime),c.runtimeArgs&&(i.runtimeArgs=c.runtimeArgs),c.program&&(M.$ic(c.program)?i.program=c.program:i.program=M.$jc(n,c.program)),c.args&&(i.args=c.args);const a=c;return a.win&&(i.win=h.A(a.win,n)),a.winx86&&(i.winx86=h.A(a.winx86,n)),a.windows&&(i.windows=h.A(a.windows,n)),a.osx&&(i.osx=h.A(a.osx,n)),a.linux&&(i.linux=h.A(a.linux,n)),i}static platformAdapterExecutable(c,n){let i=Object.create(null);n=n.toLowerCase();for(const o of c)if(o.contributes){const f=o.contributes.debuggers;f&&f.length>0&&f.filter(g=>typeof g.type=="string"&&b.$zf(g.type,n)).forEach(g=>{const w=h.A(g,o.extensionLocation.fsPath);i=O.$8n(i,w,o.isBuiltin)})}let a;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?a=i.winx86||i.win||i.windows:R.$i?a=i.win||i.windows:R.$j?a=i.osx:R.$k&&(a=i.linux),a=a||i;const s=a.program||i.program,t=a.args||i.args,u=a.runtime||i.runtime,r=a.runtimeArgs||i.runtimeArgs;if(u)return{type:"executable",command:u,args:(r||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$9nc=h}),define(ke[301],De([1,0,54,31,12]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=R,e.$$nc=$;function M(E,A){return new Promise((I,p)=>{let S="";const v=l.spawn(E,A);v.pid&&v.stdout.on("data",h=>{S+=h.toString()}),v.on("error",h=>{p(h)}),v.on("close",h=>{I(S)})})}async function R(E){if(E)if(O.$i){const A=await new Promise((I,p)=>{he(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{A.getProcessTree(E,p=>{I(!!p&&p.children.length>0)})})}else return M("/usr/bin/pgrep",["-lP",String(E)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(b||(b={}));function $(E,A,I,p,S){E=E.trim().toLowerCase();let v;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?v=1:E.indexOf("cmd.exe")>=0?v=0:E.indexOf("bash")>=0?v=2:O.$i?v=0:v=2;let h,d=" ";switch(v){case 1:if(h=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),p){const c=(0,L.$Dg)(p);c&&(d+=`${c}:; `),d+=`cd ${h(p)}; `}if(S)for(const c in S){const n=S[c];n===null?d+=`Remove-Item env:${c}; `:d+=`\${env:${c}}='${n}'; `}if(A.length>0){const c=A.shift(),n=I?c:h(c);d+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)d+=i==="<"||i===">"||I?i:h(i),d+=" "}break;case 0:if(h=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>c.includes(n))||c.length===0?`"${c}"`:c),p){const c=(0,L.$Dg)(p);c&&(d+=`${c}: && `),d+=`cd ${h(p)} && `}if(S){d+='cmd /C "';for(const c in S){let n=S[c];n===null?d+=`set "${c}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),d+=`set "${c}=${n}" && `)}}for(const c of A)d+=c==="<"||c===">"||I?c:h(c),d+=" ";S&&(d+='"');break;case 2:{h=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const c=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(p&&(d+=`cd ${h(p)} ; `),S){d+="/usr/bin/env";for(const n in S){const i=S[n];i===null?d+=` -u ${c(n)}`:d+=` ${c(`${n}=${i}`)}`}d+=" "}for(const n of A)d+=n==="<"||n===">"||I?n:h(n),d+=" ";break}}return d}}),define(ke[302],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.CellExecutionUpdateType=void 0;var L;(function(O){O[O.Output=1]="Output",O[O.OutputItems=2]="OutputItems",O[O.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$XJ=(0,l.$yi)("INotebookExecutionService")}),define(ke[303],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sib=e.$Rib=e.ProxyKernelState=e.$Qib=void 0,e.$Qib=100;var L;(function(O){O[O.Disconnected=1]="Disconnected",O[O.Connected=2]="Connected",O[O.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.$Rib=(0,l.$yi)("INotebookKernelService"),e.$Sib=(0,l.$yi)("INotebookKernelHistoryService")}),define(ke[304],De([1,0,3,29,205,100]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sXb=void 0;class R extends l.$Uc{constructor($,E,A){super(),this._source=$,this.b=E,this.c=A,this.a=void 0}f($){const E=$.getLineCount();return new L.$xt(1,1,E,this.g($,E))}g($,E){if(E<1||E>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const $=new O.$5C;$.acceptChunk(this._source);const E=$.finish(!0),{textBuffer:A,disposable:I}=E.create(1);this.b=A,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const E=new O.$5C;E.acceptChunk($);const A=E.finish(!0),{textBuffer:I,disposable:p}=A.create(1);return this.B(p),I})),this.a}findInInputs($){const A=new M.$SC($,!1,!1,null).parseSearchRequest();if(!A)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,A,!0,5e3)}findInOutputs($){const A=new M.$SC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(I=>{const p=I.findMatchesLineByLine(this.f(I),A,!0,5e3);if(p.length!==0)return{textBuffer:I,matches:p}}).filter(I=>!!I):[]}}e.$sXb=R}),define(ke[69],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(M){M.Delimiter="\0"})(l||(e.TestIdPathParts=l={}));var L;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class O{static fromExtHostTestItem(R,b,$=R.parent){if(R._isRoot)return new O([b]);const E=[R.id];for(let A=$;A&&A.id!==b;A=A.parent)E.push(A.id);return E.push(b),new O(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new O(R.split("\0"))}static join(R,b){return new O([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:O.isChild(R,b)?2:O.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new O(this.path,1)}get parentId(){return this.d>1?new O(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new O(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new O(this.path,R)}compare(R){if(typeof R=="string")return O.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$5K=O}),define(ke[89],De([1,0,2,51,29,69]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$aL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$_K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$K=e.$0K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$8K=e.$7K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$6K=e.TestResultState=void 0;var R;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$6K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$7K=[2,4,8,16,32,64];const E=N=>"runId"in N;e.$8K=E;var A;(function(N){N.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),N.deserialize=(F,U)=>({range:O.$xt.lift(U.range),uri:F.asCanonicalUri(l.URI.revive(U.uri))})})(A||(e.IRichLocation=A={}));var I;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(I||(e.TestMessageType=I={}));var p;(function(N){N.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&A.serialize(F.location)}),N.deserialize=(F,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&A.deserialize(F,U.location)})})(p||(e.ITestErrorMessage=p={}));const S=(N,F)=>`${F?"s":"e"}${N}`;e.$9K=S;var v;(function(N){N.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&A.serialize(F.location)}),N.deserialize=(F,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&A.deserialize(F,U.location)})})(v||(e.ITestOutputMessage=v={}));var h;(function(N){N.serialize=F=>F.type===0?p.serialize(F):v.serialize(F),N.deserialize=(F,U)=>U.type===0?p.deserialize(F,U):v.deserialize(F,U)})(h||(e.ITestMessage=h={}));var d;(function(N){N.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),N.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(h.serialize)}),N.deserialize=(F,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(Y=>h.deserialize(F,Y))})})(d||(e.ITestTaskState=d={}));const c="\0",n=(N,F)=>N+c+F;e.$0K=n;const i=N=>{const F=N.indexOf(c);return{ctrlId:N.slice(0,F),tagId:N.slice(F+1)}};e.$$K=i;var a;(function(N){N.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),N.deserialize=(F,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?F.asCanonicalUri(l.URI.revive(U.uri)):void 0,range:U.range?O.$xt.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(a||(e.ITestItem=a={}));var s;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(N){N.serialize=F=>({expand:F.expand,item:a.serialize(F.item)}),N.deserialize=(F,U)=>({controllerId:M.$5K.root(U.item.extId),expand:U.expand,item:a.deserialize(F,U.item)})})(t||(e.InternalTestItem=t={}));var u;(function(N){N.serialize=F=>{let U;return F.item&&(U={},F.item.label!==void 0&&(U.label=F.item.label),F.item.tags!==void 0&&(U.tags=F.item.tags),F.item.busy!==void 0&&(U.busy=F.item.busy),F.item.uri!==void 0&&(U.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(U.range=F.item.range?.toJSON()),F.item.description!==void 0&&(U.description=F.item.description),F.item.error!==void 0&&(U.error=F.item.error),F.item.sortText!==void 0&&(U.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:U}},N.deserialize=F=>{let U;return F.item&&(U={},F.item.label!==void 0&&(U.label=F.item.label),F.item.tags!==void 0&&(U.tags=F.item.tags),F.item.busy!==void 0&&(U.busy=F.item.busy),F.item.range!==void 0&&(U.range=F.item.range?O.$xt.lift(F.item.range):null),F.item.description!==void 0&&(U.description=F.item.description),F.item.error!==void 0&&(U.error=F.item.error),F.item.sortText!==void 0&&(U.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:U}}})(u||(e.ITestItemUpdate=u={}));const r=(N,F)=>{F.expand!==void 0&&(N.expand=F.expand),F.item!==void 0&&(N.item=N.item?Object.assign(N.item,F.item):F.item)};e.$_K=r;var o;(function(N){N.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(d.serializeWithoutMessages)}),N.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(d.serialize)}),N.deserialize=(F,U)=>({...t.deserialize(F,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(Y=>d.deserialize(F,Y)),retired:!0})})(o||(e.TestResultItem=o={}));var f;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(F,U)=>{F.covered+=U.covered,F.total+=U.total}})(f||(e.ICoverageCount=f={}));var g;(function(N){N.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,uri:F.uri.toJSON()}),N.deserialize=(F,U)=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:F.asCanonicalUri(l.URI.revive(U.uri))})})(g||(e.IFileCoverage=g={}));function w(N){return{...N,location:N.location?.toJSON()}}function k(N){return N.location=N.location?L.$wt.isIPosition(N.location)?L.$wt.lift(N.location):O.$xt.lift(N.location):void 0,N}e.$aL=3;var m;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(m||(e.DetailType=m={}));var y;(function(N){N.serialize=F=>F.type===0?C.serialize(F):P.serialize(F),N.deserialize=F=>F.type===0?C.deserialize(F):P.deserialize(F)})(y||(e.CoverageDetails=y={}));var D;(function(N){N.serialize=w,N.deserialize=k})(D||(e.IBranchCoverage=D={}));var C;(function(N){N.serialize=w,N.deserialize=k})(C||(e.IDeclarationCoverage=C={}));var P;(function(N){N.serialize=F=>({...w(F),branches:F.branches?.map(D.serialize)}),N.deserialize=F=>({...k(F),branches:F.branches?.map(D.deserialize)})})(P||(e.IStatementCoverage=P={}));var j;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(j||(e.TestDiffOpType=j={}));var T;(function(N){N.deserialize=(F,U)=>U.op===0?{op:U.op,item:t.deserialize(F,U.item)}:U.op===1?{op:U.op,item:u.deserialize(U.item)}:U.op===2?{op:U.op,uri:F.asCanonicalUri(l.URI.revive(U.uri)),docv:U.docv}:U,N.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:u.serialize(F.item)}:F})(T||(e.TestsDiffOp=T={}));class z{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const U=this.v();for(const Y of F)switch(Y.op){case 0:this.l(t.deserialize(this.k,Y.item),U);break;case 1:this.o(u.deserialize(Y.item),U);break;case 3:this.p(Y.itemId,U);break;case 5:this.q(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}U.complete?.()}l(F,U){const Y=M.$5K.parentId(F.item.extId)?.toString();let ie;if(!Y)ie=this.w(F),this.g.add(ie),this.f.set(F.item.extId,ie);else if(this.f.has(Y)){const H=this.f.get(Y);H.children.add(F.item.extId),ie=this.w(F,H),this.f.set(F.item.extId,ie)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return U.add?.(ie),F.expand===2&&this.h++,ie}o(F,U){const Y=this.f.get(F.extId);if(Y)return F.expand!==void 0&&(Y.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$_K)(Y,F),U.update?.(Y),Y}p(F,U){const Y=this.f.get(F);if(!Y)return;const ie=M.$5K.parentId(Y.item.extId)?.toString();ie?this.f.get(ie).children.delete(Y.item.extId):this.g.delete(Y);const H=[[F]];for(;H.length;)for(const J of H.pop()){const x=this.f.get(J);x&&(H.push(x.children),this.f.delete(J),U.remove?.(x,x!==Y),x.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$bL=z}),define(ke[113],De([1,0,7,4,3,62,89,69]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const E=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(a=>!i.includes(a)))}),p=(n,i)=>{let a;for(const[s,t]of I)t(n[s],i[s])||(a?a[s]=i[s]:a={[s]:i[s]});return a};class S extends O.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new l.$Kh(()=>this.flushDiff(),200)),this.g=this.B(new L.$fe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,R.$_K)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,R.$_K)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||a>s.expandLevels)&&(s.expandLevels=a),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,a-1):t.wait().then(()=>this.L(s,a-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,a-1)):this.L(s,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(b.$5K.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const s of a.ops)this.w(i,s);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,M.$ed)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const s=b.$5K.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let u=this.tree.get(s.toString());if(!u){u={fullId:s,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,a);return}if(u.actual===i){this.H(i,u,a);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,a);const r=this.s.getChildren(u.actual),o=u.actual,f=p(this.s.toITestItem(o),this.s.toITestItem(i));this.s.getApiFor(o).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=0,f&&(f.hasOwnProperty("tags")&&(this.C(i.tags,o.tags,s.toString()),delete f.tags),this.w(u,{op:4,update:f})),this.I(i,u,a);for(const[w,k]of r)this.s.getChildren(i).get(k.id)||this.O(b.$5K.joinToString(s,k.id));const g=u.expandLevels;g!==void 0&&queueMicrotask(()=>{u.expand===1&&(u.expandLevels=void 0,this.expand(s.toString(),g))}),this.y(u.actual.uri)}C(i,a,s){const t=new Set(a.map(u=>u.id));for(const u of i)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(u=>(0,R.$0K)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$0K)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,R.$0K)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=u=>this.w(a,u),this.J(a)}I(i,a,s){this.H(i,a,s);for(const[t,u]of this.s.getChildren(i))this.z(u,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const s=[];for(const[t,u]of this.s.getChildren(i.actual)){const r=this.expand(b.$5K.joinToString(i.fullId,u.id),a);(0,l.$kh)(r)&&s.push(r)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new l.$xh;return u.open(),u}i.expand=2,this.N(i);const a=i.resolveBarrier=new l.$xh,s=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(u){s(u)}return(0,l.$kh)(t)?t.catch(s).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[a];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,r]of this.s.getChildren(t.actual))s.push(this.tree.get(b.$5K.joinToString(t.fullId,r.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$zO=S;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$AO=v;class h extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$BO=h;class d extends Error{constructor(i,a,s){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${s}".`)}}e.$CO=d;const c=(n,i,a)=>{let s=new Map;return{get size(){return s.size},forEach(t,u){for(const r of s.values())t.call(u,r,this)},[Symbol.iterator](){return s.entries()},replace(t){const u=new Map,r=new Set(s.keys()),o={op:5,ops:[]};for(const f of t){if(!(f instanceof a))throw new h(f.id);const g=i(f).controllerId;if(g!==n.controllerId)throw new d(f.id,g,n.controllerId);if(u.has(f.id))throw new v(f.id);u.set(f.id,f),r.delete(f.id),o.ops.push({op:0,item:f})}for(const f of r.keys())o.ops.push({op:3,id:f});n.listener?.(o),s=u},add(t){if(!(t instanceof a))throw new h(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$DO=c}),define(ke[145],De([1,0,113]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=void 0;const L=new WeakMap,O=(R,b)=>{const $={controllerId:b};return L.set(R,$),$};e.$EO=O;const M=R=>{const b=L.get(R);if(!b)throw new l.$BO(R?.id||"<unknown>");return b};e.$FO=M}),define(ke[114],De([1,0,15,2]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Ab=e.$5Ab=e.$4Ab=void 0,e.$7Ab=O,e.$8Ab=R,e.$4Ab="vscode-cdn.net",e.$5Ab=`vscode-resource.${e.$4Ab}`,e.$6Ab=`'self' https://*.${e.$4Ab}`;function O(b,$){return b.scheme===l.Schemas.http||b.scheme===l.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===l.Schemas.file&&(b=L.URI.from({scheme:l.Schemas.vscodeRemote,authority:$.authority,path:b.path})),L.URI.from({scheme:l.Schemas.https,authority:`${b.scheme}+${M(b.authority)}.${e.$5Ab}`,path:b.path,fragment:b.fragment,query:b.query}))}function M(b){return b.replace(/./g,$=>{const E=$.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?$:"-"+E.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,($,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[305],De([1,0,4,3,114]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class M{constructor(b,$,E){this.d=b,this.e=$,this.f=E,this.a=0,this.b=new L.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,E,A,I){let p;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){p=i;break}if(!p)throw new Error("not a visible editor");const S=this,v=this.a++,h=new l.$fe,d=new l.$fe,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,O.$7Ab)(i,S.f)}get cspSource(){return O.$6Ab}set options(i){this.b=i,S.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(i){return S.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=E,this.webview=c,this.onDidDispose=d.event}dispose(){S.c.has(v)&&(S.c.delete(v),S.d.$disposeEditorInset(v),d.fire(),d.dispose(),h.dispose())}};return this.d.$createEditorInset(v,p.id,p.value.document.uri,$+1,E,A||{},I.identifier,I.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:h}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$6lc=M}),define(ke[146],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.$iL=void 0,e.$iL="__",e.$jL=(0,l.$yi)("IAuthenticationService"),e.$kL=(0,l.$yi)("IAuthenticationExtensionsService")}),define(ke[306],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.VariableKind=e.$xP=void 0,e.$xP=(0,l.$yi)("configurationResolverService");var L;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class O extends Error{constructor(R,b){super(b),this.variable=R}}e.$yP=O}),define(ke[307],De([1,0,16,52,18,24,12,103,246,306,14]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,v,h,d){this.h=new Map,this.a=S,this.b=v,this.g=h,d&&(this.c=d.then(c=>this.i(c)))}i(S){if(R.$i){const v=Object.create(null);return Object.keys(S).forEach(h=>{v[h.toLowerCase()]=S[h]}),v}return S}resolveWithEnvironment(S,v,h){return this.l({env:this.i(S),userHome:void 0},v?v.uri:void 0,h)}async resolveAsync(S,v){const h={env:await this.c,userHome:await this.g};return this.l(h,S?S.uri:void 0,v)}async j(S,v,h,d){const c=M.$5n(v);R.$i&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):R.$j&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):R.$k&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,c,h,d)}async resolveAnyAsync(S,v,h){return this.j(S,v,h)}async resolveAnyMap(S,v,h){const d=new Map;return{newConfig:await this.j(S,v,h,d),resolvedVariables:d}}resolveWithInteractionReplace(S,v,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,v,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,v){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,v)}async l(S,v,h,d,c){if(O.$$f(h))return this.m(S,v,h,d,c);if(Array.isArray(h))return Promise.all(h.map(n=>this.l(S,v,n,d,c)));if(O.$ag(h)){const n=Object.create(null),i=await Promise.all(Object.keys(h).map(async a=>[await this.m(S,v,a,d,c),await this.l(S,v,h[a],d,c)]));for(const[a,s]of i)n[a]=s;return n}return h}m(S,v,h,d,c){return(0,A.$rf)(h,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let a=await this.o(S,n,i,v,d);return c?.set(i,a),a!==n&&O.$$f(a)&&a.match(I.VARIABLE_REGEXP)&&(a=await this.m(S,v,a,d,c)),a})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,v,h,d,c){let n;const i=h.split(":");i.length>1&&(h=i[0],n=i[1]);const a=u=>{const r=this.a.getFilePath();if(r)return(0,b.$Hw)(r);throw new E.$yP(u,(0,$.localize)(0,null,v))},s=u=>{const r=a(u);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,b.$Hw)(o)}throw new E.$yP(u,(0,$.localize)(1,null,v,l.$nc(r)))},t=u=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new E.$yP(u,(0,$.localize)(2,null,v,n))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new E.$yP(u,(0,$.localize)(3,null,v)):new E.$yP(u,(0,$.localize)(4,null,v))};switch(h){case"env":if(n){if(S.env){const u=S.env[R.$i?n.toLowerCase():n];if(O.$$f(u))return u}return""}throw new E.$yP(E.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const u=this.a.getConfigurationValue(d,n);if(O.$hg(u))throw new E.$yP(E.VariableKind.Config,(0,$.localize)(6,null,v,n));if(O.$ag(u))throw new E.$yP(E.VariableKind.Config,(0,$.localize)(7,null,v,n));return u}throw new E.$yP(E.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(E.VariableKind.Command,v,n,c,"command");case"input":return this.p(E.VariableKind.Input,v,n,c,"input");case"extensionInstallFolder":if(n){const u=await this.a.getExtension(n);if(!u)throw new E.$yP(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(u.extensionLocation)}throw new E.$yP(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,b.$Hw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return d||n?(0,b.$Hw)(this.n(t(E.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Hw)(l.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.$yP(E.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new E.$yP(E.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new E.$yP(E.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return a(E.VariableKind.File);case"fileWorkspaceFolder":return s(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return l.$nc(s(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return d||n?l.$lc(this.n(t(E.VariableKind.RelativeFile)),a(E.VariableKind.RelativeFile)):a(E.VariableKind.RelativeFile);case"relativeFileDirname":{const u=l.$mc(a(E.VariableKind.RelativeFileDirname));if(d||n){const r=l.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),u);return r.length===0?".":r}return u}case"fileDirname":return l.$mc(a(E.VariableKind.FileDirname));case"fileExtname":return l.$oc(a(E.VariableKind.FileExtname));case"fileBasename":return l.$nc(a(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=l.$nc(a(E.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-l.$oc(u).length)}case"fileDirnameBasename":return l.$nc(l.$mc(a(E.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||v}case"execInstallFolder":{const u=this.a.getAppRoot();return u||v}case"pathSeparator":case"/":return l.sep;default:try{const u=n?`${h}:${n}`:h;return this.p(E.VariableKind.Unknown,v,u,c,void 0)}catch{return v}}}}p(S,v,h,d,c){if(h&&d){const n=c===void 0?d[h]:d[c+":"+h];if(typeof n=="string")return n;throw new E.$yP(S,(0,$.localize)(14,null,v))}return v}}e.$NP=I}),define(ke[147],De([1,0,5,143]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$2D=void 0,e.$3D=E,e.$4D=p,e.$5D=S,e.$2D=(0,l.$yi)("editorGroupsService");var O;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(O||(e.GroupDirection=O={}));var M;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function E(v){const h=v;return(0,L.$MF)(h?.editor)&&(0,L.$MF)(h?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(v){const h=v;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function S(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[308],De([1,0,5,147]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$8D=e.$7D=e.$6D=void 0,e.$0D=O,e.$6D=(0,l.$yi)("editorService"),e.$7D=-1,e.$8D=-2,e.$9D=-3;function O(M){const R=M;return typeof M=="number"||(0,L.$4D)(R)}}),define(ke[148],De([1,0,5,137]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=void 0,e.$DL=(0,l.$zi)(L.$Fi)}),define(ke[149],De([1,0,25,4,16,3,7]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=e.$mac=e.$lac=e.$kac=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$kac=b;class ${static isHostExtension(n,i,a){if(i.getExtensionDescription(n))return!1;const s=a.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new L.$fe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(h),this.f=new l.$Vm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=d(this.e,i),this.e=this.e.concat(n);const a=$.l(this.e);return this.e=d(this.e,a.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,a)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,o){this.addNode(r),this.addNode(o),this.c.has(r)?this.c.get(r).push(o):this.c.set(r,[o])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,o){const f=i.getArcs(r);for(let g=0;g<f.length;g++)if(!o.has(f[g]))return!1;return!0}getNodes(){return this.e}},a=new l.$Vm;for(const r of n)if(a.set(r.identifier,r),r.extensionDependencies)for(const o of r.extensionDependencies)i.addArc(l.$Tm.toKey(r.identifier),l.$Tm.toKey(o));const s=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>s.add(r));const t=i.getNodes().filter(r=>!s.has(r));let u;do{u=!1;for(let r=0;r<t.length;r++){const o=t[r];i.hasOnlyGoodArcs(o,s)&&(t.splice(r,1),r--,s.add(o),u=!0)}}while(u);return t.map(r=>a.get(r))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$lac=$;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$mac=E;class A{constructor(n){this.d=new S,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new I(this,i)}deltaExtensions(n,i,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$nac=A;class I extends M.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$oac=I;class p{constructor(n){this.name=n;const i=(0,R.$rh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class S{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new p(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};n.resolve((0,M.$Sc)(s))}}var v;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(v||(v={}));function h(c,n){const i=c.isBuiltin?0:c.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==a)return i-a;const s=O.$gc.basename(c.extensionLocation.path),t=O.$gc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function d(c,n){const i=new l.$Um(n);return c.filter(a=>!i.has(a.identifier))}}),define(ke[309],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.ExtHostConnectionType=void 0,e.$pn=b,e.$qn=$;var l;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(l||(e.ExtHostConnectionType=l={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[L.ENV_KEY]=this.pipeName}}e.$mn=L;class O{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[O.ENV_KEY]="1"}}e.$nn=O;class M{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[M.ENV_KEY]="1"}}e.$on=M;function R(A){delete A[L.ENV_KEY],delete A[O.ENV_KEY],delete A[M.ENV_KEY]}function b(A,I){R(I),A.serialize(I)}function $(A){if(A[L.ENV_KEY])return E(A,new L(A[L.ENV_KEY]));if(A[O.ENV_KEY])return E(A,new O);if(A[M.ENV_KEY])return E(A,new M);throw new Error("No connection information defined in environment!")}function E(A,I){return R(A),I}}),define(ke[115],De([1,0,21]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$2m=R,e.$3m=b;var L;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(L||(e.UIKind=L={}));var O;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(O||(e.ExtensionHostExitCode=O={}));var M;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(E){const A=l.$He.alloc(1);switch(E){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(E,A){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],De([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$2O=e.$1O=void 0,e.$3O=h;let S=class extends I.$Uc{constructor(c,n){super(),this.s=c,this.t=n,this.a=this.B(new L.$fe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$fe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$np,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,O.$7j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,n,i){const a=this.getTelemetryDetails(),s=new v(n,i,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(c,n,i){this.f=c,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const n=Object.create(null);switch(n["common.extname"]=`${c.publisher}.${c.name}`,n["common.extversion"]=c.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$Km)((0,$.$tp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const n=this.getTelemetryDetails();this.r.forEach((i,a)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(a):this.r.set(a,s)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,n){const a=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(c.value),!1;let s=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$1O=S,e.$1O=S=Je([We(0,M.$ZO),We(1,O.$6j)],S);class v{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,n,i,a,s,t,u){this.g=i,this.h=a,this.i=s,this.j=t,this.a=new L.$fe,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(c,n){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let n="properties"in c?c.properties??{}:c;return n=(0,$.$wp)(n,[]),this.c&&(n=(0,E.$8n)(n,this.c)),this.b||(n=(0,E.$8n)(n,this.j)),"properties"in c?c.properties=n:c=n,c}k(c,n){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(c,n),this.h.trace(c,n))}logUsage(c,n){this.d.isUsageEnabled&&this.k(c,n)}logError(c,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,n);else{const i={name:c.name,message:c.message,stack:c.stack,cause:c.cause},a=(0,$.$wp)(i,[]),s=new Error(a.message,{cause:a.cause});s.stack=a.stack,s.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const c=this,n={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$2O=v;function h(d){const c=Date.now()-new Date(d).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$4O=(0,l.$yi)("IExtHostTelemetry")}),define(ke[26],De([1,0,4,2,278,140,25,5]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.ActivationKind=e.$UG=e.$TG=e.$QG=e.ExtensionHostStartup=e.$PG=e.$OG=e.$NG=e.$MG=void 0,e.$RG=p,e.$SG=S,e.$VG=c,e.$WG=n,e.$MG=Object.freeze({identifier:new R.$Tm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$NG="extensions.webWorker",e.$OG=(0,b.$yi)("extensionService");class ${constructor(s){this.dependency=s}}e.$PG=$;var E;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,u){this.c=s,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$xG.createActivationEventsMap(this.d)}}set(s,t,u){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const r=[],o=[],f=[],g=[],w=I(this.d),k=I(t),m=(j,T)=>j.extensionLocation.toString()===T.extensionLocation.toString()||j.isBuiltin===T.isBuiltin||j.isUserBuiltin===T.isUserBuiltin||j.isUnderDevelopment===T.isUnderDevelopment;for(const j of this.d){const T=k.get(j.identifier);if(!T){r.push(j.identifier),w.delete(j.identifier);continue}if(!m(j,T)){r.push(j.identifier),w.delete(j.identifier);continue}}for(const j of t){const T=w.get(j.identifier);if(!T){o.push(j);continue}if(!m(T,j)){r.push(T.identifier),w.delete(T.identifier);continue}}const y=new R.$Um(this.e),D=new R.$Um(u);for(const j of this.e)D.has(j)||f.push(j);for(const j of u)y.has(j)||g.push(j);const C=M.$xG.createActivationEventsMap(o),P={versionId:s,toRemove:r,toAdd:o,addActivationEvents:C,myToRemove:f,myToAdd:g};return this.delta(P),P}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:r,myToAdd:o}=s,f=new R.$Um(t),g=new R.$Um(r);for(let w=0;w<this.d.length;w++)f.has(this.d[w].identifier)&&(this.d.splice(w,1),w--);for(let w=0;w<this.e.length;w++)g.has(this.e[w])&&(this.e.splice(w,1),w--);for(const w of u)this.d.push(w);for(const w of o)this.e.push(w);return this.f=null,s}containsExtension(s){for(const t of this.e)if(R.$Tm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=M.$xG.readActivationEvents(t);for(const r of u)s.add(r)}return s}}e.$QG=A;function I(a){const s=new R.$Vm;for(const t of a)s.set(t.identifier,t);return s}function p(a,s){return a.enabledApiProposals?a.enabledApiProposals.includes(s):!1}function S(a,s){if(!p(a,s))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class v{constructor(s,t,u,r){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=r}}e.$TG=v;class h{constructor(s,t){this.description=s,this.value=t}}e.$UG=h;var d;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function c(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,O.$Cp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function n(a,s){return{identifier:new R.$Tm((0,O.$Ap)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!s,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,publisherDisplayName:a.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.onWillStop=l.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$XG=i}),define(ke[310],De([1,0,13,149,25,26,11,7]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=e.$smc=e.$rmc=e.$qmc=e.$pmc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(c,n,i,a){this.startup=c,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=a}}e.$pmc=$;class E{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,n){return c===-1||n===-1?-1:n-c}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$qmc=E;class A{constructor(c,n,i,a,s,t){this.activationFailed=c,this.activationFailedError=n,this.activationTimes=i,this.module=a,this.exports=s,this.subscriptions=t}}e.$rmc=A;class I extends A{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$smc=I;class p extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$tmc=p;class S extends A{constructor(c){super(!0,c,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(c,n,i,a){this.g=a,this.a=c,this.b=n,this.c=i,this.d=new O.$Vm,this.f=Object.create(null)}dispose(){for(const[c,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const c=[];for(const[n,i]of this.d)c.push(i.wait());await Promise.all(c)}isActivated(c){const n=this.d.get(c);return!!(n&&n.value)}getActivatedExtension(c){const n=this.d.get(c);if(!n||!n.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return n.value}async activateByEvent(c,n){if(this.f[c])return;const i=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(i.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,n){const i=this.a.getExtensionDescription(c);if(!i)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(c){const n=c.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const n=this.a.getExtensionDescription(c.id);if(!n){const s=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new S(s));return this.c.onExtensionActivationError(c.id,s,new M.$PG(c.id.value)),t}const i=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of a){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:c.reason}));continue}const u=this.a.getExtensionDescription(s);if(u){if(!u.main&&!u.browser)continue;i.push(this.j({id:u.identifier,reason:c.reason}));continue}const r=n.displayName||n.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${s}'`),f=this.k(c,n.displayName,[],new S(o));return this.c.onExtensionActivationError(n.identifier,o,new M.$PG(s)),f}return this.k(c,n.displayName,i,null)}k(c,n,i,a){const s=new h(c.id,n,c.reason,i,a,this.c,this.g);return this.d.set(c.id,s),s}l(c){return L.$lac.isHostExtension(c,this.a,this.b)}m(c){const n=this.b.getExtensionDescription(c);return n?!n.main&&!n.browser:!1}};e.$umc=v,e.$umc=v=Je([We(3,R.$5j)],v);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,n,i,a,s,t,u){this.c=c,this.d=n,this.f=i,this.g=a,this.h=s,this.j=t,this.k=u,this.a=new b.$xh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const n=this.g[c];if(n.value&&!n.value.activationFailed){this.g.splice(c,1),c--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new S(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const n=new Error;if(c&&c.name&&(n.name=c.name),c&&c.message?n.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(n.stack=c.stack),this.h=new S(n),this.b&&l.$4(c))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};h=Je([We(6,R.$5j)],h)}),define(ke[311],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[312],De([1,0,248,13,41,138,110,36,25,311,108,140]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=void 0;const p=b.$fo.as(R.$go.JSONContribution);class S{constructor(s,t,u){this.a=s,this.b=t,this.c=u}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(O.default.Error,s)}warn(s){this.d(O.default.Warning,s)}info(s){this.d(O.default.Info,s)}}e.$GG=S;class v{static a(s){const t=new $.$Um;for(let u=0,r=s.length;u<r;u++)t.add(s[u].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const u=this.a(s),r=this.a(t),o=t.filter(g=>!u.has(g.description.identifier)),f=s.filter(g=>!r.has(g.description.identifier));return new v(o,f)}constructor(s,t){this.added=s,this.removed=t}}e.$HG=v;class h{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,L.$1)(s)}}}e.$IG=h;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$JG={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Sm},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:l.localize(15,null),type:"string",enum:["none"],enumDescriptions:[l.localize(16,null)]},activationEvents:{description:l.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(32,null)},{label:"onUri",body:"onUri",description:l.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(37,null)},{label:"onRenderer",description:l.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:l.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:l.localize(42,null)},{label:"*",description:l.localize(43,null),body:"*"}]}},badges:{type:"array",description:l.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(45,null)},href:{type:"string",description:l.localize(46,null)},description:{type:"string",description:l.localize(47,null)}}}},markdown:{type:"string",description:l.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Wo}},extensionPack:{description:l.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Wo}},extensionKind:{description:l.localize(52,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(53,null)},{body:["workspace"],description:l.localize(54,null)},{body:["ui","workspace"],description:l.localize(55,null)},{body:["workspace","ui"],description:l.localize(56,null)},{body:[],description:l.localize(57,null)}]},capabilities:{description:l.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(61,null),l.localize(62,null),l.localize(63,null)]},description:{type:"string",markdownDescription:l.localize(64,null)}}},untrustedWorkspaces:{description:l.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(67,null),l.localize(68,null),l.localize(69,null)]},restrictedConfigurations:{description:l.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(71,null)}}}}},sponsor:{description:l.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(74,null),type:"string"},"vscode:uninstall":{description:l.localize(75,null),type:"string"}}},icon:{type:"string",description:l.localize(76,null)},l10n:{type:"string",description:l.localize(77,null)},pricing:{type:"string",markdownDescription:l.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new h(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&I.$xG.register(s.extensionPoint,s.activationEventsGenerator),e.$JG.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,p.registerSchema(c,e.$JG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$KG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$fo.add(i.ExtensionsRegistry,new n),e.$LG=b.$fo.as(i.ExtensionsRegistry),p.registerSchema(c,e.$JG),p.registerSchema(A.$mk,{properties:{extensionEnabledApiProposals:{description:l.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[313],De([1,0,244,18,24,312,38,4]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var E;(function(p){function S(v,h,d){if(!v)return;const c=L.$$f(v.type)?v.type:void 0;if(!c||c.length===0){d.error(l.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)L.$$f(i)&&n.push(i);return{extensionId:h.value,taskType:c,required:n,properties:v.properties?O.$5n(v.properties):{},when:v.when?R.$wj.deserialize(v.when):void 0}}p.from=S})(E||(E={}));const A=M.$LG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,S)=>{for(const v of p)v.type&&S.push(`onTaskType:${v.type}`)},jsonSchema:{description:l.localize(4,null),type:"array",items:$}});class I{constructor(){this.d=new b.$fe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,v)=>{A.setHandler((h,d)=>{this.c=void 0;try{for(const c of d.removed){const n=c.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of d.added){const n=c.value;for(const i of n){const a=E.from(i,c.description.identifier,c.collector);a&&(this.a[a.taskType]=a)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const v of this.all()){const h={type:"object",additionalProperties:!1};v.required.length>0&&(h.required=v.required.slice(0)),v.properties!==void 0?h.properties=O.$5n(v.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[v.taskType]},S.push(h)}this.c={oneOf:S}}return this.c}}e.$fI=new I}),define(ke[314],De([1,0,245,18,23,24,38,313]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$pI=e.JsonSchemaVersion=e.ExecutionEngine=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$jI=e.ShellQuoting=e.$iI=e.$hI=e.$gI=void 0,e.$gI="settings",e.$hI=new R.$Pj("taskRunning",!1,l.localize(0,null)),e.$iI=l.localize2(2,"Tasks");var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$jI="$customized",function(N){function F(U){if(!U)return N.Strong;switch(U.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=F}($||(e.ShellQuoting=$={}));var E;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function F(U){switch(U.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=F}(A||(e.RevealKind=A={}));var I;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(N){function F(U){switch(U.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=F}(I||(e.RevealProblemKind=I={}));var p;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(p||(e.PanelKind=p={})),function(N){function F(U){switch(U.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=F}(p||(e.PanelKind=p={}));var S;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var v;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(N){function F(Y){switch(Y.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=F;function U(Y){switch(Y){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=U}(v||(e.RuntimeType=v={}));var h;(function(N){function F(U){return L.$$f(U)?U:U.value}N.value=F})(h||(e.CommandString=h={}));var d;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function F(Y){return Y===N.Clean._id||Y===N.Build._id||Y===N.Rebuild._id||Y===N.Test._id}N.is=F;function U(Y){if(Y!==void 0)return L.$$f(Y)?F(Y)?{_id:Y,isDefault:!1}:void 0:Y}N.from=U})(d||(e.TaskGroup=d={}));var c;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var n;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function F(U){switch(U){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var i;(function(N){N.parallel="parallel",N.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var s;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(F,U,Y,ie,H,J){this._label="",this._id=F,U&&(this._label=U),Y&&(this.type=Y),this.runOptions=ie,this.configurationProperties=H,this._source=J}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,U=!1){if(F===void 0)return!1;if(L.$$f(F))return F===this._label||F===this.configurationProperties.identifier||U&&F===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$kI=t;class u extends t{constructor(F,U,Y,ie,H,J,x,ne){super(F,Y,void 0,x,ne,U),this.command={},this._source=U,this.hasDefinedMatchers=J,H&&(this.command=H)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case v.Shell:U="shell";break;case v.Process:U="process";break;case v.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(F){return F instanceof u}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$gI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Y={type:e.$jI,folder:F,id:U};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$9g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new u(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$lI=u;class r extends t{constructor(F,U,Y,ie,H,J,x){super(F,Y,ie,J,x,U),this._source=U,this.configures=H}static is(F){return F instanceof r}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$9g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$gI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Y={type:e.$jI,folder:F,id:U};return JSON.stringify(Y)}}e.$mI=r;class o extends t{constructor(F,U,Y,ie,H,J,x,ne,be){super(F,Y,ie,ne,be,U),this.defines=H,this.hasDefinedMatchers=x,this.command=J,this.icon=be.icon,this.hide=be.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof o}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new o(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$nI=o;class f extends t{constructor(F,U,Y,ie,H,J){super(F,Y,ie,H,J,U),this._source=U}clone(){return new f(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof f}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new f(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$oI=f;var g;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(N){N._default=N.Terminal}(g||(e.ExecutionEngine=g={}));var w;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class k{constructor(F){this.c=new Map;for(let U=0;U<F.length;U++)this.c.set(F[U].uri.toString(),U)}compare(F,U){const Y=F.getWorkspaceFolder(),ie=U.getWorkspaceFolder();if(Y&&ie){let H=this.c.get(Y.uri.toString());H=H===void 0?0:H+1;let J=this.c.get(ie.uri.toString());return J=J===void 0?0:J+1,H===J?F._label.localeCompare(U._label):H-J}else return!Y&&ie?-1:Y&&!ie?1:0}}e.$pI=k;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m||(e.TaskEventKind=m={}));var y;(function(N){N.SingleRun="singleRun",N.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var C;(function(N){function F(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function U(ne,be,ae){return{...F(ne),kind:"start",terminalId:be,resolvedVariables:ae}}N.start=U;function Y(ne,be,ae){return{...F(ne),kind:"processStarted",terminalId:be,processId:ae}}N.processStarted=Y;function ie(ne,be,ae){return{...F(ne),kind:"processEnded",terminalId:be,exitCode:ae}}N.processEnded=ie;function H(ne,be,ae){return{...F(ne),kind:"terminated",exitReason:ae,terminalId:be}}N.terminated=H;function J(ne,be,ae){return{...F(be),kind:ne,terminalId:ae}}N.general=J;function x(){return{kind:"changed"}}N.changed=x})(C||(e.TaskEvent=C={}));var P;(function(N){function F(Y){const ie=Object.keys(Y).sort();let H="";for(const J of ie){let x=Y[J];x instanceof Object?x=F(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),H+=J+","+x+","}return H}function U(Y){const H={_key:F(Y),type:Y.taskType};return Object.assign(H,Y),H}N.create=U})(P||(e.KeyedTaskIdentifier=P={}));var j;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var T;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var z;(function(N){function F(U,Y){const ie=b.$fI.get(U.type);if(ie===void 0){const ne=M.$5n(U);return delete ne._key,P.create(ne)}const H=Object.create(null);H.type=ie.taskType;const J=new Set;ie.required.forEach(ne=>J.add(ne));const x=ie.properties;for(const ne of Object.keys(x)){const be=U[ne];if(be!=null)H[ne]=be;else if(J.has(ne)){const ae=x[ne];if(ae.default!==void 0)H[ne]=M.$5n(ae.default);else switch(ae.type){case"boolean":H[ne]=!1;break;case"number":case"integer":H[ne]=0;break;case"string":H[ne]="";break;default:Y.error(l.localize(1,null,JSON.stringify(U,void 0,0),ne));return}}}return P.create(H)}N.createTaskIdentifier=F})(z||(e.TaskDefinition=z={}))}),define(ke[315],De([1,0,13]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=e.$pac=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,l.$1)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$pac=L;class O extends L{constructor(){super(),this.h=!0,this.i=new l.$5}}e.$qac=O}),define(ke[48],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Bw=void 0,e.$Cw=O,e.$Dw=M;class l{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++l.count}}e.$Bw=l;const L=[];function O(b){const $=new l(b);return L[$.nid]=$,$}function M(b){return L[b].sid}class R{constructor($){this.value=$}}e.$Ew=R}),define(ke[6],De([1,0,48]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var O;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput",h[h.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(O||(e.TabInputKind=O={}));var M;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var E;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output",h[h.Hybrid=3]="Hybrid"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(d){return d._id=I.a++,d}}e.$fM=I;var p;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var S;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var v;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$gM={MainThreadAuthentication:(0,l.$Cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.$Cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,l.$Cw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,l.$Cw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,l.$Cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,l.$Cw)("MainThreadChatVariables"),MainThreadClipboard:(0,l.$Cw)("MainThreadClipboard"),MainThreadCommands:(0,l.$Cw)("MainThreadCommands"),MainThreadComments:(0,l.$Cw)("MainThreadComments"),MainThreadConfiguration:(0,l.$Cw)("MainThreadConfiguration"),MainThreadConsole:(0,l.$Cw)("MainThreadConsole"),MainThreadDebugService:(0,l.$Cw)("MainThreadDebugService"),MainThreadDecorations:(0,l.$Cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.$Cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.$Cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.$Cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.$Cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.$Cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.$Cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.$Cw)("MainThreadEditorTabs"),MainThreadErrors:(0,l.$Cw)("MainThreadErrors"),MainThreadTreeViews:(0,l.$Cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.$Cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,l.$Cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.$Cw)("MainThreadLanguages"),MainThreadLogger:(0,l.$Cw)("MainThreadLogger"),MainThreadMessageService:(0,l.$Cw)("MainThreadMessageService"),MainThreadOutputService:(0,l.$Cw)("MainThreadOutputService"),MainThreadProgress:(0,l.$Cw)("MainThreadProgress"),MainThreadQuickDiff:(0,l.$Cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,l.$Cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.$Cw)("MainThreadStatusBar"),MainThreadSecretState:(0,l.$Cw)("MainThreadSecretState"),MainThreadStorage:(0,l.$Cw)("MainThreadStorage"),MainThreadSpeech:(0,l.$Cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,l.$Cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.$Cw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,l.$Cw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,l.$Cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.$Cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.$Cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.$Cw)("MainThreadCustomEditors"),MainThreadUrls:(0,l.$Cw)("MainThreadUrls"),MainThreadUriOpeners:(0,l.$Cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,l.$Cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,l.$Cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.$Cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,l.$Cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,l.$Cw)("MainThreadExtensionService"),MainThreadSCM:(0,l.$Cw)("MainThreadSCM"),MainThreadSearch:(0,l.$Cw)("MainThreadSearch"),MainThreadShare:(0,l.$Cw)("MainThreadShare"),MainThreadTask:(0,l.$Cw)("MainThreadTask"),MainThreadWindow:(0,l.$Cw)("MainThreadWindow"),MainThreadLabelService:(0,l.$Cw)("MainThreadLabelService"),MainThreadNotebook:(0,l.$Cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.$Cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.$Cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.$Cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.$Cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.$Cw)("MainThreadInteractive"),MainThreadTheming:(0,l.$Cw)("MainThreadTheming"),MainThreadTunnelService:(0,l.$Cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,l.$Cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,l.$Cw)("MainThreadTimeline"),MainThreadTesting:(0,l.$Cw)("MainThreadTesting"),MainThreadLocalization:(0,l.$Cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,l.$Cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,l.$Cw)("MainThreadAiEmbeddingVector")},e.$hM={ExtHostCommands:(0,l.$Cw)("ExtHostCommands"),ExtHostConfiguration:(0,l.$Cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.$Cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.$Cw)("ExtHostDebugService"),ExtHostDecorations:(0,l.$Cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.$Cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.$Cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.$Cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.$Cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.$Cw)("ExtHostEditors"),ExtHostTreeViews:(0,l.$Cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.$Cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.$Cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.$Cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.$Cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.$Cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.$Cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,l.$Cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,l.$Cw)("ExtHostStatusBar"),ExtHostShare:(0,l.$Cw)("ExtHostShare"),ExtHostExtensionService:(0,l.$Cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.$Cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.$Cw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,l.$Cw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,l.$Cw)("ExtHostSCM"),ExtHostSearch:(0,l.$Cw)("ExtHostSearch"),ExtHostTask:(0,l.$Cw)("ExtHostTask"),ExtHostWorkspace:(0,l.$Cw)("ExtHostWorkspace"),ExtHostWindow:(0,l.$Cw)("ExtHostWindow"),ExtHostWebviews:(0,l.$Cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.$Cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.$Cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.$Cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.$Cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.$Cw)("ExtHostEditorTabs"),ExtHostProgress:(0,l.$Cw)("ExtHostProgress"),ExtHostComments:(0,l.$Cw)("ExtHostComments"),ExtHostSecretState:(0,l.$Cw)("ExtHostSecretState"),ExtHostStorage:(0,l.$Cw)("ExtHostStorage"),ExtHostUrls:(0,l.$Cw)("ExtHostUrls"),ExtHostUriOpeners:(0,l.$Cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,l.$Cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,l.$Cw)("ExtHostOutputService"),ExtHostLabelService:(0,l.$Cw)("ExtHostLabelService"),ExtHostNotebook:(0,l.$Cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.$Cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.$Cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.$Cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.$Cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,l.$Cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,l.$Cw)("ExtHostInteractive"),ExtHostChatAgents2:(0,l.$Cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,l.$Cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,l.$Cw)("ExtHostChatProvider"),ExtHostSpeech:(0,l.$Cw)("ExtHostSpeech"),ExtHostEmbeddings:(0,l.$Cw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,l.$Cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,l.$Cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,l.$Cw)("ExtHostTheming"),ExtHostTunnelService:(0,l.$Cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,l.$Cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,l.$Cw)("ExtHostAuthentication"),ExtHostTimeline:(0,l.$Cw)("ExtHostTimeline"),ExtHostTesting:(0,l.$Cw)("ExtHostTesting"),ExtHostTelemetry:(0,l.$Cw)("ExtHostTelemetry"),ExtHostLocalization:(0,l.$Cw)("ExtHostLocalization")}}),define(ke[91],De([1,0,5,11,6,20]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=void 0,e.$Olc=(0,l.$yi)("IExtHostApiDeprecationService");let R=class{constructor($,E){this.c=E,this.a=new Set,this.b=$.getProxy(O.$gM.MainThreadTelemetry)}report($,E,A){const I=this.d($,E);this.a.has(I)||(this.a.add(I),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:$}))}d($,E){return`${$}-${E.identifier.value}`}};e.$Plc=R,e.$Plc=R=Je([We(0,M.$JO),We(1,L.$5j)],R),e.$Qlc=Object.freeze(new class{report(b,$,E){}})}),define(ke[316],De([1,0,6]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class L{constructor(M){const R=M.getProxy(l.$gM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$4lc=L}),define(ke[317],De([1,0,24,6,28,20]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;let R=class{constructor(A,I){this.a=A.getProxy(L.$gM.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,I){const p=this,S=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){p.e(A,I,S,arguments)}})}e(A,I,p,S){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:$(S,this.b)}),this.c&&this.f(A,p,S)}};e.$Xnc=R,e.$Xnc=R=Je([We(0,M.$JO),We(1,O.$ZO)],R);const b=1e5;function $(E,A){const I=[];if(E.length)for(let p=0;p<E.length;p++){let S=E[p];if(typeof S>"u")S="undefined";else if(S instanceof Error){const v=S;v.stack?S=v.stack:S=v.toString()}I.push(S)}if(A){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,l.$0n)(I);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(ke[318],De([1,0,2,6,26]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class M{constructor(b){this.a=b.getProxy(L.$gM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,O.$SG)(b,"showLocal"),this.a.$showOpenDialog($).then(E=>E?E.map(A=>l.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?l.URI.revive($):void 0)}}e.$1mc=M}),define(ke[319],De([1,0,22,4,3,6]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;class R{constructor($){this.b=new Map,this.c=new L.$fe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(M.$gM.MainThreadEmbeddings)}registerEmbeddingsProvider($,E,A){if(this.d.has(E))throw new Error("An embeddings provider for this model is already registered");const I=this.e++;return this.a.$registerEmbeddingProvider(I,E),this.b.set(I,{id:E,provider:A}),(0,O.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(I),this.b.delete(I)})}async computeEmbeddings($,E,A){A??=l.CancellationToken.None;let I=!1;typeof E=="string"&&(E=[E],I=!0);const p=await this.a.$computeEmbeddings($,E,A);if(p.length!==E.length)throw new Error;if(I){if(p.length!==1)throw new Error;return p[0]}return p}async $provideEmbeddings($,E,A){const I=this.b.get($);if(!I)return[];const p=await I.provider.provideEmbeddings(E,A);return p||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$4mc=R}),define(ke[320],De([1,0,3,6]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class O{constructor(R){this.b=0,this.a=R.getProxy(L.$gM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,l.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$inc=O}),define(ke[116],De([1,0,12,14,2,5,11,6,28,20]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Imc=void 0;let A=class{constructor(p,S,v){this.f=v,this.d=new Map,this.a=S.getProxy(b.$gM.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===l.$g}getMessage(p,S){const{message:v,args:h,comment:d}=S;if(this.c)return(0,L.$$e)(v,h??{});let c=v;d&&d.length>0&&(c+=`/${Array.isArray(d)?d.join(""):d}`);const n=this.d.get(p)?.contents[c];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,L.$$e)(n??v,h??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let S;const v=await this.g(p);if(!v){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(v),d=JSON.parse(h);S=p.isBuiltin?d.contents?.bundle:d}catch(h){this.f.error(`Failed to load translations for ${p.identifier.value} from ${v}: ${h.message}`);return}S&&this.d.set(p.identifier.value,{contents:S,uri:v})}async g(p){if(p.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return O.URI.revive(S)}return p.l10n?O.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Imc=A,e.$Imc=A=Je([We(0,$.$ZO),We(1,E.$JO),We(2,R.$5j)],A),e.$Jmc=(0,M.$yi)("IExtHostLocalizationService")}),define(ke[150],De([1,0,11,6,28,20,2,58]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;let $=class extends l.$dk{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(S=>(0,b.$8h)(S))),this.r=I.getProxy(L.$gM.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(R.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,S){return new E(this.r,I,p,S)}};e.$Wnc=$,e.$Wnc=$=Je([We(0,M.$JO),We(1,O.$ZO)],$);class E extends l.$$j{constructor(I,p,S,v){super(v?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(p,v).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const S=[[I,p]];this.m?this.u(S):this.n.push(...S)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(ke[117],De([1,0,6,5,3,20,21]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0,e.$Kmc=(0,L.$yi)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(l.$gM.MainThreadManagedSockets)}setFactory(I,p){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,S=await this.c.makeConnection(),v=new O.$Tc;return this.d.set(p,new E(p,S,v)),v.add((0,O.$Sc)(()=>this.d.delete(p))),v.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),v.dispose()})),v.add(S.onDidClose(h=>{this.a.$onDidManagedSocketClose(p,h?.stack??h?.message),v.dispose()})),v.add(S.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(p,R.$He.wrap(h)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Lmc=b,e.$Lmc=b=Je([We(0,M.$JO)],b);class ${constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class E extends O.$Uc{constructor(I,p,S){super(),this.socketId=I,this.actual=p,this.B(S)}}}),define(ke[321],De([1,0,6,11,26]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;function M(b){return b&&b.title}let R=class{constructor($,E){this.b=E,this.a=$.getProxy(l.$gM.MainThreadMessageService)}showMessage($,E,A,I,p){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof I=="string"||M(I)?v=[I,...p]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,v=p),S.useCustom&&(0,O.$SG)($,"resolvers");const h=[];let d=!1;for(let c=0;c<v.length;c++){const n=v[c];if(typeof n=="string")h.push({title:n,handle:c,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:a}=n;h.push({title:i,isCloseAffordance:!!a,handle:c}),a&&(d?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):d=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,A,S,h).then(c=>{if(typeof c=="number")return v[c]})}};e.$knc=R,e.$knc=R=Je([We(1,L.$5j)],R)}),define(ke[322],De([1,0,3,18,2,26,6]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(R.$gM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,A,I){if((0,M.$SG)(E,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,E.identifier.value),(0,l.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(E,A,I,p){const S=this.b.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(A,I,p)}async $readProfile(E,A,I){const p=this.b.get(E);if(!p)throw new Error(`Unknown handler with id: ${E}`);return p.readProfile((0,L.$$f)(A)?A:O.URI.revive(A),I)}}e.$tnc=b}),define(ke[118],De([1,0,6,4,5]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;class M{constructor(b){this.b=new L.$fe,this.onDidChangePassword=this.b.event,this.a=b.getProxy(l.$gM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,E){return this.a.$setPassword(b,$,E)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$Fmc=M,e.$Gmc=(0,O.$yi)("IExtHostSecretState")}),define(ke[323],De([1,0,22,3,6]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class M{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.f=new Map,this.b=b.getProxy(O.$gM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,E){const A=this.c.get(b);if(!A)return;const I=new L.$Tc,p=new l.$qe;this.d.set($,p);const S=await A.provideSpeechToTextSession(p.token,E?{language:E}:void 0);S&&(I.add(S.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),I.add(p.token.onCancellationRequested(()=>I.dispose())))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createTextToSpeechSession(b,$){const E=this.c.get(b);if(!E)return;const A=new L.$Tc,I=new l.$qe;this.d.set($,I);const p=await E.provideTextToSpeechSession(I.token);p&&(this.f.set($,p),A.add(p.onDidChange(S=>{I.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,S)})),A.add(I.token.onCancellationRequested(()=>A.dispose())))}async $synthesizeSpeech(b,$){this.f.get(b)?.synthesize($)}async $cancelTextToSpeechSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b),this.f.delete(b)}async $createKeywordRecognitionSession(b,$){const E=this.c.get(b);if(!E)return;const A=new L.$Tc,I=new l.$qe;this.d.set($,I);const p=await E.provideKeywordRecognitionSession(I.token);p&&(A.add(p.onDidChange(S=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),A.add(I.token.onCancellationRequested(()=>A.dispose())))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,E){const A=M.a++;return this.c.set(A,E),this.b.$registerProvider(A,$,{extension:b,displayName:b.value}),(0,L.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Anc=M}),define(ke[119],De([1,0,6,4,5]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=e.$vmc=void 0;class M{constructor(b,$){this.c=$,this.b=new L.$fe,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(l.$gM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,E){const A=await this.a.$initializeExtensionStorage(b,$);let I;return A&&(I=this.d(b,$,A)),I||E}setValue(b,$,E){return this.a.$setValue(b,$,E)}$acceptValue(b,$,E){const A=this.d(b,$,E);A&&this.b.fire({shared:b,key:$,value:A})}d(b,$,E){try{return JSON.parse(E)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${A}`)}}}e.$vmc=M,e.$wmc=(0,O.$yi)("IExtHostStorage")}),define(ke[324],De([1,0,3,15,2,6]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(M.$gM.MainThreadUriOpeners)}registerExternalUriOpener($,E,A,I){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const p=I.schemes.find(S=>!R.a.has(S));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(E,A),this.b.$registerUriOpener(E,I.schemes,$,I.label),(0,l.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri($,E,A){const I=this.c.get($);if(!I)throw new Error(`Unknown opener with id: ${$}`);const p=O.URI.revive(E);return I.canOpenExternalUri(p,A)}async $openUri($,E,A){const I=this.c.get($);if(!I)throw new Error(`Unknown opener id: '${$}'`);return I.openExternalUri(O.URI.revive(E.resolvedUri),{sourceUri:O.URI.revive(E.sourceUri)},A)}}e.$Qnc=R}),define(ke[325],De([1,0,6,2,3,13,25]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;class b{static{this.a=0}constructor(E){this.c=new R.$Um,this.d=new Map,this.b=E.getProxy(l.$gM.MainThreadUrls)}registerUriHandler(E,A){const I=E.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=b.a++;return this.c.add(I),this.d.set(p,A),this.b.$registerUriHandler(p,I,E.displayName||E.name),(0,O.$Sc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(E,A){const I=this.d.get(E);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(A))}catch(p){(0,M.$1)(p)}return Promise.resolve(void 0)}async createAppUri(E){return L.URI.revive(await this.b.$createAppUri(E))}}e.$Rnc=b}),define(ke[92],De([1,0,4,3,15,24,2,252,290,114,6]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=e.$gmc=void 0,e.$hmc=p,e.$jmc=h,e.$kmc=d;class I{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,s,t,u,r,o,f){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new l.$fe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new l.$fe,this._onDidDispose=this.#h.event,this.#e=a,this.#t=s,this.#o=t,this.#i=u,this.#s=r,this.#r=o,this.#l=p(o),this.#d=S(o),this.#n=f}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,E.$7Ab)(a,this.#i)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===O.Schemas.https||a.scheme===O.Schemas.http){let s=a.toString();return s.endsWith("/")||(s+="/"),s+" "+E.$6Ab}return E.$6Ab}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),M.$9n(this.#o,a)||this.#t.$setOptions(this.#e,d(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const s=(0,$.$Xrb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const s=this.#r.extensionLocation?.scheme===O.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===O.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,r,o,f,g,w)=>{const k=R.URI.from({scheme:f||"file",path:decodeURIComponent(g)}),m=(0,E.$7Ab)(k,{isRemote:s,authority:t}).toString();return`${r}${m}${w}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,r,o,f,g,w)=>{const k=R.URI.from({scheme:f||"file",path:decodeURIComponent(g)}),m=(0,E.$7Ab)(k,{isRemote:s,authority:t}).toString();return`${r}${m}${w}`})}}e.$gmc=I;function p(i){try{const a=(0,b.$Lp)((0,b.$Kp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function S(i){try{const a=(0,b.$Lp)((0,b.$Kp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class v extends L.$Uc{constructor(a,s,t,u,r){super(),this.c=s,this.f=t,this.g=u,this.h=r,this.b=new Map,this.a=a.getProxy(A.$gM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,s,t){const u=this.j(a);if(u){const{message:r}=(0,$.$Yrb)(s,t.value);u._onMessageEmitter.fire(r)}}$onMissingCsp(a,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,s,t){const u=new I(a,this.a,c(s),this.c,this.f,t,this.h);this.b.set(a,u);const r=u._onDidDispose(()=>{r.dispose(),this.deleteWebview(a)});return u}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$imc=v;function h(i){return{id:i.identifier,location:i.extensionLocation}}function d(i,a,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,a)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>R.URI.from(a))}}function n(i,a){return[...(a?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ke[151],De([1,0,4,15,14,2,5,20,6]),function(he,e,l,L,O,M,R,b,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0;let A=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const p=this.d;return{get focused(){return p.focused},get active(){return p.active}}}constructor(p){this.c=new l.$fe,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=p.getProxy($.$gM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:v})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,S){S!==this.d[p]&&(this.d={...this.d,[p]:S},this.c.fire(this.d))}openUri(p,S){let v;if(typeof p=="string"){v=p;try{p=M.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,O.$9e)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,v,S)}async asExternalUri(p,S){if((0,O.$9e)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(p,S);return M.URI.from(v)}};e.$Tnc=A,e.$Tnc=A=E=Je([We(0,b.$JO)],A),e.$Unc=(0,R.$yi)("IExtHostWindow")}),define(ke[326],De([1,0,317,28,20]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0;const M=1024*1024;let R=class extends l.$Xnc{constructor($,E){super($,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,E,A){const I=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),E.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j($,E){const A=process[$],I=A.write;let p="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(S,v,h)=>{if(!this.g){p+=S.toString(v);const d=p.length>M?p.length:p.lastIndexOf(`
`);d!==-1&&(console[E](p.slice(0,d)),p=p.slice(d+1))}I.call(A,S,v,h)}})}};e.$woc=R,e.$woc=R=Je([We(0,O.$JO),We(1,L.$ZO)],R)}),define(ke[327],De([1,0,150,15,267,30]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=void 0;class R extends l.$Wnc{s($,E,A){return $.scheme===L.Schemas.file?new O.$YP(A?.name||(0,M.$Ug)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,E):super.s($,E,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Ioc=R}),define(ke[328],De([1,0,7,21,22,13,4,3,134,315,48]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.ResponsiveState=e.RequestInitiator=void 0,e.$rac=d,e.$sac=c;function p(D,C){try{return JSON.stringify(D,C)}catch{return"null"}}const S="$$ref$$",v={[S]:-1};class h{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function d(D,C=null,P=!1){const j=[];return{jsonString:(P?p:JSON.stringify)(D,(z,N)=>{if(typeof N>"u")return v;if(typeof N=="object"){if(N instanceof L.$He){const F=j.push(N)-1;return{[S]:F}}if(C)return C(z,N)}return N}),referencedBuffers:j}}function c(D,C,P){return JSON.parse(D,(j,T)=>{if(T){const z=T[S];if(typeof z=="number")return C[z];if(P&&T.$mid===1)return P.transformIncoming(T)}return T})}function n(D,C){return JSON.stringify(D,C)}function i(D){return D?(C,P)=>P&&P.$mid===1?D.transformOutgoing(P):P:null}var a;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var s;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends b.$Uc{static{I=u}static{this.a=3*1e3}constructor(C,P=null,j=null){super(),this[I]=!0,this.b=this.B(new R.$fe),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,z=A.$Bw.count;T<z;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new l.$Kh(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,$.$Dn)(C,this.g):C}getProxy(C){const{nid:P,sid:j}=C;return this.s[P]||(this.s[P]=this.J(P,j)),this.s[P]}J(C,P){const j={get:(T,z)=>(typeof z=="string"&&!T[z]&&z.charCodeAt(0)===36&&(T[z]=(...N)=>this.U(C,z,N)),z===r?P:T[z])};return new Proxy(Object.create(null),j)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,j=C.length;P<j;P++){const T=C[P];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,j=g.read(C,0),T=j.readUInt8(),z=j.readUInt32();switch(T){case 1:case 2:{let{rpcId:N,method:F,args:U}=k.deserializeRequestJSONArgs(j);this.g&&(U=(0,$.$Dn)(U,this.g)),this.M(P,z,N,F,U,T===2);break}case 3:case 4:{let{rpcId:N,method:F,args:U}=k.deserializeRequestMixedArgs(j);this.g&&(U=(0,$.$Dn)(U,this.g)),this.M(P,z,N,F,U,T===4);break}case 5:{this.f?.logIncoming(P,z,0,"ack"),this.G(z);break}case 6:{this.N(P,z);break}case 7:{this.O(P,z,void 0);break}case 9:{let N=k.deserializeReplyOKJSON(j);this.g&&(N=(0,$.$Dn)(N,this.g)),this.O(P,z,N);break}case 10:{const N=k.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(P,z,N);break}case 8:{const N=k.deserializeReplyOKVSBuffer(j);this.O(P,z,N);break}case 11:{let N=k.deserializeReplyErrError(j);this.g&&(N=(0,$.$Dn)(N,this.g)),this.P(P,z,N);break}case 12:{this.P(P,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,j,T,z,N){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,A.$Dw)(j)}.${T}(`,z);const F=String(P);let U,Y;if(N){const H=new O.$qe;z.push(H.token),U=this.Q(j,T,z),Y=()=>H.cancel()}else U=this.Q(j,T,z),Y=t;this.u[F]=Y;const ie=k.serializeAcknowledged(P);this.f?.logOutgoing(ie.byteLength,P,1,"ack"),this.c.send(ie),U.then(H=>{delete this.u[F];const J=k.serializeReplyOK(P,H,this.h);this.f?.logOutgoing(J.byteLength,P,1,"reply:",H),this.c.send(J)},H=>{delete this.u[F];const J=k.serializeReplyErr(P,H);this.f?.logOutgoing(J.byteLength,P,1,"replyErr:",H),this.c.send(J)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const j=String(P);this.u[j]?.()}O(C,P,j){this.f?.logIncoming(C,P,0,"receiveReply:",j);const T=String(P);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T],z.resolveOk(j)}P(C,P,j){this.f?.logIncoming(C,P,0,"receiveReplyErr:",j);const T=String(P);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T];let N;j&&(j.$isError?(N=new Error,N.name=j.name,N.message=j.message,N.stack=j.stack):N=j),z.resolveErr(N)}Q(C,P,j){try{return Promise.resolve(this.S(C,P,j))}catch(T){return Promise.reject(T)}}S(C,P,j){const T=this.m[C];if(!T)throw new Error("Unknown actor "+(0,A.$Dw)(C));const z=T[P];if(typeof z!="function")throw new Error("Unknown method "+P+" on actor "+(0,A.$Dw)(C));return z.apply(T,j)}U(C,P,j){if(this.j)return new E.$qac;let T=null;if(j.length>0&&O.CancellationToken.isCancellationToken(j[j.length-1])&&(T=j.pop()),T&&T.isCancellationRequested)return Promise.reject(M.$6());const z=k.serializeRequestArguments(j,this.h),N=++this.t,F=String(N),U=new E.$pac,Y=new b.$Tc;T&&Y.add(T.onCancellationRequested(()=>{const H=k.serializeCancel(N);this.f?.logOutgoing(H.byteLength,N,0,"cancel"),this.c.send(k.serializeCancel(N))})),this.w[F]=new f(U,Y),this.F(N);const ie=k.serializeRequest(N,C,P,z,!!T);return this.f?.logOutgoing(ie.byteLength,N,0,`request: ${(0,A.$Dw)(C)}.${P}(`,j),this.c.send(ie),U}}e.$tac=o;class f{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class g{static alloc(C,P,j){const T=new g(L.$He.alloc(j+1+4),0);return T.writeUInt8(C),T.writeUInt32(P),T}static read(C,P){return new g(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+C).toString();return this.b+=C,j}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+C).toString();return this.b+=C,j}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let j=0,T=C.length;j<T;j++){const z=C[j];switch(P+=1,z.type){case 1:P+=this.sizeLongString(z.value);break;case 2:P+=this.sizeVSBuffer(z.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(z.value);for(let N=0;N<z.buffers.length;++N)P+=this.sizeVSBuffer(z.buffers[N]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,j=C.length;P<j;P++){const T=C[P];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let z=0;z<T.buffers.length;++z)this.writeBuffer(T.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let j=0;j<C;j++)switch(this.readUInt8()){case 1:P[j]=this.readLongString();break;case 2:P[j]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),N=this.readLongString(),F=[];for(let U=0;U<z;++U)F.push(this.readVSBuffer());P[j]=new A.$Ew(c(N,F,null));break}case 4:P[j]=void 0;break}return P}}var w;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(w||(w={}));class k{static a(C){for(let P=0,j=C.length;P<j;P++)if(C[P]instanceof L.$He||C[P]instanceof A.$Ew||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const j=[];for(let T=0,z=C.length;T<z;T++){const N=C[T];if(N instanceof L.$He)j[T]={type:2,value:N};else if(typeof N>"u")j[T]={type:4};else if(N instanceof A.$Ew){const{jsonString:F,referencedBuffers:U}=d(N.value,P);j[T]={type:3,value:L.$He.fromString(F),buffers:U}}else j[T]={type:1,value:L.$He.fromString(n(N,P))}}return{type:1,args:j}}return{type:0,args:n(C,P)}}static serializeRequest(C,P,j,T,z){switch(T.type){case 0:return this.b(C,P,j,T.args,z);case 1:return this.c(C,P,j,T.args,z)}}static b(C,P,j,T,z){const N=L.$He.fromString(j),F=L.$He.fromString(T);let U=0;U+=g.sizeUInt8(),U+=g.sizeShortString(N),U+=g.sizeLongString(F);const Y=g.alloc(z?2:1,C,U);return Y.writeUInt8(P),Y.writeShortString(N),Y.writeLongString(F),Y.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),j=C.readShortString(),T=C.readLongString();return{rpcId:P,method:j,args:JSON.parse(T)}}static c(C,P,j,T,z){const N=L.$He.fromString(j);let F=0;F+=g.sizeUInt8(),F+=g.sizeShortString(N),F+=g.sizeMixedArray(T);const U=g.alloc(z?4:3,C,F);return U.writeUInt8(P),U.writeShortString(N),U.writeMixedArray(T),U.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),j=C.readShortString(),T=C.readMixedArray(),z=new Array(T.length);for(let N=0,F=T.length;N<F;N++){const U=T[N];typeof U=="string"?z[N]=JSON.parse(U):z[N]=U}return{rpcId:P,method:j,args:z}}static serializeAcknowledged(C){return g.alloc(5,C,0).buffer}static serializeCancel(C){return g.alloc(6,C,0).buffer}static serializeReplyOK(C,P,j){if(typeof P>"u")return this.d(C);if(P instanceof L.$He)return this.e(C,P);if(P instanceof A.$Ew){const{jsonString:T,referencedBuffers:z}=d(P.value,j,!0);return this.g(C,T,z)}else return this.f(C,p(P,j))}static d(C){return g.alloc(7,C,0).buffer}static e(C,P){let j=0;j+=g.sizeVSBuffer(P);const T=g.alloc(8,C,j);return T.writeVSBuffer(P),T.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const j=L.$He.fromString(P);let T=0;T+=g.sizeLongString(j);const z=g.alloc(9,C,T);return z.writeLongString(j),z.buffer}static g(C,P,j){const T=L.$He.fromString(P);let z=0;z+=g.sizeUInt32,z+=g.sizeLongString(T);for(const F of j)z+=g.sizeVSBuffer(F);const N=g.alloc(10,C,z);N.writeUInt32(j.length),N.writeLongString(T);for(const F of j)N.writeBuffer(F);return N.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const j=C.readUInt32(),T=C.readLongString(),z=[];for(let N=0;N<j;++N)z.push(C.readVSBuffer());return new A.$Ew(c(T,z,P))}static serializeReplyErr(C,P){const j=P?p(M.$3(P),null):void 0;if(typeof j!="string")return this.h(C);const T=L.$He.fromString(j);let z=0;z+=g.sizeLongString(T);const N=g.alloc(11,C,z);return N.writeLongString(T),N.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return g.alloc(12,C,0).buffer}}var m;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(ke[329],De([1,0,21,27,15,85,5]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=e.$TJ=void 0,e.$UJ=A,e.$VJ=I,e.$TJ=(0,R.$yi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),E=7;function A(S){if(S.scheme!==O.Schemas.vscodeNotebookCell)return;const v=S.fragment.indexOf("s");if(v<0)return;const h=parseInt(S.fragment.substring(0,v).replace($,""),E),d=(0,l.$1e)(S.fragment.substring(v+1)).toString();if(!isNaN(h))return{handle:h,notebook:S.with({scheme:d,fragment:null})}}function I(S,v){const h=v.toString(E),c=`${h.length<b.length?b[h.length-1]:"z"}${h}s${(0,l.$2e)(l.$He.fromString(S.scheme),!0,!0)}`;return S.with({scheme:O.Schemas.vscodeNotebookCell,fragment:c})}class p{constructor(){this.a=new L.$Ac}getNotebook(v){if(v.scheme===O.Schemas.vscodeNotebookCell){const h=A(v);if(h){const d=this.a.get(h.notebook);if(d)return d}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$WJ=p,(0,M.$As)(e.$TJ,p,1)}),define(ke[120],De([1,0,21,35,39,101,15,16,12,38,329]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eK=e.$bK=e.CellStatusbarAlignment=e.$aK=e.NotebookEditorPriority=e.$0J=e.$9J=e.$7J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$6J=e.$5J=e.$4J=e.$3J=e.CellKind=e.$2J=e.$1J=e.$ZJ=void 0,e.$8J=u,e.$$J=o,e.$_J=f,e.$cK=k,e.$dK=y,e.$ZJ="workbench.editor.notebook",e.$1J="workbench.editor.notebookTextDiffEditor",e.$2J="workbench.editor.interactive";var I;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(I||(e.CellKind=I={})),e.$3J=["application/json","application/javascript","text/html","image/svg+xml",M.$Ts.latex,M.$Ts.markdown,"image/png","image/jpeg",M.$Ts.text],e.$4J=[M.$Ts.latex,M.$Ts.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Ts.text],e.$5J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$6J="_notAvailable";var p;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var S;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var h;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var d;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var c;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var n;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(U){U.scheme=R.Schemas.vscodeNotebookCell;function Y(be,ae){return(0,A.$VJ)(be,ae)}U.generate=Y;function ie(be){return(0,A.$UJ)(be)}U.parse=ie;function H(be,ae){return be.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${be.scheme!==R.Schemas.file?be.scheme:""}`})}U.generateCellOutputUri=H;function J(be){if(be.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!ae)return;const Ie=ae[1]&&ae[1]!==""?ae[1]:void 0,ee=ae[2];return{outputId:Ie,notebook:be.with({scheme:ee||R.Schemas.file,fragment:null})}}U.parseCellOutputUri=J;function x(be,ae,Ie){return U.generate(be,ae).with({scheme:Ie})}U.generateCellPropertyUri=x;function ne(be,ae){if(be.scheme===ae)return U.parse(be.with({scheme:U.scheme}))}U.parseCellPropertyUri=ne})(a||(e.CellUri=a={}));const s=U=>$.$i?U.replace(/\//g,"\\"):U;class t{constructor(Y=[],ie=e.$3J){this.e=ie,this.d=[...new Set(Y)].map(H=>({pattern:H,matches:L.$sk(s(H))}))}sort(Y){const ie=new Map(O.Iterable.map(Y,J=>[J,s(J)]));let H=[];for(const{matches:J}of this.d)for(const[x,ne]of ie)if(J(ne)){H.push(x),ie.delete(x);break}return ie.size&&(H=H.concat([...ie.keys()].sort((J,x)=>this.e.indexOf(J)-this.e.indexOf(x)))),H}prioritize(Y,ie){const H=this.f(Y);if(H===-1){this.d.unshift({pattern:Y,matches:L.$sk(s(Y))});return}const J=new Set(ie.map(ne=>this.f(ne,H)));J.delete(-1);const x=Array.from(J).sort();this.d.splice(H+1,0,...x.map(ne=>this.d[ne]));for(let ne=x.length-1;ne>=0;ne--)this.d.splice(x[ne],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,ie=this.d.length){const H=s(Y);for(let J=0;J<ie;J++)if(this.d[J].matches(H))return J;return-1}}e.$7J=t;function u(U,Y,ie,H=(J,x)=>J===x){const J=[];function x(ae,Ie,ee){if(Ie===0&&ee.length===0)return;const B=J[J.length-1];B&&B.start+B.deleteCount===ae?(B.deleteCount+=Ie,B.toInsert.push(...ee)):J.push({start:ae,deleteCount:Ie,toInsert:ee})}let ne=0,be=0;for(;;){if(ne===U.length){x(ne,0,Y.slice(be));break}if(be===Y.length){x(ne,U.length-ne,[]);break}const ae=U[ne],Ie=Y[be];if(H(ae,Ie)){ne+=1,be+=1;continue}ie(Ie)?(x(ne,1,[]),ne+=1):(x(ne,0,[Ie]),be+=1)}return J}e.$9J=new E.$Pj("notebookEditorCursorAtBoundary","none"),e.$0J=new E.$Pj("notebookEditorCursorAtLineBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r||(e.NotebookEditorPriority=r={}));function o(U){const Y=U;return!!((typeof Y.include=="string"||L.$tk(Y.include))&&(typeof Y.exclude=="string"||L.$tk(Y.exclude)))}function f(U,Y,ie){if(Array.isArray(U.viewType)&&U.viewType.indexOf(Y)>=0||U.viewType===Y)return!0;if(U.filenamePattern){const H=o(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,J=o(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(L.$rk(H,(0,b.$nc)(ie.fsPath).toLowerCase()))return!(J&&L.$rk(J,(0,b.$nc)(ie.fsPath).toLowerCase()))}return!1}e.$aK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var g;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class w{static{this.d="notebook/"}static create(Y){return`${w.d}${Y}`}static parse(Y){if(Y.startsWith(w.d))return Y.substring(w.d.length)}}e.$bK=w;function k(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}const m=new TextDecoder;function y(U){const Y=[];let ie=!1;for(const ne of U)(Y.length===0||ie)&&(Y.push(ne),ie=!0);let H=P(Y);const J=l.$He.concat(Y.map(ne=>l.$He.wrap(ne))),x=F(J);return H=H||x.byteLength!==J.byteLength,{data:x,didCompression:H}}e.$eK="\x1B[A";const D=e.$eK.split("").map(U=>U.charCodeAt(0)),C=10;function P(U){let Y=!1;return U.forEach((ie,H)=>{if(H===0||ie.length<e.$eK.length)return;const J=U[H-1],x=ie.subarray(0,e.$eK.length);if(x[0]===D[0]&&x[1]===D[1]&&x[2]===D[2]){const ne=J.lastIndexOf(C);if(ne===-1)return;Y=!0,U[H-1]=J.subarray(0,ne),U[H]=ie.subarray(e.$eK.length)}}),Y}function j(U){let Y=U;do U=Y,Y=U.replace(/[^\n]\x08/gm,"");while(Y.length<U.length);return U}function T(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const Y=U.match(/^(.*)\r+/m)[1];let ie=U.match(/\r+(.*)$/m)[1];ie=ie+Y.slice(ie.length,Y.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ie)}return U}const z=8,N=13;function F(U){return!U.buffer.includes(z)&&!U.buffer.includes(N)?U:l.$He.fromString(T(j(m.decode(U.buffer))))}}),define(ke[8],De([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v){"use strict";var h,d,c,n,i,a,s,t,u,r,o,f,g,w,k,m,y;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$xO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$eO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$4N=e.$3N=e.$2N=e.$1N=e.$YN=e.$XN=e.$WN=e.$VN=e.TestRunProfileKind=e.TestResultState=e.$UN=e.$TN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$SN=e.NotebookVariablesRequestKind=e.$RN=e.$QN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$PN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.ColorThemeKind=e.$JN=e.$IN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$HN=e.$GN=e.DebugConsoleMode=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$AN=e.$zN=e.FileChangeType=e.$yN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$xN=e.$wN=e.$vN=e.$uN=e.InlineCompletionTriggerKind=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$hN=e.ConfigurationTarget=e.$gN=e.$fN=e.$eN=e.$dN=e.DocumentPasteTriggerKind=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$9M=e.ViewBadge=e.ProgressLocation=e.$8M=e.$7M=e.TaskScope=e.ShellQuoting=e.$6M=e.$5M=e.$4M=e.TaskPanelKind=e.TaskRevealKind=e.$3M=e.TerminalLocation=e.$2M=e.$1M=e.$ZM=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$YM=e.$XM=e.$WM=e.$VM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$TM=e.$SM=e.$RM=e.$QM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$PM=e.$OM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.LanguageStatusSeverity=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.CodeActionTriggerKind=e.$CM=e.$BM=e.SymbolTag=e.SymbolKind=e.$AM=e.$zM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.DiagnosticSeverity=e.DiagnosticTag=e.$tM=e.$sM=e.FileEditType=e.$rM=e.$qM=e.$pM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$UM=Dt,e.$iN=Ze,e.$ZN=vi;function D(G){return Object.assign(G,{apply:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const Ne=me.length===1?[]:me[1];return Reflect.construct(G,Ne,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const[Ne,...Qe]=me;return Reflect.construct(G,Qe,Ne.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let j=h=class{static from(...V){let me=V;return new h(function(){if(me){for(const Ne of me)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();me=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$iM=j,e.$iM=j=h=Je([D],j);let T=d=class{static Min(...V){if(V.length===0)throw new TypeError;let me=V[0];for(let Ne=1;Ne<V.length;Ne++){const Qe=V[Ne];Qe.isBefore(me)&&(me=Qe)}return me}static Max(...V){if(V.length===0)throw new TypeError;let me=V[0];for(let Ne=1;Ne<V.length;Ne++){const Qe=V[Ne];Qe.isAfter(me)&&(me=Qe)}return me}static isPosition(V){if(!V)return!1;if(V instanceof d)return!0;const{line:me,character:Ne}=V;return typeof me=="number"&&typeof Ne=="number"}static of(V){if(V instanceof d)return V;if(this.isPosition(V))return new d(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,me){if(V<0)throw(0,L.$7)("line must be non-negative");if(me<0)throw(0,L.$7)("character must be non-negative");this.c=V,this.e=me}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,me=0){if(V===null||me===null)throw(0,L.$7)();let Ne;return typeof V>"u"?Ne=0:typeof V=="number"?Ne=V:(Ne=typeof V.lineDelta=="number"?V.lineDelta:0,me=typeof V.characterDelta=="number"?V.characterDelta:0),Ne===0&&me===0?this:new d(this.line+Ne,this.character+me)}with(V,me=this.character){if(V===null||me===null)throw(0,L.$7)();let Ne;return typeof V>"u"?Ne=this.line:typeof V=="number"?Ne=V:(Ne=typeof V.line=="number"?V.line:this.line,me=typeof V.character=="number"?V.character:this.character),Ne===this.line&&me===this.character?this:new d(Ne,me)}toJSON(){return{line:this.line,character:this.character}}};e.$jM=T,e.$jM=T=d=Je([D],T);let z=c=class{static isRange(V){return V instanceof c?!0:V?T.isPosition(V.start)&&T.isPosition(V.end):!1}static of(V){if(V instanceof c)return V;if(this.isRange(V))return new c(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,me,Ne,Qe){let et,dt;if(typeof V=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Qe=="number"?(et=new T(V,me),dt=new T(Ne,Qe)):T.isPosition(V)&&T.isPosition(me)&&(et=T.of(V),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this.c=et,this.e=dt):(this.c=dt,this.e=et)}contains(V){return c.isRange(V)?this.contains(V.start)&&this.contains(V.end):T.isPosition(V)?!(T.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const me=T.Max(V.start,this.c),Ne=T.Min(V.end,this.e);if(!me.isAfter(Ne))return new c(me,Ne)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const me=T.Min(V.start,this.c),Ne=T.Max(V.end,this.end);return new c(me,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,me=this.end){if(V===null||me===null)throw(0,L.$7)();let Ne;return V?T.isPosition(V)?Ne=V:(Ne=V.start||this.start,me=V.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&me.isEqual(this.end)?this:new c(Ne,me)}toJSON(){return[this.start,this.end]}};e.$kM=z,e.$kM=z=c=Je([D],z);let N=n=class extends z{static isSelection(V){return V instanceof n?!0:V?z.isRange(V)&&T.isPosition(V.anchor)&&T.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,me,Ne,Qe){let et,dt;if(typeof V=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Qe=="number"?(et=new T(V,me),dt=new T(Ne,Qe)):T.isPosition(V)&&T.isPosition(me)&&(et=T.of(V),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this.f=et,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lM=N,e.$lM=N=n=Je([D],N);const F=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,L.$7)("connectionToken")};class U{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,me,Ne){if(typeof V!="string"||V.length===0)throw(0,L.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,L.$7)("port");typeof Ne<"u"&&F(Ne),this.host=V,this.port=Math.round(me),this.connectionToken=Ne}}e.$mM=U;class Y{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,me){this.makeConnection=V,this.connectionToken=me,typeof me<"u"&&F(me)}}e.$nM=Y;class ie extends Error{static NotAvailable(V,me){return new ie(V,S.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(V){return new ie(V,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,me=S.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(V),this._message=V,this._code=me,this._detail=Ne,Object.setPrototypeOf(this,ie.prototype)}}e.$oM=ie;var H;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var J;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let x=i=class{static isTextEdit(V){return V instanceof i?!0:V?z.isRange(V)&&typeof V.newText=="string":!1}static replace(V,me){return new i(V,me)}static insert(V,me){return i.replace(new z(V,V),me)}static delete(V){return i.replace(V,"")}static setEndOfLine(V){const me=new i(new z(new T(0,0),new T(0,0)),"");return me.newEol=V,me}get range(){return this.c}set range(V){if(V&&!z.isRange(V))throw(0,L.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,L.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,L.$7)("newEol");this.f=V}constructor(V,me){this.c=V,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pM=x,e.$pM=x=i=Je([D],x);let ne=a=class{static isNotebookCellEdit(V){return V instanceof a?!0:V?gn.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,me){return new a(V,me)}static insertCells(V,me){return new a(new gn(V,V),me)}static deleteCells(V){return new a(V,[])}static updateCellMetadata(V,me){const Ne=new a(new gn(V,V),[]);return Ne.newCellMetadata=me,Ne}static updateNotebookMetadata(V){const me=new a(new gn(0,0),[]);return me.newNotebookMetadata=V,me}constructor(V,me){this.range=V,this.newCells=me}};e.$qM=ne,e.$qM=ne=a=Je([D],ne);class be{static isSnippetTextEdit(V){return V instanceof be?!0:V?z.isRange(V.range)&&ee.isSnippetString(V.snippet):!1}static replace(V,me){return new be(V,me)}static insert(V,me){return be.replace(new z(V,V),me)}constructor(V,me){this.range=V,this.snippet=me}}e.$rM=be;var ae;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,me,Ne,Qe){this.c.push({_type:1,from:V,to:me,options:Ne,metadata:Qe})}createFile(V,me,Ne){this.c.push({_type:1,from:void 0,to:V,options:me,metadata:Ne})}deleteFile(V,me,Ne){this.c.push({_type:1,from:V,to:void 0,options:me,metadata:Ne})}e(V,me,Ne){this.c.push({_type:3,metadata:Ne,uri:V,edit:{editType:5,metadata:me},notebookMetadata:me})}f(V,me,Ne,Qe){const et=me.start,dt=me.end;(et!==dt||Ne.length>0)&&this.c.push({_type:5,uri:V,index:et,count:dt-et,cells:Ne,metadata:Qe})}g(V,me,Ne,Qe){this.c.push({_type:3,metadata:Qe,uri:V,edit:{editType:3,index:me,metadata:Ne}})}replace(V,me,Ne,Qe){this.c.push({_type:2,uri:V,edit:new x(me,Ne),metadata:Qe})}insert(V,me,Ne,Qe){this.replace(V,new z(me,me),Ne,Qe)}delete(V,me,Ne){this.replace(V,me,"",Ne)}has(V){return this.c.some(me=>me._type===2&&me.uri.toString()===V.toString())}set(V,me){if(me)for(const Ne of me){if(!Ne)continue;let Qe,et;Array.isArray(Ne)?(Qe=Ne[0],et=Ne[1]):Qe=Ne,ne.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(V,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(V,Qe.newNotebookMetadata,et):this.f(V,Qe.range,Qe.newCells,et):be.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:V,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:2,uri:V,edit:Qe,metadata:et})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Qe=this.c[Ne];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===V.toString()&&(this.c[Ne]=void 0);break}}(0,l.$Ib)(this.c)}}get(V){const me=[];for(const Ne of this.c)Ne._type===2&&Ne.uri.toString()===V.toString()&&me.push(Ne.edit);return me}entries(){const V=new M.$Ac;for(const me of this.c)if(me._type===2){let Ne=V.get(me.uri);Ne||(Ne=[me.uri,[]],V.set(me.uri,Ne)),Ne[1].push(me.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sM=Ie,e.$sM=Ie=Je([D],Ie);let ee=s=class{static isSnippetString(V){return V instanceof s?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=s.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,me=this.e++){if(typeof V=="function"){const Ne=new s;Ne.e=this.e,V(Ne),this.e=Ne.e,V=Ne.value}else V=s.c(V);return this.value+="${",this.value+=me,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,me=this.e++){const Ne=V.map(Qe=>Qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(V,me){if(typeof me=="function"){const Ne=new s;Ne.e=this.e,me(Ne),this.e=Ne.e,me=Ne.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$tM=ee,e.$tM=ee=s=Je([D],ee);var B;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var _;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let pe=t=class{static isLocation(V){return V instanceof t?!0:V?z.isRange(V.range)&&E.URI.isUri(V.uri):!1}constructor(V,me){if(this.uri=V,me)if(z.isRange(me))this.range=z.of(me);else if(T.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uM=pe,e.$uM=pe=t=Je([D],pe);let ue=class{static is(V){return V?typeof V.message=="string"&&V.location&&z.isRange(V.location.range)&&E.URI.isUri(V.location.uri):!1}constructor(V,me){this.location=V,this.message=me}static isEqual(V,me){return V===me?!0:!V||!me?!1:V.message===me.message&&V.location.range.isEqual(me.location.range)&&V.location.uri.toString()===me.location.uri.toString()}};e.$vM=ue,e.$vM=ue=Je([D],ue);let ce=class{constructor(V,me,Ne=_.Error){if(!z.isRange(V))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=V,this.message=me,this.severity=Ne}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,me){return V===me?!0:!V||!me?!1:V.message===me.message&&V.severity===me.severity&&V.code===me.code&&V.severity===me.severity&&V.source===me.source&&V.range.isEqual(me.range)&&(0,l.$ub)(V.tags,me.tags)&&(0,l.$ub)(V.relatedInformation,me.relatedInformation,ue.isEqual)}};e.$wM=ce,e.$wM=ce=Je([D],ce);let oe=class{constructor(V,me){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=me}};e.$xM=oe,e.$xM=oe=Je([D],oe);let le=class extends oe{constructor(V,me,Ne,Qe){super(V,me),this.canIncreaseHover=Ne,this.canDecreaseHover=Qe}};e.$yM=le,e.$yM=le=Je([D],le);var K;(function(G){G[G.Increase=0]="Increase",G[G.Decrease=1]="Decrease"})(K||(e.HoverVerbosityAction=K={}));var se;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let $e=class{constructor(V,me=se.Text){this.range=V,this.kind=me}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$zM=$e,e.$zM=$e=Je([D],$e);let ve=class{constructor(V,me){this.uri=V,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$AM=ve,e.$AM=ve=Je([D],ve);var Me;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var ge;(function(G){G[G.Deprecated=1]="Deprecated"})(ge||(e.SymbolTag=ge={}));let Pe=u=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,me,Ne,Qe,et){this.name=V,this.kind=me,this.containerName=et,typeof Ne=="string"&&(this.containerName=Ne),Qe instanceof pe?this.location=Qe:Ne instanceof z&&(this.location=new pe(Qe,Ne)),u.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$BM=Pe,e.$BM=Pe=u=Je([D],Pe);let Ae=r=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(r.validate)}constructor(V,me,Ne,Qe,et){this.name=V,this.detail=me,this.kind=Ne,this.range=Qe,this.selectionRange=et,this.children=[],r.validate(this)}};e.$CM=Ae,e.$CM=Ae=r=Je([D],Ae);var ze;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let q=class{constructor(V,me){this.title=V,this.kind=me}};e.$DM=q,e.$DM=q=Je([D],q);let W=class{static{o=this}static{this.c="."}constructor(V){this.value=V}append(V){return new o(this.value?this.value+o.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+o.c)}};e.$EM=W,e.$EM=W=o=Je([D],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let X=class{constructor(V,me){if(this.range=V,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$FM=X,e.$FM=X=Je([D],X);class Q{constructor(V,me,Ne,Qe,et,dt){this.kind=V,this.name=me,this.detail=Ne,this.uri=Qe,this.range=et,this.selectionRange=dt}}e.$GM=Q;class de{constructor(V,me){this.fromRanges=me,this.from=V}}e.$HM=de;class we{constructor(V,me){this.fromRanges=me,this.to=V}}e.$IM=we;var je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let qe=class{constructor(V,me){this.range=V,this.command=me}get isResolved(){return!!this.command}};e.$JM=qe,e.$JM=qe=Je([D],qe);let Ke=f=class{#e;static isMarkdownString(V){return V instanceof f?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,me=!1){this.#e=new O.$Vk(V,{supportThemeIcons:me})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,me){return this.#e.appendCodeblock(me??"",V),this}};e.$KM=Ke,e.$KM=Ke=f=Je([D],Ke);let tt=class{constructor(V,me){this.label=V,this.documentation=me}};e.$LM=tt,e.$LM=tt=Je([D],tt);let _e=class{constructor(V,me){this.label=V,this.documentation=me,this.parameters=[]}};e.$MM=_e,e.$MM=_e=Je([D],_e);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$NM=nt,e.$NM=nt=Je([D],nt);var it;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var rt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let ct=class{constructor(V){this.value=V}};e.$OM=ct,e.$OM=ct=Je([D],ct);let Re=class{constructor(V,me,Ne){this.position=V,this.label=me,this.kind=Ne}};e.$PM=Re,e.$PM=Re=Je([D],Re);var Se;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se||(e.CompletionTriggerKind=Se={}));var Ve;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ve||(e.CompletionItemKind=Ve={}));var te;(function(G){G[G.Deprecated=1]="Deprecated"})(te||(e.CompletionItemTag=te={}));let re=class{constructor(V,me){this.label=V,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$QM=re,e.$QM=re=Je([D],re);let Ce=class{constructor(V=[],me=!1){this.items=V,this.isIncomplete=me}};e.$RM=Ce,e.$RM=Ce=Je([D],Ce);let Ge=class{constructor(V,me,Ne){this.insertText=V,this.range=me,this.command=Ne}};e.$SM=Ge,e.$SM=Ge=Je([D],Ge);let Oe=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$TM=Oe,e.$TM=Oe=Je([D],Oe);var st;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var lt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(lt||(e.ViewColumn=lt={}));var mt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function Dt(G,V){return`${I.$Tm.toKey(G)}.${V}`}var It;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var zt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var Bt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Bt||(e.TextEditorRevealType=Bt={}));var kt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(kt||(e.TextEditorSelectionChangeKind=kt={}));var Zt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var xt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(G){function V(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=V}(kt||(e.TextEditorSelectionChangeKind=kt={}));var xe;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(G){function V(me){switch(me){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=V}(xe||(e.SyntaxTokenType=xe={}));let on=class{constructor(V,me){if(me&&!E.URI.isUri(me))throw(0,L.$7)("target");if(!z.isRange(V)||V.isEmpty)throw(0,L.$7)("range");this.range=V,this.target=me}};e.$VM=on,e.$VM=on=Je([D],on);let Xt=class{constructor(V,me,Ne,Qe){this.red=V,this.green=me,this.blue=Ne,this.alpha=Qe}};e.$WM=Xt,e.$WM=Xt=Je([D],Xt);let ft=class{constructor(V,me){if(me&&!(me instanceof Xt))throw(0,L.$7)("color");if(!z.isRange(V)||V.isEmpty)throw(0,L.$7)("range");this.range=V,this.color=me}};e.$XM=ft,e.$XM=ft=Je([D],ft);let $t=class{constructor(V){if(!V||typeof V!="string")throw(0,L.$7)("label");this.label=V}};e.$YM=$t,e.$YM=$t=Je([D],$t);var _t;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var Qt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Qt||(e.SourceControlInputBoxValidationType=Qt={}));var Ft;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var gt;(function(G){G[G.Low=0]="Low",G[G.Medium=1]="Medium",G[G.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Vt{constructor(V,me,Ne){if(this.startIndex=V,this.length=me,this.tooltip=Ne,typeof V!="number"||V<0)throw(0,L.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,L.$7)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,L.$7)("tooltip")}}e.$ZM=Vt;class en{constructor(V){this.uri=V}}e.$1M=en;class Ut{constructor(V){this.terminalCommand=V}}e.$2M=Ut;var Ye;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Ye||(e.TerminalLocation=Ye={}));class un{constructor(V){if(this.options=V,typeof V!="object")throw(0,L.$7)("options")}}e.$3M=un;var Yt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Yt||(e.TaskRevealKind=Yt={}));var Wt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Wt||(e.TaskPanelKind=Wt={}));let bt=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(V){switch(V){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(V,me){if(this.label=me,typeof V!="string"||typeof me!="string")throw(0,L.$7)("name");this.c=V}get id(){return this.c}};e.$4M=bt,e.$4M=bt=g=Je([D],bt);function qt(G){let V="";for(let me=0;me<G.length;me++)V+=G[me].replace(/,/g,",,")+",";return V}let Lt=class{constructor(V,me,Ne){if(typeof V!="string")throw(0,L.$7)("process");this.e=[],this.c=V,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Ne):this.f=me)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,L.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const me of this.e)V.push(me);return qt(V)}};e.$5M=Lt,e.$5M=Lt=Je([D],Lt);let Tt=class{constructor(V,me,Ne){if(this.f=[],Array.isArray(me)){if(!V)throw(0,L.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,L.$7)("command");this.e=V,this.f=me,this.g=Ne}else{if(typeof V!="string")throw(0,L.$7)("commandLine");this.c=V,this.g=me}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,L.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,L.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)V.push(typeof me=="string"?me:me.value);return qt(V)}};e.$6M=Tt,e.$6M=Tt=Je([D],Tt);var tn;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(tn||(e.ShellQuoting=tn={}));var Gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Gt||(e.TaskScope=Gt={}));class an{constructor(V){this.c=V}computeId(){return"customExecution"+(0,A.$Ug)()}set callback(V){this.c=V}get callback(){return this.c}}e.$7M=an;let Rt=class{static{w=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,me,Ne,Qe,et,dt){this.k=!1,this.l=this.definition=V;let pt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Ne,this.execution=Qe,pt=et,this.k=!0):me===Gt.Global||me===Gt.Workspace?(this.target=me,this.o=this.name=Ne,this.w=this.source=Qe,this.execution=et,pt=dt):(this.target=me,this.o=this.name=Ne,this.w=this.source=Qe,this.execution=et,pt=dt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:w.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:w.f,id:this.q.computeId()}:this.q instanceof an?this.l={type:w.c,id:this.q.computeId()}:this.l={type:w.g,id:(0,A.$Ug)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,L.$7)("Kind can't be undefined or null");this.B(),this.l=V}get scope(){return this.m}set target(V){this.B(),this.m=V}get name(){return this.o}set name(V){if(typeof V!="string")throw(0,L.$7)("name");this.B(),this.o=V}get execution(){return this.q}set execution(V){V===null&&(V=void 0),this.B(),this.q=V;const me=this.l.type;(w.g===me||w.e===me||w.f===me||w.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(V){if(Array.isArray(V))this.B(),this.r=V,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.B(),this.u=V}get source(){return this.w}set source(V){if(typeof V!="string"||V.length===0)throw(0,L.$7)("source must be a string of length > 0");this.B(),this.w=V}get group(){return this.x}set group(V){V===null&&(V=void 0),this.B(),this.x=V}get detail(){return this.A}set detail(V){V===null&&(V=void 0),this.A=V}get presentationOptions(){return this.y}set presentationOptions(V){V==null&&(V=Object.create(null)),this.B(),this.y=V}get runOptions(){return this.z}set runOptions(V){V==null&&(V=Object.create(null)),this.B(),this.z=V}};e.$8M=Rt,e.$8M=Rt=w=Je([D],Rt);var jt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(jt||(e.ProgressLocation=jt={}));var Nt;(function(G){function V(me){const Ne=me;return(0,$.$cg)(Ne.value)?Ne.tooltip&&!(0,$.$$f)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}G.isViewBadge=V})(Nt||(e.ViewBadge=Nt={}));let At=k=class{static isTreeItem(V,me){const Ne=V;if(Ne.checkboxState!==void 0){const Qe=(0,$.$cg)(Ne.checkboxState)?Ne.checkboxState:(0,$.$ag)(Ne.checkboxState)&&(0,$.$cg)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,et=!(0,$.$cg)(Ne.checkboxState)&&(0,$.$ag)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Et.Checked&&Qe!==Et.Unchecked||et!==void 0&&!(0,$.$$f)(et))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(V instanceof k)return!0;if(Ne.label!==void 0&&!(0,$.$$f)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,$.$$f)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,$.$$f)(Ne.iconPath)&&!E.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,$.$$f)(Ne.iconPath.id))){const Qe=Ne.iconPath;if(!Qe||!(0,$.$$f)(Qe.light)&&!E.URI.isUri(Qe.light)&&!(0,$.$$f)(Qe.dark)&&!E.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,$.$$f)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!E.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,$.$$f)(Ne.tooltip)&&!(Ne.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<wt.None&&Ne.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,$.$$f)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(V,me=wt.None){this.collapsibleState=me,E.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$9M=At,e.$9M=At=k=Je([D],At);var wt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var Et;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let rn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$0M=rn,e.$0M=rn=Je([D],rn);class Ct extends rn{}e.$$M=Ct;class fn extends Ct{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$_M=fn;class sn{constructor(V,me,Ne,Qe){this.name=V,this.uri=me,this._itemId=Ne,this.c=Qe}data(){return this.c()}}e.$aN=sn;let vn=class{#e=new Map;constructor(V){for(const[me,Ne]of V??[]){const Qe=this.#e.get(this.#t(me));Qe?Qe.push(Ne):this.#e.set(this.#t(me),[Ne])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,me){this.#e.set(this.#t(V),[me])}forEach(V,me){for(const[Ne,Qe]of this.#e)for(const et of Qe)V.call(me,et,Ne,this)}*[Symbol.iterator](){for(const[V,me]of this.#e)for(const Ne of me)yield[V,Ne]}#t(V){return V.toLowerCase()}};e.$bN=vn,e.$bN=vn=Je([D],vn);let ln=class{constructor(V,me,Ne){this.insertText=V,this.title=me,this.kind=Ne}};e.$cN=ln,e.$cN=ln=Je([D],ln);var $n;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})($n||(e.DocumentPasteTriggerKind=$n={}));class Pt{static{this.c="."}constructor(V){this.value=V}append(...V){return new Pt((this.value?[this.value,...V]:V).join(Pt.c))}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+Pt.c)}}e.$dN=Pt,Pt.Empty=new Pt("");class Le{constructor(V,me,Ne){this.title=me,this.insertText=V,this.kind=Ne}}e.$eN=Le;let Fe=class{constructor(V,me){this.id=V,this.color=me}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$fN=Fe,e.$fN=Fe=Je([D],Fe),Fe.File=new Fe("file"),Fe.Folder=new Fe("folder");let ye=class{constructor(V){this.id=V}};e.$gN=ye,e.$gN=ye=Je([D],ye);var Z;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Z||(e.ConfigurationTarget=Z={}));let Te=class{get base(){return this.c}set base(V){this.c=V,this.e=E.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,me){if(typeof V!="string"&&(!V||!E.URI.isUri(V)&&!E.URI.isUri(V.uri)))throw(0,L.$7)("base");if(typeof me!="string")throw(0,L.$7)("pattern");typeof V=="string"?this.baseUri=E.URI.file(V):E.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$hN=Te,e.$hN=Te=Je([D],Te);const He=new WeakMap;function Ze(G,V){He.set(G,V)}let Xe=class{constructor(V,me,Ne,Qe,et){this.enabled=typeof V=="boolean"?V:!0,typeof me=="string"&&(this.condition=me),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Qe=="string"&&(this.logMessage=Qe),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=He.get(this)??(0,A.$Ug)()),this.c}};e.$jN=Xe,e.$jN=Xe=Je([D],Xe);let at=class extends Xe{constructor(V,me,Ne,Qe,et,dt){if(super(me,Ne,Qe,et,dt),V===null)throw(0,L.$7)("location");this.location=V}};e.$kN=at,e.$kN=at=Je([D],at);let St=class extends Xe{constructor(V,me,Ne,Qe,et,dt){super(me,Ne,Qe,et,dt),this.functionName=V}};e.$lN=St,e.$lN=St=Je([D],St);let Jt=class extends Xe{constructor(V,me,Ne,Qe,et,dt,pt,Kt){if(super(Qe,et,dt,pt,Kt),!me)throw(0,L.$7)("dataId");this.label=V,this.dataId=me,this.canPersist=Ne}};e.$mN=Jt,e.$mN=Jt=Je([D],Jt);let Ht=class{constructor(V,me,Ne){this.command=V,this.args=me||[],this.options=Ne}};e.$nN=Ht,e.$nN=Ht=Je([D],Ht);let Mt=class{constructor(V,me){this.port=V,this.host=me}};e.$oN=Mt,e.$oN=Mt=Je([D],Mt);let ht=class{constructor(V){this.path=V}};e.$pN=ht,e.$pN=ht=Je([D],ht);let On=class{constructor(V){this.implementation=V}};e.$qN=On,e.$qN=On=Je([D],On);class pn{constructor(V,me,Ne){this.session=V,this.threadId=me,this.frameId=Ne}}e.$rN=pn;class En{constructor(V,me){this.session=V,this.threadId=me}}e.$sN=En;let Cn=class{constructor(V,me){this.range=V,this.expression=me}};e.$tN=Cn,e.$tN=Cn=Je([D],Cn);var Xn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Xn||(e.InlineCompletionTriggerKind=Xn={}));let Ln=class{constructor(V,me){this.range=V,this.text=me}};e.$uN=Ln,e.$uN=Ln=Je([D],Ln);let Nn=class{constructor(V,me,Ne=!0){this.range=V,this.variableName=me,this.caseSensitiveLookup=Ne}};e.$vN=Nn,e.$vN=Nn=Je([D],Nn);let In=class{constructor(V,me){this.range=V,this.expression=me}};e.$wN=In,e.$wN=In=Je([D],In);let Tn=class{constructor(V,me){this.frameId=V,this.stoppedLocation=me}};e.$xN=Tn,e.$xN=Tn=Je([D],Tn);var jn;(function(G){G[G.AIGenerated=1]="AIGenerated"})(jn||(e.NewSymbolNameTag=jn={}));var Qn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Qn||(e.NewSymbolNameTriggerKind=Qn={}));class Fn{constructor(V,me){this.newSymbolName=V,this.tags=me}}e.$yN=Fn;var Pn;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Pn||(e.FileChangeType=Pn={}));let zn=m=class extends Error{static FileExists(V){return new m(V,p.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(V){return new m(V,p.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(V){return new m(V,p.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(V){return new m(V,p.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(V){return new m(V,p.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(V){return new m(V,p.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(V,me=p.FileSystemProviderErrorCode.Unknown,Ne){super(E.URI.isUri(V)?V.toString(!0):V),this.code=Ne?.name??"Unknown",(0,p.$hl)(this,me),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$zN=zn,e.$zN=zn=m=Je([D],zn);let Bn=class{constructor(V,me,Ne){this.start=V,this.end=me,this.kind=Ne}};e.$AN=Bn,e.$AN=Bn=Je([D],Bn);var yn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(yn||(e.FoldingRangeKind=yn={}));var Yn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Yn||(e.CommentThreadCollapsibleState=Yn={}));var Zn;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Zn||(e.CommentMode=Zn={}));var An;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(An||(e.CommentState=An={}));var xn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(xn||(e.CommentThreadState=xn={}));var Un;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Un||(e.CommentThreadApplicability=Un={}));class di{constructor(V,me=[]){this.tokenTypes=V,this.tokenModifiers=me}}e.$BN=di;function _n(G){return typeof G>"u"||(0,$.$_f)(G)}class Wn{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let me=0,Ne=V.tokenTypes.length;me<Ne;me++)this.k.set(V.tokenTypes[me],me);for(let me=0,Ne=V.tokenModifiers.length;me<Ne;me++)this.l.set(V.tokenModifiers[me],me)}}push(V,me,Ne,Qe,et){if(typeof V=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(V,me,Ne,Qe,et);if(z.isRange(V)&&typeof me=="string"&&_n(Ne))return this.o(V,me,Ne);throw(0,L.$7)()}o(V,me,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Qe=V.start.line,et=V.start.character,dt=V.end.character-V.start.character,pt=this.k.get(me);let Kt=0;if(Ne)for(const cn of Ne){if(!this.l.has(cn))throw new Error("`tokenModifier` is not in the provided legend");const dn=this.l.get(cn);Kt|=1<<dn>>>0}this.q(Qe,et,dt,pt,Kt)}q(V,me,Ne,Qe,et){if(this.f&&(V<this.c||V===this.c&&me<this.e)){this.f=!1;const Kt=this.g.length/5|0;let cn=0,dn=0;for(let mn=0;mn<Kt;mn++){let wn=this.g[5*mn],Jn=this.g[5*mn+1];wn===0?(wn=cn,Jn+=dn):wn+=cn,this.g[5*mn]=wn,this.g[5*mn+1]=Jn,cn=wn,dn=Jn}}let dt=V,pt=me;this.f&&this.j>0&&(dt-=this.c,dt===0&&(pt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=pt,this.g[this.j++]=Ne,this.g[this.j++]=Qe,this.g[this.j++]=et,this.c=V,this.e=me}static r(V){const me=[],Ne=V.length/5|0;for(let pt=0;pt<Ne;pt++)me[pt]=pt;me.sort((pt,Kt)=>{const cn=V[5*pt],dn=V[5*Kt];if(cn===dn){const mn=V[5*pt+1],wn=V[5*Kt+1];return mn-wn}return cn-dn});const Qe=new Uint32Array(V.length);let et=0,dt=0;for(let pt=0;pt<Ne;pt++){const Kt=5*me[pt],cn=V[Kt+0],dn=V[Kt+1],mn=V[Kt+2],wn=V[Kt+3],Jn=V[Kt+4],ji=cn-et,pr=ji===0?dn-dt:dn,Kn=5*pt;Qe[Kn+0]=ji,Qe[Kn+1]=pr,Qe[Kn+2]=mn,Qe[Kn+3]=wn,Qe[Kn+4]=Jn,et=cn,dt=dn}return Qe}build(V){return this.f?new bn(new Uint32Array(this.g),V):new bn(Wn.r(this.g),V)}}e.$CN=Wn;class bn{constructor(V,me){this.resultId=me,this.data=V}}e.$DN=bn;class fi{constructor(V,me,Ne){this.start=V,this.deleteCount=me,this.data=Ne}}e.$EN=fi;class gi{constructor(V,me){this.resultId=me,this.edits=V}}e.$FN=gi;var ei;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ei||(e.DebugConsoleMode=ei={}));class qn{constructor(V){this.name=V}}e.$GN=qn;let Mn=class{static{this.Back={iconPath:new Fe("arrow-left")}}constructor(){}};e.$HN=Mn,e.$HN=Mn=Je([D],Mn);var Ue;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ue||(e.QuickPickItemKind=Ue={}));var hn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(hn||(e.InputBoxValidationSeverity=hn={}));var Vn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Vn||(e.ExtensionKind=Vn={}));class ot{static validate(V){if(typeof V.badge=="string"){let me=(0,b.$Jf)(V.badge,0);if(me<V.badge.length&&(me+=(0,b.$Jf)(V.badge,me)),V.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Fe.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,me,Ne){this.badge=V,this.tooltip=me,this.color=Ne}}e.$IN=ot;let vt=class{constructor(V){this.kind=V}};e.$JN=vt,e.$JN=vt=Je([D],vt);var ti;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(ti||(e.ColorThemeKind=ti={}));class gn{static isNotebookRange(V){return V instanceof gn?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,me){if(V<0)throw(0,L.$7)("start must be positive");if(me<0)throw(0,L.$7)("end must be positive");V<=me?(this.c=V,this.e=me):(this.c=me,this.e=V)}with(V){let me=this.c,Ne=this.e;return V.start!==void 0&&(me=V.start),V.end!==void 0&&(Ne=V.end),me===this.c&&Ne===this.e?this:new gn(me,Ne)}}e.$KN=gn;class kn{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(me=>kn.isNotebookCellData(me))}static isNotebookCellData(V){return!0}constructor(V,me,Ne,Qe,et,dt,pt){this.kind=V,this.value=me,this.languageId=Ne,this.mime=Qe,this.outputs=et??[],this.metadata=dt,this.executionSummary=pt,kn.validate(this)}}e.$LN=kn;class mi{constructor(V){this.cells=V}}e.$MN=mi;class nn{static isNotebookCellOutputItem(V){return V instanceof nn?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const me={name:V.name,message:V.message,stack:V.stack};return nn.json(me,"application/vnd.code.notebook.error")}static stdout(V){return nn.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return nn.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,me="application/octet-stream"){return new nn(V,me)}static#e=new TextEncoder;static text(V,me=R.$Ts.text){const Ne=nn.#e.encode(String(V));return new nn(Ne,me)}static json(V,me="text/x-json"){const Ne=JSON.stringify(V,void 0,"	");return nn.text(Ne,me)}constructor(V,me){this.data=V,this.mime=me;const Ne=(0,R.$Xs)(me,!0);if(!Ne)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$NN=nn;class Rn{static isNotebookCellOutput(V){return V instanceof Rn?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,me=!1){const Ne=new Set,Qe=new Set;for(let et=0;et<V.length;et++){const dt=V[et],pt=(0,R.$Xs)(dt.mime);if(!Ne.has(pt)||(0,v.$cK)(pt)){Ne.add(pt);continue}Qe.add(et),me&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Qe.size===0?V:V.filter((et,dt)=>!Qe.has(dt))}constructor(V,me,Ne){this.items=Rn.ensureUniqueMimeTypes(V,!0),typeof me=="string"?(this.id=me,this.metadata=Ne):(this.id=(0,A.$Ug)(),this.metadata=me??Ne)}}e.$ON=Rn;var ni;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ni||(e.NotebookCellKind=ni={}));var ii;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(ii||(e.NotebookCellExecutionState=ii={}));var Hn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Hn||(e.NotebookCellStatusBarAlignment=Hn={}));var ri;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(ri||(e.NotebookEditorRevealType=ri={}));class $i{constructor(V,me){this.text=V,this.alignment=me}}e.$PN=$i;var si;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(si||(e.NotebookControllerAffinity=si={}));var oi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(oi||(e.NotebookControllerAffinity2=oi={}));class pi{constructor(V,me=[]){this.uri=V,this.provides=(0,l.$2b)(me)}}e.$QN=pi;class bi{constructor(V){this.label=V}}e.$RN=bi;var ai;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(ai||(e.NotebookVariablesRequestKind=ai={}));let Gn=class{constructor(V,me){this.label=V,this.timestamp=me}};e.$SN=Gn,e.$SN=Gn=Je([D],Gn);var ci;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ci||(e.ExtensionMode=ci={}));var ui;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ui||(e.ExtensionRuntime=ui={}));var li;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(li||(e.StandardTokenType=li={}));class fe{constructor(V,me){this.ranges=V,this.wordPattern=me}}e.$TN=fe;class Ee{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$UN=Ee;var Be;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(Be||(e.TestResultState=Be={}));var ut;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(ut||(e.TestRunProfileKind=ut={}));let yt=class{constructor(V=void 0,me=void 0,Ne=void 0,Qe=!1,et=!0){this.include=V,this.exclude=me,this.profile=Ne,this.continuous=Qe,this.preserveFocus=et}};e.$VN=yt,e.$VN=yt=Je([D],yt);let Ot=y=class{static diff(V,me,Ne){const Qe=new y(V);return Qe.expectedOutput=me,Qe.actualOutput=Ne,Qe}constructor(V){this.message=V}};e.$WN=Ot,e.$WN=Ot=y=Je([D],Ot);let Dn=class{constructor(V){this.id=V}};e.$XN=Dn,e.$XN=Dn=Je([D],Dn);class hi{constructor(V,me){this.covered=V,this.total=me,vi(this)}}e.$YN=hi;function vi(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class wi{static fromDetails(V,me){const Ne=new hi(0,0),Qe=new hi(0,0),et=new hi(0,0);for(const pt of me)if("branches"in pt){Ne.total+=1,Ne.covered+=pt.executed?1:0;for(const Kt of pt.branches)Qe.total+=1,Qe.covered+=Kt.executed?1:0}else et.total+=1,et.covered+=pt.executed?1:0;const dt=new wi(V,Ne,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return dt.detailedCoverage=me,dt}constructor(V,me,Ne,Qe){this.uri=V,this.statementCoverage=me,this.branchCoverage=Ne,this.declarationCoverage=Qe}}e.$1N=wi;class Fi{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,me,Ne=[]){this.executed=V,this.location=me,this.branches=Ne}}e.$2N=Fi;class zi{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,me,Ne){this.executed=V,this.location=me,this.label=Ne}}e.$3N=zi;class Bi{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,me,Ne){this.name=V,this.executed=me,this.location=Ne}}e.$4N=Bi;var yi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(yi||(e.ExternalUriOpenerPriority=yi={}));var Si;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Si||(e.WorkspaceTrustState=Si={}));var Ei;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ei||(e.PortAutoForwardAction=Ei={}));class Ui{constructor(V,me,Ne,Qe,et,dt){this.kind=V,this.name=me,this.detail=Ne,this.uri=Qe,this.range=et,this.selectionRange=dt}}e.$5N=Ui;class Wi{constructor(V){this.uri=V}}e.$6N=Wi;class qi{constructor(V,me){this.original=V,this.modified=me}}e.$7N=qi;class Vi{constructor(V,me,Ne,Qe){this.base=V,this.input1=me,this.input2=Ne,this.result=Qe}}e.$8N=Vi;class Hi{constructor(V,me){this.uri=V,this.viewType=me}}e.$9N=Hi;class Gi{constructor(V){this.viewType=V}}e.$0N=Gi;class Ji{constructor(V,me){this.uri=V,this.notebookType=me}}e.$$N=Ji;class Ki{constructor(V,me,Ne){this.original=V,this.modified=me,this.notebookType=Ne}}e.$_N=Ki;class Xi{constructor(){}}e.$aO=Xi;class Qi{constructor(V,me){this.uri=V,this.inputBoxUri=me}}e.$bO=Qi;class Yi{constructor(){}}e.$cO=Yi;class Zi{constructor(V){this.textDiffs=V}}e.$dO=Zi;var ki;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(ki||(e.InteractiveSessionVoteDirection=ki={}));var Di;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Di||(e.ChatCopyKind=Di={}));var Ci;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Ci||(e.ChatVariableLevel=Ci={}));class xi{constructor(V,me){this.label=V,this.values=me}}e.$eO=xi;var Ii;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Ii||(e.InteractiveEditorResponseFeedbackKind=Ii={}));var Pi;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Pi||(e.ChatResultFeedbackKind=Pi={}));class _i{constructor(V){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Ke(V):V}}e.$fO=_i;class er{constructor(V,me){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Ke(V):V,this.vulnerabilities=me}}e.$gO=er;class tr{constructor(V,me){this.participant=V,this.command=me}}e.$hO=tr;class nr{constructor(V,me,Ne){this.title=V,this.message=me,this.data=Ne}}e.$iO=nr;class ir{constructor(V,me){this.value=V,this.baseUri=me}}e.$jO=ir;class rr{constructor(V,me){this.value=V,this.title=me}}e.$kO=rr;class sr{constructor(V){this.value=V}}e.$lO=sr;class or{constructor(V){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Ke(V):V}}e.$mO=or;class ar{constructor(V){this.value=V}}e.$nO=ar;class cr{constructor(V,me){this.value=V,this.iconPath=me}}e.$oO=cr;class ur{constructor(V,me){this.uri=V,this.edits=Array.isArray(me)?me:[me]}}e.$pO=ur;class lr{constructor(V,me,Ne,Qe){this.prompt=V,this.command=me,this.variables=Ne,this.participant=Qe}}e.$qO=lr;class hr{constructor(V,me,Ne,Qe){this.response=V,this.result=me,this.participant=Ne,this.command=Qe}}e.$rO=hr;var Ai;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(Ai||(e.ChatLocation=Ai={}));var Mi;(function(G){G[G.User=1]="User",G[G.Assistant=2]="Assistant",G[G.System=3]="System"})(Mi||(e.LanguageModelChatMessageRole=Mi={}));class dr{constructor(V,me,Ne){this.role=V,this.content=me,this.name=Ne}}e.$sO=dr;class fr{constructor(V){this.content=V}}e.$tO=fr;class gr{constructor(V,me){this.content=V,this.name=me}}e.$uO=gr;class mr{constructor(V,me){this.content=V,this.name=me}}e.$vO=mr;class Sn extends Error{static NotFound(V){return new Sn(V,Sn.NotFound.name)}static NoPermissions(V){return new Sn(V,Sn.NoPermissions.name)}static Blocked(V){return new Sn(V,Sn.Blocked.name)}constructor(V,me,Ne){super(V,{cause:Ne}),this.name="LanguageModelError",this.code=me??""}}e.$wO=Sn;var Ri;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Ri||(e.RelatedInformationType=Ri={}));var Oi;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(Oi||(e.SpeechToTextStatus=Oi={}));var Li;(function(G){G[G.Started=1]="Started",G[G.Stopped=2]="Stopped",G[G.Error=3]="Error"})(Li||(e.TextToSpeechStatus=Li={}));var Ni;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Ni||(e.KeywordRecognitionStatus=Ni={}));class $r{constructor(V,me){this.text=V,this.range=me}}e.$xO=$r;var Ti;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Ti||(e.InlineEditTriggerKind=Ti={}))}),define(ke[330],De([1,0,6,8]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class O{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$gM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,$)??[]}getRelatedInformation(R,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(R,b,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiRelatedInformationProvider(E,b),new L.$iM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Nlc=O}),define(ke[121],De([1,0,4,6,8,25,146,5,20]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=void 0,e.$Ylc=(0,b.$yi)("IExtHostAuthentication");let E=class{constructor(p){this.b=new Map,this.c=new l.$fe,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=p.getProxy(L.$gM.MainThreadAuthentication)}async getSession(p,S,v,h={}){const d=M.$Tm.toKey(p.identifier),c=[...v].sort().join(" ");return await this.d.getOrCreate(`${d} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const n=p.displayName||p.name;return this.a.$getSession(S,v,d,n,h)})}async getSessions(p,S,v){const h=M.$Tm.toKey(p.identifier),d=[...v].sort().join(" ");return await this.f.getOrCreate(`${h} ${d}`,async()=>{await this.a.$ensureProvider(S);const c=p.displayName||p.name;return this.a.$getSessions(S,v,h,c)})}async removeSession(p,S){const v=this.b.get(p);return v?v.provider.removeSession(S):this.a.$removeSession(p,S)}registerAuthenticationProvider(p,S,v,h){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:S,provider:v,options:h??{supportsMultipleAccounts:!1}});const d=v.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(p,c));return this.a.$registerAuthenticationProvider(p,S,h?.supportsMultipleAccounts??!1),new O.$iM(()=>{d.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}async $createSession(p,S,v){const h=this.b.get(p);if(h)return await h.provider.createSession(S,v);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $removeSession(p,S){const v=this.b.get(p);if(v)return await v.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $getSessions(p,S){const v=this.b.get(p);if(v)return await v.provider.getSessions(S);throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,S){return p.startsWith(R.$iL)||this.c.fire({provider:{id:p,label:S}}),Promise.resolve()}};e.$Zlc=E,e.$Zlc=E=Je([We(0,$.$JO)],E);class A{constructor(){this.a=new Map}getOrCreate(p,S){const v=this.a.get(p);if(v)return v;const h=S().finally(()=>this.a.delete(p));return this.a.set(p,h),h}}}),define(ke[152],De([1,0,2,6,8,5,20,11,19,14,16,26]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;let S=class{static{p=this}static{this.c=0}static{this.d=250}constructor(h,d){this.h=d,this.f=new Map,this.g=h.getProxy(L.$gM.MainThreadDecorations)}registerFileDecorationProvider(h,d){const c=p.c++;this.f.set(c,{provider:h,extensionDescription:d}),this.g.$registerDecorationProvider(c,d.identifier.value);const n=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const a=(0,$.$2b)(i);if(a.length<=p.d){this.g.$onDidChange(c,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,a.length);const s=a.map(r=>({uri:r,rank:(0,E.$cf)(r.path,"/")})),t=(0,$.$zb)(s,(r,o)=>r.rank-o.rank||(0,E.$sf)(r.uri.path,o.uri.path)),u=[];e:for(const r of t){let o;for(const f of r){const g=(0,A.$mc)(f.uri.path);if(o!==g&&(o=g,u.push(f.uri)>=p.d))break e}}this.g.$onDidChange(c,u)});return new O.$iM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(h,d,c){if(!this.f.has(h))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(h);return await Promise.all(d.map(async s=>{try{const{uri:t,id:u}=s,r=await Promise.resolve(i.provideFileDecoration(l.URI.revive(t),c));if(!r)return;try{O.$IN.validate(r),r.badge&&typeof r.badge!="string"&&(0,I.$SG)(a,"codiconDecoration"),n[u]=[r.propagate,r.tooltip,r.badge,r.color]}catch(o){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),n}};e.$Ymc=S,e.$Ymc=S=p=Je([We(0,R.$JO),We(1,b.$5j)],S),e.$Zmc=(0,M.$yi)("IExtHostDecorations")}),define(ke[331],De([1,0,13,2,8,6,15,22,14]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class E{static{this.a=0}constructor(I,p,S){this.d=p,this.e=S,this.b=new Map,this.c=I.getProxy(M.$gM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=E.a++;this.b.set(S,p),this.c.$registerTextContentProvider(S,I);let v;if(typeof p.onDidChange=="function"){let h;v=p.onDidChange(async d=>{if(d.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(d))return;h&&await h;const c=this.$provideTextDocumentContent(S,d).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(d);if(!i)return;const a=(0,$.$mf)(n);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(d,n)}).catch(l.$1).finally(()=>{h===c&&(h=void 0)});h=c})}return new O.$iM(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(I,p){const S=this.b.get(I);return S?Promise.resolve(S.provideTextDocumentContent(L.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$2mc=E}),define(ke[153],De([1,0,62,15,14,188,130,8,19]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0,e.$LO=A;const E=new Map;function A(v,h){h?E.set(v,h):E.delete(v)}function I(v){return E.get(v)}class p extends M.$9v{constructor(h,d,c,n,i,a,s){super(d,c,n,i),this.c=h,this.m=a,this.q=s,this.b=!1}dispose(){(0,l.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,$.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===L.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(d){return d?h.s(d):h.getText()},get eol(){return h.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(d){return h.t(d)},offsetAt(d){return h.u(d)},positionAt(d){return h.v(d)},validateRange(d){return h.w(d)},validatePosition(d){return h.x(d)},getWordRangeAtPosition(d,c){return h.y(d,c)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,l.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,l.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const d=this.w(h);if(d.isEmpty)return"";if(d.isSingleLine)return this.f[d.start.line].substring(d.start.character,d.end.character);const c=this.g,n=d.start.line,i=d.end.line,a=[];a.push(this.f[n].substring(d.start.character));for(let s=n+1;s<i;s++)a.push(this.f[s]);return a.push(this.f[i].substring(0,d.end.character)),a.join(c)}t(h){let d;if(h instanceof b.$jM?d=h.line:typeof h=="number"&&(d=h),typeof d!="number"||d<0||d>=this.f.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new S(d,this.f[d],d===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const d=this.j.getIndexOf(h),c=this.f[d.index].length;return new b.$jM(d.index,Math.min(d.remainder,c))}w(h){if(!(h instanceof b.$kM))throw new Error("Invalid argument");const d=this.x(h.start),c=this.x(h.end);return d===h.start&&c===h.end?h:new b.$kM(d.line,d.character,c.line,c.character)}x(h){if(!(h instanceof b.$jM))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:d,character:c}=h,n=!1;if(d<0)d=0,c=0,n=!0;else if(d>=this.f.length)d=this.f.length-1,c=this.f[d].length,n=!0;else{const i=this.f[d].length;c<0?(c=0,n=!0):c>i&&(c=i,n=!0)}return n?new b.$jM(d,c):h}y(h,d){const c=this.x(h);if(!d)d=I(this.m);else if((0,O.$lf)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const n=(0,R.$_s)(c.character+1,(0,R.$0s)(d),this.f[c.line],0);if(n)return new b.$kM(c.line,n.startColumn-1,c.line,n.endColumn-1)}}e.$MO=p;class S{constructor(h,d,c){this.a=h,this.b=d,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$kM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$kM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$NO=S}),define(ke[332],De([1,0,6,8]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class O{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$gM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const A=await E.provideEmbeddingVector(b,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,b,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiEmbeddingVectorProvider(b,E),new L.$iM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$5mc=O}),define(ke[70],De([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=e.$cmc=void 0;let v=S=class{constructor(d,c){this.b=new Map,this.c=new A.$Hh,this.a=d.getProxy(l.$gM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let a;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),a=await s.impl.stat(i)):a=await n.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===L.FilePermission.Readonly?1:void 0}}catch(a){S.e(a)}},async readDirectory(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(a){return S.e(a)}},async createDirectory(i){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(a.impl,a.extUri,i)):await n.a.$mkdir(i)}catch(a){return S.e(a)}},async readFile(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(a){return S.e(a)}},async writeFile(i,a){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,M.$He.wrap(a))}catch(s){return S.e(s)}},async delete(i,a){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!a?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...a})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(s){return S.e(s)}},async rename(i,a,s){try{return await n.a.$rename(i,a,{overwrite:!1,...s})}catch(t){return S.e(t)}},async copy(i,a,s){try{return await n.a.$copy(i,a,{overwrite:!1,...s})}catch(t){return S.e(t)}},isWritableFileSystem(i){const a=c.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(d,c,n){const i=[];for(;!c.isEqual(n,c.dirname(n));)try{if(!((await d.stat(n)).type&L.FileType.Directory))throw O.$zN.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(L.$il(a)!==L.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(c.basename(n)),n=c.dirname(n)}for(let a=i.length-1;a>=0;a--){n=c.joinPath(n,i[a]);try{await d.createDirectory(n)}catch(s){if(L.$il(s)!==L.FileSystemProviderErrorCode.FileExists)throw s}}}static e(d){if(d instanceof O.$zN)throw d;if(d instanceof L.$el)switch(d.code){case L.FileSystemProviderErrorCode.FileExists:throw O.$zN.FileExists(d.message);case L.FileSystemProviderErrorCode.FileNotFound:throw O.$zN.FileNotFound(d.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw O.$zN.FileNotADirectory(d.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw O.$zN.FileIsADirectory(d.message);case L.FileSystemProviderErrorCode.NoPermissions:throw O.$zN.NoPermissions(d.message);case L.FileSystemProviderErrorCode.Unavailable:throw O.$zN.Unavailable(d.message);default:throw new O.$zN(d.message,d.name)}if(!(d instanceof Error))throw new O.$zN(String(d));if(d.name==="ENOPRO"||d.message.includes("ENOPRO"))throw O.$zN.Unavailable(d.message);switch(d.name){case L.FileSystemProviderErrorCode.FileExists:throw O.$zN.FileExists(d.message);case L.FileSystemProviderErrorCode.FileNotFound:throw O.$zN.FileNotFound(d.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw O.$zN.FileNotADirectory(d.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw O.$zN.FileIsADirectory(d.message);case L.FileSystemProviderErrorCode.NoPermissions:throw O.$zN.NoPermissions(d.message);case L.FileSystemProviderErrorCode.Unavailable:throw O.$zN.Unavailable(d.message);default:throw new O.$zN(d.message,d.name)}}addFileSystemProvider(d,c,n){return this.b.set(d,{impl:c,extUri:n?.isCaseSensitive?I.$2g:I.$4g,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(d))}getFileSystemProviderExtUri(d){return this.b.get(d)?.extUri??I.$2g}};e.$cmc=v,e.$cmc=v=S=Je([We(0,b.$JO),We(1,$.$Slc)],v),e.$dmc=(0,R.$yi)("IExtHostConsumerFileSystem")}),define(ke[93],De([1,0,5,28,11,70,2]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0,e.$emc=(0,l.$yi)("IExtensionStoragePaths");let b=class{constructor(E,A,I){this.d=A,this.f=I,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,A=await this.g(E);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fmc=b,e.$fmc=b=Je([We(0,L.$ZO),We(1,O.$5j),We(2,M.$dmc)],b)}),define(ke[333],De([1,0,8,20,4]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;let M=class{constructor(b){this.a=new l.$JN(l.ColorThemeKind.Dark),this.b=new O.$fe}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=l.ColorThemeKind.Light;break;case"hcDark":$=l.ColorThemeKind.HighContrast;break;case"hcLight":$=l.ColorThemeKind.HighContrastLight;break;default:$=l.ColorThemeKind.Dark}this.a=new l.$JN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Mnc=M,e.$Mnc=M=Je([We(0,L.$JO)],M)}),define(ke[71],De([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ODb=e.$NDb=e.TunnelDtoConverter=void 0;class S extends $.$vw{}var v;(function(d){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}d.fromApiTunnel=c;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}d.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$NDb=(0,R.$yi)("IExtHostTunnelService");let h=class extends O.$Uc{constructor(c,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$fe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(E.$gM.MainThreadTunnelService)}async openTunnel(c,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,c.displayName);if(i){const a=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,n){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:n}),this.a.$registerPortsAttributesProvider(c,i),new p.$iM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,n,i,a,s){const t=[];for(const r of c){const o=this.r.get(r);if(!o)return[];t.push(...await Promise.all(n.map(async f=>{let g;try{g=await o.provider.providePortAttributes({port:f,pid:i,commandLine:a},s)}catch{g=await o.provider.providePortAttributes(f,i,a,s)}return{providedAttributes:g,port:f}})))}const u=t.filter(r=>!!r.providedAttributes);return u.length>0?u.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,s)=>await c.provideTunnel(a,s,l.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,O.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,n){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let a=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const s=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,O.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,n){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(n&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const s=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:a,disposeListener:s}),v.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const n=await Promise.all(c.map(a=>this.f(a.host,a.port,a.detail??""))),i=c.filter((a,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$ODb=h,e.$ODb=h=Je([We(0,I.$JO),We(1,A.$ZO),We(2,b.$5j)],h)}),define(ke[17],De([1,0,19,21,177,75,81,27,167,58,101,24,172,23,50,18,2,29,84,139,145,143,296,120,69,89,308,8]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u,r,o,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$GO=U,e.$HO=ie,e.$IO=H;var w;(function(Le){function Fe(Z){const{selectionStartLineNumber:Te,selectionStartColumn:He,positionLineNumber:Ze,positionColumn:Xe}=Z,at=new g.$jM(Te-1,He-1),St=new g.$jM(Ze-1,Xe-1);return new g.$lM(at,St)}Le.to=Fe;function ye(Z){const{anchor:Te,active:He}=Z;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Le.from=ye})(w||(e.Selection=w={}));var k;(function(Le){function Fe(Z){if(!Z)return;const{start:Te,end:He}=Z;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Le.from=Fe;function ye(Z){if(!Z)return;const{startLineNumber:Te,startColumn:He,endLineNumber:Ze,endColumn:Xe}=Z;return new g.$kM(Te-1,He-1,Ze-1,Xe-1)}Le.to=ye})(k||(e.Range=k={}));var m;(function(Le){function Fe(Z){return{uri:Z.uri,range:k.from(Z.range)}}Le.from=Fe;function ye(Z){return new g.$uM(d.URI.revive(Z.uri),k.to(Z.range))}Le.to=ye})(m||(e.Location=m={}));var y;(function(Le){function Fe(ye){switch(ye){case 1:return g.StandardTokenType.Comment;case 0:return g.StandardTokenType.Other;case 3:return g.StandardTokenType.RegEx;case 2:return g.StandardTokenType.String}}Le.to=Fe})(y||(e.TokenType=y={}));var D;(function(Le){function Fe(Z){return new g.$jM(Z.lineNumber-1,Z.column-1)}Le.to=Fe;function ye(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Le.from=ye})(D||(e.Position=D={}));var C;(function(Le){function Fe(Te,He,Ze){return(0,l.$Hb)((0,l.$2b)(Te).map(Xe=>ye(Xe,He,Ze)))}Le.from=Fe;function ye(Te,He,Ze){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ze?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:Z(Te.scheme,He),pattern:Ce.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ze?.isBuiltin}}function Z(Te,He){return He&&typeof Te=="string"?He.transformOutgoingScheme(Te):Te}})(C||(e.DocumentSelector=C={}));var P;(function(Le){function Fe(Z){switch(Z){case g.DiagnosticTag.Unnecessary:return 1;case g.DiagnosticTag.Deprecated:return 2}}Le.from=Fe;function ye(Z){switch(Z){case 1:return g.DiagnosticTag.Unnecessary;case 2:return g.DiagnosticTag.Deprecated;default:return}}Le.to=ye})(P||(e.DiagnosticTag=P={}));var j;(function(Le){function Fe(Z){let Te;return Z.code&&((0,h.$$f)(Z.code)||(0,h.$cg)(Z.code)?Te=String(Z.code):Te={value:String(Z.code.value),target:Z.code.target}),{...k.from(Z.range),message:Z.message,source:Z.source,code:Te,severity:z.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(T.from),tags:Array.isArray(Z.tags)?(0,l.$Hb)(Z.tags.map(P.from)):void 0}}Le.from=Fe;function ye(Z){const Te=new g.$wM(k.to(Z),Z.message,z.to(Z.severity));return Te.source=Z.source,Te.code=(0,h.$$f)(Z.code)?Z.code:Z.code?.value,Te.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(T.to),Te.tags=Z.tags&&(0,l.$Hb)(Z.tags.map(P.to)),Te}Le.to=ye})(j||(e.Diagnostic=j={}));var T;(function(Le){function Fe(Z){return{...k.from(Z.location.range),message:Z.message,resource:Z.location.uri}}Le.from=Fe;function ye(Z){return new g.$vM(new g.$uM(Z.resource,k.to(Z)),Z.message)}Le.to=ye})(T||(e.DiagnosticRelatedInformation=T={}));var z;(function(Le){function Fe(Z){switch(Z){case g.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case g.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case g.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case g.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Le.from=Fe;function ye(Z){switch(Z){case i.MarkerSeverity.Info:return g.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return g.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return g.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return g.DiagnosticSeverity.Hint;default:return g.DiagnosticSeverity.Error}}Le.to=ye})(z||(e.DiagnosticSeverity=z={}));var N;(function(Le){function Fe(Z){return typeof Z=="number"&&Z>=g.ViewColumn.One?Z-1:Z===g.ViewColumn.Beside?f.$8D:f.$7D}Le.from=Fe;function ye(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=ye})(N||(e.ViewColumn=N={}));function F(Le){return typeof Le.range<"u"}function U(Le){return Le.length===0?!0:!!F(Le[0])}var Y;(function(Le){function Fe(Xe){return Xe.map(Le.from)}Le.fromMany=Fe;function ye(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function Z(Xe){let at;if(ye(Xe)){const{language:Mt,value:ht}=Xe;at={value:"```"+Mt+`
`+ht+"\n```\n"}}else g.$KM.isMarkdownString(Xe)?at={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?at={value:Xe}:at={value:""};const St=Object.create(null);at.uris=St;const Jt=Mt=>{try{let ht=d.URI.parse(Mt,!0);ht=ht.with({query:Te(ht.query,St)}),St[Mt]=ht}catch{}return""},Ht=new $.marked.Renderer;return Ht.link=Jt,Ht.image=Mt=>typeof Mt=="string"?Jt(R.$4k(Mt).href):"",(0,$.marked)(at.value,{renderer:Ht}),at}Le.from=Z;function Te(Xe,at){if(!Xe)return Xe;let St;try{St=(0,E.$7h)(Xe)}catch{}if(!St)return Xe;let Jt=!1;return St=(0,I.$7n)(St,Ht=>{if(d.URI.isUri(Ht)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[Mt]=Ht,Jt=!0,Mt}else return}),Jt?JSON.stringify(St):Xe}function He(Xe){const at=new g.$KM(Xe.value,Xe.supportThemeIcons);return at.isTrusted=Xe.isTrusted,at.supportHtml=Xe.supportHtml,at.baseUri=Xe.baseUri?d.URI.from(Xe.baseUri):void 0,at}Le.to=He;function Ze(Xe){if(Xe)return typeof Xe=="string"?Xe:Le.from(Xe)}Le.fromStrict=Ze})(Y||(e.MarkdownString=Y={}));function ie(Le){return U(Le)?Le.map(Fe=>({range:k.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?Y.fromMany(Fe.hoverMessage):Fe.hoverMessage?Y.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Le.map(Fe=>({range:k.from(Fe)}))}function H(Le){return typeof Le>"u"?Le:typeof Le=="string"?d.URI.file(Le):Le}var J;(function(Le){function Fe(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?H(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Le.from=Fe})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var x;(function(Le){function Fe(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?H(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?J.from(ye.before):void 0,after:ye.after?J.from(ye.after):void 0}}Le.from=Fe})(x||(e.ThemableDecorationRenderOptions=x={}));var ne;(function(Le){function Fe(ye){if(typeof ye>"u")return ye;switch(ye){case g.DecorationRangeBehavior.OpenOpen:return 0;case g.DecorationRangeBehavior.ClosedClosed:return 1;case g.DecorationRangeBehavior.OpenClosed:return 2;case g.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Fe})(ne||(e.DecorationRangeBehavior=ne={}));var be;(function(Le){function Fe(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ne.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?x.from(ye.light):void 0,dark:ye.dark?x.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?H(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?J.from(ye.before):void 0,after:ye.after?J.from(ye.after):void 0}}Le.from=Fe})(be||(e.DecorationRenderOptions=be={}));var ae;(function(Le){function Fe(Z){return{text:Z.newText,eol:Z.newEol&&Re.from(Z.newEol),range:k.from(Z.range)}}Le.from=Fe;function ye(Z){const Te=new g.$pM(k.to(Z.range),Z.text);return Te.newEol=typeof Z.eol>"u"?void 0:Re.to(Z.eol),Te}Le.to=ye})(ae||(e.TextEdit=ae={}));var Ie;(function(Le){function Fe(Z,Te){const He={edits:[]};if(Z instanceof g.$sM){const Ze=new b.$Bc;for(const Xe of Z._allEntries())Xe._type===1&&d.URI.isUri(Xe.to)&&Xe.from===void 0&&Ze.add(Xe.to);for(const Xe of Z._allEntries())if(Xe._type===1){let at;Xe.options?.contents&&(ArrayBuffer.isView(Xe.options.contents)?at={type:"base64",value:(0,L.$2e)(L.$He.wrap(Xe.options.contents))}:at={type:"dataTransferItem",id:Xe.options.contents._itemId}),He.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contents:at},metadata:Xe.metadata})}else Xe._type===2?He.edits.push({resource:Xe.uri,textEdit:ae.from(Xe.edit),versionId:Ze.has(Xe.uri)?void 0:Te?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===6?He.edits.push({resource:Xe.uri,textEdit:{range:k.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:Ze.has(Xe.uri)?void 0:Te?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===3?He.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===5&&He.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(zt.from)}})}return He}Le.from=Fe;function ye(Z){const Te=new g.$sM,He=new b.$Ac;for(const Ze of Z.edits)if(Ze.textEdit){const Xe=Ze,at=d.URI.revive(Xe.resource),St=k.to(Xe.textEdit.range),Jt=Xe.textEdit.text,Ht=Xe.textEdit.insertAsSnippet;let Mt;Ht?Mt=g.$rM.replace(St,new g.$tM(Jt)):Mt=g.$pM.replace(St,Jt);const ht=He.get(at);ht?ht.push(Mt):He.set(at,[Mt])}else Te.renameFile(d.URI.revive(Ze.oldResource),d.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Xe]of He)Te.set(Ze,Xe);return Te}Le.to=ye})(Ie||(e.WorkspaceEdit=Ie={}));var ee;(function(Le){const Fe=Object.create(null);Fe[g.SymbolKind.File]=0,Fe[g.SymbolKind.Module]=1,Fe[g.SymbolKind.Namespace]=2,Fe[g.SymbolKind.Package]=3,Fe[g.SymbolKind.Class]=4,Fe[g.SymbolKind.Method]=5,Fe[g.SymbolKind.Property]=6,Fe[g.SymbolKind.Field]=7,Fe[g.SymbolKind.Constructor]=8,Fe[g.SymbolKind.Enum]=9,Fe[g.SymbolKind.Interface]=10,Fe[g.SymbolKind.Function]=11,Fe[g.SymbolKind.Variable]=12,Fe[g.SymbolKind.Constant]=13,Fe[g.SymbolKind.String]=14,Fe[g.SymbolKind.Number]=15,Fe[g.SymbolKind.Boolean]=16,Fe[g.SymbolKind.Array]=17,Fe[g.SymbolKind.Object]=18,Fe[g.SymbolKind.Key]=19,Fe[g.SymbolKind.Null]=20,Fe[g.SymbolKind.EnumMember]=21,Fe[g.SymbolKind.Struct]=22,Fe[g.SymbolKind.Event]=23,Fe[g.SymbolKind.Operator]=24,Fe[g.SymbolKind.TypeParameter]=25;function ye(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Le.from=ye;function Z(Te){for(const He in Fe)if(Fe[He]===Te)return Number(He);return g.SymbolKind.Property}Le.to=Z})(ee||(e.SymbolKind=ee={}));var B;(function(Le){function Fe(Z){switch(Z){case g.SymbolTag.Deprecated:return 1}}Le.from=Fe;function ye(Z){switch(Z){case 1:return g.SymbolTag.Deprecated}}Le.to=ye})(B||(e.SymbolTag=B={}));var _;(function(Le){function Fe(Z){return{name:Z.name,kind:ee.from(Z.kind),tags:Z.tags&&Z.tags.map(B.from),containerName:Z.containerName,location:le.from(Z.location)}}Le.from=Fe;function ye(Z){const Te=new g.$BM(Z.name,ee.to(Z.kind),Z.containerName,le.to(Z.location));return Te.tags=Z.tags&&Z.tags.map(B.to),Te}Le.to=ye})(_||(e.WorkspaceSymbol=_={}));var pe;(function(Le){function Fe(Z){const Te={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:k.from(Z.range),selectionRange:k.from(Z.selectionRange),kind:ee.from(Z.kind),tags:Z.tags?.map(B.from)??[]};return Z.children&&(Te.children=Z.children.map(Fe)),Te}Le.from=Fe;function ye(Z){const Te=new g.$CM(Z.name,Z.detail,ee.to(Z.kind),k.to(Z.range),k.to(Z.selectionRange));return(0,l.$Lb)(Z.tags)&&(Te.tags=Z.tags.map(B.to)),Z.children&&(Te.children=Z.children.map(ye)),Te}Le.to=ye})(pe||(e.DocumentSymbol=pe={}));var ue;(function(Le){function Fe(Z){const Te=new g.$GM(ee.to(Z.kind),Z.name,Z.detail||"",d.URI.revive(Z.uri),k.to(Z.range),k.to(Z.selectionRange));return Te._sessionId=Z._sessionId,Te._itemId=Z._itemId,Te}Le.to=Fe;function ye(Z,Te,He){if(Te=Te??Z._sessionId,He=He??Z._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,name:Z.name,detail:Z.detail,kind:ee.from(Z.kind),uri:Z.uri,range:k.from(Z.range),selectionRange:k.from(Z.selectionRange),tags:Z.tags?.map(B.from)}}Le.from=ye})(ue||(e.CallHierarchyItem=ue={}));var ce;(function(Le){function Fe(ye){return new g.$HM(ue.to(ye.from),ye.fromRanges.map(Z=>k.to(Z)))}Le.to=Fe})(ce||(e.CallHierarchyIncomingCall=ce={}));var oe;(function(Le){function Fe(ye){return new g.$IM(ue.to(ye.to),ye.fromRanges.map(Z=>k.to(Z)))}Le.to=Fe})(oe||(e.CallHierarchyOutgoingCall=oe={}));var le;(function(Le){function Fe(Z){return{range:Z.range&&k.from(Z.range),uri:Z.uri}}Le.from=Fe;function ye(Z){return new g.$uM(d.URI.revive(Z.uri),k.to(Z.range))}Le.to=ye})(le||(e.location=le={}));var K;(function(Le){function Fe(Z){const Te=Z,He=Z;return{originSelectionRange:Te.originSelectionRange?k.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:He.uri,range:k.from(Te.targetRange?Te.targetRange:He.range),targetSelectionRange:Te.targetSelectionRange?k.from(Te.targetSelectionRange):void 0}}Le.from=Fe;function ye(Z){return{targetUri:d.URI.revive(Z.uri),targetRange:k.to(Z.range),targetSelectionRange:Z.targetSelectionRange?k.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?k.to(Z.originSelectionRange):void 0}}Le.to=ye})(K||(e.DefinitionLink=K={}));var se;(function(Le){function Fe(Z){return{range:k.from(Z.range),contents:Y.fromMany(Z.contents),canIncreaseVerbosity:Z.canIncreaseVerbosity,canDecreaseVerbosity:Z.canDecreaseVerbosity}}Le.from=Fe;function ye(Z){const Te=Z.contents.map(Y.to),He=k.to(Z.range),Ze=Z.canIncreaseVerbosity,Xe=Z.canDecreaseVerbosity;return new g.$yM(Te,He,Ze,Xe)}Le.to=ye})(se||(e.Hover=se={}));var $e;(function(Le){function Fe(Z){return{range:k.from(Z.range),expression:Z.expression}}Le.from=Fe;function ye(Z){return new g.$tN(k.to(Z.range),Z.expression)}Le.to=ye})($e||(e.EvaluatableExpression=$e={}));var ve;(function(Le){function Fe(Z){if(Z instanceof g.$uN)return{type:"text",range:k.from(Z.range),text:Z.text};if(Z instanceof g.$vN)return{type:"variable",range:k.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof g.$wN)return{type:"expression",range:k.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Fe;function ye(Z){switch(Z.type){case"text":return{range:k.to(Z.range),text:Z.text};case"variable":return{range:k.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:k.to(Z.range),expression:Z.expression}}}Le.to=ye})(ve||(e.InlineValue=ve={}));var Me;(function(Le){function Fe(Z){return{frameId:Z.frameId,stoppedLocation:k.from(Z.stoppedLocation)}}Le.from=Fe;function ye(Z){return new g.$xN(Z.frameId,k.to(Z.stoppedLocation))}Le.to=ye})(Me||(e.InlineValueContext=Me={}));var ge;(function(Le){function Fe(Z){return{range:k.from(Z.range),kind:Z.kind}}Le.from=Fe;function ye(Z){return new g.$zM(k.to(Z.range),Z.kind)}Le.to=ye})(ge||(e.DocumentHighlight=ge={}));var Pe;(function(Le){function Fe(Z){return{uri:Z.uri,highlights:Z.highlights.map(ge.from)}}Le.from=Fe;function ye(Z){return new g.$AM(d.URI.revive(Z.uri),Z.highlights.map(ge.to))}Le.to=ye})(Pe||(e.MultiDocumentHighlight=Pe={}));var Ae;(function(Le){function Fe(ye){switch(ye){case 1:return g.CompletionTriggerKind.TriggerCharacter;case 2:return g.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return g.CompletionTriggerKind.Invoke}}Le.to=Fe})(Ae||(e.CompletionTriggerKind=Ae={}));var ze;(function(Le){function Fe(ye){return{triggerKind:Ae.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Le.to=Fe})(ze||(e.CompletionContext=ze={}));var q;(function(Le){function Fe(Z){switch(Z){case g.CompletionItemTag.Deprecated:return 1}}Le.from=Fe;function ye(Z){switch(Z){case 1:return g.CompletionItemTag.Deprecated}}Le.to=ye})(q||(e.CompletionItemTag=q={}));var W;(function(Le){const Fe=new Map([[g.CompletionItemKind.Method,0],[g.CompletionItemKind.Function,1],[g.CompletionItemKind.Constructor,2],[g.CompletionItemKind.Field,3],[g.CompletionItemKind.Variable,4],[g.CompletionItemKind.Class,5],[g.CompletionItemKind.Interface,7],[g.CompletionItemKind.Struct,6],[g.CompletionItemKind.Module,8],[g.CompletionItemKind.Property,9],[g.CompletionItemKind.Unit,12],[g.CompletionItemKind.Value,13],[g.CompletionItemKind.Constant,14],[g.CompletionItemKind.Enum,15],[g.CompletionItemKind.EnumMember,16],[g.CompletionItemKind.Keyword,17],[g.CompletionItemKind.Snippet,27],[g.CompletionItemKind.Text,18],[g.CompletionItemKind.Color,19],[g.CompletionItemKind.File,20],[g.CompletionItemKind.Reference,21],[g.CompletionItemKind.Folder,23],[g.CompletionItemKind.Event,10],[g.CompletionItemKind.Operator,11],[g.CompletionItemKind.TypeParameter,24],[g.CompletionItemKind.Issue,26],[g.CompletionItemKind.User,25]]);function ye(He){return Fe.get(He)??9}Le.from=ye;const Z=new Map([[0,g.CompletionItemKind.Method],[1,g.CompletionItemKind.Function],[2,g.CompletionItemKind.Constructor],[3,g.CompletionItemKind.Field],[4,g.CompletionItemKind.Variable],[5,g.CompletionItemKind.Class],[7,g.CompletionItemKind.Interface],[6,g.CompletionItemKind.Struct],[8,g.CompletionItemKind.Module],[9,g.CompletionItemKind.Property],[12,g.CompletionItemKind.Unit],[13,g.CompletionItemKind.Value],[14,g.CompletionItemKind.Constant],[15,g.CompletionItemKind.Enum],[16,g.CompletionItemKind.EnumMember],[17,g.CompletionItemKind.Keyword],[27,g.CompletionItemKind.Snippet],[18,g.CompletionItemKind.Text],[19,g.CompletionItemKind.Color],[20,g.CompletionItemKind.File],[21,g.CompletionItemKind.Reference],[23,g.CompletionItemKind.Folder],[10,g.CompletionItemKind.Event],[11,g.CompletionItemKind.Operator],[24,g.CompletionItemKind.TypeParameter],[25,g.CompletionItemKind.User],[26,g.CompletionItemKind.Issue]]);function Te(He){return Z.get(He)??g.CompletionItemKind.Property}Le.to=Te})(W||(e.CompletionItemKind=W={}));var X;(function(Le){function Fe(ye,Z){const Te=new g.$QM(ye.label);return Te.insertText=ye.insertText,Te.kind=W.to(ye.kind),Te.tags=ye.tags?.map(q.to),Te.detail=ye.detail,Te.documentation=R.$Xk(ye.documentation)?Y.to(ye.documentation):ye.documentation,Te.sortText=ye.sortText,Te.filterText=ye.filterText,Te.preselect=ye.preselect,Te.commitCharacters=ye.commitCharacters,c.$xt.isIRange(ye.range)?Te.range=k.to(ye.range):typeof ye.range=="object"&&(Te.range={inserting:k.to(ye.range.insert),replacing:k.to(ye.range.replace)}),Te.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Te.insertText=new g.$tM(ye.insertText):(Te.insertText=ye.insertText,Te.textEdit=Te.range instanceof g.$kM?new g.$pM(Te.range,Te.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Te.additionalTextEdits=ye.additionalTextEdits.map(He=>ae.to(He))),Te.command=Z&&ye.command?Z.fromInternal(ye.command):void 0,Te}Le.to=Fe})(X||(e.CompletionItem=X={}));var Q;(function(Le){function Fe(Z){if(typeof Z.label!="string"&&!Array.isArray(Z.label))throw new TypeError("Invalid label");return{label:Z.label,documentation:Y.fromStrict(Z.documentation)}}Le.from=Fe;function ye(Z){return{label:Z.label,documentation:R.$Xk(Z.documentation)?Y.to(Z.documentation):Z.documentation}}Le.to=ye})(Q||(e.ParameterInformation=Q={}));var de;(function(Le){function Fe(Z){return{label:Z.label,documentation:Y.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(Q.from):[],activeParameter:Z.activeParameter}}Le.from=Fe;function ye(Z){return{label:Z.label,documentation:R.$Xk(Z.documentation)?Y.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(Q.to):[],activeParameter:Z.activeParameter}}Le.to=ye})(de||(e.SignatureInformation=de={}));var we;(function(Le){function Fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(de.from):[]}}Le.from=Fe;function ye(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(de.to):[]}}Le.to=ye})(we||(e.SignatureHelp=we={}));var je;(function(Le){function Fe(ye,Z){const Te=new g.$PM(D.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(qe.to.bind(void 0,ye)),Z.kind&&Ke.to(Z.kind));return Te.textEdits=Z.textEdits&&Z.textEdits.map(ae.to),Te.tooltip=R.$Xk(Z.tooltip)?Y.to(Z.tooltip):Z.tooltip,Te.paddingLeft=Z.paddingLeft,Te.paddingRight=Z.paddingRight,Te}Le.to=Fe})(je||(e.InlayHint=je={}));var qe;(function(Le){function Fe(ye,Z){const Te=new g.$OM(Z.label);return Te.tooltip=R.$Xk(Z.tooltip)?Y.to(Z.tooltip):Z.tooltip,n.Command.is(Z.command)&&(Te.command=ye.fromInternal(Z.command)),Z.location&&(Te.location=le.to(Z.location)),Te}Le.to=Fe})(qe||(e.InlayHintLabelPart=qe={}));var Ke;(function(Le){function Fe(Z){return Z}Le.from=Fe;function ye(Z){return Z}Le.to=ye})(Ke||(e.InlayHintKind=Ke={}));var tt;(function(Le){function Fe(Z){return{range:k.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Le.from=Fe;function ye(Z){let Te;if(Z.url)try{Te=typeof Z.url=="string"?d.URI.parse(Z.url,!0):d.URI.revive(Z.url)}catch{}return new g.$VM(k.to(Z.range),Te)}Le.to=ye})(tt||(e.DocumentLink=tt={}));var _e;(function(Le){function Fe(Z){const Te=new g.$YM(Z.label);return Z.textEdit&&(Te.textEdit=ae.to(Z.textEdit)),Z.additionalTextEdits&&(Te.additionalTextEdits=Z.additionalTextEdits.map(He=>ae.to(He))),Te}Le.to=Fe;function ye(Z){return{label:Z.label,textEdit:Z.textEdit?ae.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Te=>ae.from(Te)):void 0}}Le.from=ye})(_e||(e.ColorPresentation=_e={}));var nt;(function(Le){function Fe(Z){return new g.$WM(Z[0],Z[1],Z[2],Z[3])}Le.to=Fe;function ye(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Le.from=ye})(nt||(e.Color=nt={}));var it;(function(Le){function Fe(Z){return{range:k.from(Z.range)}}Le.from=Fe;function ye(Z){return new g.$FM(k.to(Z.range))}Le.to=ye})(it||(e.SelectionRange=it={}));var rt;(function(Le){function Fe(ye){switch(ye){case 2:return g.TextDocumentSaveReason.AfterDelay;case 1:return g.TextDocumentSaveReason.Manual;case 3:case 4:return g.TextDocumentSaveReason.FocusOut}}Le.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var ct;(function(Le){function Fe(Z){switch(Z){case g.TextEditorLineNumbersStyle.Off:return 0;case g.TextEditorLineNumbersStyle.Relative:return 2;case g.TextEditorLineNumbersStyle.Interval:return 3;case g.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Fe;function ye(Z){switch(Z){case 0:return g.TextEditorLineNumbersStyle.Off;case 2:return g.TextEditorLineNumbersStyle.Relative;case 3:return g.TextEditorLineNumbersStyle.Interval;case 1:default:return g.TextEditorLineNumbersStyle.On}}Le.to=ye})(ct||(e.TextEditorLineNumbersStyle=ct={}));var Re;(function(Le){function Fe(Z){if(Z===g.EndOfLine.CRLF)return 1;if(Z===g.EndOfLine.LF)return 0}Le.from=Fe;function ye(Z){if(Z===1)return g.EndOfLine.CRLF;if(Z===0)return g.EndOfLine.LF}Le.to=ye})(Re||(e.EndOfLine=Re={}));var Se;(function(Le){function Fe(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case g.ProgressLocation.SourceControl:return 3;case g.ProgressLocation.Window:return 10;case g.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Fe})(Se||(e.ProgressLocation=Se={}));var Ve;(function(Le){function Fe(Z){const Te={start:Z.start+1,end:Z.end+1};return Z.kind&&(Te.kind=te.from(Z.kind)),Te}Le.from=Fe;function ye(Z){const Te={start:Z.start-1,end:Z.end-1};return Z.kind&&(Te.kind=te.to(Z.kind)),Te}Le.to=ye})(Ve||(e.FoldingRange=Ve={}));var te;(function(Le){function Fe(Z){if(Z)switch(Z){case g.FoldingRangeKind.Comment:return n.$gu.Comment;case g.FoldingRangeKind.Imports:return n.$gu.Imports;case g.FoldingRangeKind.Region:return n.$gu.Region}}Le.from=Fe;function ye(Z){if(Z)switch(Z.value){case n.$gu.Comment.value:return g.FoldingRangeKind.Comment;case n.$gu.Imports.value:return g.FoldingRangeKind.Imports;case n.$gu.Region.value:return g.FoldingRangeKind.Region}}Le.to=ye})(te||(e.FoldingRangeKind=te={}));var re;(function(Le){function Fe(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?k.from(ye.selection):void 0,override:typeof ye.override=="boolean"?s.$xF.id:void 0}}Le.from=Fe})(re||(e.TextEditorOpenOptions=re={}));var Ce;(function(Le){function Fe(He){return He instanceof g.$hN?He.toJSON():typeof He=="string"?He:ye(He)||Z(He)?new g.$hN(He.baseUri??He.base,He.pattern).toJSON():He}Le.from=Fe;function ye(He){const Ze=He;return Ze?d.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Z(He){const Ze=He;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Te(He){return typeof He=="string"?He:new g.$hN(d.URI.revive(He.baseUri),He.pattern)}Le.to=Te})(Ce||(e.GlobPattern=Ce={}));var Ge;(function(Le){function Fe(ye){if(ye){if(Array.isArray(ye))return ye.map(Fe);if(typeof ye=="string")return ye;{const Z=ye;return{language:Z.language,scheme:Z.scheme,pattern:Ce.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}Le.from=Fe})(Ge||(e.LanguageSelector=Ge={}));var Oe;(function(Le){function Fe(Z){return!!Z&&typeof Z=="object"&&"documents"in Z&&Array.isArray(Z.documents)&&Z.documents.every(Te=>Array.isArray(Te)&&Te.every(He=>He&&typeof He=="object"&&"uri"in He&&d.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(Ze=>Ze instanceof g.$kM)))}Le.is=Fe;function ye(Z){return{documents:Z.documents.map(Te=>Te.map(He=>({uri:d.URI.from(He.uri),version:He.version,ranges:He.ranges.map(Ze=>k.from(Ze))})))}}Le.from=ye})(Oe||(e.MappedEditsContext=Oe={}));var st;(function(Le){function Fe(Z){return{start:Z.start,end:Z.end}}Le.from=Fe;function ye(Z){return new g.$KN(Z.start,Z.end)}Le.to=ye})(st||(e.NotebookRange=st={}));var lt;(function(Le){function Fe(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Le.to=Fe;function ye(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}Le.from=ye})(lt||(e.NotebookCellExecutionSummary=lt={}));var mt;(function(Le){function Fe(ye){if(ye===u.NotebookCellExecutionState.Unconfirmed)return g.NotebookCellExecutionState.Pending;if(ye===u.NotebookCellExecutionState.Pending)return;if(ye===u.NotebookCellExecutionState.Executing)return g.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Le.to=Fe})(mt||(e.NotebookCellExecutionState=mt={}));var Dt;(function(Le){function Fe(Z){switch(Z){case g.NotebookCellKind.Markup:return u.CellKind.Markup;case g.NotebookCellKind.Code:default:return u.CellKind.Code}}Le.from=Fe;function ye(Z){switch(Z){case u.CellKind.Markup:return g.NotebookCellKind.Markup;case u.CellKind.Code:default:return g.NotebookCellKind.Code}}Le.to=ye})(Dt||(e.NotebookCellKind=Dt={}));var It;(function(Le){function Fe(Z){const Te={metadata:Z.metadata??Object.create(null),cells:[]};for(const He of Z.cells)g.$LN.validate(He),Te.cells.push(zt.from(He));return Te}Le.from=Fe;function ye(Z){const Te=new g.$MN(Z.cells.map(zt.to));return(0,h.$lg)(Z.metadata)||(Te.metadata=Z.metadata),Te}Le.to=ye})(It||(e.NotebookData=It={}));var zt;(function(Le){function Fe(Z){return{cellKind:Dt.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:lt.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(kt.from):[]}}Le.from=Fe;function ye(Z){return new g.$LN(Dt.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(kt.to):void 0,Z.metadata,Z.internalMetadata?lt.to(Z.internalMetadata):void 0)}Le.to=ye})(zt||(e.NotebookCellData=zt={}));var Bt;(function(Le){function Fe(Z){return{mime:Z.mime,valueBytes:L.$He.wrap(Z.data)}}Le.from=Fe;function ye(Z){return new g.$NN(Z.valueBytes.buffer,Z.mime)}Le.to=ye})(Bt||(e.NotebookCellOutputItem=Bt={}));var kt;(function(Le){function Fe(Z){return{outputId:Z.id,items:Z.items.map(Bt.from),metadata:Z.metadata}}Le.from=Fe;function ye(Z){const Te=Z.items.map(Bt.to);return new g.$ON(Te,Z.outputId,Z.metadata)}Le.to=ye})(kt||(e.NotebookCellOutput=kt={}));var Zt;(function(Le){function Fe(Te){return Z(Te)?{include:Ce.from(Te.include)??void 0,exclude:Ce.from(Te.exclude)??void 0}:Ce.from(Te)??void 0}Le.from=Fe;function ye(Te){return Z(Te)?{include:Ce.to(Te.include),exclude:Ce.to(Te.exclude)}:Ce.to(Te)}Le.to=ye;function Z(Te){const He=Te;return He?!(0,h.$hg)(He.include)&&!(0,h.$hg)(He.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var xt;(function(Le){function Fe(ye,Z,Te){const He=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===g.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(He,Te),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Le.from=Fe})(xt||(e.NotebookStatusBarItem=xt={}));var xe;(function(Le){function Fe(ye,Z,Te){const He=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:Z.toInternal(He,Te),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Le.from=Fe})(xe||(e.NotebookKernelSourceAction=xe={}));var on;(function(Le){function Fe(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Le.from=Fe})(on||(e.NotebookDocumentContentOptions=on={}));var Xt;(function(Le){function Fe(Z){return{uri:Z.uri,provides:Z.provides}}Le.from=Fe;function ye(Z){return new g.$QN(d.URI.revive(Z.uri),Z.provides)}Le.to=ye})(Xt||(e.NotebookRendererScript=Xt={}));var ft;(function(Le){function Fe(Z){return{message:Y.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,contextValue:Z.contextValue,location:Z.location&&{range:k.from(Z.location.range),uri:Z.location.uri}}}Le.from=Fe;function ye(Z){const Te=new g.$WN(typeof Z.message=="string"?Z.message:Y.to(Z.message));return Te.actualOutput=Z.actual,Te.expectedOutput=Z.expected,Te.contextValue=Z.contextValue,Te.location=Z.location?le.to(Z.location):void 0,Te}Le.to=ye})(ft||(e.TestMessage=ft={}));var $t;(function(Le){Le.namespace=o.$0K,Le.denamespace=o.$$K})($t||(e.TestTag=$t={}));var _t;(function(Le){function Fe(Z){const Te=(0,a.$FO)(Z).controllerId;return{extId:r.$5K.fromExtHostTestItem(Z,Te).toString(),label:Z.label,uri:d.URI.revive(Z.uri),busy:Z.busy,tags:Z.tags.map(He=>$t.namespace(Te,He.id)),range:c.$xt.lift(k.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&Y.fromStrict(Z.error)||null}}Le.from=Fe;function ye(Z){return{parent:void 0,error:void 0,id:r.$5K.fromString(Z.extId).localId,label:Z.label,uri:d.URI.revive(Z.uri),tags:(Z.tags||[]).map(Te=>{const{tagId:He}=$t.denamespace(Te);return new g.$XN(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:k.to(Z.range||void 0),canResolveChildren:!1,busy:Z.busy,description:Z.description||void 0,sortText:Z.sortText||void 0}}Le.toPlain=ye})(_t||(e.TestItem=_t={})),function(Le){function Fe(Z){return{id:Z.id}}Le.from=Fe;function ye(Z){return new g.$XN(Z.id)}Le.to=ye}($t||(e.TestTag=$t={}));var Qt;(function(Le){const Fe=(Z,Te)=>{const He=Z.value;if(!He)return;const Ze={..._t.toPlain(He.item),parent:Te,taskStates:He.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(at=>at.type===0).map(ft.to)})),children:[]};if(Z.children)for(const Xe of Z.children.values()){const at=Fe(Xe,Ze);at&&Ze.children.push(at)}return Ze};function ye(Z){const Te=new p.$yO;for(const Xe of Z.items)Te.insert(r.$5K.fromString(Xe.item.extId).path,Xe);const He=[Te.nodes],Ze=[];for(;He.length;)for(const Xe of He.pop())Xe.value?Ze.push(Xe):Xe.children&&He.push(Xe.children.values());return{completedAt:Z.completedAt,results:Ze.map(Xe=>Fe(Xe)).filter(h.$gg)}}Le.to=ye})(Qt||(e.TestResults=Qt={}));var Ft;(function(Le){function Fe(He){return{covered:He.covered,total:He.total}}function ye(He){return"line"in He?D.from(He):k.from(He)}function Z(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:ye(He.location),type:1,branches:He.branches.length?He.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ye(Ze.location),label:Ze.label})):void 0}:{type:0,name:He.name,count:He.executed,location:ye(He.location)}}Le.fromDetails=Z;function Te(He,Ze){return g.$ZN(Ze.statementCoverage),g.$ZN(Ze.branchCoverage),g.$ZN(Ze.declarationCoverage),{id:He,uri:Ze.uri,statement:Fe(Ze.statementCoverage),branch:Ze.branchCoverage&&Fe(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Fe(Ze.declarationCoverage)}}Le.fromFile=Te})(Ft||(e.TestCoverage=Ft={}));var gt;(function(Le){function Fe(ye){switch(ye){case 1:return g.CodeActionTriggerKind.Invoke;case 2:return g.CodeActionTriggerKind.Automatic}}Le.to=Fe})(gt||(e.CodeActionTriggerKind=gt={}));var Vt;(function(Le){function Fe(Z){const Te=new g.$5N(ee.to(Z.kind),Z.name,Z.detail||"",d.URI.revive(Z.uri),k.to(Z.range),k.to(Z.selectionRange));return Te._sessionId=Z._sessionId,Te._itemId=Z._itemId,Te}Le.to=Fe;function ye(Z,Te,He){if(Te=Te??Z._sessionId,He=He??Z._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,kind:ee.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:k.from(Z.range),selectionRange:k.from(Z.selectionRange),tags:Z.tags?.map(B.from)}}Le.from=ye})(Vt||(e.TypeHierarchyItem=Vt={}));var en;(function(Le){function Fe(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Le.from=Fe})(en||(e.ViewBadge=en={}));var Ut;(function(Le){function Fe(He,Ze,Xe){const at=Ze.fileData;return at?new g.$_M(new g.$aN(at.name,d.URI.revive(at.uri),at.id,(0,M.$db)(()=>Xe(at.id)))):He===A.$Ts.uriList&&Ze.uriListData?new g.$$M(Te(Ze.uriListData)):new g.$$M(Ze.asString)}Le.to=Fe;async function ye(He,Ze){const Xe=await Ze.asString();if(He===A.$Ts.uriList)return{asString:Xe,fileData:void 0,uriListData:Z(Xe)};const at=Ze.asFile();return{asString:Xe,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}Le.from=ye;function Z(He){return O.$Xt.split(He).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return d.URI.parse(Ze)}catch{}return Ze})}function Te(He){return O.$Xt.create(He.map(Ze=>typeof Ze=="string"?Ze:d.URI.revive(Ze)))}})(Ut||(e.DataTransferItem=Ut={}));var Ye;(function(Le){function Fe(Z,Te){const He=Z.items.map(([Ze,Xe])=>[Ze,Ut.to(Ze,Xe,Te)]);return new g.$bN(He)}Le.toDataTransfer=Fe;async function ye(Z){const Te={items:[]},He=[];for(const[Ze,Xe]of Z)He.push((async()=>{Te.items.push([Ze,await Ut.from(Ze,Xe)])})());return await Promise.all(He),Te}Le.from=ye})(Ye||(e.DataTransfer=Ye={}));var un;(function(Le){function Fe(Z,Te){return{kind:"reply",agentId:Z.participant??Te?.agentId??"",subCommand:Z.command??Te?.command,message:Z.prompt,title:Z.label}}Le.from=Fe;function ye(Z){return{prompt:Z.message,label:Z.title,participant:Z.agentId,command:Z.subCommand}}Le.to=ye})(un||(e.ChatFollowup=un={}));var Yt;(function(Le){function Fe(Z){switch(Z.role){case 0:return new g.$sO(g.LanguageModelChatMessageRole.System,Z.content);case 1:return new g.$sO(g.LanguageModelChatMessageRole.User,Z.content);case 2:return new g.$sO(g.LanguageModelChatMessageRole.Assistant,Z.content)}}Le.to=Fe;function ye(Z){switch(Z.role){case g.LanguageModelChatMessageRole.System:return{role:0,content:Z.content};case g.LanguageModelChatMessageRole.User:return{role:1,content:Z.content};case g.LanguageModelChatMessageRole.Assistant:return{role:2,content:Z.content}}}Le.from=ye})(Yt||(e.LanguageModelChatMessage=Yt={}));var Wt;(function(Le){function Fe(Z){return{kind:"markdownContent",content:Y.from(Z.value)}}Le.from=Fe;function ye(Z){return new g.$fO(Y.to(Z.content))}Le.to=ye})(Wt||(e.ChatResponseMarkdownPart=Wt={}));var bt;(function(Le){function Fe(Z){return{kind:"markdownVuln",content:Y.from(Z.value),vulnerabilities:Z.vulnerabilities}}Le.from=Fe;function ye(Z){return new g.$gO(Y.to(Z.content),Z.vulnerabilities)}Le.to=ye})(bt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=bt={}));var qt;(function(Le){function Fe(Z){return{kind:"agentDetection",agentId:Z.participant,command:Z.command}}Le.from=Fe;function ye(Z){return new g.$hO(Z.agentId,Z.command)}Le.to=ye})(qt||(e.ChatResponseDetectedParticipantPart=qt={}));var Lt;(function(Le){function Fe(ye){return{kind:"confirmation",title:ye.title,message:ye.message,data:ye.data}}Le.from=Fe})(Lt||(e.ChatResponseConfirmationPart=Lt={}));var Tt;(function(Le){function Fe(Z){const{value:Te,baseUri:He}=Z;function Ze(Xe,at){return Xe.map(St=>{const Jt=d.URI.joinPath(at,St.name);return{label:St.name,uri:Jt,children:St.children&&Ze(St.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,S.$9g)(He),uri:He,children:Ze(Te,He)}}}Le.from=Fe;function ye(Z){const Te=(0,E.$8h)(Z.treeData);function He(at){return at.map(St=>({name:St.label,children:St.children&&He(St.children)}))}const Ze=Te.uri,Xe=Te.children?He(Te.children):[];return new g.$jO(Xe,Ze)}Le.to=ye})(Tt||(e.ChatResponseFilesPart=Tt={}));var tn;(function(Le){function Fe(Z){return{kind:"inlineReference",name:Z.title,inlineReference:d.URI.isUri(Z.value)?Z.value:m.from(Z.value)}}Le.from=Fe;function ye(Z){const Te=(0,E.$8h)(Z);return new g.$kO(d.URI.isUri(Te.inlineReference)?Te.inlineReference:m.to(Te.inlineReference),Z.name)}Le.to=ye})(tn||(e.ChatResponseAnchorPart=tn={}));var Gt;(function(Le){function Fe(Z){return{kind:"progressMessage",content:Y.from(Z.value)}}Le.from=Fe;function ye(Z){return new g.$lO(Z.content.value)}Le.to=ye})(Gt||(e.ChatResponseProgressPart=Gt={}));var an;(function(Le){function Fe(Z){return{kind:"warning",content:Y.from(Z.value)}}Le.from=Fe;function ye(Z){return new g.$mO(Z.content.value)}Le.to=ye})(an||(e.ChatResponseWarningPart=an={}));var Rt;(function(Le){function Fe(Z,Te,He){return{kind:"command",command:Te.toInternal(Z.value,He)??{command:Z.value.command,title:Z.value.title}}}Le.from=Fe;function ye(Z,Te){return new g.$nO(Te.fromInternal(Z.command)??{command:Z.command.id,title:Z.command.title})}Le.to=ye})(Rt||(e.ChatResponseCommandButtonPart=Rt={}));var jt;(function(Le){function Fe(Z){return{kind:"textEdit",uri:Z.uri,edits:Z.edits.map(Te=>ae.from(Te))}}Le.from=Fe;function ye(Z){return new g.$pO(d.URI.revive(Z.uri),Z.edits.map(Te=>ae.to(Te)))}Le.to=ye})(jt||(e.ChatResponseTextEditPart=jt={}));var Nt;(function(Le){function Fe(Z){const Te=v.ThemeIcon.isThemeIcon(Z.iconPath)?Z.iconPath:Z.iconPath&&"light"in Z.iconPath&&"dark"in Z.iconPath&&d.URI.isUri(Z.iconPath.light)&&d.URI.isUri(Z.iconPath.dark)?{light:d.URI.revive(Z.iconPath.light),dark:d.URI.revive(Z.iconPath.dark)}:void 0;return"variableName"in Z.value?{kind:"reference",reference:{variableName:Z.value.variableName,value:d.URI.isUri(Z.value.value)||!Z.value.value?Z.value.value:m.from(Z.value.value)},iconPath:Te}:{kind:"reference",reference:d.URI.isUri(Z.value)?Z.value:m.from(Z.value),iconPath:Te}}Le.from=Fe;function ye(Z){const Te=(0,E.$8h)(Z),He=Ze=>d.URI.isUri(Ze)?Ze:m.to(Ze);return new g.$oO("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&He(Te.reference.value)}:He(Te.reference))}Le.to=ye})(Nt||(e.ChatResponseReferencePart=Nt={}));var At;(function(Le){function Fe(Te,He,Ze){return Te instanceof g.$fO?Wt.from(Te):Te instanceof g.$kO?tn.from(Te):Te instanceof g.$oO?Nt.from(Te):Te instanceof g.$lO?Gt.from(Te):Te instanceof g.$jO?Tt.from(Te):Te instanceof g.$nO?Rt.from(Te,He,Ze):Te instanceof g.$pO?jt.from(Te):Te instanceof g.$gO?bt.from(Te):Te instanceof g.$hO?qt.from(Te):Te instanceof g.$mO?an.from(Te):{kind:"markdownContent",content:Y.from("")}}Le.from=Fe;function ye(Te,He){switch(Te.kind){case"reference":return Nt.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Z(Te,He)}}Le.to=ye;function Z(Te,He){switch(Te.kind){case"markdownContent":return Wt.to(Te);case"inlineReference":return tn.to(Te);case"progressMessage":return;case"treeData":return Tt.to(Te);case"command":return Rt.to(Te,He)}}Le.toContent=Z})(At||(e.ChatResponsePart=At={}));var wt;(function(Le){function Fe(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(rn.to),location:Et.to(ye.location),acceptedConfirmationData:ye.acceptedConfirmationData,rejectedConfirmationData:ye.rejectedConfirmationData}}Le.to=Fe})(wt||(e.ChatAgentRequest=wt={}));var Et;(function(Le){function Fe(ye){switch(ye){case t.ChatAgentLocation.Notebook:return g.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return g.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return g.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return g.ChatLocation.Editor}}Le.to=Fe})(Et||(e.ChatLocation=Et={}));var rn;(function(Le){function Fe(ye){const Z=ye.value;if(!Z)throw new Error("Invalid value reference");return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],value:(0,d.$vc)(Z)?d.URI.revive(Z):Z}}Le.to=Fe})(rn||(e.ChatAgentValueReference=rn={}));var Ct;(function(Le){function Fe(ye,Z,Te){return{label:ye.label,value:ye.values[0].value,insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation,command:Z.toInternal(ye.command,Te)}}Le.from=Fe})(Ct||(e.ChatAgentCompletionItem=Ct={}));var fn;(function(Le){function Fe(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Le.to=Fe})(fn||(e.ChatAgentResult=fn={}));var sn;(function(Le){function Fe(ye,Z,Te){if(Z.action.kind==="vote")return;const He=fn.to(ye);if(Z.action.kind==="command"){const Ze=Z.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:He}}else return Z.action.kind==="followUp"?{action:{kind:"followUp",followup:un.to(Z.action.followup)},result:He}:Z.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Z.action.action==="accepted"},result:He}:{action:Z.action,result:He}}Le.to=Fe})(sn||(e.ChatAgentUserActionEvent=sn={}));var vn;(function(Le){function Fe(ye,Z,Te){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:Z.toInternal(ye,Te)}Le.from=Fe})(vn||(e.TerminalQuickFix=vn={}));var ln;(function(Le){function Fe(ye){return{kind:$n.to(ye.kind)}}Le.to=Fe})(ln||(e.PartialAcceptInfo=ln={}));var $n;(function(Le){function Fe(ye){switch(ye){case 0:return g.PartialAcceptTriggerKind.Word;case 1:return g.PartialAcceptTriggerKind.Line;case 2:return g.PartialAcceptTriggerKind.Suggest;default:return g.PartialAcceptTriggerKind.Unknown}}Le.to=Fe})($n||(e.PartialAcceptTriggerKind=$n={}));var Pt;(function(Le){function Fe(ye,Z){return{id:Z,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Le.from=Fe})(Pt||(e.DebugTreeItem=Pt={}))}),define(ke[334],De([1,0,6,20,17,48]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;let R=class{constructor($,E){this.a=$.getProxy(l.$gM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>E.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,A){const I=new M.$Ew(O.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(I,void 0,A?.isRefactoring??!1)}};e.$1lc=R,e.$1lc=R=Je([We(0,L.$JO)],R)}),define(ke[335],De([1,0,19,7,47,4,39,3,40,18,2,25,6,17,8,297,26]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class c{constructor(s,t,u,r,o){this.j=s,this.k=t,this.l=u,this.m=r,this.n=o,this.b=$.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(r){if(s.c){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const s=this;this.b.reset();const u=r=>{typeof this.d>"u"&&"content"in r&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.g={markdown(r){t(this.markdown);const o=new v.$fO(r),f=S.ChatResponseMarkdownPart.from(o);return u(f),this},markdownWithVulnerabilities(r,o){t(this.markdown),o&&(0,d.$SG)(s.j,"chatParticipantAdditions");const f=new v.$gO(r,o),g=S.ChatResponseMarkdownWithVulnerabilitiesPart.from(f);return u(g),this},filetree(r,o){t(this.filetree);const f=new v.$jO(r,o),g=S.ChatResponseFilesPart.from(f);return u(g),this},anchor(r,o){t(this.anchor);const f=new v.$kO(r,o),g=S.ChatResponseAnchorPart.from(f);return u(g),this},button(r){t(this.anchor);const o=new v.$nO(r),f=S.ChatResponseCommandButtonPart.from(o,s.m,s.n);return u(f),this},progress(r){t(this.progress);const o=new v.$lO(r),f=S.ChatResponseProgressPart.from(o);return u(f),this},warning(r){t(this.progress),(0,d.$SG)(s.j,"chatParticipantAdditions");const o=new v.$mO(r),f=S.ChatResponseWarningPart.from(o);return u(f),this},reference(r,o){if(t(this.reference),"variableName"in r&&!r.value){const f=s.k.variables.variables.find(g=>g.name===r.variableName);if(f){let g;if(f.references?.length)g=f.references.map(w=>({kind:"reference",reference:{variableName:r.variableName,value:w.reference}}));else{const w=new v.$oO(r,o);g=[S.ChatResponseReferencePart.from(w)]}return g.forEach(w=>u(w)),this}}else{const f=new v.$oO(r,o),g=S.ChatResponseReferencePart.from(f);u(g)}return this},textEdit(r,o){t(this.textEdit),(0,d.$SG)(s.j,"chatParticipantAdditions");const f=new v.$pO(r,o),g=S.ChatResponseTextEditPart.from(f);return u(g),this},detectedParticipant(r,o){t(this.detectedParticipant),(0,d.$SG)(s.j,"chatParticipantAdditions");const f=new v.$hO(r,o),g=S.ChatResponseDetectedParticipantPart.from(f);return u(g),this},confirmation(r,o,f){t(this.confirmation),(0,d.$SG)(s.j,"chatParticipantAdditions");const g=new v.$iO(r,o,f),w=S.ChatResponseConfirmationPart.from(g);return u(w),this},push(r){if(t(this.push),(r instanceof v.$pO||r instanceof v.$gO||r instanceof v.$hO||r instanceof v.$mO||r instanceof v.$iO)&&(0,d.$SG)(s.j,"chatParticipantAdditions"),r instanceof v.$oO)this.reference(r.value,r.iconPath);else{const o=S.ChatResponsePart.from(r,s.m,s.n);u(o)}return this}}}return this.g}}class n extends b.$Uc{static{this.b=0}constructor(s,t,u){super(),this.n=t,this.s=u,this.c=new Map,this.j=this.B(new b.$4c),this.m=this.B(new b.$4c),this.g=s.getProxy(p.$gM.MainThreadChatAgents2)}transferActiveChat(s){this.g.$transferActiveChatSession(s)}createChatAgent(s,t,u){const r=n.b++,o=new i(s,t,this.g,r,u);return this.c.set(r,o),this.g.$registerAgent(r,s.identifier,t,{},void 0),o.apiAgent}createDynamicChatAgent(s,t,u,r,o,f){const g=n.b++,w=new i(s,t,this.g,g,f);return this.c.set(g,w),this.g.$registerAgent(g,s.identifier,t,{isSticky:!0},{name:u,description:o,publisherDisplayName:r}),w.apiAgent}async $invokeAgent(s,t,u,r){const o=this.c.get(s);if(!o)throw new Error(`[CHAT](${s}) CANNOT invoke agent because the agent is not registered`);let f=this.j.get(t.sessionId);f||(f=new b.$Tc,this.j.set(t.sessionId,f));const g=new c(o.extension,t,this.g,this.s.converter,f);try{const w=await this.t(t.agentId,u),k=o.invoke(S.ChatAgentRequest.to(t),{history:w},g.apiObject,r);return await(0,L.$mh)(Promise.resolve(k).then(m=>{if(m?.metadata)try{JSON.stringify(m.metadata)}catch(y){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.n.error(`[${o.extension.identifier.value}] [@${o.id}] ${D}`,o.extension),{errorDetails:{message:D},timings:g.timings}}return{errorDetails:m?.errorDetails,timings:g.timings,metadata:m?.metadata}}),r)}catch(w){return this.n.error(w,o.extension),{errorDetails:{message:(0,O.$jj)(w),responseIsIncomplete:!0}}}finally{g.close()}}async t(s,t){const u=[];for(const r of t.history){const o=S.ChatAgentResult.to(r.result),f=s===r.request.agentId?o:{...o,metadata:void 0};u.push(new v.$qO(r.request.message,r.request.command,r.request.variables.variables.map(S.ChatAgentValueReference.to),r.request.agentId));const g=(0,l.$Hb)(r.response.map(w=>S.ChatResponsePart.toContent(w,this.s.converter)));u.push(new v.$rO(g,f,r.request.agentId,r.request.command))}return u}$releaseSession(s){this.j.deleteAndDispose(s)}async $provideFollowups(s,t,u,r,o){const f=this.c.get(t);if(!f)return Promise.resolve([]);const g=await this.t(f.id,r),w=S.ChatAgentResult.to(u);return(await f.provideFollowups(w,{history:g},o)).filter(k=>{const m=!k.participant||R.Iterable.some(this.c.values(),y=>y.id===k.participant&&I.$Tm.equals(y.extension.identifier,f.extension.identifier));return m||this.n.warn(`[@${f.id}] ChatFollowup refers to an unknown participant: ${k.participant}`),m}).map(k=>S.ChatFollowup.from(k,s))}$acceptFeedback(s,t,u,r){const o=this.c.get(s);if(!o)return;const f=S.ChatAgentResult.to(t);let g;switch(u){case h.InteractiveSessionVoteDirection.Down:g=v.ChatResultFeedbackKind.Unhelpful;break;case h.InteractiveSessionVoteDirection.Up:g=v.ChatResultFeedbackKind.Helpful;break}o.acceptFeedback(Object.freeze(r?{result:f,kind:g,reportIssue:r}:{result:f,kind:g}))}$acceptAction(s,t,u){const r=this.c.get(s);if(!r||u.action.kind==="vote")return;const o=S.ChatAgentUserActionEvent.to(t,u,this.s.converter);o&&r.acceptAction(Object.freeze(o))}async $invokeCompletionProvider(s,t,u){const r=this.c.get(s);if(!r)return[];let o=this.m.get(s);return o?o.clear():(o=new b.$Tc,this.m.set(s,o)),(await r.invokeCompletionProvider(t,u)).map(g=>S.ChatAgentCompletionItem.from(g,this.s.converter,o))}async $provideWelcomeMessage(s,t,u){const r=this.c.get(s);if(r)return await r.provideWelcomeMessage(S.ChatLocation.to(t),u)}async $provideSampleQuestions(s,t,u){const r=this.c.get(s);if(r)return(await r.provideSampleQuestions(S.ChatLocation.to(t),u)).map(o=>S.ChatFollowup.from(o,void 0))}}e.$2lc=n;class i{constructor(s,t,u,r,o){this.extension=s,this.id=t,this.u=u,this.w=r,this.x=o,this.n=new M.$fe,this.o=new M.$fe}acceptFeedback(s){this.n.fire(s)}acceptAction(s){this.o.fire(s)}async invokeCompletionProvider(s,t){return this.q?await this.q.provider.provideCompletionItems(s,t)??[]:[]}async provideFollowups(s,t,u){if(!this.b)return[];const r=await this.b.provideFollowups(s,t,u);return r?r.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(s,t){if(!this.s)return[];const u=await this.s.provideWelcomeMessage(s,t);return u?u.map(r=>typeof r=="string"?r:S.MarkdownString.from(r)):[]}async provideSampleQuestions(s,t){if(!this.s||!this.s.provideSampleQuestions)return[];const u=await this.s.provideSampleQuestions(s,t);return u||[]}get apiAgent(){let s=!1,t=!1;const u=()=>{s||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof v.$fN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:S.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:S.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:S.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,d.$SG)(r.extension,"defaultChatParticipant"),r.c??r.extension.displayName??r.extension.name},set fullName(o){(0,d.$SG)(r.extension,"defaultChatParticipant"),r.c=o,u()},get iconPath(){return r.d},set iconPath(o){r.d=o,u()},get requestHandler(){return r.x},set requestHandler(o){(0,E.$ig)(typeof o=="function","Invalid request handler"),r.x=o},get followupProvider(){return r.b},set followupProvider(o){r.b=o,u()},get isDefault(){return(0,d.$SG)(r.extension,"defaultChatParticipant"),r.g},set isDefault(o){(0,d.$SG)(r.extension,"defaultChatParticipant"),r.g=o,u()},get helpTextPrefix(){return(0,d.$SG)(r.extension,"defaultChatParticipant"),r.j},set helpTextPrefix(o){(0,d.$SG)(r.extension,"defaultChatParticipant"),r.j=o,u()},get helpTextVariablesPrefix(){return(0,d.$SG)(r.extension,"defaultChatParticipant"),r.k},set helpTextVariablesPrefix(o){(0,d.$SG)(r.extension,"defaultChatParticipant"),r.k=o,u()},get helpTextPostfix(){return(0,d.$SG)(r.extension,"defaultChatParticipant"),r.l},set helpTextPostfix(o){(0,d.$SG)(r.extension,"defaultChatParticipant"),r.l=o,u()},get isSecondary(){return(0,d.$SG)(r.extension,"defaultChatParticipant"),r.m},set isSecondary(o){(0,d.$SG)(r.extension,"defaultChatParticipant"),r.m=o,u()},get supportIssueReporting(){return(0,d.$SG)(r.extension,"chatParticipantAdditions"),r.p},set supportIssueReporting(o){(0,d.$SG)(r.extension,"chatParticipantAdditions"),r.p=o,u()},get onDidReceiveFeedback(){return r.n.event},set participantVariableProvider(o){if((0,d.$SG)(r.extension,"chatParticipantAdditions"),r.q=o,o){if(!o.triggerCharacters.length)throw new Error("triggerCharacters are required");r.u.$registerAgentCompletionsProvider(r.w,o.triggerCharacters)}else r.u.$unregisterAgentCompletionsProvider(r.w)},get participantVariableProvider(){return(0,d.$SG)(r.extension,"chatParticipantAdditions"),r.q},set welcomeMessageProvider(o){(0,d.$SG)(r.extension,"defaultChatParticipant"),r.s=o,u()},get welcomeMessageProvider(){return(0,d.$SG)(r.extension,"defaultChatParticipant"),r.s},onDidPerformAction:(0,d.$RG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(o){r.t=o,u()},get requester(){return r.t},dispose(){s=!0,r.b=void 0,r.n.dispose(),r.u.$unregisterAgent(r.w)}}}invoke(s,t,u,r){return this.x(s,t,u,r)}}}),define(ke[336],De([1,0,13,3,6,17,8,26]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class ${static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(O.$gM.MainThreadChatVariables)}async $resolveVariable(I,p,S,v){const h=this.b.get(I);if(h)try{if(h.resolver.resolve2){(0,b.$SG)(h.extension,"chatParticipantAdditions");const d=new E(p,this.c),c=await h.resolver.resolve2(h.data.name,{prompt:S},d.apiObject,v);if(c&&c[0])return c[0].value}else{const d=await h.resolver.resolve(h.data.name,{prompt:S},v);if(d&&d[0])return d[0].value}}catch(d){(0,l.$2)(d)}}registerVariableResolver(I,p,S,v){const h=$.a++;return this.b.set(h,{extension:I,data:{name:p,description:S},resolver:v}),this.c.$registerVariable(h,{name:p,description:S}),(0,L.$Sc)(()=>{this.b.delete(h),this.c.$unregisterVariable(h)})}}e.$3lc=$;class E{constructor(I,p){this.c=I,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(v){if(I.a){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,v),h}};const I=this,S=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){p(this.progress);const h=new R.$lO(v),d=M.ChatResponseProgressPart.from(h);return S(d),this},reference(v){p(this.reference);const h=new R.$oO(v),d=M.ChatResponseReferencePart.from(h);return S(d),this},push(v){return p(this.push),v instanceof R.$oO?S(M.ChatResponseReferencePart.from(v)):v instanceof R.$lO&&S(M.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[337],De([1,0,7,56,4,3,2,84,25,17,8,6,26]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=S;function S(v,h,d){const c=v.getProxy(I.$gM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Vm,h.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const k=this.b.get(w.handle);return k?k.value:w}else if(w&&w.$mid===7){const k=w,m=this.b.get(k.commentControlHandle);if(!m)return k;const y=m.getCommentThread(k.commentThreadHandle);return y?y.value:k}else if(w&&(w.$mid===9||w.$mid===8)){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const m=k.getCommentThread(w.thread.commentThreadHandle);return m?w.$mid===8?m.value:{thread:m.value,text:w.text}:w}else if(w&&w.$mid===10){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const m=k.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const y=w.commentUniqueId,D=m.getCommentByUniqueId(y);return D||w}else if(w&&w.$mid===11){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const m=k.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const y=w.text,D=w.commentUniqueId,C=m.getCommentByUniqueId(D);return C?(typeof C.body=="string"?C.body=y:C.body=new A.$KM(y),C):w}return w}})}createCommentController(w,k,m){const y=n.a++,D=new a(w,y,k,m);this.b.set(D.handle,D);const C=this.c.get(w.identifier)||[];return C.push(D),this.c.set(w.identifier,C),D.value}async $createCommentThreadTemplate(w,k,m,y){const D=this.b.get(w);D&&D.$createCommentThreadTemplate(k,m,y)}async $setActiveComment(w,k){const m=this.b.get(w);m&&m.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(w,k,m){const y=this.b.get(w);y&&y.$updateCommentThreadTemplate(k,m)}$deleteCommentThread(w,k){this.b.get(w)?.$deleteCommentThread(k)}async $provideCommentingRanges(w,k,m){const y=this.b.get(w);if(!y||!y.commentingRangeProvider)return Promise.resolve(void 0);const D=await d.ensureDocumentData(R.URI.revive(k));return(0,l.$qh)(async()=>{const C=await y.commentingRangeProvider.provideCommentingRanges(D.document,m);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(j=>E.Range.from(j)),fileComments:C.fileComments}),P})}$toggleReaction(w,k,m,y,D){const C=this.b.get(w);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,l.$qh)(()=>{const P=C.getCommentThread(k);if(P){const j=P.getCommentByUniqueId(y.uniqueIdInThread);if(C!==void 0&&j&&C.reactionHandler)return C.reactionHandler(j,u(D))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,p.$SG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,k,m,y,D,C,P,j,T){this.m=k,this.n=m,this.o=y,this.p=D,this.q=C,this.extensionDescription=P,this.r=j,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new O.$fe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Vc,this.l.value=new M.$Tc,this.n===void 0&&(this.n=`${w}.${this.handle}`),c.$createCommentThread(k,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r,T),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{c.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(N){z.range=N},get comments(){return z.comments},set comments(N){z.comments=N},get collapsibleState(){return z.collapsibleState},set collapsibleState(N){z.collapsibleState=N},get canReply(){return z.canReply},set canReply(N){z.canReply=N},get contextValue(){return z.contextValue},set contextValue(N){z.contextValue=N},get label(){return z.label},set label(N){z.label=N},get state(){return z.state},set state(N){z.state=N},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Tc);const w=m=>Object.prototype.hasOwnProperty.call(this.b,m),k={};w("range")&&(k.range=E.Range.from(this.p)),w("label")&&(k.label=this.label),w("contextValue")&&(k.contextValue=this.contextValue??null),w("comments")&&(k.comments=this.q.map(m=>s(this,m,this.k,this.extensionDescription))),w("collapsibleState")&&(k.collapseState=r(this.g)),w("canReply")&&(k.canReply=this.canReply),w("state")&&(k.state=o(this.h)),w("applicability")&&(k.applicability=f(this.h)),w("isTemplate")&&(k.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(w){for(const k of this.k){const m=k[0],y=k[1];if(w===y)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Je([(0,L.$4h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,p.$SG)(this.h,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$SG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$SG)(this.h,"activeComment"),this.f}constructor(w,k,m,y){this.h=w,this.i=k,this.j=m,this.k=y,this.a=new Map,c.$registerCommentController(this.handle,m,y,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(C){D.options=C},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(C){D.commentingRangeProvider=C},get reactionHandler(){return D.reactionHandler},set reactionHandler(C){D.reactionHandler=C},get activeCommentThread(){return D.activeCommentThread},createCommentThread(C,P,j){return D.createCommentThread(C,P,j).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(w,k,m){k===void 0&&(0,p.$SG)(this.h,"fileComments");const y=new i(this.id,this.handle,void 0,w,k,m,this.h,!1);return this.a.set(y.handle,y),y}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const k=this.a.get(w.commentThreadHandle);k&&(this.e=w.uniqueIdInThread?k.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(w,k,m){const y=new i(this.id,this.handle,void 0,R.URI.revive(w),E.Range.to(k),[],this.h,!0,m);return y.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(y.handle,y),y}$updateCommentThreadTemplate(w,k){const m=this.a.get(w);m&&(m.range=E.Range.to(k))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function s(g,w,k,m){let y=k.get(w);return y||(y=++g.commentHandle,k.set(w,y)),w.state!==void 0&&(0,p.$SG)(m,"commentsDraftState"),w.reactions?.some(D=>D.reactors!==void 0)&&(0,p.$SG)(m,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:y,body:typeof w.body=="string"?w.body:E.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(D=>t(D)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function t(g){return{label:g.label,iconPath:g.iconPath?E.$IO(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted,reactors:g.reactors&&g.reactors.length>0&&typeof g.reactors[0]!="string"?g.reactors.map(w=>w.name):g.reactors}}function u(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?R.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1,reactors:g.reactors?.map(w=>({name:w}))}}function r(g){if(g!==void 0)switch(g){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function o(g){let w;if(typeof g=="object"?w=g.resolved:w=g,w!==void 0)switch(w){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function f(g){let w;if(typeof g=="object"&&(w=g.applicability),w!==void 0)switch(w){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[338],De([1,0,22,57,3,15,23,2,17,92,112,6,8]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class S{constructor(u,r){this.document=u,this.b=r,this.a=1,this.c=new A.$Mlc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,r){await this.f(u).undo(),r||this.disposeBackup()}async redo(u,r){await this.f(u).redo(),r||this.disposeBackup()}disposeEdits(u){for(const r of u)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=s(this.document.uri)+this.a++;return(0,R.$_g)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const r=this.c.get(u,0);if(!r)throw new Error("No edit found");return r}}class v{constructor(){this.a=new Map}get(u,r){return this.a.get(this.b(u,r))}add(u,r,o){const f=this.b(u,r.uri);if(this.a.has(f))throw new Error(`Document already exists for viewType:${u} resource:${r.uri}`);const g=new S(r,o);return this.a.set(f,g),g}delete(u,r){const o=this.b(u,r.uri);this.a.delete(o)}b(u,r){return`${u}@@@${r}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class d{constructor(){this.a=new Map}addTextProvider(u,r,o){return this.b(u,{type:0,extension:r,provider:o})}addCustomProvider(u,r,o){return this.b(u,{type:1,extension:r,provider:o})}get(u){return this.a.get(u)}b(u,r){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,r),new p.$iM(()=>this.a.delete(u))}}class c{constructor(u,r,o,f,g){this.d=r,this.f=o,this.g=f,this.h=g,this.b=new d,this.c=new v,this.a=u.getProxy(I.$gM.MainThreadCustomEditors)}registerCustomEditorProvider(u,r,o,f){const g=new O.$Tc;return i(o)?(g.add(this.b.addTextProvider(r,u,o)),this.a.$registerTextEditorProvider((0,E.$jmc)(u),r,f.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,E.$hmc)(u))):(g.add(this.b.addCustomProvider(r,u,o)),n(o)&&g.add(o.onDidChangeCustomDocument(w=>{const k=this.i(r,w.document.uri);if(a(w)){const m=k.addEdit(w);this.a.$onDidEdit(w.document.uri,r,m,w.label)}else this.a.$onContentChange(w.document.uri,r)})),this.a.$registerCustomEditorProvider((0,E.$jmc)(u),r,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,E.$hmc)(u))),p.$iM.from(g,new p.$iM(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(u,r,o,f,g){const w=this.b.get(r);if(!w)throw new Error(`No provider found for '${r}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${r}'`);const k=b.URI.revive(u),m=await w.provider.openCustomDocument(k,{backupId:o,untitledDocumentData:f?.buffer},g);let y;return n(w.provider)&&this.f&&(y=this.f.workspaceValue(w.extension)??this.f.globalValue(w.extension)),this.c.add(r,m,y),{editable:n(w.provider)}}async $disposeCustomDocument(u,r){const o=this.b.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const f=b.URI.revive(u),{document:g}=this.i(r,f);this.c.delete(r,g),g.dispose()}async $resolveCustomEditor(u,r,o,f,g,w){const k=this.b.get(o);if(!k)throw new Error(`No provider found for '${o}'`);const m=$.ViewColumn.to(g),y=this.g.createNewWebview(r,f.contentOptions,k.extension),D=this.h.createNewWebviewPanel(r,o,f.title,m,f.options,y,f.active),C=b.URI.revive(u);switch(k.type){case 1:{const{document:P}=this.i(o,C);return k.provider.resolveCustomEditor(P,D,w)}case 0:{const P=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(P,D,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,r,o){this.i(r,u).disposeEdits(o)}async $onMoveCustomEditor(u,r,o){const f=this.b.get(o);if(!f)throw new Error(`No provider found for '${o}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const g=this.h.getWebviewPanel(u);if(!g)throw new Error("No webview found");const w=b.URI.revive(r),k=this.d.getDocument(w);await f.provider.moveCustomTextEditor(k,g,l.CancellationToken.None)}async $undo(u,r,o,f){return this.i(r,u).undo(o,f)}async $redo(u,r,o,f){return this.i(r,u).redo(o,f)}async $revert(u,r,o){const f=this.i(r,u);await this.j(r).revertCustomDocument(f.document,o),f.disposeBackup()}async $onSave(u,r,o){const f=this.i(r,u);await this.j(r).saveCustomDocument(f.document,o),f.disposeBackup()}async $onSaveAs(u,r,o,f){const g=this.i(r,u);return this.j(r).saveCustomDocumentAs(g.document,b.URI.revive(o),f)}async $backup(u,r,o){const f=this.i(r,u),w=await this.j(r).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},o);return f.updateBackup(w),w.id}i(u,r){const o=this.c.get(u,b.URI.revive(r));if(!o)throw new Error("No custom document found");return o}j(u){const o=this.b.get(u)?.provider;if(!o||!n(o))throw new Error("Custom document is not editable");return o}}e.$mmc=c;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const u=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,L.$mj)(u)+""}}),define(ke[339],De([1,0,224,139,2,6,8,17,4,11,27,60]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0;class S{#e;#t;#n;constructor(d,c,n,i,a,s,t,u){this.d=d,this.e=c,this.f=n,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,n),this.#n=new A.$Ac(r=>s.getComparisonKey(r)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(d,c){if(!d){this.clear();return}this.j();let n=[];if(O.URI.isUri(d)){if(!c){this.delete(d);return}this.#n.set(d,c.slice()),n=[d]}else if(Array.isArray(d)){n=[];let s;d=[...d].sort(S.k);for(const t of d){const[u,r]=t;if((!s||u.toString()!==s.toString())&&(s&&this.#n.get(s).length===0&&this.#n.delete(s),s=u,n.push(u),this.#n.set(u,[])),r)this.#n.get(u)?.push(...r);else{const o=this.#n.get(u);o&&(o.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let a=0;for(const s of n){let t=[];const u=this.#n.get(s);if(u)if(u.length>this.g){t=[];const r=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const f of u)if(f.severity===r[o]&&t.push({...b.Diagnostic.from(f),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,l.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(r=>({...b.Diagnostic.from(r),modelVersionId:this.h(s)}));if(i.push([s,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(d){this.j(),this.#t.fire([d]),this.#n.delete(d),this.#e?.$changeMany(this.e,[[d,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(d,c){this.j();for(const[n,i]of this)d.call(c,n,i,this)}*[Symbol.iterator](){this.j();for(const d of this.#n.keys())yield[d,this.get(d)]}get(d){this.j();const c=this.#n.get(d);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(d){return this.j(),Array.isArray(this.#n.get(d))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(d,c){return d[0].toString()<c[0].toString()?-1:d[0].toString()>c[0].toString()?1:0}}e.$Tlc=S;let v=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(d){const c=new A.$Ac;for(const n of d)c.set(n,n);return{uris:Object.freeze(Array.from(c.values()))}}constructor(d,c,n,i){this.j=c,this.k=n,this.l=i,this.g=new Map,this.h=new $.$je({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=d.getProxy(M.$gM.MainThreadDiagnostics)}createDiagnosticCollection(d,c){const{g:n,f:i,h:a,j:s,k:t,l:u}=this,r=new class{$changeMany(g,w){i.$changeMany(g,w),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,g,w.length===0?"CLEARING":w)}$clear(g){i.$clear(g),s.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,g)}dispose(){i.dispose()}};let o;if(!c)c="_generated_diagnostic_collection_name_#"+p.c++,o=c;else if(!n.has(c))o=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do o=c+p.c++;while(n.has(o))}return new class extends S{constructor(){super(c,o,p.e,p.d,g=>u.getDocument(g)?.version,t.extUri,r,a),n.set(o,this)}dispose(){super.dispose(),n.delete(o)}}}getDiagnostics(d){if(d)return this.m(d);{const c=new Map,n=[];for(const i of this.g.values())i.forEach((a,s)=>{let t=c.get(a.toString());typeof t>"u"&&(t=n.length,c.set(a.toString(),t),n.push([a,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(d){let c=[];for(const n of this.g.values())n.has(d)&&(c=c.concat(n.get(d)));return c}$acceptMarkersChange(d){if(!this.n){const c="_generated_mirror",n=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,n),this.n=n}for(const[c,n]of d)this.n.set(O.URI.revive(c),n.map(b.Diagnostic.to))}};e.$Ulc=v,e.$Ulc=v=p=Je([We(1,E.$5j),We(2,I.$Slc)],v)}),define(ke[340],De([1,0,2,13,8,17,76,48]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;class ${constructor(A,I,p,S={timeout:1500,errors:3}){this.c=A,this.d=I,this.f=p,this.g=S,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(I,p,S)=>{const h={dispose:this.a.push([I,p,A])};return Array.isArray(S)&&S.push(h),h}}async $participateInSave(A,I){const p=l.URI.revive(A);let S=!1;const v=setTimeout(()=>S=!0,this.g.timeout),h=[];try{for(const d of[...this.a]){if(S)break;const c=this.d.getDocument(p),n=await this.h(d,{document:c,reason:M.TextDocumentSaveReason.to(I)});h.push(n)}}finally{clearTimeout(v)}return h}h([A,I,p],S){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(p,A,I,S).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const d=this.b.get(A);this.b.set(A,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,I,p,S){const v=[],h=Date.now(),{document:d,reason:c}=S,{version:n}=d,i=Object.freeze({document:d,reason:c,waitUntil(a){if(Object.isFrozen(v))throw(0,L.$8)("waitUntil can not be called async");v.push(Promise.resolve(a))}});try{I.apply(p,[i])}catch(a){return Promise.reject(a)}return Object.freeze(v),new Promise((a,s)=>{const t=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(t),a(u)}).catch(u=>{clearTimeout(t),s(u)})}).then(a=>{const s={edits:[]};for(const t of a)if(Array.isArray(t)&&t.every(u=>u instanceof O.$pM))for(const{newText:u,newEol:r,range:o}of t)s.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:o&&M.Range.from(o),text:u,eol:r&&M.EndOfLine.from(r)}});if(s.edits.length!==0)return n===d.version?this.f.$tryApplyWorkspaceEdit(new b.$Ew(s)):Promise.reject(new Error("concurrent_edits"))})}}e.$3mc=$}),define(ke[341],De([1,0,4,3,2,6,153,17,18,24,8]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class I{constructor(S,v){this.a=new l.$fe,this.b=new l.$fe,this.c=new l.$fe,this.d=new l.$fe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Tc,this.h=new Map,this.f=S.getProxy(M.$gM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(h=>{for(const d of h)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const d of h)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const v=this.g.getDocument(S);if(v)return v}getDocument(S){const v=this.getDocumentData(S);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return v.document}ensureDocumentData(S){const v=this.g.getDocument(S);if(v)return Promise.resolve(v);let h=this.h.get(S.toString());return h||(h=this.f.$tryOpenDocument(S).then(d=>{this.h.delete(S.toString());const c=O.URI.revive(d);return(0,$.$jg)(this.g.getDocument(c))},d=>(this.h.delete(S.toString()),Promise.reject(d))),this.h.set(S.toString(),h)),h}createDocumentData(S){return this.f.$tryCreateDocument(S).then(v=>O.URI.revive(v))}$acceptModelLanguageChanged(S,v){const h=O.URI.revive(S),d=this.g.getDocument(h);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(v),this.a.fire(d.document)}$acceptModelSaved(S){const v=O.URI.revive(S),h=this.g.getDocument(v);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(S,v){const h=O.URI.revive(S),d=this.g.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(v),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,v,h){const d=O.URI.revive(S),c=this.g.getDocument(d);if(!c)throw new Error("unknown document");c._acceptIsDirty(h),c.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,E.$6n)({document:c.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(S,v){(0,R.$LO)(S,v)}}e.$Vlc=I}),define(ke[72],De([1,0,74,4,18,2,5,6,20,17,8]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=e.$nmc=void 0,e.$nmc=(0,R.$yi)("IExtHostEditorTabs");class I{constructor(d,c,n){this.e=n,this.d=c,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,c={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$6N(M.URI.revive(this.b.input.uri));case 2:return new A.$7N(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$8N(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$9N(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$0N(this.b.input.viewType);case 4:return new A.$$N(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$_N(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$aO;case 9:return new A.$bO(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$cO;case 11:return new A.$dO(this.b.input.diffEditors.map(d=>new A.$7N(M.URI.revive(d.original),M.URI.revive(d.modified))));default:return}}}class p{constructor(d,c){this.c=[],this.d="",this.b=d,this.e=c;for(const n of d.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,c={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return E.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(n=>n.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(n=>n.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const n=new I(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,n),d.tabDto.isActive&&(this.d=n.tabId),n}else if(d.kind===1){const n=this.c.splice(d.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(d.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,n),n}const c=this.c.find(n=>n.tabId===d.tabDto.id);if(!c)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(d.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(d){this.b=new L.$fe,this.c=new L.$fe,this.e=[],this.a=d.getProxy(b.$gM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,c={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(n=>n.apiObject))},get activeTabGroup(){const n=d.d;return(0,O.$jg)(d.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,i)=>{const a=Array.isArray(n)?n:[n];return a.length?v(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(d){const c=new Set(this.e.map(r=>r.groupId)),n=new Set(d.map(r=>r.groupId)),i=(0,l.$L)(c,n),a=this.e.filter(r=>i.removed.includes(r.groupId)).map(r=>r.apiObject),s=[],t=[];this.e=d.map(r=>{const o=new p(r,()=>this.d);return i.added.includes(o.groupId)?s.push(o.apiObject):t.push(o.apiObject),o});const u=(0,O.$jg)(d.find(r=>r.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:s,closed:a,changed:t}))}$acceptTabGroupUpdate(d){const c=this.e.find(n=>n.groupId===d.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const c=this.e.find(i=>i.groupId===d.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const n=c.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(d){for(const c of this.e)for(const n of c.tabs)if(n.apiObject===d)return n}h(d){return this.e.find(c=>c.apiObject===d)}async i(d,c){const n=[];for(const i of d){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,c)}async j(d,c){const n=[];for(const i of d){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,c)}};e.$omc=S,e.$omc=S=Je([We(0,$.$JO)],S);function v(h){return h.tabs!==void 0}}),define(ke[342],De([1,0,2,6,3,8,17,185,14,21,26,81]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class p{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const d=this.a.indexOf(h);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),d=[];let c,n,i=14,a=14;for(const s of h){let t=c?(0,$.$Bf)(c,s):0;for(t===0?n=1:n=a;t<s.length;t++)t+1===s.length?(i=a,a=9):a+=1,d.push([n,s.toUpperCase().charCodeAt(t),a]),d.push([n,s.toLowerCase().charCodeAt(t),a]),n=a;c=s,a=i}d.push([9,58,10]),d.push([10,47,12]),this.b=new b.$G2(d)}}provideDocumentLinks(h){this.c();const d=[],c=b.$H2.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of c){const i=R.DocumentLink.to(n);i.target&&d.push(i)}return d}}class S{constructor(h,d){this.i=d,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(L.$gM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,d,c,n={}){if(S.j(c),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const i=this.h++;this.b.add(d),this.d.add(d),this.c.set(i,c);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof c.copy=="function"&&(a+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,A.$SG)(h,"fsChunks"),a+=4);let s;n.isReadonly&&(0,I.$Xk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,d,a,s).catch(u=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${d}`),console.error(u)});const t=c.onDidChangeFile(u=>{const r=[];for(const o of u){const{uri:f,type:g}=o;if(f.scheme!==d)continue;let w;switch(g){case M.FileChangeType.Changed:w=0;break;case M.FileChangeType.Created:w=1;break;case M.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:f,type:w})}this.a.$onFileSystemChange(i,r)});return(0,O.$Sc)(()=>{t.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:d,ctime:c,mtime:n,size:i,permissions:a}=h;return{type:d,ctime:c,mtime:n,size:i,permissions:a}}$stat(h,d){return Promise.resolve(this.l(h).stat(l.URI.revive(d))).then(c=>S.k(c))}$readdir(h,d){return Promise.resolve(this.l(h).readDirectory(l.URI.revive(d)))}$readFile(h,d){return Promise.resolve(this.l(h).readFile(l.URI.revive(d))).then(c=>E.$He.wrap(c))}$writeFile(h,d,c,n){return Promise.resolve(this.l(h).writeFile(l.URI.revive(d),c.buffer,n))}$delete(h,d,c){return Promise.resolve(this.l(h).delete(l.URI.revive(d),c))}$rename(h,d,c,n){return Promise.resolve(this.l(h).rename(l.URI.revive(d),l.URI.revive(c),n))}$copy(h,d,c,n){const i=this.l(h);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(l.URI.revive(d),l.URI.revive(c),n))}$mkdir(h,d){return Promise.resolve(this.l(h).createDirectory(l.URI.revive(d)))}$watch(h,d,c,n){const i=this.l(h).watch(l.URI.revive(c),n);this.f.set(d,i)}$unwatch(h,d){const c=this.f.get(d);c&&(c.dispose(),this.f.delete(d))}$open(h,d,c){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(l.URI.revive(d),c))}$close(h,d){const c=this.l(h);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(d))}$read(h,d,c,n){const i=this.l(h);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$He.alloc(n);return Promise.resolve(i.read(d,c,a.buffer,0,n)).then(s=>a.slice(0,s))}$write(h,d,c,n){const i=this.l(h);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(d,c,n.buffer,0,n.byteLength))}l(h){const d=this.c.get(h);if(!d){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return d}}e.$6mc=S}),define(ke[343],De([1,0,4,35,2,6,17,8,46]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,v,h,d,c,n){this.a=Math.random(),this.b=new l.$fe,this.c=new l.$fe,this.d=new l.$fe,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,L.$sk)(c),a=typeof c=="string",s=n?.correlate,t=d(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(s&&typeof u.session>"u")){if(!n?.ignoreCreateEvents)for(const r of u.created){const o=O.URI.revive(r);i(o.fsPath)&&(!a||v.getWorkspaceFolder(o))&&this.b.fire(o)}if(!n?.ignoreChangeEvents)for(const r of u.changed){const o=O.URI.revive(r);i(o.fsPath)&&(!a||v.getWorkspaceFolder(o))&&this.c.fire(o)}if(!n?.ignoreDeleteEvents)for(const r of u.deleted){const o=O.URI.revive(r);i(o.fsPath)&&(!a||v.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=b.$iM.from(this.i(S,h,c,n,n?.correlate),this.b,this.c,this.d,t)}i(S,v,h,d,c){const n=b.$iM.from();if(typeof h=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return n;const i=S.getProxy(M.$gM.MainThreadFileSystemEventService);let a=!1;(h.pattern.includes(L.$ok)||h.pattern.includes(L.$pk))&&(a=!0);let s;return c&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(s=14,d?.ignoreChangeEvents&&(s&=-3),d?.ignoreCreateEvents&&(s&=-5),d?.ignoreDeleteEvents&&(s&=-9)),i.$watch(v.identifier.value,this.a,h.baseUri,{recursive:a,excludes:d?.excludes??[],filter:s},!!c),b.$iM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(S){this.a=S,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(O.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(O.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(O.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(S,v,h){this.j=S,this.k=v,this.l=h,this.a=new l.$fe,this.b=new l.$fe,this.c=new l.$fe,this.d=new l.$fe,this.g=new l.$he,this.h=new l.$he,this.i=new l.$he,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,v,h,d){return new E(this.j,S,v,this.a.event,R.GlobPattern.from(h),d)}$onFileEvent(S){this.a.fire(new A(S))}$onDidRunFileOperation(S,v){switch(S){case 2:this.b.fire(Object.freeze({files:v.map(h=>({oldUri:O.URI.revive(h.source),newUri:O.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(h=>O.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(h=>O.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,v){return(h,d,c)=>{const n=function(a){h.call(d,a)};return n.extension=S,v.event(n,void 0,c)}}async $onWillRunFileOperation(S,v,h,d){switch(S){case 2:return await this.n(this.g,{files:v.map(c=>({oldUri:O.URI.revive(c.source),newUri:O.URI.revive(c.target)}))},h,d);case 1:return await this.n(this.i,{files:v.map(c=>O.URI.revive(c.target))},h,d);case 0:case 3:return await this.n(this.h,{files:v.map(c=>O.URI.revive(c.target))},h,d)}}async n(S,v,h,d){const c=new Set,n=[];if(await S.fireAsync(v,d,async(a,s)=>{const t=Date.now(),u=await Promise.resolve(a);u instanceof b.$sM&&(n.push([s.extension,u]),c.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",s.extension.identifier)}),d.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,a]of n){const{edits:s}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(c)}}}e.$7mc=I}),define(ke[344],De([1,0,19,7,22,13,125,3,24,40,14,18,2,29,181,84,135,226,25,17,8,26,112,6]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class r{constructor(q,W){this.d=q,this.e=W}async provideDocumentSymbols(q,W){const X=this.d.getDocument(q),Q=await this.e.provideDocumentSymbols(X,W);if(!(0,l.$Kb)(Q))return Q[0]instanceof a.$CM?Q.map(i.DocumentSymbol.from):r.f(Q)}static f(q){q=q.slice(0).sort((Q,de)=>{let we=Q.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(Q.location.range.end)),we});const W=[],X=[];for(const Q of q){const de={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(X.length===0){X.push(de),W.push(de);break}const we=X[X.length-1];if(S.$xt.containsRange(we.range,de.range)&&!S.$xt.equalsRange(we.range,de.range)){we.children?.push(de),X.push(de);break}X.pop()}}return W}}class o{constructor(q,W,X,Q,de,we){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=de,this.l=we,this.d=new t.$Mlc("CodeLens"),this.e=new Map}async provideCodeLenses(q,W){const X=this.f.getDocument(q),Q=await this.h.provideCodeLenses(X,W);if(!Q||W.isCancellationRequested)return;const de=this.d.add(Q),we=new b.$Tc;this.e.set(de,we);const je={cacheId:de,lenses:[]};for(let qe=0;qe<Q.length;qe++)je.lenses.push({cacheId:[de,qe],range:i.Range.from(Q[qe].range),command:this.g.toInternal(Q[qe].command,we)});return je}async resolveCodeLens(q,W){const X=q.cacheId&&this.d.get(...q.cacheId);if(!X)return;let Q;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?Q=X:Q=await this.h.resolveCodeLens(X,W),Q||(Q=X),W.isCancellationRequested)return;const de=q.cacheId&&this.e.get(q.cacheId[0]);if(de){if(!Q.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return q.command=this.g.toInternal(Q.command,de),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function f(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class g{constructor(q,W){this.d=q,this.e=W}async provideDefinition(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideDefinition(Q,de,X);return f(we)}}class w{constructor(q,W){this.d=q,this.e=W}async provideDeclaration(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideDeclaration(Q,de,X);return f(we)}}class k{constructor(q,W){this.d=q,this.e=W}async provideImplementation(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideImplementation(Q,de,X);return f(we)}}class m{constructor(q,W){this.d=q,this.e=W}async provideTypeDefinition(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideTypeDefinition(Q,de,X);return f(we)}}class y{static{this.f=10}constructor(q,W){this.g=q,this.h=W,this.d=0,this.e=new Map}async provideHover(q,W,X,Q){const de=this.g.getDocument(q),we=i.Position.to(W);let je;if(X&&X.verbosityRequest){const _e=X.verbosityRequest.previousHover.id,nt=this.e.get(_e);if(!nt)throw new Error(`Hover with id ${_e} not found`);const it={action:X.verbosityRequest.action,previousHover:nt};je=await this.h.provideHover(de,we,Q,it)}else je=await this.h.provideHover(de,we,Q);if(!je||(0,l.$Kb)(je.contents))return;je.range||(je.range=de.getWordRangeAtPosition(we)),je.range||(je.range=new a.$kM(we,we));const qe=i.Hover.from(je),Ke=this.d;if(this.e.size===y.f){const _e=Math.min(...this.e.keys());this.e.delete(_e)}return this.e.set(Ke,je),this.d+=1,{...qe,id:Ke}}releaseHover(q){this.e.delete(q)}}class D{constructor(q,W){this.d=q,this.e=W}async provideEvaluatableExpression(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideEvaluatableExpression(Q,de,X);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(q,W){this.d=q,this.e=W}async provideInlineValues(q,W,X,Q){const de=this.d.getDocument(q),we=await this.e.provideInlineValues(de,i.Range.to(W),i.InlineValueContext.to(X),Q);if(Array.isArray(we))return we.map(je=>i.InlineValue.from(je))}}class P{constructor(q,W){this.d=q,this.e=W}async provideDocumentHighlights(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideDocumentHighlights(Q,de,X);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class j{constructor(q,W){this.d=q,this.e=W}async provideMultiDocumentHighlights(q,W,X,Q){const de=this.d.getDocument(q),we=X.map(Ke=>this.d.getDocument(Ke)),je=i.Position.to(W),qe=await this.e.provideMultiDocumentHighlights(de,je,we,Q);if(Array.isArray(qe))return qe.map(i.MultiDocumentHighlight.from)}}class T{constructor(q,W){this.d=q,this.e=W}async provideLinkedEditingRanges(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(Q,de,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,l.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(q,W){this.d=q,this.e=W}async provideReferences(q,W,X,Q){const de=this.d.getDocument(q),we=i.Position.to(W),je=await this.e.provideReferences(de,we,X,Q);if(Array.isArray(je))return je.map(i.location.from)}}class N{static{this.d=1e3}constructor(q,W,X,Q,de,we,je){this.g=q,this.h=W,this.j=X,this.k=Q,this.l=de,this.m=we,this.n=je,this.e=new t.$Mlc("CodeAction"),this.f=new Map}async provideCodeActions(q,W,X,Q){const de=this.g.getDocument(q),we=v.$zt.isISelection(W)?i.Selection.to(W):i.Range.to(W),je=[];for(const it of this.j.getDiagnostics(q))if(we.intersection(it.range)&&je.push(it)>N.d)break;const qe={diagnostics:je,only:X.only?new a.$EM(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Ke=await this.k.provideCodeActions(de,we,qe,Q);if(!(0,l.$Lb)(Ke)||Q.isCancellationRequested)return;const tt=this.e.add(Ke),_e=new b.$Tc;this.f.set(tt,_e);const nt=[];for(let it=0;it<Ke.length;it++){const rt=Ke[it];if(rt)if(N.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{qe.only&&(rt.kind?qe.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=rt.ranges??[];nt.push({cacheId:[tt,it],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,s.$RG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,s.$RG)(this.m,"codeActionRanges")?(0,l.$Hb)(ct.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:tt,actions:nt}}async resolveCodeAction(q,W){const[X,Q]=q,de=this.e.get(X,Q);if(!de||N.o(de))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(de,W)??de;let je;we.edit&&(je=i.WorkspaceEdit.from(we.edit,void 0));let qe;if(we.command){const Ke=this.f.get(X);Ke&&(qe=this.h.toInternal(we.command,Ke))}return{edit:je,command:qe}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class F{constructor(q,W,X,Q,de){this.e=q,this.f=W,this.g=X,this.h=Q,this.j=de,this.d=new t.$Mlc("DocumentPasteEdit")}async prepareDocumentPaste(q,W,X,Q){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(q),we=W.map(Ke=>i.Range.to(Ke)),je=i.DataTransfer.toDataTransfer(X,()=>{throw new M.$$});if(await this.g.prepareDocumentPaste(de,we,je,Q),Q.isCancellationRequested)return;const qe=Array.from(je).filter(([,Ke])=>!(Ke instanceof a.$$M));return i.DataTransfer.from(qe)}async providePasteEdits(q,W,X,Q,de,we){if(!this.g.provideDocumentPasteEdits)return[];const je=this.f.getDocument(W),qe=X.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolvePasteFileData(this.h,q,nt)).buffer),tt=await this.g.provideDocumentPasteEdits(je,qe,Ke,{only:de.only?new a.$dN(de.only):void 0,triggerKind:de.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const _e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,c.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,W){const[X,Q]=q,de=this.d.get(X,Q);if(!de||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class U{constructor(q,W){this.d=q,this.e=W}async provideDocumentFormattingEdits(q,W,X){const Q=this.d.getDocument(q),de=await this.e.provideDocumentFormattingEdits(Q,W,X);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class Y{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeFormattingEdits(q,W,X,Q){const de=this.d.getDocument(q),we=i.Range.to(W),je=await this.e.provideDocumentRangeFormattingEdits(de,we,X,Q);if(Array.isArray(je))return je.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,W,X,Q){(0,I.$ig)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(q),we=W.map(i.Range.to),je=await this.e.provideDocumentRangesFormattingEdits(de,we,X,Q);if(Array.isArray(je))return je.map(i.TextEdit.from)}}class ie{constructor(q,W){this.d=q,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,W,X,Q,de){const we=this.d.getDocument(q),je=i.Position.to(W),qe=await this.e.provideOnTypeFormattingEdits(we,je,X,Q,de);if(Array.isArray(qe))return qe.map(i.TextEdit.from)}}class H{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Mlc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,W){const X=await this.e.provideWorkspaceSymbols(q,W);if(!(0,l.$Lb)(X))return{symbols:[]};const Q=this.d.add(X),de={cacheId:Q,symbols:[]};for(let we=0;we<X.length;we++){const je=X[we];if(!je||!je.name){this.f.warn("INVALID SymbolInformation",je);continue}de.symbols.push({...i.WorkspaceSymbol.from(je),cacheId:[Q,we]})}return de}async resolveWorkspaceSymbol(q,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const X=this.d.get(...q.cacheId);if(X){const Q=await this.e.resolveWorkspaceSymbol(X,W);return Q&&(0,$.$8n)(q,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class J{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,W,X){this.d=q,this.e=W,this.f=X}async provideRenameEdits(q,W,X,Q){const de=this.d.getDocument(q),we=i.Position.to(W);try{const je=await this.e.provideRenameEdits(de,we,X,Q);return je?i.WorkspaceEdit.from(je):void 0}catch(je){const qe=J.g(je);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(je)}}async resolveRenameLocation(q,W,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(q),de=i.Position.to(W);try{const we=await this.e.prepareRename(Q,de,X);let je,qe;if(a.$kM.isRange(we)?(je=we,qe=Q.getText(we)):(0,I.$ag)(we)&&(je=we.range,qe=we.placeholder),!je||!qe)return;if(je.start.line>de.line||je.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(je),text:qe}}catch(we){const je=J.g(we);return je?{rejectReason:je,range:void 0,text:void 0}:Promise.reject(we)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class x{static{this.d={[h.NewSymbolNameTriggerKind.Invoke]:a.NewSymbolNameTriggerKind.Invoke,[h.NewSymbolNameTriggerKind.Automatic]:a.NewSymbolNameTriggerKind.Automatic}}constructor(q,W,X){this.e=q,this.f=W,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(q,W,X,Q){const de=this.e.getDocument(q),we=i.Range.to(W);try{const je=x.d[X],qe=await this.f.provideNewSymbolNames(de,we,je,Q);return qe?qe.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(je){this.g.error(x.h(je)??JSON.stringify(je,null,"	"));return}}static h(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ne{constructor(q,W){this.resultId=q,this.tokens=W}}class be{constructor(q,W){this.f=q,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,W,X){const Q=this.f.getDocument(q),de=W!==0?this.d.get(W):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,de.resultId,X):await this.g.provideDocumentSemanticTokens(Q,X);return de&&this.d.delete(W),we?(we=be.h(we),this.o(be.n(de,we),we)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return be.j(q)?be.k(q)?q:new a.$DN(new Uint32Array(q.data),q.resultId):be.l(q)?be.m(q)?q:new a.$FN(q.edits.map(W=>new a.$EN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const W of q.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(q,W){if(!be.j(W)||!q||!q.tokens)return W;const X=q.tokens,Q=X.length,de=W.data,we=de.length;let je=0;const qe=Math.min(Q,we);for(;je<qe&&X[je]===de[je];)je++;if(je===Q&&je===we)return new a.$FN([],W.resultId);let Ke=0;const tt=qe-je;for(;Ke<tt&&X[Q-Ke-1]===de[we-Ke-1];)Ke++;return new a.$FN([{start:je,deleteCount:Q-je-Ke,data:de.subarray(je,we-Ke)}],W.resultId)}o(q,W){if(be.j(q)){const X=this.e++;return this.d.set(X,new ne(q.resultId,q.data)),(0,d.$xbb)({id:X,type:"full",data:q.data})}if(be.l(q)){const X=this.e++;return be.j(W)?this.d.set(X,new ne(W.resultId,W.data)):this.d.set(X,new ne(q.resultId)),(0,d.$xbb)({id:X,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class ae{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeSemanticTokens(q,W,X){const Q=this.d.getDocument(q),de=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(W),X);return de?this.f(de):null}f(q){return(0,d.$xbb)({id:0,type:"full",data:q.data})}}class Ie{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,W,X,Q,de){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=de,this.d=new t.$Mlc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,W,X,Q){const de=this.f.getDocument(q),we=i.Position.to(W),je=de.getWordRangeAtPosition(we)||new a.$kM(we,we),qe=je.with({end:we}),Ke=new E.$be,tt=await this.h.provideCompletionItems(de,we,Q,i.CompletionContext.to(X));if(!tt||Q.isCancellationRequested)return;const _e=Array.isArray(tt)?new a.$RM(tt):tt,nt=Ie.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),it=new b.$Tc;this.e.set(nt,it);const rt=[],ct={x:nt,b:rt,a:{replace:i.Range.from(je),insert:i.Range.from(qe)},c:_e.isIncomplete||void 0,d:Ke.elapsed()};for(let Re=0;Re<_e.items.length;Re++){const Se=_e.items[Re],Ve=this.l(Se,[nt,Re],qe,je);rt.push(Ve)}return ct}async resolveCompletionItem(q,W){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...q);if(!X)return;const Q=this.l(X,q),de=await this.h.resolveCompletionItem(X,W);if(!de)return;const we=this.l(de,q);return(Q.h!==we.h||Q.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==we.n||Q.o!==we.o||!(0,$.$9n)(Q.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W,X,Q){const de=this.e.get(W[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(q.command,de),je={x:W,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),je.h=q.textEdit.newText):typeof q.insertText=="string"?je.h=q.insertText:q.insertText instanceof a.$tM&&(je.h=q.insertText.value,je.i|=4);let qe;return q.textEdit?qe=q.textEdit.range:q.range&&(qe=q.range),a.$kM.isRange(qe)?je.j=i.Range.from(qe):qe&&(!X?.isEqual(qe.inserting)||!Q?.isEqual(qe.replacing))&&(je.j={insert:i.Range.from(qe.inserting),replace:i.Range.from(qe.replacing)}),je}}class ee{async provideInlineCompletions(q,W,X,Q){}disposeCompletions(q){}handleDidShowCompletionItem(q,W,X){}handlePartialAccept(q,W,X,Q){}}class B extends ee{constructor(q,W,X,Q){super(),this.f=q,this.g=W,this.h=X,this.j=Q,this.d=new pe,this.e=(0,s.$RG)(this.f,"inlineCompletionsAdditions"),this.k={[h.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[h.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$RG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,W,X,Q){const de=this.g.getDocument(q),we=i.Position.to(W),je=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Q);if(!je||Q.isCancellationRequested)return;const qe=Array.isArray(je)?je:je.items,Ke=this.e?Array.isArray(je)?[]:je.commands||[]:[],tt=this.e&&!Array.isArray(je)?je.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:qe}),items:qe.map((it,rt)=>{let ct;it.command&&(_e||(_e=new b.$Tc),ct=this.j.toInternal(it.command,_e));const Re=it.insertText;return{insertText:typeof Re=="string"?Re:{snippet:Re.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:ct,idx:rt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Ke.map(it=>(_e||(_e=new b.$Tc),this.j.toInternal(it,_e))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,W,X){const Q=this.d.get(q)?.items[W];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,X)}handlePartialAccept(q,W,X,Q){const de=this.d.get(q)?.items[W];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,X),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(Q)))}}class _{async provideInlineEdits(q,W,X){const Q=this.f.getDocument(q),de=await this.g.provideInlineEdit(Q,{triggerKind:this.e[W.triggerKind]},X);if(!de||X.isCancellationRequested)return;let we;const je=this.d.createReferenceId({dispose(){we?.dispose()},item:de});let qe;de.accepted&&(we||(we=new b.$Tc),qe=this.h.toInternal(de.accepted,we));let Ke;return de.rejected&&(we||(we=new b.$Tc),Ke=this.h.toInternal(de.rejected,we)),{pid:je,text:de.text,range:i.Range.from(de.range),accepted:qe,rejected:Ke}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,W,X,Q){this.f=W,this.g=X,this.h=Q,this.d=new pe,this.e={[h.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[h.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const W=this.e++;return this.d.set(W,q),W}disposeReferenceId(q){const W=this.d.get(q);return this.d.delete(q),W}get(q){return this.d.get(q)}}class ue{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Mlc("SignatureHelp")}async provideSignatureHelp(q,W,X,Q){const de=this.e.getDocument(q),we=i.Position.to(W),je=this.g(X),qe=await this.f.provideSignatureHelp(de,we,Q,je);if(qe){const Ke=this.d.add([qe]);return{...i.SignatureHelp.from(qe),id:Ke}}}g(q){let W;if(q.activeSignatureHelp){const X=i.SignatureHelp.to(q.activeSignatureHelp),Q=this.d.get(q.activeSignatureHelp.id,0);Q?(W=Q,W.activeSignature=X.activeSignature,W.activeParameter=X.activeParameter):W=X}return{...q,activeSignatureHelp:W}}releaseSignatureHelp(q){this.d.delete(q)}}class ce{constructor(q,W,X,Q,de){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=de,this.d=new t.$Mlc("InlayHints"),this.e=new Map}async provideInlayHints(q,W,X){const Q=this.f.getDocument(q),de=i.Range.to(W),we=await this.h.provideInlayHints(Q,de,X);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(X.isCancellationRequested)return;const je=this.d.add(we);this.e.set(je,new b.$Tc);const qe={hints:[],cacheId:je};for(let Ke=0;Ke<we.length;Ke++)this.l(we[Ke],de)&&qe.hints.push(this.m(we[Ke],[je,Ke]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),qe}async resolveInlayHint(q,W){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.h.resolveInlayHint(X,W);if(Q&&this.l(Q))return this.m(Q,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W){return q.label.length===0||Array.isArray(q.label)&&q.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(W&&!W.contains(q.position))}m(q,W){const X=this.e.get(W[0]);if(!X)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Q.label=q.label;else{const de=[];Q.label=de;for(const we of q.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const je={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};a.$uM.isLocation(we.location)&&(je.location=i.location.from(we.location)),we.command&&(je.command=this.g.toInternal(we.command,X)),de.push(je)}}return Q}}class oe{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Mlc("DocumentLink")}async provideLinks(q,W){const X=this.e.getDocument(q),Q=await this.f.provideDocumentLinks(X,W);if(!(!Array.isArray(Q)||Q.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(oe.g).map(i.DocumentLink.from)};{const de=this.d.add(Q),we={links:[],cacheId:de};for(let je=0;je<Q.length;je++){if(!oe.g(Q[je]))continue;const qe=i.DocumentLink.from(Q[je]);qe.cacheId=[de,je],we.links.push(qe)}return we}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,W){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.f.resolveDocumentLink(X,W);if(!(!Q||!oe.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(q){this.d.delete(q)}}class le{constructor(q,W){this.d=q,this.e=W}async provideColors(q,W){const X=this.d.getDocument(q),Q=await this.e.provideDocumentColors(X,W);return Array.isArray(Q)?Q.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(q,W,X){const Q=this.d.getDocument(q),de=i.Range.to(W.range),we=i.Color.to(W.color),je=await this.e.provideColorPresentations(we,{document:Q,range:de},X);if(Array.isArray(je))return je.map(i.ColorPresentation.from)}}class K{constructor(q,W){this.d=q,this.e=W}async provideFoldingRanges(q,W,X){const Q=this.d.getDocument(q),de=await this.e.provideFoldingRanges(Q,W,X);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class se{constructor(q,W,X){this.d=q,this.e=W,this.f=X}async provideSelectionRanges(q,W,X){const Q=this.d.getDocument(q),de=W.map(i.Position.to),we=await this.e.provideSelectionRanges(Q,de,X);if(!(0,l.$Lb)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const je=[];for(let qe=0;qe<de.length;qe++){const Ke=[];je.push(Ke);let tt=de[qe],_e=we[qe];for(;;){if(!_e.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(_e)),!_e.parent)break;tt=_e.range,_e=_e.parent}}return je}}class $e{constructor(q,W){this.f=q,this.g=W,this.d=new R.$OO(""),this.e=new Map}async prepareSession(q,W,X){const Q=this.f.getDocument(q),de=i.Position.to(W),we=await this.g.prepareCallHierarchy(Q,de,X);if(!we)return;const je=this.d.nextId();return this.e.set(je,new Map),Array.isArray(we)?we.map(qe=>this.h(je,qe)):[this.h(je,we)]}async provideCallsTo(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Q,X);if(de)return de.map(we=>({from:this.h(q,we.from),fromRanges:we.fromRanges.map(je=>i.Range.from(je))}))}async provideCallsFrom(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Q,X);if(de)return de.map(we=>({to:this.h(q,we.to),fromRanges:we.fromRanges.map(je=>i.Range.from(je))}))}releaseSession(q){this.e.delete(q)}h(q,W){const X=this.e.get(q),Q=i.CallHierarchyItem.from(W,q,X.size.toString(36));return X.set(Q._itemId,W),Q}j(q,W){return this.e.get(q)?.get(W)}}class ve{constructor(q,W){this.f=q,this.g=W,this.d=new R.$OO(""),this.e=new Map}async prepareSession(q,W,X){const Q=this.f.getDocument(q),de=i.Position.to(W),we=await this.g.prepareTypeHierarchy(Q,de,X);if(!we)return;const je=this.d.nextId();return this.e.set(je,new Map),Array.isArray(we)?we.map(qe=>this.h(je,qe)):[this.h(je,we)]}async provideSupertypes(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Q,X);if(de)return de.map(we=>this.h(q,we))}async provideSubtypes(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Q,X);if(de)return de.map(we=>this.h(q,we))}releaseSession(q){this.e.delete(q)}h(q,W){const X=this.e.get(q),Q=i.TypeHierarchyItem.from(W,q,X.size.toString(36));return X.set(Q._itemId,W),Q}j(q,W){return this.e.get(q)?.get(W)}}class Me{constructor(q,W,X,Q,de){this.e=q,this.f=W,this.g=X,this.h=Q,this.j=de,this.d=new t.$Mlc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,W,X,Q,de){const we=this.f.getDocument(W),je=i.Position.to(X),qe=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(we,je,qe,de);if(!Ke)return;const tt=(0,l.$2b)(Ke),_e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,c.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,W){const[X,Q]=q,de=this.d.get(X,Q);if(!de||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class ge{constructor(q,W){this.d=q,this.e=W}async provideMappedEdits(q,W,X,Q){const de=p.URI.revive(q),we=this.d.getDocument(de),je=X.documents.map(tt=>tt.map(_e=>({uri:p.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(nt=>i.Range.to(nt))}))),qe={documents:je,selections:je[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(we,W,qe,Q);return Ke?i.WorkspaceEdit.from(Ke):null}}class Pe{constructor(q,W){this.adapter=q,this.extension=W}}class Ae{static{this.d=0}constructor(q,W,X,Q,de,we,je,qe){this.g=W,this.h=X,this.j=Q,this.k=de,this.l=we,this.m=je,this.n=qe,this.f=new Map,this.e=q.getProxy(u.$gM.MainThreadLanguageFeatures)}o(q,W){return i.DocumentSelector.from(q,this.g,W)}p(q){return new a.$iM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ae.d++}async s(q,W,X,Q,de,we=!1){const je=this.f.get(q);if(!je||!(je.adapter instanceof W))return Q;const qe=Date.now();we||this.l.trace(`[${je.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ke=X(je.adapter,je.extension);return Promise.resolve(Ke).catch(tt=>{(0,M.$4)(tt)||(this.l.error(`[${je.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(je.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${je.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),O.CancellationToken.isCancellationToken(de)?(0,L.$nh)(Ke,de):Ke}t(q,W){const X=this.q();return this.f.set(X,new Pe(q,W)),X}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,W,X,Q){const de=this.t(new r(this.h,X),q),we=Q&&Q.label||Ae.u(q);return this.e.$registerDocumentSymbolProvider(de,this.o(W,q),we),this.p(de)}$provideDocumentSymbols(q,W,X){return this.s(q,r,Q=>Q.provideDocumentSymbols(p.URI.revive(W),X),void 0,X)}registerCodeLensProvider(q,W,X){const Q=this.q(),de=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new Pe(new o(this.h,this.j.converter,X,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Q,this.o(W,q),de);let we=this.p(Q);if(de!==void 0){const je=X.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(de));we=a.$iM.from(we,je)}return we}$provideCodeLenses(q,W,X){return this.s(q,o,Q=>Q.provideCodeLenses(p.URI.revive(W),X),void 0,X)}$resolveCodeLens(q,W,X){return this.s(q,o,Q=>Q.resolveCodeLens(W,X),void 0,void 0)}$releaseCodeLenses(q,W){this.s(q,o,X=>Promise.resolve(X.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(q,W,X){const Q=this.t(new g(this.h,X),q);return this.e.$registerDefinitionSupport(Q,this.o(W,q)),this.p(Q)}$provideDefinition(q,W,X,Q){return this.s(q,g,de=>de.provideDefinition(p.URI.revive(W),X,Q),[],Q)}registerDeclarationProvider(q,W,X){const Q=this.t(new w(this.h,X),q);return this.e.$registerDeclarationSupport(Q,this.o(W,q)),this.p(Q)}$provideDeclaration(q,W,X,Q){return this.s(q,w,de=>de.provideDeclaration(p.URI.revive(W),X,Q),[],Q)}registerImplementationProvider(q,W,X){const Q=this.t(new k(this.h,X),q);return this.e.$registerImplementationSupport(Q,this.o(W,q)),this.p(Q)}$provideImplementation(q,W,X,Q){return this.s(q,k,de=>de.provideImplementation(p.URI.revive(W),X,Q),[],Q)}registerTypeDefinitionProvider(q,W,X){const Q=this.t(new m(this.h,X),q);return this.e.$registerTypeDefinitionSupport(Q,this.o(W,q)),this.p(Q)}$provideTypeDefinition(q,W,X,Q){return this.s(q,m,de=>de.provideTypeDefinition(p.URI.revive(W),X,Q),[],Q)}registerHoverProvider(q,W,X,Q){const de=this.t(new y(this.h,X),q);return this.e.$registerHoverProvider(de,this.o(W,q)),this.p(de)}$provideHover(q,W,X,Q,de){return this.s(q,y,we=>we.provideHover(p.URI.revive(W),X,Q,de),void 0,de)}$releaseHover(q,W){this.s(q,y,X=>Promise.resolve(X.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(q,W,X,Q){const de=this.t(new D(this.h,X),q);return this.e.$registerEvaluatableExpressionProvider(de,this.o(W,q)),this.p(de)}$provideEvaluatableExpression(q,W,X,Q){return this.s(q,D,de=>de.provideEvaluatableExpression(p.URI.revive(W),X,Q),void 0,Q)}registerInlineValuesProvider(q,W,X,Q){const de=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,X),q);this.e.$registerInlineValuesProvider(we,this.o(W,q),de);let je=this.p(we);if(de!==void 0){const qe=X.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(de));je=a.$iM.from(je,qe)}return je}$provideInlineValues(q,W,X,Q,de){return this.s(q,C,we=>we.provideInlineValues(p.URI.revive(W),X,Q,de),void 0,de)}registerDocumentHighlightProvider(q,W,X){const Q=this.t(new P(this.h,X),q);return this.e.$registerDocumentHighlightProvider(Q,this.o(W,q)),this.p(Q)}registerMultiDocumentHighlightProvider(q,W,X){const Q=this.t(new j(this.h,X),q);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(W,q)),this.p(Q)}$provideDocumentHighlights(q,W,X,Q){return this.s(q,P,de=>de.provideDocumentHighlights(p.URI.revive(W),X,Q),void 0,Q)}$provideMultiDocumentHighlights(q,W,X,Q,de){return this.s(q,j,we=>we.provideMultiDocumentHighlights(p.URI.revive(W),X,Q.map(je=>p.URI.revive(je)),de),void 0,de)}registerLinkedEditingRangeProvider(q,W,X){const Q=this.t(new T(this.h,X),q);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(W,q)),this.p(Q)}$provideLinkedEditingRanges(q,W,X,Q){return this.s(q,T,async de=>{const we=await de.provideLinkedEditingRanges(p.URI.revive(W),X,Q);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ae.w(we.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(q,W,X){const Q=this.t(new z(this.h,X),q);return this.e.$registerReferenceSupport(Q,this.o(W,q)),this.p(Q)}$provideReferences(q,W,X,Q,de){return this.s(q,z,we=>we.provideReferences(p.URI.revive(W),X,Q,de),void 0,de)}registerCodeActionProvider(q,W,X,Q){const de=new b.$Tc,we=this.t(new N(this.h,this.j.converter,this.k,X,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(we,this.o(W,q),{providedKinds:Q?.providedCodeActionKinds?.map(je=>je.value),documentation:Q?.documentation?.map(je=>({kind:je.kind.value,command:this.j.converter.toInternal(je.command,de)}))},Ae.u(q),!!X.resolveCodeAction),de.add(this.p(we)),de}$provideCodeActions(q,W,X,Q,de){return this.s(q,N,we=>we.provideCodeActions(p.URI.revive(W),X,Q,de),void 0,de)}$resolveCodeAction(q,W,X){return this.s(q,N,Q=>Q.resolveCodeAction(W,X),{},void 0)}$releaseCodeActions(q,W){this.s(q,N,X=>Promise.resolve(X.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(q,W,X){const Q=this.t(new U(this.h,X),q);return this.e.$registerDocumentFormattingSupport(Q,this.o(W,q),q.identifier,q.displayName||q.name),this.p(Q)}$provideDocumentFormattingEdits(q,W,X,Q){return this.s(q,U,de=>de.provideDocumentFormattingEdits(p.URI.revive(W),X,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(q,W,X){const Q=typeof X.provideDocumentRangesFormattingEdits=="function",de=this.t(new Y(this.h,X),q);return this.e.$registerRangeFormattingSupport(de,this.o(W,q),q.identifier,q.displayName||q.name,Q),this.p(de)}$provideDocumentRangeFormattingEdits(q,W,X,Q,de){return this.s(q,Y,we=>we.provideDocumentRangeFormattingEdits(p.URI.revive(W),X,Q,de),void 0,de)}$provideDocumentRangesFormattingEdits(q,W,X,Q,de){return this.s(q,Y,we=>we.provideDocumentRangesFormattingEdits(p.URI.revive(W),X,Q,de),void 0,de)}registerOnTypeFormattingEditProvider(q,W,X,Q){const de=this.t(new ie(this.h,X),q);return this.e.$registerOnTypeFormattingSupport(de,this.o(W,q),Q,q.identifier),this.p(de)}$provideOnTypeFormattingEdits(q,W,X,Q,de,we){return this.s(q,ie,je=>je.provideOnTypeFormattingEdits(p.URI.revive(W),X,Q,de,we),void 0,we)}registerWorkspaceSymbolProvider(q,W){const X=this.t(new H(W,this.l),q);return this.e.$registerNavigateTypeSupport(X,typeof W.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(q,W,X){return this.s(q,H,Q=>Q.provideWorkspaceSymbols(W,X),{symbols:[]},X)}$resolveWorkspaceSymbol(q,W,X){return this.s(q,H,Q=>Q.resolveWorkspaceSymbol(W,X),void 0,void 0)}$releaseWorkspaceSymbols(q,W){this.s(q,H,X=>X.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(q,W,X){const Q=this.t(new J(this.h,X,this.l),q);return this.e.$registerRenameSupport(Q,this.o(W,q),J.supportsResolving(X)),this.p(Q)}$provideRenameEdits(q,W,X,Q,de){return this.s(q,J,we=>we.provideRenameEdits(p.URI.revive(W),X,Q,de),void 0,de)}$resolveRenameLocation(q,W,X,Q){return this.s(q,J,de=>de.resolveRenameLocation(p.URI.revive(W),X,Q),void 0,Q)}registerNewSymbolNamesProvider(q,W,X){const Q=this.t(new x(this.h,X,this.l),q);return this.e.$registerNewSymbolNamesProvider(Q,this.o(W,q)),this.p(Q)}$supportsAutomaticNewSymbolNamesTriggerKind(q){return this.s(q,x,W=>W.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(q,W,X,Q,de){return this.s(q,x,we=>we.provideNewSymbolNames(p.URI.revive(W),X,Q,de),void 0,de)}registerDocumentSemanticTokensProvider(q,W,X,Q){const de=this.t(new be(this.h,X),q),we=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(W,q),Q,we);let je=this.p(de);if(we){const qe=X.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(we));je=a.$iM.from(je,qe)}return je}$provideDocumentSemanticTokens(q,W,X,Q){return this.s(q,be,de=>de.provideDocumentSemanticTokens(p.URI.revive(W),X,Q),null,Q)}$releaseDocumentSemanticTokens(q,W){this.s(q,be,X=>X.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,W,X,Q){const de=this.t(new ae(this.h,X),q);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(W,q),Q),this.p(de)}$provideDocumentRangeSemanticTokens(q,W,X,Q){return this.s(q,ae,de=>de.provideDocumentRangeSemanticTokens(p.URI.revive(W),X,Q),null,Q)}registerCompletionItemProvider(q,W,X,Q){const de=this.t(new Ie(this.h,this.j.converter,X,this.m,q),q);return this.e.$registerCompletionsProvider(de,this.o(W,q),Q,Ie.supportsResolving(X),q.identifier),this.p(de)}$provideCompletionItems(q,W,X,Q,de){return this.s(q,Ie,we=>we.provideCompletionItems(p.URI.revive(W),X,Q,de),void 0,de)}$resolveCompletionItem(q,W,X){return this.s(q,Ie,Q=>Q.resolveCompletionItem(W,X),void 0,X)}$releaseCompletionItems(q,W){this.s(q,Ie,X=>X.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(q,W,X,Q){const de=new B(q,this.h,X,this.j.converter),we=this.t(de,q);return this.e.$registerInlineCompletionsSupport(we,this.o(W,q),de.supportsHandleEvents,n.$Tm.toKey(q.identifier.value),Q?.yieldTo?.map(je=>n.$Tm.toKey(je))||[]),this.p(we)}$provideInlineCompletions(q,W,X,Q,de){return this.s(q,ee,we=>we.provideInlineCompletions(p.URI.revive(W),X,Q,de),void 0,de)}$handleInlineCompletionDidShow(q,W,X,Q){this.s(q,ee,async de=>{de.handleDidShowCompletionItem(W,X,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,W,X,Q,de){this.s(q,ee,async we=>{we.handlePartialAccept(W,X,Q,de)},void 0,void 0)}$freeInlineCompletionsList(q,W){this.s(q,ee,async X=>{X.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(q,W,X){const Q=new _(q,this.h,X,this.j.converter),de=this.t(Q,q);return this.e.$registerInlineEditProvider(de,this.o(W,q),q.identifier),this.p(de)}$provideInlineEdit(q,W,X,Q){return this.s(q,_,de=>de.provideInlineEdits(p.URI.revive(W),X,Q),void 0,Q)}$freeInlineEdit(q,W){this.s(q,_,async X=>{X.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(q,W,X,Q){const de=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,we=this.t(new ue(this.h,X),q);return this.e.$registerSignatureHelpProvider(we,this.o(W,q),de),this.p(we)}$provideSignatureHelp(q,W,X,Q,de){return this.s(q,ue,we=>we.provideSignatureHelp(p.URI.revive(W),X,Q,de),void 0,de)}$releaseSignatureHelp(q,W){this.s(q,ue,X=>X.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(q,W,X){const Q=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ce(this.h,this.j.converter,X,this.l,q),q);this.e.$registerInlayHintsProvider(de,this.o(W,q),typeof X.resolveInlayHint=="function",Q,Ae.u(q));let we=this.p(de);if(Q!==void 0){const je=X.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(Q));we=a.$iM.from(we,je)}return we}$provideInlayHints(q,W,X,Q){return this.s(q,ce,de=>de.provideInlayHints(p.URI.revive(W),X,Q),void 0,Q)}$resolveInlayHint(q,W,X){return this.s(q,ce,Q=>Q.resolveInlayHint(W,X),void 0,X)}$releaseInlayHints(q,W){this.s(q,ce,X=>X.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(q,W,X){const Q=this.t(new oe(this.h,X),q);return this.e.$registerDocumentLinkProvider(Q,this.o(W,q),typeof X.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(q,W,X){return this.s(q,oe,Q=>Q.provideLinks(p.URI.revive(W),X),void 0,X,W.scheme==="output")}$resolveDocumentLink(q,W,X){return this.s(q,oe,Q=>Q.resolveLink(W,X),void 0,void 0,!0)}$releaseDocumentLinks(q,W){this.s(q,oe,X=>X.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(q,W,X){const Q=this.t(new le(this.h,X),q);return this.e.$registerDocumentColorProvider(Q,this.o(W,q)),this.p(Q)}$provideDocumentColors(q,W,X){return this.s(q,le,Q=>Q.provideColors(p.URI.revive(W),X),[],X)}$provideColorPresentations(q,W,X,Q){return this.s(q,le,de=>de.provideColorPresentations(p.URI.revive(W),X,Q),void 0,Q)}registerFoldingRangeProvider(q,W,X){const Q=this.q(),de=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new Pe(new K(this.h,X),q)),this.e.$registerFoldingRangeProvider(Q,this.o(W,q),q.identifier,de);let we=this.p(Q);if(de!==void 0){const je=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=a.$iM.from(we,je)}return we}$provideFoldingRanges(q,W,X,Q){return this.s(q,K,de=>de.provideFoldingRanges(p.URI.revive(W),X,Q),void 0,Q)}registerSelectionRangeProvider(q,W,X){const Q=this.t(new se(this.h,X,this.l),q);return this.e.$registerSelectionRangeProvider(Q,this.o(W,q)),this.p(Q)}$provideSelectionRanges(q,W,X,Q){return this.s(q,se,de=>de.provideSelectionRanges(p.URI.revive(W),X,Q),[],Q)}registerCallHierarchyProvider(q,W,X){const Q=this.t(new $e(this.h,X),q);return this.e.$registerCallHierarchyProvider(Q,this.o(W,q)),this.p(Q)}$prepareCallHierarchy(q,W,X,Q){return this.s(q,$e,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),X,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,W,X,Q){return this.s(q,$e,de=>de.provideCallsTo(W,X,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,W,X,Q){return this.s(q,$e,de=>de.provideCallsFrom(W,X,Q),void 0,Q)}$releaseCallHierarchy(q,W){this.s(q,$e,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(q,W,X){const Q=this.t(new ve(this.h,X),q);return this.e.$registerTypeHierarchyProvider(Q,this.o(W,q)),this.p(Q)}$prepareTypeHierarchy(q,W,X,Q){return this.s(q,ve,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),X,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,W,X,Q){return this.s(q,ve,de=>de.provideSupertypes(W,X,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,W,X,Q){return this.s(q,ve,de=>de.provideSubtypes(W,X,Q),void 0,Q)}$releaseTypeHierarchy(q,W){this.s(q,ve,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(q,W,X,Q){const de=this.q();return this.f.set(de,new Pe(new Me(this.e,this.h,X,de,q),q)),this.e.$registerDocumentOnDropEditProvider(de,this.o(W,q),(0,s.$RG)(q,"documentPaste")&&Q?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(q,W,X,Q,de,we){return this.s(q,Me,je=>Promise.resolve(je.provideDocumentOnDropEdits(W,p.URI.revive(X),Q,de,we)),void 0,void 0)}$resolveDropEdit(q,W,X){return this.s(q,Me,Q=>Q.resolveDropEdit(W,X),{},void 0)}$releaseDropEdits(q,W){this.s(q,Me,X=>Promise.resolve(X.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(q,W,X){const Q=this.t(new ge(this.h,X),q);return this.e.$registerMappedEditsProvider(Q,this.o(W,q)),this.p(Q)}$provideMappedEdits(q,W,X,Q,de){return this.s(q,ge,we=>Promise.resolve(we.provideMappedEdits(W,X,Q,de)),null,de)}registerDocumentPasteEditProvider(q,W,X,Q){const de=this.q();return this.f.set(de,new Pe(new F(this.e,this.h,X,de,q),q)),this.e.$registerPasteEditProvider(de,this.o(W,q),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(q,W,X,Q,de){return this.s(q,F,we=>we.prepareDocumentPaste(p.URI.revive(W),X,Q,de),void 0,de)}$providePasteEdits(q,W,X,Q,de,we,je){return this.s(q,F,qe=>qe.providePasteEdits(W,p.URI.revive(X),Q,de,we,je),void 0,je)}$resolvePasteEdit(q,W,X){return this.s(q,F,Q=>Q.resolvePasteEdit(W,X),{},void 0)}$releasePasteEdits(q,W){this.s(q,F,X=>Promise.resolve(X.releasePasteEdits(W)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Ae.w(q.decreaseIndentPattern),increaseIndentPattern:Ae.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ae.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ae.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Ae.w(q.beforeText),afterText:q.afterText?Ae.w(q.afterText):void 0,previousLineText:q.previousLineText?Ae.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Ae.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(W=>a.SyntaxTokenType.toString(W)):void 0}}static D(q){return q.map(Ae.C)}setLanguageConfiguration(q,W,X){const{wordPattern:Q}=X;if(Q&&(0,A.$lf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(W,Q):this.h.setWordDefinitionFor(W,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const de=this.q(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ae.w(X.wordPattern):void 0,indentationRules:X.indentationRules?Ae.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ae.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ae.D(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,W,we),this.p(de)}$setWordDefinitions(q){for(const W of q)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$Wlc=Ae}),define(ke[122],De([1,0,3,6,17,8,109,25,7,4,227,146,13,5,20,121,11,39,26]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=void 0,e.$Dmc=(0,S.$yi)("IExtHostLanguageModels");class a{constructor(r,o){this.option=r,this.stream=new $.$2h,this.stream=o??new $.$2h}}class s{constructor(){this.a=new Map,this.b=new $.$2h,this.c=!1,this.d=!1;const r=this;this.apiObject={stream:r.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,r]of this.a)yield r.stream;else yield this.b}handleFragment(r){if(this.c)return;this.d=!0;let o=this.a.get(r.index);o||(this.a.size===0?o=new a(r.index,this.b):o=new a(r.index),this.a.set(r.index,o)),o.stream.emitOne(r.part)}get isStreaming(){return this.d}reject(r){this.c=!0;for(const o of this.f())o.reject(r)}resolve(){this.c=!0;for(const r of this.f())r.resolve()}}let t=class{static{i=this}static{this.a=1}constructor(r,o,f){this.j=o,this.k=f,this.c=new E.$fe,this.d=new E.$fe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Vm,this.i=new Map,this.p=new Set,this.b=r.getProxy(L.$gM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(r,o,f,g){const w=i.a++;this.f.set(w,{extension:r.identifier,provider:f,languageModelId:o});let k;g.auth&&(k={providerLabel:r.displayName||r.name,accountLabel:typeof g.auth=="object"?g.auth.label:void 0}),this.b.$registerLanguageModelProvider(w,o,{extension:r.identifier,identifier:o,name:g.name??"",version:g.version,tokens:g.tokens,auth:k});const m=f.onDidReceiveLanguageModelResponse2?.(({extensionId:y,participant:D,tokenCount:C})=>{this.b.$whenLanguageModelChatRequestMade(o,new b.$Tm(y),D,C)});return(0,l.$Sc)(()=>{this.f.delete(w),this.b.$unregisterProvider(w),m?.dispose()})}async $provideLanguageModelResponse(r,o,f,g,w,k){const m=this.f.get(r);if(!m)return;const y=new R.$gw(async D=>{if(k.isCancellationRequested){this.j.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(o,{index:D.index,part:D.part})});return m.provider.provideLanguageModelResponse(g.map(O.LanguageModelChatMessage.to),w,b.$Tm.toKey(f),y,k)}$provideTokenLength(r,o,f){const g=this.f.get(r);return g?Promise.resolve(g.provider.provideTokenCount(o,f)):Promise.resolve(0)}$updateLanguageModels(r){const o=[],f=[];if(r.added)for(const g of r.added)this.g.set(g.identifier,g),o.push(g.identifier);if(r.removed)for(const g of r.removed){this.g.delete(g),f.push(g);for(const[w,k]of this.i)k.languageModelId===g&&(k.res.reject(new p.$5),this.i.delete(w))}this.d.fire(Object.freeze({added:Object.freeze(o),removed:Object.freeze(f)})),r.added?.forEach(this.o,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(r){const o=new Array;for(const{from:f,to:g,enabled:w}of r){const k=this.h.get(f)??new b.$Um;if(k.has(g)!==w){w?k.add(g):k.delete(g),this.h.set(f,k);const y={from:f,to:g};o.push(y),this.c.fire(y)}}}async sendChatRequest(r,o,f,g,w){const k=this.l(r,f),m=r.identifier,y=await this.b.$prepareChatAccess(m,o,g.justification);if(!y||!this.g.has(o))throw M.$wO.NotFound(`Language model '${o}' is unknown.`);if(this.n(m,y)&&(!await this.m(r,{identifier:y.extension,displayName:y.auth.providerLabel},g.justification,!1)||!this.h.get(m)?.has(y.extension)))throw M.$wO.NoPermissions(`Language model '${o}' cannot be used by '${m.value}'.`);const D=Math.random()*1e6|0,C=this.b.$fetchResponse(m,o,D,k,g.modelOptions??{},w),P=new $.$xh,j=new s;this.i.set(D,{languageModelId:o,res:j});let T;if(C.catch(z=>{P.isOpen()?j.reject(z):T=z}).finally(()=>{this.i.delete(D),j.resolve(),P.open()}),await P.wait(),T)throw T.name===M.$wO.name?T:new M.$wO(`Language model '${o}' errored, check cause for more details`,"Unknown",T);return j.apiObject}l(r,o){const f=[];for(const g of o)g instanceof M.$sO?(g.role===M.LanguageModelChatMessageRole.System&&(0,n.$SG)(r,"languageModelSystem"),f.push(O.LanguageModelChatMessage.from(g))):(g instanceof M.$tO&&(0,n.$SG)(r,"languageModelSystem"),f.push(O.LanguageModelChatMessage.from(g)));return f}async $handleResponseFragment(r,o){const f=this.i.get(r);f&&f.res.handleFragment(o)}async m(r,o,f,g){const w=I.$iL+o.identifier.value;if(await this.k.getSession(r,w,[],{silent:!0}))return this.$updateModelAccesslist([{from:r.identifier,to:o.identifier,enabled:!0}]),!0;if(g)return!1;try{const m=f?(0,A.localize)(0,null,o.displayName,f):(0,A.localize)(1,null,o.displayName);return await this.k.getSession(r,w,[],{forceNewSession:{detail:m}}),this.$updateModelAccesslist([{from:r.identifier,to:o.identifier,enabled:!0}]),!0}catch{return!1}}n(r,o){return!!o.auth&&!b.$Tm.equals(o.extension,r)}async o(r){for(const o of this.p)try{await this.m(o,{identifier:r.extension,displayName:""},void 0,!0)}catch(f){this.j.error("Fake Auth request failed"),this.j.error(f)}}async computeTokenLength(r,o,f){const g=this.g.get(r);if(!g)throw M.$wO.NotFound(`Language model '${r}' is unknown.`);const w=c.Iterable.find(this.f.values(),k=>k.languageModelId===r);return w?w.provider.provideTokenCount(o,f):this.b.$countTokens(g.identifier,typeof o=="string"?o:O.LanguageModelChatMessage.from(o),f)}getLanguageModelInfo(r){const o=this.g.get(r);if(o)return Object.freeze({id:o.identifier,name:o.name,version:o.version,contextLength:o.tokens})}createLanguageModelAccessInformation(r){this.p.add(r);const o=this,f=E.Event.signal(E.Event.filter(this.c.event,w=>b.$Tm.equals(w.from,r.identifier))),g=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(f,g)},canSendRequest(w){const k=o.g.get(w);if(!k)return;if(!o.n(r.identifier,k))return!0;const m=o.h.get(r.identifier);if(m)return m.has(k.extension)}}}};e.$Emc=t,e.$Emc=t=i=Je([We(0,v.$JO),We(1,d.$5j),We(2,h.$Ylc)],t)}),define(ke[345],De([1,0,6,17,8,41,7,3,26]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;class E{constructor(I,p,S,v){this.c=p,this.d=S,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(l.$gM.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,p){await this.a.$changeLanguage(I,p);const S=this.c.getDocumentData(I);if(!S)throw new Error(`document '${I.toString()}' NOT found`);return S.document}async tokenAtPosition(I,p){const S=I.version,v=L.Position.from(p),h=await this.a.$tokensAtPosition(I.uri,v),d={type:O.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new O.$kM(p.line,p.character,p.line,p.character)};if(!h)return d;const c={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!c.range.contains(p)||S!==I.version?d:c}createLanguageStatusItem(I,p,S){const v=this.f++,h=this.a,d=this.g,c=`${I.identifier.value}/${p}`;if(d.has(c))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);d.add(c);const n={selector:S,id:p,name:I.displayName??I.name,severity:O.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new b.$Tc,s=()=>{if(i?.dispose(),!d.has(c)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Ah)(()=>{a.clear(),this.a.$setLanguageStatus(v,{id:c,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===O.LanguageStatusSeverity.Error?M.default.Error:n.severity===O.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),h.$removeLanguageStatus(v),d.delete(c)},get id(){return n.id},get name(){return n.name},set name(u){n.name=u,s()},get selector(){return n.selector},set selector(u){n.selector=u,s()},get text(){return n.text},set text(u){n.text=u,s()},set text2(u){(0,$.$SG)(I,"languageStatusText"),n.text=u,s()},get text2(){return(0,$.$SG)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(u){n.detail=u,s()},get severity(){return n.severity},set severity(u){n.severity=u,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(u){n.accessibilityInformation=u,s()},get command(){return n.command},set command(u){n.command=u,s()},get busy(){return n.busy},set busy(u){n.busy=u,s()}};return s(),t}}e.$jnc=E}),define(ke[346],De([1,0,15,2,17,8,120]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=e.$8mc=void 0;class b{constructor(I,p,S,v){this.start=I,this.deletedCount=p,this.deletedItems=S,this.items=v}asApiEvent(){return{range:new M.$KN(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,p,S){this.notebook=I,this.h=p,this.j=S,this.handle=S.handle,this.uri=L.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(O.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(O.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:O.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(v){I.g=v},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(S)}return this.f}setOutputs(I){this.a=I.map(O.NotebookCellOutput.to)}setOutputItems(I,p,S){const v=S.map(O.NotebookCellOutputItem.to),h=this.a.find(d=>d.id===I);if(h&&(p||(h.items.length=0),h.items.push(...v),h.items.length>1&&h.items.every(d=>R.$cK(d.mime)))){const d=new Map,c=[];h.items.forEach(n=>{let i;d.has(n.mime)?i=d.get(n.mime):(i=[],d.set(n.mime,i),c.push(n.mime)),i.push(n.data)}),h.items.length=0,c.forEach(n=>{const i=R.$dK(d.get(n));h.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(O.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$8mc=$;class E{static{this.a=0}constructor(I,p,S,v,h){this.k=I,this.l=p,this.m=S,this.uri=v,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===l.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(S){return S=I.n(S),I.b[S].apiCell},getCells(S){return(S?I.p(S):I.b).map(h=>h.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,S){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:S});const v={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},h=[];for(const c of I.rawEvents)c.kind===R.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,v.contentChanges):c.kind===R.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,v.contentChanges):c.kind===R.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),h.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),h.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),h.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===R.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),h.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),h.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const d=new Map;for(let c=0;c<h.length;c++){const n=h[c],i=d.get(n.cell);if(i===void 0){const a=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});d.set(n.cell,a-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,S=I.end|0;return p<0&&(p=0),S>this.b.length&&(S=this.b.length),I.with({start:p,end:S})}p(I){I=this.o(I);const p=[];for(let S=I.start;S<I.end;S++)p.push(this.b[S]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,S){if(this.j)return;const v=[],h=[],d=[];if(I.reverse().forEach(c=>{const i=c[2].map(t=>{const u=new $(this,this.l,t);return p||h.push($.asModelAddData(t)),u}),a=new b(c[0],c[1],[],i),s=this.b.splice(c[0],c[1],...i);for(const t of s)d.push(t.uri),a.deletedItems.push(t.apiCell);v.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:d}),S)for(const c of v)S.push(c.asApiEvent())}s(I,p,S,v){const h=this.b.splice(I,p);this.b.splice(S,0,...h);const d=[new b(I,p,h.map(c=>c.apiCell),[]),new b(S,0,[],h)];for(const c of d)v.push(c.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,S,v){this.b[I].setOutputItems(p,S,v)}v(I,p){const S=this.b[I];S.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(S.uri,p)}w(I,p){const S=this.b[I];S.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$9mc=E}),define(ke[347],De([1,0,4,2,17,8,48]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class b{constructor(E,A,I,p={timeout:1500,errors:3}){this.b=E,this.c=A,this.d=I,this.f=p,this.a=new l.$he}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(A,I,p)=>{const S=function(h){A.call(I,h)};return S.extension=E,this.a.event(S,void 0,p)}}async $participateInSave(E,A,I){const p=L.URI.revive(E),S=this.c.getNotebookDocument(p);if(!S)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:O.TextDocumentSaveReason.to(A)},I,async(d,c)=>{const n=Date.now(),i=await await Promise.resolve(d);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!I.isCancellationRequested&&i&&(i instanceof M.$sM?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),I.isCancellationRequested)return!1;if(v.length===0)return!0;const h={edits:[]};for(const d of v){const{edits:c}=O.WorkspaceEdit.from(d);h.edits=h.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new R.$Ew(h))}}e.$lnc=b}),define(ke[154],De([1,0,13,17,8]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,E,A,I,p){this.id=b,this.f=$,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(O.$KN.isNotebookRange))throw(0,l.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,E){b.f.$tryRevealRange(b.id,L.NotebookRange.from($),E??O.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(L.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$0mc=M}),define(ke[348],De([1,0,4,11,17]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;let M=class{constructor(b,$){this.c=b,this.d=$,this.a=new l.$fe,this.b=new l.$fe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const E=this.d.getEditorById(b);$.visibleRanges&&E._acceptVisibleRanges($.visibleRanges.ranges.map(O.NotebookRange.to)),$.selections&&E._acceptSelections($.selections.selections.map(O.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(O.ViewColumn.to(b[$]))}};e.$nnc=M,e.$nnc=M=Je([We(0,L.$5j)],M)}),define(ke[349],De([1,0,4,6,154]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;class M{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(L.$gM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,E){const A=this.c.getEditorById(b);this.a.get($)?.fire({editor:A.apiEditor,message:E})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,I,p)=>this.d($).event(A,I,p),postMessage:(A,I)=>{O.$0mc.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const p=I&&O.$0mc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,$,A)}}}d(b){let $=this.a.get(b);return $||($=new l.$fe({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$qnc=M}),define(ke[350],De([1,0,17,109,22,56,13]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class b{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,p,S){const v=this.b++,{title:h,location:d,cancellable:c}=p,n={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(v,{location:l.ProgressLocation.from(d),title:h,source:n,cancellable:c},I.isUnderDevelopment?void 0:I.identifier.value).catch(R.$2),this.d(v,S,!!c)}d(I,p,S){let v;S&&(v=new O.$qe,this.c.set(I,v));const h=c=>{this.a.$progressEnd(c),this.c.delete(c),v?.dispose()};let d;try{d=p(new E(this.a,I),S&&v?v.token:O.CancellationToken.None)}catch(c){throw h(I),c}return d.then(c=>h(I),c=>h(I)),d}$acceptProgressCanceled(I){const p=this.c.get(I);p&&(p.cancel(),this.c.delete(I))}}e.$unc=b;function $(A,I){return A.message=I.message,typeof I.increment=="number"&&(typeof A.increment=="number"?A.increment+=I.increment:A.increment=I.increment),A}class E extends L.$gw{constructor(I,p){super(S=>this.throttledReport(S)),this.c=I,this.d=p}throttledReport(I){this.c.$progressReport(this.d,I)}}Je([(0,M.$5h)(100,(A,I)=>$(A,I),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[351],De([1,0,2,6,7,17]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class R{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(L.$gM.MainThreadQuickDiff)}$provideOriginalResource($,E,A){const I=l.URI.revive(E),p=this.c.get($);return p?(0,O.$qh)(()=>p.provideOriginalResource(I,A)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,E,A,I){const p=R.a++;return this.c.set(p,E),this.b.$registerQuickDiffProvider(p,M.DocumentSelector.from($,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$vnc=R}),define(ke[352],De([1,0,22,4,3,6,2,8,13,19,41,50,26,17]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=v;function v(h,d,c){const n=h.getProxy(M.$gM.MainThreadQuickOpen);class i{constructor(w,k){this.e=new Map,this.f=0,this.a=w,this.b=k}showQuickPick(w,k,m,y=l.CancellationToken.None){this.c=void 0;const D=Promise.resolve(k),C=++this.f,P=n.$show(C,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},y),j={},T=P.then(()=>j);return Promise.race([T,D]).then(z=>{if(z===j)return;const N=(0,p.$RG)(w,"quickPickItemTooltip");return D.then(F=>{const U=[];for(let Y=0;Y<F.length;Y++){const ie=F[Y];if(typeof ie=="string")U.push({label:ie,handle:Y});else if(ie.kind===b.QuickPickItemKind.Separator)U.push({type:"separator",label:ie.label});else{ie.tooltip&&!N&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const H=ie.iconPath?r(ie.iconPath):void 0;U.push({label:ie.label,iconPath:H?.iconPath,iconClass:H?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:N?S.MarkdownString.fromStrict(ie.tooltip):void 0,handle:Y})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=Y=>{m.onDidSelectItem(F[Y])}),n.$setItems(C,U),P.then(Y=>{if(typeof Y=="number")return F[Y];if(Array.isArray(Y))return Y.map(ie=>F[ie])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(w){this.c?.(w)}showInput(w,k=l.CancellationToken.None){return this.d=w?.validateInput,n.$input(w,typeof this.d=="function",k).then(void 0,m=>{if(!(0,$.$4)(m))return Promise.reject(m)})}async $validateInput(w){if(!this.d)return;const k=await this.d(w);if(!k||typeof k=="string")return k;let m;switch(k.severity){case b.InputBoxValidationSeverity.Info:m=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:m=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:m=A.default.Error;break;default:m=k.message?A.default.Error:A.default.Ignore;break}return{content:k.message,severity:m}}async showWorkspaceFolderPick(w,k=l.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!m)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===m.uri.toString())}createQuickPick(w){const k=new o(w,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(w){const k=new f(w,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(w,k){this.e.get(w)?._fireDidChangeValue(k)}$onDidAccept(w){this.e.get(w)?._fireDidAccept()}$onDidChangeActive(w,k){const m=this.e.get(w);m instanceof o&&m._fireDidChangeActive(k)}$onDidChangeSelection(w,k){const m=this.e.get(w);m instanceof o&&m._fireDidChangeSelection(k)}$onDidTriggerButton(w,k){this.e.get(w)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(w,k,m){const y=this.e.get(w);y instanceof o&&y._fireDidTriggerItemButton(k,m)}$onDidHide(w){this.e.get(w)?._fireDidHide()}}class a{static{this.a=1}constructor(w,k){this.x=w,this.y=k,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$fe,this.q=new L.$fe,this.r=new L.$fe,this.s=new L.$fe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(w){this.b=w,this.z({title:w})}get step(){return this.c}set step(w){this.c=w,this.z({step:w})}get totalSteps(){return this.d}set totalSteps(w){this.d=w,this.z({totalSteps:w})}get enabled(){return this.g}set enabled(w){this.g=w,this.z({enabled:w})}get busy(){return this.j}set busy(w){this.j=w,this.z({busy:w})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(w){this.k=w,this.z({ignoreFocusOut:w})}get value(){return this.l}set value(w){this.l=w,this.z({value:w})}get placeholder(){return this.m}set placeholder(w){this.m=w,this.z({placeholder:w})}get buttons(){return this.n}set buttons(w){this.n=w.slice(),this.o.clear(),w.forEach((k,m)=>{const y=k===b.$HN.Back?-1:m;this.o.set(y,k)}),this.z({buttons:w.map((k,m)=>({...r(k.iconPath),tooltip:k.tooltip,handle:k===b.$HN.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(w){this.l=w,this.q.fire(w)}_fireDidTriggerButton(w){const k=this.o.get(w);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,O.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(w){if(!this.v){for(const k of Object.keys(w)){const m=w[k];this.u[k]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(g){if(g instanceof b.$fN)return{id:g.id};const w=u(g),k=t(g);return{dark:typeof w=="string"?R.URI.file(w):w,light:typeof k=="string"?R.URI.file(k):k}}function t(g){return typeof g=="object"&&"light"in g?g.light:g}function u(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const w=s(g);let k,m;return"id"in w?m=I.ThemeIcon.asClassName(w):k=w,{iconPath:k,iconClass:m}}class o extends a{constructor(w,k){super(w.identifier,k),this.O=w,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$fe,this.L=[],this.M=new L.$fe,this.N=new L.$fe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(w){this.B=w.slice(),this.C.clear(),this.D.clear(),w.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const k=(0,p.$RG)(this.O,"quickPickItemTooltip"),m=[];for(let y=0;y<w.length;y++){const D=w[y];if(D.kind===b.QuickPickItemKind.Separator)m.push({type:"separator",label:D.label});else{D.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=D.iconPath?r(D.iconPath):void 0;m.push({handle:y,label:D.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:k?S.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((P,j)=>({...r(P.iconPath),tooltip:P.tooltip,handle:j}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(w){this.E=w,this.z({canSelectMany:w})}get matchOnDescription(){return this.F}set matchOnDescription(w){this.F=w,this.z({matchOnDescription:w})}get matchOnDetail(){return this.G}set matchOnDetail(w){this.G=w,this.z({matchOnDetail:w})}get sortByLabel(){return this.H}set sortByLabel(w){this.H=w,this.z({sortByLabel:w})}get keepScrollPosition(){return this.I}set keepScrollPosition(w){this.I=w,this.z({keepScrollPosition:w})}get activeItems(){return this.J}set activeItems(w){this.J=w.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(w){this.L=w.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(w){const k=(0,E.$Hb)(w.map(m=>this.C.get(m)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(w){const k=(0,E.$Hb)(w.map(m=>this.C.get(m)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(w,k){const m=this.C.get(w);if(!m||!m.buttons||!m.buttons.length)return;const y=m.buttons[k];y&&this.N.fire({button:y,item:m})}}class f extends a{constructor(w,k){super(w.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(w){this.B=w,this.z({password:w})}get prompt(){return this.C}set prompt(w){this.C=w,this.z({prompt:w})}get valueSelection(){return this.D}set valueSelection(w){this.D=w,this.z({valueSelection:w})}get validationMessage(){return this.E}set validationMessage(w){this.E=w,w?typeof w=="string"?this.z({validationMessage:w,severity:A.default.Error}):this.z({validationMessage:w.message,severity:w.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(d,c)}}),define(ke[353],De([1,0,2,4,56,3,7,6,19,132,11,25,50,17,26,15,12]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=void 0;function n(C){return C instanceof l.URI}function i(C,P){return C.scheme===h.Schemas.file&&P.scheme===h.Schemas.file&&d.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?l.URI.file(C.iconPath):l.URI.isUri(C.iconPath)||p.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function s(C){if(C.icon){if(l.URI.isUri(C.icon))return C.icon;if(p.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function t(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const j=typeof C.iconPath=="string"?C.iconPath:l.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,T=typeof P.iconPath=="string"?P.iconPath:l.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$tr)(j,T)}function u(C,P){let j=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(j=t(C,P),j!==0)return j;if(C.light&&P.light)j=t(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(j!==0)return j;if(C.dark&&P.dark)j=t(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return j}function r(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let j=0;j<C.arguments.length;j++){const T=C.arguments[j],z=P.arguments[j];if(T!==z&&!(n(T)&&n(z)&&i(T,z)))return T<z?-1:1}return 0}function o(C,P){let j=(0,E.$tr)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(j!==0)return j;if(C.command&&P.command)j=r(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(j!==0)return j;if(C.decorations&&P.decorations)j=u(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)j=(0,E.$tr)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)j=(0,E.$tr)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return j}function f(C,P){for(let j=0;j<C.length;j++)if(C[j]!==P[j])return!1;return!0}function g(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?f(C.arguments,P.arguments):C.arguments===P.arguments)}function w(C,P){return(0,$.$ub)(C,P,g)}class k{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,v.$SG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,v.$SG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,v.$SG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,j,T,z,N){this.k=P,this.l=z,this.m=N,this.d="",this.e=new L.$fe,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=T}showValidationMessage(P,j){(0,v.$SG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,j)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$xnc=k;class m{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,j,T,z,N,F,U){this.q=P,this.s=j,this.t=T,this.u=z,this.v=N,this.multiDiffEditorEnableViewChanges=F,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$fe,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$fe,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=m.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,j){const T=this.h.get(P);return T?(0,R.$qh)(()=>this.s.executeCommand(T.command,...T.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(o),T=(0,$.$Db)(this.o,P,o).map(F=>{const U=F.toInsert.map(Y=>{const ie=this.e++;this.g.set(ie,Y);const H=Y.resourceUri;let J;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"||Y.command.command==="vscode.changes"){const le=new M.$Tc;J=this.s.converter.toInternal(Y.command,le),this.j.set(ie,le)}else this.h.set(ie,Y.command);const x=(0,v.$RG)(this.w,"scmMultiDiffEditor"),ne=x?Y.multiDiffEditorOriginalUri:void 0,be=x?Y.multiFileDiffEditorModifiedUri:void 0,ae=a(Y.decorations),Ie=Y.decorations&&a(Y.decorations.light)||ae,ee=Y.decorations&&a(Y.decorations.dark)||ae,B=[Ie,ee],_=Y.decorations&&Y.decorations.tooltip||"",pe=Y.decorations&&!!Y.decorations.strikeThrough,ue=Y.decorations&&!!Y.decorations.faded,ce=Y.contextValue||"";return{rawResource:[ie,H,B,_,pe,ue,ce,J,ne,be],handle:ie}});return{start:F.start,deleteCount:F.deleteCount,toInsert:U}}),z=T.map(({start:F,deleteCount:U,toInsert:Y})=>[F,U,Y.map(ie=>ie.rawResource)]),N=T.reverse();for(const{start:F,deleteCount:U,toInsert:Y}of N){const ie=Y.map(J=>J.handle),H=this.n.splice(F,U,...ie);for(const J of H)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=P,z}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let j;(0,v.$RG)(this.x,"quickDiffProvider")&&(j=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:j})}get historyProvider(){return(0,v.$SG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,v.$SG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new M.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new M.$Tc,this.o=P;const j=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:j})}get actionButton(){return(0,v.$SG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,v.$SG)(this.x,"scmActionButton"),this.p.value=new M.$Tc,this.q=P;const j=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(T=>T.map(z=>this.y.converter.toInternal(z,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:j??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&w(this.t,P))return;this.s.value=new M.$Tc,this.t=P;const j=(P||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:j})}get selected(){return this.u}constructor(P,j,T,z,N,F,U){this.x=P,this.y=z,this.z=N,this.A=F,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Vc,this.m=void 0,this.n=new M.$Vc,this.o=void 0,this.p=new M.$Vc,this.s=new M.$Vc,this.t=void 0,this.u=!1,this.v=new L.$fe,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=T;const Y=l.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new k(P,j,this.#e,this.w,Y),this.#e.$registerSourceControl(this.w,N,F,U,Y)}createResourceGroup(P,j,T){const z=(0,v.$RG)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,N=new m(this.#e,this.y,this.w,P,j,z,this.x),F=L.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,F),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const P=[],j=[];for(const[T,z]of this.C){z.dispose();const N=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});L.Event.once(T.onDidDispose)(()=>{this.D.delete(T),N.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),P.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const F=T._takeResourceStateSnapshot();F.length>0&&j.push([T.handle,F]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,P,j),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(j=>{const T=j._takeResourceStateSnapshot();T.length!==0&&P.push([j.handle,T])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,O.$4h)(100)],y.prototype,"eventuallyAddResourceGroups",null),Je([(0,O.$4h)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,j,T,z){this.l=j,this.m=T,this.n=z,this.g=new Map,this.h=new I.$Vm,this.j=new L.$fe,this.e=P.getProxy(b.$gM.MainThreadSCM),this.f=P.getProxy(b.$gM.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const F=this.g.get(N.sourceControlHandle);if(!F)return N;const U=F.getResourceGroup(N.groupHandle);return U?U.getResourceState(N.handle):N}else if(N&&N.$mid===4){const F=this.g.get(N.sourceControlHandle);return F?F.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const F=this.g.get(N.handle);return F||N}return N}})}createSourceControl(P,j,T,z){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,j,T,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const N=c.d++,F=new y(P,this.m,this.e,this.l,j,T,z);this.g.set(N,F);const U=this.h.get(P.identifier)||[];return U.push(F),this.h.set(P.identifier,U),F}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const j=this.h.get(P.identifier),T=j&&j[j.length-1];return T&&T.inputBox}$provideOriginalResource(P,j,T){const z=l.URI.revive(j);this.n.trace("ExtHostSCM#$provideOriginalResource",P,z.toString());const N=this.g.get(P);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$qh)(()=>N.quickDiffProvider.provideOriginalResource(z,T)).then(F=>F||null)}$onInputBoxValueChange(P,j){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const T=this.g.get(P);return T&&T.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(P,j,T,z){this.n.trace("ExtHostSCM#$executeResourceCommand",P,j,T);const N=this.g.get(P);if(!N)return Promise.resolve(void 0);const F=N.getResourceGroup(j);return F?F.$executeResourceCommand(T,z):Promise.resolve(void 0)}$validateInput(P,j,T){this.n.trace("ExtHostSCM#$validateInput",P);const z=this.g.get(P);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.$qh)(()=>z.inputBox.validateInput(j,T)).then(N=>{if(!N)return Promise.resolve(void 0);const F=S.MarkdownString.fromStrict(N.message);return F?Promise.resolve([F,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,j,T,z){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,T,z)??void 0}async $provideHistoryItems(P,j,T,z){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(j,T,z))?.map(U=>({...U,icon:s(U)}))??void 0}async $provideHistoryItemSummary(P,j,T,z){const N=this.g.get(P)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const F=await N.provideHistoryItemSummary(j,T,z);return F?{...F,icon:s(F)}:void 0}async $provideHistoryItemChanges(P,j,T,z){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(j,T,z)??void 0}};e.$ync=D,e.$ync=D=c=Je([We(3,A.$5j)],D)}),define(ke[354],De([1,0,6,17,2]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class M{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(l.$gM.MainThreadShare)}async $provideShare(b,$,E){return await this.c.get(b)?.provideShare({selection:L.Range.to($.selection),resourceUri:O.URI.revive($.resourceUri)},E)??void 0}registerShareProvider(b,$){const E=M.a++;return this.c.set(E,$),this.b.$registerShareProvider(E,L.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$znc=M}),define(ke[355],De([1,0,8,6,230,3,17,18]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new l.$gN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.$gN("statusBarItem.warningForeground")]])}#e;#t;constructor(p,S,v,h,d,c=l.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Tc,this.#e=p,this.#t=S,d&&h){this.c=(0,l.$UM)(h.identifier,d);const i=v.get(this.c);i&&(c=i.alignLeft?l.StatusBarAlignment.Left:l.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=h,this.f=d,this.g=c,this.h=this.u(n)}u(p){if((0,b.$cg)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new M.$Tc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let S;this.m?S=this.m:S=(0,O.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const h=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,S,this.k,h,this.r?.internal,v,this.o,this.g===l.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Bnc=$;class E{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,O.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const S={message:p};return this.b.unshift(S),this.c(),new l.$iM(()=>{const v=this.b.indexOf(S);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(p,S){this.e=new Map,this.a=p.getProxy(L.$gM.MainThreadStatusBar),this.b=S,this.c=new E(this)}$acceptStaticEntries(p){for(const S of p)this.e.set(S.entryId,S)}createStatusBarEntry(p,S,v,h){return new $(this.a,this.b,this.e,p,S,v,h)}setStatusBarMessage(p,S){const v=this.c.setMessage(p);let h;return typeof S=="number"?h=setTimeout(()=>v.dispose(),S):typeof S<"u"&&S.then(()=>v.dispose(),()=>v.dispose()),new l.$iM(()=>{v.dispose(),clearTimeout(h)})}}e.$Cnc=A}),define(ke[155],De([1,0,29,145,69,113,89,17,2]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=e.$WO=e.$VO=void 0;const E=(i,a,s,t)=>{let u=a;return{enumerable:!0,configurable:!1,get(){return u},set(r){if(!s(u,r)){const o=u;u=r,i.listener?.(t(r,o))}}}},A=(i,a)=>i===a,I={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,a)=>!(i.length!==a.length||i.some(s=>!a.find(t=>s.id===t.id)))},p=i=>a=>({op:4,update:i(a)}),S=(i,a)=>({range:(()=>{let s;const t=p(u=>({range:l.$xt.lift(b.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return s},set(u){i.listener?.({op:6}),I.range(s,u)||(s=u,i.listener?.(t(u)))}}})(),label:E(i,a,I.label,p(s=>({label:s}))),description:E(i,void 0,I.description,p(s=>({description:s}))),sortText:E(i,void 0,I.sortText,p(s=>({sortText:s}))),canResolveChildren:E(i,!1,I.canResolveChildren,s=>({op:2,state:s})),busy:E(i,!1,I.busy,p(s=>({busy:s}))),error:E(i,void 0,I.error,p(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:E(i,[],I.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const a=O.$5K.fromString(i.extId),s=new d(a.controllerId,a.localId,i.label,$.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,R.$$K)(t).tagId})),s},h=i=>{let a;for(const s of i.tests){const t=v(s.item);(0,L.$FO)(t).parent=a,a=t}return a};e.$VO=h;class d{constructor(a,s,t,u){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const r=(0,L.$EO)(this,a);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof c?void 0:r.parent}},children:{value:(0,M.$DO)(r,L.$FO,d),enumerable:!0,writable:!1},...S(r,t)})}}e.$WO=d;class c extends d{constructor(a,s){super(a,a,s,void 0),this._isRoot=!0}}e.$XO=c;class n extends M.$zO{constructor(a,s,t){super({controllerId:a,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:L.$FO,getChildren:u=>u.children,root:new c(a,s),toITestItem:b.TestItem.from})}}e.$YO=n}),define(ke[34],De([1,0,18,8,17,24,6,19,11,58,29,51,2,3,5,20,155,21,48,47,40,87,90,30]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=void 0;let r=class{#e;#t;#n;constructor(m,y,D){this.b=new Map,this.c=new Map,this.#e=m.getProxy(R.$gM.MainThreadCommands),this.d=y,this.#n=D,this.#t=m.getProxy(R.$gM.MainThreadTelemetry),this.converter=new o(this,C=>{const P=this.c.get(C);return P?.result===g.Void?P:void 0},y),this.f=[{processArgument(C){return(0,E.$8h)(C)}},{processArgument(C){return(0,M.$7n)(C,function(P){if(A.$xt.isIRange(P))return O.Range.to(P);if(I.$wt.isIPosition(P))return O.Position.to(P);if(A.$xt.isIRange(P.range)&&p.URI.isUri(P.uri))return O.location.to(P);if(P instanceof c.$He)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const y=this.registerCommand(!1,m.id,async(...D)=>{const C=m.args.map((j,T)=>{if(!j.validate(D[T]))throw new Error(`Invalid argument '${j.name}' when running '${m.id}', received: ${typeof D[T]=="object"?JSON.stringify(D[T],null,"	"):D[T]} `);return j.convert(D[T])}),P=await this.executeCommand(m.internalId,...C);return m.result.convert(P,D,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new L.$iM(()=>{y.dispose(),this.c.delete(m.id)})}registerCommand(m,y,D,C,P,j){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:C,metadata:P,extension:j}),m&&this.#e.$registerCommand(y),new L.$iM(()=>{this.b.delete(y)&&m&&this.#e.$unregisterCommand(y)})}executeCommand(m,...y){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,y,!0)}async g(m,y,D){if(this.b.has(m))return this.#e.$fireCommandActivationEvent(m),this.h(m,y,!1);{let C=!1;const P=(0,M.$7n)(y,function(j){if(j instanceof L.$jM)return O.Position.from(j);if(j instanceof L.$kM)return O.Range.from(j);if(j instanceof L.$uM)return O.location.from(j);if(L.$KN.isNotebookRange(j))return O.NotebookRange.from(j);if(j instanceof ArrayBuffer)return C=!0,c.$He.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return C=!0,c.$He.wrap(j);if(j instanceof c.$He)return C=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(m,C?new n.$Ew(P):P,D);return(0,E.$8h)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(m,y,!1);throw j}}}async h(m,y,D){const C=this.b.get(m);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:j,metadata:T}=C;if(T?.args)for(let N=0;N<T.args.length;N++)try{(0,l.$pg)(y[N],T.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${T.args[N].name}' - ${T.args[N].description}`)}const z=a.$be.create();try{return await P.apply(j,y)}catch(N){if(m===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...y);F&&(m=F.command)}if(this.d.error(N,m,C.extension?.identifier),!D)throw N;if(C.extension?.identifier){const F=this.#n.onExtensionError(C.extension.identifier,N);this.d.trace("forwarded error to extension?",F,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$jj)(N)),this.id=m,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,m,z.elapsed())}}j(m,y,D){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new s.$ip(y),duration:D})}$executeContributedCommand(m,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const D=this.b.get(m);return D?(y=y.map(C=>this.f.reduce((P,j)=>j.processArgument(P,D.extension?.identifier),C)),this.h(m,y,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(y=>(m&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[y,D]of this.b){const{metadata:C}=D;C&&(m[y]=C)}return Promise.resolve(m)}};e.$5O=r,e.$5O=r=Je([We(0,h.$JO),We(1,$.$5j),We(2,t.$4O)],r),e.$6O=(0,v.$yi)("IExtHostCommands");class o{constructor(m,y,D){this.d=m,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,u.$Ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,y){if(!m)return;const D={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return D;const C=this.f(m.command);if(C)D.id=C.internalId,D.arguments=C.args.map((P,j)=>P.convert(m.arguments&&m.arguments[j]));else if((0,b.$Lb)(m.arguments)){const P=`${m.command} /${++this.c}`;this.b.set(P,m),y.add((0,S.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),D.$ident=P,D.id=this.delegatingCommandId,D.arguments=[P],this.g.trace("CommandsConverter#CREATE",m.command,P)}return D}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const y=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.$7O=o;class f{static{this.Uri=new f("uri","Uri of a text document",m=>p.URI.isUri(m),m=>m)}static{this.Position=new f("position","A position in a text document",m=>L.$jM.isPosition(m),O.Position.from)}static{this.Range=new f("range","A range in a text document",m=>L.$kM.isRange(m),O.Range.from)}static{this.Selection=new f("selection","A selection in a text document",m=>L.$lM.isSelection(m),O.Selection.from)}static{this.Number=new f("number","",m=>typeof m=="number",m=>m)}static{this.String=new f("string","",m=>typeof m=="string",m=>m)}static{this.StringArray=f.Arr(f.String)}static Arr(m){return new f(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,y=>Array.isArray(y)&&y.every(D=>m.validate(D)),y=>y.map(D=>m.convert(D)))}static{this.CallHierarchyItem=new f("item","A call hierarchy item",m=>m instanceof L.$GM,O.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new f("item","A type hierarchy item",m=>m instanceof L.$5N,O.TypeHierarchyItem.from)}static{this.TestItem=new f("testItem","A VS Code TestItem",m=>m instanceof d.$WO,O.TestItem.from)}constructor(m,y,D,C){this.name=m,this.description=y,this.validate=D,this.convert=C}optional(){return new f(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,y){return new f(m??this.name,y??this.description,this.validate,this.convert)}}e.$8O=f;class g{static{this.Void=new g("no result",m=>m)}constructor(m,y){this.description=m,this.convert=y}}e.$9O=g;class w{constructor(m,y,D,C,P){this.id=m,this.internalId=y,this.description=D,this.args=C,this.result=P}}e.$0O=w}),define(ke[356],De([1,0,19,15,2,84,135,38,34,17,8]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;const I=[new $.$0O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of DocumentHighlight-instances.",S(E.DocumentHighlight.to))),new $.$0O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$8O.Uri],new $.$9O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,d)=>{if((0,l.$Kb)(h))return;class c extends A.$BM{static to(i){const a=new c(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new A.$uM(d[0],E.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=E.Range.to(i.selectionRange),a.children=i.children?i.children.map(c.to):[],a}}return h.map(c.to)})),new $.$0O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$8O.Uri,new $.$8O("options","Formatting options",h=>!0,h=>h)],new $.$9O("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$0O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$8O.Uri,$.$8O.Range,new $.$8O("options","Formatting options",h=>!0,h=>h)],new $.$9O("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$0O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$8O.Uri,$.$8O.Position,new $.$8O("ch","Trigger character",h=>typeof h=="string",h=>h),new $.$8O("options","Formatting options",h=>!0,h=>h)],new $.$9O("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$0O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$0O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$0O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$0O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$0O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of Location-instances.",S(E.location.to))),new $.$0O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of Hover-instances.",S(E.Hover.to))),new $.$0O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$8O.Uri,new $.$8O("position","A position in a text document",h=>Array.isArray(h)&&h.every(d=>A.$jM.isPosition(d)),h=>h.map(E.Position.from))],new $.$9O("A promise that resolves to an array of ranges.",h=>h.map(d=>{let c;for(const n of d.reverse())c=new A.$FM(E.Range.to(n),c);return c}))),new $.$0O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$8O.String.with("query","Search string")],new $.$9O("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(E.WorkspaceSymbol.to))),new $.$0O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(E.CallHierarchyItem.to))),new $.$0O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$8O.CallHierarchyItem],new $.$9O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(E.CallHierarchyIncomingCall.to))),new $.$0O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$8O.CallHierarchyItem],new $.$9O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(E.CallHierarchyOutgoingCall.to))),new $.$0O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:E.Range.to(h.range),placeholder:h.text}})),new $.$0O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$8O.Uri,$.$8O.Position,$.$8O.String.with("newName","The new symbol name")],new $.$9O("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return E.WorkspaceEdit.to(h)}})),new $.$0O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$8O.Uri,$.$8O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$9O("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(E.DocumentLink.to))),new $.$0O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$8O.Uri],new $.$9O("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$BN(h.tokenTypes,h.tokenModifiers)})),new $.$0O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$8O.Uri],new $.$9O("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,R.$ybb)(h);if(d.type==="full")return new A.$DN(d.data,void 0)})),new $.$0O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$8O.Uri,$.$8O.Range.optional()],new $.$9O("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$BN(h.tokenTypes,h.tokenModifiers)})),new $.$0O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$8O.Uri,$.$8O.Range],new $.$9O("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,R.$ybb)(h);if(d.type==="full")return new A.$DN(d.data,void 0)})),new $.$0O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$8O.Uri,$.$8O.Position,$.$8O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$8O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$9O("A promise that resolves to a CompletionList-instance.",(h,d,c)=>{if(!h)return new A.$RM([]);const n=h.suggestions.map(i=>E.CompletionItem.to(i,c));return new A.$RM(n,h.incomplete)})),new $.$0O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$8O.Uri,$.$8O.Position,$.$8O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$9O("A promise that resolves to SignatureHelp.",h=>{if(h)return E.SignatureHelp.to(h)})),new $.$0O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$8O.Uri,$.$8O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$9O("A promise that resolves to an array of CodeLens-instances.",(h,d,c)=>S(n=>new A.$JM(E.Range.to(n.range),n.command&&c.fromInternal(n.command)))(h))),new $.$0O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$8O.Uri,new $.$8O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>A.$kM.isRange(h),h=>A.$lM.isSelection(h)?E.Selection.from(h):E.Range.from(h)),$.$8O.String.with("kind","Code action kind to return code actions for").optional(),$.$8O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$9O("A promise that resolves to an array of Command-instances.",(h,d,c)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(n.command)}else{const i=new A.$DM(n.title,n.kind?new A.$EM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=c.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(h))),new $.$0O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$8O.Uri],new $.$9O("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(d=>new A.$XM(E.Range.to(d.range),E.Color.to(d.color))):[])),new $.$0O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$8O("color","The color to show and insert",h=>h instanceof A.$WM,E.Color.from),new $.$8O("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:E.Range.from(h.range)}))],new $.$9O("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(E.ColorPresentation.to):[])),new $.$0O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$8O.Uri,$.$8O.Range],new $.$9O("A promise that resolves to an array of Inlay objects",(h,d,c)=>h.map(E.InlayHint.to.bind(void 0,c)))),new $.$0O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$8O.Uri],new $.$9O("A promise that resolves to an array of FoldingRange objects",(h,d)=>{if(h)return h.map(E.FoldingRange.to)})),new $.$0O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$9O("A promise that resolves to an array of NotebookContentProvider static info objects.",S(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(d=>E.NotebookExclusiveDocumentPattern.to(d))})))),new $.$0O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$8O.Uri,$.$8O.Range,new $.$8O("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof A.$kM,h=>E.InlineValueContext.from(h))],new $.$9O("A promise that resolves to an array of InlineValue objects",h=>h.map(E.InlineValue.to))),new $.$0O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$8O("uriOrString","Uri-instance or string (only http/https)",h=>O.URI.isUri(h)||typeof h=="string"&&(0,L.$Ig)(h,L.Schemas.http,L.Schemas.https),h=>h),new $.$8O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional(),$.$8O.String.with("label","").optional()],$.$9O.Void),new $.$0O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$8O.Uri.with("resource","Resource to open"),$.$8O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$8O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional()],$.$9O.Void),new $.$0O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$8O.Uri.with("left","Left-hand side resource of the diff editor"),$.$8O.Uri.with("right","Right-hand side resource of the diff editor"),$.$8O.String.with("title","Human readable title for the diff editor").optional(),new $.$8O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)]).optional()],$.$9O.Void),new $.$0O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$8O.String.with("title","Human readable title for the changes editor"),new $.$8O("resourceList","List of resources to compare",h=>{for(const d of h){if(d.length!==3)return!1;const[c,n,i]=d;if(!O.URI.isUri(c)||!O.URI.isUri(n)&&n!==void 0&&n!==null||!O.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},h=>h)],$.$9O.Void),new $.$0O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$8O.Uri,$.$8O.Position],new $.$9O("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new $.$0O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$8O.TypeHierarchyItem],new $.$9O("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new $.$0O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$8O.TypeHierarchyItem],new $.$9O("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new $.$0O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$8O.TestItem],$.$9O.Void),new $.$0O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$8O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$9O.Void),new $.$0O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$8O.String.with("name","The context key name"),new $.$8O("value","The context key value",()=>!0,h=>h)],$.$9O.Void),new $.$0O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$8O.Uri,$.$8O.StringArray,new $.$8O("MappedEditsContext","Mapped Edits Context",h=>E.MappedEditsContext.is(h),h=>E.MappedEditsContext.from(h))],new $.$9O("A promise that resolves to a workspace edit or null",h=>h?E.WorkspaceEdit.to(h):null)),new $.$0O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$8O("Run arguments","",h=>!0,h=>{if(h)return{initialRange:h.initialRange?E.Range.from(h.initialRange):void 0,initialSelection:A.$lM.isSelection(h.initialSelection)?E.Selection.from(h.initialSelection):void 0,message:h.message,autoSend:h.autoSend,position:h.position?E.Position.from(h.position):void 0}})],$.$9O.Void)];class p{static register(d){I.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",b.$xj)}}e.$Xlc=p;function S(h){return d=>{if(Array.isArray(d))return d.map(h)}}function v(h){if(!Array.isArray(h))return;const d=[];for(const c of h)M.$cu(c)?d.push(E.DefinitionLink.to(c)):d.push(E.location.to(c));return d}}),define(ke[357],De([1,0,2,34]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class O{constructor(R,b,$,E,A){this.a=b,this.b=$,this.c=E;const I=new L.$0O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$8O("showOptions","Show Options",p=>!0,p=>p),new L.$8O("resource","Interactive resource Uri",p=>!0,p=>p),new L.$8O("controllerId","Notebook controller Id",p=>!0,p=>p),new L.$8O("title","Interactive editor title",p=>!0,p=>p)],new L.$9O("Notebook and input URI",p=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const S=this.a.getEditorById(p.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:l.URI.revive(p.notebookUri),inputUri:l.URI.revive(p.inputUri),notebookEditor:S.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:l.URI.revive(p.notebookUri),inputUri:l.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(R,b,$,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$hnc=O}),define(ke[358],De([1,0,19,7,22,4,3,27,2,25,11,6,34,17,8,114,302,26,48,303]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0,e.$pnc=f;let a=class{constructor(w,k,m,y,D){this.m=k,this.n=m,this.o=y,this.q=D,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$fe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=w.getProxy(I.$gM.MainThreadNotebookKernels);const C=new p.$0O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$8O("options","Select kernel options",j=>!0,j=>{if(j&&"notebookEditor"in j&&"id"in j){const T=this.n.getIdByEditor(j.notebookEditor);return{id:j.id,extension:j.extension,notebookEditorId:T}}else if(j&&"notebookEditor"in j){const T=this.n.getIdByEditor(j.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${j.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return j})],p.$9O.Void),P=new p.$0O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$8O.Uri],new p.$9O("A promise that resolves to an array of variables",(j,T)=>j.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(w,k,m,y,D,C){for(const ae of this.j.values())if(ae.controller.id===k&&E.$Tm.equals(w.identifier,ae.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const P=this.k++,j=this;this.q.trace(`NotebookController[${P}], CREATED by ${w.identifier.value}, ${k}`);const T=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${w.identifier}'`);let z=!1;const N=new M.$fe,F=new M.$fe,U={id:f(w.identifier,k),notebookType:m,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:y||w.identifier.value,preloads:C?C.map(S.NotebookRendererScript.from):[]};let Y=D??T,ie,H;this.a.$addKernel(P,U).catch(ae=>{console.log(ae),z=!0});let J=0;const x=()=>{if(z)return;const ae=++J;Promise.resolve().then(()=>{ae===J&&this.a.$updateKernel(P,U)})},ne=new b.$Ac,be={get id(){return k},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return U.label},set label(ae){U.label=ae??w.displayName??w.name,x()},get detail(){return U.detail??""},set detail(ae){U.detail=ae,x()},get description(){return U.description??""},set description(ae){U.description=ae,x()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ae){U.supportedLanguages=ae,x()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){U.supportsExecutionOrder=ae,x()},get rendererScripts(){return U.preloads?U.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(ae){Y=ae??T},get interruptHandler(){return ie},set interruptHandler(ae){ie=ae,U.supportsInterrupt=!!ae,x()},set variableProvider(ae){(0,c.$SG)(w,"notebookVariableProvider"),H=ae,U.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ie=>j.a.$variablesUpdated(Ie.uri)),x()},get variableProvider(){return H},createNotebookCellExecution(ae){if(z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.notebook.uri))throw j.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return j._createNotebookCellExecution(ae,f(w.identifier,this.id))},createNotebookExecution(ae){if((0,c.$SG)(w,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.uri))throw j.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return j._createNotebookExecution(ae,f(w.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${P}], DISPOSED`),z=!0,this.j.delete(P),N.dispose(),F.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ae,Ie){Ie===v.NotebookControllerAffinity2.Hidden&&(0,c.$SG)(w,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(P,ae.uri,Ie)},onDidReceiveMessage:F.event,postMessage(ae,Ie){return(0,c.$SG)(w,"notebookMessaging"),j.a.$postMessage(P,Ie&&j.n.getIdByEditor(Ie),ae)},asWebviewUri(ae){return(0,c.$SG)(w,"notebookMessaging"),(0,h.$7Ab)(ae,j.m.remote)}};return this.j.set(P,{extensionId:w.identifier,controller:be,onDidReceiveMessage:F,onDidChangeSelection:N,associatedNotebooks:ne}),be}getIdByController(w){for(const[k,m]of this.j)if(m.controller===w)return f(m.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,k){const m=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${w.identifier.value}`),this.a.$addKernelDetectionTask(m,k);const D={dispose:()=>{this.f.delete(m),y.a.$removeKernelDetectionTask(m)}};return this.f.set(m,D),D}registerKernelSourceActionProvider(w,k,m){const y=this.i++,D=typeof m.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,C=this;this.h.set(y,m),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${w.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,k);let P;return D!==void 0&&(P=m.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(D))),{dispose:()=>{this.h.delete(y),C.a.$removeKernelSourceActionProvider(y,y),P?.dispose()}}}async $provideKernelSourceActions(w,k){const m=this.h.get(w);if(m){const y=new R.$Tc;return(await m.provideNotebookKernelSourceActions(k)??[]).map(C=>S.NotebookKernelSourceAction.from(C,this.o.converter,y))}return[]}$acceptNotebookAssociation(w,k,m){const y=this.j.get(w);if(y){const D=this.n.getNotebookDocument($.URI.revive(k));m?y.associatedNotebooks.set(D.uri,!0):y.associatedNotebooks.delete(D.uri),this.q.trace(`NotebookController[${w}] ASSOCIATE notebook`,D.uri.toString(),m),y.onDidChangeSelection.fire({selected:m,notebook:D.apiNotebook})}}async $executeCells(w,k,m){const y=this.j.get(w);if(!y)return;const D=this.n.getNotebookDocument($.URI.revive(k)),C=[];for(const P of m){const j=D.getCell(P);j&&C.push(j.apiCell)}try{this.q.trace(`NotebookController[${w}] EXECUTE cells`,D.uri.toString(),C.length),await y.controller.executeHandler.call(y.controller,C,D.apiNotebook,y.controller)}catch(P){this.q.error(`NotebookController[${w}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(w,k,m){const y=this.j.get(w);if(!y)return;const D=this.n.getNotebookDocument($.URI.revive(k));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,D.apiNotebook);else for(const C of m){const P=D.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(y.controller.interruptHandler){const C=this.c.get(D.uri);this.c.delete(D.uri),m.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(w,k,m,y,D,C,P){const j=this.j.get(w);if(!j)return;const T=this.n.getNotebookDocument($.URI.revive(m)),z=j.controller.variableProvider;if(!z)return;let N;if(y!==void 0){if(N=this.s[y],!N)return}else this.s={};const F=D==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,U=z.provideVariables(T.apiNotebook,N,F,C,P);let Y=0;for await(const ie of U){if(P.isCancellationRequested)return;const H={id:this.r++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,interfaces:ie.variable.interfaces,language:ie.variable.language,expression:ie.variable.expression,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:j.extensionId.value};if(this.s[H.id]=ie.variable,this.a.$receiveVariable(k,H),Y++>=i.$Qib)return}}$acceptKernelMessageFromRenderer(w,k,m){const y=this.j.get(w);if(!y)return;const D=this.n.getEditorById(k);y.onDidReceiveMessage.fire(Object.freeze({editor:D.apiEditor,message:m}))}$cellExecutionChanged(w,k,m){const D=this.n.getNotebookDocument($.URI.revive(w)).getCell(k);if(D){const C=m?S.NotebookCellExecutionState.to(m):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:D.apiCell,state:C})}}_createNotebookCellExecution(w,k){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const D=new t(k,y,this.a);this.b.set(y.uri,D);const C=D.onDidChangeState(()=>{D.state===s.Resolved&&(D.dispose(),C.dispose(),this.b.delete(y.uri))});return D.asApiObject()}_createNotebookExecution(w,k){const m=this.n.getNotebookDocument(w.uri),y=w.getCells().find(P=>{const j=m.getCellFromApiCell(P);return j&&this.b.has(j.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const D=new r(k,m,this.a),C=D.onDidChangeState(()=>{D.state===u.Resolved&&(D.dispose(),C.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[D,C]),D.asApiObject()}};e.$onc=a,e.$onc=a=Je([We(4,A.$5j)],a);var s;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(s||(s={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(w,k,m){super(),this.m=k,this.n=m,this.b=t.a++,this.c=new M.$fe,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new O.$qe),this.h=new o(10,y=>this.s(y)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,w,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(w){await this.h.addItem(w)}async s(w){const k=Array.isArray(w)?w:[w];return this.n.$updateExecution(this.b,new n.$Ew(k))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(w){let k=this.m;if(w&&(k=this.m.notebook.getCellFromApiCell(w)),!k)throw new Error("INVALID cell");return k.handle}y(w){return w.map(k=>{const m=v.$ON.ensureUniqueMimeTypes(k.items,!0);return m===k.items?S.NotebookCellOutput.from(k):S.NotebookCellOutput.from({items:m,id:k.id,metadata:k.metadata})})}async z(w,k,m){const y=this.w(k),D=this.y((0,l.$2b)(w));return this.r({editType:d.CellExecutionUpdateType.Output,cellHandle:y,append:m,outputs:D})}async C(w,k,m){return w=v.$ON.ensureUniqueMimeTypes((0,l.$2b)(w),!0),this.r({editType:d.CellExecutionUpdateType.OutputItems,items:w.map(S.NotebookCellOutputItem.from),outputId:k.id,append:m})}asApiObject(){const w=this;return Object.freeze({get token(){return w.g.token},get cell(){return w.m.apiCell},get executionOrder(){return w.j},set executionOrder(m){w.j=m,w.s([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:w.j}])},start(m){if(w.f===s.Resolved||w.f===s.Started)throw new Error("Cannot call start again");w.f=s.Started,w.c.fire(),w.s({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,y,D){if(w.f===s.Resolved)throw new Error("Cannot call resolve twice");w.f=s.Resolved,w.c.fire(),w.h.flush();const C=D?{message:D.message,stack:D.stack,location:D?.location?{startLineNumber:D.location.start.line,startColumn:D.location.start.character,endLineNumber:D.location.end.line,endColumn:D.location.end.character}:void 0,uri:D.uri}:void 0;w.n.$completeExecution(w.b,new n.$Ew({runEndTime:y,lastRunSuccess:m,error:C}))},clearOutput(m){return w.t(),w.z([],m,!1)},appendOutput(m,y){return w.t(),w.z(m,y,!0)},replaceOutput(m,y){return w.t(),w.z(m,y,!1)},appendOutputItems(m,y){return w.t(),w.C(m,y,!0)},replaceOutputItems(m,y){return w.t(),w.C(m,y,!1)}})}}var u;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(u||(u={}));class r extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(w,k,m){super(),this.h=k,this.j=m,this.b=r.a++,this.c=new M.$fe,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new O.$qe),this.j.$createNotebookExecution(this.b,w,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(w,k){this.f=w,this.g=k,this.a=[],this.b=Date.now()}addItem(w){return this.a.push(w),this.c||(this.c=new L.$Vh,this.b=Date.now(),(0,L.$zh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const w=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>w.complete())}}function f(g,w){return`${g.value}/${w}`}}),define(ke[43],De([1,0,4,6,5,2,20,3,8,232,13,279,22,30,280,50,7,17,34]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=e.$Amc=e.$zmc=void 0,e.$zmc=(0,O.$yi)("IExtHostTerminalService");class i extends b.$Uc{constructor(m,y,D,C){super(),this.u=m,this._id=y,this.w=D,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new l.$fe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(j,T=!0){P.C(),P.u.$sendText(P._id,j,T)},show(j){P.C(),P.u.$show(P._id,j)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??y?.cwd??void 0,env:m.env??void 0,icon:f(m.iconPath)??void 0,color:h.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:y?.forceShellIntegration??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.z(m.location,y?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,y,D,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:h.ThemeColor.isThemeColor(P)?P.id:void 0,location:y?.location||this.z(m,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,y){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in m?{viewColumn:c.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,y){this.j=Object.freeze({code:m,reason:y})}setDimensions(m,y){return m===this.f&&y===this.h||m===0||y===0?!1:(this.f=m,this.h=y,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(y=>{y!==m&&(this.b=Promise.resolve(m))})}}e.$Amc=i;class a{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new l.$fe,this.onProcessData=this.a.event,this.b=new l.$fe,this.d=new l.$fe,this.onDidChangeProperty=this.d.event,this.f=new l.$fe,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,y){this.g.setDimensions?.({columns:m,rows:y})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new l.$fe,this.onDidCloseTerminal=this.H.event,this.I=new l.$fe,this.onDidOpenTerminal=this.I.event,this.J=new l.$fe,this.onDidChangeActiveTerminal=this.J.event,this.L=new l.$fe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new l.$fe,this.onDidChangeTerminalState=this.M.event,this.N=new l.$fe,this.onDidChangeShell=this.N.event,this.O=new l.$fe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new l.$fe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(L.$gM.MainThreadTerminalService),this.y=new v.$Yvb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:C=>{const P=j=>{const T=j;return this.getTerminalById(T.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let j=0;j<C.length&&C[j].$mid===15;j++)C[j]=P(C[j]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,y){const D=new i(this.a,(0,S.$Ug)(),m,m.name),C=new a(m.pty);return D.createExtensionTerminal(m.location,y,this.R(m,y).resolvedExtHostIdentifier,f(m.iconPath),g(m.color)).then(P=>{const j=this.S(P,C);this.h[P]=j}),this.f.push(D),D.value}R(m,y){if(y=y||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const D=m.location.parentTerminal;if(D){const C=this.f.find(P=>P.value===D);C&&(y.resolvedExtHostIdentifier=C._id)}}else m.location&&typeof m.location!="object"?y.location=m.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(m,y){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const C=new a(y),P=this.S(m,C);this.h[m]=P}async $acceptActiveTerminalChanged(m){const y=this.b;if(m===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.getTerminalById(m);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,y){const D=this.getTerminalById(m);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(m,y,D){const C=this.getTerminalById(m);C&&C.setDimensions(y,D)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(m,y){const D=this.getTerminalById(m);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(m,y,D){this.g.get(m)?.resize(y,D)}async $acceptTerminalTitleChange(m,y){const D=this.getTerminalById(m);D&&(D.name=y)}async $acceptTerminalClosed(m,y,D){const C=this.X(this.f,m);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(y,D),this.H.fire(P.value)}}$acceptTerminalOpened(m,y,D,C){if(y){const T=this.X(this.f,y);if(T!==null){this.f[T]._id=m,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},j=new i(this.a,m,P,D);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(m,y){this.getTerminalById(m)?._setProcessId(y)}async $startExtensionTerminal(m,y){const D=this.getTerminalById(m);if(!D)return{message:(0,E.localize)(0,null,m)};D.isOpen||await new Promise(P=>{const j=this.onDidOpenTerminal(async T=>{T===D.value&&(j.dispose(),P())})});const C=this.g.get(m);C?C.startSendingEvents(y):this.j[m]={initialDimensions:y}}S(m,y){const D=new b.$Tc;D.add(y.onProcessReady(P=>this.a.$sendProcessReady(m,P.pid,P.cwd,P.windowsPty))),D.add(y.onDidChangeProperty(P=>this.a.$sendProcessProperty(m,P))),this.y.startBuffering(m,y.onProcessData),D.add(y.onProcessExit(P=>this.U(m,P))),this.g.set(m,y);const C=this.j[m];return C&&y instanceof a&&(y.startSendingEvents(C.initialDimensions),delete this.j[m]),D}$acceptProcessAckDataEvent(m,y){this.g.get(m)?.acknowledgeDataEvent(y)}$acceptProcessInput(m,y){this.g.get(m)?.input(y)}$acceptTerminalInteraction(m){const y=this.getTerminalById(m);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(m,y){this.getTerminalById(m)?.setSelection(y)}$acceptProcessResize(m,y,D){try{this.g.get(m)?.resize(y,D)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(m,y){this.g.get(m)?.shutdown(y)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(y=>this.a.$sendProcessProperty(m,{type:"cwd",value:y}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new $.$iM(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,m.identifier.value),new $.$iM(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(m,y,D){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,D),this.a.$registerQuickFixProvider(m,y),new $.$iM(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,y){const D=new p.$qe().token;if(D.isCancellationRequested)return;const C=this.D.get(m);if(!C)return;const P=await C.provideTerminalQuickFixes(y,D);if(P===null||Array.isArray(P)&&P.length===0)return;const j=new b.$Tc;if(this.w.value=j,!Array.isArray(P))return P?c.TerminalQuickFix.from(P,this.Q.converter,j):void 0;const T=[];for(const z of P){const N=c.TerminalQuickFix.from(z,this.Q.converter,j);N&&T.push(N)}return T}async $createContributedProfileTerminal(m,y){const D=new p.$qe().token;let C=await this.C.get(m)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,y);return}this.createTerminalFromOptions(C.options,y)}}async $provideLinks(m,y){const D=this.getTerminalById(m);if(!D)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const P=new p.$qe;this.G.set(m,P);const j=[],T={terminal:D.value,line:y},z=[];for(const U of this.z)z.push(d.Promises.withAsyncBody(async Y=>{P.token.onCancellationRequested(()=>Y({provider:U,links:[]}));const ie=await U.provideTerminalLinks(T,P.token)||[];P.token.isCancellationRequested||Y({provider:U,links:ie})}));const N=await Promise.all(z);if(P.token.isCancellationRequested)return[];const F=new Map;for(const U of N)U&&U.links.length>0&&j.push(...U.links.map(Y=>{const ie={id:s++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return F.set(ie.id,{provider:U.provider,link:Y}),ie}));return this.F.set(m,F),j}$activateLink(m,y){const D=this.F.get(m)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(m,y){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const D=this.h[m];D&&(D.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,y)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const y=this.f.findIndex(D=>D.value===m);return y>=0?y:null}W(m,y){const D=this.X(m,y);return D!==null?m[D]:null}X(m,y){const D=m.findIndex(C=>C._id===y);return D>=0?D:null}getEnvironmentVariableCollection(m){let y=this.n.get(m.identifier.value);return y||(y=new u,this.Z(m.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Y(m,y){const D=(0,I.$os)(y.map),C=(0,I.$ps)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(m,y.persistent,D.length===0?void 0:D,C)}$initEnvironmentVariableCollections(m){m.forEach(y=>{const D=y[0],C=new u(y[1]);this.Z(D,C)})}$acceptDefaultProfile(m,y){const D=this.s;this.s=m,this.u=y,D?.path!==m.path&&this.N.fire(m.path)}Z(m,y){this.n.set(m,y),y.onDidChangeCollection(()=>{this.Y(m,y)})}};e.$Bmc=t,e.$Bmc=t=Je([We(1,n.$6O),We(2,R.$JO)],t);class u{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new l.$fe,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const y=this.h(m);let D=this.a.get(y);return D||(D=new r(this,m),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:C})}append(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:C})}prepend(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:C})}f(m,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(m,y.scope),C=this.map.get(D),P=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==y.value||C.type!==y.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const j=this.g(m,y.scope),T={variable:m,...y,options:P};this.map.set(j,T),this.d.fire()}}get(m,y){const D=this.g(m,y),C=this.map.get(D);return C?w(C):void 0}g(m,y){const D=this.h(y);return D.length?`${m}:::${D}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const y=new Map;for(const[D,C]of this.map)this.h(C.scope)===this.h(m)&&y.set(C.variable,w(C));return y}delete(m,y){const D=this.g(m,y);this.map.delete(D),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(y);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,y){const D=this.h(y),C=this.descriptionMap.get(D);if(!C||C.description!==m){let P;typeof m=="string"?P=m:P=m?.value.split(`

`)[0];const j={description:P,scope:y};this.descriptionMap.set(D,j),this.d.fire()}}getDescription(m){const y=this.h(m);return this.descriptionMap.get(y)?.description}k(m){const y=this.h(m);this.descriptionMap.delete(y)}}class r{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,y){this.b=m,this.d=y,this.a=new l.$fe}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,y,D){this.b.replace(m,y,D,this.d)}append(m,y,D){this.b.append(m,y,D,this.d)}prepend(m,y,D){this.b.prepend(m,y,D,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,y){this.b.getVariableMap(this.d).forEach((D,C)=>m.call(y,C,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends t{constructor(m,y){super(!1,m,y)}createTerminal(m,y,D){throw new A.$_}createTerminalFromOptions(m,y){throw new A.$_}};e.$Cmc=o,e.$Cmc=o=Je([We(0,n.$6O),We(1,R.$JO)],o);function f(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function g(k){return h.ThemeColor.isThemeColor(k)?k:void 0}function w(k){const m={...k};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[156],De([1,0,8,3,5,6,20,43,4,2,7]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,e.$Gnc=(0,O.$yi)("IExtHostTerminalShellIntegration");let I=class extends L.$Uc{constructor(d,c){super(),this.h=c,this.b=new Map,this.c=new $.$fe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$fe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$fe,this.onDidEndTerminalShellExecution=this.g.event,this.a=d.getProxy(M.$gM.MainThreadTerminalShellIntegration),this.B((0,L.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(d){const c=this.h.getTerminalById(d);if(!c)return;const n=c.value;let i=this.b.get(d);i||(i=new p(c.value,this.f),this.b.set(d,i),i.store.add(c.onWillDispose(()=>this.b.get(d)?.dispose())),i.store.add(i.onDidRequestShellExecution(a=>this.a.$executeCommand(d,a))),i.store.add(i.onDidRequestEndExecution(a=>this.g.fire(a))),i.store.add(i.onDidRequestChangeShellIntegration(a=>this.c.fire(a))),c.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(d,c,n,i,a){this.b.has(d)||this.$shellIntegrationChange(d);const s={value:c,confidence:n,isTrusted:i};this.b.get(d)?.startShellExecution(s,a)}$shellExecutionEnd(d,c,n,i,a){const s={value:c,confidence:n,isTrusted:i};this.b.get(d)?.endShellExecution(s,a)}$shellExecutionData(d,c){this.b.get(d)?.emitData(c)}$cwdChange(d,c){this.b.get(d)?.setCwd((0,E.$vc)(c)?E.URI.revive(c):c)}$closeTerminal(d){this.b.get(d)?.dispose(),this.b.delete(d)}};e.$Hnc=I,e.$Hnc=I=Je([We(0,R.$JO),We(1,b.$zmc)],I);class p extends L.$Uc{get currentExecution(){return this.a}constructor(d,c){super(),this.j=d,this.m=c,this.b=!1,this.store=this.B(new L.$Tc),this.f=this.B(new $.$fe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$fe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$fe),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,a){let s=i;a&&(s+=` "${a.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(s);const t={value:s,confidence:l.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=n.startShellExecution(t,n.c,!0).value;return n.b=!0,u}}}startShellExecution(d,c,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(d,c);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(d){this.currentExecution?.emitData(d)}endShellExecution(d,c){this.a&&(this.a.endExecution(d),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(d){let c=!1;E.URI.isUri(this.c)?c=!E.URI.isUri(d)||this.c.toString()!==d.toString():this.c!==d&&(c=!0),c&&(this.c=d,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(d,c){this.c=d,this.cwd=c,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Yh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(d){this.a?.emitData(d)}endExecution(d){d&&(this.c=d),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends L.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$xh);const d=this.a;return new A.$Yh(async n=>{this.b.push(n),await d.wait()})}emitData(d){for(const c of this.b)c.emitOne(d)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[359],De([1,0,7,21,22,4,75,57,3,18,30,11,6,20,155,17,8,69,113,89]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=e.$Jnc=e.$Inc=void 0;let a=class extends $.$Uc{constructor(P,j,T,z){super(),this.w=z,this.f=this.B(new M.$fe),this.g=new Map,this.s=this.B(new M.$fe),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(p.$gM.MainThreadTesting),this.m=new k(this.h),this.j=new r(this.h,j),T.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const F=N,U=F.tests[F.tests.length-1].item.extId;return this.g.get(c.$5K.root(U))?.collection.tree.get(U)?.actual??(0,v.$VO)(N)}case 18:{const{test:F,message:U}=N,Y=F.item.extId;return{test:this.g.get(c.$5K.root(Y))?.collection.tree.get(Y)?.actual??(0,v.$VO)({$mid:16,tests:[F]}),message:h.TestMessage.to(U)}}default:return N}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await T.executeCommand("_testing.getExplorerSelection"),F=U=>{const Y=this.g.get(c.$5K.root(U));if(Y)return c.$5K.isRoot(U)?Y.controller:Y.collection.tree.get(U)?.actual};return{include:N?.include.map(F).filter(E.$gg)||[],exclude:N?.exclude.map(F).filter(E.$gg)||[]}})}createTestController(P,j,T,z){if(this.g.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const N=new $.$Tc,F=N.add(new v.$YO(j,T,this.w));F.root.label=T;const U=new Map,Y=new Set,ie=this.h,H={items:F.root.children,get label(){return T},set label(x){T=x,F.root.label=x,ie.$updateController(j,{label:T})},get refreshHandler(){return z},set refreshHandler(x){z=x,ie.$updateController(j,{canRefresh:!!x})},get id(){return j},createRunProfile:(x,ne,be,ae,Ie,ee)=>{let B=(0,b.$mj)(x);for(;U.has(B);)B++;return new y(this.h,U,Y,this.s.event,j,B,x,ne,be,ae,Ie,ee)},createTestItem(x,ne,be){return new v.$WO(j,x,ne,be)},createTestRun:(x,ne,be=!0)=>this.j.createTestRun(j,F,x,ne,be),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const ne=x instanceof Array?x:[x];this.h.$markTestRetired(ne.map(be=>c.$5K.fromExtHostTestItem(be,j).toString()))}},set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{N.dispose()}};ie.$registerTestController(j,T,!!z),N.add((0,$.$Sc)(()=>ie.$unregisterTestController(j)));const J={controller:H,collection:F,profiles:U,extension:P,activeProfiles:Y};return this.g.set(j,J),N.add((0,$.$Sc)(()=>this.g.delete(j))),N.add(F.onDidGenerateDiff(x=>ie.$publishDiff(j,x.map(i.TestsDiffOp.serialize)))),H}createTestObserver(){return this.m.checkout()}async runTests(P,j=O.CancellationToken.None){const T=o(P);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(T.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:P.preserveFocus??!0,targets:[{testIds:P.include?.map(N=>c.$5K.fromExtHostTestItem(N,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:D[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:P.exclude?.map(N=>N.id)},j)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,j){return(await this.j.getCoverageDetails(P,j))?.map(h.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,j){this.g.get(P)?.profiles.get(j)?.configureHandler?.()}$setDefaultRunProfiles(P){const j=new Map;for(const[T,z]of Object.entries(P)){const N=this.g.get(T);if(!N)continue;const F=new Map,U=z.filter(ie=>!N.activeProfiles.has(ie)),Y=[...N.activeProfiles].filter(ie=>!z.includes(ie));for(const ie of U)F.set(ie,!0),N.activeProfiles.add(ie);for(const ie of Y)F.set(ie,!1),N.activeProfiles.delete(ie);F.size&&j.set(T,F)}this.s.fire(j)}async $refreshTests(P,j){await this.g.get(P)?.controller.refreshHandler?.(j)}$publishTestResults(P){this.results=Object.freeze(P.map(h.TestResults.to).concat(this.results).sort((j,T)=>T.completedAt-j.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,j){const T=this.g.get(c.$5K.fromString(P).controllerId)?.collection;T&&(await T.expand(P,j<0?1/0:j),T.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(j=>i.TestsDiffOp.deserialize({asCanonicalUri:T=>T},j)))}async $runControllerTests(P,j){return Promise.all(P.map(T=>this.y(T,!1,j)))}async $startContinuousRun(P,j){const T=new O.$qe(j),z=await Promise.all(P.map(N=>this.y(N,!0,T.token)));return!j.isCancellationRequested&&!z.some(N=>N.error)&&await new Promise(N=>j.onCancellationRequested(N)),T.dispose(!0),z}async y(P,j,T){const z=this.g.get(P.controllerId);if(!z)return{};const{collection:N,profiles:F}=z,U=F.get(P.profileId);if(!U)return{};const Y=P.testIds.map(x=>N.tree.get(x)).filter(E.$gg),ie=P.excludeExtIds.map(x=>z.collection.tree.get(x)).filter(E.$gg).filter(x=>Y.some(ne=>ne.fullId.compare(x.fullId)===2));if(!Y.length)return{};const H=new d.$VN(Y.some(x=>x.actual instanceof v.$XO)?void 0:Y.map(x=>x.actual),ie.map(x=>x.actual),U,j),J=(0,i.$8K)(P)&&this.j.prepareForMainThreadTestRun(H,f.fromInternal(P,z.collection),U,T);try{return await U.runHandler(H,T),{}}catch(x){return{error:String(x)}}finally{J&&J.hasRunningTasks&&!T.isCancellationRequested&&await M.Event.toPromise(J.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$Inc=a,e.$Inc=a=Je([We(0,S.$JO),We(1,I.$5j)],a);const s=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class u extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,j,T,z,N){super(),this.y=P,this.z=j,this.C=T,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new M.$fe),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new O.$qe(N));const F=this.B(new l.$Kh(()=>this.F(),s));this.B(this.j.token.onCancellationRequested(()=>F.schedule()));const U=new M.$fe;this.s=U.event,this.B((0,$.$Sc)(()=>{U.fire(),U.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,j){const[,T,z]=c.$5K.fromString(P).path,N=this.w.get(z);if(!N)return[];const F=this.g.get(T);if(!F)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(F.run,N,j)??[]}createRun(P){const j=this.y.id,T=this.y.controllerId,z=(0,A.$Ug)(),N=ie=>(H,...J)=>{if(U){this.C.warn(`Setting the state of test "${H.id}" is a no-op after the run ends.`);return}this.y.isIncluded(H)&&(this.H(H),ie(H,...J))},F=(ie,H)=>{const J=H instanceof Array?H.map(h.TestMessage.from):[h.TestMessage.from(H)];if(ie.uri&&ie.range){const x={range:h.Range.from(ie.range),uri:ie.uri};for(const ne of J)ne.location=ne.location||x}this.z.$appendTestMessagesInRun(j,z,c.$5K.fromExtHostTestItem(ie,T).toString(),J)};let U=!1;const Y={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ie=>{const H=ie.uri.toString(),J=new c.$5K([j,z,H]).toString();this.w.set(H,ie),this.z.$appendCoverage(j,z,h.TestCoverage.fromFile(J,ie))},enqueued:N(ie=>{this.z.$updateTestStateInRun(j,z,c.$5K.fromExtHostTestItem(ie,T).toString(),1)}),skipped:N(ie=>{this.z.$updateTestStateInRun(j,z,c.$5K.fromExtHostTestItem(ie,T).toString(),5)}),started:N(ie=>{this.z.$updateTestStateInRun(j,z,c.$5K.fromExtHostTestItem(ie,T).toString(),2)}),errored:N((ie,H,J)=>{F(ie,H),this.z.$updateTestStateInRun(j,z,c.$5K.fromExtHostTestItem(ie,T).toString(),6,J)}),failed:N((ie,H,J)=>{F(ie,H),this.z.$updateTestStateInRun(j,z,c.$5K.fromExtHostTestItem(ie,T).toString(),4,J)}),passed:N((ie,H)=>{this.z.$updateTestStateInRun(j,z,c.$5K.fromExtHostTestItem(ie,this.y.controllerId).toString(),3,H)}),appendOutput:(ie,H,J)=>{U||(J&&(this.y.isIncluded(J)?this.H(J):J=void 0),this.z.$appendOutputToRun(j,z,L.$He.fromString(ie),H&&h.location.from(H),J&&c.$5K.fromExtHostTestItem(J,T).toString()))},end:()=>{U||(U=!0,this.z.$finishedTestRunTask(j,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:Y}),this.z.$startedTestRunTask(j,{id:z,name:P,running:!0}),Y}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof v.$WO))throw new n.$BO(P.id);if(this.h.has(c.$5K.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const j=[],T=this.y.colllection.root;for(;;){const z=h.TestItem.from(P);if(j.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),P===T))break;P=P.parent||T}this.z.$addTestsToRun(this.y.controllerId,this.y.id,j)}dispose(){this.G(),super.dispose()}}class r{get trackers(){return this.c.values()}constructor(P,j){this.g=P,this.h=j,this.c=new Map,this.f=new Map}getCoverageDetails(P,j){const T=c.$5K.root(P);return this.f.get(T)?.getCoverageDetails(P,j)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[j,{id:T}]of this.c)T===P&&this.c.delete(j)}prepareForMainThreadTestRun(P,j,T,z){return this.j(P,j,T,z)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,j,T,z,N){const F=this.c.get(T);if(F)return F.createRun(z);const U=f.fromPublic(P,j,T,N),Y=o(T);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!T.continuous,profile:Y&&{group:D[Y.kind],id:Y.profileId},exclude:T.exclude?.map(H=>c.$5K.fromExtHostTestItem(H,j.root.id).toString())??[],id:U.id,include:T.include?.map(H=>c.$5K.fromExtHostTestItem(H,j.root.id).toString())??[j.root.id],preserveFocus:T.preserveFocus??!0,persist:N});const ie=this.j(T,U,T.profile);return M.Event.once(ie.onEnd)(()=>{this.g.$finishedExtensionTestRun(U.id)}),ie.createRun(z)}j(P,j,T,z){const N=new u(j,this.g,this.h,T,z);return this.c.set(P,N),this.f.set(N.id,N),N}}e.$Jnc=r;const o=C=>{if(C.profile){if(!(C.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class f{static fromPublic(P,j,T,z){return new f(P,(0,A.$Ug)(),T.include?.map(N=>c.$5K.fromExtHostTestItem(N,P).toString())??[P],T.exclude?.map(N=>c.$5K.fromExtHostTestItem(N,P).toString())??[],z,j)}static fromInternal(P,j){return new f(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,j)}constructor(P,j,T,z,N,F){this.controllerId=P,this.id=j,this.isPersisted=N,this.colllection=F,this.c=T.map(U=>U+"\0"),this.f=z.map(U=>U+"\0")}isIncluded(P){const j=c.$5K.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const T of this.f)if(j===T||j.startsWith(T))return!1;for(const T of this.c)if(j===T||j.startsWith(T))return!0;return!1}}e.$Knc=f;class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,h.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const j=c.$5K.parentId(P.item.extId);if(j&&this.h.has(j.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:j,g:T}=this;return{get added(){return[...P].map(z=>z.revived)},get updated(){return[...j].map(z=>z.revived)},get removed(){return[...T].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends i.$bL{constructor(){super(...arguments),this.s=new M.$fe,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,j){return{...P,revived:h.TestItem.toPlain(P.item),depth:j?j.depth+1:0,children:new Set}}v(){return new g(this.s)}}class k{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(j=>j.revived)},dispose:(0,R.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new w({asCanonicalUri:j=>j});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const m=(C,P,j,T)=>{j?Object.assign(j,T):P.$updateTestRunConfig(C.controllerId,C.profileId,T)};class y{#e;#t;#n;#i;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,m(this,this.#e,this.#i,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,m(this,this.#e,this.#i,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),m(this,this.#e,this.#i,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,m(this,this.#e,this.#i,{tag:P?h.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,m(this,this.#e,this.#i,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return M.Event.chain(this.#n,P=>P.map(j=>j.get(this.controllerId)?.get(this.profileId)).filter(E.$gg))}constructor(P,j,T,z,N,F,U,Y,ie,H=!1,J=void 0,x=!1){this.controllerId=N,this.profileId=F,this.f=U,this.kind=Y,this.runHandler=ie,this._tag=J,this.g=x,this.#e=P,this.#s=j,this.#t=T,this.#n=z,j.set(F,this);const ne=D[Y];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);H&&T.add(F),this.#i={profileId:F,controllerId:N,tag:J?h.TestTag.namespace(this.controllerId,J.id):null,label:U,group:ne,isDefault:H,hasConfigurationHandler:!1,supportsContinuousRun:x},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$Lnc=y;const D={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(ke[157],De([1,0,62,13,125,17,8]),function(he,e,l,L,O,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=e.$QO=void 0;class b{static{this.c=new O.$OO("TextEditorDecorationType")}constructor(p,S,v){const h=b.c.nextId();p.$registerTextEditorDecorationType(S.identifier,h,M.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:h,dispose(){p.$removeTextEditorDecorationType(h)}})}}e.$QO=b;class ${constructor(p,S){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,S){this.k();let v=null;if(p instanceof R.$jM)v=new R.$kM(p,p);else if(p instanceof R.$kM)v=p;else throw new Error("Unrecognized location");this.l(v,S,!1)}insert(p,S){this.k(),this.l(new R.$kM(p,p),S,!0)}delete(p){this.k();let S=null;if(p instanceof R.$kM)S=p;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(p,S,v){const h=this.c.validateRange(p);this.g.push({range:h,text:S,forceMoveMarkers:v})}setEndOfLine(p){if(this.k(),p!==R.EndOfLine.LF&&p!==R.EndOfLine.CRLF)throw(0,L.$7)("endOfLine");this.h=p}}class E{constructor(p,S,v,h){this.c=p,this.d=S,this._accept(v),this.e=h;const d=this;this.value={get tabSize(){return d.f},set tabSize(c){d.n(c)},get indentSize(){return d.g},set indentSize(c){d.p(c)},get insertSpaces(){return d.j},set insertSpaces(c){d.s(c)},get cursorStyle(){return d.k},set cursorStyle(c){d.t(c)},get lineNumbers(){return d.l},set lineNumbers(c){d.u(c)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}n(p){const S=this.m(p);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}p(p){const S=this.o(p);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const S=this.q(p);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(p)})))}assign(p){const S={};let v=!1;if(typeof p.tabSize<"u"){const h=this.m(p.tabSize);h==="auto"?(v=!0,S.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,v=!0,S.tabSize=h)}if(typeof p.indentSize<"u"){const h=this.o(p.indentSize);h==="tabSize"?(v=!0,S.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,v=!0,S.indentSize=h)}if(typeof p.insertSpaces<"u"){const h=this.q(p.insertSpaces);h==="auto"?(v=!0,S.insertSpaces=h):this.j!==h&&(this.j=h,v=!0,S.insertSpaces=h)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,v=!0,S.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,v=!0,S.lineNumbers=M.TextEditorLineNumbersStyle.from(p.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(p,S){S.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(v)})}}e.$RO=E;class A{constructor(p,S,v,h,d,c,n,i){this.id=p,this.j=S,this.k=v,this.g=!1,this.h=new Set,this.c=d,this.d=new E(this.j,this.id,c,v),this.e=n,this.f=i;const a=this;this.value=Object.freeze({get document(){return h.value},set document(s){throw new L.$9("document")},get selection(){return a.c&&a.c[0]},set selection(s){if(!(s instanceof R.$lM))throw(0,L.$7)("selection");a.c=[s],a.l()},get selections(){return a.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof R.$lM)))throw(0,L.$7)("selections");a.c=s,a.l()},get visibleRanges(){return a.e},set visibleRanges(s){throw new L.$9("visibleRanges")},get options(){return a.d.value},set options(s){a.g||a.d.assign(s)},get viewColumn(){return a.f},set viewColumn(s){throw new L.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(h.value,t);return s(u),a.m(u)},insertSnippet(s,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=a.c.map(o=>M.Range.from(o));else if(t instanceof R.$jM){const{lineNumber:o,column:f}=M.Position.from(t);r=[{startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f}]}else if(t instanceof R.$kM)r=[M.Range.from(t)];else{r=[];for(const o of t)if(o instanceof R.$kM)r.push(M.Range.from(o));else{const{lineNumber:f,column:g}=M.Position.from(o);r.push({startLineNumber:f,startColumn:g,endLineNumber:f,endColumn:g})}}return S.$tryInsertSnippet(p,h.value.version,s.value,r,u)},setDecorations(s,t){const u=t.length===0;u&&!a.h.has(s.key)||(u?a.h.delete(s.key):a.h.add(s.key),a.n(()=>{if(M.$GO(t))return S.$trySetDecorations(p,s.key,M.$HO(t));{const r=new Array(4*t.length);for(let o=0,f=t.length;o<f;o++){const g=t[o];r[4*o]=g.start.line+1,r[4*o+1]=g.start.character+1,r[4*o+2]=g.end.line+1,r[4*o+3]=g.end.character+1}return S.$trySetDecorationsFast(p,s.key,r)}}))},revealRange(s,t){a.n(()=>S.$tryRevealRange(p,M.Range.from(s),t||R.TextEditorRevealType.Default))},show(s){S.$tryShowEditor(p,M.ViewColumn.from(s))},hide(){S.$tryHideEditor(p)}})}dispose(){(0,l.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,l.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,l.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,l.ok)(!this.g),this.f=p}_acceptSelections(p){(0,l.ok)(!this.g),this.c=p}async l(){const p=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const S=p.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const v=S.edits.map(d=>d.range);v.sort((d,c)=>d.end.line===c.end.line?d.end.character===c.end.character?d.start.line===c.start.line?d.start.character-c.start.character:d.start.line-c.start.line:d.end.character-c.end.character:d.end.line-c.end.line);for(let d=0,c=v.length-1;d<c;d++){const n=v[d].end;if(v[d+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=S.edits.map(d=>({range:M.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,h,{setEndOfLine:typeof S.setEndOfLine=="number"?M.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$SO=A}),define(ke[73],De([1,0,62,4,3,2,5,6,153,20,157,17,11,27,15,39,46]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;class c{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,s){this.h=a,this.i=s,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new L.$fe,this.e=new L.$fe,this.f=new L.$fe,this.g=new L.$fe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const s=[],t=[],u=[];if(a.removedDocuments)for(const r of a.removedDocuments){const o=M.URI.revive(r),f=this.c.get(o);f?.unref()&&(this.c.delete(o),s.push(f.value))}if(a.addedDocuments)for(const r of a.addedDocuments){const o=M.URI.revive(r.uri);let f=this.c.get(o);if(f&&o.scheme!==v.Schemas.vscodeNotebookCell&&o.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);f||(f=new c(new $.$MO(this.h.getProxy(b.$gM.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this.c.set(o,f),t.push(f.value)),f.ref()}if(a.removedEditors)for(const r of a.removedEditors){const o=this.b.get(r);this.b.delete(r),o&&u.push(o)}if(a.addedEditors)for(const r of a.addedEditors){const o=M.URI.revive(r.documentUri);l.ok(this.c.has(o),`document '${o}' does not exist`),l.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const f=this.c.get(o).value,g=new A.$SO(r.id,this.h.getProxy(b.$gM.MainThreadTextEditors),this.i,new d.$V(()=>f.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(w=>I.Range.to(w)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,g)}a.newActiveEditor!==void 0&&(l.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,O.$Pc)(s),(0,O.$Pc)(u),a.removedDocuments&&this.e.fire(s),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return h.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const s=this.b.get(this.a);return a?s:s?.value}allEditors(){return[...this.b.values()]}};e.$TO=n,e.$TO=n=Je([We(0,E.$JO),We(1,p.$5j)],n),e.$UO=(0,R.$yi)("IExtHostDocumentsAndEditors")}),define(ke[360],De([1,0,19,4,6,157,17,8]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class ${constructor(A,I){this.i=I,this.a=new L.$fe,this.b=new L.$fe,this.c=new L.$fe,this.d=new L.$fe,this.f=new L.$fe,this.g=new L.$fe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(O.$gM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const I=this.i.allEditors();return A?I:I.map(p=>p.value)}async showTextDocument(A,I,p){let S;typeof I=="number"?S={position:R.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?S={position:R.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?R.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:S={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,S),h=v&&this.i.getEditor(v);if(h)return h.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,I){return new M.$QO(this.h,A,I).value}$acceptEditorPropertiesChanged(A,I){const p=this.i.getEditor(A);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const S=I.selections.selections.map(R.Selection.to);p._acceptSelections(S)}if(I.visibleRanges){const S=l.$Hb(I.visibleRanges.map(R.Range.to));p._acceptVisibleRanges(S)}if(I.options&&this.b.fire({textEditor:p.value,options:{...I.options,lineNumbers:R.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const S=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),v=I.selections.selections.map(R.Selection.to);this.a.fire({textEditor:p.value,selections:v,kind:S})}if(I.visibleRanges){const S=l.$Hb(I.visibleRanges.map(R.Range.to));this.c.fire({textEditor:p.value,visibleRanges:S})}}$acceptEditorPositionData(A){for(const I in A){const p=this.i.getEditor(I);if(!p)throw new Error("Unknown text editor");const S=R.ViewColumn.to(A[I]);p.value.viewColumn!==S&&(p._acceptViewColumn(S),this.d.fire({textEditor:p.value,viewColumn:S}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$5lc=$}),define(ke[361],De([1,0,2,5,6,3,8,17,25,18]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=e.$Nnc=void 0,e.$Nnc=(0,L.$yi)("IExtHostTimeline");class A{constructor(S,v){this.b=new Map,this.c=new Map,this.a=S.getProxy(O.$gM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(h,d)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&$.$Tm.equals(d,this.b.get(h.source)?.extension)){const c=h.uri===void 0?void 0:l.URI.revive(h.uri);return this.c.get(h.source)?.get(I(c))?.get(h.handle)}else return;return h}})}async $getTimeline(S,v,h,d){return this.b.get(S)?.provider.provideTimeline(l.URI.revive(v),h,d)}registerTimelineProvider(S,v,h,d){const c=new M.$Tc,n=this.d(v.id,d,c).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const a=this.c;return this.f({...v,scheme:S,onDidChange:void 0,async provideTimeline(s,t,u){t?.resetCache&&(c.clear(),a.get(v.id)?.clear());const r=await v.provideTimeline(s,t,u);if(r==null)return;const o=n(s,t);return{...r,source:v.id,items:r.items.map(o)}},dispose(){for(const s of a.values())s.get(v.id)?.clear();i?.dispose(),c.dispose()}},h)}d(S,v,h){return(d,c)=>{let n;if(c?.cacheResults){let i=this.c.get(S);i===void 0&&(i=new Map,this.c.set(S,i));const a=I(d);n=i.get(a),n===void 0&&(n=new Map,i.set(a,n))}return i=>{const{iconPath:a,...s}=i,t=`${S}|${i.id??i.timestamp}`;n?.set(t,i);let u,r,o;i.iconPath&&(a instanceof R.$fN?o={id:a.id,color:a.color}:l.URI.isUri(a)?(u=a,r=a):{light:u,dark:r}=a);let f;return R.$KM.isMarkdownString(s.tooltip)?f=b.MarkdownString.from(s.tooltip):(0,E.$$f)(s.tooltip)?f=s.tooltip:R.$KM.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=b.MarkdownString.from(s.detail)):(0,E.$$f)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=s.detail),{...s,id:s.id??void 0,handle:t,source:S,command:i.command?v.toInternal(i.command,h):void 0,icon:u,iconDark:r,themeIcon:o,tooltip:f,accessibilityInformation:i.accessibilityInformation}}}}f(S,v){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:v}),(0,M.$Sc)(()=>{for(const d of this.c.values())d.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$Onc=A;function I(p){return p?.toString()}}),define(ke[362],De([1,0,233,23,2,4,3,294,7,8,18,19,17,81,22,189,26]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;function c(a,s){if((0,A.$$f)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class n extends R.$Uc{constructor(s,t,u){super(),this.f=s,this.g=t,this.h=u,this.a=new Map,this.b=new h.$G0;function r(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>r(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(f=>r(f)?this.r(f):f):o})}registerTreeDataProvider(s,t,u){const r=this.createTreeView(s,{treeDataProvider:t},u);return{dispose:()=>r.dispose()}}createTreeView(s,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],f=!!t.dragAndDropController?.handleDrag,g=!!t.dragAndDropController?.handleDrop,w=this.m(s,t,u),k={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:o,hasHandleDrag:f,hasHandleDrop:g,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(s,k),y={get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get activeItem(){return(0,d.$SG)(u,"treeViewActiveItem"),w.focusedElement},get onDidChangeActiveItem(){return(0,d.$SG)(u,"treeViewActiveItem"),w.onDidChangeActiveItem},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get onDidChangeCheckboxState(){return w.onDidChangeCheckboxState},get message(){return w.message},set message(D){(0,S.$Xk)(D)&&(0,d.$SG)(u,"treeViewMarkdownMessage"),w.message=D},get title(){return w.title},set title(D){w.title=D},get description(){return w.description},set description(D){w.description=D},get badge(){return w.badge},set badge(D){D!==void 0&&E.ViewBadge.isViewBadge(D)?w.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(w.badge=void 0)},reveal:(D,C)=>w.reveal(D,C),dispose:async()=>{await m,this.a.delete(s),w.dispose()}};return this.B(y),y}$getChildren(s,t){const u=this.a.get(s);return u?u.getChildren(t):Promise.reject(new b.$7F(s))}async $handleDrop(s,t,u,r,o,f,g,w){const k=this.a.get(s);if(!k)return Promise.reject(new b.$7F(s));const m=p.DataTransfer.toDataTransfer(u,async y=>(await this.f.$resolveDropFileData(s,t,y)).buffer);return g===s&&w&&await this.j(m,k,w,o,f),k.onDrop(m,r,o)}async j(s,t,u,r,o){const f=this.b.removeDragOperationTransfer(o);if(f)(await f)?.forEach((g,w)=>{g&&s.set(w,g)});else if(o&&t.handleDrag){const g=t.handleDrag(u,s,r);this.b.addDragOperationTransfer(o,g),await g}return s}async $handleDrag(s,t,u,r){const o=this.a.get(s);if(!o)return Promise.reject(new b.$7F(s));const f=await this.j(new E.$bN,o,t,r,u);if(!(!f||r.isCancellationRequested))return p.DataTransfer.from(f)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new b.$7F(s);return t.hasResolve}$resolve(s,t,u){const r=this.a.get(s);if(!r)throw new b.$7F(s);return r.resolveTreeItem(t,u)}$setExpanded(s,t,u){const r=this.a.get(s);if(!r)throw new b.$7F(s);r.setExpanded(t,u)}$setSelectionAndFocus(s,t,u){const r=this.a.get(s);if(!r)throw new b.$7F(s);r.setSelectionAndFocus(t,u)}$setVisible(s,t){const u=this.a.get(s);if(!u){if(!t)return;throw new b.$7F(s)}u.setVisible(t)}$changeCheckboxState(s,t){const u=this.a.get(s);if(!u)throw new b.$7F(s);u.setCheckboxState(t)}m(s,t,u){const r=this.B(new i(s,t,this.f,this.g.converter,this.h,u));return this.a.set(s,r),r}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$Pnc=n;class i extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$hg)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,u,r,o,f){if(super(),this.I=s,this.J=u,this.L=r,this.M=o,this.N=f,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$fe),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$fe),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$fe),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$fe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$fe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$fe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$fe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$qe,f.contributes&&f.contributes.views)for(const m in f.contributes.views)for(const y of f.contributes.views[m])y.id===s&&(this.P=y.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>{Array.isArray(m)&&m.length===0||this.F.fire({message:!1,element:m})}));let g,w;const k=M.Event.debounce(this.F.event,(m,y)=>(m||(m={message:!1,elements:[]}),y.element!==!1&&(g||(g=new Promise(D=>w=D),this.G=this.G.then(()=>g)),Array.isArray(y.element)?m.elements.push(...y.element):m.elements.push(y.element)),y.message&&(m.message=!0),m),200,!0);this.B(k(({message:m,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=w;return g=null,this.$(y).then(()=>D())})),m&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let u=this.X(s);return u||(u=await this.Y(t)),u?u.map(r=>r.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const u=(0,A.$hg)(t.select)?!0:t.select,r=(0,A.$hg)(t.focus)?!1:t.focus,o=(0,A.$hg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(f=>this.W(s,f[f.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:f.map(w=>w.item)},{select:u,focus:r,expand:o})),f=>this.M.error(f)):this.J.$reveal(this.I,void 0,{select:u,focus:r,expand:o})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=p.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const u=this.getExtensionElement(s);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(s,t){const u=!(0,I.$ub)(this.s,s);this.s=s;const r=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async u=>{const r=this.getExtensionElement(u.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:u.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(s,t,u){const r=[];for(const o of s){const f=this.getExtensionElement(o);f&&r.push(f)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,u){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,$.$qh)(()=>this.g?.handleDrop?this.g.handleDrop(r,s,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(s);if(u){const r=this.m.get(u);if(r){const o=await this.f.resolveTreeItem(r.extensionItem,u,t)??r.extensionItem;return this.hb(o),r.item.tooltip=this.eb(o.tooltip),r.item.command=this.fb(r.disposableStore,o.command),r.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(r=>(u.push(r),u))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$qh)(()=>this.f.getParent(s))}W(s,t){const u=this.m.get(s);return u?Promise.resolve(u):(0,$.$qh)(()=>this.f.getTreeItem(s)).then(r=>this.kb(s,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(r);if(o){const f=this.m.get(o);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const u=this.getExtensionElement(s);t=u?this.m.get(u):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$qe(this.Z.token);try{const u=s?this.m.get(s):void 0,r=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const o=(0,I.$Hb)(r||[]),f=await Promise.all((0,I.$Hb)(o).map(w=>this.f.getTreeItem(w)));if(t.token.isCancellationRequested)return;const g=f.map((w,k)=>w?this.db(o[k],w,u):null);return(0,I.$Hb)(g)}finally{t.dispose()}}$(s){if(s.some(u=>!u))return this.Z.dispose(!0),this.Z=new v.$qe,this.tb(),this.J.$refresh(this.I);{const u=this.ab(s);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(s){const t=new Set,u=s.map(o=>this.m.get(o));for(const o of u)if(o&&!t.has(o.item.handle)){let f=o;for(;f&&f.parent&&u.findIndex(g=>f&&f.parent&&g&&g.item.handle===f.parent.item.handle)===-1;){const g=this.j.get(f.parent.item.handle);f=g?this.m.get(g):void 0}f&&!f.parent&&t.add(o.item.handle)}const r=[];return t.forEach(o=>{const f=this.j.get(o);if(f){const g=this.m.get(f);g&&(!g.parent||!t.has(g.parent.item.handle))&&r.push(o)}}),r}bb(s){const t={};return Promise.all(s.map(u=>this.cb(u).then(r=>{r&&(t[u]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,$.$qh)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const o=this.ib(t,r,u.parent);return this.pb(t,o,u,u.parent),u.dispose(),o}return null})}return Promise.resolve(null)}db(s,t,u){const r=this.ib(s,t,u);if(t.id&&this.j.has(r.item.handle))throw new Error((0,l.localize)(0,null,t.id));return this.ob(s,r),this.qb(r,u),r}eb(s){return E.$KM.isMarkdownString(s)?p.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,u,r;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,u=s.checkboxState.tooltip,r=s.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:r}}hb(s){if(!E.$9M.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,u){this.hb(t);const r=this.B(new R.$Tc),o=this.kb(s,t,u),f=this.lb(t);return{item:{handle:o,parentHandle:u?u.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:f,iconDark:this.mb(t)||f,themeIcon:this.jb(t),collapsibleState:(0,A.$hg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(s){return s.iconPath instanceof E.$fN?s.iconPath:void 0}kb(s,{id:t,label:u,resourceUri:r},o,f){if(t)return`${i.b}/${t}`;const g=c(u,this.N),w=o?o.item.handle:i.a;let k=g?g.label:r?(0,L.$9g)(r):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const m=this.m.has(s)?this.m.get(s).item.handle:void 0,y=this.X(o)||[];let D,C=0;do{if(D=`${w}/${C}:${k}`,f||!this.j.has(D)||m===D)break;C++}while(C<=y.length);return D}lb(s){if(s.iconPath&&!(s.iconPath instanceof E.$fN))return typeof s.iconPath=="string"||O.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof E.$fN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return O.URI.isUri(s)?s:O.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,u,r){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(s,t);const o=this.X(r)||[],f=o.filter(g=>g.item.handle===u.item.handle)[0];f&&o.splice(o.indexOf(f),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const u of t.children){const r=this.j.get(u.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const u of t.children){const r=this.j.get(u.item.handle);r&&this.sb(r)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[363],De([1,0,4,3,2,30,17,92,6,8]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class A extends L.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,h,d,c){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new l.$fe),this.onDidDispose=this.#d.event,this.#h=this.B(new l.$fe),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=h,this.#i=d,this.#n=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#u=c.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,O.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:R.ViewColumn.from(v),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends L.$Uc{static c(){return(0,M.$Ug)()}constructor(v,h,d){super(),this.j=h,this.m=d,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$gM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,h,d,c,n={}){const i=typeof c=="object"?c.viewColumn:c,a={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},s=(0,b.$hmc)(v),t=I.c();this.f.$createWebviewPanel((0,b.$jmc)(v),t,h,{title:d,panelOptions:p(n),webviewOptions:(0,b.$kmc)(v,this.m,n),serializeBuffersForPostMessage:s},a);const u=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,h,d,i,n,u,!0)}$onDidChangeWebviewPanelViewStates(v){const h=Object.keys(v);h.sort((d,c)=>{const n=v[d],i=v[c];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const d of h){const c=this.getWebviewPanel(d);if(!c)continue;const n=v[d];c._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,h,d){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:d,extension:v}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,b.$hmc)(v)}),new E.$iM(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(v,h,d,c){const n=this.h.get(h);if(!n)throw new Error(`No serializer found for '${h}'`);const{serializer:i,extension:a}=n,s=this.j.createNewWebview(v,d.webviewOptions,a),t=this.createNewWebviewPanel(v,h,d.title,c,d.panelOptions,s,d.active);await i.deserializeWebviewPanel(t,d.state)}createNewWebviewPanel(v,h,d,c,n,i,a){const s=new A(v,this.f,i,{viewType:h,title:d,viewColumn:c,panelOptions:n,active:a});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$lmc=I;function p(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(ke[364],De([1,0,4,3,92,17,6,8]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=void 0;class $ extends L.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(I,p,S,v,h,d){super(),this.#s=!1,this.#u=this.B(new l.$fe),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new l.$fe),this.onDidDispose=this.#l.event,this.#n=S,this.#a=v,this.#e=I,this.#t=p,this.#i=h,this.#r=d}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#o}set description(I){this.a(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(R.$gM.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,S,v){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:S,extension:I}),this.a.$registerWebviewViewProvider((0,O.$jmc)(I),p,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,O.$hmc)(I)}),new b.$iM(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,S,v,h){const d=this.b.get(p);if(!d)throw new Error(`No view provider found for '${p}'`);const{provider:c,extension:n}=d,i=this.d.createNewWebview(I,{},n),a=new $(I,this.a,p,S,i,!0);this.c.set(I,a),await c.resolveWebviewView(a,{state:v},h)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$Snc=E}),define(ke[365],De([1,0,70,15,11,265,33,12]),function(he,e,l,L,O,M,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0;let $=class{constructor(I,p){I.addFileSystemProvider(L.Schemas.file,new E(p),{isCaseSensitive:b.$k})}};e.$xoc=$,e.$xoc=$=Je([We(0,l.$dmc),We(1,O.$5j)],$);class E{constructor(I){this.b=I,this.a=new M.$cr(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,S){return this.a.writeFile(I,p,{...S,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,S){return this.a.rename(I,p,S)}copy(I,p,S){return this.a.copy(I,p,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(ke[366],De([1,0,16,64,30,34,3,6,2,20]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;let A=class extends R.$Uc{constructor(p,S){super();const v=p.getProxy(b.$gM.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async h=>{const d=$.URI.file((0,l.$jc)((0,L.tmpdir)(),(0,O.$Ug)()));return await v.$download(h,d),d})}};e.$voc=A,e.$voc=A=Je([We(0,E.$JO),We(1,M.$6O)],A)}),define(ke[367],De([1,0,53,16,2,93,3,15,7,32]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=void 0;class A extends M.$fmc{constructor(){super(...arguments),this.i=null}async g(t){const u=await super.g(t);if(u.scheme!==b.Schemas.file)return u;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const r=u.fsPath;let o=0;do{let f;o===0?f=r:f=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await I(f);const g=L.$jc(f,"vscode.lock"),w=await h(this.d,g,!1);if(w)return this.i=w,process.on("exit",()=>{w.dispose()}),O.URI.file(f);o++}while(o<10);return u}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Hoc=A;async function I(s){try{await E.Promises.stat(s);return}catch{}try{await E.Promises.mkdir(s,{recursive:!0})}catch{}}const p=1e3,S=10*60*1e3;class v extends R.$Uc{constructor(t,u){super(),this.b=t,this.c=u,this.a=this.B(new $.$Jh),this.a.cancelAndSet(async()=>{const r=await d(t,u);(!r||r.pid!==process.pid)&&(t.info(`Lock '${u}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(u,new Date,new Date)}catch(o){t.error(o),t.info(`Lock '${u}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{l.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(u),{flag:"w"})}catch(u){this.b.error(u)}}}async function h(s,t,u){try{const o={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(o),{flag:"wx"})}catch(o){s.error(o)}const r=await d(s,t);return!r||r.pid!==process.pid?u?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function d(s,t){let u;try{u=await E.Promises.readFile(t)}catch(r){return s.error(r),null}try{return JSON.parse(String(u))}catch(r){return s.error(r),null}}async function c(s,t){let u;try{u=await E.Promises.stat(t)}catch(r){return s.error(r),0}return u.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const u=await d(s,t);if(!u)return s.info(`Lock '${t}': Could not read pid of lock holder.`),a(s,t);if(u.willReleaseAt){let w=u.willReleaseAt-Date.now();if(w<5e3){for(w>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${w} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);w>0;){if(await(0,$.$zh)(Math.min(100,w)),await c(s,t)===0)return a(s,t);w=u.willReleaseAt-Date.now()}return a(s,t)}}if(!n(u.pid))return s.info(`Lock '${t}': The pid ${u.pid} appears to be gone.`),a(s,t);const r=await c(s,t),o=Date.now()-r;if(o<=S)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$zh)(2e3);const f=await c(s,t),g=Date.now()-f;return g<=S?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),a(s,t))}async function a(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return h(s,t,!0)}}),define(ke[368],De([1,0,30,20,43,34]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;let R=class extends O.$Bmc{constructor($,E){super(!0,$,E)}createTerminal($,E,A){return this.createTerminalFromOptions({name:$,shellPath:E,shellArgs:A})}createTerminalFromOptions($,E){const A=new O.$Amc(this.a,(0,l.$Ug)(),$,$.name);return this.f.push(A),A.create($,this.R($,E)),A.value}};e.$3nc=R,e.$3nc=R=Je([We(0,M.$6O),We(1,L.$JO)],R)}),define(ke[369],De([1,0,4,36,38,5]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$BL=e.OutputChannelUpdateMode=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=void 0,e.$oL="text/x-code-output",e.$pL="output",e.$qL="Log",e.$rL="text/x-code-log-output",e.$sL="log",e.$tL="workbench.panel.output",e.$uL=new O.$Pj("inOutput",!1),e.$vL=new O.$Pj("activeLogOutput",!1),e.$wL=new O.$Pj("activeLogOutput.levelSettable",!1),e.$xL=new O.$Pj("activeLogOutput.level",""),e.$yL=new O.$Pj("activeLogOutput.levelIsDefault",!1),e.$zL=new O.$Pj("outputView.scrollLock",!1),e.$AL=(0,M.$yi)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$BL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new l.$fe,this.onDidRegisterChannel=this.b.event,this.c=new l.$fe,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(A=>E.push(A)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}L.$fo.add(e.$BL.OutputChannels,new b),e.$CL=new O.$Pj("activeOutputChannel","")}),define(ke[158],De([1,0,6,5,20,25,11,369,70,28,60,194,21,18,33,4,3]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0;class c extends R.$$j{get disposed(){return this.n}constructor(s,t,u,r,o){super(),this.id=s,this.name=t,this.r=u,this.s=r,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=p.$He.fromString(t).byteLength,(0,R.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends c{appendLine(s){this.append(s)}}let i=class{constructor(s,t,u,r,o,f){this.i=t,this.j=u,this.k=r,this.l=o,this.m=f,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(l.$gM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(s,t,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,o=(0,S.$$f)(t)?t:void 0;if((0,S.$$f)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const g=this.i.environment.extensionLogLevel?.find(([k])=>M.$Tm.equals(u.identifier,k))?.[1];g&&(f=(0,R.$jk)(g));const w=r?this.o(s,f,u):this.n(s,o,u);return w.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),r?this.r(s,f??this.m.getLevel(),w):this.q(s,w)}async n(s,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,o=this.k.extUri.joinPath(r,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(s,o,t,u.identifier.value);return new c(g,s,f,this.a,u)}async o(s,t,u){const r=await this.p(u),o=s.replace(/[\\/:\*\?"<>\|]/g,""),f=this.k.extUri.joinPath(r,`${o}.log`),g=`${u.identifier.value}.${o}`,w=this.l.createLogger(f,{id:g,name:s,logLevel:t,extensionId:u.identifier.value});return new n(g,s,w,this.a,u)}p(s){let t=this.d.get(s.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(r){if((0,v.$il)(r)!==v.FileSystemProviderErrorCode.FileExists)throw r}return u})())}return t}q(s,t){let u=!1;const r=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return s},append(o){r(),t.then(f=>f.append(o))},appendLine(o){r(),t.then(f=>f.appendLine(o))},clear(){r(),t.then(o=>o.clear())},replace(o){r(),t.then(f=>f.replace(o))},show(o,f){r(),t.then(g=>g.show(o,f))},hide(){r(),t.then(o=>o.hide())},dispose(){u=!0,t.then(o=>o.dispose())}}}r(s,t,u){const r=new d.$Tc,o=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},f=r.add(new h.$fe);function g(w){t=w,f.fire(w)}return u.then(w=>{r.add(w),w.logLevel!==t&&g(w.logLevel),r.add(w.onDidChangeLogLevel(k=>g(k)))}),{...this.q(s,u),get logLevel(){return t},onDidChangeLogLevel:f.event,trace(w,...k){o(),u.then(m=>m.trace(w,...k))},debug(w,...k){o(),u.then(m=>m.debug(w,...k))},info(w,...k){o(),u.then(m=>m.info(w,...k))},warn(w,...k){o(),u.then(m=>m.warn(w,...k))},error(w,...k){o(),u.then(m=>m.error(w,...k))},dispose(){r.dispose()}}}};e.$rnc=i,e.$rnc=i=Je([We(0,O.$JO),We(1,E.$ZO),We(2,$.$dmc),We(3,A.$Slc),We(4,R.$6j),We(5,R.$5j)],i),e.$snc=(0,L.$yi)("IExtHostOutputService")}),define(ke[159],De([1,0,5,7]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,l.$yi)("remoteAgentService"),e.$jn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(O){let M=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await O.getRoundTripTime();if($===void 0)return;M=Math.min(M,$/2),await(0,L.$zh)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[370],De([1,0,237,66,36,42,55,3,4,159,12,24,7]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=e.$Jgb=e.$Igb=void 0,e.$Igb=Object.freeze({id:"application",order:100,title:(0,l.localize)(0,null),type:"object"}),e.$Jgb=Object.freeze({id:"workbench",order:7,title:(0,l.localize)(1,null),type:"object"}),e.$Kgb=Object.freeze({id:"security",scope:1,title:(0,l.localize)(2,null),type:"object",order:7}),e.$Lgb=Object.freeze({id:"problems",title:(0,l.localize)(3,null),type:"object",order:101}),e.$Mgb={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new $.$fe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new S;O.$fo.add(e.$Mgb.ConfigurationMigration,v);let h=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const s of a.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(a=>this.g(a,n?.uri))])}async g(n,i){const a=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,u]of s){const r=a[t];if(!r)continue;const o=[];if(r.value!==void 0){const f=await this.h(n,t,r.value,i,void 0);for(const g of f??[])o.push([g,[]])}for(const{identifiers:f,value:g}of r.overrides??[])if(g!==void 0){const w=await this.h(n,t,g,i,f);for(const k of w??[])o.push([k,f])}o.length&&await Promise.allSettled(o.map(async([[f,g],w])=>this.a.updateValue(f,g.value,{resource:i,overrideIdentifiers:w},u)))}}async h(n,i,a,s,t){const u=o=>{const g=this.a.inspect(o,{resource:s})[i];if(g)return t?g.overrides?.find(({identifiers:w})=>(0,I.$9n)(w,t))?.value:g.value},r=await n.migrateFn(a,u);return Array.isArray(r)?r:[[n.key,r]]}};e.$Ngb=h,e.$Ngb=h=Je([We(0,R.$5i),We(1,M.$Hi)],h);let d=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new p.$Vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;O.$fo.as(L.$ko.Configuration).registerConfiguration({...e.$Kgb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,l.localize)(4,null)},default:[],markdownDescription:(0,l.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,l.localize)(6,null),scope:2}}})}};e.$Ogb=d,e.$Ogb=d=Je([We(0,E.$in)],d)}),define(ke[371],De([1,0,35,15,16,23,247,370,66,5,36]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Qgb=e.$Pgb=void 0,e.$Rgb=h,e.$Sgb=d,e.$Pgb=(0,E.$yi)("editorResolverService"),e.$Qgb="workbench.editorAssociations";const I=A.$fo.as($.$ko.Configuration),p={...b.$Jgb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(p);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var v;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function h(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function d(c,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof c=="string"&&c.indexOf(O.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$9g)(n);return l.$rk(typeof c=="string"?c.toLowerCase():c,s.toLowerCase())}}),define(ke[372],De([1,0,31,15,16,12,23,2,5,284,42,148,159]),function(he,e,l,L,O,M,R,b,$,E,A,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=void 0,e.$UL=(0,$.$yi)("pathService");let v=S=class{constructor(d,c,n,i){this.d=d,this.e=c,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??d})()}hasValidBasename(d,c,n){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(d,i,c)):this.h(d,c,n)}h(d,c,n){return d.scheme===L.Schemas.file||d.scheme===L.Schemas.vscodeRemote?(0,l.$vg)(n??(0,R.$9g)(d),c===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,c){if(d.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,E.$RL)(c.getWorkspace());if(n)return n;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=c.getWorkspace().configuration;return a?a.scheme:L.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?O.$fc:O.$gc)}async fileURI(d){let c="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const i=d.indexOf("/",2);i===-1?(c=d.substring(2),d="/"):(c=d.substring(2,i),d=d.substring(i)||"/")}return b.URI.from({scheme:L.Schemas.file,authority:c,path:d,query:"",fragment:""})}};e.$VL=v,e.$VL=v=S=Je([We(1,p.$in),We(2,I.$DL),We(3,A.$Hi)],v)}),define(ke[373],De([1,0,249,56,4,57,3,2,55,254,11,67,142,88,42,148,26,22,18,24,38]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.OnPortForward=e.$IL=e.$HL=e.TunnelSource=e.TunnelCloseReason=e.$FL=e.$EL=void 0,e.$GL=o,e.$JL=w,e.$KL=k,e.$LL=m,e.$ML=D;const s=10*1e3,t="remote.tunnels.toRestore",u="remote.tunnels.toRestoreExpiration",r=1e3*60*60*24*14;e.$EL="onTunnel",e.$FL=new a.$Pj("forwardedPortsViewEnabled",!1,l.localize(0,null));function o(j){const T=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var f;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(f||(e.TunnelCloseReason=f={}));var g;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$HL={source:g.User,description:l.localize(1,null)},e.$IL={source:g.Auto,description:l.localize(2,null)};function w(j,T,z){const N=j.get(m(T,z));if(N)return N;if((0,S.$rw)(T))for(const F of S.$qw){const U=m(F,z);if(j.has(U))return j.get(U)}else if((0,S.$tw)(T))for(const F of S.$sw){const U=m(F,z);if(j.has(U))return j.get(U)}}function k(j,T,z){const N=w(j,T,z);if(N)return N;const F=(0,S.$tw)(T)?"localhost":(0,S.$rw)(T)?"0.0.0.0":void 0;if(F)return w(j,F,z)}function m(j,T){return j+":"+T}var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function D(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class C extends R.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new O.$fe,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(z=>{(z.affectsConfiguration(C.c)||z.affectsConfiguration(C.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,z,N){let F=this.w(T,z,N,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const Y=this.j[F];Y.key===T?(U.onAutoForward=Y.onAutoForward??U.onAutoForward,U.elevateIfNeeded=Y.elevateIfNeeded!==void 0?Y.elevateIfNeeded:U.elevateIfNeeded,U.label=Y.label??U.label,U.requireLocalPort=Y.requireLocalPort,U.protocol=Y.protocol):(U.onAutoForward=U.onAutoForward??Y.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:Y.elevateIfNeeded,U.label=U.label??Y.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??Y.protocol),F=this.w(T,z,N,this.j,F+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,n.$$f)(T.host)&&(0,n.$cg)(T.port)}w(T,z,N,F,U){if(U>=F.length)return-1;const Y=!(0,S.$rw)(z)&&!(0,S.$tw)(z),H=F.slice(U).findIndex(J=>(0,n.$cg)(J.key)?Y?!1:J.key===T:this.t(J.key)?Y?!1:T>=J.key.start&&T<=J.key.end:this.u(J.key)?T===J.key.port&&z===J.key.host:N?J.key.test(N):!1);return H>=0?H+U:-1}y(){const T=this.r.getValue(C.c);if(!T||!(0,n.$ag)(T))return[];const z=[];for(const F in T){if(F===void 0)continue;const U=T[F];let Y;if(Number(F))Y=Number(F);else if((0,n.$$f)(F))if(C.g.test(F)){const ie=F.match(C.g);Y={start:Number(ie[1]),end:Number(ie[2])}}else if(C.h.test(F)){const ie=F.match(C.h);Y={host:ie[1],port:Number(ie[2])}}else{let ie;try{ie=RegExp(F)}catch{}ie&&(Y=ie)}Y&&z.push({key:Y,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const N=this.r.getValue(C.f);return N&&(this.m={elevateIfNeeded:N.elevateIfNeeded,label:N.label,onAutoForward:N.onAutoForward,requireLocalPort:N.requireLocalPort,protocol:N.protocol}),this.z(z)}z(T){function z(N,F){return(0,n.$cg)(N.key)?N.key:F.t(N.key)?N.key.start:F.u(N.key)?N.key.port:Number.MAX_VALUE}return T.sort((N,F)=>z(N,this)-z(F,this))}C(){return this.m}static providedActionToAction(T){switch(T){case S.ProvidedOnAutoForward.Notify:return y.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case S.ProvidedOnAutoForward.Silent:return y.Silent;case S.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(T,z,N){const U=this.r.inspect(C.c).userRemoteValue;let Y;!U||!(0,n.$ag)(U)?Y={}:Y=(0,i.$5n)(U),Y[`${T}`]||(Y[`${T}`]={});for(const ie in z)Y[`${T}`][ie]=z[ie];return this.r.updateValue(C.c,Y,N)}}e.$NL=C;let P=class extends R.$Uc{constructor(T,z,N,F,U,Y,ie,H,J,x){super(),this.H=T,this.I=z,this.J=N,this.L=F,this.M=U,this.N=Y,this.O=ie,this.P=H,this.Q=J,this.R=x,this.c=new Map,this.g=new O.$fe,this.onForwardPort=this.g.event,this.h=new O.$fe,this.onClosePort=this.h.event,this.j=new O.$fe,this.onPortName=this.j.event,this.n=new O.$fe,this.onCandidatesChanged=this.n.event,this.t=new O.$fe,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new O.$fe,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new C(N),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const be=await this.getAttributes(ne.map(ae=>({port:ae.tunnelRemotePort,host:ae.tunnelRemoteHost})));for(const ae of ne)if(ae.localAddress){const Ie=m(ae.tunnelRemoteHost,ae.tunnelRemotePort),ee=k(this.m??new Map,ae.tunnelRemoteHost,ae.tunnelRemotePort);this.forwarded.set(Ie,{remotePort:ae.tunnelRemotePort,remoteHost:ae.tunnelRemoteHost,localAddress:ae.localAddress,protocol:be?.get(ae.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(ae.localAddress,be?.get(ae.tunnelRemotePort)),localPort:ae.tunnelLocalPort,runningProcess:ee?.detail,hasRunningProcess:!!ee,pid:ee?.pid,privacy:ae.privacy,source:e.$HL}),this.f.set(Ie,ae)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const be=m(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!k(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!k(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!k(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const ae=k(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),Ie=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set(be,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:Ie?.protocol??S.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,Ie),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,privacy:ne.privacy,source:e.$HL})}await this.cb(),this.f.set(be,ne),this.g.fire(this.forwarded.get(be))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,f.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$EL))?(this.R.createKey(e.$FL.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,z){const N=m(T.host,T.port);this.forwarded.has(N)&&(this.forwarded.delete(N),await this.cb(),this.h.fire(T))}X(T,z){if(T.startsWith("http"))return b.URI.parse(T);const N=z?.protocol??"http";return b.URI.parse(`${N}://${T}`)}async Y(T){const z=this.N.getWorkspace(),N=z.configuration?(0,M.$mj)(z.configuration.path):z.folders.length>0?(0,M.$mj)(z.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${N}`}async Z(){return this.Y(t)}async $(){return this.Y(u)}async ab(){const T=this.I.get(t,1);if(T)return this.I.remove(t,1),await this.cb(),T;const z=await this.Z();if(z)return this.I.get(z,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const z=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${z.map(N=>N.remotePort).join(", ")}`);for(const N of z){const F=k(this.detected,N.remoteHost,N.remotePort);N.source.source!==g.Extension&&!F||N.source.source===g.Extension&&F?await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,elevateIfNeeded:!0,source:N.source}):N.source.source===g.Extension&&!F&&this.D.set(m(N.remoteHost,N.remotePort),N)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new R.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async z=>{z.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(z=>z.startsWith(u));for(const z of T){const N=this.I.getNumber(z,0);if(N&&N<Date.now()){this.s=Promise.resolve(void 0);const F=z.replace(u,t);this.I.remove(z,0),this.I.remove(F,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),z=T.map(Y=>({remoteHost:Y.remoteHost,remotePort:Y.remotePort,localPort:Y.localPort,name:Y.name,localAddress:Y.localAddress,localUri:Y.localUri,protocol:Y.protocol,source:Y.source}));let N;T.length>0&&(N=JSON.stringify(z));const F=await this.Z(),U=await this.$();!N&&F&&U?(this.I.remove(F,0),this.I.remove(U,0)):N!==this.y&&F&&U&&(this.I.store(F,N,0,0),this.I.store(U,Date.now()+r,0,0)),this.y=N}}async eb(T,z,N){if(!T.tunnelLocalPort||!N?.requireLocalPort||T.tunnelLocalPort===z)return;const F=new Date;if(this.db.getTime()+s>F.getTime())return;this.db=F;const U=l.localize(3,null,z,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(U)}async forward(T,z){return!this.z&&this.L.remoteAuthority&&await O.Event.toPromise(this.C.event),this.fb(T,z)}async fb(T,z){await this.Q.activateByEvent(e.$EL);const N=k(this.forwarded,T.remote.host,T.remote.port);z=z??(z!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const F=T.local!==void 0?T.local:T.remote.port;let U;if(N)return this.hb(N,T,z);{const Y=this.L.remoteAuthority,ie=Y?{getAddress:async()=>(await this.M.resolveAuthority(Y)).authority}:void 0,H=m(T.remote.host,T.remote.port);this.c.set(H,!0),T=this.gb(H,T);const J=await this.H.openTunnel(ie,T.remote.host,T.remote.port,void 0,F,T.elevateIfNeeded?T.elevateIfNeeded:z?.elevateIfNeeded,T.privacy,z?.protocol);if(typeof J=="string")U=J;else if(J&&J.localAddress){const x=k(this.m??new Map,T.remote.host,T.remote.port),ne=J.protocol?J.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:z?.protocol??S.TunnelProtocol.Http,be={remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localPort:J.tunnelLocalPort,name:z?.label??T.name,closeable:!0,localAddress:J.localAddress,protocol:ne,localUri:await this.X(J.localAddress,z),runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,source:T.source??e.$HL,privacy:J.privacy};return this.forwarded.set(H,be),this.f.set(H,J),this.c.delete(H),await this.cb(),await this.eb(J,F,z),this.g.fire(be),J}this.c.delete(H)}return U}gb(T,z){const N=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(N){const F=N.get(T);N.delete(T),F&&(z.name=F.name??z.name,z.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??z.local,z.privacy=z.privacy)}return z}async hb(T,z,N){const F=N?.label??z.name;let U;(function(ie){ie[ie.None=0]="None",ie[ie.Fire=1]="Fire",ie[ie.Reopen=2]="Reopen"})(U||(U={}));let Y=U.None;switch(F!==T.name&&(T.name=F,Y=U.Fire),(N?.protocol||T.protocol!==S.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&(z.source=T.source,Y=U.Reopen),z.privacy&&T.privacy!==z.privacy&&(Y=U.Reopen),Y){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(T.remoteHost,T.remotePort,f.User),await this.fb(z,N)}return k(this.f,z.remote.host,z.remote.port)}async name(T,z,N){const F=k(this.forwarded,T,z),U=m(T,z);if(F){F.name=N,await this.cb(),this.j.fire({host:T,port:z});return}else this.detected.has(U)&&(this.detected.get(U).name=N,this.j.fire({host:T,port:z}))}async close(T,z,N){const F=m(T,z),U=this.forwarded.get(F);return N===f.AutoForwardEnd&&U&&U.source.source===g.Auto&&this.F.set(F,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(T,z),this.W({host:T,port:z},N)}address(T,z){const N=m(T,z);return(this.forwarded.get(N)||this.detected.get(N))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const z of T){const N=k(this.m??new Map,z.remoteAddress.host,z.remoteAddress.port),F=typeof z.localAddress=="string"?z.localAddress:m(z.localAddress.host,z.localAddress.port);this.detected.set(m(z.remoteAddress.host,z.remoteAddress.port),{remoteHost:z.remoteAddress.host,remotePort:z.remoteAddress.port,localAddress:F,protocol:S.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:N?.detail,hasRunningProcess:!!N,pid:N?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:l.localize(4,null)}}),this.H.setEnvironmentTunnel(z.remoteAddress.host,z.remoteAddress.port,F,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let z=T;this.r&&(z=await this.r(T));const N=this.ib(z);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(N.values()).map(F=>F.port).join(", ")}`),this.n.fire(N)}ib(T){const z=this.m??new Map,N=new Map;return this.m=N,T.forEach(F=>{const U=m(F.host,F.port);N.set(U,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),z.has(U)&&z.delete(U);const Y=k(this.forwarded,F.host,F.port);Y&&(Y.runningProcess=F.detail,Y.hasRunningProcess=!0,Y.pid=F.pid)}),z.forEach((F,U)=>{const Y=o(U);if(!Y)return;const ie=k(this.forwarded,Y.host,Y.port);ie&&(ie.runningProcess=void 0,ie.hasRunningProcess=!1,ie.pid=void 0);const H=k(this.detected,Y.host,Y.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0)}),z}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),z=await this.getAttributes(T.map(N=>({port:N.remotePort,host:N.remoteHost})),!1);if(z)for(const N of T){const F=z.get(N.remotePort);(F?.protocol||N.protocol!==S.TunnelProtocol.Http)&&F?.protocol!==N.protocol&&await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,source:N.source},F),F&&F.label&&F.label!==N.name&&await this.name(N.remoteHost,N.remotePort,F.label)}}async getAttributes(T,z=!0){const N=new Map,F=new Map;T.forEach(J=>{const x=k(this.m??new Map,S.$qw[0],J.port)??J;if(x){N.set(J.port,x);const ne=D(x)?x.pid:void 0;F.has(ne)||F.set(ne,[]),F.get(ne)?.push(J.port)}});const U=new Map;if(T.forEach(J=>{const x=this.configPortsAttributes.getAttributes(J.port,J.host,N.get(J.port)?.detail);x&&U.set(J.port,x)}),this.G.length===0||!z)return U.size>0?U:void 0;const Y=await Promise.all(this.G.flatMap(J=>Array.from(F.entries()).map(x=>{const ne=x[1],be=N.get(ne[0]);return J.providePortAttributes(ne,be?.pid,be?.detail,c.CancellationToken.None)}))),ie=new Map;if(Y.forEach(J=>J.forEach(x=>{x&&ie.set(x.port,x)})),!U&&!ie)return;const H=new Map;return T.forEach(J=>{const x=U.get(J.port),ne=ie.get(J.port);H.set(J.port,{elevateIfNeeded:x?.elevateIfNeeded,label:x?.label,onAutoForward:x?.onAutoForward??C.providedActionToAction(ne?.autoForwardAction),requireLocalPort:x?.requireLocalPort,protocol:x?.protocol})}),H}addAttributesProvider(T){this.G.push(T)}};e.$OL=P,Je([(0,L.$4h)(1e3)],P.prototype,"cb",null),e.$OL=P=Je([We(0,S.$lw),We(1,p.$4p),We(2,$.$5i),We(3,h.$DL),We(4,I.$Jl),We(5,v.$Hi),We(6,A.$5j),We(7,E.$Qw),We(8,d.$OG),We(9,a.$Qj)],P)}),define(ke[94],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$nK=e.$mK=void 0;class l{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new l(0,0)}with(R){return new l(0,0)}}e.$mK=l;class L{constructor(R,b,$,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(R,b),this.end=new l($,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$nK=L;var O;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(ke[37],De([1,0,19,35,24,31,14,5,16,13,94,7]),function(he,e,l,L,O,M,R,b,$,E,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$KK=e.$DK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$AK=e.$zK=e.$yK=e.$xK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.TextSearchCompleteMessageType=void 0,e.$uK=c,e.$vK=n,e.$wK=i,e.$BK=w,e.$CK=k,e.$EK=D,e.$FK=C,e.$GK=P,e.$HK=j,e.$IK=T,e.$JK=z,e.$LK=F,e.$NK=ie,e.$OK=H,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$oK="workbench.view.search",e.$pK="workbench.panel.search",e.$qK="workbench.view.search",e.$rK="search-result",e.$sK="search.exclude";const p="\u27EA ",S=" characters skipped \u27EB",v=(p.length+S.length+5)*2;e.$tK=(0,b.$yi)("searchService");var h;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(h||(e.SearchProviderType=h={}));var d;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(d||(e.QueryType=d={}));function c(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var a;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class s{constructor(ne){this.resource=ne,this.results=[]}}e.$xK=s;class t{constructor(ne,be,ae,Ie){this.ranges=be,this.webviewIndex=Ie;const ee=Array.isArray(be)?be:[be];if(ae&&ae.matchLines===1&&u(ee)){ne=(0,R.$4f)(ne,ae.matchLines);let B="",_=0,pe=0;const ue=Math.floor(ae.charsPerLine/5),ce=[];for(const oe of ee){const le=Math.max(oe.startColumn-ue,0),K=oe.startColumn+ae.charsPerLine;if(le>pe+ue+v){const se=p+(le-pe)+S;B+=se+ne.slice(le,K),_+=le-(pe+se.length)}else B+=ne.slice(pe,K);ce.push(new o(0,oe.startColumn-_,oe.endColumn-_)),pe=K}this.preview={text:B,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const B=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:ne,matches:(0,l.$1b)(be,_=>new r(_.startLineNumber-B,_.startColumn,_.endLineNumber-B,_.endColumn))}}}}e.$yK=t;function u(x){const ne=x[0].startLineNumber;for(const be of x)if(be.startLineNumber!==ne||be.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,be,ae,Ie){this.startLineNumber=ne,this.startColumn=be,this.endLineNumber=ae,this.endColumn=Ie}}e.$zK=r;class o extends r{constructor(ne,be,ae){super(ne,be,ne,ae)}}e.$AK=o;var f;(function(x){x.List="list",x.Tree="tree"})(f||(e.ViewMode=f={}));var g;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function w(x,ne=!0){const be=x&&x.files&&x.files.exclude,ae=ne&&x&&x.search&&x.search.exclude;if(!be&&!ae)return;if(!be||!ae)return be||ae;let Ie=Object.create(null);return Ie=O.$8n(Ie,O.$5n(be)),Ie=O.$8n(Ie,O.$5n(ae),!0),Ie}function k(x,ne){return x.excludePattern&&L.$rk(x.excludePattern,ne)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.$rk(x.includePattern,ne)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(be=>{const ae=be.folder.fsPath;if(M.$xg(ne,ae)){const Ie=$.$lc(ae,ne);return!be.includePattern||!!L.$rk(be.includePattern,Ie)}else return!1}):!1:!0}var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class y extends Error{constructor(ne,be){super(ne),this.code=be}}e.$DK=y;function D(x){const ne=x.message;if((0,E.$4)(x))return new y(ne,m.canceled);try{const be=JSON.parse(ne);return new y(be.message,be.code)}catch{return new y(ne,m.other)}}function C(x){const ne={message:x.message,code:x.code};return new Error(JSON.stringify(ne))}function P(x){return x.type==="error"?!0:x.type==="success"}function j(x){return x.type==="success"}function T(x){return!!x.path}function z(x,ne,be=!0){const ae=x.searchPath?x.searchPath:x.relativePath;return be?(0,R.$1f)(ae,ne):L.$rk(ne,ae)}class N{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$KK=N;function F(x,ne){const be={...x||{},...ne||{}};return Object.keys(be).filter(ae=>{const Ie=be[ae];return typeof Ie=="boolean"&&Ie})}class U{constructor(ne,be){this.c=null,this.a={...ne.excludePattern||{},...be.excludePattern||{}},this.b=L.$sk(this.a);let ae=ne.includePattern;be.includePattern&&(ae?ae={...ae,...be.includePattern}:ae=be.includePattern),ae&&(this.c=L.$sk(ae))}matchesExcludesSync(ne,be,ae){return!!(this.b&&this.b(ne,be,ae))}includedInQuerySync(ne,be,ae){return!(this.b&&this.b(ne,be,ae)||this.c&&!this.c(ne,be,ae))}includedInQuery(ne,be,ae){const Ie=this.b(ne,be,ae),ee=()=>this.c?!!this.c(ne,be,ae):!0;return(0,I.$kh)(Ie)?Ie.then(B=>B?!1:ee()):ee()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$MK=U;function Y(x){for(const ne in x)if(typeof x[ne]!="boolean")return!0;return!1}function ie(x){if(!x)return;let ne;return be=>(ne||(ne=(x()||Promise.resolve([])).then(ae=>ae?J(ae):{})),ne.then(ae=>!!ae[be]))}function H(x){if(!x)return;let ne;return be=>{if(!ne){const ae=x();ne=ae?J(ae):{}}return!!ne[be]}}function J(x){const ne={};for(const be of x)ne[be]=!0;return ne}}),define(ke[44],De([1,0,19,7,22,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,17,8,68,37,6,58]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u,r,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=e.$0lc=void 0;function g(j,T,z){return new A.$1g(N=>y(N,z)).isEqual(j,T)}function w(j,T,z){return g(j.uri,T.uri,z)?0:(0,I.$sf)(j.uri.toString(),T.uri.toString())}function k(j,T,z){return j.index!==T.index?j.index<T.index?-1:1:g(j.uri,T.uri,z)?(0,I.$sf)(j.name,T.name):(0,I.$sf)(j.uri.toString(),T.uri.toString())}function m(j,T,z,N){const F=j.slice(0).sort((Y,ie)=>z(Y,ie,N)),U=T.slice(0).sort((Y,ie)=>z(Y,ie,N));return(0,l.$Eb)(F,U,(Y,ie)=>z(Y,ie,N))}function y(j,T){const z=T.getCapabilities(j.scheme);return!(z&&z&1024)}class D extends c.$Ri{static toExtHostWorkspace(T,z,N,F){if(!T)return{workspace:null,added:[],removed:[]};const{id:U,name:Y,folders:ie,configuration:H,transient:J,isUntitled:x}=T,ne=[],be=z;z?ie.forEach((B,_)=>{const pe=p.URI.revive(B.uri),ue=D.o(N||z,pe,F);ue?(ue.name=B.name,ue.index=B.index,ne.push(ue)):ne.push({uri:pe,name:B.name,index:_})}):ne.push(...ie.map(({uri:B,name:_,index:pe})=>({uri:p.URI.revive(B),name:_,index:pe}))),ne.sort((B,_)=>B.index<_.index?-1:1);const ae=new D(U,Y,ne,!!J,H?p.URI.revive(H):null,!!x,B=>y(B,F)),{added:Ie,removed:ee}=m(be?be.workspaceFolders:[],ae.workspaceFolders,w,F);return{workspace:ae,added:Ie,removed:ee}}static o(T,z,N){for(let F=0;F<T.folders.length;F++){const U=T.workspaceFolders[F];if(g(U.uri,z,N))return U}}constructor(T,z,N,F,U,Y,ie){super(T,N.map(H=>new c.$Si(H)),F,U,ie),this.t=z,this.u=Y,this.q=[],this.s=b.$Ei.forUris(ie),N.forEach(H=>{this.q.push(H),this.s.set(H.uri,H)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,z){return z&&this.s.get(T)&&(T=(0,A.$$g)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let C=class{constructor(T,z,N,F,U){this.c=new M.$fe,this.onDidChangeWorkspace=this.c.event,this.g=new M.$fe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new M.$he,this.C=new Map,this.h=F,this.s=N,this.t=U,this.j=new E.$Fm,this.k=new L.$xh,this.o=T.getProxy(o.$gM.MainThreadWorkspace),this.q=T.getProxy(o.$gM.MainThreadMessageService);const Y=z.workspace;this.l=Y?new D(Y.id,Y.name,[],!!Y.transient,Y.configuration?p.URI.revive(Y.configuration):null,!!Y.isUntitled,ie=>y(ie,N)):void 0}$initializeWorkspace(T,z){this.v=z,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,A.$9g)((0,A.$$g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,z,N,...F){const U=[];if(Array.isArray(F)&&F.forEach(x=>{p.URI.isUri(x.uri)&&!U.some(ne=>g(ne.uri,x.uri,this.s))&&U.push({uri:x.uri,name:x.name||(0,A.$8g)(x.uri)})}),this.n||[z,N].some(x=>typeof x!="number"||x<0)||N===0&&U.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(z+N>Y.length)return!1;const ie=Y.slice(0);ie.splice(z,N,...U.map(x=>({uri:x.uri,name:x.name||(0,A.$8g)(x.uri),index:void 0})));for(let x=0;x<ie.length;x++){const ne=ie[x];if(ie.some((be,ae)=>ae!==x&&g(ne.uri,be.uri,this.s)))return!1}ie.forEach((x,ne)=>x.index=ne);const{added:H,removed:J}=m(Y,ie,k,this.s);if(H.length===0&&J.length===0)return!1;if(this.o){const x=T.displayName||T.name;this.o.$updateWorkspaceFolders(x,z,N,U).then(void 0,ne=>{this.n=void 0;const be={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(d.Severity.Error,(0,S.localize)(0,null,x,ne.toString()),be,[])})}return this.y(ie),!0}getWorkspaceFolder(T,z){if(this.x)return this.x.getWorkspaceFolder(T,z)}async getWorkspaceFolder2(T,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,z)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,z){let N,F="";if(typeof T=="string"?(N=p.URI.file(T),F=T):typeof T<"u"&&(N=T,F=T.fsPath),!N)return F;const U=this.getWorkspaceFolder(N,!0);if(!U)return F;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Y=(0,A.$bh)(U.uri,N);return z&&U.name&&(Y=`${U.name}/${Y}`),Y}y(T){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:z,added:N,removed:F}=D.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:F}))}findFiles(T,z,N,F,U=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let Y="",ie=!0;return z===null?ie=!1:z!==void 0&&(typeof z=="string"?Y=z:Y=z.pattern),this.z(T,void 0,{exclude:Y,maxResults:N,useDefaultExcludes:ie,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},U)}findFiles2(T,z={},N,F=O.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,T,z,F)}async z(T,z,N,F=O.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const U=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,Y={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:U,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let ie;if(T){const{includePattern:H,folder:J}=P(s.GlobPattern.from(T));ie=J,Y.includePattern=H}else{const{includePattern:H,folder:J}=P(s.GlobPattern.from(z));ie=J,Y.filePattern=H}return this.o.$startFileSearch(ie??null,Y,F).then(H=>Array.isArray(H)?H.map(J=>p.URI.revive(J)):[])}async findTextInFiles(T,z,N,F,U=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),ie=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:H,folder:J}=P(s.GlobPattern.from(z.include)),x=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ne={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ie,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:H,excludePattern:x},be=!1;if(this.u[Y]=ae=>{if(be)return;const Ie=p.URI.revive(ae.resource);ae.results.forEach(ee=>{const B=(0,f.$8h)(ee);(0,r.$uK)(B)?N({uri:Ie,preview:{text:B.preview.text,matches:(0,l.$1b)(B.preview.matches,_=>new t.$kM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,l.$1b)(B.ranges,_=>new t.$kM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):N({uri:Ie,text:B.text,lineNumber:B.lineNumber})})},U.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(T,J??null,ne,Y,U);return delete this.u[Y],ae||{}}catch(ae){throw delete this.u[Y],ae}}$handleTextSearchResult(T,z){this.u[z]?.(T)}async save(T){const z=await this.o.$save(T,{saveAs:!1});return p.URI.revive(z)}async saveAs(T){const z=await this.o.$save(T,{saveAs:!0});return p.URI.revive(z)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,z){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,z);const N=this.t.transformOutgoingScheme(T),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,N),(0,R.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(T,z){this.h.info("Getting edit session identifier for workspaceFolder",T);const N=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const F=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!F),!F)return;const U=await F.provideEditSessionIdentity(N,z);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(T,z,N,F){this.h.info("Getting edit session identifier for workspaceFolder",T);const U=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const Y=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!Y),!Y)return;const ie=await Y.provideEditSessionIdentityMatch?.(z,N,F);if(this.h.info("Provider returned edit session identifier match result: ",ie),!!ie)return ie}getOnWillCreateEditSessionIdentityEvent(T){return(z,N,F)=>{const U=function(ie){z.call(N,ie)};return U.extension=T,this.B.event(U,void 0,F)}}async $onWillCreateEditSessionIdentity(T,z,N){const F=await this.resolveWorkspaceFolder(p.URI.revive(T));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},z,async(U,Y)=>{const ie=Date.now();await Promise.resolve(U),Date.now()-ie>N&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(T,z){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,z);const N=this.t.transformOutgoingScheme(T),F=this.A++;return this.o.$registerCanonicalUriProvider(F,N),(0,R.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(T,z,N){const F=this.C.get(T.scheme);if(!F)return;const U=await F.provideCanonicalUri?.(p.URI.revive(T),z,N);if(U)return U}async $provideCanonicalUri(T,z,N){return this.provideCanonicalUri(p.URI.revive(T),{targetScheme:z},N)}};e.$0lc=C,e.$0lc=C=Je([We(0,a.$JO),We(1,i.$ZO),We(2,n.$Slc),We(3,h.$5j),We(4,u.$8lc)],C),e.$$lc=(0,v.$yi)("IExtHostWorkspace");function P(j){let T,z;return j&&(typeof j=="string"?T=j:(T=j.pattern,z=p.URI.revive(j.baseUri))),{includePattern:T,folder:z}}}),define(ke[45],De([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=e.$_lc=void 0;function h(u,r){if(r){const o=r.split(".");let f=u;for(let g=0;f&&g<o.length;g++)f=f[o[g]];return f}}function d(u){return u instanceof v.URI}function c(u){return u&&u.uri instanceof v.URI&&u.languageId&&typeof u.languageId=="string"}function n(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&u.uri instanceof v.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function a(u){if(d(u))return{resource:u};if(c(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(n(u))return{overrideIdentifier:u.languageId};if(i(u))return{resource:u.uri};if(u===null)return{resource:null}}let s=class{constructor(r,o,f){this.a=r.getProxy(M.$gM.MainThreadConfiguration),this.c=o,this.b=f,this.d=new A.$xh,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(r,o))}};e.$_lc=s,e.$_lc=s=Je([We(0,p.$JO),We(1,O.$$lc),We(2,S.$5j)],s);class t{constructor(r,o,f,g){this.a=new L.$fe,this.b=r,this.f=g,this.c=o,this.e=b.$Do.parse(f,g),this.d=this.k(f.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,o){const f={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Do.parse(r,this.f),this.d=this.k(r.configurationScopes),this.a.fire(this.j(o,f))}getConfiguration(r,o,f){const g=a(o)||{},w=this.g(r?h(this.e.getValue(void 0,g,this.c.workspace),r):this.e.getValue(void 0,g,this.c.workspace));r&&this.h(r,g,f?.identifier);function k(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(y){return typeof h(w,y)<"u"},get:(y,D)=>{this.h(r?`${r}.${y}`:y,g,f?.identifier);let C=h(w,y);if(typeof C>"u")C=D;else{let P;const j=(T,z)=>{if((0,E.$ag)(T)){let N;const F=()=>{P=P||(0,l.$5n)(w),N=N||h(P,z)};return new Proxy(T,{get:(U,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return F(),()=>N;if(P)return N=N||h(P,z),N[Y];const ie=U[Y];return typeof Y=="string"?j(ie,`${z}.${Y}`):ie},set:(U,Y,ie)=>(F(),N&&(N[Y]=ie),!0),deleteProperty:(U,Y)=>(F(),N&&delete N[Y],!0),defineProperty:(U,Y,ie)=>(F(),N&&Object.defineProperty(N,Y,ie),!0)})}return Array.isArray(T)?(0,l.$5n)(T):T};C=j(C,y)}return C},update:(y,D,C,P)=>{y=r?`${r}.${y}`:y;const j=k(C);return D!==void 0?this.b.$updateConfigurationOption(j,y,D,g,P):this.b.$removeConfigurationOption(j,y,g,P)},inspect:y=>{y=r?`${r}.${y}`:y;const D=this.e.inspect(y,g,this.c.workspace);if(D)return{key:y,defaultValue:(0,l.$5n)(D.policy?.value??D.default?.value),globalValue:(0,l.$5n)(D.user?.value??D.application?.value),workspaceValue:(0,l.$5n)(D.workspace?.value),workspaceFolderValue:(0,l.$5n)(D.workspaceFolder?.value),defaultLanguageValue:(0,l.$5n)(D.default?.override),globalLanguageValue:(0,l.$5n)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,l.$5n)(D.workspace?.override),workspaceFolderLanguageValue:(0,l.$5n)(D.workspaceFolder?.override),languageIds:(0,l.$5n)(D.overrideIdentifiers)}}};return typeof w=="object"&&(0,l.$8n)(m,w,!1),Object.freeze(m)}g(r){const o=f=>(0,E.$ag)(f)?new Proxy(f,{get:(g,w)=>o(g[w]),set:(g,w,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(g,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(g,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return o(r)}h(r,o,f){const g=$.$uo.test(r)?4:this.d.get(r),w=f?`[${f.value}] `:"";if(g===4){typeof o?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){o?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,o){const f=new b.$Fo(r,o,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(g,w)=>f.affectsConfiguration(g,a(w))})}k(r){return r.reduce((o,f)=>(o.set(f[0],f[1]),o),new Map)}}e.$amc=t,e.$bmc=(0,I.$yi)("IExtHostConfiguration")}),define(ke[95],De([1,0,2,7,4,6,8,44,73,45,22,43,20,28,5,15,12,11,91,314,13]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=e.$Enc=e.$Dnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(j){function T(N){if(N!=null)return N}j.from=T;function z(N){if(N!=null)return N}j.to=z})(s||(s={}));var t;(function(j){function T(N){if(N!=null)return N}j.from=T;function z(N){if(N!=null)return N}j.to=z})(t||(t={}));var u;(function(j){function T(N){if(N!=null)return N}j.from=T;function z(N){if(N!=null)return N}j.to=z})(u||(u={}));var r;(function(j){function T(F){if(F){const U=F;return U&&!!U.process}else return!1}j.is=T;function z(F){if(F==null)return;const U={process:F.process,args:F.args};return F.options&&(U.options=u.from(F.options)),U}j.from=z;function N(F){if(F!=null)return new R.$5M(F.process,F.args,F.options)}j.to=N})(r||(r={}));var o;(function(j){function T(N){if(N!=null)return N}j.from=T;function z(N){if(N!=null)return N}j.to=z})(o||(o={}));var f;(function(j){function T(F){if(F){const U=F;return U&&(!!U.commandLine||!!U.command)}else return!1}j.is=T;function z(F){if(F==null)return;const U={};return F.commandLine!==void 0?U.commandLine=F.commandLine:(U.command=F.command,U.args=F.args),F.options&&(U.options=o.from(F.options)),U}j.from=z;function N(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$6M(F.commandLine,F.options):new R.$6M(F.command,F.args?F.args:[],F.options)}j.to=N})(f||(f={}));var g;(function(j){function T(F){if(F){const U=F;return U&&U.customExecution==="customExecution"}else return!1}j.is=T;function z(F){return{customExecution:"customExecution"}}j.from=z;function N(F,U){return U.get(F)}j.to=N})(g||(e.CustomExecutionDTO=g={}));var w;(function(j){function T(z,N){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?F=N.workspaceFile:F=i.$gI),{id:z._id,workspaceFolder:F}}j.from=T})(w||(e.TaskHandleDTO=w={}));var k;(function(j){function T(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}j.from=T})(k||(k={}));var m;(function(j){function T(F,U){if(F==null)return[];const Y=[];for(const ie of F){const H=z(ie,U);H&&Y.push(H)}return Y}j.fromMany=T;function z(F,U){if(F==null)return;let Y;F.execution instanceof R.$5M?Y=r.from(F.execution):F.execution instanceof R.$6M?Y=f.from(F.execution):F.execution&&F.execution instanceof R.$7M&&(Y=g.from(F.execution));const ie=s.from(F.definition);let H;return F.scope?typeof F.scope=="number"?H=F.scope:H=F.scope.uri:H=R.TaskScope.Workspace,!ie||!H?void 0:{_id:F._id,definition:ie,name:F.name,source:{extensionId:U.identifier.value,label:F.source,scope:H},execution:Y,isBackground:F.isBackground,group:k.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}j.from=z;async function N(F,U,Y){if(F==null)return;let ie;r.is(F.execution)?ie=r.to(F.execution):f.is(F.execution)?ie=f.to(F.execution):g.is(F.execution)&&(ie=g.to(F._id,Y));const H=s.to(F.definition);let J;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?J=F.source.scope:J=await U.resolveWorkspaceFolder(l.URI.revive(F.source.scope)):J=R.TaskScope.Workspace),!H||!J)return;const x=new R.$8M(H,J,F.name,F.source.label,ie,F.problemMatchers);return F.isBackground!==void 0&&(x.isBackground=F.isBackground),F.group!==void 0&&(x.group=R.$4M.from(F.group._id),x.group&&F.group.isDefault&&(x.group=new R.$4M(x.group.id,x.group.label),F.group.isDefault===!0&&(x.group.isDefault=F.group.isDefault))),F.presentationOptions&&(x.presentationOptions=t.to(F.presentationOptions)),F._id&&(x._id=F._id),F.detail&&(x.detail=F.detail),x}j.to=N})(m||(e.TaskDTO=m={}));var y;(function(j){function T(N){return N}j.from=T;function z(N){if(N)return Object.assign(Object.create(null),N)}j.to=z})(y||(y={}));class D{#e;constructor(T,z,N){this._id=z,this.a=N,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let C=class{constructor(T,z,N,F,U,Y,ie,H){this.q=new O.$fe,this.r=new O.$fe,this.s=new O.$fe,this.u=new O.$fe,this.a=T.getProxy(M.$gM.MainThreadTask),this.b=N,this.c=F,this.d=U,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,z,N){if(!N)return new R.$iM(()=>{});const F=this.x();return this.j.set(F,{type:z,provider:N,extension:T}),this.a.$registerTaskProvider(F,z),new R.$iM(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(T,z){this.a.$registerTaskSystem(T,z)}fetchTasks(T){return this.a.$fetchTasks(y.from(T)).then(async z=>{const N=[];for(const F of z){const U=await m.to(F,this.b,this.m);U&&N.push(U)}return N})}get taskExecutions(){const T=[];return this.k.forEach(z=>T.push(z)),T}terminateTask(T){if(!(T instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,z,N){const F=this.m.get(T.id);F&&(this.o.set(T.id,F),this.e.attachPtyToTerminal(z,await F.callback(N))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const z=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const z=await this.z(T.id);this.s.fire({execution:z,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const z=await this.z(T.id);this.u.fire({execution:z,exitCode:T.exitCode})}$provideTasks(T,z){const N=this.j.get(T);if(!N)return Promise.reject(new Error("no handler found"));const F=[],U=(0,L.$qh)(()=>N.provider.provideTasks(A.CancellationToken.None)).then(Y=>this.v(z,F,N,Y));return new Promise(Y=>{U.then(ie=>{Promise.all(F).then(()=>{Y(ie)})})})}async $resolveTask(T,z){const N=this.j.get(T);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const F=await m.to(z,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const U=await N.provider.resolveTask(F,A.CancellationToken.None);if(!U)return;this.A(U,N);const Y=m.from(U,N.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(Y.execution)&&await this.y(Y,U,!0),await this.w(Y)}x(){return this.h++}async y(T,z,N){const F=await this.a.$createTaskId(T);!N&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,z.execution)),this.m.set(F,z.execution)}async z(T,z){if(typeof T=="string"){const U=this.l.get(T);if(!U)throw new a.$bb("Unexpected: The specified task is missing an execution");return U}const N=this.l.get(T.id);if(N)return N;let F;return z?F=Promise.resolve(new D(this,T.id,z)):F=m.to(T.task,this.b,this.m).then(U=>{if(!U)throw new a.$bb("Unexpected: Task does not exist.");return new D(this,T.id,U)}),this.l.set(T.id,F),F.then(U=>(this.k.set(T.id,U),U))}A(T,z){T._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const N=this.n.values();let F=N.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=N.next()}};e.$Dnc=C,e.$Dnc=C=Je([We(0,p.$JO),We(1,S.$ZO),We(2,b.$$lc),We(3,$.$UO),We(4,E.$bmc),We(5,I.$zmc),We(6,c.$5j),We(7,n.$Olc)],C);let P=class extends C{constructor(T,z,N,F,U,Y,ie,H){super(T,z,N,F,U,Y,ie,H),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:d.$h(0)})}async executeTask(T,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=m.from(z,T);if(N===void 0)throw new Error("Task is not valid");if(g.is(N.execution))await this.y(N,z,!1);else throw new a.$_;const F=await this.z(await this.a.$getTaskExecution(N),z);return this.a.$executeTask(N).catch(U=>{throw new Error(U)}),F}v(T,z,N,F){const U=[];if(F)for(const Y of F){if(this.A(Y,N),!Y.definition||!T[Y.definition.type]){const H=Y.source?Y.source:"No task source";this.f.warn(`The task [${H}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=m.from(Y,N.extension);ie&&g.is(ie.execution)?(U.push(ie),z.push(this.y(ie,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:N.extension}}async w(T){if(g.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,z,N){}};e.$Enc=P,e.$Enc=P=Je([We(0,p.$JO),We(1,S.$ZO),We(2,b.$$lc),We(3,$.$UO),We(4,E.$bmc),We(5,I.$zmc),We(6,c.$5j),We(7,n.$Olc)],P),e.$Fnc=(0,v.$yi)("IExtHostTask")}),define(ke[374],De([1,0,37,29]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=void 0,e.$UK=O,e.$WK=M;function O(R){return"cellResults"in R}e.$VK="rawCell#";function M(R,b){let $=-1;const E=[];let A=[];return R.forEach(p=>{p.range.startLineNumber!==$&&A.length>0&&(E.push([...A]),A=[]),A.push(p),$=p.range.endLineNumber}),A.length>0&&E.push([...A]),E.map(p=>{const S=[],v=p[0].range.startLineNumber,h=p[p.length-1].range.endLineNumber;for(let d=v;d<=h;d++)S.push(b.getLineContent(d));return new l.$yK(S.join(`
`)+`
`,p.map(d=>new L.$xt(d.range.startLineNumber-1,d.range.startColumn-1,d.range.endLineNumber-1,d.range.endColumn-1)))})}}),define(ke[375],De([1,0,229,21,4,3,27,14,18,2,33,112,6,34,17,8,48,346,154,24,15,304,374,371]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,g,w,k,m,y){this.q=w,this.r=k,this.s=m,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new O.$fe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new O.$fe,this.onDidOpenNotebookDocument=this.m.event,this.n=new O.$fe,this.onDidCloseNotebookDocument=this.n.event,this.o=new O.$fe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Mlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(p.$gM.MainThreadNotebook),this.c=f.getProxy(p.$gM.MainThreadNotebookDocuments),this.d=f.getProxy(p.$gM.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const C=D.notebookEditor?.notebookUri,P=D.cell.handle,T=this.g.get(C)?.getCell(P);if(T)return T.apiCell}if(D&&D.$mid===14){const C=D.uri,P=this.g.get(C);if(P)return P.apiNotebook}return D}}),r.B(g)}getEditorById(f){const g=this.h.get(f);if(!g)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(f){for(const[g,w]of this.h)if(w.apiEditor===f)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,g){const w=this.g.get(f);if(!w&&!g)throw new Error(`NO notebook document for '${f}'`);return w}static u(f,g){if(!g)return;const w=g.filenamePattern.map(k=>v.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(g.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:g.displayName,filenamePattern:w,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,g,w){const k=r.a++,m=typeof w.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(k,w),this.b.$registerNotebookCellStatusBarItemProvider(k,m,g);let y;return m!==void 0&&(y=w.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(m))),new h.$iM(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,m),y?.dispose()})}async createNotebookDocument(f){const g=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&v.NotebookData.from(f.content)});return E.URI.revive(g)}async openNotebookDocument(f){const g=this.g.get(f);if(g)return g.apiNotebook;const w=await this.c.$tryOpenNotebook(f),k=this.g.get(E.URI.revive(w));return(0,$.$jg)(k?.apiNotebook)}async showNotebookDocument(f,g){E.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let w;typeof g=="object"?w={position:v.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(v.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:w={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,w),m=k&&this.h.get(k)?.apiEditor;if(m)return m;throw k?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,g,w,k){const m=this.f.get(f),y=E.URI.revive(g),D=this.g.get(y);if(!D||!m)return;const C=D.getCellFromIndex(w);if(!C)return;const P=await m.provideCellStatusBarItems(C.apiCell,k);if(!P)return;const j=new M.$Tc,T=this.p.add([j]),N=(Array.isArray(P)?P:[P]).map(F=>v.NotebookStatusBarItem.from(F,this.i,j));return{cacheId:T,items:N}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,g,w,k,m){if((0,b.$9e)(g))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:g,serializer:w,options:k}),this.b.$registerNotebookSerializer(y,{id:f.identifier,location:f.extensionLocation},g,v.NotebookDocumentContentOptions.from(k),r.u(f,m)),(0,M.$Sc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(f,g,w){const k=this.x.get(f);if(!k)throw new Error("NO serializer found");const m=await k.serializer.deserializeNotebook(g.buffer,w);return new d.$Ew(v.NotebookData.from(m))}async $notebookToData(f,g,w){const k=this.x.get(f);if(!k)throw new Error("NO serializer found");const m=await k.serializer.serializeNotebook(v.NotebookData.to(g.value),w);return L.$He.wrap(m)}async $saveNotebook(f,g,w,k,m){const y=E.URI.revive(g),D=this.x.get(f);if(!D)throw new Error("NO serializer found");const C=this.g.get(y);if(!C)throw new Error("Document NOT found");if(C.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$nl((0,l.localize)(0,null,this.z(y)),6);await this.y(y,k);const P={metadata:(0,i.$ao)(C.apiNotebook.metadata,F=>!(D.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of C.apiNotebook.getCells()){const U=new h.$LN(F.kind,F.document.getText(),F.document.languageId,F.mime,D.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);U.metadata=(0,i.$ao)(F.metadata,Y=>!(D.options?.transientCellMetadata??{})[Y]),P.cells.push(U)}const j=await D.serializer.serializeNotebook(P,m);await this.s.value.writeFile(y,j);const T=this.s.getFileSystemProviderExtUri(y.scheme),z=await this.s.value.stat(y);return{name:T.basename(y),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$yl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(f,g,w,k,m){const y=this.x.get(f)?.serializer;if(!y)return{limitHit:!1,results:[]};const D=new R.$Bc;await(async(z,N,F)=>{await Promise.all(z.map(async U=>await Promise.all(U.filenamePatterns.map(Y=>{const ie={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:Y};return this.t.doInternalFileSearchWithCustomCallback(ie,N,H=>{H.forEach(J=>{D.has(J)||k.some(ne=>U.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(be=>(0,u.$Sgb)(be,J)))||D.add(J)})}).catch(H=>{if(H.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw H})}))))})(w,m,g);const P=new R.$Ac;let j=!1;const T=Array.from(D).map(async z=>{const N=[];try{if(m.isCancellationRequested)return;if(g.maxResults&&[...P.values()].reduce((ie,H)=>ie+H.cellResults.length,0)>g.maxResults){j=!0;return}const F=[],U=this.g.get(z);if(U)U.apiNotebook.getCells().forEach(H=>F.push({input:H.document.getText(),outputs:H.outputs.flatMap(J=>J.items.map(x=>x.data.toString()))}));else{const ie=await this.s.value.readFile(z),H=L.$He.fromString(ie.toString()),J=await y.deserializeNotebook(H.buffer,m);if(m.isCancellationRequested)return;v.NotebookData.from(J).cells.forEach(ne=>F.push({input:ne.source,outputs:ne.outputs.flatMap(be=>be.items.map(ae=>ae.valueBytes.toString()))}))}if(m.isCancellationRequested)return;F.forEach((ie,H)=>{const J=g.contentPattern.pattern,x=new s.$sXb(ie.input,void 0,ie.outputs),ne=x.findInInputs(J),be=x.findInOutputs(J),ae=be.flatMap(Ie=>(0,t.$WK)(Ie.matches,Ie.textBuffer)).map((Ie,ee)=>(Ie.webviewIndex=ee,Ie));if(ne.length>0||be.length>0){const Ie={index:H,contentResults:(0,t.$WK)(ne,x.inputTextBuffer),webviewResults:ae};N.push(Ie)}});const Y={resource:z,cellResults:N};P.set(z,Y);return}catch{return}});return await Promise.all(T),{limitHit:j,results:[...P.values()]}}async y(f,g){const w=await this.s.value.stat(f);if(typeof g?.mtime=="number"&&typeof g.etag=="string"&&g.etag!==A.$xl&&typeof w.mtime=="number"&&typeof w.size=="number"&&g.mtime<w.mtime&&g.etag!==A.$yl({mtime:g.mtime,size:w.size}))throw new A.$nl((0,l.localize)(1,null),3,g)}z(f){return f.scheme===a.Schemas.file?f.fsPath:f.toString()}A(f,g,w){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const k=new n.$0mc(g,this.d,f,w.visibleRanges.map(v.NotebookRange.to),w.selections.map(v.NotebookRange.to),typeof w.viewColumn=="number"?v.ViewColumn.to(w.viewColumn):void 0);this.h.set(g,k)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const w of f.value.removedDocuments){const k=E.URI.revive(w),m=this.g.get(k);m&&(m.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(m.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===k.toString()&&this.h.delete(y.id)}if(f.value.addedDocuments){const w=[];for(const k of f.value.addedDocuments){const m=E.URI.revive(k.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const y=new c.$9mc(this.c,this.q,this.r,m,k);w.push(...k.cells.map(D=>c.$8mc.asModelAddData(D))),this.g.get(m)?.dispose(),this.g.set(m,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(y.apiNotebook)}}if(f.value.addedEditors)for(const w of f.value.addedEditors){if(this.h.has(w.id))return;const k=E.URI.revive(w.documentUri),m=this.g.get(k);m&&this.A(m,w.id,w)}const g=[];if(f.value.removedEditors)for(const w of f.value.removedEditors){const k=this.h.get(w);k&&(this.h.delete(w),this.k?.id===k.id&&(this.k=void 0),g.push(k))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const w=new Set;this.l.forEach(k=>w.add(k.id));for(const k of this.h.values()){const m=w.has(k.id);k._acceptVisibility(m)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const g=S.$8O.String.with("notebookType","A notebook type"),w=new S.$0O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new S.$8O("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>L.$He.wrap(m))],new S.$9O("Notebook Data",m=>v.NotebookData.to(m.value))),k=new S.$0O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new S.$8O("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new d.$Ew(v.NotebookData.from(m)))],new S.$9O("Bytes",m=>m.buffer));f.registerApiCommand(w),f.registerApiCommand(k)}}e.$gnc=r}),define(ke[376],De([1,0,16,22,47,35,23,40,37]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class E{constructor(p,S,v){this.k=p,this.l=S,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&M.$sk(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&M.$sk(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const S=this.k.folderQueries||[];return new Promise((v,h)=>{const d=c=>{this.f++,p(c)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const n=c.toString(),i=l.$nc(n);this.j&&this.j(n,i)||this.v(d,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,d))).then(c=>{v({limitHit:this.e,stats:c[0]||void 0})},c=>{h(new Error((0,O.$jj)(c)))})})}async p(p,S){const v=new L.$qe,h=this.q(p),d=this.r(),c=new $.$MK(this.k,p),n=!c.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$be.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,v.token),s=i.elapsed(),t=b.$be.create();return this.g&&!this.e||(a&&a.forEach(u=>{const r=l.$gc.relative(p.folder.path,u.path);if(n){const o=l.$nc(u.path);this.v(S,{base:p.folder,relativePath:r,basename:o});return}this.s(d,p.folder,r,S)}),this.g&&!this.e)?null:(this.u(d,c,S),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(p){const S=(0,$.$LK)(this.k.includePattern,p.includePattern),v=(0,$.$LK)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:v,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},S,v,h){if(v===this.a){const c=l.$nc(this.a);this.v(h,{base:S,relativePath:this.a,basename:c})}function d(c){const n=l.$nc(c),i=l.$mc(c);let a=p[i];a||(a=p[i]=[],d(i)),a.push({base:S,relativePath:c,basename:n})}d(v)}u({rootEntries:p,pathToEntries:S},v,h){const d=this,c=this.a;function n(i){const a=(0,$.$OK)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const u=i[s],{relativePath:r,basename:o}=u;if(v.matchesExcludesSync(r,o,c!==o?a:void 0))continue;const f=S[r];if(f)n(f);else{if(r===c)continue;d.v(h,u)}if(d.e)break}}n(p)}v(p,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(S))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,S,v,h){const d=this.c(p.cacheKey),c=new E(p,S,d&&d.token);let n=0;const i=a=>{n+=a.length,v(a.map(s=>this.d(s)))};return this.e(c,A.a,i,h).then(a=>({limitHit:a.limitHit,stats:a.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}:void 0,messages:[]}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new L.$qe),this.b.get(p)}d(p){return p.relativePath?{resource:R.$_g(p.base,p.relativePath)}:{resource:p.base}}e(p,S,v,h){const d=h.onCancellationRequested(()=>{p.cancel()}),c=i=>{i&&(n.push(i),S>0&&n.length>=S&&(v(n),n=[]))};let n=[];return p.search(c).then(i=>(n.length&&v(n),d.dispose(),i),i=>(n.length&&v(n),d.dispose(),Promise.reject(i)))}}e.$$mc=A}),define(ke[377],De([1,0,19,74,35,103,27,15,16,23,14,18,2,100,250,55,11,42,147,372,37]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=void 0,e.$XL=k;let s=class{constructor(y,D,C,P,j){this.a=y,this.b=D,this.c=C,this.d=P,this.e=j}text(y,D,C={}){y=this.f(y,C);const P=this.a.getValue(),j=D&&D.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(D?.map(c.$Ti),C),type:2,contentPattern:y,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||j||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(y,D){const C=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const P={...y,wordSeparators:C.editor.wordSeparators};return this.j(y,D)&&(P.isCaseSensitive=!0),this.k(y)&&(P.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),P}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey,shouldGlobMatchFilePattern:D.shouldGlobSearch}}g(y,D){return y?(y=Array.isArray(y)?y.map(f):f(y),D?this.parseSearchPaths(y):{pattern:u(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const C=this.g(D.includePattern,D.expandPatterns),P=this.g(D.excludePattern,D.expandPatterns),j=y.length>1,T=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(F=>this.q(F,D,P)):y.map(F=>this.r(F,D,P,j))).filter(F=>!!F),z={_reason:D._reason,folderQueries:T,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const F=l.$Hb(this.c.groups.flatMap(ie=>ie.editors.map(H=>H.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const U=F.filter(ie=>(0,a.$CK)(z,ie.fsPath)),Y=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...z,...Y}}const N=D.extraFileResources&&D.extraFileResources.filter(F=>(0,a.$CK)(z,F.fsPath));return z.extraFileResources=N&&N.length?N:void 0,z}i(y){const D=[],C=new R.$Ac,P={};let j=!1;return y.forEach(T=>{if(T.scheme===b.Schemas.walkThrough)return;if((0,E.$dh)(T)){const N=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$mc(T.fsPath)});let F=C.get(N);F||(j=!0,F={folder:N,includePattern:{}},D.push(F),C.set(N,F));const U=$.$lc(N.fsPath,T.fsPath);(0,I.$jg)(F.includePattern)[U.replace(/\\/g,"/")]=!0}else T.fsPath&&(j=!0,P[T.fsPath]=!0)}),{folderQueries:D,includePattern:P,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(A.$2f(y.pattern,!0))return!0}else if(A.$2f(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,S.$TC)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=Y=>$.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),P=(Array.isArray(y)?y:r(y)).map(Y=>{const ie=this.e.resolvedUserHome;return ie?(0,M.$Jw)(Y,ie.scheme===b.Schemas.file?ie.fsPath:ie.path):Y}),j=L.$K(P,Y=>D(Y)?"searchPaths":"exprSegments"),T=(j.exprSegments||[]).map(Y=>A.$hf(Y,"/")).map(Y=>A.$hf(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),z={},N=this.m(j.searchPaths||[]);N&&N.length&&(z.searchPaths=N);const F=T.flat(),U=u(...F);return U&&(z.pattern=U),z}l(y,D){return D.disregardExcludeSettings?void 0:(0,a.$BK)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(P=>{let{pathPortion:j,globPortion:T}=t(P);return T&&(T=g(T)),this.n(j).flatMap(N=>this.o(N,T))}),C=new Map;return D.forEach(P=>{const j=P.searchPath.toString(),T=C.get(j);T?P.pattern&&(T.pattern=T.pattern||{},T.pattern[P.pattern]=!0):C.set(j,{searchPath:P.searchPath,pattern:P.pattern?u(P.pattern):void 0})}),Array.from(C.values())}n(y){if($.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==b.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:p.URI.file($.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=f(y),y.startsWith("../")||y===".."){const P=$.$gc.resolve(D.path,y);return[{searchPath:D.with({path:P})}]}const C=g(y);return[{searchPath:D,pattern:C}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(j=>{const T=D.match(new RegExp(`^${A.$bf(j.name)}(?:/(.*)|$)`));return T?{match:T,folder:j}:null}).filter(I.$gg);if(P.length)return P.map(j=>{const T=j.match[1];return{searchPath:j.folder.uri,pattern:T&&g(T)}});{const j=y.match(/\.[\/\\](.+)[\/\\]?/),T=j?j[1]:y,z=v.localize(0,null,T);throw new Error(z)}}}}o(y,D){const C=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,P=[{searchPath:y.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:y.searchPath,pattern:C+"/**"}),P}q(y,D,C){const P=this.r((0,c.$Ti)(y.searchPath),D,C,!1);return P?{...P,includePattern:y.pattern}:null}r(y,D,C,P){let j;const T=p.URI.isUri(y)?y:y.uri;if(C.searchPaths){const Y=C.searchPaths.filter(ie=>(0,E.$5g)(ie.searchPath,T))[0];if(Y&&!Y.pattern)return null;Y&&(j=Y.pattern)}const z=this.a.getValue({resource:T}),F={...this.l(z,D)||{},...j||{}},U=p.URI.isUri(y)?(0,E.$9g)(y):y.name;return{folder:T,folderName:P?U:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!z.search.followSymlinks}}};e.$WL=s,e.$WL=s=Je([We(0,h.$5i),We(1,c.$Hi),We(2,n.$2D),We(3,d.$5j),We(4,i.$UL)],s);function t(m){const y=m.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,C=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(C){let P=m.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:m.substr((C.index||0)+1)}}}return{pathPortion:m}}function u(...m){return m.length?m.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function r(m){return O.$qk(m,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function f(m){return m.replace(/\\/g,"/")}function g(m){return f(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(m){return m.replace(/([?*[\]])/g,"[$1]")}function k(m,y){m=l.$Mb(m,P=>P.toString());const D=[],C=y.getWorkspace();return m&&m.forEach(P=>{let j;if(y.getWorkbenchState()===2)j=(0,E.$bh)(C.folders[0].uri,P),j&&j!=="."&&(j="./"+j);else{const T=y.getWorkspaceFolder(P);if(T){const z=T.name;if(C.folders.filter(F=>F.name===z).length===1){const F=(0,E.$bh)(T.uri,P);F===""?j=`./${T.name}`:j=`./${T.name}/${F}`}else j=P.fsPath}}j&&D.push(w(j))}),D}}),define(ke[378],De([1,0,23,2,22,13,5,377,37,42,7]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ewb=p,e.$Fwb=h;const I=7e3;function p(d,c){const n=c.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],a=[];for(const f of n)if(/^workspaceContains:/.test(f)){const g=f.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||d.forceUsingSearch?a.push(g):i.push(g)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$rh)(),u=f=>t({activationEvent:f}),r=Promise.all(i.map(f=>S(d,f,u))).then(()=>{}),o=v(d,c.identifier,a,u);return Promise.all([r,o]).then(()=>{t(void 0)}),s}async function S(d,c,n){for(const i of d.folders)if(await d.exists(l.$_g(L.URI.revive(i),c))){n(`workspaceContains:${c}`);return}}async function v(d,c,n,i){if(n.length===0)return Promise.resolve(void 0);const a=new O.$qe,s=d.checkExists(d.folders,n,a.token),t=setTimeout(async()=>{a.cancel(),d.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let u=!1;try{u=await s}catch(r){M.$4(r)||M.$1(r)}a.dispose(),clearTimeout(t),u&&i(`workspaceContains:${n.join(",")}`)}function h(d,c,n,i){const a=d.get(R.$xi),s=d.get($.$tK),u=a.createInstance(b.$WL).file(c.map(r=>(0,E.$Ti)(L.URI.revive(r))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(u,i).then(r=>!!r.limitHit,r=>M.$4(r)?!1:Promise.reject(r))}}),define(ke[49],De([1,0,225,16,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,21,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u,r,o,f,g,w,k,m,y,D,C,P,j,T,z,N,F,U){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=e.$Omc=e.$Nmc=e.$Mmc=void 0,e.$Mmc=(0,r.$yi)("IHostUtils");let ie=Y=class extends b.$Uc{constructor(B,_,pe,ue,ce,oe,le,K,se,$e,ve,Me,ge){super(),this.Y=Me,this.Z=ge,this.a=this.B(new D.$fe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=pe,this.f=le,this.j=ue,this.m=ce,this.s=oe,this.t=se,this.u=$e,this.w=ve,this.y=this.g.getProxy(I.$gM.MainThreadWorkspace),this.z=this.g.getProxy(I.$gM.MainThreadTelemetry),this.C=this.g.getProxy(I.$gM.MainThreadExtensionService),this.D=new R.$xh,this.F=new R.$xh,this.G=new R.$xh,this.H=new R.$xh,this.I=new Ie(this.f.extensions.activationEvents),this.L=new c.$lac(this.I,this.f.extensions.allExtensions);const Pe=new i.$Um(this.f.extensions.myExtensions);this.J=new c.$lac(this.I,be(this.L,Pe)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new v.$vmc(this.g,this.s),this.N=new P.$Fmc(this.g),this.O=K,this.h=B.createChild(new w.$wi([v.$wmc,this.M],[P.$Gmc,this.N])),this.P=this.B(new S.$umc(this.J,this.L,{onExtensionActivationError:(Ae,ze,q)=>{this.C.$onExtensionActivationError(Ae,n.$3(ze),q)},actualActivateExtension:async(Ae,ze)=>{if(c.$lac.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,ze),new S.$tmc;const q=this.J.getExtensionDescription(Ae);return this.fb(q,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),O.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(B){n.$1(B)}}async $(){this.O.onWillDeactivateAll();let B=[];try{B=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(B)}terminate(B,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${B}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const pe=this.$();Promise.race([(0,R.$zh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(B){return this.G.isOpen()?this.P.isActivated(B):!1}async getExtension(B){const _=await this.C.$getExtension(B);return _&&{..._,identifier:new i.$Tm(_.identifier.value),extensionLocation:E.URI.revive(_.extensionLocation)}}ab(B,_){return this.P.activateByEvent(B,_)}bb(B,_){return this.P.activateById(B,_)}activateByIdWithErrors(B,_){return this.bb(B,_).then(()=>{const pe=this.P.getActivatedExtension(B);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(B=>this.J)}getExtensionExports(B){if(this.G.isOpen())return this.P.getActivatedExtension(B).exports;try{return this.P.getActivatedExtension(B).exports}catch{return null}}async cb(B){if(B.scheme===T.Schemas.file&&this.c.fsRealpath){const _=B.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const pe=await this.R.get(_);return E.URI.file(pe)}return B}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(B=>new ae(B))),this.Q}async db(B){const _=$.$Ei.forUris(pe=>M.$3g.ignorePathCasing(pe));return await Promise.all(B.map(async pe=>{if(this.wb(pe)){const ue=await this.cb(pe.extensionLocation);_.set(ue,pe)}})),_}eb(B){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(B))return _;const pe=this.P.getActivatedExtension(B);if(!pe)return _;try{typeof pe.module.deactivate=="function"&&(_=Promise.resolve(pe.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${B.value}':`),this.s.error(ue)}try{(0,b.$Pc)(pe.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this.s.error(ue)}return _}async fb(B,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(B.identifier):await this.C.$onWillActivateExtension(B.identifier),this.hb(B,_).then(pe=>{const ue=pe.activationTimes;return this.C.$onDidActivateExtension(B.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,_),this.gb(B,_,"success",ue),pe},pe=>{throw this.gb(B,_,"failure"),pe})}gb(B,_,pe,ue){const ce=J(B,_);this.z.$publicLog2("extensionActivationTimes",{...ce,...ue||{},outcome:pe})}hb(B,_){const pe=J(B,_);this.z.$publicLog2("activatePlugin",pe);const ue=this.wb(B);if(!ue)return Promise.resolve(new S.$smc(S.$pmc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${B.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const ce=new S.$qmc(_.startup);return Promise.all([this.xb(B,(0,M.$_g)(B.extensionLocation,ue),ce),this.ib(B)]).then(oe=>(O.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Y.jb(this.s,B.identifier,oe[0],oe[1],ce))).then(oe=>(O.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),oe))}ib(B){const _=this.Z.createLanguageModelAccessInformation(B),pe=new s.$ymc(B,this.M),ue=new s.$xmc(B.identifier.value,!1,this.M),ce=new j.$Hmc(B,this.N),oe=B.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([pe.whenReady,ue.whenReady,this.O.whenReady]).then(()=>{const K=this;let se,$e;const ve=(0,d.$RG)(B,"ipc")?this.f.messagePorts?.get(i.$Tm.toKey(B.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:ue,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Me){return L.$jc(B.extensionLocation.fsPath,Me)},get storagePath(){return K.O.workspaceValue(B)?.fsPath},get globalStoragePath(){return K.O.globalValue(B).fsPath},get logPath(){return L.$jc(K.f.logsLocation.fsPath,B.identifier.value)},get logUri(){return E.URI.joinPath(K.f.logsLocation,B.identifier.value)},get storageUri(){return K.O.workspaceValue(B)},get globalStorageUri(){return K.O.globalValue(B)},get extensionMode(){return oe},get extension(){return se===void 0&&(se=new ne(K,B.identifier,B,le,!1)),se},get extensionRuntime(){return(0,d.$SG)(B,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!$e){if(!ve)return;const Me=D.Event.buffer(D.Event.fromDOMEventEmitter(ve,"message",ge=>ge.data));ve.start(),$e={onDidReceiveMessage:Me,postMessage:ve.postMessage.bind(ve)}}return $e}})})}static jb(B,_,pe,ue,ce){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(B,_,pe,ue,ce).then(oe=>new S.$rmc(!1,null,ce.build(),pe,oe,ue.subscriptions))}static kb(B,_,pe,ue,ce){if(typeof pe.activate=="function")try{ce.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${_.value}`);const oe=typeof global=="object"?global:self,le=pe.activate.apply(oe,[ue]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(le).then(K=>(ce.activateResolveStop(),K))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(pe)}lb(B,_){this.bb(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:_}).then(void 0,pe=>{this.s.error(pe)})}mb(B,_=0){const ue=Date.now();(0,F.$B)(()=>{for(let ce=_;ce<B.length;ce+=1){const oe=B[ce];for(const le of oe.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ue>50){this.mb(B,ce);break}else this.lb(oe,le)}})}nb(){this.C.$setPerformanceMarks(O.getMarks()),this.m.getConfigProvider().then(B=>{const _=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(_)this.mb(pe);else for(const ue of pe)if(ue.activationEvents)for(const ce of ue.activationEvents)ce==="onStartupFinished"&&this.lb(ue,ce)})}ob(){const B=this.ab("*",!0).then(void 0,oe=>{this.s.error(oe)});this.B(this.j.onDidChangeWorkspace(oe=>this.pb(oe.added)));const _=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(_),ue=this.rb(),ce=Promise.all([ue,B,pe]).then(()=>{});return Promise.race([ce,(0,R.$zh)(1e4)]).then(()=>{this.nb()}),ce}pb(B){return B.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(B,_))).then(()=>{})}async qb(B,_){if(this.isActivated(_.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:B.map(oe=>oe.uri),forceUsingSearch:pe||!this.c.fsExists,exists:oe=>this.c.fsExists(oe.fsPath),checkExists:(oe,le,K)=>this.y.$checkExists(oe,le,K)},ce=await(0,C.$Ewb)(ue,_);if(ce)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:ce.activationEvent}).then(void 0,oe=>this.s.error(oe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(B){throw console.error(B),B}}async sb(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:_}=this.f.environment;if(!B||!_)throw new Error(l.localize(0,null));const pe=await this.xb(null,_,new S.$qmc(!1));if(!pe||typeof pe.run!="function")throw new Error(l.localize(1,null,_.toString()));return new Promise((ue,ce)=>{const oe=(se,$e)=>{se?(F.$t&&this.s.error("Test runner called back with error",se),ce(se)):(F.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof $e=="number"&&$e>0?1:0))},le=(0,M.$Zg)(_),K=pe.run(le,oe);K&&K.then&&K.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(se=>{F.$t&&this.s.error("Test runner finished with error",se),ce(se instanceof Error&&se.stack?se.stack:String(se))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$zh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,_){return this.S[B]=_,(0,b.$Sc)(()=>{delete this.S[B]})}async getRemoteExecServer(B){const{resolver:_}=await this.ub(B);return _?.resolveExecServer?.(B,{resolveAttempt:0})}async ub(B){const _=B.indexOf("+");if(_===-1)throw new t.$oM("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=B.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(B,_){const pe=N.$be.create(!1),ue=()=>`[resolveAuthority(${(0,u.$Nl)(B)},${_})][${pe.elapsed()}ms] `,ce=W=>this.s.info(`${ue()}${W}`),oe=W=>this.s.warn(`${ue()}${W}`),le=(W,X=void 0)=>this.s.error(`${ue()}${W}`,X),K=W=>{if(W instanceof t.$oM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},se=async W=>{ce(`activating resolver for ${W}...`);const{resolver:X,authorityPrefix:Q}=await this.ub(W);if(!X)throw le(`no resolver for ${Q}`),new t.$oM(`No remote extension installed to resolve ${Q}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:Q,remoteAuthority:W}},$e=B.split(/@|%40/g).reverse();ce(`activating remote resolvers ${$e.join(" -> ")}`);let ve;try{ve=await Promise.all($e.map(se)).catch(async W=>{if(!(W instanceof t.$oM)||W._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return oe(`resolving nested authorities failed: ${W.message}`),[await se(B)]})}catch(W){return K(W)}const Me=new R.$Jh;Me.cancelAndSet(()=>ce("waiting..."),1e3);let ge,Pe;for(const[W,{authorityPrefix:X,resolver:Q,remoteAuthority:de}]of ve.entries())try{if(W===ve.length-1)ce("invoking final resolve()..."),O.mark(`code/extHost/willResolveAuthority/${X}`),ge=await Q.resolve(de,{resolveAttempt:_,execServer:Pe}),O.mark(`code/extHost/didResolveAuthorityOK/${X}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$nM.isManagedResolvedAuthority(ge)?ge:void 0));else{if(ce(`invoking resolveExecServer() for ${de}`),O.mark(`code/extHost/willResolveExecServer/${X}`),Pe=await Q.resolveExecServer?.(de,{resolveAttempt:_,execServer:Pe}),!Pe)throw new t.$oM(`Exec server was not available for ${de}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);O.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(we){return O.mark(`code/extHost/didResolveAuthorityError/${X}`),le("returned an error",we),Me.dispose(),K(we)}Me.dispose();const Ae={environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures?{elevation:ge.tunnelFeatures.elevation,privacyOptions:ge.tunnelFeatures.privacyOptions,protocol:ge.tunnelFeatures.protocol===void 0?!0:ge.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${t.$nM.isManagedResolvedAuthority(ge)?"managed authority":`${ge.host}:${ge.port}`}`);let q;if(t.$nM.isManagedResolvedAuthority(ge)){const W=_;this.Y.setFactory(W,ge.makeConnection),q={authority:B,connectTo:new u.$Kl(W),connectionToken:ge.connectionToken}}else q={authority:B,connectTo:new u.$Ll(ge.host,ge.port),connectionToken:ge.connectionToken};return{type:"ok",value:{authority:q,options:ze,tunnelInformation:Ae}}}async $getCanonicalURI(B,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Nl)(B)})`);const{resolver:pe}=await this.ub(B);if(!pe)return null;const ue=E.URI.revive(_);if(typeof pe.getCanonicalURI>"u")return ue;const ce=await(0,R.$qh)(()=>pe.getCanonicalURI(ue));return ce||ue}async $startExtensionHost(B){B.toAdd.forEach(oe=>oe.extensionLocation=E.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=H(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(B,_){return _===1?this.D.wait().then(pe=>this.ab(B,!1)):this.G.wait().then(pe=>this.ab(B,!1))}async $activate(B,_){return await this.G.wait(),this.J.getExtensionDescription(B)?(await this.bb(B,_),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(oe=>oe.extensionLocation=E.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=H(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const _=a.$He.alloc(B),pe=Math.random()%256;for(let ue=0;ue<B;ue++)_.writeUInt8(pe,ue);return _}async $updateRemoteConnectionData(B){this.X=B,this.a.fire()}};e.$Nmc=ie,e.$Nmc=ie=Y=Je([We(0,r.$xi),We(1,e.$Mmc),We(2,g.$JO),We(3,h.$$lc),We(4,p.$bmc),We(5,A.$5j),We(6,o.$ZO),We(7,f.$emc),We(8,k.$NDb),We(9,m.$zmc),We(10,z.$Jmc),We(11,U.$Kmc),We(12,y.$Dmc)],ie);function H(ee,B,_,pe){ee.addActivationEvents(pe.addActivationEvents);const ue=new c.$lac(ee,B.getAllExtensionDescriptions());ue.deltaExtensions(pe.toAdd,pe.toRemove);const ce=new i.$Um(_.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of pe.myToRemove)ce.delete(le);for(const le of pe.myToAdd)ce.add(le);const oe=be(ue,ce);return{globalRegistry:ue,myExtensions:oe}}function J(ee,B){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function x(ee){return ee.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.$Omc=(0,r.$yi)("IExtHostExtensionService");class ne{#e;#t;#n;constructor(B,_,pe,ue,ce){this.#e=B,this.#t=_,this.#n=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=L.$hc((0,M.$Zg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=ue,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Pmc=ne;function be(ee,B){return ee.getAllExtensionDescriptions().filter(_=>B.has(_.identifier))}class ae{constructor(B){this.a=B}setSearchTree(B){this.a=B}findSubstr(B){return this.a.findSubstr(B)}forEach(B){return this.a.forEach(B)}}e.$Qmc=ae;class Ie{constructor(B){this.a=new i.$Vm,this.addActivationEvents(B)}readActivationEvents(B){return this.a.get(B.identifier)??[]}addActivationEvents(B){for(const _ of Object.keys(B))this.a.set(_,B[_])}}}),define(ke[379],De([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=void 0;let h=class{constructor(a,s,t,u,r,o,f){this.c=a,this.d=s,this.e=t,this.f=u,this.g=r,this.h=o,this.i=f,this.a=new Map,this.b=[]}async install(){this.j(),l.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new c(this.c,s,this.d,a,this.i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const s of a.nodeModuleName)this.a.set(s,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(s=>a.alternativeModuleName(s))}};e.$Znc=h,e.$Znc=h=Je([We(2,A.$xi),We(3,M.$bmc),We(4,I.$Omc),We(5,E.$ZO),We(6,p.$5j)],h);let d=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&v.a.size){const s=(0,S.$bf)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${r}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const s=this.b.exec(this.c(a));if(!s)return;const[,t,u,r]=s,o=v.a.get(u);if(o!==void 0)return console.warn(`${u} as been renamed to ${o}, please update your imports`),t+o+r}c(a){return a.replace(/\\/g,"/")}};d=v=Je([We(0,E.$ZO)],d);class c{constructor(a,s,t,u,r){this.c=a,this.d=s,this.e=t,this.f=u,this.g=r,this.nodeModuleName="vscode",this.a=new b.$Vm}load(a,s){const t=this.d.findSubstr(s);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((r,o)=>u+=`	${o} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${u}`),this.b=this.c(R.$MG,this.e,this.f)}return this.b}}let n=class{constructor(a,s,t){this.e=a,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(O.$gM.MainThreadTelemetry);const u=t.getProxy(O.$gM.MainThreadWindow);this.c=(r,o)=>{const f=L.URI.parse(r);return o?this.g(r,o):f.scheme==="http"||f.scheme==="https"?u.$openUri(f,r,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this.f?u.$openUri(f,r,{}):this.g(r,o)}}load(a,s,t){const u=this.e.findSubstr(s);return u&&(this.a=u.identifier.value,this.h()),this.b=t(a),this.c}g(a,s){return this.i(),this.b(a,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,$.$JO)],n)}),define(ke[61],De([1,0,46,3,16,52,5,73,72,49,8,44,307,45]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=e.$Rmc=void 0,e.$Rmc=(0,R.$yi)("IExtHostVariableResolverProvider");class v extends p.$NP{constructor(c,n,i,a,s,t,u){function r(){if(i){const o=i.activeEditor();if(o)return o.document.uri;const f=a.tabGroups.all.find(g=>g.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof A.$7N||f.input instanceof A.$_N)return f.input.modified;if(f.input instanceof A.$6N||f.input instanceof A.$$N||f.input instanceof A.$9N)return f.input.uri}}}super({getFolderUri:o=>{const f=t.folders.filter(g=>g.name===o);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,f)=>s.getConfiguration(void 0,o).get(f),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=r();if(o)return O.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const o=r();if(o){const f=n.getWorkspaceFolder(o);if(f)return O.$hc(f.uri.fsPath)}}},getSelectedText:()=>{if(i){const o=i.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(i){const o=i.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>c.getExtension(o)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let h=class extends L.$Uc{constructor(c,n,i,a,s){super(),this.b=c,this.c=n,this.g=i,this.h=a,this.j=s,this.a=new l.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$Smc=h,e.$Smc=h=Je([We(0,E.$Omc),We(1,I.$$lc),We(2,b.$UO),We(3,S.$bmc),We(4,$.$nmc)],h)}),define(ke[96],De([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,17,19]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=e.$Vmc=e.$Umc=e.$Tmc=void 0,e.$Tmc=(0,R.$yi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(k,m,y,D,C,P,j){this.N=m,this.O=y,this.P=D,this.Q=C,this.R=P,this.S=j,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new L.$fe,this.o=new L.$fe,this.q=new L.$fe,this.w=new L.$fe,this.l=k.getProxy(b.$gM.MainThreadDebugService),this.A=new L.$fe,this.C=new L.$fe,this.y=new r(this.l),this.z=new Map,this.O.getExtensionRegistry().then(T=>{T.onDidChange(z=>{this.V(T)}),this.V(T)})}async $getVisualizerTreeItem(k,m){const y=this.W(m);if(!y)return;const D=await this.H.get(k)?.getTreeItem?.(y);return D?this.U(k,D):void 0}registerDebugVisualizationTree(k,m,y){const D=M.$Tm.toKey(k.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.H.set(C,y),this.l.$registerDebugVisualizerTree(C,!!y.editItem),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(C),this.H.delete(m)})}async $getVisualizerTreeItemChildren(k,m){const y=this.J.get(m)?.item;return y?(await this.H.get(k)?.getChildren?.(y))?.map(C=>this.U(k,C))||[]:[]}async $editVisualizerTreeItem(k,m){const y=this.J.get(k);if(!y)return;const D=await this.H.get(y.provider)?.editItem?.(y.item,m);return this.U(y.provider,D||y.item)}$disposeVisualizedTree(k){const m=this.J.get(k);if(!m)return;const y=[m.children];for(const D of y)if(D)for(const C of D)y.push(this.J.get(C)?.children),this.J.delete(C)}U(k,m){let y=this.I.get(m);return y||(y=this.F++,this.I.set(m,y),this.J.set(y,{provider:k,item:m})),a.DebugTreeItem.from(m,y)}asDebugSourceUri(k,m){const y=k;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let D=`debug:${encodeURIComponent(y.path||"")}`,C="?";return m&&(D+=`${C}session=${encodeURIComponent(m.id)}`,C="&"),D+=`${C}ref=${y.sourceReference}`,O.URI.parse(D)}else{if(y.path)return O.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(k){const m=[];for(const y of k.getAllExtensionDescriptions())if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0)for(const C of D)(0,v.$wH)(C)&&m.push(C.type)}this.l.$registerDebugTypes(m)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const k=[];return this.z.forEach(m=>k.push(m)),k}async $resolveDebugVisualizer(k,m){const y=this.L.get(k);if(!y)throw new Error(`No debug visualizer found with id '${k}'`);let{v:D,provider:C,extensionId:P}=y;if(D.visualization||(D=await C.resolveDebugVisualization?.(D,m)||D,y.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${C}'`);return this.kb(P,D.visualization)}async $executeDebugVisualizerCommand(k){const m=this.L.get(k);if(!m)throw new Error(`No debug visualizer found with id '${k}'`);const y=m.v.visualization;y&&"command"in y&&this.S.executeCommand(y.command,...y.arguments||[])}W(k){const m=this.m.get(k.sessionId);return m&&{session:m.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,m,y,D){const C=this.W(y),P=this.jb(k,m),j=this.G.get(P);if(!C||!j)return[];const T=await j.provideDebugVisualization(C,D);return T?T.map(z=>{const N=++this.M;this.L.set(N,{v:z,provider:j,extensionId:k});const F=z.iconPath?this.lb(z.iconPath):void 0;return{id:N,name:z.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.kb(k,z.visualization)}}):[]}$disposeDebugVisualizers(k){for(const m of k)this.L.delete(m)}registerDebugVisualizationProvider(k,m,y){if(!k.contributes?.debugVisualizers?.some(P=>P.id===m))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${m})`);const D=M.$Tm.toKey(k.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.G.set(C,y),this.l.$registerDebugVisualizer(D,m),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,m),this.G.delete(m)})}addBreakpoints(k){const m=k.filter(C=>{const P=C.id;return this.z.has(P)?!1:(this.z.set(P,C),!0)});this.gb(m,[],[]);const y=[],D=new Map;for(const C of m)if(C instanceof I.$kN){let P=D.get(C.location.uri.toString());P||(P={type:"sourceMulti",uri:C.location.uri,lines:[]},D.set(C.location.uri.toString(),P),y.push(P)),P.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character,mode:C.mode})}else C instanceof I.$lN&&y.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName,mode:C.mode});return this.l.$registerBreakpoints(y)}removeBreakpoints(k){const m=k.filter(P=>this.z.delete(P.id));this.gb([],m,[]);const y=m.filter(P=>P instanceof I.$kN).map(P=>P.id),D=m.filter(P=>P instanceof I.$lN).map(P=>P.id),C=m.filter(P=>P instanceof I.$mN).map(P=>P.id);return this.l.$unregisterBreakpoints(y,D,C)}startDebugging(k,m,y){return this.l.$startDebugging(k?k.uri:void 0,m,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,suppressSaveBeforeStart:y.suppressSaveBeforeStart,suppressDebugStatusbar:y.suppressDebugStatusbar??y.debugUI?.simple,suppressDebugToolbar:y.suppressDebugToolbar??y.debugUI?.simple,suppressDebugView:y.suppressDebugView??y.debugUI?.simple})}stopDebugging(k){return this.l.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,m,y){if(!m)return new I.$iM(()=>{});const D=this.d++;return this.f.push({type:k,handle:D,provider:m}),this.l.$registerDebugConfigurationProvider(k,y,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,D),new I.$iM(()=>{this.f=this.f.filter(C=>C.provider!==m),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(k,m,y){if(!y)return new I.$iM(()=>{});if(!this.cb(k,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.$(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:m,handle:D,factory:y}),this.l.$registerDebugAdapterDescriptorFactory(m,D),new I.$iM(()=>{this.h=this.h.filter(C=>C.factory!==y),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(k,m){if(!m)return new I.$iM(()=>{});const y=this.j++;return this.k.push({type:k,handle:y,factory:m}),new I.$iM(()=>{this.k=this.k.filter(D=>D.factory!==m)})}async $runInTerminal(k,m){return Promise.resolve(void 0)}async $substituteVariables(k,m){let y;const D=await this.ib(k);return D&&(y={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(y,m)}X(k,m){if(k.type==="implementation")return new f(k.implementation)}Y(){}async $startDASession(k,m){const y=this,D=await this.hb(m);return this.eb(this.$(D.type),D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const P=this.Z(C),j=this.X(P,D);if(!j)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const T=j;return this.D.set(k,T),this.db(D).then(z=>(z&&this.E.set(k,z),T.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const F=N,U={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const Y=await this.K.sign(F.arguments.value);U.body={signature:Y},T.sendResponse(U)}else throw new Error("no signer")}catch(Y){U.success=!1,U.message=Y.message,T.sendResponse(U)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(N),N=(0,v.$BH)(N,!0),y.l.$acceptDAMessage(k,N)}),T.onError(N=>{z&&z.onError&&z.onError(N),this.l.$acceptDAError(k,N.name,N.message,N.stack)}),T.onExit(N=>{z&&z.onExit&&z.onExit(N??void 0,void 0),this.l.$acceptDAExit(k,N??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),T.startSession()))})}$sendDAMessage(k,m){m=(0,v.$AH)(m,!1);const y=this.E.get(k);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(m),this.D.get(k)?.sendMessage(m)}$stopDASession(k){const m=this.E.get(k);this.E.delete(k),m&&m.onWillStopSession&&m.onWillStopSession();const y=this.D.get(k);return this.D.delete(k),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const m=[],y=[],D=[];if(k.added)for(const C of k.added){const P=C.id;if(P&&!this.z.has(P)){let j;if(C.type==="function")j=new I.$lN(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode);else if(C.type==="data")j=new I.$mN(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage,C.mode);else{const T=O.URI.revive(C.uri);j=new I.$kN(new I.$uM(T,new I.$jM(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode)}(0,I.$iN)(j,P),this.z.set(P,j),m.push(j)}}if(k.removed)for(const C of k.removed){const P=this.z.get(C);P&&(this.z.delete(C),y.push(P))}if(k.changed){for(const C of k.changed)if(C.id){const P=this.z.get(C.id);if(P){if(P instanceof I.$lN&&C.type==="function"){const j=P;j.enabled=C.enabled,j.condition=C.condition,j.hitCondition=C.hitCondition,j.logMessage=C.logMessage,j.functionName=C.functionName}else if(P instanceof I.$kN&&C.type==="source"){const j=P;j.enabled=C.enabled,j.condition=C.condition,j.hitCondition=C.hitCondition,j.logMessage=C.logMessage,j.location=new I.$uM(O.URI.revive(C.uri),new I.$jM(C.line,C.character))}D.push(P)}}}this.gb(m,y,D)}async $acceptStackFrameFocus(k){let m;if(k){const y=await this.hb(k.sessionId);k.kind==="thread"?m=new I.$sN(y.api,k.threadId):m=new I.$rN(y.api,k.threadId,k.frameId)}this.B=m,this.C.fire(this.B)}$provideDebugConfigurations(k,m,y){return(0,l.$qh)(async()=>{const D=this.bb(k);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.ib(m);return D.provideDebugConfigurations(C,y)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(k,m,y,D){return(0,l.$qh)(async()=>{const C=this.bb(k);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(m);return C.resolveDebugConfiguration(P,y,D)})}$resolveDebugConfigurationWithSubstitutedVariables(k,m,y,D){return(0,l.$qh)(async()=>{const C=this.bb(k);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(m);return C.resolveDebugConfigurationWithSubstitutedVariables(P,y,D)})}async $provideDebugAdapter(k,m){const y=this.ab(k);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(m);return this.eb(y,D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(C)})}async $acceptDebugSessionStarted(k){const m=await this.hb(k);this.n.fire(m.api)}async $acceptDebugSessionTerminated(k){const m=await this.hb(k);m&&(this.o.fire(m.api),this.m.delete(m.id))}async $acceptDebugSessionActiveChanged(k){this.u=k?await this.hb(k):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(k,m){(await this.hb(k))?._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(k,m){const D={session:(await this.hb(k)).api,event:m.event,body:m.body};this.w.fire(D)}Z(k){if(k instanceof I.$nN)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof I.$oN)return{type:"server",port:k.port,host:k.host};if(k instanceof I.$pN)return{type:"pipeServer",path:k.path};if(k instanceof I.$qN)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}$(k){const m=this.h.filter(y=>y.type===k);if(m.length>0)return m[0].factory}ab(k){const m=this.h.filter(y=>y.handle===k);if(m.length>0)return m[0].factory}bb(k){const m=this.f.filter(y=>y.handle===k);if(m.length>0)return m[0].provider}cb(k,m){if(k.contributes){const y=k.contributes.debuggers;if(y&&y.length>0){for(const D of y)if(D.label&&D.type&&D.type===m)return!0}}return!1}db(k){const y=k.configuration.type,D=this.k.filter(C=>C.type===y||C.type==="*").map(C=>(0,l.$qh)(()=>C.factory.createDebugAdapterTracker(k.api)).then(P=>P,P=>null));return Promise.race([Promise.all(D).then(C=>{const P=(0,s.$Hb)(C);if(P.length>0)return new o(P)}),new Promise(C=>setTimeout(()=>C(void 0),1e3))]).catch(C=>{})}async eb(k,m){const y=m.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new I.$oN(y));if(k){const C=await this.O.getExtensionRegistry();return(0,l.$qh)(()=>k.createDebugAdapterDescriptor(m.api,this.fb(m,C))).then(P=>{if(P)return P})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(m,D))}fb(k,m){}gb(k,m,y){(k.length>0||m.length>0||y.length>0)&&this.A.fire(Object.freeze({added:k,removed:m,changed:y}))}async hb(k){if(k)if(typeof k=="string"){const m=this.m.get(k);if(m)return m}else{let m=this.m.get(k.id);if(!m){const y=await this.ib(k.folderUri),D=k.parent?this.m.get(k.parent):void 0;m=new u(this.l,k.id,k.type,k.name,y,k.configuration,D?.api),this.m.set(m.id,m),this.l.$sessionCached(m.id)}return m}throw new Error("cannot find session")}ib(k){if(k){const m=O.URI.revive(k);return this.N.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}jb(k,m){return`${k}\0${m}`}kb(k,m){if(m){if("title"in m&&"command"in m)return{type:0};if("treeId"in m)return{type:1,id:`${k}\0${m.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(k){const m=this.mb(k);let y,D;return"id"in m?D=n.ThemeIcon.asClassName(m):y=m,{iconPath:y,iconClass:D}}mb(k){if(k instanceof I.$fN)return{id:k.id};const m=typeof k=="object"&&"dark"in k?k.dark:k,y=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof m=="string"?O.URI.file(m):m,light:typeof y=="string"?O.URI.file(y):y}}};e.$Umc=t,e.$Umc=t=Je([We(0,A.$JO),We(1,p.$$lc),We(2,E.$Omc),We(3,h.$bmc),We(4,$.$nmc),We(5,d.$Rmc),We(6,i.$6O)],t);class u{constructor(k,m,y,D,C,P,j){this.f=k,this.g=m,this.h=y,this.j=D,this.k=C,this.l=P,this.m=j}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(m){k.j=m,k.f.$setDebugSessionName(k.g,m)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(m,y){return k.f.$customDebugAdapterRequest(k.g,m,y)},getDebugProtocolBreakpoint(m){return k.f.$getDebugProtocolBreakpoint(k.g,m.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$Vmc=u;class r{constructor(k){this.value=Object.freeze({append(m){k.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.$Wmc=r;class o{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(m=>m.onError?m.onError(k):void 0)}onExit(k,m){this.d.forEach(y=>y.onExit?y.onExit(k,m):void 0)}}class f extends S.$$rb{constructor(k){super(),this.h=k,k.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let g=class extends t{constructor(k,m,y,D,C,P,j){super(k,m,y,D,C,P,j)}};e.$Xmc=g,e.$Xmc=g=Je([We(0,A.$JO),We(1,p.$$lc),We(2,E.$Omc),We(3,h.$bmc),We(4,$.$nmc),We(5,d.$Rmc),We(6,i.$6O)],g)}),define(ke[380],De([1,0,13,59,2,6,328,11,85,107,28,263,20,68,49,90]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=void 0;class d{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(b.$5j),t=i.get(p.$JO).getProxy(M.$gM.MainThreadErrors);l.setUnexpectedErrorHandler(u=>{a.error(u);const r=l.$3(u);t.$onUnexpectedError(r)})}static async installFullHandler(i){const a=i.get(b.$5j),s=i.get(p.$JO),t=i.get(v.$Omc),u=i.get(h.$4O),r=s.getProxy(M.$gM.MainThreadExtensionService),o=s.getProxy(M.$gM.MainThreadErrors),f=await t.getExtensionPathIndex(),g=new WeakMap;function w(y,D){if(g.has(y))return g.get(y).stack;let C="",P,j;for(const z of D)C+=`
	at ${z.toString()}`,j=z.getFileName(),!P&&j&&(P=f.findSubstr(O.URI.file(j)));const T=`${y.name||"Error"}: ${y.message||""}${C}`;return g.set(y,{extensionIdentifier:P?.identifier,stack:T}),T}const k=Symbol("prepareStackTrace wrapped");let m=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(y){if(y===w||!y||y[k]){m=y||w;return}m=function(D,C){return w(D,C),y.call(Error,D,C)},Object.assign(m,{[k]:!0})}}),l.setUnexpectedErrorHandler(y=>{a.error(y);const D=l.$3(y),C=g.get(y);if(!C?.extensionIdentifier){o.$onUnexpectedError(D);return}r.$onExtensionRuntimeError(C.extensionIdentifier,D);const P=u.onExtensionError(C.extensionIdentifier,y);a.trace("forwarded error to extension?",P,C)})}}e.$1nc=d;class c{constructor(i,a,s,t,u){this.a=s,this.b=new R.$tac(i,null,t),a=c.e(a,this.b);const r=new E.$wi(...(0,$.$Bs)());r.set(A.$ZO,{_serviceBrand:void 0,...a,messagePorts:u}),r.set(p.$JO,new p.$KO(this.b)),r.set(S.$8lc,new S.$9lc(t)),r.set(v.$Mmc,s);const o=new I.$fr(r,!0);o.invokeFunction(d.installEarlyHandler),this.d=o.invokeFunction(f=>f.get(b.$5j)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=o.invokeFunction(f=>f.get(v.$Omc)),this.c.initialize(),o.invokeFunction(d.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(M.$gM.MainThreadExtensionService);return O.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=O.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=O.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>O.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=O.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=O.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=O.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=O.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=O.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=O.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$2nc=c}),define(ke[381],De([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0;let i=class extends b.$Umc{constructor(r,o,f,g,w,k,m,y){super(r,o,f,g,k,m,y),this.pb=w,this.nb=new t}X(r,o){switch(r.type){case"server":return new h.$7nc(r);case"pipeServer":return new h.$8nc(r);case"executable":return new h.$9nc(r,o.type)}return super.X(r,o)}fb(r,o){const f=h.$9nc.platformAdapterExecutable(o.getAllExtensionDescriptions(),r.type);if(f)return new p.$nN(f.command,f.args,f.options)}Y(){return new R.$hec}async $runInTerminal(r,o){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const f=await this.P.getConfigProvider(),g=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),k=r.title||O.localize(0,null),m=JSON.stringify({shell:g,shellArgs:w});let y=await this.nb.checkout(m,k),D,C=!1;if(y)D=r.cwd;else{const z={shellPath:g,shellArgs:w,cwd:r.cwd,name:k,iconPath:new p.$fN("debug")};C=!0,y=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(y,m)}y.show(!0);const P=await y.processId;C?await new Promise(z=>setTimeout(z,1e3)):(y.state.isInteractedWith&&(y.sendText(""),await(0,l.$zh)(200)),f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0||g.indexOf("cmd.exe")>=0?y.sendText("cls"):g.indexOf("bash")>=0?y.sendText("clear"):L.$i?y.sendText("cls"):y.sendText("clear")));const j=(0,d.$$nc)(g,r.args,!!r.argsCanBeInterpretedByShell,D,r.env);y.sendText(j);const T=this.onDidTerminateDebugSession(z=>{z.id===o&&(this.nb.free(y),T.dispose())});return P}else if(r.kind==="external")return s(r,await this.P.getConfigProvider());return super.$runInTerminal(r,o)}};e.$_nc=i,e.$_nc=i=Je([We(0,A.$JO),We(1,v.$$lc),We(2,E.$Omc),We(3,c.$bmc),We(4,I.$zmc),We(5,$.$nmc),We(6,S.$Rmc),We(7,n.$6O)],i);let a;function s(u,r){if(!a)if(L.$i)a=new M.$5cc;else if(L.$j)a=new M.$6cc;else if(L.$k)a=new M.$7cc;else throw new Error("external terminals not supported on this platform");const o=r.getConfiguration("terminal");return a.runInTerminal(u.title,u.cwd,u.args,u.env||{},o.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,o,f=!1){const w=[...this.b.entries()].map(([k,m])=>(0,l.$lh)(async y=>{if(k.name!==o||m.lastUsedAt!==-1&&await(0,d.$0nc)(await k.processId))return null;const D=Date.now();return m.lastUsedAt+t.a>D||y.isCancellationRequested?null:m.config!==r?(f&&k.dispose(),null):(m.lastUsedAt=D,k)}));return await(0,l.$Dh)(w,k=>!!k)}insert(r,o){this.b.set(r,{lastUsedAt:Date.now(),config:o})}free(r){const o=this.b.get(r);o&&(o.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[382],De([1,0,16,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;let i=class extends p.$Dnc{constructor(s,t,u,r,o,f,g,w,k){super(s,t,u,r,o,f,g,w),this.C=u,this.D=k,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const u=t;if(!t.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const r=p.TaskHandleDTO.from(u,this.C),o=await this.a.$getTaskExecution(r);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.z(o,t);return this.a.$executeTask(r).catch(()=>{}),f}else{const r=p.TaskDTO.from(t,s);if(r===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const o=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),o}}v(s,t,u,r){const o=[];if(r)for(const f of r){this.A(f,u),(!f.definition||!s[f.definition.type])&&this.f.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const g=p.TaskDTO.from(f,u.extension);g&&(o.push(g),p.CustomExecutionDTO.is(g.execution)&&t.push(this.y(g,f,!0)))}return{tasks:o,extension:u.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const u=L.URI.file((0,c.homedir)());t=new $.$Si({uri:u,name:d.$9g(u),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const u=L.URI.revive(s),r={process:void 0,variables:Object.create(null)},o=await this.b.resolveWorkspaceFolder(u),f=await this.b.getWorkspaceFolders2()??[],g=await this.D.getResolver(),w=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(f);for(const k of t.variables)r.variables[k]=await g.resolveAsync(w,k);if(t.process!==void 0){let k;if(t.process.path!==void 0){k=t.process.path.split(l.$tc);for(let m=0;m<k.length;m++)k[m]=await g.resolveAsync(w,k[m])}r.process=await O.win32.findExecutable(await g.resolveAsync(w,t.process.name),t.process.cwd!==void 0?await g.resolveAsync(w,t.process.cwd):void 0,k)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,u){return O.win32.findExecutable(s,t,u)}};e.$4nc=i,e.$4nc=i=Je([We(0,A.$JO),We(1,I.$ZO),We(2,M.$$lc),We(3,R.$UO),We(4,b.$bmc),We(5,E.$zmc),We(6,v.$5j),We(7,h.$Olc),We(8,n.$Rmc)],i)}),define(ke[383],De([1,0,64,61]),function(he,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;class O extends L.$Smc{m(){return(0,l.homedir)()}}e.$Joc=O}),define(ke[160],De([1,0,19,7,22,47,15,16,23,2,37]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$anc=e.$_mc=void 0,e.$bnc=h;class I{constructor(n,i,a){this.d=n,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const a=this.g.folderQueries||[],s=new O.$qe(i);return new Promise((t,u)=>{this.a=new S(n);let r=!1;const o=(f,g)=>{if(!r&&!this.b){const w=this.h(f);h(f)&&typeof this.g.maxResults=="number"&&this.c+w>this.g.maxResults&&(this.b=!0,r=!0,s.cancel(),f=this.j(f,this.g.maxResults-this.c));const k=this.h(f);this.c+=k,(k>0||!h(f))&&this.a.add(f,g)}};Promise.all(a.map((f,g)=>this.k(f,w=>o(w,g),s.token))).then(f=>{s.dispose(),this.a.flush();const g=f.some(w=>!!w&&!!w.limitHit);t({limitHit:this.b||g,messages:f.flatMap(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[]),stats:{type:this.f}})},f=>{s.dispose();const g=(0,M.$jj)(f);u(new Error(g))})})}h(n){return h(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,a){const s=new A.$MK(this.g,n),t=[],u={report:f=>{if(!this.l(f))return;const g=n.folder.scheme===R.Schemas.file?(0,A.$NK)(()=>this.e.readdir($.$$g(f.uri))):void 0,w=$.$bh(n.folder,f.uri);if(w){const k=s.includedInQuery(w,b.$nc(w),g);(0,L.$kh)(k)?t.push(k.then(m=>{m&&i(f)})):k&&i(f)}}},r=this.n(n);let o;return this.d.query.type===3?o=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,r,u,a):o=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),r,u,a),t.length&&await Promise.all(t),o}l(n){if(h(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$LK)(this.g.includePattern,n.includePattern),a=(0,A.$LK)(this.g.excludePattern,n.excludePattern),s={folder:E.URI.from(n.folder),excludes:a,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$_mc=I;function p(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new d(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$5g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$anc=S;function v(c){return h(c)?{preview:{matches:(0,l.$1b)(c.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:c.preview.text},ranges:(0,l.$1b)(c.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function h(c){return!!c.preview}class d{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cnc=d}),define(ke[97],De([1,0,3,6,5,376,20,68,11,2,160]),function(he,e,l,L,O,M,R,b,$,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0,e.$fnc=p,e.$dnc=(0,O.$yi)("IExtHostSearch");let I=class{constructor(h,d,c){this.n=h,this.o=d,this.q=c,this.c=this.n.getProxy(L.$gM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new M.$$mc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProvider(h,d){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const c=this.d++;return this.e.set(c,d),this.c.$registerTextSearchProvider(c,this.s(h)),(0,l.$Sc)(()=>{this.g.delete(h),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(h,d){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const c=this.d++;return this.h.set(c,d),this.c.$registerAITextSearchProvider(c,this.s(h)),(0,l.$Sc)(()=>{this.i.delete(h),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(h,d){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const c=this.d++;return this.j.set(c,d),this.c.$registerFileSearchProvider(c,this.s(h)),(0,l.$Sc)(()=>{this.k.delete(h),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(h,d,c,n){const i=p(c),a=this.j.get(h);if(a)return this.l.fileSearch(i,a,s=>{this.c.$handleFileMatch(h,d,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,d,c){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,d,c,n){const i=this.e.get(h);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${h}`);const a=p(c);return this.t(a,i).search(t=>this.c.$handleTextMatch(h,d,t),n)}$provideAITextSearchResults(h,d,c,n){const i=this.h.get(h);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${h}`);const a=p(c);return this.v(a,i).search(t=>this.c.$handleTextMatch(h,d,t),n)}$enableExtensionHostSearch(){}t(h,d){return new A.$_mc({query:h,provider:d},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(h,d){return new A.$_mc({query:h,provider:d},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$enc=I,e.$enc=I=Je([We(0,R.$JO),We(1,b.$8lc),We(2,$.$5j)],I);function p(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(S),extraFileResources:v.extraFileResources&&v.extraFileResources.map(h=>E.URI.revive(h))}}function S(v){return{...v,folder:E.URI.revive(v.folder)}}}),define(ke[384],De([1,0,22,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,330,356,91,121,334,335,336,316,305,34,337,45,338,96,152,339,318,331,340,341,73,72,319,332,49,342,70,343,60,28,357,320,344,122,345,116,117,321,375,347,288,348,358,349,158,322,350,351,352,20,353,97,118,354,323,355,119,93,95,90,43,156,359,360,333,361,362,71,17,8,324,68,325,92,363,364,151,44,298,115,26,94]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u,r,o,f,g,w,k,m,y,D,C,P,j,T,z,N,F,U,Y,ie,H,J,x,ne,be,ae,Ie,ee,B,_,pe,ue,ce,oe,le,K,se,$e,ve,Me,ge,Pe,Ae,ze,q,W,X,Q,de,we,je,qe,Ke,tt,_e,nt,it,rt,ct,Re,Se,Ve,te,re,Ce,Ge,Oe,st,lt,mt,Dt,It,zt,Bt,kt,Zt,xt,xe,on){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=Xt;function Xt(ft){const $t=ft.get(Ie.$ZO),_t=ft.get(ae.$Slc),Qt=ft.get(ne.$dmc),Ft=ft.get(J.$Omc),gt=ft.get(kt.$$lc),Vt=ft.get(it.$4O),en=ft.get(y.$bmc),Ut=ft.get(lt.$8lc),Ye=ft.get(X.$JO),un=ft.get(tt.$wmc),Yt=ft.get(_e.$emc),Wt=ft.get(h.$6j),bt=ft.get(h.$5j),qt=ft.get(Ce.$NDb),Lt=ft.get(t.$Olc),Tt=ft.get(Bt.$Unc),tn=ft.get(we.$Gmc),Gt=ft.get(Y.$nmc),an=ft.get(oe.$Kmc),Rt=ft.get(u.$Ylc),jt=ft.get(pe.$Dmc);Ye.set(i.$hM.ExtHostFileSystemInfo,_t),Ye.set(i.$hM.ExtHostLogLevelServiceShape,Wt),Ye.set(i.$hM.ExtHostWorkspace,gt),Ye.set(i.$hM.ExtHostConfiguration,en),Ye.set(i.$hM.ExtHostExtensionService,Ft),Ye.set(i.$hM.ExtHostStorage,un),Ye.set(i.$hM.ExtHostTunnelService,qt),Ye.set(i.$hM.ExtHostWindow,Tt),Ye.set(i.$hM.ExtHostSecretState,tn),Ye.set(i.$hM.ExtHostTelemetry,Vt),Ye.set(i.$hM.ExtHostEditorTabs,Gt),Ye.set(i.$hM.ExtHostManagedSockets,an),Ye.set(i.$hM.ExtHostAuthentication,Rt),Ye.set(i.$hM.ExtHostChatProvider,jt);const Nt=Ye.set(i.$hM.ExtHostDecorations,ft.get(P.$Zmc)),At=Ye.set(i.$hM.ExtHostDocumentsAndEditors,ft.get(U.$UO)),wt=Ye.set(i.$hM.ExtHostCommands,ft.get(k.$6O)),Et=Ye.set(i.$hM.ExtHostTerminalService,ft.get(rt.$zmc)),rn=Ye.set(i.$hM.ExtHostTerminalShellIntegration,ft.get(ct.$Gnc)),Ct=Ye.set(i.$hM.ExtHostDebugService,ft.get(C.$Tmc)),fn=Ye.set(i.$hM.ExtHostSearch,ft.get(de.$dnc)),sn=Ye.set(i.$hM.ExtHostTask,ft.get(nt.$Fnc)),vn=Ye.set(i.$hM.ExtHostOutputService,ft.get(Pe.$snc)),ln=Ye.set(i.$hM.ExtHostLocalization,ft.get(ce.$Jmc)),$n=Ye.set(i.$hM.ExtHostUrls,new mt.$Rnc(Ye)),Pt=Ye.set(i.$hM.ExtHostDocuments,new F.$Vlc(Ye,At)),Le=Ye.set(i.$hM.ExtHostDocumentContentProviders,new z.$2mc(Ye,At,bt)),Fe=Ye.set(i.$hM.ExtHostDocumentSaveParticipant,new N.$3mc(bt,Pt,Ye.getProxy(i.$gM.MainThreadBulkEdits))),ye=Ye.set(i.$hM.ExtHostNotebook,new K.$gnc(Ye,wt,At,Pt,Qt,fn)),Z=Ye.set(i.$hM.ExtHostNotebookDocuments,new $e.$mnc(ye)),Te=Ye.set(i.$hM.ExtHostNotebookEditors,new ve.$nnc(bt,ye)),He=Ye.set(i.$hM.ExtHostNotebookKernels,new Me.$onc(Ye,$t,ye,wt,bt)),Ze=Ye.set(i.$hM.ExtHostNotebookRenderers,new ge.$qnc(Ye,ye)),Xe=Ye.set(i.$hM.ExtHostNotebookDocumentSaveParticipant,new se.$lnc(bt,ye,Ye.getProxy(i.$gM.MainThreadBulkEdits))),at=Ye.set(i.$hM.ExtHostEditors,new Se.$5lc(Ye,At)),St=Ye.set(i.$hM.ExtHostTreeViews,new re.$Pnc(Ye.getProxy(i.$gM.MainThreadTreeViews),wt,bt)),Jt=Ye.set(i.$hM.ExtHostEditorInsets,new w.$6lc(Ye.getProxy(i.$gM.MainThreadEditorInsets),at,$t.remote)),Ht=Ye.set(i.$hM.ExtHostDiagnostics,new j.$Ulc(Ye,bt,_t,At)),Mt=Ye.set(i.$hM.ExtHostLanguages,new ue.$jnc(Ye,Pt,wt.converter,Ut)),ht=Ye.set(i.$hM.ExtHostLanguageFeatures,new _.$Wlc(Ye,Ut,Pt,wt,Ht,bt,Lt,Vt)),On=Ye.set(i.$hM.ExtHostFileSystem,new x.$6mc(Ye,ht)),pn=Ye.set(i.$hM.ExtHostFileSystemEventService,new be.$7mc(Ye,bt,At)),En=Ye.set(i.$hM.ExtHostQuickOpen,(0,W.$wnc)(Ye,gt,wt)),Cn=Ye.set(i.$hM.ExtHostSCM,new Q.$ync(Ye,wt,Pt,bt)),Xn=Ye.set(i.$hM.ExtHostQuickDiff,new q.$vnc(Ye,Ut)),Ln=Ye.set(i.$hM.ExtHostShare,new je.$znc(Ye,Ut)),Nn=Ye.set(i.$hM.ExtHostComments,(0,m.$7lc)(Ye,wt,Pt)),In=Ye.set(i.$hM.ExtHostProgress,new ze.$unc(Ye.getProxy(i.$gM.MainThreadProgress))),Tn=Ye.set(i.$hM.ExtHostLabelService,new B.$inc(Ye)),jn=Ye.set(i.$hM.ExtHostTheming,new Ve.$Mnc(Ye)),Qn=Ye.set(i.$hM.ExtHostTimeline,new te.$Onc(Ye,wt)),Fn=Ye.set(i.$hM.ExtHostWebviews,new Dt.$imc(Ye,$t.remote,gt,bt,Lt)),Pn=Ye.set(i.$hM.ExtHostWebviewPanels,new It.$lmc(Ye,Fn,gt)),zn=Ye.set(i.$hM.ExtHostCustomEditors,new D.$mmc(Ye,Pt,Yt,Fn,Pn)),Bn=Ye.set(i.$hM.ExtHostWebviewViews,new zt.$Snc(Ye,Fn)),yn=Ye.set(i.$hM.ExtHostTesting,new Re.$Inc(Ye,bt,wt,At)),Yn=Ye.set(i.$hM.ExtHostUriOpeners,new st.$Qnc(Ye)),Zn=Ye.set(i.$hM.ExtHostProfileContentHandlers,new Ae.$tnc(Ye));Ye.set(i.$hM.ExtHostInteractive,new ee.$hnc(Ye,ye,At,wt,bt));const An=Ye.set(i.$hM.ExtHostChatAgents2,new o.$2lc(Ye,bt,wt)),xn=Ye.set(i.$hM.ExtHostChatVariables,new f.$3lc(Ye)),Un=Ye.set(i.$hM.ExtHostAiRelatedInformation,new a.$Nlc(Ye)),di=Ye.set(i.$hM.ExtHostAiEmbeddingVector,new H.$5mc(Ye)),_n=Ye.set(i.$hM.ExtHostStatusBar,new Ke.$Cnc(Ye,wt.converter)),Wn=Ye.set(i.$hM.ExtHostSpeech,new qe.$Anc(Ye)),bn=Ye.set(i.$hM.ExtHostEmbeddings,new ie.$4mc(Ye)),fi=Object.values(i.$hM);Ye.assertRegistered(fi);const gi=new r.$1lc(Ye,At),ei=new g.$4lc(Ye),qn=new le.$knc(Ye,bt),Mn=new T.$1mc(Ye);return s.$Xlc.register(wt),function(Ue,hn,Vn){function ot(fe){return(Ee,Be,ut)=>{const yt=fe(Ot=>{try{Ee.call(Be,Ot)}catch(Dn){L.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Dn.toString()}`,{cause:Dn})),Vt.onExtensionError(Ue.identifier,Dn)}});return ut?.push(yt),yt}}const vt=function(){let fe=!Ue.isUnderDevelopment;function Ee(){fe||(bt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(ut){if(Array.isArray(ut))ut.forEach(Be);else if(typeof ut=="string")Ee();else{const yt=ut;typeof yt.scheme>"u"&&Ee(),typeof yt.exclusive=="boolean"&&(0,xe.$SG)(Ue,"documentFiltersExclusive")}return ut}}(),ti={getSession(fe,Ee,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,xe.$SG)(Ue,"authLearnMore"),Rt.getSession(Ue,fe,Ee,Be)},getSessions(fe,Ee){return(0,xe.$SG)(Ue,"authGetSessions"),Rt.getSessions(Ue,fe,Ee)},async hasSession(fe,Ee){return(0,xe.$SG)(Ue,"authSession"),!!await Rt.getSession(Ue,fe,Ee,{silent:!0})},get onDidChangeSessions(){return ot(Rt.onDidChangeSessions)},registerAuthenticationProvider(fe,Ee,Be,ut){return Rt.registerAuthenticationProvider(fe,Ee,Be,ut)}},gn={registerCommand(fe,Ee,Be){return wt.registerCommand(!0,fe,Ee,Be,void 0,Ue)},registerTextEditorCommand(fe,Ee,Be){return wt.registerCommand(!0,fe,(...ut)=>{const yt=at.getActiveTextEditor();if(!yt){bt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return yt.edit(Ot=>{Ee.apply(Be,[yt,Ot,...ut])}).then(Ot=>{Ot||bt.warn("Edits from command "+fe+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+fe,Ot)})},void 0,void 0,Ue)},registerDiffInformationCommand:(fe,Ee,Be)=>((0,xe.$SG)(Ue,"diffCommand"),wt.registerCommand(!0,fe,async(...ut)=>{const yt=At.activeEditor(!0);if(!yt){bt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Ot=await at.getDiffInformation(yt.id);Ee.apply(Be,[Ot,...ut])},void 0,void 0,Ue)),executeCommand(fe,...Ee){return wt.executeCommand(fe,...Ee)},getCommands(fe=!1){return wt.getCommands(fe)}},kn={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return ei.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return ot(Et.onDidChangeShell)},get isTelemetryEnabled(){return Vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Vt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$SG)(Ue,"telemetry"),Vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$SG)(Ue,"telemetry"),ot(Vt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$3O)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,Ee){return it.$2O.validateSender(fe),Vt.instantiateLogger(Ue,fe,Ee)},openExternal(fe,Ee){return Tt.openUri(fe,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===$t.environment.appUriScheme)return $n.createAppUri(fe);try{return await Tt.asExternalUri(fe,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,R.$Hg)(fe,R.Schemas.http)||(0,R.$Hg)(fe,R.Schemas.https))return fe;throw Ee}},get remoteName(){return(0,d.$Km)($t.remote.authority)},get remoteAuthority(){return(0,xe.$SG)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return ot(bt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$SG)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,xe.$SG)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(kn);const mi={createTestController(fe,Ee,Be){return yn.createTestController(Ue,fe,Ee,Be)},createTestObserver(){return(0,xe.$SG)(Ue,"testObserver"),yn.createTestObserver()},runTests(fe){return(0,xe.$SG)(Ue,"testObserver"),yn.runTests(fe)},get onDidChangeTestResults(){return(0,xe.$SG)(Ue,"testObserver"),ot(yn.onResultsChanged)},get testResults(){return(0,xe.$SG)(Ue,"testObserver"),yn.results}},nn=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,Rn={getExtension(fe,Ee){(0,xe.$RG)(Ue,"extensionsAny")||(Ee=!1);const Be=hn.mine.getExtensionDescription(fe);if(Be)return new J.$Pmc(Ft,Ue.identifier,Be,nn,!1);if(Ee){const ut=hn.all.getExtensionDescription(fe);if(ut)return new J.$Pmc(Ft,Ue.identifier,ut,nn,!0)}},get all(){const fe=[];for(const Ee of hn.mine.getAllExtensionDescriptions())fe.push(new J.$Pmc(Ft,Ue.identifier,Ee,nn,!1));return fe},get allAcrossExtensionHosts(){(0,xe.$SG)(Ue,"extensionsAny");const fe=new S.$Um(hn.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of hn.all.getAllExtensionDescriptions()){const ut=!fe.has(Be.identifier);Ee.push(new J.$Pmc(Ft,Ue.identifier,Be,nn,ut))}return Ee},get onDidChange(){return(0,xe.$RG)(Ue,"extensionsAny")?ot(O.Event.any(hn.mine.onDidChange,hn.all.onDidChange)):ot(hn.mine.onDidChange)}},ni={createDiagnosticCollection(fe){return Ht.createDiagnosticCollection(Ue.identifier,fe)},get onDidChangeDiagnostics(){return ot(Ht.onDidChangeDiagnostics)},getDiagnostics:fe=>Ht.getDiagnostics(fe),getLanguages(){return Mt.getLanguages()},setTextDocumentLanguage(fe,Ee){return Mt.changeLanguage(fe.uri,Ee)},match(fe,Ee){const Be=Ge.LanguageSelector.from(fe);let ut;return(0,A.$2t)(Be)&&(ut=ye.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Ot=>Ot.document===Ee))?.apiNotebook),(0,A.$1t)(Be,Ee.uri,Ee.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(fe,Ee,Be){return ht.registerCodeActionProvider(Ue,vt(fe),Ee,Be)},registerDocumentPasteEditProvider(fe,Ee,Be){return(0,xe.$SG)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,vt(fe),Ee,Be)},registerCodeLensProvider(fe,Ee){return ht.registerCodeLensProvider(Ue,vt(fe),Ee)},registerDefinitionProvider(fe,Ee){return ht.registerDefinitionProvider(Ue,vt(fe),Ee)},registerDeclarationProvider(fe,Ee){return ht.registerDeclarationProvider(Ue,vt(fe),Ee)},registerImplementationProvider(fe,Ee){return ht.registerImplementationProvider(Ue,vt(fe),Ee)},registerTypeDefinitionProvider(fe,Ee){return ht.registerTypeDefinitionProvider(Ue,vt(fe),Ee)},registerHoverProvider(fe,Ee){return ht.registerHoverProvider(Ue,vt(fe),Ee,Ue.identifier)},registerEvaluatableExpressionProvider(fe,Ee){return ht.registerEvaluatableExpressionProvider(Ue,vt(fe),Ee,Ue.identifier)},registerInlineValuesProvider(fe,Ee){return ht.registerInlineValuesProvider(Ue,vt(fe),Ee,Ue.identifier)},registerDocumentHighlightProvider(fe,Ee){return ht.registerDocumentHighlightProvider(Ue,vt(fe),Ee)},registerMultiDocumentHighlightProvider(fe,Ee){return ht.registerMultiDocumentHighlightProvider(Ue,vt(fe),Ee)},registerLinkedEditingRangeProvider(fe,Ee){return ht.registerLinkedEditingRangeProvider(Ue,vt(fe),Ee)},registerReferenceProvider(fe,Ee){return ht.registerReferenceProvider(Ue,vt(fe),Ee)},registerRenameProvider(fe,Ee){return ht.registerRenameProvider(Ue,vt(fe),Ee)},registerNewSymbolNamesProvider(fe,Ee){return(0,xe.$SG)(Ue,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Ue,vt(fe),Ee)},registerDocumentSymbolProvider(fe,Ee,Be){return ht.registerDocumentSymbolProvider(Ue,vt(fe),Ee,Be)},registerWorkspaceSymbolProvider(fe){return ht.registerWorkspaceSymbolProvider(Ue,fe)},registerDocumentFormattingEditProvider(fe,Ee){return ht.registerDocumentFormattingEditProvider(Ue,vt(fe),Ee)},registerDocumentRangeFormattingEditProvider(fe,Ee){return ht.registerDocumentRangeFormattingEditProvider(Ue,vt(fe),Ee)},registerOnTypeFormattingEditProvider(fe,Ee,Be,...ut){return ht.registerOnTypeFormattingEditProvider(Ue,vt(fe),Ee,[Be].concat(ut))},registerDocumentSemanticTokensProvider(fe,Ee,Be){return ht.registerDocumentSemanticTokensProvider(Ue,vt(fe),Ee,Be)},registerDocumentRangeSemanticTokensProvider(fe,Ee,Be){return ht.registerDocumentRangeSemanticTokensProvider(Ue,vt(fe),Ee,Be)},registerSignatureHelpProvider(fe,Ee,Be,...ut){return typeof Be=="object"?ht.registerSignatureHelpProvider(Ue,vt(fe),Ee,Be):ht.registerSignatureHelpProvider(Ue,vt(fe),Ee,typeof Be>"u"?[]:[Be,...ut])},registerCompletionItemProvider(fe,Ee,...Be){return ht.registerCompletionItemProvider(Ue,vt(fe),Ee,Be)},registerInlineCompletionItemProvider(fe,Ee,Be){return Ee.handleDidShowCompletionItem&&(0,xe.$SG)(Ue,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,xe.$SG)(Ue,"inlineCompletionsAdditions"),Be&&(0,xe.$SG)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,vt(fe),Ee,Be)},registerInlineEditProvider(fe,Ee){return(0,xe.$SG)(Ue,"inlineEdit"),ht.registerInlineEditProvider(Ue,vt(fe),Ee)},registerDocumentLinkProvider(fe,Ee){return ht.registerDocumentLinkProvider(Ue,vt(fe),Ee)},registerColorProvider(fe,Ee){return ht.registerColorProvider(Ue,vt(fe),Ee)},registerFoldingRangeProvider(fe,Ee){return ht.registerFoldingRangeProvider(Ue,vt(fe),Ee)},registerSelectionRangeProvider(fe,Ee){return ht.registerSelectionRangeProvider(Ue,fe,Ee)},registerCallHierarchyProvider(fe,Ee){return ht.registerCallHierarchyProvider(Ue,fe,Ee)},registerTypeHierarchyProvider(fe,Ee){return ht.registerTypeHierarchyProvider(Ue,fe,Ee)},setLanguageConfiguration:(fe,Ee)=>ht.setLanguageConfiguration(Ue,fe,Ee),getTokenInformationAtPosition(fe,Ee){return(0,xe.$SG)(Ue,"tokenInformation"),Mt.tokenAtPosition(fe,Ee)},registerInlayHintsProvider(fe,Ee){return ht.registerInlayHintsProvider(Ue,fe,Ee)},createLanguageStatusItem(fe,Ee){return Mt.createLanguageStatusItem(Ue,fe,Ee)},registerDocumentDropEditProvider(fe,Ee,Be){return ht.registerDocumentOnDropEditProvider(Ue,fe,Ee,(0,xe.$RG)(Ue,"documentPaste")?Be:void 0)}},ii={get activeTextEditor(){return at.getActiveTextEditor()},get visibleTextEditors(){return at.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(fe,Ee,Be){$.URI.isUri(fe)&&fe.scheme===R.Schemas.vscodeRemote&&!fe.authority&&Lt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri(fe)?Promise.resolve(Hn.openTextDocument(fe)):Promise.resolve(fe));return at.showTextDocument(ut,Ee,Be)},createTextEditorDecorationType(fe){return at.createTextEditorDecorationType(Ue,fe)},onDidChangeActiveTextEditor(fe,Ee,Be){return ot(at.onDidChangeActiveTextEditor)(fe,Ee,Be)},onDidChangeVisibleTextEditors(fe,Ee,Be){return ot(at.onDidChangeVisibleTextEditors)(fe,Ee,Be)},onDidChangeTextEditorSelection(fe,Ee,Be){return ot(at.onDidChangeTextEditorSelection)(fe,Ee,Be)},onDidChangeTextEditorOptions(fe,Ee,Be){return ot(at.onDidChangeTextEditorOptions)(fe,Ee,Be)},onDidChangeTextEditorVisibleRanges(fe,Ee,Be){return ot(at.onDidChangeTextEditorVisibleRanges)(fe,Ee,Be)},onDidChangeTextEditorViewColumn(fe,Ee,Be){return ot(at.onDidChangeTextEditorViewColumn)(fe,Ee,Be)},onDidCloseTerminal(fe,Ee,Be){return ot(Et.onDidCloseTerminal)(fe,Ee,Be)},onDidOpenTerminal(fe,Ee,Be){return ot(Et.onDidOpenTerminal)(fe,Ee,Be)},onDidChangeActiveTerminal(fe,Ee,Be){return ot(Et.onDidChangeActiveTerminal)(fe,Ee,Be)},onDidChangeTerminalDimensions(fe,Ee,Be){return(0,xe.$SG)(Ue,"terminalDimensions"),ot(Et.onDidChangeTerminalDimensions)(fe,Ee,Be)},onDidChangeTerminalState(fe,Ee,Be){return ot(Et.onDidChangeTerminalState)(fe,Ee,Be)},onDidWriteTerminalData(fe,Ee,Be){return(0,xe.$SG)(Ue,"terminalDataWriteEvent"),ot(Et.onDidWriteTerminalData)(fe,Ee,Be)},onDidExecuteTerminalCommand(fe,Ee,Be){return(0,xe.$SG)(Ue,"terminalExecuteCommandEvent"),ot(Et.onDidExecuteTerminalCommand)(fe,Ee,Be)},onDidChangeTerminalShellIntegration(fe,Ee,Be){return(0,xe.$SG)(Ue,"terminalShellIntegration"),ot(rn.onDidChangeTerminalShellIntegration)(fe,Ee,Be)},onDidStartTerminalShellExecution(fe,Ee,Be){return(0,xe.$SG)(Ue,"terminalShellIntegration"),ot(rn.onDidStartTerminalShellExecution)(fe,Ee,Be)},onDidEndTerminalShellExecution(fe,Ee,Be){return(0,xe.$SG)(Ue,"terminalShellIntegration"),ot(rn.onDidEndTerminalShellExecution)(fe,Ee,Be)},get state(){return Tt.getState()},onDidChangeWindowState(fe,Ee,Be){return ot(Tt.onDidChangeWindowState)(fe,Ee,Be)},showInformationMessage(fe,...Ee){return qn.showMessage(Ue,b.default.Info,fe,Ee[0],Ee.slice(1))},showWarningMessage(fe,...Ee){return qn.showMessage(Ue,b.default.Warning,fe,Ee[0],Ee.slice(1))},showErrorMessage(fe,...Ee){return qn.showMessage(Ue,b.default.Error,fe,Ee[0],Ee.slice(1))},showQuickPick(fe,Ee,Be){return En.showQuickPick(Ue,fe,Ee,Be)},showWorkspaceFolderPick(fe){return En.showWorkspaceFolderPick(fe)},showInputBox(fe,Ee){return En.showInput(fe,Ee)},showOpenDialog(fe){return Mn.showOpenDialog(Ue,fe)},showSaveDialog(fe){return Mn.showSaveDialog(fe)},createStatusBarItem(fe,Ee,Be){let ut,yt,Ot;return typeof fe=="string"?(ut=fe,yt=Ee,Ot=Be):(yt=fe,Ot=Ee),_n.createStatusBarEntry(Ue,ut,yt,Ot)},setStatusBarMessage(fe,Ee){return _n.setStatusBarMessage(fe,Ee)},withScmProgress(fe){return Lt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),In.withProgress(Ue,{location:Oe.ProgressLocation.SourceControl},(Ee,Be)=>fe({report(ut){}}))},withProgress(fe,Ee){return In.withProgress(Ue,fe,Ee)},createOutputChannel(fe,Ee){return vn.createOutputChannel(fe,Ee,Ue)},createWebviewPanel(fe,Ee,Be,ut){return Pn.createWebviewPanel(Ue,fe,Ee,Be,ut)},createWebviewTextEditorInset(fe,Ee,Be,ut){return(0,xe.$SG)(Ue,"editorInsets"),Jt.createWebviewEditorInset(fe,Ee,Be,ut,Ue)},createTerminal(fe,Ee,Be){return typeof fe=="object"?"pty"in fe?Et.createExtensionTerminal(fe):Et.createTerminalFromOptions(fe):Et.createTerminal(fe,Ee,Be)},registerTerminalLinkProvider(fe){return Et.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Ee){return Et.registerProfileProvider(Ue,fe,Ee)},registerTerminalQuickFixProvider(fe,Ee){return(0,xe.$SG)(Ue,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(fe,Ue.identifier.value,Ee)},registerTreeDataProvider(fe,Ee){return St.registerTreeDataProvider(fe,Ee,Ue)},createTreeView(fe,Ee){return St.createTreeView(fe,Ee,Ue)},registerWebviewPanelSerializer:(fe,Ee)=>Pn.registerWebviewPanelSerializer(Ue,fe,Ee),registerCustomEditorProvider:(fe,Ee,Be={})=>zn.registerCustomEditorProvider(Ue,fe,Ee,Be),registerFileDecorationProvider(fe){return Nt.registerFileDecorationProvider(fe,Ue)},registerUriHandler(fe){return $n.registerUriHandler(Ue,fe)},createQuickPick(){return En.createQuickPick(Ue)},createInputBox(){return En.createInputBox(Ue)},get activeColorTheme(){return jn.activeColorTheme},onDidChangeActiveColorTheme(fe,Ee,Be){return ot(jn.onDidChangeActiveColorTheme)(fe,Ee,Be)},registerWebviewViewProvider(fe,Ee,Be){return Bn.registerWebviewViewProvider(Ue,fe,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return ye.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Ee,Be){return ot(ye.onDidChangeActiveNotebookEditor)(fe,Ee,Be)},get visibleNotebookEditors(){return ye.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(ye.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,Ee,Be){return ot(Te.onDidChangeNotebookEditorSelection)(fe,Ee,Be)},onDidChangeNotebookEditorVisibleRanges(fe,Ee,Be){return ot(Te.onDidChangeNotebookEditorVisibleRanges)(fe,Ee,Be)},showNotebookDocument(fe,Ee){return ye.showNotebookDocument(fe,Ee)},registerExternalUriOpener(fe,Ee,Be){return(0,xe.$SG)(Ue,"externalUriOpener"),Yn.registerExternalUriOpener(Ue.identifier,fe,Ee,Be)},registerProfileContentHandler(fe,Ee){return(0,xe.$SG)(Ue,"profileContentHandlers"),Zn.registerProfileContentHandler(Ue,fe,Ee)},registerQuickDiffProvider(fe,Ee,Be,ut){return(0,xe.$SG)(Ue,"quickDiffProvider"),Xn.registerQuickDiffProvider(vt(fe),Ee,Be,ut)},get tabGroups(){return Gt.tabGroups},registerShareProvider(fe,Ee){return(0,xe.$SG)(Ue,"shareProvider"),Ln.registerShareProvider(vt(fe),Ee)}},Hn={get rootPath(){return Lt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(fe){throw new L.$9("rootPath")},getWorkspaceFolder(fe){return gt.getWorkspaceFolder(fe)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(fe){throw new L.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(fe){throw new L.$9("workspaceFile")},updateWorkspaceFolders:(fe,Ee,...Be)=>gt.updateWorkspaceFolders(Ue,fe,Ee||0,...Be),onDidChangeWorkspaceFolders:function(fe,Ee,Be){return ot(gt.onDidChangeWorkspace)(fe,Ee,Be)},asRelativePath:(fe,Ee)=>gt.getRelativePath(fe,Ee),findFiles:(fe,Ee,Be,ut)=>gt.findFiles(fe,Ee,Be,Ue.identifier,ut),findFiles2:(fe,Ee,Be)=>((0,xe.$SG)(Ue,"findFiles2"),gt.findFiles2(fe,Ee,Ue.identifier,Be)),findTextInFiles:(fe,Ee,Be,ut)=>{(0,xe.$SG)(Ue,"findTextInFiles");let yt,Ot;return typeof Ee=="object"?(yt=Ee,Ot=Be):(yt={},Ot=Ee,ut=Be),gt.findTextInFiles(fe,yt||{},Ot,Ue.identifier,ut)},save:fe=>gt.save(fe),saveAs:fe=>gt.saveAs(fe),saveAll:fe=>gt.saveAll(fe),applyEdit(fe,Ee){return gi.applyWorkspaceEdit(fe,Ue,Ee)},createFileSystemWatcher:(fe,Ee,Be,ut)=>{let yt;return typeof Ee=="boolean"?yt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,xe.$SG)(Ue,"createFileSystemWatcher"),yt={...Ee,correlate:!0}),pn.createFileSystemWatcher(gt,Ue,fe,yt)},get textDocuments(){return Pt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new L.$9("textDocuments")},openTextDocument(fe){let Ee;const Be=fe;if(typeof fe=="string")Ee=Promise.resolve($.URI.file(fe));else if($.URI.isUri(fe))Ee=Promise.resolve(fe);else if(!Be||typeof Be=="object")Ee=Pt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>(ut.scheme===R.Schemas.vscodeRemote&&!ut.authority&&Lt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Pt.ensureDocumentData(ut).then(yt=>yt.document)))},onDidOpenTextDocument:(fe,Ee,Be)=>ot(Pt.onDidAddDocument)(fe,Ee,Be),onDidCloseTextDocument:(fe,Ee,Be)=>ot(Pt.onDidRemoveDocument)(fe,Ee,Be),onDidChangeTextDocument:(fe,Ee,Be)=>ot(Pt.onDidChangeDocument)(fe,Ee,Be),onDidSaveTextDocument:(fe,Ee,Be)=>ot(Pt.onDidSaveDocument)(fe,Ee,Be),onWillSaveTextDocument:(fe,Ee,Be)=>ot(Fe.getOnWillSaveTextDocumentEvent(Ue))(fe,Ee,Be),get notebookDocuments(){return ye.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Ee){let Be;if($.URI.isUri(fe))Be=fe,await ye.openNotebookDocument(fe);else if(typeof fe=="string")Be=$.URI.revive(await ye.createNotebookDocument({viewType:fe,content:Ee}));else throw new Error("Invalid arguments");return ye.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,Ee,Be){return ot(Z.onDidSaveNotebookDocument)(fe,Ee,Be)},onDidChangeNotebookDocument(fe,Ee,Be){return ot(Z.onDidChangeNotebookDocument)(fe,Ee,Be)},onWillSaveNotebookDocument(fe,Ee,Be){return ot(Xe.getOnWillSaveNotebookDocumentEvent(Ue))(fe,Ee,Be)},get onDidOpenNotebookDocument(){return ot(ye.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(ye.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,Ee,Be,ut){return ye.registerNotebookSerializer(Ue,fe,Ee,Be,(0,xe.$RG)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(fe,Ee,Be)=>ot(Vn.onDidChangeConfiguration)(fe,Ee,Be),getConfiguration(fe,Ee){return Ee=arguments.length===1?void 0:Ee,Vn.getConfiguration(fe,Ee,Ue)},registerTextDocumentContentProvider(fe,Ee){return Le.registerTextDocumentContentProvider(fe,Ee)},registerTaskProvider:(fe,Ee)=>(Lt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),sn.registerTaskProvider(Ue,fe,Ee)),registerFileSystemProvider(fe,Ee,Be){return(0,M.$Rc)(On.registerFileSystemProvider(Ue,fe,Ee,Be),Qt.addFileSystemProvider(fe,Ee,Be))},get fs(){return Qt.value},registerFileSearchProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"fileSearchProvider"),fn.registerFileSearchProvider(fe,Ee)),registerTextSearchProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"textSearchProvider"),fn.registerTextSearchProvider(fe,Ee)),registerAITextSearchProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"aiTextSearchProvider"),(0,xe.$SG)(Ue,"textSearchProvider"),fn.registerAITextSearchProvider(fe,Ee)),registerRemoteAuthorityResolver:(fe,Ee)=>((0,xe.$SG)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(fe,Ee)),registerResourceLabelFormatter:fe=>((0,xe.$SG)(Ue,"resolvers"),Tn.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,xe.$SG)(Ue,"resolvers"),Ft.getRemoteExecServer(fe)),onDidCreateFiles:(fe,Ee,Be)=>ot(pn.onDidCreateFile)(fe,Ee,Be),onDidDeleteFiles:(fe,Ee,Be)=>ot(pn.onDidDeleteFile)(fe,Ee,Be),onDidRenameFiles:(fe,Ee,Be)=>ot(pn.onDidRenameFile)(fe,Ee,Be),onWillCreateFiles:(fe,Ee,Be)=>ot(pn.getOnWillCreateFileEvent(Ue))(fe,Ee,Be),onWillDeleteFiles:(fe,Ee,Be)=>ot(pn.getOnWillDeleteFileEvent(Ue))(fe,Ee,Be),onWillRenameFiles:(fe,Ee,Be)=>ot(pn.getOnWillRenameFileEvent(Ue))(fe,Ee,Be),openTunnel:fe=>((0,xe.$SG)(Ue,"tunnels"),qt.openTunnel(Ue,fe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,xe.$SG)(Ue,"tunnels"),qt.getTunnels()},onDidChangeTunnels:(fe,Ee,Be)=>((0,xe.$SG)(Ue,"tunnels"),ot(qt.onDidChangeTunnels)(fe,Ee,Be)),registerPortAttributesProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"portsAttributes"),qt.registerPortsAttributesProvider(fe,Ee)),registerTunnelProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"tunnelFactory"),qt.registerTunnelProvider(fe,Ee)),registerTimelineProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"timeline"),Qn.registerTimelineProvider(fe,Ee,Ue.identifier,wt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:fe=>((0,xe.$SG)(Ue,"workspaceTrust"),gt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Ee,Be)=>ot(gt.onDidGrantWorkspaceTrust)(fe,Ee,Be),registerEditSessionIdentityProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(fe,Ee)),onWillCreateEditSessionIdentity:(fe,Ee,Be)=>((0,xe.$SG)(Ue,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Ue))(fe,Ee,Be)),registerCanonicalUriProvider:(fe,Ee)=>((0,xe.$SG)(Ue,"canonicalUriProvider"),gt.registerCanonicalUriProvider(fe,Ee)),getCanonicalUri:(fe,Ee,Be)=>((0,xe.$SG)(Ue,"canonicalUriProvider"),gt.provideCanonicalUri(fe,Ee,Be))},ri={get inputBox(){return Lt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Cn.getLastInputBox(Ue)},createSourceControl(fe,Ee,Be){return Cn.createSourceControl(Ue,fe,Ee,Be)}},$i={createCommentController(fe,Ee){return Nn.createCommentController(Ue,fe,Ee)}},si={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){return Ct.activeStackItem},registerDebugVisualizationProvider(fe,Ee){return(0,xe.$SG)(Ue,"debugVisualization"),Ct.registerDebugVisualizationProvider(Ue,fe,Ee)},registerDebugVisualizationTreeProvider(fe,Ee){return(0,xe.$SG)(Ue,"debugVisualization"),Ct.registerDebugVisualizationTree(Ue,fe,Ee)},onDidStartDebugSession(fe,Ee,Be){return ot(Ct.onDidStartDebugSession)(fe,Ee,Be)},onDidTerminateDebugSession(fe,Ee,Be){return ot(Ct.onDidTerminateDebugSession)(fe,Ee,Be)},onDidChangeActiveDebugSession(fe,Ee,Be){return ot(Ct.onDidChangeActiveDebugSession)(fe,Ee,Be)},onDidReceiveDebugSessionCustomEvent(fe,Ee,Be){return ot(Ct.onDidReceiveDebugSessionCustomEvent)(fe,Ee,Be)},onDidChangeBreakpoints(fe,Ee,Be){return ot(Ct.onDidChangeBreakpoints)(fe,Ee,Be)},onDidChangeActiveStackItem(fe,Ee,Be){return ot(Ct.onDidChangeActiveStackItem)(fe,Ee,Be)},registerDebugConfigurationProvider(fe,Ee,Be){return Ct.registerDebugConfigurationProvider(fe,Ee,Be||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Ee){return Ct.registerDebugAdapterDescriptorFactory(Ue,fe,Ee)},registerDebugAdapterTrackerFactory(fe,Ee){return Ct.registerDebugAdapterTrackerFactory(fe,Ee)},startDebugging(fe,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Ct.startDebugging(fe,Ee,{parentSession:Be}):Ct.startDebugging(fe,Ee,Be||{})},stopDebugging(fe){return Ct.stopDebugging(fe)},addBreakpoints(fe){return Ct.addBreakpoints(fe)},removeBreakpoints(fe){return Ct.removeBreakpoints(fe)},asDebugSourceUri(fe,Ee){return Ct.asDebugSourceUri(fe,Ee)}},oi={registerTaskProvider:(fe,Ee)=>sn.registerTaskProvider(Ue,fe,Ee),fetchTasks:fe=>sn.fetchTasks(fe),executeTask:fe=>sn.executeTask(Ue,fe),get taskExecutions(){return sn.taskExecutions},onDidStartTask:(fe,Ee,Be)=>ot(sn.onDidStartTask)(fe,Ee,Be),onDidEndTask:(fe,Ee,Be)=>ot(sn.onDidEndTask)(fe,Ee,Be),onDidStartTaskProcess:(fe,Ee,Be)=>ot(sn.onDidStartTaskProcess)(fe,Ee,Be),onDidEndTaskProcess:(fe,Ee,Be)=>ot(sn.onDidEndTaskProcess)(fe,Ee,Be)},pi={createNotebookController(fe,Ee,Be,ut,yt){return He.createNotebookController(Ue,fe,Ee,Be,ut,(0,xe.$RG)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Ee)=>ye.registerNotebookCellStatusBarItemProvider(Ue,fe,Ee),createRendererMessaging(fe){return Ze.createRendererMessaging(Ue,fe)},createNotebookControllerDetectionTask(fe){return(0,xe.$SG)(Ue,"notebookKernelSource"),He.createNotebookControllerDetectionTask(Ue,fe)},registerKernelSourceActionProvider(fe,Ee){return(0,xe.$SG)(Ue,"notebookKernelSource"),He.registerKernelSourceActionProvider(Ue,fe,Ee)},onDidChangeNotebookCellExecutionState(fe,Ee,Be){return(0,xe.$SG)(Ue,"notebookCellExecutionState"),ot(He.onDidChangeNotebookCellExecutionState)(fe,Ee,Be)}},bi={t(...fe){if(typeof fe[0]=="string"){const Ee=fe.shift(),Be=!fe||typeof fe[0]!="object"?fe:fe[0];return ln.getMessage(Ue.identifier.value,{message:Ee,args:Be})}return ln.getMessage(Ue.identifier.value,fe[0])},get bundle(){return ln.getBundle(Ue.identifier.value)},get uri(){return ln.getBundleUri(Ue.identifier.value)}},ai={_version:1,transferActiveChat(fe){return(0,xe.$SG)(Ue,"interactive"),An.transferActiveChat(fe)}},Gn={getRelatedInformation(fe,Ee){return(0,xe.$SG)(Ue,"aiRelatedInformation"),Un.getRelatedInformation(Ue,fe,Ee)},registerRelatedInformationProvider(fe,Ee){return(0,xe.$SG)(Ue,"aiRelatedInformation"),Un.registerRelatedInformationProvider(Ue,fe,Ee)},registerEmbeddingVectorProvider(fe,Ee){return(0,xe.$SG)(Ue,"aiRelatedInformation"),di.registerEmbeddingVectorProvider(Ue,fe,Ee)}},ci={registerChatResponseProvider(fe,Ee,Be){return(0,xe.$SG)(Ue,"chatProvider"),jt.registerLanguageModel(Ue,fe,Ee,Be)},registerChatVariableResolver(fe,Ee,Be){return(0,xe.$SG)(Ue,"chatVariableResolver"),xn.registerVariableResolver(Ue,fe,Ee,Be)},registerMappedEditsProvider(fe,Ee){return(0,xe.$SG)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,fe,Ee)},createChatParticipant(fe,Ee){return(0,xe.$SG)(Ue,"chatParticipant"),An.createChatAgent(Ue,fe,Ee)},createDynamicChatParticipant(fe,Ee,Be,ut,yt){return(0,xe.$SG)(Ue,"chatParticipantAdditions"),An.createDynamicChatAgent(Ue,fe,Ee,Be,ut,yt)}},ui={get languageModels(){return(0,xe.$SG)(Ue,"languageModels"),jt.getLanguageModelIds()},onDidChangeLanguageModels:(fe,Ee,Be)=>((0,xe.$SG)(Ue,"languageModels"),jt.onDidChangeProviders(fe,Ee,Be)),sendChatRequest(fe,Ee,Be,ut){return(0,xe.$SG)(Ue,"languageModels"),ut??=l.CancellationToken.None,Be??={},jt.sendChatRequest(Ue,fe,Ee,Be,ut)},computeTokenLength(fe,Ee,Be){return(0,xe.$SG)(Ue,"languageModels"),Be??=l.CancellationToken.None,jt.computeTokenLength(fe,Ee,Be)},getLanguageModelInformation(fe){return(0,xe.$SG)(Ue,"languageModels"),jt.getLanguageModelInfo(fe)},get embeddingModels(){return(0,xe.$SG)(Ue,"embeddings"),bn.embeddingsModels},onDidChangeEmbeddingModels:(fe,Ee,Be)=>((0,xe.$SG)(Ue,"embeddings"),bn.onDidChange(fe,Ee,Be)),registerEmbeddingsProvider(fe,Ee){return(0,xe.$SG)(Ue,"embeddings"),bn.registerEmbeddingsProvider(Ue,fe,Ee)},async computeEmbeddings(fe,Ee,Be){return(0,xe.$SG)(Ue,"embeddings"),bn.computeEmbeddings(fe,Ee,Be)}},li={registerSpeechProvider(fe,Ee){return(0,xe.$SG)(Ue,"speech"),Wn.registerProvider(Ue.identifier,fe,Ee)}};return{version:$t.version,ai:Gn,authentication:ti,commands:gn,comments:$i,chat:ci,debug:si,env:kn,extensions:Rn,interactive:ai,l10n:bi,languages:ni,lm:ui,notebooks:pi,scm:ri,speech:li,tasks:oi,tests:mi,window:ii,workspace:Hn,Breakpoint:Oe.$jN,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatResultFeedbackKind:Oe.ChatResultFeedbackKind,ChatVariableLevel:Oe.ChatVariableLevel,ChatCompletionItem:Oe.$eO,CallHierarchyIncomingCall:Oe.$HM,CallHierarchyItem:Oe.$GM,CallHierarchyOutgoingCall:Oe.$IM,CancellationError:L.$5,CancellationTokenSource:l.$qe,CandidatePortSource:i.CandidatePortSource,CodeAction:Oe.$DM,CodeActionKind:Oe.$EM,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$JM,Color:Oe.$WM,ColorInformation:Oe.$XM,ColorPresentation:Oe.$YM,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CommentThreadApplicability:Oe.CommentThreadApplicability,CompletionItem:Oe.$QM,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$RM,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$7M,DebugAdapterExecutable:Oe.$nN,DebugAdapterInlineImplementation:Oe.$qN,DebugAdapterNamedPipeServer:Oe.$pN,DebugAdapterServer:Oe.$oN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$GN,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$wM,DiagnosticRelatedInformation:Oe.$vM,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$iM,DocumentHighlight:Oe.$zM,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$AM,DocumentLink:Oe.$VM,DocumentSymbol:Oe.$CM,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$tN,InlineValueText:Oe.$uN,InlineValueVariableLookup:Oe.$vN,InlineValueEvaluatableExpression:Oe.$wN,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:O.$fe,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$IN,FileDecoration2:Oe.$IN,FileSystemError:Oe.$zN,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Oe.$AN,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$lN,InlineCompletionItem:Oe.$SM,InlineCompletionList:Oe.$TM,Hover:Oe.$xM,VerboseHover:Oe.$yM,HoverVerbosityAction:Oe.HoverVerbosityAction,IndentAction:I.IndentAction,Location:Oe.$uM,MarkdownString:Oe.$KM,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Oe.$LM,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$jM,ProcessExecution:Oe.$5M,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$HN,Range:Oe.$kM,RelativePattern:Oe.$hN,Selection:Oe.$lM,SelectionRange:Oe.$FM,SemanticTokens:Oe.$DN,SemanticTokensBuilder:Oe.$CN,SemanticTokensEdit:Oe.$EN,SemanticTokensEdits:Oe.$FN,SemanticTokensLegend:Oe.$BN,ShellExecution:Oe.$6M,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$NM,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$MM,SnippetString:Oe.$tM,SourceBreakpoint:Oe.$kN,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$BM,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$8M,TaskGroup:Oe.$4M,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$ZM,TerminalQuickFixTerminalCommand:Oe.$2M,TerminalQuickFixOpener:Oe.$1M,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$3M,TerminalExitReason:Oe.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Oe.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$pM,SnippetTextEdit:Oe.$rM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$gN,ThemeIcon:Oe.$fN,TreeItem:Oe.$9M,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$5N,UIKind:xt.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$sM,DocumentPasteTriggerKind:Oe.DocumentPasteTriggerKind,DocumentDropEdit:Oe.$cN,DocumentDropOrPasteEditKind:Oe.$dN,DocumentPasteEdit:Oe.$eN,InlayHint:Oe.$PM,InlayHintLabelPart:Oe.$OM,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$oM,ResolvedAuthority:Oe.$mM,ManagedResolvedAuthority:Oe.$nM,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$SN,NotebookRange:Oe.$KN,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$LN,NotebookData:Oe.$MN,NotebookRendererScript:Oe.$QN,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$ON,NotebookCellOutputItem:Oe.$NN,NotebookCellStatusBarItem:Oe.$PN,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$qM,NotebookKernelSourceAction:Oe.$RN,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$UN,LinkedEditingRanges:Oe.$TN,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$VN,TestMessage:Oe.$WN,TestTag:Oe.$XN,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:on.TextSearchCompleteMessageType,DataTransfer:Oe.$bN,DataTransferItem:Oe.$0M,TestCoverageCount:Oe.$YN,FileCoverage:Oe.$1N,StatementCoverage:Oe.$2N,BranchCoverage:Oe.$3N,DeclarationCoverage:Oe.$4N,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$6N,TabInputTextDiff:Oe.$7N,TabInputTextMerge:Oe.$8N,TabInputCustom:Oe.$9N,TabInputNotebook:Oe.$$N,TabInputNotebookDiff:Oe.$_N,TabInputWebview:Oe.$0N,TabInputTerminal:Oe.$aO,TabInputInteractiveWindow:Oe.$bO,TabInputChat:Oe.$cO,TabInputTextMultiDiff:Oe.$dO,TelemetryTrustedValue:c.$ip,LogLevel:h.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatCopyKind:Oe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Oe.$rN,DebugThread:Oe.$sN,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,TextToSpeechStatus:Oe.TextToSpeechStatus,PartialAcceptTriggerKind:Oe.PartialAcceptTriggerKind,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Oe.$fO,ChatResponseFileTreePart:Oe.$jO,ChatResponseAnchorPart:Oe.$kO,ChatResponseProgressPart:Oe.$lO,ChatResponseReferencePart:Oe.$oO,ChatResponseWarningPart:Oe.$mO,ChatResponseTextEditPart:Oe.$pO,ChatResponseMarkdownWithVulnerabilitiesPart:Oe.$gO,ChatResponseCommandButtonPart:Oe.$nO,ChatResponseDetectedParticipantPart:Oe.$hO,ChatResponseConfirmationPart:Oe.$iO,ChatRequestTurn:Oe.$qO,ChatResponseTurn:Oe.$rO,ChatLocation:Oe.ChatLocation,LanguageModelChatMessageRole:Oe.LanguageModelChatMessageRole,LanguageModelChatMessage:Oe.$sO,LanguageModelChatMessage2:Oe.$sO,LanguageModelChatSystemMessage:Oe.$tO,LanguageModelChatUserMessage:Oe.$uO,LanguageModelChatAssistantMessage:Oe.$vO,LanguageModelError:Oe.$wO,NewSymbolName:Oe.$yN,NewSymbolNameTag:Oe.NewSymbolNameTag,NewSymbolNameTriggerKind:Oe.NewSymbolNameTriggerKind,InlineEdit:Oe.$xO,InlineEditTriggerKind:Oe.InlineEditTriggerKind}}}}),define(ke[385],De([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u,r,o,f,g,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$As)(o.$Jmc,o.$Imc,1),(0,l.$As)(u.$6j,t.$Wnc,1),(0,l.$As)(h.$Olc,h.$Plc,1),(0,l.$As)(b.$6O,b.$5O,0),(0,l.$As)(g.$Ylc,g.$Zlc,0),(0,l.$As)(w.$Dmc,w.$Emc,0),(0,l.$As)(R.$bmc,R.$_lc,0),(0,l.$As)(c.$dmc,c.$cmc,0),(0,l.$As)(I.$Tmc,I.$Xmc,0),(0,l.$As)(M.$Zmc,M.$Ymc,0),(0,l.$As)($.$UO,$.$TO,0),(0,l.$As)(f.$Kmc,f.$Lmc,0),(0,l.$As)(n.$Slc,n.$Rlc,0),(0,l.$As)(L.$snc,L.$rnc,1),(0,l.$As)(p.$dnc,p.$enc,0),(0,l.$As)(S.$wmc,S.$vmc,0),(0,l.$As)(A.$Fnc,A.$Enc,0),(0,l.$As)(E.$zmc,E.$Cmc,0),(0,l.$As)(k.$Gnc,k.$Hnc,0),(0,l.$As)(v.$NDb,v.$ODb,0),(0,l.$As)(d.$Unc,d.$Tnc,0),(0,l.$As)(O.$$lc,O.$0lc,0),(0,l.$As)(i.$Gmc,i.$Fmc,0),(0,l.$As)(a.$4O,a.$1O,0),(0,l.$As)(s.$nmc,s.$omc,0),(0,l.$As)(r.$Rmc,r.$Smc,0)}),define(ke[123],De([1,0,19,11,37,94]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0,e.$aoc=R,e.$boc=b;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,p,S,v){const h=(0,l.$1b)(S,$),d=new O.$yK(p,h,v),c=d.preview.matches;return{ranges:(0,l.$1b)(h,E),uri:I,preview:{text:d.preview.text,matches:(0,l.$1b)(c,E)}}}function $(I){return new O.$zK(I.start.line,I.start.character,I.end.line,I.end.character)}function E(I){return new M.$nK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(p,S){this.a=p,this.b=S}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$coc=A,e.$coc=A=Je([We(1,L.$5j)],A)}),define(ke[386],De([1,0,54,16,77,31,12,14,123,387]),function(he,e,l,L,O,M,R,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=I,e.$eoc=d,e.$foc=n;const A=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,a,s,t){const u=p(i,a,s,t),r=a.folder.fsPath;return{cmd:l.spawn(A,u.args,{cwd:r}),rgDiskPath:A,siblingClauses:u.siblingClauses,rgArgs:u,cwd:r}}function p(i,a,s,t){const u=["--files","--hidden","--case-sensitive","--no-require-git"];v([a],s,!1).forEach(o=>{const f=(0,$.$aoc)(o);if(u.push("-g",f),R.$j){const g=(0,O.$em)(f);g!==f&&u.push("-g",g)}});const r=S([a],t,void 0,!1);return r.globArgs.forEach(o=>{const f=`!${(0,$.$aoc)(o)}`;if(u.push("-g",f),R.$j){const g=(0,O.$em)(f);g!==f&&u.push("-g",g)}}),a.disregardIgnoreFiles!==!1?u.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),a.ignoreSymlinks||u.push("--follow"),i.exists&&u.push("--quiet"),u.push("--no-config"),a.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:r.siblingClauses}}function S(i,a,s,t=!0){const u=[];let r={};return i.forEach(o=>{const f=Object.assign({},o.excludePattern||{},a||{}),g=h(f,t?o.folder.fsPath:void 0,s);u.push(...g.globArgs),g.siblingClauses&&(r=Object.assign(r,g.siblingClauses))}),{globArgs:u,siblingClauses:r}}function v(i,a,s=!0){const t=[];return i.forEach(u=>{const r=Object.assign({},a||{},u.includePattern||{}),o=h(r,s?u.folder.fsPath:void 0);t.push(...o.globArgs)}),t}function h(i,a,s){const t=[],u={};return Object.keys(i).forEach(r=>{if(s&&s.has(r)||!r)return;const o=i[r];r=c(a?d(a,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof o=="boolean"&&o?(r.startsWith("\\\\")&&(r+="**"),t.push(n(r))):o&&o.when&&(u[r]=o)}),{globArgs:t,siblingClauses:u}}function d(i,a){return L.$ic(a)?a:L.$jc(i,a)}function c(i){return i=b.$hf(i,"\\"),b.$hf(i,"/")}function n(i){return M.$tg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[388],De([1,0,54,53,16,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=e.$goc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(r=>r())});class a{constructor(o){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=o,this.b=o.filePattern||"",this.d=o.includePattern&&$.$sk(o.includePattern),this.f=o.maxResults||null,this.g=!!o.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=o.shouldGlobMatchFilePattern?null:(0,n.$Ar)(this.b).normalizedLowercase),this.u=o.excludePattern&&$.$sk(o.excludePattern),this.t=new Map,o.folderQueries.forEach(f=>{const g=Object.assign({},f.excludePattern||{},this.a.excludePattern||{}),w=f.folder.fsPath;o.folderQueries.map(k=>k.folder.fsPath).filter(k=>k!==w).forEach(k=>{(0,A.$xg)(k,w)&&(g[O.$lc(w,k)]=!0)}),this.t.set(w,new t(g,w))})}cancel(){this.l=!0,i.forEach(o=>o())}walk(o,f,g,w,k){if(this.m=p.$be.create(!1),this.l)return k(null,this.j);f.forEach(m=>{const y=O.$nc(m.fsPath);this.u&&this.u(m.fsPath,y)||this.J(g,{relativePath:m.fsPath,searchPath:void 0})}),this.r=p.$be.create(!1),this.w(o,(m,y)=>{this.x(this.y,this,m,g,w,D=>{if(D){const C=(0,b.$jj)(D);console.error(C),this.q.push(C),y(D,void 0)}else y(null,void 0)})},(m,y)=>{this.m.stop();const D=m?R.$Hb(m)[0]:null;k(D,this.j)})}w(o,f,g){const w=new Array(o.length),k=new Array(o.length);let m=!1,y=0;if(o.length===0)return g(null,[]);o.forEach((D,C)=>{f(D,(P,j)=>{if(P?(m=!0,w[C]=null,k[C]=P):(w[C]=j,k[C]=null),++y===o.length)return g(m?k:null,w)})})}x(o,f,...g){try{o.apply(f,g)}catch(w){g[g.length-1](w)}}y(o,f,g,w){const k=o.folder.fsPath,m=I.$j,y=()=>T&&T.kill();i.add(y);let D=U=>{i.delete(y),D=()=>{},w(U)},C="";const P=this.D(),j=(0,c.$doc)(this.a,o,this.a.includePattern,this.t.get(o.folder.fsPath).expression),T=j.cmd,z=!Object.keys(j.siblingClauses).length,N=j.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${j.rgDiskPath} ${N}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),g({message:F}),this.s=0,this.z(T,"utf8",g,(U,Y,ie)=>{if(U){D(U);return}if(this.j){D();return}const J=(C+(m?E.$dm(Y||""):Y)).split(`
`);if(ie){const x=J.length;J[x-1]=J[x-1].trim(),J[x-1]||J.pop()}else C=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=J.length,z){for(const x of J)if(this.J(f,{base:k,relativePath:x,searchPath:this.N(o,x)}),this.j){y();break}(ie||this.j)&&D();return}this.G(o,P,k,J,f),ie&&(this.H(P,k,f),D())})}spawnFindCmd(o){const f=this.t.get(o.folder.fsPath),g=f.getBasenameTerms(),w=f.getPathTerms(),k=["-L","."];if(g.length||w.length){k.push("-not","(","(");for(const m of g)k.push("-name",m),k.push("-o");for(const m of w)k.push("-path",m),k.push("-o");k.pop(),k.push(")","-prune",")")}return k.push("-type","f"),l.spawn("find",k,{cwd:o.folder.fsPath})}readStdout(o,f,g){let w="";this.z(o,f,()=>{},(k,m,y)=>{if(k){g(k);return}w+=m,y&&g(null,w)})}z(o,f,g,w){let k=(D,C,P)=>{(D||P)&&(k=()=>{},this.r?.stop()),w(D,C,P)},m=!1;o.stdout?(this.A(o.stdout,f,k),o.stdout.once("data",()=>m=!0)):g({message:"stdout is null"});let y;o.stderr?y=this.B(o.stderr):g({message:"stderr is null"}),o.on("error",D=>{k(D)}),o.on("close",D=>{let C;!m&&(C=this.C(y,f))&&u(C)?k(new Error(`command failed with error code ${D}: ${this.C(y,f)}`)):(this.g&&D===0&&(this.j=!0),k(null,"",!0))})}A(o,f,g){const w=new M.StringDecoder(f);return o.on("data",k=>{g(null,w.write(k))}),w}B(o){const f=[];return o.on("data",g=>{f.push(g)}),f}C(o,f){const g=new M.StringDecoder(f);return o.map(w=>g.write(w)).join("")}D(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}G(o,{pathToEntries:f},g,w,k){w.indexOf(this.b)!==-1&&this.J(k,{base:g,relativePath:this.b,searchPath:this.N(o,this.b)});const m=y=>{const D=O.$nc(y),C=O.$mc(y);let P=f[C];P||(P=f[C]=[],m(C)),P.push({base:g,relativePath:y,basename:D,searchPath:this.N(o,y)})};w.forEach(m)}H({rootEntries:o,pathToEntries:f},g,w){const k=this,m=this.t.get(g),y=this.b;function D(C){k.o++;const P=(0,d.$OK)(()=>C.map(j=>j.basename));for(let j=0,T=C.length;j<T;j++){const z=C[j],{relativePath:N,basename:F}=z;if(m.test(N,F,y!==F?P:void 0))continue;const U=f[N];if(U)D(U);else{if(k.p++,N===y)continue;k.J(w,z)}if(k.j)break}}D(o)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(o,f,g,w,k){const m=o.folder,y=(0,d.$OK)(()=>g);this.w(g,(D,C)=>{if(this.l||this.j)return C(null);const P=f?[f,D].join(O.sep):D;if(this.t.get(o.folder.fsPath).test(P,D,this.a.filePattern!==D?y:void 0))return C(null);const j=[m.fsPath,P].join(O.sep);L.lstat(j,(T,z)=>{if(T||this.l||this.j)return C(null);this.L(j,z,(N,F)=>N||this.l||this.j?C(null):F.isDirectory()?(this.o++,this.M(j,z,(U,Y)=>U||this.l||this.j||(Y=Y||"",this.v[Y])?C(null):(this.v[Y]=!0,h.Promises.readdir(j).then(ie=>{if(this.l||this.j)return C(null);this.I(o,P,ie,w,H=>C(H||null))},ie=>{C(null)})))):(this.p++,P===this.b||this.h&&v.$cg(F.size)&&F.size>this.h||this.J(w,{base:m.fsPath,relativePath:P,searchPath:this.N(o,P)}),C(null,void 0)))})},D=>{const C=D&&R.$Hb(D);return k(C&&C.length>0?C[0]:void 0)})}J(o,f){this.K(f)&&(!this.d||this.d(f.relativePath,O.$nc(f.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||o(f))}K(o){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.$JK)(o,this.c);if(this.b)return(0,d.$JK)(o,this.b,!1)}return!0}L(o,f,g){return f.isSymbolicLink()?L.stat(o,g):g(null,f)}M(o,f,g){return f.isSymbolicLink()?L.realpath(o,(w,k)=>w?g(w):g(null,k)):g(null,o)}N(o,f){return o.folderName?O.$jc(o.folderName,f):f}}e.$goc=a;class s{constructor(o){this.a=o.folderQueries,this.b=o.extraFileResources||[],this.c=new a(o)}search(o,f,g){this.c.walk(this.a,this.b,o,f,(w,k)=>{g(w,{limitHit:k,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$hoc=s;class t{constructor(o,f){this.expression=o,this.c=f,this.d(o)}d(o){let f,g;Object.keys(o).filter(w=>o[w]).forEach(w=>{O.$ic(w)?(f=f||$.$nk(),f[w]=o[w]):(g=g||$.$nk(),g[w]=o[w])}),this.a=f&&$.$sk(f,{trimForExclusions:!0}),this.b=g&&$.$sk(g,{trimForExclusions:!0})}test(o,f,g){return this.b&&this.b(o,f,g)||this.a&&this.a(O.$jc(this.c,o),f,g)}getBasenameTerms(){const o=[];return this.a&&o.push(...$.$uk(this.a)),this.b&&o.push(...$.$uk(this.b)),o}getPathTerms(){const o=[];return this.a&&o.push(...$.$vk(this.a)),this.b&&o.push(...$.$vk(this.b)),o}}function u(r){const o=r.trim().split(`
`),f=o[0].trim();if(f.startsWith("Error parsing regex"))return f;if(f.startsWith("regex parse error"))return S.$3f(o[o.length-1].trim());if(f.startsWith("error parsing glob")||f.startsWith("unsupported encoding"))return f.charAt(0).toUpperCase()+f.substr(1);if(f==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(f.startsWith("Literal "))return f}}),define(ke[390],De([1,0,98,21,198,22]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pE=e.$hE=e.DecodeStreamErrorKind=e.$gE=e.$fE=e.$eE=e.$cE=e.$bE=e.$aE=e.$_D=void 0,e.$dE=R,e.$iE=v,e.$jE=h,e.$kE=d,e.$lE=c,e.$mE=n,e.$nE=r,e.$oE=o,e.$_D="utf8",e.$aE="utf8bom",e.$bE="utf16be",e.$cE="utf16le";function R(f){return[e.$_D,e.$aE,e.$bE,e.$cE].some(g=>g===f)}e.$eE=[254,255],e.$fE=[255,254],e.$gE=[239,187,191];const b=512,$=512,E=512*8,A=512*128;var I;(function(f){f[f.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(g,w){super(g),this.decodeStreamErrorKind=w}}e.$hE=p;class S{static async create(g){let w;if(g!==e.$_D)w=(await(0,O.$$D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(g));else{const k=new TextDecoder;w={write(m){return k.decode(m,{stream:!0})},end(){return k.decode()}}}return new S(w)}constructor(g){this.a=g}write(g){return this.a.write(g)}end(){return this.a.end()}}function v(f,g){const w=g.minBytesRequiredForDetection??g.guessEncoding?E:$;return new Promise((k,m)=>{const y=(0,l.$ve)(z=>z.join("")),D=[];let C=0,P;const j=new M.$qe,T=async()=>{try{const z=await o({buffer:L.$He.concat(D),bytesRead:C},g.guessEncoding);if(z.seemsBinary&&g.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await g.overwriteEncoding(z.encoding),P=await S.create(z.encoding);const N=P.write(L.$He.concat(D).buffer);y.write(N),D.length=0,C=0,k({stream:y,detected:z})}catch(z){j.cancel(),y.destroy(),m(z)}};(0,l.$ze)(f,{onData:async z=>{P?y.write(P.write(z.buffer)):(D.push(z),C+=z.byteLength,C>=w&&(f.pause(),await T(),setTimeout(()=>f.resume())))},onError:z=>y.error(z),onEnd:async()=>{P||await T(),y.end(P?.end())}},j.token)})}async function h(f,g,w){const m=(await(0,O.$$D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(g),w);let y=!1,D=!1;return{read(){if(D)return null;const C=f.read();if(typeof C!="string"){if(D=!0,!y&&w?.addBOM)switch(g){case e.$_D:case e.$aE:return L.$He.wrap(Uint8Array.from(e.$gE));case e.$bE:return L.$He.wrap(Uint8Array.from(e.$eE));case e.$cE:return L.$He.wrap(Uint8Array.from(e.$fE))}const P=m.end();return P&&P.length>0?(y=!0,L.$He.wrap(P)):null}return y=!0,L.$He.wrap(m.write(C))}}}async function d(f){return(await(0,O.$$D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(f))}function c(f){return f===e.$aE||f===null?e.$_D:f}function n(f,g){if(!f||g<e.$eE.length)return null;const w=f.readUInt8(0),k=f.readUInt8(1);if(w===e.$eE[0]&&k===e.$eE[1])return e.$bE;if(w===e.$fE[0]&&k===e.$fE[1])return e.$cE;if(g<e.$gE.length)return null;const m=f.readUInt8(2);return w===e.$gE[0]&&k===e.$gE[1]&&m===e.$gE[2]?e.$aE:null}const i=["ascii","utf-16","utf-32"];async function a(f){const g=await(0,O.$$D)("jschardet","dist/jschardet.min.js"),w=f.slice(0,A),k=u(w.buffer),m=g.detect(k);if(!m||!m.encoding)return null;const y=m.encoding.toLowerCase();return 0<=i.indexOf(y)?null:t(m.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(f){const g=f.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[g]||g}function u(f){let g="";for(let w=0;w<f.length;w++)g+=String.fromCharCode(f[w]);return g}function r(f){switch(f){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const g=f.match(/windows(\d+)/);return g?"windows-"+g[1]:f}}}function o({buffer:f,bytesRead:g},w){let k=n(f,g),m=!1;if(k!==e.$bE&&k!==e.$cE&&f){let y=!0,D=!0,C=!1;for(let P=0;P<g&&P<b;P++){const j=P%2===1,T=f.readUInt8(P)===0;if(T&&(C=!0),y&&(j&&!T||!j&&T)&&(y=!1),D&&(j&&T||!j&&!T)&&(D=!1),T&&!y&&!D)break}C&&(y?k=e.$cE:D?k=e.$bE:m=!0)}return w&&!m&&!k&&f?a(f.slice(0,g)).then(y=>({seemsBinary:!1,encoding:y})):{seemsBinary:m,encoding:k}}e.$pE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[161],De([1,0,390,32,160]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class M extends O.$_mc{constructor(b,$,E=L,A="searchProcess"){super({query:b,provider:$},{readdir:I=>E.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,l.$nE)(I)},A)}}e.$poc=M}),define(ke[162],De([1,0,54,406,389,19,74,35,14,2,37,94,407,387,123]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=e.$ioc=void 0,e.$koc=t,e.$loc=r,e.$moc=f,e.$noc=g,e.$ooc=k;const h=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(y){this.a=y}provideTextSearchResults(y,D,C,P){return this.a.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((j,T)=>{P.onCancellationRequested(()=>J());const z=t(y,D),N=D.folder.fsPath,F=z.map(Ie=>Ie.match(/^-/)?Ie:`'${Ie}'`).join(" ");this.a.appendLine(`${h} ${F}
 - cwd: ${N}`);let U=l.spawn(h,z,{cwd:N});U.on("error",Ie=>{console.error(Ie),this.a.appendLine("Error: "+(Ie&&Ie.message)),T((0,A.$FK)(new A.$DK(Ie&&Ie.message,A.SearchErrorCode.rgProcessError)))});let Y=!1;const ie=new i(D.maxResults,D.folder,D.previewOptions);ie.on("result",Ie=>{Y=!0,ne="",C.report(Ie)});let H=!1;const J=()=>{H=!0,U?.kill(),ie?.cancel()};let x=!1;ie.on("hitLimit",()=>{x=!0,J()});let ne="";U.stdout.on("data",Ie=>{ie.handleData(Ie),Y||(ne+=Ie)});let be=!1;U.stdout.once("data",()=>be=!0);let ae="";U.stderr.on("data",Ie=>{const ee=Ie.toString();this.a.appendLine(ee),ae.length+ee.length<1e6&&(ae+=ee)}),U.on("close",()=>{if(this.a.appendLine(be?"Got data from stdout":"No data from stdout"),this.a.appendLine(Y?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),H)j({limitHit:x});else{ie.flush(),U=null;let Ie;ae&&!be&&(Ie=c(ae))?T((0,A.$FK)(new A.$DK(Ie.message,Ie.code))):j({limitHit:x})}})})}}e.$ioc=d;function c(m){const y=m.split(`
`),D=y[0].trim();if(y.some(P=>P.startsWith("regex parse error")))return new A.$DK(n(y),A.SearchErrorCode.regexParseError);const C=D.match(/grep config error: unknown encoding: (.*)/);if(C)return new A.$DK(`Unknown encoding: ${C[1]}`,A.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new A.$DK(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new A.$DK(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new A.$DK(D,A.SearchErrorCode.regexParseError)}function n(m){const y=["Regex parse error"],D=m.filter(C=>C.startsWith("PCRE2:"));if(D.length>=1){const C=D[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const P=C.split(":")[1];y.push(":"+P)}}return y.join("")}class i extends L.EventEmitter{constructor(y,D,C){super(),this.g=y,this.h=D,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new O.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(y,D){return super.on(y,D),this}handleData(y){if(this.b)return;const D=typeof y=="string"?y:this.d.write(y);this.k(D)}k(y){let D=y.indexOf(`
`);const C=this.a+y;if(D>=0)D+=this.a.length;else{this.a=C;return}let P=0;for(;D>=0;)this.m(C.substring(P,D).trim()),P=D+1,D=C.indexOf(`
`,P);this.a=C.substring(P)}m(y){if(this.b||!y)return;let D;try{D=JSON.parse(y)}catch{throw new Error(`malformed line from rg: ${y}`)}if(D.type==="match"){const C=a(D.data.path),P=E.URI.joinPath(this.h,C),j=this.n(D.data,P);this.p(j),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const C=a(D.data.path),P=E.URI.joinPath(this.h,C);this.o(D.data,P).forEach(T=>this.p(T))}}n(y,D){const C=y.line_number-1,P=a(y.lines),j=Buffer.from(P);let T=0,z=0,N=C;y.submatches.length===0&&y.submatches.push(P.length?{start:0,end:1,match:{text:P[0]}}:{start:0,end:0,match:{text:""}});const F=(0,M.$Hb)(y.submatches.map((U,Y)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=a(U.match),H=j.slice(T,U.start).toString(),J=s(H),x=J.numLines>0?J.lastLineLength:J.lastLineLength+z,ne=s(ie),be=J.numLines+N,ae=ne.numLines+be,Ie=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+x;return T=U.end,z=Ie,N=ae,new I.$nK(be,x,ae,Ie)}));return(0,v.$boc)(D,P,F,this.j)}o(y,D){const C=a(y.lines),P=y.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((j,T)=>({text:j,uri:D,lineNumber:P+T}))}p(y){this.emit("result",y)}}e.$joc=i;function a(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function s(m){const y=/\n/g;let D=0,C=-1,P;for(;P=y.exec(m);)D++,C=P.index;const j=C>=0?m.length-C-1:m.length;return{numLines:D,lastLineLength:j}}function t(m,y){const D=["--hidden","--no-require-git"];D.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:P}=(0,R.$K)(y.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(P&&P.length){const T=new Set;P.forEach(z=>{T.add(z)}),D.push("-g","!*"),T.forEach(z=>{u(z).map(v.$aoc).forEach(N=>{D.push("-g",N)})})}C&&C.length&&C.forEach(T=>{D.push("-g",T)}),y.excludes.map(v.$aoc).forEach(T=>D.push("-g",`!${T}`)),y.maxFileSize&&D.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?y.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),y.followSymlinks&&D.push("--follow"),y.encoding&&y.encoding!=="utf8"&&D.push("--encoding",y.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,$.$bf)(m.pattern),m.isRegExp=!0),y.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),m.isRegExp&&(m.pattern=r(m.pattern),D.push("--engine","auto"));let j;if(m.isWordMatch){const z=(0,$.$kf)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",z)}else if(m.isRegExp){let T=f(m.pattern);T=g(T),D.push("--regexp",T)}else j=m.pattern,D.push("--fixed-strings");return D.push("--no-config"),y.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),m.isMultiline&&D.push("--multiline"),y.beforeContext&&D.push("--before-context",y.beforeContext+""),y.afterContext&&D.push("--after-context",y.afterContext+""),D.push("--"),j&&D.push(j),D.push("."),D}function u(m){return k(m).flatMap(D=>{const C=(0,b.$qk)(D,"/");return C.map((P,j)=>C.slice(0,j+1).join("/"))})}function r(m){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(y);)m=m.replace(y,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(D);)m=m.replace(D,"$1\\x{$2}");return m}const o=m=>m.type==="Assertion"&&m.kind==="lookbehind";function f(m){let y;try{y=new p.RegExpParser().parsePattern(m)}catch{return m}let D="",C=0;const P=(z,N,F)=>{D+=m.slice(C,z)+F,C=N},j=[];return new p.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const N=j[0];if(!N)P(z.start,z.end,"\\r?\\n");else if(!j.some(o))if(N.type==="CharacterClass")if(N.negate){const F=m.slice(N.start+2,z.start)+m.slice(z.end,N.end-1);N.parent?.type==="Quantifier"?P(N.start,N.end,F?`[^${F}]`:"."):P(N.start,N.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=m.slice(N.start+1,z.start)+m.slice(z.end,N.end-1);P(N.start,N.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else N.type==="Quantifier"&&P(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){j.unshift(z)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(z){j.unshift(z)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(z){j.unshift(z)},onCharacterClassLeave(){j.shift()},onAssertionEnter(z){o(z)&&j.push(z)},onAssertionLeave(z){j[0]===z&&j.shift()}}).visit(y),D+=m.slice(C),D}function g(m){return m.replace(/\n/g,"\\r?\\n")}function w(m){let y=!1,D=!1,C="",P="";for(let j=0;j<m.length;j++){const T=m[j];switch(T){case"\\":D?(y?P+="\\"+T:C+="\\"+T,D=!1):D=!0;break;case"{":if(D)y?P+=T:C+=T,D=!1;else{if(y)return{strInBraces:C+"{"+P+"{"+m.substring(j+1)};y=!0}break;case"}":if(D)y?P+=T:C+=T,D=!1;else{if(y)return{fixedStart:C,strInBraces:P,fixedEnd:m.substring(j+1)};C+=T}break;default:y?P+=(D?"\\":"")+T:C+=(D?"\\":"")+T,D=!1;break}}return{strInBraces:C+(y?"{"+P:"")}}function k(m){const{fixedStart:y,strInBraces:D,fixedEnd:C}=w(m);if(y===void 0||C===void 0)return[D];let P=(0,b.$qk)(D,",");P.length||(P=[""]);const j=k(C);return P.flatMap(T=>{const z=y+T;return j.map(N=>z+N)})}}),define(ke[391],De([1,0,22,162,109,15]),function(he,e,l,L,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0;class R{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,A,I,p){const S=new L.$ioc(this.b);if(A.folder.scheme===M.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:M.Schemas.file})},h=new O.$gw(d=>I.report({...d,uri:d.uri.with({scheme:A.folder.scheme})}));return this.c(p,d=>S.provideTextSearchResults(E,v,h,d))}else return this.c(p,v=>S.provideTextSearchResults(E,A,I,v))}async c(E,A){const I=b(E);this.a.add(I);const p=await A(I.token);return this.a.delete(I),p}d(){this.a.forEach(E=>E.cancel())}}e.$soc=R;function b($){const E=new l.$qe;return $.onCancellationRequested(()=>E.cancel()),E}}),define(ke[392],De([1,0,32,162,161]),function(he,e,l,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class M{constructor($){this.a=$}search($,E,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const I={appendLine(S){A({message:S})}},p=new O.$poc(this.a,new L.$ioc(I),l);return new Promise((S,v)=>p.search(h=>{E(h.map(R))},$).then(h=>S({limitHit:h.limitHit??!1,type:"success",stats:h.stats,messages:[]}),v))}}e.$qoc=M;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,E)=>{if(E.ranges){const A=E;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(ke[393],De([1,0,19,7,13,4,133,16,40,2,33,37,388,392]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class v{static{this.a=512}constructor(a="searchProcess"){this.d=a,this.b=Object.create(null)}fileSearch(a){let s;const t=c(a),u=new M.$fe({onDidAddFirstListener:()=>{s=(0,L.$lh)(r=>this.doFileSearchWithEngine(p.$hoc,t,o=>u.fire(o),r)),s.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return u.event}textSearch(a){let s;const t=c(a),u=new M.$fe({onDidAddFirstListener:()=>{s=(0,L.$lh)(r=>this.f(t,o=>u.fire(o),r)),s.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return u.event}f(a,s,t){return a.maxFileSize=this.g().maxFileSize,new S.$qoc(a).search(t,s,s)}g(){return{maxFileSize:16*A.$Al.GB}}doFileSearch(a,s,t){return this.doFileSearchWithEngine(p.$hoc,a,s,t)}doFileSearchWithEngine(a,s,t,u,r=v.a){let o=0;const f=w=>{Array.isArray(w)?(o+=w.length,t(w.map(k=>this.h(k)))):w.relativePath?(o++,t(this.h(w))):t(w)};if(s.sortByScore){let w=this.l(s,f,u);if(!w){const k=s.maxResults?Object.assign({},s,{maxResults:null}):s,m=new a(k);w=this.j(m,s,t,f,u)}return new Promise((k,m)=>{w.then(([y,D])=>{const C=D.map(P=>this.h(P));this.o(C,t,r),k(y)},m)})}const g=new a(s);return this.r(g,f,r,u).then(w=>({limitHit:w.limitHit,type:"success",stats:{detailStats:w.stats,type:this.d,fromCache:!1,resultCount:o,sortingTime:void 0},messages:[]}))}h(a){return{path:a.base?(0,b.$jc)(a.base,a.relativePath):a.relativePath}}j(a,s,t,u,r){const o=new M.$fe;let f=(0,L.$lh)(w=>{let k=[];const m=y=>{Array.isArray(y)?k=y:(u(y),o.fire(y))};return this.r(a,m,-1,w).then(y=>[y,k])}),g;if(s.cacheKey){g=this.k(s.cacheKey);const w={promise:f,event:o.event,resolved:!1};g.resultsToSearchCache[s.filePattern||""]=w,f.then(()=>{w.resolved=!0},k=>{delete g.resultsToSearchCache[s.filePattern||""]}),f=this.s(f)}return f.then(([w,k])=>{const m=g?g.scorerCache:Object.create(null),y=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$be.create(!1);return this.n(s,k,m,r).then(D=>{const C=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:w.stats,sortingTime:C,fromCache:!1,type:this.d,resultCount:D.length},messages:w.messages,limitHit:w.limitHit||typeof s.maxResults=="number"&&k.length>s.maxResults},D]})})}k(a){const s=this.b[a];return s||(this.b[a]=new h)}l(a,s,t){const u=a.cacheKey&&this.b[a.cacheKey];if(!u)return;const r=this.q(u,a.filePattern||"",s,t);if(r)return r.then(([o,f,g])=>{const w=$.$be.create(!1);return this.n(a,f,u.scorerCache,t).then(k=>{const m=w.elapsed(),y={fromCache:!0,detailStats:g,type:this.d,resultCount:f.length,sortingTime:m};return[{type:"success",limitHit:o.limitHit||typeof a.maxResults=="number"&&f.length>a.maxResults,stats:y,messages:[]},k]})})}n(a,s,t,u){const r=(0,R.$Ar)(a.filePattern||""),o=(g,w)=>(0,R.$zr)(g,w,r,!0,d,t),f=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return l.$Gb(s,o,f,1e4,u)}o(a,s,t){if(t&&t>0)for(let u=0;u<a.length;u+=t)s(a.slice(u,u+t));else s(a)}q(a,s,t,u){const r=$.$be.create(!1),o=s.indexOf(b.sep)>=0;let f;for(const m in a.resultsToSearchCache)if(s.startsWith(m)){if(o&&m.indexOf(b.sep)<0&&m!=="")continue;const y=a.resultsToSearchCache[m];f={promise:this.s(y.promise),event:y.event,resolved:y.resolved};break}if(!f)return null;const g=r.elapsed(),w=$.$be.create(!1),k=f.event(t);return u&&u.onCancellationRequested(()=>{k.dispose()}),f.promise.then(([m,y])=>{if(u&&u.isCancellationRequested)throw(0,O.$6)();const D=[],C=(0,R.$Ar)(s).normalizedLowercase;for(const P of y)(0,I.$JK)(P,C)&&D.push(P);return[m,D,{cacheWasResolved:f.resolved,cacheLookupTime:g,cacheFilterTime:w.elapsed(),cacheEntryCount:y.length}]})}r(a,s,t,u){return new Promise((r,o)=>{let f=[];u?.onCancellationRequested(()=>a.cancel()),a.search(g=>{g&&(t?(f.push(g),t>0&&f.length>=t&&(s(f),f=[])):s(g))},g=>{s(g)},(g,w)=>{f.length&&s(f),g?(s({message:"Search finished. Error: "+g.message}),o(g)):(s({message:"Search finished. Stats: "+JSON.stringify(w.stats)}),r(w))})})}clearCache(a){return delete this.b[a],Promise.resolve(void 0)}s(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return a.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return a.finally(s)}}}}e.$roc=v;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(i){return(0,b.$nc)(i.relativePath)}getItemDescription(i){return(0,b.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function c(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(a=>E.URI.revive(a))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(ke[394],De([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;let d=class extends E.$enc{constructor(n,i,a,s){super(n,a,s),this.w=M,this.x=-1,this.y=null,this.z=!1,this.A=new l.$Tc;const t=new v.$coc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.vscodeUserData,new S.$soc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$coc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.file,new S.$soc(n))),this.A.add(this.C(L.Schemas.file,new p.$roc("fileSearchProvider")))}C(n,i){const a=this.d++;return this.y=i,this.x=a,this.c.$registerFileSearchProvider(a,this.s(n)),(0,l.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(a)})}$provideFileSearchResults(n,i,a,s){const t=(0,E.$fnc)(a);if(n===this.x){const u=Date.now();return this.D(n,i,t,s).then(r=>{const o=Date.now()-u;return this.q.debug(`Ext host file search time: ${o}ms`),r})}return super.$provideFileSearchResults(n,i,a,s)}doInternalFileSearchWithCustomCallback(n,i,a){const s=t=>{if((0,I.$IK)(t)&&(t=[t]),Array.isArray(t)){a(t.map(u=>O.URI.file(u.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,a,s){return this.doInternalFileSearchWithCustomCallback(a,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new h.$poc(n,i,void 0,"textSearchProvider")}};e.$toc=d,e.$toc=d=Je([We(0,$.$JO),We(1,b.$ZO),We(2,A.$8lc),We(3,R.$5j)],d)}),define(ke[124],De([1,0,408,63,64,409,21,13,4,3,16,12,30,82,83]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$pi=e.$oi=e.$ni=void 0,e.$qi=r,e.$ri=o,e.$ti=w,e.$ui=k;class h{traceSocketEvent(y,D){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,y,D)}constructor(y,D=""){this.f=!0,this.debugLabel=D,this.socket=y,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(y){const D=C=>{this.traceSocketEvent("read",C),y(R.$He.wrap(C))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(y){const D=C=>{y({type:0,hadError:C,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(y){const D=()=>{y()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(y){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",y),this.socket.write(y.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((y,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),y();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),y()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ni=h;var d;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var c;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(c||(c={}));class n extends E.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(y,D){this.socket.traceSocketEvent(y,D)}constructor(y,D,C,P){super(),this.f=this.B(new $.$fe),this.g=this.B(new $.$fe),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=y,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:C?.byteLength||0,recordInflateBytes:P}),this.a=this.B(new i(this,D,C,P,this.f,(j,T)=>this.m(j,T))),this.B(this.a.onError(j=>{console.error(j),(0,b.$1)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new v.$ii,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this.f.event(y)}onClose(y){return this.g.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){let D=0;for(;D<y.byteLength;)this.a.writeMessage(y.slice(D,Math.min(D+262144,y.byteLength)),{compressed:!0,opcode:2}),D+=262144}m(y,{compressed:D,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",y);let P=2;y.byteLength<126?P+=0:y.byteLength<2**16?P+=2:P+=8;const j=R.$He.alloc(P),T=D?64:0,z=C&15;if(j.writeUInt8(128|T|z,0),y.byteLength<126)j.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){j.writeUInt8(126,1);let N=1;j.writeUInt8(y.byteLength>>>8&255,++N),j.writeUInt8(y.byteLength>>>0&255,++N)}else{j.writeUInt8(127,1);let N=1;j.writeUInt8(0,++N),j.writeUInt8(0,++N),j.writeUInt8(0,++N),j.writeUInt8(0,++N),j.writeUInt8(y.byteLength>>>24&255,++N),j.writeUInt8(y.byteLength>>>16&255,++N),j.writeUInt8(y.byteLength>>>8&255,++N),j.writeUInt8(y.byteLength>>>0&255,++N)}this.socket.write(R.$He.concat([j,y]))}end(){this.h=!0,this.socket.end()}n(y){if(y.byteLength!==0){for(this.b.acceptChunk(y);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),C=D.readUInt8(0),P=(C&128)>>>7,j=(C&64)>>>6,T=C&15,z=D.readUInt8(1),N=(z&128)>>>7,F=z&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=P,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!P,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),C=D.readUInt8(1),P=(C&128)>>>7;let j=C&127,T=1;j===126?j=D.readUInt8(++T)*2**8+D.readUInt8(++T):j===127&&(j=D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T));let z=0;P&&(z=D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T)),this.j.state=3,this.j.readLen=j,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(D,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$oi=n;class i extends E.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$He.alloc(0)}constructor(y,D,C,P,j,T){super(),this.n=y,this.r=j,this.s=T,this.a=this.B(new $.$fe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$fe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$fe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,D?(this.b=this.B(new a(this.n,P,C,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(y,D){this.g.push({data:y,options:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:y,options:D}=this.g.shift();if(this.f&&D.compressed){const C=await this.w(this.f,y);this.s(C,D)}else this.s(y,{...D,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(y,D){return new Promise((C,P)=>{y.write(D),y.flush(j=>C(j))})}acceptFrame(y,D,C){this.h.push({data:y,isCompressed:D,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const y=this.h.shift();if(this.b&&y.isCompressed){const D=await this.C(this.b,y.data,y.isLastFrameOfMessage);this.r.fire(D)}else this.r.fire(y.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(y,D,C){return new Promise((P,j)=>{y.write(D),C&&y.write(R.$He.fromByteArray([0,0,255,255])),y.flush(T=>P(T))})}}class a extends E.$Uc{get recordedInflateBytes(){return this.j?R.$He.concat(this.f):R.$He.alloc(0)}constructor(y,D,C,P){super(),this.h=y,this.j=D,this.a=this.B(new $.$fe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(P),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(R.$He.wrap(j))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(y){this.j&&this.f.push(y.clone()),this.h.traceSocketEvent("zlibInflateWrite",y),this.b.write(y.buffer)}flush(y){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=R.$He.concat(this.g);this.g.length=0,y(D)})}}class s extends E.$Uc{constructor(y,D){super(),this.g=y,this.a=this.B(new $.$fe),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(R.$He.wrap(C))})}write(y){this.g.traceSocketEvent("zlibDeflateWrite",y.buffer),this.b.write(y.buffer)}flush(y){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=R.$He.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),y(D)})}}function t(m,y){if(y===0)return;const D=m.byteLength>>>2;for(let N=0;N<D;N++){const F=m.readUInt32BE(N*4);m.writeUInt32BE(F^y,N*4)}const C=D*4,P=m.byteLength-C,j=y>>>24&255,T=y>>>16&255,z=y>>>8&255;P>=1&&m.writeUInt8(m.readUInt8(C)^j,C),P>=2&&m.writeUInt8(m.readUInt8(C+1)^T,C+1),P>=3&&m.writeUInt8(m.readUInt8(C+2)^z,C+2)}e.$pi=process.env.XDG_RUNTIME_DIR;const u={2:107,1:103};function r(){const m=(0,p.$Ug)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const y=process.platform!=="darwin"&&e.$pi?e.$pi:(0,O.tmpdir)(),D=(0,A.$jc)(y,`vscode-ipc-${m}.sock`);return f(D),D}function o(m,y,D){const P=(0,l.createHash)("sha256").update(m).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${D}-${y}-sock`;const j=D.substr(0,4),T=y.substr(0,6);let z;return process.platform!=="darwin"&&e.$pi&&!process.env.VSCODE_PORTABLE?z=(0,A.$jc)(e.$pi,`vscode-${P}-${j}-${T}.sock`):z=(0,A.$jc)(m,`${j}-${T}.sock`),f(z),z}function f(m){const y=u[I.$u];typeof y=="number"&&m.length>=y&&console.warn(`WARNING: IPC handle "${m}" is longer than ${y} chars, try a shorter --user-data-dir`)}class g extends S.$ci{static b(y){const D=$.Event.fromNodeEventEmitter(y,"connection");return $.Event.map(D,C=>({protocol:new v.$ji(new h(C,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(C,"close"))}))}constructor(y){super(g.b(y)),this.d=y}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$si=g;function w(m){return new Promise((y,D)=>{const C=(0,L.createServer)();C.on("error",D),C.listen(m,()=>{C.removeListener("error",D),y(new g(C))})})}function k(m,y){return new Promise((D,C)=>{const P=(0,L.createConnection)(m,()=>{P.removeListener("error",C),D(v.$ki.fromSocket(new h(P,`ipc-client${y}`),y))});P.once("error",C)})}}),define(ke[395],De([1,0,63,64,178,124,7,3,12,55,11,108,272,273,111,88,21]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=e.$dec=e.$cec=void 0;async function c(t,u,r,o,f){let g;for(let w=3;w&&(g?.dispose(),g=await new n(t,u,r,o,f).waitForReady(),!(f&&O.$Xg[f]||!O.$Xg[g.tunnelLocalPort]));w--);return g}class n extends b.$Uc{constructor(u,r,o,f,g){super(),this.m=r,this.n=g,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=l.createServer(),this.c=new R.$xh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=f,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,r=(0,h.$tw)(this.m)?"0.0.0.0":"127.0.0.1";let o=await(0,O.$Yg)(u,2,1e3,r),f=null;return this.b.listen(o,this.m),await this.c.wait(),f=this.b.address(),f||(o=0,this.b.listen(o,this.m),await this.c.wait(),f=this.b.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async r(u){u.pause();const r=(0,h.$rw)(this.tunnelRemoteHost)||(0,h.$tw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,p.$Ul)(this.a,r,this.tunnelRemotePort),f=o.getSocket(),g=o.readEntireBuffer();o.dispose(),g.byteLength>0&&u.write(g.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),f.end()}),u.on("close",()=>f.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),f instanceof M.$ni?f.socket.destroy():f.end()}),f instanceof M.$ni?this.t(u,f):this.s(u,f),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),f.end()})}s(u,r){r.onClose(()=>u.destroy()),r.onEnd(()=>u.end()),r.onData(o=>u.write(o.buffer)),u.on("data",o=>r.write(d.$He.wrap(o))),u.resume()}t(u,r){const o=r.socket;o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),o.pipe(u),u.pipe(o)}}e.$cec=n;let i=class extends h.$ww{constructor(u,r,o,f,g){super(r,g),this.v=u,this.w=o,this.y=f}isPortPrivileged(u){return(0,h.$uw)(u,this.m,$.OS,L.release())}t(u,r,o,f,g,w,k,m){const y=this.s(r,o);if(y)return++y.refcount,y.value;if((0,h.$nw)(u))return this.u(u,r,o,g,w,k,m);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${o} on local port ${g}.`);const D={commit:this.y.commit,quality:this.y.quality,addressProvider:u,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=c(D,f,r,o,g);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,o,C),C}}};e.$dec=i,e.$dec=i=Je([We(0,S.$Ol),We(1,A.$5j),We(2,v.$Rl),We(3,I.$lk),We(4,E.$5i)],i);let a=class extends i{constructor(u,r,o,f,g){super(u,r,o,f,g)}};e.$eec=a,e.$eec=a=Je([We(0,S.$Ol),We(1,A.$5j),We(2,v.$Rl),We(3,I.$lk),We(4,E.$5i)],a);let s=class extends b.$Uc{constructor(u,r,o,f,g){super(),this.b=u,this.c=r,this.f=o,this.g=f,this.h=g,this.a=new Map}async openTunnel(u,r,o,f,g,w,k,m,y){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${f} on local port ${w}.`),!this.a.has(u)){const D=new a(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(u,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(r,o,f,g,w,k,m,y)}};e.$fec=s,e.$fec=s=Je([We(0,S.$Ol),We(1,A.$5j),We(2,I.$lk),We(3,v.$Rl),We(4,E.$5i)],s)}),define(ke[396],De([1,0,124,292,53,34,2,11,42]),function(he,e,l,L,O,M,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=void 0;class E{constructor(p,S,v){this.b=p,this.c=S,this.f=v,this.a=L.createServer((h,d)=>this.h(h,d)),this.g().catch(h=>(S.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,S){const v=(d,c)=>{S.writeHead(d,{"content-type":"application/json"}),S.end(JSON.stringify(c||null),n=>n&&this.c.error(n))},h=[];p.setEncoding("utf8"),p.on("data",d=>h.push(d)),p.on("end",async()=>{try{const d=JSON.parse(h.join(""));let c;switch(d.type){case"open":c=await this.i(d);break;case"openExternal":c=await this.j(d);break;case"status":c=await this.l(d);break;case"extensionManagement":c=await this.k(d);break;default:v(404,`Unknown message type: ${d.type}`);break}v(200,c)}catch(d){const c=d instanceof Error?d.message:JSON.stringify(d);v(500,c),this.c.error("Error while processing pipe request",d)}})}async i(p){const{fileURIs:S,folderURIs:v,forceNewWindow:h,diffMode:d,mergeMode:c,addMode:n,forceReuseWindow:i,gotoLineMode:a,waitMarkerFilePath:s,remoteAuthority:t}=p,u=[];if(Array.isArray(v))for(const g of v)try{u.push({folderUri:R.URI.parse(g)})}catch{}if(Array.isArray(S))for(const g of S)try{(0,$.$4i)(g)?u.push({workspaceUri:R.URI.parse(g)}):u.push({fileUri:R.URI.parse(g)})}catch{}const r=s?R.URI.file(s):void 0,f={forceNewWindow:h,diffMode:d,mergeMode:c,addMode:n,gotoLineMode:a,forceReuseWindow:i,preferNewWindow:!i&&!r&&!n,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",u,f)}async j(p){for(const S of p.uris){const v=R.URI.parse(S),h=v.scheme==="file"?v:S;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(p){const S=h=>h?.map(d=>/\.vsix$/i.test(d)?R.URI.parse(d):d),v={list:p.list,install:S(p.install),uninstall:S(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&O.existsSync(this.f)&&O.unlinkSync(this.f)}}e.$$O=E;let A=class extends E{constructor(p,S){super(p,S,(0,l.$qi)())}};e.$_O=A,e.$_O=A=Je([We(0,M.$6O),We(1,b.$5j)],A)}),define(ke[397],De([1,0,59,384,379,291,49,366,2,15,8,396,104,326,365]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;class h extends O.$Znc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,a=i._load;i._load=function(r,o,f){return r=t(r),n.a.has(r)?n.a.get(r).load(r,$.URI.file((0,p.$0q)(o.filename)),g=>a.apply(this,[g,o,f])):a.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(u,r)=>s.call(this,t(u),r);const t=u=>{for(const r of n.b){const o=r(u);if(o){u=o;break}}return u}}}class d extends R.$Nmc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(S.$woc);const n=this.h.invokeFunction(L.$Vnc);if(this.h.createInstance(b.$voc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(I.$_O);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$xoc),await this.h.createInstance(h,n,{mine:this.J,all:this.L}).install(),l.mark("code/extHost/didInitAPI");const a=await this.m.getConfigProvider();await(0,M.$uoc)(this.j,a,this,this.s,this.z,this.f),l.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,a){if(i.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;a.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&l.mark(`code/extHost/willLoadExtensionCode/${t}`),s=he.__$__nodeRequire(i.fsPath)}finally{t&&l.mark(`code/extHost/didLoadExtensionCode/${t}`),a.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const a=n[i];a===null?delete process.env[i]:process.env[i]=a}}}e.$yoc=d}),define(ke[398],De([1,0,54,21,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0,e.$zoc=s,e.$Aoc=t,e.$Boc=u,e.$Coc=r,e.$Doc=f,e.$Eoc=g,e.$Foc=w;function s(y){const D=y.trim().split(`
`),C=[];return D.forEach(j=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);T&&T.length>=3&&C.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),C.reduce((j,T)=>(j[T.socket]=T,j),{})}function t(...y){const D=[].concat(...y.map(r));return[...new Map(D.filter(C=>C.st==="0A").map(C=>{const P=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:u(P[0]),port:parseInt(P[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function u(y){let D="";if(y.length===8)for(let C=y.length-2;C>=0;C-=2)D+=parseInt(y.substr(C,2),16),C!==0&&(D+=".");else for(let C=0;C<y.length;C+=8){const P=y.substring(C,C+8);let j="";for(let T=8;T>=2;T-=2)j+=P.substring(T-2,T),(T===6||T===2)&&(j=parseInt(j,16).toString(16),D+=`${j}`,j="",C+T!==y.length-6&&(D+=":"))}return D}function r(y){const D=y.trim().split(`
`),C=D.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return D.map(j=>j.trim().split(/\s+/).reduce((T,z,N)=>(T[C[N]||N]=z,T),{}))}function o(y){return!!y.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||y.indexOf("out/server-main.js")!==-1||y.indexOf("_productName=VSCode")!==-1}function f(y){const D=y.trim().split(`
`),C=[];return D.forEach(P=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(P);j&&j.length>=4&&C.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),C}async function g(y,D,C){const P=C.reduce((T,z)=>(T[z.pid]=z,T),{}),j=[];return y.forEach(({socket:T,ip:z,port:N})=>{const F=D[T]?D[T].pid:void 0,U=F?P[F]?.cmd:void 0;F&&U&&!o(U)&&j.push({host:z,port:N,detail:U,pid:F})}),j}function w(y,D,C){const P=new Map,j=f(D);for(const T of y){const z=C.get(T.port);if(z){P.set(T.port,z);continue}const N=j.find(F=>F.cmd.includes(`${T.port}`));if(N){let F=N,U;do U=j.find(Y=>Y.ppid===F.pid),U&&(F=U);while(U);P.set(T.port,{host:T.ip,port:T.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else P.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return P}let k=class extends i.$ODb{constructor(D,C,P,j){super(D,C,P),this.D=C,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(D){if(D&&this.C)return;this.C=D;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const P=new R.$Gm;let j=0;for(;this.C;){const T=new Date().getTime(),z=(await this.I()).filter(U=>(0,h.$rw)(U.host)||(0,h.$tw)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(U=>U.port).join(", ")}`);const N=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),j++>3&&P.update(N),(!C||JSON.stringify(C)!==JSON.stringify(z))&&(C=z,await this.a.$onFoundNewCandidates(C));const F=this.G(P.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(U=>setTimeout(()=>U(),F))}}G(D){return Math.max(D*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(D=>D.port).join(", ")}`)}async I(){let D="",C="";try{D=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const P=t(D,C),j=await new Promise(H=>{(0,l.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,x,ne)=>{H(x)})}),T=s(j),z=await A.Promises.readdir("/proc"),N=[];for(const H of z)try{const J=Number(H),x=$.$_g(E.URI.file("/proc"),H);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(J)){const be=await A.Promises.readlink($.$_g(x,"cwd").fsPath),ae=await A.Promises.readFile($.$_g(x,"cmdline").fsPath,"utf8");N.push({pid:J,cwd:be,cmd:ae})}}catch{}const F=[],U=P.filter(H=>{const J=T[H.socket];return J||F.push(H),J}),Y=g(U,T,N);let ie;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const H=await new Promise(J=>{(0,l.exec)("ps -F -A -l | grep root",(x,ne,be)=>{J(ne)})});this.z=w(F,H,this.z),ie=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ie.map(J=>J.port).join(", ")}`)}return Y.then(H=>ie?H.concat(ie):H)}w(D){return async C=>{const P=new d.$cec({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,z,N,F){const U=await D.makeConnection();return m.connect(U,z,N,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$Kl(0),connectionToken:D.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await P.waitForReady();const j=new O.$fe;return{localAddress:(0,a.$GL)(P.localAddress)??P.localAddress,remoteAddress:{port:P.tunnelRemotePort,host:P.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{P.dispose(),j.fire(),j.dispose()}}}}};e.$Goc=k,e.$Goc=k=Je([We(0,n.$JO),We(1,c.$ZO),We(2,I.$5j),We(3,v.$Rl)],k);class m extends p.$Gvb{static connect(D,C,P,j){const T=new M.$Tc,z={onClose:T.add(new O.$fe),onData:T.add(new O.$fe),onEnd:T.add(new O.$fe)};T.add(D.onDidReceiveMessage(F=>z.onData.fire(L.$He.wrap(F)))),T.add(D.onDidEnd(()=>z.onEnd.fire())),T.add(D.onDidClose(F=>z.onClose.fire({type:0,error:F,hadError:!!F})));const N=new m(D,j,z);return N.B(T),(0,p.$Fvb)(N,C,P,j,z)}constructor(D,C,P){super(C,P),this.n=D}write(D){this.n.send(D.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[399],De([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,327,11,383,61,286,106,111,141]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c,n,i,a,s,t,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$As)(A.$Omc,b.$yoc,0),(0,l.$As)(n.$6j,c.$Ioc,1),(0,l.$As)(n.$5j,new t.$vi(s.$Ync,[!1],!0)),(0,l.$As)(u.$Rl,r.$hec,1),(0,l.$As)(h.$emc,d.$Hoc,0),(0,l.$As)(E.$Tmc,M.$_nc,0),(0,l.$As)(I.$dnc,R.$toc,0),(0,l.$As)(p.$Fnc,O.$4nc,0),(0,l.$As)(S.$zmc,L.$3nc,0),(0,l.$As)(v.$NDb,$.$Goc,0),(0,l.$As)(a.$Rmc,i.$Joc,0)}),define(ke[410],De([1,0,63,411,59,13,83,124,269,115,380,21,32,104,7,136,293,309,385,399]),function(he,e,l,L,O,M,R,b,$,E,A,I,p,S,v,h,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let w=0;w<process.execArgv.length;w++)process.execArgv[w]==="--inspect-port=0"&&(process.execArgv.splice(w,1),w--)}();const n=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,w=g._load;g._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return w.apply(this,arguments)}})();const i=process.exit.bind(process),a=process.on.bind(process);function s(g){process.exit=function(w){if(g)i(w);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const w=new Error("An extension called process.crash() and this was prevented.");console.warn(w.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(w,k){w==="uncaughtException"&&(k=function(){try{return k.call(void 0,arguments)}catch{}}),a(w,k)}}let t=function(g){i()};function u(){const g=(0,c.$qn)(process.env);if(g.type===3)return new Promise((w,k)=>{const m=y=>{const D=y[0],C=new R.$li;D.on("message",P=>C.fire(I.$He.wrap(P.data))),D.on("close",()=>{t("renderer closed the MessagePort")}),D.start(),w({onMessage:C.event,send:P=>D.postMessage(P.buffer)})};process.parentPort.on("message",y=>m(y.ports))});if(g.type===2)return new Promise((w,k)=>{let m=null;const y=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,C=3e5,P=new v.$Lh(()=>t("renderer disconnected for too long (1)"),D),j=new v.$Lh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(z,N)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const F=I.$He.wrap(Buffer.from(z.initialDataChunk,"base64"));let U;if(z.skipWebSocketFrames)U=new b.$ni(N,"extHost-socket");else{const Y=I.$He.wrap(Buffer.from(z.inflateBytes,"base64"));U=new b.$oi(new b.$ni(N,"extHost-socket"),z.permessageDeflate,Y,!1)}m?(P.cancel(),j.cancel(),m.beginAcceptReconnection(U,F),m.endAcceptReconnection(),m.sendResume()):(clearTimeout(y),m=new R.$mi({socket:U,initialChunk:F}),m.sendResume(),m.onDidDispose(()=>t("renderer disconnected")),w(m),m.onSocketClose(()=>{P.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;P.isScheduled()&&j.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const w=g.pipeName;return new Promise((k,m)=>{const y=l.createConnection(w,()=>{y.removeListener("error",m);const D=new R.$mi({socket:new b.$ni(y,"extHost-renderer")});D.sendResume(),k(D)});y.once("error",m),y.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const g=await u();return new class{constructor(){this.a=new R.$li,this.onMessage=this.a.event,this.b=!1,g.onMessage(w=>{(0,E.$3m)(w,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(w)})}send(w){this.b||g.send(w)}async drain(){if(g.drain)return g.drain()}}}function o(g){return new Promise(w=>{const k=g.onMessage(m=>{k.dispose();const y=JSON.parse(m.toString()),D=y.commit,C=$.default.commit;if(D&&C&&D!==C&&i(55),y.parentPid){let P=0;setInterval(function(){try{process.kill(y.parentPid,0),P=0}catch(T){T&&T.code==="EPERM"?(P++,P>=3&&t(`parent process ${y.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${y.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(y.parentPid)}catch(T){(0,M.$1)(T)}}g.send((0,E.$2m)(0)),w({protocol:g,initData:y})});g.send((0,E.$2m)(1))})}async function f(){const g=[];process.on("unhandledRejection",(P,j)=>{g.push(j),setTimeout(()=>{const T=g.indexOf(j);T>=0&&j.catch(z=>{g.splice(T,1),(0,M.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),P&&(0,M.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const j=g.indexOf(P);j>=0&&g.splice(j,1)}),process.on("uncaughtException",function(P){(0,M.$Z)(P)||(0,M.$1)(P)}),O.mark("code/extHost/willConnectToRenderer");const w=await r();O.mark("code/extHost/didConnectToRenderer");const k=await o(w);O.mark("code/extHost/didWaitForInitData");const{initData:m}=k;s(!!m.environment.extensionTestsLocationURI),m.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,m.environment.skipWorkspaceStorageLock=(0,h.boolean)(n.skipWorkspaceStorageLock,!1);const y=new class{constructor(){this.pid=process.pid}exit(j){i(j)}fsExists(j){return p.Promises.exists(j)}fsRealpath(j){return(0,S.$9q)(j)}};let D=null;m.remote.authority&&n.transformURIs&&(D=(0,d.$Es)(m.remote.authority));const C=new A.$2nc(k.protocol,m,y,D);t=P=>C.terminate(P)}f().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60468916e48fe8293e7641f0fc4ada80d79117b3/core/vs/workbench/api/node/extensionHostProcess.js.map
