/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(le){for(var e=[],P=0,O=le.length;P<O;P++)e[P]=ke[le[P]];return e};define(ke[69],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=O,e.$4h=M,e.$5h=N;function P(R){return(p,m,E)=>{let T=null,S=null;if(typeof E.value=="function"?(T="value",S=E.value):typeof E.get=="function"&&(T="get",S=E.get),!S)throw new Error("not supported");E[T]=R(S,m)}}function O(R,p,m){let E=null,T=null;if(typeof m.value=="function"?(E="value",T=m.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",T=m.get),!T)throw new Error("not supported");const S=`$memoize$${p}`;m[E]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,l)}),this[S]}}function M(R,p,m){return P((E,T)=>{const S=`$debounce$${T}`,l=`$debounce$result$${T}`;return function(...b){this[l]||(this[l]=m?m():void 0),clearTimeout(this[S]),p&&(this[l]=p(this[l],...b),b=[this[l]]),this[S]=setTimeout(()=>{E.apply(this,b),this[l]=m?m():void 0},R)}})}function N(R,p,m){return P((E,T)=>{const S=`$throttle$timer$${T}`,l=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...r){if(this[l]||(this[l]=m?m():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),p&&(this[l]=p(this[l],...r)),this[f])return;const s=this[b]+R;s<=Date.now()?(this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0},s-Date.now()))}})}}),define(ke[125],Ie([1,0,18]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=M,e.$8c=N,e.$9c=R,e.$0c=p,e.$$c=m,e.$_c=E;const O=(b,f)=>b===f;e.$6c=O;function M(b=e.$6c){return(f,r)=>P.$ub(f,r,b)}function N(){return(b,f)=>JSON.stringify(b)===JSON.stringify(f)}function R(){return(b,f)=>b.equals(f)}function p(b,f,r){return!b||!f?b===f:r(b,f)}function m(b,f){if(b===f)return!0;if(Array.isArray(b)&&Array.isArray(f)){if(b.length!==f.length)return!1;for(let r=0;r<b.length;r++)if(!m(b[r],f[r]))return!1;return!0}if(b&&typeof b=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(b)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const r=b,s=f,o=Object.keys(r),n=Object.keys(s),i=new Set(n);if(o.length!==n.length)return!1;for(const c of o)if(!i.has(c)||!m(r[c],s[c]))return!1;return!0}return!1}function E(b){return JSON.stringify(l(b))}let T=0;const S=new WeakMap;function l(b){if(Array.isArray(b))return b.map(l);if(b&&typeof b=="object")if(Object.getPrototypeOf(b)===Object.prototype){const f=b,r=Object.create(null);for(const s of Object.keys(f).sort())r[s]=l(f[s]);return r}else{let f=S.get(b);return f===void 0&&(f=T++,S.set(b,f)),f+"----2b76a038c20c4bcc"}return b}}),define(ke[91],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0;class P{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$OO=P,e.$PO=new P("id#")}),define(ke[126],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=R,e.$Kn=S,e.$Ln=l,e.$Mn=b,e.$Nn=f,e.$On=r,e.$Pn=s,e.$Qn=o,e.$Rn=n,e.$Sn=i,e.$Tn=c,e.$Un=u;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,g=!1){let a=0;const d=t.length;let w="",$=0,v=16,y=0;function h(q){let A=0,B=0;for(;A<q;){const K=t.charCodeAt(a);if(K>=48&&K<=57)B=B*16+K-48;else if(K>=65&&K<=70)B=B*16+K-65+10;else if(K>=97&&K<=102)B=B*16+K-97+10;else break;a++,A++}return A<q&&(B=-1),B}function D(q){a=q,w="",$=0,v=16,y=0}function k(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&E(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&E(t.charCodeAt(a)))for(a++;a<t.length&&E(t.charCodeAt(a));)a++;else return y=3,t.substring(q,a);let A=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&E(t.charCodeAt(a))){for(a++;a<t.length&&E(t.charCodeAt(a));)a++;A=a}else y=3;return t.substring(q,A)}function C(){let q="",A=a;for(;;){if(a>=d){q+=t.substring(A,a),y=2;break}const B=t.charCodeAt(a);if(B===34){q+=t.substring(A,a),a++;break}if(B===92){if(q+=t.substring(A,a),a++,a>=d){y=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}A=a;continue}if(B>=0&&B<=31)if(m(B)){q+=t.substring(A,a),y=2;break}else y=6;a++}return q}function I(){if(w="",y=0,$=a,a>=d)return $=d,v=17;let q=t.charCodeAt(a);if(p(q)){do a++,w+=String.fromCharCode(q),q=t.charCodeAt(a);while(p(q));return v=15}if(m(q))return a++,w+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,w+=`
`),v=14;switch(q){case 123:return a++,v=1;case 125:return a++,v=2;case 91:return a++,v=3;case 93:return a++,v=4;case 58:return a++,v=6;case 44:return a++,v=5;case 34:return a++,w=C(),v=10;case 47:{const A=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<d&&!m(t.charCodeAt(a));)a++;return w=t.substring(A,a),v=12}if(t.charCodeAt(a+1)===42){a+=2;const B=d-1;let K=!1;for(;a<B;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,y=1),w=t.substring(A,a),v=13}return w+=String.fromCharCode(q),a++,v=16}case 45:if(w+=String.fromCharCode(q),a++,a===d||!E(t.charCodeAt(a)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=k(),v=11;default:for(;a<d&&W(q);)a++,q=t.charCodeAt(a);if($!==a){switch(w=t.substring($,a),w){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return w+=String.fromCharCode(q),a++,v=16}}function W(q){if(p(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=I();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>a,scan:g?V:I,getToken:()=>v,getTokenValue:()=>w,getTokenOffset:()=>$,getTokenLength:()=>a-$,getTokenError:()=>y}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function S(t,g){const a=[],d=new Object;let w;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function y(h,D,k,C){$.value=h,$.offset=D,$.length=k,$.type=C,$.colonOffset=void 0,w=$}try{i(t,{onObjectBegin:(h,D)=>{if(g<=h)throw d;w=void 0,v=g>h,a.push("")},onObjectProperty:(h,D,k)=>{if(g<D||(y(h,D,k,"property"),a[a.length-1]=h,g<=D+k))throw d},onObjectEnd:(h,D)=>{if(g<=h)throw d;w=void 0,a.pop()},onArrayBegin:(h,D)=>{if(g<=h)throw d;w=void 0,a.push(0)},onArrayEnd:(h,D)=>{if(g<=h)throw d;w=void 0,a.pop()},onLiteralValue:(h,D,k)=>{if(g<D||(y(h,D,k,u(h)),g<=D+k))throw d},onSeparator:(h,D,k)=>{if(g<=D)throw d;if(h===":"&&w&&w.type==="property")w.colonOffset=D,v=!1,w=void 0;else if(h===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(v=!0,a[a.length-1]=""),w=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:w,isAtPropertyKey:v,matches:h=>{let D=0;for(let k=0;D<h.length&&k<a.length;k++)if(h[D]===a[k]||h[D]==="*")D++;else if(h[D]!=="**")return!1;return D===h.length}}}function l(t,g=[],a=N.DEFAULT){let d=null,w=[];const $=[];function v(h){Array.isArray(w)?w.push(h):d!==null&&(w[d]=h)}return i(t,{onObjectBegin:()=>{const h={};v(h),$.push(w),w=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{w=$.pop()},onArrayBegin:()=>{const h=[];v(h),$.push(w),w=h,d=null},onArrayEnd:()=>{w=$.pop()},onLiteralValue:v,onError:(h,D,k)=>{g.push({error:h,offset:D,length:k})}},a),w[0]}function b(t,g=[],a=N.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function $(h){return d.children.push(h),h}i(t,{onObjectBegin:h=>{d=$({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,D,k)=>{d=$({type:"property",offset:D,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:D,length:k,parent:d})},onObjectEnd:(h,D)=>{d.length=h+D-d.offset,d=d.parent,w(h+D)},onArrayBegin:(h,D)=>{d=$({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,D)=>{d.length=h+D-d.offset,d=d.parent,w(h+D)},onLiteralValue:(h,D,k)=>{$({type:u(h),offset:D,length:k,parent:d,value:h}),w(D+k)},onSeparator:(h,D,k)=>{d.type==="property"&&(h===":"?d.colonOffset=D:h===","&&w(D))},onError:(h,D,k)=>{g.push({error:h,offset:D,length:k})}},a);const y=d.children[0];return y&&delete y.parent,y}function f(t,g){if(!t)return;let a=t;for(const d of g)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let w=!1;for(const $ of a.children)if(Array.isArray($.children)&&$.children[0].value===d){a=$.children[1],w=!0;break}if(!w)return}else{const w=d;if(a.type!=="array"||w<0||!Array.isArray(a.children)||w>=a.children.length)return;a=a.children[w]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const g=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;g.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&g.push(a)}return g}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const g=Object.create(null);for(const a of t.children){const d=a.children[1];d&&(g[a.children[0].value]=s(d))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,g,a=!1){return g>=t.offset&&g<t.offset+t.length||a&&g===t.offset+t.length}function n(t,g,a=!1){if(o(t,g,a)){const d=t.children;if(Array.isArray(d))for(let w=0;w<d.length&&d[w].offset<=g;w++){const $=n(d[w],g,a);if($)return $}return t}}function i(t,g,a=N.DEFAULT){const d=R(t,!1);function w(Te){return Te?()=>Te(d.getTokenOffset(),d.getTokenLength()):()=>!0}function $(Te){return Te?ae=>Te(ae,d.getTokenOffset(),d.getTokenLength()):()=>!0}const v=w(g.onObjectBegin),y=$(g.onObjectProperty),h=w(g.onObjectEnd),D=w(g.onArrayBegin),k=w(g.onArrayEnd),C=$(g.onLiteralValue),I=$(g.onSeparator),W=w(g.onComment),V=$(g.onError),q=a&&a.disallowComments,A=a&&a.allowTrailingComma;function B(){for(;;){const Te=d.scan();switch(d.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Te){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Te}}}function K(Te,ae=[],Re=[]){if(V(Te),ae.length+Re.length>0){let ne=d.getToken();for(;ne!==17;){if(ae.indexOf(ne)!==-1){B();break}else if(Re.indexOf(ne)!==-1)break;ne=B()}}}function ie(Te){const ae=d.getTokenValue();return Te?C(ae):y(ae),B(),!0}function ce(){switch(d.getToken()){case 11:{let Te=0;try{Te=JSON.parse(d.getTokenValue()),typeof Te!="number"&&(K(2),Te=0)}catch{K(2)}C(Te);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return B(),!0}function ve(){return d.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),d.getToken()===6?(I(":"),B(),$e()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Se(){v(),B();let Te=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(Te||K(4,[],[]),I(","),B(),d.getToken()===2&&A)break}else Te&&K(6,[],[]);ve()||K(4,[],[2,5]),Te=!0}return h(),d.getToken()!==2?K(7,[2],[]):B(),!0}function fe(){D(),B();let Te=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(Te||K(4,[],[]),I(","),B(),d.getToken()===4&&A)break}else Te&&K(6,[],[]);$e()||K(4,[],[4,5]),Te=!0}return k(),d.getToken()!==4?K(8,[4],[]):B(),!0}function $e(){switch(d.getToken()){case 3:return fe();case 1:return Se();case 10:return ie(!0);default:return ce()}}return B(),d.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):$e()?(d.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(t,g){const a=R(t),d=[];let w,$=0,v;do switch(v=a.getPosition(),w=a.scan(),w){case 12:case 13:case 17:$!==v&&d.push(t.substring($,v)),g!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,g)),$=a.getPosition();break}while(w!==17);return d.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(ke[127],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(De,pe){for(var ge=0;ge<pe.length;ge++){var Q=pe[ge];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(De,Q.key,Q)}}function P(De,pe,ge){return pe&&e(De.prototype,pe),ge&&e(De,ge),Object.defineProperty(De,"prototype",{writable:!1}),De}function O(De,pe){if(De){if(typeof De=="string")return M(De,pe);var ge=Object.prototype.toString.call(De).slice(8,-1);if(ge==="Object"&&De.constructor&&(ge=De.constructor.name),ge==="Map"||ge==="Set")return Array.from(De);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return M(De,pe)}}function M(De,pe){(pe==null||pe>De.length)&&(pe=De.length);for(var ge=0,Q=new Array(pe);ge<pe;ge++)Q[ge]=De[ge];return Q}function N(De,pe){var ge=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ge)return(ge=ge.call(De)).next.bind(ge);if(Array.isArray(De)||(ge=O(De))||pe&&De&&typeof De.length=="number"){ge&&(De=ge);var Q=0;return function(){return Q>=De.length?{done:!0}:{done:!1,value:De[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=R();function p(De){le.defaults=De}var m=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(pe){return l[pe]};function f(De,pe){if(pe){if(m.test(De))return De.replace(E,b)}else if(T.test(De))return De.replace(S,b);return De}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(De){return De.replace(r,function(pe,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(De,pe){De=typeof De=="string"?De:De.source,pe=pe||"";var ge={replace:function(Y,he){return he=he.source||he,he=he.replace(o,"$1"),De=De.replace(Y,he),ge},getRegex:function(){return new RegExp(De,pe)}};return ge}var i=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(De,pe,ge){if(De){var Q;try{Q=decodeURIComponent(s(ge)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}pe&&!c.test(ge)&&(ge=w(pe,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},g=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(De,pe){t[" "+De]||(g.test(De)?t[" "+De]=De+"/":t[" "+De]=h(De,"/",!0)),De=t[" "+De];var ge=De.indexOf(":")===-1;return pe.substring(0,2)==="//"?ge?pe:De.replace(a,"$1")+pe:pe.charAt(0)==="/"?ge?pe:De.replace(d,"$1")+pe:De+pe}var $={exec:function(){}};function v(De){for(var pe=1,ge,Q;pe<arguments.length;pe++){ge=arguments[pe];for(Q in ge)Object.prototype.hasOwnProperty.call(ge,Q)&&(De[Q]=ge[Q])}return De}function y(De,pe){var ge=De.replace(/\|/g,function(he,ue,Ne){for(var de=!1,Ce=ue;--Ce>=0&&Ne[Ce]==="\\";)de=!de;return de?"|":" |"}),Q=ge.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>pe)Q.splice(pe);else for(;Q.length<pe;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function h(De,pe,ge){var Q=De.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=De.charAt(Q-Y-1);if(he===pe&&!ge)Y++;else if(he!==pe&&ge)Y++;else break}return De.slice(0,Q-Y)}function D(De,pe){if(De.indexOf(pe[1])===-1)return-1;for(var ge=De.length,Q=0,Y=0;Y<ge;Y++)if(De[Y]==="\\")Y++;else if(De[Y]===pe[0])Q++;else if(De[Y]===pe[1]&&(Q--,Q<0))return Y;return-1}function k(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(De,pe){if(pe<1)return"";for(var ge="";pe>1;)pe&1&&(ge+=De),pe>>=1,De+=De;return ge+De}function I(De,pe,ge,Q){var Y=pe.href,he=pe.title?f(pe.title):null,ue=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ne={type:"link",raw:ge,href:Y,title:he,text:ue,tokens:Q.inlineTokens(ue)};return Q.state.inLink=!1,Ne}return{type:"image",raw:ge,href:Y,title:he,text:f(ue)}}function W(De,pe){var ge=De.match(/^(\s+)(?:```)/);if(ge===null)return pe;var Q=ge[1];return pe.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ue=he[0];return ue.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var V=function(){function De(ge){this.options=ge||le.defaults}var pe=De.prototype;return pe.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},pe.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},pe.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ue=W(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ue}}},pe.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ue=h(he,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(he=ue.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},pe.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},pe.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},pe.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ue,Ne,de,Ce,Me,je,j,L,H,G,ee,re=Y[1].trim(),Oe=re.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+re.slice(0,-1):"",loose:!1,items:[]};re=Oe?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Oe?re:"[*+-]");for(var He=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=He.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),j=Y[2].split(`
`,1)[0],L=Q.split(`
`,1)[0],this.options.pedantic?(de=2,G=j.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,G=j.slice(de),de+=Y[1].length),Me=!1,!j&&/^ *$/.test(L)&&(he+=L+`
`,Q=Q.substring(L.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(H=Q.split(`
`,1)[0],j=H,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(j)||tt.test(j)||_e.test(j)||xe.test(Q)));){if(j.search(/[^ ]/)>=de||!j.trim())G+=`
`+j.slice(de);else if(!Me)G+=`
`+j;else break;!Me&&!j.trim()&&(Me=!0),he+=H+`
`,Q=Q.substring(H.length+1)}Be.loose||(je?Be.loose=!0:/\n *\n *$/.test(he)&&(je=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(G),ue&&(Ne=ue[0]!=="[ ] ",G=G.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ue,checked:Ne,loose:!1,text:G}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=G.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Ce=0;Ce<it;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var ct=Be.items[Ce].tokens.filter(function(Ue){return Ue.type==="space"}),gt=ct.every(function(Ue){for(var ot=Ue.raw.split(""),Z=0,X=N(ot),me;!(me=X()).done;){var qe=me.value;if(qe===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&ct.length&&gt&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},pe.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]);he.type="paragraph",he.text=ue,he.tokens=this.lexer.inline(ue)}return he}},pe.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},pe.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:y(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ue=he.align.length,Ne,de,Ce,Me;for(Ne=0;Ne<ue;Ne++)/^ *-+: *$/.test(he.align[Ne])?he.align[Ne]="right":/^ *:-+: *$/.test(he.align[Ne])?he.align[Ne]="center":/^ *:-+ *$/.test(he.align[Ne])?he.align[Ne]="left":he.align[Ne]=null;for(ue=he.rows.length,Ne=0;Ne<ue;Ne++)he.rows[Ne]=y(he.rows[Ne],he.header.length).map(function(je){return{text:je}});for(ue=he.header.length,de=0;de<ue;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(ue=he.rows.length,de=0;de<ue;de++)for(Me=he.rows[de],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return he}}},pe.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},pe.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},pe.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},pe.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:f(Y[1])}},pe.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]}},pe.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ue=h(he.slice(0,-1),"\\");if((he.length-ue.length)%2===0)return}else{var Ne=D(Y[2],"()");if(Ne>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Me=Y[2],je="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);j&&(Me=j[1],je=j[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),I(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},pe.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ue=(he[2]||he[1]).replace(/\s+/g," ");if(ue=Y[ue.toLowerCase()],!ue||!ue.href){var Ne=he[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return I(he,ue,he[0],this.lexer)}},pe.emStrong=function(Q,Y,he){he===void 0&&(he="");var ue=this.rules.inline.emStrong.lDelim.exec(Q);if(ue&&!(ue[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=ue[1]||ue[2]||"";if(!Ne||Ne&&(he===""||this.rules.inline.punctuation.exec(he))){var de=ue[0].length-1,Ce,Me,je=de,j=0,L=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*Q.length+de);(ue=L.exec(Y))!=null;)if(Ce=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Ce){if(Me=Ce.length,ue[3]||ue[4]){je+=Me;continue}else if((ue[5]||ue[6])&&de%3&&!((de+Me)%3)){j+=Me;continue}if(je-=Me,!(je>0)){if(Me=Math.min(Me,Me+je+j),Math.min(de,Me)%2){var H=Q.slice(1,de+ue.index+Me);return{type:"em",raw:Q.slice(0,de+ue.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}var G=Q.slice(2,de+ue.index+Me-1);return{type:"strong",raw:Q.slice(0,de+ue.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}}}}},pe.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ue=/[^ ]/.test(he),Ne=/^ /.test(he)&&/ $/.test(he);return ue&&Ne&&(he=he.substring(1,he.length-1)),he=f(he,!0),{type:"codespan",raw:Y[0],text:he}}},pe.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},pe.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},pe.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ue,Ne;return he[2]==="@"?(ue=f(this.options.mangle?Y(he[1]):he[1]),Ne="mailto:"+ue):(ue=f(he[1]),Ne=ue),{type:"link",raw:he[0],text:ue,href:Ne,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ue,Ne;if(he[2]==="@")ue=f(this.options.mangle?Y(he[0]):he[0]),Ne="mailto:"+ue;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);ue=f(he[0]),he[1]==="www."?Ne="http://"+ue:Ne=ue}return{type:"link",raw:he[0],text:ue,href:Ne,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):f(he[0]):he[0]:ue=f(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ue}}},De}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=v({},q),q.gfm=v({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=v({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=n(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=n(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=n(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=n(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=n(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=n(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=n(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=n(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=n(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=n(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=v({},A),A.pedantic=v({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=v({},A.normal,{escape:n(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=n(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=v({},A.gfm,{br:n(A.br).replace("{2,}","*").getRegex(),text:n(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(De){var pe="",ge,Q,Y=De.length;for(ge=0;ge<Y;ge++)Q=De.charCodeAt(ge),Math.random()>.5&&(Q="x"+Q.toString(16)),pe+="&#"+Q+";";return pe}var ie=function(){function De(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||le.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}De.lex=function(Q,Y){var he=new De(Y);return he.lex(Q)},De.lexInline=function(Q,Y){var he=new De(Y);return he.inlineTokens(Q)};var pe=De.prototype;return pe.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},pe.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,j,L){return j+"    ".repeat(L.length)});for(var ue,Ne,de,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ue=je.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Q)){Q=Q.substring(ue.raw.length),ue.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ue);continue}if(ue=this.tokenizer.code(Q)){Q=Q.substring(ue.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ue);continue}if(ue=this.tokenizer.fences(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.heading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.hr(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.blockquote(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.list(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.html(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.def(Q)){Q=Q.substring(ue.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.lheading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,j=Q.slice(1),L=void 0;he.options.extensions.startBlock.forEach(function(H){L=H.call({lexer:this},j),typeof L=="number"&&L>=0&&(je=Math.min(je,L))}),je<1/0&&je>=0&&(de=Q.substring(0,je+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(de))){Ne=Y[Y.length-1],Ce&&Ne.type==="paragraph"?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ue),Ce=de.length!==Q.length,Q=Q.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Q)){Q=Q.substring(ue.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ue);continue}if(Q){var Me="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},pe.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},pe.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ue,Ne,de,Ce=Q,Me,je,j;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(j=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(G){return(ue=G.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.tag(Q)){Q=Q.substring(ue.raw.length),Ne=Y[Y.length-1],Ne&&ue.type==="text"&&Ne.type==="text"?(Ne.raw+=ue.raw,Ne.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.link(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ue.raw.length),Ne=Y[Y.length-1],Ne&&ue.type==="text"&&Ne.type==="text"?(Ne.raw+=ue.raw,Ne.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.emStrong(Q,Ce,j)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.codespan(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.br(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.del(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.autolink(Q,K)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Q,K))){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var G=1/0,ee=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Oe){re=Oe.call({lexer:this},ee),typeof re=="number"&&re>=0&&(G=Math.min(G,re))}),G<1/0&&G>=0&&(de=Q.substring(0,G+1))}(),ue=this.tokenizer.inlineText(de,B)){Q=Q.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(j=ue.raw.slice(-1)),je=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=ue.raw,Ne.text+=ue.text):Y.push(ue);continue}if(Q){var H="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return Y},P(De,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),De}(),ce=function(){function De(ge){this.options=ge||le.defaults}var pe=De.prototype;return pe.code=function(Q,Y,he){var ue=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Q,ue);Ne!=null&&Ne!==Q&&(he=!0,Q=Ne)}return Q=Q.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+f(ue,!0)+'">'+(he?Q:f(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:f(Q,!0))+`</code></pre>
`},pe.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},pe.html=function(Q){return Q},pe.heading=function(Q,Y,he,ue){if(this.options.headerIds){var Ne=this.options.headerPrefix+ue.slug(he);return"<h"+Y+' id="'+Ne+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(Q,Y,he){var ue=Y?"ol":"ul",Ne=Y&&he!==1?' start="'+he+'"':"";return"<"+ue+Ne+`>
`+Q+"</"+ue+`>
`},pe.listitem=function(Q){return"<li>"+Q+`</li>
`},pe.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(Q){return"<p>"+Q+`</p>
`},pe.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},pe.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},pe.tablecell=function(Q,Y){var he=Y.header?"th":"td",ue=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ue+Q+("</"+he+`>
`)},pe.strong=function(Q){return"<strong>"+Q+"</strong>"},pe.em=function(Q){return"<em>"+Q+"</em>"},pe.codespan=function(Q){return"<code>"+Q+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(Q){return"<del>"+Q+"</del>"},pe.link=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<a href="'+f(Q)+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=">"+he+"</a>",ue},pe.image=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<img src="'+Q+'" alt="'+he+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=this.options.xhtml?"/>":">",ue},pe.text=function(Q){return Q},De}(),ve=function(){function De(){}var pe=De.prototype;return pe.strong=function(Q){return Q},pe.em=function(Q){return Q},pe.codespan=function(Q){return Q},pe.del=function(Q){return Q},pe.html=function(Q){return Q},pe.text=function(Q){return Q},pe.link=function(Q,Y,he){return""+he},pe.image=function(Q,Y,he){return""+he},pe.br=function(){return""},De}(),Se=function(){function De(){this.seen={}}var pe=De.prototype;return pe.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(Q,Y){var he=Q,ue=0;if(this.seen.hasOwnProperty(he)){ue=this.seen[Q];do ue++,he=Q+"-"+ue;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ue,this.seen[he]=0),he},pe.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},De}(),fe=function(){function De(ge){this.options=ge||le.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Se}De.parse=function(Q,Y){var he=new De(Y);return he.parse(Q)},De.parseInline=function(Q,Y){var he=new De(Y);return he.parseInline(Q)};var pe=De.prototype;return pe.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ue,Ne,de,Ce,Me,je,j,L,H,G,ee,re,Oe,Be,He,_e,xe,et,tt,it=Q.length;for(ue=0;ue<it;ue++){if(G=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[G.type]&&(tt=this.options.extensions.renderers[G.type].call({parser:this},G),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(G.type))){he+=tt||"";continue}switch(G.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(G.tokens),G.depth,s(this.parseInline(G.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(G.text,G.lang,G.escaped);continue}case"table":{for(L="",j="",Ce=G.header.length,Ne=0;Ne<Ce;Ne++)j+=this.renderer.tablecell(this.parseInline(G.header[Ne].tokens),{header:!0,align:G.align[Ne]});for(L+=this.renderer.tablerow(j),H="",Ce=G.rows.length,Ne=0;Ne<Ce;Ne++){for(je=G.rows[Ne],j="",Me=je.length,de=0;de<Me;de++)j+=this.renderer.tablecell(this.parseInline(je[de].tokens),{header:!1,align:G.align[de]});H+=this.renderer.tablerow(j)}he+=this.renderer.table(L,H);continue}case"blockquote":{H=this.parse(G.tokens),he+=this.renderer.blockquote(H);continue}case"list":{for(ee=G.ordered,re=G.start,Oe=G.loose,Ce=G.items.length,H="",Ne=0;Ne<Ce;Ne++)He=G.items[Ne],_e=He.checked,xe=He.task,Be="",He.task&&(et=this.renderer.checkbox(_e),Oe?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=et+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=et+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(He.tokens,Oe),H+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(H,ee,re);continue}case"html":{he+=this.renderer.html(G.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(G.tokens));continue}case"text":{for(H=G.tokens?this.parseInline(G.tokens):G.text;ue+1<it&&Q[ue+1].type==="text";)G=Q[++ue],H+=`
`+(G.tokens?this.parseInline(G.tokens):G.text);he+=Y?this.renderer.paragraph(H):H;continue}default:{var ct='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return he},pe.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ue,Ne,de,Ce=Q.length;for(ue=0;ue<Ce;ue++){if(Ne=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(de=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){he+=de||"";continue}switch(Ne.type){case"escape":{he+=Y.text(Ne.text);break}case"html":{he+=Y.html(Ne.text);break}case"link":{he+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{he+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{he+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{he+=Y.codespan(Ne.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{he+=Y.text(Ne.text);break}default:{var Me='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},De}();function $e(De,pe,ge){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof pe=="function"&&(ge=pe,pe=null),pe=v({},$e.defaults,pe||{}),k(pe),ge){var Q=pe.highlight,Y;try{Y=ie.lex(De,pe)}catch(Ce){return ge(Ce)}var he=function(Me){var je;if(!Me)try{pe.walkTokens&&$e.walkTokens(Y,pe.walkTokens),je=fe.parse(Y,pe)}catch(j){Me=j}return pe.highlight=Q,Me?ge(Me):ge(null,je)};if(!Q||Q.length<3||(delete pe.highlight,!Y.length))return he();var ue=0;$e.walkTokens(Y,function(Ce){Ce.type==="code"&&(ue++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Me,je){if(Me)return he(Me);je!=null&&je!==Ce.text&&(Ce.text=je,Ce.escaped=!0),ue--,ue===0&&he()})},0))}),ue===0&&he();return}function Ne(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+f(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ie.lex(De,pe);if(pe.walkTokens){if(pe.async)return Promise.all($e.walkTokens(de,pe.walkTokens)).then(function(){return fe.parse(de,pe)}).catch(Ne);$e.walkTokens(de,pe.walkTokens)}return fe.parse(de,pe)}catch(Ce){Ne(Ce)}}$e.options=$e.setOptions=function(De){return v($e.defaults,De),p($e.defaults),$e},$e.getDefaults=R,$e.defaults=le.defaults,$e.use=function(){for(var De=arguments.length,pe=new Array(De),ge=0;ge<De;ge++)pe[ge]=arguments[ge];var Q=v.apply(void 0,[{}].concat(pe)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},he;pe.forEach(function(ue){if(ue.extensions&&(he=!0,ue.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Me=arguments.length,je=new Array(Me),j=0;j<Me;j++)je[j]=arguments[j];var L=de.renderer.apply(this,je);return L===!1&&(L=Ce.apply(this,je)),L}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),ue.renderer&&function(){var de=$e.defaults.renderer||new ce,Ce=function(j){var L=de[j];de[j]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var re=ue.renderer[j].apply(de,G);return re===!1&&(re=L.apply(de,G)),re}};for(var Me in ue.renderer)Ce(Me);Q.renderer=de}(),ue.tokenizer&&function(){var de=$e.defaults.tokenizer||new V,Ce=function(j){var L=de[j];de[j]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var re=ue.tokenizer[j].apply(de,G);return re===!1&&(re=L.apply(de,G)),re}};for(var Me in ue.tokenizer)Ce(Me);Q.tokenizer=de}(),ue.walkTokens){var Ne=$e.defaults.walkTokens;Q.walkTokens=function(de){var Ce=[];return Ce.push(ue.walkTokens.call(this,de)),Ne&&(Ce=Ce.concat(Ne.call(this,de))),Ce}}he&&(Q.extensions=Y),$e.setOptions(Q)})},$e.walkTokens=function(De,pe){for(var ge=[],Q=function(){var Ne=he.value;switch(ge=ge.concat(pe.call($e,Ne)),Ne.type){case"table":{for(var de=N(Ne.header),Ce;!(Ce=de()).done;){var Me=Ce.value;ge=ge.concat($e.walkTokens(Me.tokens,pe))}for(var je=N(Ne.rows),j;!(j=je()).done;)for(var L=j.value,H=N(L),G;!(G=H()).done;){var ee=G.value;ge=ge.concat($e.walkTokens(ee.tokens,pe))}break}case"list":{ge=ge.concat($e.walkTokens(Ne.items,pe));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Ne.type]?$e.defaults.extensions.childTokens[Ne.type].forEach(function(re){ge=ge.concat($e.walkTokens(Ne[re],pe))}):Ne.tokens&&(ge=ge.concat($e.walkTokens(Ne.tokens,pe)))}},Y=N(De),he;!(he=Y()).done;)Q();return ge},$e.parseInline=function(De,pe){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");pe=v({},$e.defaults,pe||{}),k(pe);try{var ge=ie.lexInline(De,pe);return pe.walkTokens&&$e.walkTokens(ge,pe.walkTokens),fe.parseInline(ge,pe)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+f(Q.message+"",!0)+"</pre>";throw Q}},$e.Parser=fe,$e.parser=fe.parse,$e.Renderer=ce,$e.TextRenderer=ve,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=V,$e.Slugger=Se,$e.parse=$e;var Te=$e.options,ae=$e.setOptions,Re=$e.use,ne=$e.walkTokens,z=$e.parseInline,x=$e,be=fe.parse,Fe=ie.lex;le.Lexer=ie,le.Parser=fe,le.Renderer=ce,le.Slugger=Se,le.TextRenderer=ve,le.Tokenizer=V,le.getDefaults=R,le.lexer=Fe,le.marked=$e,le.options=Te,le.parse=x,le.parseInline=z,le.parser=be,le.setOptions=ae,le.use=Re,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[128],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=P;function P(r){const s=N(r);if(s&&s.length>0)return new Uint32Array(s)}let O=0;const M=new Uint32Array(10);function N(r){if(O=0,R(r,S,4352),O>0||(R(r,l,4449),O>0)||(R(r,b,4520),O>0)||(R(r,f,12593),O))return M.subarray(0,O);if(r>=44032&&r<=55203){const s=r-44032,o=s%588,n=Math.floor(s/588),i=Math.floor(o/28),c=o%28-1;if(n<S.length?R(n,S,0):4352+n-12593<f.length&&R(4352+n,f,12593),i<l.length?R(i,l,0):4449+i-12593<f.length&&R(4449+i-12593,f,12593),c>=0&&(c<b.length?R(c,b,0):4520+c-12593<f.length&&R(4520+c-12593,f,12593)),O>0)return M.subarray(0,O)}}function R(r,s,o){r>=o&&r<o+s.length&&p(s[r-o])}function p(r){r!==0&&(M[O++]=r&255,r>>8&&(M[O++]=r>>8&255),r>>16&&(M[O++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var T;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(T||(T={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[129],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=P,e.rot=O;function P(p,m,E){return Math.min(Math.max(p,m),E)}function O(p,m){return(m+p%m)%m}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=M;class N{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=N;class R{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=R}),define(ke[130],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=N,e.$cd=l;class P{constructor(f,r,s){this.owner=f,this.debugNameSource=r,this.referenceFn=s}getDebugName(f){return N(f,this)}}e.$ad=P;const O=new Map,M=new WeakMap;function N(b,f){const r=M.get(b);if(r)return r;const s=R(b,f);if(s){let o=O.get(s)??0;o++,O.set(s,o);const n=o===1?s:`${s}#${o}`;return M.set(b,n),n}}function R(b,f){const r=M.get(b);if(r)return r;const s=f.owner?T(f.owner)+".":"";let o;const n=f.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(o=n(),o!==void 0)return s+o}else return s+n;const i=f.referenceFn;if(i!==void 0&&(o=l(i),o!==void 0))return s+o;if(f.owner!==void 0){const c=p(f.owner,b);if(c!==void 0)return s+c}}function p(b,f){for(const r in b)if(b[r]===f)return r}const m=new Map,E=new WeakMap;function T(b){const f=E.get(b);if(f)return f;const r=S(b);let s=m.get(r)??0;s++,m.set(r,s);const o=s===1?r:`${r}#${s}`;return E.set(b,o),o}function S(b){const f=b.constructor;return f?f.name:"Object"}function l(b){const f=b.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(s?s[1]:void 0)?.trim()}}),define(ke[131],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=M;let P;function O(r){P=r}function M(){return P}class N{constructor(){this.a=0,this.d=new WeakMap}b(s){return R([p(b("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[p(" "),E(T(s.oldValue,70),{color:"red",strikeThrough:!0}),p(" "),E(T(s.newValue,60),{color:"green"})]:[p(" (unchanged)")]:[p(" "),E(T(s.newValue,60),{color:"green"}),p(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([m("observable value changed"),E(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return E(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(n,i)=>(this.d.get(s).add(n),o.apply(s,[n,i]))}handleDerivedRecomputed(s,o){const n=this.d.get(s);console.log(...this.b([m("derived recomputed"),E(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(n),{data:[{fn:s._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([m("observable from event triggered"),E(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(n,i)=>(this.d.get(s).add(n),o.apply(s,[n,i]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([m("autorun"),E(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([m("transaction"),E(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=N;function R(r){const s=new Array,o=[];let n="";function i(u){if("length"in u)for(const t of u)t&&i(t);else"text"in u?(n+=`%c${u.text}`,s.push(u.style),u.data&&o.push(...u.data)):"data"in u&&o.push(...u.data)}i(r);const c=[n,...s];return c.push(...o),c}function p(r){return E(r,{color:"black"})}function m(r){return E(f(`${r}: `,10),{color:"black",bold:!0})}function E(r,s={color:"black"}){function o(i){return Object.entries(i).reduce((c,[u,t])=>`${c}${u}:${t};`,"")}const n={color:s.color};return s.strikeThrough&&(n["text-decoration"]="line-through"),s.bold&&(n["font-weight"]="bold"),{text:r,style:o(n)}}function T(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?S(r,s):l(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function S(r,s){let o="[ ",n=!0;for(const i of r){if(n||(o+=", "),o.length-5>s){o+="...";break}n=!1,o+=`${T(i,s-o.length)}`}return o+=" ]",o}function l(r,s){let o="{ ",n=!0;for(const[i,c]of Object.entries(r)){if(n||(o+=", "),o.length-5>s){o+="...";break}n=!1,o+=`${i}: ${T(c,s-o.length)}`}return o+=" }",o}function b(r,s){let o="";for(let n=1;n<=s;n++)o+=r;return o}function f(r,s){for(;r.length<s;)r+=" ";return r}}),define(ke[132],Ie([1,0,125,130,131]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=R,e.$Td=m,e.$Ud=T,e.$Xd=b,e.$Yd=r,e.$Zd=s,e.$1d=o,e.$3d=i,e.$4d=c,e.$6d=t;let N;function R(a){N=a}let p;function m(a){p=a}let E;function T(a){E=a}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,w){const $=w===void 0?void 0:d,v=w===void 0?d:w;return E({owner:$,debugName:()=>{const y=(0,O.$cd)(v);if(y!==void 0)return y;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(D)return`${this.debugName}.${D[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:v},y=>v(this.read(y),y))}recomputeInitiallyAndOnChange(d,w){return d.add(N(this,w)),this}keepObserved(d){return d.add(p(this)),this}get a(){return this.get()}}e.$Vd=S;class l extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const w=this.b.size;this.b.add(d),w===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=l;function b(a,d){const w=new n(a,d);try{a(w)}finally{w.finish()}}let f;function r(a){if(f)a(f);else{const d=new n(a,void 0);f=d;try{a(d)}finally{d.finish(),f=void 0}}}async function s(a,d){const w=new n(a,d);try{await a(w)}finally{w.finish()}}function o(a,d,w){a?d(a):b(d,w)}class n{constructor(d,w){this._fn=d,this.b=w,this.a=[],(0,M.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(d,w){this.a.push({observer:d,observable:w}),d.beginUpdate(w)}finish(){const d=this.a;for(let w=0;w<d.length;w++){const{observer:$,observable:v}=d[w];$.endUpdate(v)}this.a=null,(0,M.$Id)()?.handleEndTransaction()}}e.$2d=n;function i(a,d){let w;return typeof a=="string"?w=new O.$ad(void 0,a,void 0):w=new O.$ad(a,void 0,void 0),new u(w,d,P.$6c)}function c(a,d){return new u(new O.$ad(a.owner,a.debugName,void 0),d,a.equalsFn??P.$6c)}class u extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,w,$){super(),this.e=d,this.g=$,this.d=w}get(){return this.d}set(d,w,$){if($===void 0&&this.g(this.d,d))return;let v;w||(w=v=new n(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(d),(0,M.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:d,change:$,didChange:!0,hadValue:!0});for(const h of this.b)w.updateObserver(h,this),h.handleChange(this,$)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$5d=u;function t(a,d){let w;return typeof a=="string"?w=new O.$ad(void 0,a,void 0):w=new O.$ad(a,void 0,void 0),new g(w,d,P.$6c)}class g extends u{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function le(M){const N=[];typeof M=="number"&&N.push("code/timeOrigin",M);function R(m){N.push(m,Date.now())}function p(){const m=[];for(let E=0;E<N.length;E+=2)m.push({name:N[E],startTime:N[E+1]});return m}return{mark:R,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(M+R.startTime)});return N}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function P(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=P(O))}(),define(ke[133],Ie([1,0,42]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;const O=Symbol("unset");class M{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||P.Iterable.empty()}insert(m,E,T){this.d(m,S=>S._value=E,T)}mutate(m,E){this.d(m,T=>T._value=E(T._value===O?void 0:T._value))}delete(m){const E=this.c(m);if(!E)return;let T=E.length-1;const S=E[T].node._value;if(S!==O){for(this.b--,E[T].node._value=O;T>0;T--){const{node:l,part:b}=E[T];if(l.children?.size||l._value!==O)break;E[T-1].node.children.delete(b)}return S}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const T=E[E.length-1].node;for(let S=E.length-1;S>0;S--){const l=E[S-1];if(l.node.children.delete(E[S].part),l.node.children.size>0||l.node._value!==O)break}for(const S of N(T))S._value!==O&&(this.b--,yield S._value)}find(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return;E=S}return E._value===O?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;if(S._value!==O)return!0;E=S}return!1}hasKeyOrChildren(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return!0}hasKey(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return E._value!==O}c(m){const E=[{part:"",node:this.a}];let T=0;for(const S of m){const l=E[T].node.children?.get(S);if(!l)return;E.push({part:S,node:l}),T++}return E}d(m,E,T){let S=this.a;for(const f of m){if(S.children)if(S.children.has(f))S=S.children.get(f);else{const r=new R;S.children.set(f,r),S=r}else{const r=new R;S.children=new Map([[f,r]]),S=r}T?.(S)}const l=S._value===O?0:1;E(S);const b=S._value===O?0:1;this.b+=b-l}*values(){for(const{_value:m}of N(this.a))m!==O&&(yield m)}}e.$yO=M;function*N(p){const m=[p];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const T of E.children.values())m.push(T)}}class R{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var O in P)(typeof exports=="object"?exports:le)[O]=P[O]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function P(O){if(e[O])return e[O].exports;var M=e[O]={i:O,l:!1,exports:{}};return le[O].call(M.exports,M,M.exports,P),M.l=!0,M.exports}return P.m=le,P.c=e,P.d=function(O,M,N){P.o(O,M)||Object.defineProperty(O,M,{enumerable:!0,get:N})},P.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},P.t=function(O,M){if(1&M&&(O=P(O)),8&M||4&M&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(P.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&M&&typeof O!="string")for(var R in O)P.d(N,R,function(p){return O[p]}.bind(null,R));return N},P.n=function(O){var M=O&&O.__esModule?function(){return O.default}:function(){return O};return P.d(M,"a",M),M},P.o=function(O,M){return Object.prototype.hasOwnProperty.call(O,M)},P.p="",P(P.s=0)}([function(le,e,P){(function(O){var M;e=le.exports=Re,M=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],m=e.src=[],E=0,T=E++;m[T]="0|[1-9]\\d*";var S=E++;m[S]="[0-9]+";var l=E++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=E++;m[b]="("+m[T]+")\\.("+m[T]+")\\.("+m[T]+")";var f=E++;m[f]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var r=E++;m[r]="(?:"+m[T]+"|"+m[l]+")";var s=E++;m[s]="(?:"+m[S]+"|"+m[l]+")";var o=E++;m[o]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var n=E++;m[n]="(?:-?("+m[s]+"(?:\\."+m[s]+")*))";var i=E++;m[i]="[0-9A-Za-z-]+";var c=E++;m[c]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var u=E++,t="v?"+m[b]+m[o]+"?"+m[c]+"?";m[u]="^"+t+"$";var g="[v=\\s]*"+m[f]+m[n]+"?"+m[c]+"?",a=E++;m[a]="^"+g+"$";var d=E++;m[d]="((?:<|>)?=?)";var w=E++;m[w]=m[S]+"|x|X|\\*";var $=E++;m[$]=m[T]+"|x|X|\\*";var v=E++;m[v]="[v=\\s]*("+m[$]+")(?:\\.("+m[$]+")(?:\\.("+m[$]+")(?:"+m[o]+")?"+m[c]+"?)?)?";var y=E++;m[y]="[v=\\s]*("+m[w]+")(?:\\.("+m[w]+")(?:\\.("+m[w]+")(?:"+m[n]+")?"+m[c]+"?)?)?";var h=E++;m[h]="^"+m[d]+"\\s*"+m[v]+"$";var D=E++;m[D]="^"+m[d]+"\\s*"+m[y]+"$";var k=E++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;m[C]="(?:~>?)";var I=E++;m[I]="(\\s*)"+m[C]+"\\s+",p[I]=new RegExp(m[I],"g");var W=E++;m[W]="^"+m[C]+m[v]+"$";var V=E++;m[V]="^"+m[C]+m[y]+"$";var q=E++;m[q]="(?:\\^)";var A=E++;m[A]="(\\s*)"+m[q]+"\\s+",p[A]=new RegExp(m[A],"g");var B=E++;m[B]="^"+m[q]+m[v]+"$";var K=E++;m[K]="^"+m[q]+m[y]+"$";var ie=E++;m[ie]="^"+m[d]+"\\s*("+g+")$|^$";var ce=E++;m[ce]="^"+m[d]+"\\s*("+t+")$|^$";var ve=E++;m[ve]="(\\s*)"+m[d]+"\\s*("+g+"|"+m[v]+")",p[ve]=new RegExp(m[ve],"g");var Se=E++;m[Se]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var fe=E++;m[fe]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var $e=E++;m[$e]="(<|>)?=?\\s*\\*";for(var Te=0;Te<35;Te++)M(Te,m[Te]),p[Te]||(p[Te]=new RegExp(m[Te]));function ae(L,H){if(L instanceof Re)return L;if(typeof L!="string"||L.length>N||!(H?p[a]:p[u]).test(L))return null;try{return new Re(L,H)}catch{return null}}function Re(L,H){if(L instanceof Re){if(L.loose===H)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Re))return new Re(L,H);M("SemVer",L,H),this.loose=H;var G=L.trim().match(H?p[a]:p[u]);if(!G)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<R)return re}return ee}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=ae,e.valid=function(L,H){var G=ae(L,H);return G?G.version:null},e.clean=function(L,H){var G=ae(L.trim().replace(/^[=v]+/,""),H);return G?G.version:null},e.SemVer=Re,Re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Re.prototype.toString=function(){return this.version},Re.prototype.compare=function(L){return M("SemVer.compare",this.version,this.loose,L),L instanceof Re||(L=new Re(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Re.prototype.compareMain=function(L){return L instanceof Re||(L=new Re(L,this.loose)),z(this.major,L.major)||z(this.minor,L.minor)||z(this.patch,L.patch)},Re.prototype.comparePre=function(L){if(L instanceof Re||(L=new Re(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var H=0;do{var G=this.prerelease[H],ee=L.prerelease[H];if(M("prerelease compare",H,G,ee),G===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(G===void 0)return-1;if(G!==ee)return z(G,ee)}while(++H)},Re.prototype.inc=function(L,H){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,H,G,ee){typeof G=="string"&&(ee=G,G=void 0);try{return new Re(L,G).inc(H,ee).version}catch{return null}},e.diff=function(L,H){if(De(L,H))return null;var G=ae(L),ee=ae(H);if(G.prerelease.length||ee.prerelease.length){for(var re in G)if((re==="major"||re==="minor"||re==="patch")&&G[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in G)if((re==="major"||re==="minor"||re==="patch")&&G[re]!==ee[re])return re},e.compareIdentifiers=z;var ne=/^[0-9]+$/;function z(L,H){var G=ne.test(L),ee=ne.test(H);return G&&ee&&(L=+L,H=+H),G&&!ee?-1:ee&&!G?1:L<H?-1:L>H?1:0}function x(L,H,G){return new Re(L,G).compare(new Re(H,G))}function be(L,H,G){return x(L,H,G)>0}function Fe(L,H,G){return x(L,H,G)<0}function De(L,H,G){return x(L,H,G)===0}function pe(L,H,G){return x(L,H,G)!==0}function ge(L,H,G){return x(L,H,G)>=0}function Q(L,H,G){return x(L,H,G)<=0}function Y(L,H,G,ee){var re;switch(H){case"===":typeof L=="object"&&(L=L.version),typeof G=="object"&&(G=G.version),re=L===G;break;case"!==":typeof L=="object"&&(L=L.version),typeof G=="object"&&(G=G.version),re=L!==G;break;case"":case"=":case"==":re=De(L,G,ee);break;case"!=":re=pe(L,G,ee);break;case">":re=be(L,G,ee);break;case">=":re=ge(L,G,ee);break;case"<":re=Fe(L,G,ee);break;case"<=":re=Q(L,G,ee);break;default:throw new TypeError("Invalid operator: "+H)}return re}function he(L,H){if(L instanceof he){if(L.loose===H)return L;L=L.value}if(!(this instanceof he))return new he(L,H);M("comparator",L,H),this.loose=H,this.parse(L),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(L,H){return z(H,L)},e.major=function(L,H){return new Re(L,H).major},e.minor=function(L,H){return new Re(L,H).minor},e.patch=function(L,H){return new Re(L,H).patch},e.compare=x,e.compareLoose=function(L,H){return x(L,H,!0)},e.rcompare=function(L,H,G){return x(H,L,G)},e.sort=function(L,H){return L.sort(function(G,ee){return e.compare(G,ee,H)})},e.rsort=function(L,H){return L.sort(function(G,ee){return e.rcompare(G,ee,H)})},e.gt=be,e.lt=Fe,e.eq=De,e.neq=pe,e.gte=ge,e.lte=Q,e.cmp=Y,e.Comparator=he;var ue={};function Ne(L,H){if(L instanceof Ne)return L.loose===H?L:new Ne(L.raw,H);if(L instanceof he)return new Ne(L.value,H);if(!(this instanceof Ne))return new Ne(L,H);if(this.loose=H,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function de(L){return!L||L.toLowerCase()==="x"||L==="*"}function Ce(L,H,G,ee,re,Oe,Be,He,_e,xe,et,tt,it){return((H=de(G)?"":de(ee)?">="+G+".0.0":de(re)?">="+G+"."+ee+".0":">="+H)+" "+(He=de(_e)?"":de(xe)?"<"+(+_e+1)+".0.0":de(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+He)).trim()}function Me(L,H){for(var G=0;G<L.length;G++)if(!L[G].test(H))return!1;if(H.prerelease.length){for(G=0;G<L.length;G++)if(M(L[G].semver),L[G].semver!==ue&&L[G].semver.prerelease.length>0){var ee=L[G].semver;if(ee.major===H.major&&ee.minor===H.minor&&ee.patch===H.patch)return!0}return!1}return!0}function je(L,H,G){try{H=new Ne(H,G)}catch{return!1}return H.test(L)}function j(L,H,G,ee){var re,Oe,Be,He,_e;switch(L=new Re(L,ee),H=new Ne(H,ee),G){case">":re=be,Oe=Q,Be=Fe,He=">",_e=">=";break;case"<":re=Fe,Oe=ge,Be=be,He="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(L,H,ee))return!1;for(var xe=0;xe<H.set.length;++xe){var et=H.set[xe],tt=null,it=null;if(et.forEach(function(ct){ct.semver===ue&&(ct=new he(">=0.0.0")),tt=tt||ct,it=it||ct,re(ct.semver,tt.semver,ee)?tt=ct:Be(ct.semver,it.semver,ee)&&(it=ct)}),tt.operator===He||tt.operator===_e||(!it.operator||it.operator===He)&&Oe(L,it.semver)||it.operator===_e&&Be(L,it.semver))return!1}return!0}he.prototype.parse=function(L){var H=this.loose?p[ie]:p[ce],G=L.match(H);if(!G)throw new TypeError("Invalid comparator: "+L);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new Re(G[2],this.loose):this.semver=ue},he.prototype.toString=function(){return this.value},he.prototype.test=function(L){return M("Comparator.test",L,this.loose),this.semver===ue||(typeof L=="string"&&(L=new Re(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},he.prototype.intersects=function(L,H){if(!(L instanceof he))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new Ne(L.value,H),je(this.value,G,H);if(L.operator==="")return G=new Ne(this.value,H),je(L.semver,G,H);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Oe=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),He=Y(this.semver,"<",L.semver,H)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),_e=Y(this.semver,">",L.semver,H)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||re||Oe&&Be||He||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(L){var H=this.loose;L=L.trim(),M("range",L,H);var G=H?p[fe]:p[Se];L=L.replace(G,Ce),M("hyphen replace",L),L=L.replace(p[ve],"$1$2$3"),M("comparator trim",L,p[ve]),L=(L=(L=L.replace(p[I],"$1~")).replace(p[A],"$1^")).split(/\s+/).join(" ");var ee=H?p[ie]:p[ce],re=L.split(" ").map(function(Oe){return function(Be,He){return M("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){M("caret",tt,it);var ct=it?p[K]:p[B];return tt.replace(ct,function(gt,Ue,ot,Z,X){var me;return M("caret",tt,gt,Ue,ot,Z,X),de(Ue)?me="":de(ot)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(Z)?me=Ue==="0"?">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+".0 <"+(+Ue+1)+".0.0":X?(M("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+Z+X+" <"+Ue+"."+ot+"."+(+Z+1):">="+Ue+"."+ot+"."+Z+X+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+Z+X+" <"+(+Ue+1)+".0.0"):(M("no pr"),me=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+Z+" <"+Ue+"."+ot+"."+(+Z+1):">="+Ue+"."+ot+"."+Z+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+Z+" <"+(+Ue+1)+".0.0"),M("caret return",me),me})}(et,xe)}).join(" ")}(Be,He),M("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var ct=it?p[V]:p[W];return tt.replace(ct,function(gt,Ue,ot,Z,X){var me;return M("tilde",tt,gt,Ue,ot,Z,X),de(Ue)?me="":de(ot)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(Z)?me=">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":X?(M("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=">="+Ue+"."+ot+"."+Z+X+" <"+Ue+"."+(+ot+1)+".0"):me=">="+Ue+"."+ot+"."+Z+" <"+Ue+"."+(+ot+1)+".0",M("tilde return",me),me})}(et,xe)}).join(" ")}(Be,He),M("tildes",Be),Be=function(_e,xe){return M("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var ct=it?p[D]:p[h];return tt.replace(ct,function(gt,Ue,ot,Z,X,me){M("xRange",tt,gt,Ue,ot,Z,X,me);var qe=de(ot),we=qe||de(Z),at=we||de(X);return Ue==="="&&at&&(Ue=""),qe?gt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&at?(we&&(Z=0),at&&(X=0),Ue===">"?(Ue=">=",we?(ot=+ot+1,Z=0,X=0):at&&(Z=+Z+1,X=0)):Ue==="<="&&(Ue="<",we?ot=+ot+1:Z=+Z+1),gt=Ue+ot+"."+Z+"."+X):we?gt=">="+ot+".0.0 <"+(+ot+1)+".0.0":at&&(gt=">="+ot+"."+Z+".0 <"+ot+"."+(+Z+1)+".0"),M("xRange return",gt),gt})}(et,xe)}).join(" ")}(Be,He),M("xrange",Be),Be=function(_e,xe){return M("replaceStars",_e,xe),_e.trim().replace(p[$e],"")}(Be,He),M("stars",Be),Be}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Oe){return!!Oe.match(ee)})),re=re.map(function(Oe){return new he(Oe,H)})},Ne.prototype.intersects=function(L,H){if(!(L instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ee){return L.set.some(function(re){return re.every(function(Oe){return ee.intersects(Oe,H)})})})})},e.toComparators=function(L,H){return new Ne(L,H).set.map(function(G){return G.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Re(L,this.loose));for(var H=0;H<this.set.length;H++)if(Me(this.set[H],L))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(L,H,G){var ee=null,re=null;try{var Oe=new Ne(H,G)}catch{return null}return L.forEach(function(Be){Oe.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Re(ee=Be,G)))}),ee},e.minSatisfying=function(L,H,G){var ee=null,re=null;try{var Oe=new Ne(H,G)}catch{return null}return L.forEach(function(Be){Oe.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Re(ee=Be,G)))}),ee},e.validRange=function(L,H){try{return new Ne(L,H).range||"*"}catch{return null}},e.ltr=function(L,H,G){return j(L,H,"<",G)},e.gtr=function(L,H,G){return j(L,H,">",G)},e.outside=j,e.prerelease=function(L,H){var G=ae(L,H);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(L,H,G){return L=new Ne(L,G),H=new Ne(H,G),L.intersects(H)},e.coerce=function(L){if(L instanceof Re)return L;if(typeof L!="string")return null;var H=L.match(p[k]);return H==null?null:ae((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,P(1))},function(le,e){var P,O,M=le.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function p(s){if(P===setTimeout)return setTimeout(s,0);if((P===N||!P)&&setTimeout)return P=setTimeout,setTimeout(s,0);try{return P(s,0)}catch{try{return P.call(null,s,0)}catch{return P.call(this,s,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:N}catch{P=N}try{O=typeof clearTimeout=="function"?clearTimeout:R}catch{O=R}})();var m,E=[],T=!1,S=-1;function l(){T&&m&&(T=!1,m.length?E=m.concat(E):S=-1,E.length&&b())}function b(){if(!T){var s=p(l);T=!0;for(var o=E.length;o;){for(m=E,E=[];++S<o;)m&&m[S].run();S=-1,o=E.length}m=null,T=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===R||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(s)}}function f(s,o){this.fun=s,this.array=o}function r(){}M.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];E.push(new f(s,o)),E.length!==1||T||p(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=r,M.addListener=r,M.once=r,M.off=r,M.removeListener=r,M.removeAllListeners=r,M.emit=r,M.prependListener=r,M.prependOnceListener=r,M.listeners=function(s){return[]},M.binding=function(s){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(s){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(ke[134],Ie([1,0,14,6]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=M,e.$te=N,e.$ue=R,e.$ve=p,e.$we=E,e.$xe=T,e.$ye=S,e.$ze=l,e.$Ae=b,e.$Be=f,e.$Ce=r,e.$De=s,e.$Ee=o,e.$Fe=n,e.$Ge=i;function M(c){const u=c;return u?typeof u.read=="function":!1}function N(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function R(c){const u=c;return u?N(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function p(c,u){return new m(c,u)}class m{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let g;switch(u){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const a=g.indexOf(t);a>=0&&g.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,u){const t=[];let g;for(;(g=c.read())!==null;)t.push(g);return u(t)}function T(c,u,t){const g=[];let a;for(;(a=c.read())!==null&&g.length<t;)g.push(a);return a===null&&g.length>0?u(g):{read:()=>{if(g.length>0)return g.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return c.read()}}}function S(c,u){return new Promise((t,g)=>{const a=[];l(c,{onData:d=>{u&&a.push(d)},onError:d=>{u?g(d):t(void 0)},onEnd:()=>{t(u?u(a):void 0)}})})}function l(c,u,t){c.on("error",g=>{t?.isCancellationRequested||u.onError(g)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",g=>{t?.isCancellationRequested||u.onData(g)})}function b(c,u){return new Promise((t,g)=>{const a=new O.$Tc,d=[],w=y=>{if(d.push(y),d.length>u)return a.dispose(),c.pause(),t({stream:c,buffer:d,ended:!1})},$=y=>(a.dispose(),g(y)),v=()=>(a.dispose(),t({stream:c,buffer:d,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",$))),c.on("error",$),a.add((0,O.$Sc)(()=>c.removeListener("end",v))),c.on("end",v),a.add((0,O.$Sc)(()=>c.removeListener("data",w))),c.on("data",w)})}function f(c,u){const t=p(u);return t.end(c),t}function r(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function s(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function o(c,u,t){const g=p(t);return l(c,{onData:a=>g.write(u.data(a)),onError:a=>g.error(u.error?u.error(a):a),onEnd:()=>g.end()}),g}function n(c,u,t){let g=!1;return{read:()=>{const a=u.read();return g?a:(g=!0,a!==null?t([c,a]):c)}}}function i(c,u,t){let g=!1;const a=p(t);return l(u,{onData:d=>g?a.write(d):(g=!0,a.write(t([c,d]))),onError:d=>a.error(d),onEnd:()=>{g||(g=!0,a.write(c)),a.end()}}),a}}),define(ke[22],Ie([1,0,43,134]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=E,e.$Je=T,e.$Ke=S,e.$Le=l,e.$Me=b,e.$Ne=f,e.$Oe=r,e.$Pe=s,e.$Qe=o,e.$Re=n,e.$Se=i,e.$Te=c,e.$Ue=u,e.$Ve=t,e.$We=g,e.$Xe=a,e.$Ye=d,e.$Ze=w,e.$1e=$,e.$2e=h;const M=typeof Buffer<"u",N=new P.$V(()=>new Uint8Array(256));let R,p;class m{static alloc(k){return M?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return M&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,C){return!(C?.dontUseNodeBuffer||!1)&&M?new m(Buffer.from(k)):(R||(R=new TextEncoder),new m(R.encode(k)))}static fromByteArray(k){const C=m.alloc(k.length);for(let I=0,W=k.length;I<W;I++)C.buffer[I]=k[I];return C}static concat(k,C){if(typeof C>"u"){C=0;for(let V=0,q=k.length;V<q;V++)C+=k[V].byteLength}const I=m.alloc(C);let W=0;for(let V=0,q=k.length;V<q;V++){const A=k[V];I.set(A,W),W+=A.byteLength}return I}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return M?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,C){return new m(this.buffer.subarray(k,C))}set(k,C){if(k instanceof m)this.buffer.set(k.buffer,C);else if(k instanceof Uint8Array)this.buffer.set(k,C);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),C);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,C){b(this.buffer,k,C)}readUInt32LE(k){return f(this.buffer,k)}writeUInt32LE(k,C){r(this.buffer,k,C)}readUInt8(k){return s(this.buffer,k)}writeUInt8(k,C){o(this.buffer,k,C)}indexOf(k,C=0){return E(this.buffer,k instanceof m?k.buffer:k,C)}}e.$He=m;function E(D,k,C=0){const I=k.byteLength,W=D.byteLength;if(I===0)return 0;if(I===1)return D.indexOf(k[0]);if(I>W-C)return-1;const V=N.value;V.fill(k.length);for(let K=0;K<k.length;K++)V[k[K]]=k.length-K-1;let q=C+k.length-1,A=q,B=-1;for(;q<W;)if(D[q]===k[A]){if(A===0){B=q;break}q--,A--}else q+=Math.max(k.length-A,V[D[q]]),A=k.length-1;return B}function T(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0}function S(D,k,C){D[C+0]=k&255,k=k>>>8,D[C+1]=k&255}function l(D,k){return D[k]*2**24+D[k+1]*2**16+D[k+2]*2**8+D[k+3]}function b(D,k,C){D[C+3]=k,k=k>>>8,D[C+2]=k,k=k>>>8,D[C+1]=k,k=k>>>8,D[C]=k}function f(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0|D[k+2]<<16>>>0|D[k+3]<<24>>>0}function r(D,k,C){D[C+0]=k&255,k=k>>>8,D[C+1]=k&255,k=k>>>8,D[C+2]=k&255,k=k>>>8,D[C+3]=k&255}function s(D,k){return D[k]}function o(D,k,C){D[C]=k}function n(D){return O.$we(D,k=>m.concat(k))}function i(D){return O.$De(D)}function c(D){return O.$ye(D,k=>m.concat(k))}async function u(D){return D.ended?m.concat(D.buffer):m.concat([...D.buffer,await c(D.stream)])}function t(D){return O.$Be(D,k=>m.concat(k))}function g(D){return O.$Ee(D,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}function a(D){return O.$ve(k=>m.concat(k),D)}function d(D,k){return O.$Fe(D,k,C=>m.concat(C))}function w(D,k){return O.$Ge(D,k,C=>m.concat(C))}function $(D){let k=0,C=0,I=0;const W=new Uint8Array(Math.floor(D.length/4*3)),V=A=>{switch(C){case 3:W[I++]=k|A,C=0;break;case 2:W[I++]=k|A>>>2,k=A<<6,C=3;break;case 1:W[I++]=k|A>>>4,k=A<<4,C=2;break;default:k=A<<2,C=1}};for(let A=0;A<D.length;A++){const B=D.charCodeAt(A);if(B>=65&&B<=90)V(B-65);else if(B>=97&&B<=122)V(B-97+26);else if(B>=48&&B<=57)V(B-48+52);else if(B===43||B===45)V(62);else if(B===47||B===95)V(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${D[A]}`)}}const q=I;for(;C>0;)V(0);return m.wrap(W).slice(0,q)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:D},k=!0,C=!1){const I=C?y:v;let W="";const V=D.byteLength%3;let q=0;for(;q<D.byteLength-V;q+=3){const A=D[q+0],B=D[q+1],K=D[q+2];W+=I[A>>>2],W+=I[(A<<4|B>>>4)&63],W+=I[(B<<2|K>>>6)&63],W+=I[K&63]}if(V===1){const A=D[q+0];W+=I[A>>>2],W+=I[A<<4&63],k&&(W+="==")}else if(V===2){const A=D[q+0],B=D[q+1];W+=I[A>>>2],W+=I[(A<<4|B>>>4)&63],W+=I[B<<2&63],k&&(W+="=")}return W}}),define(ke[135],Ie([1,0,28,128,13]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.FuzzyScore=e.$Ak=e.$zk=void 0,e.or=N,e.$Bk=p,e.$Ck=m,e.$Dk=S,e.$Ek=$,e.$Fk=v,e.$Gk=I,e.$Hk=W,e.$Ik=V,e.$Jk=q,e.$Kk=x,e.$Mk=pe,e.$Nk=Y,e.$Ok=he;function N(...de){return function(Ce,Me){for(let je=0,j=de.length;je<j;je++){const L=de[je](Ce,Me);if(L)return L}return null}}e.$zk=R.bind(void 0,!1),e.$Ak=R.bind(void 0,!0);function R(de,Ce,Me){if(!Me||Me.length<Ce.length)return null;let je;return de?je=M.$Af(Me,Ce):je=Me.indexOf(Ce)===0,je?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(de,Ce){const Me=Ce.toLowerCase().indexOf(de.toLowerCase());return Me===-1?null:[{start:Me,end:Me+de.length}]}function m(de,Ce){return E(de.toLowerCase(),Ce.toLowerCase(),0,0)}function E(de,Ce,Me,je){if(Me===de.length)return[];if(je===Ce.length)return null;if(de[Me]===Ce[je]){let j=null;return(j=E(de,Ce,Me+1,je+1))?c({start:je,end:je+1},j):null}return E(de,Ce,Me,je+1)}function T(de){return 97<=de&&de<=122}function S(de){return 65<=de&&de<=90}function l(de){return 48<=de&&de<=57}function b(de){return de===32||de===9||de===10||de===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>f.add(de.charCodeAt(0)));function r(de){return b(de)||f.has(de)}function s(de,Ce){return de===Ce||r(de)&&r(Ce)}const o=new Map;function n(de){if(o.has(de))return o.get(de);let Ce;const Me=(0,O.$xk)(de);return Me&&(Ce=Me),o.set(de,Ce),Ce}function i(de){return T(de)||S(de)||l(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function u(de,Ce){for(let Me=Ce;Me<de.length;Me++){const je=de.charCodeAt(Me);if(S(je)||l(je)||Me>0&&!i(de.charCodeAt(Me-1)))return Me}return de.length}function t(de,Ce,Me,je){if(Me===de.length)return[];if(je===Ce.length)return null;if(de[Me]!==Ce[je].toLowerCase())return null;{let j=null,L=je+1;for(j=t(de,Ce,Me+1,je+1);!j&&(L=u(Ce,L))<Ce.length;)j=t(de,Ce,Me+1,L),L++;return j===null?null:c({start:je,end:je+1},j)}}function g(de){let Ce=0,Me=0,je=0,j=0,L=0;for(let Oe=0;Oe<de.length;Oe++)L=de.charCodeAt(Oe),S(L)&&Ce++,T(L)&&Me++,i(L)&&je++,l(L)&&j++;const H=Ce/de.length,G=Me/de.length,ee=je/de.length,re=j/de.length;return{upperPercent:H,lowerPercent:G,alphaPercent:ee,numericPercent:re}}function a(de){const{upperPercent:Ce,lowerPercent:Me}=de;return Me===0&&Ce>.6}function d(de){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:je,numericPercent:j}=de;return Me>.2&&Ce<.8&&je>.6&&j<.2}function w(de){let Ce=0,Me=0,je=0,j=0;for(let L=0;L<de.length;L++)je=de.charCodeAt(L),S(je)&&Ce++,T(je)&&Me++,b(je)&&j++;return(Ce===0||Me===0)&&j===0?de.length<=30:Ce<=5}function $(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!w(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=g(Ce);if(!d(Me)){if(!a(Me))return null;Ce=Ce.toLowerCase()}let je=null,j=0;for(de=de.toLowerCase();j<Ce.length&&(je=t(de,Ce,0,j))===null;)j=u(Ce,j+1);return je}function v(de,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let je=null,j=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();j<Ce.length&&(je=y(de,Ce,0,j,Me),je===null);)j=h(Ce,j+1);return je}function y(de,Ce,Me,je,j){let L=0;if(Me===de.length)return[];if(je===Ce.length)return null;if(!s(de.charCodeAt(Me),Ce.charCodeAt(je))){const ee=n(de.charCodeAt(Me));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!s(ee[re],Ce.charCodeAt(je+re)))return null;L+=ee.length-1}let H=null,G=je+L+1;if(H=y(de,Ce,Me+1,G,j),!j)for(;!H&&(G=h(Ce,G))<Ce.length;)H=y(de,Ce,Me+1,G,j),G++;if(!H)return null;if(de.charCodeAt(Me)!==Ce.charCodeAt(je)){const ee=n(de.charCodeAt(Me));if(!ee)return H;for(let re=0;re<ee.length;re++)if(ee[re]!==Ce.charCodeAt(je+re))return H}return c({start:je,end:je+L+1},H)}function h(de,Ce){for(let Me=Ce;Me<de.length;Me++)if(r(de.charCodeAt(Me))||Me>0&&r(de.charCodeAt(Me-1)))return Me;return de.length}const D=N(e.$Ak,$,p),k=N(e.$Ak,$,m),C=new P.$Dc(1e4);function I(de,Ce,Me=!1){if(typeof de!="string"||typeof Ce!="string")return null;let je=C.get(de);je||(je=new RegExp(M.$if(de),"i"),C.set(de,je));const j=je.exec(Ce);return j?[{start:j.index,end:j.index+j[0].length}]:Me?k(de,Ce):D(de,Ce)}function W(de,Ce){const Me=pe(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function V(de,Ce,Me,je,j,L){const H=Math.min(13,de.length);for(;Me<H;Me++){const G=pe(de,Ce,Me,je,j,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,L]}function q(de){if(typeof de>"u")return[];const Ce=[],Me=de[1];for(let je=de.length-1;je>1;je--){const j=de[je]+Me,L=Ce[Ce.length-1];L&&L.end===j?L.end=j+1:Ce.push({start:j,end:j+1})}return Ce}const A=128;function B(){const de=[],Ce=[];for(let Me=0;Me<=A;Me++)Ce[Me]=0;for(let Me=0;Me<=A;Me++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Me=0;Me<=de;Me++)Ce[Me]=0;return Ce}const ie=K(2*A),ce=K(2*A),ve=B(),Se=B(),fe=B(),$e=!1;function Te(de,Ce,Me,je,j){function L(G,ee,re=" "){for(;G.length<ee;)G=re+G;return G}let H=` |   |${je.split("").map(G=>L(G,3)).join("|")}
`;for(let G=0;G<=Me;G++)G===0?H+=" |":H+=`${Ce[G-1]}|`,H+=de[G].slice(0,j+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return H}function ae(de,Ce,Me,je){de=de.substr(Ce),Me=Me.substr(je),console.log(Te(Se,de,de.length,Me,Me.length)),console.log(Te(fe,de,de.length,Me,Me.length)),console.log(Te(ve,de,de.length,Me,Me.length))}function Re(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Me=de.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Sf(Me)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function z(de,Ce,Me){return Ce[de]!==Me[de]}function x(de,Ce,Me,je,j,L,H=!1){for(;Ce<Me&&j<L;)de[Ce]===je[j]&&(H&&(ie[Ce]=j),Ce+=1),j+=1;return Ce===Me}var be;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(be||(be={}));var Fe;(function(de){de.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}de.isDefault=Ce})(Fe||(e.FuzzyScore=Fe={}));class De{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$Lk=De;function pe(de,Ce,Me,je,j,L,H=De.default){const G=de.length>A?A:de.length,ee=je.length>A?A:je.length;if(Me>=G||L>=ee||G-Me>ee-L||!x(Ce,Me,G,j,L,ee,!0))return;ge(G,ee,Me,L,Ce,j);let re=1,Oe=1,Be=Me,He=L;const _e=[!1];for(re=1,Be=Me;Be<G;re++,Be++){const ct=ie[Be],gt=ce[Be],Ue=Be+1<G?ce[Be+1]:ee;for(Oe=ct-L+1,He=ct;He<Ue;Oe++,He++){let ot=Number.MIN_SAFE_INTEGER,Z=!1;He<=gt&&(ot=Q(de,Ce,Be,Me,je,j,He,ee,L,ve[re-1][Oe-1]===0,_e));let X=0;ot!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=ot+Se[re-1][Oe-1]);const me=He>ct,qe=me?Se[re][Oe-1]+(ve[re][Oe-1]>0?-5:0):0,we=He>ct+1&&ve[re][Oe-1]>0,at=we?Se[re][Oe-2]+(ve[re][Oe-2]>0?-5:0):0;if(we&&(!me||at>=qe)&&(!Z||at>=X))Se[re][Oe]=at,fe[re][Oe]=3,ve[re][Oe]=0;else if(me&&(!Z||qe>=X))Se[re][Oe]=qe,fe[re][Oe]=2,ve[re][Oe]=0;else if(Z)Se[re][Oe]=X,fe[re][Oe]=1,ve[re][Oe]=ve[re-1][Oe-1]+1;else throw new Error("not possible")}}if($e&&ae(de,Me,je,L),!_e[0]&&!H.firstMatchCanBeWeak)return;re--,Oe--;const xe=[Se[re][Oe],L];let et=0,tt=0;for(;re>=1;){let ct=Oe;do{const gt=fe[re][ct];if(gt===3)ct=ct-2;else if(gt===2)ct=ct-1;else break}while(ct>=1);et>1&&Ce[Me+re-1]===j[L+Oe-1]&&!z(ct+L-1,je,j)&&et+1>ve[re][ct]&&(ct=Oe),ct===Oe?et++:et=1,tt||(tt=ct),re--,Oe=ct-1,xe.push(Oe)}ee-L===G&&H.boostFullMatch&&(xe[0]+=2);const it=tt-G;return xe[0]-=it,xe}function ge(de,Ce,Me,je,j,L){let H=de-1,G=Ce-1;for(;H>=Me&&G>=je;)j[H]===L[G]&&(ce[H]=G,H--),G--}function Q(de,Ce,Me,je,j,L,H,G,ee,re,Oe){if(Ce[Me]!==L[H])return Number.MIN_SAFE_INTEGER;let Be=1,He=!1;return H===Me-je?Be=de[Me]===j[H]?7:5:z(H,j,L)&&(H===0||!z(H-1,j,L))?(Be=de[Me]===j[H]?7:5,He=!0):Re(L,H)&&(H===0||!Re(L,H-1))?Be=5:(Re(L,H-1)||ne(L,H-1))&&(Be=5,He=!0),Be>1&&Me===je&&(Oe[0]=!0),He||(He=z(H,j,L)||Re(L,H-1)||ne(L,H-1)),Me===je?H>ee&&(Be-=He?3:5):re?Be+=He?2:0:Be+=He?0:1,H+1===G&&(Be-=He?3:5),Be}function Y(de,Ce,Me,je,j,L,H){return ue(de,Ce,Me,je,j,L,!0,H)}function he(de,Ce,Me,je,j,L,H){return ue(de,Ce,Me,je,j,L,!1,H)}function ue(de,Ce,Me,je,j,L,H,G){let ee=pe(de,Ce,Me,je,j,L,G);if(ee&&!H)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Oe=Me+1;Oe<re;Oe++){const Be=Ne(de,Oe);if(Be){const He=pe(Be,Be.toLowerCase(),Me,je,j,L,G);He&&(He[0]-=3,(!ee||He[0]>ee[0])&&(ee=He))}}}return ee}function Ne(de,Ce){if(Ce+1>=de.length)return;const Me=de[Ce],je=de[Ce+1];if(Me!==je)return de.slice(0,Ce)+je+Me+de.slice(Ce+2)}}),define(ke[32],Ie([1,0,13]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(O||(O={})),function(M){const N="error",R="warning",p="warn",m="info",E="ignore";function T(l){return l?P.$zf(N,l)?M.Error:P.$zf(R,l)||P.$zf(p,l)?M.Warning:P.$zf(m,l)?M.Info:M.Ignore:M.Ignore}M.fromValue=T;function S(l){switch(l){case M.Error:return N;case M.Warning:return R;case M.Info:return m;default:return E}}M.toString=S}(O||(O={})),e.default=O}),define(ke[136],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ke[54],Ie([1,0,18,13]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),r=this.b.charCodeAt(this.c);return f-r}value(){return this.b[this.c]}}e.$Ai=M;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,O.$tf)(b,this.b,0,b.length,this.c,this.d):(0,O.$vf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=N;class R{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const r=this.b.charCodeAt(f);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,O.$tf)(b,this.b,0,b.length,this.d,this.e):(0,O.$vf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=R;var p;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(p||(p={}));class m{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,O.$uf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,O.$uf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,O.$sf)(b,this.c.query);if(this.d[this.e]===5)return(0,O.$sf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(T||(T={}));class S{static forUris(b=()=>!1,f=()=>!1){return new S(new m(b,f))}static forPaths(b=!1){return new S(new R(void 0,!b))}static forStrings(){return new S(new M)}static forConfigKeys(){return new S(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const r=f.slice(0);(0,P.$Wb)(r);for(const s of r)this.set(s,b)}else{const r=b.slice(0);(0,P.$Wb)(r);for(const s of r)this.set(s[0],s[1])}}set(b,f){const r=this.b.reset(b);let s;this.c||(this.c=new E,this.c.segment=r.value());const o=[];for(s=this.c;;){const i=r.cmp(s.segment);if(i>0)s.left||(s.left=new E,s.left.segment=r.value()),o.push([-1,s]),s=s.left;else if(i<0)s.right||(s.right=new E,s.right.segment=r.value()),o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),s.mid||(s.mid=new E,s.mid.segment=r.value()),o.push([0,s]),s=s.mid;else break}const n=s.value;s.value=f,s.key=b;for(let i=o.length-1;i>=0;i--){const c=o[i][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=o[i][0],g=o[i+1][0];if(t===1&&g===1)o[i][1]=c.rotateLeft();else if(t===-1&&g===-1)o[i][1]=c.rotateRight();else if(t===1&&g===-1)c.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=c.rotateLeft();else if(t===-1&&g===1)c.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=c.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let r=this.c;for(;r;){const s=f.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(f.hasNext())f.next(),r=r.mid;else break}return r}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const r=this.b.reset(b),s=[];let o=this.c;for(;o;){const n=r.cmp(o.segment);if(n>0)s.push([-1,o]),o=o.left;else if(n<0)s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),s.push([0,o]),o=o.mid;else break}if(o){if(f?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:c,segment:u}=n;this.e(n.key,!1),o.key=i,o.value=c,o.segment=u}}else{const n=o.left??o.right;if(s.length>0){const[i,c]=s[s.length-1];switch(i){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=s.length-1;n>=0;n--){const i=s[n][1];i.updateHeight();const c=i.balanceFactor();if(c>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),s[n][1]=i.rotateLeft()):c<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),s[n][1]=i.rotateRight()),n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let r=this.c,s;for(;r;){const o=f.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(f.hasNext())f.next(),s=r.value||s,r=r.mid;else break}return r&&r.value||s}findSuperstr(b){return this.g(b,!1)}g(b,f){const r=this.b.reset(b);let s=this.c;for(;s;){const o=r.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this.h(s.mid):f?s.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,r]of this)b(r,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){b&&(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const r=f.balanceFactor();return r<-1||r>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.$Ei=S}),define(ke[36],Ie([1,0,92]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=M;var O;(function(R){function p(m){return m&&typeof m=="object"&&typeof m.id=="string"}R.isThemeColor=p})(O||(e.ThemeColor=O={}));function M(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function m(n){const i=p.exec(n.id);if(!i)return m(P.$Xj.error);const[,c,u]=i,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}R.asClassNameArray=m;function E(n){return m(n).join(" ")}R.asClassName=E;function T(n){return"."+m(n).join(".")}R.asCSSSelector=T;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}R.isThemeIcon=S;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(n){const i=l.exec(n);if(!i)return;const[,c]=i;return{id:c}}R.fromString=b;function f(n){return{id:n}}R.fromId=f;function r(n,i){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),i&&(c=`${c}~${i}`),{id:c}}R.modify=r;function s(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=s;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=o})(N||(e.ThemeIcon=N={}))}),define(ke[137],Ie([1,0,135,13,36]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=m,e.$Qk=T,e.$Rk=l,e.$Sk=b,e.$Tk=r,e.$Uk=s;const N="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${R.source}`,"g");function m(o){return o.replace(p,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${R.source}`,"g");function T(o){return o.replace(E,n=>`\\${n}`)}const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(o){return o.indexOf(N)===-1?o:o.replace(S,(n,i,c,u)=>c?n:i||u||"")}function b(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(o){f.lastIndex=0;let n="";const i=[];let c=0;for(;;){const u=f.lastIndex,t=f.exec(o),g=o.substring(u,t?.index);if(g.length>0){n+=g;for(let a=0;a<g.length;a++)i.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:i}}function s(o,n,i=!1){const{text:c,iconOffsets:u}=n;if(!u||u.length===0)return(0,P.$Gk)(o,c,i);const t=(0,O.$gf)(c," "),g=c.length-t.length,a=(0,P.$Gk)(o,t,i);if(a)for(const d of a){const w=u[d.start+g]+g;d.start+=w,d.end+=w}return a}}),define(ke[33],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=O;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(M){return P.test(M)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(p){for(let m=0;m<p.length;m++)p[m]=Math.floor(Math.random()*256);return p};const N=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));return function(){M(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let m=0,E="";return E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E}}()}),define(ke[138],Ie([1,0,18,42,33]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=e.$Vt=void 0,e.$Tt=N,e.$Ut=R,e.$Wt=E;function N(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function R(S,l,b){const f={id:(0,M.$Ug)(),name:S,uri:l,data:b};return{asString:async()=>"",asFile:()=>f,value:void 0}}class p{constructor(){this.a=new Map}get size(){let l=0;for(const b of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const b=[...this.a.keys()];return O.Iterable.some(this,([f,r])=>r.asFile())&&b.push("files"),T(m(l),b)}get(l){return this.a.get(this.b(l))?.[0]}append(l,b){const f=this.a.get(l);f?f.push(b):this.a.set(this.b(l),[b])}replace(l,b){this.a.set(this.b(l),[b])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,b]of this.a)for(const f of b)yield[l,f]}b(l){return m(l)}}e.$Vt=p;function m(S){return S.toLowerCase()}function E(S,l){return T(m(S),l.map(m))}function T(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const b=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[f,r,s]=b;return s==="*"?l.some(o=>o.startsWith(r+"/")):!1}e.$Xt=Object.freeze({create:S=>(0,P.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Xt.split(S).filter(l=>!l.startsWith("#"))})}),define(ke[139],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$4t=O;var P;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function O(M){let N=0,R=0,p=0,m=0;for(let E=0,T=M.length;E<T;E++){const S=M.charCodeAt(E);S===13?(N===0&&(R=E),N++,E+1<T&&M.charCodeAt(E+1)===10?(m|=2,E++):m|=3,p=E+1):S===10&&(m|=1,N===0&&(R=E),N++,p=E+1)}return N===0&&(R=M.length),[N,R,M.length-p,m]}}),define(ke[140],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$7s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[141],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$nu=e.IndentAction=void 0;var P;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let m=0,E=p.notIn.length;m<E;m++)switch(p.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,m){if(p.getTokenCount()===0)return!0;const E=p.findTokenIndexAtOffset(m-2),T=p.getStandardTokenType(E);return this.isOK(T)}g(p,m){for(let E=p;E<=m;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$nu=O;class M{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of p)N(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),N(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),N(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),N(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&N(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$ou=M;function N(R,p,m){R.has(p)?R.get(p).push(m):R.set(p,[m])}}),define(ke[142],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.NodeColor=e.$IC=void 0,e.$KC=M,e.$LC=N,e.$MC=E,e.$NC=T,e.$OC=S,e.$PC=l,e.$QC=b,e.$RC=f;class P{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$JC)return M(this.right);let s=this;for(;s.parent!==e.$JC&&s.parent.left!==s;)s=s.parent;return s.parent===e.$JC?e.$JC:s.parent}prev(){if(this.left!==e.$JC)return N(this.left);let s=this;for(;s.parent!==e.$JC&&s.parent.right!==s;)s=s.parent;return s.parent===e.$JC?e.$JC:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$IC=P;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$JC=new P(null,0),e.$JC.parent=e.$JC,e.$JC.left=e.$JC,e.$JC.right=e.$JC,e.$JC.color=0;function M(r){for(;r.left!==e.$JC;)r=r.left;return r}function N(r){for(;r.right!==e.$JC;)r=r.right;return r}function R(r){return r===e.$JC?0:r.size_left+r.piece.length+R(r.right)}function p(r){return r===e.$JC?0:r.lf_left+r.piece.lineFeedCnt+p(r.right)}function m(){e.$JC.parent=e.$JC}function E(r,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$JC&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$JC?r.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function T(r,s){const o=s.left;s.left=o.right,o.right!==e.$JC&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$JC?r.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function S(r,s){let o,n;if(s.left===e.$JC?(n=s,o=n.right):s.right===e.$JC?(n=s,o=n.left):(n=M(s.right),o=n.right),n===r.root){r.root=o,o.color=0,s.detach(),m(),r.root.parent=e.$JC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===s?(o.parent=n.parent,f(r,o)):(n.parent===s?o.parent=n:o.parent=n.parent,f(r,o),n.left=s.left,n.right=s.right,n.parent=s.parent,n.color=s.color,s===r.root?r.root=n:s===s.parent.left?s.parent.left=n:s.parent.right=n,n.left!==e.$JC&&(n.left.parent=n),n.right!==e.$JC&&(n.right.parent=n),n.size_left=s.size_left,n.lf_left=s.lf_left,f(r,n)),s.detach(),o.parent.left===o){const u=R(o),t=p(o);if(u!==o.parent.size_left||t!==o.parent.lf_left){const g=u-o.parent.size_left,a=t-o.parent.lf_left;o.parent.size_left=u,o.parent.lf_left=t,b(r,o.parent,g,a)}}if(f(r,o.parent),i){m();return}let c;for(;o!==r.root&&o.color===0;)o===o.parent.left?(c=o.parent.right,c.color===1&&(c.color=0,o.parent.color=1,E(r,o.parent),c=o.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(r,c),c=o.parent.right),c.color=o.parent.color,o.parent.color=0,c.right.color=0,E(r,o.parent),o=r.root)):(c=o.parent.left,c.color===1&&(c.color=0,o.parent.color=1,T(r,o.parent),c=o.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(r,c),c=o.parent.left),c.color=o.parent.color,o.parent.color=0,c.left.color=0,T(r,o.parent),o=r.root));o.color=0,m()}function l(r,s){for(f(r,s);s!==r.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,E(r,s)),s.parent.color=0,s.parent.parent.color=1,T(r,s.parent.parent))}else{const o=s.parent.parent.left;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,T(r,s)),s.parent.color=0,s.parent.parent.color=1,E(r,s.parent.parent))}r.root.color=0}function b(r,s,o,n){for(;s!==r.root&&s!==e.$JC;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=n),s=s.parent}function f(r,s){let o=0,n=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,o=R(s.left)-s.size_left,n=p(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=n;s!==r.root&&(o!==0||n!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=n),s=s.parent}}}),define(ke[93],Ie([1,0,94,30,95,142,96]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=void 0,e.$YC=T,e.$ZC=S;const p=65535;function m(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class E{constructor(n,i,c,u,t){this.lineStarts=n,this.cr=i,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function T(o,n=!0){const i=[0];let c=1;for(let u=0,t=o.length;u<t;u++){const g=o.charCodeAt(u);g===13?u+1<t&&o.charCodeAt(u+1)===10?(i[c++]=u+2,u++):i[c++]=u+1:g===10&&(i[c++]=u+1)}return n?m(i):i}function S(o,n){o.length=0,o[0]=0;let i=1,c=0,u=0,t=0,g=!0;for(let d=0,w=n.length;d<w;d++){const $=n.charCodeAt(d);$===13?d+1<w&&n.charCodeAt(d+1)===10?(t++,o[i++]=d+2,d++):(c++,o[i++]=d+1):$===10?(u++,o[i++]=d+1):g&&$!==9&&($<32||$>126)&&(g=!1)}const a=new E(m(o),c,u,t,g);return o.length=0,a}class l{constructor(n,i,c,u,t){this.bufferIndex=n,this.start=i,this.end=c,this.lineFeedCnt=u,this.length=t}}e.$1C=l;class b{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$2C=b;class f{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==N.$JC&&n.iterate(n.root,c=>(c!==N.$JC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const c=this.b;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=n){c[u]=null,i=!0;continue}}if(i){const u=[];for(const t of c)t!==null&&u.push(t);this.b=u}}}class s{constructor(n,i,c){this.create(n,i,c)}create(n,i,c){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$JC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=c;let u=null;for(let t=0,g=n.length;t<g;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=T(n[t].buffer));const a=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),u=this.S(u,a)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=p,c=i-Math.floor(i/3),u=c*2;let t="",g=0;const a=[];if(this.iterate(this.root,d=>{const w=this.R(d),$=w.length;if(g<=c||g+$<u)return t+=w,g+=$,!0;const v=t.replace(/\r\n|\r|\n/g,n);return a.push(new b(v,T(v))),t=w,g=$,!0}),g>0){const d=t.replace(/\r\n|\r|\n/g,n);a.push(new b(d,T(d)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new f(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,u=>{if(u===N.$JC)return!0;const t=this.R(u),g=t.length,a=n.G(i),d=n.G(i+g),w=n.getValueInRange2(a,d);return i+=g,t===w})}getOffsetAt(n,i){let c=0,u=this.root;for(;u!==N.$JC;)if(u.left!==N.$JC&&u.lf_left+1>=n)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=n){c+=u.size_left;const t=this.B(u,n-u.lf_left-2);return c+=t+i-1}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,c=0;const u=n;for(;i!==N.$JC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(c+=i.lf_left+t.index,t.index===0){const g=this.getOffsetAt(c+1,1),a=u-g;return new P.$wt(c+1,a+1)}return new P.$wt(c+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,c+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$JC){const t=this.getOffsetAt(c+1,1),g=u-n-t;return new P.$wt(c+1,g+1)}else i=i.right;return new P.$wt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),u=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,u);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const a=n.node,d=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);return d.substring(w+n.remainder,w+i.remainder)}let c=n.node;const u=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let g=u.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==N.$JC;){const a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===i.node){g+=a.substring(d,d+i.remainder);break}else g+=a.substr(d,c.piece.length);c=c.next()}return g}getLinesContent(){const n=[];let i=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===N.$JC)return!0;const g=t.piece;let a=g.length;if(a===0)return!0;const d=this.a[g.bufferIndex].buffer,w=this.a[g.bufferIndex].lineStarts,$=g.start.line,v=g.end.line;let y=w[$]+g.start.column;if(u&&(d.charCodeAt(y)===10&&(y++,a--),n[i++]=c,c="",u=!1,a===0))return!0;if($===v)return!this.f&&d.charCodeAt(y+a-1)===13?(u=!0,c+=d.substr(y,a-1)):c+=d.substr(y,a),!0;c+=this.f?d.substring(y,Math.max(y,w[$+1]-this.e)):d.substring(y,w[$+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;for(let h=$+1;h<v;h++)c=this.f?d.substring(w[h],w[h+1]-this.e):d.substring(w[h],w[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;return!this.f&&d.charCodeAt(w[v]+g.end.column-1)===13?(u=!0,g.end.column===0?i--:c=d.substr(w[v],g.end.column-1)):c=d.substr(w[v],g.end.column),!0}),u&&(n[i++]=c,c=""),n[i++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const c=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start);return c.buffer.charCodeAt(u)}else{const i=this.a[n.node.piece.bufferIndex],u=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(u)}}getLineCharCode(n,i){const c=this.H(n,i+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,c,u,t,g,a,d,w,$,v){const y=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),D=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,g);let C;const I={line:0,column:0};let W,V;i._wordSeparators?(W=y.buffer.substring(D,k),V=q=>q+D,i.reset(0)):(W=y.buffer,V=q=>q,i.reset(D));do if(C=i.next(W),C){if(V(C.index)>=k)return $;this.s(n,V(C.index)-h,I);const q=this.t(n.piece.bufferIndex,t,I),A=I.line===t.line?I.column-t.column+u:I.column+1,B=A+C[0].length;if(v[$++]=(0,R.$UC)(new O.$xt(c+q,A,c+q,B),C,d),V(C.index)+C[0].length>=k||$>=w)return $}while(C);return $}findMatchesLineByLine(n,i,c,u){const t=[];let g=0;const a=new R.$XC(i.wordSeparators,i.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const w=this.H(n.endLineNumber,n.endColumn);if(w===null)return[];let $=this.s(d.node,d.remainder);const v=this.s(w.node,w.remainder);if(d.node===w.node)return this.findMatchesInNode(d.node,a,n.startLineNumber,n.startColumn,$,v,i,c,u,g,t),t;let y=n.startLineNumber,h=d.node;for(;h!==w.node;){const k=this.t(h.piece.bufferIndex,$,h.piece.end);if(k>=1){const I=this.a[h.piece.bufferIndex].lineStarts,W=this.u(h.piece.bufferIndex,h.piece.start),V=I[$.line+k],q=y===n.startLineNumber?n.startColumn:1;if(g=this.findMatchesInNode(h,a,y,q,$,this.s(h,V-W),i,c,u,g,t),g>=u)return t;y+=k}const C=y===n.startLineNumber?n.startColumn-1:0;if(y===n.endLineNumber){const I=this.getLineContent(y).substring(C,n.endColumn-1);return g=this.n(i,a,I,n.endLineNumber,C,g,t,c,u),t}if(g=this.n(i,a,this.getLineContent(y).substr(C),y,C,g,t,c,u),g>=u)return t;y++,d=this.H(y,1),h=d.node,$=this.s(d.node,d.remainder)}if(y===n.endLineNumber){const k=y===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(y).substring(k,n.endColumn-1);return g=this.n(i,a,C,n.endLineNumber,k,g,t,c,u),t}const D=y===n.startLineNumber?n.startColumn:1;return g=this.findMatchesInNode(w.node,a,y,D,$,v,i,c,u,g,t),t}n(n,i,c,u,t,g,a,d,w){const $=n.wordSeparators;if(!d&&n.simpleSearch){const y=n.simpleSearch,h=y.length,D=c.length;let k=-h;for(;(k=c.indexOf(y,k+h))!==-1;)if((!$||(0,R.$WC)($,c,D,k,h))&&(a[g++]=new M.$Iv(new O.$xt(u,k+1+t,u,k+1+h+t),null),g>=w))return g;return g}let v;i.reset(0);do if(v=i.next(c),v&&(a[g++]=(0,R.$UC)(new O.$xt(u,v.index+1+t,u,v.index+1+v[0].length+t),v,d),g>=w))return g;while(v);return g}insert(n,i,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==N.$JC){const{node:u,remainder:t,nodeStartOffset:g}=this.G(n),a=u.piece,d=a.bufferIndex,w=this.s(u,t);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&g+a.length===n&&i.length<p){this.F(u,i),this.y();return}if(g===n)this.o(i,u),this.h.validate(n);else if(g+u.piece.length>n){const $=[];let v=new l(a.bufferIndex,w,a.end,this.t(a.bufferIndex,w,a.end),this.u(d,a.end)-this.u(d,w));if(this.K()&&this.M(i)&&this.I(u,t)===10){const k={line:v.start.line+1,column:0};v=new l(v.bufferIndex,k,v.end,this.t(v.bufferIndex,k,v.end),v.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(u,t-1)===13){const k=this.s(u,t-1);this.C(u,k),i="\r"+i,u.piece.length===0&&$.push(u)}else this.C(u,w);else this.C(u,w);const y=this.w(i);v.length>0&&this.S(u,v);let h=u;for(let D=0;D<y.length;D++)h=this.S(h,y[D]);this.v($)}else this.q(i,u)}else{const u=this.w(i);let t=this.T(null,u[0]);for(let g=1;g<u.length;g++)t=this.S(t,u[g])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$JC)return;const c=this.G(n),u=this.G(n+i),t=c.node,g=u.node;if(t===g){const y=this.s(t,c.remainder),h=this.s(t,u.remainder);if(c.nodeStartOffset===n){if(i===t.piece.length){const D=t.next();(0,N.$OC)(this,t),this.N(D),this.y();return}this.D(t,h),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+i){this.C(t,y),this.O(t),this.y();return}this.E(t,y,h),this.y();return}const a=[],d=this.s(t,c.remainder);this.C(t,d),this.h.validate(n),t.piece.length===0&&a.push(t);const w=this.s(g,u.remainder);this.D(g,w),g.piece.length===0&&a.push(g);const $=t.next();for(let y=$;y!==N.$JC&&y!==g;y=y.next())a.push(y);const v=t.piece.length===0?t.prev():t;this.v(a),this.O(v),this.y()}o(n,i){const c=[];if(this.K()&&this.M(n)&&this.L(i)){const g=i.piece,a={line:g.start.line+1,column:0},d=new l(g.bufferIndex,a,g.end,this.t(g.bufferIndex,a,g.end),g.length-1);i.piece=d,n+=`
`,(0,N.$QC)(this,i,-1,-1),i.piece.length===0&&c.push(i)}const u=this.w(n);let t=this.T(i,u[u.length-1]);for(let g=u.length-2;g>=0;g--)t=this.T(t,u[g]);this.N(t),this.v(c)}q(n,i){this.Q(n,i)&&(n+=`
`);const c=this.w(n),u=this.S(i,c[0]);let t=u;for(let g=1;g<c.length;g++)t=this.S(t,c[g]);this.N(u)}s(n,i,c){const u=n.piece,t=n.piece.bufferIndex,g=this.a[t].lineStarts,d=g[u.start.line]+u.start.column+i;let w=u.start.line,$=u.end.line,v=0,y=0,h=0;for(;w<=$&&(v=w+($-w)/2|0,h=g[v],v!==$);)if(y=g[v+1],d<h)$=v-1;else if(d>=y)w=v+1;else break;return c?(c.line=v,c.column=d-h,null):{line:v,column:d-h}}t(n,i,c){if(c.column===0)return c.line-i.line;const u=this.a[n].lineStarts;if(c.line===u.length-1)return c.line-i.line;const t=u[c.line+1],g=u[c.line]+c.column;if(t>g+1)return c.line-i.line;const a=g-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-i.line+1:c.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,N.$OC)(this,n[i])}w(n){if(n.length>p){const $=[];for(;n.length>p;){const y=n.charCodeAt(p-1);let h;y===13||y>=55296&&y<=56319?(h=n.substring(0,p-1),n=n.substring(p-1)):(h=n.substring(0,p),n=n.substring(p));const D=T(h);$.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:h.length-D[D.length-1]},D.length-1,h.length)),this.a.push(new b(h,D))}const v=T(n);return $.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:n.length-v[v.length-1]},v.length-1,n.length)),this.a.push(new b(n,v)),$}let i=this.a[0].buffer.length;const c=T(n,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let $=0;$<c.length;$++)c[$]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let $=0;$<c.length;$++)c[$]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[g],d={line:g,column:a},w=new l(0,u,d,this.t(0,u,d),t-i);return this.g=d,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let c=this.root,u="";const t=this.h.get2(n);if(t){c=t.node;const g=this.B(c,n-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)u=a.substring(d+g,d+c.piece.length);else{const w=this.B(c,n-t.nodeStartLineNumber);return a.substring(d+g,d+w-i)}}else{let g=0;const a=n;for(;c!==N.$JC;)if(c.left!==N.$JC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),w=this.B(c,n-c.lf_left-1),$=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return g+=c.size_left,this.h.set({node:c,nodeStartOffset:g,nodeStartLineNumber:a-(n-1-c.lf_left)}),$.substring(v+d,v+w-i)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),w=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);u=w.substring($+d,$+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,g+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==N.$JC;){const g=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return u+=g.substring(d,d+a-i),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=g.substr(a,c.piece.length)}c=c.next()}return u}y(){let n=this.root,i=1,c=0;for(;n!==N.$JC;)i+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=c,this.h.validate(this.c)}A(n,i){const c=n.piece,u=this.s(n,i),t=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===i){const g=this.t(n.piece.bufferIndex,c.start,u);if(g!==t)return{index:g,remainder:0}}return{index:t,remainder:u.column}}B(n,i){if(i<0)return 0;const c=n.piece,u=this.a[c.bufferIndex].lineStarts,t=c.start.line+i+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}C(n,i){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),g=i,a=this.u(c.bufferIndex,g),d=this.t(c.bufferIndex,c.start,g),w=d-u,$=a-t,v=c.length+$;n.piece=new l(c.bufferIndex,c.start,g,d,v),(0,N.$QC)(this,n,$,w)}D(n,i){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),g=i,a=this.t(c.bufferIndex,g,c.end),d=this.u(c.bufferIndex,g),w=a-u,$=t-d,v=c.length+$;n.piece=new l(c.bufferIndex,g,c.end,a,v),(0,N.$QC)(this,n,$,w)}E(n,i,c){const u=n.piece,t=u.start,g=u.end,a=u.length,d=u.lineFeedCnt,w=i,$=this.t(u.bufferIndex,u.start,w),v=this.u(u.bufferIndex,i)-this.u(u.bufferIndex,t);n.piece=new l(u.bufferIndex,u.start,w,$,v),(0,N.$QC)(this,n,v-a,$-d);const y=new l(u.bufferIndex,c,g,this.t(u.bufferIndex,c,g),this.u(u.bufferIndex,g)-this.u(u.bufferIndex,c)),h=this.S(n,y);this.N(h)}F(n,i){this.Q(i,n)&&(i+=`
`);const c=this.K()&&this.L(i)&&this.M(n),u=this.a[0].buffer.length;this.a[0].buffer+=i;const t=T(i,!1);for(let h=0;h<t.length;h++)t[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const g=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[g],d={line:g,column:a},w=n.piece.length+i.length,$=n.piece.lineFeedCnt,v=this.t(0,n.piece.start,d),y=v-$;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,v,w),this.g=d,(0,N.$QC)(this,n,i.length,y)}G(n){let i=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let u=0;for(;i!==N.$JC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){u+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:u};return this.h.set(t),t}else n-=i.size_left+i.piece.length,u+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let c=this.root,u=0;for(;c!==N.$JC;)if(c.left!==N.$JC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),g=this.B(c,n-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+i-1,g),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+i-1<=c.piece.length)return{node:c,remainder:t+i-1,nodeStartOffset:u};i-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==N.$JC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),g=this.J(c);return{node:c,remainder:Math.min(i-1,t),nodeStartOffset:g}}else if(c.piece.length>=i-1){const t=this.J(c);return{node:c,remainder:i-1,nodeStartOffset:t}}else i-=c.piece.length;c=c.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start)+i;return c.buffer.charCodeAt(u)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$JC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,c=this.a[i.bufferIndex].lineStarts,u=i.start.line,t=c[u]+i.start.column;return u===c.length-1||c[u+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$JC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const c=[],u=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:u[n.piece.end.line]-u[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const g=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,a,g),(0,N.$QC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:i.piece.start.line+1,column:0},w=i.piece.length-1,$=this.t(i.piece.bufferIndex,d,i.piece.end);i.piece=new l(i.piece.bufferIndex,d,i.piece.end,$,w),(0,N.$QC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const v=this.w(`\r
`);this.S(n,v[0]);for(let y=0;y<c.length;y++)(0,N.$OC)(this,c[y])}Q(n,i){if(this.K()&&this.M(n)){const c=i.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,N.$OC)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},g=u.length-1,a=this.t(u.bufferIndex,t,u.end);c.piece=new l(u.bufferIndex,t,u.end,a,g),(0,N.$QC)(this,c,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.$JC)return i(N.$JC);const c=this.iterate(n.left,i);return c&&i(n)&&this.iterate(n.right,i)}R(n){if(n===N.$JC)return"";const i=this.a[n.piece.bufferIndex],c=n.piece,u=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return i.buffer.substring(u,t)}getPieceContent(n){const i=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),u=this.u(n.bufferIndex,n.end);return i.buffer.substring(c,u)}S(n,i){const c=new N.$IC(i,1);if(c.left=N.$JC,c.right=N.$JC,c.parent=N.$JC,c.size_left=0,c.lf_left=0,this.root===N.$JC)this.root=c,c.color=0;else if(n.right===N.$JC)n.right=c,c.parent=n;else{const t=(0,N.$KC)(n.right);t.left=c,c.parent=t}return(0,N.$PC)(this,c),c}T(n,i){const c=new N.$IC(i,1);if(c.left=N.$JC,c.right=N.$JC,c.parent=N.$JC,c.size_left=0,c.lf_left=0,this.root===N.$JC)this.root=c,c.color=0;else if(n.left===N.$JC)n.left=c,c.parent=n;else{const u=(0,N.$LC)(n.left);u.right=c,c.parent=u}return(0,N.$PC)(this,c),c}U(n){let i="";return this.iterate(n,c=>(i+=this.R(c),!0)),i}}e.$3C=s}),define(ke[143],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0=e.$G0=void 0;class P{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$G0=P;class O{constructor(N){this.identifier=N}}e.$H0=O}),define(ke[144],Ie([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[145],Ie([1,0,5,6,144]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=void 0,e.$ij=T;class N extends O.$Uc{constructor(l,b="",f="",r=!0,s){super(),this.h=this.B(new P.$fe),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=b,this.u=f,this.w=r,this.C=s}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,b){this.C&&await this.C(l)}}e.$dj=N;class R extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new P.$fe),this.onWillRun=this.f.event,this.m=this.B(new P.$fe),this.onDidRun=this.m.event}async run(l,b){if(!l.enabled)return;this.f.fire({action:l});let f;try{await this.u(l,b)}catch(r){f=r}this.m.fire({action:l,error:f})}async u(l,b){await l.run(b)}}e.$ej=R;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let b=[];for(const f of l)f.length&&(b.length?b=[...b,new p,...f]:b=f);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$fj=p;class m{get actions(){return this.a}constructor(l,b,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=b,this.class=r,this.a=f}async run(){}}e.$gj=m;class E extends N{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,M.localize(0,null),void 0,!1)}}e.$hj=E;function T(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...l)=>S.run(...l),tooltip:S.label}}}),define(ke[146],Ie([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[147],Ie([1,0,146]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=E,e.$5m=T,e.$6m=S;const O=60,M=O*60,N=M*24,R=N*7,p=N*30,m=N*365;function E(l,b,f,r){typeof l!="number"&&(l=l.getTime());const s=Math.round((new Date().getTime()-l)/1e3);if(s<-30)return(0,P.localize)(0,null,E(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,P.localize)(1,null);let o;return s<O?(o=s,b?o===1?f?(0,P.localize)(2,null,o):(0,P.localize)(3,null,o):f?(0,P.localize)(4,null,o):(0,P.localize)(5,null,o):o===1?f?(0,P.localize)(6,null,o):(0,P.localize)(7,null,o):f?(0,P.localize)(8,null,o):(0,P.localize)(9,null,o)):s<M?(o=Math.floor(s/O),b?o===1?f?(0,P.localize)(10,null,o):(0,P.localize)(11,null,o):f?(0,P.localize)(12,null,o):(0,P.localize)(13,null,o):o===1?f?(0,P.localize)(14,null,o):(0,P.localize)(15,null,o):f?(0,P.localize)(16,null,o):(0,P.localize)(17,null,o)):s<N?(o=Math.floor(s/M),b?o===1?f?(0,P.localize)(18,null,o):(0,P.localize)(19,null,o):f?(0,P.localize)(20,null,o):(0,P.localize)(21,null,o):o===1?f?(0,P.localize)(22,null,o):(0,P.localize)(23,null,o):f?(0,P.localize)(24,null,o):(0,P.localize)(25,null,o)):s<R?(o=Math.floor(s/N),b?o===1?(0,P.localize)(26,null,o):(0,P.localize)(27,null,o):o===1?(0,P.localize)(28,null,o):(0,P.localize)(29,null,o)):s<p?(o=Math.floor(s/R),b?o===1?f?(0,P.localize)(30,null,o):(0,P.localize)(31,null,o):f?(0,P.localize)(32,null,o):(0,P.localize)(33,null,o):o===1?f?(0,P.localize)(34,null,o):(0,P.localize)(35,null,o):f?(0,P.localize)(36,null,o):(0,P.localize)(37,null,o)):s<m?(o=Math.floor(s/p),b?o===1?f?(0,P.localize)(38,null,o):(0,P.localize)(39,null,o):f?(0,P.localize)(40,null,o):(0,P.localize)(41,null,o):o===1?f?(0,P.localize)(42,null,o):(0,P.localize)(43,null,o):f?(0,P.localize)(44,null,o):(0,P.localize)(45,null,o)):(o=Math.floor(s/m),b?o===1?f?(0,P.localize)(46,null,o):(0,P.localize)(47,null,o):f?(0,P.localize)(48,null,o):(0,P.localize)(49,null,o):o===1?f?(0,P.localize)(50,null,o):(0,P.localize)(51,null,o):f?(0,P.localize)(52,null,o):(0,P.localize)(53,null,o))}function T(l,b){const f=Math.abs(l/1e3);return f<1?b?(0,P.localize)(54,null,l):(0,P.localize)(55,null,l):f<O?b?(0,P.localize)(56,null,Math.round(l)/1e3):(0,P.localize)(57,null,Math.round(l)/1e3):f<M?b?(0,P.localize)(58,null,Math.round(l/(1e3*O))):(0,P.localize)(59,null,Math.round(l/(1e3*O))):f<N?b?(0,P.localize)(60,null,Math.round(l/(1e3*M))):(0,P.localize)(61,null,Math.round(l/(1e3*M))):(0,P.localize)(62,null,Math.round(l/(1e3*N)))}function S(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[148],Ie([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[44],Ie([1,0,18,15,148]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=m,e.$kj=E,e.$lj=T;function N(S,l){return l&&(S.stack||S.stacktrace)?M.localize(0,null,p(S),R(S.stack)||R(S.stacktrace)):p(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function p(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?M.localize(1,null,S.message):S.message||M.localize(2,null)}function m(S=null,l=!1){if(!S)return M.localize(3,null);if(Array.isArray(S)){const b=P.$Hb(S),f=m(b[0],l);return b.length>1?M.localize(4,null,f,b.length):f}if(O.$$f(S))return S;if(S.detail){const b=S.detail;if(b.error)return N(b.error,l);if(b.exception)return N(b.exception,l)}return S.stack?N(S,l):S.message?S.message:M.localize(5,null)}function E(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}function T(S,l){let b;return typeof S=="string"?b=new Error(S):b=S,b.actions=l,b}}),define(ke[149],Ie([1,0,43,19]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=p,e.$kr=m,e.$lr=E,e.$mr=T,e.$nr=S,e.$or=l,e.$pr=b,e.$qr=f,e.$rr=r,e.$sr=s,e.$tr=w,e.$ur=$,e.$vr=v;const M=new P.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),N=new P.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new P.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(y,h,D=!1){const k=y||"",C=h||"",I=M.value.collator.compare(k,C);return M.value.collatorIsNumeric&&I===0&&k!==C?k<C?-1:1:I}function m(y,h){const D=N.value.collator;return y=y||"",h=h||"",c(D,y,h)}function E(y,h){const D=N.value.collator;return y=y||"",h=h||"",a(y,h)||c(D,y,h)}function T(y,h){const D=N.value.collator;return y=y||"",h=h||"",g(y,h)||c(D,y,h)}function S(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function l(y,h){const[D,k]=n(y),[C,I]=n(h);let W=M.value.collator.compare(k,I);if(W===0){if(M.value.collatorIsNumeric&&k!==I)return k<I?-1:1;if(W=M.value.collator.compare(D,C),M.value.collatorIsNumeric&&W===0&&D!==C)return D<C?-1:1}return W}function b(y,h){y=y||"",h=h||"";const D=i(y),k=i(h),C=N.value.collator,I=R.value.collator;return c(I,D,k)||c(C,y,h)}function f(y,h){y=y||"",h=h||"";const D=i(y),k=i(h),C=N.value.collator,I=R.value.collator;return c(I,D,k)||a(y,h)||c(C,y,h)}function r(y,h){y=y||"",h=h||"";const D=i(y),k=i(h),C=N.value.collator,I=R.value.collator;return c(I,D,k)||g(y,h)||c(C,y,h)}function s(y,h){y=y||"",h=h||"";const D=i(y).toLowerCase(),k=i(h).toLowerCase();return D!==k?D<k?-1:1:y!==h?y<h?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(y,h=!1){const D=y?o.exec(y):[];let k=[D&&D[1]||"",D&&D[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(y){const h=y?o.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,D){const k=y.compare(h,D);return k!==0?k:h.length!==D.length?h.length<D.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function t(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function g(y,h){return u(y)&&t(h)?-1:t(y)&&u(h)?1:0}function a(y,h){return t(y)&&u(h)?-1:u(y)&&t(h)?1:0}function d(y,h,D=!1){return D||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function w(y,h,D=!1){const k=y.split(O.sep),C=h.split(O.sep),I=k.length-1,W=C.length-1;let V,q;for(let A=0;;A++){if(V=I===A,q=W===A,V&&q)return p(k[A],C[A],D);if(V)return-1;if(q)return 1;const B=d(k[A],C[A],D);if(B!==0)return B}}function $(y,h,D){const k=y.toLowerCase(),C=h.toLowerCase(),I=v(y,h,D);if(I)return I;const W=k.endsWith(D),V=C.endsWith(D);if(W!==V)return W?-1:1;const q=p(k,C);return q!==0?q:k.localeCompare(C)}function v(y,h,D){const k=y.toLowerCase(),C=h.toLowerCase(),I=k.startsWith(D),W=C.startsWith(D);if(I!==W)return I?-1:1;if(I&&W){if(k.length<C.length)return-1;if(k.length>C.length)return 1}return 0}}),define(ke[48],Ie([1,0,19,23,13,15]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=R,e.$rg=p,e.$sg=m,e.$tg=E,e.$ug=T,e.$vg=f,e.$wg=r,e.$xg=s,e.$yg=o,e.$zg=n,e.$Ag=i,e.$Bg=c,e.$Cg=u,e.$Dg=t,e.$Eg=g,e.$Fg=a,e.$Gg=$;function R(v){return v===47||v===92}function p(v){return v.replace(/[\\/]/g,P.$gc.sep)}function m(v){return v.indexOf("/")===-1&&(v=p(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function E(v,y=P.$gc.sep){if(!v)return"";const h=v.length,D=v.charCodeAt(0);if(R(D)){if(R(v.charCodeAt(1))&&!R(v.charCodeAt(2))){let C=3;const I=C;for(;C<h&&!R(v.charCodeAt(C));C++);if(I!==C&&!R(v.charCodeAt(C+1))){for(C+=1;C<h;C++)if(R(v.charCodeAt(C)))return v.slice(0,C+1).replace(/[\\/]/g,y)}}return y}else if(o(D)&&v.charCodeAt(1)===58)return R(v.charCodeAt(2))?v.slice(0,2)+y:v.slice(0,2);let k=v.indexOf("://");if(k!==-1){for(k+=3;k<h;k++)if(R(v.charCodeAt(k)))return v.slice(0,k+1)}return""}function T(v){if(!O.$i||!v||v.length<5)return!1;let y=v.charCodeAt(0);if(y!==92||(y=v.charCodeAt(1),y!==92))return!1;let h=2;const D=h;for(;h<v.length&&(y=v.charCodeAt(h),y!==92);h++);return!(D===h||(y=v.charCodeAt(h+1),isNaN(y)||y===92))}const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(v,y=O.$i){const h=y?S:l;return!(!v||v.length===0||/^\s+$/.test(v)||(h.lastIndex=0,h.test(v))||y&&b.test(v)||v==="."||v===".."||y&&v[v.length-1]==="."||y&&v.length!==v.trim().length||v.length>255)}function r(v,y,h){const D=v===y;return!h||D?D:!v||!y?!1:(0,M.$zf)(v,y)}function s(v,y,h,D=P.sep){if(v===y)return!0;if(!v||!y||y.length>v.length)return!1;if(h){if(!(0,M.$Af)(v,y))return!1;if(y.length===v.length)return!0;let C=y.length;return y.charAt(y.length-1)===D&&C--,v.charAt(C)===D}return y.charAt(y.length-1)!==D&&(y+=D),v.indexOf(y)===0}function o(v){return v>=65&&v<=90||v>=97&&v<=122}function n(v,y){return O.$i&&v.endsWith(":")&&(v+=P.sep),(0,P.$ic)(v)||(v=(0,P.$jc)(y,v)),v=(0,P.$hc)(v),i(v)}function i(v){return O.$i?(v=(0,M.$hf)(v,P.sep),v.endsWith(":")&&(v+=P.sep)):(v=(0,M.$hf)(v,P.sep),v||(v=P.sep)),v}function c(v){const y=(0,P.$hc)(v);return O.$i?v.length>3?!1:u(y)&&(v.length===2||y.charCodeAt(2)===92):y===P.$gc.sep}function u(v,y=O.$i){return y?o(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function t(v,y=O.$i){return u(v,y)?v[0]:void 0}function g(v,y,h){return y.length>v.length?-1:v===y?0:(h&&(v=v.toLowerCase(),y=y.toLowerCase()),v.indexOf(y))}function a(v){const y=v.split(":");let h,D,k;for(const C of y){const I=Number(C);(0,N.$cg)(I)?D===void 0?D=I:k===void 0&&(k=I):h=h?[h,C].join(":"):C}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(v,y,h=8){let D="";for(let C=0;C<h;C++){let I;C===0&&O.$i&&!y&&(h===3||h===4)?I=w:I=d,D+=I.charAt(Math.floor(Math.random()*I.length))}let k;return y?k=`${y}-${D}`:k=D,v?(0,P.$jc)(v,k):k}}),define(ke[70],Ie([1,0,19]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0,e.$Us=N,e.$Vs=R,e.$Ws=p,e.$Xs=E,e.$Ts=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(T){const S=(0,P.$oc)(T),l=O[S.toLowerCase()];return l!==void 0?l:R(T)}function R(T){const S=(0,P.$oc)(T);return M[S.toLowerCase()]}function p(T){for(const S in M)if(M[S]===T)return S}const m=/^(.+)\/(.+?)(;.+)?$/;function E(T,S){const l=m.exec(T);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:T}}),define(ke[49],Ie([1,0,22,2]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=M,e.$7h=N,e.$8h=p;function M(m){return JSON.stringify(m,R)}function N(m){let E=JSON.parse(m);return E=p(E),E}function R(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function p(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof P.$He||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let T=0;T<m.length;++T)m[T]=p(m[T],E+1);else for(const T in m)Object.hasOwnProperty.call(m,T)&&(m[T]=p(m[T],E+1))}return m}}),define(ke[16],Ie([1,0,14,23,13,2,19]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=m,e.$Ig=E,e.$Mg=S;var p;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(p||(e.Schemas=p={}));function m(f,r){return N.URI.isUri(f)?(0,M.$zf)(f.scheme,r):(0,M.$Af)(f,r+":")}function E(f,...r){return r.some(s=>m(f,s))}e.$Jg="vscode-tkn",e.$Kg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,s){this.f=S(r,s)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,p.vscodeRemoteResource)}set(r,s,o){this.a[r]=s,this.b[r]=o}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(u){return P.$1(u),r}const s=r.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[s],i=this.c[s];let c=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(c+=`&${e.$Kg}=${encodeURIComponent(i)}`),N.URI.from({scheme:O.$o?this.d:p.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:c})}}e.$Lg=new T;function S(f,r){return R.$gc.join(r??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class l{static{this.a=e.$Rg}asBrowserUri(r){const s=this.b(r,le);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===p.vscodeRemote?e.$Lg.rewrite(r):r.scheme===p.file&&(O.$m||O.$q===`${p.vscodeFileResource}://${l.a}`)?r.with({scheme:p.vscodeFileResource,authority:r.authority||l.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,le);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===p.vscodeFileResource?r.with({scheme:p.file,authority:r.authority!==l.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return N.URI.isUri(r)?r:N.URI.parse(s.toUrl(r))}}e.$Sg=new l;var b;(function(f){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function o(i){let c;typeof i=="string"?c=new URL(i).searchParams:i instanceof URL?c=i.searchParams:N.URI.isUri(i)&&(c=new URL(i.toString(!0)).searchParams);const u=c?.get(s);if(u)return r.get(u)}f.getHeadersFromQuery=o;function n(i,c,u){if(!globalThis.crossOriginIsolated)return;const t=c&&u?"3":u?"2":"1";i instanceof URLSearchParams?i.set(s,t):i[s]=t}f.addSearchParam=n})(b||(e.COI=b={}))}),define(ke[24],Ie([1,0,48,16,19,23,13,2]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=m,e.$ih=T,e.$jh=l;function m(b){return(0,p.$wc)(b,!0)}class E{constructor(f){this.a=f}compare(f,r,s=!1){return f===r?0:(0,R.$sf)(this.getComparisonKey(f,s),this.getComparisonKey(r,s))}isEqual(f,r,s=!1){return f===r?!0:!f||!r?!1:this.getComparisonKey(f,s)===this.getComparisonKey(r,s)}getComparisonKey(f,r=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,r,s=!1){if(f.scheme===r.scheme){if(f.scheme===O.Schemas.file)return P.$xg(m(f),m(r),this.a(f))&&f.query===r.query&&(s||f.fragment===r.fragment);if((0,e.$eh)(f.authority,r.authority))return P.$xg(f.path,r.path,this.a(f),"/")&&f.query===r.query&&(s||f.fragment===r.fragment)}return!1}joinPath(f,...r){return p.URI.joinPath(f,...r)}basenameOrAuthority(f){return(0,e.$9g)(f)||f.authority}basename(f){return M.$gc.basename(f.path)}extname(f){return M.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let r;return f.scheme===O.Schemas.file?r=p.URI.file(M.$mc(m(f))).path:(r=M.$gc.dirname(f.path),f.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),r="/")),f.with({path:r})}normalizePath(f){if(!f.path.length)return f;let r;return f.scheme===O.Schemas.file?r=p.URI.file(M.$hc(m(f))).path:r=M.$gc.normalize(f.path),f.with({path:r})}relativePath(f,r){if(f.scheme!==r.scheme||!(0,e.$eh)(f.authority,r.authority))return;if(f.scheme===O.Schemas.file){const n=M.$lc(m(f),m(r));return N.$i?P.$rg(n):n}let s=f.path||"/";const o=r.path||"/";if(this.a(f)){let n=0;for(const i=Math.min(s.length,o.length);n<i&&!(s.charCodeAt(n)!==o.charCodeAt(n)&&s.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);s=o.substr(0,n)+s.substr(n)}return M.$gc.relative(s,o)}resolvePath(f,r){if(f.scheme===O.Schemas.file){const s=p.URI.file(M.$kc(m(f),r));return f.with({authority:s.authority,path:s.path})}return r=P.$sg(r),f.with({path:M.$gc.resolve(f.path,r)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,r){return f===r||f!==void 0&&r!==void 0&&(0,R.$zf)(f,r)}hasTrailingPathSeparator(f,r=M.sep){if(f.scheme===O.Schemas.file){const s=m(f);return s.length>P.$tg(s).length&&s[s.length-1]===r}else{const s=f.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,r=M.sep){return(0,e.$fh)(f,r)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,r=M.sep){let s=!1;if(f.scheme===O.Schemas.file){const o=m(f);s=o!==void 0&&o.length===P.$tg(o).length&&o[o.length-1]===r}else{r="/";const o=f.path;s=o.length===1&&o.charCodeAt(o.length-1)===47}return!s&&!(0,e.$fh)(f,r)?f.with({path:f.path+"/"}):f}}e.$1g=E,e.$2g=new E(()=>!1),e.$3g=new E(b=>b.scheme===O.Schemas.file?!N.$k:!0),e.$4g=new E(b=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function T(b,f){const r=[];for(let s=0;s<b.length;s++){const o=f(b[s]);b.some((n,i)=>i===s?!1:(0,e.$6g)(o,f(n)))||r.push(b[s])}return r}var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(r){const s=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[c,u]=i.split(":");c&&u&&s.set(c,u)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&s.set(b.META_DATA_MIME,n),s}b.parseMetaData=f})(S||(e.DataUri=S={}));function l(b,f,r){if(f){let s=b.path;return s&&s[0]!==M.$gc.sep&&(s=M.$gc.sep+s),b.with({scheme:r,authority:f,path:s})}return b.with({scheme:r})}}),define(ke[11],Ie([1,0,20,14,5,6,24,23,136,43]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=T,e.$lh=S,e.$mh=l,e.$nh=b,e.$oh=f,e.$ph=r,e.$qh=s,e.$rh=o,e.$zh=$,e.$Ah=v,e.$Bh=y,e.$Ch=h,e.$Dh=D,e.$Sh=Se,e.$1h=De;function T(ge){return!!ge&&typeof ge.then=="function"}function S(ge){const Q=new P.$qe,Y=ge(Q.token),he=new Promise((ue,Ne)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Ne(new O.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),Q.dispose(),ue(Ce)},Ce=>{de.dispose(),Q.dispose(),Ne(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,Ne){return he.then(ue,Ne)}catch(ue){return this.then(void 0,ue)}finally(ue){return he.finally(ue)}}}function l(ge,Q,Y){return new Promise((he,ue)=>{const Ne=Q.onCancellationRequested(()=>{Ne.dispose(),he(Y)});ge.then(he,ue).finally(()=>Ne.dispose())})}function b(ge,Q){return new Promise((Y,he)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),he(new O.$5)});ge.then(Y,he).finally(()=>ue.dispose())})}async function f(ge){let Q=-1;const Y=ge.map((he,ue)=>he.then(Ne=>(Q=ue,Ne)));try{return await Promise.race(Y)}finally{ge.forEach((he,ue)=>{ue!==Q&&he.cancel()})}}function r(ge,Q,Y){let he;const ue=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([ge.finally(()=>clearTimeout(ue)),new Promise(Ne=>he=Ne)])}function s(ge){return new Promise((Q,Y)=>{const he=ge();T(he)?he.then(Q,Y):Q(he)})}function o(){let ge,Q;return{promise:new Promise((he,ue)=>{ge=he,Q=ue}),resolve:ge,reject:Q}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ue=>{this.a=null,Y(ue)},ue=>{this.a=null,he(ue)})})}dispose(){this.f=!0}}e.$sh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$th=i;class c{constructor(){this.a=new Map}queue(Q,Y){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$uh=c;const u=(ge,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=ge=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ge())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class g{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,Ne)=>{this.d=ue,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===m.$ce?t(he):u(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=g;class a{constructor(Q){this.a=new g(Q),this.b=new n}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=a;class d{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=d;class w extends d{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$yh=w;function $(ge,Q){return Q?new Promise((Y,he)=>{const ue=setTimeout(()=>{Ne.dispose(),Y()},ge),Ne=Q.onCancellationRequested(()=>{clearTimeout(ue),Ne.dispose(),he(new O.$5)})}):S(Y=>$(ge,Y))}function v(ge,Q=0,Y){const he=setTimeout(()=>{ge(),Y&&ue.dispose()},Q),ue=(0,N.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ue)});return Y?.add(ue),ue}function y(ge){const Q=[];let Y=0;const he=ge.length;function ue(){return Y<he?ge[Y++]():null}function Ne(de){de!=null&&Q.push(de);const Ce=ue();return Ce?Ce.then(Ne):Promise.resolve(Q)}return Promise.resolve(null).then(Ne)}function h(ge,Q=he=>!!he,Y=null){let he=0;const ue=ge.length,Ne=()=>{if(he>=ue)return Promise.resolve(Y);const de=ge[he++];return Promise.resolve(de()).then(Me=>Q(Me)?Promise.resolve(Me):Ne())};return Ne()}function D(ge,Q=he=>!!he,Y=null){if(ge.length===0)return Promise.resolve(Y);let he=ge.length;const ue=()=>{he=-1;for(const Ne of ge)Ne.cancel?.()};return new Promise((Ne,de)=>{for(const Ce of ge)Ce.then(Me=>{--he>=0&&Q(Me)?(ue(),Ne(Me)):he===0&&Ne(Y)}).catch(Me=>{--he>=0&&(ue(),de(Me))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new M.$fe}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=k;class C extends k{constructor(){super(1)}}e.$Fh=C;class I{constructor(){this.a=new fe,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Gh=I;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ae;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=R.$2g){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=R.$2g){const ue=he.getComparisonKey(Q);let Ne=this.a.get(ue);if(!Ne){Ne=new C;const de=this.f++,Ce=M.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(de,Ce),this.a.set(ue,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=W;class V{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Ih=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ue=he.setInterval(()=>{Q()},Y);this.d=(0,N.$Sc)(()=>{he.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=q;class A{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=A;class B{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=B;class K extends A{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Mh=K;class ie extends N.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(ge,Q)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Ph=(ge,Q,Y)=>{const he=ge.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,ge.cancelIdleCallback(he))}}},e.$Oh=ge=>(0,e.$Ph)(globalThis,ge)}();class ce{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ph)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=ce;class ve extends ce{constructor(Q){super(globalThis,Q)}}e.$Rh=ve;async function Se(ge,Q,Y){let he;for(let ue=0;ue<Y;ue++)try{return await ge()}catch(Ne){he=Ne,await $(Q)}throw he}class fe{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ue}=o();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=fe;class $e{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Uh=$e;var Te;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Te||(Te={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Vh=ae;var Re;(function(ge){async function Q(he){let ue;const Ne=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{ue||(ue=Ce)})));if(typeof ue<"u")throw ue;return Ne}ge.settled=Q;function Y(he){return new Promise(async(ue,Ne)=>{try{await he(ue,Ne)}catch(de){Ne(de)}})}ge.withAsyncBody=Y})(Re||(e.Promises=Re={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=ne;class z{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=z;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class be{static fromArray(Q){return new be(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new be(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>{for await(const ue of he)Y.emitOne(ue)}))})}static{this.EMPTY=be.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new M.$fe,queueMicrotask(async()=>{const he={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Q(he)),this.k()}catch(ue){this.l(ue)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new be(async he=>{for await(const ue of Q)he.emitOne(Y(ue))})}map(Q){return be.map(this,Q)}static filter(Q,Y){return new be(async he=>{for await(const ue of Q)Y(ue)&&he.emitOne(ue)})}filter(Q){return be.filter(this,Q)}static coalesce(Q){return be.filter(Q,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return be.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Yh=be;class Fe extends be{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Zh=Fe;function De(ge){const Q=new P.$qe,Y=ge(Q.token);return new Fe(Q,async he=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),he.reject(new O.$5)});try{for await(const Ne of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Ne)}ue.dispose(),Q.dispose()}catch(Ne){ue.dispose(),Q.dispose(),he.reject(Ne)}})}class pe{constructor(Q){this.a=new ae,this.b=new be(ue=>{if(Y){ue.reject(Y);return}return he&&ue.emitMany(he),this.d=Ne=>ue.reject(Ne),this.f=Ne=>ue.emitOne(Ne),this.a.p},Q);let Y,he;this.f=ue=>{he||(he=[]),he.push(ue)},this.d=ue=>{Y||(Y=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$2h=pe}),define(ke[37],Ie([1,0,18,11,48,28,19,23,13]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=E,e.$qk=f,e.$rk=C,e.$sk=I,e.$tk=W,e.$uk=V,e.$vk=q,e.$wk=ie;function E(){return Object.create(null)}e.$ok="**",e.$pk="/";const T="[/\\\\]",S="[^/\\\\]",l=/\//g;function b(ce,ve){switch(ce){case 0:return"";case 1:return`${S}*?`;default:return`(?:${T}|${S}+${T}${ve?`|${T}${S}+`:""})*?`}}function f(ce,ve){if(!ce)return[];const Se=[];let fe=!1,$e=!1,Te="";for(const ae of ce){switch(ae){case ve:if(!fe&&!$e){Se.push(Te),Te="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}Te+=ae}return Te&&Se.push(Te),Se}function r(ce){if(!ce)return"";let ve="";const Se=f(ce,e.$pk);if(Se.every(fe=>fe===e.$ok))ve=".*";else{let fe=!1;Se.forEach(($e,Te)=>{if($e===e.$ok){if(fe)return;ve+=b(2,Te===Se.length-1)}else{let ae=!1,Re="",ne=!1,z="";for(const x of $e){if(x!=="}"&&ae){Re+=x;continue}if(ne&&(x!=="]"||!z)){let be;x==="-"?be=x:(x==="^"||x==="!")&&!z?be="^":x===e.$pk?be="":be=(0,m.$bf)(x),z+=be;continue}switch(x){case"{":ae=!0;continue;case"[":ne=!0;continue;case"}":{const Fe=`(?:${f(Re,",").map(De=>r(De)).join("|")})`;ve+=Fe,ae=!1,Re="";break}case"]":{ve+="["+z+"]",ne=!1,z="";break}case"?":ve+=S;continue;case"*":ve+=b(1);continue;default:ve+=(0,m.$bf)(x)}}Te<Se.length-1&&(Se[Te+1]!==e.$ok||Te+2<Se.length)&&(ve+=T)}fe=$e===e.$ok})}return ve}const s=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Dc(1e4),g=function(){return!1},a=function(){return null};function d(ce,ve){if(!ce)return a;let Se;typeof ce!="string"?Se=ce.pattern:Se=ce,Se=Se.trim();const fe=`${Se}_${!!ve.trimForExclusions}`;let $e=t.get(fe);if($e)return w($e,ce);let Te;return s.test(Se)?$e=v(Se.substr(4),Se):(Te=o.exec($(Se,ve)))?$e=y(Te[1],Se):(ve.trimForExclusions?i:n).test(Se)?$e=h(Se,ve):(Te=c.exec($(Se,ve)))?$e=D(Te[1].substr(1),Se,!0):(Te=u.exec($(Se,ve)))?$e=D(Te[1],Se,!1):$e=k(Se),t.set(fe,$e),w($e,ce)}function w(ce,ve){if(typeof ve=="string")return ce;const Se=function(fe,$e){return(0,M.$xg)(fe,ve.base,!p.$k)?ce((0,m.$gf)(fe.substr(ve.base.length),R.sep),$e):null};return Se.allBasenames=ce.allBasenames,Se.allPaths=ce.allPaths,Se.basenames=ce.basenames,Se.patterns=ce.patterns,Se}function $(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function v(ce,ve){return function(Se,fe){return typeof Se=="string"&&Se.endsWith(ce)?ve:null}}function y(ce,ve){const Se=`/${ce}`,fe=`\\${ce}`,$e=function(ae,Re){return typeof ae!="string"?null:Re?Re===ce?ve:null:ae===ce||ae.endsWith(Se)||ae.endsWith(fe)?ve:null},Te=[ce];return $e.basenames=Te,$e.patterns=[ve],$e.allBasenames=Te,$e}function h(ce,ve){const Se=K(ce.slice(1,-1).split(",").map(Re=>d(Re,ve)).filter(Re=>Re!==a),ce),fe=Se.length;if(!fe)return a;if(fe===1)return Se[0];const $e=function(Re,ne){for(let z=0,x=Se.length;z<x;z++)if(Se[z](Re,ne))return ce;return null},Te=Se.find(Re=>!!Re.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=Se.reduce((Re,ne)=>ne.allPaths?Re.concat(ne.allPaths):Re,[]);return ae.length&&($e.allPaths=ae),$e}function D(ce,ve,Se){const fe=R.sep===R.$gc.sep,$e=fe?ce:ce.replace(l,R.sep),Te=R.sep+$e,ae=R.$gc.sep+ce;let Re;return Se?Re=function(ne,z){return typeof ne=="string"&&(ne===$e||ne.endsWith(Te)||!fe&&(ne===ce||ne.endsWith(ae)))?ve:null}:Re=function(ne,z){return typeof ne=="string"&&(ne===$e||!fe&&ne===ce)?ve:null},Re.allPaths=[(Se?"*/":"./")+ce],Re}function k(ce){try{const ve=new RegExp(`^${r(ce)}$`);return function(Se){return ve.lastIndex=0,typeof Se=="string"&&ve.test(Se)?ce:null}}catch{return a}}function C(ce,ve,Se){return!ce||typeof ve!="string"?!1:I(ce)(ve,void 0,Se)}function I(ce,ve={}){if(!ce)return g;if(typeof ce=="string"||W(ce)){const Se=d(ce,ve);if(Se===a)return g;const fe=function($e,Te){return!!Se($e,Te)};return Se.allBasenames&&(fe.allBasenames=Se.allBasenames),Se.allPaths&&(fe.allPaths=Se.allPaths),fe}return A(ce,ve)}function W(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function V(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function A(ce,ve){const Se=K(Object.getOwnPropertyNames(ce).map(Re=>B(Re,ce[Re],ve)).filter(Re=>Re!==a)),fe=Se.length;if(!fe)return a;if(!Se.some(Re=>!!Re.requiresSiblings)){if(fe===1)return Se[0];const Re=function(x,be){let Fe;for(let De=0,pe=Se.length;De<pe;De++){const ge=Se[De](x,be);if(typeof ge=="string")return ge;(0,O.$kh)(ge)&&(Fe||(Fe=[]),Fe.push(ge))}return Fe?(async()=>{for(const De of Fe){const pe=await De;if(typeof pe=="string")return pe}return null})():null},ne=Se.find(x=>!!x.allBasenames);ne&&(Re.allBasenames=ne.allBasenames);const z=Se.reduce((x,be)=>be.allPaths?x.concat(be.allPaths):x,[]);return z.length&&(Re.allPaths=z),Re}const $e=function(Re,ne,z){let x,be;for(let Fe=0,De=Se.length;Fe<De;Fe++){const pe=Se[Fe];pe.requiresSiblings&&z&&(ne||(ne=(0,R.$nc)(Re)),x||(x=ne.substr(0,ne.length-(0,R.$oc)(Re).length)));const ge=pe(Re,ne,x,z);if(typeof ge=="string")return ge;(0,O.$kh)(ge)&&(be||(be=[]),be.push(ge))}return be?(async()=>{for(const Fe of be){const De=await Fe;if(typeof De=="string")return De}return null})():null},Te=Se.find(Re=>!!Re.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=Se.reduce((Re,ne)=>ne.allPaths?Re.concat(ne.allPaths):Re,[]);return ae.length&&($e.allPaths=ae),$e}function B(ce,ve,Se){if(ve===!1)return a;const fe=d(ce,Se);if(fe===a)return a;if(typeof ve=="boolean")return fe;if(ve){const $e=ve.when;if(typeof $e=="string"){const Te=(ae,Re,ne,z)=>{if(!z||!fe(ae,Re))return null;const x=$e.replace("$(basename)",()=>ne),be=z(x);return(0,O.$kh)(be)?be.then(Fe=>Fe?ce:null):be?ce:null};return Te.requiresSiblings=!0,Te}}return fe}function K(ce,ve){const Se=ce.filter(Re=>!!Re.basenames);if(Se.length<2)return ce;const fe=Se.reduce((Re,ne)=>{const z=ne.basenames;return z?Re.concat(z):Re},[]);let $e;if(ve){$e=[];for(let Re=0,ne=fe.length;Re<ne;Re++)$e.push(ve)}else $e=Se.reduce((Re,ne)=>{const z=ne.patterns;return z?Re.concat(z):Re},[]);const Te=function(Re,ne){if(typeof Re!="string")return null;if(!ne){let x;for(x=Re.length;x>0;x--){const be=Re.charCodeAt(x-1);if(be===47||be===92)break}ne=Re.substr(x)}const z=fe.indexOf(ne);return z!==-1?$e[z]:null};Te.basenames=fe,Te.patterns=$e,Te.allBasenames=fe;const ae=ce.filter(Re=>!Re.basenames);return ae.push(Te),ae}function ie(ce,ve){return(0,P.$ub)(ce,ve,(Se,fe)=>typeof Se=="string"&&typeof fe=="string"?Se===fe:typeof Se!="string"&&typeof fe!="string"?Se.base===fe.base&&Se.pattern===fe.pattern:!1)}}),define(ke[55],Ie([1,0,14,137,24,13,2]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.MarkdownStringTextNewlineStyle=void 0,e.$Wk=E,e.$Xk=T,e.$Yk=S,e.$Zk=l,e.$1k=b,e.$2k=f,e.$3k=r,e.$4k=s;var p;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class m{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,P.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=l(this.supportThemeIcons?(0,O.$Pk)(n):n).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${b(i,n)}
`,this}appendLink(n,i,c){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,i){const c=new RegExp((0,N.$bf)(i),"g");return n.replace(c,(u,t)=>n.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$Vk=m;function E(o){return T(o)?!o.value:Array.isArray(o)?o.every(E):!0}function T(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function S(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,M.$5g)(R.URI.from(o.baseUri),R.URI.from(n.baseUri)))}function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(o,n){const i=o.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=i>=3?i+1:3;return[`${"`".repeat(c)}${n}`,o,`${"`".repeat(c)}`].join(`
`)}function f(o){return o.replace(/"/g,"&quot;")}function r(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const n=[],i=o.split("|").map(u=>u.trim());o=i[0];const c=i[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),g=u?u[1]:"",a=t?t[1]:"",d=isFinite(parseInt(a)),w=isFinite(parseInt(g));d&&n.push(`width="${a}"`),w&&n.push(`height="${g}"`)}return{href:o,dimensions:n}}}),define(ke[97],Ie([1,0,18,48,19,23,24,13]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=m,e.$Hw=T,e.$Iw=l,e.$Jw=b,e.$Kw=o,e.$Lw=i,e.$Mw=c,e.$Nw=u,e.$Ow=t,e.$Pw=g;function m(d,w){const{os:$,tildify:v,relative:y}=w;if(y){const k=E(d,y,$);if(typeof k=="string")return k}let h=d.fsPath;if($===1&&!N.$i?h=h.replace(/\//g,"\\"):$!==1&&N.$i&&(h=h.replace(/\\/g,"/")),$!==1&&v?.userHome){const k=v.userHome.fsPath;let C;d.scheme!==v.userHome.scheme&&d.path[0]===M.$gc.sep&&d.path[1]!==M.$gc.sep?C=v.userHome.with({path:d.path}).fsPath:C=h,h=l(C,k,$)}return($===1?M.$fc:M.$gc).normalize(T(h,$===1))}function E(d,w,$){const v=$===1?M.$fc:M.$gc,y=$===3?R.$2g:R.$4g,h=w.getWorkspace(),D=(0,P.$Ob)(h.folders);if(!D)return;d.scheme!==D.uri.scheme&&d.path[0]===M.$gc.sep&&d.path[1]!==M.$gc.sep&&(d=D.uri.with({path:d.path}));const k=w.getWorkspaceFolder(d);if(!k)return;let C;if(y.isEqual(k.uri,d)?C="":C=y.relativePath(k.uri,d)??"",C&&(C=v.normalize(C)),h.folders.length>1&&!w.noPrefix){const I=k.name?k.name:y.basenameOrAuthority(k.uri);C=C?`${I} \u2022 ${C}`:I}return C}function T(d,w=N.$i){return(0,O.$Cg)(d,w)?d.charAt(0).toUpperCase()+d.slice(1):d}let S=Object.create(null);function l(d,w,$=N.OS){if($===1||!d||!w)return d;let v=S.original===w?S.normalized:void 0;v||(v=w,N.$i&&(v=(0,O.$rg)(v)),v=`${(0,p.$hf)(v,M.$gc.sep)}${M.$gc.sep}`,S={original:w,normalized:v});let y=d;return N.$i&&(y=(0,O.$rg)(y)),($===3?y.startsWith(v):(0,p.$Af)(y,v))?`~/${y.substr(v.length)}`:d}function b(d,w){return d.replace(/^~($|\/|\\)/,`${w}$1`)}const f="\u2026",r="\\\\",s="~";function o(d,w=M.sep){const $=new Array(d.length);let v=!1;for(let y=0;y<d.length;y++){const h=d[y];if(h===""){$[y]=`.${w}`;continue}if(!h){$[y]=h;continue}v=!0;let D="",k=h;k.indexOf(r)===0?(D=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(w)===0?(D=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length)):k.indexOf(s)===0&&(D=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const C=k.split(w);for(let I=1;v&&I<=C.length;I++)for(let W=C.length-I;v&&W>=0;W--){v=!1;let V=C.slice(W,W+I).join(w);for(let q=0;!v&&q<d.length;q++)if(q!==y&&d[q]&&d[q].indexOf(V)>-1){const A=W+I===C.length,B=W>0&&d[q].indexOf(w)>-1?w+V:V,K=d[q].endsWith(B);v=!A||K}if(!v){let q="";(C[0].endsWith(":")||D!=="")&&(W===1&&(W=0,I++,V=C[0]+w+V),W>0&&(q=C[0]+w),q=D+q),W>0&&(q=q+f+w),q=q+V,W+I<C.length&&(q=q+w+f),$[y]=q}}v&&($[y]=h)}return $}var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(d,w=Object.create(null)){const $=[];let v=!1,y="";for(const h of d)if(h==="$"||v&&h==="{")y&&$.push({value:y,type:n.TEXT}),y="",v=!0;else if(h==="}"&&v){const D=w[y];if(typeof D=="string")D.length&&$.push({value:D,type:n.VARIABLE});else if(D){const k=$[$.length-1];(!k||k.type!==n.SEPARATOR)&&$.push({value:D.label,type:n.SEPARATOR})}y="",v=!1}else y+=h;return y&&!v&&$.push({value:y,type:n.TEXT}),$.filter((h,D)=>{if(h.type===n.SEPARATOR){const k=$[D-1],C=$[D+1];return[k,C].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(h=>h.value).join("")}function c(d,w){return N.$j||w?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):d.replace(/&&|&/g,$=>$==="&"?"&&":"&")}function u(d,w){return N.$j||w?d.replace(/\(&&\w\)|&&/g,""):N.$i?d.replace(/&&|&/g,$=>$==="&"?"&&":"&"):d.replace(/&&/g,"_")}function t(d){return d.replace(/&/g,"&&")}function g(d){if(d.endsWith("]")){const w=d.lastIndexOf(" [",d.length-2);if(w!==-1){const $=a(d.substring(0,w)),v=d.substring(w);return{name:$.name+v,parentPath:$.parentPath}}}return a(d)}function a(d){const w=d.indexOf("/")!==-1?M.$gc:M.$fc,$=w.basename(d),v=w.dirname(d);return $.length?{name:$,parentPath:v}:{name:v,parentPath:""}}}),define(ke[150],Ie([1,0,22,2]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=p,e.$Dn=E,e.$En=T;function M(S){return S.toJSON()}class N{constructor(l){this.a=l}transformIncoming(l){const b=this.a.transformIncoming(l);return b===l?l:M(O.URI.from(b))}transformOutgoing(l){const b=this.a.transformOutgoing(l);return b===l?l:M(O.URI.from(b))}transformOutgoingURI(l){const b=this.a.transformOutgoing(l);return b===l?l:O.URI.from(b)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$An=N,e.$Bn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,l,b){if(!S||b>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return l.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const r=R(S[f],l,b+1);r!==null&&(S[f]=r)}}return null}function p(S,l){const b=R(S,l,0);return b===null?S:b}function m(S,l,b,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return b?O.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof P.$He)return null;for(const r in S)if(Object.hasOwnProperty.call(S,r)){const s=m(S[r],l,b,f+1);s!==null&&(S[r]=s)}}return null}function E(S,l){const b=m(S,l,!1,0);return b===null?S:b}function T(S,l){const b=m(S,l,!0,0);return b===null?S:b}}),define(ke[151],Ie([1,0,11,5,6,49,15]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.StorageState=e.StorageHint=void 0,e.$Yp=m;var p;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function m(l){const b=l;return b?.changed instanceof Map||b?.deleted instanceof Set}var E;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(E||(e.StorageState=E={}));class T extends M.$Uc{static{this.a=100}constructor(b,f=Object.create(null)){super(),this.r=b,this.s=f,this.b=this.B(new O.$ie),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new P.$wh(T.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((f,r)=>this.w(r,f)),b.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(b,f){if(this.c===E.Closed)return;let r=!1;(0,R.$hg)(f)?r=this.f.delete(b):this.f.get(b)!==f&&(this.f.set(b,f),r=!0),r&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,f){const r=this.f.get(b);return(0,R.$hg)(r)?f:r}getBoolean(b,f){const r=this.get(b);return(0,R.$hg)(r)?f:r==="true"}getNumber(b,f){const r=this.get(b);return(0,R.$hg)(r)?f:parseInt(r,10)}getObject(b,f){const r=this.get(b);return(0,R.$hg)(r)?f:(0,N.$7h)(r)}async set(b,f,r=!1){if(this.c===E.Closed)return;if((0,R.$hg)(f))return this.delete(b,r);const s=(0,R.$ag)(f)||Array.isArray(f)?(0,N.$6h)(f):String(f);if(this.f.get(b)!==s)return this.f.set(b,s),this.j.set(b,s),this.h.delete(b),this.b.fire({key:b,external:r}),this.D()}async delete(b,f=!1){if(!(this.c===E.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:f}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===E.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Zp=T;class S{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((f,r)=>this.a.set(r,f)),b.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$1p=S}),define(ke[152],Ie([1,0,13,23,22]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0,e.$Gt=T,e.$Ht=S;let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let p;function m(){return p||(p=new TextDecoder("UTF-16BE")),p}let E;function T(){return E||(E=O.$D()?R():m()),E}function S(f,r,s){const o=new Uint16Array(f.buffer,r,s);return s>0&&(o[0]===65279||o[0]===65534)?l(f,r,s):R().decode(o)}function l(f,r,s){const o=[];let n=0;for(let i=0;i<s;i++){const c=M.$Je(f,r);r+=2,o[n++]=String.fromCharCode(c)}return o.join("")}class b{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return T().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const s=this.a-this.d;s<=1&&(s===0||P.$Df(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const s=r.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=r;return}for(let o=0;o<s;o++)this.b[this.d++]=r.charCodeAt(o)}}e.$It=b}),define(ke[153],Ie([1,0,22,152]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0,e.$Kt=R;function M(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,S,l){this.oldPosition=E,this.oldText=T,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,S){const l=T.length;P.$Me(E,l,S),S+=4;for(let b=0;b<l;b++)P.$Ke(E,T.charCodeAt(b),S),S+=2;return S}static d(E,T){const S=P.$Le(E,T);return T+=4,(0,O.$Ht)(E,T,S)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(E,T){return P.$Me(E,this.oldPosition,T),T+=4,P.$Me(E,this.newPosition,T),T+=4,T=N.c(E,this.oldText,T),T=N.c(E,this.newText,T),T}static read(E,T,S){const l=P.$Le(E,T);T+=4;const b=P.$Le(E,T);T+=4;const f=N.d(E,T);T+=N.a(f);const r=N.d(E,T);return T+=N.a(r),S.push(new N(l,f,b,r)),T}}e.$Jt=N;function R(m,E){return m===null||m.length===0?E:new p(m,E).compress()}class p{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,S=this.n(E),l=this.l(T);for(;E<this.f||T<this.h;){if(S===null){this.k(l),l=this.l(++T);continue}if(l===null){this.m(S),S=this.n(++E);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++T);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++E);continue}if(l.oldPosition<S.newPosition){const[o,n]=p.r(l,S.newPosition-l.oldPosition);this.k(o),l=n;continue}if(S.newPosition<l.oldPosition){const[o,n]=p.q(S,l.oldPosition-S.newPosition);this.m(o),S=n;continue}let r,s;if(l.oldEnd===S.newEnd)r=S,s=l,S=this.n(++E),l=this.l(++T);else if(l.oldEnd<S.newEnd){const[o,n]=p.q(S,l.oldLength);r=o,s=l,S=n,l=this.l(++T)}else{const[o,n]=p.r(l,S.newLength);r=S,s=o,S=this.n(++E),l=n}this.d[this.e++]=new N(r.oldPosition,r.oldText,s.newPosition,s.newText),this.g+=r.newLength-r.oldLength,this.j+=s.newLength-s.oldLength}const b=p.s(this.d);return p.t(b)}k(E){this.d[this.e++]=p.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=p.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new N(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new N(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const S=E.newText.substr(0,T),l=E.newText.substr(T);return[new N(E.oldPosition,E.oldText,E.newPosition,S),new N(E.oldEnd,"",E.newPosition+T,l)]}static r(E,T){const S=E.oldText.substr(0,T),l=E.oldText.substr(T);return[new N(E.oldPosition,S,E.newPosition,E.newText),new N(E.oldPosition+T,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let S=0,l=E[0];for(let b=1;b<E.length;b++){const f=E[b];l.oldEnd===f.oldPosition?l=new N(l.oldPosition,l.oldText+f.oldText,l.newPosition,l.newText+f.newText):(T[S++]=l,l=f)}return T[S++]=l,T}static t(E){if(E.length===0)return E;const T=[];let S=0;for(let l=0;l<E.length;l++){const b=E[l];b.oldText!==b.newText&&(T[S++]=b)}return T}}}),define(ke[154],Ie([1,0,37,19]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=M,e.$2t=N;function M(R,p,m,E,T,S){if(Array.isArray(R)){let l=0;for(const b of R){const f=M(b,p,m,E,T,S);if(f===10)return f;f>l&&(l=f)}return l}else{if(typeof R=="string")return E?R==="*"?5:R===m?10:0:0;if(R){const{language:l,pattern:b,scheme:f,hasAccessToAllModels:r,notebookType:s}=R;if(!E&&!r)return 0;s&&T&&(p=T);let o=0;if(f)if(f===p.scheme)o=10;else if(f==="*")o=5;else return 0;if(l)if(l===m)o=10;else if(l==="*")o=Math.max(o,5);else return 0;if(s)if(s===S)o=10;else if(s==="*"&&S!==void 0)o=Math.max(o,5);else return 0;if(b){let n;if(typeof b=="string"?n=b:n={...b,base:(0,O.$hc)(b.base)},n===p.fsPath||(0,P.$rk)(n,p.fsPath))o=10;else return 0}return o}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(ke[155],Ie([1,0,5,13,30,95,93,139,153,6]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=void 0;class T extends E.$Uc{constructor(l,b,f,r,s,o,n){super(),this.m=this.B(new P.$fe),this.onDidChangeContent=this.m.event,this.f=b,this.j=!o,this.g=r,this.h=s,this.c=new R.$3C(l,f,n)}equals(l){return!(l instanceof T)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,b){return this.c.getOffsetAt(l,b)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,b){const f=l+b,r=this.getPositionAt(l),s=this.getPositionAt(f);return new M.$xt(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(l,b=0){if(l.isEmpty())return"";const f=this.n(b);return this.c.getValueInRange(l,f)}getValueLengthInRange(l,b=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const f=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const o=this.n(b),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,c=l.endLineNumber-l.startLineNumber;s=i*c}return r-f+s}getCharacterCountInRange(l,b=0){if(this.j){let f=0;const r=l.startLineNumber,s=l.endLineNumber;for(let o=r;o<=s;o++){const n=this.getLineContent(o),i=o===r?l.startColumn-1:0,c=o===s?l.endColumn-1:n.length;for(let u=i;u<c;u++)O.$Df(n.charCodeAt(u))?(f=f+1,u=u+1):f=f+1}return f+=this.n(b).length*(s-r),f}return this.getValueLengthInRange(l,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,b){return this.c.getLineCharCode(l,b)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const b=O.$of(this.getLineContent(l));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(l){const b=O.$qf(this.getLineContent(l));return b===-1?0:b+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,b,f){let r=this.g,s=this.h,o=this.j,n=!0,i=[];for(let w=0;w<l.length;w++){const $=l[w];n&&$._isTracked&&(n=!1);const v=$.range;if($.text){let C=!0;o||(C=!O.$Of($.text),o=C),!r&&C&&(r=O.$Nf($.text)),!s&&C&&(s=O.$Qf($.text))}let y="",h=0,D=0,k=0;if($.text){let C;[h,D,k,C]=(0,p.$4t)($.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?y=$.text:y=$.text.replace(/\r\n|\r|\n/g,I)}i[w]={sortIndex:w,identifier:$.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:y,eolCount:h,firstLineLength:D,lastLineLength:k,forceMoveMarkers:!!$.forceMoveMarkers,isAutoWhitespaceEdit:$.isAutoWhitespaceEdit||!1}}i.sort(T.u);let c=!1;for(let w=0,$=i.length-1;w<$;w++){const v=i[w].range.getEndPosition(),y=i[w+1].range.getStartPosition();if(y.isBeforeOrEqual(v)){if(y.isBefore(v))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(i=this.s(i));const u=f||b?T._getInverseEditRanges(i):[],t=[];if(b)for(let w=0;w<i.length;w++){const $=i[w],v=u[w];if($.isAutoWhitespaceEdit&&$.range.isEmpty())for(let y=v.startLineNumber;y<=v.endLineNumber;y++){let h="";y===v.startLineNumber&&(h=this.getLineContent($.range.startLineNumber),O.$of(h)!==-1)||t.push({lineNumber:y,oldContent:h})}}let g=null;if(f){let w=0;g=[];for(let $=0;$<i.length;$++){const v=i[$],y=u[$],h=this.getValueInRange(v.range),D=v.rangeOffset+w;w+=v.text.length-h.length,g[$]={sortIndex:v.sortIndex,identifier:v.identifier,range:y,text:h,textChange:new m.$Jt(v.rangeOffset,h,D,v.text)}}c||g.sort(($,v)=>$.sortIndex-v.sortIndex)}this.g=r,this.h=s,this.j=o;const a=this.t(i);let d=null;if(b&&t.length>0){t.sort((w,$)=>$.lineNumber-w.lineNumber),d=[];for(let w=0,$=t.length;w<$;w++){const v=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===v)continue;const y=t[w].oldContent,h=this.getLineContent(v);h.length===0||h===y||O.$of(h)!==-1||d.push(v)}}return this.m.fire(),new N.$Mv(g,a,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let b=!1;const f=l[0].range,r=l[l.length-1].range,s=new M.$xt(f.startLineNumber,f.startColumn,r.endLineNumber,r.endColumn);let o=f.startLineNumber,n=f.startColumn;const i=[];for(let a=0,d=l.length;a<d;a++){const w=l[a],$=w.range;b=b||w.forceMoveMarkers,i.push(this.getValueInRange(new M.$xt(o,n,$.startLineNumber,$.startColumn))),w.text.length>0&&i.push(w.text),o=$.endLineNumber,n=$.endColumn}const c=i.join(""),[u,t,g]=(0,p.$4t)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:g,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(l){l.sort(T.w);const b=[];for(let f=0;f<l.length;f++){const r=l[f],s=r.range.startLineNumber,o=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(s===n&&o===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new M.$xt(s,o,n,i);b.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return b}findMatchesLineByLine(l,b,f,r){return this.c.findMatchesLineByLine(l,b,f,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,b){const f=l.startLineNumber,r=l.startColumn,[s,o,n]=(0,p.$4t)(b);let i;if(b.length>0){const c=s+1;c===1?i=new M.$xt(f,r,f,r+o):i=new M.$xt(f,r,f+c-1,n+1)}else i=new M.$xt(f,r,f,r);return i}static _getInverseEditRanges(l){const b=[];let f=0,r=0,s=null;for(let o=0,n=l.length;o<n;o++){const i=l[o];let c,u;s?s.range.endLineNumber===i.range.startLineNumber?(c=f,u=r+(i.range.startColumn-s.range.endColumn)):(c=f+(i.range.startLineNumber-s.range.endLineNumber),u=i.range.startColumn):(c=i.range.startLineNumber,u=i.range.startColumn);let t;if(i.text.length>0){const g=i.eolCount+1;g===1?t=new M.$xt(c,u,c,u+i.firstLineLength):t=new M.$xt(c,u,c+g-1,i.lastLineLength+1)}else t=new M.$xt(c,u,c,u);f=t.endLineNumber,r=t.endColumn,b.push(t),s=i}return b}static u(l,b){const f=M.$xt.compareRangesUsingEnds(l.range,b.range);return f===0?l.sortIndex-b.sortIndex:f}static w(l,b){const f=M.$xt.compareRangesUsingEnds(l.range,b.range);return f===0?b.sortIndex-l.sortIndex:-f}}e.$4C=T}),define(ke[156],Ie([1,0,13,93,155]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=void 0;class N{constructor(m,E,T,S,l,b,f,r,s){this.a=m,this.b=E,this.c=T,this.d=S,this.e=l,this.f=b,this.g=f,this.h=r,this.j=s}k(m){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?m===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(m){const E=this.k(m),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,b=T.length;l<b;l++){const f=T[l].buffer.replace(/\r\n|\r|\n/g,E),r=(0,O.$YC)(f);T[l]=new O.$2C(f,r)}const S=new M.$4C(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&P.$Yf(m)&&(this.b=P.$Xf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,O.$ZC)(this.e,m);this.a.push(new O.$2C(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=P.$Nf(m)),this.k||(this.k=P.$Qf(m)))}finish(m=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,O.$YC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$5C=R}),define(ke[98],Ie([1,0,22,23]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbb=m,e.$ybb=T;var M;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(M||(M={}));function N(S){for(let l=0,b=S.length;l<b;l+=4){const f=S[l+0],r=S[l+1],s=S[l+2],o=S[l+3];S[l+0]=o,S[l+1]=s,S[l+2]=r,S[l+3]=f}}function R(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return O.$D()||N(l),P.$He.wrap(l)}function p(S){const l=S.buffer;if(O.$D()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function m(S){const l=new Uint32Array(E(S));let b=0;if(l[b++]=S.id,S.type==="full")l[b++]=1,l[b++]=S.data.length,l.set(S.data,b),b+=S.data.length;else{l[b++]=2,l[b++]=S.deltas.length;for(const f of S.deltas)l[b++]=f.start,l[b++]=f.deleteCount,f.data?(l[b++]=f.data.length,l.set(f.data,b),b+=f.data.length):l[b++]=0}return R(l)}function E(S){let l=0;if(l+=2,S.type==="full")l+=1+S.data.length;else{l+=1,l+=3*S.deltas.length;for(const b of S.deltas)b.data&&(l+=b.data.length)}return l}function T(S){const l=p(S);let b=0;const f=l[b++];if(l[b++]===1){const n=l[b++],i=l.subarray(b,b+n);return b+=n,{id:f,type:"full",data:i}}const s=l[b++],o=[];for(let n=0;n<s;n++){const i=l[b++],c=l[b++],u=l[b++];let t;u>0&&(t=l.subarray(b,b+u),b+=u),o[n]={start:i,deleteCount:c,data:t}}return{id:f,type:"delta",deltas:o}}}),define(ke[157],Ie([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[158],Ie([1,0,18,26,23,140,159,157]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=s,e.clampedInt=n,e.clampedFloat=c,e.stringSet=g,e.cursorStyleToString=k,e.filterValidationDecorations=ue;var m;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class S{constructor(X,me,qe,we){this.id=X,this.name=me,this.defaultValue=qe,this.schema=we}applyUpdate(X,me){return b(X,me)}compute(X,me,qe){return qe}}class l{constructor(X,me){this.newValue=X,this.didChange=me}}e.ApplyUpdateResult=l;function b(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new l(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const qe=Array.isArray(Z)&&Array.isArray(X)&&P.$ub(Z,X);return new l(X,!qe)}let me=!1;for(const qe in X)if(X.hasOwnProperty(qe)){const we=b(Z[qe],X[qe]);we.didChange&&(Z[qe]=we.newValue,me=!0)}return new l(Z,me)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,me){return b(X,me)}validate(X){return this.defaultValue}}class r{constructor(X,me,qe,we){this.id=X,this.name=me,this.defaultValue=qe,this.schema=we}applyUpdate(X,me){return b(X,me)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,me,qe){return qe}}function s(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class o extends r{constructor(X,me,qe,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=qe),super(X,me,qe,we)}validate(X){return s(X,this.defaultValue)}}function n(Z,X,me,qe){if(typeof Z>"u")return X;let we=parseInt(Z,10);return isNaN(we)?X:(we=Math.max(me,we),we=Math.min(qe,we),we|0)}class i extends r{static clampedInt(X,me,qe,we){return n(X,me,qe,we)}constructor(X,me,qe,we,at,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=qe,dt.minimum=we,dt.maximum=at),super(X,me,qe,dt),this.minimum=we,this.maximum=at}validate(X){return i.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Z,X,me,qe){if(typeof Z>"u")return X;const we=u.float(Z,X);return u.clamp(we,me,qe)}class u extends r{static clamp(X,me,qe){return X<me?me:X>qe?qe:X}static float(X,me){if(typeof X=="number")return X;if(typeof X>"u")return me;const qe=parseFloat(X);return isNaN(qe)?me:qe}constructor(X,me,qe,we,at){typeof at<"u"&&(at.type="number",at.default=qe),super(X,me,qe,at),this.validationFn=we}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class t extends r{static string(X,me){return typeof X!="string"?me:X}constructor(X,me,qe,we=void 0){typeof we<"u"&&(we.type="string",we.default=qe),super(X,me,qe,we)}validate(X){return t.string(X,this.defaultValue)}}function g(Z,X,me,qe){return typeof Z!="string"?X:qe&&Z in qe?qe[Z]:me.indexOf(Z)===-1?X:Z}class a extends r{constructor(X,me,qe,we,at=void 0){typeof at<"u"&&(at.type="string",at.enum=we,at.default=qe),super(X,me,qe,at),this.c=we}validate(X){return g(X,this.defaultValue,this.c)}}class d extends S{constructor(X,me,qe,we,at,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=at,Pt.default=we),super(X,me,qe,Pt),this.c=at,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,me,qe){return qe===0?X.accessibilitySupport:qe}}class v extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:p.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertSpace:s(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function k(Z){switch(Z){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function C(Z){switch(Z){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class I extends f{constructor(){super(142)}compute(X,me,qe){const we=["monaco-editor"];return me.get(39)&&we.push(me.get(39)),X.extraEditorClassName&&we.push(X.extraEditorClassName),me.get(74)==="default"?we.push("mouse-default"):me.get(74)==="copy"&&we.push("mouse-copy"),me.get(111)&&we.push("showUnused"),me.get(140)&&we.push("showDeprecated"),we.join(" ")}}class W extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(X,me,qe){return qe&&X.emptySelectionClipboard}}class V extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:p.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:p.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{cursorMoveOnType:s(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":g(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":g(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(me.loop,this.defaultValue.loop)}}}class q extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?q.OFF:X==="true"?q.ON:X:X?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?A.OFF:X==="true"?A.TRANSLATE:X:X?A.TRANSLATE:A.OFF}compute(X,me,qe){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class B extends f{constructor(){super(50)}compute(X,me,qe){return X.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(X){const me=u.float(X,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(me,6,100)}compute(X,me,qe){return X.fontInfo.fontSize}}class ie extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(i.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:qe,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:qe,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:qe,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:qe,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:qe,description:p.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{multiple:g(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??g(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??g(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??g(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??g(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??g(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends S{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:p.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:s(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(me.above,this.defaultValue.above)}}}var Se;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class fe extends f{constructor(){super(145)}compute(X,me,qe){return fe.computeLayout(me,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const me=X.height/X.lineHeight,qe=Math.floor(X.paddingTop/X.lineHeight);let we=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(we=Math.max(we,me-1));const at=(qe+X.viewLineCount+we)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/at);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:we,desiredRatio:at,minimapLineCount:dt}}static c(X,me){const qe=X.outerWidth,we=X.outerHeight,at=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(at*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=me.stableMinimapLayoutInput,Pt=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,Vt=X.lineHeight,Qt=X.typicalHalfwidthCharacterWidth,ii=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let Dt=at>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Zt=X.minimap.maxColumn,Yt=X.minimap.size,Ze=X.minimap.side,si=X.verticalScrollbarWidth,Gt=X.viewLineCount,ht=X.remainingWidth,mt=X.isViewportWrapping,xt=Xt?2:3;let Kt=Math.floor(at*we);const Ft=Kt/at;let ft=!1,jt=!1,_t=xt*Dt,Lt=Dt/at,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Nt,extraLinesBeforeFirstLine:ei,extraLinesBeyondLastLine:Wt,desiredRatio:oi,minimapLineCount:Mt}=fe.computeContainedMinimapLineCount({viewLineCount:Gt,scrollBeyondLastLine:ii,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:we,lineHeight:Vt,pixelRatio:at});if(Gt/Mt>1)ft=!0,jt=!0,Dt=1,_t=1,Lt=Dt/at;else{let Ot=!1,It=Dt+1;if(Yt==="fit"){const wt=Math.ceil((ei+Gt+Wt)*_t);mt&&Pt&&ht<=me.stableFitRemainingWidth?(Ot=!0,It=me.stableFitMaxMinimapScale):Ot=wt>Kt}if(Yt==="fill"||Ot){ft=!0;const wt=Dt;_t=Math.min(Vt*at,Math.max(1,Math.floor(1/oi))),mt&&Pt&&ht<=me.stableFitRemainingWidth&&(It=me.stableFitMaxMinimapScale),Dt=Math.min(It,Math.max(1,Math.floor(_t/xt))),Dt>wt&&(Qe=Math.min(2,Dt/wt)),Lt=Dt/at/Qe,Kt=Math.ceil(Math.max(Nt,ei+Gt+Wt)*_t),mt?(me.stableMinimapLayoutInput=X,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Dt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ci=Math.floor(Zt*Lt),Jt=Math.min(ci,Math.max(0,Math.floor((ht-si-2)*Lt/(Qt+Lt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(at*Jt);const pt=zt/at;zt=Math.floor(zt*Qe);const Ut=Xt?1:2,Rt=Ze==="left"?0:qe-Jt-si;return{renderMinimap:Ut,minimapLeft:Rt,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:Dt,minimapLineHeight:_t,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:Ft}}static computeLayout(X,me){const qe=me.outerWidth|0,we=me.outerHeight|0,at=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,Vt=me.maxDigitWidth,Qt=me.pixelRatio,ii=me.viewLineCount,Xt=X.get(137),Dt=Xt==="inherit"?X.get(136):Xt,Zt=Dt==="inherit"?X.get(132):Dt,Yt=X.get(135),Ze=me.isDominatedByLongLines,si=X.get(57),Gt=X.get(68).renderType!==0,ht=X.get(69),mt=X.get(105),xt=X.get(84),Kt=X.get(73),Ft=X.get(103),ft=Ft.verticalScrollbarSize,jt=Ft.verticalHasArrows,_t=Ft.arrowSize,Lt=Ft.horizontalScrollbarSize,Qe=X.get(43),ci=X.get(110)!=="never";let Jt=X.get(66);Qe&&ci&&(Jt+=16);let zt=0;if(Gt){const ni=Math.max(dt,ht);zt=Math.round(ni*Vt)}let pt=0;si&&(pt=at*me.glyphMarginDecorationLaneCount);let Ut=0,Rt=Ut+pt,Nt=Rt+zt,ei=Nt+Jt;const Wt=qe-pt-zt-Jt;let oi=!1,Mt=!1,Tt=-1;Dt==="inherit"&&Ze?(oi=!0,Mt=!0):Zt==="on"||Zt==="bounded"?Mt=!0:Zt==="wordWrapColumn"&&(Tt=Yt);const Ot=fe.c({outerWidth:qe,outerHeight:we,lineHeight:at,typicalHalfwidthCharacterWidth:Pt,pixelRatio:Qt,scrollBeyondLastLine:mt,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Kt,verticalScrollbarWidth:ft,viewLineCount:ii,remainingWidth:Wt,isViewportWrapping:Mt},me.memory||new T);Ot.renderMinimap!==0&&Ot.minimapLeft===0&&(Ut+=Ot.minimapWidth,Rt+=Ot.minimapWidth,Nt+=Ot.minimapWidth,ei+=Ot.minimapWidth);const It=Wt-Ot.minimapWidth,wt=Math.max(1,Math.floor((It-ft-2)/Pt)),Et=jt?_t:0;return Mt&&(Tt=Math.max(1,wt),Zt==="bounded"&&(Tt=Math.min(Tt,Yt))),{width:qe,height:we,glyphMarginLeft:Ut,glyphMarginWidth:pt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:zt,decorationsLeft:Nt,decorationsWidth:Jt,contentLeft:ei,contentWidth:It,minimap:Ot,viewportColumn:wt,isWordWrapMinified:oi,isViewportWrapping:Mt,wrappingColumn:Tt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Lt,overviewRuler:{top:Et,width:ft,height:we-2*Et,right:0}}}}e.EditorLayoutInfoComputer=fe;class $e extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(X){return g(X,"simple",["simple","advanced"])}compute(X,me,qe){return me.get(2)===2?"advanced":qe}}var Te;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Te||(e.ShowLightbulbIconMode=Te={}));class ae extends S{constructor(){const X={enabled:Te.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Te.Off,Te.OnCode,Te.On],default:X.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:g(X.enabled,this.defaultValue.enabled,[Te.Off,Te.OnCode,Te.On])}}}class Re extends S{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:p.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:p.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:g(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:s(me.padding,this.defaultValue.padding)}}}class z extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):i.clampedInt(X,this.defaultValue,0,1e3)}compute(X,me,qe){return qe<0?i.clampedInt(-qe*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class x extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:p.localize(66,null)})}compute(X,me,qe){return X.fontInfo.lineHeight}}class be extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:X.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),autohide:s(me.autohide,this.defaultValue.autohide),size:g(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(me.side,this.defaultValue.side,["right","left"]),showSlider:g(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:s(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:s(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Fe(Z){return Z==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class De extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class pe extends S{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:p.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),cycle:s(me.cycle,this.defaultValue.cycle)}}}class ge extends f{constructor(){super(143)}compute(X,me,qe){return X.pixelRatio}}class Q extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:X.strings,description:p.localize(88,null)},comments:{anyOf:me,default:X.comments,description:p.localize(89,null)},other:{anyOf:me,default:X.other,description:p.localize(90,null)}},default:X,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Qt=X?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!X||typeof X!="object")return this.defaultValue;const{other:me,comments:qe,strings:we}=X,at=["on","inline","off"];let dt,Pt,Vt;return typeof me=="boolean"?dt=me?"on":"off":dt=g(me,this.defaultValue.other,at),typeof qe=="boolean"?Pt=qe?"on":"off":Pt=g(qe,this.defaultValue.comments,at),typeof we=="boolean"?Vt=we?"on":"off":Vt=g(we,this.defaultValue.strings,at),{other:dt,comments:Pt,strings:Vt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(X){let me=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(me=4,qe=X):X==="interval"?me=3:X==="relative"?me=2:X==="on"?me=1:me=0),{renderType:me,renderFn:qe}}}function ue(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Ne extends S{constructor(){const X=[],me={type:"number",description:p.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:X,description:p.localize(99,null)})}validate(X){if(Array.isArray(X)){const me=[];for(const qe of X)if(typeof qe=="number")me.push({column:i.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const we=qe;me.push({column:i.clampedInt(we.column,0,0,1e4),color:we.color})}return me.sort((qe,we)=>qe.column-we.column),me}return this.defaultValue}}class de extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ce(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X,qe=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:s(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:we,verticalSliderSize:i.clampedInt(me.verticalSliderSize,we,0,1e3),scrollByPage:s(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:p.localize(118,null)}})}applyUpdate(X,me){let qe=!1;me.allowedCharacters&&X&&(O.$9n(X.allowedCharacters,me.allowedCharacters)||(X={...X,allowedCharacters:me.allowedCharacters},qe=!0)),me.allowedLocales&&X&&(O.$9n(X.allowedLocales,me.allowedLocales)||(X={...X,allowedLocales:me.allowedLocales},qe=!0));const we=super.applyUpdate(X,me);return qe?new l(we.newValue,!0):we}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,me){if(typeof X!="object"||!X)return me;const qe={};for(const[we,at]of Object.entries(X))at===!0&&(qe[we]=!0);return qe}}class j extends S{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),mode:g(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class L extends S{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:p.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),showToolbar:g(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:s(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:s(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class H extends S{constructor(){const X={enabled:N.$7s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$7s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class G extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:X.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:X.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:X.highlightActiveIndentation,description:p.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,X,me){const qe=me.indexOf(Z);return qe===-1?X:me[qe]}class re extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:X.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:X.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertMode:g(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(me.showIcons,this.defaultValue.showIcons),showStatusBar:s(me.showStatusBar,this.defaultValue.showStatusBar),preview:s(me.preview,this.defaultValue.preview),previewMode:g(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(me.showMethods,this.defaultValue.showMethods),showFunctions:s(me.showFunctions,this.defaultValue.showFunctions),showConstructors:s(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(me.showFields,this.defaultValue.showFields),showVariables:s(me.showVariables,this.defaultValue.showVariables),showClasses:s(me.showClasses,this.defaultValue.showClasses),showStructs:s(me.showStructs,this.defaultValue.showStructs),showInterfaces:s(me.showInterfaces,this.defaultValue.showInterfaces),showModules:s(me.showModules,this.defaultValue.showModules),showProperties:s(me.showProperties,this.defaultValue.showProperties),showEvents:s(me.showEvents,this.defaultValue.showEvents),showOperators:s(me.showOperators,this.defaultValue.showOperators),showUnits:s(me.showUnits,this.defaultValue.showUnits),showValues:s(me.showValues,this.defaultValue.showValues),showConstants:s(me.showConstants,this.defaultValue.showConstants),showEnums:s(me.showEnums,this.defaultValue.showEnums),showEnumMembers:s(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(me.showKeywords,this.defaultValue.showKeywords),showWords:s(me.showWords,this.defaultValue.showWords),showColors:s(me.showColors,this.defaultValue.showColors),showFiles:s(me.showFiles,this.defaultValue.showFiles),showReferences:s(me.showReferences,this.defaultValue.showReferences),showFolders:s(me.showFolders,this.defaultValue.showFolders),showTypeParameters:s(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(me.showSnippets,this.defaultValue.showSnippets),showUsers:s(me.showUsers,this.defaultValue.showUsers),showIssues:s(me.showIssues,this.defaultValue.showIssues)}}}class Oe extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends S{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const me=[];for(const qe of X)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&me.push(qe)}catch{}return me}return this.defaultValue}}var He;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class _e extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,me,qe){return me.get(2)===2?0:qe}}class xe extends f{constructor(){super(146)}compute(X,me,qe){const we=me.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class et extends S{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),showDropSelector:g(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends S{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:s(me.enabled,this.defaultValue.enabled),showPasteSelector:g(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?ct:M.$k?gt:it,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var ot;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ot||(e.EditorOption=ot={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ue(new $),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ue(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ue(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ue(new o(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ue(new H),bracketPairGuides:Ue(new G),stickyTabStops:Ue(new o(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ue(new o(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ue(new o(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ue(new o(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ue(new v),contextmenu:Ue(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new o(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ue(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ue(new d(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(260,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ue(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new o(34,"domReadOnly",!1)),dragAndDrop:Ue(new o(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ue(new W),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Re),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:p.localize(271,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new o(42,"fixedOverflowWidgets",!1)),folding:Ue(new o(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ue(new o(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ue(new o(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ue(new B),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new A),formatOnPaste:Ue(new o(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ue(new o(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ue(new o(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new o(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ue(new ve),inDiffEditor:Ue(new o(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>u.clamp(Z,-5,20),{description:p.localize(285,null)})),lightbulb:Ue(new ae),lineDecorationsWidth:Ue(new z),lineHeight:Ue(new x),lineNumbers:Ue(new he),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new o(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ue(new o(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ue(new be),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ue(new o(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ue(new o(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ue(new d(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ue(new o(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new De),pasteAs:Ue(new tt),parameterHints:Ue(new pe),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ue(new o(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ue(new o(91,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new o(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ue(new o(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new o(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ue(new Ne),scrollbar:Ue(new Me),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ue(new o(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ue(new o(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ue(new o(107,"selectionClipboard",!0,{description:p.localize(325,null),included:M.$k})),selectionHighlight:Ue(new o(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ue(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ue(new o(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ue(new o(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ue(new Oe),smoothScrolling:Ue(new o(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new j),inlineEdit:Ue(new L),inlineCompletionsAccessibilityVerbose:Ue(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new o(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ue(new o(127,"useShadowDOM",!0)),useTabStops:Ue(new o(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new t(131,"wordSeparators",R.$8s,{description:p.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new I),defaultColorDecorators:Ue(new o(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new o(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ue(new fe),wrappingInfo:Ue(new xe),wrappingIndent:Ue(new _e),wrappingStrategy:Ue(new $e)}}),define(ke[160],Ie([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[161],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[162],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[163],Ie([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[164],Ie([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[165],Ie([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[166],Ie([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[167],Ie([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[168],Ie([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(ke[169],Ie([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[170],Ie([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[171],Ie([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[172],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[173],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[174],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[175],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[176],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[177],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[178],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[179],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[180],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[181],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[182],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[183],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[184],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[185],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[186],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[187],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[188],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[189],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[190],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[191],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[192],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[193],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[194],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[195],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[196],Ie([1,0,14,162]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var M;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(M||(e.TokenType=M={}));function N(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,O.localize)(3,null),p=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const S=this.d,l=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:T}),this.f.push(b)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const S=this.c.substring(this.d,this.e),l=m.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,S=!1,l=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(p);return}const f=this.c.charCodeAt(T);if(S)S=!1;else if(f===47&&!l){T++;break}else f===91?l=!0:f===92?S=!0:f===93&&(l=!1);T++}for(;T<this.c.length&&m.a.has(this.c.charCodeAt(T));)T++;this.e=T;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=m}),define(ke[197],Ie([1,0,24,32,164,311]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=m,e.$Kp=E,e.$Lp=T,e.$Mp=S,e.$Np=l,e.$Op=b,e.$Pp=f;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||R.test(o)}function E(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function T(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,c=o.minorBase;let u=o.minorMustEqual;const t=o.patchBase;let g=o.patchMustEqual;o.hasCaret&&(n===0||(u=!1),g=!1);let a=0;if(o.preRelease){const d=p.exec(o.preRelease);if(d){const[,w,$,v]=d;a=Date.UTC(Number(w),Number($)-1,Number(v))}}return{majorBase:n,majorMustEqual:i,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:g,isMinimum:o.hasGreaterEquals,notBefore:a}}function S(o,n,i){let c;typeof o=="string"?c=T(E(o)):c=o;let u;n instanceof Date?u=n.getTime():typeof n=="string"&&(u=new Date(n).getTime());let t;if(typeof i=="string"?t=T(E(i)):t=i,!c||!t)return!1;const g=c.majorBase,a=c.minorBase,d=c.patchBase;let w=t.majorBase,$=t.minorBase,v=t.patchBase;const y=t.notBefore;let h=t.majorMustEqual,D=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?g>w?!0:g<w?!1:a>$?!0:a<$||u&&u<y?!1:d>=v:(g===1&&w===0&&(!h||!D||!k)&&(w=1,$=0,v=0,h=!0,D=!1,k=!1),g<w?!1:g>w?!h:a<$?!1:a>$?!D:d<v?!1:d>v?!k:!(u&&u<y))}function l(o,n,i,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,M.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,M.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,M.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,M.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return t.push([O.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return t.push([O.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,M.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,M.localize(9,null,"main")]),t;{const d=(0,P.$_g)(i,c.main);(0,P.$6g)(d,i)||t.push([O.default.Warning,M.localize(10,null,d.path,i.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,M.localize(11,null,"browser")]),t;{const d=(0,P.$_g)(i,c.browser);(0,P.$6g)(d,i)||t.push([O.default.Warning,M.localize(12,null,d.path,i.path)])}}if(!N.valid(c.version))return t.push([O.default.Error,M.localize(13,null)]),t;const g=[];if(!b(o,n,c,u,g))for(const d of g)t.push([O.default.Error,d]);return t}function b(o,n,i,c,u){return c||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(o,n,i.engines.vscode,u)}function f(o,n,i){return o==="*"||r(n,i,o)}function r(o,n,i,c=[]){const u=T(E(i));if(!u)return c.push(M.localize(14,null,i)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(M.localize(15,null,i)),!1}else if(!u.majorMustEqual)return c.push(M.localize(16,null,i)),!1;return S(o,n,u)?!0:(c.push(M.localize(17,null,o,i)),!1)}function s(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[71],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class P{constructor(M,N=[],R=!1){this.ctor=M,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$vi=P}),define(ke[56],Ie([1,0,71]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$As=N,e.$Bs=R;const O=[];var M;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function N(p,m,E){m instanceof P.$vi||(m=new P.$vi(m,[],!!E)),O.push([p,m])}function R(){return O}}),define(ke[198],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;class P{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$dr=P;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const p=this.lookupOrInsertNode(N),m=this.lookupOrInsertNode(R);p.outgoing.set(m.key,m),m.incoming.set(p.key,p)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const p of this.a.values())p.outgoing.delete(R),p.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let p=this.a.get(R);return p||(p=new P(R,N),this.a.set(R,p)),p}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,p]of this.a)N.push(`${R}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const p=new Set([N]),m=this.c(R,p);if(m)return m}}c(N,R){for(const[p,m]of N.outgoing){if(R.has(p))return[...R,p].join(" -> ");R.add(p);const E=this.c(m,R);if(E)return E;R.delete(p)}}}e.$er=O}),define(ke[3],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=M,e.$zi=N;var P;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(P||(e._util=P={})),e.$xi=M("instantiationService");function O(R,p,m){p[P.DI_TARGET]===p?p[P.DI_DEPENDENCIES].push({id:R,index:m}):(p[P.DI_DEPENDENCIES]=[{id:R,index:m}],p[P.DI_TARGET]=p)}function M(R){if(P.serviceIds.has(R))return P.serviceIds.get(R);const p=function(m,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(p,m,T)};return p.toString=()=>R,P.serviceIds.set(R,p),p}function N(R){return R}}),define(ke[50],Ie([1,0,15,2,3]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=N,e.$7i=R,e.$8i=m,e.$9i=E,e.$0i=T,e.$$i=S,e.$_i=l,e.$aj=f,e.$bj=r,e.$cj=s,e.$5i=(0,M.$yi)("configurationService");function N(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function T(o,n){const i=Object.create(null);for(const c in o)S(i,c,o[c],n);return i}function S(o,n,i,c){const u=n.split("."),t=u.pop();let g=o;for(let a=0;a<u.length;a++){const d=u[a];let w=g[d];switch(typeof w){case"undefined":w=g[d]=Object.create(null);break;case"object":if(w===null){c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify(w)}`);return}g=w}if(typeof g=="object"&&g!==null)try{g[t]=i}catch{c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(g)}`)}else c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(g)}`)}function l(o,n){const i=n.split(".");b(o,i)}function b(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const c=o[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,n),Object.keys(c).length===0&&delete o[i])}}function f(o,n,i){function c(g,a){let d=g;for(const w of a){if(typeof d!="object"||d===null)return;d=d[w]}return d}const u=n.split("."),t=c(o,u);return typeof t>"u"?i:t}function r(o,n,i){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in o?P.$ag(o[c])&&P.$ag(n[c])?r(o[c],n[c],i):i&&(o[c]=n[c]):o[c]=n[c])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(ke[31],Ie([1,0,23,13,196,3,161,14]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=E,e.$xj=g,e.$yj=a,e.$Rj=Te;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",P.$j),m.set("isLinux",P.$k),m.set("isWindows",P.$i),m.set("isWeb",P.$o),m.set("isMacNative",P.$j&&!P.$o),m.set("isEdge",P.$H),m.set("isFirefox",P.$F),m.set("isChrome",P.$E),m.set("isSafari",P.$G);function E(ne,z){if(m.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ne,z)}const T=Object.prototype.hasOwnProperty;var S;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),f=(0,R.localize)(1,null),r=(0,R.localize)(2,null),s=(0,R.localize)(3,null),o=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=l){this.k=z,this.d=new M.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const be=this.D(),Fe=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:M.$tj.getLexeme(be),additionalInfo:Fe}),u.c}return x}catch(x){if(x!==u.c)throw x;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const x=this.o();z.push(x)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const x=this.s();z.push(x)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,s),x?.negate()}case 17:return this.z(),C.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,s),x}case 17:{const x=z.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const De=Fe.lexeme,pe=De.lastIndexOf("/"),ge=pe===De.length-1?void 0:this.w(De.substring(pe+1));let Q;try{Q=new RegExp(De.substring(1,pe),ge)}catch{throw this.B("REGEX",Fe)}return B.create(x,Q)}switch(Fe.type){case 10:case 19:{const De=[Fe.lexeme];this.z();let pe=this.D(),ge=0;for(let Ne=0;Ne<Fe.lexeme.length;Ne++)Fe.lexeme.charCodeAt(Ne)===40?ge++:Fe.lexeme.charCodeAt(Ne)===41&&ge--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Ne=0;Ne<pe.lexeme.length;Ne++)pe.lexeme.charCodeAt(Ne)===40?ge++:Fe.lexeme.charCodeAt(Ne)===41&&ge--}if(ge<0)break;De.push(M.$tj.getLexeme(pe)),this.z(),pe=this.D()}const Q=De.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ue;try{ue=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Fe)}return t.regex(x,ue)}case 18:{const De=Fe.lexeme;this.z();let pe=null;if(!(0,O.$9e)(De)){const ge=De.indexOf("/"),Q=De.lastIndexOf("/");if(ge!==Q&&ge>=0){const Y=De.slice(ge+1,Q),he=De[Q+1]==="i"?"i":"";try{pe=new RegExp(Y,he)}catch{throw this.B("REGEX",Fe)}}}if(pe===null)throw this.B("REGEX",Fe);return B.create(x,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Fe=this.u();return t.notIn(x,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return t.equals(x,Fe);switch(Fe){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return t.notEquals(x,Fe);switch(Fe){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Fe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:i,offset:z.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,x){if(this.C(z))return this.z();throw this.B(x,this.D())}B(z,x,be){const Fe=(0,R.localize)(8,null,z,M.$tj.getLexeme(x)),De=x.offset,pe=M.$tj.getLexeme(x);return this.h.push({message:Fe,offset:De,lexeme:pe,additionalInfo:be}),u.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=u;class t{static false(){return w.INSTANCE}static true(){return $.INSTANCE}static has(z){return v.create(z)}static equals(z,x){return y.create(z,x)}static notEquals(z,x){return k.create(z,x)}static regex(z,x){return B.create(z,x)}static in(z,x){return h.create(z,x)}static notIn(z,x){return D.create(z,x)}static not(z){return C.create(z)}static and(...z){return ce.create(z,null,!0)}static or(...z){return ve.create(z,null,!0)}static greater(z,x){return W.create(z,x)}static greaterEquals(z,x){return V.create(z,x)}static smaller(z,x){return q.create(z,x)}static smallerEquals(z,x){return A.create(z,x)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$wj=t;function g(ne){const z=new u({regexParsingWithErrorRecovery:!1});return ne.map(x=>(z.parse(x),z.lexingErrors.length>0?z.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function a(ne,z){const x=ne?ne.substituteConstants():void 0,be=z?z.substituteConstants():void 0;return!x&&!be?!0:!x||!be?!1:x.equals(be)}function d(ne,z){return ne.cmp(z)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return $.INSTANCE}}e.$zj=w;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return w.INSTANCE}}e.$Aj=$;class v{static create(z,x=null){const be=m.get(z);return typeof be=="boolean"?be?$.INSTANCE:w.INSTANCE:new v(z,x)}constructor(z,x){this.key=z,this.c=x,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=m.get(this.key);return typeof z=="boolean"?z?$.INSTANCE:w.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Bj=v;class y{static create(z,x,be=null){if(typeof x=="boolean")return x?v.create(z,be):C.create(z,be);const Fe=m.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?$.INSTANCE:w.INSTANCE:new y(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=m.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?$.INSTANCE:w.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Cj=y;class h{static create(z,x){return new h(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.f),be=z.getValue(this.d);return Array.isArray(x)?x.includes(be):typeof be=="string"&&typeof x=="object"&&x!==null?T.call(x,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Dj=h;class D{static create(z,x){return new D(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=11,this.c=h.create(z,x)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=D;class k{static create(z,x,be=null){if(typeof x=="boolean")return x?C.create(z,be):v.create(z,be);const Fe=m.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?w.INSTANCE:$.INSTANCE:new k(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=m.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?w.INSTANCE:$.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Fj=k;class C{static create(z,x=null){const be=m.get(z);return typeof be=="boolean"?be?w.INSTANCE:$.INSTANCE:new C(z,x)}constructor(z,x){this.c=z,this.d=x,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=m.get(this.c);return typeof z=="boolean"?z?w.INSTANCE:$.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Gj=C;function I(ne,z){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?z(ne):w.INSTANCE}class W{static create(z,x,be=null){return I(x,Fe=>new W(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Hj=W;class V{static create(z,x,be=null){return I(x,Fe=>new V(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ij=V;class q{static create(z,x,be=null){return I(x,Fe=>new q(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Jj=q;class A{static create(z,x,be=null){return I(x,Fe=>new A(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Kj=A;class B{static create(z,x){return new B(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return x<be?-1:x>be?1:0}equals(z){if(z.type===this.type){const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return this.d===z.d&&x===be}return!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Lj=B;class K{static create(z){return new K(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new K(this.c.map(z))}negate(){return this.c}}e.$Mj=K;function ie(ne){let z=null;for(let x=0,be=ne.length;x<be;x++){const Fe=ne[x].substituteConstants();if(ne[x]!==Fe&&z===null){z=[];for(let De=0;De<x;De++)z[De]=ne[De]}z!==null&&(z[x]=Fe)}return z===null?ne:z}class ce{static create(z,x,be){return ce.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Fe=d(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ce.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].evaluate(z))return!1;return!0}static d(z,x,be){const Fe=[];let De=!1;for(const pe of z)if(pe){if(pe.type===1){De=!0;continue}if(pe.type===0)return w.INSTANCE;if(pe.type===6){Fe.push(...pe.expr);continue}Fe.push(pe)}if(Fe.length===0&&De)return $.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(d);for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const pe=Fe[Fe.length-1];if(pe.type!==9)break;Fe.pop();const ge=Fe.pop(),Q=Fe.length===0,Y=ve.create(pe.expr.map(he=>ce.create([he,ge],null,be)),null,Q);Y&&(Fe.push(Y),Fe.sort(d))}if(Fe.length===1)return Fe[0];if(be){for(let pe=0;pe<Fe.length;pe++)for(let ge=pe+1;ge<Fe.length;ge++)if(Fe[pe].negate().equals(Fe[ge]))return w.INSTANCE;if(Fe.length===1)return Fe[0]}return new ce(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ce(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());this.c=ve.create(z,this,!0)}return this.c}}e.$Nj=ce;class ve{static create(z,x,be){return ve.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Fe=d(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ve.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(this.expr[x].evaluate(z))return!0;return!1}static d(z,x,be){let Fe=[],De=!1;if(z){for(let pe=0,ge=z.length;pe<ge;pe++){const Q=z[pe];if(Q){if(Q.type===0){De=!0;continue}if(Q.type===1)return $.INSTANCE;if(Q.type===9){Fe=Fe.concat(Q.expr);continue}Fe.push(Q)}}if(Fe.length===0&&De)return w.INSTANCE;Fe.sort(d)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];if(be){for(let pe=0;pe<Fe.length;pe++)for(let ge=pe+1;ge<Fe.length;ge++)if(Fe[pe].negate().equals(Fe[ge]))return $.INSTANCE;if(Fe.length===1)return Fe[0]}return new ve(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ve(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());for(;z.length>1;){const x=z.shift(),be=z.shift(),Fe=[];for(const De of Re(x))for(const pe of Re(be))Fe.push(ce.create([De,pe],null,!1));z.unshift(ve.create(Fe,null,!1))}this.c=ve.create(z,this,!0)}return this.c}}e.$Oj=ve;class Se extends v{static{this.d=[]}static all(){return Se.d.values()}constructor(z,x,be){super(z,null),this.f=x,typeof be=="object"?Se.d.push({...be,key:z}):be!==!0&&Se.d.push({key:z,description:be,type:x!=null?typeof x:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return y.create(this.key,z)}notEqualsTo(z){return k.create(this.key,z)}}e.$Pj=Se,e.$Qj=(0,N.$yi)("contextKeyService");function fe(ne,z){return ne<z?-1:ne>z?1:0}function $e(ne,z,x,be){return ne<x?-1:ne>x?1:z<be?-1:z>be?1:0}function Te(ne,z){if(ne.type===0||z.type===1)return!0;if(ne.type===9)return z.type===9?ae(ne.expr,z.expr):!1;if(z.type===9){for(const x of z.expr)if(Te(ne,x))return!0;return!1}if(ne.type===6){if(z.type===6)return ae(z.expr,ne.expr);for(const x of ne.expr)if(Te(x,z))return!0;return!1}return ne.equals(z)}function ae(ne,z){let x=0,be=0;for(;x<ne.length&&be<z.length;){const Fe=ne[x].cmp(z[be]);if(Fe<0)return!1;Fe===0&&x++,be++}return x===ne.length}function Re(ne){return ne.type===9?ne.expr:[ne]}}),define(ke[99],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,P.$yi)("environmentService"),e.$Gi=(0,P.$zi)(e.$Fi)}),define(ke[100],Ie([1,0,163,3]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.ExtensionManagementErrorCode=e.$9o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$3o=M,e.$4o=N,e.$5o=R,e.$6o=p,e.$7o=m,e.$8o=E,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall";function M(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(n,i){return i==="web"&&!n.includes("web")}function m(n,i,c){return p(i,c)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===c}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var T;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var S;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(n){n.Install="install",n.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var b;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$9o=(0,O.$yi)("extensionGalleryService");var f;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));class r extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$0o=r;var s;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class o extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$$o=o,e.$_o=(0,O.$yi)("extensionManagementService"),e.$ap="extensionsIdentifiers/disabled",e.$bp="extensionsIdentifiers/enabled",e.$cp=(0,O.$yi)("IGlobalExtensionEnablementService"),e.$dp=(0,O.$yi)("IExtensionTipsService"),e.$ep=(0,P.localize2)(0,"Extensions"),e.$fp=(0,P.localize2)(1,"Preferences")}),define(ke[38],Ie([1,0,54,19,13,15,2,165,3,23,16,43]),function(le,e,P,O,M,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=l,e.$7k=s,e.$8k=n,e.$9k=i,e.$0k=c,e.$$k=u,e.$_k=t,e.$al=g,e.$bl=a,e.$cl=d,e.$dl=w,e.$fl=y,e.$gl=h,e.$hl=D,e.$il=k,e.$jl=C,e.$ml=A,e.$yl=Se,e.$zl=fe,e.$Bl=Te,e.$5k=(0,m.$yi)("fileService");function l(ae){return ae.create===!0}var b;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var r;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(ae){const Re=ae;return!!Re&&typeof Re.onDidChange=="function"}var o;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(ae){return!!(ae.capabilities&2)}function i(ae){return!!(ae.capabilities&8)}function c(ae){return!!(ae.capabilities&131072)}function u(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function g(ae){return n(ae)?!!(ae.capabilities&16384):!1}function a(ae){return n(ae)?!!(ae.capabilities&32768):!1}function d(ae){return!!(ae.capabilities&65536)}function w(ae){return!!(ae.capabilities&2048)}var $;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})($||(e.FileSystemProviderErrorCode=$={}));class v extends Error{static create(Re,ne){const z=new v(Re.toString(),ne);return D(z,ne),z}constructor(Re,ne){super(Re),this.code=ne}}e.$el=v;function y(ae,Re){return v.create(ae,Re)}function h(ae){return ae||y((0,p.localize)(0,null),$.Unknown)}function D(ae,Re){return ae.name=Re?`${Re} (FileSystemError)`:"FileSystemError",ae}function k(ae){if(!ae)return $.Unknown;if(ae instanceof v)return ae.code;const Re=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Re)return $.Unknown;switch(Re[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}function C(ae){if(ae instanceof B)return ae.fileOperationResult;switch(k(ae)){case $.FileNotFound:return 1;case $.FileIsADirectory:return 0;case $.FileNotADirectory:return 9;case $.FileWriteLocked:return 5;case $.NoPermissions:return 6;case $.FileExists:return 4;case $.FileTooLarge:return 7;default:return 10}}var I;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class W{constructor(Re,ne,z){this.resource=Re,this.operation=ne,this.target=z}isOperation(Re){return this.operation===Re}}e.$kl=W;var V;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Re,ne){this.c=ne,this.b=void 0,this.d=new S.$V(()=>{const z=P.$Ei.forUris(()=>this.c);return z.fill(this.rawAdded.map(x=>[x,!0])),z}),this.f=new S.$V(()=>{const z=P.$Ei.forUris(()=>this.c);return z.fill(this.rawUpdated.map(x=>[x,!0])),z}),this.g=new S.$V(()=>{const z=P.$Ei.forUris(()=>this.c);return z.fill(this.rawDeleted.map(x=>[x,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of Re){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==q.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Re,...ne){return this.h(Re,{includeChildren:!1},...ne)}affects(Re,...ne){return this.h(Re,{includeChildren:!0},...ne)}h(Re,ne,...z){if(!Re)return!1;const x=z.length>0;return!!((!x||z.includes(1))&&(this.d.value.get(Re)||ne.includeChildren&&this.d.value.findSuperstr(Re))||(!x||z.includes(0))&&(this.f.value.get(Re)||ne.includeChildren&&this.f.value.findSuperstr(Re))||(!x||z.includes(2))&&(this.g.value.findSubstr(Re)||ne.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$ll=q;function A(ae,Re,ne){return!ae||!Re||ae===Re||Re.length>ae.length?!1:(Re.charAt(Re.length-1)!==O.sep&&(Re+=O.sep),ne?(0,M.$Af)(ae,Re):ae.indexOf(Re)===0)}class B extends Error{constructor(Re,ne,z){super(Re),this.fileOperationResult=ne,this.options=z}}e.$nl=B;class K extends B{constructor(Re,ne,z,x){super(Re,ne,x),this.fileOperationResult=ne,this.size=z}}e.$ol=K;class ie extends B{constructor(Re,ne,z){super(Re,2,z),this.stat=ne}}e.$pl=ie;var ce;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var ve;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(ve||(e.FileKind=ve={})),e.$xl="";function Se(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function fe(ae,Re){if(!Re.hasProvider(R.URI.from({scheme:ae.scheme})))return new Promise(ne=>{const z=Re.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ae.scheme&&x.added&&(z.dispose(),ne())})})}class $e{static{this.KB=1024}static{this.MB=$e.KB*$e.KB}static{this.GB=$e.MB*$e.KB}static{this.TB=$e.GB*$e.KB}static formatSize(Re){return(0,N.$cg)(Re)||(Re=0),Re<$e.KB?(0,p.localize)(1,null,Re.toFixed(0)):Re<$e.MB?(0,p.localize)(2,null,(Re/$e.KB).toFixed(2)):Re<$e.GB?(0,p.localize)(3,null,(Re/$e.MB).toFixed(2)):Re<$e.TB?(0,p.localize)(4,null,(Re/$e.GB).toFixed(2)):(0,p.localize)(5,null,(Re/$e.TB).toFixed(2))}}e.$Al=$e;function Te(ae){const Re=typeof ae=="string"||ae?.scheme===T.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===T.Schemas.file?1024*$e.MB:Re?10*$e.MB:E.$o?50*$e.MB:1024*$e.MB}}),define(ke[72],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class P{constructor(...M){this.a=new Map;for(const[N,R]of M)this.set(N,R)}set(M,N){const R=this.a.get(M);return this.a.set(M,N),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$wi=P}),define(ke[199],Ie([1,0,11,14,6,71,198,3,72,200]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;const T=!1;class S extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new m.$wi,o=!1,n,i=T){this.i=s,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$xi,this),this._globalGraph=i?n?._globalGraph??new R.$er(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,M.$Pc)(this.h),this.h.clear();for(const s of this.g)(0,M.$Oc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s){this.m();const o=new class extends l{dispose(){this.h.delete(o),super.dispose()}}(s,this.j,this,this.l);return this.h.add(o),o}invokeFunction(s,...o){this.m();const n=f.traceInvocation(this.l,s);let i=!1;try{return s({get:u=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(u,n);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(s,...o){this.m();let n,i;return s instanceof N.$vi?(n=f.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(o),n)):(n=f.traceCreation(this.l,s),i=this.o(s,o,n)),n.stop(),i}o(s,o=[],n){const i=p._util.getServiceDependencies(s).sort((t,g)=>t.index-g.index),c=[];for(const t of i){const g=this.s(t.id,n);g||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(g)}const u=i.length>0?i[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${s.name} at position ${u+1} conflicts with ${o.length} static arguments`);const t=u-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,u)}return Reflect.construct(s,o.concat(c))}q(s,o){if(this.i.get(s)instanceof N.$vi)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const n=this.r(s);return n instanceof N.$vi?this.u(s,n,o.branch(s,!0)):(o.branch(s,!1),n)}u(s,o,n){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,n)}finally{this.t.delete(s)}}v(s,o,n){const i=new R.$er(t=>t.id.toString());let c=0;const u=[{id:s,desc:o,_trace:n}];for(;u.length;){const t=u.pop();if(i.lookupOrInsertNode(t),c++>1e3)throw new S(i);for(const g of p._util.getServiceDependencies(t.desc.ctor)){const a=this.r(g.id);if(a||this.y(`[createInstance] ${s} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(g.id)),a instanceof N.$vi){const d={id:g.id,desc:a,_trace:t._trace.branch(g.id,!0)};i.insertEdge(t,d),u.push(d)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new S(i);break}for(const{data:g}of t){if(this.r(g.id)instanceof N.$vi){const d=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,d)}i.removeNode(g)}}return this.r(s)}w(s,o,n=[],i,c){if(this.i.get(s)instanceof N.$vi)return this.x(s,o,n,i,c,this.g);if(this.k)return this.k.w(s,o,n,i,c);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,n=[],i,c,u){if(i){const t=new l(void 0,this.j,this,this.l);t.c=String(s);const g=new Map,a=new P.$Rh(()=>{const d=t.o(o,n,c);for(const[w,$]of g){const v=d[w];if(typeof v=="function")for(const y of $)y.disposable=v.apply(d,y.listener)}return g.clear(),u.add(d),d});return new Proxy(Object.create(null),{get(d,w){if(!a.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let y=g.get(w);return y||(y=new E.$5c,g.set(w,y)),(D,k,C)=>{if(a.isInitialized)return a.value[w](D,k,C);{const I={listener:[D,k,C],disposable:void 0},W=y.push(I);return(0,M.$Sc)(()=>{W(),I.disposable?.dispose()})}}}if(w in d)return d[w];const $=a.value;let v=$[w];return typeof v!="function"||(v=v.bind($),d[w]=v),v},set(d,w,$){return a.value[w]=$,!0},getPrototypeOf(d){return o.prototype}})}else{const t=this.o(o,n,c);return u.add(t),t}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$fr=l;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new f(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(s,o){return s?new f(1,o.name):f.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const n=new f(3,s.toString());return this.h.push([s,o,n]),n}stop(){const s=Date.now()-this.g;f.f+=s;let o=!1;function n(c,u){const t=[],g=new Array(c+1).join("	");for(const[a,d,w]of u.h)if(d&&w){o=!0,t.push(`${g}CREATES -> ${a}`);const $=n(c+1,w);$&&t.push($)}else t.push(`${g}uses -> ${a}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(s>2||o)&&f.all.add(i.join(`
`))}}e.$gr=f}),define(ke[12],Ie([1,0,166,44,5,73,6,28,23,24,15,2,31,3]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=r,e.log=o,e.$gk=v,e.$hk=y,e.$ik=h,e.$jk=D,e.$5j=(0,b.$yi)("logService"),e.$6j=(0,b.$yi)("loggerService");function f(){return new Date().toISOString()}function r(k){return(0,T.$cg)(k)}var s;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$8j=s.Info;function o(k,C,I){switch(C){case s.Trace:k.trace(I);break;case s.Debug:k.debug(I);break;case s.Info:k.info(I);break;case s.Warning:k.warn(I);break;case s.Error:k.error(I);break;case s.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(k,C=!1){let I="";for(let W=0;W<k.length;W++){let V=k[W];if(V instanceof Error&&(V=(0,O.$jj)(V,C)),typeof V=="object")try{V=JSON.stringify(V)}catch{}I+=(W>0?" ":"")+V}return I}class i extends R.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new M.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==s.Off&&this.b<=C}}e.$0j=i;class c extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(s.Trace)&&this.g(s.Trace,n([C,...I],!0))}debug(C,...I){this.f(s.Debug)&&this.g(s.Debug,n([C,...I]))}info(C,...I){this.f(s.Info)&&this.g(s.Info,n([C,...I]))}warn(C,...I){this.f(s.Warning)&&this.g(s.Warning,n([C,...I]))}error(C,...I){if(this.f(s.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(s.Error,n(W))}else this.g(s.Error,n([C,...I]))}flush(){}}e.$$j=c;class u extends i{constructor(C=e.$8j){super(),this.setLevel(C),this.g=!m.$i}trace(C,...I){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...I):console.log(`[main ${f()}]`,C,...I))}debug(C,...I){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...I):console.log(`[main ${f()}]`,C,...I))}info(C,...I){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...I):console.log(`[main ${f()}]`,C,...I))}warn(C,...I){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,C,...I):console.warn(`[main ${f()}]`,C,...I))}error(C,...I){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,C,...I):console.error(`[main ${f()}]`,C,...I))}flush(){}}e.$_j=u;class t extends i{constructor(C=e.$8j,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$ak=t;class g extends i{constructor(C,I=e.$8j){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(C),...I])}debug(C,...I){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(C),...I])}info(C,...I){this.f(s.Info)&&this.g.log(s.Info,[this.h(C),...I])}warn(C,...I){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(C),...I])}error(C,...I){this.f(s.Error)&&this.g.log(s.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,O.$jj)(C,this.f(s.Trace))}flush(){}}e.$bk=g;class a extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const W of this.g)W.trace(C,...I)}debug(C,...I){for(const W of this.g)W.debug(C,...I)}info(C,...I){for(const W of this.g)W.info(C,...I)}warn(C,...I){for(const W of this.g)W.warn(C,...I)}error(C,...I){for(const W of this.g)W.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ck=a;class d extends R.$Uc{constructor(C,I,W){if(super(),this.h=C,this.j=I,this.b=new p.$Ac,this.c=this.B(new M.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$fe),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(C){return(0,T.$$f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const W=this.n(C),V=(0,T.$$f)(C)?C:I?.id??(0,N.$mj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const A=I?.logLevel==="always"?s.Trace:I?.logLevel;q||(q=this.s(W,A??this.getLogLevel(W)??this.h,{...I,id:V}));const B={logger:q,info:{resource:W,id:V,logLevel:A,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(B.info),this.b.set(W,B),q}n(C){return(0,T.$$f)(C)?(0,E.$_g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(S.URI.isUri(C)){const W=C,V=I,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=C;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const W=this.m(C);W&&I!==!W.info.hidden&&(W.info.hidden=!I,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=d;class w{constructor(){this.onDidChangeLogLevel=new M.$fe().event}setLevel(C){}getLevel(){return s.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$ek=w;class $ extends w{}e.$fk=$;function v(k){if(k.verbose)return s.Trace;if(typeof k.logLevel=="string"){const C=D(k.logLevel.toLowerCase());if(C!==void 0)return C}return e.$8j}function y(k){switch(k){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function h(k){switch(k){case s.Trace:return{original:"Trace",value:P.localize(0,null)};case s.Debug:return{original:"Debug",value:P.localize(1,null)};case s.Info:return{original:"Info",value:P.localize(2,null)};case s.Warning:return{original:"Warning",value:P.localize(3,null)};case s.Error:return{original:"Error",value:P.localize(4,null)};case s.Off:return{original:"Off",value:P.localize(5,null)}}}function D(k){switch(k){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$kk=new l.$Pj("logLevel",y(s.Info))}),define(ke[201],Ie([1,0,6,12]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=void 0;class M extends P.$Uc{constructor(R,p=[]){super(),this.a=new O.$ck([R,...p]),this.B(R.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...p){this.a.trace(R,...p)}debug(R,...p){this.a.debug(R,...p)}info(R,...p){this.a.info(R,...p)}warn(R,...p){this.a.warn(R,...p)}error(R,...p){this.a.error(R,...p)}flush(){this.a.flush()}}e.$0P=M}),define(ke[101],Ie([1,0,32,167,3]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(m){function E(f,r){return r-f}m.compare=E;const T=Object.create(null);T[m.Error]=(0,O.localize)(0,null),T[m.Warning]=(0,O.localize)(1,null),T[m.Info]=(0,O.localize)(2,null);function S(f){return T[f]||""}m.toString=S;function l(f){switch(f){case P.default.Error:return m.Error;case P.default.Warning:return m.Warning;case P.default.Info:return m.Info;case P.default.Ignore:return m.Hint}}m.fromSeverity=l;function b(f){switch(f){case m.Error:return P.default.Error;case m.Warning:return P.default.Warning;case m.Info:return P.default.Info;case m.Hint:return P.default.Ignore}}m.toSeverity=b}(R||(e.MarkerSeverity=R={}));var p;(function(m){const E="";function T(l){return S(l,!0)}m.makeKey=T;function S(l,b){const f=[E];return l.source?f.push(l.source.replace("\xA6","\\\xA6")):f.push(E),l.code?typeof l.code=="string"?f.push(l.code.replace("\xA6","\\\xA6")):f.push(l.code.value.replace("\xA6","\\\xA6")):f.push(E),l.severity!==void 0&&l.severity!==null?f.push(R.toString(l.severity)):f.push(E),l.message&&b?f.push(l.message.replace("\xA6","\\\xA6")):f.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?f.push(l.startLineNumber.toString()):f.push(E),l.startColumn!==void 0&&l.startColumn!==null?f.push(l.startColumn.toString()):f.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?f.push(l.endLineNumber.toString()):f.push(E),l.endColumn!==void 0&&l.endColumn!==null?f.push(l.endColumn.toString()):f.push(E),f.push(E),f.join("\xA6")}m.makeKeyOptionalMessage=S})(p||(e.IMarkerData=p={})),e.$0t=(0,M.$yi)("markerService")}),define(ke[202],Ie([1,0,5,32,3]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$aw=e.Severity=void 0,e.$bw=p,e.Severity=O.default,e.$aw=(0,M.$yi)("notificationService");var N;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function p(S){if(S){const l=S;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var m;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new T,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$cw=E;class T{infinite(){}done(){}total(l){}worked(l){}}e.$dw=T}),define(ke[102],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,P.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,P,O){var M=arguments.length,N=M<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,P):O,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(le,e,P,O);else for(var p=le.length-1;p>=0;p--)(R=le[p])&&(N=(M<3?R(N):M>3?R(e,P,N):R(e,P))||N);return M>3&&N&&Object.defineProperty(e,P,N),N},We=this&&this.__param||function(le,e){return function(P,O){e(P,O,le)}};define(ke[103],Ie([1,0,11,20,6,3]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.ProgressLocation=e.$ew=void 0,e.$ew=(0,N.$yi)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$fw=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$gw=p;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const b=this.d;this.d=()=>{b?.(),l()}}):Promise.resolve()}}e.$hw=m;let E=class extends M.$Uc{constructor(l,b){super(),this.a=new P.$Vh,b.withProgress(l,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$iw=E,e.$iw=E=Je([We(1,e.$ew)],E);class T extends M.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new M.$Tc)}start(l){this.stop();const b=++this.a,f=new O.$qe;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>f.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:f.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$jw=T,e.$kw=(0,N.$yi)("editorProgressService")}),define(ke[29],Ie([1,0,57,15]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class M{constructor(){this.a=new Map}add(R,p){P.ok(O.$$f(R)),P.ok(O.$ag(p)),P.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,p)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$fo=new M}),define(ke[74],Ie([1,0,5,29]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function M(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class N{constructor(){this.b=new P.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[M(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const R=new N;O.$fo.add(e.$go.JSONContribution,R)}),define(ke[51],Ie([1,0,18,5,15,160,50,74,29]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=r,e.$wo=s,e.$xo=o,e.$yo=i,e.$zo=c;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ko={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const S=m.$fo.as(p.$go.JSONContribution);class l{constructor(){this.h=new Set,this.i=new O.$fe,this.onDidSchemaChange=this.i.event,this.j=new O.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,g=!0){this.registerConfigurations([t],g)}registerConfigurations(t,g=!0){const a=new Set;this.n(t,g,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const g=new Set;this.o(t,g),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:t,remove:g}){const a=new Set;this.o(g,a),this.n(t,!1,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const g=new Set;this.k(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(t,g){const a=[];for(const{overrides:d,source:w}of t)for(const $ in d)if(g.add($),e.$uo.test($)){const v=this.a.get($),y=v?.valuesSources??new Map;if(w)for(const C of Object.keys(d[$]))y.set(C,w);const h={...v?.value||{},...d[$]};this.a.set($,{source:w,value:h,valuesSources:y});const D=(0,R.$cj)($),k={type:"object",default:h,description:N.localize(1,null,D),$ref:e.$ro,defaultDefaultValue:h,source:M.$$f(w)?void 0:w,defaultValueSource:w};a.push(...r($)),this.d[$]=k,this.b.properties[$]=k}else{this.a.set($,{value:d[$],source:w});const v=this.d[$];v&&(this.w($,v),this.r($,v))}this.m(a)}deregisterDefaultConfigurations(t){const g=new Set;this.l(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(t,g){for(const{overrides:a,source:d}of t)for(const w in a){const $=this.a.get(w),v=M.$$f(d)?d:d?.id,y=M.$$f($?.source)?$?.source:$?.source?.id;if(v===y)if(g.add(w),this.a.delete(w),e.$uo.test(w))delete this.d[w],delete this.b.properties[w];else{const h=this.d[w];h&&(this.w(w,h),this.r(w,h))}}this.u()}deltaConfiguration(t){let g=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),g=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),g=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const g of t)this.h.add(g);this.u()}n(t,g,a){t.forEach(d=>{this.p(d,g,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(t,g){const a=d=>{if(d.properties)for(const w in d.properties){g.add(w);const $=this.d[w];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[w],this.s(w,d.properties[w])}d.allOf?.forEach(w=>a(w))};for(const d of t){a(d);const w=this.c.indexOf(d);w!==-1&&this.c.splice(w,1)}}p(t,g=!0,a,d,w=3,$){w=M.$hg(t.scope)?w:t.scope;const v=t.properties;if(v)for(const h in v){const D=v[h];if(g&&i(h,D)){delete v[h];continue}if(D.source=a,D.defaultDefaultValue=v[h].default,this.w(h,D),e.$uo.test(h)?D.scope=void 0:(D.scope=M.$hg(D.scope)?w:D.scope,D.restricted=M.$hg(D.restricted)?!!d?.includes(h):D.restricted),v[h].hasOwnProperty("included")&&!v[h].included){this.f[h]=v[h],delete v[h];continue}else this.d[h]=v[h],v[h].policy?.name&&this.e.set(v[h].policy.name,h);!v[h].deprecationMessage&&v[h].markdownDeprecationMessage&&(v[h].deprecationMessage=v[h].markdownDeprecationMessage),$.add(h)}const y=t.allOf;if(y)for(const h of y)this.p(h,g,a,d,w,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const g=a=>{const d=a.properties;if(d)for(const $ in d)this.r($,d[$]);a.allOf?.forEach(g)};g(t)}r(t,g){switch(e.$lo.properties[t]=g,g.scope){case 1:e.$mo.properties[t]=g;break;case 2:e.$no.properties[t]=g;break;case 6:e.$oo.properties[t]=g;break;case 3:e.$po.properties[t]=g;break;case 4:e.$qo.properties[t]=g;break;case 5:e.$qo.properties[t]=g,this.g.properties[t]=g;break}}s(t,g){switch(delete e.$lo.properties[t],g.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const g=`[${t}]`,a={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ro};this.w(g,a),e.$lo.properties[g]=a,e.$mo.properties[g]=a,e.$no.properties[g]=a,e.$oo.properties[g]=a,e.$po.properties[g]=a,e.$qo.properties[g]=a}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,g){const a=this.a.get(t);let d=a?.value,w=a?.source;M.$fg(d)&&(d=g.defaultDefaultValue,w=void 0),M.$fg(d)&&(d=o(g.type)),g.default=d,g.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.$to=`^(${b})+$`,e.$uo=new RegExp(e.$to);function r(u){const t=[];if(e.$uo.test(u)){let g=f.exec(u);for(;g?.length;){const a=g[1].trim();a&&t.push(a),g=f.exec(u)}}return(0,P.$Mb)(t)}function s(u){return u.reduce((t,g)=>`${t}[${g}]`,"")}function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new l;m.$fo.add(e.$ko.Configuration,n);function i(u,t){return u.trim()?e.$uo.test(u)?N.localize(7,null,u):n.getConfigurationProperties()[u]!==void 0?N.localize(8,null,u):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,u,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function c(){const u=[],t=n.getConfigurationProperties();for(const g of Object.keys(t))u.push([g,t[g].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(ke[203],Ie([1,0,18,5,126,6,28,26,15,2,50,51,29]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=i;function b(g){return Object.isFrozen(g)?g:p.$6n(g)}class f{static createEmptyModel(a){return new f({},[],[],void 0,a)}constructor(a,d,w,$,v){this.b=a,this.c=d,this.d=w,this.raw=$,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof f)return d;const w=new r("",this.f);return w.parseRaw(d),w.configurationModel});this.g=a.reduce((d,w)=>w===d?w:d.merge(w),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$aj)(this.contents,a):this.contents}inspect(a,d){const w=this;return{get value(){return b(w.rawConfiguration.getValue(a))},get override(){return d?b(w.rawConfiguration.getOverrideValue(a,d)):void 0},get merged(){return b(d?w.rawConfiguration.override(d).getValue(a):w.rawConfiguration.getValue(a))},get overrides(){const $=[];for(const{contents:v,identifiers:y,keys:h}of w.rawConfiguration.overrides){const D=new f(v,h,[],void 0,w.f).getValue(a);D!==void 0&&$.push({identifiers:y,value:D})}return $.length?b($):void 0}}}getOverrideValue(a,d){const w=this.j(d);return w?a?(0,T.$aj)(w,a):w:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const w of this.overrides)w.identifiers.includes(a)&&d.push(...w.keys);return P.$Mb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return P.$Mb(a)}override(a){let d=this.a.get(a);return d||(d=this.h(a),this.a.set(a,d)),d}merge(...a){const d=p.$5n(this.contents),w=p.$5n(this.overrides),$=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const y of a)if(v.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(d,y.contents);for(const h of y.overrides){const[D]=w.filter(k=>P.$ub(k.identifiers,h.identifiers));D?(this.i(D.contents,h.contents),D.keys.push(...h.keys),D.keys=P.$Mb(D.keys)):w.push(p.$5n(h))}for(const h of y.keys)$.indexOf(h)===-1&&$.push(h)}return new f(d,$,w,v.every(y=>y instanceof f)?void 0:v,this.f)}h(a){const d=this.j(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const w={};for(const $ of P.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let v=this.contents[$];const y=d[$];y&&(typeof v=="object"&&typeof y=="object"?(v=p.$5n(v),this.i(v,y)):v=y),w[$]=v}return new f(w,this.keys,this.overrides,void 0,this.f)}i(a,d){for(const w of Object.keys(d)){if(w in a&&m.$ag(a[w])&&m.$ag(d[w])){this.i(a[w],d[w]);continue}a[w]=p.$5n(d[w])}}j(a){let d=null,w=null;const $=v=>{v&&(w?this.i(w,v):w=p.$5n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===a?d=v.contents:v.identifiers.includes(a)&&$(v.contents);return $(d),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.k(a,d,!0)}setValue(a,d){this.k(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,T.$_i)(this.contents,a),S.$uo.test(a)&&this.overrides.splice(this.overrides.findIndex(w=>P.$ub(w.identifiers,(0,S.$vo)(a))),1))}k(a,d,w){(0,T.$$i)(this.contents,a,d,$=>this.f.error($)),w=w||this.keys.indexOf(a)===-1,w&&this.keys.push(a),S.$uo.test(a)&&this.overrides.push({identifiers:(0,S.$vo)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$0i)(this.contents[a],$=>this.f.error($))})}}e.$Ao=f;class r{constructor(a,d){this.f=a,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!m.$hg(a)){const w=this.h(a);this.parseRaw(w,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:w,keys:$,overrides:v,restricted:y,hasExcludedProperties:h}=this.i(a,d);this.b=new f(w,$,v,h?[a]:void 0,this.g),this.c=y||[]}h(a){let d={},w=null,$=[];const v=[],y=[];function h(k){Array.isArray($)?$.push(k):w!==null&&($[w]=k)}const D={onObjectBegin:()=>{const k={};h(k),v.push($),$=k,w=null},onObjectProperty:k=>{w=k},onObjectEnd:()=>{$=v.pop()},onArrayBegin:()=>{const k=[];h(k),v.push($),$=k,w=null},onArrayEnd:()=>{$=v.pop()},onLiteralValue:h,onError:(k,C,I)=>{y.push({error:k,offset:C,length:I})}};if(a)try{M.$Sn(a,D),d=$[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return d}i(a,d){const w=l.$fo.as(S.$ko.Configuration).getConfigurationProperties(),$=this.j(a,w,!0,d);a=$.raw;const v=(0,T.$0i)(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),y=Object.keys(a),h=this.l(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:v,keys:y,overrides:h,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}j(a,d,w,$){let v=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:v};const y={},h=[];for(const D in a)if(S.$uo.test(D)&&w){const k=this.j(a[D],d,!1,$);y[D]=k.raw,v=v||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=d[D],C=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(D),!$.exclude?.includes(D)&&($.include?.includes(D)||(C===void 0||$.scopes===void 0||$.scopes.includes(C))&&!($.skipRestricted&&k?.restricted))?y[D]=a[D]:v=!0}return{raw:y,restricted:h,hasExcludedProperties:v}}l(a,d){const w=[];for(const $ of Object.keys(a))if(S.$uo.test($)){const v={};for(const y in a[$])v[y]=a[$][y];w.push({identifiers:(0,S.$vo)($),keys:Object.keys(v),contents:(0,T.$0i)(v,d)})}return w}}e.$Bo=r;class s extends N.$Uc{constructor(a,d,w,$,v){super(),this.c=a,this.f=d,this.g=$,this.h=v,this.b=this.B(new O.$fe),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),v),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&w.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=s;class o{constructor(a,d,w,$,v,y,h,D,k,C,I,W,V){this.a=a,this.b=d,this.c=w,this.overrideIdentifiers=$,this.d=v,this.f=y,this.g=h,this.h=D,this.i=k,this.j=C,this.k=I,this.l=W,this.m=V}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,d,w,$,v,y,h,D,k,C){this.j=a,this.l=d,this.m=w,this.n=$,this.p=v,this.q=y,this.r=h,this.s=D,this.t=k,this.u=C,this.h=null,this.i=new R.$Ac,this.v=null}getValue(a,d,w){return this.w(a,d,w).getValue(a)}updateValue(a,d,w={}){let $;w.resource?($=this.t.get(w.resource),$||($=f.createEmptyModel(this.u),this.t.set(w.resource,$))):$=this.s,d===void 0?$.removeValue(a):$.setValue(a,d),w.resource||(this.h=null)}inspect(a,d,w){const $=this.w(a,d,w),v=this.A(d.resource,w),y=d.resource?this.t.get(d.resource)||this.s:this.s,h=new Set;for(const D of $.overrides)for(const k of D.identifiers)$.getOverrideValue(a,k)!==void 0&&h.add(k);return new o(a,d,$.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.q:void 0,v||void 0,y)}keys(a){const d=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,d){this.r.set(a,d),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const w=[];if(!d){const{added:$,updated:v,removed:y}=u(this.j,a);d=[...$,...v,...y]}for(const $ of d)for(const v of(0,S.$vo)($)){const y=this.j.getKeysForOverrideIdentifier(v),h=a.getKeysForOverrideIdentifier(v),D=[...h.filter(k=>y.indexOf(k)===-1),...y.filter(k=>h.indexOf(k)===-1),...y.filter(k=>!p.$9n(this.j.override(v).getValue(k),a.override(v).getValue(k)))];w.push([v,D])}return this.updateDefaultConfiguration(a),{keys:d,overrides:w}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:w,removed:$}=u(this.l,a),v=[...d,...w,...$];return v.length&&this.updatePolicyConfiguration(a),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.applicationConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:v}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.localUserConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.remoteUserConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.workspaceConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:v}}compareAndUpdateFolderConfiguration(a,d){const w=this.folderConfigurations.get(a),{added:$,updated:v,removed:y,overrides:h}=u(w,d),D=[...$,...v,...y];return(D.length||!w)&&this.updateFolderConfiguration(a,d),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:w,updated:$,removed:v,overrides:y}=u(d,void 0);return{keys:[...w,...$,...v],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,d,w){let $=this.x(d,w);return d.overrideIdentifier&&($=$.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&($=$.merge(this.l)),$}x({resource:a},d){let w=this.y();if(d&&a){const $=d.getFolder(a);$&&(w=this.z($.uri)||w);const v=this.t.get(a);v&&(w=w.merge(v))}return w}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let d=this.i.get(a);if(!d){const w=this.y(),$=this.r.get(a);$?(d=w.merge($),this.i.set(a,d)):d=w}return d}A(a,d){if(d&&a){const w=d.getFolder(a);if(w)return this.r.get(w.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,d)=>{const{contents:w,overrides:$,keys:v}=this.r.get(d);return a.push([d,{contents:w,overrides:$,keys:v}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.q.keys.forEach(d=>a.add(d)),this.r.forEach(d=>d.keys.forEach(w=>a.add(w))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach(w=>a.add(w))),[...a.values()]}D(a){const d=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(w=>d.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(w=>d.add(w)),this.q.getKeysForOverrideIdentifier(a).forEach(w=>d.add(w)),this.r.forEach(w=>w.getKeysForOverrideIdentifier(a).forEach($=>d.add($))),[...d.values()]}static parse(a,d){const w=this.E(a.defaults,d),$=this.E(a.policy,d),v=this.E(a.application,d),y=this.E(a.user,d),h=this.E(a.workspace,d),D=a.folders.reduce((k,C)=>(k.set(E.URI.revive(C[0]),this.E(C[1],d)),k),new R.$Ac);return new n(w,$,v,y,f.createEmptyModel(d),h,D,f.createEmptyModel(d),new R.$Ac,d)}static E(a,d){return new f(a.contents,a.keys,a.overrides,void 0,d)}}e.$Do=n;function i(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const a=new Set,d=new Map;for(const $ of g)$.keys.forEach(v=>a.add(v)),$.overrides.forEach(([v,y])=>{const h=(0,R.$xc)(d,v,new Set);y.forEach(D=>h.add(D))});const w=[];return d.forEach(($,v)=>w.push([v,[...$.values()]])),{keys:[...a.values()],overrides:w}}class c{constructor(a,d,w,$,v){this.change=a,this.f=d,this.g=w,this.h=$,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,d){const w=this.a+a,$=this.d.indexOf(w);if($<0)return!1;const v=$+w.length;if(v>=this.d.length)return!1;const y=this.d.charCodeAt(v);if(y!==this.b&&y!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,D=this.g.getValue(a,d,this.h);return!p.$9n(h,D)}return!0}}e.$Fo=c;function u(g,a){const{added:d,removed:w,updated:$}=t(a?.rawConfiguration,g?.rawConfiguration),v=[],y=g?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const D=h.filter(k=>!y.includes(k));for(const k of D)v.push([k,a.getKeysForOverrideIdentifier(k)])}if(g){const D=y.filter(k=>!h.includes(k));for(const k of D)v.push([k,g.getKeysForOverrideIdentifier(k)])}if(a&&g){for(const D of y)if(h.includes(D)){const k=t({contents:g.getOverrideValue(void 0,D)||{},keys:g.getKeysForOverrideIdentifier(D)},{contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)});v.push([D,[...k.added,...k.removed,...k.updated]])}}return{added:d,removed:w,updated:$,overrides:v}}function t(g,a){const d=g?a?g.keys.filter(v=>a.keys.indexOf(v)===-1):[...g.keys]:[],w=a?g?a.keys.filter(v=>g.keys.indexOf(v)===-1):[...a.keys]:[],$=[];if(g&&a){for(const v of a.keys)if(g.keys.indexOf(v)!==-1){const y=(0,T.$aj)(a.contents,v),h=(0,T.$aj)(g.contents,v);p.$9n(y,h)||$.push(v)}}return{added:d,removed:w,updated:$}}}),define(ke[104],Ie([1,0,14,3]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=E,e.$Jl=(0,O.$yi)("remoteAuthorityResolverService");var M;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class N{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=N;class R{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=R;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class m extends P.$bb{static isNotAvailable(S){return S instanceof m&&S._code===p.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===p.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===p.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===p.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,l=p.Unknown,b){super(S),this._message=S,this._code=l,this._detail=b,this.isHandled=l===p.NotAvailable&&b===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Ml=m;function E(T){const S=T.indexOf("+");return S===-1?T:T.substring(0,S)}}),define(ke[58],Ie([1,0,16]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=O,e.$Km=M,e.$Lm=N,e.$Mm=R;function O(m){return m.scheme===P.Schemas.vscodeRemote?m.authority:void 0}function M(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function N(m){const{host:E,port:T}=p(m);if(typeof T>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function R(m,E){let{host:T,port:S}=p(m);return typeof S>"u"&&(S=E),{host:T,port:S}}function p(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=m.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(ke[21],Ie([1,0,13,3,58]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=N,e.$Wm=S,e.$Xm=l,e.$Ym=b,e.$Zm=f,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var p;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class m{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const n=typeof s=="string"?s:s.value,i=typeof o=="string"?o:o.value;return P.$zf(n,i)}return s._lower===o._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$Tm=m;class E{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const o of s)this.add(o)}add(s){this.c.add(m.toKey(s))}delete(s){return this.c.delete(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}}e.$Um=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(m.toKey(s))}get(s){return this.c.get(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}set(s,o){this.c.set(m.toKey(s),o)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=T;function S(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function b(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function f(r,s){if(s){const o=`onResolveRemoteAuthority:${(0,M.$Km)(s)}`;return!!r.activationEvents?.includes(o)}return!1}e.$1m=(0,O.$yi)("IBuiltinExtensionsScannerService")}),define(ke[105],Ie([1,0,14,21]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=e.$wG=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,p){this.a.set(R,p)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const p=Object.create(null);for(const m of R){const E=this.readActivationEvents(m);E.length>0&&(p[O.$Tm.toKey(m.identifier)]=E)}return p}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const p=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let m=0;m<p.length;m++)p[m]==="onUri"&&(p[m]=`onUri:${O.$Tm.toKey(R.identifier)}`);if(!R.contributes)return p;for(const m in R.contributes){const E=this.a.get(m);if(!E)continue;const T=R.contributes[m],S=Array.isArray(T)?T:[T];try{E(S,p)}catch(l){(0,P.$1)(l)}}return p}}e.$wG=M,e.$xG=new M}),define(ke[204],Ie([1,0,22,14,6,168,51,3,12,29]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Sp=l,e.$Tp=b,e.$Up=f,e.$Vp=r,e.$Wp=s,e.$Xp=o,e.$Qp=(0,p.$yi)("requestService");class T{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class S extends M.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,N.localize)(0,null),when:m.$kk.isEqualTo((0,m.$hk)(m.LogLevel.Trace)).serialize()})}async c(u,t,g){const a=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new T(t.headers??{}));try{const d=await g();return this.a.trace(`${a} - end`,t.type,d.res.statusCode,d.res.headers),d}catch(d){throw this.a.error(`${a} - error`,t.type,(0,O.$0)(d)),d}}}e.$Rp=S;function l(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function b(c){return c.res.statusCode===204}async function f(c){return b(c)?null:(await(0,P.$Te)(c.stream)).toString()}async function r(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);return f(c)}async function s(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);if(b(c))return null;const t=(await(0,P.$Te)(c.stream)).toString();try{return JSON.parse(t)}catch(g){throw g.message+=`:
`+t,g}}function o(c){i(c)}let n;function i(c){const u=E.$fo.as(R.$ko.Configuration),t=n;n={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(ke[205],Ie([1,0,23,75,33]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=R,e.$hp=p;function N(m){if(P.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function R(m,E,T,S,l,b,f,r,s){const o=Object.create(null);o["common.machineId"]=b,o["common.sqmId"]=f,o.sessionID=(0,M.$Ug)()+Date.now(),o.commitHash=S,o.version=l,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,P.$h)(P.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=T,o["common.product"]=s||"desktop",r&&(o["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),P.$l&&(o["common.snap"]="true");const c=N(E);return c&&(o["common.platformDetail"]=c),o}function p(m){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return m.some(S=>T===S)}}),define(ke[206],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,P.$yi)("telemetryService"),e.$5l=(0,P.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var M;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(ke[59],Ie([1,0,26,15,58,205,206]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=void 0,e.$pp=T,e.$qp=S,e.$rp=l,e.$sp=b,e.$tp=r,e.$up=o,e.$vp=n,e.$wp=u;class p{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$ip=p;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$jp=m,e.$kp=new m;class E{async publicLog(g,a,d){}async publicLogError(g,a,d){}}e.$lp=E,e.$mp="telemetry",e.$np="extensionTelemetryLog",e.$op={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!t.enableTelemetry)}function S(t,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const g=t.getValue(R.$_l),a=t.getValue(R.$am);if(t.getValue(R.$bm)===!1||a===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const g={},a={},d={};s(t,d);for(let w in d){w=w.length>150?w.substr(w.length-149):w;const $=d[w];typeof $=="number"?a[w]=$:typeof $=="boolean"?a[w]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${$.length}`),g[w]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(g[w]=$)}return{properties:g,measurements:a}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const g=(0,M.$Km)(t);return f.has(g)?g:"other"}function s(t,g,a=0,d){if(t)for(const w of Object.getOwnPropertyNames(t)){const $=t[w],v=d?d+w:w;Array.isArray($)?g[v]=(0,P.$0n)($):$ instanceof Date?g[v]=$.toISOString():(0,O.$ag)($)?a<2?s($,g,a+1,v+"."):g[v]=(0,P.$0n)($):g[v]=$}}function o(t,g){const a=t.msftInternalDomains||[],d=g.getValue("telemetry.internalTesting");return(0,N.$hp)(a)||d}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,g){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const d=[];for(const y of g)for(;;){const h=y.exec(t);if(!h)break;d.push([h.index,y.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const y=$.exec(t);if(!y)break;const h=d.some(([D,k])=>y.index<k&&D<$.lastIndex);!w.test(y[0])&&!h&&(a+=t.substring(v,y.index)+"<REDACTED: user-file-path>",v=$.lastIndex)}return v<t.length&&(a+=t.substr(v)),a}function c(t){if(!t)return t;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of g)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function u(t,g){return(0,P.$7n)(t,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let d=a.replaceAll("%20"," ");d=i(d,g);for(const w of g)d=d.replace(w,"");return d=c(d),d}})}}),define(ke[207],Ie([1,0,13,100,21,23,2,14,75,59]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$yp=void 0,e.$xp=T,e.$zp=f,e.$Ap=r,e.$Bp=s,e.$Cp=o,e.$Dp=n,e.$Ep=i,e.$Fp=c,e.$Hp=u,e.$Ip=g;function T(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,P.$uf)(a.id,d.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const w=d.manifest?d.manifest.version:d.version,$=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,w,$)}static parse(d){const w=S.exec(d);return w&&w[1]&&w[2]?new l({id:w[1]},w[2],w[4]||void 0):null}constructor(d,w,$="undefined"){this.version=w,this.targetPlatform=$,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?T(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$yp=l;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(a){const d=b.exec(a);return d&&d[1]?[s(d[1]),d[2]]:[s(a),void 0]}function r(a,d){return`${a}.${d}`}function s(a){return a.toLowerCase()}function o(a,d){return s(r(a??M.$Pm,d))}function n(a,d){const w=[],$=v=>{for(const y of w)if(y.some(h=>T(d(h),d(v))))return y;return null};for(const v of a){const y=$(v);y?y.push(v):w.push([v])}return w}function i(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$ip(a.identifier.id),name:new E.$ip(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Gp=new M.$Tm("pprice.better-merge");function u(a,d){const w=[],$=d.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const v=$.shift();if(v&&w.every(y=>!T(y.identifier,{id:v}))){const y=a.filter(h=>T(h.identifier,{id:v}));y.length===1&&(w.push(y[0]),$.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(a,d){if(!N.$k)return!1;let w;try{w=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){d.debug("Error while getting the os-release file.",(0,p.$0)(v))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(a,d){const w=await t(a,d),$=(0,O.$5o)(w?"alpine":N.$u,m.$ec);return d.debug("ComputeTargetPlatform:",$),$}}),define(ke[208],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=P,e.$ps=O,e.$qs=M,e.$rs=N,e.$ss=R,e.$ts=p;function P(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function M(m){return new Map(m)}function N(m){return new Map(m??[])}function R(m){return Array.from(m.entries()).map(E=>[E[0],P(E[1].map),O(E[1].descriptionMap)])}function p(m){return new Map(m.map(E=>[E[0],{map:M(E[1]),descriptionMap:N(E[2])}]))}}),define(ke[209],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yvb=void 0;class P{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,N,R=5){const p=N(m=>{const E=typeof m=="string"?m:m.data;let T=this.a.get(M);if(T){T.data.push(E);return}const S=setTimeout(()=>this.flushBuffer(M),R);T={data:[E],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(M),p.dispose()}},this.a.set(M,T)});return p}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const N=this.a.get(M);N&&(this.a.delete(M),this.b(M,N.data.join("")))}}e.$Yvb=P}),define(ke[210],Ie([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,P,O,M,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$px=e.$ox=e.$nx=e.$mx=e.$lx=e.$kx=e.IconFontDefinition=e.IconContribution=e.$hx=void 0,e.$ix=s,e.$jx=o,e.$hx={IconContribution:"base.contributions.icons"};var l;(function(u){function t(g,a){let d=g.defaults;for(;N.ThemeIcon.isThemeIcon(d);){const w=r.getIcon(d.id);if(!w)return;d=w.defaults}return d}u.getDefinition=t})(l||(e.IconContribution=l={}));var b;(function(u){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(d=>({format:d.format,location:d.location.toString()}))}}u.toJSONObject=t;function g(a){const d=w=>(0,p.$$f)(w)?w:void 0;if(a&&Array.isArray(a.src)&&a.src.every(w=>(0,p.$$f)(w.format)&&(0,p.$$f)(w.location)))return{weight:d(a.weight),style:d(a.style),src:a.src.map(w=>({format:w.format,location:m.URI.parse(w.location)}))}}u.fromJSONObject=g})(b||(e.IconFontDefinition=b={}));class f{constructor(){this.a=new R.$fe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,g,a,d){const w=this.b[t];if(w){if(a&&!w.description){w.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return w}const $={id:t,description:a,defaults:g,deprecationMessage:d};this.b[t]=$;const v={$ref:"#/definitions/icons"};return d&&(v.deprecationMessage=d),a&&(v.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=v,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const g=this.e.enum.indexOf(t);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,g){const a=this.f[t];return a||(this.f[t]=g,this.a.fire(),g)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,$)=>w.id.localeCompare($.id),g=w=>{for(;N.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(w=>this.b[w]);for(const w of d.filter($=>!!$.description).sort(t))a.push(`|<i class="${g(w)}"></i>|${w.id}|${N.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const w of d.filter($=>!N.ThemeIcon.isThemeIcon($.defaults)).sort(t))a.push(`|<i class="${g(w)}"></i>|${w.id}|`);return a.join(`
`)}}const r=new f;S.$fo.add(e.$hx.IconContribution,r);function s(u,t,g,a){return r.registerIcon(u,t,g,a)}function o(){return r}function n(){const u=(0,M.$Tj)();for(const t in u){const g="\\"+u[t].toString(16);r.registerIcon(t,{fontCharacter:g})}}n(),e.$kx="vscode://schemas/icons";const i=S.$fo.as(T.$go.JSONContribution);i.registerSchema(e.$kx,r.getIconSchema());const c=new P.$Kh(()=>i.notifySchemaChanged(e.$kx),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$lx=s("widget-close",O.$Xj.close,(0,E.localize)(2,null)),e.$mx=s("goto-previous-location",O.$Xj.arrowUp,(0,E.localize)(3,null)),e.$nx=s("goto-next-location",O.$Xj.arrowDown,(0,E.localize)(4,null)),e.$ox=N.ThemeIcon.modify(O.$Xj.sync,"spin"),e.$px=N.ThemeIcon.modify(O.$Xj.loading,"spin")}),define(ke[211],Ie([1,0,5,2,50,3,12]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.$sw=e.$qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$mw=e.$lw=void 0,e.$nw=E,e.$ow=S,e.$pw=l,e.$rw=b,e.$tw=f,e.$uw=r,e.$lw=(0,N.$yi)("tunnelService"),e.$mw=(0,N.$yi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(n){return!!n.forwardPort}var T;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function l(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const c of i){const u=c.split("=")[1];if(/^https?:/.exec(u)){const t=S(O.URI.parse(u));if(t)return t}}}e.$qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(n){return e.$qw.indexOf(n)>=0}e.$sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(n){return e.$sw.indexOf(n)>=0}function r(n,i,c,u){if(c===1)return!1;if(c===2&&f(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class s{constructor(i,c,u){this.remoteAddress=i,this.localAddress=c,this.b=u,this.a=new P.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vw=s;let o=class{constructor(i,c){this.k=i,this.l=c,this.a=new P.$fe,this.onTunnelOpened=this.a.event,this.b=new P.$fe,this.onTunnelClosed=this.b.event,this.c=new P.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],c=Array.from(this.e.values());for(const u of c){const t=Array.from(u.values());for(const g of t){const a=await g.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,u,t,g){this.q(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:u,privacy:t,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(f(i)||b(i))&&(i=e.$qw[0]);const u=this.s(i,c);if(u)return++u.refcount,u.value}openTunnel(i,c,u,t,g,a=!1,d,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${g}.`);const $=this.f??i;if(!$)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t($,c,u,t,g,a,d,w);return v?v.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&y.privacy!==d&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const u=c.get(i.tunnelRemotePort);u&&(u.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async p(i,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const t=u.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),t}}async closeTunnel(i,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const u=this.e.get(i);if(u&&u.has(c)){const t=u.get(c);t.refcount=0,await this.p(i,c,t)}}q(i,c,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:u})}async r(i,c){const u=this.e.get(i);if(u){const t=u.get(c),g=t?await t.value:void 0;(!g||typeof g=="string")&&u.delete(c),u.size===0&&this.e.delete(i)}}s(i,c){const u=[i];b(i)?(u.push(...e.$qw),u.push(...e.$sw)):f(i)&&u.push(...e.$sw);const t=u.map(g=>this.e.get(g));for(const g of t){const a=g?.get(c);if(a)return a}}canTunnel(i){return!!S(i)}u(i,c,u,t,g,a,d){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${t}.`);const w=u;this.j.add(w);const $=t===void 0?u:t,v={elevationRequired:g?this.isPortPrivileged($):!1},y={remoteAddress:{host:c,port:u},localAddressPort:t,privacy:a,public:a?a!==m.Private:void 0,protocol:d},h=i.forwardPort(y,v);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),h}};e.$ww=o,e.$ww=o=Je([We(0,R.$5j),We(1,M.$5i)],o)}),define(ke[212],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,P.$yi)("IUriIdentityService")}),define(ke[213],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xw=void 0,e.$xw=(0,P.$yi)("editSessionIdentityService");var O;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(ke[214],Ie([1,0,16]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=O,e.$QL=M,e.$RL=N,e.$SL=R,e.$TL=p;function O(m){return m.scheme!==P.Schemas.file&&m.scheme!==P.Schemas.vscodeRemote}function M(m){if(m.folders.length)return m.folders.every(E=>O(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function N(m){return M(m)?.scheme}function R(m){return M(m)?.authority}function p(m){return M(m)!==void 0}}),define(ke[45],Ie([1,0,171,19,54,24,2,3,16]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=E,e.$Ji=T,e.$Mi=S,e.$Ni=l,e.$Oi=b,e.$Pi=r,e.$Qi=s,e.$Ti=i,e.$Yi=c,e.$Zi=u,e.$2i=t,e.$3i=g,e.$4i=a,e.$Hi=(0,p.$yi)("contextService");function E(d){const w=d;return typeof w?.id=="string"&&R.URI.isUri(w.uri)}function T(d){return typeof d?.id=="string"&&!E(d)&&!l(d)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function S(d,w){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,O.$nc)(d)}:w?e.$Ki:e.$Li;const $=d;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}function l(d){const w=d;return typeof w?.id=="string"&&R.URI.isUri(w.configPath)}function b(d){const w=d;if(w?.uri)return{id:w.id,uri:R.URI.revive(w.uri)};const $=d;if($?.configPath)return{id:$.id,configPath:R.URI.revive($.configPath)};if(d?.id)return{id:d.id}}var f;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function r(d){const w=d;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function s(d){const w=d;return!!(w&&typeof w=="object"&&R.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class o{constructor(w,$,v,y,h){this.h=w,this.j=v,this.k=y,this.l=h,this.c=M.$Ei.forUris(this.l,()=>!0),this.folders=$}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=M.$Ei.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=o;class n{constructor(w,$){this.raw=$,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,N.$_g)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=n;function i(d){return new n({uri:d,index:0,name:(0,N.$8g)(d)},{uri:d.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,P.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function c(d,w){return N.$3g.isEqualOrParent(d,w.untitledWorkspacesHome)}function u(d){let w;return R.URI.isUri(d)?w=d:w=d.configuration,w?.scheme===m.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$1i}function g(d,w){return!c(d,w)&&!u(d)}function a(d){return(typeof d=="string"?(0,O.$oc)(d):(0,N.$0g)(d))===e.$Vi}}),define(ke[215],Ie([1,0,73,5,6,24,2,170,99,38,3,12,45,28,212,11,33,13,15]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=c,e.$Fl=u,e.$Gl=t;var i;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function c(d){const w=d;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&R.URI.isUri(w.location)&&R.URI.isUri(w.globalStorageHome)&&R.URI.isUri(w.settingsResource)&&R.URI.isUri(w.keybindingsResource)&&R.URI.isUri(w.tasksResource)&&R.URI.isUri(w.snippetsHome)&&R.URI.isUri(w.extensionsResource))}e.$El=(0,T.$yi)("IUserDataProfilesService");function u(d,w){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:R.URI.revive(d.location).with({scheme:w}),globalStorageHome:R.URI.revive(d.globalStorageHome).with({scheme:w}),settingsResource:R.URI.revive(d.settingsResource).with({scheme:w}),keybindingsResource:R.URI.revive(d.keybindingsResource).with({scheme:w}),tasksResource:R.URI.revive(d.tasksResource).with({scheme:w}),snippetsHome:R.URI.revive(d.snippetsHome).with({scheme:w}),extensionsResource:R.URI.revive(d.extensionsResource).with({scheme:w}),cacheHome:R.URI.revive(d.cacheHome).with({scheme:w}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}function t(d,w,$,v,y,h){return{id:d,name:w,location:$,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,N.$_g)($,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,N.$_g)($,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,N.$_g)($,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,N.$_g)($,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,N.$_g)($,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,N.$_g)($,"extensions.json"),cacheHome:(0,N.$_g)(v,d),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let g=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,$,v,y){super(),this.t=w,this.u=$,this.w=v,this.y=y,this.f=!0,this.h=this.B(new O.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new b.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),$=[w];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,n.$$f)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}$.push(t((0,N.$9g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},w))}}catch(h){this.y.error(h)}const v=new b.$Ac,y=new Map;if($.length)try{const h=this.Q();if(h.workspaces)for(const[D,k]of Object.entries(h.workspaces)){const C=R.URI.parse(D),I=$.find(W=>W.id===k);I&&v.set(C,I)}if(h.emptyWindows)for(const[D,k]of Object.entries(h.emptyWindows)){const C=$.find(I=>I.id===k);C&&y.set(D,C)}}catch(h){this.y.error(h)}this.z={profiles:$,workspaces:v,emptyWindows:y}}return this.z}D(){const w=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const $="Temp",v=new RegExp(`${(0,o.$bf)($)}\\s(\\d+)`);let y=0;for(const D of this.profiles){const k=v.exec(D.name),C=k?parseInt(k[1]):0;y=C>y?C:y}const h=`${$} ${y+1}`;return this.createProfile((0,P.$mj)((0,s.$Ug)()).toString(16),h,{transient:!0},w)}async createNamedProfile(w,$,v){return this.createProfile((0,P.$mj)((0,s.$Ug)()).toString(16),w,$,v)}async createProfile(w,$,v,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F(w,$,v);return y&&await this.setProfileForWorkspace(y,h),h}async F(w,$,v){if(!(0,n.$$f)($)||!$)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get($);return y||(y=(async()=>{try{if(this.profiles.find(C=>C.name===$||C.id===w))throw new Error(`Profile with ${$} name already exists`);const D=t(w,$,(0,N.$_g)(this.profilesHome,w),this.g,v,this.defaultProfile);await this.u.createFolder(D.location);const k=[];return this.j.fire({profile:D,join(C){k.push(C)}}),await r.Promises.settled(k),this.I([D],[],[]),D}finally{this.r.delete($)}})(),this.r.set($,y)),y}async updateProfile(w,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(y=>y.id===w.id);if(!v)throw new Error(`Profile '${w.name}' does not exist`);return v=t(v.id,$.name??v.name,v.location,this.g,{shortName:$.shortName??v.shortName,icon:$.icon===null?void 0:$.icon??v.icon,transient:$.transient??v.isTransient,useDefaultFlags:$.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const $=this.profiles.find(y=>y.id===w.id);if(!$)throw new Error(`Profile '${w.name}' does not exist`);const v=[];this.m.fire({profile:$,join(y){v.push(y)}});try{await Promise.allSettled(v)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])$.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])$.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[$],[]);try{await this.u.del($.cacheHome,{recursive:!0})}catch(y){(0,E.$jl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(w,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(y=>y.id===$.id);if(!v)throw new Error(`Profile '${$.name}' does not exist`);this.L(w,v)}unsetWorkspace(w,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,$)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter($=>$.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,$.resource))).map($=>this.u.del($.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter($=>!this.H($));await Promise.allSettled(w.map($=>this.removeProfile($)))}getProfileForWorkspace(w){const $=this.G(w);return R.URI.isUri($)?this.s.workspaces.get($)??this.C.workspaces.get($):this.s.emptyWindows.get($)??this.C.emptyWindows.get($)}G(w){return(0,l.$Ii)(w)?w.uri:(0,l.$Ni)(w)?w.configPath:w.id}H(w){return!!([...this.s.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,w.location))||[...this.s.workspaces.values()].some($=>this.w.extUri.isEqual($.location,w.location))||[...this.C.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,w.location))||[...this.C.workspaces.values()].some($=>this.w.extUri.isEqual($.location,w.location)))}I(w,$,v){const y=[...this.profiles,...w],h=[];this.s.profiles=[];for(let D of y)D.isDefault||$.some(k=>D.id===k.id)||(D=v.find(k=>D.id===k.id)??D,D.isTransient?this.s.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(h),this.z=void 0,this.J(w,$,v)}J(w,$,v){this.h.fire({added:w,removed:$,updated:v,all:this.profiles})}L(w,$,v){v=$?.isTransient?!0:v,v||this.L(w,void 0,!0);const y=this.G(w),h=v?this.s:this.C;R.URI.isUri(y)?(h.workspaces.delete(y),$&&h.workspaces.set(y,$)):(h.emptyWindows.delete(y),$&&h.emptyWindows.set(y,$)),v||this.M()}M(){const w={};for(const[v,y]of this.C.workspaces.entries())w[v.toString()]=y.id;const $={};for(const[v,y]of this.C.emptyWindows.entries())$[v.toString()]=y.id;this.R({workspaces:w,emptyWindows:$}),this.z=void 0}N(w){const $={},v=this.D();if(w.workspaces)for(const[h,D]of Object.entries(w.workspaces)){const k=R.URI.parse(D);$[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}const y={};if(w.emptyWindows)for(const[h,D]of Object.entries(w.emptyWindows)){const k=R.URI.parse(D);y[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}return{workspaces:$,emptyWindows:y}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Hl=g,e.$Hl=g=Je([We(0,m.$Fi),We(1,E.$5k),We(2,f.$Cl),We(3,S.$5j)],g);class a extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Il=a}),define(ke[216],Ie([1,0,11,5,6,60,15,151,3,215]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$6p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4p=e.$3p=e.$2p=void 0,e.$5p=b,e.$7p=r,e.$9p=o,e.$2p="__$__isNewStorageMarker",e.$3p="__$__targetStorageMarker",e.$4p=(0,m.$yi)("storageService");var T;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var S;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var l;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function b(n){const i=n.get(e.$3p);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends M.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new O.$ie),this.c=this.B(new O.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,c,u){return O.Event.filter(this.b.event,t=>t.scope===i&&(c===void 0||t.key===c),u)}n(){this.j.value=(0,P.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,c){const{key:u,external:t}=c;if(u===e.$3p){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:u,target:this.J(i)[u],external:t})}w(i){this.f.fire({reason:i})}get(i,c,u){return this.P(c)?.get(i,u)}getBoolean(i,c,u){return this.P(c)?.getBoolean(i,u)}getNumber(i,c,u){return this.P(c)?.getNumber(i,u)}getObject(i,c,u){return this.P(c)?.getObject(i,u)}storeAll(i,c){this.y(()=>{for(const u of i)this.store(u.key,u.value,u.scope,u.target,c)})}store(i,c,u,t,g=!1){if((0,R.$hg)(c)){this.remove(i,u,g);return}this.y(()=>{this.z(i,u,t),this.P(u)?.set(i,c,g)})}remove(i,c,u=!1){this.y(()=>{this.z(i,c,void 0),this.P(c)?.delete(i,u)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,c){const u=[],t=this.J(i);for(const g of Object.keys(t))t[g]===c&&u.push(g);return u}z(i,c,u,t=!1){const g=this.J(c);typeof u=="number"?g[i]!==u&&(g[i]=u,this.P(c)?.set(e.$3p,JSON.stringify(g),t)):typeof g[i]=="number"&&(delete g[i],this.P(c)?.set(e.$3p,JSON.stringify(g),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const c=this.P(i);return c?b(c):Object.create(null)}isNew(i){return this.getBoolean(e.$2p,i)===!0}async flush(i=T.NONE){this.f.fire({reason:i});const c=this.P(-1),u=this.P(0),t=this.P(1);switch(i){case T.NONE:await P.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await P.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return o(i,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,c){return this.w(T.NONE),(0,E.$Dl)(i)?this.R(i,c):this.S(i,c)}M(i,c){return!(i.id===c.id||r(c)&&r(i))}N(i,c,u){this.y(()=>{const t=new Set;for(const[g,a]of i)t.add(g),c.get(g)!==a&&this.u(u,{key:g,external:!0});for(const[g]of c.items)t.has(g)||this.u(u,{key:g,external:!0})})}}e.$6p=f;function r(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class s extends f{constructor(){super(),this.U=this.B(new p.$Zp(new p.$1p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Zp(new p.$1p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Zp(new p.$1p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$8p=s;async function o(n,i,c,u,t,g){const a=C=>{try{return JSON.parse(C)}catch{return C}},d=new Map,w=new Map;n.forEach((C,I)=>{d.set(I,C),w.set(I,a(C))});const $=new Map,v=new Map;i.forEach((C,I)=>{$.set(I,C),v.set(I,a(C))});const y=new Map,h=new Map;c.forEach((C,I)=>{y.set(I,C),h.set(I,a(C))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const D=[];if(d.forEach((C,I)=>{D.push({key:I,value:C})}),console.table(D),console.groupEnd(),console.log(w),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];$.forEach((I,W)=>{C.push({key:W,value:I})}),console.table(C),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${g})`);const k=[];y.forEach((C,I)=>{k.push({key:I,value:C})}),console.table(k),console.groupEnd(),console.log(h)}}),define(ke[76],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class P{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const N=this.c++;return this.b.set(N,M),this.e(),N}get(M,N){return this.b.has(M)?this.b.get(M)[N]:void 0}delete(M){this.b.delete(M),this.e()}e(){P.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Mlc=P}),define(ke[46],Ie([1,0,16,24,3]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=void 0;class N{constructor(){this.a=new Set(Object.keys(P.Schemas)),this.b=new Map,this.extUri=new O.$1g(p=>{const m=this.b.get(p.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(p,m){m===null?this.b.delete(p.scheme):this.b.set(p.scheme,m)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Rlc=N,e.$Slc=(0,M.$yi)("IExtHostFileSystemInfo")}),define(ke[27],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=void 0,e.$ZO=(0,P.$yi)("IExtHostInitDataService")}),define(ke[217],Ie([1,0,176,12,201,27]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;let R=class extends M.$0P{constructor(m,E,T){const S=T.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=T.remote.isRemote?(0,P.localize)(0,null):m?(0,P.localize)(1,null):(0,P.localize)(2,null);super(E.createLogger(S,{name:l}))}};e.$Ync=R,e.$Ync=R=Je([We(1,O.$6j),We(2,N.$ZO)],R)}),define(ke[218],Ie([1,0,11]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=e.$xmc=void 0;class O{constructor(R,p,m){this.h=new Map,this.a=R,this.b=p,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new P.$Kh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const S of E.values())S.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,p){let m=this.f[R];return typeof m>"u"&&(m=p),m}update(R,p){this.f[R]=p;const m=this.h.get(R);if(m!==void 0)return m.p;const E=new P.$Vh;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$xmc=O;class M extends O{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,p){super(R.identifier.value,!0,p),this.j=R}}e.$ymc=M}),define(ke[219],Ie([1,0,5,2]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class M{constructor(R){this.c=R,this.a=new P.$fe,this.onDidSaveNotebookDocument=this.a.event,this.b=new P.$fe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,p,m,E){const S=this.c.getNotebookDocument(O.URI.revive(R)).acceptModelChanged(p.value,m,E);this.b.fire(S)}$acceptDirtyStateChanged(R,p){this.c.getNotebookDocument(O.URI.revive(R)).acceptDirty(p)}$acceptModelSaved(R){const p=this.c.getNotebookDocument(O.URI.revive(R));this.a.fire(p.apiNotebook)}}e.$mnc=M}),define(ke[17],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0,e.$JO=(0,P.$yi)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$KO=O}),define(ke[220],Ie([1,0,21,5]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class M{#e;constructor(R,p){this.b=new O.$fe,this.onDidChange=this.b.event,this.a=P.$Tm.toKey(R.identifier),this.#e=p,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(R){return this.#e.get(this.a,R)}store(R,p){return this.#e.store(this.a,R,p)}delete(R){return this.#e.delete(this.a,R)}}e.$Hmc=M}),define(ke[61],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0,e.$8lc=(0,P.$yi)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$9lc=O}),define(ke[221],Ie([1,0,22]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xrb=M,e.$Yrb=R;class O{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function M(p,m){if(m.serializeBuffersForPostMessage){const E=new O,S=JSON.stringify(p,(b,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(f)};if(ArrayBuffer.isView(f)){const r=N(f);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(f.buffer),view:{type:r,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),l=E.buffers.map(b=>{const f=new Uint8Array(b);return P.$He.wrap(f)});return{message:S,buffers:l}}else return{message:JSON.stringify(p),buffers:[]}}function N(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(p,m){const E=m.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),T=m.length?(l,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:r}=f,s=E[r];if(f.view)switch(f.view.type){case 1:return new Int8Array(s,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return b}:void 0;return{message:JSON.parse(p,T),arrayBuffers:E}}}),define(ke[106],Ie([1,0,185,15,2,6,3,29,38,16,44,145,32]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$UF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$LF=e.EditorInputCapabilities=e.$KF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$BF=r,e.$CF=s,e.$DF=o,e.$EF=n,e.$FF=i,e.$GF=c,e.$HF=u,e.$IF=t,e.$JF=g,e.$MF=y,e.$NF=D,e.$OF=k,e.$PF=C,e.$QF=I,e.$RF=W,e.$SF=V,e.$TF=ce,e.$VF=fe,e.$WF=Te,e.$XF=ae,e.$YF=Re,e.$wF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$xF={id:"default",displayName:(0,P.localize)(0,null),providerDisplayName:(0,P.localize)(1,null)},e.$yF="workbench.editor.sidebysideEditor",e.$zF="workbench.editors.textDiffEditor",e.$AF="workbench.editors.binaryResourceDiffEditor";var b;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var f;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function r(ne){const z=ne;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function s(ne){const z=ne;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function o(ne,z,x){for(const be of x.visibleEditorPanes)if(be.group.id===z&&ne.matches(be.input))return be.getViewState()}function n(ne){if(y(ne))return!1;const z=ne;return M.URI.isUri(z?.resource)}function i(ne){if(y(ne))return!1;const z=ne;return z?.original!==void 0&&z.modified!==void 0}function c(ne){if(y(ne))return!1;const z=ne;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function u(ne){if(y(ne)||i(ne))return!1;const z=ne;return z?.primary!==void 0&&z.secondary!==void 0}function t(ne){if(y(ne))return!1;const z=ne;return z?z.resource===void 0||z.resource.scheme===E.Schemas.untitled||z.forceUntitled===!0:!1}function g(ne){if(y(ne))return!1;const z=ne;return M.URI.isUri(z?.base?.resource)&&M.URI.isUri(z?.input1?.resource)&&M.URI.isUri(z?.input2?.resource)&&M.URI.isUri(z?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var d;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class w{constructor(){this.a=new Map}registerSource(z,x){let be=this.a.get(z);return be||(be={source:z,label:x},this.a.set(z,be)),be.source}getSourceLabel(z){return this.a.get(z)?.label??z}}e.$KF=new w;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})($||(e.EditorInputCapabilities=$={}));class v extends N.$Uc{}e.$LF=v;function y(ne){return ne instanceof v}function h(ne){const z=ne;return M.URI.isUri(z?.preferredResource)}function D(ne){const z=ne;return y(z?.primary)&&y(z?.secondary)}function k(ne){const z=ne;return y(z?.modified)&&y(z?.original)}function C(ne,z,x,be,Fe){return Re(be,[(0,S.$ij)({id:"workbench.action.openLargeFile",label:(0,P.localize)(2,null),run:()=>{const De={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(z,De)}}),(0,S.$ij)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,P.localize)(3,null),run:()=>Fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function I(ne){return y(ne?.editor)}function W(ne){const z=ne;return I(ne)&&z?.group!==void 0}function V(ne){const z=ne;return typeof z?.groupId=="number"&&y(z.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var B;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class K{getOriginalUri(z,x){if(!z)return;if(g(z))return e.$UF.getOriginalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Fe:De}}if(i(z)||c(z)||u(z)||g(z))return;const be=h(z)?z.preferredResource:z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}a(z){return D(z)||u(z)?{primary:z.primary,secondary:z.secondary}:k(z)||i(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,x){if(!z)return;if(g(z))return e.$UF.getCanonicalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Fe:De}}if(i(z)||c(z)||u(z)||g(z))return;const be=z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}b(z,x){if(Array.isArray(x)){if(x.some(be=>z.scheme===be))return z}else if(x===z.scheme)return z}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,z,x,be){if(!ne.isSticky(z))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$UF=new K;var ve;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Se{constructor(){this.c=new Map,this.d=new Map}start(z){const x=this.a=z.get(R.$xi);for(const[be,Fe]of this.c)this.e(be,Fe,x);this.c.clear()}e(z,x,be){const Fe=be.createInstance(x);this.d.set(z,Fe)}registerFileEditorFactory(z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=z}getFileEditorFactory(){return(0,O.$jg)(this.b)}registerEditorSerializer(z,x){if(this.c.has(z)||this.d.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.a?this.e(z,x,this.a):this.c.set(z,x),(0,N.$Sc)(()=>{this.c.delete(z),this.d.delete(z)})}getEditorSerializer(z){return this.d.get(typeof z=="string"?z:z.typeId)}}p.$fo.add(e.$wF.EditorFactory,new Se);async function fe(ne,z,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async be=>{const Fe=M.URI.revive(be.fileUri);if(!Fe){x.info("Cannot resolve the path because it is not valid.",be);return}if(!await z.canHandleResource(Fe)){x.info("Cannot resolve the path because it cannot be handled",be);return}let pe=be.exists,ge=be.type;if(typeof pe!="boolean"||typeof ge!="number")try{ge=(await z.stat(Fe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,pe=!0}catch(Y){x.error(Y),pe=!1}if(!pe&&be.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",be);return}if(ge===m.FileType.Directory){x.info("Cannot resolve the path because it is a directory",be);return}const Q={...be.options,pinned:!0};return pe?{resource:Fe,options:Q}:{resource:Fe,options:Q,forceUntitled:!0}}))}var $e;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function Te(ne){const z=ne;if(!z)return!1;const x=z;if(x.modified)return Te(x.modified);const be=z;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ae(ne){return(0,T.$kj)(ne)}function Re(ne,z,x){const be=(0,T.$lj)(ne,z);return be.forceMessage=x?.forceMessage,be.forceSeverity=x?.forceSeverity,be.allowDialog=x?.allowDialog,be}}),define(ke[222],Ie([1,0,5,186,3,6,28,29,26,92,210]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=e.$6F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$5F=e.ViewContentGroups=e.$3F=e.ViewContainerLocation=e.Extensions=e.$2F=e.$1F=e.$ZF=void 0,e.$4F=b,e.$ZF="views",e.$1F=(0,O.localize)(0,null),e.$2F=(0,T.$ix)("default-view-icon",E.$Xj.window,(0,O.localize)(1,null));var S;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var l;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$3F=[0,1,2];function b(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class f extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new P.$fe),this.onDidRegister=this.c.event,this.f=this.B(new P.$fe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(g,a,d){const w=this.get(g.id);if(w)return w;const $=g;return $.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,a,[]).push($),d?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:a}),$}deregisterViewContainer(g){for(const a of this.g.keys()){const d=this.g.get(a),w=d?.indexOf(g);if(w!==-1){d?.splice(w,1),d.length===0&&this.g.delete(a),this.f.fire({viewContainer:g,viewContainerLocation:a});return}}}get(g){return this.all.filter(a=>a.id===g)[0]}getViewContainers(g){return[...this.g.get(g)||[]]}getViewContainerLocation(g){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(d=>d?.id===g.id).length>0)[0]}getDefaultViewContainer(g){return this.h.find(a=>this.getViewContainerLocation(a)===g)}}p.$fo.add(S.ViewContainersRegistry,new f);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(t,g){const a=t.group??r.More,d=g.group??r.More;return a!==d?a.localeCompare(d):(t.order??5)-(g.order??5)}class o extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new P.$fe),this.onViewsRegistered=this.c.event,this.f=this.B(new P.$fe),this.onViewsDeregistered=this.f.event,this.g=this.B(new P.$fe),this.onDidChangeContainer=this.g.event,this.h=this.B(new P.$fe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(g,a){this.registerViews2([{views:g,viewContainer:a}])}registerViews2(g){g.forEach(({views:a,viewContainer:d})=>this.r(a,d)),this.c.fire(g)}deregisterViews(g,a){const d=this.s(g,a);d.length&&this.f.fire({views:d,viewContainer:a})}moveViews(g,a){for(const d of this.m.keys())if(d!==a){const w=this.s(g,d);w.length&&(this.r(w,a),this.g.fire({views:w,from:d,to:a}))}}getViews(g){return this.m.get(g)||[]}getView(g){for(const a of this.j){const d=(this.m.get(a)||[]).filter(w=>w.id===g)[0];if(d)return d}return null}getViewContainer(g){for(const a of this.j)if((this.m.get(a)||[]).filter(w=>w.id===g)[0])return a;return null}registerViewWelcomeContent(g,a){return this.n.add(g,a),this.h.fire(g),(0,N.$Sc)(()=>{this.n.delete(g,a),this.h.fire(g)})}registerViewWelcomeContent2(g,a){const d=new Map;for(const[w,$]of a)this.n.add(g,$),d.set(w,(0,N.$Sc)(()=>{this.n.delete(g,$),this.h.fire(g)}));return this.h.fire(g),d}getViewWelcomeContent(g){const a=[];return this.n.forEach(g,d=>a.push(d)),a.sort(s)}r(g,a){let d=this.m.get(a);d||(d=[],this.m.set(a,d),this.j.push(a));for(const w of g){if(this.getView(w.id)!==null)throw new Error((0,O.localize)(2,null,w.id));d.push(w)}}s(g,a){const d=this.m.get(a);if(!d)return[];const w=[],$=[];for(const v of d)g.includes(v)?w.push(v):$.push(v);return w.length&&($.length?this.m.set(a,$):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),w}}p.$fo.add(S.ViewsRegistry,new o),e.$5F=(0,M.$yi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class c{constructor(g,a){this.c=!1,this.d=!1,(0,m.$8n)(this,g),this.d=!!a,this.resolve=async d=>{if(a&&!this.c){const w=await a(d);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$6F=c;class u extends Error{constructor(g){super((0,O.localize)(3,null,g)),this.name="NoTreeViewError"}static is(g){return g.name==="NoTreeViewError"}}e.$7F=u}),define(ke[223],Ie([1,0,187,31]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=void 0,e.$$F=new O.$Pj("chatSessionResponseVote","",{type:"string",description:(0,P.localize)(0,null)}),e.$_F=new O.$Pj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,P.localize)(1,null)}),e.$aG=new O.$Pj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,P.localize)(2,null)}),e.$bG=new O.$Pj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,P.localize)(3,null)}),e.$cG=new O.$Pj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,P.localize)(4,null)}),e.$dG=new O.$Pj("chatResponse",!1,{type:"boolean",description:(0,P.localize)(5,null)}),e.$eG=new O.$Pj("chatRequest",!1,{type:"boolean",description:(0,P.localize)(6,null)}),e.$fG=new O.$Pj("chatEditApplied",!1,{type:"boolean",description:(0,P.localize)(7,null)}),e.$gG=new O.$Pj("chatInputHasText",!1,{type:"boolean",description:(0,P.localize)(8,null)}),e.$hG=new O.$Pj("chatInputHasFocus",!1,{type:"boolean",description:(0,P.localize)(9,null)}),e.$iG=new O.$Pj("inChatInput",!1,{type:"boolean",description:(0,P.localize)(10,null)}),e.$jG=new O.$Pj("inChat",!1,{type:"boolean",description:(0,P.localize)(11,null)}),e.$kG=new O.$Pj("chatIsEnabled",!1,{type:"boolean",description:(0,P.localize)(12,null)}),e.$lG=new O.$Pj("chatCursorAtTop",!1),e.$mG=new O.$Pj("chatInputHasAgent",!1),e.$nG=new O.$Pj("chatLocation",void 0)}),define(ke[224],Ie([1,0,11,20,5,42,6,132,13,31,3,12,102,204,216,223]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.ChatAgentLocation=void 0;var o;(function(u){u.Panel="panel",u.Terminal="terminal",u.Notebook="notebook",u.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(u){function t(g){switch(g){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook;case"editor":return u.Editor}return u.Panel}u.fromRaw=t}(o||(e.ChatAgentLocation=o={})),e.$lH=(0,T.$yi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new M.$fe,this.onDidChangeAgents=this.d.event,this.e=r.$kG.bindTo(this.f)}registerAgent(t,g){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const d=this,w=g.slashCommands;g={...g,get slashCommands(){return w.filter(v=>!v.when||d.f.contextMatchesRules(E.$wj.deserialize(v.when)))}};const $={data:g};return this.b.push($),(0,R.$Sc)(()=>{this.b=this.b.filter(v=>v!==$),this.d.fire(void 0)})}registerAgentImplementation(t,g){const a=this.g(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this.e.set(!0),a.impl=g,this.d.fire(new i(a.data,g)),(0,R.$Sc)(()=>{a.impl=void 0,this.d.fire(void 0),a.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,g){t.isDynamic=!0;const a={data:t,impl:g};return this.b.push(a),this.d.fire(new i(t,g)),(0,R.$Sc)(()=>{this.b=this.b.filter(d=>d!==a),this.d.fire(void 0)})}updateAgent(t,g){const a=this.g(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...g},this.d.fire(new i(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(g=>!!g.isDefault&&g.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(g=>!!g.isDefault&&g.locations.includes(t))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(g=>g.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(g=>g.name===t)}async invokeAgent(t,g,a,d,w){const $=this.g(t);if(!$?.impl)throw new Error(`No activated agent with id ${t}`);return await $.impl.invoke(g,a,d,w)}async getFollowups(t,g,a,d,w){const $=this.g(t);if(!$?.impl)throw new Error(`No activated agent with id ${t}`);return $.impl?.provideFollowups?$.impl.provideFollowups(g,a,d,w):[]}};e.$mH=n,e.$mH=n=Je([We(0,E.$Qj)],n);class i{constructor(t,g){this.b=t,this.d=g}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,g,a,d){return this.d.invoke(t,g,a,d)}async provideFollowups(t,g,a,d){return this.d.provideFollowups?this.d.provideFollowups(t,g,a,d):[]}provideWelcomeMessage(t,g){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,g)}provideSampleQuestions(t,g){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,g)}}e.$nH=i,e.$oH=(0,T.$yi)("chatAgentNameService");let c=class{static{s=this}static{this.b="chat.participantNameRegistry"}constructor(t,g,a,d){if(this.g=g,this.h=a,this.i=d,this.e=(0,p.$3d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const w=d.get(s.b,-1);try{this.e.set(JSON.parse(w??"{}"),void 0)}catch{d.remove(s.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,P.$zh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const g=await(0,b.$Wp)(t);if(!g||g.version!==1)throw new Error("Unexpected chat participant registry response.");const a=g.restrictedChatParticipants;this.e.set(a,void 0),this.i.store(s.b,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.e.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some(d=>(0,m.$zf)(d,d.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$pH=c,e.$pH=c=s=Je([We(0,l.$lk),We(1,b.$Qp),We(2,S.$5j),We(3,f.$4p)],c)}),define(ke[225],Ie([1,0,2,30,3]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vG=e.$uG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$sG=N,e.$tG=R;function N(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof P.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$xt.isIRange)}function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(N)}var p;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$uG=(0,M.$yi)("IChatService"),e.$vG="accessibility.voice.keywordActivation"}),define(ke[226],Ie([1,0,5,11,188]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new P.$fe,this.o=new P.$fe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,m,E,T){const S={command:p};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.u("request",S),typeof T=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.f.get(S.seq);if(b){this.f.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:p,message:(0,M.localize)(0,null,T,p)};b(f)}},T)}return E&&this.f.set(S.seq,E),S.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,m){return p.type!=="event"||m.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,O.$zh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const m=p,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u(p,m){m.type=p,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((m,E)=>p.set(E,m)),await(0,O.$zh)(500),p.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$$rb=N}),define(ke[227],Ie([1,0,2,189,31,3]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$FJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$DJ=e.MemoryRangeType=e.State=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=void 0,e.$CJ=m,e.$EJ=T,e.$qI="workbench.view.debug",e.$rI="workbench.debug.variablesView",e.$sI="workbench.debug.watchExpressionsView",e.$tI="workbench.debug.callStackView",e.$uI="workbench.debug.loadedScriptsView",e.$vI="workbench.debug.breakPointsView",e.$wI="workbench.debug.disassemblyView",e.$xI="workbench.panel.repl",e.$yI="workbench.panel.repl.view",e.$zI=new M.$Pj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$AI=new M.$Pj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$BI=new M.$Pj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$CI="debugUx",e.$DI=new M.$Pj(e.$CI,"default",{type:"string",description:O.localize(3,null)}),e.$EI=new M.$Pj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$FI=new M.$Pj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$GI=new M.$Pj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$HI=new M.$Pj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$II=new M.$Pj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$JI=new M.$Pj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$KI=new M.$Pj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$LI=new M.$Pj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$MI=new M.$Pj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$NI=new M.$Pj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$OI=new M.$Pj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$PI=new M.$Pj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$QI=new M.$Pj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$RI=new M.$Pj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$SI=new M.$Pj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$TI=new M.$Pj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$UI=new M.$Pj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$VI=new M.$Pj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$WI=new M.$Pj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$XI=new M.$Pj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$YI=new M.$Pj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$ZI=new M.$Pj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$1I=new M.$Pj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$2I=new M.$Pj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$3I=new M.$Pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$4I=new M.$Pj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$5I=new M.$Pj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$6I=new M.$Pj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$7I=new M.$Pj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$8I=new M.$Pj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$9I=new M.$Pj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$0I=new M.$Pj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$$I=new M.$Pj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$_I=new M.$Pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$aJ=new M.$Pj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$bJ=new M.$Pj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$cJ=new M.$Pj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$dJ=new M.$Pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$eJ=new M.$Pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$fJ=new M.$Pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$gJ=new M.$Pj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$hJ=new M.$Pj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$iJ=new M.$Pj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$jJ=new M.$Pj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$kJ=new M.$Pj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$lJ=new M.$Pj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$mJ=new M.$Pj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$nJ=new M.$Pj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$oJ=new M.$Pj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$pJ=new M.$Pj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$qJ=new M.$Pj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$rJ=new M.$Pj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$sJ=new M.$Pj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$tJ=new M.$Pj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$uJ=new M.$Pj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$vJ=new M.$Pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$wJ=new M.$Pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const R=i=>O.localize(61,null,i);e.$xJ=R,e.$yJ="editor.contrib.debug",e.$zJ="editor.contrib.breakpoint",e.$AJ="debug",e.$BJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function m(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$DJ="vscode-debug-memory";function T(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var S;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var l;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var b;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$FJ=(0,N.$yi)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(i){i.deserialize=c=>c,i.serialize=c=>c})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:P.URI.revive(c.iconPath.light),dark:P.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),i.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(ke[228],Ie([1,0,13,2,19,26,16,30,20,18]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EH=void 0,e.$sH=S,e.$tH=l,e.$uH=b,e.$vH=f,e.$wH=r,e.$xH=s,e.$yH=o,e.$zH=i,e.$AH=t,e.$BH=g,e.$CH=d,e.$DH=$;const T=/{([^}]+)}/g;function S(y,h,D){return y.replace(T,function(k,C){return h&&C.length>0&&C[0]!=="_"?k:D&&D.hasOwnProperty(C)?D[C]:k})}function l(y){const h={};for(const D of Object.keys(y))D.startsWith("!")||(h[D]=y[D]);return h}function b(y){return y.configuration.request==="attach"&&!f(y)&&(!y.parentSession||b(y.parentSession))}function f(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,P.$zf)(h,"extensionhost")||(0,P.$zf)(h,"pwa-extensionhost")?y:y.parentSession?f(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function s(y,h,D){let k,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=I.exec(y);){const V=W.index+1,q=V+W[0].length;if(V<=h&&q>=D){k=W[0],C=V;break}}if(k){const V=/\w+/g;let q=null;for(;(q=V.exec(k))&&!(q.index+1+C+q[0].length>=D););q&&(k=k.substring(0,V.lastIndex))}return k?{start:C,end:C+k.length-1}:{start:0,end:0}}async function o(y,h,D,k){if(y.evaluatableExpressionProvider.has(h)){const C=y.evaluatableExpressionProvider.ordered(h),I=(0,E.$Hb)(await Promise.all(C.map(async W=>{try{return await W.provideEvaluatableExpression(h,D,k??m.CancellationToken.None)}catch{return}})));if(I.length>0){let W=I[0].expression;const V=I[0].range;return W||(W=h.getLineContent(D.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const C=h.getLineContent(D.lineNumber),{start:I,end:W}=s(C,D.column,D.column),V=C.substring(I-1,W);return{matchingExpression:V,range:new p.$xt(D.lineNumber,I,D.lineNumber,I+V.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(n))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return O.URI.parse(y.path);if((0,M.$ic)(y.path))return O.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=O.URI.revive(y.path);if(h)return h.scheme===R.Schemas.file?h.fsPath:h.toString()}return y.path}function t(y,h){const D=h?c:u,k=(0,N.$5n)(y);return a(k,(C,I)=>{C&&I&&(I.path=D(I))}),k}function g(y,h){const D=h?c:u,k=(0,N.$5n)(y);return a(k,(C,I)=>{!C&&I&&(I.path=D(I))}),k}function a(y,h){switch(y.type){case"event":{const D=y;switch(D.event){case"output":h(!1,D.body.source);break;case"loadedSource":h(!1,D.body.source);break;case"breakpoint":h(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=y;switch(D.command){case"setBreakpoints":h(!0,D.arguments.source);break;case"breakpointLocations":h(!0,D.arguments.source);break;case"source":h(!0,D.arguments.source);break;case"gotoTargets":h(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const D=y;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":D.body.sources.forEach(k=>h(!1,k));break;case"scopes":D.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":D.body?.instructions.forEach(C=>h(!1,C.location));break;default:break}break}}}function d(y){return y.filter(h=>!h.presentation?.hidden).sort((h,D)=>h.presentation?D.presentation?h.presentation.group?D.presentation.group?h.presentation.group!==D.presentation.group?h.presentation.group.localeCompare(D.presentation.group):w(h.presentation.order,D.presentation.order):-1:D.presentation.group?1:w(h.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function w(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function $(y,h){const D=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(D!=="none"&&(await h.saveAll(),D==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await y.reloadConfiguration()}const v=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$EH=v}),define(ke[229],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.CellExecutionUpdateType=void 0;var O;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$XJ=(0,P.$yi)("INotebookExecutionService")}),define(ke[230],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sib=e.$Rib=e.ProxyKernelState=e.$Qib=void 0,e.$Qib=100;var O;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Rib=(0,P.$yi)("INotebookKernelService"),e.$Sib=(0,P.$yi)("INotebookKernelHistoryService")}),define(ke[231],Ie([1,0,6,30,156,96]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sXb=void 0;class R extends P.$Uc{constructor(m,E,T){super(),this._source=m,this.b=E,this.c=T,this.a=void 0}f(m){const E=m.getLineCount();return new O.$xt(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new M.$5C;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:T,disposable:S}=E.create(1);this.b=T,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new M.$5C;E.acceptChunk(m);const T=E.finish(!0),{textBuffer:S,disposable:l}=T.create(1);return this.B(l),S})),this.a}findInInputs(m){const T=new N.$SC(m,!1,!1,null).parseSearchRequest();if(!T)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,T,!0,5e3)}findInOutputs(m){const T=new N.$SC(m,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),T,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$sXb=R}),define(ke[52],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.TestPosition=e.TestIdPathParts=void 0;var P;(function(N){N.Delimiter="\0"})(P||(e.TestIdPathParts=P={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class M{static fromExtHostTestItem(R,p,m=R.parent){if(R._isRoot)return new M([p]);const E=[R.id];for(let T=m;T&&T.id!==p;T=T.parent)E.push(T.id);return E.push(p),new M(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const p=R.indexOf("\0");return p===-1?R:R.slice(0,p)}static fromString(R){return new M(R.split("\0"))}static join(R,p){return new M([...R.path,p])}static joinToString(R,p){return R.toString()+"\0"+p}static parentId(R){const p=R.lastIndexOf("\0");return p===-1?void 0:R.slice(0,p)}static localId(R){const p=R.lastIndexOf("\0");return p===-1?R:R.slice(p+1)}static isChild(R,p){return p.startsWith(R)&&p[R.length]==="\0"}static compare(R,p){return R===p?0:M.isChild(R,p)?2:M.isChild(p,R)?3:1}constructor(R,p=R.length){if(this.path=R,this.d=p,R.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let p=0;p<R.d&&p<this.d;p++)if(R.path[p]!==this.path[p])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$5K=M}),define(ke[62],Ie([1,0,2,94,30,52]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$aL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$_K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$K=e.$0K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$8K=e.$7K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$6K=e.TestResultState=void 0;var R;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$6K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var m;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$7K=[2,4,8,16,32,64];const E=A=>"runId"in A;e.$8K=E;var T;(function(A){A.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),A.deserialize=(B,K)=>({range:M.$xt.lift(K.range),uri:B.asCanonicalUri(P.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var S;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(A){A.serialize=B=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&T.serialize(B.location)}),A.deserialize=(B,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(B,K.location)})})(l||(e.ITestErrorMessage=l={}));const b=(A,B)=>`${B?"s":"e"}${A}`;e.$9K=b;var f;(function(A){A.serialize=B=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&T.serialize(B.location)}),A.deserialize=(B,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(B,K.location)})})(f||(e.ITestOutputMessage=f={}));var r;(function(A){A.serialize=B=>B.type===0?l.serialize(B):f.serialize(B),A.deserialize=(B,K)=>K.type===0?l.deserialize(B,K):f.deserialize(B,K)})(r||(e.ITestMessage=r={}));var s;(function(A){A.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),A.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map(r.serialize)}),A.deserialize=(B,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>r.deserialize(B,ie))})})(s||(e.ITestTaskState=s={}));const o="\0",n=(A,B)=>A+o+B;e.$0K=n;const i=A=>{const B=A.indexOf(o);return{ctrlId:A.slice(0,B),tagId:A.slice(B+1)}};e.$$K=i;var c;(function(A){A.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),A.deserialize=(B,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?B.asCanonicalUri(P.URI.revive(K.uri)):void 0,range:K.range?M.$xt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var u;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(A){A.serialize=B=>({expand:B.expand,item:c.serialize(B.item)}),A.deserialize=(B,K)=>({controllerId:N.$5K.root(K.item.extId),expand:K.expand,item:c.deserialize(B,K.item)})})(t||(e.InternalTestItem=t={}));var g;(function(A){A.serialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.uri!==void 0&&(K.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(K.range=B.item.range?.toJSON()),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}},A.deserialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.range!==void 0&&(K.range=B.item.range?M.$xt.lift(B.item.range):null),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}}})(g||(e.ITestItemUpdate=g={}));const a=(A,B)=>{B.expand!==void 0&&(A.expand=B.expand),B.item!==void 0&&(A.item=A.item?Object.assign(A.item,B.item):B.item)};e.$_K=a;var d;(function(A){A.serializeWithoutMessages=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(s.serializeWithoutMessages)}),A.serialize=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(s.serialize)}),A.deserialize=(B,K)=>({...t.deserialize(B,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>s.deserialize(B,ie)),retired:!0})})(d||(e.TestResultItem=d={}));var w;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(B,K)=>{B.covered+=K.covered,B.total+=K.total}})(w||(e.ICoverageCount=w={}));var $;(function(A){A.serialize=B=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:B.uri.toJSON()}),A.deserialize=(B,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:B.asCanonicalUri(P.URI.revive(K.uri))})})($||(e.IFileCoverage=$={}));function v(A){return{...A,location:A.location?.toJSON()}}function y(A){return A.location=A.location?O.$wt.isIPosition(A.location)?O.$wt.lift(A.location):M.$xt.lift(A.location):void 0,A}e.$aL=3;var h;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(h||(e.DetailType=h={}));var D;(function(A){A.serialize=B=>B.type===0?C.serialize(B):I.serialize(B),A.deserialize=B=>B.type===0?C.deserialize(B):I.deserialize(B)})(D||(e.CoverageDetails=D={}));var k;(function(A){A.serialize=v,A.deserialize=y})(k||(e.IBranchCoverage=k={}));var C;(function(A){A.serialize=v,A.deserialize=y})(C||(e.IDeclarationCoverage=C={}));var I;(function(A){A.serialize=B=>({...v(B),branches:B.branches?.map(k.serialize)}),A.deserialize=B=>({...y(B),branches:B.branches?.map(k.deserialize)})})(I||(e.IStatementCoverage=I={}));var W;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(A){A.deserialize=(B,K)=>K.op===0?{op:K.op,item:t.deserialize(B,K.item)}:K.op===1?{op:K.op,item:g.deserialize(K.item)}:K.op===2?{op:K.op,uri:B.asCanonicalUri(P.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=B=>B.op===0?{op:B.op,item:t.serialize(B.item)}:B.op===1?{op:B.op,item:g.serialize(B.item)}:B})(V||(e.TestsDiffOp=V={}));class q{constructor(B){this.k=B,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(B){const K=this.v();for(const ie of B)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(g.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(B,K){const ie=N.$5K.parentId(B.item.extId)?.toString();let ce;if(!ie)ce=this.w(B),this.g.add(ce),this.f.set(B.item.extId,ce);else if(this.f.has(ie)){const ve=this.f.get(ie);ve.children.add(B.item.extId),ce=this.w(B,ve),this.f.set(B.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return K.add?.(ce),B.expand===2&&this.h++,ce}o(B,K){const ie=this.f.get(B.extId);if(ie)return B.expand!==void 0&&(ie.expand===2&&this.h--,B.expand===2&&this.h++),(0,e.$_K)(ie,B),K.update?.(ie),ie}p(B,K){const ie=this.f.get(B);if(!ie)return;const ce=N.$5K.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ve=[[B]];for(;ve.length;)for(const Se of ve.pop()){const fe=this.f.get(Se);fe&&(ve.push(fe.children),this.f.delete(Se),K.remove?.(fe,fe!==ie),fe.expand===2&&this.h--)}}q(B){}updatePendingRoots(B){this.j+=B}v(){return{}}}e.$bL=q}),define(ke[77],Ie([1,0,11,5,6,57,62,52]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(n,i)=>n===i,S=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(c=>!i.includes(c)))}),l=(n,i)=>{let c;for(const[u,t]of S)t(n[u],i[u])||(c?c[u]=i[u]:c={[u]:i[u]});return c};class b extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new P.$Kh(()=>this.flushDiff(),200)),this.g=this.B(new O.$fe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===i.uri){c.docv=i.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===i.item.extId){(0,R.$_K)(c.item,i.item);return}if(c.op===0&&c.item.item.extId===i.item.extId){(0,R.$_K)(c.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,c){const u=this.tree.get(i);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,c-1):t.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,c){switch(c.op){case 3:this.O(p.$5K.joinToString(i.fullId,c.id));break;case 0:this.z(c.item,i);break;case 5:for(const u of c.ops)this.w(i,u);break;case 1:this.C(c.new,c.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:c.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$ed)(c)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,c){const u=p.$5K.fromExtHostTestItem(i,this.root.id,c?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(i.id);let g=this.tree.get(u.toString());if(!g){g={fullId:u,actual:i,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(i,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(i)}}),this.I(i,g,c);return}if(g.actual===i){this.H(i,g,c);return}if(g.actual.uri?.toString()!==i.uri?.toString())return this.O(u.toString()),this.z(i,c);const a=this.s.getChildren(g.actual),d=g.actual,w=l(this.s.toITestItem(d),this.s.toITestItem(i));this.s.getApiFor(d).listener=void 0,g.actual=i,g.resolveBarrier=void 0,g.expand=0,w&&(w.hasOwnProperty("tags")&&(this.C(i.tags,d.tags,u.toString()),delete w.tags),this.w(g,{op:4,update:w})),this.I(i,g,c);for(const[v,y]of a)this.s.getChildren(i).get(y.id)||this.O(p.$5K.joinToString(u,y.id));const $=g.expandLevels;$!==void 0&&queueMicrotask(()=>{g.expand===1&&(g.expandLevels=void 0,this.expand(u.toString(),$))}),this.y(g.actual.uri)}C(i,c,u){const t=new Set(c.map(g=>g.id));for(const g of i)t.delete(g.id)||this.D(g);this.pushDiff({op:1,item:{extId:u,item:{tags:i.map(g=>(0,R.$0K)(this.s.controllerId,g.id))}}}),t.forEach(this.F,this)}D(i){const c=this.j.get(i.id);c?c.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$0K)(this.s.controllerId,i.id)}}))}F(i){const c=this.j.get(i);c&&!--c.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,R.$0K)(this.s.controllerId,i)}))}G(i,c){this.s.getApiFor(i).parent=c&&c.actual!==this.root?c.actual:void 0}H(i,c,u){this.G(i,u);const t=this.s.getApiFor(i);t.parent=u?.actual,t.listener=g=>this.w(c,g),this.J(c)}I(i,c,u){this.H(i,c,u);for(const[t,g]of this.s.getChildren(i))this.z(g,c)}J(i){let c;this.h?i.resolveBarrier?c=i.resolveBarrier.isOpen()?3:2:c=i.actual.canResolveChildren?1:0:c=0,c!==i.expand&&(i.expand=c,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:c}}),c===1&&i.expandLevels!==void 0&&this.M(i))}L(i,c){if(c<0)return;const u=[];for(const[t,g]of this.s.getChildren(i.actual)){const a=this.expand(p.$5K.joinToString(i.fullId,g.id),c);(0,P.$kh)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const g=new P.$xh;return g.open(),g}i.expand=2,this.N(i);const c=i.resolveBarrier=new P.$xh,u=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(g){u(g)}return(0,P.$kh)(t)?t.catch(u).then(()=>{c.open(),this.J(i)}):(c.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const c=this.tree.get(i);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const u=[c];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const g of t.actual.tags)this.F(g.id);this.tree.delete(t.fullId.toString());for(const[g,a]of this.s.getChildren(t.actual))u.push(this.tree.get(p.$5K.joinToString(t.fullId,a.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$zO=b;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$AO=f;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$BO=r;class s extends Error{constructor(i,c,u){super(`TestItem with ID "${i}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$CO=s;const o=(n,i,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,g){for(const a of u.values())t.call(g,a,this)},[Symbol.iterator](){return u.entries()},replace(t){const g=new Map,a=new Set(u.keys()),d={op:5,ops:[]};for(const w of t){if(!(w instanceof c))throw new r(w.id);const $=i(w).controllerId;if($!==n.controllerId)throw new s(w.id,$,n.controllerId);if(g.has(w.id))throw new f(w.id);g.set(w.id,w),a.delete(w.id),d.ops.push({op:0,item:w})}for(const w of a.keys())d.ops.push({op:3,id:w});n.listener?.(d),u=g},add(t){if(!(t instanceof c))throw new r(t.id);u.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){u.delete(t)&&n.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$DO=o}),define(ke[107],Ie([1,0,77]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=void 0;const O=new WeakMap,M=(R,p)=>{const m={controllerId:p};return O.set(R,m),m};e.$EO=M;const N=R=>{const p=O.get(R);if(!p)throw new P.$BO(R?.id||"<unknown>");return p};e.$FO=N}),define(ke[78],Ie([1,0,16,2]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Ab=e.$5Ab=e.$4Ab=void 0,e.$7Ab=M,e.$8Ab=R,e.$4Ab="vscode-cdn.net",e.$5Ab=`vscode-resource.${e.$4Ab}`,e.$6Ab=`'self' https://*.${e.$4Ab}`;function M(p,m){return p.scheme===P.Schemas.http||p.scheme===P.Schemas.https?p:(m&&m.authority&&m.isRemote&&p.scheme===P.Schemas.file&&(p=O.URI.from({scheme:P.Schemas.vscodeRemote,authority:m.authority,path:p.path})),O.URI.from({scheme:P.Schemas.https,authority:`${p.scheme}+${N(p.authority)}.${e.$5Ab}`,path:p.path,fragment:p.fragment,query:p.query}))}function N(p){return p.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[232],Ie([1,0,5,6,78]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class N{constructor(p,m,E){this.d=p,this.e=m,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const T=m.getVisibleTextEditors();for(const S of this.c.values())T.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,m,E,T,S){let l;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===p){l=i;break}if(!l)throw new Error("not a visible editor");const b=this,f=this.a++,r=new P.$fe,s=new P.$fe,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$7Ab)(i,b.f)}get cspSource(){return M.$6Ab}set options(i){this.b=i,b.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,b.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return b.d.$postMessage(f,i)}},n=new class{constructor(){this.editor=p,this.line=m,this.height=E,this.webview=o,this.onDidDispose=s.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),s.fire(),s.dispose(),r.dispose())}};return this.d.$createEditorInset(f,l.id,l.value.document.uri,m+1,E,T||{},S.identifier,S.extensionLocation),this.c.set(f,{editor:p,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(p){const m=this.c.get(p);m&&m.inset.dispose()}$onDidReceiveMessage(p,m){this.c.get(p)?.onDidReceiveMessage.fire(m)}}e.$6lc=N}),define(ke[108],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.$iL=void 0,e.$iL="__",e.$jL=(0,P.$yi)("IAuthenticationService"),e.$kL=(0,P.$yi)("IAuthenticationExtensionsService")}),define(ke[233],Ie([1,0,3]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.VariableKind=e.$xP=void 0,e.$xP=(0,P.$yi)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class M extends Error{constructor(R,p){super(p),this.variable=R}}e.$yP=M}),define(ke[234],Ie([1,0,19,75,15,26,23,97,192,233,13]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,f,r,s){this.h=new Map,this.a=b,this.b=f,this.g=r,s&&(this.c=s.then(o=>this.i(o)))}i(b){if(R.$i){const f=Object.create(null);return Object.keys(b).forEach(r=>{f[r.toLowerCase()]=b[r]}),f}return b}resolveWithEnvironment(b,f,r){return this.l({env:this.i(b),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(b,f){const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,f)}async j(b,f,r,s){const o=N.$5n(f);R.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):R.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):R.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,b?b.uri:void 0,o,r,s)}async resolveAnyAsync(b,f,r){return this.j(b,f,r)}async resolveAnyMap(b,f,r){const s=new Map;return{newConfig:await this.j(b,f,r,s),resolvedVariables:s}}resolveWithInteractionReplace(b,f,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,f)}async l(b,f,r,s,o){if(M.$$f(r))return this.m(b,f,r,s,o);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(b,f,n,s,o)));if(M.$ag(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async c=>[await this.m(b,f,c,s,o),await this.l(b,f,r[c],s,o)]));for(const[c,u]of i)n[c]=u;return n}return r}m(b,f,r,s,o){return(0,T.$rf)(r,S.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(S.VARIABLE_LHS))return n;let c=await this.o(b,n,i,f,s);return o?.set(i,c),c!==n&&M.$$f(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(b,f,c,s,o)),c})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,f,r,s,o){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const c=g=>{const a=this.a.getFilePath();if(a)return(0,p.$Hw)(a);throw new E.$yP(g,(0,m.localize)(0,null,f))},u=g=>{const a=c(g);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,p.$Hw)(d)}throw new E.$yP(g,(0,m.localize)(1,null,f,P.$nc(a)))},t=g=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new E.$yP(g,(0,m.localize)(2,null,f,n))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new E.$yP(g,(0,m.localize)(3,null,f)):new E.$yP(g,(0,m.localize)(4,null,f))};switch(r){case"env":if(n){if(b.env){const g=b.env[R.$i?n.toLowerCase():n];if(M.$$f(g))return g}return""}throw new E.$yP(E.VariableKind.Env,(0,m.localize)(5,null,f));case"config":if(n){const g=this.a.getConfigurationValue(s,n);if(M.$hg(g))throw new E.$yP(E.VariableKind.Config,(0,m.localize)(6,null,f,n));if(M.$ag(g))throw new E.$yP(E.VariableKind.Config,(0,m.localize)(7,null,f,n));return g}throw new E.$yP(E.VariableKind.Config,(0,m.localize)(8,null,f));case"command":return this.p(E.VariableKind.Command,f,n,o,"command");case"input":return this.p(E.VariableKind.Input,f,n,o,"input");case"extensionInstallFolder":if(n){const g=await this.a.getExtension(n);if(!g)throw new E.$yP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,f,n));return this.n(g.extensionLocation)}throw new E.$yP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,p.$Hw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return s||n?(0,p.$Hw)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Hw)(P.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new E.$yP(E.VariableKind.UserHome,(0,m.localize)(11,null,f))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new E.$yP(E.VariableKind.LineNumber,(0,m.localize)(12,null,f))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new E.$yP(E.VariableKind.SelectedText,(0,m.localize)(13,null,f))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return P.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||n?P.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const g=P.$mc(c(E.VariableKind.RelativeFileDirname));if(s||n){const a=P.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),g);return a.length===0?".":a}return g}case"fileDirname":return P.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return P.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return P.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=P.$nc(c(E.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-P.$oc(g).length)}case"fileDirnameBasename":return P.$nc(P.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||f}case"execInstallFolder":{const g=this.a.getAppRoot();return g||f}case"pathSeparator":case"/":return P.sep;default:try{const g=n?`${r}:${n}`:r;return this.p(E.VariableKind.Unknown,f,g,o,void 0)}catch{return f}}}}p(b,f,r,s,o){if(r&&s){const n=o===void 0?s[r]:s[o+":"+r];if(typeof n=="string")return n;throw new E.$yP(b,(0,m.localize)(14,null,f))}return f}}e.$NP=S}),define(ke[109],Ie([1,0,3,106]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$2D=void 0,e.$3D=E,e.$4D=l,e.$5D=b,e.$2D=(0,P.$yi)("editorGroupsService");var M;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var p;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var m;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(f){const r=f;return(0,O.$MF)(r?.editor)&&(0,O.$MF)(r?.replacement)}var T;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[235],Ie([1,0,3,109]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$8D=e.$7D=e.$6D=void 0,e.$0D=M,e.$6D=(0,P.$yi)("editorService"),e.$7D=-1,e.$8D=-2,e.$9D=-3;function M(N){const R=N;return typeof N=="number"||(0,O.$4D)(R)}}),define(ke[236],Ie([1,0,3,99]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=void 0,e.$DL=(0,P.$zi)(O.$Fi)}),define(ke[110],Ie([1,0,21,5,19,6,11]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=e.$mac=e.$lac=e.$kac=void 0;class p{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$kac=p;class m{static isHostExtension(n,i,c){if(i.getExtensionDescription(n))return!1;const u=c.getExtensionDescription(n);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new P.$Vm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const c of i)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=s(this.e,i),this.e=this.e.concat(n);const c=m.l(this.e);return this.e=s(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,d){this.addNode(a),this.addNode(d),this.c.has(a)?this.c.get(a).push(d):this.c.set(a,[d])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,d){const w=i.getArcs(a);for(let $=0;$<w.length;$++)if(!d.has(w[$]))return!1;return!0}getNodes(){return this.e}},c=new P.$Vm;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const d of a.extensionDependencies)i.addArc(P.$Tm.toKey(a.identifier),P.$Tm.toKey(d));const u=new Set;i.getNodes().filter(a=>i.getArcs(a).length===0).forEach(a=>u.add(a));const t=i.getNodes().filter(a=>!u.has(a));let g;do{g=!1;for(let a=0;a<t.length;a++){const d=t[a];i.hasOnlyGoodArcs(d,u)&&(t.splice(a,1),a--,u.add(d),g=!0)}}while(g);return t.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$lac=m;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$mac=E;class T{constructor(n){this.d=new b,this.c=new m(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new S(this,i)}deltaExtensions(n,i,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$nac=T;class S extends N.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$oac=S;class l{constructor(n){this.name=n;const i=(0,R.$rh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class b{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new l(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};n.resolve((0,N.$Sc)(u))}}var f;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(f||(f={}));function r(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==c)return i-c;const u=M.$gc.basename(o.extensionLocation.path),t=M.$gc.basename(n.extensionLocation.path);return u<t?-1:u>t?1:0}function s(o,n){const i=new P.$Um(n);return o.filter(c=>!i.has(c.identifier))}}),define(ke[79],Ie([1,0,22]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$2m=R,e.$3m=p;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var M;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var N;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(E){const T=P.$He.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function p(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(ke[63],Ie([1,0,3,5,12,27,79,58,59,26,2,6,179]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$2O=e.$1O=void 0,e.$3O=r;let b=class extends S.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new O.$fe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$fe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$np,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$7j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const c=this.getTelemetryDetails(),u=new f(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Km)((0,m.$tp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,c)=>{const u=i.filter(t=>!t.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(i=>{for(const c of i)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const c=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(o.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),u=!0);return u}};e.$1O=b,e.$1O=b=Je([We(0,N.$ZO),We(1,M.$6j)],b);class f{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,c,u,t,g){this.g=i,this.h=c,this.i=u,this.j=t,this.a=new O.$fe,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,m.$wp)(n,[]),this.c&&(n=(0,E.$8n)(n,this.c)),this.b||(n=(0,E.$8n)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},c=(0,m.$wp)(i,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(u,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$2O=f;function r(s){const o=Date.now()-new Date(s).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$4O=(0,P.$yi)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,5,2,207,105,21,3]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.ActivationKind=e.$UG=e.$TG=e.$QG=e.ExtensionHostStartup=e.$PG=e.$OG=e.$NG=e.$MG=void 0,e.$RG=l,e.$SG=b,e.$VG=o,e.$WG=n,e.$MG=Object.freeze({identifier:new R.$Tm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$NG="extensions.webWorker",e.$OG=(0,p.$yi)("extensionService");class m{constructor(u){this.dependency=u}}e.$PG=m;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,g){this.c=u,this.d=t.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$xG.createActivationEventsMap(this.d)}}set(u,t,g){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],d=[],w=[],$=[],v=S(this.d),y=S(t),h=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=y.get(W.identifier);if(!V){a.push(W.identifier),v.delete(W.identifier);continue}if(!h(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}for(const W of t){const V=v.get(W.identifier);if(!V){d.push(W);continue}if(!h(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}const D=new R.$Um(this.e),k=new R.$Um(g);for(const W of this.e)k.has(W)||w.push(W);for(const W of g)D.has(W)||$.push(W);const C=N.$xG.createActivationEventsMap(d),I={versionId:u,toRemove:a,toAdd:d,addActivationEvents:C,myToRemove:w,myToAdd:$};return this.delta(I),I}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:g,myToRemove:a,myToAdd:d}=u,w=new R.$Um(t),$=new R.$Um(a);for(let v=0;v<this.d.length;v++)w.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)$.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of g)this.d.push(v);for(const v of d)this.e.push(v);return this.f=null,u}containsExtension(u){for(const t of this.e)if(R.$Tm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const g=N.$xG.readActivationEvents(t);for(const a of g)u.add(a)}return u}}e.$QG=T;function S(c){const u=new R.$Vm;for(const t of c)u.set(t.identifier,t);return u}function l(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function b(c,u){if(!l(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class f{constructor(u,t,g,a){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=g,this.activationReason=a}}e.$TG=f;class r{constructor(u,t){this.description=u,this.value=t}}e.$UG=r;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,M.$Cp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,u){return{identifier:new R.$Tm((0,M.$Ap)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=P.Event.None,this.onDidChangeExtensionsStatus=P.Event.None,this.onDidChangeExtensions=P.Event.None,this.onWillActivateByEvent=P.Event.None,this.onDidChangeResponsiveChange=P.Event.None,this.onWillStop=P.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$XG=i}),define(ke[237],Ie([1,0,14,110,21,25,12,11]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=e.$smc=e.$rmc=e.$qmc=e.$pmc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(o,n,i,c){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=c}}e.$pmc=m;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$qmc=E;class T{constructor(o,n,i,c,u,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=c,this.exports=u,this.subscriptions=t}}e.$rmc=T;class S extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$smc=S;class l extends T{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$tmc=l;class b extends T{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(o,n,i,c){this.g=c,this.a=o,this.b=n,this.c=i,this.d=new M.$Vm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new b(u));return this.c.onExtensionActivationError(o.id,u,new N.$PG(o.id.value)),t}const i=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const u of c){if(this.m(u))continue;const t=this.d.get(u);if(t){i.push(t);continue}if(this.l(u)){i.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:o.reason}));continue}const g=this.a.getExtensionDescription(u);if(g){if(!g.main&&!g.browser)continue;i.push(this.j({id:g.identifier,reason:o.reason}));continue}const a=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),w=this.k(o,n.displayName,[],new b(d));return this.c.onExtensionActivationError(n.identifier,d,new N.$PG(u)),w}return this.k(o,n.displayName,i,null)}k(o,n,i,c){const u=new r(o.id,n,o.reason,i,c,this.c,this.g);return this.d.set(o.id,u),u}l(o){return O.$lac.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$umc=f,e.$umc=f=Je([We(3,R.$5j)],f);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,c,u,t,g){this.c=o,this.d=n,this.f=i,this.g=c,this.h=u,this.j=t,this.k=g,this.a=new p.$xh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new b(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new b(n),this.b&&P.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};r=Je([We(6,R.$5j)],r)}),define(ke[238],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[239],Ie([1,0,194,14,32,100,74,29,21,238,102,105]),function(le,e,P,O,M,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=void 0;const l=p.$fo.as(R.$go.JSONContribution);class b{constructor(u,t,g){this.a=u,this.b=t,this.c=g}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(M.default.Error,u)}warn(u){this.d(M.default.Warning,u)}info(u){this.d(M.default.Info,u)}}e.$GG=b;class f{static a(u){const t=new m.$Um;for(let g=0,a=u.length;g<a;g++)t.add(u[g].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new f(t,[]);if(!t||!t.length)return new f([],u);const g=this.a(u),a=this.a(t),d=t.filter($=>!g.has($.description.identifier)),w=u.filter($=>!a.has($.description.identifier));return new f(d,w)}constructor(u,t){this.added=u,this.removed=t}}e.$HG=f;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=f.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,O.$1)(u)}}}e.$IG=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[P.localize(0,null),P.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$JG={properties:{engines:{type:"object",description:P.localize(2,null),properties:{vscode:{type:"string",description:P.localize(3,null),default:"^1.22.0"}}},publisher:{description:P.localize(4,null),type:"string"},displayName:{description:P.localize(5,null),type:"string"},categories:{description:P.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Sm},{type:"string",const:"Languages",deprecationMessage:P.localize(7,null)}]}},galleryBanner:{type:"object",description:P.localize(8,null),properties:{color:{description:P.localize(9,null),type:"string"},theme:{description:P.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:P.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:P.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:P.localize(13,null)},enabledApiProposals:{markdownDescription:P.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:P.localize(15,null),type:"string",enum:["none"],enumDescriptions:[P.localize(16,null)]},activationEvents:{description:P.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:P.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:P.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:P.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:P.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:P.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:P.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:P.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:P.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:P.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:P.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:P.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:P.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:P.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:P.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:P.localize(32,null)},{label:"onUri",body:"onUri",description:P.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:P.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:P.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:P.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:P.localize(37,null)},{label:"onRenderer",description:P.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:P.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:P.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:P.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:P.localize(42,null)},{label:"*",description:P.localize(43,null),body:"*"}]}},badges:{type:"array",description:P.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:P.localize(45,null)},href:{type:"string",description:P.localize(46,null)},description:{type:"string",description:P.localize(47,null)}}}},markdown:{type:"string",description:P.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:P.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:P.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Wo}},extensionPack:{description:P.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Wo}},extensionKind:{description:P.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:P.localize(53,null)},{body:["workspace"],description:P.localize(54,null)},{body:["ui","workspace"],description:P.localize(55,null)},{body:["workspace","ui"],description:P.localize(56,null)},{body:[],description:P.localize(57,null)}]},capabilities:{description:P.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:P.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:P.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[P.localize(61,null),P.localize(62,null),P.localize(63,null)]},description:{type:"string",markdownDescription:P.localize(64,null)}}},untrustedWorkspaces:{description:P.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:P.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[P.localize(67,null),P.localize(68,null),P.localize(69,null)]},restrictedConfigurations:{description:P.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:P.localize(71,null)}}}}},sponsor:{description:P.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:P.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:P.localize(74,null),type:"string"},"vscode:uninstall":{description:P.localize(75,null),type:"string"}}},icon:{type:"string",description:P.localize(76,null)},l10n:{type:"string",description:P.localize(77,null)},pricing:{type:"string",markdownDescription:P.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&S.$xG.register(u.extensionPoint,u.activationEventsGenerator),e.$JG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(o,e.$JG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$KG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};p.$fo.add(i.ExtensionsRegistry,new n),e.$LG=p.$fo.as(i.ExtensionsRegistry),l.registerSchema(o,e.$JG),l.registerSchema(T.$mk,{properties:{extensionEnabledApiProposals:{description:P.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[240],Ie([1,0,190,15,26,239,31,5]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:P.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:P.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:P.localize(2,null),default:""}}};var E;(function(l){function b(f,r,s){if(!f)return;const o=O.$$f(f.type)?f.type:void 0;if(!o||o.length===0){s.error(P.localize(3,null));return}const n=[];if(Array.isArray(f.required))for(const i of f.required)O.$$f(i)&&n.push(i);return{extensionId:r.value,taskType:o,required:n,properties:f.properties?M.$5n(f.properties):{},when:f.when?R.$wj.deserialize(f.when):void 0}}l.from=b})(E||(E={}));const T=N.$LG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,b)=>{for(const f of l)f.type&&b.push(`onTaskType:${f.type}`)},jsonSchema:{description:P.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new p.$fe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{T.setHandler((r,s)=>{this.c=void 0;try{for(const o of s.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of s.added){const n=o.value;for(const i of n){const c=E.from(i,o.description.identifier,o.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=M.$5n(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},b.push(r)}this.c={oneOf:b}}return this.c}}e.$fI=new S}),define(ke[241],Ie([1,0,191,15,24,26,31,240]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$pI=e.JsonSchemaVersion=e.ExecutionEngine=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$jI=e.ShellQuoting=e.$iI=e.$hI=e.$gI=void 0,e.$gI="settings",e.$hI=new R.$Pj("taskRunning",!1,P.localize(0,null)),e.$iI=P.localize2(2,"Tasks");var m;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$jI="$customized",function(A){function B(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=B}(m||(e.ShellQuoting=m={}));var E;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(T||(e.RevealKind=T={})),function(A){function B(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=B}(T||(e.RevealKind=T={}));var S;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(A){function B(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=B}(S||(e.RevealProblemKind=S={}));var l;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(l||(e.PanelKind=l={})),function(A){function B(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=B}(l||(e.PanelKind=l={}));var b;(function(A){A.defaults={echo:!0,reveal:T.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var f;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(A){function B(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=B;function K(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(f||(e.RuntimeType=f={}));var r;(function(A){function B(K){return O.$$f(K)?K:K.value}A.value=B})(r||(e.CommandString=r={}));var s;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function B(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=B;function K(ie){if(ie!==void 0)return O.$$f(ie)?B(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=K})(s||(e.TaskGroup=s={}));var o;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function B(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var i;(function(A){A.parallel="parallel",A.sequence="sequence"})(i||(e.DependsOrder=i={}));var c;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(B,K,ie,ce,ve,Se){this._label="",this._id=B,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ve,this._source=Se}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,K=!1){if(B===void 0)return!1;if(O.$$f(B))return B===this._label||B===this.configurationProperties.identifier||K&&B===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$kI=t;class g extends t{constructor(B,K,ie,ce,ve,Se,fe,$e){super(B,ie,void 0,fe,$e,K),this.command={},this._source=K,this.hasDefinedMatchers=Se,ve&&(this.command=ve)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case f.Shell:K="shell";break;case f.Process:K="process";break;case f.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(B){return B instanceof g}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$gI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$jI,folder:B,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new g(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$lI=g;class a extends t{constructor(B,K,ie,ce,ve,Se,fe){super(B,ie,ce,Se,fe,K),this._source=K,this.configures=ve}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$gI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$jI,folder:B,id:K};return JSON.stringify(ie)}}e.$mI=a;class d extends t{constructor(B,K,ie,ce,ve,Se,fe,$e,Te){super(B,ie,ce,$e,Te,K),this.defines=ve,this.hasDefinedMatchers=fe,this.command=Se,this.icon=Te.icon,this.hide=Te.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof d}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new d(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$nI=d;class w extends t{constructor(B,K,ie,ce,ve,Se){super(B,ie,ce,ve,Se,K),this._source=K}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new w(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$oI=w;var $;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(A){A._default=A.Terminal}($||(e.ExecutionEngine=$={}));var v;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class y{constructor(B){this.c=new Map;for(let K=0;K<B.length;K++)this.c.set(B[K].uri.toString(),K)}compare(B,K){const ie=B.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ve=this.c.get(ie.uri.toString());ve=ve===void 0?0:ve+1;let Se=this.c.get(ce.uri.toString());return Se=Se===void 0?0:Se+1,ve===Se?B._label.localeCompare(K._label):ve-Se}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$pI=y;var h;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(h||(e.TaskEventKind=h={}));var D;(function(A){A.SingleRun="singleRun",A.Background="background"})(D||(e.TaskRunType=D={}));var k;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var C;(function(A){function B($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function K($e,Te,ae){return{...B($e),kind:"start",terminalId:Te,resolvedVariables:ae}}A.start=K;function ie($e,Te,ae){return{...B($e),kind:"processStarted",terminalId:Te,processId:ae}}A.processStarted=ie;function ce($e,Te,ae){return{...B($e),kind:"processEnded",terminalId:Te,exitCode:ae}}A.processEnded=ce;function ve($e,Te,ae){return{...B($e),kind:"terminated",exitReason:ae,terminalId:Te}}A.terminated=ve;function Se($e,Te,ae){return{...B(Te),kind:$e,terminalId:ae}}A.general=Se;function fe(){return{kind:"changed"}}A.changed=fe})(C||(e.TaskEvent=C={}));var I;(function(A){function B(ie){const ce=Object.keys(ie).sort();let ve="";for(const Se of ce){let fe=ie[Se];fe instanceof Object?fe=B(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ve+=Se+","+fe+","}return ve}function K(ie){const ve={_key:B(ie),type:ie.taskType};return Object.assign(ve,ie),ve}A.create=K})(I||(e.KeyedTaskIdentifier=I={}));var W;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(A){function B(K,ie){const ce=p.$fI.get(K.type);if(ce===void 0){const $e=N.$5n(K);return delete $e._key,I.create($e)}const ve=Object.create(null);ve.type=ce.taskType;const Se=new Set;ce.required.forEach($e=>Se.add($e));const fe=ce.properties;for(const $e of Object.keys(fe)){const Te=K[$e];if(Te!=null)ve[$e]=Te;else if(Se.has($e)){const ae=fe[$e];if(ae.default!==void 0)ve[$e]=N.$5n(ae.default);else switch(ae.type){case"boolean":ve[$e]=!1;break;case"number":case"integer":ve[$e]=0;break;case"string":ve[$e]="";break;default:ie.error(P.localize(1,null,JSON.stringify(K,void 0,0),$e));return}}}return I.create(ve)}A.createTaskIdentifier=B})(q||(e.TaskDefinition=q={}))}),define(ke[242],Ie([1,0,14]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=e.$pac=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,p)=>{this.b=R,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,P.$1)(R))}then(R,p){return this.j().then(R,p)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$pac=O;class M extends O{constructor(){super(),this.h=!0,this.i=new P.$5}}e.$qac=M}),define(ke[34],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Bw=void 0,e.$Cw=M,e.$Dw=N;class P{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++P.count}}e.$Bw=P;const O=[];function M(p){const m=new P(p);return O[m.nid]=m,m}function N(p){return O[p].sid}class R{constructor(m){this.value=m}}e.$Ew=R}),define(ke[4],Ie([1,0,34]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var M;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var p;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(T||(e.CandidatePortSource=T={}));class S{static{this.a=0}static mixin(s){return s._id=S.a++,s}}e.$fM=S;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$gM={MainThreadAuthentication:(0,P.$Cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,P.$Cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,P.$Cw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,P.$Cw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,P.$Cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,P.$Cw)("MainThreadChatVariables"),MainThreadClipboard:(0,P.$Cw)("MainThreadClipboard"),MainThreadCommands:(0,P.$Cw)("MainThreadCommands"),MainThreadComments:(0,P.$Cw)("MainThreadComments"),MainThreadConfiguration:(0,P.$Cw)("MainThreadConfiguration"),MainThreadConsole:(0,P.$Cw)("MainThreadConsole"),MainThreadDebugService:(0,P.$Cw)("MainThreadDebugService"),MainThreadDecorations:(0,P.$Cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,P.$Cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,P.$Cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,P.$Cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,P.$Cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,P.$Cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,P.$Cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,P.$Cw)("MainThreadEditorTabs"),MainThreadErrors:(0,P.$Cw)("MainThreadErrors"),MainThreadTreeViews:(0,P.$Cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,P.$Cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,P.$Cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,P.$Cw)("MainThreadLanguages"),MainThreadLogger:(0,P.$Cw)("MainThreadLogger"),MainThreadMessageService:(0,P.$Cw)("MainThreadMessageService"),MainThreadOutputService:(0,P.$Cw)("MainThreadOutputService"),MainThreadProgress:(0,P.$Cw)("MainThreadProgress"),MainThreadQuickDiff:(0,P.$Cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,P.$Cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,P.$Cw)("MainThreadStatusBar"),MainThreadSecretState:(0,P.$Cw)("MainThreadSecretState"),MainThreadStorage:(0,P.$Cw)("MainThreadStorage"),MainThreadSpeech:(0,P.$Cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,P.$Cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,P.$Cw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,P.$Cw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,P.$Cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,P.$Cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,P.$Cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,P.$Cw)("MainThreadCustomEditors"),MainThreadUrls:(0,P.$Cw)("MainThreadUrls"),MainThreadUriOpeners:(0,P.$Cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,P.$Cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,P.$Cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,P.$Cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,P.$Cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,P.$Cw)("MainThreadExtensionService"),MainThreadSCM:(0,P.$Cw)("MainThreadSCM"),MainThreadSearch:(0,P.$Cw)("MainThreadSearch"),MainThreadShare:(0,P.$Cw)("MainThreadShare"),MainThreadTask:(0,P.$Cw)("MainThreadTask"),MainThreadWindow:(0,P.$Cw)("MainThreadWindow"),MainThreadLabelService:(0,P.$Cw)("MainThreadLabelService"),MainThreadNotebook:(0,P.$Cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,P.$Cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,P.$Cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,P.$Cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,P.$Cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,P.$Cw)("MainThreadInteractive"),MainThreadTheming:(0,P.$Cw)("MainThreadTheming"),MainThreadTunnelService:(0,P.$Cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,P.$Cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,P.$Cw)("MainThreadTimeline"),MainThreadTesting:(0,P.$Cw)("MainThreadTesting"),MainThreadLocalization:(0,P.$Cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,P.$Cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,P.$Cw)("MainThreadAiEmbeddingVector")},e.$hM={ExtHostCommands:(0,P.$Cw)("ExtHostCommands"),ExtHostConfiguration:(0,P.$Cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,P.$Cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,P.$Cw)("ExtHostDebugService"),ExtHostDecorations:(0,P.$Cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,P.$Cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,P.$Cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,P.$Cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,P.$Cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,P.$Cw)("ExtHostEditors"),ExtHostTreeViews:(0,P.$Cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,P.$Cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,P.$Cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,P.$Cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,P.$Cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,P.$Cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,P.$Cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,P.$Cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,P.$Cw)("ExtHostStatusBar"),ExtHostShare:(0,P.$Cw)("ExtHostShare"),ExtHostExtensionService:(0,P.$Cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,P.$Cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,P.$Cw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,P.$Cw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,P.$Cw)("ExtHostSCM"),ExtHostSearch:(0,P.$Cw)("ExtHostSearch"),ExtHostTask:(0,P.$Cw)("ExtHostTask"),ExtHostWorkspace:(0,P.$Cw)("ExtHostWorkspace"),ExtHostWindow:(0,P.$Cw)("ExtHostWindow"),ExtHostWebviews:(0,P.$Cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,P.$Cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,P.$Cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,P.$Cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,P.$Cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,P.$Cw)("ExtHostEditorTabs"),ExtHostProgress:(0,P.$Cw)("ExtHostProgress"),ExtHostComments:(0,P.$Cw)("ExtHostComments"),ExtHostSecretState:(0,P.$Cw)("ExtHostSecretState"),ExtHostStorage:(0,P.$Cw)("ExtHostStorage"),ExtHostUrls:(0,P.$Cw)("ExtHostUrls"),ExtHostUriOpeners:(0,P.$Cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,P.$Cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,P.$Cw)("ExtHostOutputService"),ExtHostLabelService:(0,P.$Cw)("ExtHostLabelService"),ExtHostNotebook:(0,P.$Cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,P.$Cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,P.$Cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,P.$Cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,P.$Cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,P.$Cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,P.$Cw)("ExtHostInteractive"),ExtHostChatAgents2:(0,P.$Cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,P.$Cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,P.$Cw)("ExtHostChatProvider"),ExtHostSpeech:(0,P.$Cw)("ExtHostSpeech"),ExtHostEmbeddings:(0,P.$Cw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,P.$Cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,P.$Cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,P.$Cw)("ExtHostTheming"),ExtHostTunnelService:(0,P.$Cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,P.$Cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,P.$Cw)("ExtHostAuthentication"),ExtHostTimeline:(0,P.$Cw)("ExtHostTimeline"),ExtHostTesting:(0,P.$Cw)("ExtHostTesting"),ExtHostTelemetry:(0,P.$Cw)("ExtHostTelemetry"),ExtHostLocalization:(0,P.$Cw)("ExtHostLocalization")}}),define(ke[80],Ie([1,0,3,12,4,17]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=void 0,e.$Olc=(0,P.$yi)("IExtHostApiDeprecationService");let R=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(M.$gM.MainThreadTelemetry)}report(m,E,T){const S=this.d(m,E);this.a.has(S)||(this.a.add(S),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$Plc=R,e.$Plc=R=Je([We(0,N.$JO),We(1,O.$5j)],R),e.$Qlc=Object.freeze(new class{report(p,m,E){}})}),define(ke[243],Ie([1,0,4]),function(le,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class O{constructor(N){const R=N.getProxy(P.$gM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(p){return R.$writeText(p)}})}}e.$4lc=O}),define(ke[244],Ie([1,0,26,4,27,17]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;let R=class{constructor(T,S){this.a=T.getProxy(O.$gM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,S){const l=this,b=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){l.e(T,S,b,arguments)}})}e(T,S,l,b){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(b,this.b)}),this.c&&this.f(T,l,b)}};e.$Xnc=R,e.$Xnc=R=Je([We(0,N.$JO),We(1,M.$ZO)],R);const p=1e5;function m(E,T){const S=[];if(E.length)for(let l=0;l<E.length;l++){let b=E[l];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}S.push(b)}if(T){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,P.$0n)(S);return l.length>p?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(ke[245],Ie([1,0,2,4,25]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class N{constructor(p){this.a=p.getProxy(O.$gM.MainThreadDialogs)}showOpenDialog(p,m){return m?.allowUIResources&&(0,M.$SG)(p,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(T=>P.URI.revive(T)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(m=>m?P.URI.revive(m):void 0)}}e.$1mc=N}),define(ke[246],Ie([1,0,20,5,6,4]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;class R{constructor(m){this.b=new Map,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(N.$gM.MainThreadEmbeddings)}registerEmbeddingsProvider(m,E,T){if(this.d.has(E))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,E),this.b.set(S,{id:E,provider:T}),(0,M.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(m,E,T){T??=P.CancellationToken.None;let S=!1;typeof E=="string"&&(E=[E],S=!0);const l=await this.a.$computeEmbeddings(m,E,T);if(l.length!==E.length)throw new Error;if(S){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings(m,E,T){const S=this.b.get(m);if(!S)return[];const l=await S.provider.provideEmbeddings(E,T);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$4mc=R}),define(ke[247],Ie([1,0,6,4]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(O.$gM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,R),(0,P.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$inc=M}),define(ke[81],Ie([1,0,23,13,2,3,12,4,27,17]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Imc=void 0;let T=class{constructor(l,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(p.$gM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===P.$g}getMessage(l,b){const{message:f,args:r,comment:s}=b;if(this.c)return(0,O.$$e)(f,r??{});let o=f;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const n=this.d.get(l)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$$e)(n??f,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let b;const f=await this.g(l);if(!f){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),s=JSON.parse(r);b=l.isBuiltin?s.contents?.bundle:s}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${f}: ${r.message}`);return}b&&this.d.set(l.identifier.value,{contents:b,uri:f})}async g(l){if(l.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return M.URI.revive(b)}return l.l10n?M.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Imc=T,e.$Imc=T=Je([We(0,m.$ZO),We(1,E.$JO),We(2,R.$5j)],T),e.$Jmc=(0,N.$yi)("IExtHostLocalizationService")}),define(ke[248],Ie([1,0,12,4,27,17,2,49]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;let m=class extends P.$dk{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(b=>(0,p.$8h)(b))),this.r=S.getProxy(O.$gM.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(R.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,b){return new E(this.r,S,l,b)}};e.$Wnc=m,e.$Wnc=m=Je([We(0,N.$JO),We(1,M.$ZO)],m);class E extends P.$$j{constructor(S,l,b,f){super(f?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(l,f).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const b=[[S,l]];this.m?this.u(b):this.n.push(...b)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(ke[82],Ie([1,0,4,3,6,17,22]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0,e.$Kmc=(0,O.$yi)("IExtHostManagedSockets");let p=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(P.$gM.MainThreadManagedSockets)}setFactory(S,l){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,b=await this.c.makeConnection(),f=new M.$Tc;return this.d.set(l,new E(l,b,f)),f.add((0,M.$Sc)(()=>this.d.delete(l))),f.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),f.dispose()})),f.add(b.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),f.dispose()})),f.add(b.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$He.wrap(r)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Lmc=p,e.$Lmc=p=Je([We(0,N.$JO)],p);class m{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class E extends M.$Uc{constructor(S,l,b){super(),this.socketId=S,this.actual=l,this.B(b)}}}),define(ke[249],Ie([1,0,4,12,25]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;function N(p){return p&&p.title}let R=class{constructor(m,E){this.b=E,this.a=m.getProxy(P.$gM.MainThreadMessageService)}showMessage(m,E,T,S,l){const b={source:{identifier:m.identifier,label:m.displayName||m.name}};let f;typeof S=="string"||N(S)?f=[S,...l]:(b.modal=S?.modal,b.useCustom=S?.useCustom,b.detail=S?.detail,f=l),b.useCustom&&(0,M.$SG)(m,"resolvers");const r=[];let s=!1;for(let o=0;o<f.length;o++){const n=f[o];if(typeof n=="string")r.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:c}=n;r.push({title:i,isCloseAffordance:!!c,handle:o}),c&&(s?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):s=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,T,b,r).then(o=>{if(typeof o=="number")return f[o]})}};e.$knc=R,e.$knc=R=Je([We(1,O.$5j)],R)}),define(ke[250],Ie([1,0,6,15,2,25,4]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class p{constructor(E){this.b=new Map,this.a=E.getProxy(R.$gM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,S){if((0,N.$SG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,S),this.a.$registerProfileContentHandler(T,S.name,S.description,E.identifier.value),(0,P.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,S,l){const b=this.b.get(E);if(!b)throw new Error(`Unknown handler with id: ${E}`);return b.saveProfile(T,S,l)}async $readProfile(E,T,S){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,O.$$f)(T)?T:M.URI.revive(T),S)}}e.$tnc=p}),define(ke[83],Ie([1,0,4,5,3]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;class N{constructor(p){this.b=new O.$fe,this.onDidChangePassword=this.b.event,this.a=p.getProxy(P.$gM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,m){return this.a.$getPassword(p,m)}store(p,m,E){return this.a.$setPassword(p,m,E)}delete(p,m){return this.a.$deletePassword(p,m)}}e.$Fmc=N,e.$Gmc=(0,M.$yi)("IExtHostSecretState")}),define(ke[251],Ie([1,0,20,6,4]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class N{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.f=new Map,this.b=p.getProxy(M.$gM.MainThreadSpeech)}async $createSpeechToTextSession(p,m,E){const T=this.c.get(p);if(!T)return;const S=new O.$Tc,l=new P.$qe;this.d.set(m,l);const b=await T.provideSpeechToTextSession(l.token,E?{language:E}:void 0);b&&(S.add(b.onDidChange(f=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,f)})),S.add(l.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createTextToSpeechSession(p,m){const E=this.c.get(p);if(!E)return;const T=new O.$Tc,S=new P.$qe;this.d.set(m,S);const l=await E.provideTextToSpeechSession(S.token);l&&(this.f.set(m,l),T.add(l.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,b)})),T.add(S.token.onCancellationRequested(()=>T.dispose())))}async $synthesizeSpeech(p,m){this.f.get(p)?.synthesize(m)}async $cancelTextToSpeechSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p),this.f.delete(p)}async $createKeywordRecognitionSession(p,m){const E=this.c.get(p);if(!E)return;const T=new O.$Tc,S=new P.$qe;this.d.set(m,S);const l=await E.provideKeywordRecognitionSession(S.token);l&&(T.add(l.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,b)})),T.add(S.token.onCancellationRequested(()=>T.dispose())))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,m,E){const T=N.a++;return this.c.set(T,E),this.b.$registerProvider(T,m,{extension:p,displayName:p.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Anc=N}),define(ke[84],Ie([1,0,4,5,3]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=e.$vmc=void 0;class N{constructor(p,m){this.c=m,this.b=new O.$fe,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(P.$gM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,m){this.a.$registerExtensionStorageKeysToSync(p,m)}async initializeExtensionStorage(p,m,E){const T=await this.a.$initializeExtensionStorage(p,m);let S;return T&&(S=this.d(p,m,T)),S||E}setValue(p,m,E){return this.a.$setValue(p,m,E)}$acceptValue(p,m,E){const T=this.d(p,m,E);T&&this.b.fire({shared:p,key:m,value:T})}d(p,m,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${p}): ${T}`)}}}e.$vmc=N,e.$wmc=(0,M.$yi)("IExtHostStorage")}),define(ke[252],Ie([1,0,6,16,2,4]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0;class R{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(N.$gM.MainThreadUriOpeners)}registerExternalUriOpener(m,E,T,S){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=S.schemes.find(b=>!R.a.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,S.schemes,m,S.label),(0,P.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const l=M.URI.revive(E);return S.canOpenExternalUri(l,T)}async $openUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(M.URI.revive(E.resolvedUri),{sourceUri:M.URI.revive(E.sourceUri)},T)}}e.$Qnc=R}),define(ke[253],Ie([1,0,4,2,6,14,21]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;class p{static{this.a=0}constructor(E){this.c=new R.$Um,this.d=new Map,this.b=E.getProxy(P.$gM.MainThreadUrls)}registerUriHandler(E,T){const S=E.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=p.a++;return this.c.add(S),this.d.set(l,T),this.b.$registerUriHandler(l,S,E.displayName||E.name),(0,M.$Sc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,T){const S=this.d.get(E);if(!S)return Promise.resolve(void 0);try{S.handleUri(O.URI.revive(T))}catch(l){(0,N.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$Rnc=p}),define(ke[64],Ie([1,0,5,6,16,26,2,197,221,78,4]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=e.$gmc=void 0,e.$hmc=l,e.$jmc=r,e.$kmc=s;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,t,g,a,d,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new P.$fe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new P.$fe,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=t,this.#n=g,this.#s=a,this.#r=d,this.#l=l(d),this.#d=b(d),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$7Ab)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===M.Schemas.https||c.scheme===M.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+E.$6Ab}return E.$6Ab}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),N.$9n(this.#o,c)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$Xrb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,a,d,w,$,v)=>{const y=R.URI.from({scheme:w||"file",path:decodeURIComponent($)}),h=(0,E.$7Ab)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,a,d,w,$,v)=>{const y=R.URI.from({scheme:w||"file",path:decodeURIComponent($)}),h=(0,E.$7Ab)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`})}}e.$gmc=S;function l(i){try{const c=(0,p.$Lp)((0,p.$Kp)(i.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function b(i){try{const c=(0,p.$Lp)((0,p.$Kp)(i.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class f extends O.$Uc{constructor(c,u,t,g,a){super(),this.c=u,this.f=t,this.g=g,this.h=a,this.b=new Map,this.a=c.getProxy(T.$gM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,t){const g=this.j(c);if(g){const{message:a}=(0,m.$Yrb)(u,t.value);g._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,t){const g=new S(c,this.a,o(u),this.c,this.f,t,this.h);this.b.set(c,g);const a=g._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return g}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$imc=f;function r(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||n(i,c)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(c=>R.URI.from(c))}}function n(i,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),i.extensionLocation]}}),define(ke[111],Ie([1,0,5,16,13,2,3,17,4]),function(le,e,P,O,M,N,R,p,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new P.$fe,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=l.getProxy(m.$gM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:f})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,b){b!==this.d[l]&&(this.d={...this.d,[l]:b},this.c.fire(this.d))}openUri(l,b){let f;if(typeof l=="string"){f=l;try{l=N.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,M.$9e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,f,b)}async asExternalUri(l,b){if((0,M.$9e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(l,b);return N.URI.from(f)}};e.$Tnc=T,e.$Tnc=T=E=Je([We(0,p.$JO)],T),e.$Unc=(0,R.$yi)("IExtHostWindow")}),define(ke[254],Ie([1,0,244,27,17]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;let N=class extends P.$Xnc{constructor(p,m){super(p,m)}f(p,m,E){m.apply(console,E)}};e.$6pc=N,e.$6pc=N=Je([We(0,M.$JO),We(1,O.$ZO)],N)}),define(ke[255],Ie([1,0,11,22,20,14,5,6,150,242,34]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.ResponsiveState=e.RequestInitiator=void 0,e.$rac=s,e.$sac=o;function l(k,C){try{return JSON.stringify(k,C)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class r{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function s(k,C=null,I=!1){const W=[];return{jsonString:(I?l:JSON.stringify)(k,(q,A)=>{if(typeof A>"u")return f;if(typeof A=="object"){if(A instanceof O.$He){const B=W.push(A)-1;return{[b]:B}}if(C)return C(q,A)}return A}),referencedBuffers:W}}function o(k,C,I){return JSON.parse(k,(W,V)=>{if(V){const q=V[b];if(typeof q=="number")return C[q];if(I&&V.$mid===1)return I.transformIncoming(V)}return V})}function n(k,C){return JSON.stringify(k,C)}function i(k){return k?(C,I)=>I&&I.$mid===1?k.transformOutgoing(I):I:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},g=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends p.$Uc{static{S=g}static{this.a=3*1e3}constructor(C,I=null,W=null){super(),this[S]=!0,this.b=this.B(new R.$fe),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=W,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$Bw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new P.$Kh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,m.$Dn)(C,this.g):C}getProxy(C){const{nid:I,sid:W}=C;return this.s[I]||(this.s[I]=this.J(I,W)),this.s[I]}J(C,I){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...A)=>this.U(C,q,A)),q===a?I:V[q])};return new Proxy(Object.create(null),W)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,W=C.length;I<W;I++){const V=C[I];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,W=$.read(C,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:A,method:B,args:K}=y.deserializeRequestJSONArgs(W);this.g&&(K=(0,m.$Dn)(K,this.g)),this.M(I,q,A,B,K,V===2);break}case 3:case 4:{let{rpcId:A,method:B,args:K}=y.deserializeRequestMixedArgs(W);this.g&&(K=(0,m.$Dn)(K,this.g)),this.M(I,q,A,B,K,V===4);break}case 5:{this.f?.logIncoming(I,q,0,"ack"),this.G(q);break}case 6:{this.N(I,q);break}case 7:{this.O(I,q,void 0);break}case 9:{let A=y.deserializeReplyOKJSON(W);this.g&&(A=(0,m.$Dn)(A,this.g)),this.O(I,q,A);break}case 10:{const A=y.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(I,q,A);break}case 8:{const A=y.deserializeReplyOKVSBuffer(W);this.O(I,q,A);break}case 11:{let A=y.deserializeReplyErrError(W);this.g&&(A=(0,m.$Dn)(A,this.g)),this.P(I,q,A);break}case 12:{this.P(I,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,W,V,q,A){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,T.$Dw)(W)}.${V}(`,q);const B=String(I);let K,ie;if(A){const ve=new M.$qe;q.push(ve.token),K=this.Q(W,V,q),ie=()=>ve.cancel()}else K=this.Q(W,V,q),ie=t;this.u[B]=ie;const ce=y.serializeAcknowledged(I);this.f?.logOutgoing(ce.byteLength,I,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[B];const Se=y.serializeReplyOK(I,ve,this.h);this.f?.logOutgoing(Se.byteLength,I,1,"reply:",ve),this.c.send(Se)},ve=>{delete this.u[B];const Se=y.serializeReplyErr(I,ve);this.f?.logOutgoing(Se.byteLength,I,1,"replyErr:",ve),this.c.send(Se)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const W=String(I);this.u[W]?.()}O(C,I,W){this.f?.logIncoming(C,I,0,"receiveReply:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(C,I,W){this.f?.logIncoming(C,I,0,"receiveReplyErr:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let A;W&&(W.$isError?(A=new Error,A.name=W.name,A.message=W.message,A.stack=W.stack):A=W),q.resolveErr(A)}Q(C,I,W){try{return Promise.resolve(this.S(C,I,W))}catch(V){return Promise.reject(V)}}S(C,I,W){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,T.$Dw)(C));const q=V[I];if(typeof q!="function")throw new Error("Unknown method "+I+" on actor "+(0,T.$Dw)(C));return q.apply(V,W)}U(C,I,W){if(this.j)return new E.$qac;let V=null;if(W.length>0&&M.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(N.$6());const q=y.serializeRequestArguments(W,this.h),A=++this.t,B=String(A),K=new E.$pac,ie=new p.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const ve=y.serializeCancel(A);this.f?.logOutgoing(ve.byteLength,A,0,"cancel"),this.c.send(y.serializeCancel(A))})),this.w[B]=new w(K,ie),this.F(A);const ce=y.serializeRequest(A,C,I,q,!!V);return this.f?.logOutgoing(ce.byteLength,A,0,`request: ${(0,T.$Dw)(C)}.${I}(`,W),this.c.send(ce),K}}e.$tac=d;class w{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class ${static alloc(C,I,W){const V=new $(O.$He.alloc(W+1+4),0);return V.writeUInt8(C),V.writeUInt32(I),V}static read(C,I){return new $(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let W=0,V=C.length;W<V;W++){const q=C[W];switch(I+=1,q.type){case 1:I+=this.sizeLongString(q.value);break;case 2:I+=this.sizeVSBuffer(q.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)I+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,W=C.length;I<W;I++){const V=C[I];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let W=0;W<C;W++)switch(this.readUInt8()){case 1:I[W]=this.readLongString();break;case 2:I[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),B=[];for(let K=0;K<q;++K)B.push(this.readVSBuffer());I[W]=new T.$Ew(o(A,B,null));break}case 4:I[W]=void 0;break}return I}}var v;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(v||(v={}));class y{static a(C){for(let I=0,W=C.length;I<W;I++)if(C[I]instanceof O.$He||C[I]instanceof T.$Ew||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const W=[];for(let V=0,q=C.length;V<q;V++){const A=C[V];if(A instanceof O.$He)W[V]={type:2,value:A};else if(typeof A>"u")W[V]={type:4};else if(A instanceof T.$Ew){const{jsonString:B,referencedBuffers:K}=s(A.value,I);W[V]={type:3,value:O.$He.fromString(B),buffers:K}}else W[V]={type:1,value:O.$He.fromString(n(A,I))}}return{type:1,args:W}}return{type:0,args:n(C,I)}}static serializeRequest(C,I,W,V,q){switch(V.type){case 0:return this.b(C,I,W,V.args,q);case 1:return this.c(C,I,W,V.args,q)}}static b(C,I,W,V,q){const A=O.$He.fromString(W),B=O.$He.fromString(V);let K=0;K+=$.sizeUInt8(),K+=$.sizeShortString(A),K+=$.sizeLongString(B);const ie=$.alloc(q?2:1,C,K);return ie.writeUInt8(I),ie.writeShortString(A),ie.writeLongString(B),ie.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),W=C.readShortString(),V=C.readLongString();return{rpcId:I,method:W,args:JSON.parse(V)}}static c(C,I,W,V,q){const A=O.$He.fromString(W);let B=0;B+=$.sizeUInt8(),B+=$.sizeShortString(A),B+=$.sizeMixedArray(V);const K=$.alloc(q?4:3,C,B);return K.writeUInt8(I),K.writeShortString(A),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),W=C.readShortString(),V=C.readMixedArray(),q=new Array(V.length);for(let A=0,B=V.length;A<B;A++){const K=V[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:I,method:W,args:q}}static serializeAcknowledged(C){return $.alloc(5,C,0).buffer}static serializeCancel(C){return $.alloc(6,C,0).buffer}static serializeReplyOK(C,I,W){if(typeof I>"u")return this.d(C);if(I instanceof O.$He)return this.e(C,I);if(I instanceof T.$Ew){const{jsonString:V,referencedBuffers:q}=s(I.value,W,!0);return this.g(C,V,q)}else return this.f(C,l(I,W))}static d(C){return $.alloc(7,C,0).buffer}static e(C,I){let W=0;W+=$.sizeVSBuffer(I);const V=$.alloc(8,C,W);return V.writeVSBuffer(I),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const W=O.$He.fromString(I);let V=0;V+=$.sizeLongString(W);const q=$.alloc(9,C,V);return q.writeLongString(W),q.buffer}static g(C,I,W){const V=O.$He.fromString(I);let q=0;q+=$.sizeUInt32,q+=$.sizeLongString(V);for(const B of W)q+=$.sizeVSBuffer(B);const A=$.alloc(10,C,q);A.writeUInt32(W.length),A.writeLongString(V);for(const B of W)A.writeBuffer(B);return A.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const W=C.readUInt32(),V=C.readLongString(),q=[];for(let A=0;A<W;++A)q.push(C.readVSBuffer());return new T.$Ew(o(V,q,I))}static serializeReplyErr(C,I){const W=I?l(N.$3(I),null):void 0;if(typeof W!="string")return this.h(C);const V=O.$He.fromString(W);let q=0;q+=$.sizeLongString(V);const A=$.alloc(11,C,q);return A.writeLongString(V),A.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return $.alloc(12,C,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var D;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(D||(D={}))}),define(ke[256],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;const P=function(N){const R=p=>{globalThis.removeEventListener("message",R);const m=p.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){m.postMessage(E,T)}},onmessage:{get(){return m.onmessage},set(E){m.onmessage=E}}}),m.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class O extends EventTarget{constructor(N,R,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${P})('${R}'))`,E=new Blob([m],{type:"application/javascript"}),T=URL.createObjectURL(E),S=new MessageChannel,l=T,b={type:"_newWorker",id:l,port:S.port2,url:T,options:p};N(b,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(T),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),S.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),S.port1.start()}}e.$8pc=O}),define(ke[257],Ie([1,0,22,28,16,56,3]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=e.$TJ=void 0,e.$UJ=T,e.$VJ=S,e.$TJ=(0,R.$yi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${p.join("")}]+`),E=7;function T(b){if(b.scheme!==M.Schemas.vscodeNotebookCell)return;const f=b.fragment.indexOf("s");if(f<0)return;const r=parseInt(b.fragment.substring(0,f).replace(m,""),E),s=(0,P.$1e)(b.fragment.substring(f+1)).toString();if(!isNaN(r))return{handle:r,notebook:b.with({scheme:s,fragment:null})}}function S(b,f){const r=f.toString(E),o=`${r.length<p.length?p[r.length-1]:"z"}${r}s${(0,P.$2e)(P.$He.fromString(b.scheme),!0,!0)}`;return b.with({scheme:M.Schemas.vscodeNotebookCell,fragment:o})}class l{constructor(){this.a=new O.$Ac}getNotebook(f){if(f.scheme===M.Schemas.vscodeNotebookCell){const r=T(f);if(r){const s=this.a.get(r.notebook);if(s)return s}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$WJ=l,(0,N.$As)(e.$TJ,l,1)}),define(ke[85],Ie([1,0,22,37,42,70,16,19,23,31,257]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eK=e.$bK=e.CellStatusbarAlignment=e.$aK=e.NotebookEditorPriority=e.$0J=e.$9J=e.$7J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$6J=e.$5J=e.$4J=e.$3J=e.CellKind=e.$2J=e.$1J=e.$ZJ=void 0,e.$8J=g,e.$$J=d,e.$_J=w,e.$cK=y,e.$dK=D,e.$ZJ="workbench.editor.notebook",e.$1J="workbench.editor.notebookTextDiffEditor",e.$2J="workbench.editor.interactive";var S;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(S||(e.CellKind=S={})),e.$3J=["application/json","application/javascript","text/html","image/svg+xml",N.$Ts.latex,N.$Ts.markdown,"image/png","image/jpeg",N.$Ts.text],e.$4J=[N.$Ts.latex,N.$Ts.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$Ts.text],e.$5J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$6J="_notAvailable";var l;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var b;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var f;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var c;(function(K){K.scheme=R.Schemas.vscodeNotebookCell;function ie(Te,ae){return(0,T.$VJ)(Te,ae)}K.generate=ie;function ce(Te){return(0,T.$UJ)(Te)}K.parse=ce;function ve(Te,ae){return Te.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${Te.scheme!==R.Schemas.file?Te.scheme:""}`})}K.generateCellOutputUri=ve;function Se(Te){if(Te.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Te.fragment);if(!ae)return;const Re=ae[1]&&ae[1]!==""?ae[1]:void 0,ne=ae[2];return{outputId:Re,notebook:Te.with({scheme:ne||R.Schemas.file,fragment:null})}}K.parseCellOutputUri=Se;function fe(Te,ae,Re){return K.generate(Te,ae).with({scheme:Re})}K.generateCellPropertyUri=fe;function $e(Te,ae){if(Te.scheme===ae)return K.parse(Te.with({scheme:K.scheme}))}K.parseCellPropertyUri=$e})(c||(e.CellUri=c={}));const u=K=>m.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$3J){this.e=ce,this.d=[...new Set(ie)].map(ve=>({pattern:ve,matches:O.$sk(u(ve))}))}sort(ie){const ce=new Map(M.Iterable.map(ie,Se=>[Se,u(Se)]));let ve=[];for(const{matches:Se}of this.d)for(const[fe,$e]of ce)if(Se($e)){ve.push(fe),ce.delete(fe);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((Se,fe)=>this.e.indexOf(Se)-this.e.indexOf(fe)))),ve}prioritize(ie,ce){const ve=this.f(ie);if(ve===-1){this.d.unshift({pattern:ie,matches:O.$sk(u(ie))});return}const Se=new Set(ce.map($e=>this.f($e,ve)));Se.delete(-1);const fe=Array.from(Se).sort();this.d.splice(ve+1,0,...fe.map($e=>this.d[$e]));for(let $e=fe.length-1;$e>=0;$e--)this.d.splice(fe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ve=u(ie);for(let Se=0;Se<ce;Se++)if(this.d[Se].matches(ve))return Se;return-1}}e.$7J=t;function g(K,ie,ce,ve=(Se,fe)=>Se===fe){const Se=[];function fe(ae,Re,ne){if(Re===0&&ne.length===0)return;const z=Se[Se.length-1];z&&z.start+z.deleteCount===ae?(z.deleteCount+=Re,z.toInsert.push(...ne)):Se.push({start:ae,deleteCount:Re,toInsert:ne})}let $e=0,Te=0;for(;;){if($e===K.length){fe($e,0,ie.slice(Te));break}if(Te===ie.length){fe($e,K.length-$e,[]);break}const ae=K[$e],Re=ie[Te];if(ve(ae,Re)){$e+=1,Te+=1;continue}ce(Re)?(fe($e,1,[]),$e+=1):(fe($e,0,[Re]),Te+=1)}return Se}e.$9J=new E.$Pj("notebookEditorCursorAtBoundary","none"),e.$0J=new E.$Pj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function d(K){const ie=K;return!!((typeof ie.include=="string"||O.$tk(ie.include))&&(typeof ie.exclude=="string"||O.$tk(ie.exclude)))}function w(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ve=d(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Se=d(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(O.$rk(ve,(0,p.$nc)(ce.fsPath).toLowerCase()))return!(Se&&O.$rk(Se,(0,p.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$aK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var $;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})($||(e.CellStatusbarAlignment=$={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$bK=v;function y(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const h=new TextDecoder;function D(K){const ie=[];let ce=!1;for(const $e of K)(ie.length===0||ce)&&(ie.push($e),ce=!0);let ve=I(ie);const Se=P.$He.concat(ie.map($e=>P.$He.wrap($e))),fe=B(Se);return ve=ve||fe.byteLength!==Se.byteLength,{data:fe,didCompression:ve}}e.$eK="\x1B[A";const k=e.$eK.split("").map(K=>K.charCodeAt(0)),C=10;function I(K){let ie=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$eK.length)return;const Se=K[ve-1],fe=ce.subarray(0,e.$eK.length);if(fe[0]===k[0]&&fe[1]===k[1]&&fe[2]===k[2]){const $e=Se.lastIndexOf(C);if($e===-1)return;ie=!0,K[ve-1]=Se.subarray(0,$e),K[ve]=ce.subarray(e.$eK.length)}}),ie}function W(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,A=13;function B(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:P.$He.fromString(V(W(h.decode(K.buffer))))}}),define(ke[7],Ie([1,0,18,14,55,28,70,13,15,2,33,21,38,104,85]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f){"use strict";var r,s,o,n,i,c,u,t,g,a,d,w,$,v,y,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$xO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$eO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$4N=e.$3N=e.$2N=e.$1N=e.$YN=e.$XN=e.$WN=e.$VN=e.TestRunProfileKind=e.TestResultState=e.$UN=e.$TN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$SN=e.NotebookVariablesRequestKind=e.$RN=e.$QN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$PN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.ColorThemeKind=e.$JN=e.$IN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$HN=e.$GN=e.DebugConsoleMode=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$AN=e.$zN=e.FileChangeType=e.$yN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$xN=e.$wN=e.$vN=e.$uN=e.InlineCompletionTriggerKind=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$hN=e.ConfigurationTarget=e.$gN=e.$fN=e.$eN=e.$dN=e.DocumentPasteTriggerKind=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$9M=e.ViewBadge=e.ProgressLocation=e.$8M=e.$7M=e.TaskScope=e.ShellQuoting=e.$6M=e.$5M=e.$4M=e.TaskPanelKind=e.TaskRevealKind=e.$3M=e.TerminalLocation=e.$2M=e.$1M=e.$ZM=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$YM=e.$XM=e.$WM=e.$VM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$TM=e.$SM=e.$RM=e.$QM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$PM=e.$OM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.LanguageStatusSeverity=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.CodeActionTriggerKind=e.$CM=e.$BM=e.SymbolTag=e.SymbolKind=e.$AM=e.$zM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.DiagnosticSeverity=e.DiagnosticTag=e.$tM=e.$sM=e.FileEditType=e.$rM=e.$qM=e.$pM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$UM=Vt,e.$iN=Xe,e.$ZN=vn;function k(U){return Object.assign(U,{apply:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(U,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const[Ee,...Ke]=te;return Reflect.construct(U,Ke,Ee.constructor)}}})}var C;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let W=r=class{static from(...F){let te=F;return new r(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$iM=W,e.$iM=W=r=Je([k],W);let V=s=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(F){if(!F)return!1;if(F instanceof s)return!0;const{line:te,character:Ee}=F;return typeof te=="number"&&typeof Ee=="number"}static of(F){if(F instanceof s)return F;if(this.isPosition(F))return new s(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,O.$7)();let Ee;return typeof F>"u"?Ee=0:typeof F=="number"?Ee=F:(Ee=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Ee===0&&te===0?this:new s(this.line+Ee,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,O.$7)();let Ee;return typeof F>"u"?Ee=this.line:typeof F=="number"?Ee=F:(Ee=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Ee===this.line&&te===this.character?this:new s(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$jM=V,e.$jM=V=s=Je([k],V);let q=o=class{static isRange(F){return F instanceof o?!0:F?V.isPosition(F.start)&&V.isPosition(F.end):!1}static of(F){if(F instanceof o)return F;if(this.isRange(F))return new o(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,Ee,Ke){let Ye,lt;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(F,te),lt=new V(Ee,Ke)):V.isPosition(F)&&V.isPosition(te)&&(Ye=V.of(F),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(F){return o.isRange(F)?this.contains(F.start)&&this.contains(F.end):V.isPosition(F)?!(V.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=V.Max(F.start,this.c),Ee=V.Min(F.end,this.e);if(!te.isAfter(Ee))return new o(te,Ee)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=V.Min(F.start,this.c),Ee=V.Max(F.end,this.end);return new o(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,O.$7)();let Ee;return F?V.isPosition(F)?Ee=F:(Ee=F.start||this.start,te=F.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new o(Ee,te)}toJSON(){return[this.start,this.end]}};e.$kM=q,e.$kM=q=o=Je([k],q);let A=n=class extends q{static isSelection(F){return F instanceof n?!0:F?q.isRange(F)&&V.isPosition(F.anchor)&&V.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,Ee,Ke){let Ye,lt;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(F,te),lt=new V(Ee,Ke)):V.isPosition(F)&&V.isPosition(te)&&(Ye=V.of(F),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lM=A,e.$lM=A=n=Je([k],A);const B=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,O.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,Ee){if(typeof F!="string"||F.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof Ee<"u"&&B(Ee),this.host=F,this.port=Math.round(te),this.connectionToken=Ee}}e.$mM=K;class ie{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&B(te)}}e.$nM=ie;class ce extends Error{static NotAvailable(F,te){return new ce(F,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ce(F,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=b.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(F),this._message=F,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$oM=ce;var ve;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Se;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(Se||(e.EnvironmentVariableMutatorType=Se={}));let fe=i=class{static isTextEdit(F){return F instanceof i?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new q(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new q(new V(0,0),new V(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,O.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,O.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,O.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pM=fe,e.$pM=fe=i=Je([k],fe);let $e=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?fi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new c(F,te)}static insertCells(F,te){return new c(new fi(F,F),te)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,te){const Ee=new c(new fi(F,F),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(F){const te=new c(new fi(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$qM=$e,e.$qM=$e=c=Je([k],$e);class Te{static isSnippetTextEdit(F){return F instanceof Te?!0:F?q.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new Te(F,te)}static insert(F,te){return Te.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$rM=Te;var ae;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,Ee,Ke){this.c.push({_type:1,from:F,to:te,options:Ee,metadata:Ke})}createFile(F,te,Ee){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:Ee})}deleteFile(F,te,Ee){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:Ee})}e(F,te,Ee){this.c.push({_type:3,metadata:Ee,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,Ee,Ke){const Ye=te.start,lt=te.end;(Ye!==lt||Ee.length>0)&&this.c.push({_type:5,uri:F,index:Ye,count:lt-Ye,cells:Ee,metadata:Ke})}g(F,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:F,edit:{editType:3,index:te,metadata:Ee}})}replace(F,te,Ee,Ke){this.c.push({_type:2,uri:F,edit:new fe(te,Ee),metadata:Ke})}insert(F,te,Ee,Ke){this.replace(F,new q(te,te),Ee,Ke)}delete(F,te,Ee){this.replace(F,te,"",Ee)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,Ye;Array.isArray(Ee)?(Ke=Ee[0],Ye=Ee[1]):Ke=Ee,$e.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,Ye):this.f(F,Ke.range,Ke.newCells,Ye):Te.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:F,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:F,edit:Ke,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===F.toString()&&(this.c[Ee]=void 0);break}}(0,P.$Ib)(this.c)}}get(F){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===F.toString()&&te.push(Ee.edit);return te}entries(){const F=new N.$Ac;for(const te of this.c)if(te._type===2){let Ee=F.get(te.uri);Ee||(Ee=[te.uri,[]],F.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sM=Re,e.$sM=Re=Je([k],Re);let ne=u=class{static isSnippetString(F){return F instanceof u?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=u.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const Ee=new u;Ee.e=this.e,F(Ee),this.e=Ee.e,F=Ee.value}else F=u.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const Ee=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Ee=new u;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$tM=ne,e.$tM=ne=u=Je([k],ne);var z;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var x;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let be=t=class{static isLocation(F){return F instanceof t?!0:F?q.isRange(F.range)&&E.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uM=be,e.$uM=be=t=Je([k],be);let Fe=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&E.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$vM=Fe,e.$vM=Fe=Je([k],Fe);let De=class{constructor(F,te,Ee=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,P.$ub)(F.tags,te.tags)&&(0,P.$ub)(F.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$wM=De,e.$wM=De=Je([k],De);let pe=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$xM=pe,e.$xM=pe=Je([k],pe);let ge=class extends pe{constructor(F,te,Ee,Ke){super(F,te),this.canIncreaseHover=Ee,this.canDecreaseHover=Ke}};e.$yM=ge,e.$yM=ge=Je([k],ge);var Q;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(F,te=Y.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$zM=he,e.$zM=he=Je([k],he);let ue=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$AM=ue,e.$AM=ue=Je([k],ue);var Ne;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var de;(function(U){U[U.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ce=g=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,Ee,Ke,Ye){this.name=F,this.kind=te,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof be?this.location=Ke:Ee instanceof q&&(this.location=new be(Ke,Ee)),g.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$BM=Ce,e.$BM=Ce=g=Je([k],Ce);let Me=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(a.validate)}constructor(F,te,Ee,Ke,Ye){this.name=F,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$CM=Me,e.$CM=Me=a=Je([k],Me);var je;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let j=class{constructor(F,te){this.title=F,this.kind=te}};e.$DM=j,e.$DM=j=Je([k],j);let L=class{static{d=this}static{this.c="."}constructor(F){this.value=F}append(F){return new d(this.value?this.value+d.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+d.c)}};e.$EM=L,e.$EM=L=d=Je([k],L),L.Empty=new L(""),L.QuickFix=L.Empty.append("quickfix"),L.Refactor=L.Empty.append("refactor"),L.RefactorExtract=L.Refactor.append("extract"),L.RefactorInline=L.Refactor.append("inline"),L.RefactorMove=L.Refactor.append("move"),L.RefactorRewrite=L.Refactor.append("rewrite"),L.Source=L.Empty.append("source"),L.SourceOrganizeImports=L.Source.append("organizeImports"),L.SourceFixAll=L.Source.append("fixAll"),L.Notebook=L.Empty.append("notebook");let H=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$FM=H,e.$FM=H=Je([k],H);class G{constructor(F,te,Ee,Ke,Ye,lt){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$GM=G;class ee{constructor(F,te){this.fromRanges=te,this.from=F}}e.$HM=ee;class re{constructor(F,te){this.fromRanges=te,this.to=F}}e.$IM=re;var Oe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Be=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$JM=Be,e.$JM=Be=Je([k],Be);let He=w=class{#e;static isMarkdownString(F){return F instanceof w?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new M.$Vk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$KM=He,e.$KM=He=w=Je([k],He);let _e=class{constructor(F,te){this.label=F,this.documentation=te}};e.$LM=_e,e.$LM=_e=Je([k],_e);let xe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$MM=xe,e.$MM=xe=Je([k],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$NM=et,e.$NM=et=Je([k],et);var tt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let ct=class{constructor(F){this.value=F}};e.$OM=ct,e.$OM=ct=Je([k],ct);let gt=class{constructor(F,te,Ee){this.position=F,this.label=te,this.kind=Ee}};e.$PM=gt,e.$PM=gt=Je([k],gt);var Ue;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var ot;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(ot||(e.CompletionItemKind=ot={}));var Z;(function(U){U[U.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let X=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ot[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$QM=X,e.$QM=X=Je([k],X);let me=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$RM=me,e.$RM=me=Je([k],me);let qe=class{constructor(F,te,Ee){this.insertText=F,this.range=te,this.command=Ee}};e.$SM=qe,e.$SM=qe=Je([k],qe);let we=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$TM=we,e.$TM=we=Je([k],we);var at;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(at||(e.PartialAcceptTriggerKind=at={}));var dt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Pt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Pt||(e.StatusBarAlignment=Pt={}));function Vt(U,F){return`${S.$Tm.toKey(U)}.${F}`}var Qt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ii;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ii||(e.TextDocumentSaveReason=ii={}));var Xt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var Dt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var Zt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Yt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(U){function F(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var Ze;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(U){function F(te){switch(te){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(Ze||(e.SyntaxTokenType=Ze={}));let si=class{constructor(F,te){if(te&&!E.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.target=te}};e.$VM=si,e.$VM=si=Je([k],si);let Gt=class{constructor(F,te,Ee,Ke){this.red=F,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$WM=Gt,e.$WM=Gt=Je([k],Gt);let ht=class{constructor(F,te){if(te&&!(te instanceof Gt))throw(0,O.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.color=te}};e.$XM=ht,e.$XM=ht=Je([k],ht);let mt=class{constructor(F){if(!F||typeof F!="string")throw(0,O.$7)("label");this.label=F}};e.$YM=mt,e.$YM=mt=Je([k],mt);var xt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Kt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Ft;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var ft;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class jt{constructor(F,te,Ee){if(this.startIndex=F,this.length=te,this.tooltip=Ee,typeof F!="number"||F<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,O.$7)("tooltip")}}e.$ZM=jt;class _t{constructor(F){this.uri=F}}e.$1M=_t;class Lt{constructor(F){this.terminalCommand=F}}e.$2M=Lt;var Qe;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ci{constructor(F){if(this.options=F,typeof F!="object")throw(0,O.$7)("options")}}e.$3M=ci;var Jt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var zt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(zt||(e.TaskPanelKind=zt={}));let pt=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(F){switch(F){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=F}get id(){return this.c}};e.$4M=pt,e.$4M=pt=$=Je([k],pt);function Ut(U){let F="";for(let te=0;te<U.length;te++)F+=U[te].replace(/,/g,",,")+",";return F}let Rt=class{constructor(F,te,Ee){if(typeof F!="string")throw(0,O.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,O.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return Ut(F)}};e.$5M=Rt,e.$5M=Rt=Je([k],Rt);let Nt=class{constructor(F,te,Ee){if(this.f=[],Array.isArray(te)){if(!F)throw(0,O.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F,this.f=te,this.g=Ee}else{if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return Ut(F)}};e.$6M=Nt,e.$6M=Nt=Je([k],Nt);var ei;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ei||(e.ShellQuoting=ei={}));var Wt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class oi{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.$Ug)()}set callback(F){this.c=F}get callback(){return this.c}}e.$7M=oi;let Mt=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,Ee,Ke,Ye,lt){this.k=!1,this.l=this.definition=F;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,$t=Ye,this.k=!0):te===Wt.Global||te===Wt.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,$t=lt):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,$t=lt),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,T.$Ug)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,O.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(v.g===te||v.e===te||v.f===te||v.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$8M=Mt,e.$8M=Mt=v=Je([k],Mt);var Tt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Tt||(e.ProgressLocation=Tt={}));var Ot;(function(U){function F(te){const Ee=te;return(0,m.$cg)(Ee.value)?Ee.tooltip&&!(0,m.$$f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}U.isViewBadge=F})(Ot||(e.ViewBadge=Ot={}));let It=y=class{static isTreeItem(F,te){const Ee=F;if(Ee.checkboxState!==void 0){const Ke=(0,m.$cg)(Ee.checkboxState)?Ee.checkboxState:(0,m.$ag)(Ee.checkboxState)&&(0,m.$cg)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,m.$cg)(Ee.checkboxState)&&(0,m.$ag)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||Ye!==void 0&&!(0,m.$$f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(F instanceof y)return!0;if(Ee.label!==void 0&&!(0,m.$$f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,m.$$f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,m.$$f)(Ee.iconPath)&&!E.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,m.$$f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,m.$$f)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,m.$$f)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,m.$$f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!E.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,m.$$f)(Ee.tooltip)&&!(Ee.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<wt.None&&Ee.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,m.$$f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(F,te=wt.None){this.collapsibleState=te,E.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$9M=It,e.$9M=It=y=Je([k],It);var wt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var Et;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let ni=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$0M=ni,e.$0M=ni=Je([k],ni);class St extends ni{}e.$$M=St;class di extends St{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$_M=di;class ri{constructor(F,te,Ee,Ke){this.name=F,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$aN=ri;let bi=class{#e=new Map;constructor(F){for(const[te,Ee]of F??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[Ee,Ke]of this.#e)for(const Ye of Ke)F.call(te,Ye,Ee,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const Ee of te)yield[F,Ee]}#t(F){return F.toLowerCase()}};e.$bN=bi,e.$bN=bi=Je([k],bi);let ui=class{constructor(F,te,Ee){this.insertText=F,this.title=te,this.kind=Ee}};e.$cN=ui,e.$cN=ui=Je([k],ui);var mi;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(mi||(e.DocumentPasteTriggerKind=mi={}));class kt{static{this.c="."}constructor(F){this.value=F}append(...F){return new kt((this.value?[this.value,...F]:F).join(kt.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+kt.c)}}e.$dN=kt,kt.Empty=new kt("");class ye{constructor(F,te,Ee){this.title=te,this.insertText=F,this.kind=Ee}}e.$eN=ye;let Ae=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$fN=Ae,e.$fN=Ae=Je([k],Ae),Ae.File=new Ae("file"),Ae.Folder=new Ae("folder");let se=class{constructor(F){this.id=F}};e.$gN=se,e.$gN=se=Je([k],se);var J;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(J||(e.ConfigurationTarget=J={}));let Pe=class{get base(){return this.c}set base(F){this.c=F,this.e=E.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!E.URI.isUri(F)&&!E.URI.isUri(F.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof F=="string"?this.baseUri=E.URI.file(F):E.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$hN=Pe,e.$hN=Pe=Je([k],Pe);const Ve=new WeakMap;function Xe(U,F){Ve.set(U,F)}let Ge=class{constructor(F,te,Ee,Ke,Ye){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=Ve.get(this)??(0,T.$Ug)()),this.c}};e.$jN=Ge,e.$jN=Ge=Je([k],Ge);let rt=class extends Ge{constructor(F,te,Ee,Ke,Ye,lt){if(super(te,Ee,Ke,Ye,lt),F===null)throw(0,O.$7)("location");this.location=F}};e.$kN=rt,e.$kN=rt=Je([k],rt);let yt=class extends Ge{constructor(F,te,Ee,Ke,Ye,lt){super(te,Ee,Ke,Ye,lt),this.functionName=F}};e.$lN=yt,e.$lN=yt=Je([k],yt);let qt=class extends Ge{constructor(F,te,Ee,Ke,Ye,lt,$t,Ht){if(super(Ke,Ye,lt,$t,Ht),!te)throw(0,O.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=Ee}};e.$mN=qt,e.$mN=qt=Je([k],qt);let Bt=class{constructor(F,te,Ee){this.command=F,this.args=te||[],this.options=Ee}};e.$nN=Bt,e.$nN=Bt=Je([k],Bt);let Ct=class{constructor(F,te){this.port=F,this.host=te}};e.$oN=Ct,e.$oN=Ct=Je([k],Ct);let ut=class{constructor(F){this.path=F}};e.$pN=ut,e.$pN=ut=Je([k],ut);let Ri=class{constructor(F){this.implementation=F}};e.$qN=Ri,e.$qN=Ri=Je([k],Ri);class $i{constructor(F,te,Ee){this.session=F,this.threadId=te,this.frameId=Ee}}e.$rN=$i;class Ei{constructor(F,te){this.session=F,this.threadId=te}}e.$sN=Ei;let ki=class{constructor(F,te){this.range=F,this.expression=te}};e.$tN=ki,e.$tN=ki=Je([k],ki);var Ji;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Oi=class{constructor(F,te){this.range=F,this.text=te}};e.$uN=Oi,e.$uN=Oi=Je([k],Oi);let Ni=class{constructor(F,te,Ee=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$vN=Ni,e.$vN=Ni=Je([k],Ni);let Ii=class{constructor(F,te){this.range=F,this.expression=te}};e.$wN=Ii,e.$wN=Ii=Je([k],Ii);let Ti=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$xN=Ti,e.$xN=Ti=Je([k],Ti);var Fi;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Fi||(e.NewSymbolNameTag=Fi={}));var Qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class Li{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$yN=Li;var Ci;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ci||(e.FileChangeType=Ci={}));let zi=h=class extends Error{static FileExists(F){return new h(F,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(F){return new h(F,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(F){return new h(F,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(F){return new h(F,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(F){return new h(F,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(F){return new h(F,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(F,te=l.FileSystemProviderErrorCode.Unknown,Ee){super(E.URI.isUri(F)?F.toString(!0):F),this.code=Ee?.name??"Unknown",(0,l.$hl)(this,te),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$zN=zi,e.$zN=zi=h=Je([k],zi);let Ui=class{constructor(F,te,Ee){this.start=F,this.end=te,this.kind=Ee}};e.$AN=Ui,e.$AN=Ui=Je([k],Ui);var vi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Xi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Zi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Pi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Pi||(e.CommentState=Pi={}));var Yi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var ji;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(ji||(e.CommentThreadApplicability=ji={}));class dn{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$BN=dn;function xi(U){return typeof U>"u"||(0,m.$_f)(U)}class Bi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,Ee=F.tokenTypes.length;te<Ee;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,Ee=F.tokenModifiers.length;te<Ee;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,Ee,Ke,Ye){if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(F,te,Ee,Ke,Ye);if(q.isRange(F)&&typeof te=="string"&&xi(Ee))return this.o(F,te,Ee);throw(0,O.$7)()}o(F,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,Ye=F.start.character,lt=F.end.character-F.start.character,$t=this.k.get(te);let Ht=0;if(Ee)for(const ai of Ee){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);Ht|=1<<hi>>>0}this.q(Ke,Ye,lt,$t,Ht)}q(F,te,Ee,Ke,Ye){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ai=0,hi=0;for(let gi=0;gi<Ht;gi++){let wi=this.g[5*gi],Gi=this.g[5*gi+1];wi===0?(wi=ai,Gi+=hi):wi+=ai,this.g[5*gi]=wi,this.g[5*gi+1]=Gi,ai=wi,hi=Gi}}let lt=F,$t=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&($t-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=$t,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=F,this.e=te}static r(F){const te=[],Ee=F.length/5|0;for(let $t=0;$t<Ee;$t++)te[$t]=$t;te.sort(($t,Ht)=>{const ai=F[5*$t],hi=F[5*Ht];if(ai===hi){const gi=F[5*$t+1],wi=F[5*Ht+1];return gi-wi}return ai-hi});const Ke=new Uint32Array(F.length);let Ye=0,lt=0;for(let $t=0;$t<Ee;$t++){const Ht=5*te[$t],ai=F[Ht+0],hi=F[Ht+1],gi=F[Ht+2],wi=F[Ht+3],Gi=F[Ht+4],Ln=ai-Ye,pr=Ln===0?hi-lt:hi,Ki=5*$t;Ke[Ki+0]=Ln,Ke[Ki+1]=pr,Ke[Ki+2]=gi,Ke[Ki+3]=wi,Ke[Ki+4]=Gi,Ye=ai,lt=hi}return Ke}build(F){return this.f?new pi(new Uint32Array(this.g),F):new pi(Bi.r(this.g),F)}}e.$CN=Bi;class pi{constructor(F,te){this.resultId=te,this.data=F}}e.$DN=pi;class fn{constructor(F,te,Ee){this.start=F,this.deleteCount=te,this.data=Ee}}e.$EN=fn;class gn{constructor(F,te){this.resultId=te,this.edits=F}}e.$FN=gn;var _i;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Vi{constructor(F){this.name=F}}e.$GN=Vi;let Mi=class{static{this.Back={iconPath:new Ae("arrow-left")}}constructor(){}};e.$HN=Mi,e.$HN=Mi=Je([k],Mi);var ze;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var li;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(li||(e.InputBoxValidationSeverity=li={}));var Wi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Wi||(e.ExtensionKind=Wi={}));class nt{static validate(F){if(typeof F.badge=="string"){let te=(0,p.$Jf)(F.badge,0);if(te<F.badge.length&&(te+=(0,p.$Jf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ae.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,Ee){this.badge=F,this.tooltip=te,this.color=Ee}}e.$IN=nt;let bt=class{constructor(F){this.kind=F}};e.$JN=bt,e.$JN=bt=Je([k],bt);var en;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class fi{static isNotebookRange(F){return F instanceof fi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,Ee=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Ee=F.end),te===this.c&&Ee===this.e?this:new fi(te,Ee)}}e.$KN=fi;class Di{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>Di.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,Ee,Ke,Ye,lt,$t){this.kind=F,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=$t,Di.validate(this)}}e.$LN=Di;class mn{constructor(F){this.cells=F}}e.$MN=mn;class ti{static isNotebookCellOutputItem(F){return F instanceof ti?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ti.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ti.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ti.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ti(F,te)}static#e=new TextEncoder;static text(F,te=R.$Ts.text){const Ee=ti.#e.encode(String(F));return new ti(Ee,te)}static json(F,te="text/x-json"){const Ee=JSON.stringify(F,void 0,"	");return ti.text(Ee,te)}constructor(F,te){this.data=F,this.mime=te;const Ee=(0,R.$Xs)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$NN=ti;class Ai{static isNotebookCellOutput(F){return F instanceof Ai?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Ee=new Set,Ke=new Set;for(let Ye=0;Ye<F.length;Ye++){const lt=F[Ye],$t=(0,R.$Xs)(lt.mime);if(!Ee.has($t)||(0,f.$cK)($t)){Ee.add($t);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?F:F.filter((Ye,lt)=>!Ke.has(lt))}constructor(F,te,Ee){this.items=Ai.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,T.$Ug)(),this.metadata=te??Ee)}}e.$ON=Ai;var tn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var qi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(qi||(e.NotebookCellStatusBarAlignment=qi={}));var rn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class $n{constructor(F,te){this.text=F,this.alignment=te}}e.$PN=$n;var sn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(F,te=[]){this.uri=F,this.provides=(0,P.$2b)(te)}}e.$QN=pn;class wn{constructor(F){this.label=F}}e.$RN=wn;var an;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Hi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$SN=Hi,e.$SN=Hi=Je([k],Hi);var cn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$TN=_;class oe{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$UN=oe;var Le;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var st;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(st||(e.TestRunProfileKind=st={}));let vt=class{constructor(F=void 0,te=void 0,Ee=void 0,Ke=!1,Ye=!0){this.include=F,this.exclude=te,this.profile=Ee,this.continuous=Ke,this.preserveFocus=Ye}};e.$VN=vt,e.$VN=vt=Je([k],vt);let At=D=class{static diff(F,te,Ee){const Ke=new D(F);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(F){this.message=F}};e.$WN=At,e.$WN=At=D=Je([k],At);let Si=class{constructor(F){this.id=F}};e.$XN=Si,e.$XN=Si=Je([k],Si);class hn{constructor(F,te){this.covered=F,this.total=te,vn(this)}}e.$YN=hn;function vn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class bn{static fromDetails(F,te){const Ee=new hn(0,0),Ke=new hn(0,0),Ye=new hn(0,0);for(const $t of te)if("branches"in $t){Ee.total+=1,Ee.covered+=$t.executed?1:0;for(const Ht of $t.branches)Ke.total+=1,Ke.covered+=Ht.executed?1:0}else Ye.total+=1,Ye.covered+=$t.executed?1:0;const lt=new bn(F,Ee,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(F,te,Ee,Ke){this.uri=F,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke}}e.$1N=bn;class zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee=[]){this.executed=F,this.location=te,this.branches=Ee}}e.$2N=zn;class Un{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.executed=F,this.location=te,this.label=Ee}}e.$3N=Un;class jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.name=F,this.executed=te,this.location=Ee}}e.$4N=jn;var yn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var En;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(En||(e.WorkspaceTrustState=En={}));var Dn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class Bn{constructor(F,te,Ee,Ke,Ye,lt){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$5N=Bn;class Vn{constructor(F){this.uri=F}}e.$6N=Vn;class Wn{constructor(F,te){this.original=F,this.modified=te}}e.$7N=Wn;class qn{constructor(F,te,Ee,Ke){this.base=F,this.input1=te,this.input2=Ee,this.result=Ke}}e.$8N=qn;class Hn{constructor(F,te){this.uri=F,this.viewType=te}}e.$9N=Hn;class Gn{constructor(F){this.viewType=F}}e.$0N=Gn;class Kn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$$N=Kn;class Jn{constructor(F,te,Ee){this.original=F,this.modified=te,this.notebookType=Ee}}e.$_N=Jn;class Qn{constructor(){}}e.$aO=Qn;class Xn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$bO=Xn;class Zn{constructor(){}}e.$cO=Zn;class Yn{constructor(F){this.textDiffs=F}}e.$dO=Yn;var Sn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Sn||(e.InteractiveSessionVoteDirection=Sn={}));var kn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var In;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class xn{constructor(F,te){this.label=F,this.values=te}}e.$eO=xn;var Cn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Cn||(e.InteractiveEditorResponseFeedbackKind=Cn={}));var Pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Pn||(e.ChatResultFeedbackKind=Pn={}));class _n{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F}}e.$fO=_n;class er{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F,this.vulnerabilities=te}}e.$gO=er;class tr{constructor(F,te){this.participant=F,this.command=te}}e.$hO=tr;class ir{constructor(F,te,Ee){this.title=F,this.message=te,this.data=Ee}}e.$iO=ir;class nr{constructor(F,te){this.value=F,this.baseUri=te}}e.$jO=nr;class rr{constructor(F,te){this.value=F,this.title=te}}e.$kO=rr;class sr{constructor(F){this.value=F}}e.$lO=sr;class or{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F}}e.$mO=or;class ar{constructor(F){this.value=F}}e.$nO=ar;class cr{constructor(F,te){this.value=F,this.iconPath=te}}e.$oO=cr;class ur{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$pO=ur;class lr{constructor(F,te,Ee,Ke){this.prompt=F,this.command=te,this.variables=Ee,this.participant=Ke}}e.$qO=lr;class hr{constructor(F,te,Ee,Ke){this.response=F,this.result=te,this.participant=Ee,this.command=Ke}}e.$rO=hr;var Mn;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(Mn||(e.ChatLocation=Mn={}));var An;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(An||(e.LanguageModelChatMessageRole=An={}));class dr{constructor(F,te,Ee){this.role=F,this.content=te,this.name=Ee}}e.$sO=dr;class fr{constructor(F){this.content=F}}e.$tO=fr;class gr{constructor(F,te){this.content=F,this.name=te}}e.$uO=gr;class mr{constructor(F,te){this.content=F,this.name=te}}e.$vO=mr;class yi extends Error{static NotFound(F){return new yi(F,yi.NotFound.name)}static NoPermissions(F){return new yi(F,yi.NoPermissions.name)}static Blocked(F){return new yi(F,yi.Blocked.name)}constructor(F,te,Ee){super(F,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$wO=yi;var Rn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var On;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Nn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Nn||(e.TextToSpeechStatus=Nn={}));var Tn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Tn||(e.KeywordRecognitionStatus=Tn={}));class $r{constructor(F,te){this.text=F,this.range=te}}e.$xO=$r;var Fn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(ke[258],Ie([1,0,4,7]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(P.$gM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,p,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(p,m)??[]}getRelatedInformation(R,p,m){return this.c.$getAiRelatedInformation(p,m)}registerRelatedInformationProvider(R,p,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,p),new O.$iM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Nlc=M}),define(ke[86],Ie([1,0,5,4,7,21,108,3,17]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=void 0,e.$Ylc=(0,p.$yi)("IExtHostAuthentication");let E=class{constructor(l){this.b=new Map,this.c=new P.$fe,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=l.getProxy(O.$gM.MainThreadAuthentication)}async getSession(l,b,f,r={}){const s=N.$Tm.toKey(l.identifier),o=[...f].sort().join(" ");return await this.d.getOrCreate(`${s} ${b} ${o}`,async()=>{await this.a.$ensureProvider(b);const n=l.displayName||l.name;return this.a.$getSession(b,f,s,n,r)})}async getSessions(l,b,f){const r=N.$Tm.toKey(l.identifier),s=[...f].sort().join(" ");return await this.f.getOrCreate(`${r} ${s}`,async()=>{await this.a.$ensureProvider(b);const o=l.displayName||l.name;return this.a.$getSessions(b,f,r,o)})}async removeSession(l,b){const f=this.b.get(l);return f?f.provider.removeSession(b):this.a.$removeSession(l,b)}registerAuthenticationProvider(l,b,f,r){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:b,provider:f,options:r??{supportsMultipleAccounts:!1}});const s=f.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(l,o));return this.a.$registerAuthenticationProvider(l,b,r?.supportsMultipleAccounts??!1),new M.$iM(()=>{s.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,b,f){const r=this.b.get(l);if(r)return await r.provider.createSession(b,f);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,b){const f=this.b.get(l);if(f)return await f.provider.removeSession(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,b){const f=this.b.get(l);if(f)return await f.provider.getSessions(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,b){return l.startsWith(R.$iL)||this.c.fire({provider:{id:l,label:b}}),Promise.resolve()}};e.$Zlc=E,e.$Zlc=E=Je([We(0,m.$JO)],E);class T{constructor(){this.a=new Map}getOrCreate(l,b){const f=this.a.get(l);if(f)return f;const r=b().finally(()=>this.a.delete(l));return this.a.set(l,r),r}}}),define(ke[112],Ie([1,0,2,4,7,3,17,12,18,13,19,25]),function(le,e,P,O,M,N,R,p,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;let b=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,s){this.h=s,this.f=new Map,this.g=r.getProxy(O.$gM.MainThreadDecorations)}registerFileDecorationProvider(r,s){const o=l.c++;this.f.set(o,{provider:r,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const c=(0,m.$2b)(i);if(c.length<=l.d){this.g.$onDidChange(o,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,E.$cf)(a.path,"/")})),t=(0,m.$zb)(u,(a,d)=>a.rank-d.rank||(0,E.$sf)(a.uri.path,d.uri.path)),g=[];e:for(const a of t){let d;for(const w of a){const $=(0,T.$mc)(w.uri.path);if(d!==$&&(d=$,g.push(w.uri)>=l.d))break e}}this.g.$onDidChange(o,g)});return new M.$iM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(r,s,o){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:c}=this.f.get(r);return await Promise.all(s.map(async u=>{try{const{uri:t,id:g}=u,a=await Promise.resolve(i.provideFileDecoration(P.URI.revive(t),o));if(!a)return;try{M.$IN.validate(a),a.badge&&typeof a.badge!="string"&&(0,S.$SG)(c,"codiconDecoration"),n[g]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),n}};e.$Ymc=b,e.$Ymc=b=l=Je([We(0,R.$JO),We(1,p.$5j)],b),e.$Zmc=(0,N.$yi)("IExtHostDecorations")}),define(ke[259],Ie([1,0,14,2,7,4,16,20,13]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class E{static{this.a=0}constructor(S,l,b){this.d=l,this.e=b,this.b=new Map,this.c=S.getProxy(N.$gM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const b=E.a++;this.b.set(b,l),this.c.$registerTextContentProvider(b,S);let f;if(typeof l.onDidChange=="function"){let r;f=l.onDidChange(async s=>{if(s.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;r&&await r;const o=this.$provideTextDocumentContent(b,s).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(s);if(!i)return;const c=(0,m.$mf)(n);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(s,n)}).catch(P.$1).finally(()=>{r===o&&(r=void 0)});r=o})}return new M.$iM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,l){const b=this.b.get(S);return b?Promise.resolve(b.provideTextDocumentContent(O.URI.revive(l),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$2mc=E}),define(ke[113],Ie([1,0,57,16,13,313,159,7,18]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0,e.$LO=T;const E=new Map;function T(f,r){r?E.set(f,r):E.delete(f)}function S(f){return E.get(f)}class l extends N.$9v{constructor(r,s,o,n,i,c,u){super(s,o,n,i),this.c=r,this.m=c,this.q=u,this.b=!1}dispose(){(0,P.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,m.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===O.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(s){return s?r.s(s):r.getText()},get eol(){return r.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(s){return r.t(s)},offsetAt(s){return r.u(s)},positionAt(s){return r.v(s)},validateRange(s){return r.w(s)},validatePosition(s){return r.x(s)},getWordRangeAtPosition(s,o){return r.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,P.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,P.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const s=this.w(r);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,n=s.start.line,i=s.end.line,c=[];c.push(this.f[n].substring(s.start.character));for(let u=n+1;u<i;u++)c.push(this.f[u]);return c.push(this.f[i].substring(0,s.end.character)),c.join(o)}t(r){let s;if(r instanceof p.$jM?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new b(s,this.f[s],s===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),o=this.f[s.index].length;return new p.$jM(s.index,Math.min(s.remainder,o))}w(r){if(!(r instanceof p.$kM))throw new Error("Invalid argument");const s=this.x(r.start),o=this.x(r.end);return s===r.start&&o===r.end?r:new p.$kM(s.line,s.character,o.line,o.character)}x(r){if(!(r instanceof p.$jM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:s,character:o}=r,n=!1;if(s<0)s=0,o=0,n=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,n=!0;else{const i=this.f[s].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new p.$jM(s,o):r}y(r,s){const o=this.x(r);if(!s)s=S(this.m);else if((0,M.$lf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const n=(0,R.$_s)(o.character+1,(0,R.$0s)(s),this.f[o.line],0);if(n)return new p.$kM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$MO=l;class b{constructor(r,s,o){this.a=r,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$kM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$kM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$NO=b}),define(ke[260],Ie([1,0,4,7]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(P.$gM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,p,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(p,m);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(R,p,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider(p,E),new O.$iM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$5mc=M}),define(ke[65],Ie([1,0,4,38,7,22,3,17,46,6,11,24,16]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=e.$cmc=void 0;let f=b=class{constructor(s,o){this.b=new Map,this.c=new T.$Hh,this.a=s.getProxy(P.$gM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let c;const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),c=await u.impl.stat(i)):c=await n.a.$stat(i),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){b.e(c)}},async readDirectory(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(c){return b.e(c)}},async createDirectory(i){try{const c=n.b.get(i.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(c.impl,c.extUri,i)):await n.a.$mkdir(i)}catch(c){return b.e(c)}},async readFile(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(c){return b.e(c)}},async writeFile(i,c){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(u.impl,u.extUri,u.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(u.impl.writeFile(i,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,N.$He.wrap(c))}catch(u){return b.e(u)}},async delete(i,c){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(i.scheme),await u.impl.delete(i,{recursive:!1,...c})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return b.e(u)}},async rename(i,c,u){try{return await n.a.$rename(i,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},async copy(i,c,u){try{return await n.a.$copy(i,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},isWritableFileSystem(i){const c=o.getCapabilities(i);if(typeof c=="number")return!(c&2048)}})}async d(s,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await s.stat(n)).type&O.FileType.Directory))throw M.$zN.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$il(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(o.basename(n)),n=o.dirname(n)}for(let c=i.length-1;c>=0;c--){n=o.joinPath(n,i[c]);try{await s.createDirectory(n)}catch(u){if(O.$il(u)!==O.FileSystemProviderErrorCode.FileExists)throw u}}}static e(s){if(s instanceof M.$zN)throw s;if(s instanceof O.$el)switch(s.code){case O.FileSystemProviderErrorCode.FileExists:throw M.$zN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$zN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$zN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$zN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$zN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$zN.Unavailable(s.message);default:throw new M.$zN(s.message,s.name)}if(!(s instanceof Error))throw new M.$zN(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw M.$zN.Unavailable(s.message);switch(s.name){case O.FileSystemProviderErrorCode.FileExists:throw M.$zN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$zN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$zN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$zN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$zN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$zN.Unavailable(s.message);default:throw new M.$zN(s.message,s.name)}}addFileSystemProvider(s,o,n){return this.b.set(s,{impl:o,extUri:n?.isCaseSensitive?S.$2g:S.$4g,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??S.$2g}};e.$cmc=f,e.$cmc=f=b=Je([We(0,p.$JO),We(1,m.$Slc)],f),e.$dmc=(0,R.$yi)("IExtHostConsumerFileSystem")}),define(ke[87],Ie([1,0,3,27,12,65,2]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0,e.$emc=(0,P.$yi)("IExtensionStoragePaths");let p=class{constructor(E,T,S){this.d=T,this.f=S,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(R.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fmc=p,e.$fmc=p=Je([We(0,O.$ZO),We(1,M.$5j),We(2,N.$dmc)],p)}),define(ke[261],Ie([1,0,7,17,5]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;let N=class{constructor(p){this.a=new P.$JN(P.ColorThemeKind.Dark),this.b=new M.$fe}get activeColorTheme(){return this.a}$onColorThemeChange(p){let m;switch(p){case"light":m=P.ColorThemeKind.Light;break;case"hcDark":m=P.ColorThemeKind.HighContrast;break;case"hcLight":m=P.ColorThemeKind.HighContrastLight;break;default:m=P.ColorThemeKind.Dark}this.a=new P.$JN(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Mnc=N,e.$Mnc=N=Je([We(0,O.$JO)],N)}),define(ke[88],Ie([1,0,20,5,6,182,3,12,211,4,27,17,7]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ODb=e.$NDb=e.TunnelDtoConverter=void 0;class b extends m.$vw{}var f;(function(s){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=n})(f||(e.TunnelDtoConverter=f={})),e.$NDb=(0,R.$yi)("IExtHostTunnelService");let r=class extends M.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$fe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$gM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const c=new b(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new l.$iM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,c,u){const t=[];for(const a of o){const d=this.r.get(a);if(!d)return[];t.push(...await Promise.all(n.map(async w=>{let $;try{$=await d.provider.providePortAttributes({port:w,pid:i,commandLine:c},u)}catch{$=await d.provider.providePortAttributes(w,i,c,u)}return{providedAttributes:$,port:w}})))}const g=t.filter(a=>!!a.providedAttributes);return g.length>0?g.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await o.provideTunnel(c,u,P.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let c=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const c=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:c,disposeListener:u}),f.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(c=>this.f(c.host,c.port,c.detail??""))),i=o.filter((c,u)=>n[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(c=>c.port).join(", ")} to ${i.map(c=>c.port).join(", ")}`),i}};e.$ODb=r,e.$ODb=r=Je([We(0,S.$JO),We(1,T.$ZO),We(2,p.$5j)],r)}),define(ke[8],Ie([1,0,18,22,138,262,55,28,127,49,70,26,133,24,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g,a,d,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$GO=K,e.$HO=ce,e.$IO=ve;var v;(function(ye){function Ae(J){const{selectionStartLineNumber:Pe,selectionStartColumn:Ve,positionLineNumber:Xe,positionColumn:Ge}=J,rt=new $.$jM(Pe-1,Ve-1),yt=new $.$jM(Xe-1,Ge-1);return new $.$lM(rt,yt)}ye.to=Ae;function se(J){const{anchor:Pe,active:Ve}=J;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}ye.from=se})(v||(e.Selection=v={}));var y;(function(ye){function Ae(J){if(!J)return;const{start:Pe,end:Ve}=J;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}ye.from=Ae;function se(J){if(!J)return;const{startLineNumber:Pe,startColumn:Ve,endLineNumber:Xe,endColumn:Ge}=J;return new $.$kM(Pe-1,Ve-1,Xe-1,Ge-1)}ye.to=se})(y||(e.Range=y={}));var h;(function(ye){function Ae(J){return{uri:J.uri,range:y.from(J.range)}}ye.from=Ae;function se(J){return new $.$uM(s.URI.revive(J.uri),y.to(J.range))}ye.to=se})(h||(e.Location=h={}));var D;(function(ye){function Ae(se){switch(se){case 1:return $.StandardTokenType.Comment;case 0:return $.StandardTokenType.Other;case 3:return $.StandardTokenType.RegEx;case 2:return $.StandardTokenType.String}}ye.to=Ae})(D||(e.TokenType=D={}));var k;(function(ye){function Ae(J){return new $.$jM(J.lineNumber-1,J.column-1)}ye.to=Ae;function se(J){return{lineNumber:J.line+1,column:J.character+1}}ye.from=se})(k||(e.Position=k={}));var C;(function(ye){function Ae(Pe,Ve,Xe){return(0,P.$Hb)((0,P.$2b)(Pe).map(Ge=>se(Ge,Ve,Xe)))}ye.from=Ae;function se(Pe,Ve,Xe){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Xe?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:J(Pe.scheme,Ve),pattern:me.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Pe,Ve){return Ve&&typeof Pe=="string"?Ve.transformOutgoingScheme(Pe):Pe}})(C||(e.DocumentSelector=C={}));var I;(function(ye){function Ae(J){switch(J){case $.DiagnosticTag.Unnecessary:return 1;case $.DiagnosticTag.Deprecated:return 2}}ye.from=Ae;function se(J){switch(J){case 1:return $.DiagnosticTag.Unnecessary;case 2:return $.DiagnosticTag.Deprecated;default:return}}ye.to=se})(I||(e.DiagnosticTag=I={}));var W;(function(ye){function Ae(J){let Pe;return J.code&&((0,r.$$f)(J.code)||(0,r.$cg)(J.code)?Pe=String(J.code):Pe={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Pe,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,P.$Hb)(J.tags.map(I.from)):void 0}}ye.from=Ae;function se(J){const Pe=new $.$wM(y.to(J),J.message,q.to(J.severity));return Pe.source=J.source,Pe.code=(0,r.$$f)(J.code)?J.code:J.code?.value,Pe.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),Pe.tags=J.tags&&(0,P.$Hb)(J.tags.map(I.to)),Pe}ye.to=se})(W||(e.Diagnostic=W={}));var V;(function(ye){function Ae(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}ye.from=Ae;function se(J){return new $.$vM(new $.$uM(J.resource,y.to(J)),J.message)}ye.to=se})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(ye){function Ae(J){switch(J){case $.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case $.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case $.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case $.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ye.from=Ae;function se(J){switch(J){case i.MarkerSeverity.Info:return $.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return $.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return $.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return $.DiagnosticSeverity.Hint;default:return $.DiagnosticSeverity.Error}}ye.to=se})(q||(e.DiagnosticSeverity=q={}));var A;(function(ye){function Ae(J){return typeof J=="number"&&J>=$.ViewColumn.One?J-1:J===$.ViewColumn.Beside?w.$8D:w.$7D}ye.from=Ae;function se(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=se})(A||(e.ViewColumn=A={}));function B(ye){return typeof ye.range<"u"}function K(ye){return ye.length===0?!0:!!B(ye[0])}var ie;(function(ye){function Ae(Ge){return Ge.map(ye.from)}ye.fromMany=Ae;function se(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let rt;if(se(Ge)){const{language:Ct,value:ut}=Ge;rt={value:"```"+Ct+`
`+ut+"\n```\n"}}else $.$KM.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const yt=Object.create(null);rt.uris=yt;const qt=Ct=>{try{let ut=s.URI.parse(Ct,!0);ut=ut.with({query:Pe(ut.query,yt)}),yt[Ct]=ut}catch{}return""},Bt=new m.marked.Renderer;return Bt.link=qt,Bt.image=Ct=>typeof Ct=="string"?qt(R.$4k(Ct).href):"",(0,m.marked)(rt.value,{renderer:Bt}),rt}ye.from=J;function Pe(Ge,rt){if(!Ge)return Ge;let yt;try{yt=(0,E.$7h)(Ge)}catch{}if(!yt)return Ge;let qt=!1;return yt=(0,S.$7n)(yt,Bt=>{if(s.URI.isUri(Bt)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Ct]=Bt,qt=!0,Ct}else return}),qt?JSON.stringify(yt):Ge}function Ve(Ge){const rt=new $.$KM(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt.supportHtml=Ge.supportHtml,rt.baseUri=Ge.baseUri?s.URI.from(Ge.baseUri):void 0,rt}ye.to=Ve;function Xe(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function ce(ye){return K(ye)?ye.map(Ae=>({range:y.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?ie.fromMany(Ae.hoverMessage):Ae.hoverMessage?ie.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):ye.map(Ae=>({range:y.from(Ae)}))}function ve(ye){return typeof ye>"u"?ye:typeof ye=="string"?s.URI.file(ye):ye}var Se;(function(ye){function Ae(se){return typeof se>"u"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?ve(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}ye.from=Ae})(Se||(e.ThemableDecorationAttachmentRenderOptions=Se={}));var fe;(function(ye){function Ae(se){return typeof se>"u"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ve(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Se.from(se.before):void 0,after:se.after?Se.from(se.after):void 0}}ye.from=Ae})(fe||(e.ThemableDecorationRenderOptions=fe={}));var $e;(function(ye){function Ae(se){if(typeof se>"u")return se;switch(se){case $.DecorationRangeBehavior.OpenOpen:return 0;case $.DecorationRangeBehavior.ClosedClosed:return 1;case $.DecorationRangeBehavior.OpenClosed:return 2;case $.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Ae})($e||(e.DecorationRangeBehavior=$e={}));var Te;(function(ye){function Ae(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?$e.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?fe.from(se.light):void 0,dark:se.dark?fe.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ve(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Se.from(se.before):void 0,after:se.after?Se.from(se.after):void 0}}ye.from=Ae})(Te||(e.DecorationRenderOptions=Te={}));var ae;(function(ye){function Ae(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:y.from(J.range)}}ye.from=Ae;function se(J){const Pe=new $.$pM(y.to(J.range),J.text);return Pe.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),Pe}ye.to=se})(ae||(e.TextEdit=ae={}));var Re;(function(ye){function Ae(J,Pe){const Ve={edits:[]};if(J instanceof $.$sM){const Xe=new p.$Bc;for(const Ge of J._allEntries())Ge._type===1&&s.URI.isUri(Ge.to)&&Ge.from===void 0&&Xe.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===1){let rt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?rt={type:"base64",value:(0,O.$2e)(O.$He.wrap(Ge.options.contents))}:rt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:rt},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:ae.from(Ge.edit),versionId:Xe.has(Ge.uri)?void 0:Pe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:y.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ge.uri)?void 0:Pe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ii.from)}})}return Ve}ye.from=Ae;function se(J){const Pe=new $.$sM,Ve=new p.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const Ge=Xe,rt=s.URI.revive(Ge.resource),yt=y.to(Ge.textEdit.range),qt=Ge.textEdit.text,Bt=Ge.textEdit.insertAsSnippet;let Ct;Bt?Ct=$.$rM.replace(yt,new $.$tM(qt)):Ct=$.$pM.replace(yt,qt);const ut=Ve.get(rt);ut?ut.push(Ct):Ve.set(rt,[Ct])}else Pe.renameFile(s.URI.revive(Xe.oldResource),s.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ge]of Ve)Pe.set(Xe,Ge);return Pe}ye.to=se})(Re||(e.WorkspaceEdit=Re={}));var ne;(function(ye){const Ae=Object.create(null);Ae[$.SymbolKind.File]=0,Ae[$.SymbolKind.Module]=1,Ae[$.SymbolKind.Namespace]=2,Ae[$.SymbolKind.Package]=3,Ae[$.SymbolKind.Class]=4,Ae[$.SymbolKind.Method]=5,Ae[$.SymbolKind.Property]=6,Ae[$.SymbolKind.Field]=7,Ae[$.SymbolKind.Constructor]=8,Ae[$.SymbolKind.Enum]=9,Ae[$.SymbolKind.Interface]=10,Ae[$.SymbolKind.Function]=11,Ae[$.SymbolKind.Variable]=12,Ae[$.SymbolKind.Constant]=13,Ae[$.SymbolKind.String]=14,Ae[$.SymbolKind.Number]=15,Ae[$.SymbolKind.Boolean]=16,Ae[$.SymbolKind.Array]=17,Ae[$.SymbolKind.Object]=18,Ae[$.SymbolKind.Key]=19,Ae[$.SymbolKind.Null]=20,Ae[$.SymbolKind.EnumMember]=21,Ae[$.SymbolKind.Struct]=22,Ae[$.SymbolKind.Event]=23,Ae[$.SymbolKind.Operator]=24,Ae[$.SymbolKind.TypeParameter]=25;function se(Pe){return typeof Ae[Pe]=="number"?Ae[Pe]:6}ye.from=se;function J(Pe){for(const Ve in Ae)if(Ae[Ve]===Pe)return Number(Ve);return $.SymbolKind.Property}ye.to=J})(ne||(e.SymbolKind=ne={}));var z;(function(ye){function Ae(J){switch(J){case $.SymbolTag.Deprecated:return 1}}ye.from=Ae;function se(J){switch(J){case 1:return $.SymbolTag.Deprecated}}ye.to=se})(z||(e.SymbolTag=z={}));var x;(function(ye){function Ae(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(z.from),containerName:J.containerName,location:ge.from(J.location)}}ye.from=Ae;function se(J){const Pe=new $.$BM(J.name,ne.to(J.kind),J.containerName,ge.to(J.location));return Pe.tags=J.tags&&J.tags.map(z.to),Pe}ye.to=se})(x||(e.WorkspaceSymbol=x={}));var be;(function(ye){function Ae(J){const Pe={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(z.from)??[]};return J.children&&(Pe.children=J.children.map(Ae)),Pe}ye.from=Ae;function se(J){const Pe=new $.$CM(J.name,J.detail,ne.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,P.$Lb)(J.tags)&&(Pe.tags=J.tags.map(z.to)),J.children&&(Pe.children=J.children.map(se)),Pe}ye.to=se})(be||(e.DocumentSymbol=be={}));var Fe;(function(ye){function Ae(J){const Pe=new $.$GM(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ye.to=Ae;function se(J,Pe,Ve){if(Pe=Pe??J._sessionId,Ve=Ve??J._itemId,Pe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(z.from)}}ye.from=se})(Fe||(e.CallHierarchyItem=Fe={}));var De;(function(ye){function Ae(se){return new $.$HM(Fe.to(se.from),se.fromRanges.map(J=>y.to(J)))}ye.to=Ae})(De||(e.CallHierarchyIncomingCall=De={}));var pe;(function(ye){function Ae(se){return new $.$IM(Fe.to(se.to),se.fromRanges.map(J=>y.to(J)))}ye.to=Ae})(pe||(e.CallHierarchyOutgoingCall=pe={}));var ge;(function(ye){function Ae(J){return{range:J.range&&y.from(J.range),uri:J.uri}}ye.from=Ae;function se(J){return new $.$uM(s.URI.revive(J.uri),y.to(J.range))}ye.to=se})(ge||(e.location=ge={}));var Q;(function(ye){function Ae(J){const Pe=J,Ve=J;return{originSelectionRange:Pe.originSelectionRange?y.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ve.uri,range:y.from(Pe.targetRange?Pe.targetRange:Ve.range),targetSelectionRange:Pe.targetSelectionRange?y.from(Pe.targetSelectionRange):void 0}}ye.from=Ae;function se(J){return{targetUri:s.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}ye.to=se})(Q||(e.DefinitionLink=Q={}));var Y;(function(ye){function Ae(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ye.from=Ae;function se(J){const Pe=J.contents.map(ie.to),Ve=y.to(J.range),Xe=J.canIncreaseVerbosity,Ge=J.canDecreaseVerbosity;return new $.$yM(Pe,Ve,Xe,Ge)}ye.to=se})(Y||(e.Hover=Y={}));var he;(function(ye){function Ae(J){return{range:y.from(J.range),expression:J.expression}}ye.from=Ae;function se(J){return new $.$tN(y.to(J.range),J.expression)}ye.to=se})(he||(e.EvaluatableExpression=he={}));var ue;(function(ye){function Ae(J){if(J instanceof $.$uN)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof $.$vN)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof $.$wN)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Ae;function se(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}ye.to=se})(ue||(e.InlineValue=ue={}));var Ne;(function(ye){function Ae(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}ye.from=Ae;function se(J){return new $.$xN(J.frameId,y.to(J.stoppedLocation))}ye.to=se})(Ne||(e.InlineValueContext=Ne={}));var de;(function(ye){function Ae(J){return{range:y.from(J.range),kind:J.kind}}ye.from=Ae;function se(J){return new $.$zM(y.to(J.range),J.kind)}ye.to=se})(de||(e.DocumentHighlight=de={}));var Ce;(function(ye){function Ae(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}ye.from=Ae;function se(J){return new $.$AM(s.URI.revive(J.uri),J.highlights.map(de.to))}ye.to=se})(Ce||(e.MultiDocumentHighlight=Ce={}));var Me;(function(ye){function Ae(se){switch(se){case 1:return $.CompletionTriggerKind.TriggerCharacter;case 2:return $.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return $.CompletionTriggerKind.Invoke}}ye.to=Ae})(Me||(e.CompletionTriggerKind=Me={}));var je;(function(ye){function Ae(se){return{triggerKind:Me.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}ye.to=Ae})(je||(e.CompletionContext=je={}));var j;(function(ye){function Ae(J){switch(J){case $.CompletionItemTag.Deprecated:return 1}}ye.from=Ae;function se(J){switch(J){case 1:return $.CompletionItemTag.Deprecated}}ye.to=se})(j||(e.CompletionItemTag=j={}));var L;(function(ye){const Ae=new Map([[$.CompletionItemKind.Method,0],[$.CompletionItemKind.Function,1],[$.CompletionItemKind.Constructor,2],[$.CompletionItemKind.Field,3],[$.CompletionItemKind.Variable,4],[$.CompletionItemKind.Class,5],[$.CompletionItemKind.Interface,7],[$.CompletionItemKind.Struct,6],[$.CompletionItemKind.Module,8],[$.CompletionItemKind.Property,9],[$.CompletionItemKind.Unit,12],[$.CompletionItemKind.Value,13],[$.CompletionItemKind.Constant,14],[$.CompletionItemKind.Enum,15],[$.CompletionItemKind.EnumMember,16],[$.CompletionItemKind.Keyword,17],[$.CompletionItemKind.Snippet,27],[$.CompletionItemKind.Text,18],[$.CompletionItemKind.Color,19],[$.CompletionItemKind.File,20],[$.CompletionItemKind.Reference,21],[$.CompletionItemKind.Folder,23],[$.CompletionItemKind.Event,10],[$.CompletionItemKind.Operator,11],[$.CompletionItemKind.TypeParameter,24],[$.CompletionItemKind.Issue,26],[$.CompletionItemKind.User,25]]);function se(Ve){return Ae.get(Ve)??9}ye.from=se;const J=new Map([[0,$.CompletionItemKind.Method],[1,$.CompletionItemKind.Function],[2,$.CompletionItemKind.Constructor],[3,$.CompletionItemKind.Field],[4,$.CompletionItemKind.Variable],[5,$.CompletionItemKind.Class],[7,$.CompletionItemKind.Interface],[6,$.CompletionItemKind.Struct],[8,$.CompletionItemKind.Module],[9,$.CompletionItemKind.Property],[12,$.CompletionItemKind.Unit],[13,$.CompletionItemKind.Value],[14,$.CompletionItemKind.Constant],[15,$.CompletionItemKind.Enum],[16,$.CompletionItemKind.EnumMember],[17,$.CompletionItemKind.Keyword],[27,$.CompletionItemKind.Snippet],[18,$.CompletionItemKind.Text],[19,$.CompletionItemKind.Color],[20,$.CompletionItemKind.File],[21,$.CompletionItemKind.Reference],[23,$.CompletionItemKind.Folder],[10,$.CompletionItemKind.Event],[11,$.CompletionItemKind.Operator],[24,$.CompletionItemKind.TypeParameter],[25,$.CompletionItemKind.User],[26,$.CompletionItemKind.Issue]]);function Pe(Ve){return J.get(Ve)??$.CompletionItemKind.Property}ye.to=Pe})(L||(e.CompletionItemKind=L={}));var H;(function(ye){function Ae(se,J){const Pe=new $.$QM(se.label);return Pe.insertText=se.insertText,Pe.kind=L.to(se.kind),Pe.tags=se.tags?.map(j.to),Pe.detail=se.detail,Pe.documentation=R.$Xk(se.documentation)?ie.to(se.documentation):se.documentation,Pe.sortText=se.sortText,Pe.filterText=se.filterText,Pe.preselect=se.preselect,Pe.commitCharacters=se.commitCharacters,o.$xt.isIRange(se.range)?Pe.range=y.to(se.range):typeof se.range=="object"&&(Pe.range={inserting:y.to(se.range.insert),replacing:y.to(se.range.replace)}),Pe.keepWhitespace=typeof se.insertTextRules>"u"?!1:!!(se.insertTextRules&1),typeof se.insertTextRules<"u"&&se.insertTextRules&4?Pe.insertText=new $.$tM(se.insertText):(Pe.insertText=se.insertText,Pe.textEdit=Pe.range instanceof $.$kM?new $.$pM(Pe.range,Pe.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Pe.additionalTextEdits=se.additionalTextEdits.map(Ve=>ae.to(Ve))),Pe.command=J&&se.command?J.fromInternal(se.command):void 0,Pe}ye.to=Ae})(H||(e.CompletionItem=H={}));var G;(function(ye){function Ae(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}ye.from=Ae;function se(J){return{label:J.label,documentation:R.$Xk(J.documentation)?ie.to(J.documentation):J.documentation}}ye.to=se})(G||(e.ParameterInformation=G={}));var ee;(function(ye){function Ae(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(G.from):[],activeParameter:J.activeParameter}}ye.from=Ae;function se(J){return{label:J.label,documentation:R.$Xk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(G.to):[],activeParameter:J.activeParameter}}ye.to=se})(ee||(e.SignatureInformation=ee={}));var re;(function(ye){function Ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}ye.from=Ae;function se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}ye.to=se})(re||(e.SignatureHelp=re={}));var Oe;(function(ye){function Ae(se,J){const Pe=new $.$PM(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,se)),J.kind&&He.to(J.kind));return Pe.textEdits=J.textEdits&&J.textEdits.map(ae.to),Pe.tooltip=R.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Pe.paddingLeft=J.paddingLeft,Pe.paddingRight=J.paddingRight,Pe}ye.to=Ae})(Oe||(e.InlayHint=Oe={}));var Be;(function(ye){function Ae(se,J){const Pe=new $.$OM(J.label);return Pe.tooltip=R.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(Pe.command=se.fromInternal(J.command)),J.location&&(Pe.location=ge.to(J.location)),Pe}ye.to=Ae})(Be||(e.InlayHintLabelPart=Be={}));var He;(function(ye){function Ae(J){return J}ye.from=Ae;function se(J){return J}ye.to=se})(He||(e.InlayHintKind=He={}));var _e;(function(ye){function Ae(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}ye.from=Ae;function se(J){let Pe;if(J.url)try{Pe=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new $.$VM(y.to(J.range),Pe)}ye.to=se})(_e||(e.DocumentLink=_e={}));var xe;(function(ye){function Ae(J){const Pe=new $.$YM(J.label);return J.textEdit&&(Pe.textEdit=ae.to(J.textEdit)),J.additionalTextEdits&&(Pe.additionalTextEdits=J.additionalTextEdits.map(Ve=>ae.to(Ve))),Pe}ye.to=Ae;function se(J){return{label:J.label,textEdit:J.textEdit?ae.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Pe=>ae.from(Pe)):void 0}}ye.from=se})(xe||(e.ColorPresentation=xe={}));var et;(function(ye){function Ae(J){return new $.$WM(J[0],J[1],J[2],J[3])}ye.to=Ae;function se(J){return[J.red,J.green,J.blue,J.alpha]}ye.from=se})(et||(e.Color=et={}));var tt;(function(ye){function Ae(J){return{range:y.from(J.range)}}ye.from=Ae;function se(J){return new $.$FM(y.to(J.range))}ye.to=se})(tt||(e.SelectionRange=tt={}));var it;(function(ye){function Ae(se){switch(se){case 2:return $.TextDocumentSaveReason.AfterDelay;case 1:return $.TextDocumentSaveReason.Manual;case 3:case 4:return $.TextDocumentSaveReason.FocusOut}}ye.to=Ae})(it||(e.TextDocumentSaveReason=it={}));var ct;(function(ye){function Ae(J){switch(J){case $.TextEditorLineNumbersStyle.Off:return 0;case $.TextEditorLineNumbersStyle.Relative:return 2;case $.TextEditorLineNumbersStyle.Interval:return 3;case $.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Ae;function se(J){switch(J){case 0:return $.TextEditorLineNumbersStyle.Off;case 2:return $.TextEditorLineNumbersStyle.Relative;case 3:return $.TextEditorLineNumbersStyle.Interval;case 1:default:return $.TextEditorLineNumbersStyle.On}}ye.to=se})(ct||(e.TextEditorLineNumbersStyle=ct={}));var gt;(function(ye){function Ae(J){if(J===$.EndOfLine.CRLF)return 1;if(J===$.EndOfLine.LF)return 0}ye.from=Ae;function se(J){if(J===1)return $.EndOfLine.CRLF;if(J===0)return $.EndOfLine.LF}ye.to=se})(gt||(e.EndOfLine=gt={}));var Ue;(function(ye){function Ae(se){if(typeof se=="object")return se.viewId;switch(se){case $.ProgressLocation.SourceControl:return 3;case $.ProgressLocation.Window:return 10;case $.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Ae})(Ue||(e.ProgressLocation=Ue={}));var ot;(function(ye){function Ae(J){const Pe={start:J.start+1,end:J.end+1};return J.kind&&(Pe.kind=Z.from(J.kind)),Pe}ye.from=Ae;function se(J){const Pe={start:J.start-1,end:J.end-1};return J.kind&&(Pe.kind=Z.to(J.kind)),Pe}ye.to=se})(ot||(e.FoldingRange=ot={}));var Z;(function(ye){function Ae(J){if(J)switch(J){case $.FoldingRangeKind.Comment:return n.$gu.Comment;case $.FoldingRangeKind.Imports:return n.$gu.Imports;case $.FoldingRangeKind.Region:return n.$gu.Region}}ye.from=Ae;function se(J){if(J)switch(J.value){case n.$gu.Comment.value:return $.FoldingRangeKind.Comment;case n.$gu.Imports.value:return $.FoldingRangeKind.Imports;case n.$gu.Region.value:return $.FoldingRangeKind.Region}}ye.to=se})(Z||(e.FoldingRangeKind=Z={}));var X;(function(ye){function Ae(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?y.from(se.selection):void 0,override:typeof se.override=="boolean"?u.$xF.id:void 0}}ye.from=Ae})(X||(e.TextEditorOpenOptions=X={}));var me;(function(ye){function Ae(Ve){return Ve instanceof $.$hN?Ve.toJSON():typeof Ve=="string"?Ve:se(Ve)||J(Ve)?new $.$hN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}ye.from=Ae;function se(Ve){const Xe=Ve;return Xe?s.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ve){const Xe=Ve;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Pe(Ve){return typeof Ve=="string"?Ve:new $.$hN(s.URI.revive(Ve.baseUri),Ve.pattern)}ye.to=Pe})(me||(e.GlobPattern=me={}));var qe;(function(ye){function Ae(se){if(se){if(Array.isArray(se))return se.map(Ae);if(typeof se=="string")return se;{const J=se;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ye.from=Ae})(qe||(e.LanguageSelector=qe={}));var we;(function(ye){function Ae(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&s.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Xe=>Xe instanceof $.$kM)))}ye.is=Ae;function se(J){return{documents:J.documents.map(Pe=>Pe.map(Ve=>({uri:s.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Xe=>y.from(Xe))})))}}ye.from=se})(we||(e.MappedEditsContext=we={}));var at;(function(ye){function Ae(J){return{start:J.start,end:J.end}}ye.from=Ae;function se(J){return new $.$KN(J.start,J.end)}ye.to=se})(at||(e.NotebookRange=at={}));var dt;(function(ye){function Ae(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ye.to=Ae;function se(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ye.from=se})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(ye){function Ae(se){if(se===g.NotebookCellExecutionState.Unconfirmed)return $.NotebookCellExecutionState.Pending;if(se===g.NotebookCellExecutionState.Pending)return;if(se===g.NotebookCellExecutionState.Executing)return $.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${se}`)}ye.to=Ae})(Pt||(e.NotebookCellExecutionState=Pt={}));var Vt;(function(ye){function Ae(J){switch(J){case $.NotebookCellKind.Markup:return g.CellKind.Markup;case $.NotebookCellKind.Code:default:return g.CellKind.Code}}ye.from=Ae;function se(J){switch(J){case g.CellKind.Markup:return $.NotebookCellKind.Markup;case g.CellKind.Code:default:return $.NotebookCellKind.Code}}ye.to=se})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(ye){function Ae(J){const Pe={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)$.$LN.validate(Ve),Pe.cells.push(ii.from(Ve));return Pe}ye.from=Ae;function se(J){const Pe=new $.$MN(J.cells.map(ii.to));return(0,r.$lg)(J.metadata)||(Pe.metadata=J.metadata),Pe}ye.to=se})(Qt||(e.NotebookData=Qt={}));var ii;(function(ye){function Ae(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Dt.from):[]}}ye.from=Ae;function se(J){return new $.$LN(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Dt.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}ye.to=se})(ii||(e.NotebookCellData=ii={}));var Xt;(function(ye){function Ae(J){return{mime:J.mime,valueBytes:O.$He.wrap(J.data)}}ye.from=Ae;function se(J){return new $.$NN(J.valueBytes.buffer,J.mime)}ye.to=se})(Xt||(e.NotebookCellOutputItem=Xt={}));var Dt;(function(ye){function Ae(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}ye.from=Ae;function se(J){const Pe=J.items.map(Xt.to);return new $.$ON(Pe,J.outputId,J.metadata)}ye.to=se})(Dt||(e.NotebookCellOutput=Dt={}));var Zt;(function(ye){function Ae(Pe){return J(Pe)?{include:me.from(Pe.include)??void 0,exclude:me.from(Pe.exclude)??void 0}:me.from(Pe)??void 0}ye.from=Ae;function se(Pe){return J(Pe)?{include:me.to(Pe.include),exclude:me.to(Pe.exclude)}:me.to(Pe)}ye.to=se;function J(Pe){const Ve=Pe;return Ve?!(0,r.$hg)(Ve.include)&&!(0,r.$hg)(Ve.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Yt;(function(ye){function Ae(se,J,Pe){const Ve=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===$.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Pe),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}ye.from=Ae})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ze;(function(ye){function Ae(se,J,Pe){const Ve=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{command:J.toInternal(Ve,Pe),label:se.label,description:se.description,detail:se.detail,documentation:se.documentation}}ye.from=Ae})(Ze||(e.NotebookKernelSourceAction=Ze={}));var si;(function(ye){function Ae(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{},cellContentMetadata:se?.cellContentMetadata??{}}}ye.from=Ae})(si||(e.NotebookDocumentContentOptions=si={}));var Gt;(function(ye){function Ae(J){return{uri:J.uri,provides:J.provides}}ye.from=Ae;function se(J){return new $.$QN(s.URI.revive(J.uri),J.provides)}ye.to=se})(Gt||(e.NotebookRendererScript=Gt={}));var ht;(function(ye){function Ae(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}ye.from=Ae;function se(J){const Pe=new $.$WN(typeof J.message=="string"?J.message:ie.to(J.message));return Pe.actualOutput=J.actual,Pe.expectedOutput=J.expected,Pe.contextValue=J.contextValue,Pe.location=J.location?ge.to(J.location):void 0,Pe}ye.to=se})(ht||(e.TestMessage=ht={}));var mt;(function(ye){ye.namespace=d.$0K,ye.denamespace=d.$$K})(mt||(e.TestTag=mt={}));var xt;(function(ye){function Ae(J){const Pe=(0,c.$FO)(J).controllerId;return{extId:a.$5K.fromExtHostTestItem(J,Pe).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>mt.namespace(Pe,Ve.id)),range:o.$xt.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}ye.from=Ae;function se(J){return{parent:void 0,error:void 0,id:a.$5K.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(Pe=>{const{tagId:Ve}=mt.denamespace(Pe);return new $.$XN(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ye.toPlain=se})(xt||(e.TestItem=xt={})),function(ye){function Ae(J){return{id:J.id}}ye.from=Ae;function se(J){return new $.$XN(J.id)}ye.to=se}(mt||(e.TestTag=mt={}));var Kt;(function(ye){const Ae=(J,Pe)=>{const Ve=J.value;if(!Ve)return;const Xe={...xt.toPlain(Ve.item),parent:Pe,taskStates:Ve.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(rt=>rt.type===0).map(ht.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const rt=Ae(Ge,Xe);rt&&Xe.children.push(rt)}return Xe};function se(J){const Pe=new l.$yO;for(const Ge of J.items)Pe.insert(a.$5K.fromString(Ge.item.extId).path,Ge);const Ve=[Pe.nodes],Xe=[];for(;Ve.length;)for(const Ge of Ve.pop())Ge.value?Xe.push(Ge):Ge.children&&Ve.push(Ge.children.values());return{completedAt:J.completedAt,results:Xe.map(Ge=>Ae(Ge)).filter(r.$gg)}}ye.to=se})(Kt||(e.TestResults=Kt={}));var Ft;(function(ye){function Ae(Ve){return{covered:Ve.covered,total:Ve.total}}function se(Ve){return"line"in Ve?k.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&se(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:se(Ve.location)}}ye.fromDetails=J;function Pe(Ve,Xe){return $.$ZN(Xe.statementCoverage),$.$ZN(Xe.branchCoverage),$.$ZN(Xe.declarationCoverage),{id:Ve,uri:Xe.uri,statement:Ae(Xe.statementCoverage),branch:Xe.branchCoverage&&Ae(Xe.branchCoverage),declaration:Xe.declarationCoverage&&Ae(Xe.declarationCoverage)}}ye.fromFile=Pe})(Ft||(e.TestCoverage=Ft={}));var ft;(function(ye){function Ae(se){switch(se){case 1:return $.CodeActionTriggerKind.Invoke;case 2:return $.CodeActionTriggerKind.Automatic}}ye.to=Ae})(ft||(e.CodeActionTriggerKind=ft={}));var jt;(function(ye){function Ae(J){const Pe=new $.$5N(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ye.to=Ae;function se(J,Pe,Ve){if(Pe=Pe??J._sessionId,Ve=Ve??J._itemId,Pe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(z.from)}}ye.from=se})(jt||(e.TypeHierarchyItem=jt={}));var _t;(function(ye){function Ae(se){if(se)return{value:se.value,tooltip:se.tooltip}}ye.from=Ae})(_t||(e.ViewBadge=_t={}));var Lt;(function(ye){function Ae(Ve,Xe,Ge){const rt=Xe.fileData;return rt?new $.$_M(new $.$aN(rt.name,s.URI.revive(rt.uri),rt.id,(0,N.$db)(()=>Ge(rt.id)))):Ve===T.$Ts.uriList&&Xe.uriListData?new $.$$M(Pe(Xe.uriListData)):new $.$$M(Xe.asString)}ye.to=Ae;async function se(Ve,Xe){const Ge=await Xe.asString();if(Ve===T.$Ts.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const rt=Xe.asFile();return{asString:Ge,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}ye.from=se;function J(Ve){return M.$Xt.split(Ve).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return s.URI.parse(Xe)}catch{}return Xe})}function Pe(Ve){return M.$Xt.create(Ve.map(Xe=>typeof Xe=="string"?Xe:s.URI.revive(Xe)))}})(Lt||(e.DataTransferItem=Lt={}));var Qe;(function(ye){function Ae(J,Pe){const Ve=J.items.map(([Xe,Ge])=>[Xe,Lt.to(Xe,Ge,Pe)]);return new $.$bN(Ve)}ye.toDataTransfer=Ae;async function se(J){const Pe={items:[]},Ve=[];for(const[Xe,Ge]of J)Ve.push((async()=>{Pe.items.push([Xe,await Lt.from(Xe,Ge)])})());return await Promise.all(Ve),Pe}ye.from=se})(Qe||(e.DataTransfer=Qe={}));var ci;(function(ye){function Ae(J,Pe){return{kind:"reply",agentId:J.participant??Pe?.agentId??"",subCommand:J.command??Pe?.command,message:J.prompt,title:J.label}}ye.from=Ae;function se(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ye.to=se})(ci||(e.ChatFollowup=ci={}));var Jt;(function(ye){function Ae(J){switch(J.role){case 0:return new $.$sO($.LanguageModelChatMessageRole.System,J.content);case 1:return new $.$sO($.LanguageModelChatMessageRole.User,J.content);case 2:return new $.$sO($.LanguageModelChatMessageRole.Assistant,J.content)}}ye.to=Ae;function se(J){switch(J.role){case $.LanguageModelChatMessageRole.System:return{role:0,content:J.content};case $.LanguageModelChatMessageRole.User:return{role:1,content:J.content};case $.LanguageModelChatMessageRole.Assistant:return{role:2,content:J.content}}}ye.from=se})(Jt||(e.LanguageModelChatMessage=Jt={}));var zt;(function(ye){function Ae(J){return{kind:"markdownContent",content:ie.from(J.value)}}ye.from=Ae;function se(J){return new $.$fO(ie.to(J.content))}ye.to=se})(zt||(e.ChatResponseMarkdownPart=zt={}));var pt;(function(ye){function Ae(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}ye.from=Ae;function se(J){return new $.$gO(ie.to(J.content),J.vulnerabilities)}ye.to=se})(pt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=pt={}));var Ut;(function(ye){function Ae(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ye.from=Ae;function se(J){return new $.$hO(J.agentId,J.command)}ye.to=se})(Ut||(e.ChatResponseDetectedParticipantPart=Ut={}));var Rt;(function(ye){function Ae(se){return{kind:"confirmation",title:se.title,message:se.message,data:se.data}}ye.from=Ae})(Rt||(e.ChatResponseConfirmationPart=Rt={}));var Nt;(function(ye){function Ae(J){const{value:Pe,baseUri:Ve}=J;function Xe(Ge,rt){return Ge.map(yt=>{const qt=s.URI.joinPath(rt,yt.name);return{label:yt.name,uri:qt,children:yt.children&&Xe(yt.children,qt)}})}return{kind:"treeData",treeData:{label:(0,b.$9g)(Ve),uri:Ve,children:Xe(Pe,Ve)}}}ye.from=Ae;function se(J){const Pe=(0,E.$8h)(J.treeData);function Ve(rt){return rt.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Xe=Pe.uri,Ge=Pe.children?Ve(Pe.children):[];return new $.$jO(Ge,Xe)}ye.to=se})(Nt||(e.ChatResponseFilesPart=Nt={}));var ei;(function(ye){function Ae(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:h.from(J.value)}}ye.from=Ae;function se(J){const Pe=(0,E.$8h)(J);return new $.$kO(s.URI.isUri(Pe.inlineReference)?Pe.inlineReference:h.to(Pe.inlineReference),J.name)}ye.to=se})(ei||(e.ChatResponseAnchorPart=ei={}));var Wt;(function(ye){function Ae(J){return{kind:"progressMessage",content:ie.from(J.value)}}ye.from=Ae;function se(J){return new $.$lO(J.content.value)}ye.to=se})(Wt||(e.ChatResponseProgressPart=Wt={}));var oi;(function(ye){function Ae(J){return{kind:"warning",content:ie.from(J.value)}}ye.from=Ae;function se(J){return new $.$mO(J.content.value)}ye.to=se})(oi||(e.ChatResponseWarningPart=oi={}));var Mt;(function(ye){function Ae(J,Pe,Ve){return{kind:"command",command:Pe.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}ye.from=Ae;function se(J,Pe){return new $.$nO(Pe.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ye.to=se})(Mt||(e.ChatResponseCommandButtonPart=Mt={}));var Tt;(function(ye){function Ae(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Pe=>ae.from(Pe))}}ye.from=Ae;function se(J){return new $.$pO(s.URI.revive(J.uri),J.edits.map(Pe=>ae.to(Pe)))}ye.to=se})(Tt||(e.ChatResponseTextEditPart=Tt={}));var Ot;(function(ye){function Ae(J){const Pe=f.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Pe}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Pe}}ye.from=Ae;function se(J){const Pe=(0,E.$8h)(J),Ve=Xe=>s.URI.isUri(Xe)?Xe:h.to(Xe);return new $.$oO("variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&Ve(Pe.reference.value)}:Ve(Pe.reference))}ye.to=se})(Ot||(e.ChatResponseReferencePart=Ot={}));var It;(function(ye){function Ae(Pe,Ve,Xe){return Pe instanceof $.$fO?zt.from(Pe):Pe instanceof $.$kO?ei.from(Pe):Pe instanceof $.$oO?Ot.from(Pe):Pe instanceof $.$lO?Wt.from(Pe):Pe instanceof $.$jO?Nt.from(Pe):Pe instanceof $.$nO?Mt.from(Pe,Ve,Xe):Pe instanceof $.$pO?Tt.from(Pe):Pe instanceof $.$gO?pt.from(Pe):Pe instanceof $.$hO?Ut.from(Pe):Pe instanceof $.$mO?oi.from(Pe):{kind:"markdownContent",content:ie.from("")}}ye.from=Ae;function se(Pe,Ve){switch(Pe.kind){case"reference":return Ot.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Pe,Ve)}}ye.to=se;function J(Pe,Ve){switch(Pe.kind){case"markdownContent":return zt.to(Pe);case"inlineReference":return ei.to(Pe);case"progressMessage":return;case"treeData":return Nt.to(Pe);case"command":return Mt.to(Pe,Ve)}}ye.toContent=J})(It||(e.ChatResponsePart=It={}));var wt;(function(ye){function Ae(se){return{prompt:se.message,command:se.command,attempt:se.attempt??0,enableCommandDetection:se.enableCommandDetection??!0,variables:se.variables.variables.map(ni.to),location:Et.to(se.location),acceptedConfirmationData:se.acceptedConfirmationData,rejectedConfirmationData:se.rejectedConfirmationData}}ye.to=Ae})(wt||(e.ChatAgentRequest=wt={}));var Et;(function(ye){function Ae(se){switch(se){case t.ChatAgentLocation.Notebook:return $.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return $.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return $.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return $.ChatLocation.Editor}}ye.to=Ae})(Et||(e.ChatLocation=Et={}));var ni;(function(ye){function Ae(se){const J=se.value;if(!J)throw new Error("Invalid value reference");return{name:se.name,range:se.range&&[se.range.start,se.range.endExclusive],value:(0,s.$vc)(J)?s.URI.revive(J):J}}ye.to=Ae})(ni||(e.ChatAgentValueReference=ni={}));var St;(function(ye){function Ae(se,J,Pe){return{label:se.label,value:se.values[0].value,insertText:se.insertText,detail:se.detail,documentation:se.documentation,command:J.toInternal(se.command,Pe)}}ye.from=Ae})(St||(e.ChatAgentCompletionItem=St={}));var di;(function(ye){function Ae(se){return{errorDetails:se.errorDetails,metadata:se.metadata}}ye.to=Ae})(di||(e.ChatAgentResult=di={}));var ri;(function(ye){function Ae(se,J,Pe){if(J.action.kind==="vote")return;const Ve=di.to(se);if(J.action.kind==="command"){const Xe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ci.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}ye.to=Ae})(ri||(e.ChatAgentUserActionEvent=ri={}));var bi;(function(ye){function Ae(se,J,Pe){return"terminalCommand"in se?{terminalCommand:se.terminalCommand,shouldExecute:se.shouldExecute}:"uri"in se?{uri:se.uri}:J.toInternal(se,Pe)}ye.from=Ae})(bi||(e.TerminalQuickFix=bi={}));var ui;(function(ye){function Ae(se){return{kind:mi.to(se.kind)}}ye.to=Ae})(ui||(e.PartialAcceptInfo=ui={}));var mi;(function(ye){function Ae(se){switch(se){case 0:return $.PartialAcceptTriggerKind.Word;case 1:return $.PartialAcceptTriggerKind.Line;case 2:return $.PartialAcceptTriggerKind.Suggest;default:return $.PartialAcceptTriggerKind.Unknown}}ye.to=Ae})(mi||(e.PartialAcceptTriggerKind=mi={}));var kt;(function(ye){function Ae(se,J){return{id:J,label:se.label,description:se.description,canEdit:se.canEdit,collapsibleState:se.collapsibleState||0,contextValue:se.contextValue}}ye.from=Ae})(kt||(e.DebugTreeItem=kt={}))}),define(ke[263],Ie([1,0,4,17,8,34]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;let R=class{constructor(m,E){this.a=m.getProxy(P.$gM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,T){const S=new N.$Ew(M.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,T?.isRefactoring??!1)}};e.$1lc=R,e.$1lc=R=Je([We(0,O.$JO)],R)}),define(ke[264],Ie([1,0,18,11,44,5,42,6,66,15,2,21,4,8,7,225,25]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class o{constructor(u,t,g,a,d){this.j=u,this.k=t,this.l=g,this.m=a,this.n=d,this.b=m.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(u.c){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,a),d}};const u=this;this.b.reset();const g=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){t(this.markdown);const d=new f.$fO(a),w=b.ChatResponseMarkdownPart.from(d);return g(w),this},markdownWithVulnerabilities(a,d){t(this.markdown),d&&(0,s.$SG)(u.j,"chatParticipantAdditions");const w=new f.$gO(a,d),$=b.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return g($),this},filetree(a,d){t(this.filetree);const w=new f.$jO(a,d),$=b.ChatResponseFilesPart.from(w);return g($),this},anchor(a,d){t(this.anchor);const w=new f.$kO(a,d),$=b.ChatResponseAnchorPart.from(w);return g($),this},button(a){t(this.anchor);const d=new f.$nO(a),w=b.ChatResponseCommandButtonPart.from(d,u.m,u.n);return g(w),this},progress(a){t(this.progress);const d=new f.$lO(a),w=b.ChatResponseProgressPart.from(d);return g(w),this},warning(a){t(this.progress),(0,s.$SG)(u.j,"chatParticipantAdditions");const d=new f.$mO(a),w=b.ChatResponseWarningPart.from(d);return g(w),this},reference(a,d){if(t(this.reference),"variableName"in a&&!a.value){const w=u.k.variables.variables.find($=>$.name===a.variableName);if(w){let $;if(w.references?.length)$=w.references.map(v=>({kind:"reference",reference:{variableName:a.variableName,value:v.reference}}));else{const v=new f.$oO(a,d);$=[b.ChatResponseReferencePart.from(v)]}return $.forEach(v=>g(v)),this}}else{const w=new f.$oO(a,d),$=b.ChatResponseReferencePart.from(w);g($)}return this},textEdit(a,d){t(this.textEdit),(0,s.$SG)(u.j,"chatParticipantAdditions");const w=new f.$pO(a,d),$=b.ChatResponseTextEditPart.from(w);return g($),this},detectedParticipant(a,d){t(this.detectedParticipant),(0,s.$SG)(u.j,"chatParticipantAdditions");const w=new f.$hO(a,d),$=b.ChatResponseDetectedParticipantPart.from(w);return g($),this},confirmation(a,d,w){t(this.confirmation),(0,s.$SG)(u.j,"chatParticipantAdditions");const $=new f.$iO(a,d,w),v=b.ChatResponseConfirmationPart.from($);return g(v),this},push(a){if(t(this.push),(a instanceof f.$pO||a instanceof f.$gO||a instanceof f.$hO||a instanceof f.$mO||a instanceof f.$iO)&&(0,s.$SG)(u.j,"chatParticipantAdditions"),a instanceof f.$oO)this.reference(a.value,a.iconPath);else{const d=b.ChatResponsePart.from(a,u.m,u.n);g(d)}return this}}}return this.g}}class n extends p.$Uc{static{this.b=0}constructor(u,t,g){super(),this.n=t,this.s=g,this.c=new Map,this.j=this.B(new p.$4c),this.m=this.B(new p.$4c),this.g=u.getProxy(l.$gM.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,t,g){const a=n.b++,d=new i(u,t,this.g,a,g);return this.c.set(a,d),this.g.$registerAgent(a,u.identifier,t,{},void 0),d.apiAgent}createDynamicChatAgent(u,t,g,a,d,w){const $=n.b++,v=new i(u,t,this.g,$,w);return this.c.set($,v),this.g.$registerAgent($,u.identifier,t,{isSticky:!0},{name:g,description:d,publisherDisplayName:a}),v.apiAgent}async $invokeAgent(u,t,g,a){const d=this.c.get(u);if(!d)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(t.sessionId);w||(w=new p.$Tc,this.j.set(t.sessionId,w));const $=new o(d.extension,t,this.g,this.s.converter,w);try{const v=await this.t(t.agentId,g),y=d.invoke(b.ChatAgentRequest.to(t),{history:v},$.apiObject,a);return await(0,O.$mh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(D){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${d.extension.identifier.value}] [@${d.id}] ${k}`,d.extension),{errorDetails:{message:k},timings:$.timings}}return{errorDetails:h?.errorDetails,timings:$.timings,metadata:h?.metadata}}),a)}catch(v){return this.n.error(v,d.extension),{errorDetails:{message:(0,M.$jj)(v),responseIsIncomplete:!0}}}finally{$.close()}}async t(u,t){const g=[];for(const a of t.history){const d=b.ChatAgentResult.to(a.result),w=u===a.request.agentId?d:{...d,metadata:void 0};g.push(new f.$qO(a.request.message,a.request.command,a.request.variables.variables.map(b.ChatAgentValueReference.to),a.request.agentId));const $=(0,P.$Hb)(a.response.map(v=>b.ChatResponsePart.toContent(v,this.s.converter)));g.push(new f.$rO($,w,a.request.agentId,a.request.command))}return g}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,t,g,a,d){const w=this.c.get(t);if(!w)return Promise.resolve([]);const $=await this.t(w.id,a),v=b.ChatAgentResult.to(g);return(await w.provideFollowups(v,{history:$},d)).filter(y=>{const h=!y.participant||R.Iterable.some(this.c.values(),D=>D.id===y.participant&&S.$Tm.equals(D.extension.identifier,w.extension.identifier));return h||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>b.ChatFollowup.from(y,u))}$acceptFeedback(u,t,g,a){const d=this.c.get(u);if(!d)return;const w=b.ChatAgentResult.to(t);let $;switch(g){case r.InteractiveSessionVoteDirection.Down:$=f.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:$=f.ChatResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(a?{result:w,kind:$,reportIssue:a}:{result:w,kind:$}))}$acceptAction(u,t,g){const a=this.c.get(u);if(!a||g.action.kind==="vote")return;const d=b.ChatAgentUserActionEvent.to(t,g,this.s.converter);d&&a.acceptAction(Object.freeze(d))}async $invokeCompletionProvider(u,t,g){const a=this.c.get(u);if(!a)return[];let d=this.m.get(u);return d?d.clear():(d=new p.$Tc,this.m.set(u,d)),(await a.invokeCompletionProvider(t,g)).map($=>b.ChatAgentCompletionItem.from($,this.s.converter,d))}async $provideWelcomeMessage(u,t,g){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(b.ChatLocation.to(t),g)}async $provideSampleQuestions(u,t,g){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(b.ChatLocation.to(t),g)).map(d=>b.ChatFollowup.from(d,void 0))}}e.$2lc=n;class i{constructor(u,t,g,a,d){this.extension=u,this.id=t,this.u=g,this.w=a,this.x=d,this.n=new N.$fe,this.o=new N.$fe}acceptFeedback(u){this.n.fire(u)}acceptAction(u){this.o.fire(u)}async invokeCompletionProvider(u,t){return this.q?await this.q.provider.provideCompletionItems(u,t)??[]:[]}async provideFollowups(u,t,g){if(!this.b)return[];const a=await this.b.provideFollowups(u,t,g);return a?a.filter(d=>!(d&&"commandId"in d)).filter(d=>!(d&&"message"in d)):[]}async provideWelcomeMessage(u,t){if(!this.s)return[];const g=await this.s.provideWelcomeMessage(u,t);return g?g.map(a=>typeof a=="string"?a:b.MarkdownString.from(a)):[]}async provideSampleQuestions(u,t){if(!this.s||!this.s.provideSampleQuestions)return[];const g=await this.s.provideSampleQuestions(u,t);return g||[]}get apiAgent(){let u=!1,t=!1;const g=()=>{u||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof f.$fN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:b.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:b.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:b.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,s.$SG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(d){(0,s.$SG)(a.extension,"defaultChatParticipant"),a.c=d,g()},get iconPath(){return a.d},set iconPath(d){a.d=d,g()},get requestHandler(){return a.x},set requestHandler(d){(0,E.$ig)(typeof d=="function","Invalid request handler"),a.x=d},get followupProvider(){return a.b},set followupProvider(d){a.b=d,g()},get isDefault(){return(0,s.$SG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(d){(0,s.$SG)(a.extension,"defaultChatParticipant"),a.g=d,g()},get helpTextPrefix(){return(0,s.$SG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(d){(0,s.$SG)(a.extension,"defaultChatParticipant"),a.j=d,g()},get helpTextVariablesPrefix(){return(0,s.$SG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(d){(0,s.$SG)(a.extension,"defaultChatParticipant"),a.k=d,g()},get helpTextPostfix(){return(0,s.$SG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(d){(0,s.$SG)(a.extension,"defaultChatParticipant"),a.l=d,g()},get isSecondary(){return(0,s.$SG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(d){(0,s.$SG)(a.extension,"defaultChatParticipant"),a.m=d,g()},get supportIssueReporting(){return(0,s.$SG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(d){(0,s.$SG)(a.extension,"chatParticipantAdditions"),a.p=d,g()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(d){if((0,s.$SG)(a.extension,"chatParticipantAdditions"),a.q=d,d){if(!d.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,d.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,s.$SG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(d){(0,s.$SG)(a.extension,"defaultChatParticipant"),a.s=d,g()},get welcomeMessageProvider(){return(0,s.$SG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,s.$RG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(d){a.t=d,g()},get requester(){return a.t},dispose(){u=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(u,t,g,a){return this.x(u,t,g,a)}}}),define(ke[265],Ie([1,0,14,6,4,8,7,25]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class m{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(M.$gM.MainThreadChatVariables)}async $resolveVariable(S,l,b,f){const r=this.b.get(S);if(r)try{if(r.resolver.resolve2){(0,p.$SG)(r.extension,"chatParticipantAdditions");const s=new E(l,this.c),o=await r.resolver.resolve2(r.data.name,{prompt:b},s.apiObject,f);if(o&&o[0])return o[0].value}else{const s=await r.resolver.resolve(r.data.name,{prompt:b},f);if(s&&s[0])return s[0].value}}catch(s){(0,P.$2)(s)}}registerVariableResolver(S,l,b,f){const r=m.a++;return this.b.set(r,{extension:S,data:{name:l,description:b},resolver:f}),this.c.$registerVariable(r,{name:l,description:b}),(0,O.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$3lc=m;class E{constructor(S,l){this.c=S,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(f){if(S.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,f),r}};const S=this,b=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){l(this.progress);const r=new R.$lO(f),s=N.ChatResponseProgressPart.from(r);return b(s),this},reference(f){l(this.reference);const r=new R.$oO(f),s=N.ChatResponseReferencePart.from(r);return b(s),this},push(f){return l(this.push),f instanceof R.$oO?b(N.ChatResponseReferencePart.from(f)):f instanceof R.$lO&&b(N.ChatResponseProgressPart.from(f)),this}}}return this.b}}}),define(ke[266],Ie([1,0,11,69,5,6,2,89,21,8,7,4,25]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=b;function b(f,r,s){const o=f.getProxy(S.$gM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Vm,r.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const y=this.b.get(v.handle);return y?y.value:v}else if(v&&v.$mid===7){const y=v,h=this.b.get(y.commentControlHandle);if(!h)return y;const D=h.getCommentThread(y.commentThreadHandle);return D?D.value:y}else if(v&&(v.$mid===9||v.$mid===8)){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);return h?v.$mid===8?h.value:{thread:h.value,text:v.text}:v}else if(v&&v.$mid===10){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.commentUniqueId,k=h.getCommentByUniqueId(D);return k||v}else if(v&&v.$mid===11){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.text,k=v.commentUniqueId,C=h.getCommentByUniqueId(k);return C?(typeof C.body=="string"?C.body=D:C.body=new T.$KM(D),C):v}return v}})}createCommentController(v,y,h){const D=n.a++,k=new c(v,D,y,h);this.b.set(k.handle,k);const C=this.c.get(v.identifier)||[];return C.push(k),this.c.set(v.identifier,C),k.value}async $createCommentThreadTemplate(v,y,h,D){const k=this.b.get(v);k&&k.$createCommentThreadTemplate(y,h,D)}async $setActiveComment(v,y){const h=this.b.get(v);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(v,y,h){const D=this.b.get(v);D&&D.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(v,y){this.b.get(v)?.$deleteCommentThread(y)}async $provideCommentingRanges(v,y,h){const D=this.b.get(v);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const k=await s.ensureDocumentData(R.URI.revive(y));return(0,P.$qh)(async()=>{const C=await D.commentingRangeProvider.provideCommentingRanges(k.document,h);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(W=>E.Range.from(W)),fileComments:C.fileComments}),I})}$toggleReaction(v,y,h,D,k){const C=this.b.get(v);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,P.$qh)(()=>{const I=C.getCommentThread(y);if(I){const W=I.getCommentByUniqueId(D.uniqueIdInThread);if(C!==void 0&&W&&C.reactionHandler)return C.reactionHandler(W,g(k))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,l.$SG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,y,h,D,k,C,I,W,V){this.m=y,this.n=h,this.o=D,this.p=k,this.q=C,this.extensionDescription=I,this.r=W,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$fe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,E.Range.from(this.p),I.identifier,this.r,V),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(A){q.range=A},get comments(){return q.comments},set comments(A){q.comments=A},get collapsibleState(){return q.collapsibleState},set collapsibleState(A){q.collapsibleState=A},get canReply(){return q.canReply},set canReply(A){q.canReply=A},get contextValue(){return q.contextValue},set contextValue(A){q.contextValue=A},get label(){return q.label},set label(A){q.label=A},get state(){return q.state},set state(A){q.state=A},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const v=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};v("range")&&(y.range=E.Range.from(this.p)),v("label")&&(y.label=this.label),v("contextValue")&&(y.contextValue=this.contextValue??null),v("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),v("collapsibleState")&&(y.collapseState=a(this.g)),v("canReply")&&(y.canReply=this.canReply),v("state")&&(y.state=d(this.h)),v("applicability")&&(y.applicability=w(this.h)),v("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(v){for(const y of this.k){const h=y[0],D=y[1];if(v===D)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Je([(0,O.$4h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,l.$SG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$SG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$SG)(this.h,"activeComment"),this.f}constructor(v,y,h,D){this.h=v,this.i=y,this.j=h,this.k=D,this.a=new Map,o.$registerCommentController(this.handle,h,D,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(C){k.options=C},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(C){k.commentingRangeProvider=C},get reactionHandler(){return k.reactionHandler},set reactionHandler(C){k.reactionHandler=C},get activeCommentThread(){return k.activeCommentThread},createCommentThread(C,I,W){return k.createCommentThread(C,I,W).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(v,y,h){y===void 0&&(0,l.$SG)(this.h,"fileComments");const D=new i(this.id,this.handle,void 0,v,y,h,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const y=this.a.get(v.commentThreadHandle);y&&(this.e=v.uniqueIdInThread?y.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(v,y,h){const D=new i(this.id,this.handle,void 0,R.URI.revive(v),E.Range.to(y),[],this.h,!0,h);return D.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(v,y){const h=this.a.get(v);h&&(h.range=E.Range.to(y))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function u($,v,y,h){let D=y.get(v);return D||(D=++$.commentHandle,y.set(v,D)),v.state!==void 0&&(0,l.$SG)(h,"commentsDraftState"),v.reactions?.some(k=>k.reactors!==void 0)&&(0,l.$SG)(h,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:D,body:typeof v.body=="string"?v.body:E.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(k=>t(k)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function t($){return{label:$.label,iconPath:$.iconPath?E.$IO($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted,reactors:$.reactors&&$.reactors.length>0&&typeof $.reactors[0]!="string"?$.reactors.map(v=>v.name):$.reactors}}function g($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?R.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1,reactors:$.reactors?.map(v=>({name:v}))}}function a($){if($!==void 0)switch($){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function d($){let v;if(typeof $=="object"?v=$.resolved:v=$,v!==void 0)switch(v){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function w($){let v;if(typeof $=="object"&&(v=$.applicability),v!==void 0)switch(v){case T.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(ke[267],Ie([1,0,20,73,6,16,24,2,8,64,76,4,7]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class b{constructor(g,a){this.document=g,this.b=a,this.a=1,this.c=new T.$Mlc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,a){await this.f(g).undo(),a||this.disposeBackup()}async redo(g,a){await this.f(g).redo(),a||this.disposeBackup()}disposeEdits(g){for(const a of g)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=u(this.document.uri)+this.a++;return(0,R.$_g)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const a=this.c.get(g,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this.a=new Map}get(g,a){return this.a.get(this.b(g,a))}add(g,a,d){const w=this.b(g,a.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${g} resource:${a.uri}`);const $=new b(a,d);return this.a.set(w,$),$}delete(g,a){const d=this.b(g,a.uri);this.a.delete(d)}b(g,a){return`${g}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this.a=new Map}addTextProvider(g,a,d){return this.b(g,{type:0,extension:a,provider:d})}addCustomProvider(g,a,d){return this.b(g,{type:1,extension:a,provider:d})}get(g){return this.a.get(g)}b(g,a){if(this.a.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this.a.set(g,a),new l.$iM(()=>this.a.delete(g))}}class o{constructor(g,a,d,w,$){this.d=a,this.f=d,this.g=w,this.h=$,this.b=new s,this.c=new f,this.a=g.getProxy(S.$gM.MainThreadCustomEditors)}registerCustomEditorProvider(g,a,d,w){const $=new M.$Tc;return i(d)?($.add(this.b.addTextProvider(a,g,d)),this.a.$registerTextEditorProvider((0,E.$jmc)(g),a,w.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,E.$hmc)(g))):($.add(this.b.addCustomProvider(a,g,d)),n(d)&&$.add(d.onDidChangeCustomDocument(v=>{const y=this.i(a,v.document.uri);if(c(v)){const h=y.addEdit(v);this.a.$onDidEdit(v.document.uri,a,h,v.label)}else this.a.$onContentChange(v.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$jmc)(g),a,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,E.$hmc)(g))),l.$iM.from($,new l.$iM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(g,a,d,w,$){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=p.URI.revive(g),h=await v.provider.openCustomDocument(y,{backupId:d,untitledDocumentData:w?.buffer},$);let D;return n(v.provider)&&this.f&&(D=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(a,h,D),{editable:n(v.provider)}}async $disposeCustomDocument(g,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const w=p.URI.revive(g),{document:$}=this.i(a,w);this.c.delete(a,$),$.dispose()}async $resolveCustomEditor(g,a,d,w,$,v){const y=this.b.get(d);if(!y)throw new Error(`No provider found for '${d}'`);const h=m.ViewColumn.to($),D=this.g.createNewWebview(a,w.contentOptions,y.extension),k=this.h.createNewWebviewPanel(a,d,w.title,h,w.options,D,w.active),C=p.URI.revive(g);switch(y.type){case 1:{const{document:I}=this.i(d,C);return y.provider.resolveCustomEditor(I,k,v)}case 0:{const I=this.d.getDocument(C);return y.provider.resolveCustomTextEditor(I,k,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,a,d){this.i(a,g).disposeEdits(d)}async $onMoveCustomEditor(g,a,d){const w=this.b.get(d);if(!w)throw new Error(`No provider found for '${d}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const $=this.h.getWebviewPanel(g);if(!$)throw new Error("No webview found");const v=p.URI.revive(a),y=this.d.getDocument(v);await w.provider.moveCustomTextEditor(y,$,P.CancellationToken.None)}async $undo(g,a,d,w){return this.i(a,g).undo(d,w)}async $redo(g,a,d,w){return this.i(a,g).redo(d,w)}async $revert(g,a,d){const w=this.i(a,g);await this.j(a).revertCustomDocument(w.document,d),w.disposeBackup()}async $onSave(g,a,d){const w=this.i(a,g);await this.j(a).saveCustomDocument(w.document,d),w.disposeBackup()}async $onSaveAs(g,a,d,w){const $=this.i(a,g);return this.j(a).saveCustomDocumentAs($.document,p.URI.revive(d),w)}async $backup(g,a,d){const w=this.i(a,g),v=await this.j(a).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},d);return w.updateBackup(v),v.id}i(g,a){const d=this.c.get(g,p.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(g){const d=this.b.get(g)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$mmc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const g=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.$mj)(g)+""}}),define(ke[268],Ie([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,P,O,M,N,R,p,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0;class b{#e;#t;#i;constructor(s,o,n,i,c,u,t,g){this.d=s,this.e=o,this.f=n,this.g=i,this.h=c,this.c=!1,this.f=Math.max(i,n),this.#i=new T.$Ac(a=>u.getComparisonKey(a)),this.#e=t,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let n=[];if(M.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),n=[s]}else if(Array.isArray(s)){n=[];let u;s=[...s].sort(b.k);for(const t of s){const[g,a]=t;if((!u||g.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=g,n.push(g),this.#i.set(g,[])),a)this.#i.get(g)?.push(...a);else{const d=this.#i.get(g);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let c=0;for(const u of n){let t=[];const g=this.#i.get(u);if(g)if(g.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const w of g)if(w.severity===a[d]&&t.push({...p.Diagnostic.from(w),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,P.localize)(0,null,g.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=g.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(u)}));if(i.push([u,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[n,i]of this)s.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$Tlc=b;let f=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const o=new T.$Ac;for(const n of s)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new m.$je({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=s.getProxy(N.$gM.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:n,f:i,h:c,j:u,k:t,l:g}=this,a=new class{$changeMany($,v){i.$changeMany($,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,$,v.length===0?"CLEARING":v)}$clear($){i.$clear($),u.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,$)}dispose(){i.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+l.c++,d=o;else if(!n.has(o))d=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+l.c++;while(n.has(d))}return new class extends b{constructor(){super(o,d,l.e,l.d,$=>g.getDocument($)?.version,t.extUri,a,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((c,u)=>{let t=o.get(c.toString());typeof t>"u"&&(t=n.length,o.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...u)});return n}}m(s){let o=[];for(const n of this.g.values())n.has(s)&&(o=o.concat(n.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",n=new b(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of s)this.n.set(M.URI.revive(o),n.map(p.Diagnostic.to))}};e.$Ulc=f,e.$Ulc=f=l=Je([We(1,E.$5j),We(2,S.$Slc)],f)}),define(ke[269],Ie([1,0,2,14,7,8,200,34]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;class m{constructor(T,S,l,b={timeout:1500,errors:3}){this.c=T,this.d=S,this.f=l,this.g=b,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(S,l,b)=>{const r={dispose:this.a.push([S,l,T])};return Array.isArray(b)&&b.push(r),r}}async $participateInSave(T,S){const l=P.URI.revive(T);let b=!1;const f=setTimeout(()=>b=!0,this.g.timeout),r=[];try{for(const s of[...this.a]){if(b)break;const o=this.d.getDocument(l),n=await this.h(s,{document:o,reason:N.TextDocumentSaveReason.to(S)});r.push(n)}}finally{clearTimeout(f)}return r}h([T,S,l],b){const f=this.b.get(T);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(l,T,S,b).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this.b.get(T);this.b.set(T,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,S,l,b){const f=[],r=Date.now(),{document:s,reason:o}=b,{version:n}=s,i=Object.freeze({document:s,reason:o,waitUntil(c){if(Object.isFrozen(f))throw(0,O.$8)("waitUntil can not be called async");f.push(Promise.resolve(c))}});try{S.apply(l,[i])}catch(c){return Promise.reject(c)}return Object.freeze(f),new Promise((c,u)=>{const t=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(f).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(g)}).catch(g=>{clearTimeout(t),u(g)})}).then(c=>{const u={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(g=>g instanceof M.$pM))for(const{newText:g,newEol:a,range:d}of t)u.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:d&&N.Range.from(d),text:g,eol:a&&N.EndOfLine.from(a)}});if(u.edits.length!==0)return n===s.version?this.f.$tryApplyWorkspaceEdit(new p.$Ew(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$3mc=m}),define(ke[270],Ie([1,0,5,6,2,4,113,8,15,26,7]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class S{constructor(b,f){this.a=new P.$fe,this.b=new P.$fe,this.c=new P.$fe,this.d=new P.$fe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=b.getProxy(N.$gM.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let r=this.h.get(b.toString());return r||(r=this.f.$tryOpenDocument(b).then(s=>{this.h.delete(b.toString());const o=M.URI.revive(s);return(0,m.$jg)(this.g.getDocument(o))},s=>(this.h.delete(b.toString()),Promise.reject(s))),this.h.set(b.toString(),r)),r}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>M.URI.revive(f))}$acceptModelLanguageChanged(b,f){const r=M.URI.revive(b),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(f),this.a.fire(s.document)}$acceptModelSaved(b){const f=M.URI.revive(b),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(b,f){const r=M.URI.revive(b),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,r){const s=M.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(r),o.onEvents(f);let n;f.isUndoing?n=T.TextDocumentChangeReason.Undo:f.isRedoing&&(n=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$6n)({document:o.document,contentChanges:f.changes.map(i=>({range:p.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(b,f){(0,R.$LO)(b,f)}}e.$Vlc=S}),define(ke[67],Ie([1,0,271,5,15,2,3,4,17,8,7]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=e.$nmc=void 0,e.$nmc=(0,R.$yi)("IExtHostEditorTabs");class S{constructor(s,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$6N(N.URI.revive(this.b.input.uri));case 2:return new T.$7N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new T.$8N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new T.$9N(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$0N(this.b.input.viewType);case 4:return new T.$$N(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$_N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$aO;case 9:return new T.$bO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$cO;case 11:return new T.$dO(this.b.input.diffEditors.map(s=>new T.$7N(N.URI.revive(s.original),N.URI.revive(s.modified))));default:return}}}class l{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const n of s.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return E.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(n=>n.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const n=new S(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,n),s.tabDto.isActive&&(this.d=n.tabId),n}else if(s.kind===1){const n=this.c.splice(s.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(s.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,n),n}const o=this.c.find(n=>n.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let b=class{constructor(s){this.b=new O.$fe,this.c=new O.$fe,this.e=[],this.a=s.getProxy(p.$gM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(n=>n.apiObject))},get activeTabGroup(){const n=s.d;return(0,M.$jg)(s.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,i)=>{const c=Array.isArray(n)?n:[n];return c.length?f(c[0])?this.j(c,i):this.i(c,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(a=>a.groupId)),n=new Set(s.map(a=>a.groupId)),i=(0,P.$L)(o,n),c=this.e.filter(a=>i.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],t=[];this.e=s.map(a=>{const d=new l(a,()=>this.d);return i.added.includes(d.groupId)?u.push(d.apiObject):t.push(d.apiObject),d});const g=(0,M.$jg)(s.find(a=>a.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(s){const o=this.e.find(n=>n.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(s){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===s)return n}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const n=[];for(const i of s){const c=this.g(i);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,o)}async j(s,o){const n=[];for(const i of s){const c=this.h(i);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,o)}};e.$omc=b,e.$omc=b=Je([We(0,m.$JO)],b);function f(r){return r.tabs!==void 0}}),define(ke[272],Ie([1,0,2,4,6,7,8,314,13,22,25,55]),function(le,e,P,O,M,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const s=this.a.indexOf(r);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),s=[];let o,n,i=14,c=14;for(const u of r){let t=o?(0,m.$Bf)(o,u):0;for(t===0?n=1:n=c;t<u.length;t++)t+1===u.length?(i=c,c=9):c+=1,s.push([n,u.toUpperCase().charCodeAt(t),c]),s.push([n,u.toLowerCase().charCodeAt(t),c]),n=c;o=u,c=i}s.push([9,58,10]),s.push([10,47,12]),this.b=new p.$G2(s)}}provideDocumentLinks(r){this.c();const s=[],o=p.$H2.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of o){const i=R.DocumentLink.to(n);i.target&&s.push(i)}return s}}class b{constructor(r,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(O.$gM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,s,o,n={}){if(b.j(o),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(s),this.d.add(s),this.c.set(i,o);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof o.copy=="function"&&(c+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,T.$SG)(r,"fsChunks"),c+=4);let u;n.isReadonly&&(0,S.$Xk)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,s,c,u).catch(g=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${s}`),console.error(g)});const t=o.onDidChangeFile(g=>{const a=[];for(const d of g){const{uri:w,type:$}=d;if(w.scheme!==s)continue;let v;switch($){case N.FileChangeType.Changed:v=0;break;case N.FileChangeType.Created:v=1;break;case N.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:w,type:v})}this.a.$onFileSystemChange(i,a)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:s,ctime:o,mtime:n,size:i,permissions:c}=r;return{type:s,ctime:o,mtime:n,size:i,permissions:c}}$stat(r,s){return Promise.resolve(this.l(r).stat(P.URI.revive(s))).then(o=>b.k(o))}$readdir(r,s){return Promise.resolve(this.l(r).readDirectory(P.URI.revive(s)))}$readFile(r,s){return Promise.resolve(this.l(r).readFile(P.URI.revive(s))).then(o=>E.$He.wrap(o))}$writeFile(r,s,o,n){return Promise.resolve(this.l(r).writeFile(P.URI.revive(s),o.buffer,n))}$delete(r,s,o){return Promise.resolve(this.l(r).delete(P.URI.revive(s),o))}$rename(r,s,o,n){return Promise.resolve(this.l(r).rename(P.URI.revive(s),P.URI.revive(o),n))}$copy(r,s,o,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(P.URI.revive(s),P.URI.revive(o),n))}$mkdir(r,s){return Promise.resolve(this.l(r).createDirectory(P.URI.revive(s)))}$watch(r,s,o,n){const i=this.l(r).watch(P.URI.revive(o),n);this.f.set(s,i)}$unwatch(r,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(r,s,o){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(P.URI.revive(s),o))}$close(r,s){const o=this.l(r);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(r,s,o,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$He.alloc(n);return Promise.resolve(i.read(s,o,c.buffer,0,n)).then(u=>c.slice(0,u))}$write(r,s,o,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(s,o,n.buffer,0,n.byteLength))}l(r){const s=this.c.get(r);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.$6mc=b}),define(ke[273],Ie([1,0,5,37,2,4,8,7,43]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,f,r,s,o,n){this.a=Math.random(),this.b=new P.$fe,this.c=new P.$fe,this.d=new P.$fe,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$sk)(o),c=typeof o=="string",u=n?.correlate,t=s(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(u&&typeof g.session>"u")){if(!n?.ignoreCreateEvents)for(const a of g.created){const d=M.URI.revive(a);i(d.fsPath)&&(!c||f.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const a of g.changed){const d=M.URI.revive(a);i(d.fsPath)&&(!c||f.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const a of g.deleted){const d=M.URI.revive(a);i(d.fsPath)&&(!c||f.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=p.$iM.from(this.i(b,r,o,n,n?.correlate),this.b,this.c,this.d,t)}i(b,f,r,s,o){const n=p.$iM.from();if(typeof r=="string"||s?.ignoreChangeEvents&&s?.ignoreCreateEvents&&s?.ignoreDeleteEvents)return n;const i=b.getProxy(N.$gM.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(O.$ok)||r.pattern.includes(O.$pk))&&(c=!0);let u;return o&&(s?.ignoreChangeEvents||s?.ignoreCreateEvents||s?.ignoreDeleteEvents)&&(u=14,s?.ignoreChangeEvents&&(u&=-3),s?.ignoreCreateEvents&&(u&=-5),s?.ignoreDeleteEvents&&(u&=-9)),i.$watch(f.identifier.value,this.a,r.baseUri,{recursive:c,excludes:s?.excludes??[],filter:u},!!o),p.$iM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(b){this.a=b,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(M.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(b,f,r){this.j=b,this.k=f,this.l=r,this.a=new P.$fe,this.b=new P.$fe,this.c=new P.$fe,this.d=new P.$fe,this.g=new P.$he,this.h=new P.$he,this.i=new P.$he,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,f,r,s){return new E(this.j,b,f,this.a.event,R.GlobPattern.from(r),s)}$onFileEvent(b){this.a.fire(new T(b))}$onDidRunFileOperation(b,f){switch(b){case 2:this.b.fire(Object.freeze({files:f.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(r=>M.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(r=>M.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,f){return(r,s,o)=>{const n=function(c){r.call(s,c)};return n.extension=b,f.event(n,void 0,o)}}async $onWillRunFileOperation(b,f,r,s){switch(b){case 2:return await this.n(this.g,{files:f.map(o=>({oldUri:M.URI.revive(o.source),newUri:M.URI.revive(o.target)}))},r,s);case 1:return await this.n(this.i,{files:f.map(o=>M.URI.revive(o.target))},r,s);case 0:case 3:return await this.n(this.h,{files:f.map(o=>M.URI.revive(o.target))},r,s)}}async n(b,f,r,s){const o=new Set,n=[];if(await b.fireAsync(f,s,async(c,u)=>{const t=Date.now(),g=await Promise.resolve(c);g instanceof p.$sM&&(n.push([u.extension,g]),o.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",u.extension.identifier)}),s.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,c]of n){const{edits:u}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(u)}return{edit:i,extensionNames:Array.from(o)}}}e.$7mc=S}),define(ke[274],Ie([1,0,18,11,20,14,91,6,26,66,13,15,2,30,315,89,98,174,21,8,7,25,76,4]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class a{constructor(j,L){this.d=j,this.e=L}async provideDocumentSymbols(j,L){const H=this.d.getDocument(j),G=await this.e.provideDocumentSymbols(H,L);if(!(0,P.$Kb)(G))return G[0]instanceof c.$CM?G.map(i.DocumentSymbol.from):a.f(G)}static f(j){j=j.slice(0).sort((G,ee)=>{let re=G.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(G.location.range.end)),re});const L=[],H=[];for(const G of j){const ee={name:G.name||"!!MISSING: name!!",kind:i.SymbolKind.from(G.kind),tags:G.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:i.Range.from(G.location.range),selectionRange:i.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(ee),L.push(ee);break}const re=H[H.length-1];if(b.$xt.containsRange(re.range,ee.range)&&!b.$xt.equalsRange(re.range,ee.range)){re.children?.push(ee),H.push(ee);break}H.pop()}}return L}}class d{constructor(j,L,H,G,ee,re){this.f=j,this.g=L,this.h=H,this.j=G,this.k=ee,this.l=re,this.d=new t.$Mlc("CodeLens"),this.e=new Map}async provideCodeLenses(j,L){const H=this.f.getDocument(j),G=await this.h.provideCodeLenses(H,L);if(!G||L.isCancellationRequested)return;const ee=this.d.add(G),re=new p.$Tc;this.e.set(ee,re);const Oe={cacheId:ee,lenses:[]};for(let Be=0;Be<G.length;Be++)Oe.lenses.push({cacheId:[ee,Be],range:i.Range.from(G[Be].range),command:this.g.toInternal(G[Be].command,re)});return Oe}async resolveCodeLens(j,L){const H=j.cacheId&&this.d.get(...j.cacheId);if(!H)return;let G;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.h.resolveCodeLens(H,L),G||(G=H),L.isCancellationRequested)return;const ee=j.cacheId&&this.e.get(j.cacheId[0]);if(ee){if(!G.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return j.command=this.g.toInternal(G.command,ee),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function w(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class ${constructor(j,L){this.d=j,this.e=L}async provideDefinition(j,L,H){const G=this.d.getDocument(j),ee=i.Position.to(L),re=await this.e.provideDefinition(G,ee,H);return w(re)}}class v{constructor(j,L){this.d=j,this.e=L}async provideDeclaration(j,L,H){const G=this.d.getDocument(j),ee=i.Position.to(L),re=await this.e.provideDeclaration(G,ee,H);return w(re)}}class y{constructor(j,L){this.d=j,this.e=L}async provideImplementation(j,L,H){const G=this.d.getDocument(j),ee=i.Position.to(L),re=await this.e.provideImplementation(G,ee,H);return w(re)}}class h{constructor(j,L){this.d=j,this.e=L}async provideTypeDefinition(j,L,H){const G=this.d.getDocument(j),ee=i.Position.to(L),re=await this.e.provideTypeDefinition(G,ee,H);return w(re)}}class D{static{this.f=10}constructor(j,L){this.g=j,this.h=L,this.d=0,this.e=new Map}async provideHover(j,L,H,G){const ee=this.g.getDocument(j),re=i.Position.to(L);let Oe;if(H&&H.verbosityRequest){const xe=H.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:H.verbosityRequest.action,previousHover:et};Oe=await this.h.provideHover(ee,re,G,tt)}else Oe=await this.h.provideHover(ee,re,G);if(!Oe||(0,P.$Kb)(Oe.contents))return;Oe.range||(Oe.range=ee.getWordRangeAtPosition(re)),Oe.range||(Oe.range=new c.$kM(re,re));const Be=i.Hover.from(Oe),He=this.d;if(this.e.size===D.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(He,Oe),this.d+=1,{...Be,id:He}}releaseHover(j){this.e.delete(j)}}class k{constructor(j,L){this.d=j,this.e=L}async provideEvaluatableExpression(j,L,H){const G=this.d.getDocument(j),ee=i.Position.to(L),re=await this.e.provideEvaluatableExpression(G,ee,H);if(re)return i.EvaluatableExpression.from(re)}}class C{constructor(j,L){this.d=j,this.e=L}async provideInlineValues(j,L,H,G){const ee=this.d.getDocument(j),re=await this.e.provideInlineValues(ee,i.Range.to(L),i.InlineValueContext.to(H),G);if(Array.isArray(re))return re.map(Oe=>i.InlineValue.from(Oe))}}class I{constructor(j,L){this.d=j,this.e=L}async provideDocumentHighlights(j,L,H){const G=this.d.getDocument(j),ee=i.Position.to(L),re=await this.e.provideDocumentHighlights(G,ee,H);if(Array.isArray(re))return re.map(i.DocumentHighlight.from)}}class W{constructor(j,L){this.d=j,this.e=L}async provideMultiDocumentHighlights(j,L,H,G){const ee=this.d.getDocument(j),re=H.map(He=>this.d.getDocument(He)),Oe=i.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Oe,re,G);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class V{constructor(j,L){this.d=j,this.e=L}async provideLinkedEditingRanges(j,L,H){const G=this.d.getDocument(j),ee=i.Position.to(L),re=await this.e.provideLinkedEditingRanges(G,ee,H);if(re&&Array.isArray(re.ranges))return{ranges:(0,P.$Hb)(re.ranges.map(i.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(j,L){this.d=j,this.e=L}async provideReferences(j,L,H,G){const ee=this.d.getDocument(j),re=i.Position.to(L),Oe=await this.e.provideReferences(ee,re,H,G);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class A{static{this.d=1e3}constructor(j,L,H,G,ee,re,Oe){this.g=j,this.h=L,this.j=H,this.k=G,this.l=ee,this.m=re,this.n=Oe,this.e=new t.$Mlc("CodeAction"),this.f=new Map}async provideCodeActions(j,L,H,G){const ee=this.g.getDocument(j),re=f.$zt.isISelection(L)?i.Selection.to(L):i.Range.to(L),Oe=[];for(const tt of this.j.getDiagnostics(j))if(re.intersection(tt.range)&&Oe.push(tt)>A.d)break;const Be={diagnostics:Oe,only:H.only?new c.$EM(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},He=await this.k.provideCodeActions(ee,re,Be,G);if(!(0,P.$Lb)(He)||G.isCancellationRequested)return;const _e=this.e.add(He),xe=new p.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<He.length;tt++){const it=He[tt];if(it)if(A.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(i.Diagnostic.from),edit:it.edit&&i.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.$RG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,u.$RG)(this.m,"codeActionRanges")?(0,P.$Hb)(ct.map(i.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(j,L){const[H,G]=j,ee=this.e.get(H,G);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,L)??ee;let Oe;re.edit&&(Oe=i.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const He=this.f.get(H);He&&(Be=this.h.toInternal(re.command,He))}return{edit:Oe,command:Be}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class B{constructor(j,L,H,G,ee){this.e=j,this.f=L,this.g=H,this.h=G,this.j=ee,this.d=new t.$Mlc("DocumentPasteEdit")}async prepareDocumentPaste(j,L,H,G){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(j),re=L.map(He=>i.Range.to(He)),Oe=i.DataTransfer.toDataTransfer(H,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,re,Oe,G),G.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,He])=>!(He instanceof c.$$M));return i.DataTransfer.from(Be)}async providePasteEdits(j,L,H,G,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(L),Be=H.map(et=>i.Range.to(et)),He=i.DataTransfer.toDataTransfer(G,async et=>(await this.e.$resolvePasteFileData(this.h,j,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Be,He,{only:ee.only?new c.$dN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,L){const[H,G]=j,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?i.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class K{constructor(j,L){this.d=j,this.e=L}async provideDocumentFormattingEdits(j,L,H){const G=this.d.getDocument(j),ee=await this.e.provideDocumentFormattingEdits(G,L,H);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(j,L){this.d=j,this.e=L}async provideDocumentRangeFormattingEdits(j,L,H,G){const ee=this.d.getDocument(j),re=i.Range.to(L),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,re,H,G);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,L,H,G){(0,S.$ig)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(j),re=L.map(i.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,re,H,G);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class ce{constructor(j,L){this.d=j,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,L,H,G,ee){const re=this.d.getDocument(j),Oe=i.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(re,Oe,H,G,ee);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class ve{constructor(j,L){this.e=j,this.f=L,this.d=new t.$Mlc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,L){const H=await this.e.provideWorkspaceSymbols(j,L);if(!(0,P.$Lb)(H))return{symbols:[]};const G=this.d.add(H),ee={cacheId:G,symbols:[]};for(let re=0;re<H.length;re++){const Oe=H[re];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[G,re]})}return ee}async resolveWorkspaceSymbol(j,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const H=this.d.get(...j.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,L);return G&&(0,m.$8n)(j,i.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class Se{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,L,H){this.d=j,this.e=L,this.f=H}async provideRenameEdits(j,L,H,G){const ee=this.d.getDocument(j),re=i.Position.to(L);try{const Oe=await this.e.provideRenameEdits(ee,re,H,G);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=Se.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(j,L,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(j),ee=i.Position.to(L);try{const re=await this.e.prepareRename(G,ee,H);let Oe,Be;if(c.$kM.isRange(re)?(Oe=re,Be=G.getText(re)):(0,S.$ag)(re)&&(Oe=re.range,Be=re.placeholder),!Oe||!Be)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:Be}}catch(re){const Oe=Se.g(re);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(re)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class fe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(j,L,H){this.e=j,this.f=L,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,L,H,G){const ee=this.e.getDocument(j),re=i.Range.to(L);try{const Oe=fe.d[H],Be=await this.f.provideNewSymbolNames(ee,re,Oe,G);return Be?Be.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Oe){this.g.error(fe.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class $e{constructor(j,L){this.resultId=j,this.tokens=L}}class Te{constructor(j,L){this.f=j,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,L,H){const G=this.f.getDocument(j),ee=L!==0?this.d.get(L):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,ee.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return ee&&this.d.delete(L),re?(re=Te.h(re),this.o(Te.n(ee,re),re)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return Te.j(j)?Te.k(j)?j:new c.$DN(new Uint32Array(j.data),j.resultId):Te.l(j)?Te.m(j)?j:new c.$FN(j.edits.map(L=>new c.$EN(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const L of j.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(j,L){if(!Te.j(L)||!j||!j.tokens)return L;const H=j.tokens,G=H.length,ee=L.data,re=ee.length;let Oe=0;const Be=Math.min(G,re);for(;Oe<Be&&H[Oe]===ee[Oe];)Oe++;if(Oe===G&&Oe===re)return new c.$FN([],L.resultId);let He=0;const _e=Be-Oe;for(;He<_e&&H[G-He-1]===ee[re-He-1];)He++;return new c.$FN([{start:Oe,deleteCount:G-Oe-He,data:ee.subarray(Oe,re-He)}],L.resultId)}o(j,L){if(Te.j(j)){const H=this.e++;return this.d.set(H,new $e(j.resultId,j.data)),(0,s.$xbb)({id:H,type:"full",data:j.data})}if(Te.l(j)){const H=this.e++;return Te.j(L)?this.d.set(H,new $e(L.resultId,L.data)):this.d.set(H,new $e(j.resultId)),(0,s.$xbb)({id:H,type:"delta",deltas:(j.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ae{constructor(j,L){this.d=j,this.e=L}async provideDocumentRangeSemanticTokens(j,L,H){const G=this.d.getDocument(j),ee=await this.e.provideDocumentRangeSemanticTokens(G,i.Range.to(L),H);return ee?this.f(ee):null}f(j){return(0,s.$xbb)({id:0,type:"full",data:j.data})}}class Re{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,L,H,G,ee){this.f=j,this.g=L,this.h=H,this.j=G,this.k=ee,this.d=new t.$Mlc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,L,H,G){const ee=this.f.getDocument(j),re=i.Position.to(L),Oe=ee.getWordRangeAtPosition(re)||new c.$kM(re,re),Be=Oe.with({end:re}),He=new E.$be,_e=await this.h.provideCompletionItems(ee,re,G,i.CompletionContext.to(H));if(!_e||G.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$RM(_e):_e,et=Re.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new p.$Tc;this.e.set(et,tt);const it=[],ct={x:et,b:it,a:{replace:i.Range.from(Oe),insert:i.Range.from(Be)},c:xe.isIncomplete||void 0,d:He.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const Ue=xe.items[gt],ot=this.l(Ue,[et,gt],Be,Oe);it.push(ot)}return ct}async resolveCompletionItem(j,L){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...j);if(!H)return;const G=this.l(H,j),ee=await this.h.resolveCompletionItem(H,L);if(!ee)return;const re=this.l(ee,j);return(G.h!==re.h||G.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==re.n||G.o!==re.o||!(0,m.$9n)(G.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,L,H,G){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(j.command,ee),Oe={x:L,a:j.label,b:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(i.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=j.textEdit.newText):typeof j.insertText=="string"?Oe.h=j.insertText:j.insertText instanceof c.$tM&&(Oe.h=j.insertText.value,Oe.i|=4);let Be;return j.textEdit?Be=j.textEdit.range:j.range&&(Be=j.range),c.$kM.isRange(Be)?Oe.j=i.Range.from(Be):Be&&(!H?.isEqual(Be.inserting)||!G?.isEqual(Be.replacing))&&(Oe.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Oe}}class ne{async provideInlineCompletions(j,L,H,G){}disposeCompletions(j){}handleDidShowCompletionItem(j,L,H){}handlePartialAccept(j,L,H,G){}}class z extends ne{constructor(j,L,H,G){super(),this.f=j,this.g=L,this.h=H,this.j=G,this.d=new be,this.e=(0,u.$RG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$RG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,L,H,G){const ee=this.g.getDocument(j),re=i.Position.to(L),Oe=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Oe||G.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,He=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let ct;tt.command&&(xe||(xe=new p.$Tc),ct=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:ct,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:He.map(tt=>(xe||(xe=new p.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,L,H){const G=this.d.get(j)?.items[L];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(j,L,H,G){const ee=this.d.get(j)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,H),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(G)))}}class x{async provideInlineEdits(j,L,H){const G=this.f.getDocument(j),ee=await this.g.provideInlineEdit(G,{triggerKind:this.e[L.triggerKind]},H);if(!ee||H.isCancellationRequested)return;let re;const Oe=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new p.$Tc),Be=this.h.toInternal(ee.accepted,re));let He;return ee.rejected&&(re||(re=new p.$Tc),He=this.h.toInternal(ee.rejected,re)),{pid:Oe,text:ee.text,range:i.Range.from(ee.range),accepted:Be,rejected:He}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,L,H,G){this.f=L,this.g=H,this.h=G,this.d=new be,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const L=this.e++;return this.d.set(L,j),L}disposeReferenceId(j){const L=this.d.get(j);return this.d.delete(j),L}get(j){return this.d.get(j)}}class Fe{constructor(j,L){this.e=j,this.f=L,this.d=new t.$Mlc("SignatureHelp")}async provideSignatureHelp(j,L,H,G){const ee=this.e.getDocument(j),re=i.Position.to(L),Oe=this.g(H),Be=await this.f.provideSignatureHelp(ee,re,G,Oe);if(Be){const He=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:He}}}g(j){let L;if(j.activeSignatureHelp){const H=i.SignatureHelp.to(j.activeSignatureHelp),G=this.d.get(j.activeSignatureHelp.id,0);G?(L=G,L.activeSignature=H.activeSignature,L.activeParameter=H.activeParameter):L=H}return{...j,activeSignatureHelp:L}}releaseSignatureHelp(j){this.d.delete(j)}}class De{constructor(j,L,H,G,ee){this.f=j,this.g=L,this.h=H,this.j=G,this.k=ee,this.d=new t.$Mlc("InlayHints"),this.e=new Map}async provideInlayHints(j,L,H){const G=this.f.getDocument(j),ee=i.Range.to(L),re=await this.h.provideInlayHints(G,ee,H);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(H.isCancellationRequested)return;const Oe=this.d.add(re);this.e.set(Oe,new p.$Tc);const Be={hints:[],cacheId:Oe};for(let He=0;He<re.length;He++)this.l(re[He],ee)&&Be.hints.push(this.m(re[He],[Oe,He]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(j,L){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...j);if(!H)return;const G=await this.h.resolveInlayHint(H,L);if(G&&this.l(G))return this.m(G,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,L){return j.label.length===0||Array.isArray(j.label)&&j.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(L&&!L.contains(j.position))}m(j,L){const H=this.e.get(L[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:L,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")G.label=j.label;else{const ee=[];G.label=ee;for(const re of j.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:re.value,tooltip:i.MarkdownString.fromStrict(re.tooltip)};c.$uM.isLocation(re.location)&&(Oe.location=i.location.from(re.location)),re.command&&(Oe.command=this.g.toInternal(re.command,H)),ee.push(Oe)}}return G}}class pe{constructor(j,L){this.e=j,this.f=L,this.d=new t.$Mlc("DocumentLink")}async provideLinks(j,L){const H=this.e.getDocument(j),G=await this.f.provideDocumentLinks(H,L);if(!(!Array.isArray(G)||G.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(pe.g).map(i.DocumentLink.from)};{const ee=this.d.add(G),re={links:[],cacheId:ee};for(let Oe=0;Oe<G.length;Oe++){if(!pe.g(G[Oe]))continue;const Be=i.DocumentLink.from(G[Oe]);Be.cacheId=[ee,Oe],re.links.push(Be)}return re}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,L){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...j);if(!H)return;const G=await this.f.resolveDocumentLink(H,L);if(!(!G||!pe.g(G)))return i.DocumentLink.from(G)}releaseLinks(j){this.d.delete(j)}}class ge{constructor(j,L){this.d=j,this.e=L}async provideColors(j,L){const H=this.d.getDocument(j),G=await this.e.provideDocumentColors(H,L);return Array.isArray(G)?G.map(re=>({color:i.Color.from(re.color),range:i.Range.from(re.range)})):[]}async provideColorPresentations(j,L,H){const G=this.d.getDocument(j),ee=i.Range.to(L.range),re=i.Color.to(L.color),Oe=await this.e.provideColorPresentations(re,{document:G,range:ee},H);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class Q{constructor(j,L){this.d=j,this.e=L}async provideFoldingRanges(j,L,H){const G=this.d.getDocument(j),ee=await this.e.provideFoldingRanges(G,L,H);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(j,L,H){this.d=j,this.e=L,this.f=H}async provideSelectionRanges(j,L,H){const G=this.d.getDocument(j),ee=L.map(i.Position.to),re=await this.e.provideSelectionRanges(G,ee,H);if(!(0,P.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<ee.length;Be++){const He=[];Oe.push(He);let _e=ee[Be],xe=re[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(i.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Oe}}class he{constructor(j,L){this.f=j,this.g=L,this.d=new R.$OO(""),this.e=new Map}async prepareSession(j,L,H){const G=this.f.getDocument(j),ee=i.Position.to(L),re=await this.g.prepareCallHierarchy(G,ee,H);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Be=>this.h(Oe,Be)):[this.h(Oe,re)]}async provideCallsTo(j,L,H){const G=this.j(j,L);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(G,H);if(ee)return ee.map(re=>({from:this.h(j,re.from),fromRanges:re.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(j,L,H){const G=this.j(j,L);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(ee)return ee.map(re=>({to:this.h(j,re.to),fromRanges:re.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(j){this.e.delete(j)}h(j,L){const H=this.e.get(j),G=i.CallHierarchyItem.from(L,j,H.size.toString(36));return H.set(G._itemId,L),G}j(j,L){return this.e.get(j)?.get(L)}}class ue{constructor(j,L){this.f=j,this.g=L,this.d=new R.$OO(""),this.e=new Map}async prepareSession(j,L,H){const G=this.f.getDocument(j),ee=i.Position.to(L),re=await this.g.prepareTypeHierarchy(G,ee,H);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Be=>this.h(Oe,Be)):[this.h(Oe,re)]}async provideSupertypes(j,L,H){const G=this.j(j,L);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(G,H);if(ee)return ee.map(re=>this.h(j,re))}async provideSubtypes(j,L,H){const G=this.j(j,L);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(G,H);if(ee)return ee.map(re=>this.h(j,re))}releaseSession(j){this.e.delete(j)}h(j,L){const H=this.e.get(j),G=i.TypeHierarchyItem.from(L,j,H.size.toString(36));return H.set(G._itemId,L),G}j(j,L){return this.e.get(j)?.get(L)}}class Ne{constructor(j,L,H,G,ee){this.e=j,this.f=L,this.g=H,this.h=G,this.j=ee,this.d=new t.$Mlc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,L,H,G,ee){const re=this.f.getDocument(L),Oe=i.Position.to(H),Be=i.DataTransfer.toDataTransfer(G,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,et)).buffer),He=await this.g.provideDocumentDropEdits(re,Oe,Be,ee);if(!He)return;const _e=(0,P.$2b)(He),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,L){const[H,G]=j,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?i.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class de{constructor(j,L){this.d=j,this.e=L}async provideMappedEdits(j,L,H,G){const ee=l.URI.revive(j),re=this.d.getDocument(ee),Oe=H.documents.map(_e=>_e.map(xe=>({uri:l.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>i.Range.to(et))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(re,L,Be,G);return He?i.WorkspaceEdit.from(He):null}}class Ce{constructor(j,L){this.adapter=j,this.extension=L}}class Me{static{this.d=0}constructor(j,L,H,G,ee,re,Oe,Be){this.g=L,this.h=H,this.j=G,this.k=ee,this.l=re,this.m=Oe,this.n=Be,this.f=new Map,this.e=j.getProxy(g.$gM.MainThreadLanguageFeatures)}o(j,L){return i.DocumentSelector.from(j,this.g,L)}p(j){return new c.$iM(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Me.d++}async s(j,L,H,G,ee,re=!1){const Oe=this.f.get(j);if(!Oe||!(Oe.adapter instanceof L))return G;const Be=Date.now();re||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const He=H(Oe.adapter,Oe.extension);return Promise.resolve(He).catch(_e=>{(0,N.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),M.CancellationToken.isCancellationToken(ee)?(0,O.$nh)(He,ee):He}t(j,L){const H=this.q();return this.f.set(H,new Ce(j,L)),H}static u(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,L,H,G){const ee=this.t(new a(this.h,H),j),re=G&&G.label||Me.u(j);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,j),re),this.p(ee)}$provideDocumentSymbols(j,L,H){return this.s(j,a,G=>G.provideDocumentSymbols(l.URI.revive(L),H),void 0,H)}registerCodeLensProvider(j,L,H){const G=this.q(),ee=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new Ce(new d(this.h,this.j.converter,H,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(G,this.o(L,j),ee);let re=this.p(G);if(ee!==void 0){const Oe=H.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$iM.from(re,Oe)}return re}$provideCodeLenses(j,L,H){return this.s(j,d,G=>G.provideCodeLenses(l.URI.revive(L),H),void 0,H)}$resolveCodeLens(j,L,H){return this.s(j,d,G=>G.resolveCodeLens(L,H),void 0,void 0)}$releaseCodeLenses(j,L){this.s(j,d,H=>Promise.resolve(H.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(j,L,H){const G=this.t(new $(this.h,H),j);return this.e.$registerDefinitionSupport(G,this.o(L,j)),this.p(G)}$provideDefinition(j,L,H,G){return this.s(j,$,ee=>ee.provideDefinition(l.URI.revive(L),H,G),[],G)}registerDeclarationProvider(j,L,H){const G=this.t(new v(this.h,H),j);return this.e.$registerDeclarationSupport(G,this.o(L,j)),this.p(G)}$provideDeclaration(j,L,H,G){return this.s(j,v,ee=>ee.provideDeclaration(l.URI.revive(L),H,G),[],G)}registerImplementationProvider(j,L,H){const G=this.t(new y(this.h,H),j);return this.e.$registerImplementationSupport(G,this.o(L,j)),this.p(G)}$provideImplementation(j,L,H,G){return this.s(j,y,ee=>ee.provideImplementation(l.URI.revive(L),H,G),[],G)}registerTypeDefinitionProvider(j,L,H){const G=this.t(new h(this.h,H),j);return this.e.$registerTypeDefinitionSupport(G,this.o(L,j)),this.p(G)}$provideTypeDefinition(j,L,H,G){return this.s(j,h,ee=>ee.provideTypeDefinition(l.URI.revive(L),H,G),[],G)}registerHoverProvider(j,L,H,G){const ee=this.t(new D(this.h,H),j);return this.e.$registerHoverProvider(ee,this.o(L,j)),this.p(ee)}$provideHover(j,L,H,G,ee){return this.s(j,D,re=>re.provideHover(l.URI.revive(L),H,G,ee),void 0,ee)}$releaseHover(j,L){this.s(j,D,H=>Promise.resolve(H.releaseHover(L)),void 0,void 0)}registerEvaluatableExpressionProvider(j,L,H,G){const ee=this.t(new k(this.h,H),j);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,j)),this.p(ee)}$provideEvaluatableExpression(j,L,H,G){return this.s(j,k,ee=>ee.provideEvaluatableExpression(l.URI.revive(L),H,G),void 0,G)}registerInlineValuesProvider(j,L,H,G){const ee=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new C(this.h,H),j);this.e.$registerInlineValuesProvider(re,this.o(L,j),ee);let Oe=this.p(re);if(ee!==void 0){const Be=H.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ee));Oe=c.$iM.from(Oe,Be)}return Oe}$provideInlineValues(j,L,H,G,ee){return this.s(j,C,re=>re.provideInlineValues(l.URI.revive(L),H,G,ee),void 0,ee)}registerDocumentHighlightProvider(j,L,H){const G=this.t(new I(this.h,H),j);return this.e.$registerDocumentHighlightProvider(G,this.o(L,j)),this.p(G)}registerMultiDocumentHighlightProvider(j,L,H){const G=this.t(new W(this.h,H),j);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(L,j)),this.p(G)}$provideDocumentHighlights(j,L,H,G){return this.s(j,I,ee=>ee.provideDocumentHighlights(l.URI.revive(L),H,G),void 0,G)}$provideMultiDocumentHighlights(j,L,H,G,ee){return this.s(j,W,re=>re.provideMultiDocumentHighlights(l.URI.revive(L),H,G.map(Oe=>l.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(j,L,H){const G=this.t(new V(this.h,H),j);return this.e.$registerLinkedEditingRangeProvider(G,this.o(L,j)),this.p(G)}$provideLinkedEditingRanges(j,L,H,G){return this.s(j,V,async ee=>{const re=await ee.provideLinkedEditingRanges(l.URI.revive(L),H,G);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Me.w(re.wordPattern):void 0}},void 0,G)}registerReferenceProvider(j,L,H){const G=this.t(new q(this.h,H),j);return this.e.$registerReferenceSupport(G,this.o(L,j)),this.p(G)}$provideReferences(j,L,H,G,ee){return this.s(j,q,re=>re.provideReferences(l.URI.revive(L),H,G,ee),void 0,ee)}registerCodeActionProvider(j,L,H,G){const ee=new p.$Tc,re=this.t(new A(this.h,this.j.converter,this.k,H,this.l,j,this.m),j);return this.e.$registerQuickFixSupport(re,this.o(L,j),{providedKinds:G?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:G?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Me.u(j),!!H.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(j,L,H,G,ee){return this.s(j,A,re=>re.provideCodeActions(l.URI.revive(L),H,G,ee),void 0,ee)}$resolveCodeAction(j,L,H){return this.s(j,A,G=>G.resolveCodeAction(L,H),{},void 0)}$releaseCodeActions(j,L){this.s(j,A,H=>Promise.resolve(H.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(j,L,H){const G=this.t(new K(this.h,H),j);return this.e.$registerDocumentFormattingSupport(G,this.o(L,j),j.identifier,j.displayName||j.name),this.p(G)}$provideDocumentFormattingEdits(j,L,H,G){return this.s(j,K,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(L),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(j,L,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,H),j);return this.e.$registerRangeFormattingSupport(ee,this.o(L,j),j.identifier,j.displayName||j.name,G),this.p(ee)}$provideDocumentRangeFormattingEdits(j,L,H,G,ee){return this.s(j,ie,re=>re.provideDocumentRangeFormattingEdits(l.URI.revive(L),H,G,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(j,L,H,G,ee){return this.s(j,ie,re=>re.provideDocumentRangesFormattingEdits(l.URI.revive(L),H,G,ee),void 0,ee)}registerOnTypeFormattingEditProvider(j,L,H,G){const ee=this.t(new ce(this.h,H),j);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,j),G,j.identifier),this.p(ee)}$provideOnTypeFormattingEdits(j,L,H,G,ee,re){return this.s(j,ce,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(L),H,G,ee,re),void 0,re)}registerWorkspaceSymbolProvider(j,L){const H=this.t(new ve(L,this.l),j);return this.e.$registerNavigateTypeSupport(H,typeof L.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(j,L,H){return this.s(j,ve,G=>G.provideWorkspaceSymbols(L,H),{symbols:[]},H)}$resolveWorkspaceSymbol(j,L,H){return this.s(j,ve,G=>G.resolveWorkspaceSymbol(L,H),void 0,void 0)}$releaseWorkspaceSymbols(j,L){this.s(j,ve,H=>H.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(j,L,H){const G=this.t(new Se(this.h,H,this.l),j);return this.e.$registerRenameSupport(G,this.o(L,j),Se.supportsResolving(H)),this.p(G)}$provideRenameEdits(j,L,H,G,ee){return this.s(j,Se,re=>re.provideRenameEdits(l.URI.revive(L),H,G,ee),void 0,ee)}$resolveRenameLocation(j,L,H,G){return this.s(j,Se,ee=>ee.resolveRenameLocation(l.URI.revive(L),H,G),void 0,G)}registerNewSymbolNamesProvider(j,L,H){const G=this.t(new fe(this.h,H,this.l),j);return this.e.$registerNewSymbolNamesProvider(G,this.o(L,j)),this.p(G)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,fe,L=>L.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,L,H,G,ee){return this.s(j,fe,re=>re.provideNewSymbolNames(l.URI.revive(L),H,G,ee),void 0,ee)}registerDocumentSemanticTokensProvider(j,L,H,G){const ee=this.t(new Te(this.h,H),j),re=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,j),G,re);let Oe=this.p(ee);if(re){const Be=H.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(re));Oe=c.$iM.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(j,L,H,G){return this.s(j,Te,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(L),H,G),null,G)}$releaseDocumentSemanticTokens(j,L){this.s(j,Te,H=>H.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,L,H,G){const ee=this.t(new ae(this.h,H),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,j),G),this.p(ee)}$provideDocumentRangeSemanticTokens(j,L,H,G){return this.s(j,ae,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(L),H,G),null,G)}registerCompletionItemProvider(j,L,H,G){const ee=this.t(new Re(this.h,this.j.converter,H,this.m,j),j);return this.e.$registerCompletionsProvider(ee,this.o(L,j),G,Re.supportsResolving(H),j.identifier),this.p(ee)}$provideCompletionItems(j,L,H,G,ee){return this.s(j,Re,re=>re.provideCompletionItems(l.URI.revive(L),H,G,ee),void 0,ee)}$resolveCompletionItem(j,L,H){return this.s(j,Re,G=>G.resolveCompletionItem(L,H),void 0,H)}$releaseCompletionItems(j,L){this.s(j,Re,H=>H.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(j,L,H,G){const ee=new z(j,this.h,H,this.j.converter),re=this.t(ee,j);return this.e.$registerInlineCompletionsSupport(re,this.o(L,j),ee.supportsHandleEvents,n.$Tm.toKey(j.identifier.value),G?.yieldTo?.map(Oe=>n.$Tm.toKey(Oe))||[]),this.p(re)}$provideInlineCompletions(j,L,H,G,ee){return this.s(j,ne,re=>re.provideInlineCompletions(l.URI.revive(L),H,G,ee),void 0,ee)}$handleInlineCompletionDidShow(j,L,H,G){this.s(j,ne,async ee=>{ee.handleDidShowCompletionItem(L,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,L,H,G,ee){this.s(j,ne,async re=>{re.handlePartialAccept(L,H,G,ee)},void 0,void 0)}$freeInlineCompletionsList(j,L){this.s(j,ne,async H=>{H.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(j,L,H){const G=new x(j,this.h,H,this.j.converter),ee=this.t(G,j);return this.e.$registerInlineEditProvider(ee,this.o(L,j),j.identifier),this.p(ee)}$provideInlineEdit(j,L,H,G){return this.s(j,x,ee=>ee.provideInlineEdits(l.URI.revive(L),H,G),void 0,G)}$freeInlineEdit(j,L){this.s(j,x,async H=>{H.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(j,L,H,G){const ee=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,re=this.t(new Fe(this.h,H),j);return this.e.$registerSignatureHelpProvider(re,this.o(L,j),ee),this.p(re)}$provideSignatureHelp(j,L,H,G,ee){return this.s(j,Fe,re=>re.provideSignatureHelp(l.URI.revive(L),H,G,ee),void 0,ee)}$releaseSignatureHelp(j,L){this.s(j,Fe,H=>H.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(j,L,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new De(this.h,this.j.converter,H,this.l,j),j);this.e.$registerInlayHintsProvider(ee,this.o(L,j),typeof H.resolveInlayHint=="function",G,Me.u(j));let re=this.p(ee);if(G!==void 0){const Oe=H.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(G));re=c.$iM.from(re,Oe)}return re}$provideInlayHints(j,L,H,G){return this.s(j,De,ee=>ee.provideInlayHints(l.URI.revive(L),H,G),void 0,G)}$resolveInlayHint(j,L,H){return this.s(j,De,G=>G.resolveInlayHint(L,H),void 0,H)}$releaseInlayHints(j,L){this.s(j,De,H=>H.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(j,L,H){const G=this.t(new pe(this.h,H),j);return this.e.$registerDocumentLinkProvider(G,this.o(L,j),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(j,L,H){return this.s(j,pe,G=>G.provideLinks(l.URI.revive(L),H),void 0,H,L.scheme==="output")}$resolveDocumentLink(j,L,H){return this.s(j,pe,G=>G.resolveLink(L,H),void 0,void 0,!0)}$releaseDocumentLinks(j,L){this.s(j,pe,H=>H.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(j,L,H){const G=this.t(new ge(this.h,H),j);return this.e.$registerDocumentColorProvider(G,this.o(L,j)),this.p(G)}$provideDocumentColors(j,L,H){return this.s(j,ge,G=>G.provideColors(l.URI.revive(L),H),[],H)}$provideColorPresentations(j,L,H,G){return this.s(j,ge,ee=>ee.provideColorPresentations(l.URI.revive(L),H,G),void 0,G)}registerFoldingRangeProvider(j,L,H){const G=this.q(),ee=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new Ce(new Q(this.h,H),j)),this.e.$registerFoldingRangeProvider(G,this.o(L,j),j.identifier,ee);let re=this.p(G);if(ee!==void 0){const Oe=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$iM.from(re,Oe)}return re}$provideFoldingRanges(j,L,H,G){return this.s(j,Q,ee=>ee.provideFoldingRanges(l.URI.revive(L),H,G),void 0,G)}registerSelectionRangeProvider(j,L,H){const G=this.t(new Y(this.h,H,this.l),j);return this.e.$registerSelectionRangeProvider(G,this.o(L,j)),this.p(G)}$provideSelectionRanges(j,L,H,G){return this.s(j,Y,ee=>ee.provideSelectionRanges(l.URI.revive(L),H,G),[],G)}registerCallHierarchyProvider(j,L,H){const G=this.t(new he(this.h,H),j);return this.e.$registerCallHierarchyProvider(G,this.o(L,j)),this.p(G)}$prepareCallHierarchy(j,L,H,G){return this.s(j,he,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(j,L,H,G){return this.s(j,he,ee=>ee.provideCallsTo(L,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(j,L,H,G){return this.s(j,he,ee=>ee.provideCallsFrom(L,H,G),void 0,G)}$releaseCallHierarchy(j,L){this.s(j,he,H=>Promise.resolve(H.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(j,L,H){const G=this.t(new ue(this.h,H),j);return this.e.$registerTypeHierarchyProvider(G,this.o(L,j)),this.p(G)}$prepareTypeHierarchy(j,L,H,G){return this.s(j,ue,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),H,G)),void 0,G)}$provideTypeHierarchySupertypes(j,L,H,G){return this.s(j,ue,ee=>ee.provideSupertypes(L,H,G),void 0,G)}$provideTypeHierarchySubtypes(j,L,H,G){return this.s(j,ue,ee=>ee.provideSubtypes(L,H,G),void 0,G)}$releaseTypeHierarchy(j,L){this.s(j,ue,H=>Promise.resolve(H.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(j,L,H,G){const ee=this.q();return this.f.set(ee,new Ce(new Ne(this.e,this.h,H,ee,j),j)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,j),(0,u.$RG)(j,"documentPaste")&&G?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(j,L,H,G,ee,re){return this.s(j,Ne,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(L,l.URI.revive(H),G,ee,re)),void 0,void 0)}$resolveDropEdit(j,L,H){return this.s(j,Ne,G=>G.resolveDropEdit(L,H),{},void 0)}$releaseDropEdits(j,L){this.s(j,Ne,H=>Promise.resolve(H.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(j,L,H){const G=this.t(new de(this.h,H),j);return this.e.$registerMappedEditsProvider(G,this.o(L,j)),this.p(G)}$provideMappedEdits(j,L,H,G,ee){return this.s(j,de,re=>Promise.resolve(re.provideMappedEdits(L,H,G,ee)),null,ee)}registerDocumentPasteEditProvider(j,L,H,G){const ee=this.q();return this.f.set(ee,new Ce(new B(this.e,this.h,H,ee,j),j)),this.e.$registerPasteEditProvider(ee,this.o(L,j),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(j,L,H,G,ee){return this.s(j,B,re=>re.prepareDocumentPaste(l.URI.revive(L),H,G,ee),void 0,ee)}$providePasteEdits(j,L,H,G,ee,re,Oe){return this.s(j,B,Be=>Be.providePasteEdits(L,l.URI.revive(H),G,ee,re,Oe),void 0,Oe)}$resolvePasteEdit(j,L,H){return this.s(j,B,G=>G.resolvePasteEdit(L,H),{},void 0)}$releasePasteEdits(j,L){this.s(j,B,H=>Promise.resolve(H.releasePasteEdits(L)),void 0,void 0)}static w(j){return{pattern:j.source,flags:j.flags}}static y(j){return{decreaseIndentPattern:Me.w(j.decreaseIndentPattern),increaseIndentPattern:Me.w(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Me.w(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Me.w(j.unIndentedLinePattern):void 0}}static z(j){return{beforeText:Me.w(j.beforeText),afterText:j.afterText?Me.w(j.afterText):void 0,previousLineText:j.previousLineText?Me.w(j.previousLineText):void 0,action:j.action}}static B(j){return j.map(Me.z)}static C(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(L=>c.SyntaxTokenType.toString(L)):void 0}}static D(j){return j.map(Me.C)}setLanguageConfiguration(j,L,H){const{wordPattern:G}=H;if(G&&(0,T.$lf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(L,G):this.h.setWordDefinitionFor(L,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ee=this.q(),re={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Me.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Me.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Me.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Me.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,re),this.p(ee)}$setWordDefinitions(j){for(const L of j)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$Wlc=Me}),define(ke[90],Ie([1,0,6,4,8,7,103,21,11,5,175,108,14,3,17,86,12,42,25]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=void 0,e.$Dmc=(0,b.$yi)("IExtHostLanguageModels");class c{constructor(a,d){this.option=a,this.stream=new m.$2h,this.stream=d??new m.$2h}}class u{constructor(){this.a=new Map,this.b=new m.$2h,this.c=!1,this.d=!1;const a=this;this.apiObject={stream:a.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,a]of this.a)yield a.stream;else yield this.b}handleFragment(a){if(this.c)return;this.d=!0;let d=this.a.get(a.index);d||(this.a.size===0?d=new c(a.index,this.b):d=new c(a.index),this.a.set(a.index,d)),d.stream.emitOne(a.part)}get isStreaming(){return this.d}reject(a){this.c=!0;for(const d of this.f())d.reject(a)}resolve(){this.c=!0;for(const a of this.f())a.resolve()}}let t=class{static{i=this}static{this.a=1}constructor(a,d,w){this.j=d,this.k=w,this.c=new E.$fe,this.d=new E.$fe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Vm,this.i=new Map,this.p=new Set,this.b=a.getProxy(O.$gM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(a,d,w,$){const v=i.a++;this.f.set(v,{extension:a.identifier,provider:w,languageModelId:d});let y;$.auth&&(y={providerLabel:a.displayName||a.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,d,{extension:a.identifier,identifier:d,name:$.name??"",version:$.version,tokens:$.tokens,auth:y});const h=w.onDidReceiveLanguageModelResponse2?.(({extensionId:D,participant:k,tokenCount:C})=>{this.b.$whenLanguageModelChatRequestMade(d,new p.$Tm(D),k,C)});return(0,P.$Sc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v),h?.dispose()})}async $provideLanguageModelResponse(a,d,w,$,v,y){const h=this.f.get(a);if(!h)return;const D=new R.$gw(async k=>{if(y.isCancellationRequested){this.j.warn(`[CHAT](${h.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(d,{index:k.index,part:k.part})});return h.provider.provideLanguageModelResponse($.map(M.LanguageModelChatMessage.to),v,p.$Tm.toKey(w),D,y)}$provideTokenLength(a,d,w){const $=this.f.get(a);return $?Promise.resolve($.provider.provideTokenCount(d,w)):Promise.resolve(0)}$updateLanguageModels(a){const d=[],w=[];if(a.added)for(const $ of a.added)this.g.set($.identifier,$),d.push($.identifier);if(a.removed)for(const $ of a.removed){this.g.delete($),w.push($);for(const[v,y]of this.i)y.languageModelId===$&&(y.res.reject(new l.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(d),removed:Object.freeze(w)})),a.added?.forEach(this.o,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(a){const d=new Array;for(const{from:w,to:$,enabled:v}of a){const y=this.h.get(w)??new p.$Um;if(y.has($)!==v){v?y.add($):y.delete($),this.h.set(w,y);const D={from:w,to:$};d.push(D),this.c.fire(D)}}}async sendChatRequest(a,d,w,$,v){const y=this.l(a,w),h=a.identifier,D=await this.b.$prepareChatAccess(h,d,$.justification);if(!D||!this.g.has(d))throw N.$wO.NotFound(`Language model '${d}' is unknown.`);if(this.n(h,D)&&(!await this.m(a,{identifier:D.extension,displayName:D.auth.providerLabel},$.justification,!1)||!this.h.get(h)?.has(D.extension)))throw N.$wO.NoPermissions(`Language model '${d}' cannot be used by '${h.value}'.`);const k=Math.random()*1e6|0,C=this.b.$fetchResponse(h,d,k,y,$.modelOptions??{},v),I=new m.$xh,W=new u;this.i.set(k,{languageModelId:d,res:W});let V;if(C.catch(q=>{I.isOpen()?W.reject(q):V=q}).finally(()=>{this.i.delete(k),W.resolve(),I.open()}),await I.wait(),V)throw V.name===N.$wO.name?V:new N.$wO(`Language model '${d}' errored, check cause for more details`,"Unknown",V);return W.apiObject}l(a,d){const w=[];for(const $ of d)$ instanceof N.$sO?($.role===N.LanguageModelChatMessageRole.System&&(0,n.$SG)(a,"languageModelSystem"),w.push(M.LanguageModelChatMessage.from($))):($ instanceof N.$tO&&(0,n.$SG)(a,"languageModelSystem"),w.push(M.LanguageModelChatMessage.from($)));return w}async $handleResponseFragment(a,d){const w=this.i.get(a);w&&w.res.handleFragment(d)}async m(a,d,w,$){const v=S.$iL+d.identifier.value;if(await this.k.getSession(a,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:a.identifier,to:d.identifier,enabled:!0}]),!0;if($)return!1;try{const h=w?(0,T.localize)(0,null,d.displayName,w):(0,T.localize)(1,null,d.displayName);return await this.k.getSession(a,v,[],{forceNewSession:{detail:h}}),this.$updateModelAccesslist([{from:a.identifier,to:d.identifier,enabled:!0}]),!0}catch{return!1}}n(a,d){return!!d.auth&&!p.$Tm.equals(d.extension,a)}async o(a){for(const d of this.p)try{await this.m(d,{identifier:a.extension,displayName:""},void 0,!0)}catch(w){this.j.error("Fake Auth request failed"),this.j.error(w)}}async computeTokenLength(a,d,w){const $=this.g.get(a);if(!$)throw N.$wO.NotFound(`Language model '${a}' is unknown.`);const v=o.Iterable.find(this.f.values(),y=>y.languageModelId===a);return v?v.provider.provideTokenCount(d,w):this.b.$countTokens($.identifier,typeof d=="string"?d:M.LanguageModelChatMessage.from(d),w)}getLanguageModelInfo(a){const d=this.g.get(a);if(d)return Object.freeze({id:d.identifier,name:d.name,version:d.version,contextLength:d.tokens})}createLanguageModelAccessInformation(a){this.p.add(a);const d=this,w=E.Event.signal(E.Event.filter(this.c.event,v=>p.$Tm.equals(v.from,a.identifier))),$=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(w,$)},canSendRequest(v){const y=d.g.get(v);if(!y)return;if(!d.n(a.identifier,y))return!0;const h=d.h.get(a.identifier);if(h)return h.has(y.extension)}}}};e.$Emc=t,e.$Emc=t=i=Je([We(0,f.$JO),We(1,s.$5j),We(2,r.$Ylc)],t)}),define(ke[275],Ie([1,0,4,8,7,32,11,6,25]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;class E{constructor(S,l,b,f){this.c=l,this.d=b,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(P.$gM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const b=this.c.getDocumentData(S);if(!b)throw new Error(`document '${S.toString()}' NOT found`);return b.document}async tokenAtPosition(S,l){const b=S.version,f=O.Position.from(l),r=await this.a.$tokensAtPosition(S.uri,f),s={type:M.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new M.$kM(l.line,l.character,l.line,l.character)};if(!r)return s;const o={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!o.range.contains(l)||b!==S.version?s:o}createLanguageStatusItem(S,l,b){const f=this.f++,r=this.a,s=this.g,o=`${S.identifier.value}/${l}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(o);const n={selector:b,id:l,name:S.displayName??S.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const c=new p.$Tc,u=()=>{if(i?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Ah)(()=>{c.clear(),this.a.$setLanguageStatus(f,{id:o,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?N.default.Error:n.severity===M.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),i?.dispose(),r.$removeLanguageStatus(f),s.delete(o)},get id(){return n.id},get name(){return n.name},set name(g){n.name=g,u()},get selector(){return n.selector},set selector(g){n.selector=g,u()},get text(){return n.text},set text(g){n.text=g,u()},set text2(g){(0,m.$SG)(S,"languageStatusText"),n.text=g,u()},get text2(){return(0,m.$SG)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(g){n.detail=g,u()},get severity(){return n.severity},set severity(g){n.severity=g,u()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(g){n.accessibilityInformation=g,u()},get command(){return n.command},set command(g){n.command=g,u()},get busy(){return n.busy},set busy(g){n.busy=g,u()}};return u(),t}}e.$jnc=E}),define(ke[276],Ie([1,0,16,2,8,7,85]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=e.$8mc=void 0;class p{constructor(S,l,b,f){this.start=S,this.deletedCount=l,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new N.$KN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,l,b){this.notebook=S,this.h=l,this.j=b,this.handle=b.handle,this.uri=O.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(M.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(f){S.g=f},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(b)}return this.f}setOutputs(S){this.a=S.map(M.NotebookCellOutput.to)}setOutputItems(S,l,b){const f=b.map(M.NotebookCellOutputItem.to),r=this.a.find(s=>s.id===S);if(r&&(l||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(s=>R.$cK(s.mime)))){const s=new Map,o=[];r.items.forEach(n=>{let i;s.has(n.mime)?i=s.get(n.mime):(i=[],s.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),r.items.length=0,o.forEach(n=>{const i=R.$dK(s.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$8mc=m;class E{static{this.a=0}constructor(S,l,b,f,r){this.k=S,this.l=l,this.m=b,this.uri=f,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===P.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(b){return b=S.n(b),S.b[b].apiCell},getCells(b){return(b?S.p(b):S.b).map(r=>r.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,b){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const o of S.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,f.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,f.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),r.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),r.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<r.length;o++){const n=r[o],i=s.get(n.cell);if(i===void 0){const c=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});s.set(n.cell,c-1)}else f.cellChanges[i]={...f.cellChanges[i],...n}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,b=S.end|0;return l<0&&(l=0),b>this.b.length&&(b=this.b.length),S.with({start:l,end:b})}p(S){S=this.o(S);const l=[];for(let b=S.start;b<S.end;b++)l.push(this.b[b]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,b){if(this.j)return;const f=[],r=[],s=[];if(S.reverse().forEach(o=>{const i=o[2].map(t=>{const g=new m(this,this.l,t);return l||r.push(m.asModelAddData(t)),g}),c=new p(o[0],o[1],[],i),u=this.b.splice(o[0],o[1],...i);for(const t of u)s.push(t.uri),c.deletedItems.push(t.apiCell);f.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),b)for(const o of f)b.push(o.asApiEvent())}s(S,l,b,f){const r=this.b.splice(S,l);this.b.splice(b,0,...r);const s=[new p(S,l,r.map(o=>o.apiCell),[]),new p(b,0,[],r)];for(const o of s)f.push(o.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,b,f){this.b[S].setOutputItems(l,b,f)}v(S,l){const b=this.b[S];b.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(b.uri,l)}w(S,l){const b=this.b[S];b.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$9mc=E}),define(ke[277],Ie([1,0,5,2,8,7,34]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class p{constructor(E,T,S,l={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=S,this.f=l,this.a=new P.$he}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,S,l)=>{const b=function(r){T.call(S,r)};return b.extension=E,this.a.event(b,void 0,l)}}async $participateInSave(E,T,S){const l=O.URI.revive(E),b=this.c.getNotebookDocument(l);if(!b)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:M.TextDocumentSaveReason.to(T)},S,async(s,o)=>{const n=Date.now(),i=await await Promise.resolve(s);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!S.isCancellationRequested&&i&&(i instanceof N.$sM?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(f.length===0)return!0;const r={edits:[]};for(const s of f){const{edits:o}=M.WorkspaceEdit.from(s);r.edits=r.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new R.$Ew(r))}}e.$lnc=p}),define(ke[114],Ie([1,0,14,8,7]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,m,E,T,S,l){this.id=p,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=T,this.c=l}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(m){this.selections=[m]},get selections(){return p.a},set selections(m){if(!Array.isArray(m)||!m.every(M.$KN.isNotebookRange))throw(0,P.$7)("selections");p.a=m,p.g(m)},get visibleRanges(){return p.b},revealRange(m,E){p.f.$tryRevealRange(p.id,O.NotebookRange.from(m),E??M.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(O.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$0mc=N}),define(ke[278],Ie([1,0,5,12,8]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;let N=class{constructor(p,m){this.c=p,this.d=m,this.a=new P.$fe,this.b=new P.$fe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,m);const E=this.d.getEditorById(p);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const m in p)this.d.getEditorById(m)._acceptViewColumn(M.ViewColumn.to(p[m]))}};e.$nnc=N,e.$nnc=N=Je([We(0,O.$5j)],N)}),define(ke[279],Ie([1,0,5,4,114]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;class N{constructor(p,m){this.c=m,this.a=new Map,this.b=p.getProxy(O.$gM.MainThreadNotebookRenderers)}$postRendererMessage(p,m,E){const T=this.c.getEditorById(p);this.a.get(m)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(p,m){if(!p.contributes?.notebookRenderer?.some(T=>T.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(T,S,l)=>this.d(m).event(T,S,l),postMessage:(T,S)=>{M.$0mc.apiEditorsToExtHost.has(T)&&([T,S]=[S,T]);const l=S&&M.$0mc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,m,T)}}}d(p){let m=this.a.get(p);return m||(m=new P.$fe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(p)}}),this.a.set(p,m),m)}}e.$qnc=N}),define(ke[280],Ie([1,0,8,103,20,69,14]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class p{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,l,b){const f=this.b++,{title:r,location:s,cancellable:o}=l,n={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(f,{location:P.ProgressLocation.from(s),title:r,source:n,cancellable:o},S.isUnderDevelopment?void 0:S.identifier.value).catch(R.$2),this.d(f,b,!!o)}d(S,l,b){let f;b&&(f=new M.$qe,this.c.set(S,f));const r=o=>{this.a.$progressEnd(o),this.c.delete(o),f?.dispose()};let s;try{s=l(new E(this.a,S),b&&f?f.token:M.CancellationToken.None)}catch(o){throw r(S),o}return s.then(o=>r(S),o=>r(S)),s}$acceptProgressCanceled(S){const l=this.c.get(S);l&&(l.cancel(),this.c.delete(S))}}e.$unc=p;function m(T,S){return T.message=S.message,typeof S.increment=="number"&&(typeof T.increment=="number"?T.increment+=S.increment:T.increment=S.increment),T}class E extends O.$gw{constructor(S,l){super(b=>this.throttledReport(b)),this.c=S,this.d=l}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,N.$5h)(100,(T,S)=>m(T,S),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[281],Ie([1,0,2,4,11,8]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class R{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(O.$gM.MainThreadQuickDiff)}$provideOriginalResource(m,E,T){const S=P.URI.revive(E),l=this.c.get(m);return l?(0,M.$qh)(()=>l.provideOriginalResource(S,T)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,T,S){const l=R.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,N.DocumentSelector.from(m,this.d),T,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$vnc=R}),define(ke[282],Ie([1,0,20,5,6,4,2,7,14,18,32,36,25,8]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=f;function f(r,s,o){const n=r.getProxy(N.$gM.MainThreadQuickOpen);class i{constructor(v,y){this.e=new Map,this.f=0,this.a=v,this.b=y}showQuickPick(v,y,h,D=P.CancellationToken.None){this.c=void 0;const k=Promise.resolve(y),C=++this.f,I=n.$show(C,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},D),W={},V=I.then(()=>W);return Promise.race([V,k]).then(q=>{if(q===W)return;const A=(0,l.$RG)(v,"quickPickItemTooltip");return k.then(B=>{const K=[];for(let ie=0;ie<B.length;ie++){const ce=B[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!A&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const ve=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:A?b.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(B[ie])}),n.$setItems(C,K),I.then(ie=>{if(typeof ie=="number")return B[ie];if(Array.isArray(ie))return ie.map(ce=>B[ce])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return n.$setError(C,q),Promise.reject(q)})}$onItemSelected(v){this.c?.(v)}showInput(v,y=P.CancellationToken.None){return this.d=v?.validateInput,n.$input(v,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(v){if(!this.d)return;const y=await this.d(v);if(!y||typeof y=="string")return y;let h;switch(y.severity){case p.InputBoxValidationSeverity.Info:h=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:h=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:h=T.default.Error;break;default:h=y.message?T.default.Error:T.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(v,y=P.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!h)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(v){const y=new d(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(v){const y=new w(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(v,y){this.e.get(v)?._fireDidChangeValue(y)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeActive(y)}$onDidChangeSelection(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeSelection(y)}$onDidTriggerButton(v,y){this.e.get(v)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(v,y,h){const D=this.e.get(v);D instanceof d&&D._fireDidTriggerItemButton(y,h)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class c{static{this.a=1}constructor(v,y){this.x=v,this.y=y,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$fe,this.q=new O.$fe,this.r=new O.$fe,this.s=new O.$fe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((y,h)=>{const D=y===p.$HN.Back?-1:h;this.o.set(D,y)}),this.z({buttons:v.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===p.$HN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const y=this.o.get(v);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(v){if(!this.v){for(const y of Object.keys(v)){const h=v[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function u($){if($ instanceof p.$fN)return{id:$.id};const v=g($),y=t($);return{dark:typeof v=="string"?R.URI.file(v):v,light:typeof y=="string"?R.URI.file(y):y}}function t($){return typeof $=="object"&&"light"in $?$.light:$}function g($){return typeof $=="object"&&"dark"in $?$.dark:$}function a($){const v=u($);let y,h;return"id"in v?h=S.ThemeIcon.asClassName(v):y=v,{iconPath:y,iconClass:h}}class d extends c{constructor(v,y){super(v.identifier,y),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$fe,this.L=[],this.M=new O.$fe,this.N=new O.$fe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((D,k)=>{this.C.set(k,D),this.D.set(D,k)});const y=(0,l.$RG)(this.O,"quickPickItemTooltip"),h=[];for(let D=0;D<v.length;D++){const k=v[D];if(k.kind===p.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=k.iconPath?a(k.iconPath):void 0;h.push({handle:D,label:k.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:y?b.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((I,W)=>({...a(I.iconPath),tooltip:I.tooltip,handle:W}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(v,y){const h=this.C.get(v);if(!h||!h.buttons||!h.buttons.length)return;const D=h.buttons[y];D&&this.N.fire({button:D,item:h})}}class w extends c{constructor(v,y){super(v.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:T.default.Error}):this.z({validationMessage:v.message,severity:v.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new i(s,o)}}),define(ke[283],Ie([1,0,2,5,69,6,11,4,18,149,12,21,36,8,25,16,23]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=void 0;function n(C){return C instanceof P.URI}function i(C,I){return C.scheme===r.Schemas.file&&I.scheme===r.Schemas.file&&s.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?P.URI.file(C.iconPath):P.URI.isUri(C.iconPath)||l.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function u(C){if(C.icon){if(P.URI.isUri(C.icon))return C.icon;if(l.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function t(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const W=typeof C.iconPath=="string"?C.iconPath:P.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,V=typeof I.iconPath=="string"?I.iconPath:P.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,E.$tr)(W,V)}function g(C,I){let W=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(W=t(C,I),W!==0)return W;if(C.light&&I.light)W=t(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(W!==0)return W;if(C.dark&&I.dark)W=t(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return W}function a(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let W=0;W<C.arguments.length;W++){const V=C.arguments[W],q=I.arguments[W];if(V!==q&&!(n(V)&&n(q)&&i(V,q)))return V<q?-1:1}return 0}function d(C,I){let W=(0,E.$tr)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(W!==0)return W;if(C.command&&I.command)W=a(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(W!==0)return W;if(C.decorations&&I.decorations)W=g(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)W=(0,E.$tr)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)W=(0,E.$tr)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return W}function w(C,I){for(let W=0;W<C.length;W++)if(C[W]!==I[W])return!1;return!0}function $(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?w(C.arguments,I.arguments):C.arguments===I.arguments)}function v(C,I){return(0,m.$ub)(C,I,$)}class y{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,f.$SG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,f.$SG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,f.$SG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,W,V,q,A){this.k=I,this.l=q,this.m=A,this.d="",this.e=new O.$fe,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(I,W){(0,f.$SG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,W)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$xnc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,W,V,q,A,B,K){this.q=I,this.s=W,this.t=V,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=B,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$fe,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$fe,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,W){const V=this.h.get(I);return V?(0,R.$qh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(d),V=(0,m.$Db)(this.o,I,d).map(B=>{const K=B.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ve=ie.resourceUri;let Se;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const ge=new N.$Tc;Se=this.s.converter.toInternal(ie.command,ge),this.j.set(ce,ge)}else this.h.set(ce,ie.command);const fe=(0,f.$RG)(this.w,"scmMultiDiffEditor"),$e=fe?ie.multiDiffEditorOriginalUri:void 0,Te=fe?ie.multiFileDiffEditorModifiedUri:void 0,ae=c(ie.decorations),Re=ie.decorations&&c(ie.decorations.light)||ae,ne=ie.decorations&&c(ie.decorations.dark)||ae,z=[Re,ne],x=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Fe=ie.decorations&&!!ie.decorations.faded,De=ie.contextValue||"";return{rawResource:[ce,ve,z,x,be,Fe,De,Se,$e,Te],handle:ce}});return{start:B.start,deleteCount:B.deleteCount,toInsert:K}}),q=V.map(({start:B,deleteCount:K,toInsert:ie})=>[B,K,ie.map(ce=>ce.rawResource)]),A=V.reverse();for(const{start:B,deleteCount:K,toInsert:ie}of A){const ce=ie.map(Se=>Se.handle),ve=this.n.splice(B,K,...ce);for(const Se of ve)this.g.delete(Se),this.h.delete(Se),this.j.get(Se)?.dispose(),this.j.delete(Se)}return this.o=I,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let W;(0,f.$RG)(this.x,"quickDiffProvider")&&(W=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:W})}get historyProvider(){return(0,f.$SG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,f.$SG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new N.$Tc,this.o=I;const W=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,f.$SG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,f.$SG)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=I;const W=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&v(this.t,I))return;this.s.value=new N.$Tc,this.t=I;const W=(I||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(I,W,V,q,A,B,K){this.x=I,this.y=q,this.z=A,this.A=B,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new O.$fe,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=P.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new y(I,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,A,B,K,ie)}createResourceGroup(I,W,V){const q=(0,f.$RG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,A=new h(this.#e,this.y,this.w,I,W,q,this.x),B=O.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,B),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const I=[],W=[];for(const[V,q]of this.C){q.dispose();const A=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});O.Event.once(V.onDidDispose)(()=>{this.D.delete(V),A.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),I.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const B=V._takeResourceStateSnapshot();B.length>0&&W.push([V.handle,B]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,I,W),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&I.push([W.handle,V])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$4h)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$4h)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new S.$Vm,this.j=new O.$fe,this.e=I.getProxy(p.$gM.MainThreadSCM),this.f=I.getProxy(p.$gM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const B=this.g.get(A.sourceControlHandle);if(!B)return A;const K=B.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const B=this.g.get(A.sourceControlHandle);return B?B.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const B=this.g.get(A.handle);return B||A}return A}})}createSourceControl(I,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const A=o.d++,B=new D(I,this.m,this.e,this.l,W,V,q);this.g.set(A,B);const K=this.h.get(I.identifier)||[];return K.push(B),this.h.set(I.identifier,K),B}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const W=this.h.get(I.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(I,W,V){const q=P.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",I,q.toString());const A=this.g.get(I);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$qh)(()=>A.quickDiffProvider.provideOriginalResource(q,V)).then(B=>B||null)}$onInputBoxValueChange(I,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const V=this.g.get(I);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(I,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",I,W,V);const A=this.g.get(I);if(!A)return Promise.resolve(void 0);const B=A.getResourceGroup(W);return B?B.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(I,W,V){this.n.trace("ExtHostSCM#$validateInput",I);const q=this.g.get(I);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,R.$qh)(()=>q.inputBox.validateInput(W,V)).then(A=>{if(!A)return Promise.resolve(void 0);const B=b.MarkdownString.fromStrict(A.message);return B?Promise.resolve([B,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,W,V,q){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(I,W,V,q){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:u(K)}))??void 0}async $provideHistoryItemSummary(I,W,V,q){const A=this.g.get(I)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const B=await A.provideHistoryItemSummary(W,V,q);return B?{...B,icon:u(B)}:void 0}async $provideHistoryItemChanges(I,W,V,q){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$ync=k,e.$ync=k=o=Je([We(3,T.$5j)],k)}),define(ke[284],Ie([1,0,4,8,2]),function(le,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class N{static{this.a=0}constructor(p,m){this.d=m,this.c=new Map,this.b=p.getProxy(P.$gM.MainThreadShare)}async $provideShare(p,m,E){return await this.c.get(p)?.provideShare({selection:O.Range.to(m.selection),resourceUri:M.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider(p,m){const E=N.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,O.DocumentSelector.from(p,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$znc=N}),define(ke[285],Ie([1,0,7,4,178,6,8,15]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new P.$gN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new P.$gN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,b,f,r,s,o=P.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=l,this.#t=b,s&&r){this.c=(0,P.$UM)(r.identifier,s);const i=f.get(this.c);i&&(o=i.alignLeft?P.StatusBarAlignment.Left:P.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=r,this.f=s,this.g=o,this.h=this.u(n)}u(l){if((0,p.$cg)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let b;this.m?b=this.m:b=(0,M.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=m.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,b,this.k,r,this.r?.internal,f,this.o,this.g===P.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Bnc=m;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",P.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const b={message:l};return this.b.unshift(b),this.c(),new P.$iM(()=>{const f=this.b.indexOf(b);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(l,b){this.e=new Map,this.a=l.getProxy(O.$gM.MainThreadStatusBar),this.b=b,this.c=new E(this)}$acceptStaticEntries(l){for(const b of l)this.e.set(b.entryId,b)}createStatusBarEntry(l,b,f,r){return new m(this.a,this.b,this.e,l,b,f,r)}setStatusBarMessage(l,b){const f=this.c.setMessage(l);let r;return typeof b=="number"?r=setTimeout(()=>f.dispose(),b):typeof b<"u"&&b.then(()=>f.dispose(),()=>f.dispose()),new P.$iM(()=>{f.dispose(),clearTimeout(r)})}}e.$Cnc=T}),define(ke[115],Ie([1,0,30,107,52,77,62,8,2]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=e.$WO=e.$VO=void 0;const E=(i,c,u,t)=>{let g=c;return{enumerable:!0,configurable:!1,get(){return g},set(a){if(!u(g,a)){const d=g;g=a,i.listener?.(t(a,d))}}}},T=(i,c)=>i===c,S={range:(i,c)=>i===c?!0:!i||!c?!1:i.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(i,c)=>!(i.length!==c.length||i.some(u=>!c.find(t=>u.id===t.id)))},l=i=>c=>({op:4,update:i(c)}),b=(i,c)=>({range:(()=>{let u;const t=l(g=>({range:P.$xt.lift(p.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return u},set(g){i.listener?.({op:6}),S.range(u,g)||(u=g,i.listener?.(t(g)))}}})(),label:E(i,c,S.label,l(u=>({label:u}))),description:E(i,void 0,S.description,l(u=>({description:u}))),sortText:E(i,void 0,S.sortText,l(u=>({sortText:u}))),canResolveChildren:E(i,!1,S.canResolveChildren,u=>({op:2,state:u})),busy:E(i,!1,S.busy,l(u=>({busy:u}))),error:E(i,void 0,S.error,l(u=>({error:p.MarkdownString.fromStrict(u)||null}))),tags:E(i,[],S.tags,(u,t)=>({op:1,new:u.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),f=i=>{const c=M.$5K.fromString(i.extId),u=new s(c.controllerId,c.localId,i.label,m.URI.revive(i.uri)||void 0);return u.range=p.Range.to(i.range||void 0),u.description=i.description||void 0,u.sortText=i.sortText||void 0,u.tags=i.tags.map(t=>p.TestTag.to({id:(0,R.$$K)(t).tagId})),u},r=i=>{let c;for(const u of i.tests){const t=f(u.item);(0,O.$FO)(t).parent=c,c=t}return c};e.$VO=r;class s{constructor(c,u,t,g){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,O.$EO)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof o?void 0:a.parent}},children:{value:(0,N.$DO)(a,O.$FO,s),enumerable:!0,writable:!1},...b(a,t)})}}e.$WO=s;class o extends s{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$XO=o;class n extends N.$zO{constructor(c,u,t){super({controllerId:c,getDocumentVersion:g=>g&&t.getDocument(g)?.version,getApiFor:O.$FO,getChildren:g=>g.children,root:new o(c,u),toITestItem:p.TestItem.from})}}e.$YO=n}),define(ke[35],Ie([1,0,15,7,8,26,4,18,12,49,30,94,2,6,3,17,115,22,34,44,66,59,63,33]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=void 0;let a=class{#e;#t;#i;constructor(h,D,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(R.$gM.MainThreadCommands),this.d=D,this.#i=k,this.#t=h.getProxy(R.$gM.MainThreadTelemetry),this.converter=new d(this,C=>{const I=this.c.get(C);return I?.result===$.Void?I:void 0},D),this.f=[{processArgument(C){return(0,E.$8h)(C)}},{processArgument(C){return(0,N.$7n)(C,function(I){if(T.$xt.isIRange(I))return M.Range.to(I);if(S.$wt.isIPosition(I))return M.Position.to(I);if(T.$xt.isIRange(I.range)&&l.URI.isUri(I.uri))return M.location.to(I);if(I instanceof o.$He)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const D=this.registerCommand(!1,h.id,async(...k)=>{const C=h.args.map((W,V)=>{if(!W.validate(k[V]))throw new Error(`Invalid argument '${W.name}' when running '${h.id}', received: ${typeof k[V]=="object"?JSON.stringify(k[V],null,"	"):k[V]} `);return W.convert(k[V])}),I=await this.executeCommand(h.internalId,...C);return h.result.convert(I,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new O.$iM(()=>{D.dispose(),this.c.delete(h.id)})}registerCommand(h,D,k,C,I,W){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:k,thisArg:C,metadata:I,extension:W}),h&&this.#e.$registerCommand(D),new O.$iM(()=>{this.b.delete(D)&&h&&this.#e.$unregisterCommand(D)})}executeCommand(h,...D){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,D,!0)}async g(h,D,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,D,!1);{let C=!1;const I=(0,N.$7n)(D,function(W){if(W instanceof O.$jM)return M.Position.from(W);if(W instanceof O.$kM)return M.Range.from(W);if(W instanceof O.$uM)return M.location.from(W);if(O.$KN.isNotebookRange(W))return M.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,o.$He.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,o.$He.wrap(W);if(W instanceof o.$He)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(h,C?new n.$Ew(I):I,k);return(0,E.$8h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(h,D,!1);throw W}}}async h(h,D,k){const C=this.b.get(h);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:W,metadata:V}=C;if(V?.args)for(let A=0;A<V.args.length;A++)try{(0,P.$pg)(D[A],V.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${V.args[A].name}' - ${V.args[A].description}`)}const q=c.$be.create();try{return await I.apply(W,D)}catch(A){if(h===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...D);B&&(h=B.command)}if(this.d.error(A,h,C.extension?.identifier),!k)throw A;if(C.extension?.identifier){const B=this.#i.onExtensionError(C.extension.identifier,A);this.d.trace("forwarded error to extension?",B,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$jj)(A)),this.id=h,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,h,q.elapsed())}}j(h,D,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$ip(D),duration:k})}$executeContributedCommand(h,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(D=D.map(C=>this.f.reduce((I,W)=>W.processArgument(I,k.extension?.identifier),C)),this.h(h,D,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(D=>(h&&(D=D.filter(k=>k[0]!=="_")),D))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[D,k]of this.b){const{metadata:C}=k;C&&(h[D]=C)}return Promise.resolve(h)}};e.$5O=a,e.$5O=a=Je([We(0,r.$JO),We(1,m.$5j),We(2,t.$4O)],a),e.$6O=(0,f.$yi)("IExtHostCommands");class d{constructor(h,D,k){this.d=h,this.f=D,this.g=k,this.delegatingCommandId=`__vsc${(0,g.$Ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,D){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const C=this.f(h.command);if(C)k.id=C.internalId,k.arguments=C.args.map((I,W)=>I.convert(h.arguments&&h.arguments[W]));else if((0,p.$Lb)(h.arguments)){const I=`${h.command} /${++this.c}`;this.b.set(I,h),D.add((0,b.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),k.$ident=I,k.id=this.delegatingCommandId,k.arguments=[I],this.g.trace("CommandsConverter#CREATE",h.command,I)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const D=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$7O=d;class w{static{this.Uri=new w("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new w("position","A position in a text document",h=>O.$jM.isPosition(h),M.Position.from)}static{this.Range=new w("range","A range in a text document",h=>O.$kM.isRange(h),M.Range.from)}static{this.Selection=new w("selection","A selection in a text document",h=>O.$lM.isSelection(h),M.Selection.from)}static{this.Number=new w("number","",h=>typeof h=="number",h=>h)}static{this.String=new w("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=w.Arr(w.String)}static Arr(h){return new w(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,D=>Array.isArray(D)&&D.every(k=>h.validate(k)),D=>D.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",h=>h instanceof O.$GM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",h=>h instanceof O.$5N,M.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",h=>h instanceof s.$WO,M.TestItem.from)}constructor(h,D,k,C){this.name=h,this.description=D,this.validate=k,this.convert=C}optional(){return new w(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,D){return new w(h??this.name,D??this.description,this.validate,this.convert)}}e.$8O=w;class ${static{this.Void=new $("no result",h=>h)}constructor(h,D){this.description=h,this.convert=D}}e.$9O=$;class v{constructor(h,D,k,C,I){this.id=h,this.internalId=D,this.description=k,this.args=C,this.result=I}}e.$0O=v}),define(ke[286],Ie([1,0,18,16,2,89,98,31,35,8,7]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;const S=[new m.$0O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of DocumentHighlight-instances.",b(E.DocumentHighlight.to))),new m.$0O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$8O.Uri],new m.$9O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,P.$Kb)(r))return;class o extends T.$BM{static to(i){const c=new o(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new T.$uM(s[0],E.Range.to(i.range)));return c.detail=i.detail,c.range=c.location.range,c.selectionRange=E.Range.to(i.selectionRange),c.children=i.children?i.children.map(o.to):[],c}}return r.map(o.to)})),new m.$0O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$8O.Uri,new m.$8O("options","Formatting options",r=>!0,r=>r)],new m.$9O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$0O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$8O.Uri,m.$8O.Range,new m.$8O("options","Formatting options",r=>!0,r=>r)],new m.$9O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$0O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$8O.Uri,m.$8O.Position,new m.$8O("ch","Trigger character",r=>typeof r=="string",r=>r),new m.$8O("options","Formatting options",r=>!0,r=>r)],new m.$9O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$0O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$0O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$0O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$0O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$0O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of Location-instances.",b(E.location.to))),new m.$0O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of Hover-instances.",b(E.Hover.to))),new m.$0O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$8O.Uri,new m.$8O("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>T.$jM.isPosition(s)),r=>r.map(E.Position.from))],new m.$9O("A promise that resolves to an array of ranges.",r=>r.map(s=>{let o;for(const n of s.reverse())o=new T.$FM(E.Range.to(n),o);return o}))),new m.$0O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$8O.String.with("query","Search string")],new m.$9O("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new m.$0O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new m.$0O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$8O.CallHierarchyItem],new m.$9O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new m.$0O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$8O.CallHierarchyItem],new m.$9O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new m.$0O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new m.$0O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$8O.Uri,m.$8O.Position,m.$8O.String.with("newName","The new symbol name")],new m.$9O("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new m.$0O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$8O.Uri,m.$8O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$9O("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new m.$0O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$8O.Uri],new m.$9O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$BN(r.tokenTypes,r.tokenModifiers)})),new m.$0O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$8O.Uri],new m.$9O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,R.$ybb)(r);if(s.type==="full")return new T.$DN(s.data,void 0)})),new m.$0O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$8O.Uri,m.$8O.Range.optional()],new m.$9O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$BN(r.tokenTypes,r.tokenModifiers)})),new m.$0O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$8O.Uri,m.$8O.Range],new m.$9O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,R.$ybb)(r);if(s.type==="full")return new T.$DN(s.data,void 0)})),new m.$0O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$8O.Uri,m.$8O.Position,m.$8O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$8O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$9O("A promise that resolves to a CompletionList-instance.",(r,s,o)=>{if(!r)return new T.$RM([]);const n=r.suggestions.map(i=>E.CompletionItem.to(i,o));return new T.$RM(n,r.incomplete)})),new m.$0O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$8O.Uri,m.$8O.Position,m.$8O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$9O("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new m.$0O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$8O.Uri,m.$8O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$9O("A promise that resolves to an array of CodeLens-instances.",(r,s,o)=>b(n=>new T.$JM(E.Range.to(n.range),n.command&&o.fromInternal(n.command)))(r))),new m.$0O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$8O.Uri,new m.$8O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.$kM.isRange(r),r=>T.$lM.isSelection(r)?E.Selection.from(r):E.Range.from(r)),m.$8O.String.with("kind","Code action kind to return code actions for").optional(),m.$8O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$9O("A promise that resolves to an array of Command-instances.",(r,s,o)=>b(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new T.$DM(n.title,n.kind?new T.$EM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new m.$0O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$8O.Uri],new m.$9O("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new T.$XM(E.Range.to(s.range),E.Color.to(s.color))):[])),new m.$0O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$8O("color","The color to show and insert",r=>r instanceof T.$WM,E.Color.from),new m.$8O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new m.$9O("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new m.$0O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$8O.Uri,m.$8O.Range],new m.$9O("A promise that resolves to an array of Inlay objects",(r,s,o)=>r.map(E.InlayHint.to.bind(void 0,o)))),new m.$0O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$8O.Uri],new m.$9O("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(E.FoldingRange.to)})),new m.$0O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$9O("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.to(s))})))),new m.$0O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$8O.Uri,m.$8O.Range,new m.$8O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof T.$kM,r=>E.InlineValueContext.from(r))],new m.$9O("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new m.$0O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$8O("uriOrString","Uri-instance or string (only http/https)",r=>M.URI.isUri(r)||typeof r=="string"&&(0,O.$Ig)(r,O.Schemas.http,O.Schemas.https),r=>r),new m.$8O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),m.$8O.String.with("label","").optional()],m.$9O.Void),new m.$0O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$8O.Uri.with("resource","Resource to open"),m.$8O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$8O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],m.$9O.Void),new m.$0O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$8O.Uri.with("left","Left-hand side resource of the diff editor"),m.$8O.Uri.with("right","Right-hand side resource of the diff editor"),m.$8O.String.with("title","Human readable title for the diff editor").optional(),new m.$8O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],m.$9O.Void),new m.$0O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$8O.String.with("title","Human readable title for the changes editor"),new m.$8O("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[o,n,i]=s;if(!M.URI.isUri(o)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],m.$9O.Void),new m.$0O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$8O.Uri,m.$8O.Position],new m.$9O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$0O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$8O.TypeHierarchyItem],new m.$9O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$0O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$8O.TypeHierarchyItem],new m.$9O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$0O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$8O.TestItem],m.$9O.Void),new m.$0O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$8O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$9O.Void),new m.$0O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$8O.String.with("name","The context key name"),new m.$8O("value","The context key value",()=>!0,r=>r)],m.$9O.Void),new m.$0O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$8O.Uri,m.$8O.StringArray,new m.$8O("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new m.$9O("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null)),new m.$0O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$8O("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?E.Range.from(r.initialRange):void 0,initialSelection:T.$lM.isSelection(r.initialSelection)?E.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?E.Position.from(r.position):void 0}})],m.$9O.Void)];class l{static register(s){S.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",p.$xj)}}e.$Xlc=l;function b(r){return s=>{if(Array.isArray(s))return s.map(r)}}function f(r){if(!Array.isArray(r))return;const s=[];for(const o of r)N.$cu(o)?s.push(E.DefinitionLink.to(o)):s.push(E.location.to(o));return s}}),define(ke[287],Ie([1,0,2,35]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class M{constructor(R,p,m,E,T){this.a=p,this.b=m,this.c=E;const S=new O.$0O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$8O("showOptions","Show Options",l=>!0,l=>l),new O.$8O("resource","Interactive resource Uri",l=>!0,l=>l),new O.$8O("controllerId","Notebook controller Id",l=>!0,l=>l),new O.$8O("title","Interactive editor title",l=>!0,l=>l)],new O.$9O("Notebook and input URI",l=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const b=this.a.getEditorById(l.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:P.URI.revive(l.notebookUri),inputUri:P.URI.revive(l.inputUri),notebookEditor:b.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:P.URI.revive(l.notebookUri),inputUri:P.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,p,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:m,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$hnc=M}),define(ke[288],Ie([1,0,18,11,20,5,6,28,2,21,12,4,35,8,7,78,229,25,34,230]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0,e.$pnc=w;let c=class{constructor(v,y,h,D,k){this.m=y,this.n=h,this.o=D,this.q=k,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$fe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(S.$gM.MainThreadNotebookKernels);const C=new l.$0O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$8O("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],l.$9O.Void),I=new l.$0O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$8O.Uri],new l.$9O("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(v,y,h,D,k,C){for(const ae of this.j.values())if(ae.controller.id===y&&E.$Tm.equals(v.identifier,ae.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const I=this.k++,W=this;this.q.trace(`NotebookController[${I}], CREATED by ${v.identifier.value}, ${y}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${v.identifier}'`);let q=!1;const A=new N.$fe,B=new N.$fe,K={id:w(v.identifier,y),notebookType:h,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:D||v.identifier.value,preloads:C?C.map(b.NotebookRendererScript.from):[]};let ie=k??V,ce,ve;this.a.$addKernel(I,K).catch(ae=>{console.log(ae),q=!0});let Se=0;const fe=()=>{if(q)return;const ae=++Se;Promise.resolve().then(()=>{ae===Se&&this.a.$updateKernel(I,K)})},$e=new p.$Ac,Te={get id(){return y},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(ae){K.label=ae??v.displayName??v.name,fe()},get detail(){return K.detail??""},set detail(ae){K.detail=ae,fe()},get description(){return K.description??""},set description(ae){K.description=ae,fe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ae){K.supportedLanguages=ae,fe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){K.supportsExecutionOrder=ae,fe()},get rendererScripts(){return K.preloads?K.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ae){ie=ae??V},get interruptHandler(){return ce},set interruptHandler(ae){ce=ae,K.supportsInterrupt=!!ae,fe()},set variableProvider(ae){(0,o.$SG)(v,"notebookVariableProvider"),ve=ae,K.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Re=>W.a.$variablesUpdated(Re.uri)),fe()},get variableProvider(){return ve},createNotebookCellExecution(ae){if(q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.notebook.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,w(v.identifier,this.id))},createNotebookExecution(ae){if((0,o.$SG)(v,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return W._createNotebookExecution(ae,w(v.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${I}], DISPOSED`),q=!0,this.j.delete(I),A.dispose(),B.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ae,Re){Re===f.NotebookControllerAffinity2.Hidden&&(0,o.$SG)(v,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(I,ae.uri,Re)},onDidReceiveMessage:B.event,postMessage(ae,Re){return(0,o.$SG)(v,"notebookMessaging"),W.a.$postMessage(I,Re&&W.n.getIdByEditor(Re),ae)},asWebviewUri(ae){return(0,o.$SG)(v,"notebookMessaging"),(0,r.$7Ab)(ae,W.m.remote)}};return this.j.set(I,{extensionId:v.identifier,controller:Te,onDidReceiveMessage:B,onDidChangeSelection:A,associatedNotebooks:$e}),Te}getIdByController(v){for(const[y,h]of this.j)if(h.controller===v)return w(h.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,y){const h=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const k={dispose:()=>{this.f.delete(h),D.a.$removeKernelDetectionTask(h)}};return this.f.set(h,k),k}registerKernelSourceActionProvider(v,y,h){const D=this.i++,k=typeof h.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,C=this;this.h.set(D,h),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,y);let I;return k!==void 0&&(I=h.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(D),C.a.$removeKernelSourceActionProvider(D,D),I?.dispose()}}}async $provideKernelSourceActions(v,y){const h=this.h.get(v);if(h){const D=new R.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(C=>b.NotebookKernelSourceAction.from(C,this.o.converter,D))}return[]}$acceptNotebookAssociation(v,y,h){const D=this.j.get(v);if(D){const k=this.n.getNotebookDocument(m.URI.revive(y));h?D.associatedNotebooks.set(k.uri,!0):D.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,k.uri.toString(),h),D.onDidChangeSelection.fire({selected:h,notebook:k.apiNotebook})}}async $executeCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y)),C=[];for(const I of h){const W=k.getCell(I);W&&C.push(W.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,k.uri.toString(),C.length),await D.controller.executeHandler.call(D.controller,C,k.apiNotebook,D.controller)}catch(I){this.q.error(`NotebookController[${v}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,k.apiNotebook);else for(const C of h){const I=k.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(D.controller.interruptHandler){const C=this.c.get(k.uri);this.c.delete(k.uri),h.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(v,y,h,D,k,C,I){const W=this.j.get(v);if(!W)return;const V=this.n.getNotebookDocument(m.URI.revive(h)),q=W.controller.variableProvider;if(!q)return;let A;if(D!==void 0){if(A=this.s[D],!A)return}else this.s={};const B=k==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,A,B,C,I);let ie=0;for await(const ce of K){if(I.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(y,ve),ie++>=i.$Qib)return}}$acceptKernelMessageFromRenderer(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getEditorById(y);D.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:h}))}$cellExecutionChanged(v,y,h){const k=this.n.getNotebookDocument(m.URI.revive(v)).getCell(y);if(k){const C=h?b.NotebookCellExecutionState.to(h):f.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:k.apiCell,state:C})}}_createNotebookCellExecution(v,y){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const k=new t(y,D,this.a);this.b.set(D.uri,k);const C=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),C.dispose(),this.b.delete(D.uri))});return k.asApiObject()}_createNotebookExecution(v,y){const h=this.n.getNotebookDocument(v.uri),D=v.getCells().find(I=>{const W=h.getCellFromApiCell(I);return W&&this.b.has(W.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const k=new a(y,h,this.a),C=k.onDidChangeState(()=>{k.state===g.Resolved&&(k.dispose(),C.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[k,C]),k.asApiObject()}};e.$onc=c,e.$onc=c=Je([We(4,T.$5j)],c);var u;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(u||(u={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.m=y,this.n=h,this.b=t.a++,this.c=new N.$fe,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new M.$qe),this.h=new d(10,D=>this.s(D)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const y=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new n.$Ew(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let y=this.m;if(v&&(y=this.m.notebook.getCellFromApiCell(v)),!y)throw new Error("INVALID cell");return y.handle}y(v){return v.map(y=>{const h=f.$ON.ensureUniqueMimeTypes(y.items,!0);return h===y.items?b.NotebookCellOutput.from(y):b.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(v,y,h){const D=this.w(y),k=this.y((0,P.$2b)(v));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:D,append:h,outputs:k})}async C(v,y,h){return v=f.$ON.ensureUniqueMimeTypes((0,P.$2b)(v),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:v.map(b.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(h){v.j=h,v.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(h){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,D,k){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush();const C=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;v.n.$completeExecution(v.b,new n.$Ew({runEndTime:D,lastRunSuccess:h,error:C}))},clearOutput(h){return v.t(),v.z([],h,!1)},appendOutput(h,D){return v.t(),v.z(h,D,!0)},replaceOutput(h,D){return v.t(),v.z(h,D,!1)},appendOutputItems(h,D){return v.t(),v.C(h,D,!0)},replaceOutputItems(h,D){return v.t(),v.C(h,D,!1)}})}}var g;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(g||(g={}));class a extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new N.$fe,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new M.$qe),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(v,y){this.f=v,this.g=y,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new O.$Vh,this.b=Date.now(),(0,O.$zh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>v.complete())}}function w($,v){return`${$.value}/${v}`}}),define(ke[53],Ie([1,0,5,4,3,2,17,6,7,180,14,208,20,33,209,36,11,8,35]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=e.$Amc=e.$zmc=void 0,e.$zmc=(0,M.$yi)("IExtHostTerminalService");class i extends p.$Uc{constructor(h,D,k,C){super(),this.u=h,this._id=D,this.w=k,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new P.$fe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(W,V=!0){I.C(),I.u.$sendText(I._id,W,V)},show(W){I.C(),I.u.$show(I._id,W)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??D?.cwd??void 0,env:h.env??void 0,icon:w(h.iconPath)??void 0,color:r.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(h.location,D?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,D,k,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:r.ThemeColor.isThemeColor(I)?I.id:void 0,location:D?.location||this.z(h,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,D){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in h?{viewColumn:o.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,D){this.j=Object.freeze({code:h,reason:D})}setDimensions(h,D){return h===this.f&&D===this.h||h===0||D===0?!1:(this.f=h,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(D=>{D!==h&&(this.b=Promise.resolve(h))})}}e.$Amc=i;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new P.$fe,this.onProcessData=this.a.event,this.b=new P.$fe,this.d=new P.$fe,this.onDidChangeProperty=this.d.event,this.f=new P.$fe,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,D){this.g.setDimensions?.({columns:h,rows:D})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,D,k){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new P.$fe,this.onDidCloseTerminal=this.H.event,this.I=new P.$fe,this.onDidOpenTerminal=this.I.event,this.J=new P.$fe,this.onDidChangeActiveTerminal=this.J.event,this.L=new P.$fe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new P.$fe,this.onDidChangeTerminalState=this.M.event,this.N=new P.$fe,this.onDidChangeShell=this.N.event,this.O=new P.$fe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new P.$fe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$gM.MainThreadTerminalService),this.y=new f.$Yvb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:C=>{const I=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let W=0;W<C.length&&C[W].$mid===15;W++)C[W]=I(C[W]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,D){const k=new i(this.a,(0,b.$Ug)(),h,h.name),C=new c(h.pty);return k.createExtensionTerminal(h.location,D,this.R(h,D).resolvedExtHostIdentifier,w(h.iconPath),$(h.color)).then(I=>{const W=this.S(I,C);this.h[I]=W}),this.f.push(k),k.value}R(h,D){if(D=D||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const C=this.f.find(I=>I.value===k);C&&(D.resolvedExtHostIdentifier=C._id)}}else h.location&&typeof h.location!="object"?D.location=h.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(h,D){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const C=new c(D),I=this.S(h,C);this.h[h]=I}async $acceptActiveTerminalChanged(h){const D=this.b;if(h===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(h);k&&(this.b=k,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,D){const k=this.getTerminalById(h);k&&this.O.fire({terminal:k.value,data:D})}async $acceptTerminalDimensions(h,D,k){const C=this.getTerminalById(h);C&&C.setDimensions(D,k)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(h,D){const k=this.getTerminalById(h);k&&this.P.fire({terminal:k.value,...D})}async $acceptTerminalMaximumDimensions(h,D,k){this.g.get(h)?.resize(D,k)}async $acceptTerminalTitleChange(h,D){const k=this.getTerminalById(h);k&&(k.name=D)}async $acceptTerminalClosed(h,D,k){const C=this.X(this.f,h);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(D,k),this.H.fire(I.value)}}$acceptTerminalOpened(h,D,k,C){if(D){const V=this.X(this.f,D);if(V!==null){this.f[V]._id=h,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:N.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},W=new i(this.a,h,I,k);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(h,D){this.getTerminalById(h)?._setProcessId(D)}async $startExtensionTerminal(h,D){const k=this.getTerminalById(h);if(!k)return{message:(0,E.localize)(0,null,h)};k.isOpen||await new Promise(I=>{const W=this.onDidOpenTerminal(async V=>{V===k.value&&(W.dispose(),I())})});const C=this.g.get(h);C?C.startSendingEvents(D):this.j[h]={initialDimensions:D}}S(h,D){const k=new p.$Tc;k.add(D.onProcessReady(I=>this.a.$sendProcessReady(h,I.pid,I.cwd,I.windowsPty))),k.add(D.onDidChangeProperty(I=>this.a.$sendProcessProperty(h,I))),this.y.startBuffering(h,D.onProcessData),k.add(D.onProcessExit(I=>this.U(h,I))),this.g.set(h,D);const C=this.j[h];return C&&D instanceof c&&(D.startSendingEvents(C.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,D){this.g.get(h)?.acknowledgeDataEvent(D)}$acceptProcessInput(h,D){this.g.get(h)?.input(D)}$acceptTerminalInteraction(h){const D=this.getTerminalById(h);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(h,D){this.getTerminalById(h)?.setSelection(D)}$acceptProcessResize(h,D,k){try{this.g.get(h)?.resize(D,k)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(h,D){this.g.get(h)?.shutdown(D)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(D=>this.a.$sendProcessProperty(h,{type:"cwd",value:D}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$iM(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,D,k){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,k),this.a.$registerProfileProvider(D,h.identifier.value),new m.$iM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(h,D,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,D),new m.$iM(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,D){const k=new l.$qe().token;if(k.isCancellationRequested)return;const C=this.D.get(h);if(!C)return;const I=await C.provideTerminalQuickFixes(D,k);if(I===null||Array.isArray(I)&&I.length===0)return;const W=new p.$Tc;if(this.w.value=W,!Array.isArray(I))return I?o.TerminalQuickFix.from(I,this.Q.converter,W):void 0;const V=[];for(const q of I){const A=o.TerminalQuickFix.from(q,this.Q.converter,W);A&&V.push(A)}return V}async $createContributedProfileTerminal(h,D){const k=new l.$qe().token;let C=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,D);return}this.createTerminalFromOptions(C.options,D)}}async $provideLinks(h,D){const k=this.getTerminalById(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const I=new l.$qe;this.G.set(h,I);const W=[],V={terminal:k.value,line:D},q=[];for(const K of this.z)q.push(s.Promises.withAsyncBody(async ie=>{I.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(V,I.token)||[];I.token.isCancellationRequested||ie({provider:K,links:ce})}));const A=await Promise.all(q);if(I.token.isCancellationRequested)return[];const B=new Map;for(const K of A)K&&K.links.length>0&&W.push(...K.links.map(ie=>{const ce={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return B.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(h,B),W}$activateLink(h,D){const k=this.F.get(h)?.get(D);k&&k.provider.handleTerminalLink(k.link)}U(h,D){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,D)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const D=this.f.findIndex(k=>k.value===h);return D>=0?D:null}W(h,D){const k=this.X(h,D);return k!==null?h[k]:null}X(h,D){const k=h.findIndex(C=>C._id===D);return k>=0?k:null}getEnvironmentVariableCollection(h){let D=this.n.get(h.identifier.value);return D||(D=new g,this.Z(h.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(h,D){const k=(0,S.$os)(D.map),C=(0,S.$ps)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(h,D.persistent,k.length===0?void 0:k,C)}$initEnvironmentVariableCollections(h){h.forEach(D=>{const k=D[0],C=new g(D[1]);this.Z(k,C)})}$acceptDefaultProfile(h,D){const k=this.s;this.s=h,this.u=D,k?.path!==h.path&&this.N.fire(h.path)}Z(h,D){this.n.set(h,D),D.onDidChangeCollection(()=>{this.Y(h,D)})}};e.$Bmc=t,e.$Bmc=t=Je([We(1,n.$6O),We(2,R.$JO)],t);class g{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new P.$fe,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const D=this.h(h);let k=this.a.get(D);return k||(k=new a(this,h),this.a.set(D,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,D,k,C){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:C})}append(h,D,k,C){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:C})}prepend(h,D,k,C){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:C})}f(h,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,D.scope),C=this.map.get(k),I=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==D.value||C.type!==D.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const W=this.g(h,D.scope),V={variable:h,...D,options:I};this.map.set(W,V),this.d.fire()}}get(h,D){const k=this.g(h,D),C=this.map.get(k);return C?v(C):void 0}g(h,D){const k=this.h(D);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const D=new Map;for(const[k,C]of this.map)this.h(C.scope)===this.h(h)&&D.set(C.variable,v(C));return D}delete(h,D){const k=this.g(h,D);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[D,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(D);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,D){const k=this.h(D),C=this.descriptionMap.get(k);if(!C||C.description!==h){let I;typeof h=="string"?I=h:I=h?.value.split(`

`)[0];const W={description:I,scope:D};this.descriptionMap.set(k,W),this.d.fire()}}getDescription(h){const D=this.h(h);return this.descriptionMap.get(D)?.description}k(h){const D=this.h(h);this.descriptionMap.delete(D)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,D){this.b=h,this.d=D,this.a=new P.$fe}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,D,k){this.b.replace(h,D,k,this.d)}append(h,D,k){this.b.append(h,D,k,this.d)}prepend(h,D,k){this.b.prepend(h,D,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,D){this.b.getVariableMap(this.d).forEach((k,C)=>h.call(D,C,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor(h,D){super(!1,h,D)}createTerminal(h,D,k){throw new T.$_}createTerminalFromOptions(h,D){throw new T.$_}};e.$Cmc=d,e.$Cmc=d=Je([We(0,n.$6O),We(1,R.$JO)],d);function w(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function $(y){return r.ThemeColor.isThemeColor(y)?y:void 0}function v(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(ke[116],Ie([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,e.$Gnc=(0,M.$yi)("IExtHostTerminalShellIntegration");let S=class extends O.$Uc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new m.$fe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$fe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$fe,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(N.$gM.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const n=o.value;let i=this.b.get(s);i||(i=new l(o.value,this.f),this.b.set(s,i),i.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(c=>this.a.$executeCommand(s,c))),i.store.add(i.onDidRequestEndExecution(c=>this.g.fire(c))),i.store.add(i.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),o.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(s,o,n,i,c){this.b.has(s)||this.$shellIntegrationChange(s);const u={value:o,confidence:n,isTrusted:i};this.b.get(s)?.startShellExecution(u,c)}$shellExecutionEnd(s,o,n,i,c){const u={value:o,confidence:n,isTrusted:i};this.b.get(s)?.endShellExecution(u,c)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,E.$vc)(o)?E.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$Hnc=S,e.$Hnc=S=Je([We(0,R.$JO),We(1,p.$zmc)],S);class l extends O.$Uc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$fe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$fe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$fe),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,c){let u=i;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(u);const t={value:u,confidence:P.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=n.startShellExecution(t,n.c,!0).value;return n.b=!0,g}}}startShellExecution(s,o,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new b(s,o);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;E.URI.isUri(this.c)?o=!E.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class b{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return T.$Yh.EMPTY;this.a=new f}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$xh);const s=this.a;return new T.$Yh(async n=>{this.b.push(n),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[289],Ie([1,0,11,22,20,5,262,73,6,15,33,12,4,17,115,8,7,52,77,62]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=e.$Jnc=e.$Inc=void 0;let c=class extends m.$Uc{constructor(I,W,V,q){super(),this.w=q,this.f=this.B(new N.$fe),this.g=new Map,this.s=this.B(new N.$fe),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(l.$gM.MainThreadTesting),this.m=new y(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const B=A,K=B.tests[B.tests.length-1].item.extId;return this.g.get(o.$5K.root(K))?.collection.tree.get(K)?.actual??(0,f.$VO)(A)}case 18:{const{test:B,message:K}=A,ie=B.item.extId;return{test:this.g.get(o.$5K.root(ie))?.collection.tree.get(ie)?.actual??(0,f.$VO)({$mid:16,tests:[B]}),message:r.TestMessage.to(K)}}default:return A}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await V.executeCommand("_testing.getExplorerSelection"),B=K=>{const ie=this.g.get(o.$5K.root(K));if(ie)return o.$5K.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:A?.include.map(B).filter(E.$gg)||[],exclude:A?.exclude.map(B).filter(E.$gg)||[]}})}createTestController(I,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const A=new m.$Tc,B=A.add(new f.$YO(W,V,this.w));B.root.label=V;const K=new Map,ie=new Set,ce=this.h,ve={items:B.root.children,get label(){return V},set label(fe){V=fe,B.root.label=fe,ce.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(fe){q=fe,ce.$updateController(W,{canRefresh:!!fe})},get id(){return W},createRunProfile:(fe,$e,Te,ae,Re,ne)=>{let z=(0,p.$mj)(fe);for(;K.has(z);)z++;return new D(this.h,K,ie,this.s.event,W,z,fe,$e,Te,ae,Re,ne)},createTestItem(fe,$e,Te){return new f.$WO(W,fe,$e,Te)},createTestRun:(fe,$e,Te=!0)=>this.j.createTestRun(W,B,fe,$e,Te),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const $e=fe instanceof Array?fe:[fe];this.h.$markTestRetired($e.map(Te=>o.$5K.fromExtHostTestItem(Te,W).toString()))}},set resolveHandler(fe){B.resolveHandler=fe},get resolveHandler(){return B.resolveHandler},dispose:()=>{A.dispose()}};ce.$registerTestController(W,V,!!q),A.add((0,m.$Sc)(()=>ce.$unregisterTestController(W)));const Se={controller:ve,collection:B,profiles:K,extension:I,activeProfiles:ie};return this.g.set(W,Se),A.add((0,m.$Sc)(()=>this.g.delete(W))),A.add(B.onDidGenerateDiff(fe=>ce.$publishDiff(W,fe.map(i.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(I,W=M.CancellationToken.None){const V=d(I);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:I.preserveFocus??!0,targets:[{testIds:I.include?.map(A=>o.$5K.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:k[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:I.exclude?.map(A=>A.id)},W)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,W){return(await this.j.getCoverageDetails(I,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,W){this.g.get(I)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(I){const W=new Map;for(const[V,q]of Object.entries(I)){const A=this.g.get(V);if(!A)continue;const B=new Map,K=q.filter(ce=>!A.activeProfiles.has(ce)),ie=[...A.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)B.set(ce,!0),A.activeProfiles.add(ce);for(const ce of ie)B.set(ce,!1),A.activeProfiles.delete(ce);B.size&&W.set(V,B)}this.s.fire(W)}async $refreshTests(I,W){await this.g.get(I)?.controller.refreshHandler?.(W)}$publishTestResults(I){this.results=Object.freeze(I.map(r.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,W){const V=this.g.get(o.$5K.fromString(I).controllerId)?.collection;V&&(await V.expand(I,W<0?1/0:W),V.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(W=>i.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(I,W){return Promise.all(I.map(V=>this.y(V,!1,W)))}async $startContinuousRun(I,W){const V=new M.$qe(W),q=await Promise.all(I.map(A=>this.y(A,!0,V.token)));return!W.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>W.onCancellationRequested(A)),V.dispose(!0),q}async y(I,W,V){const q=this.g.get(I.controllerId);if(!q)return{};const{collection:A,profiles:B}=q,K=B.get(I.profileId);if(!K)return{};const ie=I.testIds.map(fe=>A.tree.get(fe)).filter(E.$gg),ce=I.excludeExtIds.map(fe=>q.collection.tree.get(fe)).filter(E.$gg).filter(fe=>ie.some($e=>$e.fullId.compare(fe.fullId)===2));if(!ie.length)return{};const ve=new s.$VN(ie.some(fe=>fe.actual instanceof f.$XO)?void 0:ie.map(fe=>fe.actual),ce.map(fe=>fe.actual),K,W),Se=(0,i.$8K)(I)&&this.j.prepareForMainThreadTestRun(ve,w.fromInternal(I,q.collection),K,V);try{return await K.runHandler(ve,V),{}}catch(fe){return{error:String(fe)}}finally{Se&&Se.hasRunningTasks&&!V.isCancellationRequested&&await N.Event.toPromise(Se.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$Inc=c,e.$Inc=c=Je([We(0,b.$JO),We(1,S.$5j)],c);const u=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class g extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,W,V,q,A){super(),this.y=I,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new N.$fe),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new M.$qe(A));const B=this.B(new P.$Kh(()=>this.F(),u));this.B(this.j.token.onCancellationRequested(()=>B.schedule()));const K=new N.$fe;this.s=K.event,this.B((0,m.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,W){const[,V,q]=o.$5K.fromString(I).path,A=this.w.get(q);if(!A)return[];const B=this.g.get(V);if(!B)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(B.run,A,W)??[]}createRun(I){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Ug)(),A=ce=>(ve,...Se)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ce(ve,...Se))},B=(ce,ve)=>{const Se=ve instanceof Array?ve.map(r.TestMessage.from):[r.TestMessage.from(ve)];if(ce.uri&&ce.range){const fe={range:r.Range.from(ce.range),uri:ce.uri};for(const $e of Se)$e.location=$e.location||fe}this.z.$appendTestMessagesInRun(W,q,o.$5K.fromExtHostTestItem(ce,V).toString(),Se)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:ce=>{const ve=ce.uri.toString(),Se=new o.$5K([W,q,ve]).toString();this.w.set(ve,ce),this.z.$appendCoverage(W,q,r.TestCoverage.fromFile(Se,ce))},enqueued:A(ce=>{this.z.$updateTestStateInRun(W,q,o.$5K.fromExtHostTestItem(ce,V).toString(),1)}),skipped:A(ce=>{this.z.$updateTestStateInRun(W,q,o.$5K.fromExtHostTestItem(ce,V).toString(),5)}),started:A(ce=>{this.z.$updateTestStateInRun(W,q,o.$5K.fromExtHostTestItem(ce,V).toString(),2)}),errored:A((ce,ve,Se)=>{B(ce,ve),this.z.$updateTestStateInRun(W,q,o.$5K.fromExtHostTestItem(ce,V).toString(),6,Se)}),failed:A((ce,ve,Se)=>{B(ce,ve),this.z.$updateTestStateInRun(W,q,o.$5K.fromExtHostTestItem(ce,V).toString(),4,Se)}),passed:A((ce,ve)=>{this.z.$updateTestStateInRun(W,q,o.$5K.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ve)}),appendOutput:(ce,ve,Se)=>{K||(Se&&(this.y.isIncluded(Se)?this.H(Se):Se=void 0),this.z.$appendOutputToRun(W,q,O.$He.fromString(ce),ve&&r.location.from(ve),Se&&o.$5K.fromExtHostTestItem(Se,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(W,{id:q,name:I,running:!0}),ie}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof f.$WO))throw new n.$BO(I.id);if(this.h.has(o.$5K.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=r.TestItem.from(I);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),I===V))break;I=I.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(I,W){this.g=I,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(I,W){const V=o.$5K.root(I);return this.f.get(V)?.getCoverageDetails(I,W)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[W,{id:V}]of this.c)V===I&&this.c.delete(W)}prepareForMainThreadTestRun(I,W,V,q){return this.j(I,W,V,q)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,W,V,q,A){const B=this.c.get(V);if(B)return B.createRun(q);const K=w.fromPublic(I,W,V,A),ie=d(V);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!V.continuous,profile:ie&&{group:k[ie.kind],id:ie.profileId},exclude:V.exclude?.map(ve=>o.$5K.fromExtHostTestItem(ve,W.root.id).toString())??[],id:K.id,include:V.include?.map(ve=>o.$5K.fromExtHostTestItem(ve,W.root.id).toString())??[W.root.id],preserveFocus:V.preserveFocus??!0,persist:A});const ce=this.j(V,K,V.profile);return N.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(I,W,V,q){const A=new g(W,this.g,this.h,V,q);return this.c.set(I,A),this.f.set(A.id,A),A}}e.$Jnc=a;const d=C=>{if(C.profile){if(!(C.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class w{static fromPublic(I,W,V,q){return new w(I,(0,T.$Ug)(),V.include?.map(A=>o.$5K.fromExtHostTestItem(A,I).toString())??[I],V.exclude?.map(A=>o.$5K.fromExtHostTestItem(A,I).toString())??[],q,W)}static fromInternal(I,W){return new w(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,W)}constructor(I,W,V,q,A,B){this.controllerId=I,this.id=W,this.isPersisted=A,this.colllection=B,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(I){const W=o.$5K.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$Knc=w;class ${get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,r.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const W=o.$5K.parentId(I.item.extId);if(W&&this.h.has(W.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:W,g:V}=this;return{get added(){return[...I].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends i.$bL{constructor(){super(...arguments),this.s=new N.$fe,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,W){return{...I,revived:r.TestItem.toPlain(I.item),depth:W?W.depth+1:0,children:new Set}}v(){return new $(this.s)}}class y{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(W=>W.revived)},dispose:(0,R.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new v({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const h=(C,I,W,V)=>{W?Object.assign(W,V):I.$updateTestRunConfig(C.controllerId,C.profileId,V)};class D{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,h(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,h(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),h(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,h(this,this.#e,this.#n,{tag:I?r.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,h(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return N.Event.chain(this.#i,I=>I.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$gg))}constructor(I,W,V,q,A,B,K,ie,ce,ve=!1,Se=void 0,fe=!1){this.controllerId=A,this.profileId=B,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=Se,this.g=fe,this.#e=I,this.#s=W,this.#t=V,this.#i=q,W.set(B,this);const $e=k[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);ve&&V.add(B),this.#n={profileId:B,controllerId:A,tag:Se?r.TestTag.namespace(this.controllerId,Se.id):null,label:K,group:$e,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Lnc=D;const k={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(ke[117],Ie([1,0,57,14,91,8,7]),function(le,e,P,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=e.$QO=void 0;class p{static{this.c=new M.$OO("TextEditorDecorationType")}constructor(l,b,f){const r=p.c.nextId();l.$registerTextEditorDecorationType(b.identifier,r,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$QO=p;class m{constructor(l,b){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,b){this.k();let f=null;if(l instanceof R.$jM)f=new R.$kM(l,l);else if(l instanceof R.$kM)f=l;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(l,b){this.k(),this.l(new R.$kM(l,l),b,!0)}delete(l){this.k();let b=null;if(l instanceof R.$kM)b=l;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(l,b,f){const r=this.c.validateRange(l);this.g.push({range:r,text:b,forceMoveMarkers:f})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=l}}class E{constructor(l,b,f,r){this.c=l,this.d=b,this._accept(f),this.e=r;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}n(l){const b=this.m(l);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}p(l){const b=this.o(l);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const b=this.q(l);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let f=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(f=!0,b.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,b.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(f=!0,b.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,f=!0,b.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(f=!0,b.insertSpaces=r):this.j!==r&&(this.j=r,f=!0,b.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,f=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,f=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(l,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(f)})}}e.$RO=E;class T{constructor(l,b,f,r,s,o,n,i){this.id=l,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=s,this.d=new E(this.j,this.id,o,f),this.e=n,this.f=i;const c=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof R.$lM))throw(0,O.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof R.$lM)))throw(0,O.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new O.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new m(r.value,t);return u(g),c.m(g)},insertSnippet(u,t,g={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(d=>N.Range.from(d));else if(t instanceof R.$jM){const{lineNumber:d,column:w}=N.Position.from(t);a=[{startLineNumber:d,startColumn:w,endLineNumber:d,endColumn:w}]}else if(t instanceof R.$kM)a=[N.Range.from(t)];else{a=[];for(const d of t)if(d instanceof R.$kM)a.push(N.Range.from(d));else{const{lineNumber:w,column:$}=N.Position.from(d);a.push({startLineNumber:w,startColumn:$,endLineNumber:w,endColumn:$})}}return b.$tryInsertSnippet(l,r.value.version,u.value,a,g)},setDecorations(u,t){const g=t.length===0;g&&!c.h.has(u.key)||(g?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(N.$GO(t))return b.$trySetDecorations(l,u.key,N.$HO(t));{const a=new Array(4*t.length);for(let d=0,w=t.length;d<w;d++){const $=t[d];a[4*d]=$.start.line+1,a[4*d+1]=$.start.character+1,a[4*d+2]=$.end.line+1,a[4*d+3]=$.end.character+1}return b.$trySetDecorationsFast(l,u.key,a)}}))},revealRange(u,t){c.n(()=>b.$tryRevealRange(l,N.Range.from(u),t||R.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(l,N.ViewColumn.from(u))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,P.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,P.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,P.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,P.ok)(!this.g),this.f=l}_acceptSelections(l){(0,P.ok)(!this.g),this.c=l}async l(){const l=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(s=>s.range);f.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=f.length-1;s<o;s++){const n=f[s].end;if(f[s+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(s=>({range:N.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$SO=T}),define(ke[68],Ie([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;class o{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new b.$Ac,this.d=new O.$fe,this.e=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],g=[];if(c.removedDocuments)for(const a of c.removedDocuments){const d=N.URI.revive(a),w=this.c.get(d);w?.unref()&&(this.c.delete(d),u.push(w.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const d=N.URI.revive(a.uri);let w=this.c.get(d);if(w&&d.scheme!==f.Schemas.vscodeNotebookCell&&d.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);w||(w=new o(new m.$MO(this.h.getProxy(p.$gM.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(d,w),t.push(w.value)),w.ref()}if(c.removedEditors)for(const a of c.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&g.push(d)}if(c.addedEditors)for(const a of c.addedEditors){const d=N.URI.revive(a.documentUri);P.ok(this.c.has(d),`document '${d}' does not exist`),P.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const w=this.c.get(d).value,$=new T.$SO(a.id,this.h.getProxy(p.$gM.MainThreadTextEditors),this.i,new s.$V(()=>w.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(v=>S.Range.to(v)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,$)}c.newActiveEditor!==void 0&&(P.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,M.$Pc)(u),(0,M.$Pc)(g),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$TO=n,e.$TO=n=Je([We(0,E.$JO),We(1,l.$5j)],n),e.$UO=(0,R.$yi)("IExtHostDocumentsAndEditors")}),define(ke[290],Ie([1,0,18,5,4,117,8,7]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class m{constructor(T,S){this.i=S,this.a=new O.$fe,this.b=new O.$fe,this.c=new O.$fe,this.d=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(M.$gM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const S=this.i.allEditors();return T?S:S.map(l=>l.value)}async showTextDocument(T,S,l){let b;typeof S=="number"?b={position:R.ViewColumn.from(S),preserveFocus:l}:typeof S=="object"?b={position:R.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?R.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(T.uri,b),r=f&&this.i.getEditor(f);if(r)return r.value;throw f?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,S){return new N.$QO(this.h,T,S).value}$acceptEditorPropertiesChanged(T,S){const l=this.i.getEditor(T);if(!l)throw new Error("unknown text editor");if(S.options&&l._acceptOptions(S.options),S.selections){const b=S.selections.selections.map(R.Selection.to);l._acceptSelections(b)}if(S.visibleRanges){const b=P.$Hb(S.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(b)}if(S.options&&this.b.fire({textEditor:l.value,options:{...S.options,lineNumbers:R.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const b=p.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:f,kind:b})}if(S.visibleRanges){const b=P.$Hb(S.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(T){for(const S in T){const l=this.i.getEditor(S);if(!l)throw new Error("Unknown text editor");const b=R.ViewColumn.to(T[S]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this.d.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$5lc=m}),define(ke[291],Ie([1,0,2,3,4,6,7,8,21,15]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=e.$Nnc=void 0,e.$Nnc=(0,O.$yi)("IExtHostTimeline");class T{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(M.$gM.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(r,s)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&m.$Tm.equals(s,this.b.get(r.source)?.extension)){const o=r.uri===void 0?void 0:P.URI.revive(r.uri);return this.c.get(r.source)?.get(S(o))?.get(r.handle)}else return;return r}})}async $getTimeline(b,f,r,s){return this.b.get(b)?.provider.provideTimeline(P.URI.revive(f),r,s)}registerTimelineProvider(b,f,r,s){const o=new N.$Tc,n=this.d(f.id,s,o).bind(this);let i;f.onDidChange&&(i=f.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:f.id}),this));const c=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(u,t,g){t?.resetCache&&(o.clear(),c.get(f.id)?.clear());const a=await f.provideTimeline(u,t,g);if(a==null)return;const d=n(u,t);return{...a,source:f.id,items:a.items.map(d)}},dispose(){for(const u of c.values())u.get(f.id)?.clear();i?.dispose(),o.dispose()}},r)}d(b,f,r){return(s,o)=>{let n;if(o?.cacheResults){let i=this.c.get(b);i===void 0&&(i=new Map,this.c.set(b,i));const c=S(s);n=i.get(c),n===void 0&&(n=new Map,i.set(c,n))}return i=>{const{iconPath:c,...u}=i,t=`${b}|${i.id??i.timestamp}`;n?.set(t,i);let g,a,d;i.iconPath&&(c instanceof R.$fN?d={id:c.id,color:c.color}:P.URI.isUri(c)?(g=c,a=c):{light:g,dark:a}=c);let w;return R.$KM.isMarkdownString(u.tooltip)?w=p.MarkdownString.from(u.tooltip):(0,E.$$f)(u.tooltip)?w=u.tooltip:R.$KM.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=p.MarkdownString.from(u.detail)):(0,E.$$f)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=u.detail),{...u,id:u.id??void 0,handle:t,source:b,command:i.command?f.toInternal(i.command,r):void 0,icon:g,iconDark:a,themeIcon:d,tooltip:w,accessibilityInformation:i.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,N.$Sc)(()=>{for(const s of this.c.values())s.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Onc=T;function S(l){return l?.toString()}}),define(ke[292],Ie([1,0,181,24,2,5,6,222,11,7,15,18,8,55,20,143,25]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;function o(c,u){if((0,T.$$f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends R.$Uc{constructor(u,t,g){super(),this.f=u,this.g=t,this.h=g,this.a=new Map,this.b=new r.$G0;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(w=>a(w)?this.r(w):w):d})}registerTreeDataProvider(u,t,g){const a=this.createTreeView(u,{treeDataProvider:t},g);return{dispose:()=>a.dispose()}}createTreeView(u,t,g){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,$=!!t.dragAndDropController?.handleDrop,v=this.m(u,t,g),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:w,hasHandleDrop:$,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),D={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,s.$SG)(g,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,s.$SG)(g,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(k){(0,b.$Xk)(k)&&(0,s.$SG)(g,"treeViewMarkdownMessage"),v.message=k},get title(){return v.title},set title(k){v.title=k},get description(){return v.description},set description(k){v.description=k},get badge(){return v.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?v.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(v.badge=void 0)},reveal:(k,C)=>v.reveal(k,C),dispose:async()=>{await h,this.a.delete(u),v.dispose()}};return this.B(D),D}$getChildren(u,t){const g=this.a.get(u);return g?g.getChildren(t):Promise.reject(new p.$7F(u))}async $handleDrop(u,t,g,a,d,w,$,v){const y=this.a.get(u);if(!y)return Promise.reject(new p.$7F(u));const h=l.DataTransfer.toDataTransfer(g,async D=>(await this.f.$resolveDropFileData(u,t,D)).buffer);return $===u&&v&&await this.j(h,y,v,d,w),y.onDrop(h,a,d)}async j(u,t,g,a,d){const w=this.b.removeDragOperationTransfer(d);if(w)(await w)?.forEach(($,v)=>{$&&u.set(v,$)});else if(d&&t.handleDrag){const $=t.handleDrag(g,u,a);this.b.addDragOperationTransfer(d,$),await $}return u}async $handleDrag(u,t,g,a){const d=this.a.get(u);if(!d)return Promise.reject(new p.$7F(u));const w=await this.j(new E.$bN,d,t,a,g);if(!(!w||a.isCancellationRequested))return l.DataTransfer.from(w)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new p.$7F(u);return t.hasResolve}$resolve(u,t,g){const a=this.a.get(u);if(!a)throw new p.$7F(u);return a.resolveTreeItem(t,g)}$setExpanded(u,t,g){const a=this.a.get(u);if(!a)throw new p.$7F(u);a.setExpanded(t,g)}$setSelectionAndFocus(u,t,g){const a=this.a.get(u);if(!a)throw new p.$7F(u);a.setSelectionAndFocus(t,g)}$setVisible(u,t){const g=this.a.get(u);if(!g){if(!t)return;throw new p.$7F(u)}g.setVisible(t)}$changeCheckboxState(u,t){const g=this.a.get(u);if(!g)throw new p.$7F(u);g.setCheckboxState(t)}m(u,t,g){const a=this.B(new i(u,t,this.f,this.g.converter,this.h,g));return this.a.set(u,a),a}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$Pnc=n;class i extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,T.$hg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,g,a,d,w){if(super(),this.I=u,this.J=g,this.L=a,this.M=d,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$fe),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$fe),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$fe),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$fe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$fe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$fe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$fe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$qe,w.contributes&&w.contributes.views)for(const h in w.contributes.views)for(const D of w.contributes.views[h])D.id===u&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let $,v;const y=N.Event.debounce(this.F.event,(h,D)=>(h||(h={message:!1,elements:[]}),D.element!==!1&&($||($=new Promise(k=>v=k),this.G=this.G.then(()=>$)),Array.isArray(D.element)?h.elements.push(...D.element):h.elements.push(D.element)),D.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const k=v;return $=null,this.$(D).then(()=>k())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let g=this.X(u);return g||(g=await this.Y(t)),g?g.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const g=(0,T.$hg)(t.select)?!0:t.select,a=(0,T.$hg)(t.focus)?!1:t.focus,d=(0,T.$hg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(w=>this.W(u,w[w.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:w.map(v=>v.item)},{select:g,focus:a,expand:d})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:g,focus:a,expand:d})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const g=this.getExtensionElement(u);g&&(t?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(u,t){const g=!(0,S.$ub)(this.s,u);this.s=u;const a=this.t!==t;this.t=t,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async g=>{const a=this.getExtensionElement(g.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:g.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);t.forEach(g=>{g.treeItem.checkboxState=g.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(g=>[g.extensionItem,g.newState])})}async handleDrag(u,t,g){const a=[];for(const d of u){const w=this.getExtensionElement(d);w&&a.push(w)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,g),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,g){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,m.$qh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const g=this.j.get(u);if(g){const a=this.m.get(g);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,g,t)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(g=>this.W(t,g[g.length-1]).then(a=>(g.push(a),g))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$qh)(()=>this.f.getParent(u))}W(u,t){const g=this.m.get(u);return g?Promise.resolve(g):(0,m.$qh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const w=this.m.get(d);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const g=this.getExtensionElement(u);t=g?this.m.get(g):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new f.$qe(this.Z.token);try{const g=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const d=(0,S.$Hb)(a||[]),w=await Promise.all((0,S.$Hb)(d).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const $=w.map((v,y)=>v?this.db(d[y],v,g):null);return(0,S.$Hb)($)}finally{t.dispose()}}$(u){if(u.some(g=>!g))return this.Z.dispose(!0),this.Z=new f.$qe,this.tb(),this.J.$refresh(this.I);{const g=this.ab(u);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(u){const t=new Set,g=u.map(d=>this.m.get(d));for(const d of g)if(d&&!t.has(d.item.handle)){let w=d;for(;w&&w.parent&&g.findIndex($=>w&&w.parent&&$&&$.item.handle===w.parent.item.handle)===-1;){const $=this.j.get(w.parent.item.handle);w=$?this.m.get($):void 0}w&&!w.parent&&t.add(d.item.handle)}const a=[];return t.forEach(d=>{const w=this.j.get(d);if(w){const $=this.m.get(w);$&&(!$.parent||!t.has($.parent.item.handle))&&a.push(d)}}),a}bb(u){const t={};return Promise.all(u.map(g=>this.cb(g).then(a=>{a&&(t[g]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const g=this.m.get(t);if(g)return this.rb(t),(0,m.$qh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const d=this.ib(t,a,g.parent);return this.pb(t,d,g,g.parent),g.dispose(),d}return null})}return Promise.resolve(null)}db(u,t,g){const a=this.ib(u,t,g);if(t.id&&this.j.has(a.item.handle))throw new Error((0,P.localize)(0,null,t.id));return this.ob(u,a),this.qb(a,g),a}eb(u){return E.$KM.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,g,a;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,g=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:a}}hb(u){if(!E.$9M.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,g){this.hb(t);const a=this.B(new R.$Tc),d=this.kb(u,t,g),w=this.lb(t);return{item:{handle:d,parentHandle:g?g.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,T.$hg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:g,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof E.$fN?u.iconPath:void 0}kb(u,{id:t,label:g,resourceUri:a},d,w){if(t)return`${i.b}/${t}`;const $=o(g,this.N),v=d?d.item.handle:i.a;let y=$?$.label:a?(0,O.$9g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,D=this.X(d)||[];let k,C=0;do{if(k=`${v}/${C}:${y}`,w||!this.j.has(k)||h===k)break;C++}while(C<=D.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$fN))return typeof u.iconPath=="string"||M.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$fN)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return M.URI.isUri(u)?u:M.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,g,a){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(u,t);const d=this.X(a)||[],w=d.filter($=>$.item.handle===g.item.handle)[0];w&&d.splice(d.indexOf(w),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const g of t.children){const a=this.j.get(g.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const g of t.children){const a=this.j.get(g.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[293],Ie([1,0,5,6,2,33,8,64,4,7]),function(le,e,P,O,M,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class T extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,r,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new P.$fe),this.onDidDispose=this.#d.event,this.#h=this.B(new P.$fe),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=r,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,M.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:R.ViewColumn.from(f),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends O.$Uc{static c(){return(0,N.$Ug)()}constructor(f,r,s){super(),this.j=r,this.m=s,this.g=new Map,this.h=new Map,this.f=f.getProxy(m.$gM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,r,s,o,n={}){const i=typeof o=="object"?o.viewColumn:o,c={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,p.$hmc)(f),t=S.c();this.f.$createWebviewPanel((0,p.$jmc)(f),t,r,{title:s,panelOptions:l(n),webviewOptions:(0,p.$kmc)(f,this.m,n),serializeBuffersForPostMessage:u},c);const g=this.j.createNewWebview(t,n,f);return this.createNewWebviewPanel(t,r,s,i,n,g,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((s,o)=>{const n=f[s],i=f[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const s of r){const o=this.getWebviewPanel(s);if(!o)continue;const n=f[s];o._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,r,s){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:s,extension:f}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,p.$hmc)(f)}),new E.$iM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,s,o){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:c}=n,u=this.j.createNewWebview(f,s.webviewOptions,c),t=this.createNewWebviewPanel(f,r,s.title,o,s.panelOptions,u,s.active);await i.deserializeWebviewPanel(t,s.state)}createNewWebviewPanel(f,r,s,o,n,i,c){const u=new T(f,this.f,i,{viewType:r,title:s,viewColumn:o,panelOptions:n,active:c});return this.g.set(f,u),u}getWebviewPanel(f){return this.g.get(f)}}e.$lmc=S;function l(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(ke[294],Ie([1,0,5,6,64,8,4,7]),function(le,e,P,O,M,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=void 0;class m extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,l,b,f,r,s){super(),this.#s=!1,this.#u=this.B(new P.$fe),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new P.$fe),this.onDidDispose=this.#l.event,this.#i=b,this.#a=f,this.#e=S,this.#t=l,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$gM.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,b,f){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:b,extension:S}),this.a.$registerWebviewViewProvider((0,M.$jmc)(S),l,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$hmc)(S)}),new p.$iM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,b,f,r){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:o,extension:n}=s,i=this.d.createNewWebview(S,{},n),c=new m(S,this.a,l,b,i,!0);this.c.set(S,c),await o.resolveWebviewView(c,{state:f},r)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$Snc=E}),define(ke[295],Ie([1,0,5,29,31,3]),function(le,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$BL=e.OutputChannelUpdateMode=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=void 0,e.$oL="text/x-code-output",e.$pL="output",e.$qL="Log",e.$rL="text/x-code-log-output",e.$sL="log",e.$tL="workbench.panel.output",e.$uL=new M.$Pj("inOutput",!1),e.$vL=new M.$Pj("activeLogOutput",!1),e.$wL=new M.$Pj("activeLogOutput.levelSettable",!1),e.$xL=new M.$Pj("activeLogOutput.level",""),e.$yL=new M.$Pj("activeLogOutput.levelIsDefault",!1),e.$zL=new M.$Pj("outputView.scrollLock",!1),e.$AL=(0,N.$yi)("outputService");var R;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$BL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new P.$fe,this.onDidRegisterChannel=this.b.event,this.c=new P.$fe,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$fo.add(e.$BL.OutputChannels,new p),e.$CL=new M.$Pj("activeOutputChannel","")}),define(ke[118],Ie([1,0,4,3,17,21,12,295,65,27,46,147,22,15,38,5,6]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0;class o extends R.$$j{get disposed(){return this.n}constructor(u,t,g,a,d){super(),this.id=u,this.name=t,this.r=g,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$He.fromString(t).byteLength,(0,R.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(u){this.append(u)}}let i=class{constructor(u,t,g,a,d,w){this.i=t,this.j=g,this.k=a,this.l=d,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(P.$gM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,g]of this.g)g.visible=t===this.h}createOutputChannel(u,t,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,d=(0,b.$$f)(t)?t:void 0;if((0,b.$$f)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const $=this.i.environment.extensionLogLevel?.find(([y])=>N.$Tm.equals(g.identifier,y))?.[1];$&&(w=(0,R.$jk)($));const v=a?this.o(u,w,g):this.n(u,d,g);return v.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,w??this.m.getLevel(),v):this.q(u,v)}async n(u,t,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(u,d,t,g.identifier.value);return new o($,u,w,this.a,g)}async o(u,t,g){const a=await this.p(g),d=u.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(a,`${d}.log`),$=`${g.identifier.value}.${d}`,v=this.l.createLogger(w,{id:$,name:u,logLevel:t,extensionId:g.identifier.value});return new n($,u,v,this.a,g)}p(u){let t=this.d.get(u.identifier.value);if(!t){const g=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(g)}catch(a){if((0,f.$il)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return g})())}return t}q(u,t){let g=!1;const a=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return u},append(d){a(),t.then(w=>w.append(d))},appendLine(d){a(),t.then(w=>w.appendLine(d))},clear(){a(),t.then(d=>d.clear())},replace(d){a(),t.then(w=>w.replace(d))},show(d,w){a(),t.then($=>$.show(d,w))},hide(){a(),t.then(d=>d.hide())},dispose(){g=!0,t.then(d=>d.dispose())}}}r(u,t,g){const a=new s.$Tc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},w=a.add(new r.$fe);function $(v){t=v,w.fire(v)}return g.then(v=>{a.add(v),v.logLevel!==t&&$(v.logLevel),a.add(v.onDidChangeLogLevel(y=>$(y)))}),{...this.q(u,g),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(v,...y){d(),g.then(h=>h.trace(v,...y))},debug(v,...y){d(),g.then(h=>h.debug(v,...y))},info(v,...y){d(),g.then(h=>h.info(v,...y))},warn(v,...y){d(),g.then(h=>h.warn(v,...y))},error(v,...y){d(),g.then(h=>h.error(v,...y))},dispose(){a.dispose()}}}};e.$rnc=i,e.$rnc=i=Je([We(0,M.$JO),We(1,E.$ZO),We(2,m.$dmc),We(3,T.$Slc),We(4,R.$6j),We(5,R.$5j)],i),e.$snc=(0,O.$yi)("IExtHostOutputService")}),define(ke[119],Ie([1,0,3,11]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,P.$yi)("remoteAgentService"),e.$jn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let N=1/0;for(let p=0;p<this.maxSampleCount;p++){const m=await M.getRoundTripTime();if(m===void 0)return;N=Math.min(N,m/2),await(0,O.$zh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((p,m)=>p+m,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((p,m)=>p+m,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[296],Ie([1,0,184,51,29,45,50,6,5,119,23,26,11]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=e.$Jgb=e.$Igb=void 0,e.$Igb=Object.freeze({id:"application",order:100,title:(0,P.localize)(0,null),type:"object"}),e.$Jgb=Object.freeze({id:"workbench",order:7,title:(0,P.localize)(1,null),type:"object"}),e.$Kgb=Object.freeze({id:"security",scope:1,title:(0,P.localize)(2,null),type:"object",order:7}),e.$Lgb=Object.freeze({id:"problems",title:(0,P.localize)(3,null),type:"object",order:101}),e.$Mgb={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new m.$fe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const f=new b;M.$fo.add(e.$Mgb.ConfigurationMigration,f);let r=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(c=>this.g(c,n?.uri))])}async g(n,i){const c=this.a.inspect(n.key,{resource:i}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,g]of u){const a=c[t];if(!a)continue;const d=[];if(a.value!==void 0){const w=await this.h(n,t,a.value,i,void 0);for(const $ of w??[])d.push([$,[]])}for(const{identifiers:w,value:$}of a.overrides??[])if($!==void 0){const v=await this.h(n,t,$,i,w);for(const y of v??[])d.push([y,w])}d.length&&await Promise.allSettled(d.map(async([[w,$],v])=>this.a.updateValue(w,$.value,{resource:i,overrideIdentifiers:v},g)))}}async h(n,i,c,u,t){const g=d=>{const $=this.a.inspect(d,{resource:u})[i];if($)return t?$.overrides?.find(({identifiers:v})=>(0,S.$9n)(v,t))?.value:$.value},a=await n.migrateFn(c,g);return Array.isArray(a)?a:[[n.key,a]]}};e.$Ngb=r,e.$Ngb=r=Je([We(0,R.$5i),We(1,N.$Hi)],r);let s=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new l.$Vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$fo.as(O.$ko.Configuration).registerConfiguration({...e.$Kgb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,P.localize)(4,null)},default:[],markdownDescription:(0,P.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,P.localize)(6,null),scope:2}}})}};e.$Ogb=s,e.$Ogb=s=Je([We(0,E.$in)],s)}),define(ke[297],Ie([1,0,37,16,19,24,193,296,51,3,29]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Qgb=e.$Pgb=void 0,e.$Rgb=r,e.$Sgb=s,e.$Pgb=(0,E.$yi)("editorResolverService"),e.$Qgb="workbench.editorAssociations";const S=T.$fo.as(m.$ko.Configuration),l={...p.$Jgb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var b;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(b||(e.RegisteredEditorPriority=b={}));var f;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function r(o){switch(o){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function s(o,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const u=typeof o=="string"&&o.indexOf(M.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,N.$9g)(n);return P.$rk(typeof o=="string"?o.toLowerCase():o,u.toLowerCase())}}),define(ke[298],Ie([1,0,48,16,19,23,24,2,3,214,45,236,119]),function(le,e,P,O,M,N,R,p,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=void 0,e.$UL=(0,m.$yi)("pathService");let f=b=class{constructor(s,o,n,i){this.d=s,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(s,i,o)):this.h(s,o,n)}h(s,o,n){return s.scheme===O.Schemas.file||s.scheme===O.Schemas.vscodeRemote?(0,P.$vg)(n??(0,R.$9g)(s),o===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,E.$RL)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const c=o.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?M.$fc:M.$gc)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(o=s.substring(2),s="/"):(o=s.substring(2,i),s=s.substring(i)||"/")}return p.URI.from({scheme:O.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$VL=f,e.$VL=f=b=Je([We(1,l.$in),We(2,S.$DL),We(3,T.$Hi)],f)}),define(ke[120],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$nK=e.$mK=void 0;class P{constructor(R,p){this.line=R,this.character=p}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,p){return new P(0,0)}with(R){return new P(0,0)}}e.$mK=P;class O{constructor(R,p,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new P(R,p),this.end=new P(m,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new O(0,0,0,0)}with(R){return new O(0,0,0,0)}}e.$nK=O;var M;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(ke[47],Ie([1,0,18,37,26,48,13,3,19,14,120,11]),function(le,e,P,O,M,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$KK=e.$DK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$AK=e.$zK=e.$yK=e.$xK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.TextSearchCompleteMessageType=void 0,e.$uK=o,e.$vK=n,e.$wK=i,e.$BK=v,e.$CK=y,e.$EK=k,e.$FK=C,e.$GK=I,e.$HK=W,e.$IK=V,e.$JK=q,e.$LK=B,e.$NK=ce,e.$OK=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$oK="workbench.view.search",e.$pK="workbench.panel.search",e.$qK="workbench.view.search",e.$rK="search-result",e.$sK="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",f=(l.length+b.length+5)*2;e.$tK=(0,p.$yi)("searchService");var r;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text",fe[fe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text",fe[fe.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(fe){return!!fe.preview}function n(fe){return!!fe.resource}function i(fe){return!!fe.message}var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor($e){this.resource=$e,this.results=[]}}e.$xK=u;class t{constructor($e,Te,ae,Re){this.ranges=Te,this.webviewIndex=Re;const ne=Array.isArray(Te)?Te:[Te];if(ae&&ae.matchLines===1&&g(ne)){$e=(0,R.$4f)($e,ae.matchLines);let z="",x=0,be=0;const Fe=Math.floor(ae.charsPerLine/5),De=[];for(const pe of ne){const ge=Math.max(pe.startColumn-Fe,0),Q=pe.startColumn+ae.charsPerLine;if(ge>be+Fe+f){const Y=l+(ge-be)+b;z+=Y+$e.slice(ge,Q),x+=ge-(be+Y.length)}else z+=$e.slice(be,Q);De.push(new d(0,pe.startColumn-x,pe.endColumn-x)),be=Q}this.preview={text:z,matches:Array.isArray(this.ranges)?De:De[0]}}else{const z=Array.isArray(Te)?Te[0].startLineNumber:Te.startLineNumber;this.preview={text:$e,matches:(0,P.$1b)(Te,x=>new a(x.startLineNumber-z,x.startColumn,x.endLineNumber-z,x.endColumn))}}}}e.$yK=t;function g(fe){const $e=fe[0].startLineNumber;for(const Te of fe)if(Te.startLineNumber!==$e||Te.endLineNumber!==$e)return!1;return!0}class a{constructor($e,Te,ae,Re){this.startLineNumber=$e,this.startColumn=Te,this.endLineNumber=ae,this.endColumn=Re}}e.$zK=a;class d extends a{constructor($e,Te,ae){super($e,Te,$e,ae)}}e.$AK=d;var w;(function(fe){fe.List="list",fe.Tree="tree"})(w||(e.ViewMode=w={}));var $;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function v(fe,$e=!0){const Te=fe&&fe.files&&fe.files.exclude,ae=$e&&fe&&fe.search&&fe.search.exclude;if(!Te&&!ae)return;if(!Te||!ae)return Te||ae;let Re=Object.create(null);return Re=M.$8n(Re,M.$5n(Te)),Re=M.$8n(Re,M.$5n(ae),!0),Re}function y(fe,$e){return fe.excludePattern&&O.$rk(fe.excludePattern,$e)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&O.$rk(fe.includePattern,$e)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(Te=>{const ae=Te.folder.fsPath;if(N.$xg($e,ae)){const Re=m.$lc(ae,$e);return!Te.includePattern||!!O.$rk(Te.includePattern,Re)}else return!1}):!1:!0}var h;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class D extends Error{constructor($e,Te){super($e),this.code=Te}}e.$DK=D;function k(fe){const $e=fe.message;if((0,E.$4)(fe))return new D($e,h.canceled);try{const Te=JSON.parse($e);return new D(Te.message,Te.code)}catch{return new D($e,h.other)}}function C(fe){const $e={message:fe.message,code:fe.code};return new Error(JSON.stringify($e))}function I(fe){return fe.type==="error"?!0:fe.type==="success"}function W(fe){return fe.type==="success"}function V(fe){return!!fe.path}function q(fe,$e,Te=!0){const ae=fe.searchPath?fe.searchPath:fe.relativePath;return Te?(0,R.$1f)(ae,$e):O.$rk($e,ae)}class A{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$KK=A;function B(fe,$e){const Te={...fe||{},...$e||{}};return Object.keys(Te).filter(ae=>{const Re=Te[ae];return typeof Re=="boolean"&&Re})}class K{constructor($e,Te){this.c=null,this.a={...$e.excludePattern||{},...Te.excludePattern||{}},this.b=O.$sk(this.a);let ae=$e.includePattern;Te.includePattern&&(ae?ae={...ae,...Te.includePattern}:ae=Te.includePattern),ae&&(this.c=O.$sk(ae))}matchesExcludesSync($e,Te,ae){return!!(this.b&&this.b($e,Te,ae))}includedInQuerySync($e,Te,ae){return!(this.b&&this.b($e,Te,ae)||this.c&&!this.c($e,Te,ae))}includedInQuery($e,Te,ae){const Re=this.b($e,Te,ae),ne=()=>this.c?!!this.c($e,Te,ae):!0;return(0,S.$kh)(Re)?Re.then(z=>z?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$MK=K;function ie(fe){for(const $e in fe)if(typeof fe[$e]!="boolean")return!0;return!1}function ce(fe){if(!fe)return;let $e;return Te=>($e||($e=(fe()||Promise.resolve([])).then(ae=>ae?Se(ae):{})),$e.then(ae=>!!ae[Te]))}function ve(fe){if(!fe)return;let $e;return Te=>{if(!$e){const ae=fe();$e=ae?Se(ae):{}}return!!$e[Te]}}function Se(fe){const $e={};for(const Te of fe)$e[Te]=!0;return $e}}),define(ke[39],Ie([1,0,18,11,20,5,6,54,16,129,24,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g,a,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=e.$0lc=void 0;function $(W,V,q){return new T.$1g(A=>D(A,q)).isEqual(W,V)}function v(W,V,q){return $(W.uri,V.uri,q)?0:(0,S.$sf)(W.uri.toString(),V.uri.toString())}function y(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:$(W.uri,V.uri,q)?(0,S.$sf)(W.name,V.name):(0,S.$sf)(W.uri.toString(),V.uri.toString())}function h(W,V,q,A){const B=W.slice(0).sort((ie,ce)=>q(ie,ce,A)),K=V.slice(0).sort((ie,ce)=>q(ie,ce,A));return(0,P.$Eb)(B,K,(ie,ce)=>q(ie,ce,A))}function D(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class k extends o.$Ri{static toExtHostWorkspace(V,q,A,B){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ve,transient:Se,isUntitled:fe}=V,$e=[],Te=q;q?ce.forEach((z,x)=>{const be=l.URI.revive(z.uri),Fe=k.o(A||q,be,B);Fe?(Fe.name=z.name,Fe.index=z.index,$e.push(Fe)):$e.push({uri:be,name:z.name,index:x})}):$e.push(...ce.map(({uri:z,name:x,index:be})=>({uri:l.URI.revive(z),name:x,index:be}))),$e.sort((z,x)=>z.index<x.index?-1:1);const ae=new k(K,ie,$e,!!Se,ve?l.URI.revive(ve):null,!!fe,z=>D(z,B)),{added:Re,removed:ne}=h(Te?Te.workspaceFolders:[],ae.workspaceFolders,v,B);return{workspace:ae,added:Re,removed:ne}}static o(V,q,A){for(let B=0;B<V.folders.length;B++){const K=V.workspaceFolders[B];if($(K.uri,q,A))return K}}constructor(V,q,A,B,K,ie,ce){super(V,A.map(ve=>new o.$Si(ve)),B,K,ce),this.t=q,this.u=ie,this.q=[],this.s=p.$Ei.forUris(ce),A.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$$g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,q,A,B,K){this.c=new N.$fe,this.onDidChangeWorkspace=this.c.event,this.g=new N.$fe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$he,this.C=new Map,this.h=B,this.s=A,this.t=K,this.j=new E.$Fm,this.k=new O.$xh,this.o=V.getProxy(d.$gM.MainThreadWorkspace),this.q=V.getProxy(d.$gM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?l.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>D(ce,A)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,T.$9g)((0,T.$$g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,A,...B){const K=[];if(Array.isArray(B)&&B.forEach(fe=>{l.URI.isUri(fe.uri)&&!K.some($e=>$($e.uri,fe.uri,this.s))&&K.push({uri:fe.uri,name:fe.name||(0,T.$8g)(fe.uri)})}),this.n||[q,A].some(fe=>typeof fe!="number"||fe<0)||A===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+A>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,A,...K.map(fe=>({uri:fe.uri,name:fe.name||(0,T.$8g)(fe.uri),index:void 0})));for(let fe=0;fe<ce.length;fe++){const $e=ce[fe];if(ce.some((Te,ae)=>ae!==fe&&$($e.uri,Te.uri,this.s)))return!1}ce.forEach((fe,$e)=>fe.index=$e);const{added:ve,removed:Se}=h(ie,ce,y,this.s);if(ve.length===0&&Se.length===0)return!1;if(this.o){const fe=V.displayName||V.name;this.o.$updateWorkspaceFolders(fe,q,A,K).then(void 0,$e=>{this.n=void 0;const Te={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(s.Severity.Error,(0,b.localize)(0,null,fe,$e.toString()),Te,[])})}return this.y(ce),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let A,B="";if(typeof V=="string"?(A=l.URI.file(V),B=V):typeof V<"u"&&(A=V,B=V.fsPath),!A)return B;const K=this.getWorkspaceFolder(A,!0);if(!K)return B;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$bh)(K.uri,A);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:A,removed:B}=k.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:B}))}findFiles(V,q,A,B,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},A,B=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,V,q,B)}async z(V,q,A,B=M.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ce;if(V){const{includePattern:ve,folder:Se}=I(u.GlobPattern.from(V));ce=Se,ie.includePattern=ve}else{const{includePattern:ve,folder:Se}=I(u.GlobPattern.from(q));ce=Se,ie.filePattern=ve}return this.o.$startFileSearch(ce??null,ie,B).then(ve=>Array.isArray(ve)?ve.map(Se=>l.URI.revive(Se)):[])}async findTextInFiles(V,q,A,B,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Se}=I(u.GlobPattern.from(q.include)),fe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,$e={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:fe},Te=!1;if(this.u[ie]=ae=>{if(Te)return;const Re=l.URI.revive(ae.resource);ae.results.forEach(ne=>{const z=(0,w.$8h)(ne);(0,a.$uK)(z)?A({uri:Re,preview:{text:z.preview.text,matches:(0,P.$1b)(z.preview.matches,x=>new t.$kM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,P.$1b)(z.ranges,x=>new t.$kM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Re,text:z.text,lineNumber:z.lineNumber})})},K.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(V,Se??null,$e,ie,K);return delete this.u[ie],ae||{}}catch(ae){throw delete this.u[ie],ae}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return l.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return l.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const A=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,A),(0,R.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const A=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const B=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!B),!B)return;const K=await B.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,A,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,A,B);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(V){return(q,A,B)=>{const K=function(ce){q.call(A,ce)};return K.extension=V,this.B.event(K,void 0,B)}}async $onWillCreateEditSessionIdentity(V,q,A){const B=await this.resolveWorkspaceFolder(l.URI.revive(V));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>A&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const A=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerCanonicalUriProvider(B,A),(0,R.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(V,q,A){const B=this.C.get(V.scheme);if(!B)return;const K=await B.provideCanonicalUri?.(l.URI.revive(V),q,A);if(K)return K}async $provideCanonicalUri(V,q,A){return this.provideCanonicalUri(l.URI.revive(V),{targetScheme:q},A)}};e.$0lc=C,e.$0lc=C=Je([We(0,c.$JO),We(1,i.$ZO),We(2,n.$Slc),We(3,r.$5j),We(4,g.$8lc)],C),e.$$lc=(0,f.$yi)("IExtHostWorkspace");function I(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=l.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(ke[40],Ie([1,0,26,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=e.$_lc=void 0;function r(g,a){if(a){const d=a.split(".");let w=g;for(let $=0;w&&$<d.length;$++)w=w[d[$]];return w}}function s(g){return g instanceof f.URI}function o(g){return g&&g.uri instanceof f.URI&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&g.uri instanceof f.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function c(g){if(s(g))return{resource:g};if(o(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(n(g))return{overrideIdentifier:g.languageId};if(i(g))return{resource:g.uri};if(g===null)return{resource:null}}let u=class{constructor(a,d,w){this.a=a.getProxy(N.$gM.MainThreadConfiguration),this.c=d,this.b=w,this.d=new T.$xh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(a,d))}};e.$_lc=u,e.$_lc=u=Je([We(0,l.$JO),We(1,M.$$lc),We(2,b.$5j)],u);class t{constructor(a,d,w,$){this.a=new O.$fe,this.b=a,this.f=$,this.c=d,this.e=p.$Do.parse(w,$),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Do.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,w))}getConfiguration(a,d,w){const $=c(d)||{},v=this.g(a?r(this.e.getValue(void 0,$,this.c.workspace),a):this.e.getValue(void 0,$,this.c.workspace));a&&this.h(a,$,w?.identifier);function y(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(D){return typeof r(v,D)<"u"},get:(D,k)=>{this.h(a?`${a}.${D}`:D,$,w?.identifier);let C=r(v,D);if(typeof C>"u")C=k;else{let I;const W=(V,q)=>{if((0,E.$ag)(V)){let A;const B=()=>{I=I||(0,P.$5n)(v),A=A||r(I,q)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return B(),()=>A;if(I)return A=A||r(I,q),A[ie];const ce=K[ie];return typeof ie=="string"?W(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(B(),A&&(A[ie]=ce),!0),deleteProperty:(K,ie)=>(B(),A&&delete A[ie],!0),defineProperty:(K,ie,ce)=>(B(),A&&Object.defineProperty(A,ie,ce),!0)})}return Array.isArray(V)?(0,P.$5n)(V):V};C=W(C,D)}return C},update:(D,k,C,I)=>{D=a?`${a}.${D}`:D;const W=y(C);return k!==void 0?this.b.$updateConfigurationOption(W,D,k,$,I):this.b.$removeConfigurationOption(W,D,$,I)},inspect:D=>{D=a?`${a}.${D}`:D;const k=this.e.inspect(D,$,this.c.workspace);if(k)return{key:D,defaultValue:(0,P.$5n)(k.policy?.value??k.default?.value),globalValue:(0,P.$5n)(k.user?.value??k.application?.value),workspaceValue:(0,P.$5n)(k.workspace?.value),workspaceFolderValue:(0,P.$5n)(k.workspaceFolder?.value),defaultLanguageValue:(0,P.$5n)(k.default?.override),globalLanguageValue:(0,P.$5n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,P.$5n)(k.workspace?.override),workspaceFolderLanguageValue:(0,P.$5n)(k.workspaceFolder?.override),languageIds:(0,P.$5n)(k.overrideIdentifiers)}}};return typeof v=="object"&&(0,P.$8n)(h,v,!1),Object.freeze(h)}g(a){const d=w=>(0,E.$ag)(w)?new Proxy(w,{get:($,v)=>d($[v]),set:($,v,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:($,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:($,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return d(a)}h(a,d,w){const $=m.$uo.test(a)?4:this.d.get(a),v=w?`[${w.value}] `:"";if($===4){typeof d?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){d?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const w=new p.$Fo(a,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:($,v)=>w.affectsConfiguration($,c(v))})}k(a){return a.reduce((d,w)=>(d.set(w[0],w[1]),d),new Map)}}e.$amc=t,e.$bmc=(0,S.$yi)("IExtHostConfiguration")}),define(ke[121],Ie([1,0,2,11,5,4,7,39,68,40,20,53,17,27,3,16,23,12,80,241,14]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=e.$Enc=e.$Dnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(u||(u={}));var t;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(t||(t={}));var g;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(g||(g={}));var a;(function(W){function V(B){if(B){const K=B;return K&&!!K.process}else return!1}W.is=V;function q(B){if(B==null)return;const K={process:B.process,args:B.args};return B.options&&(K.options=g.from(B.options)),K}W.from=q;function A(B){if(B!=null)return new R.$5M(B.process,B.args,B.options)}W.to=A})(a||(a={}));var d;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(d||(d={}));var w;(function(W){function V(B){if(B){const K=B;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(B){if(B==null)return;const K={};return B.commandLine!==void 0?K.commandLine=B.commandLine:(K.command=B.command,K.args=B.args),B.options&&(K.options=d.from(B.options)),K}W.from=q;function A(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new R.$6M(B.commandLine,B.options):new R.$6M(B.command,B.args?B.args:[],B.options)}W.to=A})(w||(w={}));var $;(function(W){function V(B){if(B){const K=B;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(B){return{customExecution:"customExecution"}}W.from=q;function A(B,K){return K.get(B)}W.to=A})($||(e.CustomExecutionDTO=$={}));var v;(function(W){function V(q,A){let B;return q.scope!==void 0&&typeof q.scope!="number"?B=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===R.TaskScope.Workspace&&A&&A.workspaceFile?B=A.workspaceFile:B=i.$gI),{id:q._id,workspaceFolder:B}}W.from=V})(v||(e.TaskHandleDTO=v={}));var y;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(y||(y={}));var h;(function(W){function V(B,K){if(B==null)return[];const ie=[];for(const ce of B){const ve=q(ce,K);ve&&ie.push(ve)}return ie}W.fromMany=V;function q(B,K){if(B==null)return;let ie;B.execution instanceof R.$5M?ie=a.from(B.execution):B.execution instanceof R.$6M?ie=w.from(B.execution):B.execution&&B.execution instanceof R.$7M&&(ie=$.from(B.execution));const ce=u.from(B.definition);let ve;return B.scope?typeof B.scope=="number"?ve=B.scope:ve=B.scope.uri:ve=R.TaskScope.Workspace,!ce||!ve?void 0:{_id:B._id,definition:ce,name:B.name,source:{extensionId:K.identifier.value,label:B.source,scope:ve},execution:ie,isBackground:B.isBackground,group:y.from(B.group),presentationOptions:t.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}W.from=q;async function A(B,K,ie){if(B==null)return;let ce;a.is(B.execution)?ce=a.to(B.execution):w.is(B.execution)?ce=w.to(B.execution):$.is(B.execution)&&(ce=$.to(B._id,ie));const ve=u.to(B.definition);let Se;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Se=B.source.scope:Se=await K.resolveWorkspaceFolder(P.URI.revive(B.source.scope)):Se=R.TaskScope.Workspace),!ve||!Se)return;const fe=new R.$8M(ve,Se,B.name,B.source.label,ce,B.problemMatchers);return B.isBackground!==void 0&&(fe.isBackground=B.isBackground),B.group!==void 0&&(fe.group=R.$4M.from(B.group._id),fe.group&&B.group.isDefault&&(fe.group=new R.$4M(fe.group.id,fe.group.label),B.group.isDefault===!0&&(fe.group.isDefault=B.group.isDefault))),B.presentationOptions&&(fe.presentationOptions=t.to(B.presentationOptions)),B._id&&(fe._id=B._id),B.detail&&(fe.detail=B.detail),fe}W.to=A})(h||(e.TaskDTO=h={}));var D;(function(W){function V(A){return A}W.from=V;function q(A){if(A)return Object.assign(Object.create(null),A)}W.to=q})(D||(D={}));class k{#e;constructor(V,q,A){this._id=q,this.a=A,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,q,A,B,K,ie,ce,ve){this.q=new M.$fe,this.r=new M.$fe,this.s=new M.$fe,this.u=new M.$fe,this.a=V.getProxy(N.$gM.MainThreadTask),this.b=A,this.c=B,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,A){if(!A)return new R.$iM(()=>{});const B=this.x();return this.j.set(B,{type:q,provider:A,extension:V}),this.a.$registerTaskProvider(B,q),new R.$iM(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(D.from(V)).then(async q=>{const A=[];for(const B of q){const K=await h.to(B,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,A){const B=this.m.get(V.id);B&&(this.o.set(V.id,B),this.e.attachPtyToTerminal(q,await B.callback(A))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));const B=[],K=(0,O.$qh)(()=>A.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,B,A,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(B).then(()=>{ie(ce)})})})}async $resolveTask(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const B=await h.to(q,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(B,T.CancellationToken.None);if(!K)return;this.A(K,A);const ie=h.from(K,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,q,A){const B=await this.a.$createTaskId(V);!A&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,q.execution)),this.m.set(B,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(V.id);if(A)return A;let B;return q?B=Promise.resolve(new k(this,V.id,q)):B=h.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,V.id,K)}),this.l.set(V.id,B),B.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const A=this.n.values();let B=A.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=A.next()}};e.$Dnc=C,e.$Dnc=C=Je([We(0,l.$JO),We(1,b.$ZO),We(2,p.$$lc),We(3,m.$UO),We(4,E.$bmc),We(5,S.$zmc),We(6,o.$5j),We(7,n.$Olc)],C);let I=class extends C{constructor(V,q,A,B,K,ie,ce,ve){super(V,q,A,B,K,ie,ce,ve),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=h.from(q,V);if(A===void 0)throw new Error("Task is not valid");if($.is(A.execution))await this.y(A,q,!1);else throw new c.$_;const B=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),B}v(V,q,A,B){const K=[];if(B)for(const ie of B){if(this.A(ie,A),!ie.definition||!V[ie.definition.type]){const ve=ie.source?ie.source:"No task source";this.f.warn(`The task [${ve}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=h.from(ie,A.extension);ce&&$.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(V){if($.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,A){}};e.$Enc=I,e.$Enc=I=Je([We(0,l.$JO),We(1,b.$ZO),We(2,p.$$lc),We(3,m.$UO),We(4,E.$bmc),We(5,S.$zmc),We(6,o.$5j),We(7,n.$Olc)],I),e.$Fnc=(0,f.$yi)("IExtHostTask")}),define(ke[299],Ie([1,0,47,30]),function(le,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=void 0,e.$UK=M,e.$WK=N;function M(R){return"cellResults"in R}e.$VK="rawCell#";function N(R,p){let m=-1;const E=[];let T=[];return R.forEach(l=>{l.range.startLineNumber!==m&&T.length>0&&(E.push([...T]),T=[]),T.push(l),m=l.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(l=>{const b=[],f=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let s=f;s<=r;s++)b.push(p.getLineContent(s));return new P.$yK(b.join(`
`)+`
`,l.map(s=>new O.$xt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(ke[300],Ie([1,0,177,22,5,6,28,13,15,2,38,76,4,35,8,7,34,276,114,26,16,231,299,297]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,$,v,y,h,D){this.q=v,this.r=y,this.s=h,this.t=D,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new M.$fe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$fe,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$fe,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$fe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Mlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=w.getProxy(l.$gM.MainThreadNotebook),this.c=w.getProxy(l.$gM.MainThreadNotebookDocuments),this.d=w.getProxy(l.$gM.MainThreadNotebookEditors),this.i=$.converter,$.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const C=k.notebookEditor?.notebookUri,I=k.cell.handle,V=this.g.get(C)?.getCell(I);if(V)return V.apiCell}if(k&&k.$mid===14){const C=k.uri,I=this.g.get(C);if(I)return I.apiNotebook}return k}}),a.B($)}getEditorById(w){const $=this.h.get(w);if(!$)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return $}getIdByEditor(w){for(const[$,v]of this.h)if(v.apiEditor===w)return $}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,$){const v=this.g.get(w);if(!v&&!$)throw new Error(`NO notebook document for '${w}'`);return v}static u(w,$){if(!$)return;const v=$.filenamePattern.map(y=>f.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if($.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${$.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:$.displayName,filenamePattern:v,exclusive:$.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,$,v){const y=a.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,v),this.b.$registerNotebookCellStatusBarItemProvider(y,h,$);let D;return h!==void 0&&(D=v.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(h))),new r.$iM(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),D?.dispose()})}async createNotebookDocument(w){const $=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&f.NotebookData.from(w.content)});return E.URI.revive($)}async openNotebookDocument(w){const $=this.g.get(w);if($)return $.apiNotebook;const v=await this.c.$tryOpenNotebook(w),y=this.g.get(E.URI.revive(v));return(0,m.$jg)(y?.apiNotebook)}async showNotebookDocument(w,$){E.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let v;typeof $=="object"?v={position:f.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selections:$.selections&&$.selections.map(f.NotebookRange.from),pinned:typeof $.preview=="boolean"?!$.preview:void 0}:v={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,v),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,$,v,y){const h=this.f.get(w),D=E.URI.revive($),k=this.g.get(D);if(!k||!h)return;const C=k.getCellFromIndex(v);if(!C)return;const I=await h.provideCellStatusBarItems(C.apiCell,y);if(!I)return;const W=new N.$Tc,V=this.p.add([W]),A=(Array.isArray(I)?I:[I]).map(B=>f.NotebookStatusBarItem.from(B,this.i,W));return{cacheId:V,items:A}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,$,v,y,h){if((0,p.$9e)($))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:$,serializer:v,options:y}),this.b.$registerNotebookSerializer(D,{id:w.identifier,location:w.extensionLocation},$,f.NotebookDocumentContentOptions.from(y),a.u(w,h)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(w,$,v){const y=this.x.get(w);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook($.buffer,v);return new s.$Ew(f.NotebookData.from(h))}async $notebookToData(w,$,v){const y=this.x.get(w);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(f.NotebookData.to($.value),v);return O.$He.wrap(h)}async $saveNotebook(w,$,v,y,h){const D=E.URI.revive($),k=this.x.get(w);if(!k)throw new Error("NO serializer found");const C=this.g.get(D);if(!C)throw new Error("Document NOT found");if(C.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new T.$nl((0,P.localize)(0,null,this.z(D)),6);await this.y(D,y);const I={metadata:(0,i.$ao)(C.apiNotebook.metadata,B=>!(k.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of C.apiNotebook.getCells()){const K=new r.$LN(B.kind,B.document.getText(),B.document.languageId,B.mime,k.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);K.metadata=(0,i.$ao)(B.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),I.cells.push(K)}const W=await k.serializer.serializeNotebook(I,h);await this.s.value.writeFile(D,W);const V=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:V.basename(D),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$yl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(w,$,v,y,h){const D=this.x.get(w)?.serializer;if(!D)return{limitHit:!1,results:[]};const k=new R.$Bc;await(async(q,A,B)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,A,ve=>{ve.forEach(Se=>{k.has(Se)||y.some($e=>K.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(Te=>(0,g.$Sgb)(Te,Se)))||k.add(Se)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(v,h,$);const I=new R.$Ac;let W=!1;const V=Array.from(k).map(async q=>{const A=[];try{if(h.isCancellationRequested)return;if($.maxResults&&[...I.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>$.maxResults){W=!0;return}const B=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>B.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Se=>Se.items.map(fe=>fe.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=O.$He.fromString(ce.toString()),Se=await D.deserializeNotebook(ve.buffer,h);if(h.isCancellationRequested)return;f.NotebookData.from(Se).cells.forEach($e=>B.push({input:$e.source,outputs:$e.outputs.flatMap(Te=>Te.items.map(ae=>ae.valueBytes.toString()))}))}if(h.isCancellationRequested)return;B.forEach((ce,ve)=>{const Se=$.contentPattern.pattern,fe=new u.$sXb(ce.input,void 0,ce.outputs),$e=fe.findInInputs(Se),Te=fe.findInOutputs(Se),ae=Te.flatMap(Re=>(0,t.$WK)(Re.matches,Re.textBuffer)).map((Re,ne)=>(Re.webviewIndex=ne,Re));if($e.length>0||Te.length>0){const Re={index:ve,contentResults:(0,t.$WK)($e,fe.inputTextBuffer),webviewResults:ae};A.push(Re)}});const ie={resource:q,cellResults:A};I.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...I.values()]}}async y(w,$){const v=await this.s.value.stat(w);if(typeof $?.mtime=="number"&&typeof $.etag=="string"&&$.etag!==T.$xl&&typeof v.mtime=="number"&&typeof v.size=="number"&&$.mtime<v.mtime&&$.etag!==T.$yl({mtime:$.mtime,size:v.size}))throw new T.$nl((0,P.localize)(1,null),3,$)}z(w){return w.scheme===c.Schemas.file?w.fsPath:w.toString()}A(w,$,v){if(this.h.has($))throw new Error(`editor with id ALREADY EXSIST: ${$}`);const y=new n.$0mc($,this.d,w,v.visibleRanges.map(f.NotebookRange.to),v.selections.map(f.NotebookRange.to),typeof v.viewColumn=="number"?f.ViewColumn.to(v.viewColumn):void 0);this.h.set($,y)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const v of w.value.removedDocuments){const y=E.URI.revive(v),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(h.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===y.toString()&&this.h.delete(D.id)}if(w.value.addedDocuments){const v=[];for(const y of w.value.addedDocuments){const h=E.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const D=new o.$9mc(this.c,this.q,this.r,h,y);v.push(...y.cells.map(k=>o.$8mc.asModelAddData(k))),this.g.get(h)?.dispose(),this.g.set(h,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(D.apiNotebook)}}if(w.value.addedEditors)for(const v of w.value.addedEditors){if(this.h.has(v.id))return;const y=E.URI.revive(v.documentUri),h=this.g.get(y);h&&this.A(h,v.id,v)}const $=[];if(w.value.removedEditors)for(const v of w.value.removedEditors){const y=this.h.get(v);y&&(this.h.delete(v),this.k?.id===y.id&&(this.k=void 0),$.push(y))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const v=new Set;this.l.forEach(y=>v.add(y.id));for(const y of this.h.values()){const h=v.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(w){const $=b.$8O.String.with("notebookType","A notebook type"),v=new b.$0O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[$,new b.$8O("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>O.$He.wrap(h))],new b.$9O("Notebook Data",h=>f.NotebookData.to(h.value))),y=new b.$0O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[$,new b.$8O("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new s.$Ew(f.NotebookData.from(h)))],new b.$9O("Bytes",h=>h.buffer));w.registerApiCommand(v),w.registerApiCommand(y)}}e.$gnc=a}),define(ke[301],Ie([1,0,19,20,44,37,24,66,47]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class E{constructor(l,b,f){this.k=l,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&N.$sk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&N.$sk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const b=this.k.folderQueries||[];return new Promise((f,r)=>{const s=o=>{this.f++,l(o)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=P.$nc(n);this.j&&this.j(n,i)||this.v(s,{base:o,basename:i})}),Promise.all(b.map(o=>this.p(o,s))).then(o=>{f({limitHit:this.e,stats:o[0]||void 0})},o=>{r(new Error((0,M.$jj)(o)))})})}async p(l,b){const f=new O.$qe,r=this.q(l),s=this.r(),o=new m.$MK(this.k,l),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=p.$be.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,f.token),u=i.elapsed(),t=p.$be.create();return this.g&&!this.e||(c&&c.forEach(g=>{const a=P.$gc.relative(l.folder.path,g.path);if(n){const d=P.$nc(g.path);this.v(b,{base:l.folder,relativePath:a,basename:d});return}this.s(s,l.folder,a,b)}),this.g&&!this.e)?null:(this.u(s,o,b),{providerTime:u,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(l){const b=(0,m.$LK)(this.k.includePattern,l.includePattern),f=(0,m.$LK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:f,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},b,f,r){if(f===this.a){const o=P.$nc(this.a);this.v(r,{base:b,relativePath:this.a,basename:o})}function s(o){const n=P.$nc(o),i=P.$mc(o);let c=l[i];c||(c=l[i]=[],s(i)),c.push({base:b,relativePath:o,basename:n})}s(f)}u({rootEntries:l,pathToEntries:b},f,r){const s=this,o=this.a;function n(i){const c=(0,m.$OK)(()=>i.map(u=>u.basename));for(let u=0,t=i.length;u<t;u++){const g=i[u],{relativePath:a,basename:d}=g;if(f.matchesExcludesSync(a,d,o!==d?c:void 0))continue;const w=b[a];if(w)n(w);else{if(a===o)continue;s.v(r,g)}if(s.e)break}}n(l)}v(l,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(b))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,b,f,r){const s=this.c(l.cacheKey),o=new E(l,b,s&&s.token);let n=0;const i=c=>{n+=c.length,f(c.map(u=>this.d(u)))};return this.e(o,T.a,i,r).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new O.$qe),this.b.get(l)}d(l){return l.relativePath?{resource:R.$_g(l.base,l.relativePath)}:{resource:l.base}}e(l,b,f,r){const s=r.onCancellationRequested(()=>{l.cancel()}),o=i=>{i&&(n.push(i),b>0&&n.length>=b&&(f(n),n=[]))};let n=[];return l.search(o).then(i=>(n.length&&f(n),s.dispose(),i),i=>(n.length&&f(n),s.dispose(),Promise.reject(i)))}}e.$$mc=T}),define(ke[302],Ie([1,0,18,271,37,97,28,16,19,24,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=void 0,e.$XL=y;let u=class{constructor(D,k,C,I,W){this.a=D,this.b=k,this.c=C,this.d=I,this.e=W}text(D,k,C={}){D=this.f(D,C);const I=this.a.getValue(),W=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(o.$Ti),C),type:2,contentPattern:D,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||W||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(D,k){const C=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const I={...D,wordSeparators:C.editor.wordSeparators};return this.j(D,k)&&(I.isCaseSensitive=!0),this.k(D)&&(I.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),I}file(D,k={}){return{...this.h(D,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(D,k){return D?(D=Array.isArray(D)?D.map(w):w(D),k?this.parseSearchPaths(D):{pattern:g(...Array.isArray(D)?D:[D])}):{}}h(D=[],k={}){const C=this.g(k.includePattern,k.expandPatterns),I=this.g(k.excludePattern,k.expandPatterns),W=D.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(B=>this.q(B,k,I)):D.map(B=>this.r(B,k,I,W))).filter(B=>!!B),q={_reason:k._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const B=P.$Hb(this.c.groups.flatMap(ce=>ce.editors.map(ve=>ve.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const K=B.filter(ce=>(0,c.$CK)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const A=k.extraFileResources&&k.extraFileResources.filter(B=>(0,c.$CK)(q,B.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(D){const k=[],C=new R.$Ac,I={};let W=!1;return D.forEach(V=>{if(V.scheme===p.Schemas.walkThrough)return;if((0,E.$dh)(V)){const A=this.b.getWorkspaceFolder(V)?.uri??V.with({path:m.$mc(V.fsPath)});let B=C.get(A);B||(W=!0,B={folder:A,includePattern:{}},k.push(B),C.set(A,B));const K=m.$lc(A.fsPath,V.fsPath);(0,S.$jg)(B.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,I[V.fsPath]=!0)}),{folderQueries:k,includePattern:I,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(D,k){if(k.isSmartCase){if(D.isRegExp){if(T.$2f(D.pattern,!0))return!0}else if(T.$2f(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,b.$TC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const k=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),I=(Array.isArray(D)?D:a(D)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,N.$Jw)(ie,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):ie}),W=O.$K(I,ie=>k(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>T.$hf(ie,"/")).map(ie=>T.$hf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),d(ie))),q={},A=this.m(W.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const B=V.flat(),K=g(...B);return K&&(q.pattern=K),q}l(D,k){return k.disregardExcludeSettings?void 0:(0,c.$BK)(D,!k.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const k=D.flatMap(I=>{let{pathPortion:W,globPortion:V}=t(I);return V&&(V=$(V)),this.n(W).flatMap(A=>this.o(A,V))}),C=new Map;return k.forEach(I=>{const W=I.searchPath.toString(),V=C.get(W);V?I.pattern&&(V.pattern=V.pattern||{},V.pattern[I.pattern]=!0):C.set(W,{searchPath:I.searchPath,pattern:I.pattern?g(I.pattern):void 0})}),Array.from(C.values())}n(D){if(m.$ic(D)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:D})}]:[{searchPath:l.URI.file(m.$hc(D))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(D=w(D),D.startsWith("../")||D===".."){const I=m.$gc.resolve(k.path,D);return[{searchPath:k.with({path:I})}]}const C=$(D);return[{searchPath:k,pattern:C}]}else{if(D==="./"||D===".\\")return[];{const k=D.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(W=>{const V=k.match(new RegExp(`^${T.$bf(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(S.$gg);if(I.length)return I.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&$(V)}});{const W=D.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:D,q=f.localize(0,null,V);throw new Error(q)}}}}o(D,k){const C=D.pattern&&k?`${D.pattern}/${k}`:D.pattern||k,I=[{searchPath:D.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:D.searchPath,pattern:C+"/**"}),I}q(D,k,C){const I=this.r((0,o.$Ti)(D.searchPath),k,C,!1);return I?{...I,includePattern:D.pattern}:null}r(D,k,C,I){let W;const V=l.URI.isUri(D)?D:D.uri;if(C.searchPaths){const ie=C.searchPaths.filter(ce=>(0,E.$5g)(ce.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),B={...this.l(q,k)||{},...W||{}},K=l.URI.isUri(D)?(0,E.$9g)(D):D.name;return{folder:V,folderName:I?K:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$WL=u,e.$WL=u=Je([We(0,r.$5i),We(1,o.$Hi),We(2,n.$2D),We(3,s.$5j),We(4,i.$UL)],u);function t(h){const D=h.match(/[\*\{\}\(\)\[\]\?]/);if(D){const k=D.index,C=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(C){let I=h.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:h.substr((C.index||0)+1)}}}return{pathPortion:h}}function g(...h){return h.length?h.reduce((D,k)=>(D[k]=!0,D),Object.create(null)):void 0}function a(h){return M.$qk(h,",").map(D=>D.trim()).filter(D=>!!D.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function w(h){return h.replace(/\\/g,"/")}function $(h){return w(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,D){h=P.$Mb(h,I=>I.toString());const k=[],C=D.getWorkspace();return h&&h.forEach(I=>{let W;if(D.getWorkbenchState()===2)W=(0,E.$bh)(C.folders[0].uri,I),W&&W!=="."&&(W="./"+W);else{const V=D.getWorkspaceFolder(I);if(V){const q=V.name;if(C.folders.filter(B=>B.name===q).length===1){const B=(0,E.$bh)(V.uri,I);B===""?W=`./${V.name}`:W=`./${V.name}/${B}`}else W=I.fsPath}}W&&k.push(v(W))}),k}}),define(ke[303],Ie([1,0,24,2,20,14,3,302,47,45,11]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ewb=l,e.$Fwb=r;const S=7e3;function l(s,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],c=[];for(const w of n)if(/^workspaceContains:/.test(w)){const $=w.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||s.forceUsingSearch?c.push($):i.push($)}if(i.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,T.$rh)(),g=w=>t({activationEvent:w}),a=Promise.all(i.map(w=>b(s,w,g))).then(()=>{}),d=f(s,o.identifier,c,g);return Promise.all([a,d]).then(()=>{t(void 0)}),u}async function b(s,o,n){for(const i of s.folders)if(await s.exists(P.$_g(O.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function f(s,o,n,i){if(n.length===0)return Promise.resolve(void 0);const c=new M.$qe,u=s.checkExists(s.folders,n,c.token),t=setTimeout(async()=>{c.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},S);let g=!1;try{g=await u}catch(a){N.$4(a)||N.$1(a)}c.dispose(),clearTimeout(t),g&&i(`workspaceContains:${n.join(",")}`)}function r(s,o,n,i){const c=s.get(R.$xi),u=s.get(m.$tK),g=c.createInstance(p.$WL).file(o.map(a=>(0,E.$Ti)(O.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return u.fileSearch(g,i).then(a=>!!a.limitHit,a=>N.$4(a)?!1:Promise.reject(a))}}),define(ke[41],Ie([1,0,173,19,60,24,11,6,54,2,12,4,40,237,84,39,25,110,14,21,22,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,23,82]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g,a,d,w,$,v,y,h,D,k,C,I,W,V,q,A,B,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=e.$Omc=e.$Nmc=e.$Mmc=void 0,e.$Mmc=(0,a.$yi)("IHostUtils");let ce=ie=class extends p.$Uc{constructor(z,x,be,Fe,De,pe,ge,Q,Y,he,ue,Ne,de){super(),this.Y=Ne,this.Z=de,this.a=this.B(new k.$fe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=be,this.f=ge,this.j=Fe,this.m=De,this.s=pe,this.t=Y,this.u=he,this.w=ue,this.y=this.g.getProxy(S.$gM.MainThreadWorkspace),this.z=this.g.getProxy(S.$gM.MainThreadTelemetry),this.C=this.g.getProxy(S.$gM.MainThreadExtensionService),this.D=new R.$xh,this.F=new R.$xh,this.G=new R.$xh,this.H=new R.$xh,this.I=new Re(this.f.extensions.activationEvents),this.L=new o.$lac(this.I,this.f.extensions.allExtensions);const Ce=new i.$Um(this.f.extensions.myExtensions);this.J=new o.$lac(this.I,Te(this.L,Ce)),B.$t&&(this.s.info(`Creating extension host with the following global extensions: ${fe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${fe(this.J)}`)),this.M=new f.$vmc(this.g,this.s),this.N=new I.$Fmc(this.g),this.O=Q,this.h=z.createChild(new v.$wi([f.$wmc,this.M],[I.$Gmc,this.N])),this.P=this.B(new b.$umc(this.J,this.L,{onExtensionActivationError:(Me,je,j)=>{this.C.$onExtensionActivationError(Me,n.$3(je),j)},actualActivateExtension:async(Me,je)=>{if(o.$lac.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,je),new b.$tmc;const j=this.J.getExtensionDescription(Me);return this.fb(j,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(z){n.$1(z)}}async $(){this.O.onWillDeactivateAll();let z=[];try{z=this.J.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this.eb(De))}catch{}await Promise.all(z)}terminate(z,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Fe=>{this.s.error(Fe)}),this.g.dispose();const be=this.$();Promise.race([(0,R.$zh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(z){return this.G.isOpen()?this.P.isActivated(z):!1}async getExtension(z){const x=await this.C.$getExtension(z);return x&&{...x,identifier:new i.$Tm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(z,x){return this.P.activateByEvent(z,x)}bb(z,x){return this.P.activateById(z,x)}activateByIdWithErrors(z,x){return this.bb(z,x).then(()=>{const be=this.P.getActivatedExtension(z);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(z=>this.J)}getExtensionExports(z){if(this.G.isOpen())return this.P.getActivatedExtension(z).exports;try{return this.P.getActivatedExtension(z).exports}catch{return null}}async cb(z){if(z.scheme===V.Schemas.file&&this.c.fsRealpath){const x=z.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const be=await this.R.get(x);return E.URI.file(be)}return z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(z=>new ae(z))),this.Q}async db(z){const x=m.$Ei.forUris(be=>N.$3g.ignorePathCasing(be));return await Promise.all(z.map(async be=>{if(this.wb(be)){const Fe=await this.cb(be.extensionLocation);x.set(Fe,be)}})),x}eb(z){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(z))return x;const be=this.P.getActivatedExtension(z);if(!be)return x;try{typeof be.module.deactivate=="function"&&(x=Promise.resolve(be.module.deactivate()).then(void 0,Fe=>(this.s.error(Fe),Promise.resolve(void 0))))}catch(Fe){this.s.error(`An error occurred when deactivating the extension '${z.value}':`),this.s.error(Fe)}try{(0,p.$Pc)(be.subscriptions)}catch(Fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${z.value}':`),this.s.error(Fe)}return x}async fb(z,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(z.identifier):await this.C.$onWillActivateExtension(z.identifier),this.hb(z,x).then(be=>{const Fe=be.activationTimes;return this.C.$onDidActivateExtension(z.identifier,Fe.codeLoadingTime,Fe.activateCallTime,Fe.activateResolvedTime,x),this.gb(z,x,"success",Fe),be},be=>{throw this.gb(z,x,"failure"),be})}gb(z,x,be,Fe){const De=Se(z,x);this.z.$publicLog2("extensionActivationTimes",{...De,...Fe||{},outcome:be})}hb(z,x){const be=Se(z,x);this.z.$publicLog2("activatePlugin",be);const Fe=this.wb(z);if(!Fe)return Promise.resolve(new b.$smc(b.$pmc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${z.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${z.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const De=new b.$qmc(x.startup);return Promise.all([this.xb(z,(0,N.$_g)(z.extensionLocation,Fe),De),this.ib(z)]).then(pe=>(M.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),ie.jb(this.s,z.identifier,pe[0],pe[1],De))).then(pe=>(M.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),pe))}ib(z){const x=this.Z.createLanguageModelAccessInformation(z),be=new u.$ymc(z,this.M),Fe=new u.$xmc(z.identifier.value,!1,this.M),De=new W.$Hmc(z,this.N),pe=z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([be.whenReady,Fe.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ue=(0,s.$RG)(z,"ipc")?this.f.messagePorts?.get(i.$Tm.toKey(z.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Fe,secrets:De,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Ne){return O.$jc(z.extensionLocation.fsPath,Ne)},get storagePath(){return Q.O.workspaceValue(z)?.fsPath},get globalStoragePath(){return Q.O.globalValue(z).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,z.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,z.identifier.value)},get storageUri(){return Q.O.workspaceValue(z)},get globalStorageUri(){return Q.O.globalValue(z)},get extensionMode(){return pe},get extension(){return Y===void 0&&(Y=new $e(Q,z.identifier,z,ge,!1)),Y},get extensionRuntime(){return(0,s.$SG)(z,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(z)},get messagePassingProtocol(){if(!he){if(!ue)return;const Ne=k.Event.buffer(k.Event.fromDOMEventEmitter(ue,"message",de=>de.data));ue.start(),he={onDidReceiveMessage:Ne,postMessage:ue.postMessage.bind(ue)}}return he}})})}static jb(z,x,be,Fe,De){return be=be||{activate:void 0,deactivate:void 0},this.kb(z,x,be,Fe,De).then(pe=>new b.$rmc(!1,null,De.build(),be,pe,Fe.subscriptions))}static kb(z,x,be,Fe,De){if(typeof be.activate=="function")try{De.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,ge=be.activate.apply(pe,[Fe]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ge).then(Q=>(De.activateResolveStop(),Q))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(be)}lb(z,x){this.bb(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:x}).then(void 0,be=>{this.s.error(be)})}mb(z,x=0){const Fe=Date.now();(0,B.$B)(()=>{for(let De=x;De<z.length;De+=1){const pe=z[De];for(const ge of pe.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Fe>50){this.mb(z,De);break}else this.lb(pe,ge)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(z=>{const x=z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(x)this.mb(be);else for(const Fe of be)if(Fe.activationEvents)for(const De of Fe.activationEvents)De==="onStartupFinished"&&this.lb(Fe,De)})}ob(){const z=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const x=this.j.workspace?this.j.workspace.folders:[],be=this.pb(x),Fe=this.rb(),De=Promise.all([Fe,z,be]).then(()=>{});return Promise.race([De,(0,R.$zh)(1e4)]).then(()=>{this.nb()}),De}pb(z){return z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(z,x))).then(()=>{})}async qb(z,x){if(this.isActivated(x.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Fe={logService:this.s,folders:z.map(pe=>pe.uri),forceUsingSearch:be||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,ge,Q)=>this.y.$checkExists(pe,ge,Q)},De=await(0,C.$Ewb)(Fe,x);if(De)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:De.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(z){throw console.error(z),z}}async sb(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:x}=this.f.environment;if(!z||!x)throw new Error(P.localize(0,null));const be=await this.xb(null,x,new b.$qmc(!1));if(!be||typeof be.run!="function")throw new Error(P.localize(1,null,x.toString()));return new Promise((Fe,De)=>{const pe=(Y,he)=>{Y?(B.$t&&this.s.error("Test runner called back with error",Y),De(Y)):(B.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Fe(typeof he=="number"&&he>0?1:0))},ge=(0,N.$Zg)(x),Q=be.run(ge,pe);Q&&Q.then&&Q.then(()=>{B.$t&&this.s.info("Test runner finished successfully."),Fe(0)}).catch(Y=>{B.$t&&this.s.error("Test runner finished with error",Y),De(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$zh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(z,x){return this.S[z]=x,(0,p.$Sc)(()=>{delete this.S[z]})}async getRemoteExecServer(z){const{resolver:x}=await this.ub(z);return x?.resolveExecServer?.(z,{resolveAttempt:0})}async ub(z){const x=z.indexOf("+");if(x===-1)throw new t.$oM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=z.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(z,x){const be=A.$be.create(!1),Fe=()=>`[resolveAuthority(${(0,g.$Nl)(z)},${x})][${be.elapsed()}ms] `,De=L=>this.s.info(`${Fe()}${L}`),pe=L=>this.s.warn(`${Fe()}${L}`),ge=(L,H=void 0)=>this.s.error(`${Fe()}${L}`,H),Q=L=>{if(L instanceof t.$oM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{De(`activating resolver for ${L}...`);const{resolver:H,authorityPrefix:G}=await this.ub(L);if(!H)throw ge(`no resolver for ${G}`),new t.$oM(`No remote extension installed to resolve ${G}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:G,remoteAuthority:L}},he=z.split(/@|%40/g).reverse();De(`activating remote resolvers ${he.join(" -> ")}`);let ue;try{ue=await Promise.all(he.map(Y)).catch(async L=>{if(!(L instanceof t.$oM)||L._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return pe(`resolving nested authorities failed: ${L.message}`),[await Y(z)]})}catch(L){return Q(L)}const Ne=new R.$Jh;Ne.cancelAndSet(()=>De("waiting..."),1e3);let de,Ce;for(const[L,{authorityPrefix:H,resolver:G,remoteAuthority:ee}]of ue.entries())try{if(L===ue.length-1)De("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${H}`),de=await G.resolve(ee,{resolveAttempt:x,execServer:Ce}),M.mark(`code/extHost/didResolveAuthorityOK/${H}`),De("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,t.$nM.isManagedResolvedAuthority(de)?de:void 0));else{if(De(`invoking resolveExecServer() for ${ee}`),M.mark(`code/extHost/willResolveExecServer/${H}`),Ce=await G.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$oM(`Exec server was not available for ${ee}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(re){return M.mark(`code/extHost/didResolveAuthorityError/${H}`),ge("returned an error",re),Ne.dispose(),Q(re)}Ne.dispose();const Me={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${t.$nM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let j;if(t.$nM.isManagedResolvedAuthority(de)){const L=x;this.Y.setFactory(L,de.makeConnection),j={authority:z,connectTo:new g.$Kl(L),connectionToken:de.connectionToken}}else j={authority:z,connectTo:new g.$Ll(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:j,options:je,tunnelInformation:Me}}}async $getCanonicalURI(z,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Nl)(z)})`);const{resolver:be}=await this.ub(z);if(!be)return null;const Fe=E.URI.revive(x);if(typeof be.getCanonicalURI>"u")return Fe;const De=await(0,R.$qh)(()=>be.getCanonicalURI(Fe));return De||Fe}async $startExtensionHost(z){z.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,z),Fe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$startExtensionHost: global extensions: ${fe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${fe(this.J)}`)),this.tb()}$activateByEvent(z,x){return x===1?this.D.wait().then(be=>this.ab(z,!1)):this.G.wait().then(be=>this.ab(z,!1))}async $activate(z,x){return await this.G.wait(),this.J.getExtensionDescription(z)?(await this.bb(z,x),!0):!1}async $deltaExtensions(z){z.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,z),Fe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$deltaExtensions: global extensions: ${fe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${fe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){const x=c.$He.alloc(z),be=Math.random()%256;for(let Fe=0;Fe<z;Fe++)x.writeUInt8(be,Fe);return x}async $updateRemoteConnectionData(z){this.X=z,this.a.fire()}};e.$Nmc=ce,e.$Nmc=ce=ie=Je([We(0,a.$xi),We(1,e.$Mmc),We(2,$.$JO),We(3,r.$$lc),We(4,l.$bmc),We(5,T.$5j),We(6,d.$ZO),We(7,w.$emc),We(8,y.$NDb),We(9,h.$zmc),We(10,q.$Jmc),We(11,K.$Kmc),We(12,D.$Dmc)],ce);function ve(ne,z,x,be){ne.addActivationEvents(be.addActivationEvents);const Fe=new o.$lac(ne,z.getAllExtensionDescriptions());Fe.deltaExtensions(be.toAdd,be.toRemove);const De=new i.$Um(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of be.myToRemove)De.delete(ge);for(const ge of be.myToAdd)De.add(ge);const pe=Te(Fe,De);return{globalRegistry:Fe,myExtensions:pe}}function Se(ne,z){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}function fe(ne){return ne.getAllExtensionDescriptions().map(z=>z.identifier.value).join(",")}e.$Omc=(0,a.$yi)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(z,x,be,Fe,De){this.#e=z,this.#t=x,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.$hc((0,N.$Zg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Fe,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Pmc=$e;function Te(ne,z){return ne.getAllExtensionDescriptions().filter(x=>z.has(x.identifier))}class ae{constructor(z){this.a=z}setSearchTree(z){this.a=z}findSubstr(z){return this.a.findSubstr(z)}forEach(z){return this.a.forEach(z)}}e.$Qmc=ae;class Re{constructor(z){this.a=new i.$Vm,this.addActivationEvents(z)}readActivationEvents(z){return this.a.get(z.identifier)??[]}addActivationEvents(z){for(const x of Object.keys(z))this.a.set(x,z[x])}}}),define(ke[304],Ie([1,0,60,2,4,40,25,21,17,27,3,41,12,13]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=void 0;let r=class{constructor(c,u,t,g,a,d,w){this.c=c,this.d=u,this.e=t,this.f=g,this.g=a,this.h=d,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),P.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();P.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new o(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$Znc=r,e.$Znc=r=Je([We(2,T.$xi),We(3,N.$bmc),We(4,S.$Omc),We(5,E.$ZO),We(6,l.$5j)],r);let s=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&f.a.size){const u=(0,b.$bf)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",g=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,t,g,a]=u,d=f.a.get(g);if(d!==void 0)return console.warn(`${g} as been renamed to ${d}, please update your imports`),t+d+a}c(c){return c.replace(/\\/g,"/")}};s=f=Je([We(0,E.$ZO)],s);class o{constructor(c,u,t,g,a){this.c=c,this.d=u,this.e=t,this.f=g,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Vm}load(c,u){const t=this.d.findSubstr(u);if(t){let g=this.a.get(t.identifier);return g||(g=this.c(t,this.e,this.f),this.a.set(t.identifier,g)),g}if(!this.b){let g="";this.d.forEach((a,d)=>g+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${g}`),this.b=this.c(R.$MG,this.e,this.f)}return this.b}}let n=class{constructor(c,u,t){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$gM.MainThreadTelemetry);const g=t.getProxy(M.$gM.MainThreadWindow);this.c=(a,d)=>{const w=O.URI.parse(a);return d?this.g(a,d):w.scheme==="http"||w.scheme==="https"?g.$openUri(w,a,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?g.$openUri(w,a,{}):this.g(a,d)}}load(c,u,t){const g=this.e.findSubstr(u);return g&&(this.a=g.identifier.value,this.h()),this.b=t(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,m.$JO)],n)}),define(ke[122],Ie([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=e.$Rmc=void 0,e.$Rmc=(0,R.$yi)("IExtHostVariableResolverProvider");class f extends l.$NP{constructor(o,n,i,c,u,t,g){function a(){if(i){const d=i.activeEditor();if(d)return d.document.uri;const w=c.tabGroups.all.find($=>$.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof T.$7N||w.input instanceof T.$_N)return w.input.modified;if(w.input instanceof T.$6N||w.input instanceof T.$$N||w.input instanceof T.$9N)return w.input.uri}}}super({getFolderUri:d=>{const w=t.folders.filter($=>$.name===d);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,w)=>u.getConfiguration(void 0,d).get(w),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return M.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=a();if(d){const w=n.getWorkspaceFolder(d);if(w)return M.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if(i){const d=i.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(i){const d=i.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>o.getExtension(d)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(N.env))}}let r=class extends O.$Uc{constructor(o,n,i,c,u){super(),this.b=o,this.c=n,this.g=i,this.h=c,this.j=u,this.a=new P.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Smc=r,e.$Smc=r=Je([We(0,E.$Omc),We(1,S.$$lc),We(2,p.$UO),We(3,b.$bmc),We(4,m.$nmc)],r)}),define(ke[123],Ie([1,0,11,5,2,21,3,4,67,41,17,7,39,226,228,40,122,6,36,35,8,18]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=e.$Vmc=e.$Umc=e.$Tmc=void 0,e.$Tmc=(0,R.$yi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,D,k,C,I,W){this.N=h,this.O=D,this.P=k,this.Q=C,this.R=I,this.S=W,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$fe,this.o=new O.$fe,this.q=new O.$fe,this.w=new O.$fe,this.l=y.getProxy(p.$gM.MainThreadDebugService),this.A=new O.$fe,this.C=new O.$fe,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(q=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(y,h){const D=this.W(h);if(!D)return;const k=await this.H.get(y)?.getTreeItem?.(D);return k?this.U(y,k):void 0}registerDebugVisualizationTree(y,h,D){const k=N.$Tm.toKey(y.identifier),C=this.jb(k,h);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(C,D),this.l.$registerDebugVisualizerTree(C,!!D.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(C),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const D=this.J.get(h)?.item;return D?(await this.H.get(y)?.getChildren?.(D))?.map(C=>this.U(y,C))||[]:[]}async $editVisualizerTreeItem(y,h){const D=this.J.get(y);if(!D)return;const k=await this.H.get(D.provider)?.editItem?.(D.item,h);return this.U(D.provider,k||D.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const D=[h.children];for(const k of D)if(k)for(const C of k)D.push(this.J.get(C)?.children),this.J.delete(C)}U(y,h){let D=this.I.get(h);return D||(D=this.F++,this.I.set(h,D),this.J.set(D,{provider:y,item:h})),c.DebugTreeItem.from(h,D)}asDebugSourceUri(y,h){const D=y;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let k=`debug:${encodeURIComponent(D.path||"")}`,C="?";return h&&(k+=`${C}session=${encodeURIComponent(h.id)}`,C="&"),k+=`${C}ref=${D.sourceReference}`,M.URI.parse(k)}else{if(D.path)return M.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const D of y.getAllExtensionDescriptions())if(D.contributes){const k=D.contributes.debuggers;if(k&&k.length>0)for(const C of k)(0,f.$wH)(C)&&h.push(C.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const D=this.L.get(y);if(!D)throw new Error(`No debug visualizer found with id '${y}'`);let{v:k,provider:C,extensionId:I}=D;if(k.visualization||(k=await C.resolveDebugVisualization?.(k,h)||k,D.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${C}'`);return this.kb(I,k.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const D=h.v.visualization;D&&"command"in D&&this.S.executeCommand(D.command,...D.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,D,k){const C=this.W(D),I=this.jb(y,h),W=this.G.get(I);if(!C||!W)return[];const V=await W.provideDebugVisualization(C,k);return V?V.map(q=>{const A=++this.M;this.L.set(A,{v:q,provider:W,extensionId:y});const B=q.iconPath?this.lb(q.iconPath):void 0;return{id:A,name:q.name,iconClass:B?.iconClass,iconPath:B?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,D){if(!y.contributes?.debugVisualizers?.some(I=>I.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const k=N.$Tm.toKey(y.identifier),C=this.jb(k,h);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(C,D),this.l.$registerDebugVisualizer(k,h),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(C=>{const I=C.id;return this.z.has(I)?!1:(this.z.set(I,C),!0)});this.gb(h,[],[]);const D=[],k=new Map;for(const C of h)if(C instanceof S.$kN){let I=k.get(C.location.uri.toString());I||(I={type:"sourceMulti",uri:C.location.uri,lines:[]},k.set(C.location.uri.toString(),I),D.push(I)),I.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character,mode:C.mode})}else C instanceof S.$lN&&D.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName,mode:C.mode});return this.l.$registerBreakpoints(D)}removeBreakpoints(y){const h=y.filter(I=>this.z.delete(I.id));this.gb([],h,[]);const D=h.filter(I=>I instanceof S.$kN).map(I=>I.id),k=h.filter(I=>I instanceof S.$lN).map(I=>I.id),C=h.filter(I=>I instanceof S.$mN).map(I=>I.id);return this.l.$unregisterBreakpoints(D,k,C)}startDebugging(y,h,D){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:D.parentSession?D.parentSession.id:void 0,lifecycleManagedByParent:D.lifecycleManagedByParent,repl:D.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact,suppressSaveBeforeStart:D.suppressSaveBeforeStart,suppressDebugStatusbar:D.suppressDebugStatusbar??D.debugUI?.simple,suppressDebugToolbar:D.suppressDebugToolbar??D.debugUI?.simple,suppressDebugView:D.suppressDebugView??D.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,D){if(!h)return new S.$iM(()=>{});const k=this.d++;return this.f.push({type:y,handle:k,provider:h}),this.l.$registerDebugConfigurationProvider(y,D,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,k),new S.$iM(()=>{this.f=this.f.filter(C=>C.provider!==h),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(y,h,D){if(!D)return new S.$iM(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:h,handle:k,factory:D}),this.l.$registerDebugAdapterDescriptorFactory(h,k),new S.$iM(()=>{this.h=this.h.filter(C=>C.factory!==D),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new S.$iM(()=>{});const D=this.j++;return this.k.push({type:y,handle:D,factory:h}),new S.$iM(()=>{this.k=this.k.filter(k=>k.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let D;const k=await this.ib(y);return k&&(D={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(D,h)}X(y,h){if(y.type==="implementation")return new w(y.implementation)}Y(){}async $startDASession(y,h){const D=this,k=await this.hb(h);return this.eb(this.$(k.type),k).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const I=this.Z(C),W=this.X(I,k);if(!W)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const V=W;return this.D.set(y,V),this.db(k).then(q=>(q&&this.E.set(y,q),V.onMessage(async A=>{if(A.type==="request"&&A.command==="handshake"){const B=A,K={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(B.arguments.value);K.body={signature:ie},V.sendResponse(K)}else throw new Error("no signer")}catch(ie){K.success=!1,K.message=ie.message,V.sendResponse(K)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(A),A=(0,f.$BH)(A,!0),D.l.$acceptDAMessage(y,A)}),V.onError(A=>{q&&q.onError&&q.onError(A),this.l.$acceptDAError(y,A.name,A.message,A.stack)}),V.onExit(A=>{q&&q.onExit&&q.onExit(A??void 0,void 0),this.l.$acceptDAExit(y,A??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),V.startSession()))})}$sendDAMessage(y,h){h=(0,f.$AH)(h,!1);const D=this.E.get(y);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const D=this.D.get(y);return this.D.delete(y),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],D=[],k=[];if(y.added)for(const C of y.added){const I=C.id;if(I&&!this.z.has(I)){let W;if(C.type==="function")W=new S.$lN(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode);else if(C.type==="data")W=new S.$mN(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage,C.mode);else{const V=M.URI.revive(C.uri);W=new S.$kN(new S.$uM(V,new S.$jM(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode)}(0,S.$iN)(W,I),this.z.set(I,W),h.push(W)}}if(y.removed)for(const C of y.removed){const I=this.z.get(C);I&&(this.z.delete(C),D.push(I))}if(y.changed){for(const C of y.changed)if(C.id){const I=this.z.get(C.id);if(I){if(I instanceof S.$lN&&C.type==="function"){const W=I;W.enabled=C.enabled,W.condition=C.condition,W.hitCondition=C.hitCondition,W.logMessage=C.logMessage,W.functionName=C.functionName}else if(I instanceof S.$kN&&C.type==="source"){const W=I;W.enabled=C.enabled,W.condition=C.condition,W.hitCondition=C.hitCondition,W.logMessage=C.logMessage,W.location=new S.$uM(M.URI.revive(C.uri),new S.$jM(C.line,C.character))}k.push(I)}}}this.gb(h,D,k)}async $acceptStackFrameFocus(y){let h;if(y){const D=await this.hb(y.sessionId);y.kind==="thread"?h=new S.$sN(D.api,y.threadId):h=new S.$rN(D.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,D){return(0,P.$qh)(async()=>{const k=this.bb(y);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.ib(h);return k.provideDebugConfigurations(C,D)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(y,h,D,k){return(0,P.$qh)(async()=>{const C=this.bb(y);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.ib(h);return C.resolveDebugConfiguration(I,D,k)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,D,k){return(0,P.$qh)(async()=>{const C=this.bb(y);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.ib(h);return C.resolveDebugConfigurationWithSubstitutedVariables(I,D,k)})}async $provideDebugAdapter(y,h){const D=this.ab(y);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(h);return this.eb(D,k).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(C)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const k={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(k)}Z(y){if(y instanceof S.$nN)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof S.$oN)return{type:"server",port:y.port,host:y.host};if(y instanceof S.$pN)return{type:"pipeServer",path:y.path};if(y instanceof S.$qN)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(D=>D.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(D=>D.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(D=>D.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0){for(const k of D)if(k.label&&k.type&&k.type===h)return!0}}return!1}db(y){const D=y.configuration.type,k=this.k.filter(C=>C.type===D||C.type==="*").map(C=>(0,P.$qh)(()=>C.factory.createDebugAdapterTracker(y.api)).then(I=>I,I=>null));return Promise.race([Promise.all(k).then(C=>{const I=(0,u.$Hb)(C);if(I.length>0)return new d(I)}),new Promise(C=>setTimeout(()=>C(void 0),1e3))]).catch(C=>{})}async eb(y,h){const D=h.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new S.$oN(D));if(y){const C=await this.O.getExtensionRegistry();return(0,P.$qh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,C))).then(I=>{if(I)return I})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,k))}fb(y,h){}gb(y,h,D){(y.length>0||h.length>0||D.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:D}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const D=await this.ib(y.folderUri),k=y.parent?this.m.get(y.parent):void 0;h=new g(this.l,y.id,y.type,y.name,D,y.configuration,k?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=M.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let D,k;return"id"in h?k=n.ThemeIcon.asClassName(h):D=h,{iconPath:D,iconClass:k}}mb(y){if(y instanceof S.$fN)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,D=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?M.URI.file(h):h,light:typeof D=="string"?M.URI.file(D):D}}};e.$Umc=t,e.$Umc=t=Je([We(0,T.$JO),We(1,l.$$lc),We(2,E.$Omc),We(3,r.$bmc),We(4,m.$nmc),We(5,s.$Rmc),We(6,i.$6O)],t);class g{constructor(y,h,D,k,C,I,W){this.f=y,this.g=h,this.h=D,this.j=k,this.k=C,this.l=I,this.m=W}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,D){return y.f.$customDebugAdapterRequest(y.g,h,D)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$Vmc=g;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$Wmc=a;class d{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(D=>D.onExit?D.onExit(y,h):void 0)}}class w extends b.$$rb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let $=class extends t{constructor(y,h,D,k,C,I,W){super(y,h,D,k,C,I,W)}};e.$Xmc=$,e.$Xmc=$=Je([We(0,T.$JO),We(1,l.$$lc),We(2,E.$Omc),We(3,r.$bmc),We(4,m.$nmc),We(5,s.$Rmc),We(6,i.$6O)],$)}),define(ke[305],Ie([1,0,14,60,2,4,255,12,56,72,27,199,17,61,41,63]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=void 0;class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const c=i.get(p.$5j),t=i.get(l.$JO).getProxy(N.$gM.MainThreadErrors);P.setUnexpectedErrorHandler(g=>{c.error(g);const a=P.$3(g);t.$onUnexpectedError(a)})}static async installFullHandler(i){const c=i.get(p.$5j),u=i.get(l.$JO),t=i.get(f.$Omc),g=i.get(r.$4O),a=u.getProxy(N.$gM.MainThreadExtensionService),d=u.getProxy(N.$gM.MainThreadErrors),w=await t.getExtensionPathIndex(),$=new WeakMap;function v(D,k){if($.has(D))return $.get(D).stack;let C="",I,W;for(const q of k)C+=`
	at ${q.toString()}`,W=q.getFileName(),!I&&W&&(I=w.findSubstr(M.URI.file(W)));const V=`${D.name||"Error"}: ${D.message||""}${C}`;return $.set(D,{extensionIdentifier:I?.identifier,stack:V}),V}const y=Symbol("prepareStackTrace wrapped");let h=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(D){if(D===v||!D||D[y]){h=D||v;return}h=function(k,C){return v(k,C),D.call(Error,k,C)},Object.assign(h,{[y]:!0})}}),P.setUnexpectedErrorHandler(D=>{c.error(D);const k=P.$3(D),C=$.get(D);if(!C?.extensionIdentifier){d.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(C.extensionIdentifier,k);const I=g.onExtensionError(C.extensionIdentifier,D);c.trace("forwarded error to extension?",I,C)})}}e.$1nc=s;class o{constructor(i,c,u,t,g){this.a=u,this.b=new R.$tac(i,null,t),c=o.e(c,this.b);const a=new E.$wi(...(0,m.$Bs)());a.set(T.$ZO,{_serviceBrand:void 0,...c,messagePorts:g}),a.set(l.$JO,new l.$KO(this.b)),a.set(b.$8lc,new b.$9lc(t)),a.set(f.$Mmc,u);const d=new S.$fr(a,!0);d.invokeFunction(s.installEarlyHandler),this.d=d.invokeFunction(w=>w.get(p.$5j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(w=>w.get(f.$Omc)),this.c.initialize(),d.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const c=this.b.getProxy(N.$gM.MainThreadExtensionService);return M.URI.revive(await c.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,c){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(c.transformIncomingURIs(i.environment.appRoot));const u=i.environment.extensionDevelopmentLocationURI;return u&&(i.environment.extensionDevelopmentLocationURI=u.map(t=>M.URI.revive(c.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(c.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(c.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(c.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(c.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(c.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(c.transformIncomingURIs(i.logsLocation)),i.workspace=c.transformIncomingURIs(i.workspace),i}}e.$2nc=o}),define(ke[306],Ie([1,0,18,11,20,44,16,19,24,2,47]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$anc=e.$_mc=void 0,e.$bnc=r;class S{constructor(n,i,c){this.d=n,this.e=i,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const c=this.g.folderQueries||[],u=new M.$qe(i);return new Promise((t,g)=>{this.a=new b(n);let a=!1;const d=(w,$)=>{if(!a&&!this.b){const v=this.h(w);r(w)&&typeof this.g.maxResults=="number"&&this.c+v>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),w=this.j(w,this.g.maxResults-this.c));const y=this.h(w);this.c+=y,(y>0||!r(w))&&this.a.add(w,$)}};Promise.all(c.map((w,$)=>this.k(w,v=>d(v,$),u.token))).then(w=>{u.dispose(),this.a.flush();const $=w.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||$,messages:w.flatMap(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[]),stats:{type:this.f}})},w=>{u.dispose();const $=(0,N.$jj)(w);g(new Error($))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],u=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,i),preview:{matches:u.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,c){const u=new T.$MK(this.g,n),t=[],g={report:w=>{if(!this.l(w))return;const $=n.folder.scheme===R.Schemas.file?(0,T.$NK)(()=>this.e.readdir(m.$$g(w.uri))):void 0,v=m.$bh(n.folder,w.uri);if(v){const y=u.includedInQuery(v,p.$nc(v),$);(0,O.$kh)(y)?t.push(y.then(h=>{h&&i(w)})):y&&i(w)}}},a=this.n(n);let d;return this.d.query.type===3?d=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,g,c):d=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,g,c),t.length&&await Promise.all(t),d}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,T.$LK)(this.g.includePattern,n.includePattern),c=(0,T.$LK)(this.g.excludePattern,n.excludePattern),u={folder:E.URI.from(n.folder),excludes:c,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$_mc=S;function l(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class b{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$5g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(f(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$anc=b;function f(o){return r(o)?{preview:{matches:(0,P.$1b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,P.$1b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function r(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cnc=s}),define(ke[124],Ie([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0,e.$fnc=l,e.$dnc=(0,M.$yi)("IExtHostSearch");let S=class{constructor(r,s,o){this.n=r,this.o=s,this.q=o,this.c=this.n.getProxy(O.$gM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$$mc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(r)),(0,P.$Sc)(()=>{this.g.delete(r),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(r,s){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(r)),(0,P.$Sc)(()=>{this.i.delete(r),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(r,s){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(r)),(0,P.$Sc)(()=>{this.k.delete(r),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(r,s,o,n){const i=l(o),c=this.j.get(r);if(c)return this.l.fileSearch(i,c,u=>{this.c.$handleFileMatch(r,s,u.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,o){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,o,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=l(o);return this.t(c,i).search(t=>this.c.$handleTextMatch(r,s,t),n)}$provideAITextSearchResults(r,s,o,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=l(o);return this.v(c,i).search(t=>this.c.$handleTextMatch(r,s,t),n)}$enableExtensionHostSearch(){}t(r,s){return new T.$_mc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(r,s){return new T.$_mc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$enc=S,e.$enc=S=Je([We(0,R.$JO),We(1,p.$8lc),We(2,m.$5j)],S);function l(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(r=>E.URI.revive(r))}}function b(f){return{...f,folder:E.URI.revive(f.folder)}}}),define(ke[307],Ie([1,0,20,14,5,6,16,32,2,158,154,141,95,21,38,12,58,59,213,4,258,286,80,86,263,264,265,243,232,35,266,40,267,123,112,268,245,259,269,270,68,67,246,260,41,272,65,273,46,27,287,247,274,90,275,81,82,249,300,277,219,278,288,279,118,250,280,281,282,17,283,124,83,284,251,285,84,87,121,63,53,116,289,290,261,291,292,88,8,7,252,61,253,64,293,294,111,39,227,79,25,120]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g,a,d,w,$,v,y,h,D,k,C,I,W,V,q,A,B,K,ie,ce,ve,Se,fe,$e,Te,ae,Re,ne,z,x,be,Fe,De,pe,ge,Q,Y,he,ue,Ne,de,Ce,Me,je,j,L,H,G,ee,re,Oe,Be,He,_e,xe,et,tt,it,ct,gt,Ue,ot,Z,X,me,qe,we,at,dt,Pt,Vt,Qt,ii,Xt,Dt,Zt,Yt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=Gt;function Gt(ht){const mt=ht.get(Re.$ZO),xt=ht.get(ae.$Slc),Kt=ht.get($e.$dmc),Ft=ht.get(Se.$Omc),ft=ht.get(Dt.$$lc),jt=ht.get(tt.$4O),_t=ht.get(D.$bmc),Lt=ht.get(dt.$8lc),Qe=ht.get(H.$JO),ci=ht.get(_e.$wmc),Jt=ht.get(xe.$emc),zt=ht.get(r.$6j),pt=ht.get(r.$5j),Ut=ht.get(me.$NDb),Rt=ht.get(t.$Olc),Nt=ht.get(Xt.$Unc),ei=ht.get(re.$Gmc),Wt=ht.get(ie.$nmc),oi=ht.get(pe.$Kmc),Mt=ht.get(g.$Ylc),Tt=ht.get(be.$Dmc);Qe.set(i.$hM.ExtHostFileSystemInfo,xt),Qe.set(i.$hM.ExtHostLogLevelServiceShape,zt),Qe.set(i.$hM.ExtHostWorkspace,ft),Qe.set(i.$hM.ExtHostConfiguration,_t),Qe.set(i.$hM.ExtHostExtensionService,Ft),Qe.set(i.$hM.ExtHostStorage,ci),Qe.set(i.$hM.ExtHostTunnelService,Ut),Qe.set(i.$hM.ExtHostWindow,Nt),Qe.set(i.$hM.ExtHostSecretState,ei),Qe.set(i.$hM.ExtHostTelemetry,jt),Qe.set(i.$hM.ExtHostEditorTabs,Wt),Qe.set(i.$hM.ExtHostManagedSockets,oi),Qe.set(i.$hM.ExtHostAuthentication,Mt),Qe.set(i.$hM.ExtHostChatProvider,Tt);const Ot=Qe.set(i.$hM.ExtHostDecorations,ht.get(I.$Zmc)),It=Qe.set(i.$hM.ExtHostDocumentsAndEditors,ht.get(K.$UO)),wt=Qe.set(i.$hM.ExtHostCommands,ht.get(y.$6O)),Et=Qe.set(i.$hM.ExtHostTerminalService,ht.get(it.$zmc)),ni=Qe.set(i.$hM.ExtHostTerminalShellIntegration,ht.get(ct.$Gnc)),St=Qe.set(i.$hM.ExtHostDebugService,ht.get(C.$Tmc)),di=Qe.set(i.$hM.ExtHostSearch,ht.get(ee.$dnc)),ri=Qe.set(i.$hM.ExtHostTask,ht.get(et.$Fnc)),bi=Qe.set(i.$hM.ExtHostOutputService,ht.get(Ce.$snc)),ui=Qe.set(i.$hM.ExtHostLocalization,ht.get(De.$Jmc)),mi=Qe.set(i.$hM.ExtHostUrls,new Pt.$Rnc(Qe)),kt=Qe.set(i.$hM.ExtHostDocuments,new B.$Vlc(Qe,It)),ye=Qe.set(i.$hM.ExtHostDocumentContentProviders,new q.$2mc(Qe,It,pt)),Ae=Qe.set(i.$hM.ExtHostDocumentSaveParticipant,new A.$3mc(pt,kt,Qe.getProxy(i.$gM.MainThreadBulkEdits))),se=Qe.set(i.$hM.ExtHostNotebook,new Q.$gnc(Qe,wt,It,kt,Kt,di)),J=Qe.set(i.$hM.ExtHostNotebookDocuments,new he.$mnc(se)),Pe=Qe.set(i.$hM.ExtHostNotebookEditors,new ue.$nnc(pt,se)),Ve=Qe.set(i.$hM.ExtHostNotebookKernels,new Ne.$onc(Qe,mt,se,wt,pt)),Xe=Qe.set(i.$hM.ExtHostNotebookRenderers,new de.$qnc(Qe,se)),Ge=Qe.set(i.$hM.ExtHostNotebookDocumentSaveParticipant,new Y.$lnc(pt,se,Qe.getProxy(i.$gM.MainThreadBulkEdits))),rt=Qe.set(i.$hM.ExtHostEditors,new Ue.$5lc(Qe,It)),yt=Qe.set(i.$hM.ExtHostTreeViews,new X.$Pnc(Qe.getProxy(i.$gM.MainThreadTreeViews),wt,pt)),qt=Qe.set(i.$hM.ExtHostEditorInsets,new v.$6lc(Qe.getProxy(i.$gM.MainThreadEditorInsets),rt,mt.remote)),Bt=Qe.set(i.$hM.ExtHostDiagnostics,new W.$Ulc(Qe,pt,xt,It)),Ct=Qe.set(i.$hM.ExtHostLanguages,new Fe.$jnc(Qe,kt,wt.converter,Lt)),ut=Qe.set(i.$hM.ExtHostLanguageFeatures,new x.$Wlc(Qe,Lt,kt,wt,Bt,pt,Rt,jt)),Ri=Qe.set(i.$hM.ExtHostFileSystem,new fe.$6mc(Qe,ut)),$i=Qe.set(i.$hM.ExtHostFileSystemEventService,new Te.$7mc(Qe,pt,It)),Ei=Qe.set(i.$hM.ExtHostQuickOpen,(0,L.$wnc)(Qe,ft,wt)),ki=Qe.set(i.$hM.ExtHostSCM,new G.$ync(Qe,wt,kt,pt)),Ji=Qe.set(i.$hM.ExtHostQuickDiff,new j.$vnc(Qe,Lt)),Oi=Qe.set(i.$hM.ExtHostShare,new Oe.$znc(Qe,Lt)),Ni=Qe.set(i.$hM.ExtHostComments,(0,h.$7lc)(Qe,wt,kt)),Ii=Qe.set(i.$hM.ExtHostProgress,new je.$unc(Qe.getProxy(i.$gM.MainThreadProgress))),Ti=Qe.set(i.$hM.ExtHostLabelService,new z.$inc(Qe)),Fi=Qe.set(i.$hM.ExtHostTheming,new ot.$Mnc(Qe)),Qi=Qe.set(i.$hM.ExtHostTimeline,new Z.$Onc(Qe,wt)),Li=Qe.set(i.$hM.ExtHostWebviews,new Vt.$imc(Qe,mt.remote,ft,pt,Rt)),Ci=Qe.set(i.$hM.ExtHostWebviewPanels,new Qt.$lmc(Qe,Li,ft)),zi=Qe.set(i.$hM.ExtHostCustomEditors,new k.$mmc(Qe,kt,Jt,Li,Ci)),Ui=Qe.set(i.$hM.ExtHostWebviewViews,new ii.$Snc(Qe,Li)),vi=Qe.set(i.$hM.ExtHostTesting,new gt.$Inc(Qe,pt,wt,It)),Xi=Qe.set(i.$hM.ExtHostUriOpeners,new at.$Qnc(Qe)),Zi=Qe.set(i.$hM.ExtHostProfileContentHandlers,new Me.$tnc(Qe));Qe.set(i.$hM.ExtHostInteractive,new ne.$hnc(Qe,se,It,wt,pt));const Pi=Qe.set(i.$hM.ExtHostChatAgents2,new d.$2lc(Qe,pt,wt)),Yi=Qe.set(i.$hM.ExtHostChatVariables,new w.$3lc(Qe)),ji=Qe.set(i.$hM.ExtHostAiRelatedInformation,new c.$Nlc(Qe)),dn=Qe.set(i.$hM.ExtHostAiEmbeddingVector,new ve.$5mc(Qe)),xi=Qe.set(i.$hM.ExtHostStatusBar,new He.$Cnc(Qe,wt.converter)),Bi=Qe.set(i.$hM.ExtHostSpeech,new Be.$Anc(Qe)),pi=Qe.set(i.$hM.ExtHostEmbeddings,new ce.$4mc(Qe)),fn=Object.values(i.$hM);Qe.assertRegistered(fn);const gn=new a.$1lc(Qe,It),_i=new $.$4lc(Qe),Vi=new ge.$knc(Qe,pt),Mi=new V.$1mc(Qe);return u.$Xlc.register(wt),function(ze,li,Wi){function nt(_){return(oe,Le,st)=>{const vt=_(At=>{try{oe.call(Le,At)}catch(Si){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),jt.onExtensionError(ze.identifier,Si)}});return st?.push(vt),vt}}const bt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(pt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(st){if(Array.isArray(st))st.forEach(Le);else if(typeof st=="string")oe();else{const vt=st;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Ze.$SG)(ze,"documentFiltersExclusive")}return st}}(),en={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ze.$SG)(ze,"authLearnMore"),Mt.getSession(ze,_,oe,Le)},getSessions(_,oe){return(0,Ze.$SG)(ze,"authGetSessions"),Mt.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Ze.$SG)(ze,"authSession"),!!await Mt.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(Mt.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,st){return Mt.registerAuthenticationProvider(_,oe,Le,st)}},fi={registerCommand(_,oe,Le){return wt.registerCommand(!0,_,oe,Le,void 0,ze)},registerTextEditorCommand(_,oe,Le){return wt.registerCommand(!0,_,(...st)=>{const vt=rt.getActiveTextEditor();if(!vt){pt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(At=>{oe.apply(Le,[vt,At,...st])}).then(At=>{At||pt.warn("Edits from command "+_+" were not applied.")},At=>{pt.warn("An error occurred while running command "+_,At)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Le)=>((0,Ze.$SG)(ze,"diffCommand"),wt.registerCommand(!0,_,async(...st)=>{const vt=It.activeEditor(!0);if(!vt){pt.warn("Cannot execute "+_+" because there is no active text editor.");return}const At=await rt.getDiffInformation(vt.id);oe.apply(Le,[At,...st])},void 0,void 0,ze)),executeCommand(_,...oe){return wt.executeCommand(_,...oe)},getCommands(_=!1){return wt.getCommands(_)}},Di={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return nt(Et.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$SG)(ze,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$SG)(ze,"telemetry"),nt(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$3O)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$2O.validateSender(_),jt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return Nt.openUri(_,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===mt.environment.appUriScheme)return mi.createAppUri(_);try{return await Nt.asExternalUri(_,{allowTunneling:!!mt.remote.authority})}catch(oe){if((0,R.$Hg)(_,R.Schemas.http)||(0,R.$Hg)(_,R.Schemas.https))return _;throw oe}},get remoteName(){return(0,s.$Km)(mt.remote.authority)},get remoteAuthority(){return(0,Ze.$SG)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return nt(pt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$SG)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Ze.$SG)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(Di);const mn={createTestController(_,oe,Le){return vi.createTestController(ze,_,oe,Le)},createTestObserver(){return(0,Ze.$SG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$SG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$SG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Ze.$SG)(ze,"testObserver"),vi.results}},ti=mt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,Ai={getExtension(_,oe){(0,Ze.$RG)(ze,"extensionsAny")||(oe=!1);const Le=li.mine.getExtensionDescription(_);if(Le)return new Se.$Pmc(Ft,ze.identifier,Le,ti,!1);if(oe){const st=li.all.getExtensionDescription(_);if(st)return new Se.$Pmc(Ft,ze.identifier,st,ti,!0)}},get all(){const _=[];for(const oe of li.mine.getAllExtensionDescriptions())_.push(new Se.$Pmc(Ft,ze.identifier,oe,ti,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$SG)(ze,"extensionsAny");const _=new b.$Um(li.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of li.all.getAllExtensionDescriptions()){const st=!_.has(Le.identifier);oe.push(new Se.$Pmc(Ft,ze.identifier,Le,ti,st))}return oe},get onDidChange(){return(0,Ze.$RG)(ze,"extensionsAny")?nt(M.Event.any(li.mine.onDidChange,li.all.onDidChange)):nt(li.mine.onDidChange)}},tn={createDiagnosticCollection(_){return Bt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(Bt.onDidChangeDiagnostics)},getDiagnostics:_=>Bt.getDiagnostics(_),getLanguages(){return Ct.getLanguages()},setTextDocumentLanguage(_,oe){return Ct.changeLanguage(_.uri,oe)},match(_,oe){const Le=qe.LanguageSelector.from(_);let st;return(0,T.$2t)(Le)&&(st=se.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(At=>At.document===oe))?.apiNotebook),(0,T.$1t)(Le,oe.uri,oe.languageId,!0,st?.uri,st?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ut.registerCodeActionProvider(ze,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Ze.$SG)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ut.registerCodeLensProvider(ze,bt(_),oe)},registerDefinitionProvider(_,oe){return ut.registerDefinitionProvider(ze,bt(_),oe)},registerDeclarationProvider(_,oe){return ut.registerDeclarationProvider(ze,bt(_),oe)},registerImplementationProvider(_,oe){return ut.registerImplementationProvider(ze,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ut.registerTypeDefinitionProvider(ze,bt(_),oe)},registerHoverProvider(_,oe){return ut.registerHoverProvider(ze,bt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ut.registerEvaluatableExpressionProvider(ze,bt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ut.registerInlineValuesProvider(ze,bt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ut.registerDocumentHighlightProvider(ze,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ut.registerMultiDocumentHighlightProvider(ze,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ut.registerLinkedEditingRangeProvider(ze,bt(_),oe)},registerReferenceProvider(_,oe){return ut.registerReferenceProvider(ze,bt(_),oe)},registerRenameProvider(_,oe){return ut.registerRenameProvider(ze,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Ze.$SG)(ze,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(ze,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ut.registerDocumentSymbolProvider(ze,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ut.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ut.registerDocumentFormattingEditProvider(ze,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ut.registerDocumentRangeFormattingEditProvider(ze,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...st){return ut.registerOnTypeFormattingEditProvider(ze,bt(_),oe,[Le].concat(st))},registerDocumentSemanticTokensProvider(_,oe,Le){return ut.registerDocumentSemanticTokensProvider(ze,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ut.registerDocumentRangeSemanticTokensProvider(ze,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...st){return typeof Le=="object"?ut.registerSignatureHelpProvider(ze,bt(_),oe,Le):ut.registerSignatureHelpProvider(ze,bt(_),oe,typeof Le>"u"?[]:[Le,...st])},registerCompletionItemProvider(_,oe,...Le){return ut.registerCompletionItemProvider(ze,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Ze.$SG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$SG)(ze,"inlineCompletionsAdditions"),Le&&(0,Ze.$SG)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Ze.$SG)(ze,"inlineEdit"),ut.registerInlineEditProvider(ze,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ut.registerDocumentLinkProvider(ze,bt(_),oe)},registerColorProvider(_,oe){return ut.registerColorProvider(ze,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ut.registerFoldingRangeProvider(ze,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ut.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ut.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ut.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ut.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Ze.$SG)(ze,"tokenInformation"),Ct.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ut.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return Ct.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ut.registerDocumentOnDropEditProvider(ze,_,oe,(0,Ze.$RG)(ze,"documentPaste")?Le:void 0)}},nn={get activeTextEditor(){return rt.getActiveTextEditor()},get visibleTextEditors(){return rt.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(_,oe,Le){m.URI.isUri(_)&&_.scheme===R.Schemas.vscodeRemote&&!_.authority&&Rt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const st=await(m.URI.isUri(_)?Promise.resolve(qi.openTextDocument(_)):Promise.resolve(_));return rt.showTextDocument(st,oe,Le)},createTextEditorDecorationType(_){return rt.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Le){return nt(rt.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return nt(rt.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return nt(rt.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return nt(rt.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return nt(rt.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return nt(rt.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return nt(Et.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return nt(Et.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return nt(Et.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Ze.$SG)(ze,"terminalDimensions"),nt(Et.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return nt(Et.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Ze.$SG)(ze,"terminalDataWriteEvent"),nt(Et.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Ze.$SG)(ze,"terminalExecuteCommandEvent"),nt(Et.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Ze.$SG)(ze,"terminalShellIntegration"),nt(ni.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Ze.$SG)(ze,"terminalShellIntegration"),nt(ni.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Ze.$SG)(ze,"terminalShellIntegration"),nt(ni.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Nt.getState()},onDidChangeWindowState(_,oe,Le){return nt(Nt.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Vi.showMessage(ze,p.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Vi.showMessage(ze,p.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Vi.showMessage(ze,p.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return Ei.showQuickPick(ze,_,oe,Le)},showWorkspaceFolderPick(_){return Ei.showWorkspaceFolderPick(_)},showInputBox(_,oe){return Ei.showInput(_,oe)},showOpenDialog(_){return Mi.showOpenDialog(ze,_)},showSaveDialog(_){return Mi.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let st,vt,At;return typeof _=="string"?(st=_,vt=oe,At=Le):(vt=_,At=oe),xi.createStatusBarEntry(ze,st,vt,At)},setStatusBarMessage(_,oe){return xi.setStatusBarMessage(_,oe)},withScmProgress(_){return Rt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ii.withProgress(ze,{location:we.ProgressLocation.SourceControl},(oe,Le)=>_({report(st){}}))},withProgress(_,oe){return Ii.withProgress(ze,_,oe)},createOutputChannel(_,oe){return bi.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Le,st){return Ci.createWebviewPanel(ze,_,oe,Le,st)},createWebviewTextEditorInset(_,oe,Le,st){return(0,Ze.$SG)(ze,"editorInsets"),qt.createWebviewEditorInset(_,oe,Le,st,ze)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?Et.createExtensionTerminal(_):Et.createTerminalFromOptions(_):Et.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return Et.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return Et.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Ze.$SG)(ze,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return yt.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return yt.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Ci.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>zi.registerCustomEditorProvider(ze,_,oe,Le),registerFileDecorationProvider(_){return Ot.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return mi.registerUriHandler(ze,_)},createQuickPick(){return Ei.createQuickPick(ze)},createInputBox(){return Ei.createInputBox(ze)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return nt(Fi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return Ui.registerWebviewViewProvider(ze,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return nt(se.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return nt(Pe.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return nt(Pe.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return se.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Ze.$SG)(ze,"externalUriOpener"),Xi.registerExternalUriOpener(ze.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Ze.$SG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Le,st){return(0,Ze.$SG)(ze,"quickDiffProvider"),Ji.registerQuickDiffProvider(bt(_),oe,Le,st)},get tabGroups(){return Wt.tabGroups},registerShareProvider(_,oe){return(0,Ze.$SG)(ze,"shareProvider"),Oi.registerShareProvider(bt(_),oe)}},qi={get rootPath(){return Rt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(ze,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return nt(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,st)=>ft.findFiles(_,oe,Le,ze.identifier,st),findFiles2:(_,oe,Le)=>((0,Ze.$SG)(ze,"findFiles2"),ft.findFiles2(_,oe,ze.identifier,Le)),findTextInFiles:(_,oe,Le,st)=>{(0,Ze.$SG)(ze,"findTextInFiles");let vt,At;return typeof oe=="object"?(vt=oe,At=Le):(vt={},At=oe,st=Le),ft.findTextInFiles(_,vt||{},At,ze.identifier,st)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return gn.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Le,st)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!st,correlate:!1}:oe&&((0,Ze.$SG)(ze,"createFileSystemWatcher"),vt={...oe,correlate:!0}),$i.createFileSystemWatcher(ft,ze,_,vt)},get textDocuments(){return kt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=kt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(st=>(st.scheme===R.Schemas.vscodeRemote&&!st.authority&&Rt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),kt.ensureDocumentData(st).then(vt=>vt.document)))},onDidOpenTextDocument:(_,oe,Le)=>nt(kt.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>nt(kt.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>nt(kt.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>nt(kt.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>nt(Ae.getOnWillSaveTextDocumentEvent(ze))(_,oe,Le),get notebookDocuments(){return se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if(m.URI.isUri(_))Le=_,await se.openNotebookDocument(_);else if(typeof _=="string")Le=m.URI.revive(await se.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return nt(J.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return nt(J.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return nt(Ge.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Le)},get onDidOpenNotebookDocument(){return nt(se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,st){return se.registerNotebookSerializer(ze,_,oe,Le,(0,Ze.$RG)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(_,oe,Le)=>nt(Wi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Wi.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return ye.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Rt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,N.$Rc)(Ri.registerFileSystemProvider(ze,_,oe,Le),Kt.addFileSystemProvider(_,oe,Le))},get fs(){return Kt.value},registerFileSearchProvider:(_,oe)=>((0,Ze.$SG)(ze,"fileSearchProvider"),di.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Ze.$SG)(ze,"textSearchProvider"),di.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Ze.$SG)(ze,"aiTextSearchProvider"),(0,Ze.$SG)(ze,"textSearchProvider"),di.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Ze.$SG)(ze,"resolvers"),Ft.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Ze.$SG)(ze,"resolvers"),Ti.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$SG)(ze,"resolvers"),Ft.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>nt($i.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>nt($i.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>nt($i.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>nt($i.getOnWillCreateFileEvent(ze))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>nt($i.getOnWillDeleteFileEvent(ze))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>nt($i.getOnWillRenameFileEvent(ze))(_,oe,Le),openTunnel:_=>((0,Ze.$SG)(ze,"tunnels"),Ut.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ze.$SG)(ze,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Ze.$SG)(ze,"tunnels"),nt(Ut.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Ze.$SG)(ze,"portsAttributes"),Ut.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Ze.$SG)(ze,"tunnelFactory"),Ut.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Ze.$SG)(ze,"timeline"),Qi.registerTimelineProvider(_,oe,ze.identifier,wt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$SG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>nt(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Ze.$SG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Ze.$SG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Ze.$SG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Ze.$SG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},rn={get inputBox(){return Rt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(ze)},createSourceControl(_,oe,Le){return ki.createSourceControl(ze,_,oe,Le)}},$n={createCommentController(_,oe){return Ni.createCommentController(ze,_,oe)}},sn={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Ze.$SG)(ze,"debugVisualization"),St.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Ze.$SG)(ze,"debugVisualization"),St.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Le){return nt(St.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return nt(St.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return nt(St.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return nt(St.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return nt(St.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return nt(St.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return St.registerDebugConfigurationProvider(_,oe,Le||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return St.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return St.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?St.startDebugging(_,oe,{parentSession:Le}):St.startDebugging(_,oe,Le||{})},stopDebugging(_){return St.stopDebugging(_)},addBreakpoints(_){return St.addBreakpoints(_)},removeBreakpoints(_){return St.removeBreakpoints(_)},asDebugSourceUri(_,oe){return St.asDebugSourceUri(_,oe)}},on={registerTaskProvider:(_,oe)=>ri.registerTaskProvider(ze,_,oe),fetchTasks:_=>ri.fetchTasks(_),executeTask:_=>ri.executeTask(ze,_),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(_,oe,Le)=>nt(ri.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>nt(ri.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>nt(ri.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>nt(ri.onDidEndTaskProcess)(_,oe,Le)},pn={createNotebookController(_,oe,Le,st,vt){return Ve.createNotebookController(ze,_,oe,Le,st,(0,Ze.$RG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>se.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return Xe.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$SG)(ze,"notebookKernelSource"),Ve.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Ze.$SG)(ze,"notebookKernelSource"),Ve.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Ze.$SG)(ze,"notebookCellExecutionState"),nt(Ve.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},wn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ui.getMessage(ze.identifier.value,{message:oe,args:Le})}return ui.getMessage(ze.identifier.value,_[0])},get bundle(){return ui.getBundle(ze.identifier.value)},get uri(){return ui.getBundleUri(ze.identifier.value)}},an={_version:1,transferActiveChat(_){return(0,Ze.$SG)(ze,"interactive"),Pi.transferActiveChat(_)}},Hi={getRelatedInformation(_,oe){return(0,Ze.$SG)(ze,"aiRelatedInformation"),ji.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Ze.$SG)(ze,"aiRelatedInformation"),ji.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Ze.$SG)(ze,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(ze,_,oe)}},cn={registerChatResponseProvider(_,oe,Le){return(0,Ze.$SG)(ze,"chatProvider"),Tt.registerLanguageModel(ze,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Ze.$SG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Ze.$SG)(ze,"mappedEditsProvider"),ut.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Ze.$SG)(ze,"chatParticipant"),Pi.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Le,st,vt){return(0,Ze.$SG)(ze,"chatParticipantAdditions"),Pi.createDynamicChatAgent(ze,_,oe,Le,st,vt)}},un={get languageModels(){return(0,Ze.$SG)(ze,"languageModels"),Tt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Le)=>((0,Ze.$SG)(ze,"languageModels"),Tt.onDidChangeProviders(_,oe,Le)),sendChatRequest(_,oe,Le,st){return(0,Ze.$SG)(ze,"languageModels"),st??=P.CancellationToken.None,Le??={},Tt.sendChatRequest(ze,_,oe,Le,st)},computeTokenLength(_,oe,Le){return(0,Ze.$SG)(ze,"languageModels"),Le??=P.CancellationToken.None,Tt.computeTokenLength(_,oe,Le)},getLanguageModelInformation(_){return(0,Ze.$SG)(ze,"languageModels"),Tt.getLanguageModelInfo(_)},get embeddingModels(){return(0,Ze.$SG)(ze,"embeddings"),pi.embeddingsModels},onDidChangeEmbeddingModels:(_,oe,Le)=>((0,Ze.$SG)(ze,"embeddings"),pi.onDidChange(_,oe,Le)),registerEmbeddingsProvider(_,oe){return(0,Ze.$SG)(ze,"embeddings"),pi.registerEmbeddingsProvider(ze,_,oe)},async computeEmbeddings(_,oe,Le){return(0,Ze.$SG)(ze,"embeddings"),pi.computeEmbeddings(_,oe,Le)}},ln={registerSpeechProvider(_,oe){return(0,Ze.$SG)(ze,"speech"),Bi.registerProvider(ze.identifier,_,oe)}};return{version:mt.version,ai:Hi,authentication:en,commands:fi,comments:$n,chat:cn,debug:sn,env:Di,extensions:Ai,interactive:an,l10n:wn,languages:tn,lm:un,notebooks:pn,scm:rn,speech:ln,tasks:on,tests:mn,window:nn,workspace:qi,Breakpoint:we.$jN,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$eO,CallHierarchyIncomingCall:we.$HM,CallHierarchyItem:we.$GM,CallHierarchyOutgoingCall:we.$IM,CancellationError:O.$5,CancellationTokenSource:P.$qe,CandidatePortSource:i.CandidatePortSource,CodeAction:we.$DM,CodeActionKind:we.$EM,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$JM,Color:we.$WM,ColorInformation:we.$XM,ColorPresentation:we.$YM,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$QM,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$RM,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$7M,DebugAdapterExecutable:we.$nN,DebugAdapterInlineImplementation:we.$qN,DebugAdapterNamedPipeServer:we.$pN,DebugAdapterServer:we.$oN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$GN,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$wM,DiagnosticRelatedInformation:we.$vM,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$iM,DocumentHighlight:we.$zM,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$AM,DocumentLink:we.$VM,DocumentSymbol:we.$CM,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$tN,InlineValueText:we.$uN,InlineValueVariableLookup:we.$vN,InlineValueEvaluatableExpression:we.$wN,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:M.$fe,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$IN,FileDecoration2:we.$IN,FileSystemError:we.$zN,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:we.$AN,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$lN,InlineCompletionItem:we.$SM,InlineCompletionList:we.$TM,Hover:we.$xM,VerboseHover:we.$yM,HoverVerbosityAction:we.HoverVerbosityAction,IndentAction:S.IndentAction,Location:we.$uM,MarkdownString:we.$KM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:we.$LM,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$jM,ProcessExecution:we.$5M,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$HN,Range:we.$kM,RelativePattern:we.$hN,Selection:we.$lM,SelectionRange:we.$FM,SemanticTokens:we.$DN,SemanticTokensBuilder:we.$CN,SemanticTokensEdit:we.$EN,SemanticTokensEdits:we.$FN,SemanticTokensLegend:we.$BN,ShellExecution:we.$6M,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$NM,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$MM,SnippetString:we.$tM,SourceBreakpoint:we.$kN,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$BM,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$8M,TaskGroup:we.$4M,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$ZM,TerminalQuickFixTerminalCommand:we.$2M,TerminalQuickFixOpener:we.$1M,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$3M,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$pM,SnippetTextEdit:we.$rM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$gN,ThemeIcon:we.$fN,TreeItem:we.$9M,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$5N,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$sM,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$cN,DocumentDropOrPasteEditKind:we.$dN,DocumentPasteEdit:we.$eN,InlayHint:we.$PM,InlayHintLabelPart:we.$OM,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$oM,ResolvedAuthority:we.$mM,ManagedResolvedAuthority:we.$nM,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$SN,NotebookRange:we.$KN,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$LN,NotebookData:we.$MN,NotebookRendererScript:we.$QN,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$ON,NotebookCellOutputItem:we.$NN,NotebookCellStatusBarItem:we.$PN,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$qM,NotebookKernelSourceAction:we.$RN,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$UN,LinkedEditingRanges:we.$TN,TestResultState:we.TestResultState,TestRunRequest:we.$VN,TestMessage:we.$WN,TestTag:we.$XN,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:we.$bN,DataTransferItem:we.$0M,TestCoverageCount:we.$YN,FileCoverage:we.$1N,StatementCoverage:we.$2N,BranchCoverage:we.$3N,DeclarationCoverage:we.$4N,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$6N,TabInputTextDiff:we.$7N,TabInputTextMerge:we.$8N,TabInputCustom:we.$9N,TabInputNotebook:we.$$N,TabInputNotebookDiff:we.$_N,TabInputWebview:we.$0N,TabInputTerminal:we.$aO,TabInputInteractiveWindow:we.$bO,TabInputChat:we.$cO,TabInputTextMultiDiff:we.$dO,TelemetryTrustedValue:o.$ip,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,DebugStackFrame:we.$rN,DebugThread:we.$sN,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,TextToSpeechStatus:we.TextToSpeechStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$fO,ChatResponseFileTreePart:we.$jO,ChatResponseAnchorPart:we.$kO,ChatResponseProgressPart:we.$lO,ChatResponseReferencePart:we.$oO,ChatResponseWarningPart:we.$mO,ChatResponseTextEditPart:we.$pO,ChatResponseMarkdownWithVulnerabilitiesPart:we.$gO,ChatResponseCommandButtonPart:we.$nO,ChatResponseDetectedParticipantPart:we.$hO,ChatResponseConfirmationPart:we.$iO,ChatRequestTurn:we.$qO,ChatResponseTurn:we.$rO,ChatLocation:we.ChatLocation,LanguageModelChatMessageRole:we.LanguageModelChatMessageRole,LanguageModelChatMessage:we.$sO,LanguageModelChatMessage2:we.$sO,LanguageModelChatSystemMessage:we.$tO,LanguageModelChatUserMessage:we.$uO,LanguageModelChatAssistantMessage:we.$vO,LanguageModelError:we.$wO,NewSymbolName:we.$yN,NewSymbolNameTag:we.NewSymbolNameTag,NewSymbolNameTriggerKind:we.NewSymbolNameTriggerKind,InlineEdit:we.$xO,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(ke[308],Ie([1,0,56,118,39,112,40,35,68,53,121,123,124,84,88,80,111,65,46,83,63,67,248,12,122,81,82,86,90,116]),function(le,e,P,O,M,N,R,p,m,E,T,S,l,b,f,r,s,o,n,i,c,u,t,g,a,d,w,$,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.$As)(d.$Jmc,d.$Imc,1),(0,P.$As)(g.$6j,t.$Wnc,1),(0,P.$As)(r.$Olc,r.$Plc,1),(0,P.$As)(p.$6O,p.$5O,0),(0,P.$As)($.$Ylc,$.$Zlc,0),(0,P.$As)(v.$Dmc,v.$Emc,0),(0,P.$As)(R.$bmc,R.$_lc,0),(0,P.$As)(o.$dmc,o.$cmc,0),(0,P.$As)(S.$Tmc,S.$Xmc,0),(0,P.$As)(N.$Zmc,N.$Ymc,0),(0,P.$As)(m.$UO,m.$TO,0),(0,P.$As)(w.$Kmc,w.$Lmc,0),(0,P.$As)(n.$Slc,n.$Rlc,0),(0,P.$As)(O.$snc,O.$rnc,1),(0,P.$As)(l.$dnc,l.$enc,0),(0,P.$As)(b.$wmc,b.$vmc,0),(0,P.$As)(T.$Fnc,T.$Enc,0),(0,P.$As)(E.$zmc,E.$Cmc,0),(0,P.$As)(y.$Gnc,y.$Hnc,0),(0,P.$As)(f.$NDb,f.$ODb,0),(0,P.$As)(s.$Unc,s.$Tnc,0),(0,P.$As)(M.$$lc,M.$0lc,0),(0,P.$As)(i.$Gmc,i.$Fmc,0),(0,P.$As)(c.$4O,c.$1O,0),(0,P.$As)(u.$nmc,u.$omc,0),(0,P.$As)(a.$Rmc,a.$Smc,0)}),define(ke[309],Ie([1,0,307,41,2,304,7,11,254]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0;class E extends N.$Znc{j(){}getModule(b,f){for(const r of this.b){const s=r(b);if(s){b=s;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends O.$Nmc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$6pc);const b=this.h.invokeFunction(P.$Vnc);this.r=this.h.createInstance(E,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,f,r){f=f.with({path:S(f.path,".js")});const s=b?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=M.URI.revive(await this.C.$asBrowserUri(f)),n=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),c=`${f.toString(!0)}#vscode-extension`,u=`${i}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch(w){throw console.error(s?`Loading code for extension ${s} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${f.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const g={},a={exports:g},d=w=>{const $=this.r.getModule(w,f);if($===void 0)throw new Error(`Cannot load module '${w}'`);return $};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),t(a,g,d),a.exports!==g?a.exports:g}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,p.$zh)(10)}}e.$7pc=T;function S(l,b){return l.endsWith(b)?l:l+b}}),define(ke[310],Ie([1,0,71,56,12,41,217,87,309]),function(le,e,P,O,M,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$As)(M.$5j,new P.$vi(R.$Ync,[!0],!0)),(0,O.$As)(N.$Omc,m.$7pc,0),(0,O.$As)(p.$emc,p.$fmc,0)}),define(ke[316],Ie([1,0,22,5,79,305,256,19,60,16,2,308,310]),function(le,e,P,O,M,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function r(t){self.fetch=async function(g,a){return g instanceof Request||b(String(g))&&(g=(await t(T.URI.parse(String(g)))).toString(!0)),f(g,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(g,a,d,w,$){(async()=>(b(a.toString())&&(a=(await t(T.URI.parse(a.toString()))).toString(!0)),super.open(g,a,d??!0,w,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(g,a){if(/^file:/i.test(g.toString()))g=E.$Sg.uriToBrowserUri(T.URI.parse(g.toString())).toString(!0);else if(/^vscode-remote:/i.test(g.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(h){function D(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const k=fetch.bind(self);self.fetch=function(I,W){return I instanceof Request?k(I,W):k(D(I),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,W,V,q,A){return super.open(I,D(W),V??!0,q,A)}};const C=importScripts.bind(self);self.importScripts=(...I)=>{C(...I.map(D))},C(h)}.toString()}('${g}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$nc(g.toString())}`;const $=new Blob([w],{type:"application/javascript"}),v=URL.createObjectURL($);return new t(v,a)}}else self.Worker=class extends R.$8pc{constructor(t,g){super(l,t,{name:p.$nc(t.toString()),...g})}};const s=new class{constructor(){this.pid=void 0}exit(t){S()}};class o{constructor(){const g=new MessageChannel,a=new O.$fe;let d=!1;l(g.port2,[g.port2]),g.port1.onmessage=w=>{const{data:$}=w;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const v=P.$He.wrap(new Uint8Array($,0,$.byteLength));if((0,M.$3m)(v,2)){d=!0,i("received terminate message from renderer");return}a.fire(v)},this.protocol={onMessage:a.event,send:w=>{if(!d){const $=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);g.port1.postMessage($,[$])}}}}}function n(t){return new Promise(g=>{const a=t.onMessage(d=>{a.dispose();const w=JSON.parse(d.toString());t.send((0,M.$2m)(0)),g({protocol:t,initData:w})});t.send((0,M.$2m)(1))})}let i=t=>S();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const t=new o;return{onmessage(g){c(g)&&n(t.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const d=new N.$2nc(a.protocol,a.initData,s,null,g.data);r(w=>d.asBrowserUri(w)),i=w=>d.terminate(w)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60468916e48fe8293e7641f0fc4ada80d79117b3/core/vs/workbench/api/worker/extensionHostWorker.js.map
